/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Z=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/base/common/uri","vs/base/common/async","vs/platform/instantiation/common/instantiation","vs/base/common/path","vs/base/common/errors","vs/nls","vs/nls!vs/code/electron-browser/sharedProcess/sharedProcessMain","vs/platform/environment/common/environment","vs/platform/files/common/files","vs/platform/log/common/log","vs/base/common/resources","vs/base/common/arrays","vs/base/common/types","vs/base/common/network","vs/base/node/pfs","vs/platform/telemetry/common/telemetry","vs/platform/configuration/common/configuration","vs/platform/storage/common/storage","vs/platform/userDataSync/common/userDataSync","vs/base/common/strings","vs/base/common/buffer","vs/base/common/objects","vs/base/common/cancellation","vs/platform/extensionManagement/common/extensionManagement","vs/platform/product/common/productService","vs/base/common/uuid","vs/base/common/process","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/registry/common/platform","vs/base/common/json","os","vs/base/parts/ipc/common/ipc","vs/base/common/errorMessage","vs/platform/configuration/common/configurationRegistry","vs/base/common/extpath","vs/base/common/map","child_process","vs/platform/product/common/product","vs/platform/request/common/request","vs/platform/telemetry/common/telemetryUtils","vs/base/common/jsonEdit","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/common/jsonFormatter","vs/base/common/codicons","vs/base/common/stream","fs","vs/base/parts/ipc/node/ipc.cp","vs/platform/instantiation/common/descriptors","vs/platform/userDataSync/common/content","vs/base/common/iterator","vs/base/common/date","vs/platform/localizations/common/localizations","vs/base/common/semver/semver","vs/platform/native/electron-sandbox/native","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/node/zip","vs/base/common/collections","vs/base/common/decorators","vs/base/common/functional","vs/base/common/normalization","vs/base/common/glob","vs/base/node/decoder","vs/base/node/powershell","vs/base/parts/storage/common/storage","vs/base/node/processes","vs/platform/extensions/common/extensionValidator","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionRecommendations/common/extensionRecommendations","vs/platform/extensions/common/extensions","vs/platform/files/node/watcher/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/log/common/logIpc","vs/platform/files/common/io","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/terminal/common/terminal","vs/platform/theme/common/themeService","vs/platform/userDataSync/common/extensionsStorageSync","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/userDataSync/common/userDataAutoSyncService","vs/base/common/assert","vs/base/common/linkedList","vs/base/common/stopwatch","vs/base/common/console","vs/base/common/marshalling","vs/base/common/mime","vs/base/common/uriIpc","vs/base/node/macAddress","vs/base/node/id","vs/base/node/extpath","vs/base/node/ps","vs/base/node/watcher","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-browser/ipc.mp","electron","vs/base/parts/request/browser/request","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/platform/environment/common/environmentService","vs/platform/environment/node/argv","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/configRemotes","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/electron-sandbox/extensionRecommendationsIpc","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/files/node/watcher/win32/csharpWatcherService","vs/platform/files/node/watcher/win32/watcherService","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/contextkey/common/contextkey","vs/code/electron-browser/sharedProcess/contrib/deprecatedExtensionsCleaner","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/checksum/node/checksumService","crypto","vs/platform/environment/node/argvHelper","vs/platform/environment/node/shellEnv","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/ipc/electron-browser/mainProcessService","vs/platform/ipc/electron-sandbox/services","vs/code/electron-browser/sharedProcess/contrib/localizationsUpdater","vs/code/electron-browser/sharedProcess/contrib/logsDataCleaner","vs/code/electron-browser/sharedProcess/contrib/storageDataCleaner","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/localizations/node/localizations","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/code/electron-browser/sharedProcess/contrib/codeCacheCleaner","vs/code/electron-browser/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/request/browser/requestService","vs/platform/download/common/downloadService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/storage/common/storageIpc","vs/platform/storage/electron-sandbox/storageService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/terminal/common/requestStore","vs/platform/terminal/electron-sandbox/terminal","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/userDataSyncBackupStoreService","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/userDataSync/common/userDataSyncResourceEnablementService","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/electron-sandbox/userDataAutoSyncService","vs/platform/windows/node/windowTracker","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","string_decoder","util","minimist","assert","yauzl","yazl","vs/code/electron-browser/sharedProcess/sharedProcessMain","graceful-fs"],ee=function(K){for(var e=[],D=0,T=K.length;D<T;D++)e[D]=Z[K[D]];return e};define(Z[90],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function D(T,R){if(!T)throw new Error(R?`Assertion failed (${R})`:"Assertion Failed")}e.ok=D}),define(Z[63],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const D=Object.prototype.hasOwnProperty;function T(i){const C=[];for(let f in i)D.call(i,f)&&C.push(i[f]);return C}e.values=T;function R(i,C){for(let f in i)if(D.call(i,f)&&C({key:f,value:i[f]},function(){delete i[f]})===!1)return}e.forEach=R;function L(i,C){const f=Object.create(null);for(const I of i){const u=C(I);let w=f[u];w||(w=f[u]=[]),w.push(I)}return f}e.groupBy=L;function k(i){const C=Object.create(null);return i&&i.forEach((f,I)=>{C[I]=f}),C}e.fromMap=k;function P(i,C){const f=[],I=[];for(let u of i)C.has(u)||f.push(u);for(let u of C)i.has(u)||I.push(u);return{removed:f,added:I}}e.diffSets=P;function m(i,C){const f=[],I=[];for(let[u,w]of i)C.has(u)||f.push(w);for(let[u,w]of C)i.has(u)||I.push(w);return{removed:f,added:I}}e.diffMaps=m;class b{constructor(){this.map=new Map}add(C,f){let I=this.map.get(C);I||(I=new Set,this.map.set(C,I)),I.add(f)}delete(C,f){const I=this.map.get(C);!I||(I.delete(f),I.size===0&&this.map.delete(C))}forEach(C,f){const I=this.map.get(C);!I||I.forEach(f)}}e.SetMap=b}),define(Z[64],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function D(k){return(P,m,b)=>{let i=null,C=null;if(typeof b.value=="function"?(i="value",C=b.value):typeof b.get=="function"&&(i="get",C=b.get),!C)throw new Error("not supported");b[i]=k(C,m)}}e.createDecorator=D;function T(k,P,m){let b=null,i=null;if(typeof m.value=="function"?(b="value",i=m.value,i.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof m.get=="function"&&(b="get",i=m.get),!i)throw new Error("not supported");const C=`$memoize$${P}`;m[b]=function(...f){return this.hasOwnProperty(C)||Object.defineProperty(this,C,{configurable:!1,enumerable:!1,writable:!1,value:i.apply(this,f)}),this[C]}}e.memoize=T;function R(k,P,m){return D((b,i)=>{const C=`$debounce$${i}`,f=`$debounce$result$${i}`;return function(...I){this[f]||(this[f]=m?m():void 0),clearTimeout(this[C]),P&&(this[f]=P(this[f],...I),I=[this[f]]),this[C]=setTimeout(()=>{b.apply(this,I),this[f]=m?m():void 0},k)}})}e.debounce=R;function L(k,P,m){return D((b,i)=>{const C=`$throttle$timer$${i}`,f=`$throttle$result$${i}`,I=`$throttle$lastRun$${i}`,u=`$throttle$pending$${i}`;return function(...w){if(this[f]||(this[f]=m?m():void 0),(this[I]===null||this[I]===void 0)&&(this[I]=-Number.MAX_VALUE),P&&(this[f]=P(this[f],...w)),this[u])return;const g=this[I]+k;g<=Date.now()?(this[I]=Date.now(),b.apply(this,[this[f]]),this[f]=m?m():void 0):(this[u]=!0,this[C]=setTimeout(()=>{this[u]=!1,this[I]=Date.now(),b.apply(this,[this[f]]),this[f]=m?m():void 0},g-Date.now()))}})}e.throttle=L}),define(Z[9],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class D{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(s=>{s(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=D,e.errorHandler=new D;function T(a){e.errorHandler.setUnexpectedErrorHandler(a)}e.setUnexpectedErrorHandler=T;function R(a){m(a)||e.errorHandler.onUnexpectedError(a)}e.onUnexpectedError=R;function L(a){m(a)||e.errorHandler.onUnexpectedExternalError(a)}e.onUnexpectedExternalError=L;function k(a){if(a instanceof Error){let{name:t,message:s}=a;const n=a.stacktrace||a.stack;return{$isError:!0,name:t,message:s,stack:n}}return a}e.transformErrorForSerialization=k;const P="Canceled";function m(a){return a instanceof Error&&a.name===P&&a.message===P}e.isPromiseCanceledError=m;class b extends Error{constructor(){super(P);this.name=this.message}}e.CancellationError=b;function i(){const a=new Error(P);return a.name=a.message,a}e.canceled=i;function C(a){return a?new Error(`Illegal argument: ${a}`):new Error("Illegal argument")}e.illegalArgument=C;function f(a){return a?new Error(`Illegal state: ${a}`):new Error("Illegal state")}e.illegalState=f;function I(a){return a?new Error(`readonly property '${a} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=I;function u(a){const t=new Error(`${a} has been disposed`);return t.name="DISPOSED",t}e.disposed=u;function w(a){return a?a.message?a.message:a.stack?a.stack.split(`
`)[0]:String(a):"Error"}e.getErrorMessage=w;class g extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=g;class E extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=E;class y extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=y;function S(a){const t=a;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=S;function o(a,t=Object.create(null)){const s=new Error(a);return t.actions&&(s.actions=t.actions),s}e.createErrorWithActions=o}),define(Z[16],ee([0,1,9]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.maxIndex=e.minIndex=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function T(_,Y=0){return _[_.length-(1+Y)]}e.tail=T;function R(_){if(_.length===0)throw new Error("Invalid tail call");return[_.slice(0,_.length-1),_[_.length-1]]}e.tail2=R;function L(_,Y,G=(ne,te)=>ne===te){if(_===Y)return!0;if(!_||!Y||_.length!==Y.length)return!1;for(let ne=0,te=_.length;ne<te;ne++)if(!G(_[ne],Y[ne]))return!1;return!0}e.equals=L;function k(_,Y,G){let ne=0,te=_.length-1;for(;ne<=te;){const J=(ne+te)/2|0,V=G(_[J],Y);if(V<0)ne=J+1;else if(V>0)te=J-1;else return J}return-(ne+1)}e.binarySearch=k;function P(_,Y){let G=0,ne=_.length;if(ne===0)return 0;for(;G<ne;){const te=Math.floor((G+ne)/2);Y(_[te])?ne=te:G=te+1}return G}e.findFirstInSorted=P;function m(_,Y,G){if(_=_|0,_>=Y.length)throw new TypeError("invalid index");let ne=Y[Math.floor(Y.length*Math.random())],te=[],J=[],V=[];for(let re of Y){const ie=G(re,ne);ie<0?te.push(re):ie>0?J.push(re):V.push(re)}return _<te.length?m(_,te,G):_<te.length+V.length?V[0]:m(_-(te.length+V.length),J,G)}e.quickSelect=m;function b(_,Y){const G=[];let ne;for(const te of _.slice(0).sort(Y))!ne||Y(ne[0],te)!==0?(ne=[te],G.push(ne)):ne.push(te);return G}e.groupBy=b;function i(_,Y,G){const ne=[];function te(re,ie,ce){if(ie===0&&ce.length===0)return;const ue=ne[ne.length-1];ue&&ue.start+ue.deleteCount===re?(ue.deleteCount+=ie,ue.toInsert.push(...ce)):ne.push({start:re,deleteCount:ie,toInsert:ce})}let J=0,V=0;for(;;){if(J===_.length){te(J,0,Y.slice(V));break}if(V===Y.length){te(J,_.length-J,[]);break}const re=_[J],ie=Y[V],ce=G(re,ie);ce===0?(J+=1,V+=1):ce<0?(te(J,1,[]),J+=1):ce>0&&(te(J,0,[ie]),V+=1)}return ne}e.sortedDiff=i;function C(_,Y,G){const ne=i(_,Y,G),te=[],J=[];for(const V of ne)te.push(..._.slice(V.start,V.start+V.deleteCount)),J.push(...V.toInsert);return{removed:te,added:J}}e.delta=C;function f(_,Y,G){if(G===0)return[];const ne=_.slice(0,G).sort(Y);return u(_,Y,ne,G,_.length),ne}e.top=f;function I(_,Y,G,ne,te){return G===0?Promise.resolve([]):new Promise((J,V)=>{(async()=>{const re=_.length,ie=_.slice(0,G).sort(Y);for(let ce=G,ue=Math.min(G+ne,re);ce<re;ce=ue,ue=Math.min(ue+ne,re)){if(ce>G&&await new Promise(ye=>setTimeout(ye)),te&&te.isCancellationRequested)throw(0,D.canceled)();u(_,Y,ie,ce,ue)}return ie})().then(J,V)})}e.topAsync=I;function u(_,Y,G,ne,te){for(const J=G.length;ne<te;ne++){const V=_[ne];if(Y(V,G[J-1])<0){G.pop();const re=P(G,ie=>Y(V,ie)<0);G.splice(re,0,V)}}}function w(_){return _.filter(Y=>!!Y)}e.coalesce=w;function g(_){let Y=0;for(let G=0;G<_.length;G++)_[G]&&(_[Y]=_[G],Y+=1);_.length=Y}e.coalesceInPlace=g;function E(_,Y,G){_.splice(G,0,_.splice(Y,1)[0])}e.move=E;function y(_){return!Array.isArray(_)||_.length===0}e.isFalsyOrEmpty=y;function S(_){return Array.isArray(_)&&_.length>0}e.isNonEmptyArray=S;function o(_,Y){if(!Y)return _.filter((ne,te)=>_.indexOf(ne)===te);const G=Object.create(null);return _.filter(ne=>{const te=Y(ne);return G[te]?!1:(G[te]=!0,!0)})}e.distinct=o;function a(_){const Y=new Set;return _.filter(G=>Y.has(G)?!1:(Y.add(G),!0))}e.distinctES6=a;function t(_){const Y=Object.create(null);return G=>{const ne=_(G);return Y[ne]?!1:(Y[ne]=!0,!0)}}e.uniqueFilter=t;function s(_,Y){for(let G=_.length-1;G>=0;G--){const ne=_[G];if(Y(ne))return G}return-1}e.lastIndex=s;function n(_,Y){return _.length>0?_[0]:Y}e.firstOrDefault=n;function r(_,Y,G=(ne,te)=>ne===te){let ne=0;for(let te=0,J=Math.min(_.length,Y.length);te<J&&G(_[te],Y[te]);te++)ne++;return ne}e.commonPrefixLength=r;function c(_){return[].concat(..._)}e.flatten=c;function l(_,Y){let G=typeof Y=="number"?_:0;typeof Y=="number"?G=_:(G=0,Y=_);const ne=[];if(G<=Y)for(let te=G;te<Y;te++)ne.push(te);else for(let te=G;te>Y;te--)ne.push(te);return ne}e.range=l;function h(_,Y,G){return _.reduce((ne,te)=>(ne[Y(te)]=G?G(te):te,ne),Object.create(null))}e.index=h;function d(_,Y){return _.push(Y),()=>v(_,Y)}e.insert=d;function v(_,Y){const G=_.indexOf(Y);if(G>-1)return _.splice(G,1),Y}e.remove=v;function A(_,Y,G){const ne=_.slice(0,Y),te=_.slice(Y);return ne.concat(G,te)}e.arrayInsert=A;function O(_,Y){let G;if(typeof Y=="number"){let ne=Y;G=()=>{const te=Math.sin(ne++)*179426549;return te-Math.floor(te)}}else G=Math.random;for(let ne=_.length-1;ne>0;ne-=1){const te=Math.floor(G()*(ne+1)),J=_[ne];_[ne]=_[te],_[te]=J}}e.shuffle=O;function p(_,Y){const G=_.indexOf(Y);G>-1&&(_.splice(G,1),_.unshift(Y))}e.pushToStart=p;function U(_,Y){const G=_.indexOf(Y);G>-1&&(_.splice(G,1),_.push(Y))}e.pushToEnd=U;function F(_,Y){return Array.isArray(_)?_.map(Y):Y(_)}e.mapArrayOrNot=F;function $(_){return Array.isArray(_)?_:[_]}e.asArray=$;function H(_){return _[Math.floor(Math.random()*_.length)]}e.getRandomElement=H;function M(_,Y){for(const G of _){const ne=Y(G);if(ne!==void 0)return ne}}e.mapFind=M;function j(_,Y,G){const ne=z(_,Y),te=_.length,J=G.length;_.length=te+J;for(let V=te-1;V>=ne;V--)_[V+J]=_[V];for(let V=0;V<J;V++)_[V+ne]=G[V]}e.insertInto=j;function q(_,Y,G,ne){const te=z(_,Y),J=_.splice(te,G);return j(_,te,ne),J}e.splice=q;function z(_,Y){return Y<0?Math.max(Y+_.length,0):Math.min(Y,_.length)}function x(_,Y){let G=Number.MAX_SAFE_INTEGER,ne=0;return _.forEach((te,J)=>{const V=Y(te);V<G&&(G=V,ne=J)}),ne}e.minIndex=x;function N(_,Y){let G=Number.MIN_SAFE_INTEGER,ne=0;return _.forEach((te,J)=>{const V=Y(te);V>G&&(G=V,ne=J)}),ne}e.maxIndex=N;class W{constructor(Y){this.items=Y,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(Y){let G=this.firstIdx;for(;G<this.items.length&&Y(this.items[G]);)G++;const ne=G===this.firstIdx?null:this.items.slice(this.firstIdx,G);return this.firstIdx=G,ne}takeFromEndWhile(Y){let G=this.lastIdx;for(;G>=0&&Y(this.items[G]);)G--;const ne=G===this.lastIdx?null:this.items.slice(G+1,this.lastIdx+1);return this.lastIdx=G,ne}}e.ArrayQueue=W}),define(Z[65],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function D(T){const R=this;let L=!1,k;return function(){return L||(L=!0,k=T.apply(R,arguments)),k}}e.once=D}),define(Z[55],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var D;(function(T){function R(a){return a&&typeof a=="object"&&typeof a[Symbol.iterator]=="function"}T.is=R;const L=Object.freeze([]);function k(){return L}T.empty=k;function*P(a){yield a}T.single=P;function m(a){return a||L}T.from=m;function b(a){return!a||a[Symbol.iterator]().next().done===!0}T.isEmpty=b;function i(a){return a[Symbol.iterator]().next().value}T.first=i;function C(a,t){for(const s of a)if(t(s))return!0;return!1}T.some=C;function f(a,t){for(const s of a)if(t(s))return s}T.find=f;function*I(a,t){for(const s of a)t(s)&&(yield s)}T.filter=I;function*u(a,t){let s=0;for(const n of a)yield t(n,s++)}T.map=u;function*w(...a){for(const t of a)for(const s of t)yield s}T.concat=w;function*g(a){for(const t of a)for(const s of t)yield s}T.concatNested=g;function E(a,t,s){let n=s;for(const r of a)n=t(n,r);return n}T.reduce=E;function*y(a,t,s=a.length){for(t<0&&(t+=a.length),s<0?s+=a.length:s>a.length&&(s=a.length);t<s;t++)yield a[t]}T.slice=y;function S(a,t=Number.POSITIVE_INFINITY){const s=[];if(t===0)return[s,a];const n=a[Symbol.iterator]();for(let r=0;r<t;r++){const c=n.next();if(c.done)return[s,T.empty()];s.push(c.value)}return[s,{[Symbol.iterator](){return n}}]}T.consume=S;function o(a,t,s=(n,r)=>n===r){const n=a[Symbol.iterator](),r=t[Symbol.iterator]();for(;;){const c=n.next(),l=r.next();if(c.done!==l.done)return!1;if(c.done)return!0;if(!s(c.value,l.value))return!1}}T.equals=o})(D=e.Iterable||(e.Iterable={}))}),define(Z[34],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var D;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(D=e.ScanError||(e.ScanError={}));var T;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(T=e.SyntaxKind||(e.SyntaxKind={}));var R;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(R=e.ParseErrorCode||(e.ParseErrorCode={}));var L;(function(t){t.DEFAULT={allowTrailingComma:!0}})(L=e.ParseOptions||(e.ParseOptions={}));function k(t,s=!1){let n=0,r=t.length,c="",l=0,h=16,d=0;function v(H){let M=0,j=0;for(;M<H;){const q=t.charCodeAt(n);if(q>=48&&q<=57)j=j*16+q-48;else if(q>=65&&q<=70)j=j*16+q-65+10;else if(q>=97&&q<=102)j=j*16+q-97+10;else break;n++,M++}return M<H&&(j=-1),j}function A(H){n=H,c="",l=0,h=16,d=0}function O(){const H=n;if(t.charCodeAt(n)===48)n++;else for(n++;n<t.length&&b(t.charCodeAt(n));)n++;if(n<t.length&&t.charCodeAt(n)===46)if(n++,n<t.length&&b(t.charCodeAt(n)))for(n++;n<t.length&&b(t.charCodeAt(n));)n++;else return d=3,t.substring(H,n);let M=n;if(n<t.length&&(t.charCodeAt(n)===69||t.charCodeAt(n)===101))if(n++,(n<t.length&&t.charCodeAt(n)===43||t.charCodeAt(n)===45)&&n++,n<t.length&&b(t.charCodeAt(n))){for(n++;n<t.length&&b(t.charCodeAt(n));)n++;M=n}else d=3;return t.substring(H,M)}function p(){let H="",M=n;for(;;){if(n>=r){H+=t.substring(M,n),d=2;break}const j=t.charCodeAt(n);if(j===34){H+=t.substring(M,n),n++;break}if(j===92){if(H+=t.substring(M,n),n++,n>=r){d=2;break}switch(t.charCodeAt(n++)){case 34:H+='"';break;case 92:H+="\\";break;case 47:H+="/";break;case 98:H+="\b";break;case 102:H+="\f";break;case 110:H+=`
`;break;case 114:H+="\r";break;case 116:H+="	";break;case 117:const z=v(4);z>=0?H+=String.fromCharCode(z):d=4;break;default:d=5}M=n;continue}if(j>=0&&j<=31)if(m(j)){H+=t.substring(M,n),d=2;break}else d=6;n++}return H}function U(){if(c="",d=0,l=n,n>=r)return l=r,h=17;let H=t.charCodeAt(n);if(P(H)){do n++,c+=String.fromCharCode(H),H=t.charCodeAt(n);while(P(H));return h=15}if(m(H))return n++,c+=String.fromCharCode(H),H===13&&t.charCodeAt(n)===10&&(n++,c+=`
`),h=14;switch(H){case 123:return n++,h=1;case 125:return n++,h=2;case 91:return n++,h=3;case 93:return n++,h=4;case 58:return n++,h=6;case 44:return n++,h=5;case 34:return n++,c=p(),h=10;case 47:const M=n-1;if(t.charCodeAt(n+1)===47){for(n+=2;n<r&&!m(t.charCodeAt(n));)n++;return c=t.substring(M,n),h=12}if(t.charCodeAt(n+1)===42){n+=2;const j=r-1;let q=!1;for(;n<j;){if(t.charCodeAt(n)===42&&t.charCodeAt(n+1)===47){n+=2,q=!0;break}n++}return q||(n++,d=1),c=t.substring(M,n),h=13}return c+=String.fromCharCode(H),n++,h=16;case 45:if(c+=String.fromCharCode(H),n++,n===r||!b(t.charCodeAt(n)))return h=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return c+=O(),h=11;default:for(;n<r&&F(H);)n++,H=t.charCodeAt(n);if(l!==n){switch(c=t.substring(l,n),c){case"true":return h=8;case"false":return h=9;case"null":return h=7}return h=16}return c+=String.fromCharCode(H),n++,h=16}}function F(H){if(P(H)||m(H))return!1;switch(H){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function $(){let H;do H=U();while(H>=12&&H<=15);return H}return{setPosition:A,getPosition:()=>n,scan:s?$:U,getToken:()=>h,getTokenValue:()=>c,getTokenOffset:()=>l,getTokenLength:()=>n-l,getTokenError:()=>d}}e.createScanner=k;function P(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function m(t){return t===10||t===13||t===8232||t===8233}function b(t){return t>=48&&t<=57}var i;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(i||(i={}));function C(t,s){const n=[],r=new Object;let c;const l={value:{},offset:0,length:0,type:"object",parent:void 0};let h=!1;function d(v,A,O,p){l.value=v,l.offset=A,l.length=O,l.type=p,l.colonOffset=void 0,c=l}try{S(t,{onObjectBegin:(v,A)=>{if(s<=v)throw r;c=void 0,h=s>v,n.push("")},onObjectProperty:(v,A,O)=>{if(s<A||(d(v,A,O,"property"),n[n.length-1]=v,s<=A+O))throw r},onObjectEnd:(v,A)=>{if(s<=v)throw r;c=void 0,n.pop()},onArrayBegin:(v,A)=>{if(s<=v)throw r;c=void 0,n.push(0)},onArrayEnd:(v,A)=>{if(s<=v)throw r;c=void 0,n.pop()},onLiteralValue:(v,A,O)=>{if(s<A||(d(v,A,O,a(v)),s<=A+O))throw r},onSeparator:(v,A,O)=>{if(s<=A)throw r;if(v===":"&&c&&c.type==="property")c.colonOffset=A,h=!1,c=void 0;else if(v===","){const p=n[n.length-1];typeof p=="number"?n[n.length-1]=p+1:(h=!0,n[n.length-1]=""),c=void 0}}})}catch(v){if(v!==r)throw v}return{path:n,previousNode:c,isAtPropertyKey:h,matches:v=>{let A=0;for(let O=0;A<v.length&&O<n.length;O++)if(v[A]===n[O]||v[A]==="*")A++;else if(v[A]!=="**")return!1;return A===v.length}}}e.getLocation=C;function f(t,s=[],n=L.DEFAULT){let r=null,c=[];const l=[];function h(v){Array.isArray(c)?c.push(v):r!==null&&(c[r]=v)}return S(t,{onObjectBegin:()=>{const v={};h(v),l.push(c),c=v,r=null},onObjectProperty:v=>{r=v},onObjectEnd:()=>{c=l.pop()},onArrayBegin:()=>{const v=[];h(v),l.push(c),c=v,r=null},onArrayEnd:()=>{c=l.pop()},onLiteralValue:h,onError:(v,A,O)=>{s.push({error:v,offset:A,length:O})}},n),c[0]}e.parse=f;function I(t,s=[],n=L.DEFAULT){let r={type:"array",offset:-1,length:-1,children:[],parent:void 0};function c(v){r.type==="property"&&(r.length=v-r.offset,r=r.parent)}function l(v){return r.children.push(v),v}S(t,{onObjectBegin:v=>{r=l({type:"object",offset:v,length:-1,parent:r,children:[]})},onObjectProperty:(v,A,O)=>{r=l({type:"property",offset:A,length:-1,parent:r,children:[]}),r.children.push({type:"string",value:v,offset:A,length:O,parent:r})},onObjectEnd:(v,A)=>{r.length=v+A-r.offset,r=r.parent,c(v+A)},onArrayBegin:(v,A)=>{r=l({type:"array",offset:v,length:-1,parent:r,children:[]})},onArrayEnd:(v,A)=>{r.length=v+A-r.offset,r=r.parent,c(v+A)},onLiteralValue:(v,A,O)=>{l({type:a(v),offset:A,length:O,parent:r,value:v}),c(A+O)},onSeparator:(v,A,O)=>{r.type==="property"&&(v===":"?r.colonOffset=A:v===","&&c(A))},onError:(v,A,O)=>{s.push({error:v,offset:A,length:O})}},n);const d=r.children[0];return d&&delete d.parent,d}e.parseTree=I;function u(t,s){if(!t)return;let n=t;for(let r of s)if(typeof r=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let c=!1;for(const l of n.children)if(Array.isArray(l.children)&&l.children[0].value===r){n=l.children[1],c=!0;break}if(!c)return}else{const c=r;if(n.type!=="array"||c<0||!Array.isArray(n.children)||c>=n.children.length)return;n=n.children[c]}return n}e.findNodeAtLocation=u;function w(t){if(!t.parent||!t.parent.children)return[];const s=w(t.parent);if(t.parent.type==="property"){const n=t.parent.children[0].value;s.push(n)}else if(t.parent.type==="array"){const n=t.parent.children.indexOf(t);n!==-1&&s.push(n)}return s}e.getNodePath=w;function g(t){switch(t.type){case"array":return t.children.map(g);case"object":const s=Object.create(null);for(let n of t.children){const r=n.children[1];r&&(s[n.children[0].value]=g(r))}return s;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=g;function E(t,s,n=!1){return s>=t.offset&&s<t.offset+t.length||n&&s===t.offset+t.length}e.contains=E;function y(t,s,n=!1){if(E(t,s,n)){const r=t.children;if(Array.isArray(r))for(let c=0;c<r.length&&r[c].offset<=s;c++){const l=y(r[c],s,n);if(l)return l}return t}}e.findNodeAtOffset=y;function S(t,s,n=L.DEFAULT){const r=k(t,!1);function c(G){return G?()=>G(r.getTokenOffset(),r.getTokenLength()):()=>!0}function l(G){return G?ne=>G(ne,r.getTokenOffset(),r.getTokenLength()):()=>!0}const h=c(s.onObjectBegin),d=l(s.onObjectProperty),v=c(s.onObjectEnd),A=c(s.onArrayBegin),O=c(s.onArrayEnd),p=l(s.onLiteralValue),U=l(s.onSeparator),F=c(s.onComment),$=l(s.onError),H=n&&n.disallowComments,M=n&&n.allowTrailingComma;function j(){for(;;){const G=r.scan();switch(r.getTokenError()){case 4:q(14);break;case 5:q(15);break;case 3:q(13);break;case 1:H||q(11);break;case 2:q(12);break;case 6:q(16);break}switch(G){case 12:case 13:H?q(10):F();break;case 16:q(1);break;case 15:case 14:break;default:return G}}}function q(G,ne=[],te=[]){if($(G),ne.length+te.length>0){let J=r.getToken();for(;J!==17;){if(ne.indexOf(J)!==-1){j();break}else if(te.indexOf(J)!==-1)break;J=j()}}}function z(G){const ne=r.getTokenValue();return G?p(ne):d(ne),j(),!0}function x(){switch(r.getToken()){case 11:let G=0;try{G=JSON.parse(r.getTokenValue()),typeof G!="number"&&(q(2),G=0)}catch(ne){q(2)}p(G);break;case 7:p(null);break;case 8:p(!0);break;case 9:p(!1);break;default:return!1}return j(),!0}function N(){return r.getToken()!==10?(q(3,[],[2,5]),!1):(z(!1),r.getToken()===6?(U(":"),j(),Y()||q(4,[],[2,5])):q(5,[],[2,5]),!0)}function W(){h(),j();let G=!1;for(;r.getToken()!==2&&r.getToken()!==17;){if(r.getToken()===5){if(G||q(4,[],[]),U(","),j(),r.getToken()===2&&M)break}else G&&q(6,[],[]);N()||q(4,[],[2,5]),G=!0}return v(),r.getToken()!==2?q(7,[2],[]):j(),!0}function _(){A(),j();let G=!1;for(;r.getToken()!==4&&r.getToken()!==17;){if(r.getToken()===5){if(G||q(4,[],[]),U(","),j(),r.getToken()===4&&M)break}else G&&q(6,[],[]);Y()||q(4,[],[4,5]),G=!0}return O(),r.getToken()!==4?q(8,[4],[]):j(),!0}function Y(){switch(r.getToken()){case 3:return _();case 1:return W();case 10:return z(!0);default:return x()}}return j(),r.getToken()===17?n.allowEmptyContent?!0:(q(4,[],[]),!1):Y()?(r.getToken()!==17&&q(9,[],[]),!0):(q(4,[],[]),!1)}e.visit=S;function o(t,s){let n=k(t),r=[],c,l=0,h;do switch(h=n.getPosition(),c=n.scan(),c){case 12:case 13:case 17:l!==h&&r.push(t.substring(l,h)),s!==void 0&&r.push(n.getTokenValue().replace(/[^\r\n]/g,s)),l=n.getPosition();break}while(c!==17);return r.join("")}e.stripComments=o;function a(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=a}),define(Z[48],ee([0,1,34]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function T(m,b,i){let C,f,I,u,w;if(b){for(u=b.offset,w=u+b.length,I=u;I>0&&!P(m,I-1);)I--;let l=w;for(;l<m.length&&!P(m,l);)l++;f=m.substring(I,l),C=L(f,i)}else f=m,C=0,I=0,u=0,w=m.length;const g=k(i,m);let E=!1,y=0,S;i.insertSpaces?S=R(" ",i.tabSize||4):S="	";const o=(0,D.createScanner)(f,!1);let a=!1;function t(){return g+R(S,C+y)}function s(){let l=o.scan();for(E=!1;l===15||l===14;)E=E||l===14,l=o.scan();return a=l===16||o.getTokenError()!==0,l}const n=[];function r(l,h,d){!a&&h<w&&d>u&&m.substring(h,d)!==l&&n.push({offset:h,length:d-h,content:l})}let c=s();if(c!==17){const l=o.getTokenOffset()+I,h=R(S,C);r(h,I,l)}for(;c!==17;){let l=o.getTokenOffset()+o.getTokenLength()+I,h=s(),d="";for(;!E&&(h===12||h===13);){const A=o.getTokenOffset()+I;r(" ",l,A),l=o.getTokenOffset()+o.getTokenLength()+I,d=h===12?t():"",h=s()}if(h===2)c!==1&&(y--,d=t());else if(h===4)c!==3&&(y--,d=t());else{switch(c){case 3:case 1:y++,d=t();break;case 5:case 12:d=t();break;case 13:E?d=t():d=" ";break;case 6:d=" ";break;case 10:if(h===6){d="";break}case 7:case 8:case 9:case 11:case 2:case 4:h===12||h===13?d=" ":h!==5&&h!==17&&(a=!0);break;case 16:a=!0;break}E&&(h===12||h===13)&&(d=t())}const v=o.getTokenOffset()+I;r(d,l,v),c=h}return n}e.format=T;function R(m,b){let i="";for(let C=0;C<b;C++)i+=m;return i}function L(m,b){let i=0,C=0;const f=b.tabSize||4;for(;i<m.length;){const I=m.charAt(i);if(I===" ")C++;else if(I==="	")C+=f;else break;i++}return Math.floor(C/f)}function k(m,b){for(let i=0;i<b.length;i++){const C=b.charAt(i);if(C==="\r")return i+1<b.length&&b.charAt(i+1)===`
`?`\r
`:"\r";if(C===`
`)return`
`}return m&&m.eol||`
`}e.getEOL=k;function P(m,b){return`\r
`.indexOf(m.charAt(b))!==-1}e.isEOL=P}),define(Z[45],ee([0,1,34,48]),function(K,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function R(b,i,C){return L(b,i,void 0,C)}e.removeProperty=R;function L(b,i,C,f,I){const u=i.slice(),w=[],g=(0,D.parseTree)(b,w);let E,y;for(;u.length>0&&(y=u.pop(),E=(0,D.findNodeAtLocation)(g,u),E===void 0&&C!==void 0);)typeof y=="string"?C={[y]:C}:C=[C];if(E)if(E.type==="object"&&typeof y=="string"&&Array.isArray(E.children)){const S=(0,D.findNodeAtLocation)(E,[y]);if(S!==void 0)if(C===void 0){if(!S.parent)throw new Error("Malformed AST");const o=E.children.indexOf(S.parent);let a,t=S.parent.offset+S.parent.length;if(o>0){const s=E.children[o-1];a=s.offset+s.length}else a=E.offset+1,E.children.length>1&&(t=E.children[1].offset);return k(b,{offset:a,length:t-a,content:""},f)}else return k(b,{offset:S.offset,length:S.length,content:JSON.stringify(C)},f);else{if(C===void 0)return[];const o=`${JSON.stringify(y)}: ${JSON.stringify(C)}`,a=I?I(E.children.map(s=>s.children[0].value)):E.children.length;let t;if(a>0){const s=E.children[a-1];t={offset:s.offset+s.length,length:0,content:","+o}}else E.children.length===0?t={offset:E.offset+1,length:0,content:o}:t={offset:E.offset+1,length:0,content:o+","};return k(b,t,f)}}else if(E.type==="array"&&typeof y=="number"&&Array.isArray(E.children))if(C!==void 0){const S=`${JSON.stringify(C)}`;let o;if(E.children.length===0||y===0)o={offset:E.offset+1,length:0,content:E.children.length===0?S:S+","};else{const a=y===-1||y>E.children.length?E.children.length:y,t=E.children[a-1];o={offset:t.offset+t.length,length:0,content:","+S}}return k(b,o,f)}else{const S=y,o=E.children[S];let a;if(E.children.length===1)a={offset:E.offset+1,length:E.length-2,content:""};else if(E.children.length-1===S){const t=E.children[S-1],s=t.offset+t.length,n=E.offset+E.length;a={offset:s,length:n-2-s,content:""}}else a={offset:o.offset,length:E.children[S+1].offset-o.offset,content:""};return k(b,a,f)}else throw new Error(`Can not add ${typeof y!="number"?"index":"property"} to parent of type ${E.type}`);else{if(C===void 0)throw new Error("Can not delete in empty document");return k(b,{offset:g?g.offset:0,length:g?g.length:0,content:JSON.stringify(C)},f)}}e.setProperty=L;function k(b,i,C){let f=P(b,i),I=i.offset,u=i.offset+i.content.length;if(i.length===0||i.content.length===0){for(;I>0&&!(0,T.isEOL)(f,I-1);)I--;for(;u<f.length&&!(0,T.isEOL)(f,u);)u++}const w=(0,T.format)(f,{offset:I,length:u-I},C);for(let E=w.length-1;E>=0;E--){const y=w[E];f=P(f,y),I=Math.min(I,y.offset),u=Math.max(u,y.offset+y.length),u+=y.content.length-y.length}const g=b.length-(f.length-u)-I;return[{offset:I,length:g,content:f.substring(I,u)}]}e.withFormatting=k;function P(b,i){return b.substring(0,i.offset)+i.content+b.substring(i.offset+i.length)}e.applyEdit=P;function m(b,i){let C=i.slice(0).sort((I,u)=>{const w=I.offset-u.offset;return w===0?I.length-u.length:w}),f=b.length;for(let I=C.length-1;I>=0;I--){let u=C[I];if(u.offset+u.length<=f)b=P(b,u);else throw new Error("Overlapping edit");f=u.offset}return b}e.applyEdits=m}),define(Z[2],ee([0,1,65,55]),function(K,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const R=!1;let L=null;function k(n){L=n}if(e.setDisposableTracker=k,R){const n="__is_disposable_tracked__";k(new class{trackDisposable(r){const c=new Error("Potentially leaked disposable").stack;setTimeout(()=>{r[n]||console.log(c)},3e3)}setParent(r,c){if(r&&r!==y.None)try{r[n]=!0}catch{}}markAsDisposed(r){if(r&&r!==y.None)try{r[n]=!0}catch{}}markAsSingleton(r){}})}function P(n){return L?.trackDisposable(n),n}function m(n){L?.markAsDisposed(n)}function b(n,r){L?.setParent(n,r)}function i(n,r){if(!!L)for(const c of n)L.setParent(c,r)}function C(n){return L?.markAsSingleton(n),n}e.markAsSingleton=C;class f extends Error{constructor(r){super(`Encountered errors while disposing of store. Errors: [${r.join(", ")}]`);this.errors=r}}e.MultiDisposeError=f;function I(n){return typeof n.dispose=="function"&&n.dispose.length===0}e.isDisposable=I;function u(n){if(T.Iterable.is(n)){let r=[];for(const c of n)if(c)try{c.dispose()}catch(l){r.push(l)}if(r.length===1)throw r[0];if(r.length>1)throw new f(r);return Array.isArray(n)?[]:n}else if(n)return n.dispose(),n}e.dispose=u;function w(...n){const r=g(()=>u(n));return i(n,r),r}e.combinedDisposable=w;function g(n){const r=P({dispose:(0,D.once)(()=>{m(r),n()})});return r}e.toDisposable=g;class E{constructor(){this._toDispose=new Set,this._isDisposed=!1,P(this)}dispose(){this._isDisposed||(m(this),this._isDisposed=!0,this.clear())}clear(){try{u(this._toDispose.values())}finally{this._toDispose.clear()}}add(r){if(!r)return r;if(r===this)throw new Error("Cannot register a disposable on itself!");return b(r,this),this._isDisposed?E.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(r),r}}e.DisposableStore=E,E.DISABLE_DISPOSED_WARNING=!1;class y{constructor(){this._store=new E,P(this),b(this._store,this)}dispose(){m(this),this._store.dispose()}_register(r){if(r===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(r)}}e.Disposable=y,y.None=Object.freeze({dispose(){}});class S{constructor(){this._isDisposed=!1,P(this)}get value(){return this._isDisposed?void 0:this._value}set value(r){this._isDisposed||r===this._value||(this._value?.dispose(),r&&b(r,this),this._value=r)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,m(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const r=this._value;return this._value=void 0,r&&b(r,null),r}}e.MutableDisposable=S;class o{constructor(r){this._disposable=r,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=o;class a{constructor(){this.references=new Map}acquire(r,...c){let l=this.references.get(r);l||(l={counter:0,object:this.createReferencedObject(r,...c)},this.references.set(r,l));const{object:h}=l,d=(0,D.once)(()=>{--l.counter==0&&(this.destroyReferencedObject(r,l.object),this.references.delete(r))});return l.counter++,{object:h,dispose:d}}}e.ReferenceCollection=a;class t{constructor(r){this.referenceCollection=r}async acquire(r,...c){const l=this.referenceCollection.acquire(r,...c);try{return{object:await l.object,dispose:()=>l.dispose()}}catch(h){throw l.dispose(),h}}}e.AsyncReferenceCollection=t;class s{constructor(r){this.object=r}dispose(){}}e.ImmortalReference=s}),define(Z[91],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class D{constructor(L){this.element=L,this.next=D.Undefined,this.prev=D.Undefined}}D.Undefined=new D(void 0);class T{constructor(){this._first=D.Undefined,this._last=D.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===D.Undefined}clear(){let L=this._first;for(;L!==D.Undefined;){const k=L.next;L.prev=D.Undefined,L.next=D.Undefined,L=k}this._first=D.Undefined,this._last=D.Undefined,this._size=0}unshift(L){return this._insert(L,!1)}push(L){return this._insert(L,!0)}_insert(L,k){const P=new D(L);if(this._first===D.Undefined)this._first=P,this._last=P;else if(k){const b=this._last;this._last=P,P.prev=b,b.next=P}else{const b=this._first;this._first=P,P.next=b,b.prev=P}this._size+=1;let m=!1;return()=>{m||(m=!0,this._remove(P))}}shift(){if(this._first!==D.Undefined){const L=this._first.element;return this._remove(this._first),L}}pop(){if(this._last!==D.Undefined){const L=this._last.element;return this._remove(this._last),L}}_remove(L){if(L.prev!==D.Undefined&&L.next!==D.Undefined){const k=L.prev;k.next=L.next,L.next.prev=k}else L.prev===D.Undefined&&L.next===D.Undefined?(this._first=D.Undefined,this._last=D.Undefined):L.next===D.Undefined?(this._last=this._last.prev,this._last.next=D.Undefined):L.prev===D.Undefined&&(this._first=this._first.next,this._first.prev=D.Undefined);this._size-=1}*[Symbol.iterator](){let L=this._first;for(;L!==D.Undefined;)yield L.element,L=L.next}}e.LinkedList=T}),function(){function K(R){const L=[];typeof R=="number"&&L.push("code/timeOrigin",R);function k(m){L.push(m,Date.now())}function P(){const m=[];for(let b=0;b<L.length;b+=2)m.push({name:L[b],startTime:L[b+1]});return m}return{mark:k,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?K():{mark(R){performance.mark(R)},getMarks(){let R=performance.timeOrigin;typeof R!="number"&&(R=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const L=[{name:"code/timeOrigin",startTime:Math.round(R)}];for(const k of performance.getEntriesByType("mark"))L.push({name:k.name,startTime:Math.round(R+k.startTime)});return L}};if(typeof process=="object"){const R=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return K(R)}else return console.trace("perf-util loaded in UNKNOWN environment"),K()}function D(R){return R.MonacoPerformanceMarks||(R.MonacoPerformanceMarks=e()),R.MonacoPerformanceMarks}var T;typeof global=="object"?T=global:typeof self=="object"?T=self:T={},typeof define=="function"?define("vs/base/common/performance",[],function(){return D(T)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=D(T):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),T.perf=D(T))}(),define(Z[4],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const D="en";let T=!1,R=!1,L=!1,k=!1,P=!1,m=!1,b=!1,i,C=D,f,I;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let u;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?u=e.globals.vscode.process:typeof process!="undefined"&&(u=process);const w=typeof u?.versions?.electron=="string"&&u.type==="renderer";if(e.isElectronSandboxed=w&&u?.sandboxed,typeof navigator=="object"&&!w)I=navigator.userAgent,T=I.indexOf("Windows")>=0,R=I.indexOf("Macintosh")>=0,b=(I.indexOf("Macintosh")>=0||I.indexOf("iPad")>=0||I.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,L=I.indexOf("Linux")>=0,m=!0,i=navigator.language,C=i;else if(typeof u=="object"){T=u.platform==="win32",R=u.platform==="darwin",L=u.platform==="linux",k=L&&!!u.env.SNAP&&!!u.env.SNAP_REVISION,i=D,C=D;const n=u.env.VSCODE_NLS_CONFIG;if(n)try{const r=JSON.parse(n),c=r.availableLanguages["*"];i=r.locale,C=c||D,f=r._translationsConfigFile}catch(r){}P=!0}else console.error("Unable to resolve platform.");var g;(function(n){n[n.Web=0]="Web",n[n.Mac=1]="Mac",n[n.Linux=2]="Linux",n[n.Windows=3]="Windows"})(g=e.Platform||(e.Platform={}));function E(n){switch(n){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=E;let y=0;R?y=1:T?y=3:L&&(y=2),e.isWindows=T,e.isMacintosh=R,e.isLinux=L,e.isLinuxSnap=k,e.isNative=P,e.isWeb=m,e.isIOS=b,e.platform=y,e.userAgent=I,e.language=C;var S;(function(n){function r(){return e.language}n.value=r;function c(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}n.isDefaultVariant=c;function l(){return e.language==="en"}n.isDefault=l})(S=e.Language||(e.Language={})),e.locale=i,e.translationsConfigFile=f,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let c=[];e.globals.addEventListener("message",h=>{if(h.data&&h.data.vscodeSetImmediateId)for(let d=0,v=c.length;d<v;d++){const A=c[d];if(A.id===h.data.vscodeSetImmediateId){c.splice(d,1),A.callback();return}}});let l=0;return h=>{const d=++l;c.push({id:d,callback:h}),e.globals.postMessage({vscodeSetImmediateId:d},"*")}}if(typeof u?.nextTick=="function")return u.nextTick.bind(u);const r=Promise.resolve();return c=>r.then(c)}();var o;(function(n){n[n.Windows=1]="Windows",n[n.Macintosh=2]="Macintosh",n[n.Linux=3]="Linux"})(o=e.OperatingSystem||(e.OperatingSystem={})),e.OS=R||b?2:T?1:3;let a=!0,t=!1;function s(){if(!t){t=!0;const n=new Uint8Array(2);n[0]=1,n[1]=2,a=new Uint16Array(n.buffer)[0]===(2<<8)+1}return a}e.isLittleEndian=s}),define(Z[31],ee([0,1,4]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.nextTick=e.platform=e.env=e.cwd=void 0;let T;if(typeof D.globals.vscode!="undefined"&&typeof D.globals.vscode.process!="undefined"){const R=D.globals.vscode.process;T={get platform(){return R.platform},get arch(){return R.arch},get env(){return R.env},cwd(){return R.cwd()},nextTick(L){return(0,D.setImmediate)(L)}}}else typeof process!="undefined"?T={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(R){return process.nextTick(R)}}:T={get platform(){return D.isWindows?"win32":D.isMacintosh?"darwin":"linux"},get arch(){},nextTick(R){return(0,D.setImmediate)(R)},get env(){return{}},cwd(){return"/"}};e.cwd=T.cwd,e.env=T.env,e.platform=T.platform,e.nextTick=T.nextTick,e.arch=T.arch}),define(Z[8],ee([0,1,31]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const T=65,R=97,L=90,k=122,P=46,m=47,b=92,i=58,C=63;class f extends Error{constructor(o,a,t){let s;typeof a=="string"&&a.indexOf("not ")===0?(s="must not be",a=a.replace(/^not /,"")):s="must be";const n=o.indexOf(".")!==-1?"property":"argument";let r=`The "${o}" ${n} ${s} of type ${a}`;r+=`. Received type ${typeof t}`,super(r),this.code="ERR_INVALID_ARG_TYPE"}}function I(S,o){if(typeof S!="string")throw new f(o,"string",S)}function u(S){return S===m||S===b}function w(S){return S===m}function g(S){return S>=T&&S<=L||S>=R&&S<=k}function E(S,o,a,t){let s="",n=0,r=-1,c=0,l=0;for(let h=0;h<=S.length;++h){if(h<S.length)l=S.charCodeAt(h);else{if(t(l))break;l=m}if(t(l)){if(!(r===h-1||c===1))if(c===2){if(s.length<2||n!==2||s.charCodeAt(s.length-1)!==P||s.charCodeAt(s.length-2)!==P){if(s.length>2){const d=s.lastIndexOf(a);d===-1?(s="",n=0):(s=s.slice(0,d),n=s.length-1-s.lastIndexOf(a)),r=h,c=0;continue}else if(s.length!==0){s="",n=0,r=h,c=0;continue}}o&&(s+=s.length>0?`${a}..`:"..",n=2)}else s.length>0?s+=`${a}${S.slice(r+1,h)}`:s=S.slice(r+1,h),n=h-r-1;r=h,c=0}else l===P&&c!==-1?++c:c=-1}return s}function y(S,o){if(o===null||typeof o!="object")throw new f("pathObject","Object",o);const a=o.dir||o.root,t=o.base||`${o.name||""}${o.ext||""}`;return a?a===o.root?`${a}${t}`:`${a}${S}${t}`:t}e.win32={resolve(...S){let o="",a="",t=!1;for(let s=S.length-1;s>=-1;s--){let n;if(s>=0){if(n=S[s],I(n,"path"),n.length===0)continue}else o.length===0?n=D.cwd():(n=D.env[`=${o}`]||D.cwd(),(n===void 0||n.slice(0,2).toLowerCase()!==o.toLowerCase()&&n.charCodeAt(2)===b)&&(n=`${o}\\`));const r=n.length;let c=0,l="",h=!1;const d=n.charCodeAt(0);if(r===1)u(d)&&(c=1,h=!0);else if(u(d))if(h=!0,u(n.charCodeAt(1))){let v=2,A=v;for(;v<r&&!u(n.charCodeAt(v));)v++;if(v<r&&v!==A){const O=n.slice(A,v);for(A=v;v<r&&u(n.charCodeAt(v));)v++;if(v<r&&v!==A){for(A=v;v<r&&!u(n.charCodeAt(v));)v++;(v===r||v!==A)&&(l=`\\\\${O}\\${n.slice(A,v)}`,c=v)}}}else c=1;else g(d)&&n.charCodeAt(1)===i&&(l=n.slice(0,2),c=2,r>2&&u(n.charCodeAt(2))&&(h=!0,c=3));if(l.length>0)if(o.length>0){if(l.toLowerCase()!==o.toLowerCase())continue}else o=l;if(t){if(o.length>0)break}else if(a=`${n.slice(c)}\\${a}`,t=h,h&&o.length>0)break}return a=E(a,!t,"\\",u),t?`${o}\\${a}`:`${o}${a}`||"."},normalize(S){I(S,"path");const o=S.length;if(o===0)return".";let a=0,t,s=!1;const n=S.charCodeAt(0);if(o===1)return w(n)?"\\":S;if(u(n))if(s=!0,u(S.charCodeAt(1))){let c=2,l=c;for(;c<o&&!u(S.charCodeAt(c));)c++;if(c<o&&c!==l){const h=S.slice(l,c);for(l=c;c<o&&u(S.charCodeAt(c));)c++;if(c<o&&c!==l){for(l=c;c<o&&!u(S.charCodeAt(c));)c++;if(c===o)return`\\\\${h}\\${S.slice(l)}\\`;c!==l&&(t=`\\\\${h}\\${S.slice(l,c)}`,a=c)}}}else a=1;else g(n)&&S.charCodeAt(1)===i&&(t=S.slice(0,2),a=2,o>2&&u(S.charCodeAt(2))&&(s=!0,a=3));let r=a<o?E(S.slice(a),!s,"\\",u):"";return r.length===0&&!s&&(r="."),r.length>0&&u(S.charCodeAt(o-1))&&(r+="\\"),t===void 0?s?`\\${r}`:r:s?`${t}\\${r}`:`${t}${r}`},isAbsolute(S){I(S,"path");const o=S.length;if(o===0)return!1;const a=S.charCodeAt(0);return u(a)||o>2&&g(a)&&S.charCodeAt(1)===i&&u(S.charCodeAt(2))},join(...S){if(S.length===0)return".";let o,a;for(let n=0;n<S.length;++n){const r=S[n];I(r,"path"),r.length>0&&(o===void 0?o=a=r:o+=`\\${r}`)}if(o===void 0)return".";let t=!0,s=0;if(typeof a=="string"&&u(a.charCodeAt(0))){++s;const n=a.length;n>1&&u(a.charCodeAt(1))&&(++s,n>2&&(u(a.charCodeAt(2))?++s:t=!1))}if(t){for(;s<o.length&&u(o.charCodeAt(s));)s++;s>=2&&(o=`\\${o.slice(s)}`)}return e.win32.normalize(o)},relative(S,o){if(I(S,"from"),I(o,"to"),S===o)return"";const a=e.win32.resolve(S),t=e.win32.resolve(o);if(a===t||(S=a.toLowerCase(),o=t.toLowerCase(),S===o))return"";let s=0;for(;s<S.length&&S.charCodeAt(s)===b;)s++;let n=S.length;for(;n-1>s&&S.charCodeAt(n-1)===b;)n--;const r=n-s;let c=0;for(;c<o.length&&o.charCodeAt(c)===b;)c++;let l=o.length;for(;l-1>c&&o.charCodeAt(l-1)===b;)l--;const h=l-c,d=r<h?r:h;let v=-1,A=0;for(;A<d;A++){const p=S.charCodeAt(s+A);if(p!==o.charCodeAt(c+A))break;p===b&&(v=A)}if(A!==d){if(v===-1)return t}else{if(h>d){if(o.charCodeAt(c+A)===b)return t.slice(c+A+1);if(A===2)return t.slice(c+A)}r>d&&(S.charCodeAt(s+A)===b?v=A:A===2&&(v=3)),v===-1&&(v=0)}let O="";for(A=s+v+1;A<=n;++A)(A===n||S.charCodeAt(A)===b)&&(O+=O.length===0?"..":"\\..");return c+=v,O.length>0?`${O}${t.slice(c,l)}`:(t.charCodeAt(c)===b&&++c,t.slice(c,l))},toNamespacedPath(S){if(typeof S!="string")return S;if(S.length===0)return"";const o=e.win32.resolve(S);if(o.length<=2)return S;if(o.charCodeAt(0)===b){if(o.charCodeAt(1)===b){const a=o.charCodeAt(2);if(a!==C&&a!==P)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(g(o.charCodeAt(0))&&o.charCodeAt(1)===i&&o.charCodeAt(2)===b)return`\\\\?\\${o}`;return S},dirname(S){I(S,"path");const o=S.length;if(o===0)return".";let a=-1,t=0;const s=S.charCodeAt(0);if(o===1)return u(s)?S:".";if(u(s)){if(a=t=1,u(S.charCodeAt(1))){let c=2,l=c;for(;c<o&&!u(S.charCodeAt(c));)c++;if(c<o&&c!==l){for(l=c;c<o&&u(S.charCodeAt(c));)c++;if(c<o&&c!==l){for(l=c;c<o&&!u(S.charCodeAt(c));)c++;if(c===o)return S;c!==l&&(a=t=c+1)}}}}else g(s)&&S.charCodeAt(1)===i&&(a=o>2&&u(S.charCodeAt(2))?3:2,t=a);let n=-1,r=!0;for(let c=o-1;c>=t;--c)if(u(S.charCodeAt(c))){if(!r){n=c;break}}else r=!1;if(n===-1){if(a===-1)return".";n=a}return S.slice(0,n)},basename(S,o){o!==void 0&&I(o,"ext"),I(S,"path");let a=0,t=-1,s=!0,n;if(S.length>=2&&g(S.charCodeAt(0))&&S.charCodeAt(1)===i&&(a=2),o!==void 0&&o.length>0&&o.length<=S.length){if(o===S)return"";let r=o.length-1,c=-1;for(n=S.length-1;n>=a;--n){const l=S.charCodeAt(n);if(u(l)){if(!s){a=n+1;break}}else c===-1&&(s=!1,c=n+1),r>=0&&(l===o.charCodeAt(r)?--r==-1&&(t=n):(r=-1,t=c))}return a===t?t=c:t===-1&&(t=S.length),S.slice(a,t)}for(n=S.length-1;n>=a;--n)if(u(S.charCodeAt(n))){if(!s){a=n+1;break}}else t===-1&&(s=!1,t=n+1);return t===-1?"":S.slice(a,t)},extname(S){I(S,"path");let o=0,a=-1,t=0,s=-1,n=!0,r=0;S.length>=2&&S.charCodeAt(1)===i&&g(S.charCodeAt(0))&&(o=t=2);for(let c=S.length-1;c>=o;--c){const l=S.charCodeAt(c);if(u(l)){if(!n){t=c+1;break}continue}s===-1&&(n=!1,s=c+1),l===P?a===-1?a=c:r!==1&&(r=1):a!==-1&&(r=-1)}return a===-1||s===-1||r===0||r===1&&a===s-1&&a===t+1?"":S.slice(a,s)},format:y.bind(null,"\\"),parse(S){I(S,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(S.length===0)return o;const a=S.length;let t=0,s=S.charCodeAt(0);if(a===1)return u(s)?(o.root=o.dir=S,o):(o.base=o.name=S,o);if(u(s)){if(t=1,u(S.charCodeAt(1))){let v=2,A=v;for(;v<a&&!u(S.charCodeAt(v));)v++;if(v<a&&v!==A){for(A=v;v<a&&u(S.charCodeAt(v));)v++;if(v<a&&v!==A){for(A=v;v<a&&!u(S.charCodeAt(v));)v++;v===a?t=v:v!==A&&(t=v+1)}}}}else if(g(s)&&S.charCodeAt(1)===i){if(a<=2)return o.root=o.dir=S,o;if(t=2,u(S.charCodeAt(2))){if(a===3)return o.root=o.dir=S,o;t=3}}t>0&&(o.root=S.slice(0,t));let n=-1,r=t,c=-1,l=!0,h=S.length-1,d=0;for(;h>=t;--h){if(s=S.charCodeAt(h),u(s)){if(!l){r=h+1;break}continue}c===-1&&(l=!1,c=h+1),s===P?n===-1?n=h:d!==1&&(d=1):n!==-1&&(d=-1)}return c!==-1&&(n===-1||d===0||d===1&&n===c-1&&n===r+1?o.base=o.name=S.slice(r,c):(o.name=S.slice(r,n),o.base=S.slice(r,c),o.ext=S.slice(n,c))),r>0&&r!==t?o.dir=S.slice(0,r-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...S){let o="",a=!1;for(let t=S.length-1;t>=-1&&!a;t--){const s=t>=0?S[t]:D.cwd();I(s,"path"),s.length!==0&&(o=`${s}/${o}`,a=s.charCodeAt(0)===m)}return o=E(o,!a,"/",w),a?`/${o}`:o.length>0?o:"."},normalize(S){if(I(S,"path"),S.length===0)return".";const o=S.charCodeAt(0)===m,a=S.charCodeAt(S.length-1)===m;return S=E(S,!o,"/",w),S.length===0?o?"/":a?"./":".":(a&&(S+="/"),o?`/${S}`:S)},isAbsolute(S){return I(S,"path"),S.length>0&&S.charCodeAt(0)===m},join(...S){if(S.length===0)return".";let o;for(let a=0;a<S.length;++a){const t=S[a];I(t,"path"),t.length>0&&(o===void 0?o=t:o+=`/${t}`)}return o===void 0?".":e.posix.normalize(o)},relative(S,o){if(I(S,"from"),I(o,"to"),S===o||(S=e.posix.resolve(S),o=e.posix.resolve(o),S===o))return"";const a=1,t=S.length,s=t-a,n=1,r=o.length-n,c=s<r?s:r;let l=-1,h=0;for(;h<c;h++){const v=S.charCodeAt(a+h);if(v!==o.charCodeAt(n+h))break;v===m&&(l=h)}if(h===c)if(r>c){if(o.charCodeAt(n+h)===m)return o.slice(n+h+1);if(h===0)return o.slice(n+h)}else s>c&&(S.charCodeAt(a+h)===m?l=h:h===0&&(l=0));let d="";for(h=a+l+1;h<=t;++h)(h===t||S.charCodeAt(h)===m)&&(d+=d.length===0?"..":"/..");return`${d}${o.slice(n+l)}`},toNamespacedPath(S){return S},dirname(S){if(I(S,"path"),S.length===0)return".";const o=S.charCodeAt(0)===m;let a=-1,t=!0;for(let s=S.length-1;s>=1;--s)if(S.charCodeAt(s)===m){if(!t){a=s;break}}else t=!1;return a===-1?o?"/":".":o&&a===1?"//":S.slice(0,a)},basename(S,o){o!==void 0&&I(o,"ext"),I(S,"path");let a=0,t=-1,s=!0,n;if(o!==void 0&&o.length>0&&o.length<=S.length){if(o===S)return"";let r=o.length-1,c=-1;for(n=S.length-1;n>=0;--n){const l=S.charCodeAt(n);if(l===m){if(!s){a=n+1;break}}else c===-1&&(s=!1,c=n+1),r>=0&&(l===o.charCodeAt(r)?--r==-1&&(t=n):(r=-1,t=c))}return a===t?t=c:t===-1&&(t=S.length),S.slice(a,t)}for(n=S.length-1;n>=0;--n)if(S.charCodeAt(n)===m){if(!s){a=n+1;break}}else t===-1&&(s=!1,t=n+1);return t===-1?"":S.slice(a,t)},extname(S){I(S,"path");let o=-1,a=0,t=-1,s=!0,n=0;for(let r=S.length-1;r>=0;--r){const c=S.charCodeAt(r);if(c===m){if(!s){a=r+1;break}continue}t===-1&&(s=!1,t=r+1),c===P?o===-1?o=r:n!==1&&(n=1):o!==-1&&(n=-1)}return o===-1||t===-1||n===0||n===1&&o===t-1&&o===a+1?"":S.slice(o,t)},format:y.bind(null,"/"),parse(S){I(S,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(S.length===0)return o;const a=S.charCodeAt(0)===m;let t;a?(o.root="/",t=1):t=0;let s=-1,n=0,r=-1,c=!0,l=S.length-1,h=0;for(;l>=t;--l){const d=S.charCodeAt(l);if(d===m){if(!c){n=l+1;break}continue}r===-1&&(c=!1,r=l+1),d===P?s===-1?s=l:h!==1&&(h=1):s!==-1&&(h=-1)}if(r!==-1){const d=n===0&&a?1:n;s===-1||h===0||h===1&&s===r-1&&s===n+1?o.base=o.name=S.slice(d,r):(o.name=S.slice(d,s),o.base=S.slice(d,r),o.ext=S.slice(s,r))}return n>0?o.dir=S.slice(0,n-1):a&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=D.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=D.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=D.platform==="win32"?e.win32.join:e.posix.join,e.resolve=D.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=D.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=D.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=D.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=D.platform==="win32"?e.win32.extname:e.posix.extname,e.format=D.platform==="win32"?e.win32.format:e.posix.format,e.parse=D.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=D.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=D.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=D.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),function(K,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var D=e();for(var T in D)(typeof exports=="object"?exports:K)[T]=D[T]}}(typeof self!="undefined"?self:this,function(){return function(K){var e={};function D(T){if(e[T])return e[T].exports;var R=e[T]={i:T,l:!1,exports:{}};return K[T].call(R.exports,R,R.exports,D),R.l=!0,R.exports}return D.m=K,D.c=e,D.d=function(T,R,L){D.o(T,R)||Object.defineProperty(T,R,{enumerable:!0,get:L})},D.r=function(T){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(T,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(T,"__esModule",{value:!0})},D.t=function(T,R){if(1&R&&(T=D(T)),8&R||4&R&&typeof T=="object"&&T&&T.__esModule)return T;var L=Object.create(null);if(D.r(L),Object.defineProperty(L,"default",{enumerable:!0,value:T}),2&R&&typeof T!="string")for(var k in T)D.d(L,k,function(P){return T[P]}.bind(null,k));return L},D.n=function(T){var R=T&&T.__esModule?function(){return T.default}:function(){return T};return D.d(R,"a",R),R},D.o=function(T,R){return Object.prototype.hasOwnProperty.call(T,R)},D.p="",D(D.s=0)}([function(K,e,D){(function(T){var R;e=K.exports=te,R=typeof T=="object"&&T.env&&T.env.NODE_DEBUG&&/\bsemver\b/i.test(T.env.NODE_DEBUG)?function(){var Q=Array.prototype.slice.call(arguments,0);Q.unshift("SEMVER"),console.log.apply(console,Q)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var L=256,k=Number.MAX_SAFE_INTEGER||9007199254740991,P=e.re=[],m=e.src=[],b=0,i=b++;m[i]="0|[1-9]\\d*";var C=b++;m[C]="[0-9]+";var f=b++;m[f]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var I=b++;m[I]="("+m[i]+")\\.("+m[i]+")\\.("+m[i]+")";var u=b++;m[u]="("+m[C]+")\\.("+m[C]+")\\.("+m[C]+")";var w=b++;m[w]="(?:"+m[i]+"|"+m[f]+")";var g=b++;m[g]="(?:"+m[C]+"|"+m[f]+")";var E=b++;m[E]="(?:-("+m[w]+"(?:\\."+m[w]+")*))";var y=b++;m[y]="(?:-?("+m[g]+"(?:\\."+m[g]+")*))";var S=b++;m[S]="[0-9A-Za-z-]+";var o=b++;m[o]="(?:\\+("+m[S]+"(?:\\."+m[S]+")*))";var a=b++,t="v?"+m[I]+m[E]+"?"+m[o]+"?";m[a]="^"+t+"$";var s="[v=\\s]*"+m[u]+m[y]+"?"+m[o]+"?",n=b++;m[n]="^"+s+"$";var r=b++;m[r]="((?:<|>)?=?)";var c=b++;m[c]=m[C]+"|x|X|\\*";var l=b++;m[l]=m[i]+"|x|X|\\*";var h=b++;m[h]="[v=\\s]*("+m[l]+")(?:\\.("+m[l]+")(?:\\.("+m[l]+")(?:"+m[E]+")?"+m[o]+"?)?)?";var d=b++;m[d]="[v=\\s]*("+m[c]+")(?:\\.("+m[c]+")(?:\\.("+m[c]+")(?:"+m[y]+")?"+m[o]+"?)?)?";var v=b++;m[v]="^"+m[r]+"\\s*"+m[h]+"$";var A=b++;m[A]="^"+m[r]+"\\s*"+m[d]+"$";var O=b++;m[O]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var p=b++;m[p]="(?:~>?)";var U=b++;m[U]="(\\s*)"+m[p]+"\\s+",P[U]=new RegExp(m[U],"g");var F=b++;m[F]="^"+m[p]+m[h]+"$";var $=b++;m[$]="^"+m[p]+m[d]+"$";var H=b++;m[H]="(?:\\^)";var M=b++;m[M]="(\\s*)"+m[H]+"\\s+",P[M]=new RegExp(m[M],"g");var j=b++;m[j]="^"+m[H]+m[h]+"$";var q=b++;m[q]="^"+m[H]+m[d]+"$";var z=b++;m[z]="^"+m[r]+"\\s*("+s+")$|^$";var x=b++;m[x]="^"+m[r]+"\\s*("+t+")$|^$";var N=b++;m[N]="(\\s*)"+m[r]+"\\s*("+s+"|"+m[h]+")",P[N]=new RegExp(m[N],"g");var W=b++;m[W]="^\\s*("+m[h]+")\\s+-\\s+("+m[h]+")\\s*$";var _=b++;m[_]="^\\s*("+m[d]+")\\s+-\\s+("+m[d]+")\\s*$";var Y=b++;m[Y]="(<|>)?=?\\s*\\*";for(var G=0;G<35;G++)R(G,m[G]),P[G]||(P[G]=new RegExp(m[G]));function ne(Q,ae){if(Q instanceof te)return Q;if(typeof Q!="string"||Q.length>L||!(ae?P[n]:P[a]).test(Q))return null;try{return new te(Q,ae)}catch(oe){return null}}function te(Q,ae){if(Q instanceof te){if(Q.loose===ae)return Q;Q=Q.version}else if(typeof Q!="string")throw new TypeError("Invalid Version: "+Q);if(Q.length>L)throw new TypeError("version is longer than "+L+" characters");if(!(this instanceof te))return new te(Q,ae);R("SemVer",Q,ae),this.loose=ae;var oe=Q.trim().match(ae?P[n]:P[a]);if(!oe)throw new TypeError("Invalid Version: "+Q);if(this.raw=Q,this.major=+oe[1],this.minor=+oe[2],this.patch=+oe[3],this.major>k||this.major<0)throw new TypeError("Invalid major version");if(this.minor>k||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>k||this.patch<0)throw new TypeError("Invalid patch version");oe[4]?this.prerelease=oe[4].split(".").map(function(pe){if(/^[0-9]+$/.test(pe)){var Se=+pe;if(Se>=0&&Se<k)return Se}return pe}):this.prerelease=[],this.build=oe[5]?oe[5].split("."):[],this.format()}e.parse=ne,e.valid=function(Q,ae){var oe=ne(Q,ae);return oe?oe.version:null},e.clean=function(Q,ae){var oe=ne(Q.trim().replace(/^[=v]+/,""),ae);return oe?oe.version:null},e.SemVer=te,te.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},te.prototype.toString=function(){return this.version},te.prototype.compare=function(Q){return R("SemVer.compare",this.version,this.loose,Q),Q instanceof te||(Q=new te(Q,this.loose)),this.compareMain(Q)||this.comparePre(Q)},te.prototype.compareMain=function(Q){return Q instanceof te||(Q=new te(Q,this.loose)),V(this.major,Q.major)||V(this.minor,Q.minor)||V(this.patch,Q.patch)},te.prototype.comparePre=function(Q){if(Q instanceof te||(Q=new te(Q,this.loose)),this.prerelease.length&&!Q.prerelease.length)return-1;if(!this.prerelease.length&&Q.prerelease.length)return 1;if(!this.prerelease.length&&!Q.prerelease.length)return 0;var ae=0;do{var oe=this.prerelease[ae],pe=Q.prerelease[ae];if(R("prerelease compare",ae,oe,pe),oe===void 0&&pe===void 0)return 0;if(pe===void 0)return 1;if(oe===void 0)return-1;if(oe!==pe)return V(oe,pe)}while(++ae)},te.prototype.inc=function(Q,ae){switch(Q){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ae);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ae);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ae),this.inc("pre",ae);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ae),this.inc("pre",ae);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var oe=this.prerelease.length;--oe>=0;)typeof this.prerelease[oe]=="number"&&(this.prerelease[oe]++,oe=-2);oe===-1&&this.prerelease.push(0)}ae&&(this.prerelease[0]===ae?isNaN(this.prerelease[1])&&(this.prerelease=[ae,0]):this.prerelease=[ae,0]);break;default:throw new Error("invalid increment argument: "+Q)}return this.format(),this.raw=this.version,this},e.inc=function(Q,ae,oe,pe){typeof oe=="string"&&(pe=oe,oe=void 0);try{return new te(Q,oe).inc(ae,pe).version}catch(Se){return null}},e.diff=function(Q,ae){if(ue(Q,ae))return null;var oe=ne(Q),pe=ne(ae);if(oe.prerelease.length||pe.prerelease.length){for(var Se in oe)if((Se==="major"||Se==="minor"||Se==="patch")&&oe[Se]!==pe[Se])return"pre"+Se;return"prerelease"}for(var Se in oe)if((Se==="major"||Se==="minor"||Se==="patch")&&oe[Se]!==pe[Se])return Se},e.compareIdentifiers=V;var J=/^[0-9]+$/;function V(Q,ae){var oe=J.test(Q),pe=J.test(ae);return oe&&pe&&(Q=+Q,ae=+ae),oe&&!pe?-1:pe&&!oe?1:Q<ae?-1:Q>ae?1:0}function re(Q,ae,oe){return new te(Q,oe).compare(new te(ae,oe))}function ie(Q,ae,oe){return re(Q,ae,oe)>0}function ce(Q,ae,oe){return re(Q,ae,oe)<0}function ue(Q,ae,oe){return re(Q,ae,oe)===0}function ye(Q,ae,oe){return re(Q,ae,oe)!==0}function ge(Q,ae,oe){return re(Q,ae,oe)>=0}function Ie(Q,ae,oe){return re(Q,ae,oe)<=0}function Pe(Q,ae,oe,pe){var Se;switch(ae){case"===":typeof Q=="object"&&(Q=Q.version),typeof oe=="object"&&(oe=oe.version),Se=Q===oe;break;case"!==":typeof Q=="object"&&(Q=Q.version),typeof oe=="object"&&(oe=oe.version),Se=Q!==oe;break;case"":case"=":case"==":Se=ue(Q,oe,pe);break;case"!=":Se=ye(Q,oe,pe);break;case">":Se=ie(Q,oe,pe);break;case">=":Se=ge(Q,oe,pe);break;case"<":Se=ce(Q,oe,pe);break;case"<=":Se=Ie(Q,oe,pe);break;default:throw new TypeError("Invalid operator: "+ae)}return Se}function Ee(Q,ae){if(Q instanceof Ee){if(Q.loose===ae)return Q;Q=Q.value}if(!(this instanceof Ee))return new Ee(Q,ae);R("comparator",Q,ae),this.loose=ae,this.parse(Q),this.semver===Ae?this.value="":this.value=this.operator+this.semver.version,R("comp",this)}e.rcompareIdentifiers=function(Q,ae){return V(ae,Q)},e.major=function(Q,ae){return new te(Q,ae).major},e.minor=function(Q,ae){return new te(Q,ae).minor},e.patch=function(Q,ae){return new te(Q,ae).patch},e.compare=re,e.compareLoose=function(Q,ae){return re(Q,ae,!0)},e.rcompare=function(Q,ae,oe){return re(ae,Q,oe)},e.sort=function(Q,ae){return Q.sort(function(oe,pe){return e.compare(oe,pe,ae)})},e.rsort=function(Q,ae){return Q.sort(function(oe,pe){return e.rcompare(oe,pe,ae)})},e.gt=ie,e.lt=ce,e.eq=ue,e.neq=ye,e.gte=ge,e.lte=Ie,e.cmp=Pe,e.Comparator=Ee;var Ae={};function De(Q,ae){if(Q instanceof De)return Q.loose===ae?Q:new De(Q.raw,ae);if(Q instanceof Ee)return new De(Q.value,ae);if(!(this instanceof De))return new De(Q,ae);if(this.loose=ae,this.raw=Q,this.set=Q.split(/\s*\|\|\s*/).map(function(oe){return this.parseRange(oe.trim())},this).filter(function(oe){return oe.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+Q);this.format()}function Te(Q){return!Q||Q.toLowerCase()==="x"||Q==="*"}function Ne(Q,ae,oe,pe,Se,Oe,Le,Ue,ke,B,se,le,he){return((ae=Te(oe)?"":Te(pe)?">="+oe+".0.0":Te(Se)?">="+oe+"."+pe+".0":">="+ae)+" "+(Ue=Te(ke)?"":Te(B)?"<"+(+ke+1)+".0.0":Te(se)?"<"+ke+"."+(+B+1)+".0":le?"<="+ke+"."+B+"."+se+"-"+le:"<="+Ue)).trim()}function _e(Q,ae){for(var oe=0;oe<Q.length;oe++)if(!Q[oe].test(ae))return!1;if(ae.prerelease.length){for(oe=0;oe<Q.length;oe++)if(R(Q[oe].semver),Q[oe].semver!==Ae&&Q[oe].semver.prerelease.length>0){var pe=Q[oe].semver;if(pe.major===ae.major&&pe.minor===ae.minor&&pe.patch===ae.patch)return!0}return!1}return!0}function $e(Q,ae,oe){try{ae=new De(ae,oe)}catch(pe){return!1}return ae.test(Q)}function xe(Q,ae,oe,pe){var Se,Oe,Le,Ue,ke;switch(Q=new te(Q,pe),ae=new De(ae,pe),oe){case">":Se=ie,Oe=Ie,Le=ce,Ue=">",ke=">=";break;case"<":Se=ce,Oe=ge,Le=ie,Ue="<",ke="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if($e(Q,ae,pe))return!1;for(var B=0;B<ae.set.length;++B){var se=ae.set[B],le=null,he=null;if(se.forEach(function(me){me.semver===Ae&&(me=new Ee(">=0.0.0")),le=le||me,he=he||me,Se(me.semver,le.semver,pe)?le=me:Le(me.semver,he.semver,pe)&&(he=me)}),le.operator===Ue||le.operator===ke||(!he.operator||he.operator===Ue)&&Oe(Q,he.semver)||he.operator===ke&&Le(Q,he.semver))return!1}return!0}Ee.prototype.parse=function(Q){var ae=this.loose?P[z]:P[x],oe=Q.match(ae);if(!oe)throw new TypeError("Invalid comparator: "+Q);this.operator=oe[1],this.operator==="="&&(this.operator=""),oe[2]?this.semver=new te(oe[2],this.loose):this.semver=Ae},Ee.prototype.toString=function(){return this.value},Ee.prototype.test=function(Q){return R("Comparator.test",Q,this.loose),this.semver===Ae||(typeof Q=="string"&&(Q=new te(Q,this.loose)),Pe(Q,this.operator,this.semver,this.loose))},Ee.prototype.intersects=function(Q,ae){if(!(Q instanceof Ee))throw new TypeError("a Comparator is required");var oe;if(this.operator==="")return oe=new De(Q.value,ae),$e(this.value,oe,ae);if(Q.operator==="")return oe=new De(this.value,ae),$e(Q.semver,oe,ae);var pe=!(this.operator!==">="&&this.operator!==">"||Q.operator!==">="&&Q.operator!==">"),Se=!(this.operator!=="<="&&this.operator!=="<"||Q.operator!=="<="&&Q.operator!=="<"),Oe=this.semver.version===Q.semver.version,Le=!(this.operator!==">="&&this.operator!=="<="||Q.operator!==">="&&Q.operator!=="<="),Ue=Pe(this.semver,"<",Q.semver,ae)&&(this.operator===">="||this.operator===">")&&(Q.operator==="<="||Q.operator==="<"),ke=Pe(this.semver,">",Q.semver,ae)&&(this.operator==="<="||this.operator==="<")&&(Q.operator===">="||Q.operator===">");return pe||Se||Oe&&Le||Ue||ke},e.Range=De,De.prototype.format=function(){return this.range=this.set.map(function(Q){return Q.join(" ").trim()}).join("||").trim(),this.range},De.prototype.toString=function(){return this.range},De.prototype.parseRange=function(Q){var ae=this.loose;Q=Q.trim(),R("range",Q,ae);var oe=ae?P[_]:P[W];Q=Q.replace(oe,Ne),R("hyphen replace",Q),Q=Q.replace(P[N],"$1$2$3"),R("comparator trim",Q,P[N]),Q=(Q=(Q=Q.replace(P[U],"$1~")).replace(P[M],"$1^")).split(/\s+/).join(" ");var pe=ae?P[z]:P[x],Se=Q.split(" ").map(function(Oe){return function(Le,Ue){return R("comp",Le),Le=function(ke,B){return ke.trim().split(/\s+/).map(function(se){return function(le,he){R("caret",le,he);var me=he?P[q]:P[j];return le.replace(me,function(be,ve,we,Ce,Re){var fe;return R("caret",le,be,ve,we,Ce,Re),Te(ve)?fe="":Te(we)?fe=">="+ve+".0.0 <"+(+ve+1)+".0.0":Te(Ce)?fe=ve==="0"?">="+ve+"."+we+".0 <"+ve+"."+(+we+1)+".0":">="+ve+"."+we+".0 <"+(+ve+1)+".0.0":Re?(R("replaceCaret pr",Re),Re.charAt(0)!=="-"&&(Re="-"+Re),fe=ve==="0"?we==="0"?">="+ve+"."+we+"."+Ce+Re+" <"+ve+"."+we+"."+(+Ce+1):">="+ve+"."+we+"."+Ce+Re+" <"+ve+"."+(+we+1)+".0":">="+ve+"."+we+"."+Ce+Re+" <"+(+ve+1)+".0.0"):(R("no pr"),fe=ve==="0"?we==="0"?">="+ve+"."+we+"."+Ce+" <"+ve+"."+we+"."+(+Ce+1):">="+ve+"."+we+"."+Ce+" <"+ve+"."+(+we+1)+".0":">="+ve+"."+we+"."+Ce+" <"+(+ve+1)+".0.0"),R("caret return",fe),fe})}(se,B)}).join(" ")}(Le,Ue),R("caret",Le),Le=function(ke,B){return ke.trim().split(/\s+/).map(function(se){return function(le,he){var me=he?P[$]:P[F];return le.replace(me,function(be,ve,we,Ce,Re){var fe;return R("tilde",le,be,ve,we,Ce,Re),Te(ve)?fe="":Te(we)?fe=">="+ve+".0.0 <"+(+ve+1)+".0.0":Te(Ce)?fe=">="+ve+"."+we+".0 <"+ve+"."+(+we+1)+".0":Re?(R("replaceTilde pr",Re),Re.charAt(0)!=="-"&&(Re="-"+Re),fe=">="+ve+"."+we+"."+Ce+Re+" <"+ve+"."+(+we+1)+".0"):fe=">="+ve+"."+we+"."+Ce+" <"+ve+"."+(+we+1)+".0",R("tilde return",fe),fe})}(se,B)}).join(" ")}(Le,Ue),R("tildes",Le),Le=function(ke,B){return R("replaceXRanges",ke,B),ke.split(/\s+/).map(function(se){return function(le,he){le=le.trim();var me=he?P[A]:P[v];return le.replace(me,function(be,ve,we,Ce,Re,fe){R("xRange",le,be,ve,we,Ce,Re,fe);var Fe=Te(we),Me=Fe||Te(Ce),ze=Me||Te(Re);return ve==="="&&ze&&(ve=""),Fe?be=ve===">"||ve==="<"?"<0.0.0":"*":ve&&ze?(Me&&(Ce=0),ze&&(Re=0),ve===">"?(ve=">=",Me?(we=+we+1,Ce=0,Re=0):ze&&(Ce=+Ce+1,Re=0)):ve==="<="&&(ve="<",Me?we=+we+1:Ce=+Ce+1),be=ve+we+"."+Ce+"."+Re):Me?be=">="+we+".0.0 <"+(+we+1)+".0.0":ze&&(be=">="+we+"."+Ce+".0 <"+we+"."+(+Ce+1)+".0"),R("xRange return",be),be})}(se,B)}).join(" ")}(Le,Ue),R("xrange",Le),Le=function(ke,B){return R("replaceStars",ke,B),ke.trim().replace(P[Y],"")}(Le,Ue),R("stars",Le),Le}(Oe,ae)}).join(" ").split(/\s+/);return this.loose&&(Se=Se.filter(function(Oe){return!!Oe.match(pe)})),Se=Se.map(function(Oe){return new Ee(Oe,ae)})},De.prototype.intersects=function(Q,ae){if(!(Q instanceof De))throw new TypeError("a Range is required");return this.set.some(function(oe){return oe.every(function(pe){return Q.set.some(function(Se){return Se.every(function(Oe){return pe.intersects(Oe,ae)})})})})},e.toComparators=function(Q,ae){return new De(Q,ae).set.map(function(oe){return oe.map(function(pe){return pe.value}).join(" ").trim().split(" ")})},De.prototype.test=function(Q){if(!Q)return!1;typeof Q=="string"&&(Q=new te(Q,this.loose));for(var ae=0;ae<this.set.length;ae++)if(_e(this.set[ae],Q))return!0;return!1},e.satisfies=$e,e.maxSatisfying=function(Q,ae,oe){var pe=null,Se=null;try{var Oe=new De(ae,oe)}catch(Le){return null}return Q.forEach(function(Le){Oe.test(Le)&&(pe&&Se.compare(Le)!==-1||(Se=new te(pe=Le,oe)))}),pe},e.minSatisfying=function(Q,ae,oe){var pe=null,Se=null;try{var Oe=new De(ae,oe)}catch(Le){return null}return Q.forEach(function(Le){Oe.test(Le)&&(pe&&Se.compare(Le)!==1||(Se=new te(pe=Le,oe)))}),pe},e.validRange=function(Q,ae){try{return new De(Q,ae).range||"*"}catch(oe){return null}},e.ltr=function(Q,ae,oe){return xe(Q,ae,"<",oe)},e.gtr=function(Q,ae,oe){return xe(Q,ae,">",oe)},e.outside=xe,e.prerelease=function(Q,ae){var oe=ne(Q,ae);return oe&&oe.prerelease.length?oe.prerelease:null},e.intersects=function(Q,ae,oe){return Q=new De(Q,oe),ae=new De(ae,oe),Q.intersects(ae)},e.coerce=function(Q){if(Q instanceof te)return Q;if(typeof Q!="string")return null;var ae=Q.match(P[O]);return ae==null?null:ne((ae[1]||"0")+"."+(ae[2]||"0")+"."+(ae[3]||"0"))}}).call(this,D(1))},function(K,e){var D,T,R=K.exports={};function L(){throw new Error("setTimeout has not been defined")}function k(){throw new Error("clearTimeout has not been defined")}function P(g){if(D===setTimeout)return setTimeout(g,0);if((D===L||!D)&&setTimeout)return D=setTimeout,setTimeout(g,0);try{return D(g,0)}catch(E){try{return D.call(null,g,0)}catch(y){return D.call(this,g,0)}}}(function(){try{D=typeof setTimeout=="function"?setTimeout:L}catch(g){D=L}try{T=typeof clearTimeout=="function"?clearTimeout:k}catch(g){T=k}})();var m,b=[],i=!1,C=-1;function f(){i&&m&&(i=!1,m.length?b=m.concat(b):C=-1,b.length&&I())}function I(){if(!i){var g=P(f);i=!0;for(var E=b.length;E;){for(m=b,b=[];++C<E;)m&&m[C].run();C=-1,E=b.length}m=null,i=!1,function(y){if(T===clearTimeout)return clearTimeout(y);if((T===k||!T)&&clearTimeout)return T=clearTimeout,clearTimeout(y);try{T(y)}catch(S){try{return T.call(null,y)}catch(o){return T.call(this,y)}}}(g)}}function u(g,E){this.fun=g,this.array=E}function w(){}R.nextTick=function(g){var E=new Array(arguments.length-1);if(arguments.length>1)for(var y=1;y<arguments.length;y++)E[y-1]=arguments[y];b.push(new u(g,E)),b.length!==1||i||P(I)},u.prototype.run=function(){this.fun.apply(null,this.array)},R.title="browser",R.browser=!0,R.env={},R.argv=[],R.version="",R.versions={},R.on=w,R.addListener=w,R.once=w,R.off=w,R.removeListener=w,R.removeAllListeners=w,R.emit=w,R.prependListener=w,R.prependOnceListener=w,R.listeners=function(g){return[]},R.binding=function(g){throw new Error("process.binding is not supported")},R.cwd=function(){return"/"},R.chdir=function(g){throw new Error("process.chdir is not supported")},R.umask=function(){return 0}}])}),define(Z[92],ee([0,1,4]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const T=D.globals.performance&&typeof D.globals.performance.now=="function";class R{constructor(k){this._highResolution=T&&k,this._startTime=this._now(),this._stopTime=-1}static create(k=!0){return new R(k)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?D.globals.performance.now():Date.now()}}e.StopWatch=R}),define(Z[3],ee([0,1,9,65,2,91,92]),function(K,e,D,T,R,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var P;(function(o){o.None=()=>R.Disposable.None;function a(M){return(j,q=null,z)=>{let x=!1,N;return N=M(W=>{if(!x)return N?N.dispose():x=!0,j.call(q,W)},null,z),x&&N.dispose(),N}}o.once=a;function t(M,j){return h((q,z=null,x)=>M(N=>q.call(z,j(N)),null,x))}o.map=t;function s(M,j){return h((q,z=null,x)=>M(N=>{j(N),q.call(z,N)},null,x))}o.forEach=s;function n(M,j){return h((q,z=null,x)=>M(N=>j(N)&&q.call(z,N),null,x))}o.filter=n;function r(M){return M}o.signal=r;function c(...M){return(j,q=null,z)=>(0,R.combinedDisposable)(...M.map(x=>x(N=>j.call(q,N),null,z)))}o.any=c;function l(M,j,q){let z=q;return t(M,x=>(z=j(z,x),z))}o.reduce=l;function h(M){let j;const q=new f({onFirstListenerAdd(){j=M(q.fire,q)},onLastListenerRemove(){j.dispose()}});return q.event}function d(M,j,q=100,z=!1,x){let N,W,_,Y=0;const G=new f({leakWarningThreshold:x,onFirstListenerAdd(){N=M(ne=>{Y++,W=j(W,ne),z&&!_&&(G.fire(W),W=void 0),clearTimeout(_),_=setTimeout(()=>{const te=W;W=void 0,_=void 0,(!z||Y>1)&&G.fire(te),Y=0},q)})},onLastListenerRemove(){N.dispose()}});return G.event}o.debounce=d;function v(M,j=(q,z)=>q===z){let q=!0,z;return n(M,x=>{const N=q||!j(x,z);return q=!1,z=x,N})}o.latch=v;function A(M,j){return[o.filter(M,j),o.filter(M,q=>!j(q))]}o.split=A;function O(M,j=!1,q=[]){let z=q.slice(),x=M(_=>{z?z.push(_):W.fire(_)});const N=()=>{z&&z.forEach(_=>W.fire(_)),z=null},W=new f({onFirstListenerAdd(){x||(x=M(_=>W.fire(_)))},onFirstListenerDidAdd(){z&&(j?setTimeout(N):N())},onLastListenerRemove(){x&&x.dispose(),x=null}});return W.event}o.buffer=O;class p{constructor(j){this.event=j}map(j){return new p(t(this.event,j))}forEach(j){return new p(s(this.event,j))}filter(j){return new p(n(this.event,j))}reduce(j,q){return new p(l(this.event,j,q))}latch(){return new p(v(this.event))}debounce(j,q=100,z=!1,x){return new p(d(this.event,j,q,z,x))}on(j,q,z){return this.event(j,q,z)}once(j,q,z){return a(this.event)(j,q,z)}}function U(M){return new p(M)}o.chain=U;function F(M,j,q=z=>z){const z=(..._)=>W.fire(q(..._)),x=()=>M.on(j,z),N=()=>M.removeListener(j,z),W=new f({onFirstListenerAdd:x,onLastListenerRemove:N});return W.event}o.fromNodeEventEmitter=F;function $(M,j,q=z=>z){const z=(..._)=>W.fire(q(..._)),x=()=>M.addEventListener(j,z),N=()=>M.removeEventListener(j,z),W=new f({onFirstListenerAdd:x,onLastListenerRemove:N});return W.event}o.fromDOMEventEmitter=$;function H(M){return new Promise(j=>a(M)(j))}o.toPromise=H})(P=e.Event||(e.Event={}));class m{constructor(a){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${a}_${m._idPool++}`}start(a){this._stopWatch=new k.StopWatch(!0),this._listenerCount=a}stop(){if(this._stopWatch){const a=this._stopWatch.elapsed();this._elapsedOverall+=a,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${a.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}m._idPool=0;let b=-1;function i(o){const a=b;return b=o,{dispose(){b=a}}}e.setGlobalLeakWarningThreshold=i;class C{constructor(a,t=Math.random().toString(18).slice(2,5)){this.customThreshold=a,this.name=t,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(a){let t=b;if(typeof this.customThreshold=="number"&&(t=this.customThreshold),t<=0||a<t)return;this._stacks||(this._stacks=new Map);const s=new Error().stack.split(`
`).slice(3).join(`
`),n=this._stacks.get(s)||0;if(this._stacks.set(s,n+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=t*.5;let r,c=0;for(const[l,h]of this._stacks)(!r||c<h)&&(r=l,c=h);console.warn(`[${this.name}] potential listener LEAK detected, having ${a} listeners already. MOST frequent listener (${c}):`),console.warn(r)}return()=>{const r=this._stacks.get(s)||0;this._stacks.set(s,r-1)}}}class f{constructor(a){this._disposed=!1,this._options=a,this._leakageMon=b>0?new C(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new m(this._options._profName):void 0}get event(){return this._event||(this._event=(a,t,s)=>{this._listeners||(this._listeners=new L.LinkedList);const n=this._listeners.isEmpty();n&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const r=this._listeners.push(t?[a,t]:a);n&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,a,t);const c=this._leakageMon?.check(this._listeners.size),l=(0,R.toDisposable)(()=>{c&&c(),this._disposed||(r(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return s instanceof R.DisposableStore?s.add(l):Array.isArray(s)&&s.push(l),l}),this._event}fire(a){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new L.LinkedList);for(let t of this._listeners)this._deliveryQueue.push([t,a]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[t,s]=this._deliveryQueue.shift();try{typeof t=="function"?t.call(void 0,s):t[0].call(t[1],s)}catch(n){(0,D.onUnexpectedError)(n)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=f;class I extends f{async fireAsync(a,t,s){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new L.LinkedList);for(const n of this._listeners)this._asyncDeliveryQueue.push([n,a]);for(;this._asyncDeliveryQueue.size>0&&!t.isCancellationRequested;){const[n,r]=this._asyncDeliveryQueue.shift(),c=[],l={...r,waitUntil:h=>{if(Object.isFrozen(c))throw new Error("waitUntil can NOT be called asynchronous");s&&(h=s(h,typeof n=="function"?n:n[0])),c.push(h)}};try{typeof n=="function"?n.call(void 0,l):n[0].call(n[1],l)}catch(h){(0,D.onUnexpectedError)(h);continue}Object.freeze(c),await Promise.allSettled(c).then(h=>{for(const d of h)d.status==="rejected"&&(0,D.onUnexpectedError)(d.reason)})}}}}e.AsyncEmitter=I;class u extends f{constructor(a){super(a);this._isPaused=0,this._eventQueue=new L.LinkedList,this._mergeFn=a?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const a=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(a))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(a){this._listeners&&(this._isPaused!==0?this._eventQueue.push(a):super.fire(a))}}e.PauseableEmitter=u;class w extends u{constructor(a){super(a);this._delay=a.delay??100}fire(a){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(a)}}e.DebounceEmitter=w;class g extends f{constructor(a){super(a);this._queuedEvents=[],this._mergeFn=a?.merge}fire(a){this._queuedEvents.push(a),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(t=>super.fire(t)),this._queuedEvents=[]})}}e.MicrotaskEmitter=g;class E{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new f({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(a){const t={event:a,listener:null};this.events.push(t),this.hasListeners&&this.hook(t);const s=()=>{this.hasListeners&&this.unhook(t);const n=this.events.indexOf(t);this.events.splice(n,1)};return(0,R.toDisposable)((0,T.once)(s))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(a=>this.hook(a))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(a=>this.unhook(a))}hook(a){a.listener=a.event(t=>this.emitter.fire(t))}unhook(a){a.listener&&a.listener.dispose(),a.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=E;class y{constructor(){this.buffers=[]}wrapEvent(a){return(t,s,n)=>a(r=>{const c=this.buffers[this.buffers.length-1];c?c.push(()=>t.call(s,r)):t.call(s,r)},void 0,n)}bufferEvents(a){const t=[];this.buffers.push(t);const s=a();return this.buffers.pop(),t.forEach(n=>n()),s}}e.EventBufferer=y;class S{constructor(){this.listening=!1,this.inputEvent=P.None,this.inputEventListener=R.Disposable.None,this.emitter=new f({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(a){this.inputEvent=a,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=a(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=S}),define(Z[27],ee([0,1,3]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const T=Object.freeze(function(P,m){const b=setTimeout(P.bind(m),0);return{dispose(){clearTimeout(b)}}});var R;(function(P){function m(b){return b===P.None||b===P.Cancelled||b instanceof L?!0:!b||typeof b!="object"?!1:typeof b.isCancellationRequested=="boolean"&&typeof b.onCancellationRequested=="function"}P.isCancellationToken=m,P.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:D.Event.None}),P.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:T})})(R=e.CancellationToken||(e.CancellationToken={}));class L{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?T:(this._emitter||(this._emitter=new D.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class k{constructor(m){this._token=void 0,this._parentListener=void 0,this._parentListener=m&&m.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new L),this._token}cancel(){this._token?this._token instanceof L&&this._token.cancel():this._token=R.Cancelled}dispose(m=!1){m&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof L&&this._token.dispose():this._token=R.None}}e.CancellationTokenSource=k}),define(Z[49],ee([0,1,3]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class T{constructor(){this._icons=new Map,this._onDidRegister=new D.Emitter}add(C){const f=this._icons.get(C.id);f?C.description?f.description=C.description:console.error(`Duplicate registration of codicon ${C.id}`):(this._icons.set(C.id,C),this._onDidRegister.fire(C))}get(C){return this._icons.get(C)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const R=new T;e.iconRegistry=R;function L(i,C){return new P(i,C)}e.registerCodicon=L;function k(i){return i?i.replace(/\$\((.*?)\)/g,(C,f)=>` ${f} `).trim():""}e.getCodiconAriaLabel=k;class P{constructor(C,f,I){this.id=C,this.definition=f,this.description=I,R.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=P;function m(i,C){const f=["codicon","codicon-"+i];return C&&f.push("codicon-modifier-"+C),f}e.getClassNamesArray=m;var b;(function(i){i.iconNameSegment="[A-Za-z0-9]+",i.iconNameExpression="[A-Za-z0-9\\-]+",i.iconModifierExpression="~[A-Za-z]+";const C=new RegExp(`^(${i.iconNameExpression})(${i.iconModifierExpression})?$`);function f(w){if(w instanceof P)return["codicon","codicon-"+w.id];const g=C.exec(w.id);if(!g)return f(P.error);let[,E,y]=g;const S=["codicon","codicon-"+E];return y&&S.push("codicon-modifier-"+y.substr(1)),S}i.asClassNameArray=f;function I(w){return f(w).join(" ")}i.asClassName=I;function u(w){return"."+f(w).join(".")}i.asCSSSelector=u})(b=e.CSSIcon||(e.CSSIcon={})),function(i){i.add=new i("add",{fontCharacter:"\\ea60"}),i.plus=new i("plus",{fontCharacter:"\\ea60"}),i.gistNew=new i("gist-new",{fontCharacter:"\\ea60"}),i.repoCreate=new i("repo-create",{fontCharacter:"\\ea60"}),i.lightbulb=new i("lightbulb",{fontCharacter:"\\ea61"}),i.lightBulb=new i("light-bulb",{fontCharacter:"\\ea61"}),i.repo=new i("repo",{fontCharacter:"\\ea62"}),i.repoDelete=new i("repo-delete",{fontCharacter:"\\ea62"}),i.gistFork=new i("gist-fork",{fontCharacter:"\\ea63"}),i.repoForked=new i("repo-forked",{fontCharacter:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{fontCharacter:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),i.recordKeys=new i("record-keys",{fontCharacter:"\\ea65"}),i.keyboard=new i("keyboard",{fontCharacter:"\\ea65"}),i.tag=new i("tag",{fontCharacter:"\\ea66"}),i.tagAdd=new i("tag-add",{fontCharacter:"\\ea66"}),i.tagRemove=new i("tag-remove",{fontCharacter:"\\ea66"}),i.person=new i("person",{fontCharacter:"\\ea67"}),i.personFollow=new i("person-follow",{fontCharacter:"\\ea67"}),i.personOutline=new i("person-outline",{fontCharacter:"\\ea67"}),i.personFilled=new i("person-filled",{fontCharacter:"\\ea67"}),i.gitBranch=new i("git-branch",{fontCharacter:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{fontCharacter:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{fontCharacter:"\\ea68"}),i.sourceControl=new i("source-control",{fontCharacter:"\\ea68"}),i.mirror=new i("mirror",{fontCharacter:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{fontCharacter:"\\ea69"}),i.star=new i("star",{fontCharacter:"\\ea6a"}),i.starAdd=new i("star-add",{fontCharacter:"\\ea6a"}),i.starDelete=new i("star-delete",{fontCharacter:"\\ea6a"}),i.starEmpty=new i("star-empty",{fontCharacter:"\\ea6a"}),i.comment=new i("comment",{fontCharacter:"\\ea6b"}),i.commentAdd=new i("comment-add",{fontCharacter:"\\ea6b"}),i.alert=new i("alert",{fontCharacter:"\\ea6c"}),i.warning=new i("warning",{fontCharacter:"\\ea6c"}),i.search=new i("search",{fontCharacter:"\\ea6d"}),i.searchSave=new i("search-save",{fontCharacter:"\\ea6d"}),i.logOut=new i("log-out",{fontCharacter:"\\ea6e"}),i.signOut=new i("sign-out",{fontCharacter:"\\ea6e"}),i.logIn=new i("log-in",{fontCharacter:"\\ea6f"}),i.signIn=new i("sign-in",{fontCharacter:"\\ea6f"}),i.eye=new i("eye",{fontCharacter:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{fontCharacter:"\\ea70"}),i.eyeWatch=new i("eye-watch",{fontCharacter:"\\ea70"}),i.circleFilled=new i("circle-filled",{fontCharacter:"\\ea71"}),i.primitiveDot=new i("primitive-dot",{fontCharacter:"\\ea71"}),i.closeDirty=new i("close-dirty",{fontCharacter:"\\ea71"}),i.debugBreakpoint=new i("debug-breakpoint",{fontCharacter:"\\ea71"}),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),i.debugHint=new i("debug-hint",{fontCharacter:"\\ea71"}),i.primitiveSquare=new i("primitive-square",{fontCharacter:"\\ea72"}),i.edit=new i("edit",{fontCharacter:"\\ea73"}),i.pencil=new i("pencil",{fontCharacter:"\\ea73"}),i.info=new i("info",{fontCharacter:"\\ea74"}),i.issueOpened=new i("issue-opened",{fontCharacter:"\\ea74"}),i.gistPrivate=new i("gist-private",{fontCharacter:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{fontCharacter:"\\ea75"}),i.lock=new i("lock",{fontCharacter:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{fontCharacter:"\\ea75"}),i.close=new i("close",{fontCharacter:"\\ea76"}),i.removeClose=new i("remove-close",{fontCharacter:"\\ea76"}),i.x=new i("x",{fontCharacter:"\\ea76"}),i.repoSync=new i("repo-sync",{fontCharacter:"\\ea77"}),i.sync=new i("sync",{fontCharacter:"\\ea77"}),i.clone=new i("clone",{fontCharacter:"\\ea78"}),i.desktopDownload=new i("desktop-download",{fontCharacter:"\\ea78"}),i.beaker=new i("beaker",{fontCharacter:"\\ea79"}),i.microscope=new i("microscope",{fontCharacter:"\\ea79"}),i.vm=new i("vm",{fontCharacter:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{fontCharacter:"\\ea7a"}),i.file=new i("file",{fontCharacter:"\\ea7b"}),i.fileText=new i("file-text",{fontCharacter:"\\ea7b"}),i.more=new i("more",{fontCharacter:"\\ea7c"}),i.ellipsis=new i("ellipsis",{fontCharacter:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{fontCharacter:"\\ea7c"}),i.mailReply=new i("mail-reply",{fontCharacter:"\\ea7d"}),i.reply=new i("reply",{fontCharacter:"\\ea7d"}),i.organization=new i("organization",{fontCharacter:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{fontCharacter:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{fontCharacter:"\\ea7e"}),i.newFile=new i("new-file",{fontCharacter:"\\ea7f"}),i.fileAdd=new i("file-add",{fontCharacter:"\\ea7f"}),i.newFolder=new i("new-folder",{fontCharacter:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{fontCharacter:"\\ea80"}),i.trash=new i("trash",{fontCharacter:"\\ea81"}),i.trashcan=new i("trashcan",{fontCharacter:"\\ea81"}),i.history=new i("history",{fontCharacter:"\\ea82"}),i.clock=new i("clock",{fontCharacter:"\\ea82"}),i.folder=new i("folder",{fontCharacter:"\\ea83"}),i.fileDirectory=new i("file-directory",{fontCharacter:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{fontCharacter:"\\ea83"}),i.logoGithub=new i("logo-github",{fontCharacter:"\\ea84"}),i.markGithub=new i("mark-github",{fontCharacter:"\\ea84"}),i.github=new i("github",{fontCharacter:"\\ea84"}),i.terminal=new i("terminal",{fontCharacter:"\\ea85"}),i.console=new i("console",{fontCharacter:"\\ea85"}),i.repl=new i("repl",{fontCharacter:"\\ea85"}),i.zap=new i("zap",{fontCharacter:"\\ea86"}),i.symbolEvent=new i("symbol-event",{fontCharacter:"\\ea86"}),i.error=new i("error",{fontCharacter:"\\ea87"}),i.stop=new i("stop",{fontCharacter:"\\ea87"}),i.variable=new i("variable",{fontCharacter:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{fontCharacter:"\\ea88"}),i.array=new i("array",{fontCharacter:"\\ea8a"}),i.symbolArray=new i("symbol-array",{fontCharacter:"\\ea8a"}),i.symbolModule=new i("symbol-module",{fontCharacter:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{fontCharacter:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{fontCharacter:"\\ea8b"}),i.symbolObject=new i("symbol-object",{fontCharacter:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{fontCharacter:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{fontCharacter:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{fontCharacter:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{fontCharacter:"\\ea8f"}),i.symbolNull=new i("symbol-null",{fontCharacter:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{fontCharacter:"\\ea90"}),i.symbolNumber=new i("symbol-number",{fontCharacter:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{fontCharacter:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{fontCharacter:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{fontCharacter:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{fontCharacter:"\\ea92"}),i.symbolKey=new i("symbol-key",{fontCharacter:"\\ea93"}),i.symbolText=new i("symbol-text",{fontCharacter:"\\ea93"}),i.symbolReference=new i("symbol-reference",{fontCharacter:"\\ea94"}),i.goToFile=new i("go-to-file",{fontCharacter:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{fontCharacter:"\\ea95"}),i.symbolValue=new i("symbol-value",{fontCharacter:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{fontCharacter:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{fontCharacter:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{fontCharacter:"\\ea97"}),i.archive=new i("archive",{fontCharacter:"\\ea98"}),i.arrowBoth=new i("arrow-both",{fontCharacter:"\\ea99"}),i.arrowDown=new i("arrow-down",{fontCharacter:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{fontCharacter:"\\ea9b"}),i.arrowRight=new i("arrow-right",{fontCharacter:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{fontCharacter:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{fontCharacter:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{fontCharacter:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{fontCharacter:"\\eaa0"}),i.arrowUp=new i("arrow-up",{fontCharacter:"\\eaa1"}),i.bell=new i("bell",{fontCharacter:"\\eaa2"}),i.bold=new i("bold",{fontCharacter:"\\eaa3"}),i.book=new i("book",{fontCharacter:"\\eaa4"}),i.bookmark=new i("bookmark",{fontCharacter:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{fontCharacter:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),i.briefcase=new i("briefcase",{fontCharacter:"\\eaac"}),i.broadcast=new i("broadcast",{fontCharacter:"\\eaad"}),i.browser=new i("browser",{fontCharacter:"\\eaae"}),i.bug=new i("bug",{fontCharacter:"\\eaaf"}),i.calendar=new i("calendar",{fontCharacter:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{fontCharacter:"\\eab1"}),i.check=new i("check",{fontCharacter:"\\eab2"}),i.checklist=new i("checklist",{fontCharacter:"\\eab3"}),i.chevronDown=new i("chevron-down",{fontCharacter:"\\eab4"}),i.chevronLeft=new i("chevron-left",{fontCharacter:"\\eab5"}),i.chevronRight=new i("chevron-right",{fontCharacter:"\\eab6"}),i.chevronUp=new i("chevron-up",{fontCharacter:"\\eab7"}),i.chromeClose=new i("chrome-close",{fontCharacter:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{fontCharacter:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{fontCharacter:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{fontCharacter:"\\eabb"}),i.circleOutline=new i("circle-outline",{fontCharacter:"\\eabc"}),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),i.circleSlash=new i("circle-slash",{fontCharacter:"\\eabd"}),i.circuitBoard=new i("circuit-board",{fontCharacter:"\\eabe"}),i.clearAll=new i("clear-all",{fontCharacter:"\\eabf"}),i.clippy=new i("clippy",{fontCharacter:"\\eac0"}),i.closeAll=new i("close-all",{fontCharacter:"\\eac1"}),i.cloudDownload=new i("cloud-download",{fontCharacter:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{fontCharacter:"\\eac3"}),i.code=new i("code",{fontCharacter:"\\eac4"}),i.collapseAll=new i("collapse-all",{fontCharacter:"\\eac5"}),i.colorMode=new i("color-mode",{fontCharacter:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{fontCharacter:"\\eac7"}),i.compareChanges=new i("compare-changes",{fontCharacter:"\\eafd"}),i.creditCard=new i("credit-card",{fontCharacter:"\\eac9"}),i.dash=new i("dash",{fontCharacter:"\\eacc"}),i.dashboard=new i("dashboard",{fontCharacter:"\\eacd"}),i.database=new i("database",{fontCharacter:"\\eace"}),i.debugContinue=new i("debug-continue",{fontCharacter:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{fontCharacter:"\\ead0"}),i.debugPause=new i("debug-pause",{fontCharacter:"\\ead1"}),i.debugRestart=new i("debug-restart",{fontCharacter:"\\ead2"}),i.debugStart=new i("debug-start",{fontCharacter:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{fontCharacter:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{fontCharacter:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{fontCharacter:"\\ead6"}),i.debugStop=new i("debug-stop",{fontCharacter:"\\ead7"}),i.debug=new i("debug",{fontCharacter:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{fontCharacter:"\\ead9"}),i.deviceCamera=new i("device-camera",{fontCharacter:"\\eada"}),i.deviceMobile=new i("device-mobile",{fontCharacter:"\\eadb"}),i.diffAdded=new i("diff-added",{fontCharacter:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{fontCharacter:"\\eadd"}),i.diffModified=new i("diff-modified",{fontCharacter:"\\eade"}),i.diffRemoved=new i("diff-removed",{fontCharacter:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{fontCharacter:"\\eae0"}),i.diff=new i("diff",{fontCharacter:"\\eae1"}),i.discard=new i("discard",{fontCharacter:"\\eae2"}),i.editorLayout=new i("editor-layout",{fontCharacter:"\\eae3"}),i.emptyWindow=new i("empty-window",{fontCharacter:"\\eae4"}),i.exclude=new i("exclude",{fontCharacter:"\\eae5"}),i.extensions=new i("extensions",{fontCharacter:"\\eae6"}),i.eyeClosed=new i("eye-closed",{fontCharacter:"\\eae7"}),i.fileBinary=new i("file-binary",{fontCharacter:"\\eae8"}),i.fileCode=new i("file-code",{fontCharacter:"\\eae9"}),i.fileMedia=new i("file-media",{fontCharacter:"\\eaea"}),i.filePdf=new i("file-pdf",{fontCharacter:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{fontCharacter:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{fontCharacter:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{fontCharacter:"\\eaee"}),i.fileZip=new i("file-zip",{fontCharacter:"\\eaef"}),i.files=new i("files",{fontCharacter:"\\eaf0"}),i.filter=new i("filter",{fontCharacter:"\\eaf1"}),i.flame=new i("flame",{fontCharacter:"\\eaf2"}),i.foldDown=new i("fold-down",{fontCharacter:"\\eaf3"}),i.foldUp=new i("fold-up",{fontCharacter:"\\eaf4"}),i.fold=new i("fold",{fontCharacter:"\\eaf5"}),i.folderActive=new i("folder-active",{fontCharacter:"\\eaf6"}),i.folderOpened=new i("folder-opened",{fontCharacter:"\\eaf7"}),i.gear=new i("gear",{fontCharacter:"\\eaf8"}),i.gift=new i("gift",{fontCharacter:"\\eaf9"}),i.gistSecret=new i("gist-secret",{fontCharacter:"\\eafa"}),i.gist=new i("gist",{fontCharacter:"\\eafb"}),i.gitCommit=new i("git-commit",{fontCharacter:"\\eafc"}),i.gitCompare=new i("git-compare",{fontCharacter:"\\eafd"}),i.gitMerge=new i("git-merge",{fontCharacter:"\\eafe"}),i.githubAction=new i("github-action",{fontCharacter:"\\eaff"}),i.githubAlt=new i("github-alt",{fontCharacter:"\\eb00"}),i.globe=new i("globe",{fontCharacter:"\\eb01"}),i.grabber=new i("grabber",{fontCharacter:"\\eb02"}),i.graph=new i("graph",{fontCharacter:"\\eb03"}),i.gripper=new i("gripper",{fontCharacter:"\\eb04"}),i.heart=new i("heart",{fontCharacter:"\\eb05"}),i.home=new i("home",{fontCharacter:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{fontCharacter:"\\eb07"}),i.hubot=new i("hubot",{fontCharacter:"\\eb08"}),i.inbox=new i("inbox",{fontCharacter:"\\eb09"}),i.issueClosed=new i("issue-closed",{fontCharacter:"\\eba4"}),i.issueReopened=new i("issue-reopened",{fontCharacter:"\\eb0b"}),i.issues=new i("issues",{fontCharacter:"\\eb0c"}),i.italic=new i("italic",{fontCharacter:"\\eb0d"}),i.jersey=new i("jersey",{fontCharacter:"\\eb0e"}),i.json=new i("json",{fontCharacter:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{fontCharacter:"\\eb10"}),i.key=new i("key",{fontCharacter:"\\eb11"}),i.law=new i("law",{fontCharacter:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{fontCharacter:"\\eb13"}),i.linkExternal=new i("link-external",{fontCharacter:"\\eb14"}),i.link=new i("link",{fontCharacter:"\\eb15"}),i.listOrdered=new i("list-ordered",{fontCharacter:"\\eb16"}),i.listUnordered=new i("list-unordered",{fontCharacter:"\\eb17"}),i.liveShare=new i("live-share",{fontCharacter:"\\eb18"}),i.loading=new i("loading",{fontCharacter:"\\eb19"}),i.location=new i("location",{fontCharacter:"\\eb1a"}),i.mailRead=new i("mail-read",{fontCharacter:"\\eb1b"}),i.mail=new i("mail",{fontCharacter:"\\eb1c"}),i.markdown=new i("markdown",{fontCharacter:"\\eb1d"}),i.megaphone=new i("megaphone",{fontCharacter:"\\eb1e"}),i.mention=new i("mention",{fontCharacter:"\\eb1f"}),i.milestone=new i("milestone",{fontCharacter:"\\eb20"}),i.mortarBoard=new i("mortar-board",{fontCharacter:"\\eb21"}),i.move=new i("move",{fontCharacter:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{fontCharacter:"\\eb23"}),i.mute=new i("mute",{fontCharacter:"\\eb24"}),i.noNewline=new i("no-newline",{fontCharacter:"\\eb25"}),i.note=new i("note",{fontCharacter:"\\eb26"}),i.octoface=new i("octoface",{fontCharacter:"\\eb27"}),i.openPreview=new i("open-preview",{fontCharacter:"\\eb28"}),i.package_=new i("package",{fontCharacter:"\\eb29"}),i.paintcan=new i("paintcan",{fontCharacter:"\\eb2a"}),i.pin=new i("pin",{fontCharacter:"\\eb2b"}),i.play=new i("play",{fontCharacter:"\\eb2c"}),i.run=new i("run",{fontCharacter:"\\eb2c"}),i.plug=new i("plug",{fontCharacter:"\\eb2d"}),i.preserveCase=new i("preserve-case",{fontCharacter:"\\eb2e"}),i.preview=new i("preview",{fontCharacter:"\\eb2f"}),i.project=new i("project",{fontCharacter:"\\eb30"}),i.pulse=new i("pulse",{fontCharacter:"\\eb31"}),i.question=new i("question",{fontCharacter:"\\eb32"}),i.quote=new i("quote",{fontCharacter:"\\eb33"}),i.radioTower=new i("radio-tower",{fontCharacter:"\\eb34"}),i.reactions=new i("reactions",{fontCharacter:"\\eb35"}),i.references=new i("references",{fontCharacter:"\\eb36"}),i.refresh=new i("refresh",{fontCharacter:"\\eb37"}),i.regex=new i("regex",{fontCharacter:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{fontCharacter:"\\eb39"}),i.remote=new i("remote",{fontCharacter:"\\eb3a"}),i.remove=new i("remove",{fontCharacter:"\\eb3b"}),i.replaceAll=new i("replace-all",{fontCharacter:"\\eb3c"}),i.replace=new i("replace",{fontCharacter:"\\eb3d"}),i.repoClone=new i("repo-clone",{fontCharacter:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{fontCharacter:"\\eb3f"}),i.repoPull=new i("repo-pull",{fontCharacter:"\\eb40"}),i.repoPush=new i("repo-push",{fontCharacter:"\\eb41"}),i.report=new i("report",{fontCharacter:"\\eb42"}),i.requestChanges=new i("request-changes",{fontCharacter:"\\eb43"}),i.rocket=new i("rocket",{fontCharacter:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{fontCharacter:"\\eb45"}),i.rootFolder=new i("root-folder",{fontCharacter:"\\eb46"}),i.rss=new i("rss",{fontCharacter:"\\eb47"}),i.ruby=new i("ruby",{fontCharacter:"\\eb48"}),i.saveAll=new i("save-all",{fontCharacter:"\\eb49"}),i.saveAs=new i("save-as",{fontCharacter:"\\eb4a"}),i.save=new i("save",{fontCharacter:"\\eb4b"}),i.screenFull=new i("screen-full",{fontCharacter:"\\eb4c"}),i.screenNormal=new i("screen-normal",{fontCharacter:"\\eb4d"}),i.searchStop=new i("search-stop",{fontCharacter:"\\eb4e"}),i.server=new i("server",{fontCharacter:"\\eb50"}),i.settingsGear=new i("settings-gear",{fontCharacter:"\\eb51"}),i.settings=new i("settings",{fontCharacter:"\\eb52"}),i.shield=new i("shield",{fontCharacter:"\\eb53"}),i.smiley=new i("smiley",{fontCharacter:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{fontCharacter:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{fontCharacter:"\\eb56"}),i.splitVertical=new i("split-vertical",{fontCharacter:"\\eb57"}),i.squirrel=new i("squirrel",{fontCharacter:"\\eb58"}),i.starFull=new i("star-full",{fontCharacter:"\\eb59"}),i.starHalf=new i("star-half",{fontCharacter:"\\eb5a"}),i.symbolClass=new i("symbol-class",{fontCharacter:"\\eb5b"}),i.symbolColor=new i("symbol-color",{fontCharacter:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{fontCharacter:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{fontCharacter:"\\eb5e"}),i.symbolField=new i("symbol-field",{fontCharacter:"\\eb5f"}),i.symbolFile=new i("symbol-file",{fontCharacter:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{fontCharacter:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{fontCharacter:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{fontCharacter:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{fontCharacter:"\\eb64"}),i.symbolProperty=new i("symbol-property",{fontCharacter:"\\eb65"}),i.wrench=new i("wrench",{fontCharacter:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{fontCharacter:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{fontCharacter:"\\eb66"}),i.tasklist=new i("tasklist",{fontCharacter:"\\eb67"}),i.telescope=new i("telescope",{fontCharacter:"\\eb68"}),i.textSize=new i("text-size",{fontCharacter:"\\eb69"}),i.threeBars=new i("three-bars",{fontCharacter:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{fontCharacter:"\\eb6b"}),i.thumbsup=new i("thumbsup",{fontCharacter:"\\eb6c"}),i.tools=new i("tools",{fontCharacter:"\\eb6d"}),i.triangleDown=new i("triangle-down",{fontCharacter:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{fontCharacter:"\\eb6f"}),i.triangleRight=new i("triangle-right",{fontCharacter:"\\eb70"}),i.triangleUp=new i("triangle-up",{fontCharacter:"\\eb71"}),i.twitter=new i("twitter",{fontCharacter:"\\eb72"}),i.unfold=new i("unfold",{fontCharacter:"\\eb73"}),i.unlock=new i("unlock",{fontCharacter:"\\eb74"}),i.unmute=new i("unmute",{fontCharacter:"\\eb75"}),i.unverified=new i("unverified",{fontCharacter:"\\eb76"}),i.verified=new i("verified",{fontCharacter:"\\eb77"}),i.versions=new i("versions",{fontCharacter:"\\eb78"}),i.vmActive=new i("vm-active",{fontCharacter:"\\eb79"}),i.vmOutline=new i("vm-outline",{fontCharacter:"\\eb7a"}),i.vmRunning=new i("vm-running",{fontCharacter:"\\eb7b"}),i.watch=new i("watch",{fontCharacter:"\\eb7c"}),i.whitespace=new i("whitespace",{fontCharacter:"\\eb7d"}),i.wholeWord=new i("whole-word",{fontCharacter:"\\eb7e"}),i.window=new i("window",{fontCharacter:"\\eb7f"}),i.wordWrap=new i("word-wrap",{fontCharacter:"\\eb80"}),i.zoomIn=new i("zoom-in",{fontCharacter:"\\eb81"}),i.zoomOut=new i("zoom-out",{fontCharacter:"\\eb82"}),i.listFilter=new i("list-filter",{fontCharacter:"\\eb83"}),i.listFlat=new i("list-flat",{fontCharacter:"\\eb84"}),i.listSelection=new i("list-selection",{fontCharacter:"\\eb85"}),i.selection=new i("selection",{fontCharacter:"\\eb85"}),i.listTree=new i("list-tree",{fontCharacter:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{fontCharacter:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{fontCharacter:"\\eb89"}),i.debugStackframeDot=new i("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),i.debugStackframe=new i("debug-stackframe",{fontCharacter:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),i.symbolString=new i("symbol-string",{fontCharacter:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{fontCharacter:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{fontCharacter:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{fontCharacter:"\\eb90"}),i.callIncoming=new i("call-incoming",{fontCharacter:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{fontCharacter:"\\eb93"}),i.menu=new i("menu",{fontCharacter:"\\eb94"}),i.expandAll=new i("expand-all",{fontCharacter:"\\eb95"}),i.feedback=new i("feedback",{fontCharacter:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{fontCharacter:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),i.account=new i("account",{fontCharacter:"\\eb99"}),i.bellDot=new i("bell-dot",{fontCharacter:"\\eb9a"}),i.debugConsole=new i("debug-console",{fontCharacter:"\\eb9b"}),i.library=new i("library",{fontCharacter:"\\eb9c"}),i.output=new i("output",{fontCharacter:"\\eb9d"}),i.runAll=new i("run-all",{fontCharacter:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{fontCharacter:"\\eb9f"}),i.pinned=new i("pinned",{fontCharacter:"\\eba0"}),i.githubInverted=new i("github-inverted",{fontCharacter:"\\eba1"}),i.debugAlt=new i("debug-alt",{fontCharacter:"\\eb91"}),i.serverProcess=new i("server-process",{fontCharacter:"\\eba2"}),i.serverEnvironment=new i("server-environment",{fontCharacter:"\\eba3"}),i.pass=new i("pass",{fontCharacter:"\\eba4"}),i.stopCircle=new i("stop-circle",{fontCharacter:"\\eba5"}),i.playCircle=new i("play-circle",{fontCharacter:"\\eba6"}),i.record=new i("record",{fontCharacter:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{fontCharacter:"\\eba8"}),i.vmConnect=new i("vm-connect",{fontCharacter:"\\eba9"}),i.cloud=new i("cloud",{fontCharacter:"\\ebaa"}),i.merge=new i("merge",{fontCharacter:"\\ebab"}),i.exportIcon=new i("export",{fontCharacter:"\\ebac"}),i.graphLeft=new i("graph-left",{fontCharacter:"\\ebad"}),i.magnet=new i("magnet",{fontCharacter:"\\ebae"}),i.notebook=new i("notebook",{fontCharacter:"\\ebaf"}),i.redo=new i("redo",{fontCharacter:"\\ebb0"}),i.checkAll=new i("check-all",{fontCharacter:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{fontCharacter:"\\ebb2"}),i.passFilled=new i("pass-filled",{fontCharacter:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{fontCharacter:"\\ebb4"}),i.circleLargeOutline=new i("circle-large-outline",{fontCharacter:"\\ebb5"}),i.combine=new i("combine",{fontCharacter:"\\ebb6"}),i.gather=new i("gather",{fontCharacter:"\\ebb6"}),i.table=new i("table",{fontCharacter:"\\ebb7"}),i.variableGroup=new i("variable-group",{fontCharacter:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{fontCharacter:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{fontCharacter:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{fontCharacter:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{fontCharacter:"\\ebbc"}),i.runAbove=new i("run-above",{fontCharacter:"\\ebbd"}),i.runBelow=new i("run-below",{fontCharacter:"\\ebbe"}),i.notebookTemplate=new i("notebook-template",{fontCharacter:"\\ebbf"}),i.debugRerun=new i("debug-rerun",{fontCharacter:"\\ebc0"}),i.workspaceTrusted=new i("workspace-trusted",{fontCharacter:"\\ebc1"}),i.workspaceUntrusted=new i("workspace-untrusted",{fontCharacter:"\\ebc2"}),i.workspaceUnspecified=new i("workspace-unspecified",{fontCharacter:"\\ebc3"}),i.terminalCmd=new i("terminal-cmd",{fontCharacter:"\\ebc4"}),i.terminalDebian=new i("terminal-debian",{fontCharacter:"\\ebc5"}),i.terminalLinux=new i("terminal-linux",{fontCharacter:"\\ebc6"}),i.terminalPowershell=new i("terminal-powershell",{fontCharacter:"\\ebc7"}),i.terminalTmux=new i("terminal-tmux",{fontCharacter:"\\ebc8"}),i.terminalUbuntu=new i("terminal-ubuntu",{fontCharacter:"\\ebc9"}),i.terminalBash=new i("terminal-bash",{fontCharacter:"\\ebca"}),i.arrowSwap=new i("arrow-swap",{fontCharacter:"\\ebcb"}),i.copy=new i("copy",{fontCharacter:"\\ebcc"}),i.personAdd=new i("person-add",{fontCharacter:"\\ebcd"}),i.filterFilled=new i("filter-filled",{fontCharacter:"\\ebce"}),i.wand=new i("wand",{fontCharacter:"\\ebcf"}),i.debugLineByLine=new i("debug-line-by-line",{fontCharacter:"\\ebd0"}),i.inspect=new i("inspect",{fontCharacter:"\\ebd1"}),i.layers=new i("layers",{fontCharacter:"\\ebd2"}),i.layersDot=new i("layers-dot",{fontCharacter:"\\ebd3"}),i.layersActive=new i("layers-active",{fontCharacter:"\\ebd4"}),i.compass=new i("compass",{fontCharacter:"\\ebd5"}),i.compassDot=new i("compass-dot",{fontCharacter:"\\ebd6"}),i.compassActive=new i("compass-active",{fontCharacter:"\\ebd7"}),i.azure=new i("azure",{fontCharacter:"\\ebd8"}),i.issueDraft=new i("issue-draft",{fontCharacter:"\\ebd9"}),i.gitPullRequestClosed=new i("git-pull-request-closed",{fontCharacter:"\\ebda"}),i.gitPullRequestDraft=new i("git-pull-request-draft",{fontCharacter:"\\ebdb"}),i.debugAll=new i("debug-all",{fontCharacter:"\\ebdc"}),i.debugCoverage=new i("debug-coverage",{fontCharacter:"\\ebdd"}),i.runErrors=new i("run-errors",{fontCharacter:"\\ebde"}),i.folderLibrary=new i("folder-library",{fontCharacter:"\\ebdf"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition)}(P=e.Codicon||(e.Codicon={}))}),define(Z[50],ee([0,1,9,2]),function(K,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function R(S){const o=S;return o?[o.on,o.pause,o.resume,o.destroy].every(a=>typeof a=="function"):!1}e.isReadableStream=R;function L(S){const o=S;return o?R(o.stream)&&Array.isArray(o.buffer)&&typeof o.ended=="boolean":!1}e.isReadableBufferedStream=L;function k(S,o){return new P(S,o)}e.newWriteableStream=k;class P{constructor(o,a){this.reducer=o,this.options=a,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(o){if(!this.state.destroyed){if(this.state.flowing)this.emitData(o);else if(this.buffer.data.push(o),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(a=>this.pendingWritePromises.push(a))}}error(o){this.state.destroyed||(this.state.flowing?this.emitError(o):this.buffer.error.push(o))}end(o){this.state.destroyed||(typeof o!="undefined"&&this.write(o),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(o){this.listeners.data.slice(0).forEach(a=>a(o))}emitError(o){this.listeners.error.length===0?(0,D.onUnexpectedError)(o):this.listeners.error.slice(0).forEach(a=>a(o))}emitEnd(){this.listeners.end.slice(0).forEach(o=>o())}on(o,a){if(!this.state.destroyed)switch(o){case"data":this.listeners.data.push(a),this.resume();break;case"end":this.listeners.end.push(a),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(a),this.state.flowing&&this.flowErrors();break}}removeListener(o,a){if(this.state.destroyed)return;let t;switch(o){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const s=t.indexOf(a);s>=0&&t.splice(s,1)}}flowData(){if(this.buffer.data.length>0){const o=this.reducer(this.buffer.data);this.emitData(o),this.buffer.data.length=0;const a=[...this.pendingWritePromises];this.pendingWritePromises.length=0,a.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const o of this.buffer.error)this.emitError(o);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function m(S,o){const a=[];let t;for(;(t=S.read())!==null;)a.push(t);return o(a)}e.consumeReadable=m;function b(S,o,a){const t=[];let s;for(;(s=S.read())!==null&&t.length<a;)t.push(s);return s===null&&t.length>0?o(t):{read:()=>{if(t.length>0)return t.shift();if(typeof s!="undefined"){const n=s;return s=void 0,n}return S.read()}}}e.peekReadable=b;function i(S,o){return new Promise((a,t)=>{const s=[];C(S,{onData:n=>{o&&s.push(n)},onError:n=>{o?t(n):a(void 0)},onEnd:()=>{a(o?o(s):void 0)}})})}e.consumeStream=i;function C(S,o){S.on("error",a=>o.onError(a)),S.on("end",()=>o.onEnd()),S.on("data",a=>o.onData(a))}e.listenStream=C;function f(S,o){return new Promise((a,t)=>{const s=new T.DisposableStore,n=[],r=h=>{if(n.push(h),n.length>o)return s.dispose(),S.pause(),a({stream:S,buffer:n,ended:!1})},c=h=>t(h),l=()=>a({stream:S,buffer:n,ended:!0});s.add((0,T.toDisposable)(()=>S.removeListener("error",c))),S.on("error",c),s.add((0,T.toDisposable)(()=>S.removeListener("end",l))),S.on("end",l),s.add((0,T.toDisposable)(()=>S.removeListener("data",r))),S.on("data",r)})}e.peekStream=f;function I(S,o){const a=k(o);return a.end(S),a}e.toStream=I;function u(){const S=k(()=>{throw new Error("not supported")});return S.end(),S}e.emptyStream=u;function w(S){let o=!1;return{read:()=>o?null:(o=!0,S)}}e.toReadable=w;function g(S,o,a){const t=k(a);return C(S,{onData:s=>t.write(o.data(s)),onError:s=>t.error(o.error?o.error(s):s),onEnd:()=>t.end()}),t}e.transform=g;function E(S,o,a){let t=!1;return{read:()=>{const s=o.read();return t?s:(t=!0,s!==null?a([S,s]):S)}}}e.prefixedReadable=E;function y(S,o,a){let t=!1;const s=k(a);return C(o,{onData:n=>t?s.write(n):(t=!0,s.write(a([S,n]))),onError:n=>s.error(n),onEnd:()=>{t||(t=!0,s.write(S)),s.end()}}),s}e.prefixedStream=y}),define(Z[25],ee([0,1,50]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const T=typeof Buffer!="undefined";let R,L;class k{constructor(r){this.buffer=r,this.byteLength=this.buffer.byteLength}static alloc(r){return T?new k(Buffer.allocUnsafe(r)):new k(new Uint8Array(r))}static wrap(r){return T&&!Buffer.isBuffer(r)&&(r=Buffer.from(r.buffer,r.byteOffset,r.byteLength)),new k(r)}static fromString(r,c){return!(c?.dontUseNodeBuffer||!1)&&T?new k(Buffer.from(r)):(R||(R=new TextEncoder),new k(R.encode(r)))}static concat(r,c){if(typeof c=="undefined"){c=0;for(let d=0,v=r.length;d<v;d++)c+=r[d].byteLength}const l=k.alloc(c);let h=0;for(let d=0,v=r.length;d<v;d++){const A=r[d];l.set(A,h),h+=A.byteLength}return l}toString(){return T?this.buffer.toString():(L||(L=new TextDecoder),L.decode(this.buffer))}slice(r,c){return new k(this.buffer.subarray(r,c))}set(r,c){r instanceof k?this.buffer.set(r.buffer,c):this.buffer.set(r,c)}readUInt32BE(r){return b(this.buffer,r)}writeUInt32BE(r,c){i(this.buffer,r,c)}readUInt32LE(r){return C(this.buffer,r)}writeUInt32LE(r,c){f(this.buffer,r,c)}readUInt8(r){return I(this.buffer,r)}writeUInt8(r,c){u(this.buffer,r,c)}}e.VSBuffer=k;function P(n,r){return n[r+0]<<0>>>0|n[r+1]<<8>>>0}e.readUInt16LE=P;function m(n,r,c){n[c+0]=r&255,r=r>>>8,n[c+1]=r&255}e.writeUInt16LE=m;function b(n,r){return n[r]*2**24+n[r+1]*2**16+n[r+2]*2**8+n[r+3]}e.readUInt32BE=b;function i(n,r,c){n[c+3]=r,r=r>>>8,n[c+2]=r,r=r>>>8,n[c+1]=r,r=r>>>8,n[c]=r}e.writeUInt32BE=i;function C(n,r){return n[r+0]<<0>>>0|n[r+1]<<8>>>0|n[r+2]<<16>>>0|n[r+3]<<24>>>0}e.readUInt32LE=C;function f(n,r,c){n[c+0]=r&255,r=r>>>8,n[c+1]=r&255,r=r>>>8,n[c+2]=r&255,r=r>>>8,n[c+3]=r&255}e.writeUInt32LE=f;function I(n,r){return n[r]}e.readUInt8=I;function u(n,r,c){n[c]=r}e.writeUInt8=u;function w(n){return D.consumeReadable(n,r=>k.concat(r))}e.readableToBuffer=w;function g(n){return D.toReadable(n)}e.bufferToReadable=g;function E(n){return D.consumeStream(n,r=>k.concat(r))}e.streamToBuffer=E;async function y(n){return n.ended?k.concat(n.buffer):k.concat([...n.buffer,await E(n.stream)])}e.bufferedStreamToBuffer=y;function S(n){return D.toStream(n,r=>k.concat(r))}e.bufferToStream=S;function o(n){return D.transform(n,{data:r=>typeof r=="string"?k.fromString(r):k.wrap(r)},r=>k.concat(r))}e.streamToBufferReadableStream=o;function a(n){return D.newWriteableStream(r=>k.concat(r),n)}e.newWriteableBufferStream=a;function t(n,r){return D.prefixedReadable(n,r,c=>k.concat(c))}e.prefixedBufferReadable=t;function s(n,r){return D.prefixedStream(n,r,c=>k.concat(c))}e.prefixedBufferStream=s}),define(Z[24],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function D(B){return!B||typeof B!="string"?!0:B.trim().length===0}e.isFalsyOrWhitespace=D;const T=/{(\d+)}/g;function R(B,...se){return se.length===0?B:B.replace(T,function(le,he){const me=parseInt(he,10);return isNaN(me)||me<0||me>=se.length?le:se[me]})}e.format=R;const L=/{([^}]+)}/g;function k(B,se){return B.replace(L,(le,he)=>se[he]??le)}e.format2=k;function P(B){return B.replace(/[<>&]/g,function(se){switch(se){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return se}})}e.escape=P;function m(B){return B.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=m;function b(B,se){let le=0;const he=se.charCodeAt(0);for(let me=B.length-1;me>=0;me--)B.charCodeAt(me)===he&&le++;return le}e.count=b;function i(B,se,le="\u2026"){return B.length<=se?B:`${B.substr(0,se)}${le}`}e.truncate=i;function C(B,se=" "){const le=f(B,se);return I(le,se)}e.trim=C;function f(B,se){if(!B||!se)return B;const le=se.length;if(le===0||B.length===0)return B;let he=0;for(;B.indexOf(se,he)===he;)he=he+le;return B.substring(he)}e.ltrim=f;function I(B,se){if(!B||!se)return B;const le=se.length,he=B.length;if(le===0||he===0)return B;let me=he,be=-1;for(;be=B.lastIndexOf(se,me-1),!(be===-1||be+le!==me);){if(be===0)return"";me=be}return B.substring(0,me)}e.rtrim=I;function u(B){return B.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=u;function w(B){return B.replace(/\*/g,"")}e.stripWildcards=w;function g(B,se,le={}){if(!B)throw new Error("Cannot create regex from empty string");se||(B=m(B)),le.wholeWord&&(/\B/.test(B.charAt(0))||(B="\\b"+B),/\B/.test(B.charAt(B.length-1))||(B=B+"\\b"));let he="";return le.global&&(he+="g"),le.matchCase||(he+="i"),le.multiline&&(he+="m"),le.unicode&&(he+="u"),new RegExp(B,he)}e.createRegExp=g;function E(B){return B.source==="^"||B.source==="^$"||B.source==="$"||B.source==="^\\s*$"?!1:!!(B.exec("")&&B.lastIndex===0)}e.regExpLeadsToEndlessLoop=E;function y(B){return!!B.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=y;function S(B){return(B.global?"g":"")+(B.ignoreCase?"i":"")+(B.multiline?"m":"")+(B.unicode?"u":"")}e.regExpFlags=S;function o(B){return B.split(/\r\n|\r|\n/)}e.splitLines=o;function a(B){for(let se=0,le=B.length;se<le;se++){const he=B.charCodeAt(se);if(he!==32&&he!==9)return se}return-1}e.firstNonWhitespaceIndex=a;function t(B,se=0,le=B.length){for(let he=se;he<le;he++){const me=B.charCodeAt(he);if(me!==32&&me!==9)return B.substring(se,he)}return B.substring(se,le)}e.getLeadingWhitespace=t;function s(B,se=B.length-1){for(let le=se;le>=0;le--){const he=B.charCodeAt(le);if(he!==32&&he!==9)return le}return-1}e.lastNonWhitespaceIndex=s;function n(B,se){return B<se?-1:B>se?1:0}e.compare=n;function r(B,se,le=0,he=B.length,me=0,be=se.length){for(;le<he&&me<be;le++,me++){let Ce=B.charCodeAt(le),Re=se.charCodeAt(me);if(Ce<Re)return-1;if(Ce>Re)return 1}const ve=he-le,we=be-me;return ve<we?-1:ve>we?1:0}e.compareSubstring=r;function c(B,se){return l(B,se,0,B.length,0,se.length)}e.compareIgnoreCase=c;function l(B,se,le=0,he=B.length,me=0,be=se.length){for(;le<he&&me<be;le++,me++){let Ce=B.charCodeAt(le),Re=se.charCodeAt(me);if(Ce===Re)continue;const fe=Ce-Re;if(!(fe===32&&d(Re))&&!(fe===-32&&d(Ce)))return h(Ce)&&h(Re)?fe:r(B.toLowerCase(),se.toLowerCase(),le,he,me,be)}const ve=he-le,we=be-me;return ve<we?-1:ve>we?1:0}e.compareSubstringIgnoreCase=l;function h(B){return B>=97&&B<=122}e.isLowerAsciiLetter=h;function d(B){return B>=65&&B<=90}e.isUpperAsciiLetter=d;function v(B){return h(B)||d(B)}function A(B,se){return B.length===se.length&&O(B,se)}e.equalsIgnoreCase=A;function O(B,se,le=B.length){for(let he=0;he<le;he++){const me=B.charCodeAt(he),be=se.charCodeAt(he);if(me!==be){if(v(me)&&v(be)){const ve=Math.abs(me-be);if(ve!==0&&ve!==32)return!1}else if(String.fromCharCode(me).toLowerCase()!==String.fromCharCode(be).toLowerCase())return!1}}return!0}function p(B,se){const le=se.length;return se.length>B.length?!1:O(B,se,le)}e.startsWithIgnoreCase=p;function U(B,se){let le,he=Math.min(B.length,se.length);for(le=0;le<he;le++)if(B.charCodeAt(le)!==se.charCodeAt(le))return le;return he}e.commonPrefixLength=U;function F(B,se){let le,he=Math.min(B.length,se.length);const me=B.length-1,be=se.length-1;for(le=0;le<he;le++)if(B.charCodeAt(me-le)!==se.charCodeAt(be-le))return le;return he}e.commonSuffixLength=F;function $(B){return 55296<=B&&B<=56319}e.isHighSurrogate=$;function H(B){return 56320<=B&&B<=57343}e.isLowSurrogate=H;function M(B,se){return(B-55296<<10)+(se-56320)+65536}e.computeCodePoint=M;function j(B,se,le){const he=B.charCodeAt(le);if($(he)&&le+1<se){const me=B.charCodeAt(le+1);if(H(me))return M(he,me)}return he}e.getNextCodePoint=j;function q(B,se){const le=B.charCodeAt(se-1);if(H(le)&&se>1){const he=B.charCodeAt(se-2);if($(he))return M(he,le)}return le}function z(B,se){const le=oe.getInstance(),he=se,me=B.length,be=j(B,me,se);se+=be>=65536?2:1;let ve=le.getGraphemeBreakType(be);for(;se<me;){const we=j(B,me,se),Ce=le.getGraphemeBreakType(we);if(Q(ve,Ce))break;se+=we>=65536?2:1,ve=Ce}return se-he}e.nextCharLength=z;function x(B,se){const le=oe.getInstance(),he=se,me=q(B,se);se-=me>=65536?2:1;let be=le.getGraphemeBreakType(me);for(;se>0;){const ve=q(B,se),we=le.getGraphemeBreakType(ve);if(Q(we,be))break;se-=ve>=65536?2:1,be=we}return he-se}e.prevCharLength=x;function N(B,se){const le=oe.getInstance(),he=B.length,me=se,be=j(B,he,se),ve=le.getGraphemeBreakType(be);se+=be>=65536?2:1;let we=ve;for(;se<he;){const Re=j(B,he,se),fe=le.getGraphemeBreakType(Re);if(Q(we,fe))break;se+=Re>=65536?2:1,we=fe}const Ce=se;for(se=me,we=ve;se>0;){const Re=q(B,se),fe=le.getGraphemeBreakType(Re);if(Q(fe,we))break;se-=Re>=65536?2:1,we=fe}return[se,Ce]}function W(B,se){return se>0&&H(B.charCodeAt(se))?N(B,se-1):N(B,se)}e.getCharContainingOffset=W;const _=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function Y(B){return _.test(B)}e.containsRTL=Y;const G=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function ne(B){return G.test(B)}e.containsEmoji=ne;const te=/^[\t\n\r\x20-\x7E]*$/;function J(B){return te.test(B)}e.isBasicASCII=J,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function V(B){return e.UNUSUAL_LINE_TERMINATORS.test(B)}e.containsUnusualLineTerminators=V;function re(B){for(let se=0,le=B.length;se<le;se++)if(ie(B.charCodeAt(se)))return!0;return!1}e.containsFullWidthCharacter=re;function ie(B){return B=+B,B>=11904&&B<=55215||B>=63744&&B<=64255||B>=65281&&B<=65374}e.isFullWidthCharacter=ie;function ce(B){return B>=127462&&B<=127487||B===8986||B===8987||B===9200||B===9203||B>=9728&&B<=10175||B===11088||B===11093||B>=127744&&B<=128591||B>=128640&&B<=128764||B>=128992&&B<=129003||B>=129280&&B<=129535||B>=129648&&B<=129750}e.isEmojiImprecise=ce;function ue(B,se){if(B.length<se)return B;const le=/\b/g;let he=0;for(;le.test(B)&&!(B.length-le.lastIndex<se);)he=le.lastIndex,le.lastIndex+=1;return B.substring(he).replace(/^\s/,"")}e.lcut=ue;const ye=/\x1B\x5B[12]?K/g,ge=/\x1b\[\d+m/g,Ie=/\x1b\[0?m/g;function Pe(B){return B&&(B=B.replace(ye,""),B=B.replace(ge,""),B=B.replace(Ie,"")),B}e.removeAnsiEscapeCodes=Pe,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Ee(B){return!!(B&&B.length>0&&B.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Ee;function Ae(B){return Ee(B)?B.substr(1):B}e.stripUTF8BOM=Ae;function De(B,se){if(!B||!se||B.length<se.length)return!1;const le=se.length,he=B.toLowerCase();let me=0,be=-1;for(;me<le;){const ve=he.indexOf(se[me],be+1);if(ve<0)return!1;be=ve,me++}return!0}e.fuzzyContains=De;function Te(B,se=!1){return B?(se&&(B=B.replace(/\\./g,"")),B.toLowerCase()!==B):!1}e.containsUppercaseCharacter=Te;function Ne(B){return B.charAt(0).toUpperCase()+B.slice(1)}e.uppercaseFirstLetter=Ne;function _e(B,se=1){if(se===0)return"";let le=-1;do le=B.indexOf(`
`,le+1),se--;while(se>0&&le>=0);return le===-1?B:(B[le-1]==="\r"&&le--,B.substr(0,le))}e.getNLines=_e;function $e(B){const se=90-65+1;return B=B%(2*se),B<se?String.fromCharCode(97+B):String.fromCharCode(65+B-se)}e.singleLetterHash=$e;function xe(B){return oe.getInstance().getGraphemeBreakType(B)}e.getGraphemeBreakType=xe;function Q(B,se){return B===0?se!==5&&se!==7:B===2&&se===3?!1:B===4||B===2||B===3||se===4||se===2||se===3?!0:!(B===8&&(se===8||se===9||se===11||se===12)||(B===11||B===9)&&(se===9||se===10)||(B===12||B===10)&&se===10||se===5||se===13||se===7||B===1||B===13&&se===14||B===6&&se===6)}e.breakBetweenGraphemeBreakType=Q;var ae;(function(B){B[B.Other=0]="Other",B[B.Prepend=1]="Prepend",B[B.CR=2]="CR",B[B.LF=3]="LF",B[B.Control=4]="Control",B[B.Extend=5]="Extend",B[B.Regional_Indicator=6]="Regional_Indicator",B[B.SpacingMark=7]="SpacingMark",B[B.L=8]="L",B[B.V=9]="V",B[B.T=10]="T",B[B.LV=11]="LV",B[B.LVT=12]="LVT",B[B.ZWJ=13]="ZWJ",B[B.Extended_Pictographic=14]="Extended_Pictographic"})(ae=e.GraphemeBreakType||(e.GraphemeBreakType={}));class oe{constructor(){this._data=pe()}static getInstance(){return oe._INSTANCE||(oe._INSTANCE=new oe),oe._INSTANCE}getGraphemeBreakType(se){if(se<32)return se===10?3:se===13?2:4;if(se<127)return 0;const le=this._data,he=le.length/3;let me=1;for(;me<=he;)if(se<le[3*me])me=2*me;else if(se>le[3*me+1])me=2*me+1;else return le[3*me+2];return 0}}oe._INSTANCE=null;function pe(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function Se(B,se){if(B===0)return 0;const le=Oe(B,se);if(le!==void 0)return le;const he=q(se,B);return B-=Le(he),B}e.getLeftDeleteOffset=Se;function Oe(B,se){let le=q(se,B);for(B-=Le(le);Ue(le)||le===65039||le===8419;){if(B===0)return;le=q(se,B),B-=Le(le)}if(!!ce(le)){if(B>=0){const he=q(se,B);he===8205&&(B-=Le(he))}return B}}function Le(B){return B>=65536?2:1}function Ue(B){return 127995<=B&&B<=127999}var ke;(function(B){B[B.zwj=8205]="zwj",B[B.emojiVariantSelector=65039]="emojiVariantSelector",B[B.enclosingKeyCap=8419]="enclosingKeyCap"})(ke||(ke={}))}),define(Z[17],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPromise=e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function D(d){return Array.isArray(d)}e.isArray=D;function T(d){return typeof d=="string"}e.isString=T;function R(d){return Array.isArray(d)&&d.every(v=>T(v))}e.isStringArray=R;function L(d){return typeof d=="object"&&d!==null&&!Array.isArray(d)&&!(d instanceof RegExp)&&!(d instanceof Date)}e.isObject=L;function k(d){return typeof d=="number"&&!isNaN(d)}e.isNumber=k;function P(d){return!!d&&typeof d[Symbol.iterator]=="function"}e.isIterable=P;function m(d){return d===!0||d===!1}e.isBoolean=m;function b(d){return typeof d=="undefined"}e.isUndefined=b;function i(d){return!C(d)}e.isDefined=i;function C(d){return b(d)||d===null}e.isUndefinedOrNull=C;function f(d,v){if(!d)throw new Error(v?`Unexpected type, expected '${v}'`:"Unexpected type")}e.assertType=f;function I(d){if(C(d))throw new Error("Assertion Failed: argument is undefined or null");return d}e.assertIsDefined=I;function u(...d){const v=[];for(let A=0;A<d.length;A++){const O=d[A];if(C(O))throw new Error(`Assertion Failed: argument at index ${A} is undefined or null`);v.push(O)}return v}e.assertAllDefined=u;const w=Object.prototype.hasOwnProperty;function g(d){if(!L(d))return!1;for(let v in d)if(w.call(d,v))return!1;return!0}e.isEmptyObject=g;function E(d){return typeof d=="function"}e.isFunction=E;function y(...d){return d.length>0&&d.every(E)}e.areFunctions=y;function S(d,v){const A=Math.min(d.length,v.length);for(let O=0;O<A;O++)o(d[O],v[O])}e.validateConstraints=S;function o(d,v){if(T(v)){if(typeof d!==v)throw new Error(`argument does not match constraint: typeof ${v}`)}else if(E(v)){try{if(d instanceof v)return}catch{}if(!C(d)&&d.constructor===v||v.length===1&&v.call(void 0,d)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=o;function a(d){let v=[],A=Object.getPrototypeOf(d);for(;Object.prototype!==A;)v=v.concat(Object.getOwnPropertyNames(A)),A=Object.getPrototypeOf(A);return v}e.getAllPropertyNames=a;function t(d){const v=[];for(const A of a(d))typeof d[A]=="function"&&v.push(A);return v}e.getAllMethodNames=t;function s(d,v){const A=p=>function(){const U=Array.prototype.slice.call(arguments,0);return v(p,U)};let O={};for(const p of d)O[p]=A(p);return O}e.createProxyObject=s;function n(d){return d===null?void 0:d}e.withNullAsUndefined=n;function r(d){return typeof d=="undefined"?null:d}e.withUndefinedAsNull=r;function c(d){return class{constructor(){return new Proxy({},{get(v,A){if(v[A])return v[A];throw new Error(`Not Implemented: ${d}->${String(A)}`)}})}}}e.NotImplementedProxy=c;function l(d,v="Unreachable"){throw new Error(v)}e.assertNever=l;function h(d){return!!d&&typeof d.then=="function"&&typeof d.catch=="function"}e.isPromise=h}),define(Z[39],ee([0,1,8,4,24,17]),function(K,e,D,T,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function k(n){return n===47||n===92}e.isPathSeparator=k;function P(n){return n.replace(/[\\/]/g,D.posix.sep)}e.toSlashes=P;function m(n){return n.indexOf("/")===-1&&(n=P(n)),/^[a-zA-Z]:(\/|$)/.test(n)&&(n="/"+n),n}e.toPosixPath=m;function b(n,r=D.posix.sep){if(!n)return"";const c=n.length,l=n.charCodeAt(0);if(k(l)){if(k(n.charCodeAt(1))&&!k(n.charCodeAt(2))){let d=3;const v=d;for(;d<c&&!k(n.charCodeAt(d));d++);if(v!==d&&!k(n.charCodeAt(d+1))){for(d+=1;d<c;d++)if(k(n.charCodeAt(d)))return n.slice(0,d+1).replace(/[\\/]/g,r)}}return r}else if(E(l)&&n.charCodeAt(1)===58)return k(n.charCodeAt(2))?n.slice(0,2)+r:n.slice(0,2);let h=n.indexOf("://");if(h!==-1){for(h+=3;h<c;h++)if(k(n.charCodeAt(h)))return n.slice(0,h+1)}return""}e.getRoot=b;function i(n){if(!T.isWindows||!n||n.length<5)return!1;let r=n.charCodeAt(0);if(r!==92||(r=n.charCodeAt(1),r!==92))return!1;let c=2;const l=c;for(;c<n.length&&(r=n.charCodeAt(c),r!==92);c++);return!(l===c||(r=n.charCodeAt(c+1),isNaN(r)||r===92))}e.isUNC=i;const C=/[\\/:\*\?"<>\|]/g,f=/[\\/]/g,I=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function u(n,r=T.isWindows){const c=r?C:f;return!(!n||n.length===0||/^\s+$/.test(n)||(c.lastIndex=0,c.test(n))||r&&I.test(n)||n==="."||n===".."||r&&n[n.length-1]==="."||r&&n.length!==n.trim().length||n.length>255)}e.isValidBasename=u;function w(n,r,c){const l=n===r;return!c||l?l:!n||!r?!1:(0,R.equalsIgnoreCase)(n,r)}e.isEqual=w;function g(n,r,c,l=D.sep){if(n===r)return!0;if(!n||!r||r.length>n.length)return!1;if(c){if(!(0,R.startsWithIgnoreCase)(n,r))return!1;if(r.length===n.length)return!0;let d=r.length;return r.charAt(r.length-1)===l&&d--,n.charAt(d)===l}return r.charAt(r.length-1)!==l&&(r+=l),n.indexOf(r)===0}e.isEqualOrParent=g;function E(n){return n>=65&&n<=90||n>=97&&n<=122}e.isWindowsDriveLetter=E;function y(n,r){return T.isWindows&&n.endsWith(":")&&(n+=D.sep),(0,D.isAbsolute)(n)||(n=(0,D.join)(r,n)),n=(0,D.normalize)(n),T.isWindows?(n=(0,R.rtrim)(n,D.sep),n.endsWith(":")&&(n+=D.sep)):(n=(0,R.rtrim)(n,D.sep),n||(n=D.sep)),n}e.sanitizeFilePath=y;function S(n){const r=(0,D.normalize)(n);return T.isWindows?n.length>3?!1:o(r)&&(n.length===2||r.charCodeAt(2)===92):r===D.posix.sep}e.isRootOrDriveLetter=S;function o(n){return T.isWindows?E(n.charCodeAt(0))&&n.charCodeAt(1)===58:!1}e.hasDriveLetter=o;function a(n){return o(n)?n[0]:void 0}e.getDriveLetter=a;function t(n,r,c){return r.length>n.length?-1:n===r?0:(c&&(n=n.toLowerCase(),r=r.toLowerCase()),n.indexOf(r))}e.indexOfPath=t;function s(n){const r=n.split(":");let c,l,h;if(r.forEach(d=>{const v=Number(d);(0,L.isNumber)(v)?l===void 0?l=v:h===void 0&&(h=v):c=c?[c,d].join(":"):d}),!c)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:c,line:l!==void 0?l:void 0,column:h!==void 0?h:l!==void 0?1:void 0}}e.parseLineAndColumnAware=s}),define(Z[26],ee([0,1,17]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function T(w){if(!w||typeof w!="object"||w instanceof RegExp)return w;const g=Array.isArray(w)?[]:{};return Object.keys(w).forEach(E=>{w[E]&&typeof w[E]=="object"?g[E]=T(w[E]):g[E]=w[E]}),g}e.deepClone=T;function R(w){if(!w||typeof w!="object")return w;const g=[w];for(;g.length>0;){const E=g.shift();Object.freeze(E);for(const y in E)if(L.call(E,y)){const S=E[y];typeof S=="object"&&!Object.isFrozen(S)&&g.push(S)}}return w}e.deepFreeze=R;const L=Object.prototype.hasOwnProperty;function k(w,g){return P(w,g,new Set)}e.cloneAndChange=k;function P(w,g,E){if((0,D.isUndefinedOrNull)(w))return w;const y=g(w);if(typeof y!="undefined")return y;if((0,D.isArray)(w)){const S=[];for(const o of w)S.push(P(o,g,E));return S}if((0,D.isObject)(w)){if(E.has(w))throw new Error("Cannot clone recursive data-structure");E.add(w);const S={};for(let o in w)L.call(w,o)&&(S[o]=P(w[o],g,E));return E.delete(w),S}return w}function m(w,g,E=!0){return(0,D.isObject)(w)?((0,D.isObject)(g)&&Object.keys(g).forEach(y=>{y in w?E&&((0,D.isObject)(w[y])&&(0,D.isObject)(g[y])?m(w[y],g[y],E):w[y]=g[y]):w[y]=g[y]}),w):g}e.mixin=m;function b(w,g){if(w===g)return!0;if(w==null||g===null||g===void 0||typeof w!=typeof g||typeof w!="object"||Array.isArray(w)!==Array.isArray(g))return!1;let E,y;if(Array.isArray(w)){if(w.length!==g.length)return!1;for(E=0;E<w.length;E++)if(!b(w[E],g[E]))return!1}else{const S=[];for(y in w)S.push(y);S.sort();const o=[];for(y in g)o.push(y);if(o.sort(),!b(S,o))return!1;for(E=0;E<S.length;E++)if(!b(w[S[E]],g[S[E]]))return!1}return!0}e.equals=b;function i(w){const g=new Set;return JSON.stringify(w,(E,y)=>{if((0,D.isObject)(y)||Array.isArray(y)){if(g.has(y))return"[Circular]";g.add(y)}return y})}e.safeStringify=i;function C(w,g,E){const y=g(w);return typeof y=="undefined"?E:y}e.getOrDefault=C;function f(w,g){const E=Object.create(null);return!w||!g||Object.keys(g).forEach(S=>{const o=w[S],a=g[S];b(o,a)||(E[S]=a)}),E}e.distinct=f;function I(w,g){const E=g.toLowerCase(),y=Object.keys(w).find(S=>S.toLowerCase()===E);return y?w[y]:w[g]}e.getCaseInsensitive=I;function u(w,g){const E=Object.create(null);for(const y of Object.keys(w))g(y,w[y])&&(E[y]=w[y]);return E}e.filter=u}),define(Z[5],ee([0,1,8,4]),function(K,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const R=/^\w[\w\d+.-]*$/,L=/^\//,k=/^\/\//;function P(n,r){if(!n.scheme&&r)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${n.authority}", path: "${n.path}", query: "${n.query}", fragment: "${n.fragment}"}`);if(n.scheme&&!R.test(n.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(n.path){if(n.authority){if(!L.test(n.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(k.test(n.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function m(n,r){return!n&&!r?"file":n}function b(n,r){switch(n){case"https":case"http":case"file":r?r[0]!==C&&(r=C+r):r=C;break}return r}const i="",C="/",f=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class I{constructor(r,c,l,h,d,v=!1){typeof r=="object"?(this.scheme=r.scheme||i,this.authority=r.authority||i,this.path=r.path||i,this.query=r.query||i,this.fragment=r.fragment||i):(this.scheme=m(r,v),this.authority=c||i,this.path=b(this.scheme,l||i),this.query=h||i,this.fragment=d||i,P(this,v))}static isUri(r){return r instanceof I?!0:r?typeof r.authority=="string"&&typeof r.fragment=="string"&&typeof r.path=="string"&&typeof r.query=="string"&&typeof r.scheme=="string"&&typeof r.fsPath=="string"&&typeof r.with=="function"&&typeof r.toString=="function":!1}get fsPath(){return S(this,!1)}with(r){if(!r)return this;let{scheme:c,authority:l,path:h,query:d,fragment:v}=r;return c===void 0?c=this.scheme:c===null&&(c=i),l===void 0?l=this.authority:l===null&&(l=i),h===void 0?h=this.path:h===null&&(h=i),d===void 0?d=this.query:d===null&&(d=i),v===void 0?v=this.fragment:v===null&&(v=i),c===this.scheme&&l===this.authority&&h===this.path&&d===this.query&&v===this.fragment?this:new w(c,l,h,d,v)}static parse(r,c=!1){const l=f.exec(r);return l?new w(l[2]||i,s(l[4]||i),s(l[5]||i),s(l[7]||i),s(l[9]||i),c):new w(i,i,i,i,i)}static file(r){let c=i;if(T.isWindows&&(r=r.replace(/\\/g,C)),r[0]===C&&r[1]===C){const l=r.indexOf(C,2);l===-1?(c=r.substring(2),r=C):(c=r.substring(2,l),r=r.substring(l)||C)}return new w("file",c,r,i,i)}static from(r){const c=new w(r.scheme,r.authority,r.path,r.query,r.fragment);return P(c,!0),c}static joinPath(r,...c){if(!r.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let l;return T.isWindows&&r.scheme==="file"?l=I.file(D.win32.join(S(r,!0),...c)).path:l=D.posix.join(r.path,...c),r.with({path:l})}toString(r=!1){return o(this,r)}toJSON(){return this}static revive(r){if(r){if(r instanceof I)return r;{const c=new w(r);return c._formatted=r.external,c._fsPath=r._sep===u?r.fsPath:null,c}}else return r}}e.URI=I;const u=T.isWindows?1:void 0;class w extends I{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=S(this,!1)),this._fsPath}toString(r=!1){return r?o(this,!0):(this._formatted||(this._formatted=o(this,!1)),this._formatted)}toJSON(){const r={$mid:1};return this._fsPath&&(r.fsPath=this._fsPath,r._sep=u),this._formatted&&(r.external=this._formatted),this.path&&(r.path=this.path),this.scheme&&(r.scheme=this.scheme),this.authority&&(r.authority=this.authority),this.query&&(r.query=this.query),this.fragment&&(r.fragment=this.fragment),r}}const g={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function E(n,r){let c,l=-1;for(let h=0;h<n.length;h++){const d=n.charCodeAt(h);if(d>=97&&d<=122||d>=65&&d<=90||d>=48&&d<=57||d===45||d===46||d===95||d===126||r&&d===47)l!==-1&&(c+=encodeURIComponent(n.substring(l,h)),l=-1),c!==void 0&&(c+=n.charAt(h));else{c===void 0&&(c=n.substr(0,h));const v=g[d];v!==void 0?(l!==-1&&(c+=encodeURIComponent(n.substring(l,h)),l=-1),c+=v):l===-1&&(l=h)}}return l!==-1&&(c+=encodeURIComponent(n.substring(l))),c!==void 0?c:n}function y(n){let r;for(let c=0;c<n.length;c++){const l=n.charCodeAt(c);l===35||l===63?(r===void 0&&(r=n.substr(0,c)),r+=g[l]):r!==void 0&&(r+=n[c])}return r!==void 0?r:n}function S(n,r){let c;return n.authority&&n.path.length>1&&n.scheme==="file"?c=`//${n.authority}${n.path}`:n.path.charCodeAt(0)===47&&(n.path.charCodeAt(1)>=65&&n.path.charCodeAt(1)<=90||n.path.charCodeAt(1)>=97&&n.path.charCodeAt(1)<=122)&&n.path.charCodeAt(2)===58?r?c=n.path.substr(1):c=n.path[1].toLowerCase()+n.path.substr(2):c=n.path,T.isWindows&&(c=c.replace(/\//g,"\\")),c}e.uriToFsPath=S;function o(n,r){const c=r?y:E;let l="",{scheme:h,authority:d,path:v,query:A,fragment:O}=n;if(h&&(l+=h,l+=":"),(d||h==="file")&&(l+=C,l+=C),d){let p=d.indexOf("@");if(p!==-1){const U=d.substr(0,p);d=d.substr(p+1),p=U.indexOf(":"),p===-1?l+=c(U,!1):(l+=c(U.substr(0,p),!1),l+=":",l+=c(U.substr(p+1),!1)),l+="@"}d=d.toLowerCase(),p=d.indexOf(":"),p===-1?l+=c(d,!1):(l+=c(d.substr(0,p),!1),l+=d.substr(p))}if(v){if(v.length>=3&&v.charCodeAt(0)===47&&v.charCodeAt(2)===58){const p=v.charCodeAt(1);p>=65&&p<=90&&(v=`/${String.fromCharCode(p+32)}:${v.substr(3)}`)}else if(v.length>=2&&v.charCodeAt(1)===58){const p=v.charCodeAt(0);p>=65&&p<=90&&(v=`${String.fromCharCode(p+32)}:${v.substr(2)}`)}l+=c(v,!0)}return A&&(l+="?",l+=c(A,!1)),O&&(l+="#",l+=r?O:E(O,!1)),l}function a(n){try{return decodeURIComponent(n)}catch{return n.length>3?n.substr(0,3)+a(n.substr(3)):n}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function s(n){return n.match(t)?n.replace(t,r=>a(r)):n}}),define(Z[93],ee([0,1,5]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function T(b){const i=b;return i&&typeof i.type=="string"&&typeof i.severity=="string"}e.isRemoteConsoleLog=T;function R(b){const i=[];let C;try{const f=JSON.parse(b.arguments),I=f[f.length-1];I&&I.__$stack&&(f.pop(),C=I.__$stack),i.push(...f)}catch(f){i.push("Unable to log remote console arguments",b.arguments)}return{args:i,stack:C}}e.parse=R;function L(b){if(typeof b!="string")return L(R(b).stack);const i=b;if(i){const C=k(i),f=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(C||"");if(f&&f.length===4)return{uri:D.URI.file(f[1]),line:Number(f[2]),column:Number(f[3])}}}e.getFirstFrame=L;function k(b){if(!b)return b;const i=b.indexOf(`
`);return i===-1?b:b.substring(0,i)}function P(b,i){const{args:C,stack:f}=R(b),I=typeof C[0]=="string"&&C.length===1;let u=k(f);u&&(u=`(${u.trim()})`);let w=[];if(typeof C[0]=="string"?u&&I?w=[`%c[${i}] %c${C[0]} %c${u}`,m("blue"),m(""),m("grey")]:w=[`%c[${i}] %c${C[0]}`,m("blue"),m(""),...C.slice(1)]:w=[`%c[${i}]%`,m("blue"),...C],u&&!I&&w.push(u),typeof console[b.severity]!="function")throw new Error("Unknown console method");console[b.severity].apply(console,w)}e.log=P;function m(b){return`color: ${b}`}});var ht=this&&this.__classPrivateFieldSet||function(K,e,D,T,R){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!R)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?K!==e||!R:!e.has(K))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?R.call(K,D):R?R.value=D:e.set(K,D),D},je=this&&this.__classPrivateFieldGet||function(K,e,D,T){if(D==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?K!==e||!T:!e.has(K))throw new TypeError("Cannot read private member from an object whose class did not declare it");return D==="m"?T:D==="a"?T.call(K):T?T.value:e.get(K)};define(Z[40],ee([0,1,16,24,5]),function(K,e,D,T,R){"use strict";var L,k,P;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function m(s,n,r){let c=s.get(n);return c===void 0&&(c=r,s.set(n,c)),c}e.getOrSet=m;function b(s){const n=[];return s.forEach((r,c)=>{n.push(`${c} => ${r}`)}),`Map(${s.size}) {${n.join(", ")}}`}e.mapToString=b;function i(s){const n=[];return s.forEach(r=>{n.push(r)}),`Set(${s.size}) {${n.join(", ")}}`}e.setToString=i;class C{constructor(){this._value="",this._pos=0}reset(n){return this._value=n,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(n){const r=n.charCodeAt(0),c=this._value.charCodeAt(this._pos);return r-c}value(){return this._value[this._pos]}}e.StringIterator=C;class f{constructor(n=!0){this._caseSensitive=n}reset(n){return this._value=n,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(n)this._from++;else break;else n=!1;return this}cmp(n){return this._caseSensitive?(0,T.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,T.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=f;class I{constructor(n=!0,r=!0){this._splitOnBackslash=n,this._caseSensitive=r}reset(n){return this._value=n.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++){const r=this._value.charCodeAt(this._to);if(r===47||this._splitOnBackslash&&r===92)if(n)this._from++;else break;else n=!1}return this}cmp(n){return this._caseSensitive?(0,T.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,T.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=I;var u;(function(s){s[s.Scheme=1]="Scheme",s[s.Authority=2]="Authority",s[s.Path=3]="Path",s[s.Query=4]="Query",s[s.Fragment=5]="Fragment"})(u||(u={}));class w{constructor(n){this._ignorePathCasing=n,this._states=[],this._stateIdx=0}reset(n){return this._value=n,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new I(!1,!this._ignorePathCasing(n)),this._pathIterator.reset(n.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(n){if(this._states[this._stateIdx]===1)return(0,T.compareIgnoreCase)(n,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,T.compareIgnoreCase)(n,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(n);if(this._states[this._stateIdx]===4)return(0,T.compare)(n,this._value.query);if(this._states[this._stateIdx]===5)return(0,T.compare)(n,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=w;class g{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class E{constructor(n){this._iter=n}static forUris(n=()=>!1){return new E(new w(n))}static forPaths(){return new E(new I)}static forStrings(){return new E(new C)}static forConfigKeys(){return new E(new f)}clear(){this._root=void 0}set(n,r){const c=this._iter.reset(n);let l;for(this._root||(this._root=new g,this._root.segment=c.value()),l=this._root;;){const d=c.cmp(l.segment);if(d>0)l.left||(l.left=new g,l.left.segment=c.value()),l=l.left;else if(d<0)l.right||(l.right=new g,l.right.segment=c.value()),l=l.right;else if(c.hasNext())c.next(),l.mid||(l.mid=new g,l.mid.segment=c.value()),l=l.mid;else break}const h=l.value;return l.value=r,l.key=n,h}fill(n,r){const c=r.slice(0);(0,D.shuffle)(c);for(let l of c)this.set(l,n)}get(n){return this._getNode(n)?.value}_getNode(n){const r=this._iter.reset(n);let c=this._root;for(;c;){const l=r.cmp(c.segment);if(l>0)c=c.left;else if(l<0)c=c.right;else if(r.hasNext())r.next(),c=c.mid;else break}return c}has(n){const r=this._getNode(n);return!(r?.value===void 0&&r?.mid===void 0)}delete(n){return this._delete(n,!1)}deleteSuperstr(n){return this._delete(n,!0)}_delete(n,r){const c=this._iter.reset(n),l=[];let h=this._root;for(;h;){const d=c.cmp(h.segment);if(d>0)l.push([1,h]),h=h.left;else if(d<0)l.push([-1,h]),h=h.right;else if(c.hasNext())c.next(),l.push([0,h]),h=h.mid;else{for(r?(h.left=void 0,h.mid=void 0,h.right=void 0):h.value=void 0;l.length>0&&h.isEmpty();){let[v,A]=l.pop();switch(v){case 1:A.left=void 0;break;case 0:A.mid=void 0;break;case-1:A.right=void 0;break}h=A}break}}}findSubstr(n){const r=this._iter.reset(n);let c=this._root,l;for(;c;){const h=r.cmp(c.segment);if(h>0)c=c.left;else if(h<0)c=c.right;else if(r.hasNext())r.next(),l=c.value||l,c=c.mid;else break}return c&&c.value||l}findSuperstr(n){const r=this._iter.reset(n);let c=this._root;for(;c;){const l=r.cmp(c.segment);if(l>0)c=c.left;else if(l<0)c=c.right;else if(r.hasNext())r.next(),c=c.mid;else return c.mid?this._entries(c.mid):void 0}}forEach(n){for(const[r,c]of this)n(c,r)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(n){if(!n)return;const r=[n];for(;r.length>0;){const c=r.pop();c&&(c.value&&(yield[c.key,c.value]),c.left&&r.push(c.left),c.mid&&r.push(c.mid),c.right&&r.push(c.right))}}}e.TernarySearchTree=E;class y{constructor(n,r){this[L]="ResourceMap",n instanceof y?(this.map=new Map(n.map),this.toKey=r??y.defaultToKey):(this.map=new Map,this.toKey=n??y.defaultToKey)}set(n,r){return this.map.set(this.toKey(n),r),this}get(n){return this.map.get(this.toKey(n))}has(n){return this.map.has(this.toKey(n))}get size(){return this.map.size}clear(){this.map.clear()}delete(n){return this.map.delete(this.toKey(n))}forEach(n,r){typeof r!="undefined"&&(n=n.bind(r));for(let[c,l]of this.map)n(l,R.URI.parse(c),this)}values(){return this.map.values()}*keys(){for(let n of this.map.keys())yield R.URI.parse(n)}*entries(){for(let n of this.map.entries())yield[R.URI.parse(n[0]),n[1]]}*[(L=Symbol.toStringTag,Symbol.iterator)](){for(let n of this.map)yield[R.URI.parse(n[0]),n[1]]}}e.ResourceMap=y,y.defaultToKey=s=>s.toString();var S;(function(s){s[s.None=0]="None",s[s.AsOld=1]="AsOld",s[s.AsNew=2]="AsNew"})(S=e.Touch||(e.Touch={}));class o{constructor(){this[k]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(n){return this._map.has(n)}get(n,r=0){const c=this._map.get(n);if(!!c)return r!==0&&this.touch(c,r),c.value}set(n,r,c=0){let l=this._map.get(n);if(l)l.value=r,c!==0&&this.touch(l,c);else{switch(l={key:n,value:r,next:void 0,previous:void 0},c){case 0:this.addItemLast(l);break;case 1:this.addItemFirst(l);break;case 2:this.addItemLast(l);break;default:this.addItemLast(l);break}this._map.set(n,l),this._size++}return this}delete(n){return!!this.remove(n)}remove(n){const r=this._map.get(n);if(!!r)return this._map.delete(n),this.removeItem(r),this._size--,r.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const n=this._head;return this._map.delete(n.key),this.removeItem(n),this._size--,n.value}forEach(n,r){const c=this._state;let l=this._head;for(;l;){if(r?n.bind(r)(l.value,l.key,this):n(l.value,l.key,this),this._state!==c)throw new Error("LinkedMap got modified during iteration.");l=l.next}}keys(){const n=this,r=this._state;let c=this._head;const l={[Symbol.iterator](){return l},next(){if(n._state!==r)throw new Error("LinkedMap got modified during iteration.");if(c){const h={value:c.key,done:!1};return c=c.next,h}else return{value:void 0,done:!0}}};return l}values(){const n=this,r=this._state;let c=this._head;const l={[Symbol.iterator](){return l},next(){if(n._state!==r)throw new Error("LinkedMap got modified during iteration.");if(c){const h={value:c.value,done:!1};return c=c.next,h}else return{value:void 0,done:!0}}};return l}entries(){const n=this,r=this._state;let c=this._head;const l={[Symbol.iterator](){return l},next(){if(n._state!==r)throw new Error("LinkedMap got modified during iteration.");if(c){const h={value:[c.key,c.value],done:!1};return c=c.next,h}else return{value:void 0,done:!0}}};return l}[(k=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(n){if(n>=this.size)return;if(n===0){this.clear();return}let r=this._head,c=this.size;for(;r&&c>n;)this._map.delete(r.key),r=r.next,c--;this._head=r,this._size=c,r&&(r.previous=void 0),this._state++}addItemFirst(n){if(!this._head&&!this._tail)this._tail=n;else if(this._head)n.next=this._head,this._head.previous=n;else throw new Error("Invalid list");this._head=n,this._state++}addItemLast(n){if(!this._head&&!this._tail)this._head=n;else if(this._tail)n.previous=this._tail,this._tail.next=n;else throw new Error("Invalid list");this._tail=n,this._state++}removeItem(n){if(n===this._head&&n===this._tail)this._head=void 0,this._tail=void 0;else if(n===this._head){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this._head=n.next}else if(n===this._tail){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this._tail=n.previous}else{const r=n.next,c=n.previous;if(!r||!c)throw new Error("Invalid list");r.previous=c,c.next=r}n.next=void 0,n.previous=void 0,this._state++}touch(n,r){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(r!==1&&r!==2)){if(r===1){if(n===this._head)return;const c=n.next,l=n.previous;n===this._tail?(l.next=void 0,this._tail=l):(c.previous=l,l.next=c),n.previous=void 0,n.next=this._head,this._head.previous=n,this._head=n,this._state++}else if(r===2){if(n===this._tail)return;const c=n.next,l=n.previous;n===this._head?(c.previous=void 0,this._head=c):(c.previous=l,l.next=c),n.next=void 0,n.previous=this._tail,this._tail.next=n,this._tail=n,this._state++}}}toJSON(){const n=[];return this.forEach((r,c)=>{n.push([c,r])}),n}fromJSON(n){this.clear();for(const[r,c]of n)this.set(r,c)}}e.LinkedMap=o;class a extends o{constructor(n,r=1){super();this._limit=n,this._ratio=Math.min(Math.max(0,r),1)}get limit(){return this._limit}set limit(n){this._limit=n,this.checkTrim()}get ratio(){return this._ratio}set ratio(n){this._ratio=Math.min(Math.max(0,n),1),this.checkTrim()}get(n,r=2){return super.get(n,r)}peek(n){return super.get(n,0)}set(n,r){return super.set(n,r,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=a;class t{constructor(n){P.set(this,void 0),ht(this,P,n,"f")}get size(){return je(this,P,"f").size}forEach(n,r){je(this,P,"f").forEach(n,r)}get(n){return je(this,P,"f").get(n)}has(n){return je(this,P,"f").has(n)}entries(){return je(this,P,"f").entries()}keys(){return je(this,P,"f").keys()}values(){return je(this,P,"f").values()}[(P=new WeakMap,Symbol.iterator)](){return je(this,P,"f").entries()}}e.ReadonlyMapView=t}),define(Z[94],ee([0,1,25,24,5]),function(K,e,D,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function L(i){return JSON.stringify(i,m)}e.stringify=L;function k(i){let C=JSON.parse(i);return C=b(C),C}e.parse=k;var P;(function(i){i[i.Uri=1]="Uri",i[i.Regexp=2]="Regexp",i[i.ScmResource=3]="ScmResource",i[i.ScmResourceGroup=4]="ScmResourceGroup",i[i.ScmProvider=5]="ScmProvider",i[i.CommentController=6]="CommentController",i[i.CommentThread=7]="CommentThread",i[i.CommentThreadReply=8]="CommentThreadReply",i[i.CommentNode=9]="CommentNode",i[i.CommentThreadNode=10]="CommentThreadNode",i[i.TimelineActionContext=11]="TimelineActionContext",i[i.NotebookCellActionContext=12]="NotebookCellActionContext",i[i.TestItemContext=13]="TestItemContext"})(P=e.MarshalledId||(e.MarshalledId={}));function m(i,C){return C instanceof RegExp?{$mid:2,source:C.source,flags:(0,T.regExpFlags)(C)}:C}function b(i,C=0){if(!i||C>200)return i;if(typeof i=="object"){switch(i.$mid){case 1:return R.URI.revive(i);case 2:return new RegExp(i.source,i.flags)}if(i instanceof D.VSBuffer||i instanceof Uint8Array)return i;if(Array.isArray(i))for(let f=0;f<i.length;++f)i[f]=b(i[f],C+1);else for(const f in i)Object.hasOwnProperty.call(i,f)&&(i[f]=b(i[f],C+1))}return i}e.revive=b}),define(Z[18],ee([0,1,4,5]),function(K,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var R;(function(P){P.inMemory="inmemory",P.vscode="vscode",P.internal="private",P.walkThrough="walkThrough",P.walkThroughSnippet="walkThroughSnippet",P.http="http",P.https="https",P.file="file",P.mailto="mailto",P.untitled="untitled",P.data="data",P.command="command",P.vscodeRemote="vscode-remote",P.vscodeRemoteResource="vscode-remote-resource",P.userData="vscode-userdata",P.vscodeCustomEditor="vscode-custom-editor",P.vscodeNotebook="vscode-notebook",P.vscodeNotebookCell="vscode-notebook-cell",P.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",P.vscodeNotebookCellOutput="vscode-notebook-cell-output",P.vscodeInteractive="vscode-interactive",P.vscodeInteractiveInput="vscode-interactive-input",P.vscodeSettings="vscode-settings",P.vscodeWorkspaceTrust="vscode-workspace-trust",P.vscodeTerminal="vscode-terminal",P.webviewPanel="webview-panel",P.vscodeWebview="vscode-webview",P.extension="extension",P.vscodeFileResource="vscode-file",P.tmp="tmp"})(R=e.Schemas||(e.Schemas={}));class L{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(m){this._preferredWebSchema=m}setDelegate(m){this._delegate=m}set(m,b,i){this._hosts[m]=b,this._ports[m]=i}setConnectionToken(m,b){this._connectionTokens[m]=b}rewrite(m){if(this._delegate)return this._delegate(m);const b=m.authority;let i=this._hosts[b];i&&i.indexOf(":")!==-1&&(i=`[${i}]`);const C=this._ports[b],f=this._connectionTokens[b];let I=`path=${encodeURIComponent(m.path)}`;return typeof f=="string"&&(I+=`&tkn=${encodeURIComponent(f)}`),T.URI.from({scheme:D.isWeb?this._preferredWebSchema:R.vscodeRemoteResource,authority:`${i}:${C}`,path:"/vscode-remote-resource",query:I})}}e.RemoteAuthorities=new L;class k{asBrowserUri(m,b){const i=this.toUri(m,b);return i.scheme===R.vscodeRemote?e.RemoteAuthorities.rewrite(i):i.scheme===R.file&&(D.isNative||typeof D.globals.importScripts=="function"&&D.globals.origin===`${R.vscodeFileResource}://${k.FALLBACK_AUTHORITY}`)?i.with({scheme:R.vscodeFileResource,authority:i.authority||k.FALLBACK_AUTHORITY,query:null,fragment:null}):i}asFileUri(m,b){const i=this.toUri(m,b);return i.scheme===R.vscodeFileResource?i.with({scheme:R.file,authority:i.authority!==k.FALLBACK_AUTHORITY?i.authority:null,query:null,fragment:null}):i}toUri(m,b){return T.URI.isUri(m)?m:T.URI.parse(b.toUrl(m))}}k.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new k}),define(Z[66],ee([0,1,40]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const T=new D.LRUCache(1e4);function R(b){return m(b,"NFC",T)}e.normalizeNFC=R;const L=new D.LRUCache(1e4);function k(b){return m(b,"NFD",L)}e.normalizeNFD=k;const P=/[^\u0000-\u0080]/;function m(b,i,C){if(!b)return b;const f=C.get(b);if(f)return f;let I;return P.test(b)?I=b.normalize(i):I=b,C.set(b,I),I}e.removeAccents=function(){const b=/[\u0300-\u036f]/g;return function(i){return k(i).replace(b,"")}}()}),define(Z[15],ee([0,1,39,18,8,4,24,5]),function(K,e,D,T,R,L,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function m(I){return(0,P.uriToFsPath)(I,!0)}e.originalFSPath=m;class b{constructor(u){this._ignorePathCasing=u}compare(u,w,g=!1){return u===w?0:(0,k.compare)(this.getComparisonKey(u,g),this.getComparisonKey(w,g))}isEqual(u,w,g=!1){return u===w?!0:!u||!w?!1:this.getComparisonKey(u,g)===this.getComparisonKey(w,g)}getComparisonKey(u,w=!1){return u.with({path:this._ignorePathCasing(u)?u.path.toLowerCase():void 0,fragment:w?null:void 0}).toString()}ignorePathCasing(u){return this._ignorePathCasing(u)}isEqualOrParent(u,w,g=!1){if(u.scheme===w.scheme){if(u.scheme===T.Schemas.file)return D.isEqualOrParent(m(u),m(w),this._ignorePathCasing(u))&&u.query===w.query&&(g||u.fragment===w.fragment);if((0,e.isEqualAuthority)(u.authority,w.authority))return D.isEqualOrParent(u.path,w.path,this._ignorePathCasing(u),"/")&&u.query===w.query&&(g||u.fragment===w.fragment)}return!1}joinPath(u,...w){return P.URI.joinPath(u,...w)}basenameOrAuthority(u){return(0,e.basename)(u)||u.authority}basename(u){return R.posix.basename(u.path)}extname(u){return R.posix.extname(u.path)}dirname(u){if(u.path.length===0)return u;let w;return u.scheme===T.Schemas.file?w=P.URI.file(R.dirname(m(u))).path:(w=R.posix.dirname(u.path),u.authority&&w.length&&w.charCodeAt(0)!==47&&(console.error(`dirname("${u.toString})) resulted in a relative path`),w="/")),u.with({path:w})}normalizePath(u){if(!u.path.length)return u;let w;return u.scheme===T.Schemas.file?w=P.URI.file(R.normalize(m(u))).path:w=R.posix.normalize(u.path),u.with({path:w})}relativePath(u,w){if(u.scheme!==w.scheme||!(0,e.isEqualAuthority)(u.authority,w.authority))return;if(u.scheme===T.Schemas.file){const y=R.relative(m(u),m(w));return L.isWindows?D.toSlashes(y):y}let g=u.path||"/",E=w.path||"/";if(this._ignorePathCasing(u)){let y=0;for(const S=Math.min(g.length,E.length);y<S&&!(g.charCodeAt(y)!==E.charCodeAt(y)&&g.charAt(y).toLowerCase()!==E.charAt(y).toLowerCase());y++);g=E.substr(0,y)+g.substr(y)}return R.posix.relative(g,E)}resolvePath(u,w){if(u.scheme===T.Schemas.file){const g=P.URI.file(R.resolve(m(u),w));return u.with({authority:g.authority,path:g.path})}return w=D.toPosixPath(w),u.with({path:R.posix.resolve(u.path,w)})}isAbsolutePath(u){return!!u.path&&u.path[0]==="/"}isEqualAuthority(u,w){return u===w||(0,k.equalsIgnoreCase)(u,w)}hasTrailingPathSeparator(u,w=R.sep){if(u.scheme===T.Schemas.file){const g=m(u);return g.length>D.getRoot(g).length&&g[g.length-1]===w}else{const g=u.path;return g.length>1&&g.charCodeAt(g.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(u.fsPath)}}removeTrailingPathSeparator(u,w=R.sep){return(0,e.hasTrailingPathSeparator)(u,w)?u.with({path:u.path.substr(0,u.path.length-1)}):u}addTrailingPathSeparator(u,w=R.sep){let g=!1;if(u.scheme===T.Schemas.file){const E=m(u);g=E!==void 0&&E.length===D.getRoot(E).length&&E[E.length-1]===w}else{w="/";const E=u.path;g=E.length===1&&E.charCodeAt(E.length-1)===47}return!g&&!(0,e.hasTrailingPathSeparator)(u,w)?u.with({path:u.path+"/"}):u}}e.ExtUri=b,e.extUri=new b(()=>!1),e.extUriBiasedIgnorePathCase=new b(I=>I.scheme===T.Schemas.file?!L.isLinux:!0),e.extUriIgnorePathCase=new b(I=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function i(I,u){const w=[];for(let g=0;g<I.length;g++){const E=u(I[g]);I.some((y,S)=>S===g?!1:(0,e.isEqualOrParent)(E,u(y)))||w.push(I[g])}return w}e.distinctParents=i;var C;(function(I){I.META_DATA_LABEL="label",I.META_DATA_DESCRIPTION="description",I.META_DATA_SIZE="size",I.META_DATA_MIME="mime";function u(w){const g=new Map;w.path.substring(w.path.indexOf(";")+1,w.path.lastIndexOf(";")).split(";").forEach(S=>{const[o,a]=S.split(":");o&&a&&g.set(o,a)});const y=w.path.substring(0,w.path.indexOf(";"));return y&&g.set(I.META_DATA_MIME,y),g}I.parseMetaData=u})(C=e.DataUri||(e.DataUri={}));function f(I,u,w){if(u){let g=I.path;return g&&g[0]!==R.posix.sep&&(g=R.posix.sep+g),I.with({scheme:w,authority:u,path:g})}return I.with({scheme:w})}e.toLocalResource=f}),define(Z[6],ee([0,1,27,9,3,2,15]),function(K,e,D,T,R,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function P(q){return!!q&&typeof q.then=="function"}e.isThenable=P;function m(q){const z=new D.CancellationTokenSource,x=q(z.token),N=new Promise((W,_)=>{const Y=z.token.onCancellationRequested(()=>{Y.dispose(),z.dispose(),_((0,T.canceled)())});Promise.resolve(x).then(G=>{Y.dispose(),z.dispose(),W(G)},G=>{Y.dispose(),z.dispose(),_(G)})});return new class{cancel(){z.cancel()}then(W,_){return N.then(W,_)}catch(W){return this.then(void 0,W)}finally(W){return N.finally(W)}}}e.createCancelablePromise=m;function b(q,z,x){return Promise.race([q,new Promise(N=>z.onCancellationRequested(()=>N(x)))])}e.raceCancellation=b;async function i(q){let z=-1;const x=q.map((W,_)=>W.then(Y=>(z=_,Y))),N=await Promise.race(x);return q.forEach((W,_)=>{_!==z&&W.cancel()}),N}e.raceCancellablePromises=i;function C(q,z,x){let N;const W=setTimeout(()=>{N?.(void 0),x?.()},z);return Promise.race([q.finally(()=>clearTimeout(W)),new Promise(_=>N=_)])}e.raceTimeout=C;function f(q){return new Promise((z,x)=>{const N=q();P(N)?N.then(z,x):z(N)})}e.asPromise=f;class I{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(z){if(this.activePromise){if(this.queuedPromiseFactory=z,!this.queuedPromise){const x=()=>{this.queuedPromise=null;const N=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,N};this.queuedPromise=new Promise(N=>{this.activePromise.then(x,x).then(N)})}return new Promise((x,N)=>{this.queuedPromise.then(x,N)})}return this.activePromise=z(),new Promise((x,N)=>{this.activePromise.then(W=>{this.activePromise=null,x(W)},W=>{this.activePromise=null,N(W)})})}}e.Throttler=I;class u{constructor(){this.current=Promise.resolve(null)}queue(z){return this.current=this.current.then(()=>z(),()=>z())}}e.Sequencer=u;class w{constructor(){this.promiseMap=new Map}queue(z,x){const W=(this.promiseMap.get(z)??Promise.resolve()).catch(()=>{}).then(x).finally(()=>{this.promiseMap.get(z)===W&&this.promiseMap.delete(z)});return this.promiseMap.set(z,W),W}}e.SequencerByKey=w;class g{constructor(z){this.defaultDelay=z,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(z,x=this.defaultDelay){return this.task=z,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((N,W)=>{this.doResolve=N,this.doReject=W}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const N=this.task;return this.task=null,N()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},x),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,T.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=g;class E{constructor(z){this.delayer=new g(z),this.throttler=new I}trigger(z,x){return this.delayer.trigger(()=>this.throttler.queue(z),x)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=E;class y{constructor(){this._isOpen=!1,this._promise=new Promise((z,x)=>{this._completePromise=z})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=y;class S extends y{constructor(z){super();this._timeout=setTimeout(()=>this.open(),z)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=S;function o(q,z){return z?new Promise((x,N)=>{const W=setTimeout(()=>{_.dispose(),x()},q),_=z.onCancellationRequested(()=>{clearTimeout(W),_.dispose(),N((0,T.canceled)())})}):m(x=>o(q,x))}e.timeout=o;function a(q,z=0){const x=setTimeout(q,z);return(0,L.toDisposable)(()=>clearTimeout(x))}e.disposableTimeout=a;function t(q){const z=[];let x=0;const N=q.length;function W(){return x<N?q[x++]():null}function _(Y){Y!=null&&z.push(Y);const G=W();return G?G.then(_):Promise.resolve(z)}return Promise.resolve(null).then(_)}e.sequence=t;function s(q,z=N=>!!N,x=null){let N=0;const W=q.length,_=()=>{if(N>=W)return Promise.resolve(x);const Y=q[N++];return Promise.resolve(Y()).then(ne=>z(ne)?Promise.resolve(ne):_())};return _()}e.first=s;function n(q,z=N=>!!N,x=null){if(q.length===0)return Promise.resolve(x);let N=q.length;const W=()=>{N=-1;for(const _ of q)_.cancel?.()};return new Promise((_,Y)=>{for(const G of q)G.then(ne=>{--N>=0&&z(ne)?(W(),_(ne)):N===0&&_(x)}).catch(ne=>{--N>=0&&(W(),Y(ne))})})}e.firstParallel=n;class r{constructor(z){this._size=0,this.maxDegreeOfParalellism=z,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new R.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(z){return this._size++,new Promise((x,N)=>{this.outstandingPromises.push({factory:z,c:x,e:N}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const z=this.outstandingPromises.shift();this.runningPromises++;const x=z.factory();x.then(z.c,z.e),x.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=r;class c extends r{constructor(){super(1)}}e.Queue=c;class l{constructor(){this.queues=new Map}queueFor(z,x=k.extUri){const N=x.getComparisonKey(z);let W=this.queues.get(N);return W||(W=new c,R.Event.once(W.onFinished)(()=>{W?.dispose(),this.queues.delete(N)}),this.queues.set(N,W)),W}dispose(){this.queues.forEach(z=>z.dispose()),this.queues.clear()}}e.ResourceQueue=l;class h{constructor(z,x){this._token=-1,typeof z=="function"&&typeof x=="number"&&this.setIfNotSet(z,x)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(z,x){this.cancel(),this._token=setTimeout(()=>{this._token=-1,z()},x)}setIfNotSet(z,x){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,z()},x))}}e.TimeoutTimer=h;class d{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(z,x){this.cancel(),this._token=setInterval(()=>{z()},x)}}e.IntervalTimer=d;class v{constructor(z,x){this.timeoutToken=-1,this.runner=z,this.timeout=x,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(z=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,z)}get delay(){return this.timeout}set delay(z){this.timeout=z}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=v;class A{constructor(z,x){x%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${x}ms is not a multiple of 1000ms.`),this.runner=z,this.timeout=x,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(z=this.timeout){z%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${z}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(z/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=A;class O extends v{constructor(z,x){super(z,x);this.units=[]}work(z){this.units.push(z),this.isScheduled()||this.schedule()}doRun(){const z=this.units;this.units=[],this.runner&&this.runner(z)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=O;class p extends L.Disposable{constructor(z,x,N,W){super();this.maxWorkChunkSize=z,this.maxPendingWork=x,this.throttleDelay=N,this.handler=W,this.pendingWork=[],this.throttler=this._register(new L.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(z){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+z.length>this.maxPendingWork)return!1}else if(this.pending+z.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...z),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new v(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=p,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const q=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=z=>{const x=setTimeout(()=>z(q));let N=!1;return{dispose(){N||(N=!0,clearTimeout(x))}}}}else e.runWhenIdle=(q,z)=>{const x=requestIdleCallback(q,typeof z=="number"?{timeout:z}:void 0);let N=!1;return{dispose(){N||(N=!0,cancelIdleCallback(x))}}}}();class U{constructor(z){this._didRun=!1,this._executor=()=>{try{this._value=z()}catch(x){this._error=x}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=U;async function F(q,z,x){let N;for(let W=0;W<x;W++)try{return await q()}catch(_){N=_,await o(z)}throw N}e.retry=F;class ${hasPending(z){return this._pending?typeof z=="number"?this._pending.taskId===z:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(z,x,N){return this._pending={taskId:z,cancel:()=>N?.(),promise:x},x.then(()=>this.donePending(z),()=>this.donePending(z)),x}donePending(z){this._pending&&z===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const z=this._next;this._next=void 0,z.run().then(z.promiseResolve,z.promiseReject)}}setNext(z){if(this._next)this._next.run=z;else{let x,N;const W=new Promise((_,Y)=>{x=_,N=Y});this._next={run:z,promise:W,promiseResolve:x,promiseReject:N}}return this._next.promise}}e.TaskSequentializer=$;class H{constructor(z){this.interval=z,this.lastIncrementTime=0,this.value=0}increment(){const z=Date.now();return z-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=z,this.value=0),this.value++,this.value}}e.IntervalCounter=H;class M{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((z,x)=>{this.completeCallback=z,this.errorCallback=x})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(z){return new Promise(x=>{this.completeCallback(z),this.resolved=!0,x()})}error(z){return new Promise(x=>{this.errorCallback(z),this.rejected=!0,x()})}cancel(){new Promise(z=>{this.errorCallback((0,T.canceled)()),this.rejected=!0,z()})}}e.DeferredPromise=M;var j;(function(q){async function z(x){let N;const W=await Promise.all(x.map(_=>_.then(Y=>Y,Y=>{N||(N=Y)})));if(typeof N!="undefined")throw N;return W}q.settled=z})(j=e.Promises||(e.Promises={}))}),define(Z[67],ee([0,1,6,39,40,8,24]),function(K,e,D,T,R,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function P(){return Object.create(null)}e.getEmptyExpression=P;const m="**",b="/",i="[/\\\\]",C="[^/\\\\]",f=/\//g;function I(N){switch(N){case 0:return"";case 1:return`${C}*?`;default:return`(?:${i}|${C}+${i}|${i}${C}+)*?`}}function u(N,W){if(!N)return[];const _=[];let Y=!1,G=!1,ne="";for(const te of N){switch(te){case W:if(!Y&&!G){_.push(ne),ne="";continue}break;case"{":Y=!0;break;case"}":Y=!1;break;case"[":G=!0;break;case"]":G=!1;break}ne+=te}return ne&&_.push(ne),_}e.splitGlobAware=u;function w(N){if(!N)return"";let W="";const _=u(N,b);if(_.every(Y=>Y===m))W=".*";else{let Y=!1;_.forEach((G,ne)=>{if(G===m){Y||(W+=I(2),Y=!0);return}let te=!1,J="",V=!1,re="";for(const ie of G){if(ie!=="}"&&te){J+=ie;continue}if(V&&(ie!=="]"||!re)){let ce;ie==="-"?ce=ie:(ie==="^"||ie==="!")&&!re?ce="^":ie===b?ce="":ce=k.escapeRegExpCharacters(ie),re+=ce;continue}switch(ie){case"{":te=!0;continue;case"[":V=!0;continue;case"}":W+=`(?:${u(J,",").map(ye=>w(ye)).join("|")})`,te=!1,J="";break;case"]":W+="["+re+"]",V=!1,re="";break;case"?":W+=C;continue;case"*":W+=I(1);continue;default:W+=k.escapeRegExpCharacters(ie)}}ne<_.length-1&&(_[ne+1]!==m||ne+2<_.length)&&(W+=i),Y=!1})}return W}const g=/^\*\*\/\*\.[\w\.-]+$/,E=/^\*\*\/([\w\.-]+)\/?$/,y=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,S=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,o=/^\*\*((\/[\w\.-]+)+)\/?$/,a=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new R.LRUCache(1e4),s=function(){return!1},n=function(){return null};function r(N,W){if(!N)return n;let _;typeof N!="string"?_=N.pattern:_=N,_=_.trim();const Y=`${_}_${!!W.trimForExclusions}`;let G=t.get(Y);if(G)return c(G,N);let ne;if(g.test(_)){const te=_.substr(4);G=function(J,V){return typeof J=="string"&&J.endsWith(te)?_:null}}else(ne=E.exec(l(_,W)))?G=h(ne[1],_):(W.trimForExclusions?S:y).test(_)?G=d(_,W):(ne=o.exec(l(_,W)))?G=v(ne[1].substr(1),_,!0):(ne=a.exec(l(_,W)))?G=v(ne[1],_,!1):G=A(_);return t.set(Y,G),c(G,N)}function c(N,W){return typeof W=="string"?N:function(_,Y){return T.isEqualOrParent(_,W.base)?N(L.relative(W.base,_),Y):null}}function l(N,W){return W.trimForExclusions&&N.endsWith("/**")?N.substr(0,N.length-2):N}function h(N,W){const _=`/${N}`,Y=`\\${N}`,G=function(te,J){return typeof te!="string"?null:J?J===N?W:null:te===N||te.endsWith(_)||te.endsWith(Y)?W:null},ne=[N];return G.basenames=ne,G.patterns=[W],G.allBasenames=ne,G}function d(N,W){const _=x(N.slice(1,-1).split(",").map(J=>r(J,W)).filter(J=>J!==n),N),Y=_.length;if(!Y)return n;if(Y===1)return _[0];const G=function(J,V){for(let re=0,ie=_.length;re<ie;re++)if(_[re](J,V))return N;return null},ne=_.find(J=>!!J.allBasenames);ne&&(G.allBasenames=ne.allBasenames);const te=_.reduce((J,V)=>V.allPaths?J.concat(V.allPaths):J,[]);return te.length&&(G.allPaths=te),G}function v(N,W,_){const Y=L.sep===L.posix.sep,G=Y?N:N.replace(f,L.sep),ne=L.sep+G,te=L.posix.sep+N,J=_?function(V,re){return typeof V=="string"&&(V===G||V.endsWith(ne)||!Y&&(V===N||V.endsWith(te)))?W:null}:function(V,re){return typeof V=="string"&&(V===G||!Y&&V===N)?W:null};return J.allPaths=[(_?"*/":"./")+N],J}function A(N){try{const W=new RegExp(`^${w(N)}$`);return function(_){return W.lastIndex=0,typeof _=="string"&&W.test(_)?N:null}}catch(W){return n}}function O(N,W,_){return!N||typeof W!="string"?!1:p(N)(W,void 0,_)}e.match=O;function p(N,W={}){if(!N)return s;if(typeof N=="string"||H(N)){const _=r(N,W);if(_===n)return s;const Y=function(G,ne){return!!_(G,ne)};return _.allBasenames&&(Y.allBasenames=_.allBasenames),_.allPaths&&(Y.allPaths=_.allPaths),Y}return q(N,W)}e.parse=p;function U(N){if(!N)return;let W;return _=>(W||(W=(N()||Promise.resolve([])).then(Y=>Y?$(Y):{})),W.then(Y=>!!Y[_]))}e.hasSiblingPromiseFn=U;function F(N){if(!N)return;let W;return _=>{if(!W){const Y=N();W=Y?$(Y):{}}return!!W[_]}}e.hasSiblingFn=F;function $(N){const W={};for(const _ of N)W[_]=!0;return W}function H(N){const W=N;return W&&typeof W.base=="string"&&typeof W.pattern=="string"}e.isRelativePattern=H;function M(N){return N.allBasenames||[]}e.getBasenameTerms=M;function j(N){return N.allPaths||[]}e.getPathTerms=j;function q(N,W){const _=x(Object.getOwnPropertyNames(N).map(J=>z(J,N[J],W)).filter(J=>J!==n)),Y=_.length;if(!Y)return n;if(!_.some(J=>!!J.requiresSiblings)){if(Y===1)return _[0];const J=function(ie,ce){for(let ue=0,ye=_.length;ue<ye;ue++){const ge=_[ue](ie,ce);if(ge)return ge}return null},V=_.find(ie=>!!ie.allBasenames);V&&(J.allBasenames=V.allBasenames);const re=_.reduce((ie,ce)=>ce.allPaths?ie.concat(ce.allPaths):ie,[]);return re.length&&(J.allPaths=re),J}const G=function(J,V,re){let ie;for(let ce=0,ue=_.length;ce<ue;ce++){const ye=_[ce];ye.requiresSiblings&&re&&(V||(V=L.basename(J)),ie||(ie=V.substr(0,V.length-L.extname(J).length)));const ge=ye(J,V,ie,re);if(ge)return ge}return null},ne=_.find(J=>!!J.allBasenames);ne&&(G.allBasenames=ne.allBasenames);const te=_.reduce((J,V)=>V.allPaths?J.concat(V.allPaths):J,[]);return te.length&&(G.allPaths=te),G}function z(N,W,_){if(W===!1)return n;const Y=r(N,_);if(Y===n)return n;if(typeof W=="boolean")return Y;if(W){const G=W.when;if(typeof G=="string"){const ne=(te,J,V,re)=>{if(!re||!Y(te,J))return null;const ie=G.replace("$(basename)",V),ce=re(ie);return(0,D.isThenable)(ce)?ce.then(ue=>ue?N:null):ce?N:null};return ne.requiresSiblings=!0,ne}}return Y}function x(N,W){const _=N.filter(J=>!!J.basenames);if(_.length<2)return N;const Y=_.reduce((J,V)=>{const re=V.basenames;return re?J.concat(re):J},[]);let G;if(W){G=[];for(let J=0,V=Y.length;J<V;J++)G.push(W)}else G=_.reduce((J,V)=>{const re=V.patterns;return re?J.concat(re):J},[]);const ne=function(J,V){if(typeof J!="string")return null;if(!V){let ie;for(ie=J.length;ie>0;ie--){const ce=J.charCodeAt(ie-1);if(ce===47||ce===92)break}V=J.substr(ie)}const re=Y.indexOf(V);return re!==-1?G[re]:null};ne.basenames=Y,ne.patterns=G,ne.allBasenames=Y;const te=N.filter(J=>!J.basenames);return te.push(ne),te}}),define(Z[95],ee([0,1,67,18,8,15,24]),function(K,e,D,T,R,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var P;(function(r){r.text="text/plain",r.binary="application/octet-stream",r.unknown="application/unknown",r.markdown="text/markdown"})(P=e.Mimes||(e.Mimes={}));let m=[],b=[],i=[];function C(r,c=!1){const l=f(r);m.push(l),l.userConfigured?i.push(l):b.push(l),c&&!l.userConfigured&&m.forEach(h=>{h.mime===l.mime||h.userConfigured||(l.extension&&h.extension===l.extension&&console.warn(`Overwriting extension <<${l.extension}>> to now point to mime <<${l.mime}>>`),l.filename&&h.filename===l.filename&&console.warn(`Overwriting filename <<${l.filename}>> to now point to mime <<${l.mime}>>`),l.filepattern&&h.filepattern===l.filepattern&&console.warn(`Overwriting filepattern <<${l.filepattern}>> to now point to mime <<${l.mime}>>`),l.firstline&&h.firstline===l.firstline&&console.warn(`Overwriting firstline <<${l.firstline}>> to now point to mime <<${l.mime}>>`))})}e.registerTextMime=C;function f(r){return{id:r.id,mime:r.mime,filename:r.filename,extension:r.extension,filepattern:r.filepattern,firstline:r.firstline,userConfigured:r.userConfigured,filenameLowercase:r.filename?r.filename.toLowerCase():void 0,extensionLowercase:r.extension?r.extension.toLowerCase():void 0,filepatternLowercase:r.filepattern?(0,D.parse)(r.filepattern.toLowerCase()):void 0,filepatternOnPath:r.filepattern?r.filepattern.indexOf(R.posix.sep)>=0:!1}}function I(r){r?(m=m.filter(c=>!c.userConfigured),i=[]):(m=[],b=[],i=[])}e.clearTextMimes=I;function u(r,c){let l;if(r)switch(r.scheme){case T.Schemas.file:l=r.fsPath;break;case T.Schemas.data:l=L.DataUri.parseMetaData(r).get(L.DataUri.META_DATA_LABEL);break;default:l=r.path}if(!l)return[P.unknown];l=l.toLowerCase();const h=(0,R.basename)(l),d=w(l,h,i);if(d)return[d,P.text];const v=w(l,h,b);if(v)return[v,P.text];if(c){const A=g(c);if(A)return[A,P.text]}return[P.unknown]}e.guessMimeTypes=u;function w(r,c,l){let h=null,d=null,v=null;for(let A=l.length-1;A>=0;A--){const O=l[A];if(c===O.filenameLowercase){h=O;break}if(O.filepattern&&(!d||O.filepattern.length>d.filepattern.length)){const p=O.filepatternOnPath?r:c;O.filepatternLowercase?.(p)&&(d=O)}O.extension&&(!v||O.extension.length>v.extension.length)&&c.endsWith(O.extensionLowercase)&&(v=O)}return h?h.mime:d?d.mime:v?v.mime:null}function g(r){if((0,k.startsWithUTF8BOM)(r)&&(r=r.substr(1)),r.length>0)for(let c=m.length-1;c>=0;c--){const l=m[c];if(!l.firstline)continue;const h=r.match(l.firstline);if(h&&h.length>0)return l.mime}return null}function E(r){return r?typeof r=="string"?r===P.binary||r===P.text||r===P.unknown:r.length===1&&E(r[0]):!0}e.isUnspecific=E;const y={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},S={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function o(r){const c=(0,R.extname)(r),l=y[c.toLowerCase()];return l!==void 0?l:a(r)}e.getMediaOrTextMime=o;function a(r){const c=(0,R.extname)(r);return S[c.toLowerCase()]}e.getMediaMime=a;function t(r){for(const c in S)if(S[c]===r)return c}e.getExtensionForMimeType=t;const s=/^(.+)\/(.+?)(;.+)?$/;function n(r,c){const l=s.exec(r);return l?`${l[1].toLowerCase()}/${l[2].toLowerCase()}${l[3]??""}`:c?void 0:r}e.normalizeMimeType=n}),define(Z[96],ee([0,1,5]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function T(i){return i.toJSON()}class R{constructor(C){this._uriTransformer=C}transformIncoming(C){const f=this._uriTransformer.transformIncoming(C);return f===C?C:T(D.URI.from(f))}transformOutgoing(C){const f=this._uriTransformer.transformOutgoing(C);return f===C?C:T(D.URI.from(f))}transformOutgoingURI(C){const f=this._uriTransformer.transformOutgoing(C);return f===C?C:D.URI.from(f)}transformOutgoingScheme(C){return this._uriTransformer.transformOutgoingScheme(C)}}e.URITransformer=R,e.DefaultURITransformer=new class{transformIncoming(i){return i}transformOutgoing(i){return i}transformOutgoingURI(i){return i}transformOutgoingScheme(i){return i}};function L(i,C,f){if(!i||f>200)return null;if(typeof i=="object"){if(i instanceof D.URI)return C.transformOutgoing(i);for(let I in i)if(Object.hasOwnProperty.call(i,I)){const u=L(i[I],C,f+1);u!==null&&(i[I]=u)}}return null}function k(i,C){const f=L(i,C,0);return f===null?i:f}e.transformOutgoingURIs=k;function P(i,C,f,I){if(!i||I>200)return null;if(typeof i=="object"){if(i.$mid===1)return f?D.URI.revive(C.transformIncoming(i)):C.transformIncoming(i);for(let u in i)if(Object.hasOwnProperty.call(i,u)){const w=P(i[u],C,f,I+1);w!==null&&(i[u]=w)}}return null}function m(i,C){const f=P(i,C,!1,0);return f===null?i:f}e.transformIncomingURIs=m;function b(i,C){const f=P(i,C,!0,0);return f===null?i:f}e.transformAndReviveIncomingURIs=b}),define(Z[30],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const D=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function T(m){return D.test(m)}e.isUUID=T;const R=new Uint8Array(16),L=[];for(let m=0;m<256;m++)L.push(m.toString(16).padStart(2,"0"));let k;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?k=crypto.getRandomValues.bind(crypto):k=function(m){for(let b=0;b<m.length;b++)m[b]=Math.floor(Math.random()*256);return m};function P(){k(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let m=0,b="";return b+=L[R[m++]],b+=L[R[m++]],b+=L[R[m++]],b+=L[R[m++]],b+="-",b+=L[R[m++]],b+=L[R[m++]],b+="-",b+=L[R[m++]],b+=L[R[m++]],b+="-",b+=L[R[m++]],b+=L[R[m++]],b+="-",b+=L[R[m++]],b+=L[R[m++]],b+=L[R[m++]],b+=L[R[m++]],b+=L[R[m++]],b+=L[R[m++]],b}e.generateUuid=P}),define(Z[68],ee([0,1,218]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class T{constructor(L="utf8"){this.stringDecoder=new D.StringDecoder(L),this.remaining=null}write(L){const k=[],P=this.remaining?this.remaining+this.stringDecoder.write(L):this.stringDecoder.write(L);if(P.length<1)return k;let m=0,b,i=m;for(;i<P.length;)if(b=P.charCodeAt(i),b===13||b===10){if(k.push(P.substring(m,i)),i++,i<P.length){const C=b;b=P.charCodeAt(i),(C===13&&b===10||C===10&&b===13)&&i++}m=i}else i++;return this.remaining=m<P.length?P.substr(m):null,k}end(){return this.remaining}}e.LineDecoder=T}),define(Z[97],ee([0,1,35]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const T=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function R(P){const m=P.replace(/\-/g,":").toLowerCase();return!T.has(m)}function L(){return new Promise(async(P,m)=>{const b=setTimeout(()=>m("Unable to retrieve mac address (timeout after 10s)"),1e4);try{P(await k())}catch(i){m(i)}finally{clearTimeout(b)}})}e.getMac=L;function k(){return new Promise((P,m)=>{try{const b=(0,D.networkInterfaces)();for(let i in b){const C=b[i];if(C){for(const{mac:f}of C)if(R(f))return P(f)}}m("Unable to retrieve mac address (unexpected format)")}catch(b){m(b)}})}}),define(Z[98],ee([0,1,35,9,40,30,97]),function(K,e,D,T,R,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(i){return this._virtualMachineOUIs||(this._virtualMachineOUIs=R.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(i)}value(){if(this._value===void 0){let i=0,C=0;const f=(0,D.networkInterfaces)();for(let I in f){const u=f[I];if(u)for(const{mac:w,internal:g}of u)g||(C+=1,this._isVirtualMachineMacAddress(w.toUpperCase())&&(i+=1))}this._value=C>0?i/C:0}return this._value}};let P;async function m(){return P||(P=(async()=>await b()||L.generateUuid())()),P}e.getMachineId=m;async function b(){try{const i=await new Promise((f,I)=>{K(["crypto"],f,I)}),C=await(0,k.getMac)();return i.createHash("sha256").update(C,"utf8").digest("hex")}catch(i){T.onUnexpectedError(i);return}}}),define(Z[19],ee([0,1,51,35,219,6,39,66,8,4,15,5,30]),function(K,e,D,T,R,L,k,P,m,b,i,C,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var I;(function(M){M[M.UNLINK=0]="UNLINK",M[M.MOVE=1]="MOVE"})(I=e.RimRafMode||(e.RimRafMode={}));async function u(M,j=I.UNLINK){if((0,k.isRootOrDriveLetter)(M))throw new Error("rimraf - will refuse to recursively delete root");return j===I.UNLINK?g(M):w(M)}async function w(M){try{const j=(0,m.join)((0,T.tmpdir)(),(0,f.generateUuid)());try{await e.Promises.rename(M,j)}catch(q){return g(M)}g(j).catch(q=>{})}catch(j){if(j.code!=="ENOENT")throw j}}async function g(M){return e.Promises.rmdir(M,{recursive:!0,maxRetries:3})}function E(M){if((0,k.isRootOrDriveLetter)(M))throw new Error("rimraf - will refuse to recursively delete root");D.rmdirSync(M,{recursive:!0})}e.rimrafSync=E;async function y(M,j){return a(await(j?S(M):(0,R.promisify)(D.readdir)(M)))}async function S(M){try{return await(0,R.promisify)(D.readdir)(M,{withFileTypes:!0})}catch(z){console.warn("[node.js fs] readdir with filetypes failed with error: ",z)}const j=[],q=await y(M);for(const z of q){let x=!1,N=!1,W=!1;try{const _=await e.Promises.lstat((0,m.join)(M,z));x=_.isFile(),N=_.isDirectory(),W=_.isSymbolicLink()}catch(_){console.warn("[node.js fs] unexpected error from lstat after readdir: ",_)}j.push({name:z,isFile:()=>x,isDirectory:()=>N,isSymbolicLink:()=>W})}return j}function o(M){return a(D.readdirSync(M))}e.readdirSync=o;function a(M){return M.map(j=>typeof j=="string"?b.isMacintosh?(0,P.normalizeNFC)(j):j:(j.name=b.isMacintosh?(0,P.normalizeNFC)(j.name):j.name,j))}async function t(M){const j=await y(M),q=[];for(const z of j)await n.existsDirectory((0,m.join)(M,z))&&q.push(z);return q}function s(M,j=1e3){return new Promise(q=>{let z=!1;const x=setInterval(()=>{z||(z=!0,D.access(M,N=>{z=!1,N&&(clearInterval(x),q(void 0))}))},j)})}e.whenDeleted=s;var n;(function(M){async function j(x){let N;try{if(N=await e.Promises.lstat(x),!N.isSymbolicLink())return{stat:N}}catch(W){}try{return{stat:await e.Promises.stat(x),symbolicLink:N?.isSymbolicLink()?{dangling:!1}:void 0}}catch(W){if(W.code==="ENOENT"&&N)return{stat:N,symbolicLink:{dangling:!0}};if(b.isWindows&&W.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(x)),symbolicLink:{dangling:!1}}}catch(_){if(_.code==="ENOENT"&&N)return{stat:N,symbolicLink:{dangling:!0}};throw _}throw W}}M.stat=j;async function q(x){try{const{stat:N,symbolicLink:W}=await M.stat(x);return N.isFile()&&W?.dangling!==!0}catch(N){}return!1}M.existsFile=q;async function z(x){try{const{stat:N,symbolicLink:W}=await M.stat(x);return N.isDirectory()&&W?.dangling!==!0}catch(N){}return!1}M.existsDirectory=z})(n=e.SymlinkSupport||(e.SymlinkSupport={}));const r=new L.ResourceQueue;function c(M,j,q){return r.queueFor(C.URI.file(M),i.extUriBiasedIgnorePathCase).queue(()=>{const z=v(q);return new Promise((x,N)=>h(M,j,z,W=>W?N(W):x()))})}let l=!0;function h(M,j,q,z){if(!l)return D.writeFile(M,j,{mode:q.mode,flag:q.flag},z);D.open(M,q.flag,q.mode,(x,N)=>{if(x)return z(x);D.writeFile(N,j,W=>{if(W)return D.close(N,()=>z(W));D.fdatasync(N,_=>(_&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",_),l=!1),D.close(N,Y=>z(Y))))})})}function d(M,j,q){const z=v(q);if(!l)return D.writeFileSync(M,j,{mode:z.mode,flag:z.flag});const x=D.openSync(M,z.flag,z.mode);try{D.writeFileSync(x,j);try{D.fdatasyncSync(x)}catch(N){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",N),l=!1}}finally{D.closeSync(x)}}e.writeFileSync=d;function v(M){return M?{mode:typeof M.mode=="number"?M.mode:438,flag:typeof M.flag=="string"?M.flag:"w"}:{mode:438,flag:"w"}}async function A(M,j){if(M===j)return;async function q(z){try{const x=await e.Promises.lstat(z);if(x.isDirectory()||x.isSymbolicLink())return;await e.Promises.utimes(z,x.atime,new Date)}catch(x){}}try{await e.Promises.rename(M,j),await q(j)}catch(z){if(M.toLowerCase()!==j.toLowerCase()&&z.code==="EXDEV"||M.endsWith("."))await O(M,j,{preserveSymlinks:!1}),await u(M,I.MOVE),await q(j);else throw z}}async function O(M,j,q){return U(M,j,{root:{source:M,target:j},options:q,handledSourcePaths:new Set})}const p=511;async function U(M,j,q){if(q.handledSourcePaths.has(M))return;q.handledSourcePaths.add(M);const{stat:z,symbolicLink:x}=await n.stat(M);if(x){if(q.options.preserveSymlinks)try{return await H(M,j,q)}catch(N){console.warn("[node.js fs] copy of symlink failed: ",N)}if(x.dangling)return}return z.isDirectory()?F(M,j,z.mode&p,q):$(M,j,z.mode&p)}async function F(M,j,q,z){await e.Promises.mkdir(j,{recursive:!0,mode:q});const x=await y(M);for(const N of x)await U((0,m.join)(M,N),(0,m.join)(j,N),z)}async function $(M,j,q){await e.Promises.copyFile(M,j),await e.Promises.chmod(j,q)}async function H(M,j,q){let z=await e.Promises.readlink(M);(0,k.isEqualOrParent)(z,q.root.source,!b.isLinux)&&(z=(0,m.join)(q.root.target,z.substr(q.root.source.length+1))),await e.Promises.symlink(z,j)}e.Promises=new class{get access(){return(0,R.promisify)(D.access)}get stat(){return(0,R.promisify)(D.stat)}get lstat(){return(0,R.promisify)(D.lstat)}get utimes(){return(0,R.promisify)(D.utimes)}get read(){return(0,R.promisify)(D.read)}get readFile(){return(0,R.promisify)(D.readFile)}get write(){return(0,R.promisify)(D.write)}get appendFile(){return(0,R.promisify)(D.appendFile)}get fdatasync(){return(0,R.promisify)(D.fdatasync)}get truncate(){return(0,R.promisify)(D.truncate)}get rename(){return(0,R.promisify)(D.rename)}get copyFile(){return(0,R.promisify)(D.copyFile)}get open(){return(0,R.promisify)(D.open)}get close(){return(0,R.promisify)(D.close)}get symlink(){return(0,R.promisify)(D.symlink)}get readlink(){return(0,R.promisify)(D.readlink)}get chmod(){return(0,R.promisify)(D.chmod)}get mkdir(){return(0,R.promisify)(D.mkdir)}get unlink(){return(0,R.promisify)(D.unlink)}get rmdir(){return(0,R.promisify)(D.rmdir)}get realpath(){return(0,R.promisify)(D.realpath)}async exists(M){try{return await e.Promises.access(M),!0}catch{return!1}}get readdir(){return y}get readDirsInDir(){return t}get writeFile(){return c}get rm(){return u}get move(){return A}get copy(){return O}}}),define(Z[99],ee([0,1,51,8,24,19]),function(K,e,D,T,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function k(i){const C=(0,T.dirname)(i);if(i===C)return i;const f=((0,T.basename)(i)||i).toLowerCase();try{const u=(0,L.readdirSync)(C).filter(w=>w.toLowerCase()===f);if(u.length===1){const w=k(C);if(w)return(0,T.join)(w,u[0])}else if(u.length>1){const w=u.indexOf(f);if(w>=0){const g=k(C);if(g)return(0,T.join)(g,u[w])}}}catch(I){}return null}e.realcaseSync=k;async function P(i){try{return await L.Promises.realpath(i)}catch(C){const f=b(i);return await L.Promises.access(f,D.constants.R_OK),f}}e.realpath=P;function m(i){try{return D.realpathSync(i)}catch(C){const f=b(i);return D.accessSync(f,D.constants.R_OK),f}}e.realpathSync=m;function b(i){return(0,R.rtrim)((0,T.normalize)(i),T.sep)}}),define(Z[69],ee([0,1,35,8,19]),function(K,e,D,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const L=/^\d+$/,k=/^Microsoft.PowerShell_.*/,P=/^Microsoft.PowerShellPreview_.*/;var m;(function(o){o[o.x64=0]="x64",o[o.x86=1]="x86",o[o.ARM=2]="ARM"})(m||(m={}));let b;switch(process.arch){case"ia32":case"x32":b=1;break;case"arm":case"arm64":b=2;break;default:b=0;break}let i;process.env.PROCESSOR_ARCHITEW6432?i=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?i=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?i=1:i=0;class C{constructor(a,t,s){this.exePath=a,this.displayName=t,this.knownToExist=s}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await R.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function f({useAlternateBitness:o=!1}={}){return o?b===0?process.env["ProgramFiles(x86)"]||null:i===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function I({useAlternateBitness:o=!1,findPreview:a=!1}={}){const t=f({useAlternateBitness:o});if(!t)return null;const s=T.join(t,"PowerShell");if(!await R.SymlinkSupport.existsDirectory(s))return null;let n=-1,r=null;for(const h of await R.Promises.readdir(s)){let d=-1;if(a){const A=h.indexOf("-");if(A<0)continue;const O=h.substring(0,A);if(!L.test(O)||h.substring(A+1)!=="preview")continue;d=parseInt(O,10)}else{if(!L.test(h))continue;d=parseInt(h,10)}if(d<=n)continue;const v=T.join(s,h,"pwsh.exe");!await R.SymlinkSupport.existsFile(v)||(r=v,n=d)}if(!r)return null;const c=t.includes("x86")?" (x86)":"",l=a?" Preview":"";return new C(r,`PowerShell${l}${c}`,!0)}async function u({findPreview:o}={}){if(!process.env.LOCALAPPDATA)return null;const a=T.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await R.SymlinkSupport.existsDirectory(a))return null;const{pwshMsixDirRegex:t,pwshMsixName:s}=o?{pwshMsixDirRegex:P,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:k,pwshMsixName:"PowerShell (Store)"};for(const n of await R.Promises.readdir(a))if(t.test(n)){const r=T.join(a,n,"pwsh.exe");return new C(r,s)}return null}function w(){const o=T.join(D.homedir(),".dotnet","tools","pwsh.exe");return new C(o,".NET Core PowerShell Global Tool")}function g(){const o=T.join(process.env.windir,b===1&&i!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new C(o,"Windows PowerShell",!0)}async function*E(){let o=await I();o&&(yield o),o=await I({useAlternateBitness:!0}),o&&(yield o),o=await u(),o&&(yield o),o=w(),o&&(yield o),o=await I({findPreview:!0}),o&&(yield o),o=await u({findPreview:!0}),o&&(yield o),o=await I({useAlternateBitness:!0,findPreview:!0}),o&&(yield o),o=g(),o&&(yield o)}async function*y(){for await(const o of E())await o.exists()&&(yield o)}e.enumeratePowerShellInstallations=y;async function S(){for await(const o of y())return o;return null}e.getFirstAvailablePowerShellInstallation=S}),define(Z[100],ee([0,1,41,18]),function(K,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function R(k){return new Promise((P,m)=>{let b;const i=new Map;function C(I,u,w,g,E){const y=i.get(u);if(I===k||y){const S={name:f(w),cmd:w,pid:I,ppid:u,load:g,mem:E};i.set(I,S),I===k&&(b=S),y&&(y.children||(y.children=[]),y.children.push(S),y.children.length>1&&(y.children=y.children.sort((o,a)=>o.pid-a.pid)))}}function f(I){const u=/--disable-blink-features=Auxclick/,w=/\\watcher\\win32\\CodeHelper\.exe/,g=/--crashes-directory/,E=/\\pipe\\winpty-control/,y=/conhost\.exe/,S=/--type=([a-zA-Z-]+)/;if(w.exec(I))return"watcherService ";if(g.exec(I))return"electron-crash-reporter";if(E.exec(I))return"winpty-process";if(y.exec(I))return"console-window-host (Windows internal process)";let o=S.exec(I);if(o&&o.length===2)return o[1]==="renderer"?u.exec(I)?"shared-process":"window":o[1];const a=/[a-zA-Z-]+\.js/g;let t="";do o=a.exec(I),o&&(t+=o+" ");while(o);return t&&I.indexOf("node ")<0&&I.indexOf("node.exe")<0?`electron_node ${t}`:I}if(process.platform==="win32"){const I=u=>u.indexOf("\\\\?\\")===0||u.indexOf("\\??\\")===0?u.substr(4):u.indexOf('"\\\\?\\')===0||u.indexOf('"\\??\\')===0?'"'+u.substr(5):u;new Promise((u,w)=>{K(["windows-process-tree"],u,w)}).then(u=>{u.getProcessList(k,w=>{u.getProcessCpuUsage(w,g=>{const E=new Map;g.forEach(y=>{const S=I(y.commandLine||"");E.set(y.pid,{name:f(S),cmd:S,pid:y.pid,ppid:y.ppid,load:y.cpu||0,mem:y.memory||0})}),b=E.get(k),b?(E.forEach(y=>{const S=E.get(y.ppid);S&&(S.children||(S.children=[]),S.children.push(y))}),E.forEach(y=>{y.children&&(y.children=y.children.sort((S,o)=>S.pid-o.pid))}),P(b)):m(new Error(`Root process ${k} not found`))})},u.ProcessDataFlag.CommandLine|u.ProcessDataFlag.Memory)})}else{let I=function(){let u=[b];const w=[];for(;u.length;){const E=u.shift();E&&(w.push(E.pid),E.children&&(u=u.concat(E.children)))}let g=JSON.stringify(T.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",K).fsPath);g+=" "+w.join(" "),(0,D.exec)(g,{},(E,y,S)=>{if(E||S)m(E||new Error(S.toString()));else{const o=y.toString().split(`
`);for(let a=0;a<w.length;a++){const t=i.get(w[a]);t.load=parseFloat(o[a])}if(!b){m(new Error(`Root process ${k} not found`));return}P(b)}})};(0,D.exec)("which ps",{},(u,w,g)=>{if(u||g)if(process.platform!=="linux")m(u||new Error(g.toString()));else{const E=JSON.stringify(T.FileAccess.asFileUri("vs/base/node/ps.sh",K).fsPath);(0,D.exec)(E,{},(y,S,o)=>{y||o?m(y||new Error(o.toString())):(L(S,C),I())})}else{const E=w.toString().trim(),y="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,D.exec)(`${E} ${y}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(S,o,a)=>{S||a&&!a.includes("screen size is bogus")?m(S||new Error(a.toString())):(L(o,C),process.platform==="linux"?I():b?P(b):m(new Error(`Root process ${k} not found`)))})}})}})}e.listProcesses=R;function L(k,P){const m=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,b=k.toString().split(`
`);for(const i of b){const C=m.exec(i.trim());C&&C.length===6&&P(parseInt(C[1]),parseInt(C[2]),C[5],parseFloat(C[3]),parseFloat(C[4]))}}}),define(Z[101],ee([0,1,51,27,39,2,66,8,4,19]),function(K,e,D,T,R,L,k,P,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.CHANGE_BUFFER_DELAY=e.watchFolder=e.watchFile=void 0;function i(u,w,g){return f({path:u,isDirectory:!1},w,g)}e.watchFile=i;function C(u,w,g){return f({path:u,isDirectory:!0},w,g)}e.watchFolder=C,e.CHANGE_BUFFER_DELAY=100;function f(u,w,g){if(m.isMacintosh&&(0,R.isEqualOrParent)(u.path,"/Volumes/"))return g(`Refusing to watch ${u.path} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),L.Disposable.None;const E=(0,P.basename)(u.path),y=new Map;let S=!1,o=[(0,L.toDisposable)(()=>{y.forEach(a=>(0,L.dispose)(a)),y.clear()})];try{const a=(0,D.watch)(u.path);o.push((0,L.toDisposable)(()=>{a.removeAllListeners(),a.close()}));const t=new Set;u.isDirectory&&b.Promises.readdir(u.path).then(s=>s.forEach(n=>t.add(n))),a.on("error",(s,n)=>{S||g(`Failed to watch ${u.path} for changes using fs.watch() (${s}, ${n})`)}),a.on("change",(s,n)=>{if(S)return;let r="";if(n&&(r=n.toString(),m.isMacintosh&&(r=(0,k.normalizeNFC)(r))),!r||s!=="change"&&s!=="rename")return;const c=u.isDirectory?(0,P.join)(u.path,r):u.path;if(u.isDirectory)if(s==="rename"){const l=y.get(c);l&&(0,L.dispose)(l);const h=setTimeout(async()=>{y.delete(c);const d=await b.Promises.exists(c);if(S)return;let v;d?t.has(r)?v="changed":(v="added",t.add(r)):(t.delete(r),v="deleted"),w(v,c)},e.CHANGE_BUFFER_DELAY);y.set(c,(0,L.toDisposable)(()=>clearTimeout(h)))}else{let l;t.has(r)?l="changed":(l="added",t.add(r)),w(l,c)}else if(s==="rename"||r!==E){const l=setTimeout(async()=>{const h=await b.Promises.exists(c);S||(h?(w("changed",c),o=[f(u,w,g)]):w("deleted",c))},e.CHANGE_BUFFER_DELAY);(0,L.dispose)(o),o=[(0,L.toDisposable)(()=>clearTimeout(l))]}else w("changed",c)})}catch(a){b.Promises.exists(u.path).then(t=>{t&&!S&&g(`Failed to watch ${u.path} for changes using fs.watch() (${a.toString()})`)})}return(0,L.toDisposable)(()=>{S=!0,o=(0,L.dispose)(o)})}async function I(u,w,g,E=512){const y=await b.Promises.open(u,"r"),S=Buffer.allocUnsafe(E),o=new T.CancellationTokenSource(g);let a,t=!1;const s=i(u,async n=>{if(n==="changed"){if(t)return;t=!0;try{for(;!o.token.isCancellationRequested;){const{bytesRead:r}=await b.Promises.read(y,S,0,E,null);if(!r||o.token.isCancellationRequested)break;w(S.slice(0,r))}}catch(r){a=new Error(r),o.dispose(!0)}finally{t=!1}}},n=>{a=new Error(n),o.dispose(!0)});return new Promise((n,r)=>{o.token.onCancellationRequested(async()=>{s.dispose(),await b.Promises.close(y),a?r(a):n()})})}e.watchFileContents=I});var de=this&&this.__decorate||function(K,e,D,T){var R=arguments.length,L=R<3?e:T===null?T=Object.getOwnPropertyDescriptor(e,D):T,k;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")L=Reflect.decorate(K,e,D,T);else for(var P=K.length-1;P>=0;P--)(k=K[P])&&(L=(R<3?k(L):R>3?k(e,D,L):k(e,D))||L);return R>3&&L&&Object.defineProperty(e,D,L),L};define(Z[36],ee([0,1,16,6,25,27,64,9,3,2,94,24,17]),function(K,e,D,T,R,L,k,P,m,b,i,C,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var I;(function(x){x[x.Promise=100]="Promise",x[x.PromiseCancel=101]="PromiseCancel",x[x.EventListen=102]="EventListen",x[x.EventDispose=103]="EventDispose"})(I=e.RequestType||(e.RequestType={}));function u(x){switch(x){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var w;(function(x){x[x.Initialize=200]="Initialize",x[x.PromiseSuccess=201]="PromiseSuccess",x[x.PromiseError=202]="PromiseError",x[x.PromiseErrorObj=203]="PromiseErrorObj",x[x.EventFire=204]="EventFire"})(w=e.ResponseType||(e.ResponseType={}));function g(x){switch(x){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var E;(function(x){x[x.Uninitialized=0]="Uninitialized",x[x.Idle=1]="Idle"})(E||(E={}));class y{constructor(N){this.buffer=N,this.pos=0}read(N){const W=this.buffer.slice(this.pos,this.pos+N);return this.pos+=W.byteLength,W}}class S{constructor(){this.buffers=[]}get buffer(){return R.VSBuffer.concat(this.buffers)}write(N){this.buffers.push(N)}}var o;(function(x){x[x.Undefined=0]="Undefined",x[x.String=1]="String",x[x.Buffer=2]="Buffer",x[x.VSBuffer=3]="VSBuffer",x[x.Array=4]="Array",x[x.Object=5]="Object"})(o||(o={}));function a(x){const N=R.VSBuffer.alloc(4);return N.writeUInt32BE(x,0),N}function t(x){return x.read(4).readUInt32BE(0)}function s(x){const N=R.VSBuffer.alloc(1);return N.writeUInt8(x,0),N}const n={Undefined:s(o.Undefined),String:s(o.String),Buffer:s(o.Buffer),VSBuffer:s(o.VSBuffer),Array:s(o.Array),Object:s(o.Object)},r=typeof Buffer!="undefined";function c(x,N){if(typeof N=="undefined")x.write(n.Undefined);else if(typeof N=="string"){const W=R.VSBuffer.fromString(N);x.write(n.String),x.write(a(W.byteLength)),x.write(W)}else if(r&&Buffer.isBuffer(N)){const W=R.VSBuffer.wrap(N);x.write(n.Buffer),x.write(a(W.byteLength)),x.write(W)}else if(N instanceof R.VSBuffer)x.write(n.VSBuffer),x.write(a(N.byteLength)),x.write(N);else if(Array.isArray(N)){x.write(n.Array),x.write(a(N.length));for(const W of N)c(x,W)}else{const W=R.VSBuffer.fromString(JSON.stringify(N));x.write(n.Object),x.write(a(W.byteLength)),x.write(W)}}function l(x){switch(x.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return x.read(t(x)).toString();case o.Buffer:return x.read(t(x)).buffer;case o.VSBuffer:return x.read(t(x));case o.Array:{const W=t(x),_=[];for(let Y=0;Y<W;Y++)_.push(l(x));return _}case o.Object:return JSON.parse(x.read(t(x)).toString())}}class h{constructor(N,W,_=null,Y=1e3){this.protocol=N,this.ctx=W,this.logger=_,this.timeoutDelay=Y,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(G=>this.onRawMessage(G)),this.sendResponse({type:200})}registerChannel(N,W){this.channels.set(N,W),setTimeout(()=>this.flushPendingRequests(N),0)}sendResponse(N){switch(N.type){case 200:{const W=this.send([N.type]);this.logger&&this.logger.logOutgoing(W,0,1,g(N.type));return}case 201:case 202:case 204:case 203:{const W=this.send([N.type,N.id],N.data);this.logger&&this.logger.logOutgoing(W,N.id,1,g(N.type),N.data);return}}}send(N,W=void 0){const _=new S;return c(_,N),c(_,W),this.sendBuffer(_.buffer)}sendBuffer(N){try{return this.protocol.send(N),N.byteLength}catch(W){return 0}}onRawMessage(N){const W=new y(N),_=l(W),Y=l(W),G=_[0];switch(G){case 100:return this.logger&&this.logger.logIncoming(N.byteLength,_[1],1,`${u(G)}: ${_[2]}.${_[3]}`,Y),this.onPromise({type:G,id:_[1],channelName:_[2],name:_[3],arg:Y});case 102:return this.logger&&this.logger.logIncoming(N.byteLength,_[1],1,`${u(G)}: ${_[2]}.${_[3]}`,Y),this.onEventListen({type:G,id:_[1],channelName:_[2],name:_[3],arg:Y});case 101:return this.logger&&this.logger.logIncoming(N.byteLength,_[1],1,`${u(G)}`),this.disposeActiveRequest({type:G,id:_[1]});case 103:return this.logger&&this.logger.logIncoming(N.byteLength,_[1],1,`${u(G)}`),this.disposeActiveRequest({type:G,id:_[1]})}}onPromise(N){const W=this.channels.get(N.channelName);if(!W){this.collectPendingRequest(N);return}const _=new L.CancellationTokenSource;let Y;try{Y=W.call(this.ctx,N.name,N.arg,_.token)}catch(te){Y=Promise.reject(te)}const G=N.id;Y.then(te=>{this.sendResponse({id:G,data:te,type:201}),this.activeRequests.delete(N.id)},te=>{te instanceof Error?this.sendResponse({id:G,data:{message:te.message,name:te.name,stack:te.stack?te.stack.split?te.stack.split(`
`):te.stack:void 0},type:202}):this.sendResponse({id:G,data:te,type:203}),this.activeRequests.delete(N.id)});const ne=(0,b.toDisposable)(()=>_.cancel());this.activeRequests.set(N.id,ne)}onEventListen(N){const W=this.channels.get(N.channelName);if(!W){this.collectPendingRequest(N);return}const _=N.id,G=W.listen(this.ctx,N.name,N.arg)(ne=>this.sendResponse({id:_,data:ne,type:204}));this.activeRequests.set(N.id,G)}disposeActiveRequest(N){const W=this.activeRequests.get(N.id);W&&(W.dispose(),this.activeRequests.delete(N.id))}collectPendingRequest(N){let W=this.pendingRequests.get(N.channelName);W||(W=[],this.pendingRequests.set(N.channelName,W));const _=setTimeout(()=>{console.error(`Unknown channel: ${N.channelName}`),N.type===100&&this.sendResponse({id:N.id,data:{name:"Unknown channel",message:`Channel name '${N.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);W.push({request:N,timeoutTimer:_})}flushPendingRequests(N){const W=this.pendingRequests.get(N);if(W){for(const _ of W)switch(clearTimeout(_.timeoutTimer),_.request.type){case 100:this.onPromise(_.request);break;case 102:this.onEventListen(_.request);break}this.pendingRequests.delete(N)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(N=>N.dispose()),this.activeRequests.clear()}}e.ChannelServer=h;var d;(function(x){x[x.LocalSide=0]="LocalSide",x[x.OtherSide=1]="OtherSide"})(d=e.RequestInitiator||(e.RequestInitiator={}));class v{constructor(N,W=null){this.protocol=N,this.isDisposed=!1,this.state=E.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new m.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(_=>this.onBuffer(_)),this.logger=W}getChannel(N){const W=this;return{call(_,Y,G){return W.isDisposed?Promise.reject(P.canceled()):W.requestPromise(N,_,Y,G)},listen(_,Y){return W.isDisposed?Promise.reject(P.canceled()):W.requestEvent(N,_,Y)}}}requestPromise(N,W,_,Y=L.CancellationToken.None){const G=this.lastRequestId++,te={id:G,type:100,channelName:N,name:W,arg:_};if(Y.isCancellationRequested)return Promise.reject(P.canceled());let J;return new Promise((re,ie)=>{if(Y.isCancellationRequested)return ie(P.canceled());const ce=()=>{const Ie=Pe=>{switch(Pe.type){case 201:this.handlers.delete(G),re(Pe.data);break;case 202:this.handlers.delete(G);const Ee=new Error(Pe.data.message);Ee.stack=Pe.data.stack,Ee.name=Pe.data.name,ie(Ee);break;case 203:this.handlers.delete(G),ie(Pe.data);break}};this.handlers.set(G,Ie),this.sendRequest(te)};let ue=null;this.state===E.Idle?ce():(ue=(0,T.createCancelablePromise)(Ie=>this.whenInitialized()),ue.then(()=>{ue=null,ce()}));const ye=()=>{ue?(ue.cancel(),ue=null):this.sendRequest({id:G,type:101}),ie(P.canceled())},ge=Y.onCancellationRequested(ye);J=(0,b.combinedDisposable)((0,b.toDisposable)(ye),ge),this.activeRequests.add(J)}).finally(()=>{this.activeRequests.delete(J)})}requestEvent(N,W,_){const Y=this.lastRequestId++,ne={id:Y,type:102,channelName:N,name:W,arg:_};let te=null;const J=new m.Emitter({onFirstListenerAdd:()=>{te=(0,T.createCancelablePromise)(re=>this.whenInitialized()),te.then(()=>{te=null,this.activeRequests.add(J),this.sendRequest(ne)})},onLastListenerRemove:()=>{te?(te.cancel(),te=null):(this.activeRequests.delete(J),this.sendRequest({id:Y,type:103}))}}),V=re=>J.fire(re.data);return this.handlers.set(Y,V),J.event}sendRequest(N){switch(N.type){case 100:case 102:{const W=this.send([N.type,N.id,N.channelName,N.name],N.arg);this.logger&&this.logger.logOutgoing(W,N.id,0,`${u(N.type)}: ${N.channelName}.${N.name}`,N.arg);return}case 101:case 103:{const W=this.send([N.type,N.id]);this.logger&&this.logger.logOutgoing(W,N.id,0,u(N.type));return}}}send(N,W=void 0){const _=new S;return c(_,N),c(_,W),this.sendBuffer(_.buffer)}sendBuffer(N){try{return this.protocol.send(N),N.byteLength}catch(W){return 0}}onBuffer(N){const W=new y(N),_=l(W),Y=l(W),G=_[0];switch(G){case 200:return this.logger&&this.logger.logIncoming(N.byteLength,0,0,g(G)),this.onResponse({type:_[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(N.byteLength,_[1],0,g(G),Y),this.onResponse({type:_[0],id:_[1],data:Y})}}onResponse(N){if(N.type===200){this.state=E.Idle,this._onDidInitialize.fire();return}const W=this.handlers.get(N.id);W&&W(N)}get onDidInitializePromise(){return m.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===E.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(N=>N.dispose()),this.activeRequests.clear()}}de([k.memoize],v.prototype,"onDidInitializePromise",null),e.ChannelClient=v;class A{constructor(N){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new m.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new m.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,N(({protocol:W,onDidClientDisconnect:_})=>{m.Event.once(W.onMessage)(G=>{const ne=new y(G),te=l(ne),J=new h(W,te),V=new v(W);this.channels.forEach((ie,ce)=>J.registerChannel(ce,ie));const re={channelServer:J,channelClient:V,ctx:te};this._connections.add(re),this._onDidAddConnection.fire(re),_(()=>{J.dispose(),V.dispose(),this._connections.delete(re),this._onDidRemoveConnection.fire(re)})})})}get connections(){const N=[];return this._connections.forEach(W=>N.push(W)),N}getChannel(N,W){const _=this;return{call(Y,G,ne){let te;if((0,f.isFunction)(W)){let V=(0,D.getRandomElement)(_.connections.filter(W));te=V?Promise.resolve(V):m.Event.toPromise(m.Event.filter(_.onDidAddConnection,W))}else te=W.routeCall(_,Y,G);const J=te.then(V=>V.channelClient.getChannel(N));return p(J).call(Y,G,ne)},listen(Y,G){if((0,f.isFunction)(W))return _.getMulticastEvent(N,W,Y,G);const ne=W.routeEvent(_,Y,G).then(te=>te.channelClient.getChannel(N));return p(ne).listen(Y,G)}}}getMulticastEvent(N,W,_,Y){const G=this;let ne=new b.DisposableStore;const te=new m.Emitter({onFirstListenerAdd:()=>{ne=new b.DisposableStore;const J=new m.EventMultiplexer,V=new Map,re=ce=>{const ye=ce.channelClient.getChannel(N).listen(_,Y),ge=J.add(ye);V.set(ce,ge)},ie=ce=>{const ue=V.get(ce);!ue||(ue.dispose(),V.delete(ce))};G.connections.filter(W).forEach(re),m.Event.filter(G.onDidAddConnection,W)(re,void 0,ne),G.onDidRemoveConnection(ie,void 0,ne),J.event(te.fire,te,ne),ne.add(J)},onLastListenerRemove:()=>{ne.dispose()}});return te.event}registerChannel(N,W){this.channels.set(N,W),this._connections.forEach(_=>{_.channelServer.registerChannel(N,W)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=A;class O{constructor(N,W,_=null){const Y=new S;c(Y,W),N.send(Y.buffer),this.channelClient=new v(N,_),this.channelServer=new h(N,W,_)}getChannel(N){return this.channelClient.getChannel(N)}registerChannel(N,W){this.channelServer.registerChannel(N,W)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=O;function p(x){return{call(N,W,_){return x.then(Y=>Y.call(N,W,_))},listen(N,W){const _=new m.Relay;return x.then(Y=>_.input=Y.listen(N,W)),_.event}}}e.getDelayedChannel=p;function U(x){let N=!1;return{call(W,_,Y){return N?x.call(W,_,Y):(0,T.timeout)(0).then(()=>N=!0).then(()=>x.call(W,_,Y))},listen(W,_){if(N)return x.listen(W,_);const Y=new m.Relay;return(0,T.timeout)(0).then(()=>N=!0).then(()=>Y.input=x.listen(W,_)),Y.event}}}e.getNextTickChannel=U;class F{constructor(N){this.fn=N}routeCall(N){return this.route(N)}routeEvent(N){return this.route(N)}async route(N){for(const W of N.connections)if(await Promise.resolve(this.fn(W.ctx)))return Promise.resolve(W);return await m.Event.toPromise(N.onDidAddConnection),await this.route(N)}}e.StaticRouter=F;var $;(function(x){function N(Y,G){const ne=Y,te=G&&G.disableMarshalling,J=new Map;for(const V in ne)_(V)&&J.set(V,m.Event.buffer(ne[V],!0));return new class{listen(V,re){const ie=J.get(re);if(ie)return ie;throw new Error(`Event not found: ${re}`)}call(V,re,ie){const ce=ne[re];if(typeof ce=="function"){if(!te&&Array.isArray(ie))for(let ue=0;ue<ie.length;ue++)ie[ue]=(0,i.revive)(ie[ue]);return ce.apply(ne,ie)}throw new Error(`Method not found: ${re}`)}}}x.fromService=N;function W(Y,G){const ne=G&&G.disableMarshalling;return new Proxy({},{get(te,J){if(typeof J=="string")return G?.properties?.has(J)?G.properties.get(J):_(J)?Y.listen(J):async function(...V){let re;G&&!(0,f.isUndefinedOrNull)(G.context)?re=[G.context,...V]:re=V;const ie=await Y.call(J,re);return ne?ie:(0,i.revive)(ie)};throw new Error(`Property not found: ${String(J)}`)}})}x.toService=W;function _(Y){return Y[0]==="o"&&Y[1]==="n"&&C.isUpperAsciiLetter(Y.charCodeAt(2))}})($=e.ProxyChannel||(e.ProxyChannel={}));const H=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function M(x){if(Array.isArray(x))return x;if(x&&typeof x=="object"&&typeof x.toString=="function"){let N=x.toString();if(N!=="[object Object]")return N}return x}function j(x){return Array.isArray(x)?x.map(M):M(x)}function q(x,N,W,_,Y,G,ne){ne=j(ne);const te=H[Y],J=te[_%te.length];let V=[`%c[${x}]%c[${String(N).padStart(7," ")}]%c[len: ${String(W).padStart(5," ")}]%c${String(_).padStart(5," ")} - ${G}`,"color: darkgreen","color: grey","color: grey",`color: ${J}`];/\($/.test(G)?(V=V.concat(ne),V.push(")")):V.push(ne),console.log.apply(console,V)}e.logWithColors=q;class z{constructor(N,W){this._outgoingPrefix=N,this._incomingPrefix=W,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(N,W,_,Y,G){this._totalOutgoing+=N,q(this._outgoingPrefix,this._totalOutgoing,N,W,_,Y,G)}logIncoming(N,W,_,Y,G){this._totalIncoming+=N,q(this._incomingPrefix,this._totalIncoming,N,W,_,Y,G)}}e.IPCLogger=z}),define(Z[102],ee([0,1,25,3,36]),function(K,e,D,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class L{constructor(m){this.port=m,this.onMessage=T.Event.fromDOMEventEmitter(this.port,"message",b=>D.VSBuffer.wrap(b.data)),m.start()}send(m){this.port.postMessage(m.buffer)}disconnect(){this.port.close()}}e.Protocol=L;class k extends R.IPCClient{constructor(m,b){const i=new L(m);super(i,b);this.protocol=i}dispose(){this.protocol.disconnect()}}e.Client=k}),define(Z[103],ee([0,1,104,3,36,102]),function(K,e,D,T,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;class k extends R.IPCServer{static getOnDidClientConnect(){const m=T.Event.fromNodeEventEmitter(D.ipcRenderer,"vscode:createMessageChannel",(b,i)=>i);return T.Event.map(m,b=>{const{port1:i,port2:C}=new MessageChannel,I={protocol:new L.Protocol(i),onDidClientDisconnect:T.Event.fromDOMEventEmitter(i,"close")};return D.ipcRenderer.postMessage("vscode:createMessageChannelResult",b,[C]),I})}constructor(){super(k.getOnDidClientConnect())}}e.Server=k}),define(Z[105],ee([0,1,25,9]),function(K,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.request=void 0;function R(P,m){P.proxyAuthorization&&(P.headers={...P.headers||{},"Proxy-Authorization":P.proxyAuthorization});const b=new XMLHttpRequest;return new Promise((i,C)=>{b.open(P.type||"GET",P.url||"",!0,P.user,P.password),L(b,P),b.responseType="arraybuffer",b.onerror=f=>C(new Error(b.statusText&&"XHR failed: "+b.statusText||"XHR failed")),b.onload=f=>{i({res:{statusCode:b.status,headers:k(b)},stream:(0,D.bufferToStream)(D.VSBuffer.wrap(new Uint8Array(b.response)))})},b.ontimeout=f=>C(new Error(`XHR timeout: ${P.timeout}ms`)),P.timeout&&(b.timeout=P.timeout),b.send(P.data),m.onCancellationRequested(()=>{b.abort(),C((0,T.canceled)())})})}e.request=R;function L(P,m){if(m.headers){e:for(let b in m.headers){switch(b){case"User-Agent":case"Accept-Encoding":case"Content-Length":continue e}P.setRequestHeader(b,m.headers[b])}}}function k(P){const m=Object.create(null);for(const b of P.getAllResponseHeaders().split(/\r\n|\n|\r/g))if(b){const i=b.indexOf(":");m[b.substr(0,i).trim().toLowerCase()]=b.substr(i+1).trim()}return m}}),define(Z[70],ee([0,1,6,3,2,17]),function(K,e,D,T,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var k;(function(C){C[C.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(k=e.StorageHint||(e.StorageHint={}));function P(C){const f=C;return f?.changed instanceof Map||f?.deleted instanceof Set}e.isStorageItemsChangeEvent=P;var m;(function(C){C[C.None=0]="None",C[C.Initialized=1]="Initialized",C[C.Closed=2]="Closed"})(m||(m={}));class b extends R.Disposable{constructor(f,I=Object.create(null)){super();this.database=f,this.options=I,this._onDidChangeStorage=this._register(new T.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=m.None,this.cache=new Map,this.flushDelayer=new D.ThrottledDelayer(b.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(f=>this.onDidChangeItemsExternal(f)))}onDidChangeItemsExternal(f){f.changed?.forEach((I,u)=>this.accept(u,I)),f.deleted?.forEach(I=>this.accept(I,void 0))}accept(f,I){if(this.state===m.Closed)return;let u=!1;(0,L.isUndefinedOrNull)(I)?u=this.cache.delete(f):this.cache.get(f)!==I&&(this.cache.set(f,I),u=!0),u&&this._onDidChangeStorage.fire(f)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===m.None&&(this.state=m.Initialized,this.options.hint!==k.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(f,I){const u=this.cache.get(f);return(0,L.isUndefinedOrNull)(u)?I:u}getBoolean(f,I){const u=this.get(f);return(0,L.isUndefinedOrNull)(u)?I:u==="true"}getNumber(f,I){const u=this.get(f);return(0,L.isUndefinedOrNull)(u)?I:parseInt(u,10)}async set(f,I){if(this.state===m.Closed)return;if((0,L.isUndefinedOrNull)(I))return this.delete(f);const u=String(I);if(this.cache.get(f)!==u)return this.cache.set(f,u),this.pendingInserts.set(f,u),this.pendingDeletes.delete(f),this._onDidChangeStorage.fire(f),this.flushDelayer.trigger(()=>this.flushPending())}async delete(f){if(!(this.state===m.Closed||!this.cache.delete(f)))return this.pendingDeletes.has(f)||this.pendingDeletes.add(f),this.pendingInserts.delete(f),this._onDidChangeStorage.fire(f),this.flushDelayer.trigger(()=>this.flushPending())}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=m.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(f){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const f={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(f).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async whenFlushed(){if(!!this.hasPending)return new Promise(f=>this.whenFlushedCallbacks.push(f))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=b,b.DEFAULT_FLUSH_DELAY=100;class i{constructor(){this.onDidChangeItemsExternal=T.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(f){f.insert&&f.insert.forEach((I,u)=>this.items.set(u,I)),f.delete&&f.delete.forEach(I=>this.items.delete(I))}async close(){}}e.InMemoryStorageDatabase=i}),define(Z[106],ee([10,11]),function(K,e){return K.create("vs/base/common/date",e)}),define(Z[56],ee([0,1,106]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const T=60,R=T*60,L=R*24,k=L*7,P=L*30,m=L*365;function b(C,f){typeof C!="number"&&(C=C.getTime());const I=Math.round((new Date().getTime()-C)/1e3);if(I<-30)return(0,D.localize)(0,null,b(new Date().getTime()+I*1e3,!1));if(I<30)return(0,D.localize)(1,null);let u;return I<T?(u=I,f?u===1?(0,D.localize)(2,null,u):(0,D.localize)(3,null,u):u===1?(0,D.localize)(4,null,u):(0,D.localize)(5,null,u)):I<R?(u=Math.floor(I/T),f?u===1?(0,D.localize)(6,null,u):(0,D.localize)(7,null,u):u===1?(0,D.localize)(8,null,u):(0,D.localize)(9,null,u)):I<L?(u=Math.floor(I/R),f?u===1?(0,D.localize)(10,null,u):(0,D.localize)(11,null,u):u===1?(0,D.localize)(12,null,u):(0,D.localize)(13,null,u)):I<k?(u=Math.floor(I/L),f?u===1?(0,D.localize)(14,null,u):(0,D.localize)(15,null,u):u===1?(0,D.localize)(16,null,u):(0,D.localize)(17,null,u)):I<P?(u=Math.floor(I/k),f?u===1?(0,D.localize)(18,null,u):(0,D.localize)(19,null,u):u===1?(0,D.localize)(20,null,u):(0,D.localize)(21,null,u)):I<m?(u=Math.floor(I/P),f?u===1?(0,D.localize)(22,null,u):(0,D.localize)(23,null,u):u===1?(0,D.localize)(24,null,u):(0,D.localize)(25,null,u)):(u=Math.floor(I/m),f?u===1?(0,D.localize)(26,null,u):(0,D.localize)(27,null,u):u===1?(0,D.localize)(28,null,u):(0,D.localize)(29,null,u))}e.fromNow=b;function i(C){return C.getFullYear()+"-"+String(C.getMonth()+1).padStart(2,"0")+"-"+String(C.getDate()).padStart(2,"0")+"T"+String(C.getHours()).padStart(2,"0")+":"+String(C.getMinutes()).padStart(2,"0")+":"+String(C.getSeconds()).padStart(2,"0")+"."+(C.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=i}),define(Z[107],ee([10,11]),function(K,e){return K.create("vs/base/common/errorMessage",e)}),define(Z[37],ee([0,1,16,17,107]),function(K,e,D,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function L(b,i){return i&&(b.stack||b.stacktrace)?R.localize(0,null,P(b),k(b.stack)||k(b.stacktrace)):P(b)}function k(b){return Array.isArray(b)?b.join(`
`):b}function P(b){return typeof b.code=="string"&&typeof b.errno=="number"&&typeof b.syscall=="string"?R.localize(1,null,b.message):b.message||R.localize(2,null)}function m(b=null,i=!1){if(!b)return R.localize(3,null);if(Array.isArray(b)){const C=D.coalesce(b),f=m(C[0],i);return C.length>1?R.localize(4,null,f,C.length):f}if(T.isString(b))return b;if(b.detail){const C=b.detail;if(C.error)return L(C.error,i);if(C.exception)return L(C.exception,i)}return b.stack?L(b,i):b.message?b.message:R.localize(5,null)}e.toErrorMessage=m}),define(Z[108],ee([10,11]),function(K,e){return K.create("vs/base/node/processes",e)}),define(Z[71],ee([0,1,41,39,18,26,8,4,31,17,68,19,108]),function(K,e,D,T,R,L,k,P,m,b,i,C,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0;function I(o){switch(o){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function u(o,a){if(P.isWindows)try{const t={stdio:["pipe","pipe","ignore"]};a&&(t.cwd=a);const s=D.execFile("taskkill",["/T","/F","/PID",o.pid.toString()],t);return new Promise(n=>{s.once("error",r=>{n({success:!1,error:r})}),s.once("exit",(r,c)=>{n(r===0?{success:!0}:{success:!1,code:r!==null?r:1})})})}catch(t){return Promise.resolve({success:!1,error:t,code:t.status?I(t.status):1})}else if(P.isLinux||P.isMacintosh)try{const t=R.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",K).fsPath;return new Promise(s=>{D.execFile(t,[o.pid.toString()],{encoding:"utf8",shell:!0},(n,r,c)=>{s(n?{success:!1,error:n}:{success:!0})})})}catch(t){return Promise.resolve({success:!1,error:t})}else o.kill("SIGKILL");return Promise.resolve({success:!0})}function w(o=m.env){return o.comspec||"cmd.exe"}e.getWindowsShell=w;class g{constructor(a,t,s,n){if(t!==void 0&&s!==void 0&&n!==void 0)this.cmd=a,this.args=t,this.shell=s,this.options=n;else{const r=a;this.cmd=r.command,this.shell=r.isShellCommand,this.args=r.args.slice(0),this.options=r.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const r=Object.create(null);Object.keys(m.env).forEach(c=>{r[c]=m.env[c]}),Object.keys(this.options.env).forEach(c=>{r[c]=this.options.env[c]}),this.options.env=r}}getSanitizedCommand(){let a=this.cmd.toLowerCase();const t=a.lastIndexOf(k.sep);return t!==-1&&(a=a.substring(t+1)),g.WellKnowCommands[a]?a:"other"}start(a){return P.isWindows&&(this.options&&this.options.cwd&&T.isUNC(this.options.cwd)||!this.options&&T.isUNC(m.cwd()))?Promise.reject(new Error(f.localize(0,null))):this.useExec().then(t=>{let s,n;const r=new Promise((c,l)=>{s=c,n=l});if(t){let c=this.cmd;this.args&&(c=c+" "+this.args.join(" ")),this.childProcess=D.exec(c,this.options,(l,h,d)=>{this.childProcess=null;const v=l;v&&v.killed?n({killed:this.terminateRequested,stdout:h.toString(),stderr:d.toString()}):this.handleExec(s,a,l,h,d)})}else{let c=null;const l=h=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(h,s,a,n);const d={terminated:this.terminateRequested};b.isNumber(h)&&(d.cmdCode=h),s(d)};if(this.shell&&P.isWindows){const h=L.deepClone(this.options);h.windowsVerbatimArguments=!0,h.detached=!1;let d=!1,v=!1;const A=[];let O=this.ensureQuotes(this.cmd);A.push(O.value),d=O.quoted,this.args&&this.args.forEach(U=>{O=this.ensureQuotes(U),A.push(O.value),v=v&&O.quoted});const p=["/s","/c"];d?v?p.push('"'+A.join(" ")+'"'):A.length>1?p.push('"'+A[0]+'" '+A.slice(1).join(" ")):p.push('"'+A[0]+'"'):p.push(A.join(" ")),c=D.spawn(w(),p,h)}else this.cmd&&(c=D.spawn(this.cmd,this.args,this.options));c&&(this.childProcess=c,this.childProcessPromise=Promise.resolve(c),this.pidResolve&&(this.pidResolve(b.isNumber(c.pid)?c.pid:-1),this.pidResolve=void 0),c.on("error",h=>{this.childProcess=null,n({terminated:this.terminateRequested,error:h})}),c.pid&&(this.childProcess.on("close",l),this.handleSpawn(c,s,a,n,!0)))}return r})}handleClose(a,t,s,n){}ensureQuotes(a){return g.regexp.test(a)?{value:'"'+a+'"',quoted:!0}:{value:a,quoted:a.length>0&&a[0]==='"'&&a[a.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(a=>a.pid,a=>-1):new Promise(a=>{this.pidResolve=a})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(a=>(this.terminateRequested=!0,u(a,this.options.cwd).then(t=>(t.success&&(this.childProcess=null),t))),a=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(a=>{if(!this.shell||!P.isWindows)return a(!1);const t=D.spawn(w(),["/s","/c"]);t.on("error",s=>a(!0)),t.on("exit",s=>a(!1))})}}e.AbstractProcess=g,g.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},g.regexp=/^[^"].* .*[^"]/;class E extends g{constructor(a,t,s,n){super(a,t,s,n);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(a,t,s,n,r){[n,r].forEach((c,l)=>{const h=new i.LineDecoder;h.write(c).forEach(A=>{t({line:A,source:l===0?0:1})});const v=h.end();v&&t({line:v,source:l===0?0:1})}),a({terminated:this.terminateRequested,error:s})}handleSpawn(a,t,s,n,r){const c=new i.LineDecoder,l=new i.LineDecoder;a.stdout.on("data",h=>{c.write(h).forEach(v=>s({line:v,source:0}))}),a.stderr.on("data",h=>{l.write(h).forEach(v=>s({line:v,source:1}))}),this.stdoutLineDecoder=c,this.stderrLineDecoder=l}handleClose(a,t,s,n){const r=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;r&&s({line:r,source:0});const c=this.stderrLineDecoder?this.stderrLineDecoder.end():null;c&&s({line:c,source:1})}}e.LineProcess=E;function y(o){let a=[],t=!1;const s=function(n){if(t){a.push(n);return}(!o.send(n,c=>{if(c&&console.error(c),t=!1,a.length>0){const l=a.slice(0);a=[],l.forEach(h=>s(h))}})||P.isWindows)&&(t=!0)};return{send:s}}e.createQueuedSender=y;var S;(function(o){async function a(t,s,n){if(k.isAbsolute(t))return t;if(s===void 0&&(s=m.cwd()),k.dirname(t)!=="."||(n===void 0&&b.isString(m.env.PATH)&&(n=m.env.PATH.split(k.delimiter)),n===void 0||n.length===0))return k.join(s,t);async function c(l){if(await C.Promises.exists(l)){let h;try{h=await C.Promises.stat(l)}catch(d){d.message.startsWith("EACCES")&&(h=await C.Promises.lstat(l))}return h?!h.isDirectory():!1}return!1}for(let l of n){let h;if(k.isAbsolute(l)?h=k.join(l,t):h=k.join(s,l,t),await c(h))return h;let d=h+".com";if(await c(d)||(d=h+".exe",await c(d)))return d}return k.join(s,t)}o.findExecutable=a})(S=e.win32||(e.win32={}))}),define(Z[109],ee([0,1,35,4,69,71]),function(K,e,D,T,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function k(I,u){return I===1?T.isWindows?C():L.getWindowsShell(u):b(I,u)}e.getSystemShell=k;function P(I,u){return I===1?T.isWindows?f(u):L.getWindowsShell(u):b(I,u)}e.getSystemShellSync=P;let m=null;function b(I,u){if(T.isLinux&&I===2||T.isMacintosh&&I===3)return"/bin/bash";if(!m){let w;if(T.isWindows)w="/bin/bash";else{if(w=u.SHELL,!w)try{w=(0,D.userInfo)().shell}catch(g){}w||(w="sh"),w==="/bin/false"&&(w="/bin/bash")}m=w}return m}let i=null;async function C(){return i||(i=(await(0,R.getFirstAvailablePowerShellInstallation)()).exePath),i}function f(I){if(i)return i;const u=T.isWindows&&parseFloat((0,D.release)())>=10,w=I.hasOwnProperty("PROCESSOR_ARCHITEW6432"),g=`${I.windir}\\${w?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return u?g:L.getWindowsShell(I)}}),define(Z[52],ee([0,1,41,6,25,27,93,9,3,2,26,4,71,36]),function(K,e,D,T,R,L,k,P,m,b,i,C,f,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class u extends I.ChannelServer{constructor(E){super({send:y=>{try{process.send&&process.send(y.buffer.toString("base64"))}catch(S){}},onMessage:m.Event.fromNodeEventEmitter(process,"message",y=>R.VSBuffer.wrap(Buffer.from(y,"base64")))},E);process.once("disconnect",()=>this.dispose())}}e.Server=u;class w{constructor(E,y){this.modulePath=E,this.options=y,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new m.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const S=y&&y.timeout?y.timeout:6e4;this.disposeDelayer=new T.Delayer(S),this.child=null,this._client=null}getChannel(E){const y=this;return{call(S,o,a){return y.requestPromise(E,S,o,a)},listen(S,o){return y.requestEvent(E,S,o)}}}requestPromise(E,y,S,o=L.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(o.isCancellationRequested)return Promise.reject(P.canceled());this.disposeDelayer.cancel();const a=this.getCachedChannel(E),t=(0,T.createCancelablePromise)(r=>a.call(y,S,r)),s=o.onCancellationRequested(()=>t.cancel()),n=(0,b.toDisposable)(()=>t.cancel());return this.activeRequests.add(n),t.finally(()=>{s.dispose(),this.activeRequests.delete(n),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),t}requestEvent(E,y,S){if(!this.disposeDelayer)return m.Event.None;this.disposeDelayer.cancel();let o;const a=new m.Emitter({onFirstListenerAdd:()=>{o=this.getCachedChannel(E).listen(y,S)(a.fire,a),this.activeRequests.add(o)},onLastListenerRemove:()=>{this.activeRequests.delete(o),o.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return a.event}get client(){if(!this._client){const E=this.options&&this.options.args?this.options.args:[],y=Object.create(null);y.env={...(0,i.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(y.env={...y.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(y.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(y.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(y.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),y.execArgv===void 0&&(y.execArgv=process.execArgv.filter(c=>!/^--inspect(-brk)?=/.test(c))),C.isMacintosh&&y.env&&delete y.env.DYLD_LIBRARY_PATH,this.child=(0,D.fork)(this.modulePath,E,y);const S=new m.Emitter;m.Event.fromNodeEventEmitter(this.child,"message",c=>c)(c=>{if((0,k.isRemoteConsoleLog)(c)){(0,k.log)(c,`IPC Library: ${this.options.serverName}`);return}S.fire(R.VSBuffer.wrap(Buffer.from(c,"base64")))});const a=this.options.useQueue?(0,f.createQueuedSender)(this.child):this.child,t=c=>this.child&&this.child.connected&&a.send(c.buffer.toString("base64")),s=S.event,n={send:t,onMessage:s};this._client=new I.ChannelClient(n);const r=()=>this.disposeClient();process.once("exit",r),this.child.on("error",c=>console.warn('IPC "'+this.options.serverName+'" errored with '+c)),this.child.on("exit",(c,l)=>{process.removeListener("exit",r),this.activeRequests.forEach(h=>(0,b.dispose)(h)),this.activeRequests.clear(),c!==0&&l!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+c+" and signal "+l),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:c,signal:l})})}return this._client}getCachedChannel(E){let y=this.channels.get(E);return y||(y=this.client.getChannel(E),this.channels.set(E,y)),y}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=w}),define(Z[110],ee([10,11]),function(K,e){return K.create("vs/base/node/zip",e)}),define(Z[111],ee([10,11]),function(K,e){return K.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Z[112],ee([10,11]),function(K,e){return K.create("vs/platform/environment/node/argv",e)}),define(Z[113],ee([10,11]),function(K,e){return K.create("vs/platform/environment/node/argvHelper",e)}),define(Z[114],ee([10,11]),function(K,e){return K.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(Z[115],ee([10,11]),function(K,e){return K.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Z[116],ee([10,11]),function(K,e){return K.create("vs/platform/extensionManagement/electron-sandbox/extensionTipsService",e)}),define(Z[117],ee([10,11]),function(K,e){return K.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(Z[118],ee([10,11]),function(K,e){return K.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(Z[119],ee([10,11]),function(K,e){return K.create("vs/platform/extensionManagement/node/extensionsScanner",e)}),define(Z[120],ee([10,11]),function(K,e){return K.create("vs/platform/extensions/common/extensionValidator",e)}),define(Z[121],ee([10,11]),function(K,e){return K.create("vs/platform/files/common/fileService",e)}),define(Z[122],ee([10,11]),function(K,e){return K.create("vs/platform/files/common/files",e)}),define(Z[123],ee([10,11]),function(K,e){return K.create("vs/platform/files/common/io",e)}),define(Z[124],ee([10,11]),function(K,e){return K.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Z[125],ee([10,11]),function(K,e){return K.create("vs/platform/request/common/request",e)}),define(Z[126],ee([10,11]),function(K,e){return K.create("vs/platform/telemetry/common/telemetryService",e)}),define(Z[127],ee([10,11]),function(K,e){return K.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(Z[128],ee([10,11]),function(K,e){return K.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(Z[129],ee([10,11]),function(K,e){return K.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(Z[130],ee([10,11]),function(K,e){return K.create("vs/platform/userDataSync/common/settingsSync",e)}),define(Z[131],ee([10,11]),function(K,e){return K.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(Z[132],ee([10,11]),function(K,e){return K.create("vs/platform/userDataSync/common/userDataSync",e)}),define(Z[133],ee([10,11]),function(K,e){return K.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(Z[134],ee([0,1,56,64,18,8,31,15,5]),function(K,e,D,T,R,L,k,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class b{constructor(u,w,g){this._args=u,this.paths=w,this.productService=g}get appRoot(){return(0,L.dirname)(R.FileAccess.asFileUri("",K).fsPath)}get userHome(){return m.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return m.URI.file((0,L.join)(this.userDataPath,"User"))}get tmpDir(){return m.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,P.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,P.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const u=(0,D.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,L.join)(this.userDataPath,"logs",u)}return this.args.logsPath}get userDataSyncLogResource(){return m.URI.file((0,L.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,P.joinPath)(m.URI.file((0,L.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return m.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return m.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,P.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,P.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const u=k.env.VSCODE_PORTABLE;return u?m.URI.file((0,L.join)(u,"argv.json")):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,P.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return m.URI.file((0,L.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,L.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const u=this.args["builtin-extensions-dir"];return u?(0,L.resolve)(u):(0,L.normalize)((0,L.join)(R.FileAccess.asFileUri("",K).fsPath,"..","extensions"))}get extensionsDownloadPath(){const u=this.args["extensions-download-dir"];return u?(0,L.resolve)(u):(0,L.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const u=this.args["extensions-dir"];if(u)return(0,L.resolve)(u);const w=k.env.VSCODE_EXTENSIONS;if(w)return w;const g=k.env.VSCODE_PORTABLE;return g?(0,L.join)(g,"extensions"):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const u=this.args.extensionDevelopmentPath;if(Array.isArray(u))return u.map(w=>/^[^:/?#]+?:\/\//.test(w)?m.URI.parse(w):m.URI.file((0,L.normalize)(w)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(u=>u==="ui"||u==="workspace"||u==="web"?u:"workspace")}get extensionTestsLocationURI(){const u=this.args.extensionTestsPath;if(u)return/^[^:/?#]+?:\/\//.test(u)?m.URI.parse(u):m.URI.file((0,L.normalize)(u))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const u=this.args["disable-extension"];if(u){if(typeof u=="string")return[u];if(Array.isArray(u)&&u.length>0)return u}return!1}get debugExtensionHost(){return i(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!k.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,P.joinPath)(m.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return m.URI.file((0,L.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}de([T.memoize],b.prototype,"appRoot",null),de([T.memoize],b.prototype,"userHome",null),de([T.memoize],b.prototype,"userDataPath",null),de([T.memoize],b.prototype,"appSettingsHome",null),de([T.memoize],b.prototype,"tmpDir",null),de([T.memoize],b.prototype,"userRoamingDataHome",null),de([T.memoize],b.prototype,"settingsResource",null),de([T.memoize],b.prototype,"userDataSyncHome",null),de([T.memoize],b.prototype,"userDataSyncLogResource",null),de([T.memoize],b.prototype,"sync",null),de([T.memoize],b.prototype,"machineSettingsResource",null),de([T.memoize],b.prototype,"globalStorageHome",null),de([T.memoize],b.prototype,"workspaceStorageHome",null),de([T.memoize],b.prototype,"keybindingsResource",null),de([T.memoize],b.prototype,"keyboardLayoutResource",null),de([T.memoize],b.prototype,"argvResource",null),de([T.memoize],b.prototype,"snippetsHome",null),de([T.memoize],b.prototype,"isExtensionDevelopment",null),de([T.memoize],b.prototype,"untitledWorkspacesHome",null),de([T.memoize],b.prototype,"installSourcePath",null),de([T.memoize],b.prototype,"builtinExtensionsPath",null),de([T.memoize],b.prototype,"extensionsPath",null),de([T.memoize],b.prototype,"extensionDevelopmentLocationURI",null),de([T.memoize],b.prototype,"extensionDevelopmentKind",null),de([T.memoize],b.prototype,"extensionTestsLocationURI",null),de([T.memoize],b.prototype,"debugExtensionHost",null),de([T.memoize],b.prototype,"serviceMachineIdResource",null),de([T.memoize],b.prototype,"telemetryLogResource",null),de([T.memoize],b.prototype,"disableWorkspaceTrust",null),e.AbstractNativeEnvironmentService=b;function i(I,u){return f(I["inspect-extensions"],I["inspect-brk-extensions"],5870,u,I.debugId)}e.parseExtensionHostPort=i;function C(I,u){return f(I["inspect-search"],I["inspect-brk-search"],5876,u)}e.parseSearchPort=C;function f(I,u,w,g,E){const S=Number(u||I)||(g?null:w),o=S?Boolean(!!u):!1;return{port:S,break:o,debugId:E}}}),define(Z[135],ee([0,1,220,4,112]),function(K,e,D,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const L={o:(0,R.localize)(0,null),e:(0,R.localize)(1,null),t:(0,R.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,R.localize)(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,R.localize)(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,R.localize)(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,R.localize)(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,R.localize)(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,R.localize)(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,R.localize)(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,R.localize)(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,R.localize)(11,null)},"extensions-dir":{type:"string",deprecates:"extensionHomePath",cat:"e",args:"dir",description:(0,R.localize)(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,R.localize)(13,null)},"show-versions":{type:"boolean",cat:"e",description:(0,R.localize)(14,null)},category:{type:"string",cat:"e",description:(0,R.localize)(15,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"extension-id[@version] | path-to-vsix",description:(0,R.localize)(16,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"extension-id",description:(0,R.localize)(17,null)},"enable-proposed-api":{type:"string[]",cat:"e",args:"extension-id",description:(0,R.localize)(18,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,R.localize)(19,null)},verbose:{type:"boolean",cat:"t",description:(0,R.localize)(20,null)},log:{type:"string",cat:"t",args:"level",description:(0,R.localize)(21,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,R.localize)(22,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,R.localize)(23,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:"disableExtensions",cat:"t",description:(0,R.localize)(24,null)},"disable-extension":{type:"string[]",cat:"t",args:"extension-id",description:(0,R.localize)(25,null)},sync:{type:"string",cat:"t",description:(0,R.localize)(26,null),args:["on","off"]},"inspect-extensions":{type:"string",deprecates:"debugPluginHost",args:"port",cat:"t",description:(0,R.localize)(27,null)},"inspect-brk-extensions":{type:"string",deprecates:"debugBrkPluginHost",args:"port",cat:"t",description:(0,R.localize)(28,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,R.localize)(29,null)},"max-memory":{type:"string",cat:"t",description:(0,R.localize)(30,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,R.localize)(31,null)},remote:{type:"string"},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-search":{type:"string",deprecates:"debugSearch"},"inspect-brk-search":{type:"string",deprecates:"debugBrkSearch"},"export-default-configuration":{type:"string"},"install-source":{type:"string"},driver:{type:"string"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"driver-verbose":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string"},"inspect-brk":{type:"string"},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},_:{type:"string[]"}};const k={onUnknownOption:()=>{},onMultipleValues:()=>{}};function P(u,w,g=k){const E={},y=[],S=[];for(let s in w){const n=w[s];n.alias&&(E[s]=n.alias),n.type==="string"||n.type==="string[]"?(y.push(s),n.deprecates&&y.push(n.deprecates)):n.type==="boolean"&&(S.push(s),n.deprecates&&S.push(n.deprecates))}const o=D(u,{string:y,boolean:S,alias:E}),a={},t=o;a._=o._.map(s=>String(s)).filter(s=>s.length>0),delete t._;for(let s in w){const n=w[s];n.alias&&delete t[n.alias];let r=t[s];n.deprecates&&t.hasOwnProperty(n.deprecates)&&(r||(r=t[n.deprecates]),delete t[n.deprecates]),typeof r!="undefined"&&(n.type==="string[]"?r&&!Array.isArray(r)&&(r=[r]):n.type==="string"&&Array.isArray(r)&&(r=r.pop(),g.onMultipleValues(s,r)),a[s]=r),delete t[s]}for(let s in t)g.onUnknownOption(s);return a}e.parseArgs=P;function m(u,w){let g="";return w.args&&(Array.isArray(w.args)?g=` <${w.args.join("> <")}>`:g=` <${w.args}>`),w.alias?`-${w.alias} --${u}${g}`:`--${u}${g}`}function b(u,w){let g=0,E=[];for(const a in u){const t=u[a],s=m(a,t);g=Math.max(g,s.length),E.push([s,t.description])}let y=g+2+1;if(w-y<25)return E.reduce((a,t)=>a.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);let S=w-y-1,o=[];for(const a of E){let t=a[0],s=C(a[1],S),n=i(y-t.length-2);o.push("  "+t+n+s[0]);for(let r=1;r<s.length;r++)o.push(i(y)+s[r])}return o}e.formatOptions=b;function i(u){return" ".repeat(u)}function C(u,w){let g=[];for(;u.length;){let E=u.length<w?u.length:u.lastIndexOf(" ",w),y=u.slice(0,E).trim();u=u.slice(E),g.push(y)}return g}function f(u,w,g,E,y=!0){const S=process.stdout.isTTY&&process.stdout.columns||80;let o=[`${u} ${g}`];o.push(""),o.push(`${(0,R.localize)(32,null)}: ${w} [${(0,R.localize)(33,null)}][${(0,R.localize)(34,null)}...]`),o.push(""),y&&(T.isWindows?o.push((0,R.localize)(35,null,w)):o.push((0,R.localize)(36,null,w)),o.push(""));const a={};for(const t in E){const s=E[t];if(s.description&&s.cat){let n=a[s.cat];n||(a[s.cat]=n={}),n[t]=s}}for(let t in a){const s=t;let n=a[s];n&&(o.push(L[s]),o.push(...b(n,S)),o.push(""))}return o.join(`
`)}e.buildHelpMessage=f;function I(u,w){return`${u||(0,R.localize)(37,null)}
${w||(0,R.localize)(38,null)}
${process.arch}`}e.buildVersionMessage=I}),function(){"use strict";function K(e,D,T,R){function L(P){const m=k(P),b=[m];return e.isAbsolute(m)||b.unshift(R),e.resolve(...b)}function k(P){const m=process.env.VSCODE_PORTABLE;if(m)return e.join(m,"user-data");let b=process.env.VSCODE_APPDATA;if(b)return e.join(b,T);const i=P["user-data-dir"];if(i)return i;switch(process.platform){case"win32":if(b=process.env.APPDATA,!b){const C=process.env.USERPROFILE;if(typeof C!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");b=e.join(C,"AppData","Roaming")}break;case"darwin":b=e.join(D.homedir(),"Library","Application Support");break;case"linux":b=process.env.XDG_CONFIG_HOME||e.join(D.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(b,T)}return{getUserDataPath:L}}if(typeof define=="function")define(Z[136],ee([0,137,35,18,15,31]),function(e,D,T,R,L,k){const P=L.dirname(R.FileAccess.asFileUri("",e)),m=e.__$__nodeRequire(L.joinPath(P,"package.json").fsPath);return K(D,T,m.name,k.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),D=require("path"),T=require("os");module.exports=K(D,T,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Z[138],ee([0,1,35,134,136]),function(K,e,D,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class L extends T.AbstractNativeEnvironmentService{constructor(P,m){super(P,{homeDir:(0,D.homedir)(),tmpDir:(0,D.tmpdir)(),userDataDir:(0,R.getUserDataPath)(P)},m)}}e.NativeEnvironmentService=L}),define(Z[139],ee([0,1,5]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemotes=e.getDomainsOfRemotes=e.AllowedSecondLevelDomains=void 0;const T=/^([^@:]+@)?([^:]+):/,R=/^([^@:]+@)?([^:]+):(.+)$/,L=/^([^@]+@)?([^:]+)(:\d+)?$/,k=/([^@:.]+\.[^@:.]+)(:\d+)?$/,P=/^\s*url\s*=\s*(.+\S)\s*$/mg,m=/[^.]/g;e.AllowedSecondLevelDomains=["github.com","bitbucket.org","visualstudio.com","gitlab.com","heroku.com","azurewebsites.net","ibm.com","amazon.com","amazonaws.com","cloudapp.net","rhcloud.com","google.com","azure.com"];function b(g){const E=g.match(k);return E?E[1]:null}function i(g){if(g.indexOf("://")===-1){const E=g.match(T);return E?b(E[2]):null}try{const E=D.URI.parse(g);if(E.authority)return b(E.authority)}catch(E){}return null}function C(g,E){const y=new Set;let S;for(;S=P.exec(g);){const a=i(S[1]);a&&y.add(a)}const o=new Set(E);return Array.from(y).map(a=>o.has(a)?a:a.replace(m,"a"))}e.getDomainsOfRemotes=C;function f(g){const E=g.match(L);return E?E[2]:null}function I(g,E,y){return g&&E?(y&&E.endsWith(".git")&&(E=E.substr(0,E.length-4)),E.indexOf("/")===0?`${g}${E}`:`${g}/${E}`):null}function u(g,E){if(g.indexOf("://")===-1){const y=g.match(R);if(y)return I(y[2],y[3],E)}try{const y=D.URI.parse(g);if(y.authority)return I(f(y.authority),y.path,E)}catch(y){}return null}function w(g,E=!1){const y=[];let S;for(;S=P.exec(g);){const o=u(S[1],E);o&&y.push(o)}return y}e.getRemotes=w}),define(Z[140],ee([0,1,26]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;const T=/^%([\w\d.-]+)%$/i;function R(L,k){const P=m=>{if(typeof m!="string")return;const b=T.exec(m);if(!b)return;const i=k[b[1]]??m;return typeof i=="string"?i:typeof i.message=="string"?i.message:m};return(0,D.cloneAndChange)(L,P)}e.localizeManifest=R}),define(Z[141],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class D{constructor(L){this.channel=L}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(L,k,P,m){return this.channel.call("promptImportantExtensionsInstallNotification",[L,k,P,m])}promptWorkspaceRecommendations(L){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=D;class T{constructor(L){this.service=L}listen(L,k){throw new Error(`Event not found: ${k}`)}call(L,k,P){switch(k){case"promptImportantExtensionsInstallNotification":return this.service.promptImportantExtensionsInstallNotification(P[0],P[1],P[2],P[3])}throw new Error(`Call not found: ${k}`)}}e.ExtensionRecommendationNotificationServiceChannel=T}),define(Z[72],ee([0,1,120]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const T=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,R=/^-(\d{4})(\d{2})(\d{2})$/;function L(f){return f=f.trim(),f==="*"||T.test(f)}e.isValidVersionStr=L;function k(f){if(!L(f))return null;if(f=f.trim(),f==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let I=f.match(T);return I?{hasCaret:I[1]==="^",hasGreaterEquals:I[1]===">=",majorBase:I[2]==="x"?0:parseInt(I[2],10),majorMustEqual:I[2]!=="x",minorBase:I[4]==="x"?0:parseInt(I[4],10),minorMustEqual:I[4]!=="x",patchBase:I[6]==="x"?0:parseInt(I[6],10),patchMustEqual:I[6]!=="x",preRelease:I[8]||null}:null}e.parseVersion=k;function P(f){if(!f)return null;let I=f.majorBase,u=f.majorMustEqual,w=f.minorBase,g=f.minorMustEqual,E=f.patchBase,y=f.patchMustEqual;f.hasCaret&&(I===0||(g=!1),y=!1);let S=0;if(f.preRelease){const o=R.exec(f.preRelease);if(o){const[,a,t,s]=o;S=Date.UTC(Number(a),Number(t)-1,Number(s))}}return{majorBase:I,majorMustEqual:u,minorBase:w,minorMustEqual:g,patchBase:E,patchMustEqual:y,isMinimum:f.hasGreaterEquals,notBefore:S}}e.normalizeVersion=P;function m(f,I,u){let w;typeof f=="string"?w=P(k(f)):w=f;let g;I instanceof Date?g=I.getTime():typeof I=="string"&&(g=new Date(I).getTime());let E;if(typeof u=="string"?E=P(k(u)):E=u,!w||!E)return!1;let y=w.majorBase,S=w.minorBase,o=w.patchBase,a=E.majorBase,t=E.minorBase,s=E.patchBase,n=E.notBefore,r=E.majorMustEqual,c=E.minorMustEqual,l=E.patchMustEqual;return E.isMinimum?y>a?!0:y<a?!1:S>t?!0:S<t||g&&g<n?!1:o>=s:(y===1&&a===0&&(!r||!c||!l)&&(a=1,t=0,s=0,r=!0,c=!1,l=!1),y<a?!1:y>a?!r:S<t?!1:S>t?!c:o<s?!1:o>s?!l:!(g&&g<n))}e.isValidVersion=m;function b(f,I,u,w){return u.isBuiltin||typeof u.main=="undefined"?!0:C(f,I,u.engines.vscode,w)}e.isValidExtensionVersion=b;function i(f,I,u){return f==="*"||C(I,u,f)}e.isEngineValid=i;function C(f,I,u,w=[]){let g=P(k(u));if(!g)return w.push(D.localize(0,null,u)),!1;if(g.majorBase===0){if(!g.majorMustEqual||!g.minorMustEqual)return w.push(D.localize(1,null,u)),!1}else if(!g.majorMustEqual)return w.push(D.localize(2,null,u)),!1;return m(f,I,g)?!0:(w.push(D.localize(3,null,f,u)),!1)}}),define(Z[142],ee([0,1,2,18,36,52]),function(K,e,D,T,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class k extends D.Disposable{constructor(m,b,i,C){super();this.folders=m,this.onDidFilesChange=b,this.onLogMessage=i,this.verboseLogging=C,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const m=this._register(new L.Client(T.FileAccess.asFileUri("bootstrap-fork",K).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(m.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=k.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=R.ProxyChannel.toService((0,R.getNextTickChannel)(m.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(b=>!this.isDisposed&&this.onDidFilesChange(b))),this._register(this.service.onDidLogMessage(b=>this.onLogMessage(b))),this.setFolders(this.folders)}setVerboseLogging(m){this.verboseLogging=m,!this.isDisposed&&this.service&&this.service.setVerboseLogging(m)}error(m){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${m}`})}setFolders(m){this.folders=m,this.service&&this.service.setRoots(m)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=k,k.MAX_RESTARTS=5}),define(Z[143],ee([0,1,2,18,36,52]),function(K,e,D,T,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class k extends D.Disposable{constructor(m,b,i,C,f={}){super();this.folders=m,this.onDidFilesChange=b,this.onLogMessage=i,this.verboseLogging=C,this.watcherOptions=f,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const m=this._register(new L.Client(T.FileAccess.asFileUri("bootstrap-fork",K).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(m.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=k.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=R.ProxyChannel.toService((0,R.getNextTickChannel)(m.getChannel("watcher"))),this.service.init({...this.watcherOptions,verboseLogging:this.verboseLogging}),this._register(this.service.onDidChangeFile(b=>!this.isDisposed&&this.onDidFilesChange(b))),this._register(this.service.onDidLogMessage(b=>this.onLogMessage(b))),this.service.setRoots(this.folders)}error(m){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${m}`})}setVerboseLogging(m){this.verboseLogging=m,this.service&&this.service.setVerboseLogging(m)}setFolders(m){this.folders=m,this.service&&this.service.setRoots(m)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=k,k.MAX_RESTARTS=5}),define(Z[144],ee([0,1,41,67,18,68]),function(K,e,D,T,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutOfProcessWin32FolderWatcher=void 0;class k{constructor(m,b,i,C,f){this.watchedFolder=m,this.eventCallback=i,this.logCallback=C,this.verboseLogging=f,this.restartCounter=0,Array.isArray(b)?this.ignored=b.map(I=>(0,T.parse)(I)):this.ignored=[],this.verboseLogging&&this.log(`Start watching: ${m}, excludes: ${b.join(",")}`),this.startWatcher()}startWatcher(){const m=[this.watchedFolder];this.verboseLogging&&m.push("-verbose"),this.handle=(0,D.spawn)(R.FileAccess.asFileUri("vs/platform/files/node/watcher/win32/CodeHelper.exe",K).fsPath,m);const b=new L.LineDecoder;this.handle.stdout.on("data",i=>{const C=[];for(const f of b.write(i)){const I=f.split("|");if(I.length===2){const u=Number(I[0]),w=I[1];if(u>=0&&u<3){if(this.ignored&&this.ignored.some(g=>g(w))){this.verboseLogging&&this.log(w);continue}C.push({type:k.changeTypeMap[u],path:w})}else this.log(I[1])}}C.length>0&&this.eventCallback(C)}),this.handle.on("error",i=>this.onError(i)),this.handle.stderr.on("data",i=>this.onError(i)),this.handle.on("exit",(i,C)=>this.onExit(i,C))}onError(m){this.error("process error: "+m.toString())}onExit(m,b){this.handle&&(this.error(`terminated unexpectedly (code: ${m}, signal: ${b})`),this.restartCounter<=k.MAX_RESTARTS?(this.error("is restarted again..."),this.restartCounter++,this.startWatcher()):this.error("Watcher failed to start after retrying for some time, giving up. Please report this as a bug report!"))}error(m){this.logCallback({type:"error",message:`[File Watcher (C#)] ${m}`})}log(m){this.logCallback({type:"trace",message:`[File Watcher (C#)] ${m}`})}dispose(){this.handle&&(this.handle.kill(),this.handle=void 0)}}e.OutOfProcessWin32FolderWatcher=k,k.MAX_RESTARTS=5,k.changeTypeMap=[0,1,2]}),define(Z[145],ee([0,1,8,24,144]),function(K,e,D,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class L{constructor(P,m,b,i){this.onDidFilesChange=m,this.onLogMessage=b,this.verboseLogging=i,this.service=void 0,this.folder=P[0],this.folder.path.indexOf("\\\\")===0&&this.folder.path.endsWith(D.posix.sep)&&(this.folder.path=(0,T.rtrim)(this.folder.path,D.posix.sep)),this.service=this.startWatching()}get isDisposed(){return!this.service}startWatching(){return new R.OutOfProcessWin32FolderWatcher(this.folder.path,this.folder.excludes,P=>this.onFileEvents(P),P=>this.onLogMessage(P),this.verboseLogging)}setVerboseLogging(P){this.verboseLogging=P,this.service&&(this.service.dispose(),this.service=this.startWatching())}onFileEvents(P){this.isDisposed||P.length>0&&this.onDidFilesChange(P)}dispose(){this.service&&(this.service.dispose(),this.service=void 0)}}e.FileWatcher=L}),define(Z[53],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class D{constructor(R,L=[],k=!1){this.ctor=R,this.staticArguments=L,this.supportsDelayedInstantiation=k}}e.SyncDescriptor=D}),define(Z[146],ee([0,1,53]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const T=[];function R(k,P,m){P instanceof D.SyncDescriptor||(P=new D.SyncDescriptor(P,[],m)),T.push([k,P])}e.registerSingleton=R;function L(){return T}e.getSingletonServiceDescriptors=L}),define(Z[147],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class D{constructor(L){this.incoming=new Map,this.outgoing=new Map,this.data=L}}e.Node=D;class T{constructor(L){this._hashFn=L,this._nodes=new Map}roots(){const L=[];for(let k of this._nodes.values())k.outgoing.size===0&&L.push(k);return L}insertEdge(L,k){const P=this.lookupOrInsertNode(L),m=this.lookupOrInsertNode(k);P.outgoing.set(this._hashFn(k),m),m.incoming.set(this._hashFn(L),P)}removeNode(L){const k=this._hashFn(L);this._nodes.delete(k);for(let P of this._nodes.values())P.outgoing.delete(k),P.incoming.delete(k)}lookupOrInsertNode(L){const k=this._hashFn(L);let P=this._nodes.get(k);return P||(P=new D(L),this._nodes.set(k,P)),P}lookup(L){return this._nodes.get(this._hashFn(L))}isEmpty(){return this._nodes.size===0}toString(){let L=[];for(let[k,P]of this._nodes)L.push(`${k}, (incoming)[${[...P.incoming.keys()].join(", ")}], (outgoing)[${[...P.outgoing.keys()].join(",")}]`);return L.join(`
`)}findCycleSlow(){for(let[L,k]of this._nodes){const P=new Set([L]),m=this._findCycle(k,P);if(m)return m}}_findCycle(L,k){for(let[P,m]of L.outgoing){if(k.has(P))return[...k,P].join(" -> ");k.add(P);const b=this._findCycle(m,k);if(b)return b;k.delete(P)}}}e.Graph=T}),define(Z[7],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var D;(function(P){P.serviceIds=new Map,P.DI_TARGET="$di$target",P.DI_DEPENDENCIES="$di$dependencies";function m(b){return b[P.DI_DEPENDENCIES]||[]}P.getServiceDependencies=m})(D=e._util||(e._util={})),e.IInstantiationService=R("instantiationService");function T(P,m,b,i){m[D.DI_TARGET]===m?m[D.DI_DEPENDENCIES].push({id:P,index:b,optional:i}):(m[D.DI_DEPENDENCIES]=[{id:P,index:b,optional:i}],m[D.DI_TARGET]=m)}function R(P){if(D.serviceIds.has(P))return D.serviceIds.get(P);const m=function(b,i,C){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");T(m,b,C,!1)};return m.toString=()=>P,D.serviceIds.set(P,m),m}e.createDecorator=R;function L(P){return P}e.refineServiceDecorator=L;function k(P){return function(m,b,i){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");T(P,m,i,!0)}}e.optional=k}),define(Z[148],ee([0,1,7]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=(0,D.createDecorator)("checksumService")}),define(Z[149],ee([0,1,4,24,7]),function(K,e,D,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let L=D.userAgent||"";const k=new Map;k.set("false",!1),k.set("true",!0),k.set("isMac",D.isMacintosh),k.set("isLinux",D.isLinux),k.set("isWindows",D.isWindows),k.set("isWeb",D.isWeb),k.set("isMacNative",D.isMacintosh&&!D.isWeb),k.set("isEdge",L.indexOf("Edg/")>=0),k.set("isFirefox",L.indexOf("Firefox")>=0),k.set("isChrome",L.indexOf("Chrome")>=0),k.set("isSafari",L.indexOf("Safari")>=0);const P=Object.prototype.hasOwnProperty;var m;(function(O){O[O.False=0]="False",O[O.True=1]="True",O[O.Defined=2]="Defined",O[O.Not=3]="Not",O[O.Equals=4]="Equals",O[O.NotEquals=5]="NotEquals",O[O.And=6]="And",O[O.Regex=7]="Regex",O[O.NotRegex=8]="NotRegex",O[O.Or=9]="Or",O[O.In=10]="In",O[O.NotIn=11]="NotIn",O[O.Greater=12]="Greater",O[O.GreaterEquals=13]="GreaterEquals",O[O.Smaller=14]="Smaller",O[O.SmallerEquals=15]="SmallerEquals"})(m=e.ContextKeyExprType||(e.ContextKeyExprType={}));class b{static false(){return C.INSTANCE}static true(){return f.INSTANCE}static has(p){return I.create(p)}static equals(p,U){return u.create(p,U)}static notEquals(p,U){return E.create(p,U)}static regex(p,U){return s.create(p,U)}static in(p,U){return w.create(p,U)}static not(p){return y.create(p)}static and(...p){return r.create(p,null)}static or(...p){return c.create(p,null,!0)}static greater(p,U){return S.create(p,U)}static less(p,U){return a.create(p,U)}static deserialize(p,U=!1){if(!!p)return this._deserializeOrExpression(p,U)}static _deserializeOrExpression(p,U){let F=p.split("||");return c.create(F.map($=>this._deserializeAndExpression($,U)),null,!0)}static _deserializeAndExpression(p,U){let F=p.split("&&");return r.create(F.map($=>this._deserializeOne($,U)),null)}static _deserializeOne(p,U){if(p=p.trim(),p.indexOf("!=")>=0){let F=p.split("!=");return E.create(F[0].trim(),this._deserializeValue(F[1],U))}if(p.indexOf("==")>=0){let F=p.split("==");return u.create(F[0].trim(),this._deserializeValue(F[1],U))}if(p.indexOf("=~")>=0){let F=p.split("=~");return s.create(F[0].trim(),this._deserializeRegexValue(F[1],U))}if(p.indexOf(" in ")>=0){let F=p.split(" in ");return w.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(p)){const F=p.split(">=");return o.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(p)){const F=p.split(">");return S.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(p)){const F=p.split("<=");return t.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(p)){const F=p.split("<");return a.create(F[0].trim(),F[1].trim())}return/^\!\s*/.test(p)?y.create(p.substr(1).trim()):I.create(p)}static _deserializeValue(p,U){if(p=p.trim(),p==="true")return!0;if(p==="false")return!1;let F=/^'([^']*)'$/.exec(p);return F?F[1].trim():p}static _deserializeRegexValue(p,U){if((0,T.isFalsyOrWhitespace)(p)){if(U)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let F=p.indexOf("/"),$=p.lastIndexOf("/");if(F===$||F<0){if(U)throw new Error(`bad regexp-value '${p}', missing /-enclosure`);return console.warn(`bad regexp-value '${p}', missing /-enclosure`),null}let H=p.slice(F+1,$),M=p[$+1]==="i"?"i":"";try{return new RegExp(H,M)}catch(j){if(U)throw new Error(`bad regexp-value '${p}', parse error: ${j}`);return console.warn(`bad regexp-value '${p}', parse error: ${j}`),null}}}e.ContextKeyExpr=b;function i(O,p){return O.cmp(p)}class C{constructor(){this.type=0}cmp(p){return this.type-p.type}equals(p){return p.type===this.type}evaluate(p){return!1}serialize(){return"false"}keys(){return[]}map(p){return this}negate(){return f.INSTANCE}}e.ContextKeyFalseExpr=C,C.INSTANCE=new C;class f{constructor(){this.type=1}cmp(p){return this.type-p.type}equals(p){return p.type===this.type}evaluate(p){return!0}serialize(){return"true"}keys(){return[]}map(p){return this}negate(){return C.INSTANCE}}e.ContextKeyTrueExpr=f,f.INSTANCE=new f;class I{constructor(p,U){this.key=p,this.negated=U,this.type=2}static create(p,U=null){const F=k.get(p);return typeof F=="boolean"?F?f.INSTANCE:C.INSTANCE:new I(p,U)}cmp(p){return p.type!==this.type?this.type-p.type:h(this.key,p.key)}equals(p){return p.type===this.type?this.key===p.key:!1}evaluate(p){return!!p.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(p){return p.mapDefined(this.key)}negate(){return this.negated||(this.negated=y.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=I;class u{constructor(p,U,F){this.key=p,this.value=U,this.negated=F,this.type=4}static create(p,U,F=null){if(typeof U=="boolean")return U?I.create(p,F):y.create(p,F);const $=k.get(p);return typeof $=="boolean"?U===($?"true":"false")?f.INSTANCE:C.INSTANCE:new u(p,U,F)}cmp(p){return p.type!==this.type?this.type-p.type:d(this.key,this.value,p.key,p.value)}equals(p){return p.type===this.type?this.key===p.key&&this.value===p.value:!1}evaluate(p){return p.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(p){return p.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=E.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=u;class w{constructor(p,U){this.key=p,this.valueKey=U,this.type=10,this.negated=null}static create(p,U){return new w(p,U)}cmp(p){return p.type!==this.type?this.type-p.type:d(this.key,this.valueKey,p.key,p.valueKey)}equals(p){return p.type===this.type?this.key===p.key&&this.valueKey===p.valueKey:!1}evaluate(p){const U=p.getValue(this.valueKey),F=p.getValue(this.key);return Array.isArray(U)?U.indexOf(F)>=0:typeof F=="string"&&typeof U=="object"&&U!==null?P.call(U,F):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(p){return p.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=g.create(this)),this.negated}}e.ContextKeyInExpr=w;class g{constructor(p){this._actual=p,this.type=11}static create(p){return new g(p)}cmp(p){return p.type!==this.type?this.type-p.type:this._actual.cmp(p._actual)}equals(p){return p.type===this.type?this._actual.equals(p._actual):!1}evaluate(p){return!this._actual.evaluate(p)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(p){return new g(this._actual.map(p))}negate(){return this._actual}}e.ContextKeyNotInExpr=g;class E{constructor(p,U,F){this.key=p,this.value=U,this.negated=F,this.type=5}static create(p,U,F=null){if(typeof U=="boolean")return U?y.create(p,F):I.create(p,F);const $=k.get(p);return typeof $=="boolean"?U===($?"true":"false")?C.INSTANCE:f.INSTANCE:new E(p,U,F)}cmp(p){return p.type!==this.type?this.type-p.type:d(this.key,this.value,p.key,p.value)}equals(p){return p.type===this.type?this.key===p.key&&this.value===p.value:!1}evaluate(p){return p.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(p){return p.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=u.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=E;class y{constructor(p,U){this.key=p,this.negated=U,this.type=3}static create(p,U=null){const F=k.get(p);return typeof F=="boolean"?F?C.INSTANCE:f.INSTANCE:new y(p,U)}cmp(p){return p.type!==this.type?this.type-p.type:h(this.key,p.key)}equals(p){return p.type===this.type?this.key===p.key:!1}evaluate(p){return!p.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(p){return p.mapNot(this.key)}negate(){return this.negated||(this.negated=I.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=y;class S{constructor(p,U,F){this.key=p,this.value=U,this.negated=F,this.type=12}static create(p,U,F=null){return new S(p,U,F)}cmp(p){return p.type!==this.type?this.type-p.type:d(this.key,this.value,p.key,p.value)}equals(p){return p.type===this.type?this.key===p.key&&this.value===p.value:!1}evaluate(p){return parseFloat(p.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(p){return p.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=t.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=S;class o{constructor(p,U,F){this.key=p,this.value=U,this.negated=F,this.type=13}static create(p,U,F=null){return new o(p,U,F)}cmp(p){return p.type!==this.type?this.type-p.type:d(this.key,this.value,p.key,p.value)}equals(p){return p.type===this.type?this.key===p.key&&this.value===p.value:!1}evaluate(p){return parseFloat(p.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(p){return p.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=a.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=o;class a{constructor(p,U,F){this.key=p,this.value=U,this.negated=F,this.type=14}static create(p,U,F=null){return new a(p,U,F)}cmp(p){return p.type!==this.type?this.type-p.type:d(this.key,this.value,p.key,p.value)}equals(p){return p.type===this.type?this.key===p.key&&this.value===p.value:!1}evaluate(p){return parseFloat(p.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(p){return p.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=o.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=a;class t{constructor(p,U,F){this.key=p,this.value=U,this.negated=F,this.type=15}static create(p,U,F=null){return new t(p,U,F)}cmp(p){return p.type!==this.type?this.type-p.type:d(this.key,this.value,p.key,p.value)}equals(p){return p.type===this.type?this.key===p.key&&this.value===p.value:!1}evaluate(p){return parseFloat(p.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(p){return p.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=S.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=t;class s{constructor(p,U){this.key=p,this.regexp=U,this.type=7,this.negated=null}static create(p,U){return new s(p,U)}cmp(p){if(p.type!==this.type)return this.type-p.type;if(this.key<p.key)return-1;if(this.key>p.key)return 1;const U=this.regexp?this.regexp.source:"",F=p.regexp?p.regexp.source:"";return U<F?-1:U>F?1:0}equals(p){if(p.type===this.type){const U=this.regexp?this.regexp.source:"",F=p.regexp?p.regexp.source:"";return this.key===p.key&&U===F}return!1}evaluate(p){let U=p.getValue(this.key);return this.regexp?this.regexp.test(U):!1}serialize(){const p=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${p}`}keys(){return[this.key]}map(p){return p.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=n.create(this)),this.negated}}e.ContextKeyRegexExpr=s;class n{constructor(p){this._actual=p,this.type=8}static create(p){return new n(p)}cmp(p){return p.type!==this.type?this.type-p.type:this._actual.cmp(p._actual)}equals(p){return p.type===this.type?this._actual.equals(p._actual):!1}evaluate(p){return!this._actual.evaluate(p)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(p){return new n(this._actual.map(p))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=n;class r{constructor(p,U){this.expr=p,this.negated=U,this.type=6}static create(p,U){return r._normalizeArr(p,U)}cmp(p){if(p.type!==this.type)return this.type-p.type;if(this.expr.length<p.expr.length)return-1;if(this.expr.length>p.expr.length)return 1;for(let U=0,F=this.expr.length;U<F;U++){const $=i(this.expr[U],p.expr[U]);if($!==0)return $}return 0}equals(p){if(p.type===this.type){if(this.expr.length!==p.expr.length)return!1;for(let U=0,F=this.expr.length;U<F;U++)if(!this.expr[U].equals(p.expr[U]))return!1;return!0}return!1}evaluate(p){for(let U=0,F=this.expr.length;U<F;U++)if(!this.expr[U].evaluate(p))return!1;return!0}static _normalizeArr(p,U){const F=[];let $=!1;for(const H of p)if(!!H){if(H.type===1){$=!0;continue}if(H.type===0)return C.INSTANCE;if(H.type===6){F.push(...H.expr);continue}F.push(H)}if(F.length===0&&$)return f.INSTANCE;if(F.length!==0){if(F.length===1)return F[0];F.sort(i);for(let H=1;H<F.length;H++)F[H-1].equals(F[H])&&(F.splice(H,1),H--);if(F.length===1)return F[0];for(;F.length>1;){const H=F[F.length-1];if(H.type!==9)break;F.pop();const M=F.pop(),j=F.length===0,q=c.create(H.expr.map(z=>r.create([z,M],null)),null,j);q&&(F.push(q),F.sort(i))}return F.length===1?F[0]:new r(F,U)}}serialize(){return this.expr.map(p=>p.serialize()).join(" && ")}keys(){const p=[];for(let U of this.expr)p.push(...U.keys());return p}map(p){return new r(this.expr.map(U=>U.map(p)),null)}negate(){if(!this.negated){const p=[];for(let U of this.expr)p.push(U.negate());this.negated=c.create(p,this,!0)}return this.negated}}class c{constructor(p,U){this.expr=p,this.negated=U,this.type=9}static create(p,U,F){return c._normalizeArr(p,U,F)}cmp(p){if(p.type!==this.type)return this.type-p.type;if(this.expr.length<p.expr.length)return-1;if(this.expr.length>p.expr.length)return 1;for(let U=0,F=this.expr.length;U<F;U++){const $=i(this.expr[U],p.expr[U]);if($!==0)return $}return 0}equals(p){if(p.type===this.type){if(this.expr.length!==p.expr.length)return!1;for(let U=0,F=this.expr.length;U<F;U++)if(!this.expr[U].equals(p.expr[U]))return!1;return!0}return!1}evaluate(p){for(let U=0,F=this.expr.length;U<F;U++)if(this.expr[U].evaluate(p))return!0;return!1}static _normalizeArr(p,U,F){let $=[],H=!1;if(p){for(let M=0,j=p.length;M<j;M++){const q=p[M];if(!!q){if(q.type===0){H=!0;continue}if(q.type===1)return f.INSTANCE;if(q.type===9){$=$.concat(q.expr);continue}$.push(q)}}if($.length===0&&H)return C.INSTANCE;$.sort(i)}if($.length!==0){if($.length===1)return $[0];for(let M=1;M<$.length;M++)$[M-1].equals($[M])&&($.splice(M,1),M--);if($.length===1)return $[0];if(F){for(let M=0;M<$.length;M++)for(let j=M+1;j<$.length;j++)v($[M],$[j])&&($.splice(j,1),j--);if($.length===1)return $[0]}return new c($,U)}}serialize(){return this.expr.map(p=>p.serialize()).join(" || ")}keys(){const p=[];for(let U of this.expr)p.push(...U.keys());return p}map(p){return new c(this.expr.map(U=>U.map(p)),null)}negate(){if(!this.negated){let p=[];for(let U of this.expr)p.push(U.negate());for(;p.length>1;){const U=p.shift(),F=p.shift(),$=[];for(const M of A(U))for(const j of A(F))$.push(r.create([M,j],null));const H=p.length===0;p.unshift(c.create($,null,H))}this.negated=p[0]}return this.negated}}class l extends I{constructor(p,U,F){super(p,null);this._defaultValue=U,typeof F=="object"?l._info.push({...F,key:p}):F!==!0&&l._info.push({key:p,description:F,type:U!=null?typeof U:void 0})}static all(){return l._info.values()}bindTo(p){return p.createKey(this.key,this._defaultValue)}getValue(p){return p.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(p){return u.create(this.key,p)}notEqualsTo(p){return E.create(this.key,p)}}e.RawContextKey=l,l._info=[],e.IContextKeyService=(0,R.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function h(O,p){return O<p?-1:O>p?1:0}function d(O,p,U,F){return O<U?-1:O>U?1:p<F?-1:p>F?1:0}function v(O,p){if(p.type===6&&O.type!==9&&O.type!==6){for(const $ of p.expr)if(O.equals($))return!0}const U=O.negate(),F=A(U).concat(A(p));F.sort(i);for(let $=0;$<F.length;$++){const M=F[$].negate();for(let j=$+1;j<F.length;j++){const q=F[j];if(M.equals(q))return!0}}return!1}e.implies=v;function A(O){return O.type===9?O.expr:[O]}}),define(Z[73],ee([0,1,7]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,D.createDecorator)(e.ID);function T(R){return!!R.hostName&&!!R.errorMessage}e.isRemoteDiagnosticError=T}),define(Z[74],ee([0,1,7]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,D.createDecorator)("downloadService")}),define(Z[12],ee([0,1,7]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,D.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,D.refineServiceDecorator)(e.IEnvironmentService)}),define(Z[28],ee([0,1,18,115,7]),function(K,e,D,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.TargetPlatform=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";var L;(function(y){y.WIN32_X64="win32-x64",y.WIN32_IA32="win32-ia32",y.WIN32_ARM64="win32-arm64",y.LINUX_X64="linux-x64",y.LINUX_ARM64="linux-arm64",y.LINUX_ARMHF="linux-armhf",y.ALPINE_X64="alpine-x64",y.ALPINE_ARM64="alpine-arm64",y.DARWIN_X64="darwin-x64",y.DARWIN_ARM64="darwin-arm64",y.WEB="web",y.UNIVERSAL="universal",y.UNKNOWN="unknown",y.UNDEFINED="undefined"})(L=e.TargetPlatform||(e.TargetPlatform={}));function k(y){switch(y){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=k;function P(y){switch(y){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=P;function m(y,S){switch(y){case 3:return S==="x64"?"win32-x64":S==="ia32"?"win32-ia32":S==="arm64"?"win32-arm64":"unknown";case 2:return S==="x64"?"linux-x64":S==="arm64"?"linux-arm64":S==="arm"?"linux-armhf":"unknown";case"alpine":return S==="x64"?"alpine-x64":S==="arm64"?"alpine-arm64":"unknown";case 1:return S==="x64"?"darwin-x64":S==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=m;function b(y,S){return S==="web"&&!y.includes("web")}e.isNotWebExtensionInWebTargetPlatform=b;function i(y,S,o){return b(S,o)?!1:y==="undefined"||y==="universal"?!0:y==="unknown"?!1:y===o?!0:C(o).includes(y)}e.isTargetPlatformCompatible=i;function C(y){switch(y){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=C;function f(y){return y&&typeof y=="object"&&typeof y.id=="string"&&(!y.uuid||typeof y.uuid=="string")}e.isIExtensionIdentifier=f;var I;(function(y){y[y.NoneOrRelevance=0]="NoneOrRelevance",y[y.LastUpdatedDate=1]="LastUpdatedDate",y[y.Title=2]="Title",y[y.PublisherName=3]="PublisherName",y[y.InstallCount=4]="InstallCount",y[y.PublishedDate=10]="PublishedDate",y[y.AverageRating=6]="AverageRating",y[y.WeightedRating=12]="WeightedRating"})(I=e.SortBy||(e.SortBy={}));var u;(function(y){y[y.Default=0]="Default",y[y.Ascending=1]="Ascending",y[y.Descending=2]="Descending"})(u=e.SortOrder||(e.SortOrder={}));var w;(function(y){y.Install="install",y.Uninstall="uninstall"})(w=e.StatisticType||(e.StatisticType={}));var g;(function(y){y[y.None=0]="None",y[y.Install=1]="Install",y[y.Update=2]="Update"})(g=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,R.createDecorator)("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class E extends Error{constructor(S,o){super(S);this.code=o,this.name=o}}e.ExtensionManagementError=E,e.IExtensionManagementService=(0,R.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,R.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,R.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=D.FileAccess.asBrowserUri("./media/defaultIcon.png",K).toString(!0),e.ExtensionsLabel=(0,T.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,T.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,R.createDecorator)("IExtensionManagementCLIService")});var X=this&&this.__param||function(K,e){return function(D,T){e(D,T,K)}};define(Z[150],ee([0,1,2,28]),function(K,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DeprecatedExtensionsCleaner=void 0;let R=class extends D.Disposable{constructor(k){super();this.extensionManagementService=k,this._register(k),this.cleanUpDeprecatedExtensions()}cleanUpDeprecatedExtensions(){this.extensionManagementService.removeDeprecatedExtensions()}};R=de([X(0,T.IExtensionManagementService)],R),e.DeprecatedExtensionsCleaner=R}),define(Z[151],ee([0,1,3,2,26,5,96,28]),function(K,e,D,T,R,L,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function m(w,g){return L.URI.revive(g?g.transformIncoming(w):w)}function b(w,g){return g?g.transformOutgoingURI(w):w}function i(w,g){g=g||k.DefaultURITransformer;const E=w.manifest;return{...(0,k.transformAndReviveIncomingURIs)({...w,manifest:void 0},g),manifest:E}}function C(w,g){return g?(0,R.cloneAndChange)(w,E=>E instanceof L.URI?g.transformOutgoingURI(E):void 0):w}class f{constructor(g,E){this.service=g,this.getUriTransformer=E,this.onInstallExtension=D.Event.buffer(g.onInstallExtension,!0),this.onDidInstallExtensions=D.Event.buffer(g.onDidInstallExtensions,!0),this.onUninstallExtension=D.Event.buffer(g.onUninstallExtension,!0),this.onDidUninstallExtension=D.Event.buffer(g.onDidUninstallExtension,!0)}listen(g,E){const y=this.getUriTransformer(g);switch(E){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtensions":return D.Event.map(this.onDidInstallExtensions,S=>S.map(o=>({...o,local:o.local?C(o.local,y):o.local})));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(g,E,y){const S=this.getUriTransformer(g);switch(E){case"zip":return this.service.zip(i(y[0],S)).then(o=>b(o,S));case"unzip":return this.service.unzip(m(y[0],S));case"install":return this.service.install(m(y[0],S),y[1]);case"getManifest":return this.service.getManifest(m(y[0],S));case"getTargetPlatform":return this.service.getTargetPlatform();case"canInstall":return this.service.canInstall(y[0]);case"installFromGallery":return this.service.installFromGallery(y[0],y[1]);case"uninstall":return this.service.uninstall(i(y[0],S),y[1]);case"reinstallFromGallery":return this.service.reinstallFromGallery(i(y[0],S));case"getInstalled":return this.service.getInstalled(y[0]).then(o=>o.map(a=>C(a,S)));case"updateMetadata":return this.service.updateMetadata(i(y[0],S),y[1]).then(o=>C(o,S));case"updateExtensionScope":return this.service.updateExtensionScope(i(y[0],S),y[1]).then(o=>C(o,S));case"getExtensionsReport":return this.service.getExtensionsReport()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=f;class I extends T.Disposable{constructor(g){super();this.channel=g,this._onInstallExtension=this._register(new D.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new D.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new D.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new D.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this._register(this.channel.listen("onInstallExtension")(E=>this._onInstallExtension.fire({identifier:E.identifier,source:this.isUriComponents(E.source)?L.URI.revive(E.source):E.source}))),this._register(this.channel.listen("onDidInstallExtensions")(E=>this._onDidInstallExtensions.fire(E.map(y=>({...y,local:y.local?i(y.local,null):y.local,source:this.isUriComponents(y.source)?L.URI.revive(y.source):y.source}))))),this._register(this.channel.listen("onUninstallExtension")(E=>this._onUninstallExtension.fire(E))),this._register(this.channel.listen("onDidUninstallExtension")(E=>this._onDidUninstallExtension.fire(E)))}isUriComponents(g){return g?typeof g.path=="string"&&typeof g.scheme=="string":!1}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=this.channel.call("getTargetPlatform")),this._targetPlatformPromise}async canInstall(g){const E=await this.getTargetPlatform();return g.allTargetPlatforms.some(y=>(0,P.isTargetPlatformCompatible)(y,g.allTargetPlatforms,E))}zip(g){return Promise.resolve(this.channel.call("zip",[g]).then(E=>L.URI.revive(E)))}unzip(g){return Promise.resolve(this.channel.call("unzip",[g]))}install(g,E){return Promise.resolve(this.channel.call("install",[g,E])).then(y=>i(y,null))}getManifest(g){return Promise.resolve(this.channel.call("getManifest",[g]))}installFromGallery(g,E){return Promise.resolve(this.channel.call("installFromGallery",[g,E])).then(y=>i(y,null))}uninstall(g,E){return Promise.resolve(this.channel.call("uninstall",[g,E]))}reinstallFromGallery(g){return Promise.resolve(this.channel.call("reinstallFromGallery",[g]))}getInstalled(g=null){return Promise.resolve(this.channel.call("getInstalled",[g])).then(E=>E.map(y=>i(y,null)))}updateMetadata(g,E){return Promise.resolve(this.channel.call("updateMetadata",[g,E])).then(y=>i(y,null))}updateExtensionScope(g,E){return Promise.resolve(this.channel.call("updateExtensionScope",[g,E])).then(y=>i(y,null))}getExtensionsReport(){return Promise.resolve(this.channel.call("getExtensionsReport"))}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=I;class u{constructor(g){this.service=g}listen(g,E){throw new Error("Invalid listen")}call(g,E,y){switch(E){case"getConfigBasedTips":return this.service.getConfigBasedTips(L.URI.revive(y[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips();case"getAllWorkspacesTips":return this.service.getAllWorkspacesTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=u}),define(Z[75],ee([0,1,7]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSourceToString=e.RecommendationSource=void 0;var T;(function(k){k[k.FILE=1]="FILE",k[k.WORKSPACE=2]="WORKSPACE",k[k.EXE=3]="EXE"})(T=e.RecommendationSource||(e.RecommendationSource={}));function R(k){switch(k){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.RecommendationSourceToString=R;var L;(function(k){k.Ignored="ignored",k.Cancelled="cancelled",k.TooMany="toomany",k.IncompatibleWindow="incompatibleWindow",k.Accepted="reacted"})(L=e.RecommendationsNotificationResult||(e.RecommendationsNotificationResult={})),e.IExtensionRecommendationNotificationService=(0,D.createDecorator)("IExtensionRecommendationNotificationService")}),define(Z[76],ee([0,1,24,7]),function(K,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function R(i){if(typeof i=="object"&&i!==null&&i.supported!==!0)return i.description}e.getWorkspaceSupportTypeMessage=R;function L(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(!i.uuid||typeof i.uuid=="string")}e.isIExtensionIdentifier=L,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var k;(function(i){i[i.System=0]="System",i[i.User=1]="User"})(k=e.ExtensionType||(e.ExtensionType={}));class P{constructor(C){this.value=C,this._lower=C.toLowerCase()}static equals(C,f){if(typeof C=="undefined"||C===null)return typeof f=="undefined"||f===null;if(typeof f=="undefined"||f===null)return!1;if(typeof C=="string"||typeof f=="string"){let I=typeof C=="string"?C:C.value,u=typeof f=="string"?f:f.value;return D.equalsIgnoreCase(I,u)}return C._lower===f._lower}static toKey(C){return typeof C=="string"?C.toLowerCase():C._lower}}e.ExtensionIdentifier=P;function m(i){return i.contributes&&i.contributes.localizations?i.contributes.localizations.length>0:!1}e.isLanguagePackExtension=m;function b(i){return i.contributes&&i.contributes.authentication?i.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=b,e.IBuiltinExtensionsScannerService=(0,T.createDecorator)("IBuiltinExtensionsScannerService")}),define(Z[32],ee([0,1,24,76]),function(K,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function R(u,w){return u.uuid&&w.uuid?u.uuid===w.uuid:u.id===w.id?!0:(0,D.compareIgnoreCase)(u.id,w.id)===0}e.areSameExtensions=R;class L{constructor(w,g){this.version=g,this.id=w.id,this.uuid=w.uuid}key(){return`${this.id}-${this.version}`}equals(w){return w instanceof L?R(this,w)&&this.version===w.version:!1}}e.ExtensionIdentifierWithVersion=L;function k(u,w){return`${u}.${w}`}e.getExtensionId=k;function P(u){return u.toLocaleLowerCase()}e.adoptToGalleryExtensionId=P;function m(u,w){return P(k(u,w))}e.getGalleryExtensionId=m;function b(u,w){const g=[],E=y=>{for(const S of g)if(S.some(o=>R(w(o),w(y))))return S;return null};for(const y of u){const S=E(y);S?S.push(y):g.push([y])}return g}e.groupByExtension=b;function i(u){return{id:u.identifier.id,name:u.manifest.name,galleryId:null,publisherId:u.publisherId,publisherName:u.manifest.publisher,publisherDisplayName:u.publisherDisplayName,dependencies:u.manifest.extensionDependencies&&u.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=i;function C(u){return{id:u.identifier.id,name:u.name,galleryId:u.identifier.uuid,publisherId:u.publisherId,publisherName:u.publisher,publisherDisplayName:u.publisherDisplayName,dependencies:!!(u.properties.dependencies&&u.properties.dependencies.length>0),...u.telemetryData}}e.getGalleryExtensionTelemetryData=C,e.BetterMergeId=new T.ExtensionIdentifier("pprice.better-merge");function f(u){const w=new Set;for(const g of u)g.malicious&&w.add(g.id.id);return w}e.getMaliciousExtensionsSet=f;function I(u,w){const g=[],E=w.manifest.extensionDependencies?.slice(0)??[];for(;E.length;){const y=E.shift();if(y&&g.every(S=>!R(S.identifier,{id:y}))){const S=u.filter(o=>R(o.identifier,{id:y}));S.length===1&&(g.push(S[0]),E.push(...S[0].manifest.extensionDependencies?.slice(0)??[]))}}return g}e.getExtensionDependencies=I}),define(Z[152],ee([0,1,2,8,19,76]),function(K,e,D,T,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class k extends D.Disposable{constructor(m,b){super();this.environmentService=m,this.extensionsManifestCache=(0,T.join)(this.environmentService.userDataPath,L.MANIFEST_CACHE_FOLDER,L.USER_MANIFEST_CACHE_FILE),this._register(b.onDidInstallExtensions(i=>this.onDidInstallExtensions(i))),this._register(b.onDidUninstallExtension(i=>this.onDidUnInstallExtension(i)))}onDidInstallExtensions(m){m.some(b=>!!b.local)&&this.invalidate()}onDidUnInstallExtension(m){m.error||this.invalidate()}invalidate(){R.Promises.rm(this.extensionsManifestCache,R.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=k}),define(Z[13],ee([0,1,40,8,24,17,5,122,7]),function(K,e,D,T,R,L,k,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,m.createDecorator)("fileService");function b(M){return M.create===!0}e.isFileOpenForWriteOptions=b;var i;(function(M){M[M.Unknown=0]="Unknown",M[M.File=1]="File",M[M.Directory=2]="Directory",M[M.SymbolicLink=64]="SymbolicLink"})(i=e.FileType||(e.FileType={}));var C;(function(M){M[M.Readonly=1]="Readonly"})(C=e.FilePermission||(e.FilePermission={}));var f;(function(M){M[M.FileReadWrite=2]="FileReadWrite",M[M.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",M[M.FileReadStream=16]="FileReadStream",M[M.FileFolderCopy=8]="FileFolderCopy",M[M.PathCaseSensitive=1024]="PathCaseSensitive",M[M.Readonly=2048]="Readonly",M[M.Trash=4096]="Trash",M[M.FileWriteUnlock=8192]="FileWriteUnlock"})(f=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function I(M){return!!(M.capabilities&2)}e.hasReadWriteCapability=I;function u(M){return!!(M.capabilities&8)}e.hasFileFolderCopyCapability=u;function w(M){return!!(M.capabilities&4)}e.hasOpenReadWriteCloseCapability=w;function g(M){return!!(M.capabilities&16)}e.hasFileReadStreamCapability=g;var E;(function(M){M.FileExists="EntryExists",M.FileNotFound="EntryNotFound",M.FileNotADirectory="EntryNotADirectory",M.FileIsADirectory="EntryIsADirectory",M.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",M.FileTooLarge="EntryTooLarge",M.FileWriteLocked="EntryWriteLocked",M.NoPermissions="NoPermissions",M.Unavailable="Unavailable",M.Unknown="Unknown"})(E=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class y extends Error{constructor(j,q){super(j);this.code=q}}e.FileSystemProviderError=y;function S(M,j){const q=new y(M.toString(),j);return a(q,j),q}e.createFileSystemProviderError=S;function o(M){return M||S((0,P.localize)(0,null),E.Unknown)}e.ensureFileSystemProviderError=o;function a(M,j){return M.name=j?`${j} (FileSystemError)`:"FileSystemError",M}e.markAsFileSystemProviderError=a;function t(M){if(!M)return E.Unknown;if(M instanceof y)return M.code;const j=/^(.+) \(FileSystemError\)$/.exec(M.name);if(!j)return E.Unknown;switch(j[1]){case E.FileExists:return E.FileExists;case E.FileIsADirectory:return E.FileIsADirectory;case E.FileNotADirectory:return E.FileNotADirectory;case E.FileNotFound:return E.FileNotFound;case E.FileExceedsMemoryLimit:return E.FileExceedsMemoryLimit;case E.FileTooLarge:return E.FileTooLarge;case E.FileWriteLocked:return E.FileWriteLocked;case E.NoPermissions:return E.NoPermissions;case E.Unavailable:return E.Unavailable}return E.Unknown}e.toFileSystemProviderErrorCode=t;function s(M){if(M instanceof d)return M.fileOperationResult;switch(t(M)){case E.FileNotFound:return 1;case E.FileIsADirectory:return 0;case E.FileNotADirectory:return 10;case E.FileWriteLocked:return 5;case E.NoPermissions:return 6;case E.FileExists:return 4;case E.FileExceedsMemoryLimit:return 9;case E.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=s;var n;(function(M){M[M.CREATE=0]="CREATE",M[M.DELETE=1]="DELETE",M[M.MOVE=2]="MOVE",M[M.COPY=3]="COPY"})(n=e.FileOperation||(e.FileOperation={}));class r{constructor(j,q,z){this.resource=j,this.operation=q,this.target=z}isOperation(j){return this.operation===j}}e.FileOperationEvent=r;var c;(function(M){M[M.UPDATED=0]="UPDATED",M[M.ADDED=1]="ADDED",M[M.DELETED=2]="DELETED"})(c=e.FileChangeType||(e.FileChangeType={}));class l{constructor(j,q){this.added=void 0,this.updated=void 0,this.deleted=void 0;for(const z of j)switch(z.type){case 1:this.added||(this.added=D.TernarySearchTree.forUris(()=>q)),this.added.set(z.resource,z);break;case 0:this.updated||(this.updated=D.TernarySearchTree.forUris(()=>q)),this.updated.set(z.resource,z);break;case 2:this.deleted||(this.deleted=D.TernarySearchTree.forUris(()=>q)),this.deleted.set(z.resource,z);break}}contains(j,...q){return this.doContains(j,{includeChildren:!1},...q)}affects(j,...q){return this.doContains(j,{includeChildren:!0},...q)}doContains(j,q,...z){if(!j)return!1;const x=z.length>0;return!!((!x||z.includes(1))&&(this.added?.get(j)||q.includeChildren&&this.added?.findSuperstr(j))||(!x||z.includes(0))&&(this.updated?.get(j)||q.includeChildren&&this.updated?.findSuperstr(j))||(!x||z.includes(2))&&(this.deleted?.findSubstr(j)||q.includeChildren&&this.deleted?.findSuperstr(j)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=l;function h(M,j,q){return!M||!j||M===j||j.length>M.length?!1:(j.charAt(j.length-1)!==T.sep&&(j+=T.sep),q?(0,R.startsWithIgnoreCase)(M,j):M.indexOf(j)===0)}e.isParent=h;class d extends Error{constructor(j,q,z){super(j);this.fileOperationResult=q,this.options=z}}e.FileOperationError=d;class v extends d{constructor(j,q,z){super(j,2,z);this.stat=q}}e.NotModifiedSinceFileOperationError=v;var A;(function(M){M[M.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",M[M.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",M[M.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",M[M.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",M[M.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",M[M.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",M[M.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",M[M.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",M[M.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",M[M.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",M[M.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",M[M.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(A=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var O;(function(M){M[M.FILE=0]="FILE",M[M.FOLDER=1]="FOLDER",M[M.ROOT_FOLDER=2]="ROOT_FOLDER"})(O=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function p(M){if(!(typeof M.size!="number"||typeof M.mtime!="number"))return M.mtime.toString(29)+M.size.toString(31)}e.etag=p;async function U(M,j){if(!j.canHandleResource(k.URI.from({scheme:M.scheme})))return new Promise(q=>{const z=j.onDidChangeFileSystemProviderRegistrations(x=>{x.scheme===M.scheme&&x.added&&(z.dispose(),q())})})}e.whenProviderRegistered=U,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class F{static formatSize(j){return(0,L.isNumber)(j)||(j=0),j<F.KB?(0,P.localize)(1,null,j.toFixed(0)):j<F.MB?(0,P.localize)(2,null,(j/F.KB).toFixed(2)):j<F.GB?(0,P.localize)(3,null,(j/F.MB).toFixed(2)):j<F.TB?(0,P.localize)(4,null,(j/F.GB).toFixed(2)):(0,P.localize)(5,null,(j/F.TB).toFixed(2))}}e.ByteSize=F,F.KB=1024,F.MB=F.KB*F.KB,F.GB=F.MB*F.KB,F.TB=F.GB*F.KB;var $;(function(M){M[M.IA32=0]="IA32",M[M.OTHER=1]="OTHER"})($=e.Arch||(e.Arch={}));function H(M){return{maxFileSize:M===0?300*F.MB:16*F.GB,maxHeapSize:M===0?700*F.MB:2*700*F.MB}}e.getPlatformLimits=H}),define(Z[153],ee([0,1,154,50,13]),function(K,e,D,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let L=class{constructor(P){this.fileService=P}checksum(P){return new Promise(async(m,b)=>{const i=(0,D.createHash)("md5"),C=(await this.fileService.readFileStream(P)).value;(0,T.listenStream)(C,{onData:f=>i.update(f.buffer),onError:f=>b(f),onEnd:()=>m(i.digest("base64").replace(/=+$/,""))})})}};L=de([X(0,R.IFileService)],L),e.ChecksumService=L}),define(Z[155],ee([0,1,221,113,135,13]),function(K,e,D,T,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;function k(f,I){const u={onUnknownOption:g=>{console.warn((0,T.localize)(0,null,g))},onMultipleValues:(g,E)=>{console.warn((0,T.localize)(1,null,g,E))}},w=(0,R.parseArgs)(f,R.OPTIONS,I?u:void 0);return w.goto&&w._.forEach(g=>D(/^(\w:)?[^:]+(:\d*){0,2}$/.test(g),(0,T.localize)(2,null))),w["max-memory"]&&D(parseInt(w["max-memory"])>=L.MIN_MAX_MEMORY_SIZE_MB,`The max-memory argument cannot be specified lower than ${L.MIN_MAX_MEMORY_SIZE_MB} MB.`),w}function P(f){const I=f.findIndex(u=>!/^-/.test(u));if(I>-1)return[...f.slice(0,I),...f.slice(I+1)]}function m(f){let[,...I]=f;process.env.VSCODE_DEV&&(I=P(I)||[]);const u=!C(process.env);return k(I,u)}e.parseMainProcessArgv=m;function b(f){const[,,...I]=f;return k(I,!0)}e.parseCLIProcessArgv=b;function i(f,...I){const u=f.indexOf("--");return u===-1?f.push(...I):f.splice(u,0,...I),f}e.addArg=i;function C(f){return f.VSCODE_CLI==="1"}e.isLaunchedFromCli=C}),define(Z[156],ee([0,1,41,137,27,37,9,4,30,109,155]),function(K,e,D,T,R,L,k,P,m,b,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveShellEnv=void 0;async function C(u,w,g){return w["force-disable-user-env"]?(u.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):P.isWindows?(u.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,i.isLaunchedFromCli)(g)&&!w["force-user-env"]?(u.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,i.isLaunchedFromCli)(g)?u.trace("resolveShellEnv(): running (--force-user-env)"):u.trace("resolveShellEnv(): running (macOS/Linux)"),f||(f=new Promise(async E=>{const y=new R.CancellationTokenSource,S=setTimeout(()=>{u.error("[resolve shell env] Could not resolve shell environment within 10 seconds. Proceeding without shell environment..."),y.dispose(!0),E({})},1e4);try{const o=await I(u,y.token);E(o)}catch(o){(0,k.isPromiseCanceledError)(o)||u.error(`[resolve shell env] Unable to resolve shell environment (${o}). Proceeding without shell environment...`),E({})}finally{clearTimeout(S),y.dispose()}})),f)}e.resolveShellEnv=C;let f;async function I(u,w){const g=new Promise(async(E,y)=>{const S=process.env.ELECTRON_RUN_AS_NODE;u.trace("getUnixShellEnvironment#runAsNode",S);const o=process.env.ELECTRON_NO_ATTACH_CONSOLE;u.trace("getUnixShellEnvironment#noAttach",o);const a=(0,m.generateUuid)().replace(/-/g,"").substr(0,12),t=new RegExp(a+"(.*)"+a),s={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};u.trace("getUnixShellEnvironment#env",s);const n=await(0,b.getSystemShell)(P.OS,s);if(u.trace("getUnixShellEnvironment#shell",n),w.isCancellationRequested)return y(k.canceled);const r=T.basename(n);let c,l;/^pwsh(-preview)?$/.test(r)?(c=`& '${process.execPath}' -p '''${a}'' + JSON.stringify(process.env) + ''${a}'''`,l=["-Login","-Command"]):(c=`'${process.execPath}' -p '"${a}" + JSON.stringify(process.env) + "${a}"'`,l=["-ilc"]),u.trace("getUnixShellEnvironment#spawn",JSON.stringify(l),c);const h=(0,D.spawn)(n,[...l,c],{detached:!0,stdio:["ignore","pipe","pipe"],env:s});w.onCancellationRequested(()=>(h.kill(),y(k.canceled))),h.on("error",A=>{u.error("getUnixShellEnvironment#errorChildProcess",(0,L.toErrorMessage)(A)),E({})});const d=[];h.stdout.on("data",A=>d.push(A));const v=[];h.stderr.on("data",A=>v.push(A)),h.on("close",(A,O)=>{const p=Buffer.concat(d).toString("utf8");u.trace("getUnixShellEnvironment#raw",p);const U=Buffer.concat(v).toString("utf8");if(U.trim()&&u.trace("getUnixShellEnvironment#stderr",U),A||O)return y(new Error(`Failed to get environment (code ${A}, signal ${O})`));const F=t.exec(p),$=F?F[1]:"{}";try{const H=JSON.parse($);S?H.ELECTRON_RUN_AS_NODE=S:delete H.ELECTRON_RUN_AS_NODE,o?H.ELECTRON_NO_ATTACH_CONSOLE=o:delete H.ELECTRON_NO_ATTACH_CONSOLE,delete H.XDG_RUNTIME_DIR,u.trace("getUnixShellEnvironment#result",H),E(H)}catch(H){u.error("getUnixShellEnvironment#errorCaught",(0,L.toErrorMessage)(H)),y(H)}})});try{return await g}catch(E){return u.error("getUnixShellEnvironment#error",(0,L.toErrorMessage)(E)),{}}}}),define(Z[77],ee([0,1,4,5,13]),function(K,e,D,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeFileChanges=e.toFileChanges=void 0;function L(m){return m.map(b=>({type:b.type,resource:T.URI.file(b.path)}))}e.toFileChanges=L;function k(m){const b=new P;for(const i of m)b.processEvent(i);return b.normalize()}e.normalizeFileChanges=k;class P{constructor(){this.normalized=[],this.mapPathToChange=new Map}processEvent(b){const i=this.mapPathToChange.get(b.path);if(i){const C=i.type,f=b.type;C===1&&f===2?(this.mapPathToChange.delete(b.path),this.normalized.splice(this.normalized.indexOf(i),1)):C===2&&f===1?i.type=0:C===1&&f===0||(i.type=f)}else this.normalized.push(b),this.mapPathToChange.set(b.path,b)}normalize(){const b=[],i=[];return this.normalized.filter(C=>C.type!==2?(b.push(C),!1):!0).sort((C,f)=>C.path.length-f.path.length).filter(C=>i.some(f=>(0,R.isParent)(C.path,f,!D.isLinux))?!1:(i.push(C.path),!0)).concat(b)}}}),define(Z[157],ee([0,1,6,2,8,99,19,101,77]),function(K,e,D,T,R,L,k,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class b extends T.Disposable{constructor(C,f,I,u){super();this.path=C,this.onDidFilesChange=f,this.onLogMessage=I,this.verboseLogging=u,this.fileChangesDelayer=this._register(new D.ThrottledDelayer(P.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(C){this.verboseLogging=C}async startWatching(){try{const{stat:C,symbolicLink:f}=await k.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let I=this.path;if(f)try{I=await(0,L.realpath)(I)}catch(u){if(this.onError(u),f.dangling)return}C.isDirectory()?this._register((0,P.watchFolder)(I,(u,w)=>{this.onFileChange({type:u==="changed"?0:u==="added"?1:2,path:(0,R.join)(this.path,(0,R.basename)(w))})},u=>this.onError(u))):this._register((0,P.watchFile)(I,u=>{this.onFileChange({type:u==="changed"?0:2,path:this.path})},u=>this.onError(u)))}catch(C){C.code!=="ENOENT"&&this.onError(C)}}onFileChange(C){this.fileChangesBuffer.push(C),this.verboseLogging&&this.onVerbose(`${C.type===1?"[ADDED]":C.type===2?"[DELETED]":"[CHANGED]"} ${C.path}`),this.fileChangesDelayer.trigger(async()=>{const f=this.fileChangesBuffer;this.fileChangesBuffer=[];const I=(0,m.normalizeFileChanges)(f);if(this.verboseLogging)for(const u of I)this.onVerbose(`>> normalized ${u.type===1?"[ADDED]":u.type===2?"[DELETED]":"[CHANGED]"} ${u.path}`);I.length>0&&this.onDidFilesChange(I)})}onError(C){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${C}`})}onVerbose(C){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${C}`})}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=b}),define(Z[78],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class D{constructor(...R){this._entries=new Map;for(let[L,k]of R)this.set(L,k)}set(R,L){const k=this._entries.get(R);return this._entries.set(R,L),k}has(R){return this._entries.has(R)}get(R){return this._entries.get(R)}}e.ServiceCollection=D}),define(Z[158],ee([0,1,6,9,53,147,7,78]),function(K,e,D,T,R,L,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const m=!1;class b extends Error{constructor(u){super("cyclic dependency between services");this.message=u.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${u.toString()}`}}class i{constructor(u=new P.ServiceCollection,w=!1,g){this._activeInstantiations=new Set,this._services=u,this._strict=w,this._parent=g,this._services.set(k.IInstantiationService,this)}createChild(u){return new i(u,this._strict,this)}invokeFunction(u,...w){let g=f.traceInvocation(u),E=!1;try{return u({get:(S,o)=>{if(E)throw(0,T.illegalState)("service accessor is only valid during the invocation of its target method");const a=this._getOrCreateServiceInstance(S,g);if(!a&&o!==k.optional)throw new Error(`[invokeFunction] unknown service '${S}'`);return a}},...w)}finally{E=!0,g.stop()}}createInstance(u,...w){let g,E;return u instanceof R.SyncDescriptor?(g=f.traceCreation(u.ctor),E=this._createInstance(u.ctor,u.staticArguments.concat(w),g)):(g=f.traceCreation(u),E=this._createInstance(u,w,g)),g.stop(),E}_createInstance(u,w=[],g){let E=k._util.getServiceDependencies(u).sort((o,a)=>o.index-a.index),y=[];for(const o of E){let a=this._getOrCreateServiceInstance(o.id,g);if(!a&&this._strict&&!o.optional)throw new Error(`[createInstance] ${u.name} depends on UNKNOWN service ${o.id}.`);y.push(a)}let S=E.length>0?E[0].index:w.length;if(w.length!==S){console.warn(`[createInstance] First service dependency of ${u.name} at position ${S+1} conflicts with ${w.length} static arguments`);let o=S-w.length;o>0?w=w.concat(new Array(o)):w=w.slice(0,S)}return new u(...[...w,...y])}_setServiceInstance(u,w){if(this._services.get(u)instanceof R.SyncDescriptor)this._services.set(u,w);else if(this._parent)this._parent._setServiceInstance(u,w);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(u){let w=this._services.get(u);return!w&&this._parent?this._parent._getServiceInstanceOrDescriptor(u):w}_getOrCreateServiceInstance(u,w){let g=this._getServiceInstanceOrDescriptor(u);return g instanceof R.SyncDescriptor?this._safeCreateAndCacheServiceInstance(u,g,w.branch(u,!0)):(w.branch(u,!1),g)}_safeCreateAndCacheServiceInstance(u,w,g){if(this._activeInstantiations.has(u))throw new Error(`illegal state - RECURSIVELY instantiating service '${u}'`);this._activeInstantiations.add(u);try{return this._createAndCacheServiceInstance(u,w,g)}finally{this._activeInstantiations.delete(u)}}_createAndCacheServiceInstance(u,w,g){const E=new L.Graph(o=>o.id.toString());let y=0;const S=[{id:u,desc:w,_trace:g}];for(;S.length;){const o=S.pop();if(E.lookupOrInsertNode(o),y++>1e3)throw new b(E);for(let a of k._util.getServiceDependencies(o.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(a.id);if(!t&&!a.optional&&console.warn(`[createInstance] ${u} depends on ${a.id} which is NOT registered.`),t instanceof R.SyncDescriptor){const s={id:a.id,desc:t,_trace:o._trace.branch(a.id,!0)};E.insertEdge(o,s),S.push(s)}}}for(;;){const o=E.roots();if(o.length===0){if(!E.isEmpty())throw new b(E);break}for(const{data:a}of o){if(this._getServiceInstanceOrDescriptor(a.id)instanceof R.SyncDescriptor){const s=this._createServiceInstanceWithOwner(a.id,a.desc.ctor,a.desc.staticArguments,a.desc.supportsDelayedInstantiation,a._trace);this._setServiceInstance(a.id,s)}E.removeNode(a)}}return this._getServiceInstanceOrDescriptor(u)}_createServiceInstanceWithOwner(u,w,g=[],E,y){if(this._services.get(u)instanceof R.SyncDescriptor)return this._createServiceInstance(w,g,E,y);if(this._parent)return this._parent._createServiceInstanceWithOwner(u,w,g,E,y);throw new Error(`illegalState - creating UNKNOWN service instance ${w.name}`)}_createServiceInstance(u,w=[],g,E){if(g){const y=new D.IdleValue(()=>this._createInstance(u,w,E));return new Proxy(Object.create(null),{get(S,o){if(o in S)return S[o];let a=y.value,t=a[o];return typeof t!="function"||(t=t.bind(a),S[o]=t),t},set(S,o,a){return y.value[o]=a,!0}})}else return this._createInstance(u,w,E)}}e.InstantiationService=i;var C;(function(I){I[I.Creation=0]="Creation",I[I.Invocation=1]="Invocation",I[I.Branch=2]="Branch"})(C||(C={}));class f{constructor(u,w){this.type=u,this.name=w,this._start=Date.now(),this._dep=[]}static traceInvocation(u){return m?new f(1,u.name||u.toString().substring(0,42).replace(/\n/g,"")):f._None}static traceCreation(u){return m?new f(0,u.name):f._None}branch(u,w){let g=new f(2,u.toString());return this._dep.push([u,w,g]),g}stop(){let u=Date.now()-this._start;f._totals+=u;let w=!1;function g(y,S){let o=[],a=new Array(y+1).join("	");for(const[t,s,n]of S._dep)if(s&&n){w=!0,o.push(`${a}CREATES -> ${t}`);let r=g(y+1,n);r&&o.push(r)}else o.push(`${a}uses -> ${t}`);return o.join(`
`)}let E=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${g(1,this)}`,`DONE, took ${u.toFixed(2)}ms (grand total ${f._totals.toFixed(2)}ms)`];(u>2||w)&&console.log(E.join(`
`))}}f._None=new class extends f{constructor(){super(-1,null)}stop(){}branch(){return this}},f._totals=0}),define(Z[159],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MessagePortMainProcessService=void 0;class D{constructor(R,L){this.server=R,this.router=L}getChannel(R){return this.server.getChannel(R,this.router)}registerChannel(R,L){this.server.registerChannel(R,L)}}e.MessagePortMainProcessService=D}),define(Z[160],ee([0,1,36,53,146,7]),function(K,e,D,T,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerSharedProcessRemoteService=e.ISharedProcessService=e.registerMainProcessRemoteService=e.IMainProcessService=void 0;class k{constructor(I,u,w){const g=w.getChannel(I);return P(u)?new u.channelClientCtor(g):D.ProxyChannel.toService(g,u?.proxyOptions)}}function P(f){return!!f?.channelClientCtor}e.IMainProcessService=(0,L.createDecorator)("mainProcessService");let m=class extends k{constructor(I,u,w){super(I,u,w)}};m=de([X(2,e.IMainProcessService)],m);function b(f,I,u){(0,R.registerSingleton)(f,new T.SyncDescriptor(m,[I,u],u?.supportsDelayedInstantiation))}e.registerMainProcessRemoteService=b,e.ISharedProcessService=(0,L.createDecorator)("sharedProcessService");let i=class extends k{constructor(I,u,w){super(I,u,w)}};i=de([X(2,e.ISharedProcessService)],i);function C(f,I,u){(0,R.registerSingleton)(f,new T.SyncDescriptor(i,[I,u],u?.supportsDelayedInstantiation))}e.registerSharedProcessRemoteService=C}),define(Z[57],ee([0,1,7]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isValidLocalization=e.ILocalizationsService=void 0,e.ILocalizationsService=(0,D.createDecorator)("localizationsService");function T(R){if(typeof R.languageId!="string"||!Array.isArray(R.translations)||R.translations.length===0)return!1;for(const L of R.translations)if(typeof L.id!="string"||typeof L.path!="string")return!1;return!(R.languageName&&typeof R.languageName!="string"||R.localizedLanguageName&&typeof R.localizedLanguageName!="string")}e.isValidLocalization=T}),define(Z[161],ee([0,1,2,57]),function(K,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let R=class extends D.Disposable{constructor(k){super();this.localizationsService=k,this.updateLocalizations()}updateLocalizations(){this.localizationsService.update()}};R=de([X(0,T.ILocalizationsService)],R),e.LocalizationsUpdater=R}),define(Z[14],ee([0,1,37,3,2,4,7]),function(K,e,D,T,R,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,k.createDecorator)("logService"),e.ILoggerService=(0,k.createDecorator)("loggerService");function P(){return new Date().toISOString()}var m;(function(a){a[a.Trace=0]="Trace",a[a.Debug=1]="Debug",a[a.Info=2]="Info",a[a.Warning=3]="Warning",a[a.Error=4]="Error",a[a.Critical=5]="Critical",a[a.Off=6]="Off"})(m=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=m.Info;class b extends R.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new T.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=b;class i extends b{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...s){this.checkLogLevel(m.Trace)&&this.log(m.Trace,this.format([t,...s]))}debug(t,...s){this.checkLogLevel(m.Debug)&&this.log(m.Debug,this.format([t,...s]))}info(t,...s){this.checkLogLevel(m.Info)&&this.log(m.Info,this.format([t,...s]))}warn(t,...s){this.checkLogLevel(m.Warning)&&this.log(m.Warning,this.format([t,...s]))}error(t,...s){if(this.checkLogLevel(m.Error))if(t instanceof Error){const n=Array.prototype.slice.call(arguments);n[0]=t.stack,this.log(m.Error,this.format(n))}else this.log(m.Error,this.format([t,...s]))}critical(t,...s){this.checkLogLevel(m.Critical)&&this.log(m.Critical,this.format([t,...s]))}flush(){}format(t){let s="";for(let n=0;n<t.length;n++){let r=t[n];if(typeof r=="object")try{r=JSON.stringify(r)}catch(c){}s+=(n>0?" ":"")+r}return s}}e.AbstractMessageLogger=i;class C extends b{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!L.isWindows}trace(t,...s){this.getLevel()<=m.Trace&&(this.useColors?console.log(`[90m[main ${P()}][0m`,t,...s):console.log(`[main ${P()}]`,t,...s))}debug(t,...s){this.getLevel()<=m.Debug&&(this.useColors?console.log(`[90m[main ${P()}][0m`,t,...s):console.log(`[main ${P()}]`,t,...s))}info(t,...s){this.getLevel()<=m.Info&&(this.useColors?console.log(`[90m[main ${P()}][0m`,t,...s):console.log(`[main ${P()}]`,t,...s))}warn(t,...s){this.getLevel()<=m.Warning&&(this.useColors?console.warn(`[93m[main ${P()}][0m`,t,...s):console.warn(`[main ${P()}]`,t,...s))}error(t,...s){this.getLevel()<=m.Error&&(this.useColors?console.error(`[91m[main ${P()}][0m`,t,...s):console.error(`[main ${P()}]`,t,...s))}critical(t,...s){this.getLevel()<=m.Critical&&(this.useColors?console.error(`[90m[main ${P()}][0m`,t,...s):console.error(`[main ${P()}]`,t,...s))}dispose(){}flush(){}}e.ConsoleMainLogger=C;class f extends b{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...s){this.getLevel()<=m.Trace&&console.log("%cTRACE","color: #888",t,...s)}debug(t,...s){this.getLevel()<=m.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...s)}info(t,...s){this.getLevel()<=m.Info&&console.log("%c INFO","color: #33f",t,...s)}warn(t,...s){this.getLevel()<=m.Warning&&console.log("%c WARN","color: #993",t,...s)}error(t,...s){this.getLevel()<=m.Error&&console.log("%c  ERR","color: #f33",t,...s)}critical(t,...s){this.getLevel()<=m.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...s)}dispose(){}flush(){}}e.ConsoleLogger=f;class I extends b{constructor(t,s=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(s)}trace(t,...s){this.getLevel()<=m.Trace&&this.adapter.log(m.Trace,[this.extractMessage(t),...s])}debug(t,...s){this.getLevel()<=m.Debug&&this.adapter.log(m.Debug,[this.extractMessage(t),...s])}info(t,...s){this.getLevel()<=m.Info&&this.adapter.log(m.Info,[this.extractMessage(t),...s])}warn(t,...s){this.getLevel()<=m.Warning&&this.adapter.log(m.Warning,[this.extractMessage(t),...s])}error(t,...s){this.getLevel()<=m.Error&&this.adapter.log(m.Error,[this.extractMessage(t),...s])}critical(t,...s){this.getLevel()<=m.Critical&&this.adapter.log(m.Critical,[this.extractMessage(t),...s])}extractMessage(t){return typeof t=="string"?t:(0,D.toErrorMessage)(t,this.getLevel()<=m.Trace)}dispose(){}flush(){}}e.AdapterLogger=I;class u extends b{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const s of this.logServices)s.setLevel(t);super.setLevel(t)}trace(t,...s){for(const n of this.logServices)n.trace(t,...s)}debug(t,...s){for(const n of this.logServices)n.debug(t,...s)}info(t,...s){for(const n of this.logServices)n.info(t,...s)}warn(t,...s){for(const n of this.logServices)n.warn(t,...s)}error(t,...s){for(const n of this.logServices)n.error(t,...s)}critical(t,...s){for(const n of this.logServices)n.critical(t,...s)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=u;class w extends R.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...s){this.logger.trace(t,...s)}debug(t,...s){this.logger.debug(t,...s)}info(t,...s){this.logger.info(t,...s)}warn(t,...s){this.logger.warn(t,...s)}error(t,...s){this.logger.error(t,...s)}critical(t,...s){this.logger.critical(t,...s)}flush(){this.logger.flush()}}e.LogService=w;class g extends R.Disposable{constructor(t,s){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(s(n=>{this.logLevel=n,this.logLevelChangeableLoggers.forEach(r=>r.setLevel(n))}))}getLogger(t){return this.loggers.get(t.toString())}createLogger(t,s){let n=this.loggers.get(t.toString());return n||(n=this.doCreateLogger(t,s?.always?m.Trace:this.logLevel,s),this.loggers.set(t.toString(),n),s?.always||this.logLevelChangeableLoggers.push(n)),n}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=g;class E{constructor(){this.onDidChangeLogLevel=new T.Emitter().event}setLevel(t){}getLevel(){return m.Info}trace(t,...s){}debug(t,...s){}info(t,...s){}warn(t,...s){}error(t,...s){}critical(t,...s){}dispose(){}flush(){}}e.NullLogService=E;function y(a){if(a.verbose)return m.Trace;if(typeof a.logLevel=="string"){const t=S(a.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=y;function S(a){switch(a){case"trace":return m.Trace;case"debug":return m.Debug;case"info":return m.Info;case"warn":return m.Warning;case"error":return m.Error;case"critical":return m.Critical;case"off":return m.Off}}e.parseLogLevel=S;function o(a){switch(a){case m.Trace:return"trace";case m.Debug:return"debug";case m.Info:return"info";case m.Warning:return"warn";case m.Error:return"error";case m.Critical:return"critical";case m.Off:return"off"}}e.LogLevelToString=o}),define(Z[162],ee([0,1,6,9,2,8,19,12,14]),function(K,e,D,T,R,L,k,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let b=class extends R.Disposable{constructor(C,f){super();this.environmentService=C,this.logService=f,this._register(new D.RunOnceScheduler(()=>{this.cleanUpOldLogs()},10*1e3)).schedule()}async cleanUpOldLogs(){this.logService.info("[logs cleanup]: Starting to clean up old logs.");try{const C=(0,L.basename)(this.environmentService.logsPath),f=(0,L.dirname)(this.environmentService.logsPath),w=(await k.Promises.readdir(f)).filter(E=>/^\d{8}T\d{6}$/.test(E)).sort().filter(E=>E!==C),g=w.slice(0,Math.max(0,w.length-9));g.length>0&&(this.logService.info(`[logs cleanup]: Removing log folders '${g.join(", ")}'`),await Promise.all(g.map(E=>k.Promises.rm((0,L.join)(f,E)))))}catch(C){(0,T.onUnexpectedError)(C)}}};b=de([X(0,P.IEnvironmentService),X(1,m.ILogService)],b),e.LogsDataCleaner=b}),define(Z[163],ee([0,1,6,9,2,8,19,12,14]),function(K,e,D,T,R,L,k,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDataCleaner=void 0;let b=class ut extends R.Disposable{constructor(C,f,I){super();this.backupWorkspacesPath=C,this.environmentService=f,this.logService=I,this._register(new D.RunOnceScheduler(()=>{this.cleanUpStorage()},30*1e3)).schedule()}async cleanUpStorage(){this.logService.info("[storage cleanup]: Starting to clean up storage folders.");try{const C=await k.Promises.readFile(this.backupWorkspacesPath,"utf8"),I=JSON.parse(C).emptyWorkspaceInfos.map(w=>w.backupFolder),u=await k.Promises.readdir(this.environmentService.workspaceStorageHome.fsPath);await Promise.all(u.map(async w=>{w.length!==ut.NON_EMPTY_WORKSPACE_ID_LENGTH&&I.indexOf(w)===-1&&(this.logService.info(`[storage cleanup]: Deleting storage folder ${w}.`),await k.Promises.rm((0,L.join)(this.environmentService.workspaceStorageHome.fsPath,w)))}))}catch(C){(0,T.onUnexpectedError)(C)}}};b.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4,b=de([X(1,P.INativeEnvironmentService),X(2,m.ILogService)],b),e.StorageDataCleaner=b}),define(Z[164],ee([0,1,6,9,2,4,15,58,5,30,19,12,28,32,13,14]),function(K,e,D,T,R,L,k,P,m,b,i,C,f,I,u,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;const g=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let E=class extends R.Disposable{constructor(S,o,a,t){super();this.fileService=o,this.extensionGalleryService=a,this.logService=t,this.extensionsDownloadDir=m.URI.file(S.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(S,o){await this.cleanUpPromise;const a=this.getName(S),t=(0,k.joinPath)(this.extensionsDownloadDir,a);if(!await this.fileService.exists(t)){const s=(0,k.joinPath)(this.extensionsDownloadDir,`.${(0,b.generateUuid)()}`);await this.fileService.exists(s)||await this.extensionGalleryService.download(S,s,o);try{await this.rename(s,t,Date.now()+2*60*1e3)}catch(n){try{await this.fileService.del(s)}catch(r){}if(n.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",S.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,T.getErrorMessage)(n)}. Deleted the vsix from downloaded location`,s.path),n}}return t}async delete(S){}async rename(S,o,a){try{await i.Promises.rename(S.fsPath,o.fsPath)}catch(t){if(L.isWindows&&t&&t.code==="EPERM"&&Date.now()<a)return this.logService.info(`Failed renaming ${S} to ${o} with 'EPERM' error. Trying again...`),this.rename(S,o,a);throw t}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const S=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(S.children){const o=[],a=[];for(const n of S.children){const r=this.parse(n.name);r&&a.push([r,n])}const t=(0,I.groupByExtension)(a,([n])=>n),s=[];for(const n of t)n.sort((r,c)=>P.rcompare(r[0].version,c[0].version)),o.push(...n.slice(1).map(r=>r[1].resource)),s.push(n[0][1]);s.sort((n,r)=>n.mtime-r.mtime),o.push(...s.slice(0,Math.max(0,s.length-this.cache)).map(n=>n.resource)),await D.Promises.settled(o.map(n=>(this.logService.trace("Deleting vsix from cache",n.path),this.fileService.del(n))))}}catch(S){this.logService.error(S)}}getName(S){return this.cache?`${new I.ExtensionIdentifierWithVersion(S.identifier,S.version).key().toLowerCase()}${S.properties.targetPlatform!=="undefined"?`-${S.properties.targetPlatform}`:""}`:(0,b.generateUuid)()}parse(S){const o=g.exec(S);return o&&o[1]&&o[2]?new I.ExtensionIdentifierWithVersion({id:o[1]},o[2]):null}};E=de([X(0,C.INativeEnvironmentService),X(1,u.IFileService),X(2,f.IExtensionGalleryService),X(3,w.ILogService)],E),e.ExtensionsDownloader=E}),define(Z[165],ee([0,1,41,6,37,3,2,18,8,19,12,14]),function(K,e,D,T,R,L,k,P,m,b,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let f=class extends k.Disposable{constructor(u,w){super();this.environmentService=u,this.logService=w,this.processesLimiter=new T.Limiter(5)}async postUninstall(u){const w=this.parseScript(u,"uninstall");return w&&(this.logService.info(u.identifier.id,u.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(w.script,"uninstall",w.args,!0,u).then(()=>this.logService.info(u.identifier.id,u.manifest.version,"Finished running post uninstall script"),g=>this.logService.error(u.identifier.id,u.manifest.version,`Failed to run post uninstall script: ${g}`)))),b.Promises.rm(this.getExtensionStoragePath(u)).then(void 0,g=>this.logService.error("Error while removing extension storage path",g))}parseScript(u,w){const g=`vscode:${w}`;if(u.location.scheme===P.Schemas.file&&u.manifest&&u.manifest.scripts&&typeof u.manifest.scripts[g]=="string"){const E=u.manifest.scripts[g].split(" ");return E.length<2||E[0]!=="node"||!E[1]?(this.logService.warn(u.identifier.id,u.manifest.version,`${g} should be a node script`),null):{script:(0,m.join)(u.location.fsPath,E[1]),args:E.slice(2)||[]}}return null}runLifecycleHook(u,w,g,E,y){return new Promise((S,o)=>{const a=this.start(u,w,g,y);let t;const s=n=>{t&&(clearTimeout(t),t=null),n?o(n):S(void 0)};a.on("error",n=>{s((0,R.toErrorMessage)(n)||"Unknown")}),a.on("exit",(n,r)=>{s(n?`post-${w} process exited with code ${n}`:void 0)}),E&&(t=setTimeout(()=>{t=null,a.kill(),o("timed out")},5e3))})}start(u,w,g,E){const y={silent:!0,execArgv:void 0},S=(0,D.fork)(u,[`--type=extension-post-${w}`,...g],y);S.stdout.setEncoding("utf8"),S.stderr.setEncoding("utf8");const o=L.Event.fromNodeEventEmitter(S.stdout,"data"),a=L.Event.fromNodeEventEmitter(S.stderr,"data");o(n=>this.logService.info(E.identifier.id,E.manifest.version,`post-${w}`,n)),a(n=>this.logService.error(E.identifier.id,E.manifest.version,`post-${w}`,n));const t=L.Event.any(L.Event.map(o,n=>({data:`%c${n}`,format:[""]})),L.Event.map(a,n=>({data:`%c${n}`,format:["color: red"]})));return L.Event.debounce(t,(n,r)=>n?{data:n.data+r.data,format:[...n.format,...r.format]}:{data:r.data,format:r.format},100)(n=>{console.group(E.identifier.id),console.log(n.data,...n.format),console.groupEnd()}),S}getExtensionStoragePath(u){return(0,m.join)(this.environmentService.globalStorageHome.fsPath,u.identifier.id.toLowerCase())}};f=de([X(0,i.IEnvironmentService),X(1,C.ILogService)],f),e.ExtensionsLifecycle=f}),define(Z[166],ee([0,1,3,2,15,5,12,32,13,14]),function(K,e,D,T,R,L,k,P,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;let i=class extends T.Disposable{constructor(f,I,u,w){super();this.extensionsManagementService=f,this.logService=w,this._onDidChangeExtensionsByAnotherSource=this._register(new D.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(y=>{this.installedExtensions=y.map(S=>S.identifier),this.startTimestamp=Date.now()}),this._register(f.onInstallExtension(y=>this.onInstallExtension(y))),this._register(f.onDidInstallExtensions(y=>this.onDidInstallExtensions(y))),this._register(f.onDidUninstallExtension(y=>this.onDidUninstallExtension(y)));const g=L.URI.file(u.extensionsPath),E=new R.ExtUri(y=>!I.hasCapability(y,1024));this._register(I.watch(g)),this._register(D.Event.filter(I.onDidChangeFilesRaw,y=>y.changes.some(S=>this.doesChangeAffects(S,g,E)))(()=>this.onDidChange()))}doesChangeAffects(f,I,u){return u.isEqual(u.dirname(f.resource),I)?u.isEqual(f.resource,u.joinPath(I,".obsolete"))?!0:!(f.type!==1&&f.type!==2||u.basename(f.resource).startsWith(".")):!1}onInstallExtension(f){this.addInstallingExtension(f.identifier)}onDidInstallExtensions(f){for(const I of f)this.removeInstallingExtension(I.identifier),I.local&&this.addInstalledExtension(I.identifier)}onDidUninstallExtension(f){f.error||this.removeInstalledExtension(f.identifier)}addInstallingExtension(f){this.removeInstallingExtension(f),this.installingExtensions.push(f)}removeInstallingExtension(f){this.installingExtensions=this.installingExtensions.filter(I=>!(0,P.areSameExtensions)(I,f))}addInstalledExtension(f){this.installedExtensions&&(this.removeInstalledExtension(f),this.installedExtensions.push(f))}removeInstalledExtension(f){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(I=>!(0,P.areSameExtensions)(I,f)))}async onDidChange(){if(this.installedExtensions){const f=await this.extensionsManagementService.getInstalled(1),I=f.filter(w=>[...this.installingExtensions,...this.installedExtensions].some(g=>(0,P.areSameExtensions)(g,w.identifier))?!1:w.installedTimestamp&&w.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",w.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",w.identifier.id),!1)),u=this.installedExtensions.filter(w=>this.installingExtensions.some(g=>(0,P.areSameExtensions)(g,w))?!1:f.every(g=>!(0,P.areSameExtensions)(g.identifier,w))?(this.logService.info("Detected extension removed from another source",w.id),!0):!1);this.installedExtensions=f.map(w=>w.identifier),(I.length||u.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:I,removed:u})}}};i=de([X(1,m.IFileService),X(2,k.INativeEnvironmentService),X(3,b.ILogService)],i),e.ExtensionsWatcher=i}),define(Z[167],ee([0,1,154,16,6,2,18,8,19,12,28,32,57,14]),function(K,e,D,T,R,L,k,P,m,b,i,C,f,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsService=void 0;let u=class extends L.Disposable{constructor(E,y,S){super();this.extensionManagementService=E,this.logService=S,this.cache=this._register(new w(y,S)),this.extensionManagementService.registerParticipant({postInstall:async o=>this.postInstallExtension(o),postUninstall:async o=>this.postUninstallExtension(o)})}async getLanguageIds(){const E=await this.cache.getLanguagePacks(),y=["en",...Object.keys(E)];return(0,T.distinct)(y)}async postInstallExtension(E){E&&E.manifest&&E.manifest.contributes&&E.manifest.contributes.localizations&&E.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",E.identifier.id),await this.update())}async postUninstallExtension(E){const y=await this.cache.getLanguagePacks();Object.keys(y).some(S=>y[S]&&y[S].extensions.some(o=>(0,C.areSameExtensions)(o.extensionIdentifier,E.identifier)))&&(this.logService.info("Removing language packs from the extension",E.identifier.id),await this.update())}async update(){const[E,y]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),S=await this.cache.update(y);return!(0,T.equals)(Object.keys(E),Object.keys(S))}};u=de([X(0,i.IExtensionManagementService),X(1,b.INativeEnvironmentService),X(2,I.ILogService)],u),e.LocalizationsService=u;let w=class extends L.Disposable{constructor(E,y){super();this.logService=y,this.languagePacks={},this.languagePacksFilePath=(0,P.join)(E.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new R.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(E){return this.withLanguagePacks(y=>{Object.keys(y).forEach(S=>delete y[S]),this.createLanguagePacksFromExtensions(y,...E)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(E,...y){for(const S of y)S&&S.manifest&&S.manifest.contributes&&S.manifest.contributes.localizations&&S.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(E,S);Object.keys(E).forEach(S=>this.updateHash(E[S]))}createLanguagePacksFromExtension(E,y){const S=y.identifier,o=y.manifest.contributes&&y.manifest.contributes.localizations?y.manifest.contributes.localizations:[];for(const a of o)if(y.location.scheme===k.Schemas.file&&(0,f.isValidLocalization)(a)){let t=E[a.languageId];t||(t={hash:"",extensions:[],translations:{}},E[a.languageId]=t);let s=t.extensions.filter(n=>(0,C.areSameExtensions)(n.extensionIdentifier,S))[0];s?s.version=y.manifest.version:t.extensions.push({extensionIdentifier:S,version:y.manifest.version});for(const n of a.translations)t.translations[n.id]=(0,P.join)(y.location.fsPath,n.path)}}updateHash(E){if(E){const y=(0,D.createHash)("md5");for(const S of E.extensions)y.update(S.extensionIdentifier.uuid||S.extensionIdentifier.id).update(S.version);E.hash=y.digest("hex")}}withLanguagePacks(E=()=>null){return this.languagePacksFileLimiter.queue(()=>{let y=null;return m.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,S=>S.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(S)).then(S=>{try{return JSON.parse(S)}catch(o){return{}}}).then(S=>(y=E(S),S)).then(S=>{for(const a of Object.keys(S))S[a]||delete S[a];this.languagePacks=S,this.initializedCache=!0;const o=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",o),m.Promises.writeFile(this.languagePacksFilePath,o)}).then(()=>y,S=>this.logService.error(S))})}};w=de([X(0,b.INativeEnvironmentService),X(1,I.ILogService)],w)}),define(Z[79],ee([0,1,3,5,14]),function(K,e,D,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class L{constructor(f){this.service=f,this.onDidChangeLogLevel=D.Event.buffer(f.onDidChangeLogLevel,!0)}listen(f,I){switch(I){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${I}`)}async call(f,I,u){switch(I){case"setLevel":return this.service.setLevel(u)}throw new Error(`Call not found: ${I}`)}}e.LogLevelChannel=L;class k{constructor(f){this.channel=f}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(f){k.setLevel(this.channel,f)}static setLevel(f,I){return f.call("setLevel",I)}}e.LogLevelChannelClient=k;class P{constructor(f){this.loggerService=f,this.loggers=new Map}listen(f,I){throw new Error(`Event not found: ${I}`)}async call(f,I,u){switch(I){case"createLogger":this.createLogger(T.URI.revive(u[0]),u[1]);return;case"log":return this.log(T.URI.revive(u[0]),u[1]);case"consoleLog":return this.consoleLog(u[0],u[1])}throw new Error(`Call not found: ${I}`)}createLogger(f,I){this.loggers.set(f.toString(),this.loggerService.createLogger(f,I))}consoleLog(f,I){let u=console.log;switch(f){case R.LogLevel.Error:u=console.error;break;case R.LogLevel.Warning:u=console.warn;break;case R.LogLevel.Info:u=console.info;break}u.call(console,...I)}log(f,I){const u=this.loggers.get(f.toString());if(!u)throw new Error("Create the logger before logging");for(const[w,g]of I)switch(w){case R.LogLevel.Trace:u.trace(g);break;case R.LogLevel.Debug:u.debug(g);break;case R.LogLevel.Info:u.info(g);break;case R.LogLevel.Warning:u.warn(g);break;case R.LogLevel.Error:u.error(g);break;case R.LogLevel.Critical:u.critical(g);break;default:throw new Error("Invalid log level")}}}e.LoggerChannel=P;class m extends R.AbstractLoggerService{constructor(f,I,u){super(f,I);this.channel=u}createConsoleMainLogger(){return new R.AdapterLogger({log:(f,I)=>{this.channel.call("consoleLog",[f,I])}})}doCreateLogger(f,I,u){return new b(this.channel,f,I,u)}}e.LoggerChannelClient=m;class b extends R.AbstractMessageLogger{constructor(f,I,u,w){super(w?.always);this.channel=f,this.file=I,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(u),this.channel.call("createLogger",[I,w]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(f,I){const u=[[f,I]];this.isLoggerCreated?this.doLog(u):this.buffer.push(...u)}doLog(f){this.channel.call("log",[this.file,f])}}class i extends R.LogService{constructor(f,I){super(I);this.parent=f,this._register(f.onDidChangeLogLevel(u=>I.setLevel(u)))}setLevel(f){super.setLevel(f),this.parent.setLevel(f)}}e.FollowerLogService=i}),define(Z[59],ee([0,1,7]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=(0,D.createDecorator)("nativeHostService")}),define(Z[42],ee([0,1,18,4,31,15]),function(K,e,D,T,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let k;if(typeof T.globals.vscode!="undefined"&&typeof T.globals.vscode.context!="undefined"){const P=T.globals.vscode.context.configuration();if(P)k=P.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof K?.__$__nodeRequire=="function"){const P=(0,L.dirname)(D.FileAccess.asFileUri("",K));k=K.__$__nodeRequire((0,L.joinPath)(P,"product.json").fsPath);const m=K.__$__nodeRequire((0,L.joinPath)(P,"package.json").fsPath);R.env.VSCODE_DEV&&Object.assign(k,{nameShort:`${k.nameShort} Dev`,nameLong:`${k.nameLong} Dev`,dataFolderName:`${k.dataFolderName}-dev`}),Object.assign(k,{version:m.version})}else k={},Object.keys(k).length===0&&Object.assign(k,{version:"1.61.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.remotehub","ms-vscode.remotehub-insiders","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=k}),define(Z[80],ee([0,1,25,9,123,13,42]),function(K,e,D,T,R,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function P(C,f,I,u,w,g){let E;try{await m(C,f,I,u,w,g)}catch(y){E=y}finally{E&&w.errorTransformer&&(E=w.errorTransformer(E)),typeof E!="undefined"&&I.error(E),I.end()}}e.readFileIntoStream=P;async function m(C,f,I,u,w,g){b(g);const E=await C.open(f,{create:!1});try{b(g);let y=0,S=0,o=w&&typeof w.length=="number"?w.length:void 0,a=D.VSBuffer.alloc(Math.min(w.bufferSize,typeof o=="number"?o:w.bufferSize)),t=w&&typeof w.position=="number"?w.position:0,s=0;do S=await C.read(E,t,a.buffer,s,a.byteLength-s),t+=S,s+=S,y+=S,typeof o=="number"&&(o-=S),s===a.byteLength&&(await I.write(u(a)),a=D.VSBuffer.alloc(Math.min(w.bufferSize,typeof o=="number"?o:w.bufferSize)),s=0);while(S>0&&(typeof o!="number"||o>0)&&b(g)&&i(y,w));if(s>0){let n=s;typeof o=="number"&&(n=Math.min(s,o)),I.write(u(a.slice(0,n)))}}catch(y){throw(0,L.ensureFileSystemProviderError)(y)}finally{await C.close(E)}}function b(C){if(C.isCancellationRequested)throw(0,T.canceled)();return!0}function i(C,f){if(f?.limits){if(typeof f.limits.memory=="number"&&C>f.limits.memory)throw(0,L.createFileSystemProviderError)((0,R.localize)(0,null,k.default.nameShort),L.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof f.limits.size=="number"&&C>f.limits.size)throw(0,L.createFileSystemProviderError)((0,R.localize)(1,null),L.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Z[168],ee([0,1,16,6,25,27,3,55,2,40,18,169,15,50,121,13,80,14]),function(K,e,D,T,R,L,k,P,m,b,i,C,f,I,u,w,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let y=class Be extends m.Disposable{constructor(o){super();this.logService=o,this.BUFFER_SIZE=64*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new k.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new k.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new k.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new k.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new k.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidChangeFilesRaw=this._register(new k.Emitter),this.onDidChangeFilesRaw=this._onDidChangeFilesRaw.event,this.activeWatchers=new Map,this.caseSensitiveFileEventsWorker=this._register(new T.ThrottledWorker(Be.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Be.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Be.FILE_EVENTS_THROTTLING.coolDownDelay,a=>this._onDidFilesChange.fire(new w.FileChangesEvent(a,!1)))),this.caseInsensitiveFileEventsWorker=this._register(new T.ThrottledWorker(Be.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Be.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Be.FILE_EVENTS_THROTTLING.coolDownDelay,a=>this._onDidFilesChange.fire(new w.FileChangesEvent(a,!0)))),this.watchedResources=b.TernarySearchTree.forUris(a=>{const t=this.getProvider(a.scheme);return t?!this.isPathCaseSensitive(t):!1}),this.writeQueue=this._register(new T.ResourceQueue)}registerProvider(o,a){if(this.provider.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,C.mark)(`code/registerFilesystem/${o}`),this.provider.set(o,a),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:o,provider:a});const t=new m.DisposableStore;return t.add(a.onDidChangeFile(s=>this.onDidChangeFile(s,this.isPathCaseSensitive(a)))),t.add(a.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:a,scheme:o}))),typeof a.onDidErrorOccur=="function"&&t.add(a.onDidErrorOccur(s=>this._onError.fire(new Error(s)))),(0,m.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:o,provider:a}),this.provider.delete(o),(0,m.dispose)(t)})}getProvider(o){return this.provider.get(o)}async activateProvider(o){const a=[];this._onWillActivateFileSystemProvider.fire({scheme:o,join(t){a.push(t)}}),!this.provider.has(o)&&await T.Promises.settled(a)}canHandleResource(o){return this.provider.has(o.scheme)}hasCapability(o,a){const t=this.provider.get(o.scheme);return!!(t&&t.capabilities&a)}listCapabilities(){return P.Iterable.map(this.provider,([o,a])=>({scheme:o,capabilities:a.capabilities}))}async withProvider(o){if(!(0,f.isAbsolutePath)(o))throw new w.FileOperationError((0,u.localize)(0,null,this.resourceForError(o)),8);await this.activateProvider(o.scheme);const a=this.provider.get(o.scheme);if(!a){const t=new Error;throw t.name="ENOPRO",t.message=(0,u.localize)(1,null,o.toString()),t}return a}async withReadProvider(o){const a=await this.withProvider(o);if((0,w.hasOpenReadWriteCloseCapability)(a)||(0,w.hasReadWriteCapability)(a)||(0,w.hasFileReadStreamCapability)(a))return a;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(o){const a=await this.withProvider(o);if((0,w.hasOpenReadWriteCloseCapability)(a)||(0,w.hasReadWriteCapability)(a))return a;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,a){try{return await this.doResolveFile(o,a)}catch(t){throw(0,w.toFileSystemProviderErrorCode)(t)===w.FileSystemProviderErrorCode.FileNotFound?new w.FileOperationError((0,u.localize)(2,null,this.resourceForError(o)),1):(0,w.ensureFileSystemProviderError)(t)}}async doResolveFile(o,a){const t=await this.withProvider(o),s=this.isPathCaseSensitive(t),n=a?.resolveTo,r=a?.resolveSingleChildDescendants,c=a?.resolveMetadata,l=await t.stat(o);let h;return this.toFileStat(t,o,l,void 0,!!c,(d,v)=>{if(!h&&(h=b.TernarySearchTree.forUris(()=>!s),h.set(o,!0),n))for(const A of n)h.set(A,!0);return h.get(d.resource)||h.findSuperstr(d.resource.with({query:null,fragment:null}))?!0:d.isDirectory&&r?v===1:!1})}async toFileStat(o,a,t,s,n,r){const{providerExtUri:c}=this.getExtUri(o),l={resource:a,name:c.basename(a),isFile:(t.type&w.FileType.File)!=0,isDirectory:(t.type&w.FileType.Directory)!=0,isSymbolicLink:(t.type&w.FileType.SymbolicLink)!=0,mtime:t.mtime,ctime:t.ctime,size:t.size,readonly:Boolean((t.permissions??0)&w.FilePermission.Readonly)||Boolean(o.capabilities&2048),etag:(0,w.etag)({mtime:t.mtime,size:t.size})};if(l.isDirectory&&r(l,s)){try{const h=await o.readdir(a),d=await T.Promises.settled(h.map(async([v,A])=>{try{const O=c.joinPath(a,v),p=n?await o.stat(O):{type:A};return await this.toFileStat(o,O,p,h.length,n,r)}catch(O){return this.logService.trace(O),null}}));l.children=(0,D.coalesce)(d)}catch(h){this.logService.trace(h),l.children=[]}return l}return l}async resolveAll(o){return T.Promises.settled(o.map(async a=>{try{return{stat:await this.doResolveFile(a.resource,a.options),success:!0}}catch(t){return this.logService.trace(t),{stat:void 0,success:!1}}}))}async exists(o){const a=await this.withProvider(o);try{return!!await a.stat(o)}catch(t){return!1}}async canCreateFile(o,a){try{await this.doValidateCreateFile(o,a)}catch(t){return t}return!0}async doValidateCreateFile(o,a){if(!a?.overwrite&&await this.exists(o))throw new w.FileOperationError((0,u.localize)(3,null,this.resourceForError(o)),3,a)}async createFile(o,a=R.VSBuffer.fromString(""),t){await this.doValidateCreateFile(o,t);const s=await this.writeFile(o,a);return this._onDidRunOperation.fire(new w.FileOperationEvent(o,0,s)),s}async writeFile(o,a,t){const s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),{providerExtUri:n}=this.getExtUri(s);try{await this.validateWriteFile(s,o,t)||await this.mkdirp(s,n.dirname(o));let c;if((0,w.hasReadWriteCapability)(s)&&!(a instanceof R.VSBuffer))if((0,I.isReadableStream)(a)){const l=await(0,I.peekStream)(a,3);l.ended?c=R.VSBuffer.concat(l.buffer):c=l}else c=(0,I.peekReadable)(a,l=>R.VSBuffer.concat(l),3);else c=a;!(0,w.hasOpenReadWriteCloseCapability)(s)||(0,w.hasReadWriteCapability)(s)&&c instanceof R.VSBuffer?await this.doWriteUnbuffered(s,o,t,c):await this.doWriteBuffered(s,o,t,c instanceof R.VSBuffer?(0,R.bufferToReadable)(c):c)}catch(r){throw new w.FileOperationError((0,u.localize)(4,null,this.resourceForError(o),(0,w.ensureFileSystemProviderError)(r).toString()),(0,w.toFileOperationResult)(r),t)}return this.resolve(o,{resolveMetadata:!0})}async validateWriteFile(o,a,t){if(!!t?.unlock&&!(o.capabilities&8192))throw new Error((0,u.localize)(5,null,this.resourceForError(a)));let n;try{n=await o.stat(a)}catch(r){return}if((n.type&w.FileType.Directory)!=0)throw new w.FileOperationError((0,u.localize)(6,null,this.resourceForError(a)),0,t);if(this.throwIfFileIsReadonly(a,n),typeof t?.mtime=="number"&&typeof t.etag=="string"&&t.etag!==w.ETAG_DISABLED&&typeof n.mtime=="number"&&typeof n.size=="number"&&t.mtime<n.mtime&&t.etag!==(0,w.etag)({mtime:t.mtime,size:n.size}))throw new w.FileOperationError((0,u.localize)(7,null),3,t);return n}async readFile(o,a){const t=await this.withReadProvider(o);return a?.atomic?this.doReadFileAtomic(t,o,a):this.doReadFile(t,o,a)}async doReadFileAtomic(o,a,t){return new Promise((s,n)=>{this.writeQueue.queueFor(a,this.getExtUri(o).providerExtUri).queue(async()=>{try{const r=await this.doReadFile(o,a,t);s(r)}catch(r){n(r)}})})}async doReadFile(o,a,t){const s=await this.doReadFileStream(o,a,{...t,preferUnbuffered:!0});return{...s,value:await(0,R.streamToBuffer)(s.value)}}async readFileStream(o,a){const t=await this.withReadProvider(o);return this.doReadFileStream(t,o,a)}async doReadFileStream(o,a,t){const s=new L.CancellationTokenSource,n=this.validateReadFile(a,t).then(c=>c,c=>{throw s.cancel(),c});let r;try{return typeof t?.etag=="string"&&t.etag!==w.ETAG_DISABLED&&await n,!((0,w.hasOpenReadWriteCloseCapability)(o)||(0,w.hasFileReadStreamCapability)(o))||(0,w.hasReadWriteCapability)(o)&&t?.preferUnbuffered?r=this.readFileUnbuffered(o,a,t):(0,w.hasFileReadStreamCapability)(o)?r=this.readFileStreamed(o,a,s.token,t):r=this.readFileBuffered(o,a,s.token,t),{...await n,value:r}}catch(c){r&&await(0,I.consumeStream)(r);const l=(0,u.localize)(8,null,this.resourceForError(a),(0,w.ensureFileSystemProviderError)(c).toString());throw c instanceof w.NotModifiedSinceFileOperationError?new w.NotModifiedSinceFileOperationError(l,c.stat,t):new w.FileOperationError(l,(0,w.toFileOperationResult)(c),t)}}readFileStreamed(o,a,t,s=Object.create(null)){const n=o.readFileStream(a,s,t);return(0,I.transform)(n,{data:r=>r instanceof R.VSBuffer?r:R.VSBuffer.wrap(r),error:r=>new w.FileOperationError((0,u.localize)(9,null,this.resourceForError(a),(0,w.ensureFileSystemProviderError)(r).toString()),(0,w.toFileOperationResult)(r),s)},r=>R.VSBuffer.concat(r))}readFileBuffered(o,a,t,s=Object.create(null)){const n=(0,R.newWriteableBufferStream)();return(0,g.readFileIntoStream)(o,a,n,r=>r,{...s,bufferSize:this.BUFFER_SIZE,errorTransformer:r=>new w.FileOperationError((0,u.localize)(10,null,this.resourceForError(a),(0,w.ensureFileSystemProviderError)(r).toString()),(0,w.toFileOperationResult)(r),s)},t),n}readFileUnbuffered(o,a,t){const s=(0,I.newWriteableStream)(n=>R.VSBuffer.concat(n));return(async()=>{try{let n=await o.readFile(a);typeof t?.position=="number"&&(n=n.slice(t.position)),typeof t?.length=="number"&&(n=n.slice(0,t.length)),this.validateReadFileLimits(a,n.byteLength,t),s.end(R.VSBuffer.wrap(n))}catch(n){s.error(n),s.end()}})(),s}async validateReadFile(o,a){const t=await this.resolve(o,{resolveMetadata:!0});if(t.isDirectory)throw new w.FileOperationError((0,u.localize)(11,null,this.resourceForError(o)),0,a);if(typeof a?.etag=="string"&&a.etag!==w.ETAG_DISABLED&&a.etag===t.etag)throw new w.NotModifiedSinceFileOperationError((0,u.localize)(12,null),t,a);return this.validateReadFileLimits(o,t.size,a),t}validateReadFileLimits(o,a,t){if(t?.limits){let s;if(typeof t.limits.memory=="number"&&a>t.limits.memory&&(s=9),typeof t.limits.size=="number"&&a>t.limits.size&&(s=7),typeof s=="number")throw new w.FileOperationError((0,u.localize)(13,null,this.resourceForError(o)),s)}}async canMove(o,a,t){return this.doCanMoveCopy(o,a,"move",t)}async canCopy(o,a,t){return this.doCanMoveCopy(o,a,"copy",t)}async doCanMoveCopy(o,a,t,s){if(o.toString()!==a.toString())try{const n=t==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o):await this.withReadProvider(o),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a);await this.doValidateMoveCopy(n,o,r,a,t,s)}catch(n){return n}return!0}async move(o,a,t){const s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),r=await this.doMoveCopy(s,o,n,a,"move",!!t),c=await this.resolve(a,{resolveMetadata:!0});return this._onDidRunOperation.fire(new w.FileOperationEvent(o,r==="move"?2:3,c)),c}async copy(o,a,t){const s=await this.withReadProvider(o),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),r=await this.doMoveCopy(s,o,n,a,"copy",!!t),c=await this.resolve(a,{resolveMetadata:!0});return this._onDidRunOperation.fire(new w.FileOperationEvent(o,r==="copy"?3:2,c)),c}async doMoveCopy(o,a,t,s,n,r){if(a.toString()===s.toString())return n;const{exists:c,isSameResourceWithDifferentPathCase:l}=await this.doValidateMoveCopy(o,a,t,s,n,r);if(c&&!l&&r&&await this.del(s,{recursive:!0}),await this.mkdirp(t,this.getExtUri(t).providerExtUri.dirname(s)),n==="copy"){if(o===t&&(0,w.hasFileFolderCopyCapability)(o))await o.copy(a,s,{overwrite:r});else{const h=await this.resolve(a);h.isDirectory?await this.doCopyFolder(o,h,t,s):await this.doCopyFile(o,a,t,s)}return n}else return o===t?(await o.rename(a,s,{overwrite:r}),n):(await this.doMoveCopy(o,a,t,s,"copy",r),await this.del(a,{recursive:!0}),"copy")}async doCopyFile(o,a,t,s){if((0,w.hasOpenReadWriteCloseCapability)(o)&&(0,w.hasOpenReadWriteCloseCapability)(t))return this.doPipeBuffered(o,a,t,s);if((0,w.hasOpenReadWriteCloseCapability)(o)&&(0,w.hasReadWriteCapability)(t))return this.doPipeBufferedToUnbuffered(o,a,t,s);if((0,w.hasReadWriteCapability)(o)&&(0,w.hasOpenReadWriteCloseCapability)(t))return this.doPipeUnbufferedToBuffered(o,a,t,s);if((0,w.hasReadWriteCapability)(o)&&(0,w.hasReadWriteCapability)(t))return this.doPipeUnbuffered(o,a,t,s)}async doCopyFolder(o,a,t,s){await t.mkdir(s),Array.isArray(a.children)&&await T.Promises.settled(a.children.map(async n=>{const r=this.getExtUri(t).providerExtUri.joinPath(s,n.name);return n.isDirectory?this.doCopyFolder(o,await this.resolve(n.resource),t,r):this.doCopyFile(o,n.resource,t,r)}))}async doValidateMoveCopy(o,a,t,s,n,r){let c=!1;if(o===t){const{providerExtUri:h,isPathCaseSensitive:d}=this.getExtUri(o);if(d||(c=h.isEqual(a,s)),c&&n==="copy")throw new Error((0,u.localize)(14,null,this.resourceForError(a),this.resourceForError(s)));if(!c&&h.isEqualOrParent(s,a))throw new Error((0,u.localize)(15,null,this.resourceForError(a),this.resourceForError(s)))}const l=await this.exists(s);if(l&&!c){if(!r)throw new w.FileOperationError((0,u.localize)(16,null,this.resourceForError(a),this.resourceForError(s)),4);if(o===t){const{providerExtUri:h}=this.getExtUri(o);if(h.isEqualOrParent(a,s))throw new Error((0,u.localize)(17,null,this.resourceForError(a),this.resourceForError(s)))}}return{exists:l,isSameResourceWithDifferentPathCase:c}}getExtUri(o){const a=this.isPathCaseSensitive(o);return{providerExtUri:a?f.extUri:f.extUriIgnorePathCase,isPathCaseSensitive:a}}isPathCaseSensitive(o){return!!(o.capabilities&1024)}async createFolder(o){const a=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);await this.mkdirp(a,o);const t=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new w.FileOperationEvent(o,0,t)),t}async mkdirp(o,a){const t=[],{providerExtUri:s}=this.getExtUri(o);for(;!s.isEqual(a,s.dirname(a));)try{if(((await o.stat(a)).type&w.FileType.Directory)==0)throw new Error((0,u.localize)(18,null,this.resourceForError(a)));break}catch(n){if((0,w.toFileSystemProviderErrorCode)(n)!==w.FileSystemProviderErrorCode.FileNotFound)throw n;t.push(s.basename(a)),a=s.dirname(a)}for(let n=t.length-1;n>=0;n--){a=s.joinPath(a,t[n]);try{await o.mkdir(a)}catch(r){if((0,w.toFileSystemProviderErrorCode)(r)!==w.FileSystemProviderErrorCode.FileExists)throw r}}}async canDelete(o,a){try{await this.doValidateDelete(o,a)}catch(t){return t}return!0}async doValidateDelete(o,a){const t=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);if(!!a?.useTrash&&!(t.capabilities&4096))throw new Error((0,u.localize)(19,null,this.resourceForError(o)));let n;try{n=await t.stat(o)}catch(c){}if(n)this.throwIfFileIsReadonly(o,n);else throw new w.FileOperationError((0,u.localize)(20,null,this.resourceForError(o)),1);if(!!!a?.recursive){const c=await this.resolve(o);if(c.isDirectory&&Array.isArray(c.children)&&c.children.length>0)throw new Error((0,u.localize)(21,null,this.resourceForError(o)))}return t}async del(o,a){const t=await this.doValidateDelete(o,a),s=!!a?.useTrash,n=!!a?.recursive;await t.delete(o,{recursive:n,useTrash:s}),this._onDidRunOperation.fire(new w.FileOperationEvent(o,1))}onDidChangeFile(o,a){this._onDidChangeFilesRaw.fire({changes:o});let t,s;{for(const n of o)this.watchedResources.has(n.resource)?(t||(t=[]),t.push(n)):(s||(s=[]),s.push(n));t&&this._onDidFilesChange.fire(new w.FileChangesEvent(t,!a))}if(s){const n=a?this.caseSensitiveFileEventsWorker:this.caseInsensitiveFileEventsWorker;!n.work(s)&&Be.FILE_EVENTS_THROTTLING.warningscounter++<10&&this.logService.warn(`[File watcher]: started ignoring events due to too many file change events at once (incoming: ${s.length}, most recent change: ${s[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`),n.pending>0&&this.logService.trace(`[File watcher]: started throttling events due to large amount of file change events at once (pending: ${n.pending}, most recent change: ${s[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}watch(o,a={recursive:!1,excludes:[]}){const t=new m.DisposableStore;{let s=!1,n=()=>{s=!0};t.add((0,m.toDisposable)(()=>n())),this.doWatch(o,a).then(r=>{s?(0,m.dispose)(r):n=()=>(0,m.dispose)(r)},r=>this.logService.error(r))}return a.recursive||(this.watchedResources.set(o,(this.watchedResources.get(o)??0)+1),t.add((0,m.toDisposable)(()=>{const s=this.watchedResources.get(o);typeof s=="number"&&(s<=1?this.watchedResources.delete(o):this.watchedResources.set(o,s-1))}))),t}async doWatch(o,a){const t=await this.withProvider(o),s=this.toWatchKey(t,o,a),n=this.activeWatchers.get(s)||{count:0,disposable:t.watch(o,a)};return this.activeWatchers.has(s)||this.activeWatchers.set(s,n),n.count+=1,(0,m.toDisposable)(()=>{n.count--,n.count===0&&((0,m.dispose)(n.disposable),this.activeWatchers.delete(s))})}toWatchKey(o,a,t){const{providerExtUri:s}=this.getExtUri(o);return[s.getComparisonKey(a),String(t.recursive),t.excludes.join()].join()}dispose(){super.dispose();for(const[,o]of this.activeWatchers)(0,m.dispose)(o.disposable);this.activeWatchers.clear()}async doWriteBuffered(o,a,t,s){return this.writeQueue.queueFor(a,this.getExtUri(o).providerExtUri).queue(async()=>{const n=await o.open(a,{create:!0,unlock:t?.unlock??!1});try{(0,I.isReadableStream)(s)||(0,I.isReadableBufferedStream)(s)?await this.doWriteStreamBufferedQueued(o,n,s):await this.doWriteReadableBufferedQueued(o,n,s)}catch(r){throw(0,w.ensureFileSystemProviderError)(r)}finally{await o.close(n)}})}async doWriteStreamBufferedQueued(o,a,t){let s=0,n;if((0,I.isReadableBufferedStream)(t)){if(t.buffer.length>0){const r=R.VSBuffer.concat(t.buffer);await this.doWriteBuffer(o,a,r,r.byteLength,s,0),s+=r.byteLength}if(t.ended)return;n=t.stream}else n=t;return new Promise(async(r,c)=>{(0,I.listenStream)(n,{onData:async l=>{n.pause();try{await this.doWriteBuffer(o,a,l,l.byteLength,s,0)}catch(h){return c(h)}s+=l.byteLength,setTimeout(()=>n.resume())},onError:l=>c(l),onEnd:()=>r()})})}async doWriteReadableBufferedQueued(o,a,t){let s=0,n;for(;(n=t.read())!==null;)await this.doWriteBuffer(o,a,n,n.byteLength,s,0),s+=n.byteLength}async doWriteBuffer(o,a,t,s,n,r){let c=0;for(;c<s;)c+=await o.write(a,n+c,t.buffer,r+c,s-c)}async doWriteUnbuffered(o,a,t,s){return this.writeQueue.queueFor(a,this.getExtUri(o).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(o,a,t,s))}async doWriteUnbufferedQueued(o,a,t,s){let n;s instanceof R.VSBuffer?n=s:(0,I.isReadableStream)(s)?n=await(0,R.streamToBuffer)(s):(0,I.isReadableBufferedStream)(s)?n=await(0,R.bufferedStreamToBuffer)(s):n=(0,R.readableToBuffer)(s),await o.writeFile(a,n.buffer,{create:!0,overwrite:!0,unlock:t?.unlock??!1})}async doPipeBuffered(o,a,t,s){return this.writeQueue.queueFor(s,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeBufferedQueued(o,a,t,s))}async doPipeBufferedQueued(o,a,t,s){let n,r;try{n=await o.open(a,{create:!1}),r=await t.open(s,{create:!0,unlock:!1});const c=R.VSBuffer.alloc(this.BUFFER_SIZE);let l=0,h=0,d=0;do d=await o.read(n,l,c.buffer,h,c.byteLength-h),await this.doWriteBuffer(t,r,c,d,l,h),l+=d,h+=d,h===c.byteLength&&(h=0);while(d>0)}catch(c){throw(0,w.ensureFileSystemProviderError)(c)}finally{await T.Promises.settled([typeof n=="number"?o.close(n):Promise.resolve(),typeof r=="number"?t.close(r):Promise.resolve()])}}async doPipeUnbuffered(o,a,t,s){return this.writeQueue.queueFor(s,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(o,a,t,s))}async doPipeUnbufferedQueued(o,a,t,s){return t.writeFile(s,await o.readFile(a),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(o,a,t,s){return this.writeQueue.queueFor(s,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(o,a,t,s))}async doPipeUnbufferedToBufferedQueued(o,a,t,s){const n=await t.open(s,{create:!0,unlock:!1});try{const r=await o.readFile(a);await this.doWriteBuffer(t,n,R.VSBuffer.wrap(r),r.byteLength,0,0)}catch(r){throw(0,w.ensureFileSystemProviderError)(r)}finally{await t.close(n)}}async doPipeBufferedToUnbuffered(o,a,t,s){const n=await(0,R.streamToBuffer)(this.readFileBuffered(o,a,L.CancellationToken.None));await this.doWriteUnbuffered(t,s,void 0,n)}throwIfFileSystemIsReadonly(o,a){if(o.capabilities&2048)throw new w.FileOperationError((0,u.localize)(22,null,this.resourceForError(a)),6);return o}throwIfFileIsReadonly(o,a){if((a.permissions??0)&w.FilePermission.Readonly)throw new w.FileOperationError((0,u.localize)(23,null,this.resourceForError(o)),6)}resourceForError(o){return o.scheme===i.Schemas.file?o.fsPath:o.toString(!0)}};y.FILE_EVENTS_THROTTLING={maxChangesChunkSize:500,maxChangesBufferSize:3e4,coolDownDelay:200,warningscounter:0},y=de([X(0,E.ILogService)],y),e.FileService=y}),define(Z[170],ee([0,1,16,6,25,3,39,2,8,4,15,50,19,124,13,80,157,142,143,77,145,14,42]),function(K,e,D,T,R,L,k,P,m,b,i,C,f,I,u,w,g,E,y,S,o,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0;class s extends P.Disposable{constructor(r,c){super();this.logService=r,this.options=c,this.BUFFER_SIZE=this.options?.bufferSize||64*1024,this.onDidChangeCapabilities=L.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0,this._onDidWatchErrorOccur=this._register(new L.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeFile=this._register(new L.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new T.ThrottledDelayer(0))}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,b.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(r){try{const{stat:c,symbolicLink:l}=await f.SymlinkSupport.stat(this.toFilePath(r));return{type:this.toType(c,l),ctime:c.birthtime.getTime(),mtime:c.mtime.getTime(),size:c.size}}catch(c){throw this.toFileSystemProviderError(c)}}async readdir(r){try{const c=await f.Promises.readdir(this.toFilePath(r),{withFileTypes:!0}),l=[];return await Promise.all(c.map(async h=>{try{let d;h.isSymbolicLink()?d=(await this.stat((0,i.joinPath)(r,h.name))).type:d=this.toType(h),l.push([h.name,d])}catch(d){this.logService.trace(d)}})),l}catch(c){throw this.toFileSystemProviderError(c)}}toType(r,c){let l;return c?.dangling?l=u.FileType.Unknown:r.isFile()?l=u.FileType.File:r.isDirectory()?l=u.FileType.Directory:l=u.FileType.Unknown,c&&(l|=u.FileType.SymbolicLink),l}async readFile(r){try{const c=this.toFilePath(r);return await f.Promises.readFile(c)}catch(c){throw this.toFileSystemProviderError(c)}}readFileStream(r,c,l){const h=(0,C.newWriteableStream)(d=>R.VSBuffer.concat(d.map(v=>R.VSBuffer.wrap(v))).buffer);return(0,w.readFileIntoStream)(this,r,h,d=>d.buffer,{...c,bufferSize:this.BUFFER_SIZE},l),h}async writeFile(r,c,l){let h;try{const d=this.toFilePath(r);if(!l.create||!l.overwrite){if(await f.Promises.exists(d)){if(!l.overwrite)throw(0,u.createFileSystemProviderError)((0,I.localize)(0,null),u.FileSystemProviderErrorCode.FileExists)}else if(!l.create)throw(0,u.createFileSystemProviderError)((0,I.localize)(1,null),u.FileSystemProviderErrorCode.FileNotFound)}h=await this.open(r,{create:!0,unlock:l.unlock}),await this.write(h,0,c,0,c.byteLength)}catch(d){throw await this.toFileSystemProviderWriteError(r,d)}finally{typeof h=="number"&&await this.close(h)}}async open(r,c){try{const l=this.toFilePath(r);if((0,u.isFileOpenForWriteOptions)(c)&&c.unlock)try{const{stat:v}=await f.SymlinkSupport.stat(l);v.mode&128||await f.Promises.chmod(l,v.mode|128)}catch(v){this.logService.trace(v)}let h;if((0,u.isFileOpenForWriteOptions)(c)){if(b.isWindows)try{await f.Promises.truncate(l,0),h="r+"}catch(v){v.code!=="ENOENT"&&this.logService.trace(v)}h||(h="w")}else h="r";const d=await f.Promises.open(l,h);return this.mapHandleToPos.set(d,0),(0,u.isFileOpenForWriteOptions)(c)&&this.writeHandles.set(d,r),d}catch(l){throw(0,u.isFileOpenForWriteOptions)(c)?await this.toFileSystemProviderWriteError(r,l):this.toFileSystemProviderError(l)}}async close(r){try{if(this.mapHandleToPos.delete(r),this.writeHandles.delete(r)&&this.canFlush)try{await f.Promises.fdatasync(r)}catch(c){this.canFlush=!1,this.logService.error(c)}return await f.Promises.close(r)}catch(c){throw this.toFileSystemProviderError(c)}}async read(r,c,l,h,d){const v=this.normalizePos(r,c);let A=null;try{const O=await f.Promises.read(r,l,h,d,v);return typeof O=="number"?A=O:A=O.bytesRead,A}catch(O){throw this.toFileSystemProviderError(O)}finally{this.updatePos(r,v,A)}}normalizePos(r,c){return c===this.mapHandleToPos.get(r)?null:c}updatePos(r,c,l){const h=this.mapHandleToPos.get(r);typeof h=="number"&&(typeof c=="number"||(typeof l=="number"?this.mapHandleToPos.set(r,h+l):this.mapHandleToPos.delete(r)))}async write(r,c,l,h,d){return(0,T.retry)(()=>this.doWrite(r,c,l,h,d),100,3)}async doWrite(r,c,l,h,d){const v=this.normalizePos(r,c);let A=null;try{const O=await f.Promises.write(r,l,h,d,v);return typeof O=="number"?A=O:A=O.bytesWritten,A}catch(O){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(r),O)}finally{this.updatePos(r,v,A)}}async mkdir(r){try{await f.Promises.mkdir(this.toFilePath(r))}catch(c){throw this.toFileSystemProviderError(c)}}async delete(r,c){try{const l=this.toFilePath(r);await this.doDelete(l,c)}catch(l){throw this.toFileSystemProviderError(l)}}async doDelete(r,c){c.recursive?await f.Promises.rm(r,f.RimRafMode.MOVE):await f.Promises.unlink(r)}async rename(r,c,l){const h=this.toFilePath(r),d=this.toFilePath(c);if(h!==d)try{await this.validateTargetDeleted(r,c,"move",l.overwrite),await f.Promises.move(h,d)}catch(v){throw(v.code==="EINVAL"||v.code==="EBUSY"||v.code==="ENAMETOOLONG")&&(v=new Error((0,I.localize)(2,null,(0,m.basename)(h),(0,m.basename)((0,m.dirname)(d)),v.toString()))),this.toFileSystemProviderError(v)}}async copy(r,c,l){const h=this.toFilePath(r),d=this.toFilePath(c);if(h!==d)try{await this.validateTargetDeleted(r,c,"copy",l.overwrite),await f.Promises.copy(h,d,{preserveSymlinks:!0})}catch(v){throw(v.code==="EINVAL"||v.code==="EBUSY"||v.code==="ENAMETOOLONG")&&(v=new Error((0,I.localize)(3,null,(0,m.basename)(h),(0,m.basename)((0,m.dirname)(d)),v.toString()))),this.toFileSystemProviderError(v)}}async validateTargetDeleted(r,c,l,h){const d=this.toFilePath(r),v=this.toFilePath(c);let A=!1;if(!!(this.capabilities&1024)||(A=(0,k.isEqual)(d,v,!0)),A&&l==="copy")throw(0,u.createFileSystemProviderError)((0,I.localize)(4,null),u.FileSystemProviderErrorCode.FileExists);if(!A&&await f.Promises.exists(v)){if(!h)throw(0,u.createFileSystemProviderError)((0,I.localize)(5,null),u.FileSystemProviderErrorCode.FileExists);await this.delete(c,{recursive:!0,useTrash:!1})}}watch(r,c){return c.recursive?this.watchRecursive(r,c.excludes):this.watchNonRecursive(r)}watchRecursive(r,c){const l={path:this.toFilePath(r),excludes:c},h=(0,D.insert)(this.recursiveFoldersToWatch,l);return this.refreshRecursiveWatchers(),(0,P.toDisposable)(()=>{h(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(async()=>{this.doRefreshRecursiveWatchers()})}doRefreshRecursiveWatchers(){if(this.recursiveWatcher instanceof E.FileWatcher)this.recursiveWatcher.setFolders(this.recursiveFoldersToWatch);else if((0,P.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,this.recursiveFoldersToWatch.length>0){let r,c;this.options?.watcher?.usePolling?(r=y.FileWatcher,c=this.options?.watcher):t.default.quality==="stable"&&this.recursiveFoldersToWatch.length===1?b.isWindows?r=o.FileWatcher:r=y.FileWatcher:r=E.FileWatcher,this.recursiveWatcher=new r(this.recursiveFoldersToWatch,l=>this._onDidChangeFile.fire((0,S.toFileChanges)(l)),l=>{l.type==="error"&&this._onDidWatchErrorOccur.fire(l.message),this.logService[l.type](l.message)},this.logService.getLevel()===a.LogLevel.Trace,c),this.recursiveWatcherLogLevelListener||(this.recursiveWatcherLogLevelListener=this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher&&this.recursiveWatcher.setVerboseLogging(this.logService.getLevel()===a.LogLevel.Trace)}))}}watchNonRecursive(r){const c=new g.FileWatcher(this.toFilePath(r),h=>this._onDidChangeFile.fire((0,S.toFileChanges)(h)),h=>{h.type==="error"&&this._onDidWatchErrorOccur.fire(h.message),this.logService[h.type](h.message)},this.logService.getLevel()===a.LogLevel.Trace),l=this.logService.onDidChangeLogLevel(()=>{c.setVerboseLogging(this.logService.getLevel()===a.LogLevel.Trace)});return(0,P.combinedDisposable)(c,l)}toFilePath(r){return(0,m.normalize)(r.fsPath)}toFileSystemProviderError(r){if(r instanceof u.FileSystemProviderError)return r;let c;switch(r.code){case"ENOENT":c=u.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":c=u.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":c=u.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":c=u.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":c=u.FileSystemProviderErrorCode.NoPermissions;break;default:c=u.FileSystemProviderErrorCode.Unknown}return(0,u.createFileSystemProviderError)(r,c)}async toFileSystemProviderWriteError(r,c){let l=this.toFileSystemProviderError(c);if(r&&l.code===u.FileSystemProviderErrorCode.NoPermissions)try{const{stat:h}=await f.SymlinkSupport.stat(this.toFilePath(r));h.mode&128||(l=(0,u.createFileSystemProviderError)(c,u.FileSystemProviderErrorCode.FileWriteLocked))}catch(h){this.logService.trace(h)}return l}dispose(){super.dispose(),(0,P.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,(0,P.dispose)(this.recursiveWatcherLogLevelListener),this.recursiveWatcherLogLevelListener=void 0}}e.DiskFileSystemProvider=s}),define(Z[29],ee([0,1,7]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProductService=void 0,e.IProductService=(0,D.createDecorator)("productService")}),define(Z[171],ee([0,1,6,9,2,8,19,14,29]),function(K,e,D,T,R,L,k,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeCacheCleaner=void 0;let b=class extends R.Disposable{constructor(C,f,I){super();this.productService=f,this.logService=I,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,C&&this._register(new D.RunOnceScheduler(()=>{this.cleanUpCodeCaches(C)},30*1e3)).schedule()}async cleanUpCodeCaches(C){this.logService.info("[code cache cleanup]: Starting to clean up old code cache folders.");try{const f=Date.now(),I=(0,L.dirname)(C),u=(0,L.basename)(C),w=await k.Promises.readdir(I);await Promise.all(w.map(async g=>{if(g===u)return;const E=(0,L.join)(I,g),y=await k.Promises.stat(E);if(y.isDirectory()&&f-y.mtime.getTime()>this._DataMaxAge)return this.logService.info(`[code cache cleanup]: Removing code cache folder ${g}.`),k.Promises.rm(E)}))}catch(f){(0,T.onUnexpectedError)(f)}}};b=de([X(1,m.IProductService),X(2,P.ILogService)],b),e.CodeCacheCleaner=b}),define(Z[172],ee([0,1,6,9,2,8,19,12,14,29]),function(K,e,D,T,R,L,k,P,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let i=class extends R.Disposable{constructor(f,I,u){super();this.environmentService=f,this.logService=I,this.productService=u,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.environmentService.isBuilt&&this._register(new D.RunOnceScheduler(()=>{this.cleanUpLanguagePackCache()},40*1e3)).schedule()}async cleanUpLanguagePackCache(){this.logService.info("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const f=Object.create(null),I=JSON.parse(await k.Promises.readFile((0,L.join)(this.environmentService.userDataPath,"languagepacks.json"),"utf8"));for(let y of Object.keys(I)){const S=I[y];f[`${S.hash}.${y}`]=!0}const u=(0,L.join)(this.environmentService.userDataPath,"clp");if(!await k.Promises.exists(u))return;const g=await k.Promises.readdir(u);for(const y of g){if(f[y]){this.logService.info(`[language pack cache cleanup]: Skipping folder ${y}. Language pack still in use.`);continue}this.logService.info(`[language pack cache cleanup]: Removing unused language pack: ${y}`),await k.Promises.rm((0,L.join)(u,y))}const E=Date.now();for(const y of Object.keys(f)){const S=(0,L.join)(u,y),o=await k.Promises.readdir(S);for(const a of o){if(a==="tcf.json")continue;const t=(0,L.join)(S,a),s=await k.Promises.stat(t);s.isDirectory()&&E-s.mtime.getTime()>this._DataMaxAge&&(this.logService.info(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,L.join)(y,a)}`),await k.Promises.rm(t))}}}catch(f){(0,T.onUnexpectedError)(f)}}};i=de([X(0,P.INativeEnvironmentService),X(1,m.ILogService),X(2,b.IProductService)],i),e.LanguagePackCachedDataCleaner=i}),define(Z[33],ee([0,1,90,17]),function(K,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class R{constructor(){this.data=new Map}add(k,P){D.ok(T.isString(k)),D.ok(T.isObject(P)),D.ok(!this.data.has(k),"There is already an extension with this id"),this.data.set(k,P)}knows(k){return this.data.has(k)}as(k){return this.data.get(k)||null}}e.Registry=new R}),define(Z[81],ee([0,1,3,33]),function(K,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function R(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class L{constructor(){this._onDidChangeSchema=new D.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(m,b){this.schemasById[R(m)]=b,this._onDidChangeSchema.fire(m)}notifySchemaChanged(m){this._onDidChangeSchema.fire(m)}getSchemaContributions(){return{schemas:this.schemasById}}}const k=new L;T.Registry.add(e.Extensions.JSONContribution,k)}),define(Z[38],ee([0,1,16,3,17,111,81,33]),function(K,e,D,T,R,L,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var m;(function(y){y.Multiline="multilineText",y.Singleline="singlelineText"})(m=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var b;(function(y){y[y.APPLICATION=1]="APPLICATION",y[y.MACHINE=2]="MACHINE",y[y.WINDOW=3]="WINDOW",y[y.RESOURCE=4]="RESOURCE",y[y.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",y[y.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(b=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const i=P.Registry.as(k.Extensions.JSONContribution);class C{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new T.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new T.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:L.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},i.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(S,o=!0){this.registerConfigurations([S],o)}registerConfigurations(S,o=!0){const a=this.doRegisterConfigurations(S,o);i.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(a)}deregisterConfigurations(S){const o=this.doDeregisterConfigurations(S);i.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}updateConfigurations({add:S,remove:o}){const a=[];a.push(...this.doDeregisterConfigurations(o)),a.push(...this.doRegisterConfigurations(S,!1)),i.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire((0,D.distinct)(a))}registerDefaultConfigurations(S){const o=[],a=[];for(const t of S)for(const s in t)if(o.push(s),e.OVERRIDE_PROPERTY_PATTERN.test(s)){this.defaultValues[s]={...this.defaultValues[s]||{},...t[s]};const n={type:"object",default:this.defaultValues[s],description:L.localize(1,null,s),$ref:e.resourceLanguageSettingsSchemaId};a.push(I(s)),this.configurationProperties[s]=n,this.defaultLanguageConfigurationOverridesNode.properties[s]=n}else{this.defaultValues[s]=t[s];const n=this.configurationProperties[s];n&&(this.updatePropertyDefaultValue(s,n),this.updateSchema(s,n))}this.registerOverrideIdentifiers(a),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}deregisterDefaultConfigurations(S){const o=[];for(const a of S)for(const t in a)if(o.push(t),delete this.defaultValues[t],e.OVERRIDE_PROPERTY_PATTERN.test(t))delete this.configurationProperties[t],delete this.defaultLanguageConfigurationOverridesNode.properties[t];else{const s=this.configurationProperties[t];s&&(this.updatePropertyDefaultValue(t,s),this.updateSchema(t,s))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}notifyConfigurationSchemaUpdated(...S){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(S){for(const o of S)this.overrideIdentifiers.add(o);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(S,o){const a=[];return S.forEach(t=>{a.push(...this.validateAndRegisterProperties(t,o,t.extensionInfo)),this.configurationContributors.push(t),this.registerJSONConfiguration(t)}),a}doDeregisterConfigurations(S){const o=[],a=t=>{if(t.properties)for(const s in t.properties)o.push(s),delete this.configurationProperties[s],this.removeFromSchema(s,t.properties[s]);t.allOf&&t.allOf.forEach(s=>a(s))};for(const t of S){a(t);const s=this.configurationContributors.indexOf(t);s!==-1&&this.configurationContributors.splice(s,1)}return o}validateAndRegisterProperties(S,o=!0,a,t=3){t=R.isUndefinedOrNull(S.scope)?t:S.scope;let s=[],n=S.properties;if(n)for(let c in n){if(o&&g(c)){delete n[c];continue}const l=n[c];if(this.updatePropertyDefaultValue(c,l),e.OVERRIDE_PROPERTY_PATTERN.test(c)?l.scope=void 0:(l.scope=R.isUndefinedOrNull(l.scope)?t:l.scope,l.restricted=R.isUndefinedOrNull(l.restricted)?!!a?.restrictedConfigurations?.includes(c):l.restricted),n[c].hasOwnProperty("included")&&!n[c].included){this.excludedConfigurationProperties[c]=n[c],delete n[c];continue}else this.configurationProperties[c]=n[c];!n[c].deprecationMessage&&n[c].markdownDeprecationMessage&&(n[c].deprecationMessage=n[c].markdownDeprecationMessage),s.push(c)}let r=S.allOf;if(r)for(let c of r)s.push(...this.validateAndRegisterProperties(c,o,a,t));return s}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(S){const o=a=>{let t=a.properties;if(t)for(const n in t)this.updateSchema(n,t[n]);let s=a.allOf;s&&s.forEach(o)};o(S)}updateSchema(S,o){switch(e.allSettings.properties[S]=o,o.scope){case 1:e.applicationSettings.properties[S]=o;break;case 2:e.machineSettings.properties[S]=o;break;case 6:e.machineOverridableSettings.properties[S]=o;break;case 3:e.windowSettings.properties[S]=o;break;case 4:e.resourceSettings.properties[S]=o;break;case 5:e.resourceSettings.properties[S]=o,this.resourceLanguageSettingsSchema.properties[S]=o;break}}removeFromSchema(S,o){switch(delete e.allSettings.properties[S],o.scope){case 1:delete e.applicationSettings.properties[S];break;case 2:delete e.machineSettings.properties[S];break;case 6:delete e.machineOverridableSettings.properties[S];break;case 3:delete e.windowSettings.properties[S];break;case 4:case 5:delete e.resourceSettings.properties[S];break}}updateOverridePropertyPatternKey(){for(const S of this.overrideIdentifiers.values()){const o=`[${S}]`,a={type:"object",description:L.localize(2,null),errorMessage:L.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(o,a),e.allSettings.properties[o]=a,e.applicationSettings.properties[o]=a,e.machineSettings.properties[o]=a,e.machineOverridableSettings.properties[o]=a,e.windowSettings.properties[o]=a,e.resourceSettings.properties[o]=a}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(S,o){let a=this.defaultValues[S];R.isUndefined(a)&&(a=o.default),R.isUndefined(a)&&(a=u(o.type)),o.default=a}}const f="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(f);function I(y){return y.substring(1,y.length-1)}e.overrideIdentifierFromKey=I;function u(y){switch(Array.isArray(y)?y[0]:y){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=u;const w=new C;P.Registry.add(e.Extensions.Configuration,w);function g(y){return y.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(y)?L.localize(5,null,y):w.getConfigurationProperties()[y]!==void 0?L.localize(6,null,y):null:L.localize(4,null)}e.validateProperty=g;function E(){const y=[],S=w.getConfigurationProperties();for(const o of Object.keys(S))y.push([o,S[o].scope]);return y.push(["launch",4]),y.push(["task",4]),y}e.getScopes=E}),define(Z[21],ee([0,1,26,17,5,38,7,33]),function(K,e,D,T,R,L,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,k.createDecorator)("configurationService");function m(s){return s&&typeof s=="object"&&(!s.overrideIdentifier||typeof s.overrideIdentifier=="string")&&(!s.resource||s.resource instanceof R.URI)}e.isConfigurationOverrides=m;var b;(function(s){s[s.USER=1]="USER",s[s.USER_LOCAL=2]="USER_LOCAL",s[s.USER_REMOTE=3]="USER_REMOTE",s[s.WORKSPACE=4]="WORKSPACE",s[s.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",s[s.DEFAULT=6]="DEFAULT",s[s.MEMORY=7]="MEMORY"})(b=e.ConfigurationTarget||(e.ConfigurationTarget={}));function i(s){switch(s){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=i;function C(s,n){const r=n?s?n.keys.filter(O=>s.keys.indexOf(O)===-1):[...n.keys]:[],c=s?n?s.keys.filter(O=>n.keys.indexOf(O)===-1):[...s.keys]:[],l=[];if(n&&s){for(const O of s.keys)if(n.keys.indexOf(O)!==-1){const p=E(s.contents,O),U=E(n.contents,O);D.equals(p,U)||l.push(O)}}const h=[],d=O=>{const p={};for(const U of O)for(const F of U.identifiers)p[a(F)]=U;return p},v=n?d(n.overrides):{},A=s?d(s.overrides):{};if(Object.keys(v).length)for(const O of r){const p=v[O];p&&h.push([(0,L.overrideIdentifierFromKey)(O),p.keys])}if(Object.keys(A).length)for(const O of c){const p=A[O];p&&h.push([(0,L.overrideIdentifierFromKey)(O),p.keys])}if(Object.keys(v).length&&Object.keys(A).length)for(const O of l){const p=A[O],U=v[O];if(p&&U){const F=C({contents:p.contents,keys:p.keys,overrides:[]},{contents:U.contents,keys:U.keys,overrides:[]});h.push([(0,L.overrideIdentifierFromKey)(O),[...F.added,...F.removed,...F.updated]])}}return{added:r,removed:c,updated:l,overrides:h}}e.compare=C;function f(s,n){const r=[];for(const c of Object.keys(s))if(L.OVERRIDE_PROPERTY_PATTERN.test(c)){const l={};for(const h in s[c])l[h]=s[c][h];r.push({identifiers:[(0,L.overrideIdentifierFromKey)(c).trim()],keys:Object.keys(l),contents:I(l,n)})}return r}e.toOverrides=f;function I(s,n){const r=Object.create(null);for(let c in s)u(r,c,s[c],n);return r}e.toValuesTree=I;function u(s,n,r,c){const l=n.split("."),h=l.pop();let d=s;for(let v=0;v<l.length;v++){let A=l[v],O=d[A];switch(typeof O){case"undefined":O=d[A]=Object.create(null);break;case"object":break;default:c(`Ignoring ${n} as ${l.slice(0,v+1).join(".")} is ${JSON.stringify(O)}`);return}d=O}if(typeof d=="object"&&d!==null)try{d[h]=r}catch(v){c(`Ignoring ${n} as ${l.join(".")} is ${JSON.stringify(d)}`)}else c(`Ignoring ${n} as ${l.join(".")} is ${JSON.stringify(d)}`)}e.addToValueTree=u;function w(s,n){const r=n.split(".");g(s,r)}e.removeFromValueTree=w;function g(s,n){const r=n.shift();if(n.length===0){delete s[r];return}if(Object.keys(s).indexOf(r)!==-1){const c=s[r];typeof c=="object"&&!Array.isArray(c)&&(g(c,n),Object.keys(c).length===0&&delete s[r])}}function E(s,n,r){function c(d,v){let A=d;for(const O of v){if(typeof A!="object"||A===null)return;A=A[O]}return A}const l=n.split("."),h=c(s,l);return typeof h=="undefined"?r:h}e.getConfigurationValue=E;function y(s,n,r){Object.keys(n).forEach(c=>{c!=="__proto__"&&(c in s?T.isObject(s[c])&&T.isObject(n[c])?y(s[c],n[c],r):r&&(s[c]=n[c]):s[c]=n[c])})}e.merge=y;function S(){const s=P.Registry.as(L.Extensions.Configuration).getConfigurationProperties();return Object.keys(s)}e.getConfigurationKeys=S;function o(){const s=Object.create(null),n=P.Registry.as(L.Extensions.Configuration).getConfigurationProperties();for(let r in n){let c=n[r].default;u(s,r,c,l=>console.error(`Conflict in default settings: ${l}`))}return s}e.getDefaultValues=o;function a(s){return`[${s}]`}e.keyFromOverrideIdentifier=a;function t(s,n,r){const c=s.inspect(n),l=s.inspect(r);return typeof c.userValue!="undefined"||typeof c.workspaceValue!="undefined"||typeof c.workspaceFolderValue!="undefined"?c.value:typeof l.userValue!="undefined"||typeof l.workspaceValue!="undefined"||typeof l.workspaceFolderValue!="undefined"?l.value:c.defaultValue}e.getMigratedSettingValue=t}),define(Z[173],ee([0,1,16,3,34,2,40,26,17,5,21,38,33]),function(K,e,D,T,R,L,k,P,m,b,i,C,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class I{constructor(t={},s=[],n=[]){this._contents=t,this._keys=s,this._overrides=n,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,i.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,s){const n=this.getContentsForOverrideIdentifer(s);return n?t?(0,i.getConfigurationValue)(n,t):n:void 0}getKeysForOverrideIdentifier(t){for(const s of this.overrides)if(s.identifiers.indexOf(t)!==-1)return s.keys;return[]}override(t){const s=this.getContentsForOverrideIdentifer(t);if(!s||typeof s!="object"||!Object.keys(s).length)return this;let n={};for(const r of D.distinct([...Object.keys(this.contents),...Object.keys(s)])){let c=this.contents[r],l=s[r];l&&(typeof c=="object"&&typeof l=="object"?(c=P.deepClone(c),this.mergeContents(c,l)):c=l),n[r]=c}return new I(n,this.keys,this.overrides)}merge(...t){const s=P.deepClone(this.contents),n=P.deepClone(this.overrides),r=[...this.keys];for(const c of t){this.mergeContents(s,c.contents);for(const l of c.overrides){const[h]=n.filter(d=>D.equals(d.identifiers,l.identifiers));h?this.mergeContents(h.contents,l.contents):n.push(P.deepClone(l))}for(const l of c.keys)r.indexOf(l)===-1&&r.push(l)}return new I(s,r,n)}freeze(){return this.isFrozen=!0,this}mergeContents(t,s){for(const n of Object.keys(s)){if(n in t&&m.isObject(t[n])&&m.isObject(s[n])){this.mergeContents(t[n],s[n]);continue}t[n]=P.deepClone(s[n])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?P.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const s of this.overrides)if(s.identifiers.indexOf(t)!==-1)return s.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,s){this.addKey(t),(0,i.addToValueTree)(this.contents,t,s,n=>{throw new Error(n)})}removeValue(t){this.removeKey(t)&&(0,i.removeFromValueTree)(this.contents,t)}addKey(t){let s=this.keys.length;for(let n=0;n<s;n++)t.indexOf(this.keys[n])===0&&(s=n);this.keys.splice(s,1,t)}removeKey(t){let s=this.keys.indexOf(t);return s!==-1?(this.keys.splice(s,1),!0):!1}}e.ConfigurationModel=I;class u extends I{constructor(){const t=(0,i.getDefaultValues)(),s=(0,i.getConfigurationKeys)(),n=[];for(const r of Object.keys(t))C.OVERRIDE_PROPERTY_PATTERN.test(r)&&n.push({identifiers:[(0,C.overrideIdentifierFromKey)(r).trim()],keys:Object.keys(t[r]),contents:(0,i.toValuesTree)(t[r],c=>console.error(`Conflict in default settings file: ${c}`))});super(t,s,n)}}e.DefaultConfigurationModel=u;class w{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new I}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,s){if(!m.isUndefinedOrNull(t)){const n=this.doParseContent(t);this.parseRaw(n,s)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,s){this._raw=t;const{contents:n,keys:r,overrides:c,restricted:l}=this.doParseRaw(t,s);this._configurationModel=new I(n,r,c),this._restrictedConfigurations=l||[]}doParseContent(t){let s={},n=null,r=[],c=[],l=[];function h(v){Array.isArray(r)?r.push(v):n!==null&&(r[n]=v)}let d={onObjectBegin:()=>{let v={};h(v),c.push(r),r=v,n=null},onObjectProperty:v=>{n=v},onObjectEnd:()=>{r=c.pop()},onArrayBegin:()=>{let v=[];h(v),c.push(r),r=v,n=null},onArrayEnd:()=>{r=c.pop()},onLiteralValue:h,onError:(v,A,O)=>{l.push({error:v,offset:A,length:O})}};if(t)try{R.visit(t,d),s=r[0]||{}}catch(v){console.error(`Error while parsing settings file ${this._name}: ${v}`),this._parseErrors=[v]}return s}doParseRaw(t,s){const n=f.Registry.as(C.Extensions.Configuration).getConfigurationProperties(),r=this.filter(t,n,!0,s);t=r.raw;const c=(0,i.toValuesTree)(t,d=>console.error(`Conflict in settings file ${this._name}: ${d}`)),l=Object.keys(t),h=(0,i.toOverrides)(t,d=>console.error(`Conflict in settings file ${this._name}: ${d}`));return{contents:c,keys:l,overrides:h,restricted:r.restricted}}filter(t,s,n,r){if(!r?.scopes&&!r?.skipRestricted)return{raw:t,restricted:[]};const c={},l=[];for(let h in t)if(C.OVERRIDE_PROPERTY_PATTERN.test(h)&&n){const d=this.filter(t[h],s,!1,r);c[h]=d.raw,l.push(...d.restricted)}else{const d=s[h],v=d?typeof d.scope!="undefined"?d.scope:3:void 0;d?.restricted&&l.push(h),(v===void 0||r.scopes===void 0||r.scopes.includes(v))&&(r.skipRestricted&&d?.restricted||(c[h]=t[h]))}return{raw:c,restricted:l}}}e.ConfigurationModelParser=w;class g extends L.Disposable{constructor(t,s,n,r){super();this.userSettingsResource=t,this.scopes=s,this.fileService=r,this._onDidChange=this._register(new T.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new w(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(n.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(T.Event.filter(this.fileService.onDidFilesChange,c=>c.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new I}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=g;class E{constructor(t,s,n=new I,r=new I,c=new k.ResourceMap,l=new I,h=new k.ResourceMap,d=!0){this._defaultConfiguration=t,this._localUserConfiguration=s,this._remoteUserConfiguration=n,this._workspaceConfiguration=r,this._folderConfigurations=c,this._memoryConfiguration=l,this._memoryConfigurationByResource=h,this._freeze=d,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new k.ResourceMap,this._userConfiguration=null}getValue(t,s,n){return this.getConsolidateConfigurationModel(s,n).getValue(t)}updateValue(t,s,n={}){let r;n.resource?(r=this._memoryConfigurationByResource.get(n.resource),r||(r=new I,this._memoryConfigurationByResource.set(n.resource,r))):r=this._memoryConfiguration,s===void 0?r.removeValue(t):r.setValue(t,s),n.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,s,n){const r=this.getConsolidateConfigurationModel(s,n),c=this.getFolderConfigurationModelForResource(s.resource,n),l=s.resource?this._memoryConfigurationByResource.get(s.resource)||this._memoryConfiguration:this._memoryConfiguration,h=s.overrideIdentifier?this._defaultConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),d=s.overrideIdentifier?this.userConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),v=s.overrideIdentifier?this.localUserConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),A=s.overrideIdentifier?this.remoteUserConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),O=n?s.overrideIdentifier?this._workspaceConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,p=c?s.overrideIdentifier?c.freeze().override(s.overrideIdentifier).getValue(t):c.freeze().getValue(t):void 0,U=s.overrideIdentifier?l.override(s.overrideIdentifier).getValue(t):l.getValue(t),F=r.getValue(t),$=D.distinct(D.flatten(r.overrides.map(H=>H.identifiers))).filter(H=>r.getOverrideValue(t,H)!==void 0);return{defaultValue:h,userValue:d,userLocalValue:v,userRemoteValue:A,workspaceValue:O,workspaceFolderValue:p,memoryValue:U,value:F,default:h!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,user:d!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,userLocal:v!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,userRemote:A!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,workspace:O!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,workspaceFolder:p!==void 0?{value:c?.freeze().getValue(t),override:s.overrideIdentifier?c?.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,memory:U!==void 0?{value:l.getValue(t),override:s.overrideIdentifier?l.getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,overrideIdentifiers:$.length?$:void 0}}keys(t){const s=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:s?s.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,s){this._folderConfigurations.set(t,s),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,s){const n=s.filter(r=>C.OVERRIDE_PROPERTY_PATTERN.test(r)).map(r=>{const c=(0,C.overrideIdentifierFromKey)(r),l=this._defaultConfiguration.getKeysForOverrideIdentifier(c),h=t.getKeysForOverrideIdentifier(c),d=[...h.filter(v=>l.indexOf(v)===-1),...l.filter(v=>h.indexOf(v)===-1),...l.filter(v=>!P.equals(this._defaultConfiguration.override(c).getValue(v),t.override(c).getValue(v)))];return[c,d]});return this.updateDefaultConfiguration(t),{keys:s,overrides:n}}compareAndUpdateLocalUserConfiguration(t){const{added:s,updated:n,removed:r,overrides:c}=(0,i.compare)(this.localUserConfiguration,t),l=[...s,...n,...r];return l.length&&this.updateLocalUserConfiguration(t),{keys:l,overrides:c}}compareAndUpdateRemoteUserConfiguration(t){const{added:s,updated:n,removed:r,overrides:c}=(0,i.compare)(this.remoteUserConfiguration,t);let l=[...s,...n,...r];return l.length&&this.updateRemoteUserConfiguration(t),{keys:l,overrides:c}}compareAndUpdateWorkspaceConfiguration(t){const{added:s,updated:n,removed:r,overrides:c}=(0,i.compare)(this.workspaceConfiguration,t);let l=[...s,...n,...r];return l.length&&this.updateWorkspaceConfiguration(t),{keys:l,overrides:c}}compareAndUpdateFolderConfiguration(t,s){const n=this.folderConfigurations.get(t),{added:r,updated:c,removed:l,overrides:h}=(0,i.compare)(n,s);let d=[...r,...c,...l];return(d.length||!n)&&this.updateFolderConfiguration(t,s),{keys:d,overrides:h}}compareAndDeleteFolderConfiguration(t){const s=this.folderConfigurations.get(t);if(!s)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:n,updated:r,removed:c,overrides:l}=(0,i.compare)(s,void 0);return{keys:[...n,...r,...c],overrides:l}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,s){let n=this.getConsolidatedConfigurationModelForResource(t,s);return t.overrideIdentifier?n.override(t.overrideIdentifier):n}getConsolidatedConfigurationModelForResource({resource:t},s){let n=this.getWorkspaceConsolidatedConfiguration();if(s&&t){const r=s.getFolder(t);r&&(n=this.getFolderConsolidatedConfiguration(r.uri)||n);const c=this._memoryConfigurationByResource.get(t);c&&(n=n.merge(c))}return n}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let s=this._foldersConsolidatedConfigurations.get(t);if(!s){const n=this.getWorkspaceConsolidatedConfiguration(),r=this._folderConfigurations.get(t);r?(s=n.merge(r),this._freeze&&(s=s.freeze()),this._foldersConsolidatedConfigurations.set(t,s)):s=n}return s}getFolderConfigurationModelForResource(t,s){if(s&&t){const n=s.getFolder(t);if(n)return this._folderConfigurations.get(n.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,s)=>{const{contents:n,overrides:r,keys:c}=this._folderConfigurations.get(s);return t.push([s,{contents:n,overrides:r,keys:c}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(s=>t.add(s)),this.userConfiguration.freeze().keys.forEach(s=>t.add(s)),this._workspaceConfiguration.freeze().keys.forEach(s=>t.add(s)),this._folderConfigurations.forEach(s=>s.freeze().keys.forEach(n=>t.add(n))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const s=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(n=>s.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(n=>s.add(n)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(n=>s.add(n)),this._folderConfigurations.forEach(n=>n.getKeysForOverrideIdentifier(t).forEach(r=>s.add(r))),[...s.values()]}static parse(t){const s=this.parseConfigurationModel(t.defaults),n=this.parseConfigurationModel(t.user),r=this.parseConfigurationModel(t.workspace),c=t.folders.reduce((l,h)=>(l.set(b.URI.revive(h[0]),this.parseConfigurationModel(h[1])),l),new k.ResourceMap);return new E(s,n,new I,r,c,new I,new k.ResourceMap,!1)}static parseConfigurationModel(t){return new I(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=E;function y(...a){if(a.length===0)return{keys:[],overrides:[]};if(a.length===1)return a[0];const t=new Set,s=new Map;for(const r of a)r.keys.forEach(c=>t.add(c)),r.overrides.forEach(([c,l])=>{const h=(0,k.getOrSet)(s,c,new Set);l.forEach(d=>h.add(d))});const n=[];return s.forEach((r,c)=>n.push([c,[...r.values()]])),{keys:[...t.values()],overrides:n}}e.mergeChanges=y;class S{constructor(t,s,n,r){this.change=t,this.previous=s,this.currentConfiguraiton=n,this.currentWorkspace=r,this._previousConfiguration=void 0;const c=new Set;t.keys.forEach(h=>c.add(h)),t.overrides.forEach(([,h])=>h.forEach(d=>c.add(d))),this.affectedKeys=[...c.values()];const l=new I;this.affectedKeys.forEach(h=>l.setValue(h,{})),this.affectedKeysTree=l.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=E.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,s){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(s){const n=this.previousConfiguration?this.previousConfiguration.getValue(t,s,this.previous?.workspace):void 0,r=this.currentConfiguraiton.getValue(t,s,this.currentWorkspace);return!P.equals(n,r)}return!0}return!1}doesAffectedKeysTreeContains(t,s){let n=(0,i.toValuesTree)({[s]:!0},()=>{}),r;for(;typeof n=="object"&&(r=Object.keys(n)[0]);){if(t=t[r],!t)return!1;n=n[r]}return!0}}e.ConfigurationChangeEvent=S;class o extends S{constructor(t,s,n,r){super({keys:t.allKeys(),overrides:[]},void 0,t,s);this.source=n,this.sourceConfig=r}}e.AllKeysConfigurationChangeEvent=o}),define(Z[174],ee([0,1,6,3,2,15,21,173,38,33]),function(K,e,D,T,R,L,k,P,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class i extends R.Disposable{constructor(f,I){super();this.settingsResource=f,this._onDidChangeConfiguration=this._register(new T.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new P.UserSettings(this.settingsResource,void 0,L.extUriBiasedIgnorePathCase,I)),this.configuration=new P.Configuration(new P.DefaultConfigurationModel,new P.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new D.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(b.Registry.as(m.Extensions.Configuration).onDidUpdateConfiguration(u=>this.onDidDefaultConfigurationChange(u))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const f=await this.userConfiguration.loadConfiguration();this.configuration=new P.Configuration(new P.DefaultConfigurationModel,f)}getConfigurationData(){return this.configuration.toData()}getValue(f,I){const u=typeof f=="string"?f:void 0,w=(0,k.isConfigurationOverrides)(f)?f:(0,k.isConfigurationOverrides)(I)?I:{};return this.configuration.getValue(u,w,void 0)}updateValue(f,I,u,w){return Promise.reject(new Error("not supported"))}inspect(f){return this.configuration.inspect(f,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const f=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(f)}onDidChangeUserConfiguration(f){const I=this.configuration.toData(),u=this.configuration.compareAndUpdateLocalUserConfiguration(f);this.trigger(u,I,1)}onDidDefaultConfigurationChange(f){const I=this.configuration.toData(),u=this.configuration.compareAndUpdateDefaultConfiguration(new P.DefaultConfigurationModel,f);this.trigger(u,I,6)}trigger(f,I,u){const w=new P.ConfigurationChangeEvent(f,{data:I},this.configuration);w.source=u,w.sourceConfig=this.getTargetConfiguration(u),this._onDidChangeConfiguration.fire(w)}getTargetConfiguration(f){switch(f){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=i}),define(Z[175],ee([0,1,105,21,14]),function(K,e,D,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let L=class{constructor(P,m){this.configurationService=P,this.logService=m}request(P,m){return this.logService.trace("RequestService#request",P.url),P.proxyAuthorization||(P.proxyAuthorization=this.configurationService.getValue("http.proxyAuthorization")),(0,D.request)(P,m)}async resolveProxy(P){}};L=de([X(0,T.IConfigurationService),X(1,R.ILogService)],L),e.RequestService=L}),define(Z[43],ee([0,1,25,125,38,7,33]),function(K,e,D,T,R,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,L.createDecorator)("requestService");function P(u){return u.res.statusCode&&u.res.statusCode>=200&&u.res.statusCode<300||u.res.statusCode===1223}e.isSuccess=P;function m(u){return u.res.statusCode===204}async function b(u){if(!P(u))throw new Error("Server returned "+u.res.statusCode);return m(u)?null:(await(0,D.streamToBuffer)(u.stream)).toString()}e.asText=b;async function i(u){if(!P(u))throw new Error("Server returned "+u.res.statusCode);if(m(u))return null;const g=(await(0,D.streamToBuffer)(u.stream)).toString();try{return JSON.parse(g)}catch(E){throw E.message+=`:
`+g,E}}e.asJson=i;function C(u){I(u)}e.updateProxyConfigurationsScope=C;let f;function I(u){const w=k.Registry.as(R.Extensions.Configuration),g=f;f={id:"http",order:15,title:(0,T.localize)(0,null),type:"object",scope:u,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,T.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,T.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,T.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,T.localize)(4,null),(0,T.localize)(5,null),(0,T.localize)(6,null),(0,T.localize)(7,null)],default:"override",description:(0,T.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,T.localize)(9,null),restricted:!0}}},w.updateConfigurations({add:[f],remove:g?[g]:[]})}I(2)}),define(Z[176],ee([0,1,27,18,13,43]),function(K,e,D,T,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let k=class{constructor(m,b){this.requestService=m,this.fileService=b}async download(m,b,i=D.CancellationToken.None){if(m.scheme===T.Schemas.file||m.scheme===T.Schemas.vscodeRemote){await this.fileService.copy(m,b);return}const C={type:"GET",url:m.toString()},f=await this.requestService.request(C,i);if(f.res.statusCode===200)await this.fileService.writeFile(b,f.stream);else{const I=await(0,L.asText)(f);throw new Error(`Expected 200, got back ${f.res.statusCode} instead.

${I}`)}}};k=de([X(0,L.IRequestService),X(1,R.IFileService)],k),e.DownloadService=k}),define(Z[177],ee([0,1,16,27,63,2,15,139,13,14,29,43]),function(K,e,D,T,R,L,k,P,m,b,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let f=class extends L.Disposable{constructor(u,w,g,E){super();this.fileService=u,this.productService=w,this.requestService=g,this.logService=E,this.allConfigBasedTips=new Map,this.productService.configBasedExtensionTips&&(0,R.forEach)(this.productService.configBasedExtensionTips,({value:y})=>this.allConfigBasedTips.set(y.configPath,y))}getConfigBasedTips(u){return this.getValidConfigBasedTips(u)}getAllWorkspacesTips(){return this.fetchWorkspacesTips()}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async getValidConfigBasedTips(u){const w=[];for(const[g,E]of this.allConfigBasedTips)try{const y=await this.fileService.readFile((0,k.joinPath)(u,g)),S=new Map;(0,R.forEach)(E.recommendations,({key:a,value:t})=>{if((0,D.isNonEmptyArray)(t.remotes))for(const s of t.remotes)S.set(s,{extensionId:a,extensionName:t.name,configName:E.configName,important:!!t.important,isExtensionPack:!!t.isExtensionPack});else w.push({extensionId:a,extensionName:t.name,configName:E.configName,important:!!t.important,isExtensionPack:!!t.isExtensionPack})});const o=(0,P.getDomainsOfRemotes)(y.value.toString(),[...S.keys()]);for(const a of o){const t=S.get(a);t&&w.push(t)}}catch(y){}return w}async fetchWorkspacesTips(){if(!this.productService.extensionsGallery?.recommendationsUrl)return[];try{const u=await this.requestService.request({type:"GET",url:this.productService.extensionsGallery?.recommendationsUrl},T.CancellationToken.None);if(u.res.statusCode!==200)return[];const w=await(0,C.asJson)(u);return w?w.workspaceRecommendations||[]:[]}catch(u){return this.logService.error(u),[]}}};f=de([X(0,m.IFileService),X(1,i.IProductService),X(2,C.IRequestService),X(3,b.ILogService)],f),e.ExtensionTipsService=f}),define(Z[46],ee([0,1,25,30]),function(K,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function R(L,k,P){let m=P&&P.get("storage.serviceMachineId",0)||null;if(m)return m;try{const i=(await k.readFile(L.serviceMachineIdResource)).value.toString();m=(0,T.isUUID)(i)?i:null}catch(b){m=null}if(!m){m=(0,T.generateUuid)();try{await k.writeFile(L.serviceMachineIdResource,D.VSBuffer.fromString(m))}catch(b){}}return P&&P.store("storage.serviceMachineId",m,0,1),m}e.getServiceMachineId=R}),define(Z[22],ee([0,1,6,3,2,17,70,7]),function(K,e,D,T,R,L,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const m="__$__targetStorageMarker";e.IStorageService=(0,P.createDecorator)("storageService");var b;(function(w){w[w.NONE=0]="NONE",w[w.SHUTDOWN=1]="SHUTDOWN"})(b=e.WillSaveStateReason||(e.WillSaveStateReason={}));var i;(function(w){w[w.GLOBAL=0]="GLOBAL",w[w.WORKSPACE=1]="WORKSPACE"})(i=e.StorageScope||(e.StorageScope={}));var C;(function(w){w[w.USER=0]="USER",w[w.MACHINE=1]="MACHINE"})(C=e.StorageTarget||(e.StorageTarget={}));class f extends R.Disposable{constructor(g={flushInterval:f.DEFAULT_FLUSH_INTERVAL}){super();this.options=g,this._onDidChangeValue=this._register(new T.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new T.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new T.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new D.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new R.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,D.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,R.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{await this.doInitialize(),this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(g,E){E===m?(g===0?this._globalKeyTargets=void 0:g===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:g})):this._onDidChangeValue.fire({scope:g,key:E,target:this.getKeyTargets(g)[E]})}emitWillSaveState(g){this._onWillSaveState.fire({reason:g})}get(g,E,y){return this.getStorage(E)?.get(g,y)}getBoolean(g,E,y){return this.getStorage(E)?.getBoolean(g,y)}getNumber(g,E,y){return this.getStorage(E)?.getNumber(g,y)}store(g,E,y,S){if((0,L.isUndefinedOrNull)(E)){this.remove(g,y);return}this.withPausedEmitters(()=>{this.updateKeyTarget(g,y,S),this.getStorage(y)?.set(g,E)})}remove(g,E){this.withPausedEmitters(()=>{this.updateKeyTarget(g,E,void 0),this.getStorage(E)?.delete(g)})}withPausedEmitters(g){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{g()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(g,E){const y=[],S=this.getKeyTargets(g);for(const o of Object.keys(S))S[o]===E&&y.push(o);return y}updateKeyTarget(g,E,y){const S=this.getKeyTargets(E);typeof y=="number"?S[g]!==y&&(S[g]=y,this.getStorage(E)?.set(m,JSON.stringify(S))):typeof S[g]=="number"&&(delete S[g],this.getStorage(E)?.set(m,JSON.stringify(S)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(g){return g===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(g){const E=this.get(m,g);if(E)try{return JSON.parse(E)}catch(y){}return Object.create(null)}isNew(g){return this.getBoolean(e.IS_NEW_KEY,g)===!0}async flush(g=b.NONE){this._onWillSaveState.fire({reason:g}),await D.Promises.settled([this.getStorage(0)?.whenFlushed()??Promise.resolve(),this.getStorage(1)?.whenFlushed()??Promise.resolve()])}async logStorage(){const g=this.getStorage(0)?.items??new Map,E=this.getStorage(1)?.items??new Map;return u(g,E,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}e.AbstractStorageService=f,f.DEFAULT_FLUSH_INTERVAL=60*1e3;class I extends f{constructor(){super();this.globalStorage=this._register(new k.Storage(new k.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new k.Storage(new k.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(g=>this.emitDidChangeValue(1,g))),this._register(this.globalStorage.onDidChangeStorage(g=>this.emitDidChangeValue(0,g)))}getStorage(g){return g===0?this.globalStorage:this.workspaceStorage}getLogDetails(g){return g===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(g){}}e.InMemoryStorageService=I;async function u(w,g,E,y){const S=c=>{try{return JSON.parse(c)}catch(l){return c}},o=new Map,a=new Map;w.forEach((c,l)=>{o.set(l,c),a.set(l,S(c))});const t=new Map,s=new Map;g.forEach((c,l)=>{t.set(l,c),s.set(l,S(c))}),console.group(`Storage: Global (path: ${E})`);let n=[];o.forEach((c,l)=>{n.push({key:l,value:c})}),console.table(n),console.groupEnd(),console.log(a),console.group(`Storage: Workspace (path: ${y})`);let r=[];t.forEach((c,l)=>{r.push({key:l,value:c})}),console.table(r),console.groupEnd(),console.log(s)}e.logStorage=u}),define(Z[178],ee([0,1,3,2,17,28,32,22]),function(K,e,D,T,R,L,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let m=class extends T.Disposable{constructor(C){super();this._onDidChangeEnablement=new D.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this.storageManger=this._register(new b(C)),this._register(this.storageManger.onDidChange(f=>this._onDidChangeEnablement.fire({extensions:f,source:"storage"})))}async enableExtension(C,f){return this._removeFromDisabledExtensions(C)?(this._onDidChangeEnablement.fire({extensions:[C],source:f}),!0):!1}async disableExtension(C,f){return this._addToDisabledExtensions(C)?(this._onDidChangeEnablement.fire({extensions:[C],source:f}),!0):!1}getDisabledExtensions(){return this._getExtensions(L.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}_addToDisabledExtensions(C){let f=this.getDisabledExtensions();return f.every(I=>!(0,k.areSameExtensions)(I,C))?(f.push(C),this._setDisabledExtensions(f),!0):!1}_removeFromDisabledExtensions(C){let f=this.getDisabledExtensions();for(let I=0;I<f.length;I++){const u=f[I];if((0,k.areSameExtensions)(u,C))return f.splice(I,1),this._setDisabledExtensions(f),!0}return!1}_setDisabledExtensions(C){this._setExtensions(L.DISABLED_EXTENSIONS_STORAGE_PATH,C)}_getExtensions(C){return this.storageManger.get(C,0)}_setExtensions(C,f){this.storageManger.set(C,f,0)}};m=de([X(0,P.IStorageService)],m),e.GlobalExtensionEnablementService=m;class b extends T.Disposable{constructor(C){super();this.storageService=C,this.storage=Object.create(null),this._onDidChange=this._register(new D.Emitter),this.onDidChange=this._onDidChange.event,this._register(C.onDidChangeValue(f=>this.onDidStorageChange(f)))}get(C,f){let I;return f===0?((0,R.isUndefinedOrNull)(this.storage[C])&&(this.storage[C]=this._get(C,f)),I=this.storage[C]):I=this._get(C,f),JSON.parse(I)}set(C,f,I){let u=JSON.stringify(f.map(({id:g,uuid:E})=>({id:g,uuid:E})));this._get(C,I)!==u&&(I===0&&(f.length?this.storage[C]=u:delete this.storage[C]),this._set(C,f.length?u:void 0,I))}onDidStorageChange(C){if(C.scope===0&&!(0,R.isUndefinedOrNull)(this.storage[C.key])&&this._get(C.key,C.scope)!==this.storage[C.key]){const I=this.get(C.key,C.scope);delete this.storage[C.key];const u=this.get(C.key,C.scope),w=I.filter(E=>!u.some(y=>(0,k.areSameExtensions)(E,y))),g=u.filter(E=>!I.some(y=>(0,k.areSameExtensions)(y,E)));(w.length||g.length)&&this._onDidChange.fire([...w,...g])}}_get(C,f){return this.storageService.get(C,f,"[]")}_set(C,f,I){f?this.storageService.store(C,f,I,1):this.storageService.remove(C,I)}}e.StorageManager=b}),define(Z[179],ee([0,1,3,2]),function(K,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannelClient=void 0;class R extends T.Disposable{constructor(b,i){super();this.channel=b,this.workspace=i}async getItems(){const b={workspace:this.workspace},i=await this.channel.call("getItems",b);return new Map(i)}updateItems(b){const i={workspace:this.workspace};return b.insert&&(i.insert=Array.from(b.insert.entries())),b.delete&&(i.delete=Array.from(b.delete.values())),this.channel.call("updateItems",i)}}class L extends R{constructor(b){super(b,void 0);this._onDidChangeItemsExternal=this._register(new D.Emitter),this.onDidChangeItemsExternal=this._onDidChangeItemsExternal.event,this.registerListeners()}registerListeners(){this._register(this.channel.listen("onDidChangeGlobalStorage")(b=>this.onDidChangeGlobalStorage(b)))}onDidChangeGlobalStorage(b){(Array.isArray(b.changed)||Array.isArray(b.deleted))&&this._onDidChangeItemsExternal.fire({changed:b.changed?new Map(b.changed):void 0,deleted:b.deleted?new Set(b.deleted):void 0})}async close(){this.dispose()}}class k extends R{constructor(b,i){super(b,i);this.onDidChangeItemsExternal=D.Event.None}async close(){const b={workspace:this.workspace};return this.channel.call("close",b)}}class P extends T.Disposable{constructor(b,i){super();this.channel=b,this.workspace=i,this._globalStorage=void 0,this._workspaceStorage=void 0}get globalStorage(){return this._globalStorage||(this._globalStorage=new L(this.channel)),this._globalStorage}get workspaceStorage(){return!this._workspaceStorage&&this.workspace&&(this._workspaceStorage=new k(this.channel,this.workspace)),this._workspaceStorage}}e.StorageDatabaseChannelClient=P}),define(Z[180],ee([0,1,6,2,169,15,70,22,179]),function(K,e,D,T,R,L,k,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeStorageService=void 0;class b extends P.AbstractStorageService{constructor(C,f,I){super();this.mainProcessService=f,this.environmentService=I,this.workspaceStorage=void 0,this.workspaceStorageId=void 0,this.workspaceStorageDisposable=this._register(new T.MutableDisposable),this.globalStorage=this.createGlobalStorage(),this.workspaceStorage=this.createWorkspaceStorage(C)}createGlobalStorage(){const C=new m.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),void 0),f=new k.Storage(C.globalStorage);return this._register(f.onDidChangeStorage(I=>this.emitDidChangeValue(0,I))),f}createWorkspaceStorage(C){const f=new m.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),C);if(f.workspaceStorage){const I=new k.Storage(f.workspaceStorage);return this.workspaceStorageDisposable.value=I.onDidChangeStorage(u=>this.emitDidChangeValue(1,u)),this.workspaceStorageId=C?.id,I}else{this.workspaceStorageDisposable.clear(),this.workspaceStorageId=void 0;return}}async doInitialize(){(0,R.mark)("code/willInitStorage");try{await D.Promises.settled([this.globalStorage.init(),this.workspaceStorage?.init()??Promise.resolve()])}finally{(0,R.mark)("code/didInitStorage")}}getStorage(C){return C===0?this.globalStorage:this.workspaceStorage}getLogDetails(C){return C===0?this.environmentService.globalStorageHome.fsPath:this.workspaceStorageId?`${(0,L.joinPath)(this.environmentService.workspaceStorageHome,this.workspaceStorageId,"state.vscdb").fsPath}`:void 0}async close(){this.stopFlushWhenIdle(),this.emitWillSaveState(P.WillSaveStateReason.SHUTDOWN),await D.Promises.settled([this.globalStorage.close(),this.workspaceStorage?.close()??Promise.resolve()])}async migrate(C){const f=this.workspaceStorage,I=f?.items??new Map;f&&(await f.close(),f.dispose()),this.workspaceStorage=this.createWorkspaceStorage(C),await this.workspaceStorage.init();for(const[u,w]of I)this.workspaceStorage.set(u,w)}}e.NativeStorageService=b}),define(Z[181],ee([0,1,4,31,5,30]),function(K,e,D,T,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function k(b){if(D.platform===2&&/^penguin(\.|$)/i.test(b))return"chromebook"}async function P(b,i,C,f,I,u,w,g,E,y){const S=Object.create(null);S["common.machineId"]=w,S.sessionID=(0,L.generateUuid)()+Date.now(),S.commitHash=I,S.version=u,S["common.platformVersion"]=(i||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),S["common.platform"]=(0,D.PlatformToString)(D.platform),S["common.nodePlatform"]=T.platform,S["common.nodeArch"]=f,S["common.product"]=y||"desktop";const o=m(g||[]);o&&(S["common.msftInternal"]=o);let a=0;const t=Date.now();Object.defineProperties(S,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-t,enumerable:!0},"common.sequence":{get:()=>a++,enumerable:!0}}),D.isLinuxSnap&&(S["common.snap"]="true");const s=k(C);s&&(S["common.platformDetail"]=s);try{const n=await b.readFile(R.URI.file(E));S["common.source"]=n.value.toString().slice(0,30)}catch(n){}return S}e.resolveCommonProperties=P;function m(b){const i=T.env.USERDNSDOMAIN;if(!i)return!1;const C=i.toLowerCase();return b.some(f=>C===f)}e.verifyMicrosoftInternalDomain=m}),define(Z[20],ee([0,1,7]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.instanceStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,D.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,D.createDecorator)("customEndpointTelemetryService"),e.instanceStorageKey="telemetry.instanceId",e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var T;(function(L){L[L.NONE=0]="NONE",L[L.LOG=1]="LOG",L[L.USER=2]="USER"})(T=e.TelemetryLevel||(e.TelemetryLevel={}));var R;(function(L){L.OFF="off",L.ERROR="error",L.ON="on"})(R=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(Z[182],ee([0,1,35,55,34,18,8,4,5,98,19,100,73,13,29,20]),function(K,e,D,T,R,L,k,P,m,b,i,C,f,I,u,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function g(a,t){const s=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.yml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i}],n=new Map,r=new Map,c=2e4;function l(v,A,O,p){const U=A.substring(v.length+1);return new Promise(async F=>{let $;try{$=await i.Promises.readdir(A,{withFileTypes:!0})}catch(j){F();return}if(p.count>=c){p.count+=$.length,p.maxReached=!0,F();return}let H=$.length;if(H===0){F();return}let M=$;p.count+$.length>c&&(p.maxReached=!0,H=c-p.count,M=$.slice(0,H)),p.count+=$.length;for(const j of M)if(j.isDirectory()){if(O.includes(j.name)||await l(v,(0,k.join)(A,j.name),O,p),--H==0){F();return}}else{const q=j.name.lastIndexOf(".");if(q>=0){const z=j.name.substring(q+1);z&&n.set(z,(n.get(z)??0)+1)}for(const z of s)z.relativePathPattern?.test(U)!==!1&&z.filePattern.test(j.name)&&r.set(z.tag,(r.get(z.tag)??0)+1);if(--H==0){F();return}}})}const h={count:0,maxReached:!1};await l(a,a,t,h);const d=await S(a);return{configFiles:E(r),fileTypes:E(n),fileCount:h.count,maxFilesReached:h.maxReached,launchConfigFiles:d}}e.collectWorkspaceStats=g;function E(a){return[...T.Iterable.map(a.entries(),([t,s])=>({name:t,count:s}))].sort((t,s)=>s.count-t.count)}function y(){const a={os:`${D.type()} ${D.arch()} ${D.release()}`,memory:`${(D.totalmem()/I.ByteSize.GB).toFixed(2)}GB (${(D.freemem()/I.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(b.virtualMachineHint.value()*100)}%`},t=D.cpus();return t&&t.length>0&&(a.cpus=`${t[0].model} (${t.length} x ${t[0].speed})`),a}e.getMachineInfo=y;async function S(a){try{const t=new Map,s=(0,k.join)(a,".vscode","launch.json"),n=await i.Promises.readFile(s),r=[],c=(0,R.parse)(n.toString(),r);if(r.length)return console.log(`Unable to parse ${s}`),[];if((0,R.getNodeType)(c)==="object"&&c.configurations)for(const l of c.configurations){const h=l.type;h&&(t.has(h)?t.set(h,t.get(h)+1):t.set(h,1))}return E(t)}catch(t){return[]}}e.collectLaunchConfigs=S;let o=class{constructor(t,s){this.telemetryService=t,this.productService=s}formatMachineInfo(t){const s=[];return s.push(`OS Version:       ${t.os}`),s.push(`CPUs:             ${t.cpus}`),s.push(`Memory (System):  ${t.memory}`),s.push(`VM:               ${t.vmHint}`),s.join(`
`)}formatEnvironment(t){const s=[];s.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),s.push(`OS Version:       ${D.type()} ${D.arch()} ${D.release()}`);const n=D.cpus();return n&&n.length>0&&s.push(`CPUs:             ${n[0].model} (${n.length} x ${n[0].speed})`),s.push(`Memory (System):  ${(D.totalmem()/I.ByteSize.GB).toFixed(2)}GB (${(D.freemem()/I.ByteSize.GB).toFixed(2)}GB free)`),P.isWindows||s.push(`Load (avg):       ${D.loadavg().map(r=>Math.round(r)).join(", ")}`),s.push(`VM:               ${Math.round(b.virtualMachineHint.value()*100)}%`),s.push(`Screen Reader:    ${t.screenReader?"yes":"no"}`),s.push(`Process Argv:     ${t.mainArguments.join(" ")}`),s.push(`GPU Status:       ${this.expandGPUFeatures(t.gpuFeatureStatus)}`),s.join(`
`)}async getPerformanceInfo(t,s){return Promise.all([(0,C.listProcesses)(t.mainPID),this.formatWorkspaceMetadata(t)]).then(async n=>{let[r,c]=n,l=this.formatProcessList(t,r);return s.forEach(h=>{if((0,f.isRemoteDiagnosticError)(h))l+=`
${h.errorMessage}`,c+=`
${h.errorMessage}`;else if(l+=`

Remote: ${h.hostName}`,h.processes&&(l+=`
${this.formatProcessList(t,h.processes)}`),h.workspaceMetadata){c+=`
|  Remote: ${h.hostName}`;for(const d of Object.keys(h.workspaceMetadata)){const v=h.workspaceMetadata[d];let A=`${v.fileCount} files`;v.maxFilesReached&&(A=`more than ${A}`),c+=`|    Folder (${d}): ${A}`,c+=this.formatWorkspaceStats(v)}}}),{processInfo:l,workspaceInfo:c}})}async getSystemInfo(t,s){const{memory:n,vmHint:r,os:c,cpus:l}=y(),h={os:c,memory:n,cpus:l,vmHint:r,processArgs:`${t.mainArguments.join(" ")}`,gpuStatus:t.gpuFeatureStatus,screenReader:`${t.screenReader?"yes":"no"}`,remoteData:s};return P.isWindows||(h.load=`${D.loadavg().map(d=>Math.round(d)).join(", ")}`),P.isLinux&&(h.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(h)}async getDiagnostics(t,s){const n=[];return(0,C.listProcesses)(t.mainPID).then(async r=>(n.push(""),n.push(this.formatEnvironment(t)),n.push(""),n.push(this.formatProcessList(t,r)),t.windows.some(c=>c.folderURIs&&c.folderURIs.length>0&&!c.remoteAuthority)&&(n.push(""),n.push("Workspace Stats: "),n.push(await this.formatWorkspaceMetadata(t))),s.forEach(c=>{if((0,f.isRemoteDiagnosticError)(c))n.push(`
${c.errorMessage}`);else if(n.push(`

`),n.push(`Remote:           ${c.hostName}`),n.push(this.formatMachineInfo(c.machineInfo)),c.processes&&n.push(this.formatProcessList(t,c.processes)),c.workspaceMetadata)for(const l of Object.keys(c.workspaceMetadata)){const h=c.workspaceMetadata[l];let d=`${h.fileCount} files`;h.maxFilesReached&&(d=`more than ${d}`),n.push(`Folder (${l}): ${d}`),n.push(this.formatWorkspaceStats(h))}}),n.push(""),n.push(""),n.join(`
`)))}formatWorkspaceStats(t){const s=[],n=60;let r=0;const c=(v,A)=>{const O=` ${v}(${A})`;r+O.length>n?(s.push(l),l="|                 ",r=l.length):r+=O.length,l+=O};let l="|      File types:";const h=10;let d=t.fileTypes.length>h?h:t.fileTypes.length;for(let v=0;v<d;v++){const A=t.fileTypes[v];c(A.name,A.count)}if(s.push(l),t.configFiles.length>=0&&(l="|      Conf files:",r=0,t.configFiles.forEach(v=>{c(v.name,v.count)}),s.push(l)),t.launchConfigFiles.length>0){let v="|      Launch Configs:";t.launchConfigFiles.forEach(A=>{v+=A.count>1?` ${A.name}(${A.count})`:` ${A.name}`}),s.push(v)}return s.join(`
`)}expandGPUFeatures(t){const s=Math.max(...Object.keys(t).map(n=>n.length));return Object.keys(t).map(n=>`${n}:  ${" ".repeat(s-n.length)}  ${t[n]}`).join(`
                  `)}formatWorkspaceMetadata(t){const s=[],n=[];return t.windows.forEach(r=>{r.folderURIs.length===0||!!r.remoteAuthority||(s.push(`|  Window (${r.title})`),r.folderURIs.forEach(c=>{const l=m.URI.revive(c);if(l.scheme===L.Schemas.file){const h=l.fsPath;n.push(g(h,["node_modules",".git"]).then(d=>{let v=`${d.fileCount} files`;d.maxFilesReached&&(v=`more than ${v}`),s.push(`|    Folder (${(0,k.basename)(h)}): ${v}`),s.push(this.formatWorkspaceStats(d))}).catch(d=>{s.push(`|      Error: Unable to collect workspace stats for folder ${h} (${d.toString()})`)}))}else s.push(`|    Folder (${l.toString()}): Workspace stats not available.`)}))}),Promise.all(n).then(r=>s.join(`
`)).catch(r=>`Unable to collect workspace stats: ${r}`)}formatProcessList(t,s){const n=new Map;t.windows.forEach(c=>n.set(c.pid,c.title));const r=[];return r.push("CPU %	Mem MB	   PID	Process"),s&&this.formatProcessItem(t.mainPID,n,r,s,0),r.join(`
`)}formatProcessItem(t,s,n,r,c){const l=c===0;let h;l?h=r.pid===t?`${this.productService.applicationName} main`:"remote agent":(h=`${"  ".repeat(c)} ${r.name}`,r.name==="window"&&(h=`${h} (${s.get(r.pid)})`));const d=process.platform==="win32"?r.mem:D.totalmem()*(r.mem/100);n.push(`${r.load.toFixed(0).padStart(5," ")}	${(d/I.ByteSize.MB).toFixed(0).padStart(6," ")}	${r.pid.toFixed(0).padStart(6," ")}	${h}`),Array.isArray(r.children)&&r.children.forEach(v=>this.formatProcessItem(t,s,n,v,c+1))}async reportWorkspaceStats(t){for(const{uri:s}of t.folders){const n=m.URI.revive(s);if(n.scheme!==L.Schemas.file)continue;const r=n.fsPath;try{const c=await g(r,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":t.telemetryId,rendererSessionId:t.rendererSessionId}),c.fileTypes.forEach(l=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:t.rendererSessionId,type:l.name,count:l.count})}),c.launchConfigFiles.forEach(l=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:t.rendererSessionId,type:l.name,count:l.count})}),c.configFiles.forEach(l=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:t.rendererSessionId,type:l.name,count:l.count})})}catch{}}}};o=de([X(0,w.ITelemetryService),X(1,u.IProductService)],o),e.DiagnosticsService=o}),define(Z[183],ee([0,1,16,6,27,9,3,2,4,5,114,28,32,14,42,20]),function(K,e,D,T,R,L,k,P,m,b,i,C,f,I,u,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.reportTelemetry=e.joinErrors=e.AbstractExtensionManagementService=e.INSTALL_ERROR_LOCAL=e.ERROR_UNKNOWN=e.INSTALL_ERROR_VALIDATING=void 0,e.INSTALL_ERROR_VALIDATING="validating",e.ERROR_UNKNOWN="unknown",e.INSTALL_ERROR_LOCAL="local";let g=class extends P.Disposable{constructor(a,t,s){super();this.galleryService=a,this.telemetryService=t,this.logService=s,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new k.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new k.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new k.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new k.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,P.toDisposable)(()=>{this.installingExtensions.forEach(n=>n.cancel()),this.uninstallingExtensions.forEach(n=>n.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(a){const t=await this.getTargetPlatform();return a.allTargetPlatforms.some(s=>(0,C.isTargetPlatformCompatible)(s,a.allTargetPlatforms,t))}async installFromGallery(a,t={}){if(!this.galleryService.isEnabled())throw new Error(i.localize(0,null));if(!await this.canInstall(a)){const n=await this.getTargetPlatform(),r=new C.ExtensionManagementError(i.localize(1,null,a.identifier.id,u.default.nameLong,(0,C.TargetPlatformToString)(n)),e.INSTALL_ERROR_VALIDATING);throw this.logService.error("Cannot install extension.",a.identifier.id,r.message),y(this.telemetryService,"extensionGallery:install",(0,f.getGalleryExtensionTelemetryData)(a),void 0,r),r}try{a=await this.checkAndGetCompatibleVersion(a,!t.installGivenVersion)}catch(n){throw this.logService.error((0,L.getErrorMessage)(n)),y(this.telemetryService,"extensionGallery:install",(0,f.getGalleryExtensionTelemetryData)(a),void 0,n),n}const s=await this.galleryService.getManifest(a,R.CancellationToken.None);if(s===null){const n=new C.ExtensionManagementError(`Missing manifest for extension ${a.identifier.id}`,e.INSTALL_ERROR_VALIDATING);throw this.logService.error("Failed to install extension:",a.identifier.id,n.message),y(this.telemetryService,"extensionGallery:install",(0,f.getGalleryExtensionTelemetryData)(a),void 0,n),n}if(s.version!==a.version){const n=new C.ExtensionManagementError(`Cannot install '${a.identifier.id}' extension because of version mismatch in Marketplace`,e.INSTALL_ERROR_VALIDATING);throw this.logService.error(n.message),y(this.telemetryService,"extensionGallery:install",(0,f.getGalleryExtensionTelemetryData)(a),void 0,n),n}return this.installExtension(s,a,t)}async uninstall(a,t={}){return this.logService.trace("ExtensionManagementService#uninstall",a.identifier.id),this.unininstallExtension(a,t)}async reinstallFromGallery(a){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",a.identifier.id),!this.galleryService.isEnabled())throw new Error(i.localize(2,null));const t=await this.findGalleryExtension(a);if(!t)throw new Error(i.localize(3,null));await this.createUninstallExtensionTask(a,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(t)}getExtensionsReport(){const a=new Date().getTime();return(!this.reportedExtensions||a-this.lastReportTimestamp>1e3*60*5)&&(this.reportedExtensions=this.updateReportCache(),this.lastReportTimestamp=a),this.reportedExtensions}registerParticipant(a){this.participants.push(a)}async installExtension(a,t,s){if(!b.URI.isUri(t)){let h=this.installingExtensions.get(new f.ExtensionIdentifierWithVersion(t.identifier,t.version).key());if(h)return this.logService.info("Extensions is already requested to install",t.identifier.id),h.waitUntilTaskIsFinished();s={...s,installOnlyNewlyAddedFromExtensionPack:!0}}const n=[],r=[],c=this.createInstallExtensionTask(a,t,s);b.URI.isUri(t)||this.installingExtensions.set(new f.ExtensionIdentifierWithVersion(c.identifier,a.version).key(),c),this._onInstallExtension.fire({identifier:c.identifier,source:t}),this.logService.info("Installing extension:",c.identifier.id),n.push({task:c,manifest:a});let l=!1;try{if(s.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",c.identifier.id);else try{const d=await this.getAllDepsAndPackExtensionsToInstall(c.identifier,a,!!s.installOnlyNewlyAddedFromExtensionPack);for(const{gallery:v,manifest:A}of d)if(l=l||!!A.extensionDependencies?.some(O=>(0,f.areSameExtensions)({id:O},c.identifier)),this.installingExtensions.has(new f.ExtensionIdentifierWithVersion(v.identifier,v.version).key()))this.logService.info("Extension is already requested to install",v.identifier.id);else{const O=this.createInstallExtensionTask(A,v,{...s,donotIncludePackAndDependencies:!0});this.installingExtensions.set(new f.ExtensionIdentifierWithVersion(O.identifier,A.version).key(),O),this._onInstallExtension.fire({identifier:O.identifier,source:v}),this.logService.info("Installing extension:",O.identifier.id),n.push({task:O,manifest:A})}}catch(d){if(b.URI.isUri(c.source))(0,D.isNonEmptyArray)(a.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",c.identifier.id,d.message),(0,D.isNonEmptyArray)(a.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",c.identifier.id,d.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",c.identifier.id),this.logService.error(d),d}const h=n.reduce((d,{task:v,manifest:A})=>(d.set(v.identifier.id.toLowerCase(),{task:v,manifest:A}),d),new Map);for(;h.size;){let d;const v=[...h.values()].filter(({manifest:A})=>!A.extensionDependencies?.some(O=>h.has(O.toLowerCase())));v.length?d=h.size===1?v:v.filter(({task:A})=>!(A===c&&!l)):(this.logService.info("Found extensions with circular dependencies",v.map(({task:A})=>A.identifier.id)),d=[...h.values()]),await this.joinAllSettled(d.map(async({task:A})=>{const O=new Date().getTime();try{const p=await A.run();if(await this.joinAllSettled(this.participants.map(U=>U.postInstall(p,A.source,s,R.CancellationToken.None))),!b.URI.isUri(A.source)&&(y(this.telemetryService,A.operation===2?"extensionGallery:update":"extensionGallery:install",(0,f.getGalleryExtensionTelemetryData)(A.source),new Date().getTime()-O,void 0),m.isWeb&&A.operation===1))try{await this.galleryService.reportStatistic(p.manifest.publisher,p.manifest.name,p.manifest.version,"install")}catch(U){}r.push({local:p,identifier:A.identifier,operation:A.operation,source:A.source})}catch(p){throw b.URI.isUri(A.source)||y(this.telemetryService,A.operation===2?"extensionGallery:update":"extensionGallery:install",(0,f.getGalleryExtensionTelemetryData)(A.source),new Date().getTime()-O,p),this.logService.error("Error while installing the extension:",A.identifier.id),this.logService.error(p),p}finally{h.delete(A.identifier.id.toLowerCase())}}))}return r.forEach(({identifier:d})=>this.logService.info("Extension installed successfully:",d.id)),this._onDidInstallExtensions.fire(r),r.filter(({identifier:d})=>(0,f.areSameExtensions)(d,c.identifier))[0].local}catch(h){if(n.forEach(({task:d})=>d.cancel()),r.length)try{const d=await Promise.allSettled(r.map(({local:v})=>this.createUninstallExtensionTask(v,{versionOnly:!0}).run()));for(let v=0;v<d.length;v++){const A=d[v],{identifier:O}=r[v];A.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",O.id):this.logService.warn("Rollback: Error while uninstalling extension",O.id,(0,L.getErrorMessage)(A.reason))}}catch(d){this.logService.warn("Error while rolling back extensions",(0,L.getErrorMessage)(d),r.map(({identifier:v})=>v.id))}throw this.logService.error("Failed to install extension:",c.identifier.id,(0,L.getErrorMessage)(h)),this._onDidInstallExtensions.fire(n.map(({task:d})=>({identifier:d.identifier,operation:1,source:d.source}))),h instanceof Error&&(h.name=h&&h.code?h.code:e.ERROR_UNKNOWN),h}finally{for(const{task:h,manifest:d}of n)if(!b.URI.isUri(h.source)){const v=new f.ExtensionIdentifierWithVersion(h.identifier,d.version).key();this.installingExtensions.delete(v)||this.logService.warn("Installation task is not found in the cache",v)}}}async joinAllSettled(a){const t=[],s=[],n=await Promise.allSettled(a);for(const r of n)r.status==="fulfilled"?t.push(r.value):s.push(r.reason);if(s.length)throw E(s);return t}async getAllDepsAndPackExtensionsToInstall(a,t,s){if(!this.galleryService.isEnabled())return[];let n=await this.getInstalled();const r=[a,...n.map(h=>h.identifier)],c=[],l=async(h,d)=>{const v=d.extensionDependencies||[],A=[...v];if(d.extensionPack){const O=s?n.find(p=>(0,f.areSameExtensions)(p.identifier,h)):void 0;for(const p of d.extensionPack)O&&O.manifest.extensionPack&&O.manifest.extensionPack.some(U=>(0,f.areSameExtensions)({id:U},{id:p}))||A.every(U=>!(0,f.areSameExtensions)({id:U},{id:p}))&&A.push(p)}if(A.length){const O=[...r,...c.map(U=>U.gallery.identifier)],p=A.filter(U=>O.every(F=>!(0,f.areSameExtensions)(F,{id:U})));if(p.length){const U=await this.galleryService.query({names:p,pageSize:A.length},R.CancellationToken.None);for(const F of U.firstPage){if(O.find(j=>(0,f.areSameExtensions)(j,F.identifier)))continue;if(!v.some(j=>(0,f.areSameExtensions)({id:j},F.identifier))&&!await this.canInstall(F)){this.logService.info("Skipping the packed extension as it cannot be installed",F.identifier.id);continue}const H=await this.checkAndGetCompatibleVersion(F,!0),M=await this.galleryService.getManifest(H,R.CancellationToken.None);if(M===null)throw new C.ExtensionManagementError(`Missing manifest for extension ${H.identifier.id}`,e.INSTALL_ERROR_VALIDATING);c.push({gallery:H,manifest:M}),await l(H.identifier,M)}}}};return await l(a,t),n=await this.getInstalled(),c.filter(h=>!n.some(d=>(0,f.areSameExtensions)(d.identifier,h.gallery.identifier)))}async checkAndGetCompatibleVersion(a,t){if(await this.isMalicious(a))throw new C.ExtensionManagementError(i.localize(4,null,a.identifier.id),C.INSTALL_ERROR_MALICIOUS);const s=await this.getTargetPlatform();let n=null;if(await this.galleryService.isExtensionCompatible(a,s)&&(n=a),!n&&t&&(n=await this.galleryService.getCompatibleExtension(a,s)),!n)throw new C.ExtensionManagementError(i.localize(5,null,a.identifier.id,u.default.version),C.INSTALL_ERROR_INCOMPATIBLE);return n}async isMalicious(a){const t=await this.getExtensionsReport();return(0,f.getMaliciousExtensionsSet)(t).has(a.identifier.id)}async unininstallExtension(a,t){const s=this.uninstallingExtensions.get(a.identifier.id.toLowerCase());if(s)return this.logService.info("Extensions is already requested to uninstall",a.identifier.id),s.waitUntilTaskIsFinished();const n=(h,d)=>{const v=this.createUninstallExtensionTask(h,d);return this.uninstallingExtensions.set(v.extension.identifier.id.toLowerCase(),v),this.logService.info("Uninstalling extension:",h.identifier.id),this._onUninstallExtension.fire(h.identifier),v},r=(h,d)=>{d?this.logService.error("Failed to uninstall extension:",h.identifier.id,d.message):this.logService.info("Successfully uninstalled extension:",h.identifier.id),y(this.telemetryService,"extensionGallery:uninstall",(0,f.getLocalExtensionTelemetryData)(h),void 0,d),this._onDidUninstallExtension.fire({identifier:h.identifier,error:d?.code})},c=[],l=[];try{c.push(n(a,{}));const h=await this.getInstalled(1);if(t.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",a.identifier.id);else{const d=this.getAllPackExtensionsToUninstall(a,h);for(const v of d)this.uninstallingExtensions.has(v.identifier.id.toLowerCase())?this.logService.info("Extensions is already requested to uninstall",v.identifier.id):c.push(n(v,{}))}t.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",a.identifier.id):this.checkForDependents(c.map(d=>d.extension),h,a),await this.joinAllSettled(c.map(async d=>{try{if(await d.run(),await this.joinAllSettled(this.participants.map(v=>v.postUninstall(d.extension,t,R.CancellationToken.None))),d.extension.identifier.uuid)try{await this.galleryService.reportStatistic(d.extension.manifest.publisher,d.extension.manifest.name,d.extension.manifest.version,"uninstall")}catch(v){}r(d.extension)}catch(v){const A=v instanceof C.ExtensionManagementError?v:new C.ExtensionManagementError((0,L.getErrorMessage)(v),e.ERROR_UNKNOWN);throw r(d.extension,A),A}finally{l.push(d)}}))}catch(h){const d=h instanceof C.ExtensionManagementError?h:new C.ExtensionManagementError((0,L.getErrorMessage)(h),e.ERROR_UNKNOWN);for(const v of c){try{v.cancel()}catch(A){}l.includes(v)||r(v.extension,d)}throw d}finally{for(const h of c)this.uninstallingExtensions.delete(h.extension.identifier.id.toLowerCase())||this.logService.warn("Uninstallation task is not found in the cache",h.extension.identifier.id)}}checkForDependents(a,t,s){for(const n of a){const r=this.getDependents(n,t);if(r.length){const c=r.filter(l=>!a.some(h=>(0,f.areSameExtensions)(h.identifier,l.identifier)));if(c.length)throw new Error(this.getDependentsErrorMessage(n,c,s))}}}getDependentsErrorMessage(a,t,s){return s===a?t.length===1?i.localize(6,null,s.manifest.displayName||s.manifest.name,t[0].manifest.displayName||t[0].manifest.name):t.length===2?i.localize(7,null,s.manifest.displayName||s.manifest.name,t[0].manifest.displayName||t[0].manifest.name,t[1].manifest.displayName||t[1].manifest.name):i.localize(8,null,s.manifest.displayName||s.manifest.name,t[0].manifest.displayName||t[0].manifest.name,t[1].manifest.displayName||t[1].manifest.name):t.length===1?i.localize(9,null,s.manifest.displayName||s.manifest.name,a.manifest.displayName||a.manifest.name,t[0].manifest.displayName||t[0].manifest.name):t.length===2?i.localize(10,null,s.manifest.displayName||s.manifest.name,a.manifest.displayName||a.manifest.name,t[0].manifest.displayName||t[0].manifest.name,t[1].manifest.displayName||t[1].manifest.name):i.localize(11,null,s.manifest.displayName||s.manifest.name,a.manifest.displayName||a.manifest.name,t[0].manifest.displayName||t[0].manifest.name,t[1].manifest.displayName||t[1].manifest.name)}getAllPackExtensionsToUninstall(a,t,s=[]){if(s.indexOf(a)!==-1)return[];s.push(a);const n=a.manifest.extensionPack?a.manifest.extensionPack:[];if(n.length){const r=t.filter(l=>!l.isBuiltin&&n.some(h=>(0,f.areSameExtensions)({id:h},l.identifier))),c=[];for(const l of r)c.push(...this.getAllPackExtensionsToUninstall(l,t,s));return[...r,...c]}return[]}getDependents(a,t){return t.filter(s=>s.manifest.extensionDependencies&&s.manifest.extensionDependencies.some(n=>(0,f.areSameExtensions)({id:n},a.identifier)))}async findGalleryExtension(a){if(a.identifier.uuid){const t=await this.findGalleryExtensionById(a.identifier.uuid);return t||this.findGalleryExtensionByName(a.identifier.id)}return this.findGalleryExtensionByName(a.identifier.id)}async findGalleryExtensionById(a){return(await this.galleryService.query({ids:[a],pageSize:1},R.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(a){return(await this.galleryService.query({names:[a],pageSize:1},R.CancellationToken.None)).firstPage[0]}async updateReportCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const a=await this.galleryService.getExtensionsReport();return this.logService.trace(`ExtensionManagementService.refreshReportedCache - got ${a.length} reported extensions from service`),a}catch(a){return this.logService.trace("ExtensionManagementService.refreshReportedCache - failed to get extension report"),[]}}};g=de([X(0,C.IExtensionGalleryService),X(1,w.ITelemetryService),X(2,I.ILogService)],g),e.AbstractExtensionManagementService=g;function E(o){const a=Array.isArray(o)?o:[o];return a.length===1?a[0]instanceof Error?a[0]:new Error(a[0]):a.reduce((t,s)=>new Error(`${t.message}${t.message?",":""}${s instanceof Error?s.message:s}`),new Error(""))}e.joinErrors=E;function y(o,a,t,s,n){const r=n?n instanceof C.ExtensionManagementError?n.code:e.ERROR_UNKNOWN:void 0;o.publicLogError(a,{...t,success:!n,duration:s,errorcode:r})}e.reportTelemetry=y;class S{constructor(){this.barrier=new T.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,T.createCancelablePromise)(a=>this.doRun(a))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,T.createCancelablePromise)(a=>new Promise((t,s)=>{const n=a.onCancellationRequested(()=>{n.dispose(),s((0,L.canceled)())})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=S}),define(Z[184],ee([0,1,16,6,63,3,8,4,31,5,116,12,28,177,75,13,14,59,29,43,22,20]),function(K,e,D,T,R,L,k,P,m,b,i,C,f,I,u,w,g,E,y,S,o,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;const t="extensionTips/promptedExecutableTips",s="extensionTips/lastPromptedMediumImpExeTime";let n=class extends I.ExtensionTipsService{constructor(c,l,h,d,v,A,O,p,U,F){super(O,p,U,F);this.environmentService=c,this.telemetryService=l,this.extensionManagementService=h,this.storageService=d,this.nativeHostService=v,this.extensionRecommendationNotificationService=A,this.highImportanceExecutableTips=new Map,this.mediumImportanceExecutableTips=new Map,this.allOtherExecutableTips=new Map,this.highImportanceTipsByExe=new Map,this.mediumImportanceTipsByExe=new Map,p.exeBasedExtensionTips&&(0,R.forEach)(p.exeBasedExtensionTips,({key:$,value:H})=>{const M=[],j=[],q=[];(0,R.forEach)(H.recommendations,({key:z,value:x})=>{x.important?H.important?M.push({extensionId:z,extensionName:x.name,isExtensionPack:!!x.isExtensionPack}):j.push({extensionId:z,extensionName:x.name,isExtensionPack:!!x.isExtensionPack}):q.push({extensionId:z,extensionName:x.name,isExtensionPack:!!x.isExtensionPack})}),M.length&&this.highImportanceExecutableTips.set($,{exeFriendlyName:H.friendlyName,windowsPath:H.windowsPath,recommendations:M}),j.length&&this.mediumImportanceExecutableTips.set($,{exeFriendlyName:H.friendlyName,windowsPath:H.windowsPath,recommendations:j}),q.length&&this.allOtherExecutableTips.set($,{exeFriendlyName:H.friendlyName,windowsPath:H.windowsPath,recommendations:q})}),(0,T.timeout)(3e3).then(async()=>{await this.collectTips(),this.promptHighImportanceExeBasedTip(),this.promptMediumImportanceExeBasedTip()})}async getImportantExecutableBasedTips(){const c=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),l=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips);return[...c,...l]}getOtherExecutableBasedTips(){return this.getValidExecutableBasedExtensionTips(this.allOtherExecutableTips)}async collectTips(){const c=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),l=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips),h=await this.extensionManagementService.getInstalled();this.highImportanceTipsByExe=this.groupImportantTipsByExe(c,h),this.mediumImportanceTipsByExe=this.groupImportantTipsByExe(l,h)}groupImportantTipsByExe(c,l){const h=new Map;c.forEach(p=>h.set(p.extensionId.toLowerCase(),p));const{installed:d,uninstalled:v}=this.groupByInstalled([...h.keys()],l);for(const p of d){const U=h.get(p);U&&this.telemetryService.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:p,exeName:U.exeName})}for(const p of v){const U=h.get(p);U&&this.telemetryService.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:p,exeName:U.exeName})}const A=this.getPromptedExecutableTips(),O=new Map;for(const p of v){const U=h.get(p);if(U&&(!A[U.exeName]||!A[U.exeName].includes(U.extensionId))){let F=O.get(U.exeName);F||(F=[],O.set(U.exeName,F)),F.push(U)}}return O}promptHighImportanceExeBasedTip(){if(this.highImportanceTipsByExe.size===0)return;const[c,l]=[...this.highImportanceTipsByExe.entries()][0];this.promptExeRecommendations(l).then(h=>{switch(h){case"reacted":this.addToRecommendedExecutables(l[0].exeName,l);break;case"ignored":this.highImportanceTipsByExe.delete(c);break;case"incompatibleWindow":const d=L.Event.once(L.Event.latch(L.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(d(()=>this.promptHighImportanceExeBasedTip()));break;case"toomany":const v=this._register((0,T.disposableTimeout)(()=>{v.dispose(),this.promptHighImportanceExeBasedTip()},60*60*1e3));break}})}promptMediumImportanceExeBasedTip(){if(this.mediumImportanceTipsByExe.size===0)return;const c=this.getLastPromptedMediumExeTime(),l=Date.now()-c,h=7*24*60*60*1e3;if(l<h){const A=this._register((0,T.disposableTimeout)(()=>{A.dispose(),this.promptMediumImportanceExeBasedTip()},h-l));return}const[d,v]=[...this.mediumImportanceTipsByExe.entries()][0];this.promptExeRecommendations(v).then(A=>{switch(A){case"reacted":this.updateLastPromptedMediumExeTime(Date.now()),this.mediumImportanceTipsByExe.delete(d),this.addToRecommendedExecutables(v[0].exeName,v);const O=this._register((0,T.disposableTimeout)(()=>{O.dispose(),this.promptMediumImportanceExeBasedTip()},h));break;case"ignored":this.mediumImportanceTipsByExe.delete(d),this.promptMediumImportanceExeBasedTip();break;case"incompatibleWindow":const p=L.Event.once(L.Event.latch(L.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(p(()=>this.promptMediumImportanceExeBasedTip()));break;case"toomany":const U=this._register((0,T.disposableTimeout)(()=>{U.dispose(),this.promptMediumImportanceExeBasedTip()},60*60*1e3));break}})}promptExeRecommendations(c){const l=c.map(({extensionId:d})=>d.toLowerCase()),h=(0,i.localize)(0,null,c[0].exeFriendlyName);return this.extensionRecommendationNotificationService.promptImportantExtensionsInstallNotification(l,h,`@exe:"${c[0].exeName}"`,3)}getLastPromptedMediumExeTime(){let c=this.storageService.getNumber(s,0);return c||(c=Date.now(),this.updateLastPromptedMediumExeTime(c)),c}updateLastPromptedMediumExeTime(c){this.storageService.store(s,c,0,1)}getPromptedExecutableTips(){return JSON.parse(this.storageService.get(t,0,"{}"))}addToRecommendedExecutables(c,l){const h=this.getPromptedExecutableTips();h[c]=l.map(({extensionId:d})=>d.toLowerCase()),this.storageService.store(t,JSON.stringify(h),0,0)}groupByInstalled(c,l){const h=[],d=[],v=l.reduce((A,O)=>(A.add(O.identifier.id.toLowerCase()),A),new Set);return c.forEach(A=>{v.has(A.toLowerCase())?h.push(A):d.push(A)}),{installed:h,uninstalled:d}}async getValidExecutableBasedExtensionTips(c){const l=[],h=new Map;for(const d of c.keys()){const v=c.get(d);if(!v||!(0,D.isNonEmptyArray)(v.recommendations))continue;const A=[];P.isWindows?v.windowsPath&&A.push(v.windowsPath.replace("%USERPROFILE%",m.env.USERPROFILE).replace("%ProgramFiles(x86)%",m.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",m.env.ProgramFiles).replace("%APPDATA%",m.env.APPDATA).replace("%WINDIR%",m.env.WINDIR)):(A.push((0,k.join)("/usr/local/bin",d)),A.push((0,k.join)("/usr/bin",d)),A.push((0,k.join)(this.environmentService.userHome.fsPath,d)));for(const O of A){let p=h.get(O);if(p===void 0&&(p=await this.fileService.exists(b.URI.file(O)),h.set(O,p)),p)for(const{extensionId:U,extensionName:F,isExtensionPack:$}of v.recommendations)l.push({extensionId:U,extensionName:F,isExtensionPack:$,exeName:d,exeFriendlyName:v.exeFriendlyName,windowsPath:v.windowsPath})}}return l}};n=de([X(0,C.INativeEnvironmentService),X(1,a.ITelemetryService),X(2,f.IExtensionManagementService),X(3,o.IStorageService),X(4,E.INativeHostService),X(5,u.IExtensionRecommendationNotificationService),X(6,w.IFileService),X(7,y.IProductService),X(8,S.IRequestService),X(9,g.ILogService)],n),e.ExtensionTipsService=n}),define(Z[82],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class D{constructor(L){this.appender=L}listen(L,k){throw new Error(`Event not found: ${k}`)}call(L,k,{eventName:P,data:m}){return this.appender.log(P,m),Promise.resolve(null)}}e.TelemetryAppenderChannel=D;class T{constructor(L){this.channel=L}log(L,k){return this.channel.call("log",{eventName:L,data:k}).then(void 0,P=>`Failed to log telemetry: ${console.warn(P)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=T}),define(Z[44],ee([0,1,6,26,17,21,20]),function(K,e,D,T,R,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryConfiguration=e.getTelemetryLevel=e.configurationTelemetry=e.NullAppender=e.combinedAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=void 0,e.NullTelemetryService=new class{constructor(){this.sendErrorTelemetry=!1,this.isOptedIn=!0}publicLog(E,y){return Promise.resolve(void 0)}publicLog2(E,y){return this.publicLog(E,y)}publicLogError(E,y){return Promise.resolve(void 0)}publicLogError2(E,y){return this.publicLogError(E,y)}setExperimentProperty(){}setEnabled(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}};class P{async publicLog(y,S,o){}async publicLogError(y,S,o){}}e.NullEndpointTelemetryService=P;function m(...E){return{log:(y,S)=>E.forEach(o=>o.log(y,S)),flush:()=>D.Promises.settled(E.map(y=>y.flush()))}}e.combinedAppender=m,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function b(E,y){return y.onDidChangeConfiguration(S=>{S.source!==6&&E.publicLog2("updateConfiguration",{configurationSource:(0,L.ConfigurationTargetToString)(S.source),configurationKeys:w(S.sourceConfig)})})}e.configurationTelemetry=b;function i(E,y){return y.disableTelemetry||!E.enableTelemetry?0:y.isBuilt?2:1}e.getTelemetryLevel=i;function C(E){const y=E.getValue(k.TELEMETRY_SETTING_ID),S=E.getValue(k.TELEMETRY_OLD_SETTING_ID);return S!==void 0&&S===!1?"off":y??"on"}e.getTelemetryConfiguration=C;function f(E){const y=Object.create(null),S=Object.create(null),o=Object.create(null);u(E,o);for(let a in o){a=a.length>150?a.substr(a.length-149):a;const t=o[a];typeof t=="number"?S[a]=t:typeof t=="boolean"?S[a]=t?1:0:typeof t=="string"?y[a]=t.substring(0,1023):typeof t!="undefined"&&t!==null&&(y[a]=t)}return{properties:y,measurements:S}}e.validateTelemetryData=f;function I(E){if(!E)return"none";let y="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(o=>{E.indexOf(`${o}+`)===0&&(y=o)}),y}e.cleanRemoteAuthority=I;function u(E,y,S=0,o){if(!!E)for(let a of Object.getOwnPropertyNames(E)){const t=E[a],s=o?o+a:a;Array.isArray(t)?y[s]=(0,T.safeStringify)(t):t instanceof Date?y[s]=t.toISOString():(0,R.isObject)(t)?S<2?u(t,y,S+1,s+"."):y[s]=(0,T.safeStringify)(t):y[s]=t}}function w(E){if(!E)return[];const y=[];return g(y,"",E),y}function g(E,y,S){S&&typeof S=="object"&&!Array.isArray(S)?Object.keys(S).forEach(o=>g(E,y?`${y}.${o}`:o,S[o])):E.push(y)}}),define(Z[185],ee([0,1,16,27,9,26,4,31,5,21,12,28,32,72,13,14,29,43,46,22,20,44]),function(K,e,D,T,R,L,k,P,m,b,i,C,f,I,u,w,g,E,y,S,o,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const t=k.isWeb?"web":(0,C.getTargetPlatform)(k.platform,P.arch);var s;(function(J){J[J.None=0]="None",J[J.IncludeVersions=1]="IncludeVersions",J[J.IncludeFiles=2]="IncludeFiles",J[J.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",J[J.IncludeSharedAccounts=8]="IncludeSharedAccounts",J[J.IncludeVersionProperties=16]="IncludeVersionProperties",J[J.ExcludeNonValidated=32]="ExcludeNonValidated",J[J.IncludeInstallationTargets=64]="IncludeInstallationTargets",J[J.IncludeAssetUri=128]="IncludeAssetUri",J[J.IncludeStatistics=256]="IncludeStatistics",J[J.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",J[J.Unpublished=4096]="Unpublished"})(s||(s={}));function n(...J){return String(J.reduce((V,re)=>V|re,0))}var r;(function(J){J[J.Tag=1]="Tag",J[J.ExtensionId=4]="ExtensionId",J[J.Category=5]="Category",J[J.ExtensionName=7]="ExtensionName",J[J.Target=8]="Target",J[J.Featured=9]="Featured",J[J.SearchText=10]="SearchText",J[J.ExcludeWithFlags=12]="ExcludeWithFlags"})(r||(r={}));const c={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},l={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},d={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:s.None,criteria:[],assetTypes:[]};class v{constructor(V=d){this.state=V}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(V,re=this.state.pageSize){return new v({...this.state,pageNumber:V,pageSize:re})}withFilter(V,...re){const ie=[...this.state.criteria,...re.length?re.map(ce=>({filterType:V,value:ce})):[{filterType:V}]];return new v({...this.state,criteria:ie})}withSortBy(V){return new v({...this.state,sortBy:V})}withSortOrder(V){return new v({...this.state,sortOrder:V})}withFlags(...V){return new v({...this.state,flags:V.reduce((re,ie)=>re|ie,0)})}withAssetTypes(...V){return new v({...this.state,assetTypes:V})}get raw(){const{criteria:V,pageNumber:re,pageSize:ie,sortBy:ce,sortOrder:ue,flags:ye,assetTypes:ge}=this.state;return{filters:[{criteria:V,pageNumber:re,pageSize:ie,sortBy:ce,sortOrder:ue}],assetTypes:ge,flags:ye}}get searchText(){const V=this.state.criteria.filter(re=>re.filterType===r.SearchText)[0];return V&&V.value?V.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(V=>String(V.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function A(J,V){const re=(J||[]).filter(ie=>ie.statisticName===V)[0];return re?re.value:0}function O(J){const V="Microsoft.VisualStudio.Code.Translation.";return J.files.filter(ie=>ie.assetType.indexOf(V)===0).reduce((ie,ce)=>{const ue=$(J,ce.assetType);return ue&&ie.push([ce.assetType.substring(V.length),ue]),ie},[])}function p(J){if(J.properties){const V=J.properties.filter(ce=>ce.key===c.Repository),re=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),ie=V.filter(ce=>re.test(ce.value))[0];return ie?{uri:ie.value,fallbackUri:ie.value}:null}return $(J,c.Repository)}function U(J){return{uri:`${J.fallbackAssetUri}/${c.VSIX}?redirect=true${J.targetPlatform?`&targetPlatform=${J.targetPlatform}`:""}`,fallbackUri:`${J.fallbackAssetUri}/${c.VSIX}${J.targetPlatform?`?targetPlatform=${J.targetPlatform}`:""}`}}function F(J){const V=$(J,c.Icon);if(V)return V;const re=C.DefaultIconPath;return{uri:re,fallbackUri:re}}function $(J,V){return J.files.filter(ie=>ie.assetType===V)[0]?{uri:`${J.assetUri}/${V}`,fallbackUri:`${J.fallbackAssetUri}/${V}`}:null}function H(J,V){const re=J.properties?J.properties.filter(ce=>ce.key===V):[],ie=re.length>0&&re[0].value;return ie?ie.split(",").map(ce=>(0,f.adoptToGalleryExtensionId)(ce)):[]}function M(J){const V=J.properties?J.properties.filter(re=>re.key===l.Engine):[];return V.length>0&&V[0].value||""}function j(J){const V=J.properties?J.properties.filter(ie=>ie.key===l.LocalizedLanguages):[],re=V.length>0&&V[0].value||"";return re?re.split(","):[]}function q(J){return J.indexOf("preview")!==-1}function z(J){return J.targetPlatform?(0,C.toTargetPlatform)(J.targetPlatform):"undefined"}function x(J){const V=(0,D.distinct)(J.versions.map(z)),re=!!J.tags?.includes(C.WEB_EXTENSION_TAG),ie=V.indexOf("web");return re?ie===-1&&V.push("web"):ie!==-1&&V.splice(ie,1),V}function N(J,V){const re=(0,C.getFallbackTargetPlarforms)(V);for(let ie=0;ie<J.length;ie++){const ce=J[ie];if(ce.version===J[ie-1]?.version){let ue=ie;const ye=z(ce);if(ye===V)for(;ue>0&&J[ue-1].version===ce.version;)ue--;else if(re.includes(ye))for(;ue>0&&J[ue-1].version===ce.version&&z(J[ue-1])!==V;)ue--;ue!==ie&&(J.splice(ie,1),J.splice(ue,0,ce))}}return J}e.sortExtensionVersions=N;function W(J,V,re,ie,ce){const ue=x(J);let ye=J.versions[0];return ye=J.versions.find(ge=>ge.version===ye.version&&(0,C.isTargetPlatformCompatible)(z(ge),ue,ce))||ye,_(J,ye,ue,V,re,ie)}function _(J,V,re,ie,ce,ue){const ye={manifest:$(V,c.Manifest),readme:$(V,c.Details),changelog:$(V,c.Changelog),license:$(V,c.License),repository:p(V),download:U(V),icon:F(V),coreTranslations:O(V)};return{identifier:{id:(0,f.getGalleryExtensionId)(J.publisher.publisherName,J.extensionName),uuid:J.extensionId},name:J.extensionName,version:V.version,displayName:J.displayName,publisherId:J.publisher.publisherId,publisher:J.publisher.publisherName,publisherDisplayName:J.publisher.displayName,description:J.shortDescription||"",installCount:A(J.statistics,"install"),rating:A(J.statistics,"averagerating"),ratingCount:A(J.statistics,"ratingcount"),categories:J.categories||[],tags:J.tags||[],releaseDate:Date.parse(J.releaseDate),lastUpdated:Date.parse(J.lastUpdated),allTargetPlatforms:re,assets:ye,properties:{dependencies:H(V,l.Dependency),extensionPack:H(V,l.ExtensionPack),engine:M(V),localizedLanguages:j(V),targetPlatform:z(V)},preview:q(J.flags),telemetryData:{index:(ce.pageNumber-1)*ce.pageSize+ie,querySource:ue}}}let Y=class{constructor(V,re,ie,ce,ue,ye,ge,Ie){this.requestService=re,this.logService=ie,this.environmentService=ce,this.telemetryService=ue,this.fileService=ye,this.productService=ge,this.configurationService=Ie;const Pe=ge.extensionsGallery;this.extensionsGalleryUrl=Pe&&Pe.serviceUrl,this.extensionsControlUrl=Pe&&Pe.controlUrl,this.commonHeadersPromise=te(ge.version,ge,this.environmentService,this.configurationService,this.fileService,V)}api(V=""){return`${this.extensionsGalleryUrl}${V}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(V,re){const ie=[];let ce=new v().withFlags(s.IncludeAssetUri,s.IncludeStatistics,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeVersionProperties).withPage(1,V.length).withFilter(r.Target,"Microsoft.VisualStudio.Code").withFilter(r.ExtensionName,...V.map(({id:ye})=>ye.toLowerCase()));V.every(ye=>!ye.version)&&(ce=ce.withFlags(s.IncludeAssetUri,s.IncludeStatistics,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeVersionProperties,s.IncludeLatestVersionOnly));const{galleryExtensions:ue}=await this.queryGallery(ce,t,T.CancellationToken.None);for(let ye=0;ye<ue.length;ye++){const ge=ue[ye];if(!ge.versions.length)continue;const Ie=(0,f.getGalleryExtensionId)(ge.publisher.publisherName,ge.extensionName),Pe=V.find(Ee=>(0,f.areSameExtensions)(Ee,{id:Ie}))?.version;if(Pe){const Ee=ge.versions.find(Ae=>Ae.version===Pe);Ee&&ie.push(_(ge,Ee,x(ge),ye,ce))}else ie.push(W(ge,ye,ce,void 0,t))}return ie}async getCompatibleExtension(V,re){const ie=(0,C.isIExtensionIdentifier)(V)?null:V;if(ie){if((0,C.isNotWebExtensionInWebTargetPlatform)(ie.allTargetPlatforms,re))return null;if(await this.isExtensionCompatible(ie,re))return ie}const{id:ce,uuid:ue}=ie?ie.identifier:V;let ye=new v().withFlags(s.IncludeAssetUri,s.IncludeStatistics,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeVersionProperties).withPage(1,1).withFilter(r.Target,"Microsoft.VisualStudio.Code");ue?ye=ye.withFilter(r.ExtensionId,ue):ye=ye.withFilter(r.ExtensionName,ce);const{galleryExtensions:ge}=await this.queryGallery(ye,re,T.CancellationToken.None),[Ie]=ge;if(!Ie||!Ie.versions.length)return null;const Pe=x(Ie);if((0,C.isNotWebExtensionInWebTargetPlatform)(Pe,re))return null;for(let Ee of Ie.versions){if(!M(Ee)){const Ae=await this.getEngine(Ee);Ee={...Ee,properties:[...Ee.properties||[],{key:l.Engine,value:Ae}]}}if(await this.isRawExtensionVersionCompatible(Ee,Pe,re))return _(Ie,Ee,Pe,0,ye)}return null}async isExtensionCompatible(V,re){if(!(0,C.isTargetPlatformCompatible)(V.properties.targetPlatform,V.allTargetPlatforms,re))return!1;let ie=V.properties.engine;if(!ie){const ce=await this.getManifest(V,T.CancellationToken.None);if(!ce)throw new Error("Manifest was not found");ie=ce.engines.vscode}return(0,I.isEngineValid)(ie,this.productService.version,this.productService.date)}async isRawExtensionVersionCompatible(V,re,ie){if(!(0,C.isTargetPlatformCompatible)(z(V),re,ie))return!1;const ce=await this.getEngine(V);return(0,I.isEngineValid)(ce,this.productService.version,this.productService.date)}async query(V,re){const ie=T.CancellationToken.isCancellationToken(V)?{}:V,ce=T.CancellationToken.isCancellationToken(V)?V:re;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let ue=ie.text||"";const ye=(0,L.getOrDefault)(ie,De=>De.pageSize,50);let ge=new v().withFlags(s.IncludeLatestVersionOnly,s.IncludeAssetUri,s.IncludeStatistics,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeVersionProperties).withPage(1,ye).withFilter(r.Target,"Microsoft.VisualStudio.Code");ue?(ue=ue.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(De,Te,Ne)=>(ge=ge.withFilter(r.Category,Ne||Te),"")),ue=ue.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(De,Te,Ne)=>(ge=ge.withFilter(r.Tag,Ne||Te),"")),ue=ue.replace(/\bfeatured(\s+|\b|$)/g,()=>(ge=ge.withFilter(r.Featured),"")),ue=ue.trim(),ue&&(ue=ue.length<200?ue:ue.substring(0,200),ge=ge.withFilter(r.SearchText,ue)),ge=ge.withSortBy(0)):ie.ids?ge=ge.withFilter(r.ExtensionId,...ie.ids):ie.names?ge=ge.withFilter(r.ExtensionName,...ie.names):ge=ge.withSortBy(4),typeof ie.sortBy=="number"&&(ge=ge.withSortBy(ie.sortBy)),typeof ie.sortOrder=="number"&&(ge=ge.withSortOrder(ie.sortOrder));const{galleryExtensions:Ie,total:Pe}=await this.queryGallery(ge,t,ce),Ee=Ie.map((De,Te)=>W(De,Te,ge,ie.source,t)),Ae=async(De,Te)=>{if(Te.isCancellationRequested)throw(0,R.canceled)();const Ne=ge.withPage(De+1),{galleryExtensions:_e}=await this.queryGallery(Ne,t,Te);return _e.map(($e,xe)=>W($e,xe,Ne,ie.source,t))};return{firstPage:Ee,total:Pe,pageSize:ge.pageSize,getPage:Ae}}async queryGallery(V,re,ie){if(!this.isEnabled())throw new Error("No extension gallery service configured.");V=V.withFlags(V.flags,s.ExcludeNonValidated).withFilter(r.ExcludeWithFlags,n(s.Unpublished));const ce=await this.commonHeadersPromise,ue=JSON.stringify(V.raw),ye={...ce,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(ue.length)},ge=new Date().getTime();let Ie,Pe,Ee=0;try{if(Ie=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:ue,headers:ye},ie),Ie.res.statusCode&&Ie.res.statusCode>=400&&Ie.res.statusCode<500)return{galleryExtensions:[],total:Ee};const Ae=await(0,E.asJson)(Ie);if(Ae){const De=Ae.results[0],Te=De.extensions;Te.forEach(_e=>N(_e.versions,re));const Ne=De.resultMetadata&&De.resultMetadata.filter(_e=>_e.metadataType==="ResultCount")[0];return Ee=Ne&&Ne.metadataItems.filter(_e=>_e.name==="TotalCount")[0].count||0,{galleryExtensions:Te,total:Ee}}return{galleryExtensions:[],total:Ee}}catch(Ae){throw Pe=Ae,Ae}finally{this.telemetryService.publicLog2("galleryService:query",{...V.telemetryData,requestBodySize:String(ue.length),duration:new Date().getTime()-ge,success:!!Ie&&(0,E.isSuccess)(Ie),responseBodySize:Ie?.res.headers["Content-Length"],statusCode:Ie?String(Ie.res.statusCode):void 0,errorCode:Pe?(0,R.isPromiseCanceledError)(Pe)?"canceled":(0,R.getErrorMessage)(Pe).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(Ee)})}}async reportStatistic(V,re,ie,ce){if(!this.isEnabled())return;const ue=k.isWeb?this.api(`/itemName/${V}.${re}/version/${ie}/statType/${ce==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${V}/extensions/${re}/${ie}/stats?statType=${ce}`),ye=k.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",Ie={...await this.commonHeadersPromise,Accept:ye};try{await this.requestService.request({type:"POST",url:ue,headers:Ie},T.CancellationToken.None)}catch(Pe){}}async download(V,re,ie){this.logService.trace("ExtensionGalleryService#download",V.identifier.id);const ce=(0,f.getGalleryExtensionTelemetryData)(V),ue=new Date().getTime(),ye=Ee=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...ce,duration:Ee}),ge=ie===1?"install":ie===2?"update":"",Ie=ge?{uri:`${V.assets.download.uri}${m.URI.parse(V.assets.download.uri).query?"&":"?"}${ge}=true`,fallbackUri:`${V.assets.download.fallbackUri}${m.URI.parse(V.assets.download.fallbackUri).query?"&":"?"}${ge}=true`}:V.assets.download,Pe=await this.getAsset(Ie);await this.fileService.writeFile(re,Pe.stream),ye(new Date().getTime()-ue)}async getReadme(V,re){if(V.assets.readme){const ie=await this.getAsset(V.assets.readme,{},re);return await(0,E.asText)(ie)||""}return""}async getManifest(V,re){if(V.assets.manifest){const ie=await this.getAsset(V.assets.manifest,{},re),ce=await(0,E.asText)(ie);return ce?JSON.parse(ce):null}return null}async getManifestFromRawExtensionVersion(V,re){const ie=$(V,c.Manifest);if(!ie)throw new Error("Manifest was not found");const ce={"Accept-Encoding":"gzip"},ue=await this.getAsset(ie,{headers:ce});return await(0,E.asJson)(ue)}async getCoreTranslation(V,re){const ie=V.assets.coreTranslations.filter(ce=>ce[0]===re.toUpperCase())[0];if(ie){const ce=await this.getAsset(ie[1]),ue=await(0,E.asText)(ce);return ue?JSON.parse(ue):null}return null}async getChangelog(V,re){if(V.assets.changelog){const ie=await this.getAsset(V.assets.changelog,{},re);return await(0,E.asText)(ie)||""}return""}async getAllCompatibleVersions(V,re){let ie=new v().withFlags(s.IncludeVersions,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeVersionProperties).withPage(1,1).withFilter(r.Target,"Microsoft.VisualStudio.Code");V.identifier.uuid?ie=ie.withFilter(r.ExtensionId,V.identifier.uuid):ie=ie.withFilter(r.ExtensionName,V.identifier.id);const{galleryExtensions:ce}=await this.queryGallery(ie,re,T.CancellationToken.None);if(!ce.length)return[];const ue=x(ce[0]);if((0,C.isNotWebExtensionInWebTargetPlatform)(ue,re))return[];const ye=[];for(const ge of ce[0].versions)try{ye[ye.length-1]?.version!==ge.version&&await this.isRawExtensionVersionCompatible(ge,ue,re)&&ye.push({version:ge.version,date:ge.lastUpdated})}catch(Ie){}return ye}async getAsset(V,re={},ie=T.CancellationToken.None){const ce=await this.commonHeadersPromise,ue={type:"GET"},ye={...ce,...re.headers||{}};re={...re,...ue,headers:ye};const ge=V.uri,Ie=V.fallbackUri,Pe={...re,url:ge};try{const Ee=await this.requestService.request(Pe,ie);if(Ee.res.statusCode===200)return Ee;const Ae=await(0,E.asText)(Ee);throw new Error(`Expected 200, got back ${Ee.res.statusCode} instead.

${Ae}`)}catch(Ee){if((0,R.isPromiseCanceledError)(Ee))throw Ee;const Ae=(0,R.getErrorMessage)(Ee);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:ge,message:Ae});const De={...re,url:Ie};return this.requestService.request(De,ie)}}async getEngine(V){let re=M(V);if(!re){const ie=await this.getManifestFromRawExtensionVersion(V,T.CancellationToken.None);if(!ie)throw new Error("Manifest was not found");re=ie.engines.vscode}return re}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const V=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},T.CancellationToken.None);if(V.res.statusCode!==200)throw new Error("Could not get extensions report.");const re=await(0,E.asJson)(V),ie=new Map;if(re)for(const ce of re.malicious){const ue=ie.get(ce)||{id:{id:ce},malicious:!0,slow:!1};ue.malicious=!0,ie.set(ce,ue)}return[...ie.values()]}};Y=de([X(1,E.IRequestService),X(2,w.ILogService),X(3,i.IEnvironmentService),X(4,o.ITelemetryService),X(5,u.IFileService),X(6,g.IProductService),X(7,b.IConfigurationService)],Y);let G=class extends Y{constructor(V,re,ie,ce,ue,ye,ge,Ie){super(V,re,ie,ce,ue,ye,ge,Ie)}};G=de([X(0,S.IStorageService),X(1,E.IRequestService),X(2,w.ILogService),X(3,i.IEnvironmentService),X(4,o.ITelemetryService),X(5,u.IFileService),X(6,g.IProductService),X(7,b.IConfigurationService)],G),e.ExtensionGalleryService=G;let ne=class extends Y{constructor(V,re,ie,ce,ue,ye,ge){super(void 0,V,re,ie,ce,ue,ye,ge)}};ne=de([X(0,E.IRequestService),X(1,w.ILogService),X(2,i.IEnvironmentService),X(3,o.ITelemetryService),X(4,u.IFileService),X(5,g.IProductService),X(6,b.IConfigurationService)],ne),e.ExtensionGalleryServiceWithNoStorageService=ne;async function te(J,V,re,ie,ce,ue){const ye={"X-Market-Client-Id":`VSCode ${J}`,"User-Agent":`VSCode ${J}`},ge=await(0,y.getServiceMachineId)(re,ce,ue);return(0,a.getTelemetryLevel)(V,re)>=2&&(0,a.getTelemetryConfiguration)(ie)==="on"&&(ye["X-Market-User-Id"]=ge),ye}e.resolveMarketplaceHeaders=te}),define(Z[83],ee([0,1,2,12,14,44]),function(K,e,D,T,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let k=class extends D.Disposable{constructor(m,b,i=""){super();this.prefix=i;const C=m.getLogger(b.telemetryLogResource);C?this.logger=this._register(C):(this.logger=this._register(m.createLogger(b.telemetryLogResource)),this.logger.info("The below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.logger.info("==========================================================="))}flush(){return Promise.resolve(void 0)}log(m,b){this.logger.trace(`${this.prefix}telemetry/${m}`,(0,L.validateTelemetryData)(b))}};k=de([X(0,R.ILoggerService),X(1,T.IEnvironmentService)],k),e.TelemetryLogAppender=k}),define(Z[84],ee([0,1,2,26,24,126,21,38,42,33,20,44]),function(K,e,D,T,R,L,k,P,m,b,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let f=class{constructor(u,w){this._configurationService=w,this._experimentProperties={},this._disposables=new D.DisposableStore,this._cleanupPatterns=[],this._appender=u.appender,this._commonProperties=u.commonProperties||Promise.resolve({}),this._piiPaths=u.piiPaths||[],this._userOptIn=!0,this._errorOptIn=!0,this._enabled=!0,this.sendErrorTelemetry=!!u.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let g of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,R.escapeRegExpCharacters)(g),"gi"));this._updateUserOptIn(),this._configurationService.onDidChangeConfiguration(this._updateUserOptIn,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._userOptIn}),this._commonProperties.then(g=>{const E=/^[a-f0-9]+$/i.test(g["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!E})})}setExperimentProperty(u,w){this._experimentProperties[u]=w}setEnabled(u){this._enabled=u}_updateUserOptIn(){const u=(0,C.getTelemetryConfiguration)(this._configurationService);this._errorOptIn=u!=="off",this._userOptIn=u==="on"}get isOptedIn(){return this._userOptIn&&this._enabled}async getTelemetryInfo(){const u=await this._commonProperties;let w=u.sessionID,g=u["common.instanceId"],E=u["common.machineId"],y=u["common.firstSessionDate"],S=u["common.msftInternal"];return{sessionId:w,instanceId:g,machineId:E,firstSessionDate:y,msftInternal:S}}dispose(){this._disposables.dispose()}publicLog(u,w,g){return this.isOptedIn?this._commonProperties.then(E=>{w=(0,T.mixin)(w,E),w=(0,T.mixin)(w,this._experimentProperties),w=(0,T.cloneAndChange)(w,y=>{if(typeof y=="string")return this._cleanupInfo(y,g)}),this._appender.log(u,w)},E=>{console.error(E)}):Promise.resolve(void 0)}publicLog2(u,w,g){return this.publicLog(u,w,g)}publicLogError(u,w){return!this.sendErrorTelemetry||!this._errorOptIn?Promise.resolve(void 0):this.publicLog(u,w,!0)}publicLogError2(u,w){return this.publicLogError(u,w)}_anonymizeFilePaths(u){let w=u;const g=[];for(let o of this._cleanupPatterns)for(;;){const a=o.exec(u);if(!a)break;g.push([a.index,o.lastIndex])}const E=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,y=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let S=0;for(w="";;){const o=y.exec(u);if(!o)break;!E.test(o[0])&&g.every(([a,t])=>o.index<a||o.index>=t)&&(w+=u.substring(S,o.index)+"<REDACTED: user-file-path>",S=y.lastIndex)}return S<u.length&&(w+=u.substr(S)),w}_removePropertiesWithPossibleUserInfo(u){if(!u)return u;const w=u.toLowerCase(),g=/@[a-zA-Z0-9-.]+/;return/\S*(key|token|sig|password|passwd|pwd)[="':\s]+\S*/.test(w)?"<REDACTED: secret>":g.test(w)?"<REDACTED: email>":u}_cleanupInfo(u,w){let g=u;w&&(g=this._anonymizeFilePaths(g));for(let E of this._cleanupPatterns)g=g.replace(E,"");return g=this._removePropertiesWithPossibleUserInfo(g),g}};f.IDLE_START_EVENT_NAME="UserIdleStart",f.IDLE_STOP_EVENT_NAME="UserIdleStop",f=de([X(1,k.IConfigurationService)],f),e.TelemetryService=f,b.Registry.as(P.Extensions.Configuration).registerConfiguration({id:i.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,L.localize)(0,null),properties:{[i.TELEMETRY_SETTING_ID]:{type:"string",enum:["on","error","off"],enumDescriptions:[(0,L.localize)(1,null),(0,L.localize)(2,null),(0,L.localize)(3,null)],markdownDescription:m.default.privacyStatementUrl?(0,L.localize)(5,null,m.default.nameLong,m.default.privacyStatementUrl):(0,L.localize)(4,null,m.default.nameLong),default:"on",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),b.Registry.as(P.Extensions.Configuration).registerConfiguration({id:i.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,L.localize)(6,null),properties:{[i.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:m.default.privacyStatementUrl?(0,L.localize)(8,null,m.default.nameLong,m.default.privacyStatementUrl):(0,L.localize)(7,null,m.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,L.localize)(9,null,`\`#${i.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(Z[186],ee([0,1,9,26,44]),function(K,e,D,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AppInsightsAppender=void 0;async function L(P){const m=await new Promise((i,C)=>{K(["applicationinsights"],i,C)});let b;return m.defaultClient?(b=new m.TelemetryClient(P),b.channel.setUseDiskRetryCaching(!0)):(m.setup(P).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),b=m.defaultClient),P.indexOf("AIF-")===0&&(b.config.endpointUrl="https://vortex.data.microsoft.com/collect/v1"),b}class k{constructor(m,b,i){this._eventPrefix=m,this._defaultData=b,this._defaultData||(this._defaultData=Object.create(null)),typeof i=="function"?this._aiClient=i():this._aiClient=i,this._asyncAIClient=null}_withAIClient(m){if(!!this._aiClient){if(typeof this._aiClient!="string"){m(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=L(this._aiClient)),this._asyncAIClient.then(b=>{m(b)},b=>{(0,D.onUnexpectedError)(b),console.error(b)})}}log(m,b){!this._aiClient||(b=(0,T.mixin)(b,this._defaultData),b=(0,R.validateTelemetryData)(b),this._withAIClient(i=>i.trackEvent({name:this._eventPrefix+"/"+m,properties:b.properties,measurements:b.measurements})))}flush(){return this._aiClient?new Promise(m=>{this._withAIClient(b=>{b.flush({callback:()=>{this._aiClient=void 0,m(void 0)}})})}):Promise.resolve(void 0)}}e.AppInsightsAppender=k}),define(Z[187],ee([0,1,18,52,21,12,14,20,82,83,84,44]),function(K,e,D,T,R,L,k,P,m,b,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let f=class{constructor(u,w,g,E){this.configurationService=u,this.telemetryService=w,this.loggerService=g,this.environmentService=E,this.customTelemetryServices=new Map}async getCustomTelemetryService(u){if(!this.customTelemetryServices.has(u.id)){const{machineId:w,sessionId:g}=await this.telemetryService.getTelemetryInfo(),E=Object.create(null);E["common.vscodemachineid"]=w,E["common.vscodesessionid"]=g;const y=[u.id,JSON.stringify(E),u.aiKey],o=new T.Client(D.FileAccess.asFileUri("bootstrap-fork",K).fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:y,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),a=(0,C.combinedAppender)(new m.TelemetryAppenderClient(o),new b.TelemetryLogAppender(this.loggerService,this.environmentService,`[${u.id}] `));this.customTelemetryServices.set(u.id,new i.TelemetryService({appender:a,sendErrorTelemetry:u.sendErrorTelemetry},this.configurationService))}return this.customTelemetryServices.get(u.id)}async publicLog(u,w,g){await(await this.getCustomTelemetryService(u)).publicLog(w,g)}async publicLogError(u,w,g){await(await this.getCustomTelemetryService(u)).publicLogError(w,g)}};f=de([X(0,R.IConfigurationService),X(1,P.ITelemetryService),X(2,k.ILoggerService),X(3,L.IEnvironmentService)],f),e.CustomEndpointTelemetryService=f}),define(Z[188],ee([0,1,6,27,3,2,14]),function(K,e,D,T,R,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let P=class extends L.Disposable{constructor(b,i){super();this._logService=i,this._lastRequestId=0,this._pendingRequests=new Map,this._pendingRequestDisposables=new Map,this._onCreateRequest=this._register(new R.Emitter),this.onCreateRequest=this._onCreateRequest.event,this._timeout=b===void 0?15e3:b}createRequest(b){return new Promise((i,C)=>{const f=++this._lastRequestId;this._pendingRequests.set(f,i),this._onCreateRequest.fire({requestId:f,...b});const I=new T.CancellationTokenSource;(0,D.timeout)(this._timeout,I.token).then(()=>C(`Request ${f} timed out (${this._timeout}ms)`)),this._pendingRequestDisposables.set(f,[(0,L.toDisposable)(()=>I.cancel())])})}acceptReply(b,i){const C=this._pendingRequests.get(b);C?(this._pendingRequests.delete(b),(0,L.dispose)(this._pendingRequestDisposables.get(b)||[]),this._pendingRequestDisposables.delete(b),C(i)):this._logService.warn(`RequestStore#acceptReply was called without receiving a matching request ${b}`)}};P=de([X(1,k.ILogService)],P),e.RequestStore=P}),define(Z[85],ee([0,1,7]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.ProcessCapability=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.ProcessPropertyType=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var T;(function(g){g.Shell="terminal.integrated.shell.",g.ShellArgs="terminal.integrated.shellArgs.",g.DefaultProfile="terminal.integrated.defaultProfile.",g.Profiles="terminal.integrated.profiles."})(T=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var R;(function(g){g.ShellLinux="terminal.integrated.shell.linux",g.ShellMacOs="terminal.integrated.shell.osx",g.ShellWindows="terminal.integrated.shell.windows",g.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",g.AutomationShellLinux="terminal.integrated.automationShell.linux",g.AutomationShellMacOs="terminal.integrated.automationShell.osx",g.AutomationShellWindows="terminal.integrated.automationShell.windows",g.ShellArgsLinux="terminal.integrated.shellArgs.linux",g.ShellArgsMacOs="terminal.integrated.shellArgs.osx",g.ShellArgsWindows="terminal.integrated.shellArgs.windows",g.ProfilesWindows="terminal.integrated.profiles.windows",g.ProfilesMacOs="terminal.integrated.profiles.osx",g.ProfilesLinux="terminal.integrated.profiles.linux",g.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",g.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",g.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",g.UseWslProfiles="terminal.integrated.useWslProfiles",g.TabsEnabled="terminal.integrated.tabs.enabled",g.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",g.TabsHideCondition="terminal.integrated.tabs.hideCondition",g.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",g.TabsShowActions="terminal.integrated.tabs.showActions",g.TabsLocation="terminal.integrated.tabs.location",g.TabsFocusMode="terminal.integrated.tabs.focusMode",g.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",g.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",g.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",g.CopyOnSelection="terminal.integrated.copyOnSelection",g.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",g.FontFamily="terminal.integrated.fontFamily",g.FontSize="terminal.integrated.fontSize",g.LetterSpacing="terminal.integrated.letterSpacing",g.LineHeight="terminal.integrated.lineHeight",g.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",g.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",g.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",g.BellDuration="terminal.integrated.bellDuration",g.FontWeight="terminal.integrated.fontWeight",g.FontWeightBold="terminal.integrated.fontWeightBold",g.CursorBlinking="terminal.integrated.cursorBlinking",g.CursorStyle="terminal.integrated.cursorStyle",g.CursorWidth="terminal.integrated.cursorWidth",g.Scrollback="terminal.integrated.scrollback",g.DetectLocale="terminal.integrated.detectLocale",g.DefaultLocation="terminal.integrated.defaultLocation",g.GpuAcceleration="terminal.integrated.gpuAcceleration",g.TerminalTitleSeparator="terminal.integrated.tabs.separator",g.TerminalTitle="terminal.integrated.tabs.title",g.TerminalDescription="terminal.integrated.tabs.description",g.RightClickBehavior="terminal.integrated.rightClickBehavior",g.Cwd="terminal.integrated.cwd",g.ConfirmOnExit="terminal.integrated.confirmOnExit",g.ConfirmOnKill="terminal.integrated.confirmOnKill",g.EnableBell="terminal.integrated.enableBell",g.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",g.AllowChords="terminal.integrated.allowChords",g.AllowMnemonics="terminal.integrated.allowMnemonics",g.EnvMacOs="terminal.integrated.env.osx",g.EnvLinux="terminal.integrated.env.linux",g.EnvWindows="terminal.integrated.env.windows",g.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",g.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",g.ShowExitAlert="terminal.integrated.showExitAlert",g.SplitCwd="terminal.integrated.splitCwd",g.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",g.WordSeparators="terminal.integrated.wordSeparators",g.EnableFileLinks="terminal.integrated.enableFileLinks",g.UnicodeVersion="terminal.integrated.unicodeVersion",g.ExperimentalLinkProvider="terminal.integrated.experimentalLinkProvider",g.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",g.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",g.LocalEchoStyle="terminal.integrated.localEchoStyle",g.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",g.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",g.CustomGlyphs="terminal.integrated.customGlyphs",g.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",g.InheritEnv="terminal.integrated.inheritEnv",g.ShowLinkHover="terminal.integrated.showLinkHover"})(R=e.TerminalSettingId||(e.TerminalSettingId={}));var L;(function(g){g.CommandPrompt="cmd",g.PowerShell="pwsh",g.Wsl="wsl",g.GitBash="gitbash"})(L=e.WindowsShellType||(e.WindowsShellType={}));var k;(function(g){g[g.Api=0]="Api",g[g.Process=1]="Process",g[g.Sequence=2]="Sequence",g[g.Config=3]="Config"})(k=e.TitleEventSource||(e.TitleEventSource={}));var P;(function(g){g.LocalPty="localPty",g.PtyHost="ptyHost",g.Log="log",g.Heartbeat="heartbeat"})(P=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,D.createDecorator)("ptyService");var m;(function(g){g.Cwd="cwd",g.InitialCwd="initialCwd"})(m=e.ProcessPropertyType||(e.ProcessPropertyType={}));var b;(function(g){g[g.BeatInterval=5e3]="BeatInterval",g[g.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",g[g.SecondWaitMultiplier=1]="SecondWaitMultiplier",g[g.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(b=e.HeartbeatConstants||(e.HeartbeatConstants={}));var i;(function(g){g[g.Panel=1]="Panel",g[g.Editor=2]="Editor"})(i=e.TerminalLocation||(e.TerminalLocation={}));var C;(function(g){g.TerminalView="view",g.Editor="editor"})(C=e.TerminalLocationString||(e.TerminalLocationString={}));var f;(function(g){g.CwdDetection="cwdDetection"})(f=e.ProcessCapability||(e.ProcessCapability={}));var I;(function(g){g[g.GraceTime=6e4]="GraceTime",g[g.ShortGraceTime=6e3]="ShortGraceTime"})(I=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var u;(function(g){g[g.HighWatermarkChars=1e5]="HighWatermarkChars",g[g.LowWatermarkChars=5e3]="LowWatermarkChars",g[g.CharCountAckSize=5e3]="CharCountAckSize"})(u=e.FlowControlConstants||(e.FlowControlConstants={}));var w;(function(g){g.GitBash="Git Bash",g.Pwsh="PowerShell"})(w=e.ProfileSource||(e.ProfileSource={}))}),define(Z[189],ee([0,1,7]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILocalPtyService=void 0,e.ILocalPtyService=(0,D.createDecorator)("localPtyService")}),define(Z[190],ee([0,1,35,26,8,4,31,17,19]),function(K,e,D,T,R,L,k,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findExecutable=e.getWindowsBuildNumber=void 0;function b(){const C=/(\d+)\.(\d+)\.(\d+)/g.exec(D.release());let f=0;return C&&C.length===4&&(f=parseInt(C[3])),f}e.getWindowsBuildNumber=b;async function i(C,f,I,u=k.env,w=m.Promises.exists){if(R.isAbsolute(C))return await w(C)?C:void 0;if(f===void 0&&(f=k.cwd()),R.dirname(C)!=="."){const S=R.join(f,C);return await w(S)?S:void 0}const E=(0,T.getCaseInsensitive)(u,"PATH");if(I===void 0&&(0,P.isString)(E)&&(I=E.split(R.delimiter)),I===void 0||I.length===0){const S=R.join(f,C);return await w(S)?S:void 0}for(let S of I){let o;if(R.isAbsolute(S)?o=R.join(S,C):o=R.join(f,S,C),await w(o))return o;if(L.isWindows){let a=o+".com";if(await w(a)||(a=o+".exe",await w(a)))return a}}const y=R.join(f,C);return await w(y)?y:void 0}e.findExecutable=i}),define(Z[191],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var D;(function(T){T.DARK="dark",T.LIGHT="light",T.HIGH_CONTRAST="hc"})(D=e.ColorScheme||(e.ColorScheme={}))}),define(Z[86],ee([0,1,49,3,2,7,33,191]),function(K,e,D,T,R,L,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,L.createDecorator)("themeService");var m;(function(g){function E(y){return y&&typeof y=="object"&&typeof y.id=="string"}g.isThemeColor=E})(m=e.ThemeColor||(e.ThemeColor={}));function b(g){return{id:g}}e.themeColorFromId=b;var i;(function(g){function E(s){return s&&typeof s=="object"&&typeof s.id=="string"&&(typeof s.color=="undefined"||m.isThemeColor(s.color))}g.isThemeIcon=E;const y=new RegExp(`^\\$\\((${D.CSSIcon.iconNameExpression}(?:${D.CSSIcon.iconModifierExpression})?)\\)$`);function S(s){const n=y.exec(s);if(!n)return;let[,r]=n;return{id:r}}g.fromString=S;function o(s,n){let r=s.id;const c=r.lastIndexOf("~");return c!==-1&&(r=r.substring(0,c)),n&&(r=`${r}~${n}`),{id:r}}g.modify=o;function a(s,n){return s.id===n.id&&s.color?.id===n.color?.id}g.isEqual=a;function t(s,n){return{id:s.id,color:n?b(n):void 0}}g.asThemeIcon=t,g.asClassNameArray=D.CSSIcon.asClassNameArray,g.asClassName=D.CSSIcon.asClassName,g.asCSSSelector=D.CSSIcon.asCSSSelector})(i=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=D.Codicon.file,e.FolderThemeIcon=D.Codicon.folder;function C(g){switch(g){case P.ColorScheme.DARK:return"vs-dark";case P.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=C,e.Extensions={ThemingContribution:"base.contributions.theming"};class f{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new T.Emitter}onColorThemeChange(E){return this.themingParticipants.push(E),this.onThemingParticipantAddedEmitter.fire(E),(0,R.toDisposable)(()=>{const y=this.themingParticipants.indexOf(E);this.themingParticipants.splice(y,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let I=new f;k.Registry.add(e.Extensions.ThemingContribution,I);function u(g){return I.onColorThemeChange(g)}e.registerThemingParticipant=u;class w extends R.Disposable{constructor(E){super();this.themeService=E,this.theme=E.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(y=>this.onThemeChange(y)))}onThemeChange(E){this.theme=E,this.updateStyles()}updateStyles(){}getColor(E,y){let S=this.theme.getColor(E);return S&&y&&(S=y(S,this.theme)),S?S.toString():null}}e.Themable=w}),define(Z[192],ee([0,1,49,86]),function(K,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProfileSchemaEnums=void 0;function R(P,m){const b=P.map(i=>({name:i.profileName,description:L(i)}));return m&&b.push(...m.map(i=>({name:i.title,description:k(i)}))),{values:b.map(i=>i.name),markdownDescriptions:b.map(i=>i.description)}}e.createProfileSchemaEnums=R;function L(P){let m=`$(${T.ThemeIcon.isThemeIcon(P.icon)?P.icon.id:P.icon?P.icon:D.Codicon.terminal.id}) ${P.profileName}
- path: ${P.path}`;return P.args&&(typeof P.args=="string"?m+=`
- args: "${P.args}"`:m+=`
- args: [${P.args.length===0?"":`'${P.args.join("','")}'`}]`),P.overrideName!==void 0&&(m+=`
- overrideName: ${P.overrideName}`),P.color&&(m+=`
- color: ${P.color}`),P.env&&(m+=`
- env: ${JSON.stringify(P.env)}`),m}function k(P){return`$(${T.ThemeIcon.isThemeIcon(P.icon)?P.icon.id:P.icon?P.icon:D.Codicon.terminal.id}) ${P.title}
- extensionIdenfifier: ${P.extensionIdentifier}`}}),define(Z[193],ee([0,1,49,127,38,33,192]),function(K,e,D,T,R,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=void 0;const P={args:{description:(0,T.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,T.localize)(1,null),type:"boolean"},icon:{description:(0,T.localize)(2,null),type:"string",enum:Array.from(D.iconRegistry.all,g=>g.id),markdownEnumDescriptions:Array.from(D.iconRegistry.all,g=>`$(${g.id})`)},color:{description:(0,T.localize)(3,null),type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},env:{markdownDescription:(0,T.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},m={type:"object",required:["path"],properties:{path:{description:(0,T.localize)(5,null),type:["string","array"],items:{type:"string"}},...P}},b=(0,T.localize)(6,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),i=(0,T.localize)(7,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),C=(0,T.localize)(8,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),f={id:"terminal",order:100,title:(0,T.localize)(9,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,T.localize)(10,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,T.localize)(11,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,T.localize)(12,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,T.localize)(13,null),type:["string","null"],default:null,markdownDeprecationMessage:b},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,T.localize)(14,null),type:["string","null"],default:null,markdownDeprecationMessage:i},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,T.localize)(15,null),type:["string","null"],default:null,markdownDeprecationMessage:C},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,T.localize)(16,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:b},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,T.localize)(17,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:i},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,T.localize)(18,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,T.localize)(19,null)}},{type:"string",markdownDescription:(0,T.localize)(20,null)}],default:[],markdownDeprecationMessage:C},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:(0,T.localize)(21,null,"`source`","`path`","`args`."),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,T.localize)(22,null),enum:["PowerShell","Git Bash"]},...P}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,T.localize)(23,null),type:"string"},id:{description:(0,T.localize)(24,null),type:"string"},title:{description:(0,T.localize)(25,null),type:"string"},...P}},{type:"null"},m]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:(0,T.localize)(26,null,"`path`","`args`."),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,T.localize)(27,null),type:"string"},id:{description:(0,T.localize)(28,null),type:"string"},title:{description:(0,T.localize)(29,null),type:"string"},...P}},{type:"null"},m]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:(0,T.localize)(30,null,"`path`","`args`."),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,T.localize)(31,null),type:"string"},id:{description:(0,T.localize)(32,null),type:"string"},title:{description:(0,T.localize)(33,null),type:"string"},...P}},{type:"null"},m]}},["terminal.integrated.useWslProfiles"]:{description:(0,T.localize)(34,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,T.localize)(35,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,T.localize)(36,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,T.localize)(37,null),type:"boolean",default:!0}}};function I(){L.Registry.as(R.Extensions.Configuration).registerConfiguration(f),w()}e.registerTerminalPlatformConfiguration=I;let u;function w(g,E){const y=L.Registry.as(R.Extensions.Configuration);let S;g&&(S=(0,k.createProfileSchemaEnums)(g?.profiles,E));const o=u;u={id:"terminal",order:100,title:(0,T.localize)(38,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,T.localize)(39,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:g?.os===3?S?.values:void 0,markdownEnumDescriptions:g?.os===3?S?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,T.localize)(40,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:g?.os===2?S?.values:void 0,markdownEnumDescriptions:g?.os===2?S?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,T.localize)(41,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:g?.os===1?S?.values:void 0,markdownEnumDescriptions:g?.os===1?S?.markdownDescriptions:void 0}}},y.updateConfigurations({add:[u],remove:o?[o]:[]})}e.registerTerminalDefaultProfileConfiguration=w}),define(Z[194],ee([0,1,41,49,8,4,19,69,190,86]),function(K,e,D,T,R,L,k,P,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let i;function C(t,s,n,r,c=process.env,l,h,d,v){return l=l||{existsFile:k.SymlinkSupport.existsFile,readFile:k.Promises.readFile},L.isWindows?f(n,l,c,h,r.getValue("terminal.integrated.useWslProfiles")!==!1,t&&typeof t=="object"?{...t}:r.getValue("terminal.integrated.profiles.windows"),typeof s=="string"?s:r.getValue("terminal.integrated.defaultProfile.windows"),v,d):S(l,h,n,t&&typeof t=="object"?{...t}:r.getValue(L.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof s=="string"?s:r.getValue(L.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),v,d,c)}e.detectAvailableProfiles=C;async function f(t,s,n,r,c,l,h,d,v){const A=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),O=`${process.env.windir}\\${A?"Sysnative":"System32"}`;let p=!1;(0,m.getWindowsBuildNumber)()>=16299&&(p=!0),await w(d);const U=new Map;t&&(U.set("PowerShell",{source:"PowerShell",icon:T.Codicon.terminalPowershell,isAutoDetected:!0}),U.set("Windows PowerShell",{path:`${O}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:T.Codicon.terminalPowershell,isAutoDetected:!0}),U.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),U.set("Cygwin",{path:[`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`],args:["--login"],isAutoDetected:!0}),U.set("Command Prompt",{path:`${O}\\cmd.exe`,icon:T.Codicon.terminalCmd,isAutoDetected:!0})),o(l,U);const F=await I(U.entries(),h,s,n,r,v);if(t||!t&&c)try{const $=await E(`${O}\\${p?"wsl":"bash"}.exe`,h);for(const H of $)(!l||!(H.profileName in l))&&F.push(H)}catch($){r?.info("WSL is not installed, so could not detect WSL profiles")}return F}async function I(t,s,n,r=process.env,c,l){const h=[];for(const[d,v]of t){if(v===null)continue;let A,O,p;if("source"in v){const $=i?.get(v.source);if(!$)continue;A=$.paths,O=v.args||$.args,v.icon?p=u(v.icon):$.icon&&(p=$.icon)}else A=Array.isArray(v.path)?v.path:[v.path],O=L.isWindows||Array.isArray(v.args)?v.args:void 0,p=u(v.icon)||void 0;const U=await l?.(A)||A.slice(),F=await a(d,s,U,n,r,O,v.env,v.overrideName,v.isAutoDetected,c);F?(F.isAutoDetected=v.isAutoDetected,F.icon=p,F.color=v.color,h.push(F)):c?.trace("profile not validated",d,A)}return h}function u(t){return typeof t=="string"?{id:t}:t}async function w(t){i&&!t||(i=new Map,i.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`,`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`,`${process.env.AllUsersProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`],args:["--login"]}),i.set("PowerShell",{profileName:"PowerShell",paths:t||await g(),icon:b.ThemeIcon.asThemeIcon(T.Codicon.terminalPowershell)}))}async function g(){const t=[];for await(const s of(0,P.enumeratePowerShellInstallations)())t.push(s.exePath);return t}async function E(t,s){const n=[],r=await new Promise((h,d)=>{D.exec("wsl.exe -l -q",{encoding:"utf16le"},(v,A)=>{if(v)return d("Problem occurred when getting wsl distros");h(A)})});if(!r)return[];const c=new RegExp(/[\r?\n]/),l=r.split(c).filter(h=>h.trim().length>0&&h!=="");for(const h of l){if(h===""||h.startsWith("docker-desktop"))continue;const d=`${h} (WSL)`,v={profileName:d,path:t,args:["-d",`${h}`],isDefault:d===s,icon:y(h)};n.push(v)}return n}function y(t){return t.includes("Ubuntu")?b.ThemeIcon.asThemeIcon(T.Codicon.terminalUbuntu):t.includes("Debian")?b.ThemeIcon.asThemeIcon(T.Codicon.terminalDebian):b.ThemeIcon.asThemeIcon(T.Codicon.terminalLinux)}async function S(t,s,n,r,c,l,h,d){const v=new Map;if(n){const A=(await t.readFile("/etc/shells")).toString(),O=l||A.split(`
`).filter(U=>U.trim().indexOf("#")!==0&&U.trim().length>0),p=new Map;for(const U of O){let F=(0,R.basename)(U),$=p.get(F)||0;$++,$>1&&(F=`${F} (${$})`),p.set(F,$),v.set(F,{path:U,isAutoDetected:!0})}}return o(r,v),await I(v.entries(),c,t,d,s,h)}function o(t,s){if(!!t)for(const[n,r]of Object.entries(t))r===null||!("path"in r)&&!("source"in r)?s.delete(n):s.set(n,r)}async function a(t,s,n,r,c,l,h,d,v,A){if(n.length===0)return Promise.resolve(void 0);const O=n.shift();if(O==="")return a(t,s,n,r,c,l,h,d,v);const p={profileName:t,path:O,args:l,env:h,overrideName:d,isAutoDetected:v,isDefault:t===s};if((0,R.basename)(O)===O){const F=c.PATH?c.PATH.split(R.delimiter):void 0;return await(0,m.findExecutable)(O,void 0,F,void 0,r.existsFile)?p:a(t,s,n,r,c,l)}return await r.existsFile((0,R.normalize)(O))?p:a(t,s,n,r,c,l,h,d,v)}}),define(Z[195],ee([0,1,3,2,18,4,36,52,21,156,14,79,20,188,85,193,194]),function(K,e,D,T,R,L,k,P,m,b,i,C,f,I,u,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var E;(function(o){o[o.MaxRestarts=5]="MaxRestarts"})(E||(E={}));let y=0,S=class extends T.Disposable{constructor(a,t,s,n){super();this._reconnectConstants=a,this._configurationService=t,this._logService=s,this._telemetryService=n,this._restartCount=0,this._isResponsive=!0,this._isDisposed=!1,this._onPtyHostExit=this._register(new D.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new D.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new D.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new D.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onPtyHostRequestResolveVariables=this._register(new D.Emitter),this.onPtyHostRequestResolveVariables=this._onPtyHostRequestResolveVariables.event,this._onProcessData=this._register(new D.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessExit=this._register(new D.Emitter),this.onProcessExit=this._onProcessExit.event,this._onProcessReady=this._register(new D.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new D.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessTitleChanged=this._register(new D.Emitter),this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessShellTypeChanged=this._register(new D.Emitter),this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event,this._onProcessOverrideDimensions=this._register(new D.Emitter),this.onProcessOverrideDimensions=this._onProcessOverrideDimensions.event,this._onProcessResolvedShellLaunchConfig=this._register(new D.Emitter),this.onProcessResolvedShellLaunchConfig=this._onProcessResolvedShellLaunchConfig.event,this._onProcessOrphanQuestion=this._register(new D.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._onDidRequestDetach=this._register(new D.Emitter),this.onDidRequestDetach=this._onDidRequestDetach.event,this._onProcessDidChangeHasChildProcesses=this._register(new D.Emitter),this.onProcessDidChangeHasChildProcesses=this._onProcessDidChangeHasChildProcesses.event,this._onDidChangeProperty=this._register(new D.Emitter),this.onDidChangeProperty=this._onDidChangeProperty.event,(0,w.registerTerminalPlatformConfiguration)(),this._shellEnv=L.isWindows?Promise.resolve(process.env):(0,b.resolveShellEnv)(this._logService,{_:[]},process.env),this._register((0,T.toDisposable)(()=>this._disposePtyHost())),this._resolveVariablesRequestStore=this._register(new I.RequestStore(void 0,this._logService)),this._resolveVariablesRequestStore.onCreateRequest(this._onPtyHostRequestResolveVariables.fire,this._onPtyHostRequestResolveVariables),[this._client,this._proxy]=this._startPtyHost()}_startPtyHost(){const a=new P.Client(R.FileAccess.asFileUri("bootstrap-fork",K).fsPath,{serverName:"Pty Host",args:["--type=ptyHost"],env:{VSCODE_LAST_PTY_ID:y,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this._reconnectConstants.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this._reconnectConstants.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this._reconnectConstants.scrollback}});this._onPtyHostStart.fire(),k.ProxyChannel.toService(a.getChannel(u.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(),this._register(a.onDidProcessExit(r=>{this._telemetryService.publicLog("ptyHost/exit"),this._onPtyHostExit.fire(r.code),this._isDisposed||(this._restartCount<=E.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${r.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${r.code}, giving up`))}));const s=a.getChannel(u.TerminalIpcChannels.Log);C.LogLevelChannelClient.setLevel(s,this._logService.getLevel()),this._register(this._logService.onDidChangeLogLevel(()=>{C.LogLevelChannelClient.setLevel(s,this._logService.getLevel())}));const n=k.ProxyChannel.toService(a.getChannel(u.TerminalIpcChannels.PtyHost));return this._register(n.onProcessData(r=>this._onProcessData.fire(r))),this._register(n.onProcessExit(r=>this._onProcessExit.fire(r))),this._register(n.onProcessReady(r=>this._onProcessReady.fire(r))),this._register(n.onProcessTitleChanged(r=>this._onProcessTitleChanged.fire(r))),this._register(n.onProcessShellTypeChanged(r=>this._onProcessShellTypeChanged.fire(r))),this._register(n.onProcessOverrideDimensions(r=>this._onProcessOverrideDimensions.fire(r))),this._register(n.onProcessResolvedShellLaunchConfig(r=>this._onProcessResolvedShellLaunchConfig.fire(r))),this._register(n.onProcessDidChangeHasChildProcesses(r=>this._onProcessDidChangeHasChildProcesses.fire(r))),this._register(n.onDidChangeProperty(r=>this._onDidChangeProperty.fire(r))),this._register(n.onProcessReplay(r=>this._onProcessReplay.fire(r))),this._register(n.onProcessOrphanQuestion(r=>this._onProcessOrphanQuestion.fire(r))),this._register(n.onDidRequestDetach(r=>this._onDidRequestDetach.fire(r))),[a,n]}dispose(){this._isDisposed=!0,super.dispose()}async createProcess(a,t,s,n,r,c,l,h,d,v,A){const O=setTimeout(()=>this._handleUnresponsiveCreateProcess(),u.HeartbeatConstants.CreateProcessTimeout),p=await this._proxy.createProcess(a,t,s,n,r,c,l,h,d,v,A);return clearTimeout(O),y=Math.max(y,p),p}updateTitle(a,t,s){return this._proxy.updateTitle(a,t,s)}updateIcon(a,t,s){return this._proxy.updateIcon(a,t,s)}attachToProcess(a){return this._proxy.attachToProcess(a)}detachFromProcess(a){return this._proxy.detachFromProcess(a)}listProcesses(){return this._proxy.listProcesses()}reduceConnectionGraceTime(){return this._proxy.reduceConnectionGraceTime()}start(a){return this._proxy.start(a)}shutdown(a,t){return this._proxy.shutdown(a,t)}input(a,t){return this._proxy.input(a,t)}processBinary(a,t){return this._proxy.processBinary(a,t)}resize(a,t,s){return this._proxy.resize(a,t,s)}acknowledgeDataEvent(a,t){return this._proxy.acknowledgeDataEvent(a,t)}setUnicodeVersion(a,t){return this._proxy.setUnicodeVersion(a,t)}getInitialCwd(a){return this._proxy.getInitialCwd(a)}getCwd(a){return this._proxy.getCwd(a)}getLatency(a){return this._proxy.getLatency(a)}orphanQuestionReply(a){return this._proxy.orphanQuestionReply(a)}getDefaultSystemShell(a){return this._proxy.getDefaultSystemShell(a)}async getProfiles(a,t,s,n=!1){const r=await this._shellEnv;return(0,g.detectAvailableProfiles)(t,s,n,this._configurationService,r,void 0,this._logService,this._resolveVariables.bind(this,a))}getEnvironment(){return this._proxy.getEnvironment()}getWslPath(a){return this._proxy.getWslPath(a)}setTerminalLayoutInfo(a){return this._proxy.setTerminalLayoutInfo(a)}async getTerminalLayoutInfo(a){return await this._proxy.getTerminalLayoutInfo(a)}async requestDetachInstance(a,t){return this._proxy.requestDetachInstance(a,t)}async acceptDetachInstanceReply(a,t){return this._proxy.acceptDetachInstanceReply(a,t)}async serializeTerminalState(a){return this._proxy.serializeTerminalState(a)}async reviveTerminalProcesses(a){return this._proxy.reviveTerminalProcesses(a)}async refreshProperty(a,t){return this._proxy.refreshProperty(a,t)}async restartPtyHost(){this._telemetryService.publicLog("ptyHost/restart"),this._isResponsive=!0,this._disposePtyHost(),[this._client,this._proxy]=this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll?.(),this._client.dispose()}_handleHeartbeat(){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),u.HeartbeatConstants.BeatInterval*u.HeartbeatConstants.FirstWaitMultiplier),this._isResponsive||(this._telemetryService.publicLog("ptyHost/responsive"),this._isResponsive=!0),this._onPtyHostResponsive.fire()}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${u.HeartbeatConstants.BeatInterval*u.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),u.HeartbeatConstants.BeatInterval*u.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(u.HeartbeatConstants.BeatInterval*u.HeartbeatConstants.FirstWaitMultiplier+u.HeartbeatConstants.BeatInterval*u.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._isResponsive&&(this._telemetryService.publicLog("ptyHost/unresponsive"),this._isResponsive=!1),this._onPtyHostUnresponsive.fire()}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${u.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._telemetryService.publicLog("ptyHost/responsive"),this._onPtyHostUnresponsive.fire()}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}_resolveVariables(a,t){return this._resolveVariablesRequestStore.createRequest({workspaceId:a,originalText:t})}async acceptPtyHostResolvedVariables(a,t){this._resolveVariablesRequestStore.acceptReply(a,t)}};S=de([X(1,m.IConfigurationService),X(2,i.ILogService),X(3,f.ITelemetryService)],S),e.PtyHostService=S}),define(Z[54],ee([0,1,45]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLineEndOffset=e.getLineStartOffset=e.edit=void 0;function T(k,P,m,b){const i=(0,D.setProperty)(k,P,m,b)[0];return i&&(k=k.substring(0,i.offset)+i.content+k.substring(i.offset+i.length)),k}e.edit=T;function R(k,P,m){let b=m;for(;b>=0;){if(k.charAt(b)===P.charAt(P.length-1)&&P.length===1)return b+1;if(b--,P.length===2&&b>=0&&k.charAt(b)===P.charAt(0))return b+2}return 0}e.getLineStartOffset=R;function L(k,P,m){let b=m;for(;b>=0;)if(k.charAt(b)===P.charAt(P.length-1)&&P.length===1||(b++,P.length===2&&b>=0&&k.charAt(b)===P.charAt(1)))return b;return k.length-1}e.getLineEndOffset=L}),define(Z[196],ee([0,1,26,58]),function(K,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function R(C,f,I,u,w){const g=[],E=[],y=[];if(!f){const O=C.filter(({identifier:p})=>w.every(U=>U.toLowerCase()!==p.id.toLowerCase()));return{local:{added:g,removed:E,updated:y},remote:O.length>0?{added:O,updated:[],removed:[],all:O}:null}}C=C.map(b),f=f.map(b),I=I?I.map(b):null;const S=new Map,o=O=>{O.uuid&&S.set(O.id.toLowerCase(),O.uuid)};C.forEach(({identifier:O})=>o(O)),f.forEach(({identifier:O})=>o(O)),I&&I.forEach(({identifier:O})=>o(O));const a=O=>{const p=O.identifier.uuid||S.get(O.identifier.id.toLowerCase());return p?`uuid:${p}`:`id:${O.identifier.id.toLowerCase()}`},t=(O,p)=>(O.set(a(p),p),O),s=C.reduce(t,new Map),n=f.reduce(t,new Map),r=f.reduce((O,p)=>{const U=a(p);p=(0,D.deepClone)(p);const F=s.get(U);return F&&(F.installed&&(p.installed=!0),p.version||(p.version=F.version)),t(O,p)},new Map),c=I?I.reduce(t,new Map):null,l=u.reduce(t,new Map),h=w.reduce((O,p)=>{const U=S.get(p.toLowerCase());return O.add(U?`uuid:${U}`:`id:${p.toLowerCase()}`)},new Set),d=L(s,n,h);if(d.added.size>0||d.removed.size>0||d.updated.size>0){const O=L(c,s,h),p=L(c,n,h),U=(F,$)=>{const H=s.get(F);if(H){const M=n.get(F);return{...$?M:H,version:(M.version&&T.gt(M.version,H.version),H.version),state:k(H,M,c?.get(F))}}};for(const F of p.removed.values()){const $=s.get(F);$&&E.push($.identifier)}for(const F of p.added.values())if(O.added.has(F)){if(d.updated.has(F)){const $=U(F,!0);$&&(y.push(i($,F)),r.set(F,$))}}else{const $=n.get(F);$.installed&&g.push(i($,F))}for(const F of p.updated.values()){const $=U(F,!0);$&&(y.push(i($,F)),r.set(F,$))}for(const F of O.added.values())p.added.has(F)||r.set(F,s.get(F));for(const F of O.updated.values())if(!p.removed.has(F)&&!p.updated.has(F)){const $=U(F,!1);$&&(r.get(F)?.installed&&($.installed=!0),r.set(F,$))}for(const F of O.removed.values())!l.has(F)&&!p.updated.has(F)&&c?.get(F)?.installed&&r.delete(F)}const v=[],A=L(n,r,new Set,{checkInstalledProperty:!0,checkVersionProperty:!0});return(A.added.size>0||A.updated.size>0||A.removed.size>0)&&r.forEach((O,p)=>v.push(i(O,p))),{local:{added:g,removed:E,updated:y},remote:v.length?{added:[...A.added].map(O=>r.get(O)),updated:[...A.updated].map(O=>r.get(O)),removed:[...A.removed].map(O=>n.get(O)),all:v}:null}}e.merge=R;function L(C,f,I,{checkInstalledProperty:u,checkVersionProperty:w}={checkInstalledProperty:!1,checkVersionProperty:!1}){const g=C?[...C.keys()].filter(a=>!I.has(a)):[],E=[...f.keys()].filter(a=>!I.has(a)),y=E.filter(a=>g.indexOf(a)===-1).reduce((a,t)=>(a.add(t),a),new Set),S=g.filter(a=>E.indexOf(a)===-1).reduce((a,t)=>(a.add(t),a),new Set),o=new Set;for(const a of g){if(S.has(a))continue;const t=C.get(a),s=f.get(a);(!s||t.disabled!==s.disabled||!m(t.state,s.state)||w&&t.version!==s.version||u&&t.installed!==s.installed)&&o.add(a)}return{added:y,removed:S,updated:o}}function k(C,f,I){const u=C.state,w=f.state,g=I?.state;if(!f.version||u&&T.gt(C.version,f.version))return u;if(w&&T.gt(f.version,C.version)||!u)return w;if(!w)return u;const E=(0,D.deepClone)(u),y=g?P(g,w):{added:Object.keys(w).reduce((o,a)=>(o.add(a),o),new Set),removed:new Set,updated:new Set},S=g?P(g,u):{added:Object.keys(u).reduce((o,a)=>(o.add(a),o),new Set),removed:new Set,updated:new Set};for(const o of[...y.added.values(),...y.updated.values()])E[o]=w[o];for(const o of y.removed.values())S.updated.has(o)||delete E[o];return E}function P(C,f){const I=Object.keys(C),u=Object.keys(f),w=u.filter(y=>I.indexOf(y)===-1).reduce((y,S)=>(y.add(S),y),new Set),g=I.filter(y=>u.indexOf(y)===-1).reduce((y,S)=>(y.add(S),y),new Set),E=new Set;for(const y of I){if(g.has(y))continue;const S=C[y],o=f[y];(0,D.equals)(S,o)||E.add(y)}return{added:w,removed:g,updated:E}}function m(C={},f={}){const{added:I,removed:u,updated:w}=P(C,f);return I.size===0&&u.size===0&&w.size===0}function b(C){return{...C,disabled:!!C.disabled,installed:!!C.installed}}function i(C,f){const I={identifier:{id:C.identifier.id,uuid:f.startsWith("uuid:")?f.substring("uuid:".length):void 0}};return C.version&&(I.version=C.version),C.disabled&&(I.disabled=!0),C.installed&&(I.installed=!0),C.state&&(I.state=C.state),I}}),define(Z[87],ee([0,1,16,3,2,32,7,29,22]),function(K,e,D,T,R,L,k,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsStorageSyncService=e.IExtensionsStorageSyncService=void 0,e.IExtensionsStorageSyncService=(0,k.createDecorator)("IExtensionsStorageSyncService");const b=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let i=class Ze extends R.Disposable{constructor(f,I){super();this.storageService=f,this.productService=I,this._onDidChangeExtensionsStorage=this._register(new T.Emitter),this.onDidChangeExtensionsStorage=this._onDidChangeExtensionsStorage.event,this.extensionsWithKeysForSync=new Set,this.initialize(),this._register(this.storageService.onDidChangeValue(u=>this.onDidChangeStorageValue(u)))}static toKey(f){return`extensionKeys/${(0,L.adoptToGalleryExtensionId)(f.id)}@${f.version}`}static fromKey(f){const I=b.exec(f);if(I&&I[1])return{id:I[1],version:I[2]}}initialize(){const f=this.storageService.keys(0,1);for(const I of f){const u=Ze.fromKey(I);u&&this.extensionsWithKeysForSync.add(u.id.toLowerCase())}}onDidChangeStorageValue(f){if(f.scope!==0)return;if(this.extensionsWithKeysForSync.has(f.key.toLowerCase())){this._onDidChangeExtensionsStorage.fire();return}const I=Ze.fromKey(f.key);if(I){this.extensionsWithKeysForSync.add(I.id.toLowerCase()),this._onDidChangeExtensionsStorage.fire();return}}setKeysForSync(f,I){this.storageService.store(Ze.toKey(f),JSON.stringify(I),0,1)}getKeysForSync(f){const I=this.productService.extensionSyncedKeys?.[f.id.toLowerCase()],u=this.storageService.get(Ze.toKey(f),0),w=u?JSON.parse(u):void 0;return w&&I?(0,D.distinct)([...w,...I]):w||I}};i=de([X(0,m.IStorageService),X(1,P.IProductService)],i),e.ExtensionsStorageSyncService=i}),define(Z[88],ee([0,1,16,21,7]),function(K,e,D,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=(0,R.createDecorator)("IIgnoredExtensionsManagementService");let L=class{constructor(P){this.configurationService=P}hasToNeverSyncExtension(P){return this.getConfiguredIgnoredExtensions().includes(P.toLowerCase())}hasToAlwaysSyncExtension(P){return this.getConfiguredIgnoredExtensions().includes(`-${P.toLowerCase()}`)}updateIgnoredExtensions(P,m){let b=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(i=>i.toLowerCase());return b=b.filter(i=>i!==P&&i!==`-${P}`),m&&b.push(P.toLowerCase()),this.configurationService.updateValue("settingsSync.ignoredExtensions",b.length?b:void 0,1)}updateSynchronizedExtensions(P,m){let b=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(i=>i.toLowerCase());return b=b.filter(i=>i!==P&&i!==`-${P}`),m&&b.push(`-${P.toLowerCase()}`),this.configurationService.updateValue("settingsSync.ignoredExtensions",b.length?b:void 0,1)}getIgnoredExtensions(P){const m=P.filter(f=>f.isMachineScoped).map(f=>f.identifier.id.toLowerCase()),b=this.getConfiguredIgnoredExtensions().map(f=>f.toLowerCase()),i=[],C=[];if(Array.isArray(b))for(const f of b)f.startsWith("-")?C.push(f.substring(1)):i.push(f);return(0,D.distinct)([...m,...i].filter(f=>C.indexOf(f)===-1))}getConfiguredIgnoredExtensions(){let P=this.configurationService.inspect("settingsSync.ignoredExtensions").userValue;return P!==void 0||(P=this.configurationService.inspect("sync.ignoredExtensions").userValue,P!==void 0)?P:(this.configurationService.getValue("settingsSync.ignoredExtensions")||[]).map(m=>m.toLowerCase())}};L=de([X(0,T.IConfigurationService)],L),e.IgnoredExtensionsManagementService=L}),define(Z[197],ee([0,1,16,34,26,149,54]),function(K,e,D,T,R,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=e.parseKeybindings=void 0;function P(o){return(0,T.parse)(o)||[]}e.parseKeybindings=P;async function m(o,a,t,s,n){const r=P(o),c=P(a),l=t?P(t):null,h=[...r,...c,...l||[]].map(j=>j.key),d=await n.resolveUserBindings(h);let v=i(r,c,l,d);if(!v.hasLocalForwarded&&!v.hasRemoteForwarded)return{mergeContent:o,hasChanges:!1,hasConflicts:!1};if(!v.hasLocalForwarded&&v.hasRemoteForwarded)return{mergeContent:a,hasChanges:!0,hasConflicts:!1};if(v.hasLocalForwarded&&!v.hasRemoteForwarded)return{mergeContent:o,hasChanges:!0,hasConflicts:!1};const A=f(r),O=f(c),p=l?f(l):null,U=u(A,O,d),F=p?u(p,A,d):{added:[...A.keys()].reduce((j,q)=>(j.add(q),j),new Set),removed:new Set,updated:new Set},$=p?u(p,O,d):{added:[...O.keys()].reduce((j,q)=>(j.add(q),j),new Set),removed:new Set,updated:new Set},H=b(U,F,$);let M=o;for(const j of H.removed.values())H.conflicts.has(j)||(M=y(M,j,s));for(const j of H.added.values()){if(H.conflicts.has(j))continue;const q=O.get(j);if(q.some(z=>z.command!==`-${j}`&&v.conflicts.has(d[z.key]))){H.conflicts.add(j);continue}M=E(M,q,s)}for(const j of H.updated.values()){if(H.conflicts.has(j))continue;const q=O.get(j);if(q.some(z=>z.command!==`-${j}`&&v.conflicts.has(d[z.key]))){H.conflicts.add(j);continue}M=S(M,j,q,s)}return{mergeContent:M,hasChanges:!0,hasConflicts:H.conflicts.size>0}}e.merge=m;function b(o,a,t){const s=new Set,n=new Set,r=new Set,c=new Set;for(const l of a.removed.values())t.updated.has(l)&&c.add(l);for(const l of t.removed.values())c.has(l)||(a.updated.has(l)?c.add(l):n.add(l));for(const l of a.added.values())c.has(l)||t.added.has(l)&&o.updated.has(l)&&c.add(l);for(const l of t.added.values())c.has(l)||(a.added.has(l)?o.updated.has(l)&&c.add(l):s.add(l));for(const l of a.updated.values())c.has(l)||t.updated.has(l)&&o.updated.has(l)&&c.add(l);for(const l of t.updated.values())c.has(l)||(a.updated.has(l)?o.updated.has(l)&&c.add(l):r.add(l));return{added:s,removed:n,updated:r,conflicts:c}}function i(o,a,t,s){const n=new Set,r=C(o,s),c=C(a,s),l=t?C(t,s):null,h=I(r,c);if(h.added.size===0&&h.removed.size===0&&h.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const d=l?I(l,r):{added:[...r.keys()].reduce((F,$)=>(F.add($),F),new Set),removed:new Set,updated:new Set};if(d.added.size===0&&d.removed.size===0&&d.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:n,removed:n,updated:n,conflicts:n};const v=l?I(l,c):{added:[...c.keys()].reduce((F,$)=>(F.add($),F),new Set),removed:new Set,updated:new Set};if(v.added.size===0&&v.removed.size===0&&v.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const{added:A,removed:O,updated:p,conflicts:U}=b(h,d,v);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:A,removed:O,updated:p,conflicts:U}}function C(o,a){const t=new Map;for(const s of o){const n=a[s.key];let r=t.get(n);r||(r=[],t.set(n,r)),r.push(s)}return t}function f(o){const a=new Map;for(const t of o){const s=t.command[0]==="-"?t.command.substring(1):t.command;let n=a.get(s);n||(n=[],a.set(s,n)),n.push(t)}return a}function I(o,a){const t=[...o.keys()],s=[...a.keys()],n=s.filter(l=>t.indexOf(l)===-1).reduce((l,h)=>(l.add(h),l),new Set),r=t.filter(l=>s.indexOf(l)===-1).reduce((l,h)=>(l.add(h),l),new Set),c=new Set;for(const l of t){if(r.has(l))continue;const h=o.get(l).map(v=>({...v,key:l})),d=a.get(l).map(v=>({...v,key:l}));(0,D.equals)(h,d,(v,A)=>g(v,A))||c.add(l)}return{added:n,removed:r,updated:c}}function u(o,a,t){const s=[...o.keys()],n=[...a.keys()],r=n.filter(h=>s.indexOf(h)===-1).reduce((h,d)=>(h.add(d),h),new Set),c=s.filter(h=>n.indexOf(h)===-1).reduce((h,d)=>(h.add(d),h),new Set),l=new Set;for(const h of s){if(c.has(h))continue;const d=o.get(h).map(A=>({...A,key:t[A.key]})),v=a.get(h).map(A=>({...A,key:t[A.key]}));w(d,v)||l.add(h)}return{added:r,removed:c,updated:l}}function w(o,a){return!(!(0,D.equals)(o.filter(({command:t})=>t[0]!=="-"),a.filter(({command:t})=>t[0]!=="-"),(t,s)=>g(t,s))||!(0,D.equals)(o.filter(({command:t})=>t[0]==="-"),a.filter(({command:t})=>t[0]==="-"),(t,s)=>g(t,s)))}function g(o,a){if(o.command!==a.command||o.key!==a.key)return!1;const t=L.ContextKeyExpr.deserialize(o.when),s=L.ContextKeyExpr.deserialize(a.when);return!(t&&!s||!t&&s||t&&s&&!t.equals(s)||!R.equals(o.args,a.args))}function E(o,a,t){for(const s of a)o=k.edit(o,[-1],s,t);return o}function y(o,a,t){const s=P(o);for(let n=s.length-1;n>=0;n--)(s[n].command===a||s[n].command===`-${a}`)&&(o=k.edit(o,[n],void 0,t));return o}function S(o,a,t,s){const n=P(o),r=n.findIndex(c=>c.command===a||c.command===`-${a}`);for(let c=n.length-1;c>=0;c--)(n[c].command===a||n[c].command===`-${a}`)&&(o=k.edit(o,[c],void 0,s));for(let c=t.length-1;c>=0;c--)o=k.edit(o,[r],t[c],s);return o}}),define(Z[198],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.areSame=e.merge=void 0;function D(L,k,P){const m={},b={},i=new Set;if(!k)return{local:{added:m,updated:b,removed:[...i.values()]},remote:{added:L,updated:{},removed:[]},conflicts:[]};const C=T(L,k);if(C.added.size===0&&C.removed.size===0&&C.updated.size===0)return{local:{added:m,updated:b,removed:[...i.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const f=T(P,L),I=T(P,k),u={},w={},g=new Set,E=new Set;for(const y of f.removed.values())I.updated.has(y)?m[y]=k[y]:g.add(y);for(const y of I.removed.values())E.has(y)||(f.updated.has(y)?E.add(y):i.add(y));for(const y of f.updated.values())E.has(y)||(I.updated.has(y)?C.updated.has(y)&&E.add(y):w[y]=L[y]);for(const y of I.updated.values())E.has(y)||(f.updated.has(y)?C.updated.has(y)&&E.add(y):L[y]!==void 0&&(b[y]=k[y]));for(const y of f.added.values())E.has(y)||(I.added.has(y)?C.updated.has(y)&&E.add(y):u[y]=L[y]);for(const y of I.added.values())E.has(y)||(f.added.has(y)?C.updated.has(y)&&E.add(y):m[y]=k[y]);return{local:{added:m,removed:[...i.values()],updated:b},remote:{added:u,removed:[...g.values()],updated:w},conflicts:[...E.values()]}}e.merge=D;function T(L,k){const P=L?Object.keys(L):[],m=k?Object.keys(k):[],b=m.filter(f=>P.indexOf(f)===-1).reduce((f,I)=>(f.add(I),f),new Set),i=P.filter(f=>m.indexOf(f)===-1).reduce((f,I)=>(f.add(I),f),new Set),C=new Set;for(const f of P){if(i.has(f))continue;const I=L[f],u=k[f];I!==u&&C.add(f)}return{added:b,removed:i,updated:C}}function R(L,k){const{added:P,removed:m,updated:b}=T(L,k);return P.size===0&&m.size===0&&b.size===0}e.areSame=R}),define(Z[23],ee([0,1,16,15,17,132,38,28,7,81,33]),function(K,e,D,T,R,L,k,P,m,b,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSyncResourceFromLocalPreview=e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataAutoSyncEnablementService=e.IUserDataSyncService=e.IUserDataSyncResourceEnablementService=e.getEnablementKey=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.createSyncHeaders=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncBackupStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.getLastSyncResourceUri=e.ALL_SYNC_RESOURCES=e.SyncResource=e.isAuthenticationProvider=e.registerConfiguration=e.getDefaultIgnoredSettings=e.getDisallowedIgnoredSettings=e.CONFIGURATION_SYNC_STORE_KEY=void 0,e.CONFIGURATION_SYNC_STORE_KEY="configurationSync.store";function C(){const l=i.Registry.as(k.Extensions.Configuration).getConfigurationProperties();return Object.keys(l).filter(h=>!!l[h].disallowSyncIgnore)}e.getDisallowedIgnoredSettings=C;function f(){const l=i.Registry.as(k.Extensions.Configuration).getConfigurationProperties(),h=Object.keys(l).filter(A=>!!l[A].ignoreSync),d=Object.keys(l).filter(A=>l[A].scope===2||l[A].scope===6),v=C();return(0,D.distinct)([e.CONFIGURATION_SYNC_STORE_KEY,...h,...d,...v])}e.getDefaultIgnoredSettings=f;function I(){const l="vscode://schemas/ignoredSettings",h=i.Registry.as(k.Extensions.Configuration);h.registerConfiguration({id:"settingsSync",order:30,title:(0,L.localize)(0,null),type:"object",properties:{"settingsSync.keybindingsPerPlatform":{type:"boolean",description:(0,L.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,L.localize)(2,null),items:[{type:"string",pattern:P.EXTENSION_IDENTIFIER_PATTERN,errorMessage:(0,L.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,L.localize)(4,null),default:[],scope:1,$ref:l,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const d=i.Registry.as(b.Extensions.JSONContribution),v=()=>{const A=C(),O=f().filter($=>$!==e.CONFIGURATION_SYNC_STORE_KEY),p=Object.keys(k.allSettings.properties).filter($=>O.indexOf($)===-1),U=O.filter($=>A.indexOf($)===-1),F={items:{type:"string",enum:[...p,...U.map($=>`-${$}`)]}};d.registerSchema(l,F)};return h.onDidUpdateConfiguration(()=>v())}e.registerConfiguration=I;function u(l){return l&&(0,R.isObject)(l)&&(0,R.isString)(l.id)&&(0,R.isArray)(l.scopes)}e.isAuthenticationProvider=u;var w;(function(l){l.Settings="settings",l.Keybindings="keybindings",l.Snippets="snippets",l.Extensions="extensions",l.GlobalState="globalState"})(w=e.SyncResource||(e.SyncResource={})),e.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","extensions","globalState"];function g(l,h,d){return d.joinPath(h.userDataSyncHome,l,`lastSync${l}.json`)}e.getLastSyncResourceUri=g,e.IUserDataSyncStoreManagementService=(0,m.createDecorator)("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=(0,m.createDecorator)("IUserDataSyncStoreService"),e.IUserDataSyncBackupStoreService=(0,m.createDecorator)("IUserDataSyncBackupStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function E(l){const h={};return h[e.HEADER_EXECUTION_ID]=l,h}e.createSyncHeaders=E;var y;(function(l){l.Unauthorized="Unauthorized",l.Conflict="Conflict",l.Gone="Gone",l.PreconditionFailed="PreconditionFailed",l.TooLarge="TooLarge",l.UpgradeRequired="UpgradeRequired",l.PreconditionRequired="PreconditionRequired",l.TooManyRequests="RemoteTooManyRequests",l.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",l.RequestFailed="RequestFailed",l.RequestCanceled="RequestCanceled",l.RequestTimeout="RequestTimeout",l.RequestProtocolNotSupported="RequestProtocolNotSupported",l.RequestPathNotEscaped="RequestPathNotEscaped",l.RequestHeadersNotObject="RequestHeadersNotObject",l.NoRef="NoRef",l.EmptyResponse="EmptyResponse",l.TurnedOff="TurnedOff",l.SessionExpired="SessionExpired",l.ServiceChanged="ServiceChanged",l.DefaultServiceChanged="DefaultServiceChanged",l.LocalTooManyRequests="LocalTooManyRequests",l.LocalPreconditionFailed="LocalPreconditionFailed",l.LocalInvalidContent="LocalInvalidContent",l.LocalError="LocalError",l.IncompatibleLocalContent="IncompatibleLocalContent",l.IncompatibleRemoteContent="IncompatibleRemoteContent",l.UnresolvedConflicts="UnresolvedConflicts",l.Unknown="Unknown"})(y=e.UserDataSyncErrorCode||(e.UserDataSyncErrorCode={}));class S extends Error{constructor(h,d,v,A){super(h);this.code=d,this.resource=v,this.operationId=A,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=S;class o extends S{constructor(h,d,v,A,O){super(h,v,void 0,O);this.url=d,this.serverCode=A}}e.UserDataSyncStoreError=o;class a extends S{constructor(h,d){super(h,d)}}e.UserDataAutoSyncError=a,function(l){function h(d){if(d instanceof l)return d;const v=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(d.name);if(v&&v[1]){const A=v[2]==="unknown"?void 0:v[2],O=v[3]==="unknown"?void 0:v[3];return new l(d.message,v[1],A,O)}return new l(d.message,"Unknown")}l.toUserDataSyncError=h}(S=e.UserDataSyncError||(e.UserDataSyncError={}));var t;(function(l){l.Uninitialized="uninitialized",l.Idle="idle",l.Syncing="syncing",l.HasConflicts="hasConflicts"})(t=e.SyncStatus||(e.SyncStatus={}));var s;(function(l){l[l.None=0]="None",l[l.Added=1]="Added",l[l.Modified=2]="Modified",l[l.Deleted=3]="Deleted"})(s=e.Change||(e.Change={}));var n;(function(l){l.Preview="preview",l.Conflict="conflict",l.Accepted="accepted"})(n=e.MergeState||(e.MergeState={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function r(l){return`sync.enable.${l}`}e.getEnablementKey=r,e.IUserDataSyncResourceEnablementService=(0,m.createDecorator)("IUserDataSyncResourceEnablementService"),e.IUserDataSyncService=(0,m.createDecorator)("IUserDataSyncService"),e.IUserDataAutoSyncEnablementService=(0,m.createDecorator)("IUserDataAutoSyncEnablementService"),e.IUserDataAutoSyncService=(0,m.createDecorator)("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=(0,m.createDecorator)("IUserDataSyncUtilService"),e.IUserDataSyncLogService=(0,m.createDecorator)("IUserDataSyncLogService"),e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview";function c(l,h){if(l.scheme!==e.USER_DATA_SYNC_SCHEME)return l=l.with({scheme:h.userDataSyncHome.scheme}),e.ALL_SYNC_RESOURCES.filter(d=>(0,T.isEqualOrParent)(l,(0,T.joinPath)(h.userDataSyncHome,d,e.PREVIEW_DIR_NAME)))[0]}e.getSyncResourceFromLocalPreview=c}),define(Z[47],ee([0,1,16,6,25,27,3,34,2,15,24,17,5,128,21,12,13,46,22,20,23]),function(K,e,D,T,R,L,k,P,m,b,i,C,f,I,u,w,g,E,y,S,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=e.isSyncData=void 0;function a(c){return!!(c&&c.version!==void 0&&typeof c.version=="number"&&c.content!==void 0&&typeof c.content=="string"&&(Object.keys(c).length===2||Object.keys(c).length===3&&c.machineId!==void 0&&typeof c.machineId=="string"))}e.isSyncData=a;let t=class extends m.Disposable{constructor(l,h,d,v,A,O,p,U,F,$){super();this.resource=l,this.fileService=h,this.environmentService=d,this.userDataSyncStoreService=A,this.userDataSyncBackupStoreService=O,this.userDataSyncResourceEnablementService=p,this.telemetryService=U,this.logService=F,this.configurationService=$,this.syncPreviewPromise=null,this._status="idle",this._onDidChangStatus=this._register(new k.Emitter),this.onDidChangeStatus=this._onDidChangStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new k.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this.localChangeTriggerScheduler=new T.RunOnceScheduler(()=>this.doTriggerLocalChange(),50),this._onDidChangeLocal=this._register(new k.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this.hasSyncResourceStateVersionChanged=!1,this.syncHeaders={},this.syncResourceLogLabel=(0,i.uppercaseFirstLetter)(this.resource),this.extUri=this.fileService.hasCapability(d.userDataSyncHome,1024)?b.extUri:b.extUriIgnorePathCase,this.syncFolder=this.extUri.joinPath(d.userDataSyncHome,l),this.syncPreviewFolder=this.extUri.joinPath(this.syncFolder,o.PREVIEW_DIR_NAME),this.lastSyncResource=(0,o.getLastSyncResourceUri)(l,d,this.extUri),this.currentMachineIdPromise=(0,E.getServiceMachineId)(d,h,v)}get status(){return this._status}get conflicts(){return this._conflicts}isEnabled(){return this.userDataSyncResourceEnablementService.isResourceEnabled(this.resource)}async triggerLocalChange(){this.isEnabled()&&this.localChangeTriggerScheduler.schedule()}async doTriggerLocalChange(){if(this.status==="hasConflicts"){this.logService.info(`${this.syncResourceLogLabel}: In conflicts state and local change detected. Syncing again...`);const l=await this.syncPreviewPromise;this.syncPreviewPromise=null;const h=await this.performSync(l.remoteUserData,l.lastSyncUserData,!0);this.setStatus(h)}else{this.logService.trace(`${this.syncResourceLogLabel}: Checking for local changes...`);const l=await this.getLastSyncUserData();(l?(await this.doGenerateSyncResourcePreview(l,l,!0,L.CancellationToken.None)).resourcePreviews.some(({remoteChange:d})=>d!==0):!0)&&this._onDidChangeLocal.fire()}}setStatus(l){if(this._status!==l){const h=this._status;l==="hasConflicts"&&this.telemetryService.publicLog2("sync/conflictsDetected",{source:this.resource}),h==="hasConflicts"&&l==="idle"&&this.telemetryService.publicLog2("sync/conflictsResolved",{source:this.resource}),this._status=l,this._onDidChangStatus.fire(l)}}async sync(l,h={}){await this._sync(l,!0,h)}async preview(l,h={}){return this._sync(l,!1,h)}async apply(l,h={}){try{this.syncHeaders={...h};const d=await this.doApply(l);return this.setStatus(d),this.syncPreviewPromise}finally{this.syncHeaders={}}}async _sync(l,h,d){try{if(this.syncHeaders={...d},!this.isEnabled())return this.status!=="idle"&&await this.stop(),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is disabled.`),null;if(this.status==="hasConflicts")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.syncPreviewPromise;if(this.status==="syncing")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.syncPreviewPromise;this.logService.trace(`${this.syncResourceLogLabel}: Started synchronizing ${this.resource.toLowerCase()}...`),this.setStatus("syncing");let v="idle";try{const A=await this.getLastSyncUserData(),O=await this.getLatestRemoteUserData(l,A);return v=await this.performSync(O,A,h),v==="hasConflicts"?this.logService.info(`${this.syncResourceLogLabel}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):v==="idle"&&this.logService.trace(`${this.syncResourceLogLabel}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise||null}finally{this.setStatus(v)}}finally{this.syncHeaders={}}}async replace(l){const h=await this.resolveContent(l);if(!h)return!1;const d=this.parseSyncData(h);if(!d)return!1;await this.stop();try{this.logService.trace(`${this.syncResourceLogLabel}: Started resetting ${this.resource.toLowerCase()}...`),this.setStatus("syncing");const v=await this.getLastSyncUserData(),A=await this.getLatestRemoteUserData(null,v),O=await this.isRemoteDataFromCurrentMachine(A),p=await this.generateSyncPreview({ref:A.ref,syncData:d},v,O,L.CancellationToken.None),U=[];for(const F of p){const $=await this.getAcceptResult(F,F.remoteResource,void 0,L.CancellationToken.None),{remoteChange:H}=await this.getAcceptResult(F,F.previewResource,F.remoteContent,L.CancellationToken.None);U.push([F,{...$,remoteChange:H!==0?H:2}])}await this.applyResult(A,v,U,!1),this.logService.info(`${this.syncResourceLogLabel}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.setStatus("idle")}return!0}async isRemoteDataFromCurrentMachine(l){const h=await this.currentMachineIdPromise;return!!l.syncData?.machineId&&l.syncData.machineId===h}async getLatestRemoteUserData(l,h){if(h){const d=l&&l.latest?l.latest[this.resource]:void 0;if(h.ref===d||d===void 0&&h.syncData===null)return h}return this.getRemoteUserData(h)}async performSync(l,h,d){if(l.syncData&&l.syncData.version>this.version)throw this.telemetryService.publicLog2("sync/incompatible",{source:this.resource}),new o.UserDataSyncError((0,I.localize)(0,null,this.resource,this.version,l.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.doSync(l,h,d)}catch(v){if(v instanceof o.UserDataSyncError)switch(v.code){case"LocalPreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize ${this.syncResourceLogLabel} as there is a new local version available. Synchronizing again...`),this.performSync(l,h,d);case"Conflict":case"PreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),l=await this.getRemoteUserData(null),h=await this.getLastSyncUserData(),this.performSync(l,h,d)}throw v}}async doSync(l,h,d){try{this.syncPreviewPromise||(this.syncPreviewPromise=(0,T.createCancelablePromise)(A=>this.doGenerateSyncResourcePreview(l,h,d,A)));const v=await this.syncPreviewPromise;return this.updateConflicts(v.resourcePreviews),v.resourcePreviews.some(({mergeState:A})=>A==="conflict")?"hasConflicts":d?await this.doApply(!1):"syncing"}catch(v){throw this.syncPreviewPromise=null,v}}async merge(l){return await this.updateSyncResourcePreview(l,async h=>{const d=await this.getMergeResult(h,L.CancellationToken.None);await this.fileService.writeFile(h.previewResource,R.VSBuffer.fromString(d?.content||""));const v=d&&!d.hasConflicts?await this.getAcceptResult(h,h.previewResource,void 0,L.CancellationToken.None):void 0;return h.acceptResult=v,h.mergeState=d.hasConflicts?"conflict":v?"accepted":"preview",h.localChange=v?v.localChange:d.localChange,h.remoteChange=v?v.remoteChange:d.remoteChange,h}),this.syncPreviewPromise}async accept(l,h){return await this.updateSyncResourcePreview(l,async d=>{const v=await this.getAcceptResult(d,l,h,L.CancellationToken.None);return d.acceptResult=v,d.mergeState="accepted",d.localChange=v.localChange,d.remoteChange=v.remoteChange,d}),this.syncPreviewPromise}async discard(l){return await this.updateSyncResourcePreview(l,async h=>{const d=await this.getMergeResult(h,L.CancellationToken.None);return await this.fileService.writeFile(h.previewResource,R.VSBuffer.fromString(d.content||"")),h.acceptResult=void 0,h.mergeState="preview",h.localChange=d.localChange,h.remoteChange=d.remoteChange,h}),this.syncPreviewPromise}async updateSyncResourcePreview(l,h){if(!this.syncPreviewPromise)return;let d=await this.syncPreviewPromise;const v=d.resourcePreviews.findIndex(({localResource:A,remoteResource:O,previewResource:p})=>this.extUri.isEqual(A,l)||this.extUri.isEqual(O,l)||this.extUri.isEqual(p,l));v!==-1&&(this.syncPreviewPromise=(0,T.createCancelablePromise)(async A=>{const O=[...d.resourcePreviews];return O[v]=await h(O[v]),{...d,resourcePreviews:O}}),d=await this.syncPreviewPromise,this.updateConflicts(d.resourcePreviews),d.resourcePreviews.some(({mergeState:A})=>A==="conflict")?this.setStatus("hasConflicts"):this.setStatus("syncing"))}async doApply(l){if(!this.syncPreviewPromise)return"idle";const h=await this.syncPreviewPromise;return h.resourcePreviews.some(({mergeState:d})=>d==="conflict")?"hasConflicts":h.resourcePreviews.some(({mergeState:d})=>d!=="accepted")?"syncing":(await this.applyResult(h.remoteUserData,h.lastSyncUserData,h.resourcePreviews.map(d=>[d,d.acceptResult]),l),this.syncPreviewPromise=null,await this.clearPreviewFolder(),"idle")}async clearPreviewFolder(){try{await this.fileService.del(this.syncPreviewFolder,{recursive:!0})}catch(l){}}updateConflicts(l){const h=l.filter(({mergeState:d})=>d==="conflict");(0,D.equals)(this._conflicts,h,(d,v)=>this.extUri.isEqual(d.previewResource,v.previewResource))||(this._conflicts=h,this._onDidChangeConflicts.fire(h))}async hasPreviouslySynced(){return!!await this.getLastSyncUserData()}async getRemoteSyncResourceHandles(){return(await this.userDataSyncStoreService.getAllRefs(this.resource)).map(({created:h,ref:d})=>({created:h,uri:this.toRemoteBackupResource(d)}))}async getLocalSyncResourceHandles(){return(await this.userDataSyncBackupStoreService.getAllRefs(this.resource)).map(({created:h,ref:d})=>({created:h,uri:this.toLocalBackupResource(d)}))}toRemoteBackupResource(l){return f.URI.from({scheme:o.USER_DATA_SYNC_SCHEME,authority:"remote-backup",path:`/${this.resource}/${l}`})}toLocalBackupResource(l){return f.URI.from({scheme:o.USER_DATA_SYNC_SCHEME,authority:"local-backup",path:`/${this.resource}/${l}`})}async getMachineId({uri:l}){const h=this.extUri.basename(l);if(this.extUri.isEqual(l,this.toRemoteBackupResource(h))){const{content:d}=await this.getUserData(h);if(d)return this.parseSyncData(d)?.machineId}}async resolveContent(l){const h=this.extUri.basename(l);if(this.extUri.isEqual(l,this.toRemoteBackupResource(h))){const{content:d}=await this.getUserData(h);return d}return this.extUri.isEqual(l,this.toLocalBackupResource(h))?this.userDataSyncBackupStoreService.resolveContent(this.resource,h):null}async resolvePreviewContent(l){const h=this.syncPreviewPromise?await this.syncPreviewPromise:null;if(h)for(const d of h.resourcePreviews){if(this.extUri.isEqual(d.acceptedResource,l))return d.acceptResult?d.acceptResult.content:null;if(this.extUri.isEqual(d.remoteResource,l))return d.remoteContent;if(this.extUri.isEqual(d.localResource,l))return d.localContent}return null}async resetLocal(){try{await this.fileService.del(this.lastSyncResource)}catch(l){}}async doGenerateSyncResourcePreview(l,h,d,v){const A=await this.isRemoteDataFromCurrentMachine(l),O=await this.generateSyncPreview(l,h,A,v),p=[];for(const U of O){const F=U.previewResource.with({scheme:o.USER_DATA_SYNC_SCHEME,authority:"accepted"});if(U.localChange===0&&U.remoteChange===0)p.push({...U,acceptedResource:F,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const $=d?await this.getMergeResult(U,v):void 0;if(v.isCancellationRequested)break;await this.fileService.writeFile(U.previewResource,R.VSBuffer.fromString($?.content||""));const H=$&&!$.hasConflicts?await this.getAcceptResult(U,U.previewResource,void 0,v):void 0;p.push({...U,acceptResult:H,mergeState:$?.hasConflicts?"conflict":H?"accepted":"preview",localChange:H?H.localChange:$?$.localChange:U.localChange,remoteChange:H?H.remoteChange:$?$.remoteChange:U.remoteChange})}}return{remoteUserData:l,lastSyncUserData:h,resourcePreviews:p,isLastSyncFromCurrentMachine:A}}async getLastSyncUserData(){try{const l=await this.fileService.readFile(this.lastSyncResource),h=JSON.parse(l.value.toString()),d=this.userDataSyncResourceEnablementService.getResourceSyncStateVersion(this.resource);if(this.hasSyncResourceStateVersionChanged=h.version&&d&&h.version!==d,this.hasSyncResourceStateVersionChanged)return this.logService.info(`${this.syncResourceLogLabel}: Reset last sync state because last sync state version ${h.version} is not compatible with current sync state version ${d}.`),await this.resetLocal(),null;const v=h;if(v.content===null)return{ref:h.ref,syncData:null};const A=JSON.parse(v.content);if(a(A))return{...h,syncData:A,content:void 0}}catch(l){l instanceof g.FileOperationError&&l.fileOperationResult===1||this.logService.error(l)}return null}async updateLastSyncUserData(l,h={}){if(h.ref||h.content||h.version)throw new Error("Cannot have core properties as additional");const d=this.userDataSyncResourceEnablementService.getResourceSyncStateVersion(this.resource),v={ref:l.ref,content:l.syncData?JSON.stringify(l.syncData):null,version:d,...h};await this.fileService.writeFile(this.lastSyncResource,R.VSBuffer.fromString(JSON.stringify(v)))}async getRemoteUserData(l){const{ref:h,content:d}=await this.getUserData(l);let v=null;return d!==null&&(v=this.parseSyncData(d)),{ref:h,syncData:v}}parseSyncData(l){try{const h=JSON.parse(l);if(a(h))return h}catch(h){this.logService.error(h)}throw new o.UserDataSyncError((0,I.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async getUserData(l){if((0,C.isString)(l)){const h=await this.userDataSyncStoreService.resolveContent(this.resource,l);return{ref:l,content:h}}else{const h=l?{ref:l.ref,content:l.syncData?JSON.stringify(l.syncData):null}:null;return this.userDataSyncStoreService.read(this.resource,h,this.syncHeaders)}}async updateRemoteUserData(l,h){const d=await this.currentMachineIdPromise,v={version:this.version,machineId:d,content:l};return h=await this.userDataSyncStoreService.write(this.resource,JSON.stringify(v),h,this.syncHeaders),{ref:h,syncData:v}}async backupLocal(l){const h={version:this.version,content:l};return this.userDataSyncBackupStoreService.backup(this.resource,JSON.stringify(h))}async stop(){this.status!=="idle"&&(this.logService.trace(`${this.syncResourceLogLabel}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise&&(this.syncPreviewPromise.cancel(),this.syncPreviewPromise=null),this.updateConflicts([]),await this.clearPreviewFolder(),this.setStatus("idle"),this.logService.info(`${this.syncResourceLogLabel}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}};t=de([X(1,g.IFileService),X(2,w.IEnvironmentService),X(3,y.IStorageService),X(4,o.IUserDataSyncStoreService),X(5,o.IUserDataSyncBackupStoreService),X(6,o.IUserDataSyncResourceEnablementService),X(7,S.ITelemetryService),X(8,o.IUserDataSyncLogService),X(9,u.IConfigurationService)],t),e.AbstractSynchroniser=t;let s=class extends t{constructor(l,h,d,v,A,O,p,U,F,$,H){super(h,d,v,A,O,p,U,F,$,H);this.file=l,this._register(this.fileService.watch(this.extUri.dirname(l))),this._register(this.fileService.onDidFilesChange(M=>this.onFileChanges(M)))}async getLocalFileContent(){try{return await this.fileService.readFile(this.file)}catch(l){return null}}async updateLocalFileContent(l,h,d){try{h?await this.fileService.writeFile(this.file,R.VSBuffer.fromString(l),d?void 0:h):await this.fileService.createFile(this.file,R.VSBuffer.fromString(l),{overwrite:d})}catch(v){throw v instanceof g.FileOperationError&&v.fileOperationResult===1||v instanceof g.FileOperationError&&v.fileOperationResult===3?new o.UserDataSyncError(v.message,"LocalPreconditionFailed"):v}}onFileChanges(l){!l.contains(this.file)||this.triggerLocalChange()}};s=de([X(2,g.IFileService),X(3,w.IEnvironmentService),X(4,y.IStorageService),X(5,o.IUserDataSyncStoreService),X(6,o.IUserDataSyncBackupStoreService),X(7,o.IUserDataSyncResourceEnablementService),X(8,S.ITelemetryService),X(9,o.IUserDataSyncLogService),X(10,u.IConfigurationService)],s),e.AbstractFileSynchroniser=s;let n=class extends s{constructor(l,h,d,v,A,O,p,U,F,$,H,M){super(l,h,d,v,A,O,p,U,F,$,M);this.userDataSyncUtilService=H,this._formattingOptions=void 0}hasErrors(l){const h=[];return(0,P.parse)(l,h,{allowEmptyContent:!0,allowTrailingComma:!0}),h.length>0}getFormattingOptions(){return this._formattingOptions||(this._formattingOptions=this.userDataSyncUtilService.resolveFormattingOptions(this.file)),this._formattingOptions}};n=de([X(2,g.IFileService),X(3,w.IEnvironmentService),X(4,y.IStorageService),X(5,o.IUserDataSyncStoreService),X(6,o.IUserDataSyncBackupStoreService),X(7,o.IUserDataSyncResourceEnablementService),X(8,S.ITelemetryService),X(9,o.IUserDataSyncLogService),X(10,o.IUserDataSyncUtilService),X(11,u.IConfigurationService)],n),e.AbstractJsonFileSynchroniser=n;let r=class{constructor(l,h,d,v){this.resource=l,this.environmentService=h,this.logService=d,this.fileService=v,this.extUri=this.fileService.hasCapability(h.userDataSyncHome,1024)?b.extUri:b.extUriIgnorePathCase,this.lastSyncResource=(0,o.getLastSyncResourceUri)(this.resource,h,b.extUri)}async initialize({ref:l,content:h}){if(!h){this.logService.info("Remote content does not exist.",this.resource);return}const d=this.parseSyncData(h);if(!d)return;if(await this.fileService.exists(this.lastSyncResource)){this.logService.info("Remote content does not exist.",this.resource);return}try{await this.doInitialize({ref:l,syncData:d})}catch(A){this.logService.error(A)}}parseSyncData(l){try{const h=JSON.parse(l);if(a(h))return h}catch(h){this.logService.error(h)}this.logService.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async updateLastSyncUserData(l,h={}){const d={ref:l.ref,content:l.syncData?JSON.stringify(l.syncData):null,...h};await this.fileService.writeFile(this.lastSyncResource,R.VSBuffer.fromString(JSON.stringify(d)))}};r=de([X(1,w.IEnvironmentService),X(2,o.IUserDataSyncLogService),X(3,g.IFileService)],r),e.AbstractInitializer=r}),define(Z[199],ee([0,1,6,27,9,3,45,48,24,5,21,12,28,32,13,22,20,47,196,87,88,23]),function(K,e,D,T,R,L,k,P,m,b,i,C,f,I,u,w,g,E,y,S,o,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsInitializer=e.ExtensionsSynchroniser=e.storeExtensionStorageState=e.getExtensionStorageState=void 0;async function t(l,h){const d=JSON.parse(l.content);if(l.version===1||l.version===2){const v=(await h.getInstalled(0)).filter(A=>A.isBuiltin);for(const A of d)l.version===1&&(A.enabled===!1&&(A.disabled=!0),delete A.enabled),l.version===2&&v.every(O=>!(0,I.areSameExtensions)(O.identifier,A.identifier))&&(A.installed=!0)}return d}function s(l,h,d){const v=d.get((0,I.getExtensionId)(l,h),0)||"{}";return JSON.parse(v)}e.getExtensionStorageState=s;function n(l,h,d,v){v.store((0,I.getExtensionId)(l,h),JSON.stringify(d),0,1)}e.storeExtensionStorageState=n;let r=class at extends E.AbstractSynchroniser{constructor(h,d,v,A,O,p,U,F,$,H,M,j,q,z){super("extensions",d,h,v,A,O,j,q,$,M);this.storageService=v,this.extensionManagementService=p,this.extensionEnablementService=U,this.ignoredExtensionsManagementService=F,this.extensionGalleryService=H,this.extensionsStorageSyncService=z,this.version=5,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"extensions.json"),this.localResource=this.previewResource.with({scheme:a.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:a.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:a.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(L.Event.debounce(L.Event.any(L.Event.filter(this.extensionManagementService.onDidInstallExtensions,x=>x.some(({local:N})=>!!N)),L.Event.filter(this.extensionManagementService.onDidUninstallExtension,x=>!x.error),this.extensionEnablementService.onDidChangeEnablement,this.extensionsStorageSyncService.onDidChangeExtensionsStorage),()=>{},500)(()=>this.triggerLocalChange()))}isEnabled(){return super.isEnabled()&&this.extensionGalleryService.isEnabled()}async generateSyncPreview(h,d){const v=h.syncData?await t(h.syncData,this.extensionManagementService):null,A=d?.skippedExtensions||[],O=d?.syncData?await t(d.syncData,this.extensionManagementService):null,p=await this.extensionManagementService.getInstalled(),U=this.getLocalExtensions(p),F=this.ignoredExtensionsManagementService.getIgnoredExtensions(p);v?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote extensions with local extensions...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:$,remote:H}=(0,y.merge)(U,v,O,A,F),M={local:$,remote:H,content:this.getPreviewContent(U,$.added,$.updated,$.removed),localChange:$.added.length>0||$.removed.length>0||$.updated.length>0?2:0,remoteChange:H!==null?2:0};return[{skippedExtensions:A,localResource:this.localResource,localContent:this.format(U),localExtensions:U,remoteResource:this.remoteResource,remoteContent:v?this.format(v):null,previewResource:this.previewResource,previewResult:M,localChange:M.localChange,remoteChange:M.remoteChange,acceptedResource:this.acceptedResource}]}getPreviewContent(h,d,v,A){const O=[...d,...v],p=new Set,U=F=>{p.add(F.id.toLowerCase()),F.uuid&&p.add(F.uuid)};O.forEach(({identifier:F})=>U(F)),A.forEach(U);for(const F of h)p.has(F.identifier.id.toLowerCase())||F.identifier.uuid&&p.has(F.identifier.uuid)||O.push(F);return this.format(O)}async getMergeResult(h,d){return{...h.previewResult,hasConflicts:!1}}async getAcceptResult(h,d,v,A){if(this.extUri.isEqual(d,this.localResource))return this.acceptLocal(h);if(this.extUri.isEqual(d,this.remoteResource))return this.acceptRemote(h);if(this.extUri.isEqual(d,this.previewResource))return h.previewResult;throw new Error(`Invalid Resource: ${d.toString()}`)}async acceptLocal(h){const d=await this.extensionManagementService.getInstalled(),v=this.ignoredExtensionsManagementService.getIgnoredExtensions(d),A=(0,y.merge)(h.localExtensions,null,null,h.skippedExtensions,v),{local:O,remote:p}=A;return{content:h.localContent,local:O,remote:p,localChange:O.added.length>0||O.removed.length>0||O.updated.length>0?2:0,remoteChange:p!==null?2:0}}async acceptRemote(h){const d=await this.extensionManagementService.getInstalled(),v=this.ignoredExtensionsManagementService.getIgnoredExtensions(d),A=h.remoteContent?JSON.parse(h.remoteContent):null;if(A!==null){const O=(0,y.merge)(h.localExtensions,A,h.localExtensions,[],v),{local:p,remote:U}=O;return{content:h.remoteContent,local:p,remote:U,localChange:p.added.length>0||p.removed.length>0||p.updated.length>0?2:0,remoteChange:U!==null?2:0}}else return{content:h.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async applyResult(h,d,v,A){let{skippedExtensions:O,localExtensions:p}=v[0][0],{local:U,remote:F,localChange:$,remoteChange:H}=v[0][1];if($===0&&H===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing extensions.`),$!==0&&(await this.backupLocal(JSON.stringify(p)),O=await this.updateLocalExtensions(U.added,U.removed,U.updated,O)),F){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote extensions...`);const M=JSON.stringify(F.all);h=await this.updateRemoteUserData(M,A?null:h.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote extensions.${F.added.length?` Added: ${JSON.stringify(F.added.map(j=>j.identifier.id))}.`:""}${F.updated.length?` Updated: ${JSON.stringify(F.updated.map(j=>j.identifier.id))}.`:""}${F.removed.length?` Removed: ${JSON.stringify(F.removed.map(j=>j.identifier.id))}.`:""}`)}d?.ref!==h.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized extensions...`),await this.updateLastSyncUserData(h,{skippedExtensions:O}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized extensions.${O.length?` Skipped: ${JSON.stringify(O.map(M=>M.identifier.id))}.`:""}`))}async getAssociatedResources({uri:h}){return[{resource:this.extUri.joinPath(h,"extensions.json"),comparableResource:at.EXTENSIONS_DATA_URI}]}async resolveContent(h){if(this.extUri.isEqual(h,at.EXTENSIONS_DATA_URI)){const v=await this.extensionManagementService.getInstalled(),A=this.ignoredExtensionsManagementService.getIgnoredExtensions(v),O=this.getLocalExtensions(v).filter(p=>!A.some(U=>(0,I.areSameExtensions)({id:U},p.identifier)));return this.format(O)}if(this.extUri.isEqual(this.remoteResource,h)||this.extUri.isEqual(this.localResource,h)||this.extUri.isEqual(this.acceptedResource,h))return this.resolvePreviewContent(h);let d=await super.resolveContent(h);if(d)return d;if(d=await super.resolveContent(this.extUri.dirname(h)),d){const v=this.parseSyncData(d);if(v)switch(this.extUri.basename(h)){case"extensions.json":return this.format(this.parseExtensions(v))}}return null}format(h){h.sort((A,O)=>!A.identifier.uuid&&O.identifier.uuid?-1:A.identifier.uuid&&!O.identifier.uuid?1:(0,m.compare)(A.identifier.id,O.identifier.id));const d=JSON.stringify(h),v=(0,P.format)(d,void 0,{});return(0,k.applyEdits)(d,v)}async hasLocalData(){try{const h=await this.extensionManagementService.getInstalled();if(this.getLocalExtensions(h).some(v=>v.installed||v.disabled))return!0}catch(h){}return!1}async updateLocalExtensions(h,d,v,A){const O=[],p=[],U=await this.extensionManagementService.getInstalled();if(d.length){const $=U.filter(({identifier:H,isBuiltin:M})=>!M&&d.some(j=>(0,I.areSameExtensions)(H,j)));await D.Promises.settled($.map(async H=>{this.logService.trace(`${this.syncResourceLogLabel}: Uninstalling local extension...`,H.identifier.id),await this.extensionManagementService.uninstall(H,{donotIncludePack:!0,donotCheckDependents:!0}),this.logService.info(`${this.syncResourceLogLabel}: Uninstalled local extension.`,H.identifier.id),O.push(H.identifier)}))}(h.length||v.length)&&await D.Promises.settled([...h,...v].map(async $=>{const H=U.find(j=>(0,I.areSameExtensions)(j.identifier,$.identifier));if(H&&H.isBuiltin){$.state&&H.manifest.version===$.version&&this.updateExtensionState($.state,H.manifest.publisher,H.manifest.name,H.manifest.version),$.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,$.identifier.id),await this.extensionEnablementService.disableExtension($.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,$.identifier.id)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,$.identifier.id),await this.extensionEnablementService.enableExtension($.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,$.identifier.id)),O.push($.identifier);return}const M=(await this.extensionGalleryService.getExtensions([$.identifier],T.CancellationToken.None))[0];if($.state&&(H?H.manifest.version===$.version:!!M)){const j=H?H.manifest.publisher:M.publisher,q=H?H.manifest.name:M.name;this.updateExtensionState($.state,j,q,H?.manifest.version)}if(M)try{$.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,$.identifier.id,M.version),await this.extensionEnablementService.disableExtension(M.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,$.identifier.id,M.version)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,$.identifier.id,M.version),await this.extensionEnablementService.enableExtension(M.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,$.identifier.id,M.version)),H||(await this.extensionManagementService.canInstall(M)?(this.logService.trace(`${this.syncResourceLogLabel}: Installing extension...`,$.identifier.id,M.version),await this.extensionManagementService.installFromGallery(M,{isMachineScoped:!1,donotIncludePackAndDependencies:!0}),this.logService.info(`${this.syncResourceLogLabel}: Installed extension.`,$.identifier.id,M.version),O.push(M.identifier)):(this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because it cannot be installed.`,M.displayName||M.identifier.id),p.push($)))}catch(j){p.push($),j instanceof f.ExtensionManagementError&&j.code===f.INSTALL_ERROR_INCOMPATIBLE?this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the compatible extension is not found.`,M.displayName||M.identifier.id):(this.logService.error(j),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension`,M.displayName||M.identifier.id))}else p.push($),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the extension is not found.`,$.identifier.id)}));const F=[];for(const $ of A)O.some(H=>(0,I.areSameExtensions)(H,$.identifier))||F.push($);for(const $ of p)F.some(H=>(0,I.areSameExtensions)(H.identifier,$.identifier))||F.push($);return F}updateExtensionState(h,d,v,A){const O=s(d,v,this.storageService),p=A?this.extensionsStorageSyncService.getKeysForSync({id:(0,I.getGalleryExtensionId)(d,v),version:A}):void 0;p?p.forEach(U=>{O[U]=h[U]}):Object.keys(h).forEach(U=>O[U]=h[U]),n(d,v,O,this.storageService)}parseExtensions(h){return JSON.parse(h.content)}getLocalExtensions(h){const d=this.extensionEnablementService.getDisabledExtensions();return h.map(({identifier:v,isBuiltin:A,manifest:O})=>{const p={identifier:v,version:O.version};d.some(U=>(0,I.areSameExtensions)(U,v))&&(p.disabled=!0),A||(p.installed=!0);try{const U=this.extensionsStorageSyncService.getKeysForSync({id:v.id,version:O.version});if(U){const F=s(O.publisher,O.name,this.storageService);p.state=Object.keys(F).reduce(($,H)=>(U.includes(H)&&($[H]=F[H]),$),{})}}catch(U){this.logService.info(`${this.syncResourceLogLabel}: Error while parsing extension state`,(0,R.getErrorMessage)(U))}return p})}};r.EXTENSIONS_DATA_URI=b.URI.from({scheme:a.USER_DATA_SYNC_SCHEME,authority:"extensions",path:"/extensions.json"}),r=de([X(0,C.IEnvironmentService),X(1,u.IFileService),X(2,w.IStorageService),X(3,a.IUserDataSyncStoreService),X(4,a.IUserDataSyncBackupStoreService),X(5,f.IExtensionManagementService),X(6,f.IGlobalExtensionEnablementService),X(7,o.IIgnoredExtensionsManagementService),X(8,a.IUserDataSyncLogService),X(9,f.IExtensionGalleryService),X(10,i.IConfigurationService),X(11,a.IUserDataSyncResourceEnablementService),X(12,g.ITelemetryService),X(13,S.IExtensionsStorageSyncService)],r),e.ExtensionsSynchroniser=r;let c=class extends E.AbstractInitializer{constructor(h,d,v,A,O){super("extensions",A,O,v);this.extensionManagementService=h,this.ignoredExtensionsManagementService=d}async parseExtensions(h){return h.syncData?await t(h.syncData,this.extensionManagementService):null}generatePreview(h,d){const v=[],A=[],O=[];for(const p of h){if(this.ignoredExtensionsManagementService.hasToNeverSyncExtension(p.identifier.id))continue;const U=d.find(F=>(0,I.areSameExtensions)(F.identifier,p.identifier));U?(v.push(U),p.disabled&&O.push(p.identifier)):p.installed&&(A.push(p.identifier),p.disabled&&O.push(p.identifier))}return{installedExtensions:v,newExtensions:A,disabledExtensions:O,remoteExtensions:h}}};c=de([X(0,f.IExtensionManagementService),X(1,o.IIgnoredExtensionsManagementService),X(2,u.IFileService),X(3,C.IEnvironmentService),X(4,a.IUserDataSyncLogService)],c),e.AbstractExtensionsInitializer=c}),define(Z[200],ee([0,1,26,23]),function(K,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function R(P,m,b,i,C){if(!m)return{remote:Object.keys(P).length>0?P:null,local:{added:{},removed:[],updated:{}}};const f=L(P,m);if(f.added.size===0&&f.removed.size===0&&f.updated.size===0)return{remote:null,local:{added:{},removed:[],updated:{}}};const I=b?L(b,m):{added:Object.keys(m).reduce((y,S)=>(y.add(S),y),new Set),removed:new Set,updated:new Set},u=b?L(b,P):{added:Object.keys(P).reduce((y,S)=>(y.add(S),y),new Set),removed:new Set,updated:new Set},w={added:{},removed:[],updated:{}},g=D.deepClone(m),E=!b;for(const y of u.added.values())y!==T.SYNC_SERVICE_URL_TYPE&&E&&I.added.has(y)||(g[y]=P[y]);for(const y of u.updated.values())g[y]=P[y];for(const y of u.removed.values())i.unregistered.includes(y)||delete g[y];for(const y of I.added.values()){const S=m[y];if(i.machine.includes(y)){C.info(`GlobalState: Skipped adding ${y} in local storage because it is declared as machine scoped.`);continue}if(b&&u.added.has(y))continue;const o=P[y];o&&o.value===S.value||y===T.SYNC_SERVICE_URL_TYPE&&E&&u.added.has(y)||(o?w.updated[y]=S:w.added[y]=S)}for(const y of I.updated.values()){const S=m[y];if(i.machine.includes(y)){C.info(`GlobalState: Skipped updating ${y} in local storage because it is declared as machine scoped.`);continue}if(u.updated.has(y)||u.removed.has(y))continue;const o=P[y];o&&o.value===S.value||(w.updated[y]=S)}for(const y of I.removed.values()){if(i.machine.includes(y)){C.trace(`GlobalState: Skipped removing ${y} in local storage because it is declared as machine scoped.`);continue}u.updated.has(y)||u.removed.has(y)||w.removed.push(y)}return{local:w,remote:k(g,m)?null:g}}e.merge=R;function L(P,m){const b=Object.keys(P),i=Object.keys(m),C=i.filter(u=>b.indexOf(u)===-1).reduce((u,w)=>(u.add(w),u),new Set),f=b.filter(u=>i.indexOf(u)===-1).reduce((u,w)=>(u.add(w),u),new Set),I=new Set;for(const u of b){if(f.has(u))continue;const w=P[u],g=m[u];D.equals(w,g)||I.add(u)}return{added:C,removed:f,updated:I}}function k(P,m){const{added:b,removed:i,updated:C}=L(P,m);return b.size===0&&i.size===0&&C.size===0}}),define(Z[201],ee([0,1,25,3,34,45,48,4,5,30,21,12,13,14,46,22,20,47,54,200,23]),function(K,e,D,T,R,L,k,P,m,b,i,C,f,I,u,w,g,E,y,S,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.GlobalStateInitializer=e.GlobalStateSynchroniser=void 0;const a="globalState.argv.",t=["locale"];function s(h){const d=h.storage?Object.keys(h.storage).sort():[],v={};d.forEach(p=>v[p]=h.storage[p]),h.storage=v;const A=JSON.stringify(h),O=(0,k.format)(A,void 0,{});return(0,L.applyEdits)(A,O)}const n=1;let r=class ot extends E.AbstractSynchroniser{constructor(d,v,A,O,p,U,F,$,H){super("globalState",d,p,H,v,A,U,F,O,$);this.storageService=H,this.version=n,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"globalState.json"),this.localResource=this.previewResource.with({scheme:o.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:o.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:o.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(d.watch(this.extUri.dirname(this.environmentService.argvResource))),this._register(T.Event.any(T.Event.filter(d.onDidFilesChange,M=>M.contains(this.environmentService.argvResource)),T.Event.filter(H.onDidChangeValue,M=>M.scope===0&&M.target!==void 0?M.target===0:H.keys(0,0).includes(M.key)),this.storageService.onDidChangeTarget)(()=>this.triggerLocalChange()))}async generateSyncPreview(d,v,A,O){const p=d.syncData?JSON.parse(d.syncData.content):null;v=v===null&&A?d:v;const U=v&&v.syncData?JSON.parse(v.syncData.content):null,F=await this.getLocalGlobalState();p?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote ui state with local ui state...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const $=this.getStorageKeys(U),{local:H,remote:M}=(0,S.merge)(F.storage,p?p.storage:null,U?U.storage:null,$,this.logService),j={content:null,local:H,remote:M,localChange:Object.keys(H.added).length>0||Object.keys(H.updated).length>0||H.removed.length>0?2:0,remoteChange:M!==null?2:0};return[{localResource:this.localResource,localContent:s(F),localUserData:F,remoteResource:this.remoteResource,remoteContent:p?s(p):null,previewResource:this.previewResource,previewResult:j,localChange:j.localChange,remoteChange:j.remoteChange,acceptedResource:this.acceptedResource,storageKeys:$}]}async getMergeResult(d,v){return{...d.previewResult,hasConflicts:!1}}async getAcceptResult(d,v,A,O){if(this.extUri.isEqual(v,this.localResource))return this.acceptLocal(d);if(this.extUri.isEqual(v,this.remoteResource))return this.acceptRemote(d);if(this.extUri.isEqual(v,this.previewResource))return d.previewResult;throw new Error(`Invalid Resource: ${v.toString()}`)}async acceptLocal(d){return{content:d.localContent,local:{added:{},removed:[],updated:{}},remote:d.localUserData.storage,localChange:0,remoteChange:2}}async acceptRemote(d){if(d.remoteContent!==null){const v=JSON.parse(d.remoteContent),{local:A,remote:O}=(0,S.merge)(d.localUserData.storage,v.storage,null,d.storageKeys,this.logService);return{content:d.remoteContent,local:A,remote:O,localChange:Object.keys(A.added).length>0||Object.keys(A.updated).length>0||A.removed.length>0?2:0,remoteChange:O!==null?2:0}}else return{content:d.remoteContent,local:{added:{},removed:[],updated:{}},remote:null,localChange:0,remoteChange:0}}async applyResult(d,v,A,O){let{localUserData:p}=A[0][0],{local:U,remote:F,localChange:$,remoteChange:H}=A[0][1];if($===0&&H===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing ui state.`),$!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local ui state...`),await this.backupLocal(JSON.stringify(p)),await this.writeLocalGlobalState(U),this.logService.info(`${this.syncResourceLogLabel}: Updated local ui state`)),H!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote ui state...`);const M=JSON.stringify({storage:F});d=await this.updateRemoteUserData(M,O?null:d.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote ui state`)}v?.ref!==d.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized ui state...`),await this.updateLastSyncUserData(d),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized ui state`))}async getAssociatedResources({uri:d}){return[{resource:this.extUri.joinPath(d,"globalState.json"),comparableResource:ot.GLOBAL_STATE_DATA_URI}]}async resolveContent(d){if(this.extUri.isEqual(d,ot.GLOBAL_STATE_DATA_URI)){const A=await this.getLocalGlobalState();return s(A)}if(this.extUri.isEqual(this.remoteResource,d)||this.extUri.isEqual(this.localResource,d)||this.extUri.isEqual(this.acceptedResource,d))return this.resolvePreviewContent(d);let v=await super.resolveContent(d);if(v)return v;if(v=await super.resolveContent(this.extUri.dirname(d)),v){const A=this.parseSyncData(v);if(A)switch(this.extUri.basename(d)){case"globalState.json":return s(JSON.parse(A.content))}}return null}async hasLocalData(){try{const{storage:d}=await this.getLocalGlobalState();if(Object.keys(d).length>1||d[`${a}.locale`]?.value!=="en")return!0}catch(d){}return!1}async getLocalGlobalState(){const d={},v=await this.getLocalArgvContent(),A=(0,R.parse)(v);for(const O of t)A[O]!==void 0&&(d[`${a}${O}`]={version:1,value:A[O]});for(const O of this.storageService.keys(0,0)){const p=this.storageService.get(O,0);p&&(d[O]={version:1,value:p})}return{storage:d}}async getLocalArgvContent(){try{return(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch(d){}return"{}"}async writeLocalGlobalState({added:d,removed:v,updated:A}){const O={},p={},U=($,H)=>{for(const M of $){if(M.startsWith(a)){O[M.substring(a.length)]=H?H[M].value:void 0;continue}if(H){const j=H[M];j.value!==String(this.storageService.get(M,0))&&(p[M]=j.value)}else this.storageService.get(M,0)!==void 0&&(p[M]=void 0)}};if(U(Object.keys(d),d),U(Object.keys(A),A),U(v),Object.keys(O).length&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.updateArgv(O),this.logService.info(`${this.syncResourceLogLabel}: Updated locale`)),Object.keys(p).length){this.logService.trace(`${this.syncResourceLogLabel}: Updating global state...`);for(const $ of Object.keys(p))this.storageService.store($,p[$],0,0);this.logService.info(`${this.syncResourceLogLabel}: Updated global state`,Object.keys(p))}}async updateArgv(d){const v=await this.getLocalArgvContent();let A=v;for(const O of Object.keys(d))A=(0,y.edit)(A,[O],d[O],{});v!==A&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.fileService.writeFile(this.environmentService.argvResource,D.VSBuffer.fromString(A)),this.logService.info(`${this.syncResourceLogLabel}: Updated locale.`))}getStorageKeys(d){const v=this.storageService.keys(0,0),A=this.storageService.keys(0,1),O=[...v,...A],p=d?.storage?Object.keys(d.storage).filter(U=>!U.startsWith(a)&&!O.includes(U)&&this.storageService.get(U,0)!==void 0):[];if(!P.isWeb){const U=[...o.ALL_SYNC_RESOURCES.map(F=>(0,o.getEnablementKey)(F)),o.SYNC_SERVICE_URL_TYPE];p.push(...U),A.push(...U)}return{user:v,machine:A,unregistered:p}}};r.GLOBAL_STATE_DATA_URI=m.URI.from({scheme:o.USER_DATA_SYNC_SCHEME,authority:"globalState",path:"/globalState.json"}),r=de([X(0,f.IFileService),X(1,o.IUserDataSyncStoreService),X(2,o.IUserDataSyncBackupStoreService),X(3,o.IUserDataSyncLogService),X(4,C.IEnvironmentService),X(5,o.IUserDataSyncResourceEnablementService),X(6,g.ITelemetryService),X(7,i.IConfigurationService),X(8,w.IStorageService)],r),e.GlobalStateSynchroniser=r;let c=class extends E.AbstractInitializer{constructor(d,v,A,O){super("globalState",A,O,v);this.storageService=d}async doInitialize(d){const v=d.syncData?JSON.parse(d.syncData.content):null;if(!v){this.logService.info("Skipping initializing global state because remote global state does not exist.");return}const A={},O={};for(const p of Object.keys(v.storage))p.startsWith(a)?A[p.substring(a.length)]=v.storage[p].value:this.storageService.get(p,0)===void 0&&(O[p]=v.storage[p].value);if(Object.keys(A).length){let p="{}";try{p=(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch(U){}for(const U of Object.keys(A))p=(0,y.edit)(p,[U],A[U],{});await this.fileService.writeFile(this.environmentService.argvResource,D.VSBuffer.fromString(p))}if(Object.keys(O).length)for(const p of Object.keys(O))this.storageService.store(p,O[p],0,0)}};c=de([X(0,w.IStorageService),X(1,f.IFileService),X(2,C.IEnvironmentService),X(3,o.IUserDataSyncLogService)],c),e.GlobalStateInitializer=c;let l=class{constructor(d,v,A,O,p){this.userDataSyncStoreClient=d,this.storageService=v,this.environmentService=A,this.fileService=O,this.logService=p}getSyncStoreType(d){return this.parseGlobalState(d)?.storage[o.SYNC_SERVICE_URL_TYPE]?.value}async sync(d){const v=(0,o.createSyncHeaders)((0,b.generateUuid)());try{return await this.doSync(d,v)}catch(A){if(A instanceof o.UserDataSyncError)switch(A.code){case"PreconditionFailed":return this.logService.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.doSync(d,v)}throw A}}async doSync(d,v){const A=await this.userDataSyncStoreClient.read("globalState",null,v),O=this.parseGlobalState(A)||{storage:{}};O.storage[o.SYNC_SERVICE_URL_TYPE]={value:d,version:n};const p=await(0,u.getServiceMachineId)(this.environmentService,this.fileService,this.storageService),U={version:n,machineId:p,content:s(O)};await this.userDataSyncStoreClient.write("globalState",JSON.stringify(U),A.ref,v)}parseGlobalState({content:d}){if(!d)return null;const v=JSON.parse(d);if((0,E.isSyncData)(v))return v?JSON.parse(v.content):null;throw new Error("Invalid remote data")}};l=de([X(1,w.IStorageService),X(2,C.IEnvironmentService),X(3,f.IFileService),X(4,I.ILogService)],l),e.UserDataSyncStoreTypeSynchronizer=l}),define(Z[202],ee([0,1,16,25,3,34,4,17,129,21,12,13,22,20,47,197,23]),function(K,e,D,T,R,L,k,P,m,b,i,C,f,I,u,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=e.getKeybindingsContentFromSyncContent=void 0;function E(o,a){const t=JSON.parse(o);if(!a)return(0,P.isUndefined)(t.all)?null:t.all;switch(k.OS){case 2:return(0,P.isUndefined)(t.mac)?null:t.mac;case 3:return(0,P.isUndefined)(t.linux)?null:t.linux;case 1:return(0,P.isUndefined)(t.windows)?null:t.windows}}e.getKeybindingsContentFromSyncContent=E;let y=class extends u.AbstractJsonFileSynchroniser{constructor(a,t,s,n,r,c,l,h,d,v){super(l.keybindingsResource,"keybindings",c,l,h,a,t,r,v,s,d,n);this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"keybindings.json"),this.localResource=this.previewResource.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(R.Event.filter(n.onDidChangeConfiguration,A=>A.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.triggerLocalChange()))}async generateSyncPreview(a,t,s,n){const r=a.syncData?this.getKeybindingsContentFromSyncContent(a.syncData.content):null;t=t===null&&s?a:t;const c=t?this.getKeybindingsContentFromLastSyncUserData(t):null,l=await this.getLocalFileContent(),h=await this.getFormattingOptions();let d=null,v=!1,A=!1,O=!1;if(r){let U=l?l.value.toString():"[]";if(U=U||"[]",this.hasErrors(U))throw new g.UserDataSyncError((0,m.localize)(0,null),"LocalInvalidContent",this.resource);if(!c||c!==U||c!==r){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote keybindings with local keybindings...`);const F=await(0,w.merge)(U,r,c,h,this.userDataSyncUtilService);F.hasChanges&&(d=F.mergeContent,O=F.hasConflicts,v=O||F.mergeContent!==U,A=O||F.mergeContent!==r)}}else l&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),d=l.value.toString(),A=!0);const p={content:d,localChange:v?l?2:1:0,remoteChange:A?2:0,hasConflicts:O};return[{fileContent:l,localResource:this.localResource,localContent:l?l.value.toString():null,localChange:p.localChange,remoteResource:this.remoteResource,remoteContent:r,remoteChange:p.remoteChange,previewResource:this.previewResource,previewResult:p,acceptedResource:this.acceptedResource}]}async getMergeResult(a,t){return a.previewResult}async getAcceptResult(a,t,s,n){if(this.extUri.isEqual(t,this.localResource))return{content:a.fileContent?a.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(t,this.remoteResource))return{content:a.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(t,this.previewResource))return s===void 0?{content:a.previewResult.content,localChange:a.previewResult.localChange,remoteChange:a.previewResult.remoteChange}:{content:s,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${t.toString()}`)}async applyResult(a,t,s,n){const{fileContent:r}=s[0][0];let{content:c,localChange:l,remoteChange:h}=s[0][1];if(l===0&&h===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing keybindings.`),c!==null&&(c=c.trim(),c=c||"[]",this.hasErrors(c)))throw new g.UserDataSyncError((0,m.localize)(1,null),"LocalInvalidContent",this.resource);if(l!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local keybindings...`),r&&await this.backupLocal(this.toSyncContent(r.value.toString())),await this.updateLocalFileContent(c||"[]",r,n),this.logService.info(`${this.syncResourceLogLabel}: Updated local keybindings`)),h!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote keybindings...`);const d=this.toSyncContent(c||"[]",a.syncData?.content);a=await this.updateRemoteUserData(d,n?null:a.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote keybindings`)}try{await this.fileService.del(this.previewResource)}catch(d){}t?.ref!==a.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized keybindings...`),await this.updateLastSyncUserData(a,{platformSpecific:this.syncKeybindingsPerPlatform()}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized keybindings`))}async hasLocalData(){try{const a=await this.getLocalFileContent();if(a){const t=(0,L.parse)(a.value.toString());if((0,D.isNonEmptyArray)(t))return!0}}catch(a){if(a.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:a}){const t=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(a,"keybindings.json"),comparableResource:t}]}async resolveContent(a){if(this.extUri.isEqual(this.remoteResource,a)||this.extUri.isEqual(this.localResource,a)||this.extUri.isEqual(this.acceptedResource,a))return this.resolvePreviewContent(a);let t=await super.resolveContent(a);if(t)return t;if(t=await super.resolveContent(this.extUri.dirname(a)),t){const s=this.parseSyncData(t);if(s)switch(this.extUri.basename(a)){case"keybindings.json":return this.getKeybindingsContentFromSyncContent(s.content)}}return null}getKeybindingsContentFromLastSyncUserData(a){return!a.syncData||a.platformSpecific!==void 0&&a.platformSpecific!==this.syncKeybindingsPerPlatform()?null:this.getKeybindingsContentFromSyncContent(a.syncData.content)}getKeybindingsContentFromSyncContent(a){try{return E(a,this.syncKeybindingsPerPlatform())}catch(t){return this.logService.error(t),null}}toSyncContent(a,t){let s={};try{s=JSON.parse(t||"{}")}catch(n){this.logService.error(n)}switch(this.syncKeybindingsPerPlatform()?delete s.all:s.all=a,k.OS){case 2:s.mac=a;break;case 3:s.linux=a;break;case 1:s.windows=a;break}return JSON.stringify(s)}syncKeybindingsPerPlatform(){return!!this.configurationService.getValue("settingsSync.keybindingsPerPlatform")}};y=de([X(0,g.IUserDataSyncStoreService),X(1,g.IUserDataSyncBackupStoreService),X(2,g.IUserDataSyncLogService),X(3,b.IConfigurationService),X(4,g.IUserDataSyncResourceEnablementService),X(5,C.IFileService),X(6,i.IEnvironmentService),X(7,f.IStorageService),X(8,g.IUserDataSyncUtilService),X(9,I.ITelemetryService)],y),e.KeybindingsSynchroniser=y;let S=class extends u.AbstractInitializer{constructor(a,t,s){super("keybindings",t,s,a)}async doInitialize(a){const t=a.syncData?this.getKeybindingsContentFromSyncContent(a.syncData.content):null;if(!t){this.logService.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing keybindings because local keybindings exist.");return}await this.fileService.writeFile(this.environmentService.keybindingsResource,T.VSBuffer.fromString(t)),await this.updateLastSyncUserData(a)}async isEmpty(){try{const a=await this.fileService.readFile(this.environmentService.settingsResource),t=(0,L.parse)(a.value.toString());return!(0,D.isNonEmptyArray)(t)}catch(a){return a.fileOperationResult===1}}getKeybindingsContentFromSyncContent(a){try{return E(a,!0)}catch(t){return this.logService.error(t),null}}};S=de([X(0,C.IFileService),X(1,i.IEnvironmentService),X(2,g.IUserDataSyncLogService)],S),e.KeybindingsInitializer=S}),define(Z[203],ee([0,1,16,34,45,48,26,54,23]),function(K,e,D,T,R,L,k,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.addSetting=e.isEmpty=e.areSame=e.merge=e.updateIgnoredSettings=e.getIgnoredSettings=void 0;function b(l,h,d){let v=[];d?v=C(d):v=i(h);const A=[],O=[...(0,m.getDisallowedIgnoredSettings)()];if(Array.isArray(v))for(const p of v)p.startsWith("-")?O.push(p.substring(1)):A.push(p);return(0,D.distinct)([...l,...A].filter(p=>O.indexOf(p)===-1))}e.getIgnoredSettings=b;function i(l){let h=l.inspect("settingsSync.ignoredSettings").userValue;return h!==void 0||(h=l.inspect("sync.ignoredSettings").userValue,h!==void 0)?h:l.getValue("settingsSync.ignoredSettings")||[]}function C(l){const h=(0,T.parse)(l);return h?h["settingsSync.ignoredSettings"]||h["sync.ignoredSettings"]||[]:[]}function f(l,h,d,v){if(d.length){const A=c(h),O=(0,T.parse)(h),p=(0,T.parse)(l),U=[];for(const F of d){const $=O[F],H=p[F];$===void 0?l=P.edit(l,[F],void 0,v):H!==void 0?l=P.edit(l,[F],$,v):U.push(a(F,A))}U.sort((F,$)=>F.startOffset-$.startOffset),U.forEach(F=>l=E(F.setting.key,h,l,v))}return l}e.updateIgnoredSettings=f;function I(l,h,d,v,A,O){const p=f(l,h,v,O),U=d!==p,F=d!==h;if(!U&&!F)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(U&&!F)return{conflictsSettings:[],localContent:null,remoteContent:p,hasConflicts:!1};if(F&&!U)return{conflictsSettings:[],localContent:f(h,l,v,O),remoteContent:null,hasConflicts:!1};if(d===null&&w(l)){const V=u(l,h,v)?null:f(h,l,v,O);return{conflictsSettings:[],localContent:V,remoteContent:null,hasConflicts:!1}}let $=l,H=h;const M=(0,T.parse)(l),j=(0,T.parse)(h),q=d?(0,T.parse)(d):null,z=v.reduce((V,re)=>(V.add(re),V),new Set),x=g(M,j,z),N=g(q,M,z),W=g(q,j,z),_=new Map,Y=new Set,G=V=>{Y.add(V);const re=A.filter(({key:ie})=>ie===V)[0];re?($=P.edit($,[V],re.value,O),H=P.edit(H,[V],re.value,O)):_.set(V,{key:V,localValue:M[V],remoteValue:j[V]})};for(const V of N.removed.values())W.updated.has(V)?G(V):H=P.edit(H,[V],void 0,O);for(const V of W.removed.values())Y.has(V)||(N.updated.has(V)?G(V):$=P.edit($,[V],void 0,O));for(const V of N.updated.values())Y.has(V)||(W.updated.has(V)?x.updated.has(V)&&G(V):H=P.edit(H,[V],M[V],O));for(const V of W.updated.values())Y.has(V)||(N.updated.has(V)?x.updated.has(V)&&G(V):$=P.edit($,[V],j[V],O));for(const V of N.added.values())Y.has(V)||(W.added.has(V)?x.updated.has(V)&&G(V):H=E(V,$,H,O));for(const V of W.added.values())Y.has(V)||(N.added.has(V)?x.updated.has(V)&&G(V):$=E(V,H,$,O));const ne=_.size>0||!u($,H,v),te=ne||!u($,l,[]),J=ne||!u(H,h,[]);return{localContent:te?$:null,remoteContent:J?H:null,conflictsSettings:[..._.values()],hasConflicts:ne}}e.merge=I;function u(l,h,d){if(l===h)return!0;const v=(0,T.parse)(l),A=(0,T.parse)(h),O=d.reduce((F,$)=>(F.add($),F),new Set),p=c(l).filter(F=>!(F.setting&&O.has(F.setting.key))),U=c(h).filter(F=>!(F.setting&&O.has(F.setting.key)));if(p.length!==U.length)return!1;for(let F=0;F<p.length;F++){const $=p[F],H=U[F];if($.setting&&H.setting){if($.setting.key!==H.setting.key||!k.equals(v[$.setting.key],A[$.setting.key]))return!1}else if(!$.setting&&!H.setting){if($.value!==H.value)return!1}else return!1}return!0}e.areSame=u;function w(l){return l?c(l).length===0:!0}e.isEmpty=w;function g(l,h,d){const v=l?Object.keys(l).filter(F=>!d.has(F)):[],A=Object.keys(h).filter(F=>!d.has(F)),O=A.filter(F=>v.indexOf(F)===-1).reduce((F,$)=>(F.add($),F),new Set),p=v.filter(F=>A.indexOf(F)===-1).reduce((F,$)=>(F.add($),F),new Set),U=new Set;if(l)for(const F of v){if(p.has(F))continue;const $=l[F],H=h[F];k.equals($,H)||U.add(F)}return{added:O,removed:p,updated:U}}function E(l,h,d,v){const A=(0,T.parse)(h),O=c(h),p=c(d),U=y(l,O,p);return S(d,l,A[l],U,p,v)}e.addSetting=E;function y(l,h,d){const v=h.findIndex(O=>O.setting?.key===l),A=h[v-1];if(A){if(A.setting){const p=a(A.setting.key,d);if(p)return{index:d.indexOf(p),insertAfter:!0}}else{const p=t(v,h);if(p){const U=a(p.setting.key,d);if(U){const F=s(d.indexOf(U),d),$=n(h,p,h[v]);if(F){const H=n(d,U,F),M=r($,H);return M?{index:d.indexOf(M),insertAfter:!0}:{index:d.indexOf(F),insertAfter:!1}}else{const H=n(d,U,d[d.length-1]),M=r($,H);return M?{index:d.indexOf(M),insertAfter:!0}:{index:d.length-1,insertAfter:!0}}}}}const O=h[v+1];if(O)if(O.setting){const p=a(O.setting.key,d);if(p)return{index:d.indexOf(p),insertAfter:!1}}else{const p=s(v,h);if(p){const U=a(p.setting.key,d);if(U){const F=t(d.indexOf(U),d),$=n(h,h[v],p);if(F){const H=n(d,F,U),M=r($.reverse(),H.reverse());return M?{index:d.indexOf(M),insertAfter:!1}:{index:d.indexOf(F),insertAfter:!0}}else{const H=n(d,d[0],U),M=r($.reverse(),H.reverse());return M?{index:d.indexOf(M),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:d.length-1,insertAfter:!0}}function S(l,h,d,v,A,O){let p;return v.index===-1?p=(0,R.setProperty)(l,[h],d,O):p=o(l,h,d,v,A,O).map(U=>(0,R.withFormatting)(l,U,O)[0]),(0,R.applyEdits)(l,p)}function o(l,h,d,v,A,O){const p=`${JSON.stringify(h)}: ${JSON.stringify(d)}`,U=(0,L.getEOL)(O,l),F=A[v.index];if(v.insertAfter){const $=[];if(F.setting)$.push({offset:F.endOffset,length:0,content:","+p});else{const H=s(v.index,A),M=t(v.index,A),j=M?.setting?.commaOffset;M&&j===void 0&&$.push({offset:M.endOffset,length:0,content:","});const q=j!==void 0&&j>F.endOffset;$.push({offset:q?j+1:F.endOffset,length:0,content:H?U+p+",":U+p})}return $}else{if(F.setting)return[{offset:F.startOffset,length:0,content:p+","}];const $=(A[v.index-1]&&!A[v.index-1].setting?U:"")+p+(s(v.index,A)?",":"")+U;return[{offset:F.startOffset,length:0,content:$}]}}function a(l,h){return h.filter(d=>d.setting?.key===l)[0]}function t(l,h){for(let d=l-1;d>=0;d--)if(h[d].setting)return h[d]}function s(l,h){for(let d=l+1;d<h.length;d++)if(h[d].setting)return h[d]}function n(l,h,d){const v=l.indexOf(h),A=l.indexOf(d);return l.filter((O,p)=>v<p&&p<A)}function r(l,h){if(l.length&&h.length){let d=0;for(;d<h.length&&d<l.length;d++)if(l[d].value!==h[d].value)return h[d-1];return h[d-1]}}function c(l){const h=[];let d=-1,v,A;const O={onObjectBegin:p=>{d++},onObjectProperty:(p,U,F)=>{d===0&&(v=U,A=p)},onObjectEnd:(p,U)=>{d--,d===0&&h.push({startOffset:v,endOffset:p+U,value:l.substring(v,p+U),setting:{key:A,commaOffset:void 0}})},onArrayBegin:(p,U)=>{d++},onArrayEnd:(p,U)=>{d--,d===0&&h.push({startOffset:v,endOffset:p+U,value:l.substring(v,p+U),setting:{key:A,commaOffset:void 0}})},onLiteralValue:(p,U,F)=>{d===0&&h.push({startOffset:v,endOffset:U+F,value:l.substring(v,U+F),setting:{key:A,commaOffset:void 0}})},onSeparator:(p,U,F)=>{if(d===0&&p===","){let $=h.length-1;for(;$>=0&&!h[$].setting;$--);const H=h[$];H&&h.splice($,1,{startOffset:H.startOffset,endOffset:H.endOffset,value:H.value,setting:{key:H.setting.key,commaOffset:U}})}},onComment:(p,U)=>{d===0&&h.push({startOffset:p,endOffset:p+U,value:l.substring(p,p+U)})}};return(0,T.visit)(l,O),h}}),define(Z[204],ee([0,1,25,3,45,130,21,12,28,13,22,20,47,54,203,23]),function(K,e,D,T,R,L,k,P,m,b,i,C,f,I,u,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=e.parseSettingsSyncContent=void 0;function g(a){return a&&a.settings&&typeof a.settings=="string"&&Object.keys(a).length===1}function E(a){const t=JSON.parse(a);return g(t)?t:{settings:a}}e.parseSettingsSyncContent=E;let y=class extends f.AbstractJsonFileSynchroniser{constructor(t,s,n,r,c,l,h,d,v,A,O){super(s.settingsResource,"settings",t,s,n,r,c,v,A,l,h,d);this.extensionManagementService=O,this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"settings.json"),this.localResource=this.previewResource.with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._defaultIgnoredSettings=void 0}async generateSyncPreview(t,s,n,r){const c=await this.getLocalFileContent(),l=await this.getFormattingOptions(),h=this.getSettingsSyncContent(t);s=s===null&&n?t:s;const d=s?this.getSettingsSyncContent(s):null,v=await this.getIgnoredSettings();let A=null,O=!1,p=!1,U=!1;if(h){let $=c?c.value.toString().trim():"{}";$=$||"{}",this.validateContent($),this.logService.trace(`${this.syncResourceLogLabel}: Merging remote settings with local settings...`);const H=(0,u.merge)($,h.settings,d?d.settings:null,v,[],l);A=H.localContent||H.remoteContent,O=H.localContent!==null,p=H.remoteContent!==null,U=H.hasConflicts}else c&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote settings does not exist. Synchronizing settings for the first time.`),A=c.value.toString(),p=!0);const F={content:A,localChange:O?2:0,remoteChange:p?2:0,hasConflicts:U};return[{fileContent:c,localResource:this.localResource,localContent:c?c.value.toString():null,localChange:F.localChange,remoteResource:this.remoteResource,remoteContent:h?h.settings:null,remoteChange:F.remoteChange,previewResource:this.previewResource,previewResult:F,acceptedResource:this.acceptedResource}]}async getMergeResult(t,s){const n=await this.getFormattingOptions(),r=await this.getIgnoredSettings();return{...t.previewResult,content:t.previewResult.content?(0,u.updateIgnoredSettings)(t.previewResult.content,"{}",r,n):null}}async getAcceptResult(t,s,n,r){const c=await this.getFormattingOptions(),l=await this.getIgnoredSettings();if(this.extUri.isEqual(s,this.localResource))return{content:t.fileContent?(0,u.updateIgnoredSettings)(t.fileContent.value.toString(),"{}",l,c):null,localChange:0,remoteChange:2};if(this.extUri.isEqual(s,this.remoteResource))return{content:t.remoteContent!==null?(0,u.updateIgnoredSettings)(t.remoteContent,t.fileContent?t.fileContent.value.toString():"{}",l,c):null,localChange:2,remoteChange:0};if(this.extUri.isEqual(s,this.previewResource))return n===void 0?{content:t.previewResult.content,localChange:t.previewResult.localChange,remoteChange:t.previewResult.remoteChange}:{content:n!==null?(0,u.updateIgnoredSettings)(n,t.fileContent?t.fileContent.value.toString():"{}",l,c):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${s.toString()}`)}async applyResult(t,s,n,r){const{fileContent:c}=n[0][0];let{content:l,localChange:h,remoteChange:d}=n[0][1];if(h===0&&d===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing settings.`),l=l?l.trim():"{}",l=l||"{}",this.validateContent(l),h!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local settings...`),c&&await this.backupLocal(JSON.stringify(this.toSettingsSyncContent(c.value.toString()))),await this.updateLocalFileContent(l,c,r),await this.configurationService.reloadConfiguration(2),this.logService.info(`${this.syncResourceLogLabel}: Updated local settings`)),d!==0){const v=await this.getFormattingOptions(),A=this.getSettingsSyncContent(t),O=await this.getIgnoredSettings(l);l=(0,u.updateIgnoredSettings)(l,A?A.settings:"{}",O,v),this.logService.trace(`${this.syncResourceLogLabel}: Updating remote settings...`),t=await this.updateRemoteUserData(JSON.stringify(this.toSettingsSyncContent(l)),r?null:t.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote settings`)}try{await this.fileService.del(this.previewResource)}catch(v){}s?.ref!==t.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized settings...`),await this.updateLastSyncUserData(t),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized settings`))}async hasLocalData(){try{const t=await this.getLocalFileContent();if(t){const s=await this.getFormattingOptions(),n=(0,I.edit)(t.value.toString(),[w.CONFIGURATION_SYNC_STORE_KEY],void 0,s);return!(0,u.isEmpty)(n)}}catch(t){if(t.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:t}){const s=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(t,"settings.json"),comparableResource:s}]}async resolveContent(t){if(this.extUri.isEqual(this.remoteResource,t)||this.extUri.isEqual(this.localResource,t)||this.extUri.isEqual(this.acceptedResource,t))return this.resolvePreviewContent(t);let s=await super.resolveContent(t);if(s)return s;if(s=await super.resolveContent(this.extUri.dirname(t)),s){const n=this.parseSyncData(s);if(n){const r=this.parseSettingsSyncContent(n.content);if(r)switch(this.extUri.basename(t)){case"settings.json":return r.settings}}}return null}async resolvePreviewContent(t){let s=await super.resolvePreviewContent(t);if(s){const n=await this.getFormattingOptions(),r=await this.getIgnoredSettings();s=(0,u.updateIgnoredSettings)(s,"{}",r,n)}return s}getSettingsSyncContent(t){return t.syncData?this.parseSettingsSyncContent(t.syncData.content):null}parseSettingsSyncContent(t){try{return E(t)}catch(s){this.logService.error(s)}return null}toSettingsSyncContent(t){return{settings:t}}async getIgnoredSettings(t){if(!this._defaultIgnoredSettings){this._defaultIgnoredSettings=this.userDataSyncUtilService.resolveDefaultIgnoredSettings();const n=T.Event.any(T.Event.filter(this.extensionManagementService.onDidInstallExtensions,r=>r.some(({local:c})=>!!c)),T.Event.filter(this.extensionManagementService.onDidUninstallExtension,r=>!r.error))(()=>{n.dispose(),this._defaultIgnoredSettings=void 0})}const s=await this._defaultIgnoredSettings;return(0,u.getIgnoredSettings)(s,this.configurationService,t)}validateContent(t){if(this.hasErrors(t))throw new w.UserDataSyncError((0,L.localize)(0,null),"LocalInvalidContent",this.resource)}async recoverSettings(){try{const t=await this.getLocalFileContent();if(!t)return;const s=JSON.parse(t.value.toString());if(!o(s))return;this.telemetryService.publicLog2("sync/settingsCorrupted");const n=this.parseSettingsSyncContent(s.content);if(!n||!n.settings)return;let r=n.settings;const c=await this.getFormattingOptions();for(const l in s)if(["version","content","machineId"].indexOf(l)===-1&&s[l]!==void 0){const h=(0,R.setProperty)(r,[l],s[l],c);h.length&&(r=(0,R.applyEdits)(r,h))}await this.fileService.writeFile(this.file,D.VSBuffer.fromString(r))}catch(t){}}};y=de([X(0,b.IFileService),X(1,P.IEnvironmentService),X(2,i.IStorageService),X(3,w.IUserDataSyncStoreService),X(4,w.IUserDataSyncBackupStoreService),X(5,w.IUserDataSyncLogService),X(6,w.IUserDataSyncUtilService),X(7,k.IConfigurationService),X(8,w.IUserDataSyncResourceEnablementService),X(9,C.ITelemetryService),X(10,m.IExtensionManagementService)],y),e.SettingsSynchroniser=y;let S=class extends f.AbstractInitializer{constructor(t,s,n){super("settings",s,n,t)}async doInitialize(t){const s=t.syncData?this.parseSettingsSyncContent(t.syncData.content):null;if(!s){this.logService.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing settings because local settings exist.");return}await this.fileService.writeFile(this.environmentService.settingsResource,D.VSBuffer.fromString(s.settings)),await this.updateLastSyncUserData(t)}async isEmpty(){try{const t=await this.fileService.readFile(this.environmentService.settingsResource);return(0,u.isEmpty)(t.value.toString().trim())}catch(t){return t.fileOperationResult===1}}parseSettingsSyncContent(t){try{return E(t)}catch(s){this.logService.error(s)}return null}};S=de([X(0,b.IFileService),X(1,P.IEnvironmentService),X(2,w.IUserDataSyncLogService)],S),e.SettingsInitializer=S;function o(a){return!!(a&&a.version!==void 0&&typeof a.version=="number"&&a.content!==void 0&&typeof a.content=="string"&&a.machineId!==void 0&&typeof a.machineId=="string")}}),define(Z[205],ee([0,1,25,3,26,21,12,13,22,20,47,198,23]),function(K,e,D,T,R,L,k,P,m,b,i,C,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=void 0;let I=class extends i.AbstractSynchroniser{constructor(g,E,y,S,o,a,t,s,n){super("snippets",E,g,y,S,o,s,n,a,t);this.version=1,this.snippetsFolder=g.snippetsHome,this._register(this.fileService.watch(g.userRoamingDataHome)),this._register(this.fileService.watch(this.snippetsFolder)),this._register(T.Event.filter(this.fileService.onDidFilesChange,r=>r.affects(this.snippetsFolder))(()=>this.triggerLocalChange()))}async generateSyncPreview(g,E,y,S){const o=await this.getSnippetsFileContents(),a=this.toSnippetsContents(o),t=g.syncData?this.parseSnippets(g.syncData):null;E=E===null&&y?g:E;const s=E&&E.syncData?this.parseSnippets(E.syncData):null;t?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote snippets with local snippets...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const n=(0,C.merge)(a,t,s);return this.getResourcePreviews(n,o,t||{})}async getMergeResult(g,E){return g.previewResult}async getAcceptResult(g,E,y,S){if(this.extUri.isEqualOrParent(E,this.syncPreviewFolder.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:g.fileContent?g.fileContent.value.toString():null,localChange:0,remoteChange:g.fileContent?g.remoteContent!==null?2:1:3};if(this.extUri.isEqualOrParent(E,this.syncPreviewFolder.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:g.remoteContent,localChange:g.remoteContent!==null?g.fileContent?2:1:3,remoteChange:0};if(this.extUri.isEqualOrParent(E,this.syncPreviewFolder))return y===void 0?{content:g.previewResult.content,localChange:g.previewResult.localChange,remoteChange:g.previewResult.remoteChange}:{content:y,localChange:y===null?g.fileContent!==null?3:0:2,remoteChange:y===null?g.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${E.toString()}`)}async applyResult(g,E,y,S){const o=y.map(([a,t])=>({...a,acceptResult:t}));o.every(({localChange:a,remoteChange:t})=>a===0&&t===0)&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing snippets.`),o.some(({localChange:a})=>a!==0)&&(await this.updateLocalBackup(o),await this.updateLocalSnippets(o,S)),o.some(({remoteChange:a})=>a!==0)&&(g=await this.updateRemoteSnippets(o,g,S)),E?.ref!==g.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized snippets...`),await this.updateLastSyncUserData(g),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized snippets`));for(const{previewResource:a}of o)try{await this.fileService.del(a)}catch(t){}}getResourcePreviews(g,E,y){const S=new Map;for(const o of Object.keys(g.local.added)){const a={content:g.local.added[o],hasConflicts:!1,localChange:1,remoteChange:0};S.set(o,{fileContent:null,localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:y[o],previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of Object.keys(g.local.updated)){const a={content:g.local.updated[o],hasConflicts:!1,localChange:2,remoteChange:0};S.set(o,{localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:E[o],localContent:E[o].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:y[o],previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of g.local.removed){const a={content:null,hasConflicts:!1,localChange:3,remoteChange:0};S.set(o,{localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:E[o],localContent:E[o].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of Object.keys(g.remote.added)){const a={content:g.remote.added[o],hasConflicts:!1,localChange:0,remoteChange:1};S.set(o,{localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:E[o],localContent:E[o].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of Object.keys(g.remote.updated)){const a={content:g.remote.updated[o],hasConflicts:!1,localChange:0,remoteChange:2};S.set(o,{localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:E[o],localContent:E[o].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:y[o],previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of g.remote.removed){const a={content:null,hasConflicts:!1,localChange:0,remoteChange:3};S.set(o,{localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:y[o],previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of g.conflicts){const a={content:E[o]?E[o].value.toString():null,hasConflicts:!0,localChange:E[o]?2:1,remoteChange:y[o]?2:1};S.set(o,{localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:E[o]||null,localContent:E[o]?E[o].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:y[o]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of Object.keys(E))if(!S.has(o)){const a={content:E[o]?E[o].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0};S.set(o,{localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:E[o]||null,localContent:E[o]?E[o].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:y[o]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...S.values()]}async getAssociatedResources({uri:g}){let E=await super.resolveContent(g);if(E){const y=this.parseSyncData(E);if(y){const S=this.parseSnippets(y),o=[];for(const a of Object.keys(S)){const t=this.extUri.joinPath(g,a),s=this.extUri.joinPath(this.snippetsFolder,a),n=await this.fileService.exists(s);o.push({resource:t,comparableResource:n?s:this.extUri.joinPath(this.syncPreviewFolder,a).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"})})}return o}}return[]}async resolveContent(g){if(this.extUri.isEqualOrParent(g,this.syncPreviewFolder.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.extUri.isEqualOrParent(g,this.syncPreviewFolder.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.extUri.isEqualOrParent(g,this.syncPreviewFolder.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})))return this.resolvePreviewContent(g);let E=await super.resolveContent(g);if(E)return E;if(E=await super.resolveContent(this.extUri.dirname(g)),E){const y=this.parseSyncData(E);if(y)return this.parseSnippets(y)[this.extUri.basename(g)]||null}return null}async hasLocalData(){try{const g=await this.getSnippetsFileContents();if(Object.keys(g).length)return!0}catch(g){}return!1}async updateLocalBackup(g){const E={};for(const y of g)y.fileContent&&(E[this.extUri.basename(y.localResource)]=y.fileContent);await this.backupLocal(JSON.stringify(this.toSnippetsContents(E)))}async updateLocalSnippets(g,E){for(const{fileContent:y,acceptResult:S,localResource:o,remoteResource:a,localChange:t}of g)if(t!==0){const s=a?this.extUri.basename(a):this.extUri.basename(o),n=this.extUri.joinPath(this.snippetsFolder,s);t===3?(this.logService.trace(`${this.syncResourceLogLabel}: Deleting snippet...`,this.extUri.basename(n)),await this.fileService.del(n),this.logService.info(`${this.syncResourceLogLabel}: Deleted snippet`,this.extUri.basename(n))):t===1?(this.logService.trace(`${this.syncResourceLogLabel}: Creating snippet...`,this.extUri.basename(n)),await this.fileService.createFile(n,D.VSBuffer.fromString(S.content),{overwrite:E}),this.logService.info(`${this.syncResourceLogLabel}: Created snippet`,this.extUri.basename(n))):(this.logService.trace(`${this.syncResourceLogLabel}: Updating snippet...`,this.extUri.basename(n)),await this.fileService.writeFile(n,D.VSBuffer.fromString(S.content),E?void 0:y),this.logService.info(`${this.syncResourceLogLabel}: Updated snippet`,this.extUri.basename(n)))}}async updateRemoteSnippets(g,E,y){const S=E.syncData?this.parseSnippets(E.syncData):{},o=(0,R.deepClone)(S);for(const{acceptResult:a,localResource:t,remoteResource:s,remoteChange:n}of g)if(n!==0){const r=t?this.extUri.basename(t):this.extUri.basename(s);n===3?delete o[r]:o[r]=a.content}return(0,C.areSame)(S,o)||(this.logService.trace(`${this.syncResourceLogLabel}: Updating remote snippets...`),E=await this.updateRemoteUserData(JSON.stringify(o),y?null:E.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote snippets`)),E}parseSnippets(g){return JSON.parse(g.content)}toSnippetsContents(g){const E={};for(const y of Object.keys(g))E[y]=g[y].value.toString();return E}async getSnippetsFileContents(){const g={};let E;try{E=await this.fileService.resolve(this.snippetsFolder)}catch(y){if(y instanceof P.FileOperationError&&y.fileOperationResult===1)return g;throw y}for(const y of E.children||[]){const S=y.resource,o=this.extUri.extname(S);if(o===".json"||o===".code-snippets"){const a=this.extUri.relativePath(this.snippetsFolder,S),t=await this.fileService.readFile(S);g[a]=t}}return g}};I=de([X(0,k.IEnvironmentService),X(1,P.IFileService),X(2,m.IStorageService),X(3,f.IUserDataSyncStoreService),X(4,f.IUserDataSyncBackupStoreService),X(5,f.IUserDataSyncLogService),X(6,L.IConfigurationService),X(7,f.IUserDataSyncResourceEnablementService),X(8,b.ITelemetryService)],I),e.SnippetsSynchroniser=I;let u=class extends i.AbstractInitializer{constructor(g,E,y){super("snippets",E,y,g)}async doInitialize(g){const E=g.syncData?JSON.parse(g.syncData.content):null;if(!E){this.logService.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing snippets because local snippets exist.");return}for(const S of Object.keys(E)){const o=E[S];if(o){const a=this.extUri.joinPath(this.environmentService.snippetsHome,S);await this.fileService.createFile(a,D.VSBuffer.fromString(o)),this.logService.info("Created snippet",this.extUri.basename(a))}}await this.updateLastSyncUserData(g)}async isEmpty(){try{return!(await this.fileService.resolve(this.environmentService.snippetsHome)).children?.length}catch(g){return g.fileOperationResult===1}}};u=de([X(0,P.IFileService),X(1,k.IEnvironmentService),X(2,f.IUserDataSyncLogService)],u),e.SnippetsInitializer=u}),define(Z[60],ee([0,1,3,2,7,23]),function(K,e,D,T,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=(0,R.createDecorator)("IUserDataSyncAccountService");let k=class extends T.Disposable{constructor(m){super();this.userDataSyncStoreService=m,this._onDidChangeAccount=this._register(new D.Emitter),this.onDidChangeAccount=this._onDidChangeAccount.event,this._onTokenFailed=this._register(new D.Emitter),this.onTokenFailed=this._onTokenFailed.event,this.wasTokenFailed=!1,this._register(m.onTokenFailed(()=>{this.updateAccount(void 0),this._onTokenFailed.fire(this.wasTokenFailed),this.wasTokenFailed=!0})),this._register(m.onTokenSucceed(()=>this.wasTokenFailed=!1))}get account(){return this._account}async updateAccount(m){(m&&this._account?m.token!==this._account.token||m.authenticationProviderId!==this._account.authenticationProviderId:m!==this._account)&&(this._account=m,this._account&&this.userDataSyncStoreService.setAuthToken(this._account.token,this._account.authenticationProviderId),this._onDidChangeAccount.fire(m))}};k=de([X(0,L.IUserDataSyncStoreService)],k),e.UserDataSyncAccountService=k}),define(Z[206],ee([0,1,6,25,56,2,15,21,12,13,23]),function(K,e,D,T,R,L,k,P,m,b,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncBackupStoreService=void 0;let C=class extends L.Disposable{constructor(I,u,w,g){super();this.environmentService=I,this.fileService=u,this.configurationService=w,this.logService=g,i.ALL_SYNC_RESOURCES.forEach(E=>this.cleanUpBackup(E))}async getAllRefs(I){const u=(0,k.joinPath)(this.environmentService.userDataSyncHome,I),w=await this.fileService.resolve(u);return w.children?w.children.filter(E=>E.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(E.name)).sort().reverse().map(E=>({ref:E.name,created:this.getCreationTime(E)})):[]}async resolveContent(I,u){if(!u){const w=await this.getAllRefs(I);w.length&&(u=w[w.length-1].ref)}if(u){const w=(0,k.joinPath)(this.environmentService.userDataSyncHome,I,u);return(await this.fileService.readFile(w)).value.toString()}return null}async backup(I,u){const w=(0,k.joinPath)(this.environmentService.userDataSyncHome,I),g=(0,k.joinPath)(w,`${(0,R.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.fileService.writeFile(g,T.VSBuffer.fromString(u))}catch(E){this.logService.error(E)}try{this.cleanUpBackup(I)}catch(E){}}async cleanUpBackup(I){const u=(0,k.joinPath)(this.environmentService.userDataSyncHome,I);try{try{if(!await this.fileService.exists(u))return}catch(g){return}const w=await this.fileService.resolve(u);if(w.children){const g=w.children.filter(o=>o.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(o.name)).sort(),E=1e3*60*60*24*(this.configurationService.getValue("sync.localBackupDuration")||30);let y=g.filter(o=>Date.now()-this.getCreationTime(o)>E);const S=g.length-y.length;S<10&&(y=y.slice(10-S)),await D.Promises.settled(y.map(async o=>{this.logService.info("Deleting from backup",o.resource.path),await this.fileService.del(o.resource)}))}}catch(w){this.logService.error(w)}}getCreationTime(I){return I.ctime||new Date(parseInt(I.name.substring(0,4)),parseInt(I.name.substring(4,6))-1,parseInt(I.name.substring(6,8)),parseInt(I.name.substring(9,11)),parseInt(I.name.substring(11,13)),parseInt(I.name.substring(13,15))).getTime()}};C=de([X(0,m.IEnvironmentService),X(1,b.IFileService),X(2,P.IConfigurationService),X(3,i.IUserDataSyncLogService)],C),e.UserDataSyncBackupStoreService=C}),define(Z[207],ee([0,1,2,5]),function(K,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannel=e.UserDataSyncMachinesServiceChannel=e.UserDataSyncUtilServiceClient=e.UserDataSycnUtilServiceChannel=e.UserDataAutoSyncChannel=void 0;class R{constructor(f){this.service=f}listen(f,I){switch(I){case"onError":return this.service.onError}throw new Error(`Event not found: ${I}`)}call(f,I,u){switch(I){case"triggerSync":return this.service.triggerSync(u[0],u[1],u[2]);case"turnOn":return this.service.turnOn();case"turnOff":return this.service.turnOff(u[0])}throw new Error("Invalid call")}}e.UserDataAutoSyncChannel=R;class L{constructor(f){this.service=f}listen(f,I){throw new Error(`Event not found: ${I}`)}call(f,I,u){switch(I){case"resolveDefaultIgnoredSettings":return this.service.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.service.resolveUserBindings(u[0]);case"resolveFormattingOptions":return this.service.resolveFormattingOptions(T.URI.revive(u[0]))}throw new Error("Invalid call")}}e.UserDataSycnUtilServiceChannel=L;class k{constructor(f){this.channel=f}async resolveDefaultIgnoredSettings(){return this.channel.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(f){return this.channel.call("resolveUserKeybindings",[f])}async resolveFormattingOptions(f){return this.channel.call("resolveFormattingOptions",[f])}}e.UserDataSyncUtilServiceClient=k;class P{constructor(f){this.service=f}listen(f,I){switch(I){case"onDidChange":return this.service.onDidChange}throw new Error(`Event not found: ${I}`)}async call(f,I,u){switch(I){case"getMachines":return this.service.getMachines();case"addCurrentMachine":return this.service.addCurrentMachine();case"removeCurrentMachine":return this.service.removeCurrentMachine();case"renameMachine":return this.service.renameMachine(u[0],u[1]);case"setEnablement":return this.service.setEnablement(u[0],u[1])}throw new Error("Invalid call")}}e.UserDataSyncMachinesServiceChannel=P;class m{constructor(f){this.service=f}listen(f,I){switch(I){case"onDidChangeAccount":return this.service.onDidChangeAccount;case"onTokenFailed":return this.service.onTokenFailed}throw new Error(`Event not found: ${I}`)}call(f,I,u){switch(I){case"_getInitialData":return Promise.resolve(this.service.account);case"updateAccount":return this.service.updateAccount(u)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=m;class b{constructor(f){this.service=f}listen(f,I){switch(I){case"onDidChangeUserDataSyncStore":return this.service.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${I}`)}call(f,I,u){switch(I){case"switch":return this.service.switch(u[0]);case"getPreviousUserDataSyncStore":return this.service.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=b;class i extends D.Disposable{constructor(f){super();this.channel=f,this.onDidChangeUserDataSyncStore=this.channel.listen("onDidChangeUserDataSyncStore")}async switch(f){return this.channel.call("switch",[f])}async getPreviousUserDataSyncStore(){const f=await this.channel.call("getPreviousUserDataSyncStore");return this.revive(f)}revive(f){return{url:T.URI.revive(f.url),type:f.type,defaultUrl:T.URI.revive(f.defaultUrl),insidersUrl:T.URI.revive(f.insidersUrl),stableUrl:T.URI.revive(f.stableUrl),canSwitch:f.canSwitch,authenticationProviders:f.authenticationProviders}}}e.UserDataSyncStoreManagementServiceChannelClient=i}),define(Z[208],ee([0,1,12,14]),function(K,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let R=class extends T.AbstractLogger{constructor(k,P){super();this.logger=this._register(k.createLogger(P.userDataSyncLogResource,{name:"settingssync"}))}trace(k,...P){this.logger.trace(k,...P)}debug(k,...P){this.logger.debug(k,...P)}info(k,...P){this.logger.info(k,...P)}warn(k,...P){this.logger.warn(k,...P)}error(k,...P){this.logger.error(k,...P)}critical(k,...P){this.logger.critical(k,...P)}flush(){this.logger.flush()}};R=de([X(0,T.ILoggerService),X(1,D.IEnvironmentService)],R),e.UserDataSyncLogService=R}),define(Z[61],ee([0,1,3,2,4,24,133,12,13,7,29,46,22,23]),function(K,e,D,T,R,L,k,P,m,b,i,C,f,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.IUserDataSyncMachinesService=void 0,e.IUserDataSyncMachinesService=(0,b.createDecorator)("IUserDataSyncMachinesService");const u="sync.currentMachineName";let w=class Je extends T.Disposable{constructor(E,y,S,o,a,t){super();this.storageService=S,this.userDataSyncStoreService=o,this.logService=a,this.productService=t,this._onDidChange=this._register(new D.Emitter),this.onDidChange=this._onDidChange.event,this.userData=null,this.currentMachineIdPromise=(0,C.getServiceMachineId)(E,y,S)}async getMachines(E){const y=await this.currentMachineIdPromise;return(await this.readMachinesData(E)).machines.map(o=>({...o,isCurrent:o.id===y}))}async addCurrentMachine(E){const y=await this.currentMachineIdPromise,S=await this.readMachinesData(E);S.machines.some(({id:o})=>o===y)||(S.machines.push({id:y,name:this.computeCurrentMachineName(S.machines)}),await this.writeMachinesData(S))}async removeCurrentMachine(E){const y=await this.currentMachineIdPromise,S=await this.readMachinesData(E),o=S.machines.filter(({id:a})=>a!==y);o.length!==S.machines.length&&(S.machines=o,await this.writeMachinesData(S))}async renameMachine(E,y,S){const o=await this.currentMachineIdPromise,a=await this.readMachinesData(S),t=a.machines.find(({id:s})=>s===E);t&&(t.name=y,await this.writeMachinesData(a),a.machines.some(({id:s})=>s===o)&&this.storageService.store(u,y,0,1))}async setEnablement(E,y){const S=await this.readMachinesData(),o=S.machines.find(({id:a})=>a===E);o&&(o.disabled=y?void 0:!0,await this.writeMachinesData(S))}computeCurrentMachineName(E){const y=this.storageService.get(u,0);if(y)return y;const S=`${this.productService.nameLong} (${(0,R.PlatformToString)(R.isWeb?0:R.platform)})`,o=new RegExp(`${(0,L.escapeRegExpCharacters)(S)}\\s#(\\d+)`);let a=0;for(const t of E){const s=o.exec(t.name),n=s?parseInt(s[1]):0;a=n>a?n:a}return`${S} #${a+1}`}async readMachinesData(E){this.userData=await this.readUserData(E);const y=this.parse(this.userData);if(y.version!==Je.VERSION)throw new Error((0,k.localize)(0,null,this.productService.nameLong));return y}async writeMachinesData(E){const y=JSON.stringify(E),S=await this.userDataSyncStoreService.write(Je.RESOURCE,y,this.userData?.ref||null);this.userData={ref:S,content:y},this._onDidChange.fire()}async readUserData(E){if(this.userData){const y=E&&E.latest?E.latest[Je.RESOURCE]:void 0;if(this.userData.ref===y)return this.userData;if(y===void 0&&this.userData.content===null)return this.userData}return this.userDataSyncStoreService.read(Je.RESOURCE,this.userData)}parse(E){if(E.content!==null)try{return JSON.parse(E.content)}catch(y){this.logService.error(y)}return{version:Je.VERSION,machines:[]}}};w.VERSION=1,w.RESOURCE="machines",w=de([X(0,P.IEnvironmentService),X(1,m.IFileService),X(2,f.IStorageService),X(3,I.IUserDataSyncStoreService),X(4,I.IUserDataSyncLogService),X(5,i.IProductService)],w),e.UserDataSyncMachinesService=w}),define(Z[89],ee([0,1,6,56,37,9,3,2,4,15,5,131,12,29,22,20,23,60,61]),function(K,e,D,T,R,L,k,P,m,b,i,C,f,I,u,w,g,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=e.UserDataAutoSyncEnablementService=void 0;const S="sync.enable",o="sync.disableMachineEventually",a="sync.sessionId",t="sync.storeUrl",s="sync.productQuality";let n=class extends P.Disposable{constructor(h,d,v){super();this.storageService=h,this.environmentService=d,this.userDataSyncStoreManagementService=v,this._onDidChangeEnablement=new k.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this._register(h.onDidChangeValue(A=>this.onDidStorageChange(A)))}isEnabled(){switch(this.environmentService.sync){case"on":return!0;case"off":return!1}return this.storageService.getBoolean(S,0,!1)}canToggleEnablement(){return this.userDataSyncStoreManagementService.userDataSyncStore!==void 0&&this.environmentService.sync===void 0}setEnablement(h){h&&!this.canToggleEnablement()||this.storageService.store(S,h,0,1)}onDidStorageChange(h){if(h.scope===0&&S===h.key){this._onDidChangeEnablement.fire(this.isEnabled());return}}};n=de([X(0,u.IStorageService),X(1,f.IEnvironmentService),X(2,g.IUserDataSyncStoreManagementService)],n),e.UserDataAutoSyncEnablementService=n;let r=class extends P.Disposable{constructor(h,d,v,A,O,p,U,F,$,H,M){super();this.userDataSyncStoreManagementService=d,this.userDataSyncStoreService=v,this.userDataSyncResourceEnablementService=A,this.userDataSyncService=O,this.logService=p,this.userDataSyncAccountService=U,this.telemetryService=F,this.userDataSyncMachinesService=$,this.storageService=H,this.autoSync=this._register(new P.MutableDisposable),this.successiveFailures=0,this.lastSyncTriggerTime=void 0,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this.sources=[],this.userDataAutoSyncEnablementService=M,this.syncTriggerDelayer=this._register(new D.Delayer(0)),this.lastSyncUrl=this.syncUrl,this.syncUrl=d.userDataSyncStore?.url,this.previousProductQuality=this.productQuality,this.productQuality=h.quality,this.syncUrl&&(this.logService.info("Using settings sync service",this.syncUrl.toString()),this._register(d.onDidChangeUserDataSyncStore(()=>{(0,b.isEqual)(this.syncUrl,d.userDataSyncStore?.url)||(this.lastSyncUrl=this.syncUrl,this.syncUrl=d.userDataSyncStore?.url,this.syncUrl&&this.logService.info("Using settings sync service",this.syncUrl.toString()))})),this.userDataAutoSyncEnablementService.isEnabled()?this.logService.info("Auto Sync is enabled."):this.logService.info("Auto Sync is disabled."),this.updateAutoSync(),this.hasToDisableMachineEventually()&&this.disableMachineEventually(),this._register(U.onDidChangeAccount(()=>this.updateAutoSync())),this._register(v.onDidChangeDonotMakeRequestsUntil(()=>this.updateAutoSync())),this._register(k.Event.debounce(O.onDidChangeLocal,(j,q)=>j?[...j,q]:[q],1e3)(j=>this.triggerSync(j,!1,!1))),this._register(k.Event.filter(this.userDataSyncResourceEnablementService.onDidChangeResourceEnablement,([,j])=>j)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this._register(this.userDataSyncStoreManagementService.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}get syncUrl(){const h=this.storageService.get(t,0);return h?i.URI.parse(h):void 0}set syncUrl(h){h?this.storageService.store(t,h.toString(),0,1):this.storageService.remove(t,0)}get productQuality(){return this.storageService.get(s,0)}set productQuality(h){h?this.storageService.store(s,h,0,1):this.storageService.remove(s,0)}updateAutoSync(){const{enabled:h,message:d}=this.isAutoSyncEnabled();h?this.autoSync.value===void 0&&(this.autoSync.value=new c(this.lastSyncUrl,1e3*60*5,this.userDataSyncStoreManagementService,this.userDataSyncStoreService,this.userDataSyncService,this.userDataSyncMachinesService,this.logService,this.storageService),this.autoSync.value.register(this.autoSync.value.onDidStartSync(()=>this.lastSyncTriggerTime=new Date().getTime())),this.autoSync.value.register(this.autoSync.value.onDidFinishSync(v=>this.onDidFinishSync(v))),this.startAutoSync()&&this.autoSync.value.start()):(this.syncTriggerDelayer.cancel(),this.autoSync.value!==void 0?(d&&this.logService.info(d),this.autoSync.clear()):d&&this.userDataAutoSyncEnablementService.isEnabled()&&this.logService.info(d))}startAutoSync(){return!0}isAutoSyncEnabled(){return this.userDataAutoSyncEnablementService.isEnabled()?this.userDataSyncAccountService.account?this.userDataSyncStoreService.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,T.toLocalISOString)(this.userDataSyncStoreService.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.stopDisableMachineEventually(),this.lastSyncUrl=this.syncUrl,this.updateEnablement(!0)}async turnOff(h,d,v){try{this.userDataSyncAccountService.account&&!v&&await this.userDataSyncMachinesService.removeCurrentMachine(),this.updateEnablement(!1),this.storageService.remove(a,0),h?(this.telemetryService.publicLog2("sync/turnOffEveryWhere"),await this.userDataSyncService.reset()):await this.userDataSyncService.resetLocal()}catch(A){if(d)this.logService.error(A),this.updateEnablement(!1);else throw A}}updateEnablement(h){this.userDataAutoSyncEnablementService.isEnabled()!==h&&(this.telemetryService.publicLog2(S,{enabled:h}),this.userDataAutoSyncEnablementService.setEnablement(h),this.updateAutoSync())}hasProductQualityChanged(){return!!this.previousProductQuality&&!!this.productQuality&&this.previousProductQuality!==this.productQuality}async onDidFinishSync(h){if(!h){this.successiveFailures=0;return}const d=g.UserDataSyncError.toUserDataSyncError(h);d instanceof g.UserDataAutoSyncError&&this.telemetryService.publicLog2("autosync/error",{code:d.code,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()}),d.code==="SessionExpired"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current session is expired")):d.code==="TurnedOff"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):d.code==="LocalTooManyRequests"||d.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because of making too many requests to server")):d.code==="UpgradeRequired"||d.code==="Gone"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):d.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${d.resource} content with newer version than of client. Requires client upgrade.`)):d.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${d.resource} content with older version than of client. Requires server reset.`)):d.code==="ServiceChanged"||d.code==="DefaultServiceChanged"?m.isWeb&&d.code==="DefaultServiceChanged"&&!this.hasProductQualityChanged()?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.logService.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.logService.error(d),this.successiveFailures++),this._onError.fire(d)}async disableMachineEventually(){this.storageService.store(o,!0,0,1),await(0,D.timeout)(1e3*60*10),!!this.hasToDisableMachineEventually()&&(this.stopDisableMachineEventually(),!this.userDataAutoSyncEnablementService.isEnabled()&&this.userDataSyncAccountService.account&&await this.userDataSyncMachinesService.removeCurrentMachine())}hasToDisableMachineEventually(){return this.storageService.getBoolean(o,0,!1)}stopDisableMachineEventually(){this.storageService.remove(o,0)}async triggerSync(h,d,v){if(this.autoSync.value===void 0)return this.syncTriggerDelayer.cancel();if(d&&this.lastSyncTriggerTime&&Math.round((new Date().getTime()-this.lastSyncTriggerTime)/1e3)<10){this.logService.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.sources.push(...h),this.syncTriggerDelayer.trigger(async()=>{this.logService.trace("activity sources",...this.sources),this.telemetryService.publicLog2("sync/triggered",{sources:this.sources}),this.sources=[],this.autoSync.value&&await this.autoSync.value.sync("Activity",v)},this.successiveFailures?this.getSyncTriggerDelayTime()*1*Math.min(Math.pow(2,this.successiveFailures),60):this.getSyncTriggerDelayTime())}getSyncTriggerDelayTime(){return 1e3}};r=de([X(0,I.IProductService),X(1,g.IUserDataSyncStoreManagementService),X(2,g.IUserDataSyncStoreService),X(3,g.IUserDataSyncResourceEnablementService),X(4,g.IUserDataSyncService),X(5,g.IUserDataSyncLogService),X(6,E.IUserDataSyncAccountService),X(7,w.ITelemetryService),X(8,y.IUserDataSyncMachinesService),X(9,u.IStorageService),X(10,g.IUserDataAutoSyncEnablementService)],r),e.UserDataAutoSyncService=r;class c extends P.Disposable{constructor(h,d,v,A,O,p,U,F){super();this.lastSyncUrl=h,this.interval=d,this.userDataSyncStoreManagementService=v,this.userDataSyncStoreService=A,this.userDataSyncService=O,this.userDataSyncMachinesService=p,this.logService=U,this.storageService=F,this.intervalHandler=this._register(new P.MutableDisposable),this._onDidStartSync=this._register(new k.Emitter),this.onDidStartSync=this._onDidStartSync.event,this._onDidFinishSync=this._register(new k.Emitter),this.onDidFinishSync=this._onDidFinishSync.event,this.manifest=null}start(){this._register(this.onDidFinishSync(()=>this.waitUntilNextIntervalAndSync())),this._register((0,P.toDisposable)(()=>{this.syncPromise&&(this.syncPromise.cancel(),this.logService.info("Auto sync: Cancelled sync that is in progress"),this.syncPromise=void 0),this.syncTask&&this.syncTask.stop(),this.logService.info("Auto Sync: Stopped")})),this.logService.info("Auto Sync: Started"),this.sync(c.INTERVAL_SYNCING,!1)}waitUntilNextIntervalAndSync(){this.intervalHandler.value=(0,D.disposableTimeout)(()=>this.sync(c.INTERVAL_SYNCING,!1),this.interval)}sync(h,d){const v=(0,D.createCancelablePromise)(async A=>{if(this.syncPromise)try{this.logService.debug("Auto Sync: Waiting until sync is finished."),await this.syncPromise}catch(O){if((0,L.isPromiseCanceledError)(O))return}return this.doSync(h,d,A)});return this.syncPromise=v,this.syncPromise.finally(()=>this.syncPromise=void 0),this.syncPromise}hasSyncServiceChanged(){return this.lastSyncUrl!==void 0&&!(0,b.isEqual)(this.lastSyncUrl,this.userDataSyncStoreManagementService.userDataSyncStore?.url)}async hasDefaultServiceChanged(){const h=await this.userDataSyncStoreManagementService.getPreviousUserDataSyncStore(),d=this.userDataSyncStoreManagementService.userDataSyncStore;return!!d&&!!h&&(!(0,b.isEqual)(d.defaultUrl,h.defaultUrl)||!(0,b.isEqual)(d.insidersUrl,h.insidersUrl)||!(0,b.isEqual)(d.stableUrl,h.stableUrl))}async doSync(h,d,v){this.logService.info(`Auto Sync: Triggered by ${h}`),this._onDidStartSync.fire();let A;try{if(this.syncTask=await this.userDataSyncService.createSyncTask(this.manifest,d),v.isCancellationRequested)return;if(this.manifest=this.syncTask.manifest,this.manifest===null&&await this.userDataSyncService.hasPreviouslySynced())throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new g.UserDataAutoSyncError((0,C.localize)(0,null),"DefaultServiceChanged"):new g.UserDataAutoSyncError((0,C.localize)(1,null),"ServiceChanged"):new g.UserDataAutoSyncError((0,C.localize)(2,null),"TurnedOff");const O=this.storageService.get(a,0);if(O&&this.manifest&&O!==this.manifest.session)throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new g.UserDataAutoSyncError((0,C.localize)(3,null),"DefaultServiceChanged"):new g.UserDataAutoSyncError((0,C.localize)(4,null),"ServiceChanged"):new g.UserDataAutoSyncError((0,C.localize)(5,null),"SessionExpired");const p=await this.userDataSyncMachinesService.getMachines(this.manifest||void 0);if(v.isCancellationRequested)return;const U=p.find(F=>F.isCurrent);if(U?.disabled)throw new g.UserDataAutoSyncError((0,C.localize)(6,null),"TurnedOff");if(await this.syncTask.run(),this.manifest===null)try{this.manifest=await this.userDataSyncStoreService.manifest(null)}catch(F){throw new g.UserDataAutoSyncError((0,R.toErrorMessage)(F),F instanceof g.UserDataSyncError?F.code:"Unknown")}if(this.manifest&&this.manifest.session!==O&&this.storageService.store(a,this.manifest.session,0,1),v.isCancellationRequested)return;U||await this.userDataSyncMachinesService.addCurrentMachine(this.manifest||void 0)}catch(O){this.logService.error(O),A=O}this._onDidFinishSync.fire(A)}register(h){return super._register(h)}}c.INTERVAL_SYNCING="Interval"}),define(Z[209],ee([0,1,3,2,4,22,20,23]),function(K,e,D,T,R,L,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncResourceEnablementService=void 0;let m=class extends T.Disposable{constructor(i,C){super();this.storageService=i,this.telemetryService=C,this._onDidChangeResourceEnablement=new D.Emitter,this.onDidChangeResourceEnablement=this._onDidChangeResourceEnablement.event,this._register(i.onDidChangeValue(f=>this.onDidStorageChange(f)))}isResourceEnabled(i){return this.storageService.getBoolean((0,P.getEnablementKey)(i),0,!0)}setResourceEnablement(i,C){if(this.isResourceEnabled(i)!==C){const f=(0,P.getEnablementKey)(i);this.telemetryService.publicLog2(f,{enabled:C}),this.storeResourceEnablement(f,C)}}getResourceSyncStateVersion(i){}storeResourceEnablement(i,C){this.storageService.store(i,C,0,R.isWeb?0:1)}onDidStorageChange(i){if(i.scope===0){const C=P.ALL_SYNC_RESOURCES.filter(f=>(0,P.getEnablementKey)(f)===i.key)[0];if(C){this._onDidChangeResourceEnablement.fire([C,this.isResourceEnabled(C)]);return}}}};m=de([X(0,L.IStorageService),X(1,k.ITelemetryService)],m),e.UserDataSyncResourceEnablementService=m}),define(Z[210],ee([0,1,16,6,37,9,3,2,15,30,7,22,20,199,201,202,204,205,23]),function(K,e,D,T,R,L,k,P,m,b,i,C,f,I,u,w,g,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const S="sync.lastSyncTime";let o=class extends P.Disposable{constructor(n,r,c,l,h,d){super();this.userDataSyncStoreService=n,this.userDataSyncStoreManagementService=r,this.instantiationService=c,this.logService=l,this.telemetryService=h,this.storageService=d,this._status="uninitialized",this._onDidChangeStatus=this._register(new k.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new k.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._syncErrors=[],this._onSyncErrors=this._register(new k.Emitter),this.onSyncErrors=this._onSyncErrors.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new k.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onDidResetLocal=this._register(new k.Emitter),this.onDidResetLocal=this._onDidResetLocal.event,this._onDidResetRemote=this._register(new k.Emitter),this.onDidResetRemote=this._onDidResetRemote.event,this.recoveredSettings=!1,this.settingsSynchroniser=this._register(this.instantiationService.createInstance(g.SettingsSynchroniser)),this.keybindingsSynchroniser=this._register(this.instantiationService.createInstance(w.KeybindingsSynchroniser)),this.snippetsSynchroniser=this._register(this.instantiationService.createInstance(E.SnippetsSynchroniser)),this.globalStateSynchroniser=this._register(this.instantiationService.createInstance(u.GlobalStateSynchroniser)),this.extensionsSynchroniser=this._register(this.instantiationService.createInstance(I.ExtensionsSynchroniser)),this.synchronisers=[this.settingsSynchroniser,this.keybindingsSynchroniser,this.snippetsSynchroniser,this.globalStateSynchroniser,this.extensionsSynchroniser],this.updateStatus(),this.userDataSyncStoreManagementService.userDataSyncStore&&(this._register(k.Event.any(...this.synchronisers.map(v=>k.Event.map(v.onDidChangeStatus,()=>{})))(()=>this.updateStatus())),this._register(k.Event.any(...this.synchronisers.map(v=>k.Event.map(v.onDidChangeConflicts,()=>{})))(()=>this.updateConflicts()))),this._lastSyncTime=this.storageService.getNumber(S,0,void 0),this.onDidChangeLocal=k.Event.any(...this.synchronisers.map(v=>k.Event.map(v.onDidChangeLocal,()=>v.resource)))}get status(){return this._status}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}async createSyncTask(n,r){await this.checkEnablement();const c=(0,b.generateUuid)();try{const v=(0,y.createSyncHeaders)(c);r&&(v["Cache-Control"]="no-cache"),n=await this.userDataSyncStoreService.manifest(n,v)}catch(v){const A=y.UserDataSyncError.toUserDataSyncError(v);throw this.reportUserDataSyncError(A,c),A}let l=!1;const h=this;let d;return{manifest:n,run(){if(l)throw new Error("Can run a task only once");return d=(0,T.createCancelablePromise)(v=>h.sync(n,c,v)),d.finally(()=>d=void 0)},async stop(){if(d&&d.cancel(),h.status!=="idle")return h.stop()}}}async createManualSyncTask(){await this.checkEnablement();const n=(0,b.generateUuid)(),r=(0,y.createSyncHeaders)(n);let c;try{c=await this.userDataSyncStoreService.manifest(null,r)}catch(l){const h=y.UserDataSyncError.toUserDataSyncError(l);throw this.reportUserDataSyncError(h,n),h}return new a(n,c,r,this.synchronisers,this.logService)}async sync(n,r,c){if(this.recoveredSettings||(await this.settingsSynchroniser.recoverSettings(),this.recoveredSettings=!0),c.isCancellationRequested)return;const l=new Date().getTime();this._syncErrors=[];try{this.logService.trace("Sync started."),this.status!=="hasConflicts"&&this.setStatus("syncing");const h=(0,y.createSyncHeaders)(r);for(const d of this.synchronisers){if(c.isCancellationRequested)return;try{await d.sync(n,h)}catch(v){let A=!1;if(v instanceof y.UserDataSyncError)switch(v.code){case"TooLarge":v=new y.UserDataSyncError(v.message,v.code,d.resource),A=!0;break;case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":A=!0;break}const O=y.UserDataSyncError.toUserDataSyncError(v);if(this.reportUserDataSyncError(O,r),A)throw O;this.logService.error(v),this.logService.error(`${d.resource}: ${(0,R.toErrorMessage)(v)}`),this._syncErrors.push([d.resource,O])}}this.logService.info(`Sync done. Took ${new Date().getTime()-l}ms`),this.updateLastSyncTime()}catch(h){const d=y.UserDataSyncError.toUserDataSyncError(h);throw this.reportUserDataSyncError(d,r),d}finally{this.updateStatus(),this._onSyncErrors.fire(this._syncErrors)}}async stop(){if(this.status!=="idle")for(const n of this.synchronisers)try{n.status!=="idle"&&await n.stop()}catch(r){this.logService.error(r)}}async replace(n){await this.checkEnablement();for(const r of this.synchronisers)if(await r.replace(n))return}async accept(n,r,c,l){await this.checkEnablement();const h=this.getSynchroniser(n);await h.accept(r,c),l&&await h.apply(!1,(0,y.createSyncHeaders)((0,b.generateUuid)()))}async resolveContent(n){for(const r of this.synchronisers){const c=await r.resolveContent(n);if(c)return c}return null}getRemoteSyncResourceHandles(n){return this.getSynchroniser(n).getRemoteSyncResourceHandles()}getLocalSyncResourceHandles(n){return this.getSynchroniser(n).getLocalSyncResourceHandles()}getAssociatedResources(n,r){return this.getSynchroniser(n).getAssociatedResources(r)}getMachineId(n,r){return this.getSynchroniser(n).getMachineId(r)}async hasLocalData(){const n=[this.settingsSynchroniser,this.keybindingsSynchroniser,this.snippetsSynchroniser,this.extensionsSynchroniser];for(const r of n)if(await r.hasLocalData())return!0;return!1}async reset(){await this.checkEnablement(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){await this.checkEnablement();try{await this.userDataSyncStoreService.clear(),this.logService.info("Cleared data on server")}catch(n){this.logService.error(n)}this._onDidResetRemote.fire()}async resetLocal(){await this.checkEnablement(),this.storageService.remove(S,0);for(const n of this.synchronisers)try{await n.resetLocal()}catch(r){this.logService.error(`${n.resource}: ${(0,R.toErrorMessage)(r)}`),this.logService.error(r)}this._onDidResetLocal.fire(),this.logService.info("Did reset the local sync state.")}async hasPreviouslySynced(){for(const n of this.synchronisers)if(await n.hasPreviouslySynced())return!0;return!1}setStatus(n){const r=this._status;this._status!==n&&(this._status=n,this._onDidChangeStatus.fire(n),r==="hasConflicts"&&this.updateLastSyncTime())}updateStatus(){this.updateConflicts();const n=this.computeStatus();this.setStatus(n)}updateConflicts(){const n=this.computeConflicts();(0,D.equals)(this._conflicts,n,([r,c],[l,h])=>r===r&&(0,D.equals)(c,h,(d,v)=>(0,m.isEqual)(d.previewResource,v.previewResource)))||(this._conflicts=this.computeConflicts(),this._onDidChangeConflicts.fire(n))}computeStatus(){return this.userDataSyncStoreManagementService.userDataSyncStore?this.synchronisers.some(n=>n.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(n=>n.status==="syncing")?"syncing":"idle":"uninitialized"}updateLastSyncTime(){this.status==="idle"&&(this._lastSyncTime=new Date().getTime(),this.storageService.store(S,this._lastSyncTime,0,1),this._onDidChangeLastSyncTime.fire(this._lastSyncTime))}reportUserDataSyncError(n,r){this.telemetryService.publicLog2("sync/error",{code:n.code,serverCode:n instanceof y.UserDataSyncStoreError?String(n.serverCode):void 0,url:n instanceof y.UserDataSyncStoreError?n.url:void 0,resource:n.resource,executionId:r,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()})}computeConflicts(){return this.synchronisers.filter(n=>n.status==="hasConflicts").map(n=>[n.resource,n.conflicts.map(t)])}getSynchroniser(n){return this.synchronisers.find(r=>r.resource===n)}async checkEnablement(){if(!this.userDataSyncStoreManagementService.userDataSyncStore)throw new Error("Not enabled")}};o=de([X(0,y.IUserDataSyncStoreService),X(1,y.IUserDataSyncStoreManagementService),X(2,i.IInstantiationService),X(3,y.IUserDataSyncLogService),X(4,f.ITelemetryService),X(5,C.IStorageService)],o),e.UserDataSyncService=o;class a extends P.Disposable{constructor(n,r,c,l,h){super();this.id=n,this.manifest=r,this.syncHeaders=c,this.synchronisers=l,this.logService=h,this.synchronizingResources=[],this._onSynchronizeResources=this._register(new k.Emitter),this.onSynchronizeResources=this._onSynchronizeResources.event,this.isDisposed=!1}get status(){return this.synchronisers.some(n=>n.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(n=>n.status==="syncing")?"syncing":"idle"}async preview(){try{if(this.isDisposed)throw new Error("Disposed");return this.previewsPromise||(this.previewsPromise=(0,T.createCancelablePromise)(n=>this.getPreviews(n))),this.previews||(this.previews=await this.previewsPromise),this.previews}catch(n){throw this.logService.error(n),n}}async accept(n,r){try{return await this.performAction(n,c=>c.accept(n,r))}catch(c){throw this.logService.error(c),c}}async merge(n){try{return n?await this.performAction(n,r=>r.merge(n)):await this.mergeAll()}catch(r){throw this.logService.error(r),r}}async discard(n){try{return await this.performAction(n,r=>r.discard(n))}catch(r){throw this.logService.error(r),r}}async discardConflicts(){try{if(!this.previews)throw new Error("Missing preview. Create preview and try again.");if(this.synchronizingResources.length)throw new Error("Cannot discard while synchronizing resources");const n=[];for(const[,r]of this.previews)for(const c of r.resourcePreviews)c.mergeState==="conflict"&&n.push(c.previewResource);for(const r of n)await this.discard(r);return this.previews}catch(n){throw this.logService.error(n),n}}async apply(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");const n=[];for(const[r,c]of this.previews){this.synchronizingResources.push([r,c.resourcePreviews.map(d=>d.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const l=this.synchronisers.find(d=>d.resource===r);for(const d of c.resourcePreviews)(d.localChange!==0||d.remoteChange!==0)&&d.mergeState==="preview"&&await l.merge(d.previewResource);const h=await l.apply(!1,this.syncHeaders);h&&n.push(this.toSyncResourcePreview(l.resource,h)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(d=>d[0]===r),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=n,this.previews}catch(n){throw this.logService.error(n),n}}async pull(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[n,r]of this.previews){this.synchronizingResources.push([n,r.resourcePreviews.map(l=>l.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const c=this.synchronisers.find(l=>l.resource===n);for(const l of r.resourcePreviews)await c.accept(l.remoteResource);await c.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(l=>l[0]===n),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(n){throw this.logService.error(n),n}}async push(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[n,r]of this.previews){this.synchronizingResources.push([n,r.resourcePreviews.map(l=>l.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const c=this.synchronisers.find(l=>l.resource===n);for(const l of r.resourcePreviews)await c.accept(l.localResource);await c.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(l=>l[0]===n),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(n){throw this.logService.error(n),n}}async stop(){for(const n of this.synchronisers)try{await n.stop()}catch(r){(0,L.isPromiseCanceledError)(r)||this.logService.error(r)}this.reset()}async performAction(n,r){if(!this.previews)throw new Error("Missing preview. Create preview and try again.");const c=this.previews.findIndex(([,U])=>U.resourcePreviews.some(({localResource:F,previewResource:$,remoteResource:H})=>(0,m.isEqual)(n,F)||(0,m.isEqual)(n,$)||(0,m.isEqual)(n,H)));if(c===-1)return this.previews;const[l,h]=this.previews[c],d=h.resourcePreviews.find(({localResource:U,remoteResource:F,previewResource:$})=>(0,m.isEqual)(U,n)||(0,m.isEqual)(F,n)||(0,m.isEqual)($,n));if(!d)return this.previews;let v=this.synchronizingResources.find(U=>U[0]===l);v||(v=[l,[]],this.synchronizingResources.push(v)),v[1].some(U=>(0,m.isEqual)(U,d.localResource))||(v[1].push(d.localResource),this._onSynchronizeResources.fire(this.synchronizingResources));const A=this.synchronisers.find(U=>U.resource===this.previews[c][0]),O=await r(A);O?this.previews.splice(c,1,this.toSyncResourcePreview(A.resource,O)):this.previews.splice(c,1);const p=this.synchronizingResources.findIndex(U=>U[0]===l);return this.synchronizingResources[p][1].splice(v[1].findIndex(U=>(0,m.isEqual)(U,d.localResource)),1),v[1].length||(this.synchronizingResources.splice(p,1),this._onSynchronizeResources.fire(this.synchronizingResources)),this.previews}async mergeAll(){if(!this.previews)throw new Error("You need to create preview before merging or applying");if(this.synchronizingResources.length)throw new Error("Cannot merge or apply while synchronizing resources");const n=[];for(const[r,c]of this.previews){this.synchronizingResources.push([r,c.resourcePreviews.map(d=>d.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const l=this.synchronisers.find(d=>d.resource===r);let h=c;for(const d of c.resourcePreviews)(d.localChange!==0||d.remoteChange!==0)&&d.mergeState==="preview"&&(h=await l.merge(d.previewResource));h&&n.push(this.toSyncResourcePreview(l.resource,h)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(d=>d[0]===r),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=n,this.previews}async getPreviews(n){const r=[];for(const c of this.synchronisers){if(n.isCancellationRequested)return[];const l=await c.preview(this.manifest,this.syncHeaders);l&&r.push(this.toSyncResourcePreview(c.resource,l))}return r}toSyncResourcePreview(n,r){return[n,{isLastSyncFromCurrentMachine:r.isLastSyncFromCurrentMachine,resourcePreviews:r.resourcePreviews.map(t)}]}reset(){this.previewsPromise&&(this.previewsPromise.cancel(),this.previewsPromise=void 0),this.previews=void 0,this.synchronizingResources=[]}dispose(){this.reset(),this.isDisposed=!0}}function t(s){return{localResource:s.localResource,previewResource:s.previewResource,remoteResource:s.remoteResource,acceptedResource:s.acceptedResource,localChange:s.localChange,remoteChange:s.remoteChange,mergeState:s.mergeState}}}),define(Z[211],ee([0,1,3,2,17,5,23]),function(K,e,D,T,R,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncChannelClient=e.UserDataSyncChannel=void 0;class P{constructor(C,f){this.service=C,this.logService=f,this.manualSyncTasks=new Map,this.onManualSynchronizeResources=new D.Emitter}listen(C,f){switch(f){case"onDidChangeStatus":return this.service.onDidChangeStatus;case"onDidChangeConflicts":return this.service.onDidChangeConflicts;case"onDidChangeLocal":return this.service.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.service.onDidChangeLastSyncTime;case"onSyncErrors":return this.service.onSyncErrors;case"onDidResetLocal":return this.service.onDidResetLocal;case"onDidResetRemote":return this.service.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.onManualSynchronizeResources.event}throw new Error(`Event not found: ${f}`)}async call(C,f,I){try{return await this._call(C,f,I)}catch(u){throw this.logService.error(u),u}}async _call(C,f,I){switch(f){case"_getInitialData":return Promise.resolve([this.service.status,this.service.conflicts,this.service.lastSyncTime]);case"replace":return this.service.replace(L.URI.revive(I[0]));case"reset":return this.service.reset();case"resetRemote":return this.service.resetRemote();case"resetLocal":return this.service.resetLocal();case"hasPreviouslySynced":return this.service.hasPreviouslySynced();case"hasLocalData":return this.service.hasLocalData();case"accept":return this.service.accept(I[0],L.URI.revive(I[1]),I[2],I[3]);case"resolveContent":return this.service.resolveContent(L.URI.revive(I[0]));case"getLocalSyncResourceHandles":return this.service.getLocalSyncResourceHandles(I[0]);case"getRemoteSyncResourceHandles":return this.service.getRemoteSyncResourceHandles(I[0]);case"getAssociatedResources":return this.service.getAssociatedResources(I[0],{created:I[1].created,uri:L.URI.revive(I[1].uri)});case"getMachineId":return this.service.getMachineId(I[0],{created:I[1].created,uri:L.URI.revive(I[1].uri)});case"createManualSyncTask":return this.createManualSyncTask()}if(f.startsWith("manualSync/")){const u=f.substring("manualSync/".length),w=I[0],g=this.getManualSyncTask(w);switch(I=I.slice(1),u){case"preview":return g.preview();case"accept":return g.accept(L.URI.revive(I[0]),I[1]);case"merge":return g.merge(L.URI.revive(I[0]));case"discard":return g.discard(L.URI.revive(I[0]));case"discardConflicts":return g.discardConflicts();case"apply":return g.apply();case"pull":return g.pull();case"push":return g.push();case"stop":return g.stop();case"_getStatus":return g.status;case"dispose":return this.disposeManualSyncTask(g)}}throw new Error("Invalid call")}getManualSyncTask(C){const f=this.manualSyncTasks.get(this.createKey(C));if(!f)throw new Error(`Manual sync taks not found: ${C}`);return f.manualSyncTask}async createManualSyncTask(){const C=new T.DisposableStore,f=C.add(await this.service.createManualSyncTask());return C.add(f.onSynchronizeResources(I=>this.onManualSynchronizeResources.fire({manualSyncTaskId:f.id,data:I}))),this.manualSyncTasks.set(this.createKey(f.id),{manualSyncTask:f,disposables:C}),{id:f.id,manifest:f.manifest,status:f.status}}disposeManualSyncTask(C){C.dispose();const f=this.createKey(C.id);this.manualSyncTasks.get(f)?.disposables.dispose(),this.manualSyncTasks.delete(f)}createKey(C){return`manualSyncTask-${C}`}}e.UserDataSyncChannel=P;class m extends T.Disposable{constructor(C){super();this._status="uninitialized",this._onDidChangeStatus=this._register(new D.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new D.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new D.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onSyncErrors=this._register(new D.Emitter),this.onSyncErrors=this._onSyncErrors.event,this.channel={call(f,I,u){return C.call(f,I,u).then(null,w=>{throw k.UserDataSyncError.toUserDataSyncError(w)})},listen(f,I){return C.listen(f,I)}},this.channel.call("_getInitialData").then(([f,I,u])=>{this.updateStatus(f),this.updateConflicts(I),u&&this.updateLastSyncTime(u),this._register(this.channel.listen("onDidChangeStatus")(w=>this.updateStatus(w))),this._register(this.channel.listen("onDidChangeLastSyncTime")(w=>this.updateLastSyncTime(w)))}),this._register(this.channel.listen("onDidChangeConflicts")(f=>this.updateConflicts(f))),this._register(this.channel.listen("onSyncErrors")(f=>this._onSyncErrors.fire(f.map(([I,u])=>[I,k.UserDataSyncError.toUserDataSyncError(u)]))))}get status(){return this._status}get onDidChangeLocal(){return this.channel.listen("onDidChangeLocal")}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}get onDidResetLocal(){return this.channel.listen("onDidResetLocal")}get onDidResetRemote(){return this.channel.listen("onDidResetRemote")}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const{id:C,manifest:f,status:I}=await this.channel.call("createManualSyncTask"),u=this,w=new b(C,f,I,{async call(g,E,y){return u.channel.call(`manualSync/${g}`,[C,...(0,R.isArray)(E)?E:[E]],y)},listen(g,E){return D.Event.map(D.Event.filter(u.channel.listen(`manualSync/${g}`,E),y=>!w.isDiposed()&&y.manualSyncTaskId===C),y=>y.data)}});return w}replace(C){return this.channel.call("replace",[C])}reset(){return this.channel.call("reset")}resetRemote(){return this.channel.call("resetRemote")}resetLocal(){return this.channel.call("resetLocal")}hasPreviouslySynced(){return this.channel.call("hasPreviouslySynced")}hasLocalData(){return this.channel.call("hasLocalData")}accept(C,f,I,u){return this.channel.call("accept",[C,f,I,u])}resolveContent(C){return this.channel.call("resolveContent",[C])}async getLocalSyncResourceHandles(C){return(await this.channel.call("getLocalSyncResourceHandles",[C])).map(({created:I,uri:u})=>({created:I,uri:L.URI.revive(u)}))}async getRemoteSyncResourceHandles(C){return(await this.channel.call("getRemoteSyncResourceHandles",[C])).map(({created:I,uri:u})=>({created:I,uri:L.URI.revive(u)}))}async getAssociatedResources(C,f){return(await this.channel.call("getAssociatedResources",[C,f])).map(({resource:u,comparableResource:w})=>({resource:L.URI.revive(u),comparableResource:L.URI.revive(w)}))}async getMachineId(C,f){return this.channel.call("getMachineId",[C,f])}async updateStatus(C){this._status=C,this._onDidChangeStatus.fire(C)}async updateConflicts(C){this._conflicts=C.map(([f,I])=>[f,I.map(u=>({...u,localResource:L.URI.revive(u.localResource),remoteResource:L.URI.revive(u.remoteResource),previewResource:L.URI.revive(u.previewResource)}))]),this._onDidChangeConflicts.fire(this._conflicts)}updateLastSyncTime(C){this._lastSyncTime!==C&&(this._lastSyncTime=C,this._onDidChangeLastSyncTime.fire(C))}}e.UserDataSyncChannelClient=m;class b extends T.Disposable{constructor(C,f,I,u){super();this.id=C,this.manifest=f,this._disposed=!1,this._status=I;const w=this;this.channel={async call(g,E,y){try{const S=await u.call(g,E,y);return w.isDiposed()||(w._status=await u.call("_getStatus")),S}catch(S){throw k.UserDataSyncError.toUserDataSyncError(S)}},listen(g,E){return u.listen(g,E)}}}get onSynchronizeResources(){return this.channel.listen("onSynchronizeResources")}get status(){return this._status}async preview(){const C=await this.channel.call("preview");return this.deserializePreviews(C)}async accept(C,f){const I=await this.channel.call("accept",[C,f]);return this.deserializePreviews(I)}async merge(C){const f=await this.channel.call("merge",[C]);return this.deserializePreviews(f)}async discard(C){const f=await this.channel.call("discard",[C]);return this.deserializePreviews(f)}async discardConflicts(){const C=await this.channel.call("discardConflicts");return this.deserializePreviews(C)}async apply(){const C=await this.channel.call("apply");return this.deserializePreviews(C)}pull(){return this.channel.call("pull")}push(){return this.channel.call("push")}stop(){return this.channel.call("stop")}isDiposed(){return this._disposed}dispose(){this._disposed=!0,this.channel.call("dispose")}deserializePreviews(C){return C.map(([f,I])=>[f,{isLastSyncFromCurrentMachine:I.isLastSyncFromCurrentMachine,resourcePreviews:I.resourcePreviews.map(u=>({...u,localResource:L.URI.revive(u.localResource),remoteResource:L.URI.revive(u.remoteResource),previewResource:L.URI.revive(u.previewResource),acceptedResource:L.URI.revive(u.acceptedResource)}))}])}}}),define(Z[212],ee([0,1,6,27,9,3,2,95,4,15,17,5,30,21,12,13,29,43,46,22,23]),function(K,e,D,T,R,L,k,P,m,b,i,C,f,I,u,w,g,E,y,S,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const a="sync.previous.store",t="sync.donot-make-requests-until",s="sync.user-session-id",n="sync.machine-session-id",r=100,c=1e3*60*5;let l=class extends k.Disposable{constructor(p,U,F){super();this.productService=p,this.configurationService=U,this.storageService=F,this._onDidChangeUserDataSyncStore=this._register(new L.Emitter),this.onDidChangeUserDataSyncStore=this._onDidChangeUserDataSyncStore.event,this.updateUserDataSyncStore(),this._register(L.Event.filter(F.onDidChangeValue,$=>$.key===o.SYNC_SERVICE_URL_TYPE&&$.scope===0&&this.userDataSyncStoreType!==this.userDataSyncStore?.type)(()=>this.updateUserDataSyncStore()))}get userDataSyncStore(){return this._userDataSyncStore}get userDataSyncStoreType(){return this.storageService.get(o.SYNC_SERVICE_URL_TYPE,0)}set userDataSyncStoreType(p){this.storageService.store(o.SYNC_SERVICE_URL_TYPE,p,0,m.isWeb?0:1)}updateUserDataSyncStore(){this._userDataSyncStore=this.toUserDataSyncStore(this.productService[o.CONFIGURATION_SYNC_STORE_KEY],this.configurationService.getValue(o.CONFIGURATION_SYNC_STORE_KEY)),this._onDidChangeUserDataSyncStore.fire()}toUserDataSyncStore(p,U){p=m.isWeb&&p?.web?{...p,...p.web}:p;const F={...p||{},...U||{}};if(F&&(0,i.isString)(F.url)&&(0,i.isObject)(F.authenticationProviders)&&Object.keys(F.authenticationProviders).every($=>(0,i.isArray)(F.authenticationProviders[$].scopes))){const $=F,H=!!$.canSwitch&&!U?.url,M=$.url===$.insidersUrl?"insiders":"stable",j=(H?this.userDataSyncStoreType:void 0)||M,q=U?.url||(j==="insiders"?$.insidersUrl:j==="stable"?$.stableUrl:$.url);return{url:C.URI.parse(q),type:j,defaultType:M,defaultUrl:C.URI.parse($.url),stableUrl:C.URI.parse($.stableUrl),insidersUrl:C.URI.parse($.insidersUrl),canSwitch:H,authenticationProviders:Object.keys($.authenticationProviders).reduce((z,x)=>(z.push({id:x,scopes:$.authenticationProviders[x].scopes}),z),[])}}}};l=de([X(0,g.IProductService),X(1,I.IConfigurationService),X(2,S.IStorageService)],l),e.AbstractUserDataSyncStoreManagementService=l;let h=class extends l{constructor(p,U,F){super(p,U,F);const $=this.storageService.get(a,0);$&&(this.previousConfigurationSyncStore=JSON.parse($));const H=this.productService[o.CONFIGURATION_SYNC_STORE_KEY];H?this.storageService.store(a,JSON.stringify(H),0,1):this.storageService.remove(a,0)}async switch(p){p!==this.userDataSyncStoreType&&(this.userDataSyncStoreType=p,this.updateUserDataSyncStore())}async getPreviousUserDataSyncStore(){return this.toUserDataSyncStore(this.previousConfigurationSyncStore)}};h=de([X(0,g.IProductService),X(1,I.IConfigurationService),X(2,S.IStorageService)],h),e.UserDataSyncStoreManagementService=h;let d=class extends k.Disposable{constructor(p,U,F,$,H,M,j){super();this.requestService=F,this.logService=$,this.storageService=j,this._onTokenFailed=this._register(new L.Emitter),this.onTokenFailed=this._onTokenFailed.event,this._onTokenSucceed=this._register(new L.Emitter),this.onTokenSucceed=this._onTokenSucceed.event,this._donotMakeRequestsUntil=void 0,this._onDidChangeDonotMakeRequestsUntil=this._register(new L.Emitter),this.onDidChangeDonotMakeRequestsUntil=this._onDidChangeDonotMakeRequestsUntil.event,this.resetDonotMakeRequestsUntilPromise=void 0,this.updateUserDataSyncStoreUrl(p),this.commonHeadersPromise=(0,y.getServiceMachineId)(H,M,j).then(q=>{const z={"X-Client-Name":`${U.applicationName}${m.isWeb?"-web":""}`,"X-Client-Version":U.version};return U.commit&&(z["X-Client-Commit"]=U.commit),z}),this.session=new A(r,c,this.requestService,this.logService),this.initDonotMakeRequestsUntil(),this._register((0,k.toDisposable)(()=>{this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0)}))}get donotMakeRequestsUntil(){return this._donotMakeRequestsUntil}setAuthToken(p,U){this.authToken={token:p,type:U}}updateUserDataSyncStoreUrl(p){this.userDataSyncStoreUrl=p?(0,b.joinPath)(p,"v1"):void 0}initDonotMakeRequestsUntil(){const p=this.storageService.getNumber(t,0);p&&Date.now()<p&&this.setDonotMakeRequestsUntil(new Date(p))}setDonotMakeRequestsUntil(p){this._donotMakeRequestsUntil?.getTime()!==p?.getTime()&&(this._donotMakeRequestsUntil=p,this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0),this._donotMakeRequestsUntil?(this.storageService.store(t,this._donotMakeRequestsUntil.getTime(),0,1),this.resetDonotMakeRequestsUntilPromise=(0,D.createCancelablePromise)(U=>(0,D.timeout)(this._donotMakeRequestsUntil.getTime()-Date.now(),U).then(()=>this.setDonotMakeRequestsUntil(void 0))),this.resetDonotMakeRequestsUntilPromise.then(null,U=>null)):this.storageService.remove(t,0),this._onDidChangeDonotMakeRequestsUntil.fire())}async getAllRefs(p){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const U=(0,b.joinPath)(this.userDataSyncStoreUrl,"resource",p),F={},$=await this.request(U.toString(),{type:"GET",headers:F},[],T.CancellationToken.None);return(await(0,E.asJson)($)||[]).map(({url:M,created:j})=>({ref:(0,b.relativePath)(U,U.with({path:M})),created:j*1e3}))}async resolveContent(p,U){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const F=(0,b.joinPath)(this.userDataSyncStoreUrl,"resource",p,U).toString(),$={};$["Cache-Control"]="no-cache";const H=await this.request(F,{type:"GET",headers:$},[],T.CancellationToken.None);return await(0,E.asText)(H)}async delete(p){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const U=(0,b.joinPath)(this.userDataSyncStoreUrl,"resource",p).toString(),F={};await this.request(U,{type:"DELETE",headers:F},[],T.CancellationToken.None)}async read(p,U,F={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const $=(0,b.joinPath)(this.userDataSyncStoreUrl,"resource",p,"latest").toString();F={...F},F["Cache-Control"]="no-cache",U&&(F["If-None-Match"]=U.ref);const H=await this.request($,{type:"GET",headers:F},[304],T.CancellationToken.None);let M=null;if(H.res.statusCode===304&&(M=U),M===null){const j=H.res.headers.etag;if(!j)throw new o.UserDataSyncStoreError("Server did not return the ref",$,"NoRef",H.res.statusCode,H.res.headers[o.HEADER_OPERATION_ID]);const q=await(0,E.asText)(H);if(!q&&H.res.statusCode===304)throw new o.UserDataSyncStoreError("Empty response",$,"EmptyResponse",H.res.statusCode,H.res.headers[o.HEADER_OPERATION_ID]);M={ref:j,content:q}}return M}async write(p,U,F,$={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const H=(0,b.joinPath)(this.userDataSyncStoreUrl,"resource",p).toString();$={...$},$["Content-Type"]=P.Mimes.text,F&&($["If-Match"]=F);const M=await this.request(H,{type:"POST",data:U,headers:$},[],T.CancellationToken.None),j=M.res.headers.etag;if(!j)throw new o.UserDataSyncStoreError("Server did not return the ref",H,"NoRef",M.res.statusCode,M.res.headers[o.HEADER_OPERATION_ID]);return j}async manifest(p,U={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const F=(0,b.joinPath)(this.userDataSyncStoreUrl,"manifest").toString();U={...U},U["Content-Type"]="application/json",p&&(U["If-None-Match"]=p.ref);const $=await this.request(F,{type:"GET",headers:U},[304],T.CancellationToken.None);let H=null;if($.res.statusCode===304&&(H=p),!H){const j=$.res.headers.etag;if(!j)throw new o.UserDataSyncStoreError("Server did not return the ref",F,"NoRef",$.res.statusCode,$.res.headers[o.HEADER_OPERATION_ID]);const q=await(0,E.asText)($);if(!q&&$.res.statusCode===304)throw new o.UserDataSyncStoreError("Empty response",F,"EmptyResponse",$.res.statusCode,$.res.headers[o.HEADER_OPERATION_ID]);q&&(H={...JSON.parse(q),ref:j})}const M=this.storageService.get(s,0);return M&&H&&M!==H.session&&this.clearSession(),H===null&&M&&this.clearSession(),H&&this.storageService.store(s,H.session,0,1),H}async clear(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const p=(0,b.joinPath)(this.userDataSyncStoreUrl,"resource").toString(),U={"Content-Type":P.Mimes.text};await this.request(p,{type:"DELETE",headers:U},[],T.CancellationToken.None),this.clearSession()}clearSession(){this.storageService.remove(s,0),this.storageService.remove(n,0)}async request(p,U,F,$){if(!this.authToken)throw new o.UserDataSyncStoreError("No Auth Token Available",p,"Unauthorized",void 0,void 0);if(this._donotMakeRequestsUntil&&Date.now()<this._donotMakeRequestsUntil.getTime())throw new o.UserDataSyncStoreError(`${U.type} request '${p}' failed because of too many requests (429).`,p,"TooManyRequestsAndRetryAfter",void 0,void 0);this.setDonotMakeRequestsUntil(void 0);const H=await this.commonHeadersPromise;U.headers={...U.headers||{},...H,"X-Account-Type":this.authToken.type,authorization:`Bearer ${this.authToken.token}`},this.addSessionHeaders(U.headers),this.logService.trace("Sending request to server",{url:p,type:U.type,headers:{...U.headers,authorization:void 0}});let M;try{M=await this.session.request(p,U,$)}catch(x){if(!(x instanceof o.UserDataSyncStoreError)){let N="RequestFailed";const W=(0,R.getErrorMessage)(x).toLowerCase();W.includes("xhr timeout")?N="RequestTimeout":W.includes("protocol")&&W.includes("not supported")?N="RequestProtocolNotSupported":W.includes("request path contains unescaped characters")?N="RequestPathNotEscaped":W.includes("headers must be an object")?N="RequestHeadersNotObject":(0,R.isPromiseCanceledError)(x)&&(N="RequestCanceled"),x=new o.UserDataSyncStoreError(`Connection refused for the request '${p}'.`,p,N,void 0,void 0)}throw this.logService.info("Request failed",p),x}const j=M.res.headers[o.HEADER_OPERATION_ID],q={url:p,status:M.res.statusCode,"execution-id":U.headers[o.HEADER_EXECUTION_ID],"operation-id":j},z=(0,E.isSuccess)(M)||M.res.statusCode&&F.indexOf(M.res.statusCode)!==-1;if(z?this.logService.trace("Request succeeded",q):this.logService.info("Request failed",q),M.res.statusCode===401)throw this.authToken=void 0,this._onTokenFailed.fire(),new o.UserDataSyncStoreError(`Request '${p}' failed because of Unauthorized (401).`,p,"Unauthorized",M.res.statusCode,j);if(this._onTokenSucceed.fire(),M.res.statusCode===409)throw new o.UserDataSyncStoreError(`${U.type} request '${p}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,p,"Conflict",M.res.statusCode,j);if(M.res.statusCode===410)throw new o.UserDataSyncStoreError(`${U.type} request '${p}' failed because the requested resource is not longer available (410).`,p,"Gone",M.res.statusCode,j);if(M.res.statusCode===412)throw new o.UserDataSyncStoreError(`${U.type} request '${p}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,p,"PreconditionFailed",M.res.statusCode,j);if(M.res.statusCode===413)throw new o.UserDataSyncStoreError(`${U.type} request '${p}' failed because of too large payload (413).`,p,"TooLarge",M.res.statusCode,j);if(M.res.statusCode===426)throw new o.UserDataSyncStoreError(`${U.type} request '${p}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,p,"UpgradeRequired",M.res.statusCode,j);if(M.res.statusCode===429){const x=M.res.headers["retry-after"];throw x?(this.setDonotMakeRequestsUntil(new Date(Date.now()+parseInt(x)*1e3)),new o.UserDataSyncStoreError(`${U.type} request '${p}' failed because of too many requests (429).`,p,"TooManyRequestsAndRetryAfter",M.res.statusCode,j)):new o.UserDataSyncStoreError(`${U.type} request '${p}' failed because of too many requests (429).`,p,"RemoteTooManyRequests",M.res.statusCode,j)}if(!z)throw new o.UserDataSyncStoreError("Server returned "+M.res.statusCode,p,"Unknown",M.res.statusCode,j);return M}addSessionHeaders(p){let U=this.storageService.get(n,0);U===void 0&&(U=(0,f.generateUuid)(),this.storageService.store(n,U,0,1)),p["X-Machine-Session-Id"]=U;const F=this.storageService.get(s,0);F!==void 0&&(p["X-User-Session-Id"]=F)}};d=de([X(1,g.IProductService),X(2,E.IRequestService),X(3,o.IUserDataSyncLogService),X(4,u.IEnvironmentService),X(5,w.IFileService),X(6,S.IStorageService)],d),e.UserDataSyncStoreClient=d;let v=class extends d{constructor(p,U,F,$,H,M,j){super(p.userDataSyncStore?.url,U,F,$,H,M,j);this._register(p.onDidChangeUserDataSyncStore(()=>this.updateUserDataSyncStoreUrl(p.userDataSyncStore?.url)))}};v=de([X(0,o.IUserDataSyncStoreManagementService),X(1,g.IProductService),X(2,E.IRequestService),X(3,o.IUserDataSyncLogService),X(4,u.IEnvironmentService),X(5,w.IFileService),X(6,S.IStorageService)],v),e.UserDataSyncStoreService=v;class A{constructor(p,U,F,$){this.limit=p,this.interval=U,this.requestService=F,this.logService=$,this.requests=[],this.startTime=void 0}request(p,U,F){if(this.isExpired()&&this.reset(),U.url=p,this.requests.length>=this.limit)throw this.logService.info("Too many requests",...this.requests),new o.UserDataSyncStoreError(`Too many requests. Only ${this.limit} requests allowed in ${this.interval/(1e3*60)} minutes.`,p,"LocalTooManyRequests",void 0,void 0);return this.startTime=this.startTime||new Date,this.requests.push(p),this.requestService.request(U,F)}isExpired(){return this.startTime!==void 0&&new Date().getTime()-this.startTime.getTime()>this.interval}reset(){this.requests=[],this.startTime=void 0}}e.RequestsSession=A}),define(Z[213],ee([0,1,3,59,29,22,20,89,23,60,61]),function(K,e,D,T,R,L,k,P,m,b,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let C=class extends P.UserDataAutoSyncService{constructor(I,u,w,g,E,y,S,o,a,t,s,n){super(I,u,w,g,E,S,o,a,t,s,n);this._register(D.Event.debounce(D.Event.any(D.Event.map(y.onDidFocusWindow,()=>"windowFocus"),D.Event.map(y.onDidOpenWindow,()=>"windowOpen")),(r,c)=>r?[...r,c]:[c],1e3)(r=>this.triggerSync(r,!0,!1)))}};C=de([X(0,R.IProductService),X(1,m.IUserDataSyncStoreManagementService),X(2,m.IUserDataSyncStoreService),X(3,m.IUserDataSyncResourceEnablementService),X(4,m.IUserDataSyncService),X(5,T.INativeHostService),X(6,m.IUserDataSyncLogService),X(7,b.IUserDataSyncAccountService),X(8,k.ITelemetryService),X(9,i.IUserDataSyncMachinesService),X(10,L.IStorageService),X(11,m.IUserDataAutoSyncEnablementService)],C),e.UserDataAutoSyncService=C}),define(Z[214],ee([0,1,6,3,2]),function(K,e,D,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class L extends R.Disposable{constructor({onDidOpenWindow:P,onDidFocusWindow:m,getActiveWindowId:b}){super();this.disposables=this._register(new R.DisposableStore),T.Event.latch(T.Event.any(P,m))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,D.createCancelablePromise)(()=>b()),(async()=>{try{const C=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:C}catch(C){}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(P){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=P}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=L}),define(Z[62],ee([0,1,51,6,8,17,19,110,222,223]),function(K,e,D,T,R,L,k,P,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class i extends Error{constructor(t,s){let n=s.message;switch(t){case"CorruptZip":n=`Corrupt ZIP: ${n}`;break}super(n);this.type=t,this.cause=s}}e.ExtractError=i;function C(a){const t=a.externalFileAttributes>>16||33188;return[448,56,7].map(s=>t&s).reduce((s,n)=>s+n,t&61440)}function f(a){if(a instanceof i)return a;let t;return/end of central directory record signature not found/.test(a.message)&&(t="CorruptZip"),new i(t,a)}function I(a,t,s,n,r,c){const l=R.dirname(t),h=R.join(n,l);if(!h.startsWith(n))return Promise.reject(new Error(P.localize(0,null,t)));const d=R.join(n,t);let v;return c.onCancellationRequested(()=>{v&&v.destroy()}),Promise.resolve(k.Promises.mkdir(h,{recursive:!0})).then(()=>new Promise((A,O)=>{if(!c.isCancellationRequested)try{v=(0,D.createWriteStream)(d,{mode:s}),v.once("close",()=>A()),v.once("error",O),a.once("error",O),a.pipe(v)}catch(p){O(p)}}))}function u(a,t,s,n){let r=(0,T.createCancelablePromise)(()=>Promise.resolve()),c=0;return n.onCancellationRequested(()=>{r.cancel(),a.close()}),new Promise((l,h)=>{const d=new T.Sequencer,v=A=>{A.isCancellationRequested||(c++,a.readEntry())};a.once("error",h),a.once("close",()=>r.then(()=>{n.isCancellationRequested||a.entryCount===c?l():h(new i("Incomplete",new Error(P.localize(1,null,c,a.entryCount))))},h)),a.readEntry(),a.on("entry",A=>{if(n.isCancellationRequested)return;if(!s.sourcePathRegex.test(A.fileName)){v(n);return}const O=A.fileName.replace(s.sourcePathRegex,"");if(/\/$/.test(O)){const F=R.join(t,O);r=(0,T.createCancelablePromise)($=>k.Promises.mkdir(F,{recursive:!0}).then(()=>v($)).then(void 0,h));return}const p=g(a,A),U=C(A);r=(0,T.createCancelablePromise)(F=>d.queue(()=>p.then($=>I($,O,U,t,s,F).then(()=>v(F)))).then(null,h))})})}function w(a,t=!1){return new Promise((s,n)=>{(0,m.open)(a,t?{lazyEntries:!0}:void 0,(r,c)=>{r?n(f(r)):s((0,L.assertIsDefined)(c))})})}function g(a,t){return new Promise((s,n)=>{a.openReadStream(t,(r,c)=>{r?n(f(r)):s((0,L.assertIsDefined)(c))})})}function E(a,t){return new Promise((s,n)=>{const r=new b.ZipFile;t.forEach(l=>{l.contents?r.addBuffer(typeof l.contents=="string"?Buffer.from(l.contents,"utf8"):l.contents,l.path):l.localPath&&r.addFile(l.localPath,l.path)}),r.end();const c=(0,D.createWriteStream)(a);r.outputStream.pipe(c),r.outputStream.once("error",n),c.once("error",n),c.once("finish",()=>s(a))})}e.zip=E;function y(a,t,s={},n){const r=new RegExp(s.sourcePath?`^${s.sourcePath}`:"");let c=w(a,!0);return s.overwrite&&(c=c.then(l=>k.Promises.rm(t).then(()=>l))),c.then(l=>u(l,t,{sourcePathRegex:r},n))}e.extract=y;function S(a,t){return w(a).then(s=>new Promise((n,r)=>{s.on("entry",c=>{c.fileName===t&&g(s,c).then(l=>n(l),l=>r(l))}),s.once("close",()=>r(new Error(P.localize(2,null,t))))}))}function o(a,t){return S(a,t).then(s=>new Promise((n,r)=>{const c=[];s.once("error",r),s.on("data",l=>c.push(l)),s.on("end",()=>n(Buffer.concat(c)))}))}e.buffer=o}),define(Z[215],ee([0,1,62,118]),function(K,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function R(L){return(0,D.buffer)(L,"extension/package.json").then(k=>{try{return JSON.parse(k.toString("utf8"))}catch(P){throw new Error((0,T.localize)(0,null))}})}e.getManifest=R}),define(Z[216],ee([0,1,16,6,9,2,18,8,4,15,58,5,30,19,62,119,12,28,32,140,13,14,29]),function(K,e,D,T,R,L,k,P,m,b,i,C,f,I,u,w,g,E,y,S,o,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScanner=void 0;const s="scanningSystem",n="scanningUser",r="extracting",c="deleting",l="renaming";let h=class extends L.Disposable{constructor(v,A,O,p,U){super();this.beforeRemovingExtension=v,this.fileService=A,this.logService=O,this.environmentService=p,this.productService=U,this._devSystemExtensionsPath=null,this.systemExtensionsPath=p.builtinExtensionsPath,this.extensionsPath=p.extensionsPath,this.uninstalledPath=P.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new T.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(v){const A=[];(v===null||v===0)&&A.push(this.scanSystemExtensions().then(null,O=>Promise.reject(new E.ExtensionManagementError(this.joinErrors(O).message,s)))),(v===null||v===1)&&A.push(this.scanUserExtensions(!0).then(null,O=>Promise.reject(new E.ExtensionManagementError(this.joinErrors(O).message,n))));try{const O=await Promise.all(A);return(0,D.flatten)(O)}catch(O){throw this.joinErrors(O)}}async scanUserExtensions(v){this.logService.trace("Started scanning user extensions");let[A,O]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return O=O.filter(p=>!A[new y.ExtensionIdentifierWithVersion(p.identifier,p.manifest.version).key()]),v&&(O=(0,y.groupByExtension)(O,U=>U.identifier).map(U=>U.sort((F,$)=>i.rcompare(F.manifest.version,$.manifest.version))[0])),this.logService.trace("Scanned user extensions:",O.length),O}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(v,A,O,p){const U=v.key(),F=P.join(this.extensionsPath,`.${(0,f.generateUuid)()}`),$=P.join(this.extensionsPath,U);try{await I.Promises.rm($)}catch(M){try{await I.Promises.rm($)}catch(j){}throw new E.ExtensionManagementError((0,w.localize)(0,null,$,v.id),c)}await this.extractAtLocation(v,A,F,p);let H=await this.scanExtension(C.URI.file(F),1);if(!H)throw new Error((0,w.localize)(1,null,F));await this.storeMetadata(H,{...O,installedTimestamp:Date.now()});try{await this.rename(v,F,$,Date.now()+2*60*1e3),this.logService.info("Renamed to",$)}catch(M){try{await I.Promises.rm(F)}catch(j){}if(M.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",v.id);else throw this.logService.info(`Rename failed because of ${(0,R.getErrorMessage)(M)}. Deleted from extracted location`,F),M}try{H=await this.scanExtension(C.URI.file($),1)}catch(M){}if(H)return H;throw new Error((0,w.localize)(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(v,A){return this.setMetadata(v,A),await this.storeMetadata(v,{...A,installedTimestamp:v.installedTimestamp}),v}async storeMetadata(v,A){A.isMachineScoped=A.isMachineScoped||void 0,A.isBuiltin=A.isBuiltin||void 0,A.installedTimestamp=A.installedTimestamp||void 0;const O=P.join(v.location.fsPath,"package.json"),p=await I.Promises.readFile(O,"utf8"),{manifest:U}=await this.parseManifest(p);return U.__metadata=A,await I.Promises.writeFile(O,JSON.stringify(U,null,"	")),v}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...v){const A=v.map(O=>new y.ExtensionIdentifierWithVersion(O.identifier,O.manifest.version));await this.withUninstalledExtensions(O=>{A.forEach(p=>O[p.key()]=!0)})}async setInstalled(v){await this.withUninstalledExtensions(p=>delete p[v.key()]);const O=(await this.scanExtensions(1)).find(p=>new y.ExtensionIdentifierWithVersion(p.identifier,p.manifest.version).equals(v))||null;return O?(await this.storeMetadata(O,{installedTimestamp:Date.now()}),this.scanExtension(O.location,1)):null}async withUninstalledExtensions(v){return this.uninstalledFileLimiter.queue(async()=>{let A;try{A=await I.Promises.readFile(this.uninstalledPath,"utf8")}catch(p){if(p.code!=="ENOENT")throw p}let O={};if(A)try{O=JSON.parse(A)}catch(p){}return v&&(v(O),Object.keys(O).length?await I.Promises.writeFile(this.uninstalledPath,JSON.stringify(O)):await I.Promises.rm(this.uninstalledPath)),O})}async removeExtension(v,A){this.logService.trace(`Deleting ${A} extension from disk`,v.identifier.id,v.location.fsPath),await I.Promises.rm(v.location.fsPath),this.logService.info("Deleted from disk",v.identifier.id,v.location.fsPath)}async removeUninstalledExtension(v){await this.removeExtension(v,"uninstalled"),await this.withUninstalledExtensions(A=>delete A[new y.ExtensionIdentifierWithVersion(v.identifier,v.manifest.version).key()])}async extractAtLocation(v,A,O,p){this.logService.trace(`Started extracting the extension from ${A} to ${O}`);try{await I.Promises.rm(O)}catch(U){throw new E.ExtensionManagementError(this.joinErrors(U).message,c)}try{await(0,u.extract)(A,O,{sourcePath:"extension",overwrite:!0},p),this.logService.info(`Extracted extension to ${O}:`,v.id)}catch(U){try{await I.Promises.rm(O)}catch(F){}throw new E.ExtensionManagementError(U.message,U instanceof u.ExtractError&&U.type?U.type:r)}}async rename(v,A,O,p){try{await I.Promises.rename(A,O)}catch(U){if(m.isWindows&&U&&U.code==="EPERM"&&Date.now()<p)return this.logService.info(`Failed renaming ${A} to ${O} with 'EPERM' error. Trying again...`,v.id),this.rename(v,A,O,p);throw new E.ExtensionManagementError(U.message||(0,w.localize)(3,null,A,O),U.code||l)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const v=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return v;const A=this.scanDevSystemExtensions(),[O,p]=await Promise.all([v,A]);return[...O,...p]}async scanExtensionsInDir(v,A){const O=new T.Limiter(10),p=await this.fileService.resolve(C.URI.file(v));return p.children?(await Promise.all(p.children.filter(F=>F.isDirectory).map(F=>O.queue(async()=>A===1&&(0,b.basename)(F.resource).indexOf(".")===0?null:this.scanExtension(F.resource,A))))).filter(F=>F&&F.identifier):[]}async scanExtension(v,A){try{const O=await this.fileService.resolve(v);if(O.children){const{manifest:p,metadata:U}=await this.readManifest(v.fsPath),F=O.children.find(({name:j})=>/^readme(\.txt|\.md|)$/i.test(j))?.resource,$=O.children.find(({name:j})=>/^changelog(\.txt|\.md|)$/i.test(j))?.resource,H={id:(0,y.getGalleryExtensionId)(p.publisher,p.name)},M={type:A,identifier:H,manifest:p,location:v,readmeUrl:F,changelogUrl:$,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:A===0};return U&&(this.setMetadata(M,U),M.installedTimestamp=U.installedTimestamp),M}}catch(O){A!==0&&this.logService.trace(O)}return null}async scanDefaultSystemExtensions(){const v=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",v.length),v}async scanDevSystemExtensions(){const v=this.getDevSystemExtensionsList();if(v.length){const A=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",A.length),A.filter(O=>v.some(p=>(0,y.areSameExtensions)(O.identifier,{id:p})))}else return[]}setMetadata(v,A){v.publisherDisplayName=A.publisherDisplayName||null,v.publisherId=A.publisherId||null,v.identifier.uuid=A.id,v.isMachineScoped=!!A.isMachineScoped,v.isBuiltin=v.type===0||!!A.isBuiltin}async removeUninstalledExtensions(){const v=await this.getUninstalledExtensions(),A=await this.scanAllUserExtensions(),O=new Set;for(const F of A)v[new y.ExtensionIdentifierWithVersion(F.identifier,F.manifest.version).key()]||O.add(F.identifier.id.toLowerCase());const p=(0,y.groupByExtension)(A,F=>F.identifier);await T.Promises.settled(p.map(async F=>{const $=F.sort((H,M)=>i.rcompare(H.manifest.version,M.manifest.version))[0];O.has($.identifier.id.toLowerCase())||await this.beforeRemovingExtension($)}));const U=A.filter(F=>v[new y.ExtensionIdentifierWithVersion(F.identifier,F.manifest.version).key()]);await T.Promises.settled(U.map(F=>this.removeUninstalledExtension(F)))}async removeOutdatedExtensions(){const v=await this.scanAllUserExtensions(),A=[],O=(0,y.groupByExtension)(v,p=>p.identifier);A.push(...(0,D.flatten)(O.map(p=>p.sort((U,F)=>i.rcompare(U.manifest.version,F.manifest.version)).slice(1)))),await T.Promises.settled(A.map(p=>this.removeExtension(p,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(v=>v.name)}joinErrors(v){const A=Array.isArray(v)?v:[v];return A.length===1?A[0]instanceof Error?A[0]:new Error(A[0]):A.reduce((O,p)=>new Error(`${O.message}${O.message?",":""}${p instanceof Error?p.message:p}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=P.normalize(P.join(k.FileAccess.asFileUri("",K).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(v){const A=[I.Promises.readFile(P.join(v,"package.json"),"utf8").then(F=>this.parseManifest(F)),I.Promises.readFile(P.join(v,"package.nls.json"),"utf8").then(void 0,F=>F.code!=="ENOENT"?Promise.reject(F):"{}").then(F=>JSON.parse(F))],[{manifest:O,metadata:p},U]=await Promise.all(A);return{manifest:(0,S.localizeManifest)(O,U),metadata:p}}parseManifest(v){return new Promise((A,O)=>{try{const p=JSON.parse(v),U=p.__metadata||null;A({manifest:p,metadata:U})}catch(p){O(new Error((0,w.localize)(4,null)))}})}};h=de([X(1,o.IFileService),X(2,a.ILogService),X(3,g.INativeEnvironmentService),X(4,t.IProductService)],h),e.ExtensionsScanner=h}),define(Z[217],ee([0,1,37,9,18,8,4,31,15,58,5,30,19,62,117,74,12,183,28,32,164,165,215,152,216,166,72,13,7,14,42,20]),function(K,e,D,T,R,L,k,P,m,b,i,C,f,I,u,w,g,E,y,S,o,a,t,s,n,r,c,l,h,d,v,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementService=void 0;const O="unsetUninstalled",p="downloading";let U=class extends E.AbstractExtensionManagementService{constructor(q,z,x,N,W,_,Y){super(q,z,x);this.environmentService=N,this.downloadService=W,this.fileService=Y;const G=this._register(_.createInstance(a.ExtensionsLifecycle));this.extensionsScanner=this._register(_.createInstance(n.ExtensionsScanner,te=>G.postUninstall(te))),this.manifestCache=this._register(new s.ExtensionsManifestCache(N,this)),this.extensionsDownloader=this._register(_.createInstance(o.ExtensionsDownloader));const ne=this._register(new r.ExtensionsWatcher(this,Y,N,x));this._register(ne.onDidChangeExtensionsByAnotherSource(({added:te,removed:J})=>{te.length&&this._onDidInstallExtensions.fire(te.map(V=>({identifier:V.identifier,operation:0,local:V}))),J.forEach(V=>this._onDidUninstallExtension.fire({identifier:V}))}))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(async()=>{const q=await this.isAlpineLinux(),z=(0,y.getTargetPlatform)(q?"alpine":k.platform,P.arch);return this.logService.debug("ExtensionManagementService#TargetPlatform:",z),z})()),this._targetPlatformPromise}async isAlpineLinux(){if(!k.isLinux)return!1;let q;try{q=(await this.fileService.readFile(i.URI.file("/etc/os-release"))).value.toString()}catch(z){try{q=(await this.fileService.readFile(i.URI.file("/usr/lib/os-release"))).value.toString()}catch(x){this.logService.debug("Error while getting the os-release file.",(0,T.getErrorMessage)(x))}}return!!q&&(q.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async zip(q){this.logService.trace("ExtensionManagementService#zip",q.identifier.id);const z=await this.collectFiles(q),x=await(0,I.zip)((0,m.joinPath)(this.environmentService.tmpDir,(0,C.generateUuid)()).fsPath,z);return i.URI.file(x)}async unzip(q){return this.logService.trace("ExtensionManagementService#unzip",q.toString()),(await this.install(q)).identifier}async getManifest(q){const z=await this.downloadVsix(q),x=L.resolve(z.fsPath);return(0,t.getManifest)(x)}getInstalled(q=null){return this.extensionsScanner.scanExtensions(q)}async install(q,z={}){this.logService.trace("ExtensionManagementService#install",q.toString());const x=await this.downloadVsix(q),N=await(0,t.getManifest)(L.resolve(x.fsPath));if(N.engines&&N.engines.vscode&&!(0,c.isEngineValid)(N.engines.vscode,v.default.version,v.default.date))throw new Error(u.localize(0,null,(0,S.getGalleryExtensionId)(N.publisher,N.name),v.default.version));return this.installExtension(N,x,z)}async updateMetadata(q,z){return this.logService.trace("ExtensionManagementService#updateMetadata",q.identifier.id),q=await this.extensionsScanner.saveMetadataForLocalExtension(q,{...q.manifest.__metadata||{},...z}),this.manifestCache.invalidate(),q}async updateExtensionScope(q,z){return this.logService.trace("ExtensionManagementService#updateExtensionScope",q.identifier.id),q=await this.extensionsScanner.saveMetadataForLocalExtension(q,{...q.manifest.__metadata||{},isMachineScoped:z}),this.manifestCache.invalidate(),q}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async downloadVsix(q){if(q.scheme===R.Schemas.file)return q;const z=(0,m.joinPath)(this.environmentService.tmpDir,(0,C.generateUuid)());return await this.downloadService.download(q,z),z}createInstallExtensionTask(q,z,x){return i.URI.isUri(z)?new H(q,z,x,this.galleryService,this.extensionsScanner,this.logService):new $(z,x,this.extensionsDownloader,this.extensionsScanner,this.logService)}createUninstallExtensionTask(q,z){return new M(q,z,this.extensionsScanner)}async collectFiles(q){const z=async N=>{let W=await f.Promises.readdir(N);W=W.map(G=>L.join(N,G));const _=await Promise.all(W.map(G=>f.Promises.stat(G)));let Y=Promise.resolve([]);return _.forEach((G,ne)=>{const te=W[ne];G.isFile()&&(Y=Y.then(J=>[...J,te])),G.isDirectory()&&(Y=Y.then(J=>z(te).then(V=>[...J,...V])))}),Y};return(await z(q.location.fsPath)).map(N=>({path:`extension/${L.relative(q.location.fsPath,N)}`,localPath:N}))}};U=de([X(0,y.IExtensionGalleryService),X(1,A.ITelemetryService),X(2,d.ILogService),X(3,g.INativeEnvironmentService),X(4,w.IDownloadService),X(5,h.IInstantiationService),X(6,l.IFileService)],U),e.ExtensionManagementService=U;class F extends E.AbstractExtensionTask{constructor(q,z,x,N){super();this.identifier=q,this.source=z,this.extensionsScanner=x,this.logService=N,this._operation=1}get operation(){return this._operation}async installExtension(q,z){try{const x=await this.unsetUninstalledAndGetLocal(q.identifierWithVersion);if(x)return q.metadata?this.extensionsScanner.saveMetadataForLocalExtension(x,q.metadata):x}catch(x){throw k.isMacintosh?new y.ExtensionManagementError(u.localize(1,null),O):new y.ExtensionManagementError(u.localize(2,null),O)}return this.extract(q,z)}async unsetUninstalledAndGetLocal(q){if(!await this.isUninstalled(q))return null;this.logService.trace("Removing the extension from uninstalled list:",q.id);const x=await this.extensionsScanner.setInstalled(q);return this.logService.info("Removed the extension from uninstalled list:",q.id),x}async isUninstalled(q){return!!(await this.extensionsScanner.getUninstalledExtensions())[q.key()]}async extract({zipPath:q,identifierWithVersion:z,metadata:x},N){let W=await this.extensionsScanner.extractUserExtension(z,q,x,N);return this.logService.info("Extracting completed.",z.id),W}}class $ extends F{constructor(q,z,x,N,W){super(q.identifier,q,N,W);this.gallery=q,this.options=z,this.extensionsDownloader=x}async doRun(q){const x=(await this.extensionsScanner.scanExtensions(null)).find(_=>(0,S.areSameExtensions)(_.identifier,this.gallery.identifier));x&&(this._operation=2);const N=await this.downloadInstallableExtension(this.gallery,this._operation);N.metadata.isMachineScoped=this.options.isMachineScoped||x?.isMachineScoped,N.metadata.isBuiltin=this.options.isBuiltin||x?.isBuiltin;const W=await this.installExtension(N,q);x&&b.neq(x.manifest.version,this.gallery.version)&&await this.extensionsScanner.setUninstalled(x);try{await this.extensionsDownloader.delete(i.URI.file(N.zipPath))}catch(_){}return W}async downloadInstallableExtension(q,z){const x={id:q.identifier.uuid,publisherId:q.publisherId,publisherDisplayName:q.publisherDisplayName};let N;try{this.logService.trace("Started downloading extension:",q.identifier.id),N=(await this.extensionsDownloader.downloadExtension(q,z)).fsPath,this.logService.info("Downloaded extension:",q.identifier.id,N)}catch(W){throw new y.ExtensionManagementError((0,E.joinErrors)(W).message,p)}try{const W=await(0,t.getManifest)(N);return{zipPath:N,identifierWithVersion:new S.ExtensionIdentifierWithVersion(q.identifier,W.version),metadata:x}}catch(W){throw new y.ExtensionManagementError((0,E.joinErrors)(W).message,E.INSTALL_ERROR_VALIDATING)}}}class H extends F{constructor(q,z,x,N,W,_){super({id:(0,S.getGalleryExtensionId)(q.publisher,q.name)},z,W,_);this.manifest=q,this.location=z,this.options=x,this.galleryService=N}async doRun(q){const z=new S.ExtensionIdentifierWithVersion(this.identifier,this.manifest.version),N=(await this.extensionsScanner.scanExtensions(1)).find(_=>(0,S.areSameExtensions)(this.identifier,_.identifier)),W=await this.getMetadata(this.identifier.id,q);if(W.isMachineScoped=this.options.isMachineScoped||N?.isMachineScoped,W.isBuiltin=this.options.isBuiltin||N?.isBuiltin,N)if(this._operation=2,z.equals(new S.ExtensionIdentifierWithVersion(N.identifier,N.manifest.version)))try{await this.extensionsScanner.removeExtension(N,"existing")}catch(_){throw new Error(u.localize(3,null,this.manifest.displayName||this.manifest.name))}else b.gt(N.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(N);else{const _=await this.unsetUninstalledAndGetLocal(z);if(_)try{await this.extensionsScanner.removeExtension(_,"existing")}catch(Y){throw new Error(u.localize(4,null,this.manifest.displayName||this.manifest.name))}}return this.installExtension({zipPath:L.resolve(this.location.fsPath),identifierWithVersion:z,metadata:W},q)}async getMetadata(q,z){try{const x=(await this.galleryService.query({names:[q],pageSize:1},z)).firstPage[0];if(x)return{id:x.identifier.uuid,publisherDisplayName:x.publisherDisplayName,publisherId:x.publisherId}}catch(x){}return{}}}class M extends E.AbstractExtensionTask{constructor(q,z,x){super();this.extension=q,this.options=z,this.extensionsScanner=x}async doRun(q){const z=[],x=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const N=new S.ExtensionIdentifierWithVersion(this.extension.identifier,this.extension.manifest.version);z.push(...x.filter(W=>N.equals(new S.ExtensionIdentifierWithVersion(W.identifier,W.manifest.version))))}else z.push(...x.filter(N=>(0,S.areSameExtensions)(N.identifier,this.extension.identifier)));if(!z.length)throw new Error(u.localize(5,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...z),this.options.remove)for(const N of z)try{q.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(N)}catch(W){throw new Error(u.localize(6,null,(0,D.toErrorMessage)(W)))}}}}),define(Z[224],ee([0,1,104,51,225,35,37,9,2,18,15,5,36,103,171,150,172,161,162,163,148,153,21,174,73,182,74,176,12,138,178,185,28,151,184,217,75,141,13,168,170,53,7,158,78,159,160,57,167,14,79,59,42,29,175,43,22,180,181,20,82,83,84,44,186,187,85,189,195,87,88,89,23,60,206,207,208,61,209,210,211,212,213,214]),function(K,e,D,T,R,L,k,P,m,b,i,C,f,I,u,w,g,E,y,S,o,a,t,s,n,r,c,l,h,d,v,A,O,p,U,F,$,H,M,j,q,z,x,N,W,_,Y,G,ne,te,J,V,re,ie,ce,ue,ye,ge,Ie,Pe,Ee,Ae,De,Te,Ne,_e,$e,xe,Q,ae,oe,pe,Se,Oe,Le,Ue,ke,B,se,le,he,me,be,ve){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class we extends m.Disposable{constructor(fe){super();this.configuration=fe,this.server=this._register(new I.Server),(0,R.gracefulify)(T),this.registerListeners()}registerListeners(){const fe=()=>this.dispose();process.once("exit",fe),D.ipcRenderer.once("vscode:electron-main->shared-process=exit",fe)}async open(){const fe=await this.initServices();(0,Se.registerConfiguration)(),fe.invokeFunction(Fe=>{const Me=Fe.get(te.ILogService);Me.trace("sharedProcess configuration",JSON.stringify(this.configuration)),this.initChannels(Fe),this.registerErrorHandler(Me)}),this._register((0,m.combinedDisposable)(fe.createInstance(u.CodeCacheCleaner,this.configuration.codeCachePath),fe.createInstance(g.LanguagePackCachedDataCleaner),fe.createInstance(S.StorageDataCleaner,this.configuration.backupWorkspacesPath),fe.createInstance(y.LogsDataCleaner),fe.createInstance(E.LocalizationsUpdater),fe.createInstance(w.DeprecatedExtensionsCleaner)))}async initServices(){const fe=new W.ServiceCollection,Fe={_serviceBrand:void 0,...re.default};fe.set(ie.IProductService,Fe);const Me=new f.StaticRouter(Ve=>Ve==="main"),ze=new _.MessagePortMainProcessService(this.server,Me);fe.set(Y.IMainProcessService,ze);const qe=new d.NativeEnvironmentService(this.configuration.args,Fe);fe.set(h.INativeEnvironmentService,qe);const et=new J.LogLevelChannelClient(this.server.getChannel("logLevel",Me)),He=new J.LoggerChannelClient(this.configuration.logLevel,et.onDidChangeLogLevel,ze.getChannel("logger"));fe.set(te.ILoggerService,He);const nt=this._register(new te.MultiplexLogService([this._register(new te.ConsoleLogger(this.configuration.logLevel)),this._register(He.createLogger((0,i.joinPath)(C.URI.file(qe.logsPath),"sharedprocess.log"),{name:"sharedprocess"}))])),Ge=this._register(new J.FollowerLogService(et,nt));fe.set(te.ILogService,Ge);const Ke=this._register(new j.FileService(Ge));fe.set(M.IFileService,Ke);const it=this._register(new q.DiskFileSystemProvider(Ge));Ke.registerProvider(b.Schemas.file,it);const We=this._register(new s.ConfigurationService(qe.settingsResource,Ke));fe.set(t.IConfigurationService,We),await We.initialize();const Xe=new ge.NativeStorageService(void 0,ze,qe);fe.set(ye.IStorageService,Xe),await Xe.initialize(),this._register((0,m.toDisposable)(()=>Xe.flush())),fe.set(ue.IRequestService,new z.SyncDescriptor(ce.RequestService)),fe.set(o.IChecksumService,new z.SyncDescriptor(a.ChecksumService));const tt=f.ProxyChannel.toService(ze.getChannel("nativeHost"),{context:this.configuration.windowId});fe.set(V.INativeHostService,tt),fe.set(c.IDownloadService,new z.SyncDescriptor(l.DownloadService));const rt=this._register(new ve.ActiveWindowManager(tt)),ft=new f.StaticRouter(Ve=>rt.getActiveClientId().then(st=>Ve===st));fe.set($.IExtensionRecommendationNotificationService,new H.ExtensionRecommendationNotificationServiceChannelClient(this.server.getChannel("extensionRecommendationNotification",ft)));let Qe,Ye,ct=(0,Te.getTelemetryLevel)(Fe,qe);if(ct>=1){Ye=new Ae.TelemetryLogAppender(He,qe);const{appRoot:Ve,extensionsPath:st,installSourcePath:gt}=qe;if(Fe.aiConfig&&Fe.aiConfig.asimovKey&&ct>=2){const lt=new Ne.AppInsightsAppender("monacoworkbench",null,Fe.aiConfig.asimovKey);this._register((0,m.toDisposable)(()=>lt.flush())),Ye=(0,Te.combinedAppender)(lt,Ye)}Qe=new De.TelemetryService({appender:Ye,commonProperties:(0,Ie.resolveCommonProperties)(Ke,(0,L.release)(),(0,L.hostname)(),process.arch,Fe.commit,Fe.version,this.configuration.machineId,Fe.msftInternalDomains,gt),sendErrorTelemetry:!0,piiPaths:[Ve,st]},We)}else Qe=Te.NullTelemetryService,Ye=Te.NullAppender;this.server.registerChannel("telemetryAppender",new Ee.TelemetryAppenderChannel(Ye)),fe.set(Pe.ITelemetryService,Qe);const dt=new _e.CustomEndpointTelemetryService(We,Qe,He,qe);return fe.set(Pe.ICustomEndpointTelemetryService,dt),fe.set(O.IExtensionManagementService,new z.SyncDescriptor(F.ExtensionManagementService)),fe.set(O.IExtensionGalleryService,new z.SyncDescriptor(A.ExtensionGalleryService)),fe.set(O.IExtensionTipsService,new z.SyncDescriptor(U.ExtensionTipsService)),fe.set(G.ILocalizationsService,new z.SyncDescriptor(ne.LocalizationsService)),fe.set(n.IDiagnosticsService,new z.SyncDescriptor(r.DiagnosticsService)),fe.set(Oe.IUserDataSyncAccountService,new z.SyncDescriptor(Oe.UserDataSyncAccountService)),fe.set(Se.IUserDataSyncLogService,new z.SyncDescriptor(ke.UserDataSyncLogService)),fe.set(Se.IUserDataSyncUtilService,new Ue.UserDataSyncUtilServiceClient(this.server.getChannel("userDataSyncUtil",Ve=>Ve.ctx!=="main"))),fe.set(O.IGlobalExtensionEnablementService,new z.SyncDescriptor(v.GlobalExtensionEnablementService)),fe.set(oe.IIgnoredExtensionsManagementService,new z.SyncDescriptor(oe.IgnoredExtensionsManagementService)),fe.set(ae.IExtensionsStorageSyncService,new z.SyncDescriptor(ae.ExtensionsStorageSyncService)),fe.set(Se.IUserDataSyncStoreManagementService,new z.SyncDescriptor(me.UserDataSyncStoreManagementService)),fe.set(Se.IUserDataSyncStoreService,new z.SyncDescriptor(me.UserDataSyncStoreService)),fe.set(B.IUserDataSyncMachinesService,new z.SyncDescriptor(B.UserDataSyncMachinesService)),fe.set(Se.IUserDataSyncBackupStoreService,new z.SyncDescriptor(Le.UserDataSyncBackupStoreService)),fe.set(Se.IUserDataAutoSyncEnablementService,new z.SyncDescriptor(pe.UserDataAutoSyncEnablementService)),fe.set(Se.IUserDataSyncResourceEnablementService,new z.SyncDescriptor(se.UserDataSyncResourceEnablementService)),fe.set(Se.IUserDataSyncService,new z.SyncDescriptor(le.UserDataSyncService)),fe.set(xe.ILocalPtyService,this._register(new Q.PtyHostService({graceTime:6e4,shortGraceTime:6e3,scrollback:We.getValue("terminal.integrated.persistentSessionScrollback")??100},We,Ge,Qe))),new N.InstantiationService(fe)}initChannels(fe){const Fe=new p.ExtensionManagementChannel(fe.get(O.IExtensionManagementService),()=>null);this.server.registerChannel("extensions",Fe);const Me=f.ProxyChannel.fromService(fe.get(G.ILocalizationsService));this.server.registerChannel("localizations",Me);const ze=f.ProxyChannel.fromService(fe.get(n.IDiagnosticsService));this.server.registerChannel("diagnostics",ze);const qe=new p.ExtensionTipsChannel(fe.get(O.IExtensionTipsService));this.server.registerChannel("extensionTipsService",qe);const et=f.ProxyChannel.fromService(fe.get(o.IChecksumService));this.server.registerChannel("checksum",et);const He=new Ue.UserDataSyncMachinesServiceChannel(fe.get(B.IUserDataSyncMachinesService));this.server.registerChannel("userDataSyncMachines",He);const nt=f.ProxyChannel.fromService(fe.get(Pe.ICustomEndpointTelemetryService));this.server.registerChannel("customEndpointTelemetry",nt);const Ge=new Ue.UserDataSyncAccountServiceChannel(fe.get(Oe.IUserDataSyncAccountService));this.server.registerChannel("userDataSyncAccount",Ge);const Ke=new Ue.UserDataSyncStoreManagementServiceChannel(fe.get(Se.IUserDataSyncStoreManagementService));this.server.registerChannel("userDataSyncStoreManagement",Ke);const it=new he.UserDataSyncChannel(fe.get(Se.IUserDataSyncService),fe.get(te.ILogService));this.server.registerChannel("userDataSync",it);const We=this._register(fe.get(x.IInstantiationService).createInstance(be.UserDataAutoSyncService)),Xe=new Ue.UserDataAutoSyncChannel(We);this.server.registerChannel("userDataAutoSync",Xe);const tt=fe.get(xe.ILocalPtyService),rt=f.ProxyChannel.fromService(tt);this.server.registerChannel($e.TerminalIpcChannels.LocalPty,rt)}registerErrorHandler(fe){window.addEventListener("unhandledrejection",Fe=>{(0,P.onUnexpectedError)(Fe.reason),Fe.preventDefault()}),(0,P.setUnexpectedErrorHandler)(Fe=>{const Me=(0,k.toErrorMessage)(Fe,!0);!Me||fe.error(`[uncaught exception in sharedProcess]: ${Me}`)})}}async function Ce(Re){const fe=new we(Re);D.ipcRenderer.send("vscode:shared-process->electron-main=ipc-ready"),await fe.open(),D.ipcRenderer.send("vscode:shared-process->electron-main=init-done")}e.main=Ce})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/54cdd9c58b8cc77f6f9983125ddfacf15d6c82a6/core/vs/code/electron-browser/sharedProcess/sharedProcessMain.js.map
