/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var be=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/base/common/strings","vs/base/common/types","vs/base/common/network","vs/base/common/arrays","vs/workbench/api/common/extHostRpcService","vs/base/common/async","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/path","vs/nls","vs/nls!vs/workbench/services/extensions/worker/extensionHostWorker","vs/base/common/map","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/objects","vs/base/common/resources","vs/platform/extensions/common/extensions","vs/base/common/platform","vs/base/common/glob","vs/platform/registry/common/platform","vs/workbench/api/common/extHostInitDataService","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/codicons","vs/base/common/severity","vs/base/common/uuid","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostTerminalService","vs/workbench/services/search/common/search","vs/base/common/assert","vs/base/common/extpath","vs/editor/common/core/range","vs/platform/contextkey/common/contextkey","vs/platform/theme/common/themeService","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostWebview","vs/base/common/collections","vs/base/common/decorators","vs/base/common/idGenerator","vs/base/common/marshalling","vs/editor/common/modes/languageSelector","vs/base/common/errorMessage","vs/platform/instantiation/common/extensions","vs/base/common/hash","vs/editor/common/modes","vs/platform/files/common/files","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/shared/webview","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/numbers","vs/base/common/htmlContent","vs/base/common/labels","vs/base/common/mime","vs/editor/common/model","vs/editor/common/services/semanticTokensDto","vs/platform/instantiation/common/descriptors","vs/platform/markers/common/markers","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configuration","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testCollection","vs/base/common/process","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/lazy","vs/base/common/skipList","vs/base/common/stream","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/model/textModelSearch","vs/editor/common/core/position","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/tokenizationRegistry","vs/nls!vs/base/common/errorMessage","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/model/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/opener/common/opener","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationModels","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/theme/common/iconRegistry","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/shared/treeDataTransfer","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/editor","vs/workbench/common/views","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/base/common/stopwatch","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostLogService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/editor/common/core/characterClassifier","vs/editor/common/model/mirrorTextModel","vs/editor/common/viewModel/prefixSumComputer","vs/base/common/marked/marked","vs/base/common/linkedList","vs/base/common/iterator","vs/editor/common/modes/linkComputer","vs/editor/common/core/selection","vs/base/common/functional","vs/workbench/services/extensions/worker/extensionHostWorker"],Ee=function(re){for(var e=[],d=0,M=re.length;d<M;d++)e[d]=be[re[d]];return e};define(be[42],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function d(M,b){if(!M)throw new Error(b?`Assertion failed (${b})`:"Assertion Failed")}e.ok=d}),define(be[51],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const d=Object.prototype.hasOwnProperty;function M(t){const E=[];for(let n in t)d.call(t,n)&&E.push(t[n]);return E}e.values=M;function b(t,E){for(let n in t)if(d.call(t,n)&&E({key:n,value:t[n]},function(){delete t[n]})===!1)return}e.forEach=b;function R(t,E){const n=Object.create(null);for(const c of t){const u=E(c);let a=n[u];a||(a=n[u]=[]),a.push(c)}return n}e.groupBy=R;function F(t){const E=Object.create(null);return t&&t.forEach((n,c)=>{E[c]=n}),E}e.fromMap=F;function C(t,E){const n=[],c=[];for(let u of t)E.has(u)||n.push(u);for(let u of E)t.has(u)||c.push(u);return{removed:n,added:c}}e.diffSets=C;function _(t,E){const n=[],c=[];for(let[u,a]of t)E.has(u)||n.push(a);for(let[u,a]of E)t.has(u)||c.push(a);return{removed:n,added:c}}e.diffMaps=_;class I{constructor(){this.map=new Map}add(E,n){let c=this.map.get(E);c||(c=new Set,this.map.set(E,c)),c.add(n)}delete(E,n){const c=this.map.get(E);!c||(c.delete(n),c.size===0&&this.map.delete(E))}forEach(E,n){const c=this.map.get(E);!c||c.forEach(n)}}e.SetMap=I}),define(be[52],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function d(F){return(C,_,I)=>{let t=null,E=null;if(typeof I.value=="function"?(t="value",E=I.value):typeof I.get=="function"&&(t="get",E=I.get),!E)throw new Error("not supported");I[t]=F(E,_)}}e.createDecorator=d;function M(F,C,_){let I=null,t=null;if(typeof _.value=="function"?(I="value",t=_.value,t.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof _.get=="function"&&(I="get",t=_.get),!t)throw new Error("not supported");const E=`$memoize$${C}`;_[I]=function(...n){return this.hasOwnProperty(E)||Object.defineProperty(this,E,{configurable:!1,enumerable:!1,writable:!1,value:t.apply(this,n)}),this[E]}}e.memoize=M;function b(F,C,_){return d((I,t)=>{const E=`$debounce$${t}`,n=`$debounce$result$${t}`;return function(...c){this[n]||(this[n]=_?_():void 0),clearTimeout(this[E]),C&&(this[n]=C(this[n],...c),c=[this[n]]),this[E]=setTimeout(()=>{I.apply(this,c),this[n]=_?_():void 0},F)}})}e.debounce=b;function R(F,C,_){return d((I,t)=>{const E=`$throttle$timer$${t}`,n=`$throttle$result$${t}`,c=`$throttle$lastRun$${t}`,u=`$throttle$pending$${t}`;return function(...a){if(this[n]||(this[n]=_?_():void 0),(this[c]===null||this[c]===void 0)&&(this[c]=-Number.MAX_VALUE),C&&(this[n]=C(this[n],...a)),this[u])return;const w=this[c]+F;w<=Date.now()?(this[c]=Date.now(),I.apply(this,[this[n]]),this[n]=_?_():void 0):(this[u]=!0,this[E]=setTimeout(()=>{this[u]=!1,this[c]=Date.now(),I.apply(this,[this[n]]),this[n]=_?_():void 0},w-Date.now()))}})}e.throttle=R}),define(be[12],Ee([0,1,16]),function(re,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.maxIndex=e.minIndex=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function M(j,le=0){return j[j.length-(1+le)]}e.tail=M;function b(j){if(j.length===0)throw new Error("Invalid tail call");return[j.slice(0,j.length-1),j[j.length-1]]}e.tail2=b;function R(j,le,se=(ve,Fe)=>ve===Fe){if(j===le)return!0;if(!j||!le||j.length!==le.length)return!1;for(let ve=0,Fe=j.length;ve<Fe;ve++)if(!se(j[ve],le[ve]))return!1;return!0}e.equals=R;function F(j,le,se){let ve=0,Fe=j.length-1;for(;ve<=Fe;){const Me=(ve+Fe)/2|0,Ne=se(j[Me],le);if(Ne<0)ve=Me+1;else if(Ne>0)Fe=Me-1;else return Me}return-(ve+1)}e.binarySearch=F;function C(j,le){let se=0,ve=j.length;if(ve===0)return 0;for(;se<ve;){const Fe=Math.floor((se+ve)/2);le(j[Fe])?ve=Fe:se=Fe+1}return se}e.findFirstInSorted=C;function _(j,le,se){if(j=j|0,j>=le.length)throw new TypeError("invalid index");let ve=le[Math.floor(le.length*Math.random())],Fe=[],Me=[],Ne=[];for(let Ye of le){const Ve=se(Ye,ve);Ve<0?Fe.push(Ye):Ve>0?Me.push(Ye):Ne.push(Ye)}return j<Fe.length?_(j,Fe,se):j<Fe.length+Ne.length?Ne[0]:_(j-(Fe.length+Ne.length),Me,se)}e.quickSelect=_;function I(j,le){const se=[];let ve;for(const Fe of j.slice(0).sort(le))!ve||le(ve[0],Fe)!==0?(ve=[Fe],se.push(ve)):ve.push(Fe);return se}e.groupBy=I;function t(j,le,se){const ve=[];function Fe(Ye,Ve,qe){if(Ve===0&&qe.length===0)return;const x=ve[ve.length-1];x&&x.start+x.deleteCount===Ye?(x.deleteCount+=Ve,x.toInsert.push(...qe)):ve.push({start:Ye,deleteCount:Ve,toInsert:qe})}let Me=0,Ne=0;for(;;){if(Me===j.length){Fe(Me,0,le.slice(Ne));break}if(Ne===le.length){Fe(Me,j.length-Me,[]);break}const Ye=j[Me],Ve=le[Ne],qe=se(Ye,Ve);qe===0?(Me+=1,Ne+=1):qe<0?(Fe(Me,1,[]),Me+=1):qe>0&&(Fe(Me,0,[Ve]),Ne+=1)}return ve}e.sortedDiff=t;function E(j,le,se){const ve=t(j,le,se),Fe=[],Me=[];for(const Ne of ve)Fe.push(...j.slice(Ne.start,Ne.start+Ne.deleteCount)),Me.push(...Ne.toInsert);return{removed:Fe,added:Me}}e.delta=E;function n(j,le,se){if(se===0)return[];const ve=j.slice(0,se).sort(le);return u(j,le,ve,se,j.length),ve}e.top=n;function c(j,le,se,ve,Fe){return se===0?Promise.resolve([]):new Promise((Me,Ne)=>{(async()=>{const Ye=j.length,Ve=j.slice(0,se).sort(le);for(let qe=se,x=Math.min(se+ve,Ye);qe<Ye;qe=x,x=Math.min(x+ve,Ye)){if(qe>se&&await new Promise(Q=>setTimeout(Q)),Fe&&Fe.isCancellationRequested)throw(0,d.canceled)();u(j,le,Ve,qe,x)}return Ve})().then(Me,Ne)})}e.topAsync=c;function u(j,le,se,ve,Fe){for(const Me=se.length;ve<Fe;ve++){const Ne=j[ve];if(le(Ne,se[Me-1])<0){se.pop();const Ye=C(se,Ve=>le(Ne,Ve)<0);se.splice(Ye,0,Ne)}}}function a(j){return j.filter(le=>!!le)}e.coalesce=a;function w(j){let le=0;for(let se=0;se<j.length;se++)j[se]&&(j[le]=j[se],le+=1);j.length=le}e.coalesceInPlace=w;function T(j,le,se){j.splice(se,0,j.splice(le,1)[0])}e.move=T;function S(j){return!Array.isArray(j)||j.length===0}e.isFalsyOrEmpty=S;function o(j){return Array.isArray(j)&&j.length>0}e.isNonEmptyArray=o;function f(j,le){if(!le)return j.filter((ve,Fe)=>j.indexOf(ve)===Fe);const se=Object.create(null);return j.filter(ve=>{const Fe=le(ve);return se[Fe]?!1:(se[Fe]=!0,!0)})}e.distinct=f;function y(j){const le=new Set;return j.filter(se=>le.has(se)?!1:(le.add(se),!0))}e.distinctES6=y;function i(j){const le=Object.create(null);return se=>{const ve=j(se);return le[ve]?!1:(le[ve]=!0,!0)}}e.uniqueFilter=i;function v(j,le){for(let se=j.length-1;se>=0;se--){const ve=j[se];if(le(ve))return se}return-1}e.lastIndex=v;function r(j,le){return j.length>0?j[0]:le}e.firstOrDefault=r;function s(j,le,se=(ve,Fe)=>ve===Fe){let ve=0;for(let Fe=0,Me=Math.min(j.length,le.length);Fe<Me&&se(j[Fe],le[Fe]);Fe++)ve++;return ve}e.commonPrefixLength=s;function l(j){return[].concat(...j)}e.flatten=l;function h(j,le){let se=typeof le=="number"?j:0;typeof le=="number"?se=j:(se=0,le=j);const ve=[];if(se<=le)for(let Fe=se;Fe<le;Fe++)ve.push(Fe);else for(let Fe=se;Fe>le;Fe--)ve.push(Fe);return ve}e.range=h;function p(j,le,se){return j.reduce((ve,Fe)=>(ve[le(Fe)]=se?se(Fe):Fe,ve),Object.create(null))}e.index=p;function k(j,le){return j.push(le),()=>P(j,le)}e.insert=k;function P(j,le){const se=j.indexOf(le);if(se>-1)return j.splice(se,1),le}e.remove=P;function g(j,le,se){const ve=j.slice(0,le),Fe=j.slice(le);return ve.concat(se,Fe)}e.arrayInsert=g;function D(j,le){let se;if(typeof le=="number"){let ve=le;se=()=>{const Fe=Math.sin(ve++)*179426549;return Fe-Math.floor(Fe)}}else se=Math.random;for(let ve=j.length-1;ve>0;ve-=1){const Fe=Math.floor(se()*(ve+1)),Me=j[ve];j[ve]=j[Fe],j[Fe]=Me}}e.shuffle=D;function m(j,le){const se=j.indexOf(le);se>-1&&(j.splice(se,1),j.unshift(le))}e.pushToStart=m;function A(j,le){const se=j.indexOf(le);se>-1&&(j.splice(se,1),j.push(le))}e.pushToEnd=A;function L(j,le){return Array.isArray(j)?j.map(le):le(j)}e.mapArrayOrNot=L;function V(j){return Array.isArray(j)?j:[j]}e.asArray=V;function G(j){return j[Math.floor(Math.random()*j.length)]}e.getRandomElement=G;function U(j,le){for(const se of j){const ve=le(se);if(ve!==void 0)return ve}}e.mapFind=U;function K(j,le,se){const ve=B(j,le),Fe=j.length,Me=se.length;j.length=Fe+Me;for(let Ne=Fe-1;Ne>=ve;Ne--)j[Ne+Me]=j[Ne];for(let Ne=0;Ne<Me;Ne++)j[Ne+ve]=se[Ne]}e.insertInto=K;function $(j,le,se,ve){const Fe=B(j,le),Me=j.splice(Fe,se);return K(j,Fe,ve),Me}e.splice=$;function B(j,le){return le<0?Math.max(le+j.length,0):Math.min(le,j.length)}function z(j,le){let se=Number.MAX_SAFE_INTEGER,ve=0;return j.forEach((Fe,Me)=>{const Ne=le(Fe);Ne<se&&(se=Ne,ve=Me)}),ve}e.minIndex=z;function Y(j,le){let se=Number.MIN_SAFE_INTEGER,ve=0;return j.forEach((Fe,Me)=>{const Ne=le(Fe);Ne>se&&(se=Ne,ve=Me)}),ve}e.maxIndex=Y;class ne{constructor(le){this.items=le,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(le){let se=this.firstIdx;for(;se<this.items.length&&le(this.items[se]);)se++;const ve=se===this.firstIdx?null:this.items.slice(this.firstIdx,se);return this.firstIdx=se,ve}takeFromEndWhile(le){let se=this.lastIdx;for(;se>=0&&le(this.items[se]);)se--;const ve=se===this.lastIdx?null:this.items.slice(se+1,this.lastIdx+1);return this.lastIdx=se,ve}}e.ArrayQueue=ne}),define(be[53],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class d{constructor(b){this._prefix=b,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=d,e.defaultGenerator=new d("id#")}),define(be[102],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var d;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(d=e.ScanError||(e.ScanError={}));var M;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(M=e.SyntaxKind||(e.SyntaxKind={}));var b;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(b=e.ParseErrorCode||(e.ParseErrorCode={}));var R;(function(i){i.DEFAULT={allowTrailingComma:!0}})(R=e.ParseOptions||(e.ParseOptions={}));function F(i,v=!1){let r=0,s=i.length,l="",h=0,p=16,k=0;function P(G){let U=0,K=0;for(;U<G;){const $=i.charCodeAt(r);if($>=48&&$<=57)K=K*16+$-48;else if($>=65&&$<=70)K=K*16+$-65+10;else if($>=97&&$<=102)K=K*16+$-97+10;else break;r++,U++}return U<G&&(K=-1),K}function g(G){r=G,l="",h=0,p=16,k=0}function D(){const G=r;if(i.charCodeAt(r)===48)r++;else for(r++;r<i.length&&I(i.charCodeAt(r));)r++;if(r<i.length&&i.charCodeAt(r)===46)if(r++,r<i.length&&I(i.charCodeAt(r)))for(r++;r<i.length&&I(i.charCodeAt(r));)r++;else return k=3,i.substring(G,r);let U=r;if(r<i.length&&(i.charCodeAt(r)===69||i.charCodeAt(r)===101))if(r++,(r<i.length&&i.charCodeAt(r)===43||i.charCodeAt(r)===45)&&r++,r<i.length&&I(i.charCodeAt(r))){for(r++;r<i.length&&I(i.charCodeAt(r));)r++;U=r}else k=3;return i.substring(G,U)}function m(){let G="",U=r;for(;;){if(r>=s){G+=i.substring(U,r),k=2;break}const K=i.charCodeAt(r);if(K===34){G+=i.substring(U,r),r++;break}if(K===92){if(G+=i.substring(U,r),r++,r>=s){k=2;break}switch(i.charCodeAt(r++)){case 34:G+='"';break;case 92:G+="\\";break;case 47:G+="/";break;case 98:G+="\b";break;case 102:G+="\f";break;case 110:G+=`
`;break;case 114:G+="\r";break;case 116:G+="	";break;case 117:const B=P(4);B>=0?G+=String.fromCharCode(B):k=4;break;default:k=5}U=r;continue}if(K>=0&&K<=31)if(_(K)){G+=i.substring(U,r),k=2;break}else k=6;r++}return G}function A(){if(l="",k=0,h=r,r>=s)return h=s,p=17;let G=i.charCodeAt(r);if(C(G)){do r++,l+=String.fromCharCode(G),G=i.charCodeAt(r);while(C(G));return p=15}if(_(G))return r++,l+=String.fromCharCode(G),G===13&&i.charCodeAt(r)===10&&(r++,l+=`
`),p=14;switch(G){case 123:return r++,p=1;case 125:return r++,p=2;case 91:return r++,p=3;case 93:return r++,p=4;case 58:return r++,p=6;case 44:return r++,p=5;case 34:return r++,l=m(),p=10;case 47:const U=r-1;if(i.charCodeAt(r+1)===47){for(r+=2;r<s&&!_(i.charCodeAt(r));)r++;return l=i.substring(U,r),p=12}if(i.charCodeAt(r+1)===42){r+=2;const K=s-1;let $=!1;for(;r<K;){if(i.charCodeAt(r)===42&&i.charCodeAt(r+1)===47){r+=2,$=!0;break}r++}return $||(r++,k=1),l=i.substring(U,r),p=13}return l+=String.fromCharCode(G),r++,p=16;case 45:if(l+=String.fromCharCode(G),r++,r===s||!I(i.charCodeAt(r)))return p=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return l+=D(),p=11;default:for(;r<s&&L(G);)r++,G=i.charCodeAt(r);if(h!==r){switch(l=i.substring(h,r),l){case"true":return p=8;case"false":return p=9;case"null":return p=7}return p=16}return l+=String.fromCharCode(G),r++,p=16}}function L(G){if(C(G)||_(G))return!1;switch(G){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function V(){let G;do G=A();while(G>=12&&G<=15);return G}return{setPosition:g,getPosition:()=>r,scan:v?V:A,getToken:()=>p,getTokenValue:()=>l,getTokenOffset:()=>h,getTokenLength:()=>r-h,getTokenError:()=>k}}e.createScanner=F;function C(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function _(i){return i===10||i===13||i===8232||i===8233}function I(i){return i>=48&&i<=57}var t;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(t||(t={}));function E(i,v){const r=[],s=new Object;let l;const h={value:{},offset:0,length:0,type:"object",parent:void 0};let p=!1;function k(P,g,D,m){h.value=P,h.offset=g,h.length=D,h.type=m,h.colonOffset=void 0,l=h}try{o(i,{onObjectBegin:(P,g)=>{if(v<=P)throw s;l=void 0,p=v>P,r.push("")},onObjectProperty:(P,g,D)=>{if(v<g||(k(P,g,D,"property"),r[r.length-1]=P,v<=g+D))throw s},onObjectEnd:(P,g)=>{if(v<=P)throw s;l=void 0,r.pop()},onArrayBegin:(P,g)=>{if(v<=P)throw s;l=void 0,r.push(0)},onArrayEnd:(P,g)=>{if(v<=P)throw s;l=void 0,r.pop()},onLiteralValue:(P,g,D)=>{if(v<g||(k(P,g,D,y(P)),v<=g+D))throw s},onSeparator:(P,g,D)=>{if(v<=g)throw s;if(P===":"&&l&&l.type==="property")l.colonOffset=g,p=!1,l=void 0;else if(P===","){const m=r[r.length-1];typeof m=="number"?r[r.length-1]=m+1:(p=!0,r[r.length-1]=""),l=void 0}}})}catch(P){if(P!==s)throw P}return{path:r,previousNode:l,isAtPropertyKey:p,matches:P=>{let g=0;for(let D=0;g<P.length&&D<r.length;D++)if(P[g]===r[D]||P[g]==="*")g++;else if(P[g]!=="**")return!1;return g===P.length}}}e.getLocation=E;function n(i,v=[],r=R.DEFAULT){let s=null,l=[];const h=[];function p(P){Array.isArray(l)?l.push(P):s!==null&&(l[s]=P)}return o(i,{onObjectBegin:()=>{const P={};p(P),h.push(l),l=P,s=null},onObjectProperty:P=>{s=P},onObjectEnd:()=>{l=h.pop()},onArrayBegin:()=>{const P=[];p(P),h.push(l),l=P,s=null},onArrayEnd:()=>{l=h.pop()},onLiteralValue:p,onError:(P,g,D)=>{v.push({error:P,offset:g,length:D})}},r),l[0]}e.parse=n;function c(i,v=[],r=R.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function l(P){s.type==="property"&&(s.length=P-s.offset,s=s.parent)}function h(P){return s.children.push(P),P}o(i,{onObjectBegin:P=>{s=h({type:"object",offset:P,length:-1,parent:s,children:[]})},onObjectProperty:(P,g,D)=>{s=h({type:"property",offset:g,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:P,offset:g,length:D,parent:s})},onObjectEnd:(P,g)=>{s.length=P+g-s.offset,s=s.parent,l(P+g)},onArrayBegin:(P,g)=>{s=h({type:"array",offset:P,length:-1,parent:s,children:[]})},onArrayEnd:(P,g)=>{s.length=P+g-s.offset,s=s.parent,l(P+g)},onLiteralValue:(P,g,D)=>{h({type:y(P),offset:g,length:D,parent:s,value:P}),l(g+D)},onSeparator:(P,g,D)=>{s.type==="property"&&(P===":"?s.colonOffset=g:P===","&&l(g))},onError:(P,g,D)=>{v.push({error:P,offset:g,length:D})}},r);const k=s.children[0];return k&&delete k.parent,k}e.parseTree=c;function u(i,v){if(!i)return;let r=i;for(let s of v)if(typeof s=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let l=!1;for(const h of r.children)if(Array.isArray(h.children)&&h.children[0].value===s){r=h.children[1],l=!0;break}if(!l)return}else{const l=s;if(r.type!=="array"||l<0||!Array.isArray(r.children)||l>=r.children.length)return;r=r.children[l]}return r}e.findNodeAtLocation=u;function a(i){if(!i.parent||!i.parent.children)return[];const v=a(i.parent);if(i.parent.type==="property"){const r=i.parent.children[0].value;v.push(r)}else if(i.parent.type==="array"){const r=i.parent.children.indexOf(i);r!==-1&&v.push(r)}return v}e.getNodePath=a;function w(i){switch(i.type){case"array":return i.children.map(w);case"object":const v=Object.create(null);for(let r of i.children){const s=r.children[1];s&&(v[r.children[0].value]=w(s))}return v;case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.getNodeValue=w;function T(i,v,r=!1){return v>=i.offset&&v<i.offset+i.length||r&&v===i.offset+i.length}e.contains=T;function S(i,v,r=!1){if(T(i,v,r)){const s=i.children;if(Array.isArray(s))for(let l=0;l<s.length&&s[l].offset<=v;l++){const h=S(s[l],v,r);if(h)return h}return i}}e.findNodeAtOffset=S;function o(i,v,r=R.DEFAULT){const s=F(i,!1);function l(se){return se?()=>se(s.getTokenOffset(),s.getTokenLength()):()=>!0}function h(se){return se?ve=>se(ve,s.getTokenOffset(),s.getTokenLength()):()=>!0}const p=l(v.onObjectBegin),k=h(v.onObjectProperty),P=l(v.onObjectEnd),g=l(v.onArrayBegin),D=l(v.onArrayEnd),m=h(v.onLiteralValue),A=h(v.onSeparator),L=l(v.onComment),V=h(v.onError),G=r&&r.disallowComments,U=r&&r.allowTrailingComma;function K(){for(;;){const se=s.scan();switch(s.getTokenError()){case 4:$(14);break;case 5:$(15);break;case 3:$(13);break;case 1:G||$(11);break;case 2:$(12);break;case 6:$(16);break}switch(se){case 12:case 13:G?$(10):L();break;case 16:$(1);break;case 15:case 14:break;default:return se}}}function $(se,ve=[],Fe=[]){if(V(se),ve.length+Fe.length>0){let Me=s.getToken();for(;Me!==17;){if(ve.indexOf(Me)!==-1){K();break}else if(Fe.indexOf(Me)!==-1)break;Me=K()}}}function B(se){const ve=s.getTokenValue();return se?m(ve):k(ve),K(),!0}function z(){switch(s.getToken()){case 11:let se=0;try{se=JSON.parse(s.getTokenValue()),typeof se!="number"&&($(2),se=0)}catch(ve){$(2)}m(se);break;case 7:m(null);break;case 8:m(!0);break;case 9:m(!1);break;default:return!1}return K(),!0}function Y(){return s.getToken()!==10?($(3,[],[2,5]),!1):(B(!1),s.getToken()===6?(A(":"),K(),le()||$(4,[],[2,5])):$(5,[],[2,5]),!0)}function ne(){p(),K();let se=!1;for(;s.getToken()!==2&&s.getToken()!==17;){if(s.getToken()===5){if(se||$(4,[],[]),A(","),K(),s.getToken()===2&&U)break}else se&&$(6,[],[]);Y()||$(4,[],[2,5]),se=!0}return P(),s.getToken()!==2?$(7,[2],[]):K(),!0}function j(){g(),K();let se=!1;for(;s.getToken()!==4&&s.getToken()!==17;){if(s.getToken()===5){if(se||$(4,[],[]),A(","),K(),s.getToken()===4&&U)break}else se&&$(6,[],[]);le()||$(4,[],[4,5]),se=!0}return D(),s.getToken()!==4?$(8,[4],[]):K(),!0}function le(){switch(s.getToken()){case 3:return j();case 1:return ne();case 10:return B(!0);default:return z()}}return K(),s.getToken()===17?r.allowEmptyContent?!0:($(4,[],[]),!1):le()?(s.getToken()!==17&&$(9,[],[]),!0):($(4,[],[]),!1)}e.visit=o;function f(i,v){let r=F(i),s=[],l,h=0,p;do switch(p=r.getPosition(),l=r.scan(),l){case 12:case 13:case 17:h!==p&&s.push(i.substring(h,p)),v!==void 0&&s.push(r.getTokenValue().replace(/[^\r\n]/g,v)),h=r.getPosition();break}while(l!==17);return s.join("")}e.stripComments=f;function y(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=y}),define(be[103],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class d{constructor(b){this.executor=b,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(b){this._error=b}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(b){return new d(()=>b(this.getValue()))}}e.Lazy=d}),function(re,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(re=typeof globalThis!="undefined"?globalThis:re||self,re.marked=e())}(this,function(){"use strict";function re(Pe,Se){for(var De=0;De<Se.length;De++){var ee=Se[De];ee.enumerable=ee.enumerable||!1,ee.configurable=!0,"value"in ee&&(ee.writable=!0),Object.defineProperty(Pe,ee.key,ee)}}function e(Pe,Se,De){return Se&&re(Pe.prototype,Se),De&&re(Pe,De),Pe}function d(Pe,Se){if(!!Pe){if(typeof Pe=="string")return M(Pe,Se);var De=Object.prototype.toString.call(Pe).slice(8,-1);if(De==="Object"&&Pe.constructor&&(De=Pe.constructor.name),De==="Map"||De==="Set")return Array.from(Pe);if(De==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(De))return M(Pe,Se)}}function M(Pe,Se){(Se==null||Se>Pe.length)&&(Se=Pe.length);for(var De=0,ee=new Array(Se);De<Se;De++)ee[De]=Pe[De];return ee}function b(Pe,Se){var De=typeof Symbol!="undefined"&&Pe[Symbol.iterator]||Pe["@@iterator"];if(De)return(De=De.call(Pe)).next.bind(De);if(Array.isArray(Pe)||(De=d(Pe))||Se&&Pe&&typeof Pe.length=="number"){De&&(Pe=De);var ee=0;return function(){return ee>=Pe.length?{done:!0}:{done:!1,value:Pe[ee++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}var R={exports:{}};function F(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function C(Pe){R.exports.defaults=Pe}R.exports={defaults:F(),getDefaults:F,changeDefaults:C};var _=/[&<>"']/,I=/[&<>"']/g,t=/[<>"']|&(?!#?\w+;)/,E=/[<>"']|&(?!#?\w+;)/g,n={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},c=function(Se){return n[Se]};function u(Pe,Se){if(Se){if(_.test(Pe))return Pe.replace(I,c)}else if(t.test(Pe))return Pe.replace(E,c);return Pe}var a=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function w(Pe){return Pe.replace(a,function(Se,De){return De=De.toLowerCase(),De==="colon"?":":De.charAt(0)==="#"?De.charAt(1)==="x"?String.fromCharCode(parseInt(De.substring(2),16)):String.fromCharCode(+De.substring(1)):""})}var T=/(^|[^\[])\^/g;function S(Pe,Se){Pe=Pe.source||Pe,Se=Se||"";var De={replace:function(ue,pe){return pe=pe.source||pe,pe=pe.replace(T,"$1"),Pe=Pe.replace(ue,pe),De},getRegex:function(){return new RegExp(Pe,Se)}};return De}var o=/[^\w:]/g,f=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function y(Pe,Se,De){if(Pe){var ee;try{ee=decodeURIComponent(w(De)).replace(o,"").toLowerCase()}catch(ue){return null}if(ee.indexOf("javascript:")===0||ee.indexOf("vbscript:")===0||ee.indexOf("data:")===0)return null}Se&&!f.test(De)&&(De=l(Se,De));try{De=encodeURI(De).replace(/%25/g,"%")}catch(ue){return null}return De}var i={},v=/^[^:]+:\/*[^/]*$/,r=/^([^:]+:)[\s\S]*$/,s=/^([^:]+:\/*[^/]*)[\s\S]*$/;function l(Pe,Se){i[" "+Pe]||(v.test(Pe)?i[" "+Pe]=Pe+"/":i[" "+Pe]=P(Pe,"/",!0)),Pe=i[" "+Pe];var De=Pe.indexOf(":")===-1;return Se.substring(0,2)==="//"?De?Se:Pe.replace(r,"$1")+Se:Se.charAt(0)==="/"?De?Se:Pe.replace(s,"$1")+Se:Pe+Se}var h={exec:function(){}};function p(Pe){for(var Se=1,De,ee;Se<arguments.length;Se++){De=arguments[Se];for(ee in De)Object.prototype.hasOwnProperty.call(De,ee)&&(Pe[ee]=De[ee])}return Pe}function k(Pe,Se){var De=Pe.replace(/\|/g,function(pe,me,Ie){for(var Be=!1,Oe=me;--Oe>=0&&Ie[Oe]==="\\";)Be=!Be;return Be?"|":" |"}),ee=De.split(/ \|/),ue=0;if(ee[0].trim()||ee.shift(),ee[ee.length-1].trim()||ee.pop(),ee.length>Se)ee.splice(Se);else for(;ee.length<Se;)ee.push("");for(;ue<ee.length;ue++)ee[ue]=ee[ue].trim().replace(/\\\|/g,"|");return ee}function P(Pe,Se,De){var ee=Pe.length;if(ee===0)return"";for(var ue=0;ue<ee;){var pe=Pe.charAt(ee-ue-1);if(pe===Se&&!De)ue++;else if(pe!==Se&&De)ue++;else break}return Pe.substr(0,ee-ue)}function g(Pe,Se){if(Pe.indexOf(Se[1])===-1)return-1;for(var De=Pe.length,ee=0,ue=0;ue<De;ue++)if(Pe[ue]==="\\")ue++;else if(Pe[ue]===Se[0])ee++;else if(Pe[ue]===Se[1]&&(ee--,ee<0))return ue;return-1}function D(Pe){Pe&&Pe.sanitize&&!Pe.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function m(Pe,Se){if(Se<1)return"";for(var De="";Se>1;)Se&1&&(De+=Pe),Se>>=1,Pe+=Pe;return De+Pe}var A={escape:u,unescape:w,edit:S,cleanUrl:y,resolveUrl:l,noopTest:h,merge:p,splitCells:k,rtrim:P,findClosingBracket:g,checkSanitizeDeprecation:D,repeatString:m},L=R.exports.defaults,V=A.rtrim,G=A.splitCells,U=A.escape,K=A.findClosingBracket;function $(Pe,Se,De,ee){var ue=Se.href,pe=Se.title?U(Se.title):null,me=Pe[1].replace(/\\([\[\]])/g,"$1");if(Pe[0].charAt(0)!=="!"){ee.state.inLink=!0;var Ie={type:"link",raw:De,href:ue,title:pe,text:me,tokens:ee.inlineTokens(me,[])};return ee.state.inLink=!1,Ie}else return{type:"image",raw:De,href:ue,title:pe,text:U(me)}}function B(Pe,Se){var De=Pe.match(/^(\s+)(?:```)/);if(De===null)return Se;var ee=De[1];return Se.split(`
`).map(function(ue){var pe=ue.match(/^\s+/);if(pe===null)return ue;var me=pe[0];return me.length>=ee.length?ue.slice(ee.length):ue}).join(`
`)}var z=function(){function Pe(De){this.options=De||L}var Se=Pe.prototype;return Se.space=function(ee){var ue=this.rules.block.newline.exec(ee);if(ue)return ue[0].length>1?{type:"space",raw:ue[0]}:{raw:`
`}},Se.code=function(ee){var ue=this.rules.block.code.exec(ee);if(ue){var pe=ue[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ue[0],codeBlockStyle:"indented",text:this.options.pedantic?pe:V(pe,`
`)}}},Se.fences=function(ee){var ue=this.rules.block.fences.exec(ee);if(ue){var pe=ue[0],me=B(pe,ue[3]||"");return{type:"code",raw:pe,lang:ue[2]?ue[2].trim():ue[2],text:me}}},Se.heading=function(ee){var ue=this.rules.block.heading.exec(ee);if(ue){var pe=ue[2].trim();if(/#$/.test(pe)){var me=V(pe,"#");(this.options.pedantic||!me||/ $/.test(me))&&(pe=me.trim())}var Ie={type:"heading",raw:ue[0],depth:ue[1].length,text:pe,tokens:[]};return this.lexer.inline(Ie.text,Ie.tokens),Ie}},Se.hr=function(ee){var ue=this.rules.block.hr.exec(ee);if(ue)return{type:"hr",raw:ue[0]}},Se.blockquote=function(ee){var ue=this.rules.block.blockquote.exec(ee);if(ue){var pe=ue[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:ue[0],tokens:this.lexer.blockTokens(pe,[]),text:pe}}},Se.list=function(ee){var ue=this.rules.block.list.exec(ee);if(ue){var pe,me,Ie,Be,Oe,je,et,Le,de,ge,J=ue[1].trim(),W=J.length>1,we={type:"list",raw:"",ordered:W,start:W?+J.slice(0,-1):"",loose:!1,items:[]};J=W?"\\d{1,9}\\"+J.slice(-1):"\\"+J,this.options.pedantic&&(J=W?J:"[*+-]");for(var ke=new RegExp("^( {0,3}"+J+")((?: [^\\n]*| *)(?:\\n[^\\n]*)*(?:\\n|$))");ee&&!(this.rules.block.hr.test(ee)||!(ue=ke.exec(ee)));){de=ue[2].split(`
`),this.options.pedantic?(Be=2,ge=de[0].trimLeft()):(Be=ue[2].search(/[^ ]/),Be=ue[1].length+(Be>4?1:Be),ge=de[0].slice(Be-ue[1].length)),je=!1,pe=ue[0],!de[0]&&/^ *$/.test(de[1])&&(pe=ue[1]+de.slice(0,2).join(`
`)+`
`,we.loose=!0,de=[]);var Je=new RegExp("^ {0,"+Math.min(3,Be-1)+"}(?:[*+-]|\\d{1,9}[.)])");for(Oe=1;Oe<de.length;Oe++){if(Le=de[Oe],this.options.pedantic&&(Le=Le.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),Je.test(Le)){pe=ue[1]+de.slice(0,Oe).join(`
`)+`
`;break}if(!je){Le.trim()||(je=!0),Le.search(/[^ ]/)>=Be?ge+=`
`+Le.slice(Be):ge+=`
`+Le;continue}if(Le.search(/[^ ]/)>=Be||!Le.trim()){ge+=`
`+Le.slice(Be);continue}else{pe=ue[1]+de.slice(0,Oe).join(`
`)+`
`;break}}we.loose||(et?we.loose=!0:/\n *\n *$/.test(pe)&&(et=!0)),this.options.gfm&&(me=/^\[[ xX]\] /.exec(ge),me&&(Ie=me[0]!=="[ ] ",ge=ge.replace(/^\[[ xX]\] +/,""))),we.items.push({type:"list_item",raw:pe,task:!!me,checked:Ie,loose:!1,text:ge}),we.raw+=pe,ee=ee.slice(pe.length)}we.items[we.items.length-1].raw=pe.trimRight(),we.items[we.items.length-1].text=ge.trimRight(),we.raw=we.raw.trimRight();var $e=we.items.length;for(Oe=0;Oe<$e;Oe++)this.lexer.state.top=!1,we.items[Oe].tokens=this.lexer.blockTokens(we.items[Oe].text,[]),we.items[Oe].tokens.some(function(ut){return ut.type==="space"})&&(we.loose=!0,we.items[Oe].loose=!0);return we}},Se.html=function(ee){var ue=this.rules.block.html.exec(ee);if(ue){var pe={type:"html",raw:ue[0],pre:!this.options.sanitizer&&(ue[1]==="pre"||ue[1]==="script"||ue[1]==="style"),text:ue[0]};return this.options.sanitize&&(pe.type="paragraph",pe.text=this.options.sanitizer?this.options.sanitizer(ue[0]):U(ue[0]),pe.tokens=[],this.lexer.inline(pe.text,pe.tokens)),pe}},Se.def=function(ee){var ue=this.rules.block.def.exec(ee);if(ue){ue[3]&&(ue[3]=ue[3].substring(1,ue[3].length-1));var pe=ue[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:pe,raw:ue[0],href:ue[2],title:ue[3]}}},Se.table=function(ee){var ue=this.rules.block.table.exec(ee);if(ue){var pe={type:"table",header:G(ue[1]).map(function(et){return{text:et}}),align:ue[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ue[3]?ue[3].replace(/\n$/,"").split(`
`):[]};if(pe.header.length===pe.align.length){pe.raw=ue[0];var me=pe.align.length,Ie,Be,Oe,je;for(Ie=0;Ie<me;Ie++)/^ *-+: *$/.test(pe.align[Ie])?pe.align[Ie]="right":/^ *:-+: *$/.test(pe.align[Ie])?pe.align[Ie]="center":/^ *:-+ *$/.test(pe.align[Ie])?pe.align[Ie]="left":pe.align[Ie]=null;for(me=pe.rows.length,Ie=0;Ie<me;Ie++)pe.rows[Ie]=G(pe.rows[Ie],pe.header.length).map(function(et){return{text:et}});for(me=pe.header.length,Be=0;Be<me;Be++)pe.header[Be].tokens=[],this.lexer.inlineTokens(pe.header[Be].text,pe.header[Be].tokens);for(me=pe.rows.length,Be=0;Be<me;Be++)for(je=pe.rows[Be],Oe=0;Oe<je.length;Oe++)je[Oe].tokens=[],this.lexer.inlineTokens(je[Oe].text,je[Oe].tokens);return pe}}},Se.lheading=function(ee){var ue=this.rules.block.lheading.exec(ee);if(ue){var pe={type:"heading",raw:ue[0],depth:ue[2].charAt(0)==="="?1:2,text:ue[1],tokens:[]};return this.lexer.inline(pe.text,pe.tokens),pe}},Se.paragraph=function(ee){var ue=this.rules.block.paragraph.exec(ee);if(ue){var pe={type:"paragraph",raw:ue[0],text:ue[1].charAt(ue[1].length-1)===`
`?ue[1].slice(0,-1):ue[1],tokens:[]};return this.lexer.inline(pe.text,pe.tokens),pe}},Se.text=function(ee){var ue=this.rules.block.text.exec(ee);if(ue){var pe={type:"text",raw:ue[0],text:ue[0],tokens:[]};return this.lexer.inline(pe.text,pe.tokens),pe}},Se.escape=function(ee){var ue=this.rules.inline.escape.exec(ee);if(ue)return{type:"escape",raw:ue[0],text:U(ue[1])}},Se.tag=function(ee){var ue=this.rules.inline.tag.exec(ee);if(ue)return!this.lexer.state.inLink&&/^<a /i.test(ue[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ue[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ue[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ue[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ue[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ue[0]):U(ue[0]):ue[0]}},Se.link=function(ee){var ue=this.rules.inline.link.exec(ee);if(ue){var pe=ue[2].trim();if(!this.options.pedantic&&/^</.test(pe)){if(!/>$/.test(pe))return;var me=V(pe.slice(0,-1),"\\");if((pe.length-me.length)%2==0)return}else{var Ie=K(ue[2],"()");if(Ie>-1){var Be=ue[0].indexOf("!")===0?5:4,Oe=Be+ue[1].length+Ie;ue[2]=ue[2].substring(0,Ie),ue[0]=ue[0].substring(0,Oe).trim(),ue[3]=""}}var je=ue[2],et="";if(this.options.pedantic){var Le=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(je);Le&&(je=Le[1],et=Le[3])}else et=ue[3]?ue[3].slice(1,-1):"";return je=je.trim(),/^</.test(je)&&(this.options.pedantic&&!/>$/.test(pe)?je=je.slice(1):je=je.slice(1,-1)),$(ue,{href:je&&je.replace(this.rules.inline._escapes,"$1"),title:et&&et.replace(this.rules.inline._escapes,"$1")},ue[0],this.lexer)}},Se.reflink=function(ee,ue){var pe;if((pe=this.rules.inline.reflink.exec(ee))||(pe=this.rules.inline.nolink.exec(ee))){var me=(pe[2]||pe[1]).replace(/\s+/g," ");if(me=ue[me.toLowerCase()],!me||!me.href){var Ie=pe[0].charAt(0);return{type:"text",raw:Ie,text:Ie}}return $(pe,me,pe[0],this.lexer)}},Se.emStrong=function(ee,ue,pe){pe===void 0&&(pe="");var me=this.rules.inline.emStrong.lDelim.exec(ee);if(!!me&&!(me[3]&&pe.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Ie=me[1]||me[2]||"";if(!Ie||Ie&&(pe===""||this.rules.inline.punctuation.exec(pe))){var Be=me[0].length-1,Oe,je,et=Be,Le=0,de=me[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(de.lastIndex=0,ue=ue.slice(-1*ee.length+Be);(me=de.exec(ue))!=null;)if(Oe=me[1]||me[2]||me[3]||me[4]||me[5]||me[6],!!Oe){if(je=Oe.length,me[3]||me[4]){et+=je;continue}else if((me[5]||me[6])&&Be%3&&!((Be+je)%3)){Le+=je;continue}if(et-=je,!(et>0)){if(je=Math.min(je,je+et+Le),Math.min(Be,je)%2){var ge=ee.slice(1,Be+me.index+je);return{type:"em",raw:ee.slice(0,Be+me.index+je+1),text:ge,tokens:this.lexer.inlineTokens(ge,[])}}var J=ee.slice(2,Be+me.index+je-1);return{type:"strong",raw:ee.slice(0,Be+me.index+je+1),text:J,tokens:this.lexer.inlineTokens(J,[])}}}}}},Se.codespan=function(ee){var ue=this.rules.inline.code.exec(ee);if(ue){var pe=ue[2].replace(/\n/g," "),me=/[^ ]/.test(pe),Ie=/^ /.test(pe)&&/ $/.test(pe);return me&&Ie&&(pe=pe.substring(1,pe.length-1)),pe=U(pe,!0),{type:"codespan",raw:ue[0],text:pe}}},Se.br=function(ee){var ue=this.rules.inline.br.exec(ee);if(ue)return{type:"br",raw:ue[0]}},Se.del=function(ee){var ue=this.rules.inline.del.exec(ee);if(ue)return{type:"del",raw:ue[0],text:ue[2],tokens:this.lexer.inlineTokens(ue[2],[])}},Se.autolink=function(ee,ue){var pe=this.rules.inline.autolink.exec(ee);if(pe){var me,Ie;return pe[2]==="@"?(me=U(this.options.mangle?ue(pe[1]):pe[1]),Ie="mailto:"+me):(me=U(pe[1]),Ie=me),{type:"link",raw:pe[0],text:me,href:Ie,tokens:[{type:"text",raw:me,text:me}]}}},Se.url=function(ee,ue){var pe;if(pe=this.rules.inline.url.exec(ee)){var me,Ie;if(pe[2]==="@")me=U(this.options.mangle?ue(pe[0]):pe[0]),Ie="mailto:"+me;else{var Be;do Be=pe[0],pe[0]=this.rules.inline._backpedal.exec(pe[0])[0];while(Be!==pe[0]);me=U(pe[0]),pe[1]==="www."?Ie="http://"+me:Ie=me}return{type:"link",raw:pe[0],text:me,href:Ie,tokens:[{type:"text",raw:me,text:me}]}}},Se.inlineText=function(ee,ue){var pe=this.rules.inline.text.exec(ee);if(pe){var me;return this.lexer.state.inRawBlock?me=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(pe[0]):U(pe[0]):pe[0]:me=U(this.options.smartypants?ue(pe[0]):pe[0]),{type:"text",raw:pe[0],text:me}}},Pe}(),Y=A.noopTest,ne=A.edit,j=A.merge,le={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)( [^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,table:Y,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};le._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,le._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,le.def=ne(le.def).replace("label",le._label).replace("title",le._title).getRegex(),le.bullet=/(?:[*+-]|\d{1,9}[.)])/,le.listItemStart=ne(/^( *)(bull) */).replace("bull",le.bullet).getRegex(),le.list=ne(le.list).replace(/bull/g,le.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+le.def.source+")").getRegex(),le._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",le._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,le.html=ne(le.html,"i").replace("comment",le._comment).replace("tag",le._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),le.paragraph=ne(le._paragraph).replace("hr",le.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",le._tag).getRegex(),le.blockquote=ne(le.blockquote).replace("paragraph",le.paragraph).getRegex(),le.normal=j({},le),le.gfm=j({},le.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)\\|?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),le.gfm.table=ne(le.gfm.table).replace("hr",le.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",le._tag).getRegex(),le.pedantic=j({},le.normal,{html:ne(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",le._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:Y,paragraph:ne(le.normal._paragraph).replace("hr",le.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",le.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var se={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:Y,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_*]*?\*[^_*]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^_*]*?\_[^_*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:Y,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};se._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",se.punctuation=ne(se.punctuation).replace(/punctuation/g,se._punctuation).getRegex(),se.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,se.escapedEmSt=/\\\*|\\_/g,se._comment=ne(le._comment).replace("(?:-->|$)","-->").getRegex(),se.emStrong.lDelim=ne(se.emStrong.lDelim).replace(/punct/g,se._punctuation).getRegex(),se.emStrong.rDelimAst=ne(se.emStrong.rDelimAst,"g").replace(/punct/g,se._punctuation).getRegex(),se.emStrong.rDelimUnd=ne(se.emStrong.rDelimUnd,"g").replace(/punct/g,se._punctuation).getRegex(),se._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,se._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,se._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,se.autolink=ne(se.autolink).replace("scheme",se._scheme).replace("email",se._email).getRegex(),se._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,se.tag=ne(se.tag).replace("comment",se._comment).replace("attribute",se._attribute).getRegex(),se._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,se._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,se._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,se.link=ne(se.link).replace("label",se._label).replace("href",se._href).replace("title",se._title).getRegex(),se.reflink=ne(se.reflink).replace("label",se._label).getRegex(),se.reflinkSearch=ne(se.reflinkSearch,"g").replace("reflink",se.reflink).replace("nolink",se.nolink).getRegex(),se.normal=j({},se),se.pedantic=j({},se.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:ne(/^!?\[(label)\]\((.*?)\)/).replace("label",se._label).getRegex(),reflink:ne(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",se._label).getRegex()}),se.gfm=j({},se.normal,{escape:ne(se.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),se.gfm.url=ne(se.gfm.url,"i").replace("email",se.gfm._extended_email).getRegex(),se.breaks=j({},se.gfm,{br:ne(se.br).replace("{2,}","*").getRegex(),text:ne(se.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var ve={block:le,inline:se},Fe=z,Me=R.exports.defaults,Ne=ve.block,Ye=ve.inline,Ve=A.repeatString;function qe(Pe){return Pe.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function x(Pe){var Se="",De,ee,ue=Pe.length;for(De=0;De<ue;De++)ee=Pe.charCodeAt(De),Math.random()>.5&&(ee="x"+ee.toString(16)),Se+="&#"+ee+";";return Se}var Q=function(){function Pe(De){this.tokens=[],this.tokens.links=Object.create(null),this.options=De||Me,this.options.tokenizer=this.options.tokenizer||new Fe,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var ee={block:Ne.normal,inline:Ye.normal};this.options.pedantic?(ee.block=Ne.pedantic,ee.inline=Ye.pedantic):this.options.gfm&&(ee.block=Ne.gfm,this.options.breaks?ee.inline=Ye.breaks:ee.inline=Ye.gfm),this.tokenizer.rules=ee}Pe.lex=function(ee,ue){var pe=new Pe(ue);return pe.lex(ee)},Pe.lexInline=function(ee,ue){var pe=new Pe(ue);return pe.inlineTokens(ee)};var Se=Pe.prototype;return Se.lex=function(ee){ee=ee.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(ee,this.tokens);for(var ue;ue=this.inlineQueue.shift();)this.inlineTokens(ue.src,ue.tokens);return this.tokens},Se.blockTokens=function(ee,ue){var pe=this;ue===void 0&&(ue=[]),this.options.pedantic&&(ee=ee.replace(/^ +$/gm,""));for(var me,Ie,Be,Oe;ee;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(et){return(me=et.call({lexer:pe},ee,ue))?(ee=ee.substring(me.raw.length),ue.push(me),!0):!1}))){if(me=this.tokenizer.space(ee)){ee=ee.substring(me.raw.length),me.type&&ue.push(me);continue}if(me=this.tokenizer.code(ee)){ee=ee.substring(me.raw.length),Ie=ue[ue.length-1],Ie&&(Ie.type==="paragraph"||Ie.type==="text")?(Ie.raw+=`
`+me.raw,Ie.text+=`
`+me.text,this.inlineQueue[this.inlineQueue.length-1].src=Ie.text):ue.push(me);continue}if(me=this.tokenizer.fences(ee)){ee=ee.substring(me.raw.length),ue.push(me);continue}if(me=this.tokenizer.heading(ee)){ee=ee.substring(me.raw.length),ue.push(me);continue}if(me=this.tokenizer.hr(ee)){ee=ee.substring(me.raw.length),ue.push(me);continue}if(me=this.tokenizer.blockquote(ee)){ee=ee.substring(me.raw.length),ue.push(me);continue}if(me=this.tokenizer.list(ee)){ee=ee.substring(me.raw.length),ue.push(me);continue}if(me=this.tokenizer.html(ee)){ee=ee.substring(me.raw.length),ue.push(me);continue}if(me=this.tokenizer.def(ee)){ee=ee.substring(me.raw.length),Ie=ue[ue.length-1],Ie&&(Ie.type==="paragraph"||Ie.type==="text")?(Ie.raw+=`
`+me.raw,Ie.text+=`
`+me.raw,this.inlineQueue[this.inlineQueue.length-1].src=Ie.text):this.tokens.links[me.tag]||(this.tokens.links[me.tag]={href:me.href,title:me.title});continue}if(me=this.tokenizer.table(ee)){ee=ee.substring(me.raw.length),ue.push(me);continue}if(me=this.tokenizer.lheading(ee)){ee=ee.substring(me.raw.length),ue.push(me);continue}if(Be=ee,this.options.extensions&&this.options.extensions.startBlock&&function(){var et=Infinity,Le=ee.slice(1),de=void 0;pe.options.extensions.startBlock.forEach(function(ge){de=ge.call({lexer:this},Le),typeof de=="number"&&de>=0&&(et=Math.min(et,de))}),et<Infinity&&et>=0&&(Be=ee.substring(0,et+1))}(),this.state.top&&(me=this.tokenizer.paragraph(Be))){Ie=ue[ue.length-1],Oe&&Ie.type==="paragraph"?(Ie.raw+=`
`+me.raw,Ie.text+=`
`+me.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ie.text):ue.push(me),Oe=Be.length!==ee.length,ee=ee.substring(me.raw.length);continue}if(me=this.tokenizer.text(ee)){ee=ee.substring(me.raw.length),Ie=ue[ue.length-1],Ie&&Ie.type==="text"?(Ie.raw+=`
`+me.raw,Ie.text+=`
`+me.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ie.text):ue.push(me);continue}if(ee){var je="Infinite loop on byte: "+ee.charCodeAt(0);if(this.options.silent){console.error(je);break}else throw new Error(je)}}return this.state.top=!0,ue},Se.inline=function(ee,ue){this.inlineQueue.push({src:ee,tokens:ue})},Se.inlineTokens=function(ee,ue){var pe=this;ue===void 0&&(ue=[]);var me,Ie,Be,Oe=ee,je,et,Le;if(this.tokens.links){var de=Object.keys(this.tokens.links);if(de.length>0)for(;(je=this.tokenizer.rules.inline.reflinkSearch.exec(Oe))!=null;)de.includes(je[0].slice(je[0].lastIndexOf("[")+1,-1))&&(Oe=Oe.slice(0,je.index)+"["+Ve("a",je[0].length-2)+"]"+Oe.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(je=this.tokenizer.rules.inline.blockSkip.exec(Oe))!=null;)Oe=Oe.slice(0,je.index)+"["+Ve("a",je[0].length-2)+"]"+Oe.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(je=this.tokenizer.rules.inline.escapedEmSt.exec(Oe))!=null;)Oe=Oe.slice(0,je.index)+"++"+Oe.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;ee;)if(et||(Le=""),et=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(J){return(me=J.call({lexer:pe},ee,ue))?(ee=ee.substring(me.raw.length),ue.push(me),!0):!1}))){if(me=this.tokenizer.escape(ee)){ee=ee.substring(me.raw.length),ue.push(me);continue}if(me=this.tokenizer.tag(ee)){ee=ee.substring(me.raw.length),Ie=ue[ue.length-1],Ie&&me.type==="text"&&Ie.type==="text"?(Ie.raw+=me.raw,Ie.text+=me.text):ue.push(me);continue}if(me=this.tokenizer.link(ee)){ee=ee.substring(me.raw.length),ue.push(me);continue}if(me=this.tokenizer.reflink(ee,this.tokens.links)){ee=ee.substring(me.raw.length),Ie=ue[ue.length-1],Ie&&me.type==="text"&&Ie.type==="text"?(Ie.raw+=me.raw,Ie.text+=me.text):ue.push(me);continue}if(me=this.tokenizer.emStrong(ee,Oe,Le)){ee=ee.substring(me.raw.length),ue.push(me);continue}if(me=this.tokenizer.codespan(ee)){ee=ee.substring(me.raw.length),ue.push(me);continue}if(me=this.tokenizer.br(ee)){ee=ee.substring(me.raw.length),ue.push(me);continue}if(me=this.tokenizer.del(ee)){ee=ee.substring(me.raw.length),ue.push(me);continue}if(me=this.tokenizer.autolink(ee,x)){ee=ee.substring(me.raw.length),ue.push(me);continue}if(!this.state.inLink&&(me=this.tokenizer.url(ee,x))){ee=ee.substring(me.raw.length),ue.push(me);continue}if(Be=ee,this.options.extensions&&this.options.extensions.startInline&&function(){var J=Infinity,W=ee.slice(1),we=void 0;pe.options.extensions.startInline.forEach(function(ke){we=ke.call({lexer:this},W),typeof we=="number"&&we>=0&&(J=Math.min(J,we))}),J<Infinity&&J>=0&&(Be=ee.substring(0,J+1))}(),me=this.tokenizer.inlineText(Be,qe)){ee=ee.substring(me.raw.length),me.raw.slice(-1)!=="_"&&(Le=me.raw.slice(-1)),et=!0,Ie=ue[ue.length-1],Ie&&Ie.type==="text"?(Ie.raw+=me.raw,Ie.text+=me.text):ue.push(me);continue}if(ee){var ge="Infinite loop on byte: "+ee.charCodeAt(0);if(this.options.silent){console.error(ge);break}else throw new Error(ge)}}return ue},e(Pe,null,[{key:"rules",get:function(){return{block:Ne,inline:Ye}}}]),Pe}(),te=R.exports.defaults,ae=A.cleanUrl,q=A.escape,oe=function(){function Pe(De){this.options=De||te}var Se=Pe.prototype;return Se.code=function(ee,ue,pe){var me=(ue||"").match(/\S*/)[0];if(this.options.highlight){var Ie=this.options.highlight(ee,me);Ie!=null&&Ie!==ee&&(pe=!0,ee=Ie)}return ee=ee.replace(/\n$/,"")+`
`,me?'<pre><code class="'+this.options.langPrefix+q(me,!0)+'">'+(pe?ee:q(ee,!0))+`</code></pre>
`:"<pre><code>"+(pe?ee:q(ee,!0))+`</code></pre>
`},Se.blockquote=function(ee){return`<blockquote>
`+ee+`</blockquote>
`},Se.html=function(ee){return ee},Se.heading=function(ee,ue,pe,me){return this.options.headerIds?"<h"+ue+' id="'+this.options.headerPrefix+me.slug(pe)+'">'+ee+"</h"+ue+`>
`:"<h"+ue+">"+ee+"</h"+ue+`>
`},Se.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},Se.list=function(ee,ue,pe){var me=ue?"ol":"ul",Ie=ue&&pe!==1?' start="'+pe+'"':"";return"<"+me+Ie+`>
`+ee+"</"+me+`>
`},Se.listitem=function(ee){return"<li>"+ee+`</li>
`},Se.checkbox=function(ee){return"<input "+(ee?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},Se.paragraph=function(ee){return"<p>"+ee+`</p>
`},Se.table=function(ee,ue){return ue&&(ue="<tbody>"+ue+"</tbody>"),`<table>
<thead>
`+ee+`</thead>
`+ue+`</table>
`},Se.tablerow=function(ee){return`<tr>
`+ee+`</tr>
`},Se.tablecell=function(ee,ue){var pe=ue.header?"th":"td",me=ue.align?"<"+pe+' align="'+ue.align+'">':"<"+pe+">";return me+ee+"</"+pe+`>
`},Se.strong=function(ee){return"<strong>"+ee+"</strong>"},Se.em=function(ee){return"<em>"+ee+"</em>"},Se.codespan=function(ee){return"<code>"+ee+"</code>"},Se.br=function(){return this.options.xhtml?"<br/>":"<br>"},Se.del=function(ee){return"<del>"+ee+"</del>"},Se.link=function(ee,ue,pe){if(ee=ae(this.options.sanitize,this.options.baseUrl,ee),ee===null)return pe;var me='<a href="'+q(ee)+'"';return ue&&(me+=' title="'+ue+'"'),me+=">"+pe+"</a>",me},Se.image=function(ee,ue,pe){if(ee=ae(this.options.sanitize,this.options.baseUrl,ee),ee===null)return pe;var me='<img src="'+ee+'" alt="'+pe+'"';return ue&&(me+=' title="'+ue+'"'),me+=this.options.xhtml?"/>":">",me},Se.text=function(ee){return ee},Pe}(),he=function(){function Pe(){}var Se=Pe.prototype;return Se.strong=function(ee){return ee},Se.em=function(ee){return ee},Se.codespan=function(ee){return ee},Se.del=function(ee){return ee},Se.html=function(ee){return ee},Se.text=function(ee){return ee},Se.link=function(ee,ue,pe){return""+pe},Se.image=function(ee,ue,pe){return""+pe},Se.br=function(){return""},Pe}(),Te=function(){function Pe(){this.seen={}}var Se=Pe.prototype;return Se.serialize=function(ee){return ee.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},Se.getNextSafeSlug=function(ee,ue){var pe=ee,me=0;if(this.seen.hasOwnProperty(pe)){me=this.seen[ee];do me++,pe=ee+"-"+me;while(this.seen.hasOwnProperty(pe))}return ue||(this.seen[ee]=me,this.seen[pe]=0),pe},Se.slug=function(ee,ue){ue===void 0&&(ue={});var pe=this.serialize(ee);return this.getNextSafeSlug(pe,ue.dryrun)},Pe}(),Ue=oe,He=he,Ke=Te,ye=R.exports.defaults,nt=A.unescape,H=function(){function Pe(De){this.options=De||ye,this.options.renderer=this.options.renderer||new Ue,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new He,this.slugger=new Ke}Pe.parse=function(ee,ue){var pe=new Pe(ue);return pe.parse(ee)},Pe.parseInline=function(ee,ue){var pe=new Pe(ue);return pe.parseInline(ee)};var Se=Pe.prototype;return Se.parse=function(ee,ue){ue===void 0&&(ue=!0);var pe="",me,Ie,Be,Oe,je,et,Le,de,ge,J,W,we,ke,Je,$e,ut,gt,at,dt,st=ee.length;for(me=0;me<st;me++){if(J=ee[me],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[J.type]&&(dt=this.options.extensions.renderers[J.type].call({parser:this},J),dt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(J.type))){pe+=dt||"";continue}switch(J.type){case"space":continue;case"hr":{pe+=this.renderer.hr();continue}case"heading":{pe+=this.renderer.heading(this.parseInline(J.tokens),J.depth,nt(this.parseInline(J.tokens,this.textRenderer)),this.slugger);continue}case"code":{pe+=this.renderer.code(J.text,J.lang,J.escaped);continue}case"table":{for(de="",Le="",Oe=J.header.length,Ie=0;Ie<Oe;Ie++)Le+=this.renderer.tablecell(this.parseInline(J.header[Ie].tokens),{header:!0,align:J.align[Ie]});for(de+=this.renderer.tablerow(Le),ge="",Oe=J.rows.length,Ie=0;Ie<Oe;Ie++){for(et=J.rows[Ie],Le="",je=et.length,Be=0;Be<je;Be++)Le+=this.renderer.tablecell(this.parseInline(et[Be].tokens),{header:!1,align:J.align[Be]});ge+=this.renderer.tablerow(Le)}pe+=this.renderer.table(de,ge);continue}case"blockquote":{ge=this.parse(J.tokens),pe+=this.renderer.blockquote(ge);continue}case"list":{for(W=J.ordered,we=J.start,ke=J.loose,Oe=J.items.length,ge="",Ie=0;Ie<Oe;Ie++)$e=J.items[Ie],ut=$e.checked,gt=$e.task,Je="",$e.task&&(at=this.renderer.checkbox(ut),ke?$e.tokens.length>0&&$e.tokens[0].type==="paragraph"?($e.tokens[0].text=at+" "+$e.tokens[0].text,$e.tokens[0].tokens&&$e.tokens[0].tokens.length>0&&$e.tokens[0].tokens[0].type==="text"&&($e.tokens[0].tokens[0].text=at+" "+$e.tokens[0].tokens[0].text)):$e.tokens.unshift({type:"text",text:at}):Je+=at),Je+=this.parse($e.tokens,ke),ge+=this.renderer.listitem(Je,gt,ut);pe+=this.renderer.list(ge,W,we);continue}case"html":{pe+=this.renderer.html(J.text);continue}case"paragraph":{pe+=this.renderer.paragraph(this.parseInline(J.tokens));continue}case"text":{for(ge=J.tokens?this.parseInline(J.tokens):J.text;me+1<st&&ee[me+1].type==="text";)J=ee[++me],ge+=`
`+(J.tokens?this.parseInline(J.tokens):J.text);pe+=ue?this.renderer.paragraph(ge):ge;continue}default:{var Et='Token with "'+J.type+'" type was not found.';if(this.options.silent){console.error(Et);return}else throw new Error(Et)}}}return pe},Se.parseInline=function(ee,ue){ue=ue||this.renderer;var pe="",me,Ie,Be,Oe=ee.length;for(me=0;me<Oe;me++){if(Ie=ee[me],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Ie.type]&&(Be=this.options.extensions.renderers[Ie.type].call({parser:this},Ie),Be!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Ie.type))){pe+=Be||"";continue}switch(Ie.type){case"escape":{pe+=ue.text(Ie.text);break}case"html":{pe+=ue.html(Ie.text);break}case"link":{pe+=ue.link(Ie.href,Ie.title,this.parseInline(Ie.tokens,ue));break}case"image":{pe+=ue.image(Ie.href,Ie.title,Ie.text);break}case"strong":{pe+=ue.strong(this.parseInline(Ie.tokens,ue));break}case"em":{pe+=ue.em(this.parseInline(Ie.tokens,ue));break}case"codespan":{pe+=ue.codespan(Ie.text);break}case"br":{pe+=ue.br();break}case"del":{pe+=ue.del(this.parseInline(Ie.tokens,ue));break}case"text":{pe+=ue.text(Ie.text);break}default:{var je='Token with "'+Ie.type+'" type was not found.';if(this.options.silent){console.error(je);return}else throw new Error(je)}}}return pe},Pe}(),X=Q,fe=H,xe=z,Qe=oe,rt=he,ct=Te,ft=A.merge,Pt=A.checkSanitizeDeprecation,mt=A.escape,St=R.exports.getDefaults,Ct=R.exports.changeDefaults,pt=R.exports.defaults;function Xe(Pe,Se,De){if(typeof Pe=="undefined"||Pe===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Pe!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Pe)+", string expected");if(typeof Se=="function"&&(De=Se,Se=null),Se=ft({},Xe.defaults,Se||{}),Pt(Se),De){var ee=Se.highlight,ue;try{ue=X.lex(Pe,Se)}catch(Be){return De(Be)}var pe=function(Oe){var je;if(!Oe)try{Se.walkTokens&&Xe.walkTokens(ue,Se.walkTokens),je=fe.parse(ue,Se)}catch(et){Oe=et}return Se.highlight=ee,Oe?De(Oe):De(null,je)};if(!ee||ee.length<3||(delete Se.highlight,!ue.length))return pe();var me=0;Xe.walkTokens(ue,function(Be){Be.type==="code"&&(me++,setTimeout(function(){ee(Be.text,Be.lang,function(Oe,je){if(Oe)return pe(Oe);je!=null&&je!==Be.text&&(Be.text=je,Be.escaped=!0),me--,me===0&&pe()})},0))}),me===0&&pe();return}try{var Ie=X.lex(Pe,Se);return Se.walkTokens&&Xe.walkTokens(Ie,Se.walkTokens),fe.parse(Ie,Se)}catch(Be){if(Be.message+=`
Please report this to https://github.com/markedjs/marked.`,Se.silent)return"<p>An error occurred:</p><pre>"+mt(Be.message+"",!0)+"</pre>";throw Be}}Xe.options=Xe.setOptions=function(Pe){return ft(Xe.defaults,Pe),Ct(Xe.defaults),Xe},Xe.getDefaults=St,Xe.defaults=pt,Xe.use=function(){for(var Pe=this,Se=arguments.length,De=new Array(Se),ee=0;ee<Se;ee++)De[ee]=arguments[ee];var ue=ft.apply(void 0,[{}].concat(De)),pe=Xe.defaults.extensions||{renderers:{},childTokens:{}},me;De.forEach(function(Ie){if(Ie.extensions&&(me=!0,Ie.extensions.forEach(function(Oe){if(!Oe.name)throw new Error("extension name required");if(Oe.renderer){var je=pe.renderers?pe.renderers[Oe.name]:null;je?pe.renderers[Oe.name]=function(){for(var et=arguments.length,Le=new Array(et),de=0;de<et;de++)Le[de]=arguments[de];var ge=Oe.renderer.apply(this,Le);return ge===!1&&(ge=je.apply(this,Le)),ge}:pe.renderers[Oe.name]=Oe.renderer}if(Oe.tokenizer){if(!Oe.level||Oe.level!=="block"&&Oe.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");pe[Oe.level]?pe[Oe.level].unshift(Oe.tokenizer):pe[Oe.level]=[Oe.tokenizer],Oe.start&&(Oe.level==="block"?pe.startBlock?pe.startBlock.push(Oe.start):pe.startBlock=[Oe.start]:Oe.level==="inline"&&(pe.startInline?pe.startInline.push(Oe.start):pe.startInline=[Oe.start]))}Oe.childTokens&&(pe.childTokens[Oe.name]=Oe.childTokens)})),Ie.renderer&&function(){var Oe=Xe.defaults.renderer||new Qe,je=function(de){var ge=Oe[de];Oe[de]=function(){for(var J=arguments.length,W=new Array(J),we=0;we<J;we++)W[we]=arguments[we];var ke=Ie.renderer[de].apply(Oe,W);return ke===!1&&(ke=ge.apply(Oe,W)),ke}};for(var et in Ie.renderer)je(et);ue.renderer=Oe}(),Ie.tokenizer&&function(){var Oe=Xe.defaults.tokenizer||new xe,je=function(de){var ge=Oe[de];Oe[de]=function(){for(var J=arguments.length,W=new Array(J),we=0;we<J;we++)W[we]=arguments[we];var ke=Ie.tokenizer[de].apply(Oe,W);return ke===!1&&(ke=ge.apply(Oe,W)),ke}};for(var et in Ie.tokenizer)je(et);ue.tokenizer=Oe}(),Ie.walkTokens){var Be=Xe.defaults.walkTokens;ue.walkTokens=function(Oe){Ie.walkTokens.call(Pe,Oe),Be&&Be(Oe)}}me&&(ue.extensions=pe),Xe.setOptions(ue)})},Xe.walkTokens=function(Pe,Se){for(var De=function(){var me=ue.value;switch(Se(me),me.type){case"table":{for(var Ie=b(me.header),Be;!(Be=Ie()).done;){var Oe=Be.value;Xe.walkTokens(Oe.tokens,Se)}for(var je=b(me.rows),et;!(et=je()).done;)for(var Le=et.value,de=b(Le),ge;!(ge=de()).done;){var J=ge.value;Xe.walkTokens(J.tokens,Se)}break}case"list":{Xe.walkTokens(me.items,Se);break}default:Xe.defaults.extensions&&Xe.defaults.extensions.childTokens&&Xe.defaults.extensions.childTokens[me.type]?Xe.defaults.extensions.childTokens[me.type].forEach(function(W){Xe.walkTokens(me[W],Se)}):me.tokens&&Xe.walkTokens(me.tokens,Se)}},ee=b(Pe),ue;!(ue=ee()).done;)De()},Xe.parseInline=function(Pe,Se){if(typeof Pe=="undefined"||Pe===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Pe!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Pe)+", string expected");Se=ft({},Xe.defaults,Se||{}),Pt(Se);try{var De=X.lexInline(Pe,Se);return Se.walkTokens&&Xe.walkTokens(De,Se.walkTokens),fe.parseInline(De,Se)}catch(ee){if(ee.message+=`
Please report this to https://github.com/markedjs/marked.`,Se.silent)return"<p>An error occurred:</p><pre>"+mt(ee.message+"",!0)+"</pre>";throw ee}},Xe.Parser=fe,Xe.parser=fe.parse,Xe.Renderer=Qe,Xe.TextRenderer=rt,Xe.Lexer=X,Xe.lexer=X.lex,Xe.Tokenizer=xe,Xe.Slugger=ct,Xe.parse=Xe;var _t=Xe;return _t}),define(be[75],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function d(F,C,_){return Math.min(Math.max(F,C),_)}e.clamp=d;function M(F,C){return(C+F%C)%C}e.rot=M;class b{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=b;class R{constructor(){this._n=1,this._val=0}update(C){return this._val=this._val+(C-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=R}),function(){function re(b){const R=[];typeof b=="number"&&R.push("code/timeOrigin",b);function F(_){R.push(_,Date.now())}function C(){const _=[];for(let I=0;I<R.length;I+=2)_.push({name:R[I],startTime:R[I+1]});return _}return{mark:F,getMarks:C}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?re():{mark(b){performance.mark(b)},getMarks(){let b=performance.timeOrigin;typeof b!="number"&&(b=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(b)}];for(const F of performance.getEntriesByType("mark"))R.push({name:F.name,startTime:Math.round(b+F.startTime)});return R}};if(typeof process=="object"){const b=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return re(b)}else return console.trace("perf-util loaded in UNKNOWN environment"),re()}function d(b){return b.MonacoPerformanceMarks||(b.MonacoPerformanceMarks=e()),b.MonacoPerformanceMarks}var M;typeof global=="object"?M=global:typeof self=="object"?M=self:M={},typeof define=="function"?define("vs/base/common/performance",[],function(){return d(M)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=d(M):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),M.perf=d(M))}(),define(be[104],Ee([0,1]),function(re,e){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class M{constructor(C,_,I){this.level=C,this.key=_,this.value=I,this.forward=[]}}const b=void 0;class R{constructor(C,_=2**16){this.comparator=C,this[d]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(_)|0),this._header=new M(this._maxLevel,b,b)}get size(){return this._size}clear(){this._header=new M(this._maxLevel,b,b)}has(C){return Boolean(R._search(this,C,this.comparator))}get(C){return R._search(this,C,this.comparator)?.value}set(C,_){return R._insert(this,C,_,this.comparator)&&(this._size+=1),this}delete(C){const _=R._delete(this,C,this.comparator);return _&&(this._size-=1),_}forEach(C,_){let I=this._header.forward[0];for(;I;)C.call(_,I.value,I.key,this),I=I.forward[0]}[(d=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let C=this._header.forward[0];for(;C;)yield[C.key,C.value],C=C.forward[0]}*keys(){let C=this._header.forward[0];for(;C;)yield C.key,C=C.forward[0]}*values(){let C=this._header.forward[0];for(;C;)yield C.value,C=C.forward[0]}toString(){let C="[SkipList]:",_=this._header.forward[0];for(;_;)C+=`node(${_.key}, ${_.value}, lvl:${_.level})`,_=_.forward[0];return C}static _search(C,_,I){let t=C._header;for(let E=C._level-1;E>=0;E--)for(;t.forward[E]&&I(t.forward[E].key,_)<0;)t=t.forward[E];if(t=t.forward[0],t&&I(t.key,_)===0)return t}static _insert(C,_,I,t){let E=[],n=C._header;for(let c=C._level-1;c>=0;c--){for(;n.forward[c]&&t(n.forward[c].key,_)<0;)n=n.forward[c];E[c]=n}if(n=n.forward[0],n&&t(n.key,_)===0)return n.value=I,!1;{let c=R._randomLevel(C);if(c>C._level){for(let u=C._level;u<c;u++)E[u]=C._header;C._level=c}n=new M(c,_,I);for(let u=0;u<c;u++)n.forward[u]=E[u].forward[u],E[u].forward[u]=n;return!0}}static _randomLevel(C,_=.5){let I=1;for(;Math.random()<_&&I<C._maxLevel;)I+=1;return I}static _delete(C,_,I){let t=[],E=C._header;for(let n=C._level-1;n>=0;n--){for(;E.forward[n]&&I(E.forward[n].key,_)<0;)E=E.forward[n];t[n]=E}if(E=E.forward[0],!E||I(E.key,_)!==0)return!1;for(let n=0;n<C._level&&t[n].forward[n]===E;n++)t[n].forward[n]=E.forward[n];for(;C._level>0&&C._header.forward[C._level-1]===b;)C._level-=1;return!0}}e.SkipList=R}),define(be[34],Ee([0,1,3]),function(re,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class M{constructor(){this._icons=new Map,this._onDidRegister=new d.Emitter}add(E){const n=this._icons.get(E.id);n?E.description?n.description=E.description:console.error(`Duplicate registration of codicon ${E.id}`):(this._icons.set(E.id,E),this._onDidRegister.fire(E))}get(E){return this._icons.get(E)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const b=new M;e.iconRegistry=b;function R(t,E){return new C(t,E)}e.registerCodicon=R;function F(t){return t?t.replace(/\$\((.*?)\)/g,(E,n)=>` ${n} `).trim():""}e.getCodiconAriaLabel=F;class C{constructor(E,n,c){this.id=E,this.definition=n,this.description=c,b.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=C;function _(t,E){const n=["codicon","codicon-"+t];return E&&n.push("codicon-modifier-"+E),n}e.getClassNamesArray=_;var I;(function(t){t.iconNameSegment="[A-Za-z0-9]+",t.iconNameExpression="[A-Za-z0-9\\-]+",t.iconModifierExpression="~[A-Za-z]+";const E=new RegExp(`^(${t.iconNameExpression})(${t.iconModifierExpression})?$`);function n(a){if(a instanceof C)return["codicon","codicon-"+a.id];const w=E.exec(a.id);if(!w)return n(C.error);let[,T,S]=w;const o=["codicon","codicon-"+T];return S&&o.push("codicon-modifier-"+S.substr(1)),o}t.asClassNameArray=n;function c(a){return n(a).join(" ")}t.asClassName=c;function u(a){return"."+n(a).join(".")}t.asCSSSelector=u})(I=e.CSSIcon||(e.CSSIcon={})),function(t){t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",{fontCharacter:"\\ea60"}),t.gistNew=new t("gist-new",{fontCharacter:"\\ea60"}),t.repoCreate=new t("repo-create",{fontCharacter:"\\ea60"}),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",{fontCharacter:"\\ea71"}),t.closeDirty=new t("close-dirty",{fontCharacter:"\\ea71"}),t.debugBreakpoint=new t("debug-breakpoint",{fontCharacter:"\\ea71"}),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),t.debugHint=new t("debug-hint",{fontCharacter:"\\ea71"}),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circleOutline=new t("circle-outline",{fontCharacter:"\\eabc"}),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.debugStackframeDot=new t("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLargeOutline=new t("circle-large-outline",{fontCharacter:"\\ebb5"}),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition)}(C=e.Codicon||(e.Codicon={}))}),define(be[105],Ee([0,1,16,6]),function(re,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function b(o){const f=o;return f?[f.on,f.pause,f.resume,f.destroy].every(y=>typeof y=="function"):!1}e.isReadableStream=b;function R(o){const f=o;return f?b(f.stream)&&Array.isArray(f.buffer)&&typeof f.ended=="boolean":!1}e.isReadableBufferedStream=R;function F(o,f){return new C(o,f)}e.newWriteableStream=F;class C{constructor(f,y){this.reducer=f,this.options=y,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(f){if(!this.state.destroyed){if(this.state.flowing)this.emitData(f);else if(this.buffer.data.push(f),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(y=>this.pendingWritePromises.push(y))}}error(f){this.state.destroyed||(this.state.flowing?this.emitError(f):this.buffer.error.push(f))}end(f){this.state.destroyed||(typeof f!="undefined"&&this.write(f),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(f){this.listeners.data.slice(0).forEach(y=>y(f))}emitError(f){this.listeners.error.length===0?(0,d.onUnexpectedError)(f):this.listeners.error.slice(0).forEach(y=>y(f))}emitEnd(){this.listeners.end.slice(0).forEach(f=>f())}on(f,y){if(!this.state.destroyed)switch(f){case"data":this.listeners.data.push(y),this.resume();break;case"end":this.listeners.end.push(y),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(y),this.state.flowing&&this.flowErrors();break}}removeListener(f,y){if(this.state.destroyed)return;let i;switch(f){case"data":i=this.listeners.data;break;case"end":i=this.listeners.end;break;case"error":i=this.listeners.error;break}if(i){const v=i.indexOf(y);v>=0&&i.splice(v,1)}}flowData(){if(this.buffer.data.length>0){const f=this.reducer(this.buffer.data);this.emitData(f),this.buffer.data.length=0;const y=[...this.pendingWritePromises];this.pendingWritePromises.length=0,y.forEach(i=>i())}}flowErrors(){if(this.listeners.error.length>0){for(const f of this.buffer.error)this.emitError(f);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function _(o,f){const y=[];let i;for(;(i=o.read())!==null;)y.push(i);return f(y)}e.consumeReadable=_;function I(o,f,y){const i=[];let v;for(;(v=o.read())!==null&&i.length<y;)i.push(v);return v===null&&i.length>0?f(i):{read:()=>{if(i.length>0)return i.shift();if(typeof v!="undefined"){const r=v;return v=void 0,r}return o.read()}}}e.peekReadable=I;function t(o,f){return new Promise((y,i)=>{const v=[];E(o,{onData:r=>{f&&v.push(r)},onError:r=>{f?i(r):y(void 0)},onEnd:()=>{y(f?f(v):void 0)}})})}e.consumeStream=t;function E(o,f){o.on("error",y=>f.onError(y)),o.on("end",()=>f.onEnd()),o.on("data",y=>f.onData(y))}e.listenStream=E;function n(o,f){return new Promise((y,i)=>{const v=new M.DisposableStore,r=[],s=p=>{if(r.push(p),r.length>f)return v.dispose(),o.pause(),y({stream:o,buffer:r,ended:!1})},l=p=>i(p),h=()=>y({stream:o,buffer:r,ended:!0});v.add((0,M.toDisposable)(()=>o.removeListener("error",l))),o.on("error",l),v.add((0,M.toDisposable)(()=>o.removeListener("end",h))),o.on("end",h),v.add((0,M.toDisposable)(()=>o.removeListener("data",s))),o.on("data",s)})}e.peekStream=n;function c(o,f){const y=F(f);return y.end(o),y}e.toStream=c;function u(){const o=F(()=>{throw new Error("not supported")});return o.end(),o}e.emptyStream=u;function a(o){let f=!1;return{read:()=>f?null:(f=!0,o)}}e.toReadable=a;function w(o,f,y){const i=F(y);return E(o,{onData:v=>i.write(f.data(v)),onError:v=>i.error(f.error?f.error(v):v),onEnd:()=>i.end()}),i}e.transform=w;function T(o,f,y){let i=!1;return{read:()=>{const v=f.read();return i?v:(i=!0,v!==null?y([o,v]):o)}}}e.prefixedReadable=T;function S(o,f,y){let i=!1;const v=F(y);return E(f,{onData:r=>i?v.write(r):(i=!0,v.write(y([o,r]))),onError:r=>v.error(r),onEnd:()=>{i||(i=!0,v.write(o)),v.end()}}),v}e.prefixedStream=S}),define(be[22],Ee([0,1,105]),function(re,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const M=typeof Buffer!="undefined";let b,R;class F{constructor(s){this.buffer=s,this.byteLength=this.buffer.byteLength}static alloc(s){return M?new F(Buffer.allocUnsafe(s)):new F(new Uint8Array(s))}static wrap(s){return M&&!Buffer.isBuffer(s)&&(s=Buffer.from(s.buffer,s.byteOffset,s.byteLength)),new F(s)}static fromString(s,l){return!(l?.dontUseNodeBuffer||!1)&&M?new F(Buffer.from(s)):(b||(b=new TextEncoder),new F(b.encode(s)))}static concat(s,l){if(typeof l=="undefined"){l=0;for(let k=0,P=s.length;k<P;k++)l+=s[k].byteLength}const h=F.alloc(l);let p=0;for(let k=0,P=s.length;k<P;k++){const g=s[k];h.set(g,p),p+=g.byteLength}return h}toString(){return M?this.buffer.toString():(R||(R=new TextDecoder),R.decode(this.buffer))}slice(s,l){return new F(this.buffer.subarray(s,l))}set(s,l){s instanceof F?this.buffer.set(s.buffer,l):this.buffer.set(s,l)}readUInt32BE(s){return I(this.buffer,s)}writeUInt32BE(s,l){t(this.buffer,s,l)}readUInt32LE(s){return E(this.buffer,s)}writeUInt32LE(s,l){n(this.buffer,s,l)}readUInt8(s){return c(this.buffer,s)}writeUInt8(s,l){u(this.buffer,s,l)}}e.VSBuffer=F;function C(r,s){return r[s+0]<<0>>>0|r[s+1]<<8>>>0}e.readUInt16LE=C;function _(r,s,l){r[l+0]=s&255,s=s>>>8,r[l+1]=s&255}e.writeUInt16LE=_;function I(r,s){return r[s]*2**24+r[s+1]*2**16+r[s+2]*2**8+r[s+3]}e.readUInt32BE=I;function t(r,s,l){r[l+3]=s,s=s>>>8,r[l+2]=s,s=s>>>8,r[l+1]=s,s=s>>>8,r[l]=s}e.writeUInt32BE=t;function E(r,s){return r[s+0]<<0>>>0|r[s+1]<<8>>>0|r[s+2]<<16>>>0|r[s+3]<<24>>>0}e.readUInt32LE=E;function n(r,s,l){r[l+0]=s&255,s=s>>>8,r[l+1]=s&255,s=s>>>8,r[l+2]=s&255,s=s>>>8,r[l+3]=s&255}e.writeUInt32LE=n;function c(r,s){return r[s]}e.readUInt8=c;function u(r,s,l){r[l]=s}e.writeUInt8=u;function a(r){return d.consumeReadable(r,s=>F.concat(s))}e.readableToBuffer=a;function w(r){return d.toReadable(r)}e.bufferToReadable=w;function T(r){return d.consumeStream(r,s=>F.concat(s))}e.streamToBuffer=T;async function S(r){return r.ended?F.concat(r.buffer):F.concat([...r.buffer,await T(r.stream)])}e.bufferedStreamToBuffer=S;function o(r){return d.toStream(r,s=>F.concat(s))}e.bufferToStream=o;function f(r){return d.transform(r,{data:s=>typeof s=="string"?F.fromString(s):F.wrap(s)},s=>F.concat(s))}e.streamToBufferReadableStream=f;function y(r){return d.newWriteableStream(s=>F.concat(s),r)}e.newWriteableBufferStream=y;function i(r,s){return d.prefixedReadable(r,s,l=>F.concat(l))}e.prefixedBufferReadable=i;function v(r,s){return d.prefixedStream(r,s,l=>F.concat(l))}e.prefixedBufferStream=v}),define(be[35],Ee([0,1,9]),function(re,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var M;(function(b){b[b.Ignore=0]="Ignore",b[b.Info=1]="Info",b[b.Warning=2]="Warning",b[b.Error=3]="Error"})(M||(M={})),function(b){const R="error",F="warning",C="warn",_="info",I="ignore";function t(n){return n?d.equalsIgnoreCase(R,n)?b.Error:d.equalsIgnoreCase(F,n)||d.equalsIgnoreCase(C,n)?b.Warning:d.equalsIgnoreCase(_,n)?b.Info:b.Ignore:b.Ignore}b.fromValue=t;function E(n){switch(n){case b.Error:return R;case b.Warning:return F;case b.Info:return _;default:return I}}b.toString=E}(M||(M={})),e.default=M}),define(be[43],Ee([0,1,17,26,9,10]),function(re,e,d,M,b,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function F(r){return r===47||r===92}e.isPathSeparator=F;function C(r){return r.replace(/[\\/]/g,d.posix.sep)}e.toSlashes=C;function _(r){return r.indexOf("/")===-1&&(r=C(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.toPosixPath=_;function I(r,s=d.posix.sep){if(!r)return"";const l=r.length,h=r.charCodeAt(0);if(F(h)){if(F(r.charCodeAt(1))&&!F(r.charCodeAt(2))){let k=3;const P=k;for(;k<l&&!F(r.charCodeAt(k));k++);if(P!==k&&!F(r.charCodeAt(k+1))){for(k+=1;k<l;k++)if(F(r.charCodeAt(k)))return r.slice(0,k+1).replace(/[\\/]/g,s)}}return s}else if(T(h)&&r.charCodeAt(1)===58)return F(r.charCodeAt(2))?r.slice(0,2)+s:r.slice(0,2);let p=r.indexOf("://");if(p!==-1){for(p+=3;p<l;p++)if(F(r.charCodeAt(p)))return r.slice(0,p+1)}return""}e.getRoot=I;function t(r){if(!M.isWindows||!r||r.length<5)return!1;let s=r.charCodeAt(0);if(s!==92||(s=r.charCodeAt(1),s!==92))return!1;let l=2;const h=l;for(;l<r.length&&(s=r.charCodeAt(l),s!==92);l++);return!(h===l||(s=r.charCodeAt(l+1),isNaN(s)||s===92))}e.isUNC=t;const E=/[\\/:\*\?"<>\|]/g,n=/[\\/]/g,c=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function u(r,s=M.isWindows){const l=s?E:n;return!(!r||r.length===0||/^\s+$/.test(r)||(l.lastIndex=0,l.test(r))||s&&c.test(r)||r==="."||r===".."||s&&r[r.length-1]==="."||s&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=u;function a(r,s,l){const h=r===s;return!l||h?h:!r||!s?!1:(0,b.equalsIgnoreCase)(r,s)}e.isEqual=a;function w(r,s,l,h=d.sep){if(r===s)return!0;if(!r||!s||s.length>r.length)return!1;if(l){if(!(0,b.startsWithIgnoreCase)(r,s))return!1;if(s.length===r.length)return!0;let k=s.length;return s.charAt(s.length-1)===h&&k--,r.charAt(k)===h}return s.charAt(s.length-1)!==h&&(s+=h),r.indexOf(s)===0}e.isEqualOrParent=w;function T(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=T;function S(r,s){return M.isWindows&&r.endsWith(":")&&(r+=d.sep),(0,d.isAbsolute)(r)||(r=(0,d.join)(s,r)),r=(0,d.normalize)(r),M.isWindows?(r=(0,b.rtrim)(r,d.sep),r.endsWith(":")&&(r+=d.sep)):(r=(0,b.rtrim)(r,d.sep),r||(r=d.sep)),r}e.sanitizeFilePath=S;function o(r){const s=(0,d.normalize)(r);return M.isWindows?r.length>3?!1:f(s)&&(r.length===2||s.charCodeAt(2)===92):s===d.posix.sep}e.isRootOrDriveLetter=o;function f(r){return M.isWindows?T(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=f;function y(r){return f(r)?r[0]:void 0}e.getDriveLetter=y;function i(r,s,l){return s.length>r.length?-1:r===s?0:(l&&(r=r.toLowerCase(),s=s.toLowerCase()),r.indexOf(s))}e.indexOfPath=i;function v(r){const s=r.split(":");let l,h,p;if(s.forEach(k=>{const P=Number(k);(0,R.isNumber)(P)?h===void 0?h=P:p===void 0&&(p=P):l=l?[l,k].join(":"):k}),!l)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:l,line:h!==void 0?h:void 0,column:p!==void 0?p:h!==void 0?1:void 0}}e.parseLineAndColumnAware=v}),define(be[23],Ee([0,1,10]),function(re,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function M(a){if(!a||typeof a!="object"||a instanceof RegExp)return a;const w=Array.isArray(a)?[]:{};return Object.keys(a).forEach(T=>{a[T]&&typeof a[T]=="object"?w[T]=M(a[T]):w[T]=a[T]}),w}e.deepClone=M;function b(a){if(!a||typeof a!="object")return a;const w=[a];for(;w.length>0;){const T=w.shift();Object.freeze(T);for(const S in T)if(R.call(T,S)){const o=T[S];typeof o=="object"&&!Object.isFrozen(o)&&w.push(o)}}return a}e.deepFreeze=b;const R=Object.prototype.hasOwnProperty;function F(a,w){return C(a,w,new Set)}e.cloneAndChange=F;function C(a,w,T){if((0,d.isUndefinedOrNull)(a))return a;const S=w(a);if(typeof S!="undefined")return S;if((0,d.isArray)(a)){const o=[];for(const f of a)o.push(C(f,w,T));return o}if((0,d.isObject)(a)){if(T.has(a))throw new Error("Cannot clone recursive data-structure");T.add(a);const o={};for(let f in a)R.call(a,f)&&(o[f]=C(a[f],w,T));return T.delete(a),o}return a}function _(a,w,T=!0){return(0,d.isObject)(a)?((0,d.isObject)(w)&&Object.keys(w).forEach(S=>{S in a?T&&((0,d.isObject)(a[S])&&(0,d.isObject)(w[S])?_(a[S],w[S],T):a[S]=w[S]):a[S]=w[S]}),a):w}e.mixin=_;function I(a,w){if(a===w)return!0;if(a==null||w===null||w===void 0||typeof a!=typeof w||typeof a!="object"||Array.isArray(a)!==Array.isArray(w))return!1;let T,S;if(Array.isArray(a)){if(a.length!==w.length)return!1;for(T=0;T<a.length;T++)if(!I(a[T],w[T]))return!1}else{const o=[];for(S in a)o.push(S);o.sort();const f=[];for(S in w)f.push(S);if(f.sort(),!I(o,f))return!1;for(T=0;T<o.length;T++)if(!I(a[o[T]],w[o[T]]))return!1}return!0}e.equals=I;function t(a){const w=new Set;return JSON.stringify(a,(T,S)=>{if((0,d.isObject)(S)||Array.isArray(S)){if(w.has(S))return"[Circular]";w.add(S)}return S})}e.safeStringify=t;function E(a,w,T){const S=w(a);return typeof S=="undefined"?T:S}e.getOrDefault=E;function n(a,w){const T=Object.create(null);return!a||!w||Object.keys(w).forEach(o=>{const f=a[o],y=w[o];I(f,y)||(T[o]=y)}),T}e.distinct=n;function c(a,w){const T=w.toLowerCase(),S=Object.keys(a).find(o=>o.toLowerCase()===T);return S?a[S]:a[w]}e.getCaseInsensitive=c;function u(a,w){const T=Object.create(null);for(const S of Object.keys(a))w(S,a[S])&&(T[S]=a[S]);return T}e.filter=u});var Ze=this&&this.__classPrivateFieldSet||function(re,e,d,M,b){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!b:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?b.call(re,d):b?b.value=d:e.set(re,d),d},Ae=this&&this.__classPrivateFieldGet||function(re,e,d,M){if(d==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?M:d==="a"?M.call(re):M?M.value:e.get(re)};define(be[20],Ee([0,1,12,9,2]),function(re,e,d,M,b){"use strict";var R,F,C;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function _(v,r,s){let l=v.get(r);return l===void 0&&(l=s,v.set(r,l)),l}e.getOrSet=_;function I(v){const r=[];return v.forEach((s,l)=>{r.push(`${l} => ${s}`)}),`Map(${v.size}) {${r.join(", ")}}`}e.mapToString=I;function t(v){const r=[];return v.forEach(s=>{r.push(s)}),`Set(${v.size}) {${r.join(", ")}}`}e.setToString=t;class E{constructor(){this._value="",this._pos=0}reset(r){return this._value=r,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(r){const s=r.charCodeAt(0),l=this._value.charCodeAt(this._pos);return s-l}value(){return this._value[this._pos]}}e.StringIterator=E;class n{constructor(r=!0){this._caseSensitive=r}reset(r){return this._value=r,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(r)this._from++;else break;else r=!1;return this}cmp(r){return this._caseSensitive?(0,M.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,M.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=n;class c{constructor(r=!0,s=!0){this._splitOnBackslash=r,this._caseSensitive=s}reset(r){return this._value=r.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++){const s=this._value.charCodeAt(this._to);if(s===47||this._splitOnBackslash&&s===92)if(r)this._from++;else break;else r=!1}return this}cmp(r){return this._caseSensitive?(0,M.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,M.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=c;var u;(function(v){v[v.Scheme=1]="Scheme",v[v.Authority=2]="Authority",v[v.Path=3]="Path",v[v.Query=4]="Query",v[v.Fragment=5]="Fragment"})(u||(u={}));class a{constructor(r){this._ignorePathCasing=r,this._states=[],this._stateIdx=0}reset(r){return this._value=r,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new c(!1,!this._ignorePathCasing(r)),this._pathIterator.reset(r.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(r){if(this._states[this._stateIdx]===1)return(0,M.compareIgnoreCase)(r,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,M.compareIgnoreCase)(r,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(r);if(this._states[this._stateIdx]===4)return(0,M.compare)(r,this._value.query);if(this._states[this._stateIdx]===5)return(0,M.compare)(r,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=a;class w{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class T{constructor(r){this._iter=r}static forUris(r=()=>!1){return new T(new a(r))}static forPaths(){return new T(new c)}static forStrings(){return new T(new E)}static forConfigKeys(){return new T(new n)}clear(){this._root=void 0}set(r,s){const l=this._iter.reset(r);let h;for(this._root||(this._root=new w,this._root.segment=l.value()),h=this._root;;){const k=l.cmp(h.segment);if(k>0)h.left||(h.left=new w,h.left.segment=l.value()),h=h.left;else if(k<0)h.right||(h.right=new w,h.right.segment=l.value()),h=h.right;else if(l.hasNext())l.next(),h.mid||(h.mid=new w,h.mid.segment=l.value()),h=h.mid;else break}const p=h.value;return h.value=s,h.key=r,p}fill(r,s){const l=s.slice(0);(0,d.shuffle)(l);for(let h of l)this.set(h,r)}get(r){return this._getNode(r)?.value}_getNode(r){const s=this._iter.reset(r);let l=this._root;for(;l;){const h=s.cmp(l.segment);if(h>0)l=l.left;else if(h<0)l=l.right;else if(s.hasNext())s.next(),l=l.mid;else break}return l}has(r){const s=this._getNode(r);return!(s?.value===void 0&&s?.mid===void 0)}delete(r){return this._delete(r,!1)}deleteSuperstr(r){return this._delete(r,!0)}_delete(r,s){const l=this._iter.reset(r),h=[];let p=this._root;for(;p;){const k=l.cmp(p.segment);if(k>0)h.push([1,p]),p=p.left;else if(k<0)h.push([-1,p]),p=p.right;else if(l.hasNext())l.next(),h.push([0,p]),p=p.mid;else{for(s?(p.left=void 0,p.mid=void 0,p.right=void 0):p.value=void 0;h.length>0&&p.isEmpty();){let[P,g]=h.pop();switch(P){case 1:g.left=void 0;break;case 0:g.mid=void 0;break;case-1:g.right=void 0;break}p=g}break}}}findSubstr(r){const s=this._iter.reset(r);let l=this._root,h;for(;l;){const p=s.cmp(l.segment);if(p>0)l=l.left;else if(p<0)l=l.right;else if(s.hasNext())s.next(),h=l.value||h,l=l.mid;else break}return l&&l.value||h}findSuperstr(r){const s=this._iter.reset(r);let l=this._root;for(;l;){const h=s.cmp(l.segment);if(h>0)l=l.left;else if(h<0)l=l.right;else if(s.hasNext())s.next(),l=l.mid;else return l.mid?this._entries(l.mid):void 0}}forEach(r){for(const[s,l]of this)r(l,s)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(r){if(!r)return;const s=[r];for(;s.length>0;){const l=s.pop();l&&(l.value&&(yield[l.key,l.value]),l.left&&s.push(l.left),l.mid&&s.push(l.mid),l.right&&s.push(l.right))}}}e.TernarySearchTree=T;class S{constructor(r,s){this[R]="ResourceMap",r instanceof S?(this.map=new Map(r.map),this.toKey=s??S.defaultToKey):(this.map=new Map,this.toKey=r??S.defaultToKey)}set(r,s){return this.map.set(this.toKey(r),s),this}get(r){return this.map.get(this.toKey(r))}has(r){return this.map.has(this.toKey(r))}get size(){return this.map.size}clear(){this.map.clear()}delete(r){return this.map.delete(this.toKey(r))}forEach(r,s){typeof s!="undefined"&&(r=r.bind(s));for(let[l,h]of this.map)r(h,b.URI.parse(l),this)}values(){return this.map.values()}*keys(){for(let r of this.map.keys())yield b.URI.parse(r)}*entries(){for(let r of this.map.entries())yield[b.URI.parse(r[0]),r[1]]}*[(R=Symbol.toStringTag,Symbol.iterator)](){for(let r of this.map)yield[b.URI.parse(r[0]),r[1]]}}e.ResourceMap=S,S.defaultToKey=v=>v.toString();var o;(function(v){v[v.None=0]="None",v[v.AsOld=1]="AsOld",v[v.AsNew=2]="AsNew"})(o=e.Touch||(e.Touch={}));class f{constructor(){this[F]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(r){return this._map.has(r)}get(r,s=0){const l=this._map.get(r);if(!!l)return s!==0&&this.touch(l,s),l.value}set(r,s,l=0){let h=this._map.get(r);if(h)h.value=s,l!==0&&this.touch(h,l);else{switch(h={key:r,value:s,next:void 0,previous:void 0},l){case 0:this.addItemLast(h);break;case 1:this.addItemFirst(h);break;case 2:this.addItemLast(h);break;default:this.addItemLast(h);break}this._map.set(r,h),this._size++}return this}delete(r){return!!this.remove(r)}remove(r){const s=this._map.get(r);if(!!s)return this._map.delete(r),this.removeItem(s),this._size--,s.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const r=this._head;return this._map.delete(r.key),this.removeItem(r),this._size--,r.value}forEach(r,s){const l=this._state;let h=this._head;for(;h;){if(s?r.bind(s)(h.value,h.key,this):r(h.value,h.key,this),this._state!==l)throw new Error("LinkedMap got modified during iteration.");h=h.next}}keys(){const r=this,s=this._state;let l=this._head;const h={[Symbol.iterator](){return h},next(){if(r._state!==s)throw new Error("LinkedMap got modified during iteration.");if(l){const p={value:l.key,done:!1};return l=l.next,p}else return{value:void 0,done:!0}}};return h}values(){const r=this,s=this._state;let l=this._head;const h={[Symbol.iterator](){return h},next(){if(r._state!==s)throw new Error("LinkedMap got modified during iteration.");if(l){const p={value:l.value,done:!1};return l=l.next,p}else return{value:void 0,done:!0}}};return h}entries(){const r=this,s=this._state;let l=this._head;const h={[Symbol.iterator](){return h},next(){if(r._state!==s)throw new Error("LinkedMap got modified during iteration.");if(l){const p={value:[l.key,l.value],done:!1};return l=l.next,p}else return{value:void 0,done:!0}}};return h}[(F=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(r){if(r>=this.size)return;if(r===0){this.clear();return}let s=this._head,l=this.size;for(;s&&l>r;)this._map.delete(s.key),s=s.next,l--;this._head=s,this._size=l,s&&(s.previous=void 0),this._state++}addItemFirst(r){if(!this._head&&!this._tail)this._tail=r;else if(this._head)r.next=this._head,this._head.previous=r;else throw new Error("Invalid list");this._head=r,this._state++}addItemLast(r){if(!this._head&&!this._tail)this._head=r;else if(this._tail)r.previous=this._tail,this._tail.next=r;else throw new Error("Invalid list");this._tail=r,this._state++}removeItem(r){if(r===this._head&&r===this._tail)this._head=void 0,this._tail=void 0;else if(r===this._head){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this._head=r.next}else if(r===this._tail){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this._tail=r.previous}else{const s=r.next,l=r.previous;if(!s||!l)throw new Error("Invalid list");s.previous=l,l.next=s}r.next=void 0,r.previous=void 0,this._state++}touch(r,s){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(r===this._head)return;const l=r.next,h=r.previous;r===this._tail?(h.next=void 0,this._tail=h):(l.previous=h,h.next=l),r.previous=void 0,r.next=this._head,this._head.previous=r,this._head=r,this._state++}else if(s===2){if(r===this._tail)return;const l=r.next,h=r.previous;r===this._head?(l.previous=void 0,this._head=l):(l.previous=h,h.next=l),r.next=void 0,r.previous=this._tail,this._tail.next=r,this._tail=r,this._state++}}}toJSON(){const r=[];return this.forEach((s,l)=>{r.push([l,s])}),r}fromJSON(r){this.clear();for(const[s,l]of r)this.set(s,l)}}e.LinkedMap=f;class y extends f{constructor(r,s=1){super();this._limit=r,this._ratio=Math.min(Math.max(0,s),1)}get limit(){return this._limit}set limit(r){this._limit=r,this.checkTrim()}get ratio(){return this._ratio}set ratio(r){this._ratio=Math.min(Math.max(0,r),1),this.checkTrim()}get(r,s=2){return super.get(r,s)}peek(r){return super.get(r,0)}set(r,s){return super.set(r,s,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=y;class i{constructor(r){C.set(this,void 0),Ze(this,C,r,"f")}get size(){return Ae(this,C,"f").size}forEach(r,s){Ae(this,C,"f").forEach(r,s)}get(r){return Ae(this,C,"f").get(r)}has(r){return Ae(this,C,"f").has(r)}entries(){return Ae(this,C,"f").entries()}keys(){return Ae(this,C,"f").keys()}values(){return Ae(this,C,"f").values()}[(C=new WeakMap,Symbol.iterator)](){return Ae(this,C,"f").entries()}}e.ReadonlyMapView=i}),define(be[106],Ee([0,1,20,9]),function(re,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function b(...q){return function(oe,he){for(let Te=0,Ue=q.length;Te<Ue;Te++){const He=q[Te](oe,he);if(He)return He}return null}}e.or=b,e.matchesStrictPrefix=R.bind(void 0,!1),e.matchesPrefix=R.bind(void 0,!0);function R(q,oe,he){if(!he||he.length<oe.length)return null;let Te;return q?Te=M.startsWithIgnoreCase(he,oe):Te=he.indexOf(oe)===0,Te?oe.length>0?[{start:0,end:oe.length}]:[]:null}function F(q,oe){const he=oe.toLowerCase().indexOf(q.toLowerCase());return he===-1?null:[{start:he,end:he+q.length}]}e.matchesContiguousSubString=F;function C(q,oe){return _(q.toLowerCase(),oe.toLowerCase(),0,0)}e.matchesSubString=C;function _(q,oe,he,Te){if(he===q.length)return[];if(Te===oe.length)return null;if(q[he]===oe[Te]){let Ue=null;return(Ue=_(q,oe,he+1,Te+1))?T({start:Te,end:Te+1},Ue):null}return _(q,oe,he,Te+1)}function I(q){return 97<=q&&q<=122}function t(q){return 65<=q&&q<=90}e.isUpper=t;function E(q){return 48<=q&&q<=57}function n(q){return q===32||q===9||q===10||q===13}const c=new Set;"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(q=>c.add(q.charCodeAt(0)));function u(q){return n(q)||c.has(q)}function a(q,oe){return q===oe||u(q)&&u(oe)}function w(q){return I(q)||t(q)||E(q)}function T(q,oe){return oe.length===0?oe=[q]:q.end===oe[0].start?oe[0].start=q.start:oe.unshift(q),oe}function S(q,oe){for(let he=oe;he<q.length;he++){const Te=q.charCodeAt(he);if(t(Te)||E(Te)||he>0&&!w(q.charCodeAt(he-1)))return he}return q.length}function o(q,oe,he,Te){if(he===q.length)return[];if(Te===oe.length)return null;if(q[he]!==oe[Te].toLowerCase())return null;{let Ue=null,He=Te+1;for(Ue=o(q,oe,he+1,Te+1);!Ue&&(He=S(oe,He))<oe.length;)Ue=o(q,oe,he+1,He),He++;return Ue===null?null:T({start:Te,end:Te+1},Ue)}}function f(q){let oe=0,he=0,Te=0,Ue=0,He=0;for(let X=0;X<q.length;X++)He=q.charCodeAt(X),t(He)&&oe++,I(He)&&he++,w(He)&&Te++,E(He)&&Ue++;const Ke=oe/q.length,ye=he/q.length,nt=Te/q.length,H=Ue/q.length;return{upperPercent:Ke,lowerPercent:ye,alphaPercent:nt,numericPercent:H}}function y(q){const{upperPercent:oe,lowerPercent:he}=q;return he===0&&oe>.6}function i(q){const{upperPercent:oe,lowerPercent:he,alphaPercent:Te,numericPercent:Ue}=q;return he>.2&&oe<.8&&Te>.6&&Ue<.2}function v(q){let oe=0,he=0,Te=0,Ue=0;for(let He=0;He<q.length;He++)Te=q.charCodeAt(He),t(Te)&&oe++,I(Te)&&he++,n(Te)&&Ue++;return(oe===0||he===0)&&Ue===0?q.length<=30:oe<=5}function r(q,oe){if(!oe||(oe=oe.trim(),oe.length===0)||!v(q)||oe.length>60)return null;const he=f(oe);if(!i(he)){if(!y(he))return null;oe=oe.toLowerCase()}let Te=null,Ue=0;for(q=q.toLowerCase();Ue<oe.length&&(Te=o(q,oe,0,Ue))===null;)Ue=S(oe,Ue+1);return Te}e.matchesCamelCase=r;function s(q,oe,he=!1){if(!oe||oe.length===0)return null;let Te=null,Ue=0;for(q=q.toLowerCase(),oe=oe.toLowerCase();Ue<oe.length&&(Te=l(q,oe,0,Ue,he))===null;)Ue=h(oe,Ue+1);return Te}e.matchesWords=s;function l(q,oe,he,Te,Ue){if(he===q.length)return[];if(Te===oe.length)return null;if(a(q.charCodeAt(he),oe.charCodeAt(Te))){let He=null,Ke=Te+1;if(He=l(q,oe,he+1,Te+1,Ue),!Ue)for(;!He&&(Ke=h(oe,Ke))<oe.length;)He=l(q,oe,he+1,Ke,Ue),Ke++;return He===null?null:T({start:Te,end:Te+1},He)}else return null}function h(q,oe){for(let he=oe;he<q.length;he++)if(u(q.charCodeAt(he))||he>0&&u(q.charCodeAt(he-1)))return he;return q.length}const p=b(e.matchesPrefix,r,F),k=b(e.matchesPrefix,r,C),P=new d.LRUCache(1e4);function g(q,oe,he=!1){if(typeof q!="string"||typeof oe!="string")return null;let Te=P.get(q);Te||(Te=new RegExp(M.convertSimple2RegExpPattern(q),"i"),P.set(q,Te));const Ue=Te.exec(oe);return Ue?[{start:Ue.index,end:Ue.index+Ue[0].length}]:he?k(q,oe):p(q,oe)}e.matchesFuzzy=g;function D(q,oe){const he=Ye(q,q.toLowerCase(),0,oe,oe.toLowerCase(),0,!0);return he?A(he):null}e.matchesFuzzy2=D;function m(q,oe,he,Te,Ue,He){const Ke=Math.min(13,q.length);for(;he<Ke;he++){const ye=Ye(q,oe,he,Te,Ue,He,!1);if(ye)return ye}return[0,He]}e.anyScore=m;function A(q){if(typeof q=="undefined")return[];const oe=[],he=q[1];for(let Te=q.length-1;Te>1;Te--){const Ue=q[Te]+he,He=oe[oe.length-1];He&&He.end===Ue?He.end=Ue+1:oe.push({start:Ue,end:Ue+1})}return oe}e.createMatches=A;const L=128;function V(){const q=[],oe=[];for(let he=0;he<=L;he++)oe[he]=0;for(let he=0;he<=L;he++)q.push(oe.slice(0));return q}function G(q){const oe=[];for(let he=0;he<=q;he++)oe[he]=0;return oe}const U=G(2*L),K=G(2*L),$=V(),B=V(),z=V(),Y=!1;function ne(q,oe,he,Te,Ue){function He(ye,nt,H=" "){for(;ye.length<nt;)ye=H+ye;return ye}let Ke=` |   |${Te.split("").map(ye=>He(ye,3)).join("|")}
`;for(let ye=0;ye<=he;ye++)ye===0?Ke+=" |":Ke+=`${oe[ye-1]}|`,Ke+=q[ye].slice(0,Ue+1).map(nt=>He(nt.toString(),3)).join("|")+`
`;return Ke}function j(q,oe,he,Te){q=q.substr(oe),he=he.substr(Te),console.log(ne(B,q,q.length,he,he.length)),console.log(ne(z,q,q.length,he,he.length)),console.log(ne($,q,q.length,he,he.length))}function le(q,oe){if(oe<0||oe>=q.length)return!1;const he=q.codePointAt(oe);switch(he){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!M.isEmojiImprecise(he)}}function se(q,oe){if(oe<0||oe>=q.length)return!1;switch(q.charCodeAt(oe)){case 32:case 9:return!0;default:return!1}}function ve(q,oe,he){return oe[q]!==he[q]}function Fe(q,oe,he,Te,Ue,He,Ke=!1){for(;oe<he&&Ue<He;)q[oe]===Te[Ue]&&(Ke&&(U[oe]=Ue),oe+=1),Ue+=1;return oe===he}e.isPatternInWord=Fe;var Me;(function(q){q[q.Diag=1]="Diag",q[q.Left=2]="Left",q[q.LeftLeft=3]="LeftLeft"})(Me||(Me={}));var Ne;(function(q){q.Default=[-100,0];function oe(he){return!he||he.length===2&&he[0]===-100&&he[1]===0}q.isDefault=oe})(Ne=e.FuzzyScore||(e.FuzzyScore={}));function Ye(q,oe,he,Te,Ue,He,Ke){const ye=q.length>L?L:q.length,nt=Te.length>L?L:Te.length;if(he>=ye||He>=nt||ye-he>nt-He||!Fe(oe,he,ye,Ue,He,nt,!0))return;Ve(ye,nt,he,He,oe,Ue);let H=1,X=1,fe=he,xe=He;const Qe=[!1];for(H=1,fe=he;fe<ye;H++,fe++){const mt=U[fe],St=K[fe],Ct=fe+1<ye?K[fe+1]:nt;for(X=mt-He+1,xe=mt;xe<Ct;X++,xe++){let pt=Number.MIN_SAFE_INTEGER,Xe=!1;xe<=St&&(pt=qe(q,oe,fe,he,Te,Ue,xe,nt,He,$[H-1][X-1]===0,Qe));let _t=0;pt!==Number.MAX_SAFE_INTEGER&&(Xe=!0,_t=pt+B[H-1][X-1]);const Pe=xe>mt,Se=Pe?B[H][X-1]+($[H][X-1]>0?-5:0):0,De=xe>mt+1&&$[H][X-1]>0,ee=De?B[H][X-2]+($[H][X-2]>0?-5:0):0;if(De&&(!Pe||ee>=Se)&&(!Xe||ee>=_t))B[H][X]=ee,z[H][X]=3,$[H][X]=0;else if(Pe&&(!Xe||Se>=_t))B[H][X]=Se,z[H][X]=2,$[H][X]=0;else if(Xe)B[H][X]=_t,z[H][X]=1,$[H][X]=$[H-1][X-1]+1;else throw new Error("not possible")}}if(Y&&j(q,he,Te,He),!Qe[0]&&!Ke)return;H--,X--;const rt=[B[H][X],He];let ct=0,ft=0;for(;H>=1;){let mt=X;do{const St=z[H][mt];if(St===3)mt=mt-2;else if(St===2)mt=mt-1;else break}while(mt>=1);ct>1&&oe[he+H-1]===Ue[He+X-1]&&!ve(mt+He-1,Te,Ue)&&ct+1>$[H][mt]&&(mt=X),mt===X?ct++:ct=1,ft||(ft=mt),H--,X=mt-1,rt.push(X)}nt===ye&&(rt[0]+=2);const Pt=ft-ye;return rt[0]-=Pt,rt}e.fuzzyScore=Ye;function Ve(q,oe,he,Te,Ue,He){let Ke=q-1,ye=oe-1;for(;Ke>=he&&ye>=Te;)Ue[Ke]===He[ye]&&(K[Ke]=ye,Ke--),ye--}function qe(q,oe,he,Te,Ue,He,Ke,ye,nt,H,X){if(oe[he]!==He[Ke])return Number.MIN_SAFE_INTEGER;let fe=1,xe=!1;return Ke===he-Te?fe=q[he]===Ue[Ke]?7:5:ve(Ke,Ue,He)&&(Ke===0||!ve(Ke-1,Ue,He))?(fe=q[he]===Ue[Ke]?7:5,xe=!0):le(He,Ke)&&(Ke===0||!le(He,Ke-1))?fe=5:(le(He,Ke-1)||se(He,Ke-1))&&(fe=5,xe=!0),fe>1&&he===Te&&(X[0]=!0),xe||(xe=ve(Ke,Ue,He)||le(He,Ke-1)||se(He,Ke-1)),he===Te?Ke>nt&&(fe-=xe?3:5):H?fe+=xe?2:0:fe+=xe?0:1,Ke+1===ye&&(fe-=xe?3:5),fe}function x(q,oe,he,Te,Ue,He,Ke){return te(q,oe,he,Te,Ue,He,!0,Ke)}e.fuzzyScoreGracefulAggressive=x;function Q(q,oe,he,Te,Ue,He,Ke){return te(q,oe,he,Te,Ue,He,!1,Ke)}e.fuzzyScoreGraceful=Q;function te(q,oe,he,Te,Ue,He,Ke,ye){let nt=Ye(q,oe,he,Te,Ue,He,ye);if(nt&&!Ke)return nt;if(q.length>=3){const H=Math.min(7,q.length-1);for(let X=he+1;X<H;X++){const fe=ae(q,X);if(fe){const xe=Ye(fe,fe.toLowerCase(),he,Te,Ue,He,ye);xe&&(xe[0]-=3,(!nt||xe[0]>nt[0])&&(nt=xe))}}}return nt}function ae(q,oe){if(oe+1>=q.length)return;const he=q[oe],Te=q[oe+1];if(he!==Te)return q.slice(0,oe)+Te+he+q.slice(oe+2)}}),define(be[107],Ee([0,1,34,106,9]),function(re,e,d,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const R=new RegExp(`\\$\\(${d.CSSIcon.iconNameExpression}(?:${d.CSSIcon.iconModifierExpression})?\\)`,"g"),F=new RegExp(`(\\\\)?${R.source}`,"g");function C(a){return a.replace(F,(w,T)=>T?w:`\\${w}`)}e.escapeIcons=C;const _=new RegExp(`\\\\${R.source}`,"g");function I(a){return a.replace(_,w=>`\\${w}`)}e.markdownEscapeEscapedIcons=I;const t=new RegExp(`(\\s)?(\\\\)?${R.source}(\\s)?`,"g");function E(a){return a.indexOf(e.iconStartMarker)===-1?a:a.replace(t,(w,T,S,o)=>S?w:T||o||"")}e.stripIcons=E;function n(a){const w=a.indexOf(e.iconStartMarker);return w===-1?{text:a}:c(a,w)}e.parseLabelWithIcons=n;function c(a,w){const T=[];let S="";function o(h){if(h){S+=h;for(const p of h)T.push(i)}}let f=-1,y="",i=0,v,r,s=w;const l=a.length;for(o(a.substr(0,w));s<l;)v=a[s],r=a[s+1],v===e.iconStartMarker[0]&&r===e.iconStartMarker[1]?(f=s,o(y),y=e.iconStartMarker,s++):v===")"&&f!==-1?(i+=s-f+1,f=-1,y=""):f!==-1?/^[a-z0-9\-]$/i.test(v)?y+=v:(o(y),f=-1,y=""):o(v),s++;return o(y),{text:S,iconOffsets:T}}function u(a,w,T=!1){const{text:S,iconOffsets:o}=w;if(!o||o.length===0)return(0,M.matchesFuzzy)(a,S,T);const f=(0,b.ltrim)(S," "),y=S.length-f.length,i=(0,M.matchesFuzzy)(a,f,T);if(i)for(const v of i){const r=o[v.start+y]+y;v.start+=r,v.end+=r}return i}e.matchesFuzzyIconAware=u}),define(be[76],Ee([0,1,16,107]),function(re,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var b;(function(n){n[n.Paragraph=0]="Paragraph",n[n.Break=1]="Break"})(b=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class R{constructor(c="",u=!1){if(this.value=c,typeof this.value!="string")throw(0,d.illegalArgument)("value");typeof u=="boolean"?(this.isTrusted=u,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=u.isTrusted??void 0,this.supportThemeIcons=u.supportThemeIcons??!1,this.supportHtml=u.supportHtml??!1)}appendText(c,u=0){return this.value+=I(this.supportThemeIcons?(0,M.escapeIcons)(c):c).replace(/([ \t]+)/g,(a,w)=>"&nbsp;".repeat(w.length)).replace(/\>/gm,"\\>").replace(/\n/g,u===1?`\\
`:`

`),this}appendMarkdown(c){return this.value+=c,this}appendCodeblock(c,u){return this.value+="\n```",this.value+=c,this.value+=`
`,this.value+=u,this.value+="\n```\n",this}}e.MarkdownString=R;function F(n){return C(n)?!n.value:Array.isArray(n)?n.every(F):!0}e.isEmptyMarkdownString=F;function C(n){return n instanceof R?!0:n&&typeof n=="object"?typeof n.value=="string"&&(typeof n.isTrusted=="boolean"||n.isTrusted===void 0)&&(typeof n.supportThemeIcons=="boolean"||n.supportThemeIcons===void 0):!1}e.isMarkdownString=C;function _(n,c){return n===c?!0:!n||!c?!1:n.value===c.value&&n.isTrusted===c.isTrusted&&n.supportThemeIcons===c.supportThemeIcons}e.markdownStringEqual=_;function I(n){return n.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=I;function t(n){return n&&n.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=t;function E(n){const c=[],u=n.split("|").map(w=>w.trim());n=u[0];const a=u[1];if(a){const w=/height=(\d+)/.exec(a),T=/width=(\d+)/.exec(a),S=w?w[1]:"",o=T?T[1]:"",f=isFinite(parseInt(o)),y=isFinite(parseInt(S));f&&c.push(`width="${o}"`),y&&c.push(`height="${S}"`)}return{href:n,dimensions:c}}e.parseHrefAndDimensions=E}),define(be[54],Ee([0,1,22,9,2]),function(re,e,d,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function R(t){return JSON.stringify(t,_)}e.stringify=R;function F(t){let E=JSON.parse(t);return E=I(E),E}e.parse=F;var C;(function(t){t[t.Uri=1]="Uri",t[t.Regexp=2]="Regexp",t[t.ScmResource=3]="ScmResource",t[t.ScmResourceGroup=4]="ScmResourceGroup",t[t.ScmProvider=5]="ScmProvider",t[t.CommentController=6]="CommentController",t[t.CommentThread=7]="CommentThread",t[t.CommentThreadReply=8]="CommentThreadReply",t[t.CommentNode=9]="CommentNode",t[t.CommentThreadNode=10]="CommentThreadNode",t[t.TimelineActionContext=11]="TimelineActionContext",t[t.NotebookCellActionContext=12]="NotebookCellActionContext",t[t.TestItemContext=13]="TestItemContext"})(C=e.MarshalledId||(e.MarshalledId={}));function _(t,E){return E instanceof RegExp?{$mid:2,source:E.source,flags:(0,M.regExpFlags)(E)}:E}function I(t,E=0){if(!t||E>200)return t;if(typeof t=="object"){switch(t.$mid){case 1:return b.URI.revive(t);case 2:return new RegExp(t.source,t.flags)}if(t instanceof d.VSBuffer||t instanceof Uint8Array)return t;if(Array.isArray(t))for(let n=0;n<t.length;++n)t[n]=I(t[n],E+1);else for(const n in t)Object.hasOwnProperty.call(t,n)&&(t[n]=I(t[n],E+1))}return t}e.revive=I}),define(be[11],Ee([0,1,26,2]),function(re,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var b;(function(C){C.inMemory="inmemory",C.vscode="vscode",C.internal="private",C.walkThrough="walkThrough",C.walkThroughSnippet="walkThroughSnippet",C.http="http",C.https="https",C.file="file",C.mailto="mailto",C.untitled="untitled",C.data="data",C.command="command",C.vscodeRemote="vscode-remote",C.vscodeRemoteResource="vscode-remote-resource",C.userData="vscode-userdata",C.vscodeCustomEditor="vscode-custom-editor",C.vscodeNotebook="vscode-notebook",C.vscodeNotebookCell="vscode-notebook-cell",C.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",C.vscodeNotebookCellOutput="vscode-notebook-cell-output",C.vscodeInteractive="vscode-interactive",C.vscodeInteractiveInput="vscode-interactive-input",C.vscodeSettings="vscode-settings",C.vscodeWorkspaceTrust="vscode-workspace-trust",C.vscodeTerminal="vscode-terminal",C.webviewPanel="webview-panel",C.vscodeWebview="vscode-webview",C.extension="extension",C.vscodeFileResource="vscode-file",C.tmp="tmp"})(b=e.Schemas||(e.Schemas={}));class R{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(_){this._preferredWebSchema=_}setDelegate(_){this._delegate=_}set(_,I,t){this._hosts[_]=I,this._ports[_]=t}setConnectionToken(_,I){this._connectionTokens[_]=I}rewrite(_){if(this._delegate)return this._delegate(_);const I=_.authority;let t=this._hosts[I];t&&t.indexOf(":")!==-1&&(t=`[${t}]`);const E=this._ports[I],n=this._connectionTokens[I];let c=`path=${encodeURIComponent(_.path)}`;return typeof n=="string"&&(c+=`&tkn=${encodeURIComponent(n)}`),M.URI.from({scheme:d.isWeb?this._preferredWebSchema:b.vscodeRemoteResource,authority:`${t}:${E}`,path:"/vscode-remote-resource",query:c})}}e.RemoteAuthorities=new R;class F{asBrowserUri(_,I){const t=this.toUri(_,I);return t.scheme===b.vscodeRemote?e.RemoteAuthorities.rewrite(t):t.scheme===b.file&&(d.isNative||typeof d.globals.importScripts=="function"&&d.globals.origin===`${b.vscodeFileResource}://${F.FALLBACK_AUTHORITY}`)?t.with({scheme:b.vscodeFileResource,authority:t.authority||F.FALLBACK_AUTHORITY,query:null,fragment:null}):t}asFileUri(_,I){const t=this.toUri(_,I);return t.scheme===b.vscodeFileResource?t.with({scheme:b.file,authority:t.authority!==F.FALLBACK_AUTHORITY?t.authority:null,query:null,fragment:null}):t}toUri(_,I){return M.URI.isUri(_)?_:M.URI.parse(I.toUrl(_))}}F.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new F}),define(be[24],Ee([0,1,43,11,17,26,9,2]),function(re,e,d,M,b,R,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function _(c){return(0,C.uriToFsPath)(c,!0)}e.originalFSPath=_;class I{constructor(u){this._ignorePathCasing=u}compare(u,a,w=!1){return u===a?0:(0,F.compare)(this.getComparisonKey(u,w),this.getComparisonKey(a,w))}isEqual(u,a,w=!1){return u===a?!0:!u||!a?!1:this.getComparisonKey(u,w)===this.getComparisonKey(a,w)}getComparisonKey(u,a=!1){return u.with({path:this._ignorePathCasing(u)?u.path.toLowerCase():void 0,fragment:a?null:void 0}).toString()}ignorePathCasing(u){return this._ignorePathCasing(u)}isEqualOrParent(u,a,w=!1){if(u.scheme===a.scheme){if(u.scheme===M.Schemas.file)return d.isEqualOrParent(_(u),_(a),this._ignorePathCasing(u))&&u.query===a.query&&(w||u.fragment===a.fragment);if((0,e.isEqualAuthority)(u.authority,a.authority))return d.isEqualOrParent(u.path,a.path,this._ignorePathCasing(u),"/")&&u.query===a.query&&(w||u.fragment===a.fragment)}return!1}joinPath(u,...a){return C.URI.joinPath(u,...a)}basenameOrAuthority(u){return(0,e.basename)(u)||u.authority}basename(u){return b.posix.basename(u.path)}extname(u){return b.posix.extname(u.path)}dirname(u){if(u.path.length===0)return u;let a;return u.scheme===M.Schemas.file?a=C.URI.file(b.dirname(_(u))).path:(a=b.posix.dirname(u.path),u.authority&&a.length&&a.charCodeAt(0)!==47&&(console.error(`dirname("${u.toString})) resulted in a relative path`),a="/")),u.with({path:a})}normalizePath(u){if(!u.path.length)return u;let a;return u.scheme===M.Schemas.file?a=C.URI.file(b.normalize(_(u))).path:a=b.posix.normalize(u.path),u.with({path:a})}relativePath(u,a){if(u.scheme!==a.scheme||!(0,e.isEqualAuthority)(u.authority,a.authority))return;if(u.scheme===M.Schemas.file){const S=b.relative(_(u),_(a));return R.isWindows?d.toSlashes(S):S}let w=u.path||"/",T=a.path||"/";if(this._ignorePathCasing(u)){let S=0;for(const o=Math.min(w.length,T.length);S<o&&!(w.charCodeAt(S)!==T.charCodeAt(S)&&w.charAt(S).toLowerCase()!==T.charAt(S).toLowerCase());S++);w=T.substr(0,S)+w.substr(S)}return b.posix.relative(w,T)}resolvePath(u,a){if(u.scheme===M.Schemas.file){const w=C.URI.file(b.resolve(_(u),a));return u.with({authority:w.authority,path:w.path})}return a=d.toPosixPath(a),u.with({path:b.posix.resolve(u.path,a)})}isAbsolutePath(u){return!!u.path&&u.path[0]==="/"}isEqualAuthority(u,a){return u===a||(0,F.equalsIgnoreCase)(u,a)}hasTrailingPathSeparator(u,a=b.sep){if(u.scheme===M.Schemas.file){const w=_(u);return w.length>d.getRoot(w).length&&w[w.length-1]===a}else{const w=u.path;return w.length>1&&w.charCodeAt(w.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(u.fsPath)}}removeTrailingPathSeparator(u,a=b.sep){return(0,e.hasTrailingPathSeparator)(u,a)?u.with({path:u.path.substr(0,u.path.length-1)}):u}addTrailingPathSeparator(u,a=b.sep){let w=!1;if(u.scheme===M.Schemas.file){const T=_(u);w=T!==void 0&&T.length===d.getRoot(T).length&&T[T.length-1]===a}else{a="/";const T=u.path;w=T.length===1&&T.charCodeAt(T.length-1)===47}return!w&&!(0,e.hasTrailingPathSeparator)(u,a)?u.with({path:u.path+"/"}):u}}e.ExtUri=I,e.extUri=new I(()=>!1),e.extUriBiasedIgnorePathCase=new I(c=>c.scheme===M.Schemas.file?!R.isLinux:!0),e.extUriIgnorePathCase=new I(c=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function t(c,u){const a=[];for(let w=0;w<c.length;w++){const T=u(c[w]);c.some((S,o)=>o===w?!1:(0,e.isEqualOrParent)(T,u(S)))||a.push(c[w])}return a}e.distinctParents=t;var E;(function(c){c.META_DATA_LABEL="label",c.META_DATA_DESCRIPTION="description",c.META_DATA_SIZE="size",c.META_DATA_MIME="mime";function u(a){const w=new Map;a.path.substring(a.path.indexOf(";")+1,a.path.lastIndexOf(";")).split(";").forEach(o=>{const[f,y]=o.split(":");f&&y&&w.set(f,y)});const S=a.path.substring(0,a.path.indexOf(";"));return S&&w.set(c.META_DATA_MIME,S),w}c.parseMetaData=u})(E=e.DataUri||(e.DataUri={}));function n(c,u,a){if(u){let w=c.path;return w&&w[0]!==b.posix.sep&&(w=b.posix.sep+w),c.with({scheme:a,authority:u,path:w})}return c.with({scheme:a})}e.toLocalResource=n}),define(be[14],Ee([0,1,21,16,3,6,24]),function(re,e,d,M,b,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function C($){return!!$&&typeof $.then=="function"}e.isThenable=C;function _($){const B=new d.CancellationTokenSource,z=$(B.token),Y=new Promise((ne,j)=>{const le=B.token.onCancellationRequested(()=>{le.dispose(),B.dispose(),j((0,M.canceled)())});Promise.resolve(z).then(se=>{le.dispose(),B.dispose(),ne(se)},se=>{le.dispose(),B.dispose(),j(se)})});return new class{cancel(){B.cancel()}then(ne,j){return Y.then(ne,j)}catch(ne){return this.then(void 0,ne)}finally(ne){return Y.finally(ne)}}}e.createCancelablePromise=_;function I($,B,z){return Promise.race([$,new Promise(Y=>B.onCancellationRequested(()=>Y(z)))])}e.raceCancellation=I;async function t($){let B=-1;const z=$.map((ne,j)=>ne.then(le=>(B=j,le))),Y=await Promise.race(z);return $.forEach((ne,j)=>{j!==B&&ne.cancel()}),Y}e.raceCancellablePromises=t;function E($,B,z){let Y;const ne=setTimeout(()=>{Y?.(void 0),z?.()},B);return Promise.race([$.finally(()=>clearTimeout(ne)),new Promise(j=>Y=j)])}e.raceTimeout=E;function n($){return new Promise((B,z)=>{const Y=$();C(Y)?Y.then(B,z):B(Y)})}e.asPromise=n;class c{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(B){if(this.activePromise){if(this.queuedPromiseFactory=B,!this.queuedPromise){const z=()=>{this.queuedPromise=null;const Y=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,Y};this.queuedPromise=new Promise(Y=>{this.activePromise.then(z,z).then(Y)})}return new Promise((z,Y)=>{this.queuedPromise.then(z,Y)})}return this.activePromise=B(),new Promise((z,Y)=>{this.activePromise.then(ne=>{this.activePromise=null,z(ne)},ne=>{this.activePromise=null,Y(ne)})})}}e.Throttler=c;class u{constructor(){this.current=Promise.resolve(null)}queue(B){return this.current=this.current.then(()=>B(),()=>B())}}e.Sequencer=u;class a{constructor(){this.promiseMap=new Map}queue(B,z){const ne=(this.promiseMap.get(B)??Promise.resolve()).catch(()=>{}).then(z).finally(()=>{this.promiseMap.get(B)===ne&&this.promiseMap.delete(B)});return this.promiseMap.set(B,ne),ne}}e.SequencerByKey=a;class w{constructor(B){this.defaultDelay=B,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(B,z=this.defaultDelay){return this.task=B,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((Y,ne)=>{this.doResolve=Y,this.doReject=ne}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const Y=this.task;return this.task=null,Y()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},z),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,M.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=w;class T{constructor(B){this.delayer=new w(B),this.throttler=new c}trigger(B,z){return this.delayer.trigger(()=>this.throttler.queue(B),z)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=T;class S{constructor(){this._isOpen=!1,this._promise=new Promise((B,z)=>{this._completePromise=B})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=S;class o extends S{constructor(B){super();this._timeout=setTimeout(()=>this.open(),B)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=o;function f($,B){return B?new Promise((z,Y)=>{const ne=setTimeout(()=>{j.dispose(),z()},$),j=B.onCancellationRequested(()=>{clearTimeout(ne),j.dispose(),Y((0,M.canceled)())})}):_(z=>f($,z))}e.timeout=f;function y($,B=0){const z=setTimeout($,B);return(0,R.toDisposable)(()=>clearTimeout(z))}e.disposableTimeout=y;function i($){const B=[];let z=0;const Y=$.length;function ne(){return z<Y?$[z++]():null}function j(le){le!=null&&B.push(le);const se=ne();return se?se.then(j):Promise.resolve(B)}return Promise.resolve(null).then(j)}e.sequence=i;function v($,B=Y=>!!Y,z=null){let Y=0;const ne=$.length,j=()=>{if(Y>=ne)return Promise.resolve(z);const le=$[Y++];return Promise.resolve(le()).then(ve=>B(ve)?Promise.resolve(ve):j())};return j()}e.first=v;function r($,B=Y=>!!Y,z=null){if($.length===0)return Promise.resolve(z);let Y=$.length;const ne=()=>{Y=-1;for(const j of $)j.cancel?.()};return new Promise((j,le)=>{for(const se of $)se.then(ve=>{--Y>=0&&B(ve)?(ne(),j(ve)):Y===0&&j(z)}).catch(ve=>{--Y>=0&&(ne(),le(ve))})})}e.firstParallel=r;class s{constructor(B){this._size=0,this.maxDegreeOfParalellism=B,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new b.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(B){return this._size++,new Promise((z,Y)=>{this.outstandingPromises.push({factory:B,c:z,e:Y}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const B=this.outstandingPromises.shift();this.runningPromises++;const z=B.factory();z.then(B.c,B.e),z.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=s;class l extends s{constructor(){super(1)}}e.Queue=l;class h{constructor(){this.queues=new Map}queueFor(B,z=F.extUri){const Y=z.getComparisonKey(B);let ne=this.queues.get(Y);return ne||(ne=new l,b.Event.once(ne.onFinished)(()=>{ne?.dispose(),this.queues.delete(Y)}),this.queues.set(Y,ne)),ne}dispose(){this.queues.forEach(B=>B.dispose()),this.queues.clear()}}e.ResourceQueue=h;class p{constructor(B,z){this._token=-1,typeof B=="function"&&typeof z=="number"&&this.setIfNotSet(B,z)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(B,z){this.cancel(),this._token=setTimeout(()=>{this._token=-1,B()},z)}setIfNotSet(B,z){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,B()},z))}}e.TimeoutTimer=p;class k{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(B,z){this.cancel(),this._token=setInterval(()=>{B()},z)}}e.IntervalTimer=k;class P{constructor(B,z){this.timeoutToken=-1,this.runner=B,this.timeout=z,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(B=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,B)}get delay(){return this.timeout}set delay(B){this.timeout=B}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=P;class g{constructor(B,z){z%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${z}ms is not a multiple of 1000ms.`),this.runner=B,this.timeout=z,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(B=this.timeout){B%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${B}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(B/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=g;class D extends P{constructor(B,z){super(B,z);this.units=[]}work(B){this.units.push(B),this.isScheduled()||this.schedule()}doRun(){const B=this.units;this.units=[],this.runner&&this.runner(B)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=D;class m extends R.Disposable{constructor(B,z,Y,ne){super();this.maxWorkChunkSize=B,this.maxPendingWork=z,this.throttleDelay=Y,this.handler=ne,this.pendingWork=[],this.throttler=this._register(new R.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(B){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+B.length>this.maxPendingWork)return!1}else if(this.pending+B.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...B),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new P(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=m,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const $=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=B=>{const z=setTimeout(()=>B($));let Y=!1;return{dispose(){Y||(Y=!0,clearTimeout(z))}}}}else e.runWhenIdle=($,B)=>{const z=requestIdleCallback($,typeof B=="number"?{timeout:B}:void 0);let Y=!1;return{dispose(){Y||(Y=!0,cancelIdleCallback(z))}}}}();class A{constructor(B){this._didRun=!1,this._executor=()=>{try{this._value=B()}catch(z){this._error=z}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=A;async function L($,B,z){let Y;for(let ne=0;ne<z;ne++)try{return await $()}catch(j){Y=j,await f(B)}throw Y}e.retry=L;class V{hasPending(B){return this._pending?typeof B=="number"?this._pending.taskId===B:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(B,z,Y){return this._pending={taskId:B,cancel:()=>Y?.(),promise:z},z.then(()=>this.donePending(B),()=>this.donePending(B)),z}donePending(B){this._pending&&B===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const B=this._next;this._next=void 0,B.run().then(B.promiseResolve,B.promiseReject)}}setNext(B){if(this._next)this._next.run=B;else{let z,Y;const ne=new Promise((j,le)=>{z=j,Y=le});this._next={run:B,promise:ne,promiseResolve:z,promiseReject:Y}}return this._next.promise}}e.TaskSequentializer=V;class G{constructor(B){this.interval=B,this.lastIncrementTime=0,this.value=0}increment(){const B=Date.now();return B-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=B,this.value=0),this.value++,this.value}}e.IntervalCounter=G;class U{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((B,z)=>{this.completeCallback=B,this.errorCallback=z})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(B){return new Promise(z=>{this.completeCallback(B),this.resolved=!0,z()})}error(B){return new Promise(z=>{this.errorCallback(B),this.rejected=!0,z()})}cancel(){new Promise(B=>{this.errorCallback((0,M.canceled)()),this.rejected=!0,B()})}}e.DeferredPromise=U;var K;(function($){async function B(z){let Y;const ne=await Promise.all(z.map(j=>j.then(le=>le,le=>{Y||(Y=le)})));if(typeof Y!="undefined")throw Y;return ne}$.settled=B})(K=e.Promises||(e.Promises={}))}),define(be[108],Ee([0,1,14,17]),function(re,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const b=new d.IdleValue(()=>{const P=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:P,collatorIsNumeric:P.resolvedOptions().numeric}}),R=new d.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),F=new d.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function C(P,g,D=!1){const m=P||"",A=g||"",L=b.value.collator.compare(m,A);return b.value.collatorIsNumeric&&L===0&&m!==A?m<A?-1:1:L}e.compareFileNames=C;function _(P,g){const D=R.value.collator;return P=P||"",g=g||"",y(D,P,g)}e.compareFileNamesDefault=_;function I(P,g){const D=R.value.collator;return P=P||"",g=g||"",s(P,g)||y(D,P,g)}e.compareFileNamesUpper=I;function t(P,g){const D=R.value.collator;return P=P||"",g=g||"",r(P,g)||y(D,P,g)}e.compareFileNamesLower=t;function E(P,g){return P=P||"",g=g||"",P===g?0:P<g?-1:1}e.compareFileNamesUnicode=E;function n(P,g,D=!1){D||(P=P&&P.toLowerCase(),g=g&&g.toLowerCase());const[m,A]=o(P),[L,V]=o(g);return m!==L?m<L?-1:1:A===V?0:A<V?-1:1}e.noIntlCompareFileNames=n;function c(P,g){const[D,m]=o(P),[A,L]=o(g);let V=b.value.collator.compare(m,L);if(V===0){if(b.value.collatorIsNumeric&&m!==L)return m<L?-1:1;if(V=b.value.collator.compare(D,A),b.value.collatorIsNumeric&&V===0&&D!==A)return D<A?-1:1}return V}e.compareFileExtensions=c;function u(P,g){P=P||"",g=g||"";const D=f(P),m=f(g),A=R.value.collator,L=F.value.collator;return y(L,D,m)||y(A,P,g)}e.compareFileExtensionsDefault=u;function a(P,g){P=P||"",g=g||"";const D=f(P),m=f(g),A=R.value.collator,L=F.value.collator;return y(L,D,m)||s(P,g)||y(A,P,g)}e.compareFileExtensionsUpper=a;function w(P,g){P=P||"",g=g||"";const D=f(P),m=f(g),A=R.value.collator,L=F.value.collator;return y(L,D,m)||r(P,g)||y(A,P,g)}e.compareFileExtensionsLower=w;function T(P,g){P=P||"",g=g||"";const D=f(P).toLowerCase(),m=f(g).toLowerCase();return D!==m?D<m?-1:1:P!==g?P<g?-1:1:0}e.compareFileExtensionsUnicode=T;const S=/^(.*?)(\.([^.]*))?$/;function o(P,g=!1){const D=P?S.exec(P):[];let m=[D&&D[1]||"",D&&D[3]||""];return g&&(!m[0]&&m[1]||m[0]&&m[0].charAt(0)===".")&&(m=[m[0]+"."+m[1],""]),m}function f(P){const g=P?S.exec(P):[];return g&&g[1]&&g[1].charAt(0)!=="."&&g[3]||""}function y(P,g,D){let m=P.compare(g,D);return m!==0?m:g.length!==D.length?g.length<D.length?-1:1:0}function i(P){const g=P.charAt(0);return g.toLocaleUpperCase()!==g}function v(P){const g=P.charAt(0);return g.toLocaleLowerCase()!==g}function r(P,g){return i(P)&&v(g)?-1:v(P)&&i(g)?1:0}function s(P,g){return v(P)&&i(g)?-1:i(P)&&v(g)?1:0}function l(P,g,D=!1){return D||(P=P&&P.toLowerCase(),g=g&&g.toLowerCase()),P===g?0:P<g?-1:1}function h(P,g,D=!1){const m=P.split(M.sep),A=g.split(M.sep),L=m.length-1,V=A.length-1;let G,U;for(let K=0;;K++){if(G=L===K,U=V===K,G&&U)return C(m[K],A[K],D);if(G)return-1;if(U)return 1;const $=l(m[K],A[K],D);if($!==0)return $}}e.comparePaths=h;function p(P,g,D){const m=P.toLowerCase(),A=g.toLowerCase(),L=k(P,g,D);if(L)return L;const V=m.endsWith(D),G=A.endsWith(D);if(V!==G)return V?-1:1;const U=C(m,A);return U!==0?U:m.localeCompare(A)}e.compareAnything=p;function k(P,g,D){const m=P.toLowerCase(),A=g.toLowerCase(),L=m.startsWith(D),V=A.startsWith(D);if(L!==V)return L?-1:1;if(L&&V){if(m.length<A.length)return-1;if(m.length>A.length)return 1}return 0}e.compareByPrefix=k}),define(be[27],Ee([0,1,14,43,20,17,9]),function(re,e,d,M,b,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function C(){return Object.create(null)}e.getEmptyExpression=C;const _="**",I="/",t="[/\\\\]",E="[^/\\\\]",n=/\//g;function c(Y){switch(Y){case 0:return"";case 1:return`${E}*?`;default:return`(?:${t}|${E}+${t}|${t}${E}+)*?`}}function u(Y,ne){if(!Y)return[];const j=[];let le=!1,se=!1,ve="";for(const Fe of Y){switch(Fe){case ne:if(!le&&!se){j.push(ve),ve="";continue}break;case"{":le=!0;break;case"}":le=!1;break;case"[":se=!0;break;case"]":se=!1;break}ve+=Fe}return ve&&j.push(ve),j}e.splitGlobAware=u;function a(Y){if(!Y)return"";let ne="";const j=u(Y,I);if(j.every(le=>le===_))ne=".*";else{let le=!1;j.forEach((se,ve)=>{if(se===_){le||(ne+=c(2),le=!0);return}let Fe=!1,Me="",Ne=!1,Ye="";for(const Ve of se){if(Ve!=="}"&&Fe){Me+=Ve;continue}if(Ne&&(Ve!=="]"||!Ye)){let qe;Ve==="-"?qe=Ve:(Ve==="^"||Ve==="!")&&!Ye?qe="^":Ve===I?qe="":qe=F.escapeRegExpCharacters(Ve),Ye+=qe;continue}switch(Ve){case"{":Fe=!0;continue;case"[":Ne=!0;continue;case"}":ne+=`(?:${u(Me,",").map(Q=>a(Q)).join("|")})`,Fe=!1,Me="";break;case"]":ne+="["+Ye+"]",Ne=!1,Ye="";break;case"?":ne+=E;continue;case"*":ne+=c(1);continue;default:ne+=F.escapeRegExpCharacters(Ve)}}ve<j.length-1&&(j[ve+1]!==_||ve+2<j.length)&&(ne+=t),le=!1})}return ne}const w=/^\*\*\/\*\.[\w\.-]+$/,T=/^\*\*\/([\w\.-]+)\/?$/,S=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,o=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,f=/^\*\*((\/[\w\.-]+)+)\/?$/,y=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new b.LRUCache(1e4),v=function(){return!1},r=function(){return null};function s(Y,ne){if(!Y)return r;let j;typeof Y!="string"?j=Y.pattern:j=Y,j=j.trim();const le=`${j}_${!!ne.trimForExclusions}`;let se=i.get(le);if(se)return l(se,Y);let ve;if(w.test(j)){const Fe=j.substr(4);se=function(Me,Ne){return typeof Me=="string"&&Me.endsWith(Fe)?j:null}}else(ve=T.exec(h(j,ne)))?se=p(ve[1],j):(ne.trimForExclusions?o:S).test(j)?se=k(j,ne):(ve=f.exec(h(j,ne)))?se=P(ve[1].substr(1),j,!0):(ve=y.exec(h(j,ne)))?se=P(ve[1],j,!1):se=g(j);return i.set(le,se),l(se,Y)}function l(Y,ne){return typeof ne=="string"?Y:function(j,le){return M.isEqualOrParent(j,ne.base)?Y(R.relative(ne.base,j),le):null}}function h(Y,ne){return ne.trimForExclusions&&Y.endsWith("/**")?Y.substr(0,Y.length-2):Y}function p(Y,ne){const j=`/${Y}`,le=`\\${Y}`,se=function(Fe,Me){return typeof Fe!="string"?null:Me?Me===Y?ne:null:Fe===Y||Fe.endsWith(j)||Fe.endsWith(le)?ne:null},ve=[Y];return se.basenames=ve,se.patterns=[ne],se.allBasenames=ve,se}function k(Y,ne){const j=z(Y.slice(1,-1).split(",").map(Me=>s(Me,ne)).filter(Me=>Me!==r),Y),le=j.length;if(!le)return r;if(le===1)return j[0];const se=function(Me,Ne){for(let Ye=0,Ve=j.length;Ye<Ve;Ye++)if(j[Ye](Me,Ne))return Y;return null},ve=j.find(Me=>!!Me.allBasenames);ve&&(se.allBasenames=ve.allBasenames);const Fe=j.reduce((Me,Ne)=>Ne.allPaths?Me.concat(Ne.allPaths):Me,[]);return Fe.length&&(se.allPaths=Fe),se}function P(Y,ne,j){const le=R.sep===R.posix.sep,se=le?Y:Y.replace(n,R.sep),ve=R.sep+se,Fe=R.posix.sep+Y,Me=j?function(Ne,Ye){return typeof Ne=="string"&&(Ne===se||Ne.endsWith(ve)||!le&&(Ne===Y||Ne.endsWith(Fe)))?ne:null}:function(Ne,Ye){return typeof Ne=="string"&&(Ne===se||!le&&Ne===Y)?ne:null};return Me.allPaths=[(j?"*/":"./")+Y],Me}function g(Y){try{const ne=new RegExp(`^${a(Y)}$`);return function(j){return ne.lastIndex=0,typeof j=="string"&&ne.test(j)?Y:null}}catch(ne){return r}}function D(Y,ne,j){return!Y||typeof ne!="string"?!1:m(Y)(ne,void 0,j)}e.match=D;function m(Y,ne={}){if(!Y)return v;if(typeof Y=="string"||G(Y)){const j=s(Y,ne);if(j===r)return v;const le=function(se,ve){return!!j(se,ve)};return j.allBasenames&&(le.allBasenames=j.allBasenames),j.allPaths&&(le.allPaths=j.allPaths),le}return $(Y,ne)}e.parse=m;function A(Y){if(!Y)return;let ne;return j=>(ne||(ne=(Y()||Promise.resolve([])).then(le=>le?V(le):{})),ne.then(le=>!!le[j]))}e.hasSiblingPromiseFn=A;function L(Y){if(!Y)return;let ne;return j=>{if(!ne){const le=Y();ne=le?V(le):{}}return!!ne[j]}}e.hasSiblingFn=L;function V(Y){const ne={};for(const j of Y)ne[j]=!0;return ne}function G(Y){const ne=Y;return ne&&typeof ne.base=="string"&&typeof ne.pattern=="string"}e.isRelativePattern=G;function U(Y){return Y.allBasenames||[]}e.getBasenameTerms=U;function K(Y){return Y.allPaths||[]}e.getPathTerms=K;function $(Y,ne){const j=z(Object.getOwnPropertyNames(Y).map(Me=>B(Me,Y[Me],ne)).filter(Me=>Me!==r)),le=j.length;if(!le)return r;if(!j.some(Me=>!!Me.requiresSiblings)){if(le===1)return j[0];const Me=function(Ve,qe){for(let x=0,Q=j.length;x<Q;x++){const te=j[x](Ve,qe);if(te)return te}return null},Ne=j.find(Ve=>!!Ve.allBasenames);Ne&&(Me.allBasenames=Ne.allBasenames);const Ye=j.reduce((Ve,qe)=>qe.allPaths?Ve.concat(qe.allPaths):Ve,[]);return Ye.length&&(Me.allPaths=Ye),Me}const se=function(Me,Ne,Ye){let Ve;for(let qe=0,x=j.length;qe<x;qe++){const Q=j[qe];Q.requiresSiblings&&Ye&&(Ne||(Ne=R.basename(Me)),Ve||(Ve=Ne.substr(0,Ne.length-R.extname(Me).length)));const te=Q(Me,Ne,Ve,Ye);if(te)return te}return null},ve=j.find(Me=>!!Me.allBasenames);ve&&(se.allBasenames=ve.allBasenames);const Fe=j.reduce((Me,Ne)=>Ne.allPaths?Me.concat(Ne.allPaths):Me,[]);return Fe.length&&(se.allPaths=Fe),se}function B(Y,ne,j){if(ne===!1)return r;const le=s(Y,j);if(le===r)return r;if(typeof ne=="boolean")return le;if(ne){const se=ne.when;if(typeof se=="string"){const ve=(Fe,Me,Ne,Ye)=>{if(!Ye||!le(Fe,Me))return null;const Ve=se.replace("$(basename)",Ne),qe=Ye(Ve);return(0,d.isThenable)(qe)?qe.then(x=>x?Y:null):qe?Y:null};return ve.requiresSiblings=!0,ve}}return le}function z(Y,ne){const j=Y.filter(Me=>!!Me.basenames);if(j.length<2)return Y;const le=j.reduce((Me,Ne)=>{const Ye=Ne.basenames;return Ye?Me.concat(Ye):Me},[]);let se;if(ne){se=[];for(let Me=0,Ne=le.length;Me<Ne;Me++)se.push(ne)}else se=j.reduce((Me,Ne)=>{const Ye=Ne.patterns;return Ye?Me.concat(Ye):Me},[]);const ve=function(Me,Ne){if(typeof Me!="string")return null;if(!Ne){let Ve;for(Ve=Me.length;Ve>0;Ve--){const qe=Me.charCodeAt(Ve-1);if(qe===47||qe===92)break}Ne=Me.substr(Ve)}const Ye=le.indexOf(Ne);return Ye!==-1?se[Ye]:null};ve.basenames=le,ve.patterns=se,ve.allBasenames=le;const Fe=Y.filter(Me=>!Me.basenames);return Fe.push(ve),Fe}}),define(be[77],Ee([0,1,43,11,17,26,24,9,2]),function(re,e,d,M,b,R,F,C,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function I(s,l,h){if(typeof s=="string"&&(s=_.URI.file(s)),h){const k=h.getWorkspaceFolder(s);if(k){const P=h.getWorkspace().folders.length>1;let g;if((0,F.isEqual)(k.uri,s)?g="":g=(0,F.relativePath)(k.uri,s),P){const D=k.name?k.name:(0,F.basename)(k.uri);g=g?D+" \u2022 "+g:D}return g}}if(s.scheme!==M.Schemas.file&&s.scheme!==M.Schemas.untitled)return s.with({query:null,fragment:null}).toString(!0);if((0,d.hasDriveLetter)(s.fsPath))return(0,b.normalize)(E(s.fsPath));let p=(0,b.normalize)(s.fsPath);return!R.isWindows&&l?.userHome&&(p=c(p,l.userHome.fsPath)),p}e.getPathLabel=I;function t(s){if(!s)return;typeof s=="string"&&(s=_.URI.file(s));const l=(0,F.basename)(s)||(s.scheme===M.Schemas.file?s.fsPath:s.path);return R.isWindows&&(0,d.isRootOrDriveLetter)(l)?E(l):l}e.getBaseLabel=t;function E(s){return(0,d.hasDriveLetter)(s)?s.charAt(0).toUpperCase()+s.slice(1):s}e.normalizeDriveLetter=E;let n=Object.create(null);function c(s,l){if(R.isWindows||!s||!l)return s;let h=n.original===l?n.normalized:void 0;return h||(h=`${(0,C.rtrim)(l,b.posix.sep)}${b.posix.sep}`,n={original:l,normalized:h}),(R.isLinux?s.startsWith(h):(0,C.startsWithIgnoreCase)(s,h))&&(s=`~/${s.substr(h.length)}`),s}e.tildify=c;function u(s,l){return s.replace(/^~($|\/|\\)/,`${l}$1`)}e.untildify=u;const a="\u2026",w="\\\\",T="~";function S(s,l=b.sep){const h=new Array(s.length);let p=!1;for(let k=0;k<s.length;k++){let P=s[k];if(P===""){h[k]=`.${l}`;continue}if(!P){h[k]=P;continue}p=!0;let g="";P.indexOf(w)===0?(g=P.substr(0,P.indexOf(w)+w.length),P=P.substr(P.indexOf(w)+w.length)):P.indexOf(l)===0?(g=P.substr(0,P.indexOf(l)+l.length),P=P.substr(P.indexOf(l)+l.length)):P.indexOf(T)===0&&(g=P.substr(0,P.indexOf(T)+T.length),P=P.substr(P.indexOf(T)+T.length));const D=P.split(l);for(let m=1;p&&m<=D.length;m++)for(let A=D.length-m;p&&A>=0;A--){p=!1;let L=D.slice(A,A+m).join(l);for(let V=0;!p&&V<s.length;V++)if(V!==k&&s[V]&&s[V].indexOf(L)>-1){const G=A+m===D.length,U=A>0&&s[V].indexOf(l)>-1?l+L:L,K=s[V].endsWith(U);p=!G||K}if(!p){let V="";(D[0].endsWith(":")||g!=="")&&(A===1&&(A=0,m++,L=D[0]+l+L),A>0&&(V=D[0]+l),V=g+V),A>0&&(V=V+a+l),V=V+L,A+m<D.length&&(V=V+l+a),h[k]=V}}p&&(h[k]=P)}return h}e.shorten=S;var o;(function(s){s[s.TEXT=0]="TEXT",s[s.VARIABLE=1]="VARIABLE",s[s.SEPARATOR=2]="SEPARATOR"})(o||(o={}));function f(s,l=Object.create(null)){const h=[];let p=!1,k="";for(const P of s)if(P==="$"||p&&P==="{")k&&h.push({value:k,type:o.TEXT}),k="",p=!0;else if(P==="}"&&p){const g=l[k];if(typeof g=="string")g.length&&h.push({value:g,type:o.VARIABLE});else if(g){const D=h[h.length-1];(!D||D.type!==o.SEPARATOR)&&h.push({value:g.label,type:o.SEPARATOR})}k="",p=!1}else k+=P;return k&&!p&&h.push({value:k,type:o.TEXT}),h.filter((P,g)=>{if(P.type===o.SEPARATOR){const D=h[g-1],m=h[g+1];return[D,m].every(A=>A&&(A.type===o.VARIABLE||A.type===o.TEXT)&&A.value.length>0)}return!0}).map(P=>P.value).join("")}e.template=f;function y(s,l){return R.isMacintosh||l?s.replace(/\(&&\w\)|&&/g,"").replace(/&/g,R.isMacintosh?"&":"&&"):s.replace(/&&|&/g,h=>h==="&"?"&&":"&")}e.mnemonicMenuLabel=y;function i(s,l){return R.isMacintosh||l?s.replace(/\(&&\w\)|&&/g,""):R.isWindows?s.replace(/&&|&/g,h=>h==="&"?"&&":"&"):s.replace(/&&/g,"_")}e.mnemonicButtonLabel=i;function v(s){return s.replace(/&/g,"&&")}e.unmnemonicLabel=v;function r(s){const l=s.indexOf("/")!==-1?b.posix:b.win32,h=l.basename(s),p=l.dirname(s);return h.length?{name:h,parentPath:p}:{name:p,parentPath:""}}e.splitName=r}),define(be[78],Ee([0,1,27,11,17,24,9]),function(re,e,d,M,b,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var C;(function(s){s.text="text/plain",s.binary="application/octet-stream",s.unknown="application/unknown",s.markdown="text/markdown"})(C=e.Mimes||(e.Mimes={}));let _=[],I=[],t=[];function E(s,l=!1){const h=n(s);_.push(h),h.userConfigured?t.push(h):I.push(h),l&&!h.userConfigured&&_.forEach(p=>{p.mime===h.mime||p.userConfigured||(h.extension&&p.extension===h.extension&&console.warn(`Overwriting extension <<${h.extension}>> to now point to mime <<${h.mime}>>`),h.filename&&p.filename===h.filename&&console.warn(`Overwriting filename <<${h.filename}>> to now point to mime <<${h.mime}>>`),h.filepattern&&p.filepattern===h.filepattern&&console.warn(`Overwriting filepattern <<${h.filepattern}>> to now point to mime <<${h.mime}>>`),h.firstline&&p.firstline===h.firstline&&console.warn(`Overwriting firstline <<${h.firstline}>> to now point to mime <<${h.mime}>>`))})}e.registerTextMime=E;function n(s){return{id:s.id,mime:s.mime,filename:s.filename,extension:s.extension,filepattern:s.filepattern,firstline:s.firstline,userConfigured:s.userConfigured,filenameLowercase:s.filename?s.filename.toLowerCase():void 0,extensionLowercase:s.extension?s.extension.toLowerCase():void 0,filepatternLowercase:s.filepattern?(0,d.parse)(s.filepattern.toLowerCase()):void 0,filepatternOnPath:s.filepattern?s.filepattern.indexOf(b.posix.sep)>=0:!1}}function c(s){s?(_=_.filter(l=>!l.userConfigured),t=[]):(_=[],I=[],t=[])}e.clearTextMimes=c;function u(s,l){let h;if(s)switch(s.scheme){case M.Schemas.file:h=s.fsPath;break;case M.Schemas.data:h=R.DataUri.parseMetaData(s).get(R.DataUri.META_DATA_LABEL);break;default:h=s.path}if(!h)return[C.unknown];h=h.toLowerCase();const p=(0,b.basename)(h),k=a(h,p,t);if(k)return[k,C.text];const P=a(h,p,I);if(P)return[P,C.text];if(l){const g=w(l);if(g)return[g,C.text]}return[C.unknown]}e.guessMimeTypes=u;function a(s,l,h){let p=null,k=null,P=null;for(let g=h.length-1;g>=0;g--){const D=h[g];if(l===D.filenameLowercase){p=D;break}if(D.filepattern&&(!k||D.filepattern.length>k.filepattern.length)){const m=D.filepatternOnPath?s:l;D.filepatternLowercase?.(m)&&(k=D)}D.extension&&(!P||D.extension.length>P.extension.length)&&l.endsWith(D.extensionLowercase)&&(P=D)}return p?p.mime:k?k.mime:P?P.mime:null}function w(s){if((0,F.startsWithUTF8BOM)(s)&&(s=s.substr(1)),s.length>0)for(let l=_.length-1;l>=0;l--){const h=_[l];if(!h.firstline)continue;const p=s.match(h.firstline);if(p&&p.length>0)return h.mime}return null}function T(s){return s?typeof s=="string"?s===C.binary||s===C.text||s===C.unknown:s.length===1&&T(s[0]):!0}e.isUnspecific=T;const S={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},o={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function f(s){const l=(0,b.extname)(s),h=S[l.toLowerCase()];return h!==void 0?h:y(s)}e.getMediaOrTextMime=f;function y(s){const l=(0,b.extname)(s);return o[l.toLowerCase()]}e.getMediaMime=y;function i(s){for(const l in o)if(o[l]===s)return l}e.getExtensionForMimeType=i;const v=/^(.+)\/(.+?)(;.+)?$/;function r(s,l){const h=v.exec(s);return h?`${h[1].toLowerCase()}/${h[2].toLowerCase()}${h[3]??""}`:l?void 0:s}e.normalizeMimeType=r}),define(be[109],Ee([0,1,2]),function(re,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function M(t){return t.toJSON()}class b{constructor(E){this._uriTransformer=E}transformIncoming(E){const n=this._uriTransformer.transformIncoming(E);return n===E?E:M(d.URI.from(n))}transformOutgoing(E){const n=this._uriTransformer.transformOutgoing(E);return n===E?E:M(d.URI.from(n))}transformOutgoingURI(E){const n=this._uriTransformer.transformOutgoing(E);return n===E?E:d.URI.from(n)}transformOutgoingScheme(E){return this._uriTransformer.transformOutgoingScheme(E)}}e.URITransformer=b,e.DefaultURITransformer=new class{transformIncoming(t){return t}transformOutgoing(t){return t}transformOutgoingURI(t){return t}transformOutgoingScheme(t){return t}};function R(t,E,n){if(!t||n>200)return null;if(typeof t=="object"){if(t instanceof d.URI)return E.transformOutgoing(t);for(let c in t)if(Object.hasOwnProperty.call(t,c)){const u=R(t[c],E,n+1);u!==null&&(t[c]=u)}}return null}function F(t,E){const n=R(t,E,0);return n===null?t:n}e.transformOutgoingURIs=F;function C(t,E,n,c){if(!t||c>200)return null;if(typeof t=="object"){if(t.$mid===1)return n?d.URI.revive(E.transformIncoming(t)):E.transformIncoming(t);for(let u in t)if(Object.hasOwnProperty.call(t,u)){const a=C(t[u],E,n,c+1);a!==null&&(t[u]=a)}}return null}function _(t,E){const n=C(t,E,!1,0);return n===null?t:n}e.transformIncomingURIs=_;function I(t,E){const n=C(t,E,!0,0);return n===null?t:n}e.transformAndReviveIncomingURIs=I}),define(be[36],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const d=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function M(_){return d.test(_)}e.isUUID=M;const b=new Uint8Array(16),R=[];for(let _=0;_<256;_++)R.push(_.toString(16).padStart(2,"0"));let F;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?F=crypto.getRandomValues.bind(crypto):F=function(_){for(let I=0;I<_.length;I++)_[I]=Math.floor(Math.random()*256);return _};function C(){F(b),b[6]=b[6]&15|64,b[8]=b[8]&63|128;let _=0,I="";return I+=R[b[_++]],I+=R[b[_++]],I+=R[b[_++]],I+=R[b[_++]],I+="-",I+=R[b[_++]],I+=R[b[_++]],I+="-",I+=R[b[_++]],I+=R[b[_++]],I+="-",I+=R[b[_++]],I+=R[b[_++]],I+="-",I+=R[b[_++]],I+=R[b[_++]],I+=R[b[_++]],I+=R[b[_++]],I+=R[b[_++]],I+=R[b[_++]],I}e.generateUuid=C}),define(be[110],Ee([0,1,226]),function(re,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var M;(function(F){F[F.Regular=0]="Regular",F[F.Whitespace=1]="Whitespace",F[F.WordSeparator=2]="WordSeparator"})(M=e.WordCharacterClass||(e.WordCharacterClass={}));class b extends d.CharacterClassifier{constructor(C){super(0);for(let _=0,I=C.length;_<I;_++)this.set(C.charCodeAt(_),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=b;function R(F){let C={};return _=>(C.hasOwnProperty(_)||(C[_]=F(_)),C[_])}e.getMapForWordSeparators=R(F=>new b(F))}),define(be[79],Ee([0,1,23]),function(re,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var M;(function(a){a[a.Left=1]="Left",a[a.Center=2]="Center",a[a.Right=4]="Right",a[a.Full=7]="Full"})(M=e.OverviewRulerLane||(e.OverviewRulerLane={}));var b;(function(a){a[a.Inline=1]="Inline",a[a.Gutter=2]="Gutter"})(b=e.MinimapPosition||(e.MinimapPosition={}));var R;(function(a){a[a.TextDefined=0]="TextDefined",a[a.LF=1]="LF",a[a.CRLF=2]="CRLF"})(R=e.EndOfLinePreference||(e.EndOfLinePreference={}));var F;(function(a){a[a.LF=1]="LF",a[a.CRLF=2]="CRLF"})(F=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var C;(function(a){a[a.LF=0]="LF",a[a.CRLF=1]="CRLF"})(C=e.EndOfLineSequence||(e.EndOfLineSequence={}));class _{constructor(w){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,w.tabSize|0),this.indentSize=w.tabSize|0,this.insertSpaces=Boolean(w.insertSpaces),this.defaultEOL=w.defaultEOL|0,this.trimAutoWhitespace=Boolean(w.trimAutoWhitespace),this.bracketPairColorizationOptions=w.bracketPairColorizationOptions}equals(w){return this.tabSize===w.tabSize&&this.indentSize===w.indentSize&&this.insertSpaces===w.insertSpaces&&this.defaultEOL===w.defaultEOL&&this.trimAutoWhitespace===w.trimAutoWhitespace&&(0,d.equals)(this.bracketPairColorizationOptions,w.bracketPairColorizationOptions)}createChangeEvent(w){return{tabSize:this.tabSize!==w.tabSize,indentSize:this.indentSize!==w.indentSize,insertSpaces:this.insertSpaces!==w.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==w.trimAutoWhitespace}}}e.TextModelResolvedOptions=_;class I{constructor(w,T){this._findMatchBrand=void 0,this.range=w,this.matches=T}}e.FindMatch=I;var t;(function(a){a[a.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",a[a.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",a[a.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",a[a.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(t=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var E;(function(a){a[a.Left=0]="Left",a[a.Right=1]="Right",a[a.None=2]="None"})(E=e.PositionAffinity||(e.PositionAffinity={}));var n;(function(a){a[a.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(n=e.ModelConstants||(e.ModelConstants={}));class c{constructor(w,T,S,o,f,y){this.identifier=w,this.range=T,this.text=S,this.forceMoveMarkers=o,this.isAutoWhitespaceEdit=f,this._isTracked=y}}e.ValidAnnotatedEditOperation=c;class u{constructor(w,T,S){this.reverseEdits=w,this.changes=T,this.trimAutoWhitespaceLineNumbers=S}}e.ApplyEditsResult=u}),define(be[111],Ee([0,1,9,110,112,44,79]),function(re,e,d,M,b,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const C=999;class _{constructor(o,f,y,i){this.searchString=o,this.isRegex=f,this.matchCase=y,this.wordSeparators=i}parseSearchRequest(){if(this.searchString==="")return null;let o;this.isRegex?o=I(this.searchString):o=this.searchString.indexOf(`
`)>=0;let f=null;try{f=d.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:o,global:!0,unicode:!0})}catch(i){return null}if(!f)return null;let y=!this.isRegex&&!o;return y&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(y=this.matchCase),new t(f,this.wordSeparators?(0,M.getMapForWordSeparators)(this.wordSeparators):null,y?this.searchString:null)}}e.SearchParams=_;function I(S){if(!S||S.length===0)return!1;for(let o=0,f=S.length;o<f;o++)if(S.charCodeAt(o)===92){if(o++,o>=f)break;const i=S.charCodeAt(o);if(i===110||i===114||i===87||i===119)return!0}return!1}e.isMultilineRegexSource=I;class t{constructor(o,f,y){this.regex=o,this.wordSeparators=f,this.simpleSearch=y}}e.SearchData=t;function E(S,o,f){if(!f)return new F.FindMatch(S,null);let y=[];for(let i=0,v=o.length;i<v;i++)y[i]=o[i];return new F.FindMatch(S,y)}e.createFindMatch=E;class n{constructor(o){let f=[],y=0;for(let i=0,v=o.length;i<v;i++)o.charCodeAt(i)===10&&(f[y++]=i);this._lineFeedsOffsets=f}findLineFeedCountBeforeOffset(o){const f=this._lineFeedsOffsets;let y=0,i=f.length-1;if(i===-1||o<=f[0])return 0;for(;y<i;){const v=y+((i-y)/2>>0);f[v]>=o?i=v-1:f[v+1]>=o?(y=v,i=v):y=v+1}return y+1}}class c{static findMatches(o,f,y,i,v){const r=f.parseSearchRequest();return r?r.regex.multiline?this._doFindMatchesMultiline(o,y,new T(r.wordSeparators,r.regex),i,v):this._doFindMatchesLineByLine(o,y,r,i,v):[]}static _getMultilineMatchRange(o,f,y,i,v,r){let s,l=0;i?(l=i.findLineFeedCountBeforeOffset(v),s=f+v+l):s=f+v;let h;if(i){let g=i.findLineFeedCountBeforeOffset(v+r.length)-l;h=s+r.length+g}else h=s+r.length;const p=o.getPositionAt(s),k=o.getPositionAt(h);return new R.Range(p.lineNumber,p.column,k.lineNumber,k.column)}static _doFindMatchesMultiline(o,f,y,i,v){const r=o.getOffsetAt(f.getStartPosition()),s=o.getValueInRange(f,1),l=o.getEOL()===`\r
`?new n(s):null,h=[];let p=0,k;for(y.reset(0);k=y.next(s);)if(h[p++]=E(this._getMultilineMatchRange(o,r,s,l,k.index,k[0]),k,i),p>=v)return h;return h}static _doFindMatchesLineByLine(o,f,y,i,v){const r=[];let s=0;if(f.startLineNumber===f.endLineNumber){const h=o.getLineContent(f.startLineNumber).substring(f.startColumn-1,f.endColumn-1);return s=this._findMatchesInLine(y,h,f.startLineNumber,f.startColumn-1,s,r,i,v),r}const l=o.getLineContent(f.startLineNumber).substring(f.startColumn-1);s=this._findMatchesInLine(y,l,f.startLineNumber,f.startColumn-1,s,r,i,v);for(let h=f.startLineNumber+1;h<f.endLineNumber&&s<v;h++)s=this._findMatchesInLine(y,o.getLineContent(h),h,0,s,r,i,v);if(s<v){const h=o.getLineContent(f.endLineNumber).substring(0,f.endColumn-1);s=this._findMatchesInLine(y,h,f.endLineNumber,0,s,r,i,v)}return r}static _findMatchesInLine(o,f,y,i,v,r,s,l){const h=o.wordSeparators;if(!s&&o.simpleSearch){const P=o.simpleSearch,g=P.length,D=f.length;let m=-g;for(;(m=f.indexOf(P,m+g))!==-1;)if((!h||w(h,f,D,m,g))&&(r[v++]=new F.FindMatch(new R.Range(y,m+1+i,y,m+1+g+i),null),v>=l))return v;return v}const p=new T(o.wordSeparators,o.regex);let k;p.reset(0);do if(k=p.next(f),k&&(r[v++]=E(new R.Range(y,k.index+1+i,y,k.index+1+k[0].length+i),k,s),v>=l))return v;while(k);return v}static findNextMatch(o,f,y,i){const v=f.parseSearchRequest();if(!v)return null;const r=new T(v.wordSeparators,v.regex);return v.regex.multiline?this._doFindNextMatchMultiline(o,y,r,i):this._doFindNextMatchLineByLine(o,y,r,i)}static _doFindNextMatchMultiline(o,f,y,i){const v=new b.Position(f.lineNumber,1),r=o.getOffsetAt(v),s=o.getLineCount(),l=o.getValueInRange(new R.Range(v.lineNumber,v.column,s,o.getLineMaxColumn(s)),1),h=o.getEOL()===`\r
`?new n(l):null;y.reset(f.column-1);let p=y.next(l);return p?E(this._getMultilineMatchRange(o,r,l,h,p.index,p[0]),p,i):f.lineNumber!==1||f.column!==1?this._doFindNextMatchMultiline(o,new b.Position(1,1),y,i):null}static _doFindNextMatchLineByLine(o,f,y,i){const v=o.getLineCount(),r=f.lineNumber,s=o.getLineContent(r),l=this._findFirstMatchInLine(y,s,r,f.column,i);if(l)return l;for(let h=1;h<=v;h++){const p=(r+h-1)%v,k=o.getLineContent(p+1),P=this._findFirstMatchInLine(y,k,p+1,1,i);if(P)return P}return null}static _findFirstMatchInLine(o,f,y,i,v){o.reset(i-1);const r=o.next(f);return r?E(new R.Range(y,r.index+1,y,r.index+1+r[0].length),r,v):null}static findPreviousMatch(o,f,y,i){const v=f.parseSearchRequest();if(!v)return null;const r=new T(v.wordSeparators,v.regex);return v.regex.multiline?this._doFindPreviousMatchMultiline(o,y,r,i):this._doFindPreviousMatchLineByLine(o,y,r,i)}static _doFindPreviousMatchMultiline(o,f,y,i){const v=this._doFindMatchesMultiline(o,new R.Range(1,1,f.lineNumber,f.column),y,i,10*C);if(v.length>0)return v[v.length-1];const r=o.getLineCount();return f.lineNumber!==r||f.column!==o.getLineMaxColumn(r)?this._doFindPreviousMatchMultiline(o,new b.Position(r,o.getLineMaxColumn(r)),y,i):null}static _doFindPreviousMatchLineByLine(o,f,y,i){const v=o.getLineCount(),r=f.lineNumber,s=o.getLineContent(r).substring(0,f.column-1),l=this._findLastMatchInLine(y,s,r,i);if(l)return l;for(let h=1;h<=v;h++){const p=(v+r-h-1)%v,k=o.getLineContent(p+1),P=this._findLastMatchInLine(y,k,p+1,i);if(P)return P}return null}static _findLastMatchInLine(o,f,y,i){let v=null,r;for(o.reset(0);r=o.next(f);)v=E(new R.Range(y,r.index+1,y,r.index+1+r[0].length),r,i);return v}}e.TextModelSearch=c;function u(S,o,f,y,i){if(y===0)return!0;const v=o.charCodeAt(y-1);if(S.get(v)!==0||v===13||v===10)return!0;if(i>0){const r=o.charCodeAt(y);if(S.get(r)!==0)return!0}return!1}function a(S,o,f,y,i){if(y+i===f)return!0;const v=o.charCodeAt(y+i);if(S.get(v)!==0||v===13||v===10)return!0;if(i>0){const r=o.charCodeAt(y+i-1);if(S.get(r)!==0)return!0}return!1}function w(S,o,f,y,i){return u(S,o,f,y,i)&&a(S,o,f,y,i)}e.isValidMatch=w;class T{constructor(o,f){this._wordSeparators=o,this._searchRegex=f,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(o){this._searchRegex.lastIndex=o,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(o){const f=o.length;let y;do{if(this._prevMatchStartIndex+this._prevMatchLength===f||(y=this._searchRegex.exec(o),!y))return null;const i=y.index,v=y[0].length;if(i===this._prevMatchStartIndex&&v===this._prevMatchLength){if(v===0){d.getNextCodePoint(o,f,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=i,this._prevMatchLength=v,!this._wordSeparators||w(this._wordSeparators,o,f,i,v))return y}while(y);return null}}e.Searcher=T}),define(be[113],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var d;(function(F){F[F.None=0]="None",F[F.Indent=1]="Indent",F[F.IndentOutdent=2]="IndentOutdent",F[F.Outdent=3]="Outdent"})(d=e.IndentAction||(e.IndentAction={}));class M{constructor(C){if(this._standardAutoClosingPairConditionalBrand=void 0,this.open=C.open,this.close=C.close,this._standardTokenMask=0,Array.isArray(C.notIn))for(let _=0,I=C.notIn.length;_<I;_++)switch(C.notIn[_]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(C){return(this._standardTokenMask&C)==0}}e.StandardAutoClosingPairConditional=M;class b{constructor(C){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const _ of C)R(this.autoClosingPairsOpenByStart,_.open.charAt(0),_),R(this.autoClosingPairsOpenByEnd,_.open.charAt(_.open.length-1),_),R(this.autoClosingPairsCloseByStart,_.close.charAt(0),_),R(this.autoClosingPairsCloseByEnd,_.close.charAt(_.close.length-1),_),_.close.length===1&&_.open.length===1&&R(this.autoClosingPairsCloseSingleChar,_.close,_)}}e.AutoClosingPairs=b;function R(F,C,_){F.has(C)?F.get(C).push(_):F.set(C,[_])}}),define(be[55],Ee([0,1,27,17]),function(re,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function b(R,F,C,_){if(Array.isArray(R)){let I=0;for(const t of R){const E=b(t,F,C,_);if(E===10)return E;E>I&&(I=E)}return I}else{if(typeof R=="string")return _?R==="*"?5:R===C?10:0:0;if(R){const{language:I,pattern:t,scheme:E,hasAccessToAllModels:n}=R;if(!_&&!n)return 0;let c=0;if(E)if(E===F.scheme)c=10;else if(E==="*")c=5;else return 0;if(I)if(I===C)c=10;else if(I==="*")c=Math.max(c,5);else return 0;if(t){let u;if(typeof t=="string"?u=t:u={...t,base:(0,M.normalize)(t.base)},u===F.fsPath||(0,d.match)(u,F.fsPath))c=10;else return 0}return c}else return 0}}e.score=b}),define(be[114],Ee([0,1,3,6]),function(re,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class b{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new d.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(F){this._onDidChange.fire({changedLanguages:F,changedColorMap:!1})}register(F,C){return this._map.set(F,C),this.fire([F]),(0,M.toDisposable)(()=>{this._map.get(F)===C&&(this._map.delete(F),this.fire([F]))})}registerPromise(F,C){let _=null,I=!1;return this._promises.set(F,C.then(t=>{this._promises.delete(F),!(I||!t)&&(_=this.register(F,t))})),(0,M.toDisposable)(()=>{I=!0,_&&_.dispose()})}getPromise(F){const C=this.get(F);if(C)return Promise.resolve(C);const _=this._promises.get(F);return _?_.then(I=>this.get(F)):null}get(F){return this._map.get(F)||null}setColorMap(F){this._colorMap=F,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=b}),define(be[80],Ee([0,1,22,26]),function(re,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var b;(function(E){E[E.Full=1]="Full",E[E.Delta=2]="Delta"})(b||(b={}));function R(E){for(let n=0,c=E.length;n<c;n+=4){const u=E[n+0],a=E[n+1],w=E[n+2],T=E[n+3];E[n+0]=T,E[n+1]=w,E[n+2]=a,E[n+3]=u}}function F(E){const n=new Uint8Array(E.buffer,E.byteOffset,E.length*4);return M.isLittleEndian()||R(n),d.VSBuffer.wrap(n)}function C(E){const n=E.buffer;if(M.isLittleEndian()||R(n),n.byteOffset%4==0)return new Uint32Array(n.buffer,n.byteOffset,n.length/4);{const c=new Uint8Array(n.byteLength);return c.set(n),new Uint32Array(c.buffer,c.byteOffset,c.length/4)}}function _(E){const n=new Uint32Array(I(E));let c=0;if(n[c++]=E.id,E.type==="full")n[c++]=1,n[c++]=E.data.length,n.set(E.data,c),c+=E.data.length;else{n[c++]=2,n[c++]=E.deltas.length;for(const u of E.deltas)n[c++]=u.start,n[c++]=u.deleteCount,u.data?(n[c++]=u.data.length,n.set(u.data,c),c+=u.data.length):n[c++]=0}return F(n)}e.encodeSemanticTokensDto=_;function I(E){let n=0;if(n+=1+1,E.type==="full")n+=1+E.data.length;else{n+=1,n+=(1+1+1)*E.deltas.length;for(const c of E.deltas)c.data&&(n+=c.data.length)}return n}function t(E){const n=C(E);let c=0;const u=n[c++];if(n[c++]===1){const S=n[c++],o=n.subarray(c,c+S);return c+=S,{id:u,type:"full",data:o}}const w=n[c++];let T=[];for(let S=0;S<w;S++){const o=n[c++],f=n[c++],y=n[c++];let i;y>0&&(i=n.subarray(c,c+y),c+=y),T[S]={start:o,deleteCount:f,data:i}}return{id:u,type:"delta",deltas:T}}e.decodeSemanticTokensDto=t}),define(be[115],Ee([18,19]),function(re,e){return re.create("vs/base/common/errorMessage",e)}),define(be[56],Ee([0,1,12,10,115]),function(re,e,d,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function R(I,t){return t&&(I.stack||I.stacktrace)?b.localize(0,null,C(I),F(I.stack)||F(I.stacktrace)):C(I)}function F(I){return Array.isArray(I)?I.join(`
`):I}function C(I){return typeof I.code=="string"&&typeof I.errno=="number"&&typeof I.syscall=="string"?b.localize(1,null,I.message):I.message||b.localize(2,null)}function _(I=null,t=!1){if(!I)return b.localize(3,null);if(Array.isArray(I)){const E=d.coalesce(I),n=_(E[0],t);return E.length>1?b.localize(4,null,n,E.length):n}if(M.isString(I))return I;if(I.detail){const E=I.detail;if(E.error)return R(E.error,t);if(E.exception)return R(E.exception,t)}return I.stack?R(I,t):I.message?I.message:b.localize(5,null)}e.toErrorMessage=_}),define(be[116],Ee([18,19]),function(re,e){return re.create("vs/editor/common/config/editorOptions",e)}),define(be[117],Ee([0,1,116,26,118]),function(re,e,d,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var R;(function(H){H[H.None=0]="None",H[H.Keep=1]="Keep",H[H.Brackets=2]="Brackets",H[H.Advanced=3]="Advanced",H[H.Full=4]="Full"})(R=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class F{constructor(X){this._values=X}hasChanged(X){return this._values[X]}}e.ConfigurationChangedEvent=F;class C{constructor(){this._values=[]}_read(X){return this._values[X]}get(X){return this._values[X]}_write(X,fe){this._values[X]=fe}}e.ValidatedEditorOptions=C;class _{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=_;class I{constructor(X,fe,xe,Qe){this.id=X,this.name=fe,this.defaultValue=xe,this.schema=Qe}compute(X,fe,xe){return xe}}class t{constructor(X,fe=null){this.schema=void 0,this.id=X,this.name="_never_",this.defaultValue=void 0,this.deps=fe}validate(X){return this.defaultValue}}class E{constructor(X,fe,xe,Qe){this.id=X,this.name=fe,this.defaultValue=xe,this.schema=Qe}validate(X){return typeof X=="undefined"?this.defaultValue:X}compute(X,fe,xe){return xe}}function n(H,X){return typeof H=="undefined"?X:H==="false"?!1:Boolean(H)}e.boolean=n;class c extends E{constructor(X,fe,xe,Qe=void 0){typeof Qe!="undefined"&&(Qe.type="boolean",Qe.default=xe),super(X,fe,xe,Qe)}validate(X){return n(X,this.defaultValue)}}function u(H,X,fe,xe){if(typeof H=="undefined")return X;let Qe=parseInt(H,10);return isNaN(Qe)?X:(Qe=Math.max(fe,Qe),Qe=Math.min(xe,Qe),Qe|0)}e.clampedInt=u;class a extends E{constructor(X,fe,xe,Qe,rt,ct=void 0){typeof ct!="undefined"&&(ct.type="integer",ct.default=xe,ct.minimum=Qe,ct.maximum=rt),super(X,fe,xe,ct),this.minimum=Qe,this.maximum=rt}static clampedInt(X,fe,xe,Qe){return u(X,fe,xe,Qe)}validate(X){return a.clampedInt(X,this.defaultValue,this.minimum,this.maximum)}}class w extends E{constructor(X,fe,xe,Qe,rt){typeof rt!="undefined"&&(rt.type="number",rt.default=xe),super(X,fe,xe,rt),this.validationFn=Qe}static clamp(X,fe,xe){return X<fe?fe:X>xe?xe:X}static float(X,fe){if(typeof X=="number")return X;if(typeof X=="undefined")return fe;const xe=parseFloat(X);return isNaN(xe)?fe:xe}validate(X){return this.validationFn(w.float(X,this.defaultValue))}}class T extends E{static string(X,fe){return typeof X!="string"?fe:X}constructor(X,fe,xe,Qe=void 0){typeof Qe!="undefined"&&(Qe.type="string",Qe.default=xe),super(X,fe,xe,Qe)}validate(X){return T.string(X,this.defaultValue)}}function S(H,X,fe){return typeof H!="string"||fe.indexOf(H)===-1?X:H}e.stringSet=S;class o extends E{constructor(X,fe,xe,Qe,rt=void 0){typeof rt!="undefined"&&(rt.type="string",rt.enum=Qe,rt.default=xe),super(X,fe,xe,rt),this._allowedValues=Qe}validate(X){return S(X,this.defaultValue,this._allowedValues)}}class f extends I{constructor(X,fe,xe,Qe,rt,ct,ft=void 0){typeof ft!="undefined"&&(ft.type="string",ft.enum=rt,ft.default=Qe),super(X,fe,xe,ft),this._allowedValues=rt,this._convert=ct}validate(X){return typeof X!="string"?this.defaultValue:this._allowedValues.indexOf(X)===-1?this.defaultValue:this._convert(X)}}function y(H){switch(H){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class i extends I{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[d.localize(0,null),d.localize(1,null),d.localize(2,null)],default:"auto",description:d.localize(3,null)})}validate(X){switch(X){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(X,fe,xe){return xe===0?X.accessibilitySupport:xe}}class v extends I{constructor(){const X={insertSpace:!0,ignoreEmptyLines:!0};super(18,"comments",X,{"editor.comments.insertSpace":{type:"boolean",default:X.insertSpace,description:d.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:X.ignoreEmptyLines,description:d.localize(5,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const fe=X;return{insertSpace:n(fe.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:n(fe.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var r;(function(H){H[H.Hidden=0]="Hidden",H[H.Blink=1]="Blink",H[H.Smooth=2]="Smooth",H[H.Phase=3]="Phase",H[H.Expand=4]="Expand",H[H.Solid=5]="Solid"})(r=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function s(H){switch(H){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var l;(function(H){H[H.Line=1]="Line",H[H.Block=2]="Block",H[H.Underline=3]="Underline",H[H.LineThin=4]="LineThin",H[H.BlockOutline=5]="BlockOutline",H[H.UnderlineThin=6]="UnderlineThin"})(l=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function h(H){switch(H){case l.Line:return"line";case l.Block:return"block";case l.Underline:return"underline";case l.LineThin:return"line-thin";case l.BlockOutline:return"block-outline";case l.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=h;function p(H){switch(H){case"line":return l.Line;case"block":return l.Block;case"underline":return l.Underline;case"line-thin":return l.LineThin;case"block-outline":return l.BlockOutline;case"underline-thin":return l.UnderlineThin}}class k extends t{constructor(){super(127,[65,32])}compute(X,fe,xe){const Qe=["monaco-editor"];return fe.get(32)&&Qe.push(fe.get(32)),X.extraEditorClassName&&Qe.push(X.extraEditorClassName),fe.get(65)==="default"?Qe.push("mouse-default"):fe.get(65)==="copy"&&Qe.push("mouse-copy"),fe.get(100)&&Qe.push("showUnused"),fe.get(125)&&Qe.push("showDeprecated"),Qe.join(" ")}}class P extends c{constructor(){super(31,"emptySelectionClipboard",!0,{description:d.localize(6,null)})}compute(X,fe,xe){return xe&&X.emptySelectionClipboard}}class g extends I{constructor(){const X={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(34,"find",X,{"editor.find.cursorMoveOnType":{type:"boolean",default:X.cursorMoveOnType,description:d.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:X.seedSearchStringFromSelection,enumDescriptions:[d.localize(8,null),d.localize(9,null),d.localize(10,null)],description:d.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:X.autoFindInSelection,enumDescriptions:[d.localize(12,null),d.localize(13,null),d.localize(14,null)],description:d.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:X.globalFindClipboard,description:d.localize(16,null),included:M.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:X.addExtraSpaceOnTop,description:d.localize(17,null)},"editor.find.loop":{type:"boolean",default:X.loop,description:d.localize(18,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const fe=X;return{cursorMoveOnType:n(fe.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof X.seedSearchStringFromSelection=="boolean"?X.seedSearchStringFromSelection?"always":"never":S(fe.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof X.autoFindInSelection=="boolean"?X.autoFindInSelection?"always":"never":S(fe.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:n(fe.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:n(fe.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:n(fe.loop,this.defaultValue.loop)}}}class D extends I{constructor(){super(43,"fontLigatures",D.OFF,{anyOf:[{type:"boolean",description:d.localize(19,null)},{type:"string",description:d.localize(20,null)}],description:d.localize(21,null),default:!1})}validate(X){return typeof X=="undefined"?this.defaultValue:typeof X=="string"?X==="false"?D.OFF:X==="true"?D.ON:X:Boolean(X)?D.ON:D.OFF}}e.EditorFontLigatures=D,D.OFF='"liga" off, "calt" off',D.ON='"liga" on, "calt" on';class m extends t{constructor(){super(42)}compute(X,fe,xe){return X.fontInfo}}class A extends E{constructor(){super(44,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:d.localize(22,null)})}validate(X){let fe=w.float(X,this.defaultValue);return fe===0?e.EDITOR_FONT_DEFAULTS.fontSize:w.clamp(fe,6,100)}compute(X,fe,xe){return X.fontInfo.fontSize}}class L extends I{constructor(){super(45,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:L.MINIMUM_VALUE,maximum:L.MAXIMUM_VALUE,errorMessage:d.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:L.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:d.localize(24,null)})}validate(X){return X==="normal"||X==="bold"?X:String(a.clampedInt(X,e.EDITOR_FONT_DEFAULTS.fontWeight,L.MINIMUM_VALUE,L.MAXIMUM_VALUE))}}L.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],L.MINIMUM_VALUE=1,L.MAXIMUM_VALUE=1e3;class V extends I{constructor(){const X={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},fe={type:"string",enum:["peek","gotoAndPeek","goto"],default:X.multiple,enumDescriptions:[d.localize(25,null),d.localize(26,null),d.localize(27,null)]},xe=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(49,"gotoLocation",X,{"editor.gotoLocation.multiple":{deprecationMessage:d.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:d.localize(29,null),...fe},"editor.gotoLocation.multipleTypeDefinitions":{description:d.localize(30,null),...fe},"editor.gotoLocation.multipleDeclarations":{description:d.localize(31,null),...fe},"editor.gotoLocation.multipleImplementations":{description:d.localize(32,null),...fe},"editor.gotoLocation.multipleReferences":{description:d.localize(33,null),...fe},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:X.alternativeDefinitionCommand,enum:xe,description:d.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:X.alternativeTypeDefinitionCommand,enum:xe,description:d.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:X.alternativeDeclarationCommand,enum:xe,description:d.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:X.alternativeImplementationCommand,enum:xe,description:d.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:X.alternativeReferenceCommand,enum:xe,description:d.localize(38,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const fe=X;return{multiple:S(fe.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:fe.multipleDefinitions??S(fe.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:fe.multipleTypeDefinitions??S(fe.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:fe.multipleDeclarations??S(fe.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:fe.multipleImplementations??S(fe.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:fe.multipleReferences??S(fe.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:T.string(fe.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:T.string(fe.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:T.string(fe.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:T.string(fe.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:T.string(fe.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class G extends I{constructor(){const X={enabled:!0,delay:300,sticky:!0};super(52,"hover",X,{"editor.hover.enabled":{type:"boolean",default:X.enabled,description:d.localize(39,null)},"editor.hover.delay":{type:"number",default:X.delay,description:d.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:X.sticky,description:d.localize(41,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const fe=X;return{enabled:n(fe.enabled,this.defaultValue.enabled),delay:a.clampedInt(fe.delay,this.defaultValue.delay,0,1e4),sticky:n(fe.sticky,this.defaultValue.sticky)}}}var U;(function(H){H[H.None=0]="None",H[H.Text=1]="Text",H[H.Blocks=2]="Blocks"})(U=e.RenderMinimap||(e.RenderMinimap={}));class K extends t{constructor(){super(130,[48,57,36,64,92,59,60,94,117,120,121,122,2])}compute(X,fe,xe){return K.computeLayout(fe,{memory:X.memory,outerWidth:X.outerWidth,outerHeight:X.outerHeight,isDominatedByLongLines:X.isDominatedByLongLines,lineHeight:X.fontInfo.lineHeight,viewLineCount:X.viewLineCount,lineNumbersDigitCount:X.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:X.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:X.fontInfo.maxDigitWidth,pixelRatio:X.pixelRatio})}static computeContainedMinimapLineCount(X){const fe=X.height/X.lineHeight,xe=X.scrollBeyondLastLine?fe-1:0,Qe=(X.viewLineCount+xe)/(X.pixelRatio*X.height),rt=Math.floor(X.viewLineCount/Qe);return{typicalViewportLineCount:fe,extraLinesBeyondLastLine:xe,desiredRatio:Qe,minimapLineCount:rt}}static _computeMinimapLayout(X,fe){const xe=X.outerWidth,Qe=X.outerHeight,rt=X.pixelRatio;if(!X.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(rt*Qe),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Qe};const ct=fe.stableMinimapLayoutInput,ft=ct&&X.outerHeight===ct.outerHeight&&X.lineHeight===ct.lineHeight&&X.typicalHalfwidthCharacterWidth===ct.typicalHalfwidthCharacterWidth&&X.pixelRatio===ct.pixelRatio&&X.scrollBeyondLastLine===ct.scrollBeyondLastLine&&X.minimap.enabled===ct.minimap.enabled&&X.minimap.side===ct.minimap.side&&X.minimap.size===ct.minimap.size&&X.minimap.showSlider===ct.minimap.showSlider&&X.minimap.renderCharacters===ct.minimap.renderCharacters&&X.minimap.maxColumn===ct.minimap.maxColumn&&X.minimap.scale===ct.minimap.scale&&X.verticalScrollbarWidth===ct.verticalScrollbarWidth&&X.isViewportWrapping===ct.isViewportWrapping,Pt=X.lineHeight,mt=X.typicalHalfwidthCharacterWidth,St=X.scrollBeyondLastLine,Ct=X.minimap.renderCharacters;let pt=rt>=2?Math.round(X.minimap.scale*2):X.minimap.scale;const Xe=X.minimap.maxColumn,_t=X.minimap.size,Pe=X.minimap.side,Se=X.verticalScrollbarWidth,De=X.viewLineCount,ee=X.remainingWidth,ue=X.isViewportWrapping,pe=Ct?2:3;let me=Math.floor(rt*Qe);const Ie=me/rt;let Be=!1,Oe=!1,je=pe*pt,et=pt/rt,Le=1;if(_t==="fill"||_t==="fit"){const{typicalViewportLineCount:Je,extraLinesBeyondLastLine:$e,desiredRatio:ut,minimapLineCount:gt}=K.computeContainedMinimapLineCount({viewLineCount:De,scrollBeyondLastLine:St,height:Qe,lineHeight:Pt,pixelRatio:rt});if(De/gt>1)Be=!0,Oe=!0,pt=1,je=1,et=pt/rt;else{let dt=!1,st=pt+1;if(_t==="fit"){const Et=Math.ceil((De+$e)*je);ue&&ft&&ee<=fe.stableFitRemainingWidth?(dt=!0,st=fe.stableFitMaxMinimapScale):dt=Et>me}if(_t==="fill"||dt){Be=!0;const Et=pt;je=Math.min(Pt*rt,Math.max(1,Math.floor(1/ut))),ue&&ft&&ee<=fe.stableFitRemainingWidth&&(st=fe.stableFitMaxMinimapScale),pt=Math.min(st,Math.max(1,Math.floor(je/pe))),pt>Et&&(Le=Math.min(2,pt/Et)),et=pt/rt/Le,me=Math.ceil(Math.max(Je,De+$e)*je),ue?(fe.stableMinimapLayoutInput=X,fe.stableFitRemainingWidth=ee,fe.stableFitMaxMinimapScale=pt):(fe.stableMinimapLayoutInput=null,fe.stableFitRemainingWidth=0)}}}const de=Math.floor(Xe*et),ge=Math.min(de,Math.max(0,Math.floor((ee-Se-2)*et/(mt+et)))+e.MINIMAP_GUTTER_WIDTH);let J=Math.floor(rt*ge);const W=J/rt;J=Math.floor(J*Le);const we=Ct?1:2,ke=Pe==="left"?0:xe-ge-Se;return{renderMinimap:we,minimapLeft:ke,minimapWidth:ge,minimapHeightIsEditorHeight:Be,minimapIsSampling:Oe,minimapScale:pt,minimapLineHeight:je,minimapCanvasInnerWidth:J,minimapCanvasInnerHeight:me,minimapCanvasOuterWidth:W,minimapCanvasOuterHeight:Ie}}static computeLayout(X,fe){const xe=fe.outerWidth|0,Qe=fe.outerHeight|0,rt=fe.lineHeight|0,ct=fe.lineNumbersDigitCount|0,ft=fe.typicalHalfwidthCharacterWidth,Pt=fe.maxDigitWidth,mt=fe.pixelRatio,St=fe.viewLineCount,Ct=X.get(122),pt=Ct==="inherit"?X.get(121):Ct,Xe=pt==="inherit"?X.get(117):pt,_t=X.get(120),Pe=X.get(2),Se=fe.isDominatedByLongLines,De=X.get(48),ee=X.get(59).renderType!==0,ue=X.get(60),pe=X.get(94),me=X.get(64),Ie=X.get(92),Be=Ie.verticalScrollbarSize,Oe=Ie.verticalHasArrows,je=Ie.arrowSize,et=Ie.horizontalScrollbarSize,Le=X.get(57),de=X.get(36);let ge;if(typeof Le=="string"&&/^\d+(\.\d+)?ch$/.test(Le)){const $t=parseFloat(Le.substr(0,Le.length-2));ge=a.clampedInt($t*ft,0,0,1e3)}else ge=a.clampedInt(Le,0,0,1e3);de&&(ge+=16);let J=0;if(ee){const $t=Math.max(ct,ue);J=Math.round($t*Pt)}let W=0;De&&(W=rt);let we=0,ke=we+W,Je=ke+J,$e=Je+ge;const ut=xe-W-J-ge;let gt=!1,at=!1,dt=-1;Pe!==2&&(pt==="inherit"&&Se?(gt=!0,at=!0):Xe==="on"||Xe==="bounded"?at=!0:Xe==="wordWrapColumn"&&(dt=_t));const st=K._computeMinimapLayout({outerWidth:xe,outerHeight:Qe,lineHeight:rt,typicalHalfwidthCharacterWidth:ft,pixelRatio:mt,scrollBeyondLastLine:pe,minimap:me,verticalScrollbarWidth:Be,viewLineCount:St,remainingWidth:ut,isViewportWrapping:at},fe.memory||new _);st.renderMinimap!==0&&st.minimapLeft===0&&(we+=st.minimapWidth,ke+=st.minimapWidth,Je+=st.minimapWidth,$e+=st.minimapWidth);const Et=ut-st.minimapWidth,yt=Math.max(1,Math.floor((Et-Be-2)/ft)),Ut=Oe?je:0;return at&&(dt=Math.max(1,yt),Xe==="bounded"&&(dt=Math.min(dt,_t))),{width:xe,height:Qe,glyphMarginLeft:we,glyphMarginWidth:W,lineNumbersLeft:ke,lineNumbersWidth:J,decorationsLeft:Je,decorationsWidth:ge,contentLeft:$e,contentWidth:Et,minimap:st,viewportColumn:yt,isWordWrapMinified:gt,isViewportWrapping:at,wrappingColumn:dt,verticalScrollbarWidth:Be,horizontalScrollbarHeight:et,overviewRuler:{top:Ut,width:Be,height:Qe-2*Ut,right:0}}}}e.EditorLayoutInfoComputer=K;class $ extends I{constructor(){const X={enabled:!0};super(56,"lightbulb",X,{"editor.lightbulb.enabled":{type:"boolean",default:X.enabled,description:d.localize(42,null)}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{enabled:n(X.enabled,this.defaultValue.enabled)}}}class B extends I{constructor(){const X={enabled:!0,fontSize:0,fontFamily:""};super(126,"inlayHints",X,{"editor.inlayHints.enabled":{type:"boolean",default:X.enabled,description:d.localize(43,null)},"editor.inlayHints.fontSize":{type:"number",default:X.fontSize,markdownDescription:d.localize(44,null)},"editor.inlayHints.fontFamily":{type:"string",default:X.fontFamily,markdownDescription:d.localize(45,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const fe=X;return{enabled:n(fe.enabled,this.defaultValue.enabled),fontSize:a.clampedInt(fe.fontSize,this.defaultValue.fontSize,0,100),fontFamily:T.string(fe.fontFamily,this.defaultValue.fontFamily)}}}class z extends w{constructor(){super(58,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,X=>w.clamp(X,0,150),{markdownDescription:d.localize(46,null)})}compute(X,fe,xe){return X.fontInfo.lineHeight}}class Y extends I{constructor(){const X={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(64,"minimap",X,{"editor.minimap.enabled":{type:"boolean",default:X.enabled,description:d.localize(47,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[d.localize(48,null),d.localize(49,null),d.localize(50,null)],default:X.size,description:d.localize(51,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:X.side,description:d.localize(52,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:X.showSlider,description:d.localize(53,null)},"editor.minimap.scale":{type:"number",default:X.scale,minimum:1,maximum:3,enum:[1,2,3],description:d.localize(54,null)},"editor.minimap.renderCharacters":{type:"boolean",default:X.renderCharacters,description:d.localize(55,null)},"editor.minimap.maxColumn":{type:"number",default:X.maxColumn,description:d.localize(56,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const fe=X;return{enabled:n(fe.enabled,this.defaultValue.enabled),size:S(fe.size,this.defaultValue.size,["proportional","fill","fit"]),side:S(fe.side,this.defaultValue.side,["right","left"]),showSlider:S(fe.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:n(fe.renderCharacters,this.defaultValue.renderCharacters),scale:a.clampedInt(fe.scale,1,1,3),maxColumn:a.clampedInt(fe.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function ne(H){return H==="ctrlCmd"?M.isMacintosh?"metaKey":"ctrlKey":"altKey"}class j extends I{constructor(){super(74,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:d.localize(57,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:d.localize(58,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const fe=X;return{top:a.clampedInt(fe.top,0,0,1e3),bottom:a.clampedInt(fe.bottom,0,0,1e3)}}}class le extends I{constructor(){const X={enabled:!0,cycle:!1};super(75,"parameterHints",X,{"editor.parameterHints.enabled":{type:"boolean",default:X.enabled,description:d.localize(59,null)},"editor.parameterHints.cycle":{type:"boolean",default:X.cycle,description:d.localize(60,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const fe=X;return{enabled:n(fe.enabled,this.defaultValue.enabled),cycle:n(fe.cycle,this.defaultValue.cycle)}}}class se extends t{constructor(){super(128)}compute(X,fe,xe){return X.pixelRatio}}class ve extends I{constructor(){const X={other:!0,comments:!1,strings:!1};super(78,"quickSuggestions",X,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:X.strings,description:d.localize(61,null)},comments:{type:"boolean",default:X.comments,description:d.localize(62,null)},other:{type:"boolean",default:X.other,description:d.localize(63,null)}}}],default:X,description:d.localize(64,null)});this.defaultValue=X}validate(X){if(typeof X=="boolean")return X;if(X&&typeof X=="object"){const fe=X,xe={other:n(fe.other,this.defaultValue.other),comments:n(fe.comments,this.defaultValue.comments),strings:n(fe.strings,this.defaultValue.strings)};return xe.other&&xe.comments&&xe.strings?!0:!xe.other&&!xe.comments&&!xe.strings?!1:xe}return this.defaultValue}}var Fe;(function(H){H[H.Off=0]="Off",H[H.On=1]="On",H[H.Relative=2]="Relative",H[H.Interval=3]="Interval",H[H.Custom=4]="Custom"})(Fe=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Me extends I{constructor(){super(59,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[d.localize(65,null),d.localize(66,null),d.localize(67,null),d.localize(68,null)],default:"on",description:d.localize(69,null)})}validate(X){let fe=this.defaultValue.renderType,xe=this.defaultValue.renderFn;return typeof X!="undefined"&&(typeof X=="function"?(fe=4,xe=X):X==="interval"?fe=3:X==="relative"?fe=2:X==="on"?fe=1:fe=0),{renderType:fe,renderFn:xe}}}function Ne(H){const X=H.get(87);return X==="editable"?H.get(80):X!=="on"}e.filterValidationDecorations=Ne;class Ye extends I{constructor(){const X=[],fe={type:"number",description:d.localize(70,null)};super(91,"rulers",X,{type:"array",items:{anyOf:[fe,{type:["object"],properties:{column:fe,color:{type:"string",description:d.localize(71,null),format:"color-hex"}}}]},default:X,description:d.localize(72,null)})}validate(X){if(Array.isArray(X)){let fe=[];for(let xe of X)if(typeof xe=="number")fe.push({column:a.clampedInt(xe,0,0,1e4),color:null});else if(xe&&typeof xe=="object"){const Qe=xe;fe.push({column:a.clampedInt(Qe.column,0,0,1e4),color:Qe.color})}return fe.sort((xe,Qe)=>xe.column-Qe.column),fe}return this.defaultValue}}function Ve(H,X){if(typeof H!="string")return X;switch(H){case"hidden":return 2;case"visible":return 3;default:return 1}}class qe extends I{constructor(){const X={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(92,"scrollbar",X,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[d.localize(73,null),d.localize(74,null),d.localize(75,null)],default:"auto",description:d.localize(76,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[d.localize(77,null),d.localize(78,null),d.localize(79,null)],default:"auto",description:d.localize(80,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:X.verticalScrollbarSize,description:d.localize(81,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:X.horizontalScrollbarSize,description:d.localize(82,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:X.scrollByPage,description:d.localize(83,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const fe=X,xe=a.clampedInt(fe.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Qe=a.clampedInt(fe.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:a.clampedInt(fe.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Ve(fe.vertical,this.defaultValue.vertical),horizontal:Ve(fe.horizontal,this.defaultValue.horizontal),useShadows:n(fe.useShadows,this.defaultValue.useShadows),verticalHasArrows:n(fe.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:n(fe.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:n(fe.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:n(fe.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:xe,horizontalSliderSize:a.clampedInt(fe.horizontalSliderSize,xe,0,1e3),verticalScrollbarSize:Qe,verticalSliderSize:a.clampedInt(fe.verticalSliderSize,Qe,0,1e3),scrollByPage:n(fe.scrollByPage,this.defaultValue.scrollByPage)}}}class x extends I{constructor(){const X={enabled:!0,mode:"subwordSmart"};super(54,"inlineSuggest",X,{"editor.inlineSuggest.enabled":{type:"boolean",default:X.enabled,description:d.localize(84,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const fe=X;return{enabled:n(fe.enabled,this.defaultValue.enabled),mode:S(fe.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class Q extends I{constructor(){const X={enabled:e.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled};super(12,"bracketPairColorization",X,{"editor.bracketPairColorization.enabled":{type:"boolean",default:X.enabled,description:d.localize(85,null)}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{enabled:n(X.enabled,this.defaultValue.enabled)}}}class te extends I{constructor(){const X={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(106,"suggest",X,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[d.localize(86,null),d.localize(87,null)],default:X.insertMode,description:d.localize(88,null)},"editor.suggest.filterGraceful":{type:"boolean",default:X.filterGraceful,description:d.localize(89,null)},"editor.suggest.localityBonus":{type:"boolean",default:X.localityBonus,description:d.localize(90,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:X.shareSuggestSelections,markdownDescription:d.localize(91,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:X.snippetsPreventQuickSuggestions,description:d.localize(92,null)},"editor.suggest.showIcons":{type:"boolean",default:X.showIcons,description:d.localize(93,null)},"editor.suggest.showStatusBar":{type:"boolean",default:X.showStatusBar,description:d.localize(94,null)},"editor.suggest.preview":{type:"boolean",default:X.preview,description:d.localize(95,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:X.showInlineDetails,description:d.localize(96,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:d.localize(97,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:d.localize(98,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:d.localize(99,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:d.localize(100,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:d.localize(101,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:d.localize(102,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:d.localize(103,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:d.localize(104,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:d.localize(105,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:d.localize(106,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:d.localize(107,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:d.localize(108,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:d.localize(109,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:d.localize(110,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:d.localize(111,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:d.localize(112,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:d.localize(113,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:d.localize(114,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:d.localize(115,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:d.localize(116,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:d.localize(117,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:d.localize(118,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:d.localize(119,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:d.localize(120,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:d.localize(121,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:d.localize(122,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:d.localize(123,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:d.localize(124,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:d.localize(125,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:d.localize(126,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:d.localize(127,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const fe=X;return{insertMode:S(fe.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:n(fe.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:n(fe.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:n(fe.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:n(fe.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:n(fe.showIcons,this.defaultValue.showIcons),showStatusBar:n(fe.showStatusBar,this.defaultValue.showStatusBar),preview:n(fe.preview,this.defaultValue.preview),previewMode:S(fe.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:n(fe.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:n(fe.showMethods,this.defaultValue.showMethods),showFunctions:n(fe.showFunctions,this.defaultValue.showFunctions),showConstructors:n(fe.showConstructors,this.defaultValue.showConstructors),showDeprecated:n(fe.showDeprecated,this.defaultValue.showDeprecated),showFields:n(fe.showFields,this.defaultValue.showFields),showVariables:n(fe.showVariables,this.defaultValue.showVariables),showClasses:n(fe.showClasses,this.defaultValue.showClasses),showStructs:n(fe.showStructs,this.defaultValue.showStructs),showInterfaces:n(fe.showInterfaces,this.defaultValue.showInterfaces),showModules:n(fe.showModules,this.defaultValue.showModules),showProperties:n(fe.showProperties,this.defaultValue.showProperties),showEvents:n(fe.showEvents,this.defaultValue.showEvents),showOperators:n(fe.showOperators,this.defaultValue.showOperators),showUnits:n(fe.showUnits,this.defaultValue.showUnits),showValues:n(fe.showValues,this.defaultValue.showValues),showConstants:n(fe.showConstants,this.defaultValue.showConstants),showEnums:n(fe.showEnums,this.defaultValue.showEnums),showEnumMembers:n(fe.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:n(fe.showKeywords,this.defaultValue.showKeywords),showWords:n(fe.showWords,this.defaultValue.showWords),showColors:n(fe.showColors,this.defaultValue.showColors),showFiles:n(fe.showFiles,this.defaultValue.showFiles),showReferences:n(fe.showReferences,this.defaultValue.showReferences),showFolders:n(fe.showFolders,this.defaultValue.showFolders),showTypeParameters:n(fe.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:n(fe.showSnippets,this.defaultValue.showSnippets),showUsers:n(fe.showUsers,this.defaultValue.showUsers),showIssues:n(fe.showIssues,this.defaultValue.showIssues)}}}class ae extends I{constructor(){super(102,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:d.localize(128,null),default:!0,type:"boolean"}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:n(X.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class q extends t{constructor(){super(129,[80])}compute(X,fe,xe){return fe.get(80)?!0:X.tabFocusMode}}var oe;(function(H){H[H.None=0]="None",H[H.Same=1]="Same",H[H.Indent=2]="Indent",H[H.DeepIndent=3]="DeepIndent"})(oe=e.WrappingIndent||(e.WrappingIndent={}));function he(H){switch(H){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class Te extends t{constructor(){super(131,[130])}compute(X,fe,xe){const Qe=fe.get(130);return{isDominatedByLongLines:X.isDominatedByLongLines,isWordWrapMinified:Qe.isWordWrapMinified,isViewportWrapping:Qe.isViewportWrapping,wrappingColumn:Qe.wrappingColumn}}}const Ue="Consolas, 'Courier New', monospace",He="Menlo, Monaco, 'Courier New', monospace",Ke="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:M.isMacintosh?He:M.isLinux?Ke:Ue,fontWeight:"normal",fontSize:M.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!1}},e.editorOptionsRegistry=[];function ye(H){return e.editorOptionsRegistry[H.id]=H,H}var nt;(function(H){H[H.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",H[H.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",H[H.accessibilitySupport=2]="accessibilitySupport",H[H.accessibilityPageSize=3]="accessibilityPageSize",H[H.ariaLabel=4]="ariaLabel",H[H.autoClosingBrackets=5]="autoClosingBrackets",H[H.autoClosingDelete=6]="autoClosingDelete",H[H.autoClosingOvertype=7]="autoClosingOvertype",H[H.autoClosingQuotes=8]="autoClosingQuotes",H[H.autoIndent=9]="autoIndent",H[H.automaticLayout=10]="automaticLayout",H[H.autoSurround=11]="autoSurround",H[H.bracketPairColorization=12]="bracketPairColorization",H[H.codeLens=13]="codeLens",H[H.codeLensFontFamily=14]="codeLensFontFamily",H[H.codeLensFontSize=15]="codeLensFontSize",H[H.colorDecorators=16]="colorDecorators",H[H.columnSelection=17]="columnSelection",H[H.comments=18]="comments",H[H.contextmenu=19]="contextmenu",H[H.copyWithSyntaxHighlighting=20]="copyWithSyntaxHighlighting",H[H.cursorBlinking=21]="cursorBlinking",H[H.cursorSmoothCaretAnimation=22]="cursorSmoothCaretAnimation",H[H.cursorStyle=23]="cursorStyle",H[H.cursorSurroundingLines=24]="cursorSurroundingLines",H[H.cursorSurroundingLinesStyle=25]="cursorSurroundingLinesStyle",H[H.cursorWidth=26]="cursorWidth",H[H.disableLayerHinting=27]="disableLayerHinting",H[H.disableMonospaceOptimizations=28]="disableMonospaceOptimizations",H[H.domReadOnly=29]="domReadOnly",H[H.dragAndDrop=30]="dragAndDrop",H[H.emptySelectionClipboard=31]="emptySelectionClipboard",H[H.extraEditorClassName=32]="extraEditorClassName",H[H.fastScrollSensitivity=33]="fastScrollSensitivity",H[H.find=34]="find",H[H.fixedOverflowWidgets=35]="fixedOverflowWidgets",H[H.folding=36]="folding",H[H.foldingStrategy=37]="foldingStrategy",H[H.foldingHighlight=38]="foldingHighlight",H[H.foldingImportsByDefault=39]="foldingImportsByDefault",H[H.unfoldOnClickAfterEndOfLine=40]="unfoldOnClickAfterEndOfLine",H[H.fontFamily=41]="fontFamily",H[H.fontInfo=42]="fontInfo",H[H.fontLigatures=43]="fontLigatures",H[H.fontSize=44]="fontSize",H[H.fontWeight=45]="fontWeight",H[H.formatOnPaste=46]="formatOnPaste",H[H.formatOnType=47]="formatOnType",H[H.glyphMargin=48]="glyphMargin",H[H.gotoLocation=49]="gotoLocation",H[H.hideCursorInOverviewRuler=50]="hideCursorInOverviewRuler",H[H.highlightActiveIndentGuide=51]="highlightActiveIndentGuide",H[H.hover=52]="hover",H[H.inDiffEditor=53]="inDiffEditor",H[H.inlineSuggest=54]="inlineSuggest",H[H.letterSpacing=55]="letterSpacing",H[H.lightbulb=56]="lightbulb",H[H.lineDecorationsWidth=57]="lineDecorationsWidth",H[H.lineHeight=58]="lineHeight",H[H.lineNumbers=59]="lineNumbers",H[H.lineNumbersMinChars=60]="lineNumbersMinChars",H[H.linkedEditing=61]="linkedEditing",H[H.links=62]="links",H[H.matchBrackets=63]="matchBrackets",H[H.minimap=64]="minimap",H[H.mouseStyle=65]="mouseStyle",H[H.mouseWheelScrollSensitivity=66]="mouseWheelScrollSensitivity",H[H.mouseWheelZoom=67]="mouseWheelZoom",H[H.multiCursorMergeOverlapping=68]="multiCursorMergeOverlapping",H[H.multiCursorModifier=69]="multiCursorModifier",H[H.multiCursorPaste=70]="multiCursorPaste",H[H.occurrencesHighlight=71]="occurrencesHighlight",H[H.overviewRulerBorder=72]="overviewRulerBorder",H[H.overviewRulerLanes=73]="overviewRulerLanes",H[H.padding=74]="padding",H[H.parameterHints=75]="parameterHints",H[H.peekWidgetDefaultFocus=76]="peekWidgetDefaultFocus",H[H.definitionLinkOpensInPeek=77]="definitionLinkOpensInPeek",H[H.quickSuggestions=78]="quickSuggestions",H[H.quickSuggestionsDelay=79]="quickSuggestionsDelay",H[H.readOnly=80]="readOnly",H[H.renameOnType=81]="renameOnType",H[H.renderControlCharacters=82]="renderControlCharacters",H[H.renderIndentGuides=83]="renderIndentGuides",H[H.renderFinalNewline=84]="renderFinalNewline",H[H.renderLineHighlight=85]="renderLineHighlight",H[H.renderLineHighlightOnlyWhenFocus=86]="renderLineHighlightOnlyWhenFocus",H[H.renderValidationDecorations=87]="renderValidationDecorations",H[H.renderWhitespace=88]="renderWhitespace",H[H.revealHorizontalRightPadding=89]="revealHorizontalRightPadding",H[H.roundedSelection=90]="roundedSelection",H[H.rulers=91]="rulers",H[H.scrollbar=92]="scrollbar",H[H.scrollBeyondLastColumn=93]="scrollBeyondLastColumn",H[H.scrollBeyondLastLine=94]="scrollBeyondLastLine",H[H.scrollPredominantAxis=95]="scrollPredominantAxis",H[H.selectionClipboard=96]="selectionClipboard",H[H.selectionHighlight=97]="selectionHighlight",H[H.selectOnLineNumbers=98]="selectOnLineNumbers",H[H.showFoldingControls=99]="showFoldingControls",H[H.showUnused=100]="showUnused",H[H.snippetSuggestions=101]="snippetSuggestions",H[H.smartSelect=102]="smartSelect",H[H.smoothScrolling=103]="smoothScrolling",H[H.stickyTabStops=104]="stickyTabStops",H[H.stopRenderingLineAfter=105]="stopRenderingLineAfter",H[H.suggest=106]="suggest",H[H.suggestFontSize=107]="suggestFontSize",H[H.suggestLineHeight=108]="suggestLineHeight",H[H.suggestOnTriggerCharacters=109]="suggestOnTriggerCharacters",H[H.suggestSelection=110]="suggestSelection",H[H.tabCompletion=111]="tabCompletion",H[H.tabIndex=112]="tabIndex",H[H.unusualLineTerminators=113]="unusualLineTerminators",H[H.useShadowDOM=114]="useShadowDOM",H[H.useTabStops=115]="useTabStops",H[H.wordSeparators=116]="wordSeparators",H[H.wordWrap=117]="wordWrap",H[H.wordWrapBreakAfterCharacters=118]="wordWrapBreakAfterCharacters",H[H.wordWrapBreakBeforeCharacters=119]="wordWrapBreakBeforeCharacters",H[H.wordWrapColumn=120]="wordWrapColumn",H[H.wordWrapOverride1=121]="wordWrapOverride1",H[H.wordWrapOverride2=122]="wordWrapOverride2",H[H.wrappingIndent=123]="wrappingIndent",H[H.wrappingStrategy=124]="wrappingStrategy",H[H.showDeprecated=125]="showDeprecated",H[H.inlayHints=126]="inlayHints",H[H.editorClassName=127]="editorClassName",H[H.pixelRatio=128]="pixelRatio",H[H.tabFocusMode=129]="tabFocusMode",H[H.layoutInfo=130]="layoutInfo",H[H.wrappingInfo=131]="wrappingInfo"})(nt=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:ye(new c(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:d.localize(129,null)})),acceptSuggestionOnEnter:ye(new o(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",d.localize(130,null),""],markdownDescription:d.localize(131,null)})),accessibilitySupport:ye(new i),accessibilityPageSize:ye(new a(3,"accessibilityPageSize",10,1,1073741824,{description:d.localize(132,null)})),ariaLabel:ye(new T(4,"ariaLabel",d.localize(133,null))),autoClosingBrackets:ye(new o(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",d.localize(134,null),d.localize(135,null),""],description:d.localize(136,null)})),autoClosingDelete:ye(new o(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",d.localize(137,null),""],description:d.localize(138,null)})),autoClosingOvertype:ye(new o(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",d.localize(139,null),""],description:d.localize(140,null)})),autoClosingQuotes:ye(new o(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",d.localize(141,null),d.localize(142,null),""],description:d.localize(143,null)})),autoIndent:ye(new f(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],y,{enumDescriptions:[d.localize(144,null),d.localize(145,null),d.localize(146,null),d.localize(147,null),d.localize(148,null)],description:d.localize(149,null)})),automaticLayout:ye(new c(10,"automaticLayout",!1)),autoSurround:ye(new o(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[d.localize(150,null),d.localize(151,null),d.localize(152,null),""],description:d.localize(153,null)})),bracketPairColorization:ye(new Q),stickyTabStops:ye(new c(104,"stickyTabStops",!1,{description:d.localize(154,null)})),codeLens:ye(new c(13,"codeLens",!0,{description:d.localize(155,null)})),codeLensFontFamily:ye(new T(14,"codeLensFontFamily","",{description:d.localize(156,null)})),codeLensFontSize:ye(new a(15,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:d.localize(157,null)})),colorDecorators:ye(new c(16,"colorDecorators",!0,{description:d.localize(158,null)})),columnSelection:ye(new c(17,"columnSelection",!1,{description:d.localize(159,null)})),comments:ye(new v),contextmenu:ye(new c(19,"contextmenu",!0)),copyWithSyntaxHighlighting:ye(new c(20,"copyWithSyntaxHighlighting",!0,{description:d.localize(160,null)})),cursorBlinking:ye(new f(21,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],s,{description:d.localize(161,null)})),cursorSmoothCaretAnimation:ye(new c(22,"cursorSmoothCaretAnimation",!1,{description:d.localize(162,null)})),cursorStyle:ye(new f(23,"cursorStyle",l.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],p,{description:d.localize(163,null)})),cursorSurroundingLines:ye(new a(24,"cursorSurroundingLines",0,0,1073741824,{description:d.localize(164,null)})),cursorSurroundingLinesStyle:ye(new o(25,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[d.localize(165,null),d.localize(166,null)],description:d.localize(167,null)})),cursorWidth:ye(new a(26,"cursorWidth",0,0,1073741824,{markdownDescription:d.localize(168,null)})),disableLayerHinting:ye(new c(27,"disableLayerHinting",!1)),disableMonospaceOptimizations:ye(new c(28,"disableMonospaceOptimizations",!1)),domReadOnly:ye(new c(29,"domReadOnly",!1)),dragAndDrop:ye(new c(30,"dragAndDrop",!0,{description:d.localize(169,null)})),emptySelectionClipboard:ye(new P),extraEditorClassName:ye(new T(32,"extraEditorClassName","")),fastScrollSensitivity:ye(new w(33,"fastScrollSensitivity",5,H=>H<=0?5:H,{markdownDescription:d.localize(170,null)})),find:ye(new g),fixedOverflowWidgets:ye(new c(35,"fixedOverflowWidgets",!1)),folding:ye(new c(36,"folding",!0,{description:d.localize(171,null)})),foldingStrategy:ye(new o(37,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[d.localize(172,null),d.localize(173,null)],description:d.localize(174,null)})),foldingHighlight:ye(new c(38,"foldingHighlight",!0,{description:d.localize(175,null)})),foldingImportsByDefault:ye(new c(39,"foldingImportsByDefault",!1,{description:d.localize(176,null)})),unfoldOnClickAfterEndOfLine:ye(new c(40,"unfoldOnClickAfterEndOfLine",!1,{description:d.localize(177,null)})),fontFamily:ye(new T(41,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:d.localize(178,null)})),fontInfo:ye(new m),fontLigatures2:ye(new D),fontSize:ye(new A),fontWeight:ye(new L),formatOnPaste:ye(new c(46,"formatOnPaste",!1,{description:d.localize(179,null)})),formatOnType:ye(new c(47,"formatOnType",!1,{description:d.localize(180,null)})),glyphMargin:ye(new c(48,"glyphMargin",!0,{description:d.localize(181,null)})),gotoLocation:ye(new V),hideCursorInOverviewRuler:ye(new c(50,"hideCursorInOverviewRuler",!1,{description:d.localize(182,null)})),highlightActiveIndentGuide:ye(new c(51,"highlightActiveIndentGuide",!0,{description:d.localize(183,null)})),hover:ye(new G),inDiffEditor:ye(new c(53,"inDiffEditor",!1)),letterSpacing:ye(new w(55,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,H=>w.clamp(H,-5,20),{description:d.localize(184,null)})),lightbulb:ye(new $),lineDecorationsWidth:ye(new E(57,"lineDecorationsWidth",10)),lineHeight:ye(new z),lineNumbers:ye(new Me),lineNumbersMinChars:ye(new a(60,"lineNumbersMinChars",5,1,300)),linkedEditing:ye(new c(61,"linkedEditing",!1,{description:d.localize(185,null)})),links:ye(new c(62,"links",!0,{description:d.localize(186,null)})),matchBrackets:ye(new o(63,"matchBrackets","always",["always","near","never"],{description:d.localize(187,null)})),minimap:ye(new Y),mouseStyle:ye(new o(65,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:ye(new w(66,"mouseWheelScrollSensitivity",1,H=>H===0?1:H,{markdownDescription:d.localize(188,null)})),mouseWheelZoom:ye(new c(67,"mouseWheelZoom",!1,{markdownDescription:d.localize(189,null)})),multiCursorMergeOverlapping:ye(new c(68,"multiCursorMergeOverlapping",!0,{description:d.localize(190,null)})),multiCursorModifier:ye(new f(69,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],ne,{markdownEnumDescriptions:[d.localize(191,null),d.localize(192,null)],markdownDescription:d.localize(193,null)})),multiCursorPaste:ye(new o(70,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[d.localize(194,null),d.localize(195,null)],markdownDescription:d.localize(196,null)})),occurrencesHighlight:ye(new c(71,"occurrencesHighlight",!0,{description:d.localize(197,null)})),overviewRulerBorder:ye(new c(72,"overviewRulerBorder",!0,{description:d.localize(198,null)})),overviewRulerLanes:ye(new a(73,"overviewRulerLanes",3,0,3)),padding:ye(new j),parameterHints:ye(new le),peekWidgetDefaultFocus:ye(new o(76,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[d.localize(199,null),d.localize(200,null)],description:d.localize(201,null)})),definitionLinkOpensInPeek:ye(new c(77,"definitionLinkOpensInPeek",!1,{description:d.localize(202,null)})),quickSuggestions:ye(new ve),quickSuggestionsDelay:ye(new a(79,"quickSuggestionsDelay",10,0,1073741824,{description:d.localize(203,null)})),readOnly:ye(new c(80,"readOnly",!1)),renameOnType:ye(new c(81,"renameOnType",!1,{description:d.localize(204,null),markdownDeprecationMessage:d.localize(205,null)})),renderControlCharacters:ye(new c(82,"renderControlCharacters",!1,{description:d.localize(206,null)})),renderIndentGuides:ye(new c(83,"renderIndentGuides",!0,{description:d.localize(207,null)})),renderFinalNewline:ye(new c(84,"renderFinalNewline",!0,{description:d.localize(208,null)})),renderLineHighlight:ye(new o(85,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",d.localize(209,null)],description:d.localize(210,null)})),renderLineHighlightOnlyWhenFocus:ye(new c(86,"renderLineHighlightOnlyWhenFocus",!1,{description:d.localize(211,null)})),renderValidationDecorations:ye(new o(87,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:ye(new o(88,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",d.localize(212,null),d.localize(213,null),d.localize(214,null),""],description:d.localize(215,null)})),revealHorizontalRightPadding:ye(new a(89,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:ye(new c(90,"roundedSelection",!0,{description:d.localize(216,null)})),rulers:ye(new Ye),scrollbar:ye(new qe),scrollBeyondLastColumn:ye(new a(93,"scrollBeyondLastColumn",5,0,1073741824,{description:d.localize(217,null)})),scrollBeyondLastLine:ye(new c(94,"scrollBeyondLastLine",!0,{description:d.localize(218,null)})),scrollPredominantAxis:ye(new c(95,"scrollPredominantAxis",!0,{description:d.localize(219,null)})),selectionClipboard:ye(new c(96,"selectionClipboard",!0,{description:d.localize(220,null),included:M.isLinux})),selectionHighlight:ye(new c(97,"selectionHighlight",!0,{description:d.localize(221,null)})),selectOnLineNumbers:ye(new c(98,"selectOnLineNumbers",!0)),showFoldingControls:ye(new o(99,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[d.localize(222,null),d.localize(223,null)],description:d.localize(224,null)})),showUnused:ye(new c(100,"showUnused",!0,{description:d.localize(225,null)})),showDeprecated:ye(new c(125,"showDeprecated",!0,{description:d.localize(226,null)})),inlayHints:ye(new B),snippetSuggestions:ye(new o(101,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[d.localize(227,null),d.localize(228,null),d.localize(229,null),d.localize(230,null)],description:d.localize(231,null)})),smartSelect:ye(new ae),smoothScrolling:ye(new c(103,"smoothScrolling",!1,{description:d.localize(232,null)})),stopRenderingLineAfter:ye(new a(105,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:ye(new te),inlineSuggest:ye(new x),suggestFontSize:ye(new a(107,"suggestFontSize",0,0,1e3,{markdownDescription:d.localize(233,null)})),suggestLineHeight:ye(new a(108,"suggestLineHeight",0,0,1e3,{markdownDescription:d.localize(234,null)})),suggestOnTriggerCharacters:ye(new c(109,"suggestOnTriggerCharacters",!0,{description:d.localize(235,null)})),suggestSelection:ye(new o(110,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[d.localize(236,null),d.localize(237,null),d.localize(238,null)],description:d.localize(239,null)})),tabCompletion:ye(new o(111,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[d.localize(240,null),d.localize(241,null),d.localize(242,null)],description:d.localize(243,null)})),tabIndex:ye(new a(112,"tabIndex",0,-1,1073741824)),unusualLineTerminators:ye(new o(113,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[d.localize(244,null),d.localize(245,null),d.localize(246,null)],description:d.localize(247,null)})),useShadowDOM:ye(new c(114,"useShadowDOM",!0)),useTabStops:ye(new c(115,"useTabStops",!0,{description:d.localize(248,null)})),wordSeparators:ye(new T(116,"wordSeparators",b.USUAL_WORD_SEPARATORS,{description:d.localize(249,null)})),wordWrap:ye(new o(117,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[d.localize(250,null),d.localize(251,null),d.localize(252,null),d.localize(253,null)],description:d.localize(254,null)})),wordWrapBreakAfterCharacters:ye(new T(118,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:ye(new T(119,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:ye(new a(120,"wordWrapColumn",80,1,1073741824,{markdownDescription:d.localize(255,null)})),wordWrapOverride1:ye(new o(121,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:ye(new o(122,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:ye(new f(123,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],he,{enumDescriptions:[d.localize(256,null),d.localize(257,null),d.localize(258,null),d.localize(259,null)],description:d.localize(260,null)})),wrappingStrategy:ye(new o(124,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[d.localize(261,null),d.localize(262,null)],description:d.localize(263,null)})),editorClassName:ye(new k),pixelRatio:ye(new se),tabFocusMode:ye(new q),layoutInfo:ye(new K),wrappingInfo:ye(new Te)}}),define(be[119],Ee([18,19]),function(re,e){return re.create("vs/platform/configuration/common/configurationRegistry",e)}),define(be[120],Ee([18,19]),function(re,e){return re.create("vs/platform/extensions/common/extensionValidator",e)}),define(be[121],Ee([18,19]),function(re,e){return re.create("vs/platform/files/common/files",e)}),define(be[122],Ee([18,19]),function(re,e){return re.create("vs/platform/markers/common/markers",e)}),define(be[123],Ee([18,19]),function(re,e){return re.create("vs/platform/theme/common/iconRegistry",e)}),define(be[124],Ee([18,19]),function(re,e){return re.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(be[125],Ee([18,19]),function(re,e){return re.create("vs/workbench/api/common/extHostExtensionService",e)}),define(be[126],Ee([18,19]),function(re,e){return re.create("vs/workbench/api/common/extHostProgress",e)}),define(be[127],Ee([18,19]),function(re,e){return re.create("vs/workbench/api/common/extHostStatusBar",e)}),define(be[128],Ee([18,19]),function(re,e){return re.create("vs/workbench/api/common/extHostTerminalService",e)}),define(be[129],Ee([18,19]),function(re,e){return re.create("vs/workbench/api/common/extHostTreeViews",e)}),define(be[130],Ee([18,19]),function(re,e){return re.create("vs/workbench/api/common/extHostWorkspace",e)}),define(be[131],Ee([18,19]),function(re,e){return re.create("vs/workbench/common/editor",e)}),define(be[132],Ee([18,19]),function(re,e){return re.create("vs/workbench/common/views",e)}),define(be[133],Ee([18,19]),function(re,e){return re.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(be[134],Ee([18,19]),function(re,e){return re.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(be[135],Ee([18,19]),function(re,e){return re.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(be[136],Ee([18,19]),function(re,e){return re.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(be[137],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorResolution=e.EditorActivation=void 0;var d;(function(F){F[F.ACTIVATE=1]="ACTIVATE",F[F.RESTORE=2]="RESTORE",F[F.PRESERVE=3]="PRESERVE"})(d=e.EditorActivation||(e.EditorActivation={}));var M;(function(F){F[F.PICK=0]="PICK",F[F.DISABLED=1]="DISABLED",F[F.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(M=e.EditorResolution||(e.EditorResolution={}));var b;(function(F){F[F.API=0]="API",F[F.USER=1]="USER"})(b=e.EditorOpenContext||(e.EditorOpenContext={}));var R;(function(F){F[F.Center=0]="Center",F[F.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",F[F.NearTop=2]="NearTop",F[F.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(R=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(be[138],Ee([0,1,120]),function(re,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const M=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,b=/^-(\d{4})(\d{2})(\d{2})$/;function R(n){return n=n.trim(),n==="*"||M.test(n)}e.isValidVersionStr=R;function F(n){if(!R(n))return null;if(n=n.trim(),n==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let c=n.match(M);return c?{hasCaret:c[1]==="^",hasGreaterEquals:c[1]===">=",majorBase:c[2]==="x"?0:parseInt(c[2],10),majorMustEqual:c[2]!=="x",minorBase:c[4]==="x"?0:parseInt(c[4],10),minorMustEqual:c[4]!=="x",patchBase:c[6]==="x"?0:parseInt(c[6],10),patchMustEqual:c[6]!=="x",preRelease:c[8]||null}:null}e.parseVersion=F;function C(n){if(!n)return null;let c=n.majorBase,u=n.majorMustEqual,a=n.minorBase,w=n.minorMustEqual,T=n.patchBase,S=n.patchMustEqual;n.hasCaret&&(c===0||(w=!1),S=!1);let o=0;if(n.preRelease){const f=b.exec(n.preRelease);if(f){const[,y,i,v]=f;o=Date.UTC(Number(y),Number(i)-1,Number(v))}}return{majorBase:c,majorMustEqual:u,minorBase:a,minorMustEqual:w,patchBase:T,patchMustEqual:S,isMinimum:n.hasGreaterEquals,notBefore:o}}e.normalizeVersion=C;function _(n,c,u){let a;typeof n=="string"?a=C(F(n)):a=n;let w;c instanceof Date?w=c.getTime():typeof c=="string"&&(w=new Date(c).getTime());let T;if(typeof u=="string"?T=C(F(u)):T=u,!a||!T)return!1;let S=a.majorBase,o=a.minorBase,f=a.patchBase,y=T.majorBase,i=T.minorBase,v=T.patchBase,r=T.notBefore,s=T.majorMustEqual,l=T.minorMustEqual,h=T.patchMustEqual;return T.isMinimum?S>y?!0:S<y?!1:o>i?!0:o<i||w&&w<r?!1:f>=v:(S===1&&y===0&&(!s||!l||!h)&&(y=1,i=0,v=0,s=!0,l=!1,h=!1),S<y?!1:S>y?!s:o<i?!1:o>i?!l:f<v?!1:f>v?!h:!(w&&w<r))}e.isValidVersion=_;function I(n,c,u,a){return u.isBuiltin||typeof u.main=="undefined"?!0:E(n,c,u.engines.vscode,a)}e.isValidExtensionVersion=I;function t(n,c,u){return n==="*"||E(c,u,n)}e.isEngineValid=t;function E(n,c,u,a=[]){let w=C(F(u));if(!w)return a.push(d.localize(0,null,u)),!1;if(w.majorBase===0){if(!w.majorMustEqual||!w.minorMustEqual)return a.push(d.localize(1,null,u)),!1}else if(!w.majorMustEqual)return a.push(d.localize(2,null,u)),!1;return _(n,c,w)?!0:(a.push(d.localize(3,null,n,u)),!1)}}),define(be[81],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class d{constructor(b,R=[],F=!1){this.ctor=b,this.staticArguments=R,this.supportsDelayedInstantiation=F}}e.SyncDescriptor=d}),define(be[57],Ee([0,1,81]),function(re,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const M=[];function b(F,C,_){C instanceof d.SyncDescriptor||(C=new d.SyncDescriptor(C,[],_)),M.push([F,C])}e.registerSingleton=b;function R(){return M}e.getSingletonServiceDescriptors=R}),define(be[139],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class d{constructor(R){this.incoming=new Map,this.outgoing=new Map,this.data=R}}e.Node=d;class M{constructor(R){this._hashFn=R,this._nodes=new Map}roots(){const R=[];for(let F of this._nodes.values())F.outgoing.size===0&&R.push(F);return R}insertEdge(R,F){const C=this.lookupOrInsertNode(R),_=this.lookupOrInsertNode(F);C.outgoing.set(this._hashFn(F),_),_.incoming.set(this._hashFn(R),C)}removeNode(R){const F=this._hashFn(R);this._nodes.delete(F);for(let C of this._nodes.values())C.outgoing.delete(F),C.incoming.delete(F)}lookupOrInsertNode(R){const F=this._hashFn(R);let C=this._nodes.get(F);return C||(C=new d(R),this._nodes.set(F,C)),C}lookup(R){return this._nodes.get(this._hashFn(R))}isEmpty(){return this._nodes.size===0}toString(){let R=[];for(let[F,C]of this._nodes)R.push(`${F}, (incoming)[${[...C.incoming.keys()].join(", ")}], (outgoing)[${[...C.outgoing.keys()].join(",")}]`);return R.join(`
`)}findCycleSlow(){for(let[R,F]of this._nodes){const C=new Set([R]),_=this._findCycle(F,C);if(_)return _}}_findCycle(R,F){for(let[C,_]of R.outgoing){if(F.has(C))return[...F,C].join(" -> ");F.add(C);const I=this._findCycle(_,F);if(I)return I;F.delete(C)}}}e.Graph=M}),define(be[4],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var d;(function(C){C.serviceIds=new Map,C.DI_TARGET="$di$target",C.DI_DEPENDENCIES="$di$dependencies";function _(I){return I[C.DI_DEPENDENCIES]||[]}C.getServiceDependencies=_})(d=e._util||(e._util={})),e.IInstantiationService=b("instantiationService");function M(C,_,I,t){_[d.DI_TARGET]===_?_[d.DI_DEPENDENCIES].push({id:C,index:I,optional:t}):(_[d.DI_DEPENDENCIES]=[{id:C,index:I,optional:t}],_[d.DI_TARGET]=_)}function b(C){if(d.serviceIds.has(C))return d.serviceIds.get(C);const _=function(I,t,E){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");M(_,I,E,!1)};return _.toString=()=>C,d.serviceIds.set(C,_),_}e.createDecorator=b;function R(C){return C}e.refineServiceDecorator=R;function F(C){return function(_,I,t){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");M(C,_,t,!0)}}e.optional=F}),define(be[140],Ee([0,1,4]),function(re,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,d.createDecorator)("modelService");function M(b){return!b.isTooLargeForSyncing()&&!b.isForSimpleWidget}e.shouldSynchronizeModel=M}),define(be[141],Ee([0,1,3,58,6,20,75,55,140]),function(re,e,d,M,b,R,F,C,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function I(a){return typeof a=="string"?!1:Array.isArray(a)?a.every(I):!!a.exclusive}class t{constructor(){this._clock=0,this._entries=[],this._onDidChange=new d.Emitter}get onDidChange(){return this._onDidChange.event}register(w,T){let S={selector:w,provider:T,_score:-1,_time:this._clock++};return this._entries.push(S),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,b.toDisposable)(()=>{if(S){let o=this._entries.indexOf(S);o>=0&&(this._entries.splice(o,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),S=void 0)}})}has(w){return this.all(w).length>0}all(w){if(!w)return[];this._updateScores(w);const T=[];for(let S of this._entries)S._score>0&&T.push(S.provider);return T}ordered(w){const T=[];return this._orderedForEach(w,S=>T.push(S.provider)),T}orderedGroups(w){const T=[];let S,o;return this._orderedForEach(w,f=>{S&&o===f._score?S.push(f.provider):(o=f._score,S=[f.provider],T.push(S))}),T}_orderedForEach(w,T){if(!!w){this._updateScores(w);for(const S of this._entries)S._score>0&&T(S)}}_updateScores(w){let T={uri:w.uri.toString(),language:w.getLanguageIdentifier().language};if(!(this._lastCandidate&&this._lastCandidate.language===T.language&&this._lastCandidate.uri===T.uri)){this._lastCandidate=T;for(let S of this._entries)if(S._score=(0,C.score)(S.selector,w.uri,w.getLanguageIdentifier().language,(0,_.shouldSynchronizeModel)(w)),I(S.selector)&&S._score>0){for(let o of this._entries)o._score=0;S._score=1e3;break}this._entries.sort(t._compareByScoreAndTime)}}static _compareByScoreAndTime(w,T){return w._score<T._score?1:w._score>T._score?-1:w._time<T._time?1:w._time>T._time?-1:0}}e.LanguageFeatureRegistry=t;const E=new WeakMap;let n=0;function c(a){let w=E.get(a);return w===void 0&&(w=++n,E.set(a,w)),w}class u{constructor(w,T,S=Number.MAX_SAFE_INTEGER){this._registry=w,this.min=T,this.max=S,this._cache=new R.LRUCache(50,.7)}_key(w){return w.id+this._registry.all(w).reduce((T,S)=>(0,M.doHash)(c(S),T),0)}_clamp(w){return w===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(w*1.3)))}get(w){const T=this._key(w),S=this._cache.get(T);return this._clamp(S?.value)}update(w,T){const S=this._key(w);let o=this._cache.get(S);return o||(o=new F.MovingAverage,this._cache.set(S,o)),o.update(T),this.get(w)}}e.LanguageFeatureRequestDelays=u}),define(be[59],Ee([0,1,2,44,141,114,34]),function(re,e,d,M,b,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.InlineCompletionsProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageIdentifier=e.LanguageId=void 0;var C;(function(g){g[g.Null=0]="Null",g[g.PlainText=1]="PlainText"})(C=e.LanguageId||(e.LanguageId={}));class _{constructor(D,m){this.language=D,this.id=m}}e.LanguageIdentifier=_;var I;(function(g){g[g.NotSet=-1]="NotSet",g[g.None=0]="None",g[g.Italic=1]="Italic",g[g.Bold=2]="Bold",g[g.Underline=4]="Underline"})(I=e.FontStyle||(e.FontStyle={}));var t;(function(g){g[g.None=0]="None",g[g.DefaultForeground=1]="DefaultForeground",g[g.DefaultBackground=2]="DefaultBackground"})(t=e.ColorId||(e.ColorId={}));var E;(function(g){g[g.Other=0]="Other",g[g.Comment=1]="Comment",g[g.String=2]="String",g[g.RegEx=4]="RegEx"})(E=e.StandardTokenType||(e.StandardTokenType={}));var n;(function(g){g[g.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",g[g.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",g[g.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",g[g.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",g[g.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",g[g.ITALIC_MASK=2048]="ITALIC_MASK",g[g.BOLD_MASK=4096]="BOLD_MASK",g[g.UNDERLINE_MASK=8192]="UNDERLINE_MASK",g[g.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",g[g.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",g[g.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",g[g.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",g[g.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",g[g.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",g[g.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",g[g.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",g[g.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",g[g.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(n=e.MetadataConsts||(e.MetadataConsts={}));class c{static getLanguageId(D){return(D&255)>>>0}static getTokenType(D){return(D&1792)>>>8}static getFontStyle(D){return(D&14336)>>>11}static getForeground(D){return(D&8372224)>>>14}static getBackground(D){return(D&4286578688)>>>23}static getClassNameFromMetadata(D){let m=this.getForeground(D),A="mtk"+m,L=this.getFontStyle(D);return L&1&&(A+=" mtki"),L&2&&(A+=" mtkb"),L&4&&(A+=" mtku"),A}static getInlineStyleFromMetadata(D,m){const A=this.getForeground(D),L=this.getFontStyle(D);let V=`color: ${m[A]};`;return L&1&&(V+="font-style: italic;"),L&2&&(V+="font-weight: bold;"),L&4&&(V+="text-decoration: underline;"),V}}e.TokenMetadata=c;var u;(function(g){g[g.Method=0]="Method",g[g.Function=1]="Function",g[g.Constructor=2]="Constructor",g[g.Field=3]="Field",g[g.Variable=4]="Variable",g[g.Class=5]="Class",g[g.Struct=6]="Struct",g[g.Interface=7]="Interface",g[g.Module=8]="Module",g[g.Property=9]="Property",g[g.Event=10]="Event",g[g.Operator=11]="Operator",g[g.Unit=12]="Unit",g[g.Value=13]="Value",g[g.Constant=14]="Constant",g[g.Enum=15]="Enum",g[g.EnumMember=16]="EnumMember",g[g.Keyword=17]="Keyword",g[g.Text=18]="Text",g[g.Color=19]="Color",g[g.File=20]="File",g[g.Reference=21]="Reference",g[g.Customcolor=22]="Customcolor",g[g.Folder=23]="Folder",g[g.TypeParameter=24]="TypeParameter",g[g.User=25]="User",g[g.Issue=26]="Issue",g[g.Snippet=27]="Snippet"})(u=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let g=Object.create(null);return g[0]="symbol-method",g[1]="symbol-function",g[2]="symbol-constructor",g[3]="symbol-field",g[4]="symbol-variable",g[5]="symbol-class",g[6]="symbol-struct",g[7]="symbol-interface",g[8]="symbol-module",g[9]="symbol-property",g[10]="symbol-event",g[11]="symbol-operator",g[12]="symbol-unit",g[13]="symbol-value",g[14]="symbol-constant",g[15]="symbol-enum",g[16]="symbol-enum-member",g[17]="symbol-keyword",g[27]="symbol-snippet",g[18]="symbol-text",g[19]="symbol-color",g[20]="symbol-file",g[21]="symbol-reference",g[22]="symbol-customcolor",g[23]="symbol-folder",g[24]="symbol-type-parameter",g[25]="account",g[26]="issues",function(D){const m=g[D];let A=m&&F.iconRegistry.get(m);return A||(console.info("No codicon found for CompletionItemKind "+D),A=F.Codicon.symbolProperty),A.classNames}}(),e.completionKindFromString=function(){let g=Object.create(null);return g.method=0,g.function=1,g.constructor=2,g.field=3,g.variable=4,g.class=5,g.struct=6,g.interface=7,g.module=8,g.property=9,g.event=10,g.operator=11,g.unit=12,g.value=13,g.constant=14,g.enum=15,g["enum-member"]=16,g.enumMember=16,g.keyword=17,g.snippet=27,g.text=18,g.color=19,g.file=20,g.reference=21,g.customcolor=22,g.folder=23,g["type-parameter"]=24,g.typeParameter=24,g.account=25,g.issue=26,function(D,m){let A=g[D];return typeof A=="undefined"&&!m&&(A=9),A}}();var a;(function(g){g[g.Deprecated=1]="Deprecated"})(a=e.CompletionItemTag||(e.CompletionItemTag={}));var w;(function(g){g[g.KeepWhitespace=1]="KeepWhitespace",g[g.InsertAsSnippet=4]="InsertAsSnippet"})(w=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var T;(function(g){g[g.Invoke=0]="Invoke",g[g.TriggerCharacter=1]="TriggerCharacter",g[g.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(T=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var S;(function(g){g[g.Automatic=0]="Automatic",g[g.Explicit=1]="Explicit"})(S=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var o;(function(g){g[g.Invoke=1]="Invoke",g[g.Auto=2]="Auto"})(o=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var f;(function(g){g[g.Invoke=1]="Invoke",g[g.TriggerCharacter=2]="TriggerCharacter",g[g.ContentChange=3]="ContentChange"})(f=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var y;(function(g){g[g.Text=0]="Text",g[g.Read=1]="Read",g[g.Write=2]="Write"})(y=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function i(g){return g&&d.URI.isUri(g.uri)&&M.Range.isIRange(g.range)&&(M.Range.isIRange(g.originSelectionRange)||M.Range.isIRange(g.targetSelectionRange))}e.isLocationLink=i;var v;(function(g){g[g.File=0]="File",g[g.Module=1]="Module",g[g.Namespace=2]="Namespace",g[g.Package=3]="Package",g[g.Class=4]="Class",g[g.Method=5]="Method",g[g.Property=6]="Property",g[g.Field=7]="Field",g[g.Constructor=8]="Constructor",g[g.Enum=9]="Enum",g[g.Interface=10]="Interface",g[g.Function=11]="Function",g[g.Variable=12]="Variable",g[g.Constant=13]="Constant",g[g.String=14]="String",g[g.Number=15]="Number",g[g.Boolean=16]="Boolean",g[g.Array=17]="Array",g[g.Object=18]="Object",g[g.Key=19]="Key",g[g.Null=20]="Null",g[g.EnumMember=21]="EnumMember",g[g.Struct=22]="Struct",g[g.Event=23]="Event",g[g.Operator=24]="Operator",g[g.TypeParameter=25]="TypeParameter"})(v=e.SymbolKind||(e.SymbolKind={}));var r;(function(g){g[g.Deprecated=1]="Deprecated"})(r=e.SymbolTag||(e.SymbolTag={}));var s;(function(g){const D=new Map;D.set("file",0),D.set("module",1),D.set("namespace",2),D.set("package",3),D.set("class",4),D.set("method",5),D.set("property",6),D.set("field",7),D.set("constructor",8),D.set("enum",9),D.set("interface",10),D.set("function",11),D.set("variable",12),D.set("constant",13),D.set("string",14),D.set("number",15),D.set("boolean",16),D.set("array",17),D.set("object",18),D.set("key",19),D.set("null",20),D.set("enum-member",21),D.set("struct",22),D.set("event",23),D.set("operator",24),D.set("type-parameter",25);const m=new Map;m.set(0,"file"),m.set(1,"module"),m.set(2,"namespace"),m.set(3,"package"),m.set(4,"class"),m.set(5,"method"),m.set(6,"property"),m.set(7,"field"),m.set(8,"constructor"),m.set(9,"enum"),m.set(10,"interface"),m.set(11,"function"),m.set(12,"variable"),m.set(13,"constant"),m.set(14,"string"),m.set(15,"number"),m.set(16,"boolean"),m.set(17,"array"),m.set(18,"object"),m.set(19,"key"),m.set(20,"null"),m.set(21,"enum-member"),m.set(22,"struct"),m.set(23,"event"),m.set(24,"operator"),m.set(25,"type-parameter");function A(G){return D.get(G)}g.fromString=A;function L(G){return m.get(G)}g.toString=L;function V(G,U){const K=m.get(G);let $=K&&F.iconRegistry.get("symbol-"+K);return $||(console.info("No codicon found for SymbolKind "+G),$=F.Codicon.symbolProperty),`${U?"inline":"block"} ${$.classNames}`}g.toCssClassName=V})(s=e.SymbolKinds||(e.SymbolKinds={}));class l{constructor(D){this.value=D}}e.FoldingRangeKind=l,l.Comment=new l("comment"),l.Imports=new l("imports"),l.Region=new l("region");var h;(function(g){g[g.Collapsed=0]="Collapsed",g[g.Expanded=1]="Expanded"})(h=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var p;(function(g){g[g.Editing=0]="Editing",g[g.Preview=1]="Preview"})(p=e.CommentMode||(e.CommentMode={}));var k;(function(g){g[g.Other=0]="Other",g[g.Type=1]="Type",g[g.Parameter=2]="Parameter"})(k=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new b.LanguageFeatureRegistry,e.RenameProviderRegistry=new b.LanguageFeatureRegistry,e.CompletionProviderRegistry=new b.LanguageFeatureRegistry,e.InlineCompletionsProviderRegistry=new b.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new b.LanguageFeatureRegistry,e.HoverProviderRegistry=new b.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new b.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new b.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new b.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new b.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new b.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new b.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new b.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new b.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new b.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new b.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new b.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new b.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new b.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new b.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new b.LanguageFeatureRegistry,e.LinkProviderRegistry=new b.LanguageFeatureRegistry,e.ColorProviderRegistry=new b.LanguageFeatureRegistry,e.SelectionRangeRegistry=new b.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new b.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new b.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new b.LanguageFeatureRegistry,e.TokenizationRegistry=new R.TokenizationRegistryImpl;var P;(function(g){g[g.None=0]="None",g[g.Option=1]="Option",g[g.Default=2]="Default",g[g.Preferred=3]="Preferred"})(P=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(be[45],Ee([0,1,26,9,4]),function(re,e,d,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let R=d.userAgent||"";const F=new Map;F.set("false",!1),F.set("true",!0),F.set("isMac",d.isMacintosh),F.set("isLinux",d.isLinux),F.set("isWindows",d.isWindows),F.set("isWeb",d.isWeb),F.set("isMacNative",d.isMacintosh&&!d.isWeb),F.set("isEdge",R.indexOf("Edg/")>=0),F.set("isFirefox",R.indexOf("Firefox")>=0),F.set("isChrome",R.indexOf("Chrome")>=0),F.set("isSafari",R.indexOf("Safari")>=0);const C=Object.prototype.hasOwnProperty;var _;(function(D){D[D.False=0]="False",D[D.True=1]="True",D[D.Defined=2]="Defined",D[D.Not=3]="Not",D[D.Equals=4]="Equals",D[D.NotEquals=5]="NotEquals",D[D.And=6]="And",D[D.Regex=7]="Regex",D[D.NotRegex=8]="NotRegex",D[D.Or=9]="Or",D[D.In=10]="In",D[D.NotIn=11]="NotIn",D[D.Greater=12]="Greater",D[D.GreaterEquals=13]="GreaterEquals",D[D.Smaller=14]="Smaller",D[D.SmallerEquals=15]="SmallerEquals"})(_=e.ContextKeyExprType||(e.ContextKeyExprType={}));class I{static false(){return E.INSTANCE}static true(){return n.INSTANCE}static has(m){return c.create(m)}static equals(m,A){return u.create(m,A)}static notEquals(m,A){return T.create(m,A)}static regex(m,A){return v.create(m,A)}static in(m,A){return a.create(m,A)}static not(m){return S.create(m)}static and(...m){return s.create(m,null)}static or(...m){return l.create(m,null,!0)}static greater(m,A){return o.create(m,A)}static less(m,A){return y.create(m,A)}static deserialize(m,A=!1){if(!!m)return this._deserializeOrExpression(m,A)}static _deserializeOrExpression(m,A){let L=m.split("||");return l.create(L.map(V=>this._deserializeAndExpression(V,A)),null,!0)}static _deserializeAndExpression(m,A){let L=m.split("&&");return s.create(L.map(V=>this._deserializeOne(V,A)),null)}static _deserializeOne(m,A){if(m=m.trim(),m.indexOf("!=")>=0){let L=m.split("!=");return T.create(L[0].trim(),this._deserializeValue(L[1],A))}if(m.indexOf("==")>=0){let L=m.split("==");return u.create(L[0].trim(),this._deserializeValue(L[1],A))}if(m.indexOf("=~")>=0){let L=m.split("=~");return v.create(L[0].trim(),this._deserializeRegexValue(L[1],A))}if(m.indexOf(" in ")>=0){let L=m.split(" in ");return a.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(m)){const L=m.split(">=");return f.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(m)){const L=m.split(">");return o.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(m)){const L=m.split("<=");return i.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(m)){const L=m.split("<");return y.create(L[0].trim(),L[1].trim())}return/^\!\s*/.test(m)?S.create(m.substr(1).trim()):c.create(m)}static _deserializeValue(m,A){if(m=m.trim(),m==="true")return!0;if(m==="false")return!1;let L=/^'([^']*)'$/.exec(m);return L?L[1].trim():m}static _deserializeRegexValue(m,A){if((0,M.isFalsyOrWhitespace)(m)){if(A)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let L=m.indexOf("/"),V=m.lastIndexOf("/");if(L===V||L<0){if(A)throw new Error(`bad regexp-value '${m}', missing /-enclosure`);return console.warn(`bad regexp-value '${m}', missing /-enclosure`),null}let G=m.slice(L+1,V),U=m[V+1]==="i"?"i":"";try{return new RegExp(G,U)}catch(K){if(A)throw new Error(`bad regexp-value '${m}', parse error: ${K}`);return console.warn(`bad regexp-value '${m}', parse error: ${K}`),null}}}e.ContextKeyExpr=I;function t(D,m){return D.cmp(m)}class E{constructor(){this.type=0}cmp(m){return this.type-m.type}equals(m){return m.type===this.type}evaluate(m){return!1}serialize(){return"false"}keys(){return[]}map(m){return this}negate(){return n.INSTANCE}}e.ContextKeyFalseExpr=E,E.INSTANCE=new E;class n{constructor(){this.type=1}cmp(m){return this.type-m.type}equals(m){return m.type===this.type}evaluate(m){return!0}serialize(){return"true"}keys(){return[]}map(m){return this}negate(){return E.INSTANCE}}e.ContextKeyTrueExpr=n,n.INSTANCE=new n;class c{constructor(m,A){this.key=m,this.negated=A,this.type=2}static create(m,A=null){const L=F.get(m);return typeof L=="boolean"?L?n.INSTANCE:E.INSTANCE:new c(m,A)}cmp(m){return m.type!==this.type?this.type-m.type:p(this.key,m.key)}equals(m){return m.type===this.type?this.key===m.key:!1}evaluate(m){return!!m.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(m){return m.mapDefined(this.key)}negate(){return this.negated||(this.negated=S.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=c;class u{constructor(m,A,L){this.key=m,this.value=A,this.negated=L,this.type=4}static create(m,A,L=null){if(typeof A=="boolean")return A?c.create(m,L):S.create(m,L);const V=F.get(m);return typeof V=="boolean"?A===(V?"true":"false")?n.INSTANCE:E.INSTANCE:new u(m,A,L)}cmp(m){return m.type!==this.type?this.type-m.type:k(this.key,this.value,m.key,m.value)}equals(m){return m.type===this.type?this.key===m.key&&this.value===m.value:!1}evaluate(m){return m.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(m){return m.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=T.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=u;class a{constructor(m,A){this.key=m,this.valueKey=A,this.type=10,this.negated=null}static create(m,A){return new a(m,A)}cmp(m){return m.type!==this.type?this.type-m.type:k(this.key,this.valueKey,m.key,m.valueKey)}equals(m){return m.type===this.type?this.key===m.key&&this.valueKey===m.valueKey:!1}evaluate(m){const A=m.getValue(this.valueKey),L=m.getValue(this.key);return Array.isArray(A)?A.indexOf(L)>=0:typeof L=="string"&&typeof A=="object"&&A!==null?C.call(A,L):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(m){return m.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=w.create(this)),this.negated}}e.ContextKeyInExpr=a;class w{constructor(m){this._actual=m,this.type=11}static create(m){return new w(m)}cmp(m){return m.type!==this.type?this.type-m.type:this._actual.cmp(m._actual)}equals(m){return m.type===this.type?this._actual.equals(m._actual):!1}evaluate(m){return!this._actual.evaluate(m)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(m){return new w(this._actual.map(m))}negate(){return this._actual}}e.ContextKeyNotInExpr=w;class T{constructor(m,A,L){this.key=m,this.value=A,this.negated=L,this.type=5}static create(m,A,L=null){if(typeof A=="boolean")return A?S.create(m,L):c.create(m,L);const V=F.get(m);return typeof V=="boolean"?A===(V?"true":"false")?E.INSTANCE:n.INSTANCE:new T(m,A,L)}cmp(m){return m.type!==this.type?this.type-m.type:k(this.key,this.value,m.key,m.value)}equals(m){return m.type===this.type?this.key===m.key&&this.value===m.value:!1}evaluate(m){return m.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(m){return m.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=u.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=T;class S{constructor(m,A){this.key=m,this.negated=A,this.type=3}static create(m,A=null){const L=F.get(m);return typeof L=="boolean"?L?E.INSTANCE:n.INSTANCE:new S(m,A)}cmp(m){return m.type!==this.type?this.type-m.type:p(this.key,m.key)}equals(m){return m.type===this.type?this.key===m.key:!1}evaluate(m){return!m.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(m){return m.mapNot(this.key)}negate(){return this.negated||(this.negated=c.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=S;class o{constructor(m,A,L){this.key=m,this.value=A,this.negated=L,this.type=12}static create(m,A,L=null){return new o(m,A,L)}cmp(m){return m.type!==this.type?this.type-m.type:k(this.key,this.value,m.key,m.value)}equals(m){return m.type===this.type?this.key===m.key&&this.value===m.value:!1}evaluate(m){return parseFloat(m.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(m){return m.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=i.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=o;class f{constructor(m,A,L){this.key=m,this.value=A,this.negated=L,this.type=13}static create(m,A,L=null){return new f(m,A,L)}cmp(m){return m.type!==this.type?this.type-m.type:k(this.key,this.value,m.key,m.value)}equals(m){return m.type===this.type?this.key===m.key&&this.value===m.value:!1}evaluate(m){return parseFloat(m.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(m){return m.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=y.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=f;class y{constructor(m,A,L){this.key=m,this.value=A,this.negated=L,this.type=14}static create(m,A,L=null){return new y(m,A,L)}cmp(m){return m.type!==this.type?this.type-m.type:k(this.key,this.value,m.key,m.value)}equals(m){return m.type===this.type?this.key===m.key&&this.value===m.value:!1}evaluate(m){return parseFloat(m.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(m){return m.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=f.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=y;class i{constructor(m,A,L){this.key=m,this.value=A,this.negated=L,this.type=15}static create(m,A,L=null){return new i(m,A,L)}cmp(m){return m.type!==this.type?this.type-m.type:k(this.key,this.value,m.key,m.value)}equals(m){return m.type===this.type?this.key===m.key&&this.value===m.value:!1}evaluate(m){return parseFloat(m.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(m){return m.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=o.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=i;class v{constructor(m,A){this.key=m,this.regexp=A,this.type=7,this.negated=null}static create(m,A){return new v(m,A)}cmp(m){if(m.type!==this.type)return this.type-m.type;if(this.key<m.key)return-1;if(this.key>m.key)return 1;const A=this.regexp?this.regexp.source:"",L=m.regexp?m.regexp.source:"";return A<L?-1:A>L?1:0}equals(m){if(m.type===this.type){const A=this.regexp?this.regexp.source:"",L=m.regexp?m.regexp.source:"";return this.key===m.key&&A===L}return!1}evaluate(m){let A=m.getValue(this.key);return this.regexp?this.regexp.test(A):!1}serialize(){const m=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${m}`}keys(){return[this.key]}map(m){return m.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=r.create(this)),this.negated}}e.ContextKeyRegexExpr=v;class r{constructor(m){this._actual=m,this.type=8}static create(m){return new r(m)}cmp(m){return m.type!==this.type?this.type-m.type:this._actual.cmp(m._actual)}equals(m){return m.type===this.type?this._actual.equals(m._actual):!1}evaluate(m){return!this._actual.evaluate(m)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(m){return new r(this._actual.map(m))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=r;class s{constructor(m,A){this.expr=m,this.negated=A,this.type=6}static create(m,A){return s._normalizeArr(m,A)}cmp(m){if(m.type!==this.type)return this.type-m.type;if(this.expr.length<m.expr.length)return-1;if(this.expr.length>m.expr.length)return 1;for(let A=0,L=this.expr.length;A<L;A++){const V=t(this.expr[A],m.expr[A]);if(V!==0)return V}return 0}equals(m){if(m.type===this.type){if(this.expr.length!==m.expr.length)return!1;for(let A=0,L=this.expr.length;A<L;A++)if(!this.expr[A].equals(m.expr[A]))return!1;return!0}return!1}evaluate(m){for(let A=0,L=this.expr.length;A<L;A++)if(!this.expr[A].evaluate(m))return!1;return!0}static _normalizeArr(m,A){const L=[];let V=!1;for(const G of m)if(!!G){if(G.type===1){V=!0;continue}if(G.type===0)return E.INSTANCE;if(G.type===6){L.push(...G.expr);continue}L.push(G)}if(L.length===0&&V)return n.INSTANCE;if(L.length!==0){if(L.length===1)return L[0];L.sort(t);for(let G=1;G<L.length;G++)L[G-1].equals(L[G])&&(L.splice(G,1),G--);if(L.length===1)return L[0];for(;L.length>1;){const G=L[L.length-1];if(G.type!==9)break;L.pop();const U=L.pop(),K=L.length===0,$=l.create(G.expr.map(B=>s.create([B,U],null)),null,K);$&&(L.push($),L.sort(t))}return L.length===1?L[0]:new s(L,A)}}serialize(){return this.expr.map(m=>m.serialize()).join(" && ")}keys(){const m=[];for(let A of this.expr)m.push(...A.keys());return m}map(m){return new s(this.expr.map(A=>A.map(m)),null)}negate(){if(!this.negated){const m=[];for(let A of this.expr)m.push(A.negate());this.negated=l.create(m,this,!0)}return this.negated}}class l{constructor(m,A){this.expr=m,this.negated=A,this.type=9}static create(m,A,L){return l._normalizeArr(m,A,L)}cmp(m){if(m.type!==this.type)return this.type-m.type;if(this.expr.length<m.expr.length)return-1;if(this.expr.length>m.expr.length)return 1;for(let A=0,L=this.expr.length;A<L;A++){const V=t(this.expr[A],m.expr[A]);if(V!==0)return V}return 0}equals(m){if(m.type===this.type){if(this.expr.length!==m.expr.length)return!1;for(let A=0,L=this.expr.length;A<L;A++)if(!this.expr[A].equals(m.expr[A]))return!1;return!0}return!1}evaluate(m){for(let A=0,L=this.expr.length;A<L;A++)if(this.expr[A].evaluate(m))return!0;return!1}static _normalizeArr(m,A,L){let V=[],G=!1;if(m){for(let U=0,K=m.length;U<K;U++){const $=m[U];if(!!$){if($.type===0){G=!0;continue}if($.type===1)return n.INSTANCE;if($.type===9){V=V.concat($.expr);continue}V.push($)}}if(V.length===0&&G)return E.INSTANCE;V.sort(t)}if(V.length!==0){if(V.length===1)return V[0];for(let U=1;U<V.length;U++)V[U-1].equals(V[U])&&(V.splice(U,1),U--);if(V.length===1)return V[0];if(L){for(let U=0;U<V.length;U++)for(let K=U+1;K<V.length;K++)P(V[U],V[K])&&(V.splice(K,1),K--);if(V.length===1)return V[0]}return new l(V,A)}}serialize(){return this.expr.map(m=>m.serialize()).join(" || ")}keys(){const m=[];for(let A of this.expr)m.push(...A.keys());return m}map(m){return new l(this.expr.map(A=>A.map(m)),null)}negate(){if(!this.negated){let m=[];for(let A of this.expr)m.push(A.negate());for(;m.length>1;){const A=m.shift(),L=m.shift(),V=[];for(const U of g(A))for(const K of g(L))V.push(s.create([U,K],null));const G=m.length===0;m.unshift(l.create(V,null,G))}this.negated=m[0]}return this.negated}}class h extends c{constructor(m,A,L){super(m,null);this._defaultValue=A,typeof L=="object"?h._info.push({...L,key:m}):L!==!0&&h._info.push({key:m,description:L,type:A!=null?typeof A:void 0})}static all(){return h._info.values()}bindTo(m){return m.createKey(this.key,this._defaultValue)}getValue(m){return m.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(m){return u.create(this.key,m)}notEqualsTo(m){return T.create(this.key,m)}}e.RawContextKey=h,h._info=[],e.IContextKeyService=(0,b.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function p(D,m){return D<m?-1:D>m?1:0}function k(D,m,A,L){return D<A?-1:D>A?1:m<L?-1:m>L?1:0}function P(D,m){if(m.type===6&&D.type!==9&&D.type!==6){for(const V of m.expr)if(D.equals(V))return!0}const A=D.negate(),L=g(A).concat(g(m));L.sort(t);for(let V=0;V<L.length;V++){const U=L[V].negate();for(let K=V+1;K<L.length;K++){const $=L[K];if(U.equals($))return!0}}return!1}e.implies=P;function g(D){return D.type===9?D.expr:[D]}}),define(be[142],Ee([0,1,4]),function(re,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,d.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,d.refineServiceDecorator)(e.IEnvironmentService)}),define(be[25],Ee([0,1,9,4]),function(re,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function b(t){if(typeof t=="object"&&t!==null&&t.supported!==!0)return t.description}e.getWorkspaceSupportTypeMessage=b;function R(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(!t.uuid||typeof t.uuid=="string")}e.isIExtensionIdentifier=R,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var F;(function(t){t[t.System=0]="System",t[t.User=1]="User"})(F=e.ExtensionType||(e.ExtensionType={}));class C{constructor(E){this.value=E,this._lower=E.toLowerCase()}static equals(E,n){if(typeof E=="undefined"||E===null)return typeof n=="undefined"||n===null;if(typeof n=="undefined"||n===null)return!1;if(typeof E=="string"||typeof n=="string"){let c=typeof E=="string"?E:E.value,u=typeof n=="string"?n:n.value;return d.equalsIgnoreCase(c,u)}return E._lower===n._lower}static toKey(E){return typeof E=="string"?E.toLowerCase():E._lower}}e.ExtensionIdentifier=C;function _(t){return t.contributes&&t.contributes.localizations?t.contributes.localizations.length>0:!1}e.isLanguagePackExtension=_;function I(t){return t.contributes&&t.contributes.authentication?t.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=I,e.IBuiltinExtensionsScannerService=(0,M.createDecorator)("IBuiltinExtensionsScannerService")}),define(be[143],Ee([0,1,9,25]),function(re,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function b(u,a){return u.uuid&&a.uuid?u.uuid===a.uuid:u.id===a.id?!0:(0,d.compareIgnoreCase)(u.id,a.id)===0}e.areSameExtensions=b;class R{constructor(a,w){this.version=w,this.id=a.id,this.uuid=a.uuid}key(){return`${this.id}-${this.version}`}equals(a){return a instanceof R?b(this,a)&&this.version===a.version:!1}}e.ExtensionIdentifierWithVersion=R;function F(u,a){return`${u}.${a}`}e.getExtensionId=F;function C(u){return u.toLocaleLowerCase()}e.adoptToGalleryExtensionId=C;function _(u,a){return C(F(u,a))}e.getGalleryExtensionId=_;function I(u,a){const w=[],T=S=>{for(const o of w)if(o.some(f=>b(a(f),a(S))))return o;return null};for(const S of u){const o=T(S);o?o.push(S):w.push([S])}return w}e.groupByExtension=I;function t(u){return{id:u.identifier.id,name:u.manifest.name,galleryId:null,publisherId:u.publisherId,publisherName:u.manifest.publisher,publisherDisplayName:u.publisherDisplayName,dependencies:u.manifest.extensionDependencies&&u.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=t;function E(u){return{id:u.identifier.id,name:u.name,galleryId:u.identifier.uuid,publisherId:u.publisherId,publisherName:u.publisher,publisherDisplayName:u.publisherDisplayName,dependencies:!!(u.properties.dependencies&&u.properties.dependencies.length>0),...u.telemetryData}}e.getGalleryExtensionTelemetryData=E,e.BetterMergeId=new M.ExtensionIdentifier("pprice.better-merge");function n(u){const a=new Set;for(const w of u)w.malicious&&a.add(w.id.id);return a}e.getMaliciousExtensionsSet=n;function c(u,a){const w=[],T=a.manifest.extensionDependencies?.slice(0)??[];for(;T.length;){const S=T.shift();if(S&&w.every(o=>!b(o.identifier,{id:S}))){const o=u.filter(f=>b(f.identifier,{id:S}));o.length===1&&(w.push(o[0]),T.push(...o[0].manifest.extensionDependencies?.slice(0)??[]))}}return w}e.getExtensionDependencies=c}),define(be[60],Ee([0,1,20,17,9,10,2,121,4]),function(re,e,d,M,b,R,F,C,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,_.createDecorator)("fileService");function I(U){return U.create===!0}e.isFileOpenForWriteOptions=I;var t;(function(U){U[U.Unknown=0]="Unknown",U[U.File=1]="File",U[U.Directory=2]="Directory",U[U.SymbolicLink=64]="SymbolicLink"})(t=e.FileType||(e.FileType={}));var E;(function(U){U[U.Readonly=1]="Readonly"})(E=e.FilePermission||(e.FilePermission={}));var n;(function(U){U[U.FileReadWrite=2]="FileReadWrite",U[U.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",U[U.FileReadStream=16]="FileReadStream",U[U.FileFolderCopy=8]="FileFolderCopy",U[U.PathCaseSensitive=1024]="PathCaseSensitive",U[U.Readonly=2048]="Readonly",U[U.Trash=4096]="Trash",U[U.FileWriteUnlock=8192]="FileWriteUnlock"})(n=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function c(U){return!!(U.capabilities&2)}e.hasReadWriteCapability=c;function u(U){return!!(U.capabilities&8)}e.hasFileFolderCopyCapability=u;function a(U){return!!(U.capabilities&4)}e.hasOpenReadWriteCloseCapability=a;function w(U){return!!(U.capabilities&16)}e.hasFileReadStreamCapability=w;var T;(function(U){U.FileExists="EntryExists",U.FileNotFound="EntryNotFound",U.FileNotADirectory="EntryNotADirectory",U.FileIsADirectory="EntryIsADirectory",U.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",U.FileTooLarge="EntryTooLarge",U.FileWriteLocked="EntryWriteLocked",U.NoPermissions="NoPermissions",U.Unavailable="Unavailable",U.Unknown="Unknown"})(T=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class S extends Error{constructor(K,$){super(K);this.code=$}}e.FileSystemProviderError=S;function o(U,K){const $=new S(U.toString(),K);return y($,K),$}e.createFileSystemProviderError=o;function f(U){return U||o((0,C.localize)(0,null),T.Unknown)}e.ensureFileSystemProviderError=f;function y(U,K){return U.name=K?`${K} (FileSystemError)`:"FileSystemError",U}e.markAsFileSystemProviderError=y;function i(U){if(!U)return T.Unknown;if(U instanceof S)return U.code;const K=/^(.+) \(FileSystemError\)$/.exec(U.name);if(!K)return T.Unknown;switch(K[1]){case T.FileExists:return T.FileExists;case T.FileIsADirectory:return T.FileIsADirectory;case T.FileNotADirectory:return T.FileNotADirectory;case T.FileNotFound:return T.FileNotFound;case T.FileExceedsMemoryLimit:return T.FileExceedsMemoryLimit;case T.FileTooLarge:return T.FileTooLarge;case T.FileWriteLocked:return T.FileWriteLocked;case T.NoPermissions:return T.NoPermissions;case T.Unavailable:return T.Unavailable}return T.Unknown}e.toFileSystemProviderErrorCode=i;function v(U){if(U instanceof k)return U.fileOperationResult;switch(i(U)){case T.FileNotFound:return 1;case T.FileIsADirectory:return 0;case T.FileNotADirectory:return 10;case T.FileWriteLocked:return 5;case T.NoPermissions:return 6;case T.FileExists:return 4;case T.FileExceedsMemoryLimit:return 9;case T.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=v;var r;(function(U){U[U.CREATE=0]="CREATE",U[U.DELETE=1]="DELETE",U[U.MOVE=2]="MOVE",U[U.COPY=3]="COPY"})(r=e.FileOperation||(e.FileOperation={}));class s{constructor(K,$,B){this.resource=K,this.operation=$,this.target=B}isOperation(K){return this.operation===K}}e.FileOperationEvent=s;var l;(function(U){U[U.UPDATED=0]="UPDATED",U[U.ADDED=1]="ADDED",U[U.DELETED=2]="DELETED"})(l=e.FileChangeType||(e.FileChangeType={}));class h{constructor(K,$){this.added=void 0,this.updated=void 0,this.deleted=void 0;for(const B of K)switch(B.type){case 1:this.added||(this.added=d.TernarySearchTree.forUris(()=>$)),this.added.set(B.resource,B);break;case 0:this.updated||(this.updated=d.TernarySearchTree.forUris(()=>$)),this.updated.set(B.resource,B);break;case 2:this.deleted||(this.deleted=d.TernarySearchTree.forUris(()=>$)),this.deleted.set(B.resource,B);break}}contains(K,...$){return this.doContains(K,{includeChildren:!1},...$)}affects(K,...$){return this.doContains(K,{includeChildren:!0},...$)}doContains(K,$,...B){if(!K)return!1;const z=B.length>0;return!!((!z||B.includes(1))&&(this.added?.get(K)||$.includeChildren&&this.added?.findSuperstr(K))||(!z||B.includes(0))&&(this.updated?.get(K)||$.includeChildren&&this.updated?.findSuperstr(K))||(!z||B.includes(2))&&(this.deleted?.findSubstr(K)||$.includeChildren&&this.deleted?.findSuperstr(K)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=h;function p(U,K,$){return!U||!K||U===K||K.length>U.length?!1:(K.charAt(K.length-1)!==M.sep&&(K+=M.sep),$?(0,b.startsWithIgnoreCase)(U,K):U.indexOf(K)===0)}e.isParent=p;class k extends Error{constructor(K,$,B){super(K);this.fileOperationResult=$,this.options=B}}e.FileOperationError=k;class P extends k{constructor(K,$,B){super(K,2,B);this.stat=$}}e.NotModifiedSinceFileOperationError=P;var g;(function(U){U[U.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",U[U.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",U[U.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",U[U.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",U[U.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",U[U.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",U[U.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",U[U.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",U[U.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",U[U.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",U[U.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",U[U.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(g=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var D;(function(U){U[U.FILE=0]="FILE",U[U.FOLDER=1]="FOLDER",U[U.ROOT_FOLDER=2]="ROOT_FOLDER"})(D=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function m(U){if(!(typeof U.size!="number"||typeof U.mtime!="number"))return U.mtime.toString(29)+U.size.toString(31)}e.etag=m;async function A(U,K){if(!K.canHandleResource(F.URI.from({scheme:U.scheme})))return new Promise($=>{const B=K.onDidChangeFileSystemProviderRegistrations(z=>{z.scheme===U.scheme&&z.added&&(B.dispose(),$())})})}e.whenProviderRegistered=A,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class L{static formatSize(K){return(0,R.isNumber)(K)||(K=0),K<L.KB?(0,C.localize)(1,null,K.toFixed(0)):K<L.MB?(0,C.localize)(2,null,(K/L.KB).toFixed(2)):K<L.GB?(0,C.localize)(3,null,(K/L.MB).toFixed(2)):K<L.TB?(0,C.localize)(4,null,(K/L.GB).toFixed(2)):(0,C.localize)(5,null,(K/L.TB).toFixed(2))}}e.ByteSize=L,L.KB=1024,L.MB=L.KB*L.KB,L.GB=L.MB*L.KB,L.TB=L.GB*L.KB;var V;(function(U){U[U.IA32=0]="IA32",U[U.OTHER=1]="OTHER"})(V=e.Arch||(e.Arch={}));function G(U){return{maxFileSize:U===0?300*L.MB:16*L.GB,maxHeapSize:U===0?700*L.MB:2*700*L.MB}}e.getPlatformLimits=G}),define(be[61],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class d{constructor(...b){this._entries=new Map;for(let[R,F]of b)this.set(R,F)}set(b,R){const F=this._entries.get(b);return this._entries.set(b,R),F}has(b){return this._entries.has(b)}get(b){return this._entries.get(b)}}e.ServiceCollection=d}),define(be[144],Ee([0,1,14,16,81,139,4,61]),function(re,e,d,M,b,R,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const _=!1;class I extends Error{constructor(u){super("cyclic dependency between services");this.message=u.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${u.toString()}`}}class t{constructor(u=new C.ServiceCollection,a=!1,w){this._activeInstantiations=new Set,this._services=u,this._strict=a,this._parent=w,this._services.set(F.IInstantiationService,this)}createChild(u){return new t(u,this._strict,this)}invokeFunction(u,...a){let w=n.traceInvocation(u),T=!1;try{return u({get:(o,f)=>{if(T)throw(0,M.illegalState)("service accessor is only valid during the invocation of its target method");const y=this._getOrCreateServiceInstance(o,w);if(!y&&f!==F.optional)throw new Error(`[invokeFunction] unknown service '${o}'`);return y}},...a)}finally{T=!0,w.stop()}}createInstance(u,...a){let w,T;return u instanceof b.SyncDescriptor?(w=n.traceCreation(u.ctor),T=this._createInstance(u.ctor,u.staticArguments.concat(a),w)):(w=n.traceCreation(u),T=this._createInstance(u,a,w)),w.stop(),T}_createInstance(u,a=[],w){let T=F._util.getServiceDependencies(u).sort((f,y)=>f.index-y.index),S=[];for(const f of T){let y=this._getOrCreateServiceInstance(f.id,w);if(!y&&this._strict&&!f.optional)throw new Error(`[createInstance] ${u.name} depends on UNKNOWN service ${f.id}.`);S.push(y)}let o=T.length>0?T[0].index:a.length;if(a.length!==o){console.warn(`[createInstance] First service dependency of ${u.name} at position ${o+1} conflicts with ${a.length} static arguments`);let f=o-a.length;f>0?a=a.concat(new Array(f)):a=a.slice(0,o)}return new u(...[...a,...S])}_setServiceInstance(u,a){if(this._services.get(u)instanceof b.SyncDescriptor)this._services.set(u,a);else if(this._parent)this._parent._setServiceInstance(u,a);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(u){let a=this._services.get(u);return!a&&this._parent?this._parent._getServiceInstanceOrDescriptor(u):a}_getOrCreateServiceInstance(u,a){let w=this._getServiceInstanceOrDescriptor(u);return w instanceof b.SyncDescriptor?this._safeCreateAndCacheServiceInstance(u,w,a.branch(u,!0)):(a.branch(u,!1),w)}_safeCreateAndCacheServiceInstance(u,a,w){if(this._activeInstantiations.has(u))throw new Error(`illegal state - RECURSIVELY instantiating service '${u}'`);this._activeInstantiations.add(u);try{return this._createAndCacheServiceInstance(u,a,w)}finally{this._activeInstantiations.delete(u)}}_createAndCacheServiceInstance(u,a,w){const T=new R.Graph(f=>f.id.toString());let S=0;const o=[{id:u,desc:a,_trace:w}];for(;o.length;){const f=o.pop();if(T.lookupOrInsertNode(f),S++>1e3)throw new I(T);for(let y of F._util.getServiceDependencies(f.desc.ctor)){let i=this._getServiceInstanceOrDescriptor(y.id);if(!i&&!y.optional&&console.warn(`[createInstance] ${u} depends on ${y.id} which is NOT registered.`),i instanceof b.SyncDescriptor){const v={id:y.id,desc:i,_trace:f._trace.branch(y.id,!0)};T.insertEdge(f,v),o.push(v)}}}for(;;){const f=T.roots();if(f.length===0){if(!T.isEmpty())throw new I(T);break}for(const{data:y}of f){if(this._getServiceInstanceOrDescriptor(y.id)instanceof b.SyncDescriptor){const v=this._createServiceInstanceWithOwner(y.id,y.desc.ctor,y.desc.staticArguments,y.desc.supportsDelayedInstantiation,y._trace);this._setServiceInstance(y.id,v)}T.removeNode(y)}}return this._getServiceInstanceOrDescriptor(u)}_createServiceInstanceWithOwner(u,a,w=[],T,S){if(this._services.get(u)instanceof b.SyncDescriptor)return this._createServiceInstance(a,w,T,S);if(this._parent)return this._parent._createServiceInstanceWithOwner(u,a,w,T,S);throw new Error(`illegalState - creating UNKNOWN service instance ${a.name}`)}_createServiceInstance(u,a=[],w,T){if(w){const S=new d.IdleValue(()=>this._createInstance(u,a,T));return new Proxy(Object.create(null),{get(o,f){if(f in o)return o[f];let y=S.value,i=y[f];return typeof i!="function"||(i=i.bind(y),o[f]=i),i},set(o,f,y){return S.value[f]=y,!0}})}else return this._createInstance(u,a,T)}}e.InstantiationService=t;var E;(function(c){c[c.Creation=0]="Creation",c[c.Invocation=1]="Invocation",c[c.Branch=2]="Branch"})(E||(E={}));class n{constructor(u,a){this.type=u,this.name=a,this._start=Date.now(),this._dep=[]}static traceInvocation(u){return _?new n(1,u.name||u.toString().substring(0,42).replace(/\n/g,"")):n._None}static traceCreation(u){return _?new n(0,u.name):n._None}branch(u,a){let w=new n(2,u.toString());return this._dep.push([u,a,w]),w}stop(){let u=Date.now()-this._start;n._totals+=u;let a=!1;function w(S,o){let f=[],y=new Array(S+1).join("	");for(const[i,v,r]of o._dep)if(v&&r){a=!0,f.push(`${y}CREATES -> ${i}`);let s=w(S+1,r);s&&f.push(s)}else f.push(`${y}uses -> ${i}`);return f.join(`
`)}let T=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${w(1,this)}`,`DONE, took ${u.toFixed(2)}ms (grand total ${n._totals.toFixed(2)}ms)`];(u>2||a)&&console.log(T.join(`
`))}}n._None=new class extends n{constructor(){super(-1,null)}stop(){}branch(){return this}},n._totals=0}),define(be[15],Ee([0,1,56,3,6,26,4]),function(re,e,d,M,b,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,F.createDecorator)("logService"),e.ILoggerService=(0,F.createDecorator)("loggerService");function C(){return new Date().toISOString()}var _;(function(y){y[y.Trace=0]="Trace",y[y.Debug=1]="Debug",y[y.Info=2]="Info",y[y.Warning=3]="Warning",y[y.Error=4]="Error",y[y.Critical=5]="Critical",y[y.Off=6]="Off"})(_=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=_.Info;class I extends b.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new M.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(i){this.level!==i&&(this.level=i,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=I;class t extends I{constructor(i){super();this.logAlways=i}checkLogLevel(i){return this.logAlways||this.getLevel()<=i}trace(i,...v){this.checkLogLevel(_.Trace)&&this.log(_.Trace,this.format([i,...v]))}debug(i,...v){this.checkLogLevel(_.Debug)&&this.log(_.Debug,this.format([i,...v]))}info(i,...v){this.checkLogLevel(_.Info)&&this.log(_.Info,this.format([i,...v]))}warn(i,...v){this.checkLogLevel(_.Warning)&&this.log(_.Warning,this.format([i,...v]))}error(i,...v){if(this.checkLogLevel(_.Error))if(i instanceof Error){const r=Array.prototype.slice.call(arguments);r[0]=i.stack,this.log(_.Error,this.format(r))}else this.log(_.Error,this.format([i,...v]))}critical(i,...v){this.checkLogLevel(_.Critical)&&this.log(_.Critical,this.format([i,...v]))}flush(){}format(i){let v="";for(let r=0;r<i.length;r++){let s=i[r];if(typeof s=="object")try{s=JSON.stringify(s)}catch(l){}v+=(r>0?" ":"")+s}return v}}e.AbstractMessageLogger=t;class E extends I{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i),this.useColors=!R.isWindows}trace(i,...v){this.getLevel()<=_.Trace&&(this.useColors?console.log(`[90m[main ${C()}][0m`,i,...v):console.log(`[main ${C()}]`,i,...v))}debug(i,...v){this.getLevel()<=_.Debug&&(this.useColors?console.log(`[90m[main ${C()}][0m`,i,...v):console.log(`[main ${C()}]`,i,...v))}info(i,...v){this.getLevel()<=_.Info&&(this.useColors?console.log(`[90m[main ${C()}][0m`,i,...v):console.log(`[main ${C()}]`,i,...v))}warn(i,...v){this.getLevel()<=_.Warning&&(this.useColors?console.warn(`[93m[main ${C()}][0m`,i,...v):console.warn(`[main ${C()}]`,i,...v))}error(i,...v){this.getLevel()<=_.Error&&(this.useColors?console.error(`[91m[main ${C()}][0m`,i,...v):console.error(`[main ${C()}]`,i,...v))}critical(i,...v){this.getLevel()<=_.Critical&&(this.useColors?console.error(`[90m[main ${C()}][0m`,i,...v):console.error(`[main ${C()}]`,i,...v))}dispose(){}flush(){}}e.ConsoleMainLogger=E;class n extends I{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i)}trace(i,...v){this.getLevel()<=_.Trace&&console.log("%cTRACE","color: #888",i,...v)}debug(i,...v){this.getLevel()<=_.Debug&&console.log("%cDEBUG","background: #eee; color: #888",i,...v)}info(i,...v){this.getLevel()<=_.Info&&console.log("%c INFO","color: #33f",i,...v)}warn(i,...v){this.getLevel()<=_.Warning&&console.log("%c WARN","color: #993",i,...v)}error(i,...v){this.getLevel()<=_.Error&&console.log("%c  ERR","color: #f33",i,...v)}critical(i,...v){this.getLevel()<=_.Critical&&console.log("%cCRITI","background: #f33; color: white",i,...v)}dispose(){}flush(){}}e.ConsoleLogger=n;class c extends I{constructor(i,v=e.DEFAULT_LOG_LEVEL){super();this.adapter=i,this.setLevel(v)}trace(i,...v){this.getLevel()<=_.Trace&&this.adapter.log(_.Trace,[this.extractMessage(i),...v])}debug(i,...v){this.getLevel()<=_.Debug&&this.adapter.log(_.Debug,[this.extractMessage(i),...v])}info(i,...v){this.getLevel()<=_.Info&&this.adapter.log(_.Info,[this.extractMessage(i),...v])}warn(i,...v){this.getLevel()<=_.Warning&&this.adapter.log(_.Warning,[this.extractMessage(i),...v])}error(i,...v){this.getLevel()<=_.Error&&this.adapter.log(_.Error,[this.extractMessage(i),...v])}critical(i,...v){this.getLevel()<=_.Critical&&this.adapter.log(_.Critical,[this.extractMessage(i),...v])}extractMessage(i){return typeof i=="string"?i:(0,d.toErrorMessage)(i,this.getLevel()<=_.Trace)}dispose(){}flush(){}}e.AdapterLogger=c;class u extends I{constructor(i){super();this.logServices=i,i.length&&this.setLevel(i[0].getLevel())}setLevel(i){for(const v of this.logServices)v.setLevel(i);super.setLevel(i)}trace(i,...v){for(const r of this.logServices)r.trace(i,...v)}debug(i,...v){for(const r of this.logServices)r.debug(i,...v)}info(i,...v){for(const r of this.logServices)r.info(i,...v)}warn(i,...v){for(const r of this.logServices)r.warn(i,...v)}error(i,...v){for(const r of this.logServices)r.error(i,...v)}critical(i,...v){for(const r of this.logServices)r.critical(i,...v)}flush(){for(const i of this.logServices)i.flush()}dispose(){for(const i of this.logServices)i.dispose()}}e.MultiplexLogService=u;class a extends b.Disposable{constructor(i){super();this.logger=i,this._register(i)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(i){this.logger.setLevel(i)}getLevel(){return this.logger.getLevel()}trace(i,...v){this.logger.trace(i,...v)}debug(i,...v){this.logger.debug(i,...v)}info(i,...v){this.logger.info(i,...v)}warn(i,...v){this.logger.warn(i,...v)}error(i,...v){this.logger.error(i,...v)}critical(i,...v){this.logger.critical(i,...v)}flush(){this.logger.flush()}}e.LogService=a;class w extends b.Disposable{constructor(i,v){super();this.logLevel=i,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(v(r=>{this.logLevel=r,this.logLevelChangeableLoggers.forEach(s=>s.setLevel(r))}))}getLogger(i){return this.loggers.get(i.toString())}createLogger(i,v){let r=this.loggers.get(i.toString());return r||(r=this.doCreateLogger(i,v?.always?_.Trace:this.logLevel,v),this.loggers.set(i.toString(),r),v?.always||this.logLevelChangeableLoggers.push(r)),r}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(i=>i.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=w;class T{constructor(){this.onDidChangeLogLevel=new M.Emitter().event}setLevel(i){}getLevel(){return _.Info}trace(i,...v){}debug(i,...v){}info(i,...v){}warn(i,...v){}error(i,...v){}critical(i,...v){}dispose(){}flush(){}}e.NullLogService=T;function S(y){if(y.verbose)return _.Trace;if(typeof y.logLevel=="string"){const i=o(y.logLevel.toLowerCase());if(i!==void 0)return i}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=S;function o(y){switch(y){case"trace":return _.Trace;case"debug":return _.Debug;case"info":return _.Info;case"warn":return _.Warning;case"error":return _.Error;case"critical":return _.Critical;case"off":return _.Off}}e.parseLogLevel=o;function f(y){switch(y){case _.Trace:return"trace";case _.Debug:return"debug";case _.Info:return"info";case _.Warning:return"warn";case _.Error:return"error";case _.Critical:return"critical";case _.Off:return"off"}}e.LogLevelToString=f}),define(be[82],Ee([0,1,35,122,4]),function(re,e,d,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var R;(function(_){_[_.Unnecessary=1]="Unnecessary",_[_.Deprecated=2]="Deprecated"})(R=e.MarkerTag||(e.MarkerTag={}));var F;(function(_){_[_.Hint=1]="Hint",_[_.Info=2]="Info",_[_.Warning=4]="Warning",_[_.Error=8]="Error"})(F=e.MarkerSeverity||(e.MarkerSeverity={})),function(_){function I(u,a){return a-u}_.compare=I;const t=Object.create(null);t[_.Error]=(0,M.localize)(0,null),t[_.Warning]=(0,M.localize)(1,null),t[_.Info]=(0,M.localize)(2,null);function E(u){return t[u]||""}_.toString=E;function n(u){switch(u){case d.default.Error:return _.Error;case d.default.Warning:return _.Warning;case d.default.Info:return _.Info;case d.default.Ignore:return _.Hint}}_.fromSeverity=n;function c(u){switch(u){case _.Error:return d.default.Error;case _.Warning:return d.default.Warning;case _.Info:return d.default.Info;case _.Hint:return d.default.Ignore}}_.toSeverity=c}(F=e.MarkerSeverity||(e.MarkerSeverity={}));var C;(function(_){const I="";function t(n){return E(n,!0)}_.makeKey=t;function E(n,c){let u=[I];return n.source?u.push(n.source.replace("\xA6","\\\xA6")):u.push(I),n.code?typeof n.code=="string"?u.push(n.code.replace("\xA6","\\\xA6")):u.push(n.code.value.replace("\xA6","\\\xA6")):u.push(I),n.severity!==void 0&&n.severity!==null?u.push(F.toString(n.severity)):u.push(I),n.message&&c?u.push(n.message.replace("\xA6","\\\xA6")):u.push(I),n.startLineNumber!==void 0&&n.startLineNumber!==null?u.push(n.startLineNumber.toString()):u.push(I),n.startColumn!==void 0&&n.startColumn!==null?u.push(n.startColumn.toString()):u.push(I),n.endLineNumber!==void 0&&n.endLineNumber!==null?u.push(n.endLineNumber.toString()):u.push(I),n.endColumn!==void 0&&n.endColumn!==null?u.push(n.endColumn.toString()):u.push(I),u.push(I),u.join("\xA6")}_.makeKeyOptionalMessage=E})(C=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,b.createDecorator)("markerService")}),define(be[145],Ee([0,1,3,35,4]),function(re,e,d,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=M.default,e.INotificationService=(0,b.createDecorator)("notificationService");var R;(function(I){I[I.WORKSPACE=0]="WORKSPACE",I[I.GLOBAL=1]="GLOBAL"})(R=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var F;(function(I){I[I.OFF=0]="OFF",I[I.SILENT=1]="SILENT",I[I.ERROR=2]="ERROR"})(F=e.NotificationsFilter||(e.NotificationsFilter={}));class C{constructor(){this.progress=new _,this.onDidClose=d.Event.None,this.onDidChangeVisibility=d.Event.None}updateSeverity(t){}updateMessage(t){}updateActions(t){}close(){}}e.NoOpNotification=C;class _{infinite(){}done(){}total(t){}worked(t){}}e.NoOpProgress=_}),define(be[146],Ee([0,1,6,9,2,4]),function(re,e,d,M,b,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,R.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return d.Disposable.None},registerValidator(){return d.Disposable.None},registerExternalUriResolver(){return d.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return d.Disposable.None},async open(){return!1},async resolveExternalUri(C){return{resolved:C,dispose(){}}}});function F(C,_){return b.URI.isUri(C)?(0,M.equalsIgnoreCase)(C.scheme,_):(0,M.startsWithIgnoreCase)(C,_+":")}e.matchesScheme=F});var We=this&&this.__decorate||function(re,e,d,M){var b=arguments.length,R=b<3?e:M===null?M=Object.getOwnPropertyDescriptor(e,d):M,F;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate(re,e,d,M);else for(var C=re.length-1;C>=0;C--)(F=re[C])&&(R=(b<3?F(R):b>3?F(e,d,R):F(e,d))||R);return b>3&&R&&Object.defineProperty(e,d,R),R},ze=this&&this.__param||function(re,e){return function(d,M){e(d,M,re)}};define(be[147],Ee([0,1,14,21,6,4]),function(re,e,d,M,b,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,R.createDecorator)("progressService");var F;(function(t){t[t.Explorer=1]="Explorer",t[t.Scm=3]="Scm",t[t.Extensions=5]="Extensions",t[t.Window=10]="Window",t[t.Notification=15]="Notification",t[t.Dialog=20]="Dialog"})(F=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class C{constructor(E){this.callback=E}get value(){return this._value}report(E){this._value=E,this.callback(this._value)}}e.Progress=C,C.None=Object.freeze({report(){}});let _=class extends b.Disposable{constructor(E,n){super();this.deferred=new d.DeferredPromise,n.withProgress(E,c=>(this.reporter=c,this.lastStep&&c.report(this.lastStep),this.deferred.p)),this._register((0,b.toDisposable)(()=>this.deferred.complete()))}report(E){this.reporter?this.reporter.report(E):this.lastStep=E}};_=We([ze(1,e.IProgressService)],_),e.UnmanagedProgress=_;class I extends b.Disposable{constructor(E){super();this.progressIndicator=E,this.currentOperationId=0,this.currentOperationDisposables=this._register(new b.DisposableStore)}start(E){this.stop();const n=++this.currentOperationId,c=new M.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{n===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},E),this.currentOperationDisposables.add((0,b.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,b.toDisposable)(()=>c.cancel())),this.currentOperationDisposables.add((0,b.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:n,token:c.token,stop:()=>this.doStop(n),isCurrent:()=>this.currentOperationId===n}}stop(){this.doStop(this.currentOperationId)}doStop(E){this.currentOperationId===E&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=I,e.IEditorProgressService=(0,R.createDecorator)("editorProgressService")}),define(be[28],Ee([0,1,42,10]),function(re,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class b{constructor(){this.data=new Map}add(F,C){d.ok(M.isString(F)),d.ok(M.isObject(C)),d.ok(!this.data.has(F),"There is already an extension with this id"),this.data.set(F,C)}knows(F){return this.data.has(F)}as(F){return this.data.get(F)||null}}e.Registry=new b}),define(be[83],Ee([0,1,3,28]),function(re,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function b(C){return C.length>0&&C.charAt(C.length-1)==="#"?C.substring(0,C.length-1):C}class R{constructor(){this._onDidChangeSchema=new d.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(_,I){this.schemasById[b(_)]=I,this._onDidChangeSchema.fire(_)}notifySchemaChanged(_){this._onDidChangeSchema.fire(_)}getSchemaContributions(){return{schemas:this.schemasById}}}const F=new R;M.Registry.add(e.Extensions.JSONContribution,F)}),define(be[62],Ee([0,1,12,3,10,119,83,28]),function(re,e,d,M,b,R,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var _;(function(S){S.Multiline="multilineText",S.Singleline="singlelineText"})(_=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var I;(function(S){S[S.APPLICATION=1]="APPLICATION",S[S.MACHINE=2]="MACHINE",S[S.WINDOW=3]="WINDOW",S[S.RESOURCE=4]="RESOURCE",S[S.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",S[S.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(I=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const t=C.Registry.as(F.Extensions.JSONContribution);class E{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new M.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new M.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:R.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},t.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(o,f=!0){this.registerConfigurations([o],f)}registerConfigurations(o,f=!0){const y=this.doRegisterConfigurations(o,f);t.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(y)}deregisterConfigurations(o){const f=this.doDeregisterConfigurations(o);t.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(f)}updateConfigurations({add:o,remove:f}){const y=[];y.push(...this.doDeregisterConfigurations(f)),y.push(...this.doRegisterConfigurations(o,!1)),t.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire((0,d.distinct)(y))}registerDefaultConfigurations(o){const f=[],y=[];for(const i of o)for(const v in i)if(f.push(v),e.OVERRIDE_PROPERTY_PATTERN.test(v)){this.defaultValues[v]={...this.defaultValues[v]||{},...i[v]};const r={type:"object",default:this.defaultValues[v],description:R.localize(1,null,v),$ref:e.resourceLanguageSettingsSchemaId};y.push(c(v)),this.configurationProperties[v]=r,this.defaultLanguageConfigurationOverridesNode.properties[v]=r}else{this.defaultValues[v]=i[v];const r=this.configurationProperties[v];r&&(this.updatePropertyDefaultValue(v,r),this.updateSchema(v,r))}this.registerOverrideIdentifiers(y),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(f)}deregisterDefaultConfigurations(o){const f=[];for(const y of o)for(const i in y)if(f.push(i),delete this.defaultValues[i],e.OVERRIDE_PROPERTY_PATTERN.test(i))delete this.configurationProperties[i],delete this.defaultLanguageConfigurationOverridesNode.properties[i];else{const v=this.configurationProperties[i];v&&(this.updatePropertyDefaultValue(i,v),this.updateSchema(i,v))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(f)}notifyConfigurationSchemaUpdated(...o){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(o){for(const f of o)this.overrideIdentifiers.add(f);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(o,f){const y=[];return o.forEach(i=>{y.push(...this.validateAndRegisterProperties(i,f,i.extensionInfo)),this.configurationContributors.push(i),this.registerJSONConfiguration(i)}),y}doDeregisterConfigurations(o){const f=[],y=i=>{if(i.properties)for(const v in i.properties)f.push(v),delete this.configurationProperties[v],this.removeFromSchema(v,i.properties[v]);i.allOf&&i.allOf.forEach(v=>y(v))};for(const i of o){y(i);const v=this.configurationContributors.indexOf(i);v!==-1&&this.configurationContributors.splice(v,1)}return f}validateAndRegisterProperties(o,f=!0,y,i=3){i=b.isUndefinedOrNull(o.scope)?i:o.scope;let v=[],r=o.properties;if(r)for(let l in r){if(f&&w(l)){delete r[l];continue}const h=r[l];if(this.updatePropertyDefaultValue(l,h),e.OVERRIDE_PROPERTY_PATTERN.test(l)?h.scope=void 0:(h.scope=b.isUndefinedOrNull(h.scope)?i:h.scope,h.restricted=b.isUndefinedOrNull(h.restricted)?!!y?.restrictedConfigurations?.includes(l):h.restricted),r[l].hasOwnProperty("included")&&!r[l].included){this.excludedConfigurationProperties[l]=r[l],delete r[l];continue}else this.configurationProperties[l]=r[l];!r[l].deprecationMessage&&r[l].markdownDeprecationMessage&&(r[l].deprecationMessage=r[l].markdownDeprecationMessage),v.push(l)}let s=o.allOf;if(s)for(let l of s)v.push(...this.validateAndRegisterProperties(l,f,y,i));return v}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(o){const f=y=>{let i=y.properties;if(i)for(const r in i)this.updateSchema(r,i[r]);let v=y.allOf;v&&v.forEach(f)};f(o)}updateSchema(o,f){switch(e.allSettings.properties[o]=f,f.scope){case 1:e.applicationSettings.properties[o]=f;break;case 2:e.machineSettings.properties[o]=f;break;case 6:e.machineOverridableSettings.properties[o]=f;break;case 3:e.windowSettings.properties[o]=f;break;case 4:e.resourceSettings.properties[o]=f;break;case 5:e.resourceSettings.properties[o]=f,this.resourceLanguageSettingsSchema.properties[o]=f;break}}removeFromSchema(o,f){switch(delete e.allSettings.properties[o],f.scope){case 1:delete e.applicationSettings.properties[o];break;case 2:delete e.machineSettings.properties[o];break;case 6:delete e.machineOverridableSettings.properties[o];break;case 3:delete e.windowSettings.properties[o];break;case 4:case 5:delete e.resourceSettings.properties[o];break}}updateOverridePropertyPatternKey(){for(const o of this.overrideIdentifiers.values()){const f=`[${o}]`,y={type:"object",description:R.localize(2,null),errorMessage:R.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(f,y),e.allSettings.properties[f]=y,e.applicationSettings.properties[f]=y,e.machineSettings.properties[f]=y,e.machineOverridableSettings.properties[f]=y,e.windowSettings.properties[f]=y,e.resourceSettings.properties[f]=y}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(o,f){let y=this.defaultValues[o];b.isUndefined(y)&&(y=f.default),b.isUndefined(y)&&(y=u(f.type)),f.default=y}}const n="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(n);function c(S){return S.substring(1,S.length-1)}e.overrideIdentifierFromKey=c;function u(S){switch(Array.isArray(S)?S[0]:S){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=u;const a=new E;C.Registry.add(e.Extensions.Configuration,a);function w(S){return S.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(S)?R.localize(5,null,S):a.getConfigurationProperties()[S]!==void 0?R.localize(6,null,S):null:R.localize(4,null)}e.validateProperty=w;function T(){const S=[],o=a.getConfigurationProperties();for(const f of Object.keys(o))S.push([f,o[f].scope]);return S.push(["launch",4]),S.push(["task",4]),S}e.getScopes=T}),define(be[84],Ee([0,1,23,10,2,62,4,28]),function(re,e,d,M,b,R,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,F.createDecorator)("configurationService");function _(v){return v&&typeof v=="object"&&(!v.overrideIdentifier||typeof v.overrideIdentifier=="string")&&(!v.resource||v.resource instanceof b.URI)}e.isConfigurationOverrides=_;var I;(function(v){v[v.USER=1]="USER",v[v.USER_LOCAL=2]="USER_LOCAL",v[v.USER_REMOTE=3]="USER_REMOTE",v[v.WORKSPACE=4]="WORKSPACE",v[v.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",v[v.DEFAULT=6]="DEFAULT",v[v.MEMORY=7]="MEMORY"})(I=e.ConfigurationTarget||(e.ConfigurationTarget={}));function t(v){switch(v){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=t;function E(v,r){const s=r?v?r.keys.filter(D=>v.keys.indexOf(D)===-1):[...r.keys]:[],l=v?r?v.keys.filter(D=>r.keys.indexOf(D)===-1):[...v.keys]:[],h=[];if(r&&v){for(const D of v.keys)if(r.keys.indexOf(D)!==-1){const m=T(v.contents,D),A=T(r.contents,D);d.equals(m,A)||h.push(D)}}const p=[],k=D=>{const m={};for(const A of D)for(const L of A.identifiers)m[y(L)]=A;return m},P=r?k(r.overrides):{},g=v?k(v.overrides):{};if(Object.keys(P).length)for(const D of s){const m=P[D];m&&p.push([(0,R.overrideIdentifierFromKey)(D),m.keys])}if(Object.keys(g).length)for(const D of l){const m=g[D];m&&p.push([(0,R.overrideIdentifierFromKey)(D),m.keys])}if(Object.keys(P).length&&Object.keys(g).length)for(const D of h){const m=g[D],A=P[D];if(m&&A){const L=E({contents:m.contents,keys:m.keys,overrides:[]},{contents:A.contents,keys:A.keys,overrides:[]});p.push([(0,R.overrideIdentifierFromKey)(D),[...L.added,...L.removed,...L.updated]])}}return{added:s,removed:l,updated:h,overrides:p}}e.compare=E;function n(v,r){const s=[];for(const l of Object.keys(v))if(R.OVERRIDE_PROPERTY_PATTERN.test(l)){const h={};for(const p in v[l])h[p]=v[l][p];s.push({identifiers:[(0,R.overrideIdentifierFromKey)(l).trim()],keys:Object.keys(h),contents:c(h,r)})}return s}e.toOverrides=n;function c(v,r){const s=Object.create(null);for(let l in v)u(s,l,v[l],r);return s}e.toValuesTree=c;function u(v,r,s,l){const h=r.split("."),p=h.pop();let k=v;for(let P=0;P<h.length;P++){let g=h[P],D=k[g];switch(typeof D){case"undefined":D=k[g]=Object.create(null);break;case"object":break;default:l(`Ignoring ${r} as ${h.slice(0,P+1).join(".")} is ${JSON.stringify(D)}`);return}k=D}if(typeof k=="object"&&k!==null)try{k[p]=s}catch(P){l(`Ignoring ${r} as ${h.join(".")} is ${JSON.stringify(k)}`)}else l(`Ignoring ${r} as ${h.join(".")} is ${JSON.stringify(k)}`)}e.addToValueTree=u;function a(v,r){const s=r.split(".");w(v,s)}e.removeFromValueTree=a;function w(v,r){const s=r.shift();if(r.length===0){delete v[s];return}if(Object.keys(v).indexOf(s)!==-1){const l=v[s];typeof l=="object"&&!Array.isArray(l)&&(w(l,r),Object.keys(l).length===0&&delete v[s])}}function T(v,r,s){function l(k,P){let g=k;for(const D of P){if(typeof g!="object"||g===null)return;g=g[D]}return g}const h=r.split("."),p=l(v,h);return typeof p=="undefined"?s:p}e.getConfigurationValue=T;function S(v,r,s){Object.keys(r).forEach(l=>{l!=="__proto__"&&(l in v?M.isObject(v[l])&&M.isObject(r[l])?S(v[l],r[l],s):s&&(v[l]=r[l]):v[l]=r[l])})}e.merge=S;function o(){const v=C.Registry.as(R.Extensions.Configuration).getConfigurationProperties();return Object.keys(v)}e.getConfigurationKeys=o;function f(){const v=Object.create(null),r=C.Registry.as(R.Extensions.Configuration).getConfigurationProperties();for(let s in r){let l=r[s].default;u(v,s,l,h=>console.error(`Conflict in default settings: ${h}`))}return v}e.getDefaultValues=f;function y(v){return`[${v}]`}e.keyFromOverrideIdentifier=y;function i(v,r,s){const l=v.inspect(r),h=v.inspect(s);return typeof l.userValue!="undefined"||typeof l.workspaceValue!="undefined"||typeof l.workspaceFolderValue!="undefined"?l.value:typeof h.userValue!="undefined"||typeof h.workspaceValue!="undefined"||typeof h.workspaceFolderValue!="undefined"?h.value:l.defaultValue}e.getMigratedSettingValue=i}),define(be[148],Ee([0,1,12,3,102,6,20,23,10,2,84,62,28]),function(re,e,d,M,b,R,F,C,_,I,t,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class c{constructor(i={},v=[],r=[]){this._contents=i,this._keys=v,this._overrides=r,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(i){return i?(0,t.getConfigurationValue)(this.contents,i):this.contents}getOverrideValue(i,v){const r=this.getContentsForOverrideIdentifer(v);return r?i?(0,t.getConfigurationValue)(r,i):r:void 0}getKeysForOverrideIdentifier(i){for(const v of this.overrides)if(v.identifiers.indexOf(i)!==-1)return v.keys;return[]}override(i){const v=this.getContentsForOverrideIdentifer(i);if(!v||typeof v!="object"||!Object.keys(v).length)return this;let r={};for(const s of d.distinct([...Object.keys(this.contents),...Object.keys(v)])){let l=this.contents[s],h=v[s];h&&(typeof l=="object"&&typeof h=="object"?(l=C.deepClone(l),this.mergeContents(l,h)):l=h),r[s]=l}return new c(r,this.keys,this.overrides)}merge(...i){const v=C.deepClone(this.contents),r=C.deepClone(this.overrides),s=[...this.keys];for(const l of i){this.mergeContents(v,l.contents);for(const h of l.overrides){const[p]=r.filter(k=>d.equals(k.identifiers,h.identifiers));p?this.mergeContents(p.contents,h.contents):r.push(C.deepClone(h))}for(const h of l.keys)s.indexOf(h)===-1&&s.push(h)}return new c(v,s,r)}freeze(){return this.isFrozen=!0,this}mergeContents(i,v){for(const r of Object.keys(v)){if(r in i&&_.isObject(i[r])&&_.isObject(v[r])){this.mergeContents(i[r],v[r]);continue}i[r]=C.deepClone(v[r])}}checkAndFreeze(i){return this.isFrozen&&!Object.isFrozen(i)?C.deepFreeze(i):i}getContentsForOverrideIdentifer(i){for(const v of this.overrides)if(v.identifiers.indexOf(i)!==-1)return v.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(i,v){this.addKey(i),(0,t.addToValueTree)(this.contents,i,v,r=>{throw new Error(r)})}removeValue(i){this.removeKey(i)&&(0,t.removeFromValueTree)(this.contents,i)}addKey(i){let v=this.keys.length;for(let r=0;r<v;r++)i.indexOf(this.keys[r])===0&&(v=r);this.keys.splice(v,1,i)}removeKey(i){let v=this.keys.indexOf(i);return v!==-1?(this.keys.splice(v,1),!0):!1}}e.ConfigurationModel=c;class u extends c{constructor(){const i=(0,t.getDefaultValues)(),v=(0,t.getConfigurationKeys)(),r=[];for(const s of Object.keys(i))E.OVERRIDE_PROPERTY_PATTERN.test(s)&&r.push({identifiers:[(0,E.overrideIdentifierFromKey)(s).trim()],keys:Object.keys(i[s]),contents:(0,t.toValuesTree)(i[s],l=>console.error(`Conflict in default settings file: ${l}`))});super(i,v,r)}}e.DefaultConfigurationModel=u;class a{constructor(i){this._name=i,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new c}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(i,v){if(!_.isUndefinedOrNull(i)){const r=this.doParseContent(i);this.parseRaw(r,v)}}reparse(i){this._raw&&this.parseRaw(this._raw,i)}parseRaw(i,v){this._raw=i;const{contents:r,keys:s,overrides:l,restricted:h}=this.doParseRaw(i,v);this._configurationModel=new c(r,s,l),this._restrictedConfigurations=h||[]}doParseContent(i){let v={},r=null,s=[],l=[],h=[];function p(P){Array.isArray(s)?s.push(P):r!==null&&(s[r]=P)}let k={onObjectBegin:()=>{let P={};p(P),l.push(s),s=P,r=null},onObjectProperty:P=>{r=P},onObjectEnd:()=>{s=l.pop()},onArrayBegin:()=>{let P=[];p(P),l.push(s),s=P,r=null},onArrayEnd:()=>{s=l.pop()},onLiteralValue:p,onError:(P,g,D)=>{h.push({error:P,offset:g,length:D})}};if(i)try{b.visit(i,k),v=s[0]||{}}catch(P){console.error(`Error while parsing settings file ${this._name}: ${P}`),this._parseErrors=[P]}return v}doParseRaw(i,v){const r=n.Registry.as(E.Extensions.Configuration).getConfigurationProperties(),s=this.filter(i,r,!0,v);i=s.raw;const l=(0,t.toValuesTree)(i,k=>console.error(`Conflict in settings file ${this._name}: ${k}`)),h=Object.keys(i),p=(0,t.toOverrides)(i,k=>console.error(`Conflict in settings file ${this._name}: ${k}`));return{contents:l,keys:h,overrides:p,restricted:s.restricted}}filter(i,v,r,s){if(!s?.scopes&&!s?.skipRestricted)return{raw:i,restricted:[]};const l={},h=[];for(let p in i)if(E.OVERRIDE_PROPERTY_PATTERN.test(p)&&r){const k=this.filter(i[p],v,!1,s);l[p]=k.raw,h.push(...k.restricted)}else{const k=v[p],P=k?typeof k.scope!="undefined"?k.scope:3:void 0;k?.restricted&&h.push(p),(P===void 0||s.scopes===void 0||s.scopes.includes(P))&&(s.skipRestricted&&k?.restricted||(l[p]=i[p]))}return{raw:l,restricted:h}}}e.ConfigurationModelParser=a;class w extends R.Disposable{constructor(i,v,r,s){super();this.userSettingsResource=i,this.scopes=v,this.fileService=s,this._onDidChange=this._register(new M.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new a(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(r.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(M.Event.filter(this.fileService.onDidFilesChange,l=>l.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const i=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(i.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(i){return new c}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=w;class T{constructor(i,v,r=new c,s=new c,l=new F.ResourceMap,h=new c,p=new F.ResourceMap,k=!0){this._defaultConfiguration=i,this._localUserConfiguration=v,this._remoteUserConfiguration=r,this._workspaceConfiguration=s,this._folderConfigurations=l,this._memoryConfiguration=h,this._memoryConfigurationByResource=p,this._freeze=k,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new F.ResourceMap,this._userConfiguration=null}getValue(i,v,r){return this.getConsolidateConfigurationModel(v,r).getValue(i)}updateValue(i,v,r={}){let s;r.resource?(s=this._memoryConfigurationByResource.get(r.resource),s||(s=new c,this._memoryConfigurationByResource.set(r.resource,s))):s=this._memoryConfiguration,v===void 0?s.removeValue(i):s.setValue(i,v),r.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(i,v,r){const s=this.getConsolidateConfigurationModel(v,r),l=this.getFolderConfigurationModelForResource(v.resource,r),h=v.resource?this._memoryConfigurationByResource.get(v.resource)||this._memoryConfiguration:this._memoryConfiguration,p=v.overrideIdentifier?this._defaultConfiguration.freeze().override(v.overrideIdentifier).getValue(i):this._defaultConfiguration.freeze().getValue(i),k=v.overrideIdentifier?this.userConfiguration.freeze().override(v.overrideIdentifier).getValue(i):this.userConfiguration.freeze().getValue(i),P=v.overrideIdentifier?this.localUserConfiguration.freeze().override(v.overrideIdentifier).getValue(i):this.localUserConfiguration.freeze().getValue(i),g=v.overrideIdentifier?this.remoteUserConfiguration.freeze().override(v.overrideIdentifier).getValue(i):this.remoteUserConfiguration.freeze().getValue(i),D=r?v.overrideIdentifier?this._workspaceConfiguration.freeze().override(v.overrideIdentifier).getValue(i):this._workspaceConfiguration.freeze().getValue(i):void 0,m=l?v.overrideIdentifier?l.freeze().override(v.overrideIdentifier).getValue(i):l.freeze().getValue(i):void 0,A=v.overrideIdentifier?h.override(v.overrideIdentifier).getValue(i):h.getValue(i),L=s.getValue(i),V=d.distinct(d.flatten(s.overrides.map(G=>G.identifiers))).filter(G=>s.getOverrideValue(i,G)!==void 0);return{defaultValue:p,userValue:k,userLocalValue:P,userRemoteValue:g,workspaceValue:D,workspaceFolderValue:m,memoryValue:A,value:L,default:p!==void 0?{value:this._defaultConfiguration.freeze().getValue(i),override:v.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(i,v.overrideIdentifier):void 0}:void 0,user:k!==void 0?{value:this.userConfiguration.freeze().getValue(i),override:v.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(i,v.overrideIdentifier):void 0}:void 0,userLocal:P!==void 0?{value:this.localUserConfiguration.freeze().getValue(i),override:v.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(i,v.overrideIdentifier):void 0}:void 0,userRemote:g!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(i),override:v.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(i,v.overrideIdentifier):void 0}:void 0,workspace:D!==void 0?{value:this._workspaceConfiguration.freeze().getValue(i),override:v.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(i,v.overrideIdentifier):void 0}:void 0,workspaceFolder:m!==void 0?{value:l?.freeze().getValue(i),override:v.overrideIdentifier?l?.freeze().getOverrideValue(i,v.overrideIdentifier):void 0}:void 0,memory:A!==void 0?{value:h.getValue(i),override:v.overrideIdentifier?h.getOverrideValue(i,v.overrideIdentifier):void 0}:void 0,overrideIdentifiers:V.length?V:void 0}}keys(i){const v=this.getFolderConfigurationModelForResource(void 0,i);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:v?v.freeze().keys:[]}}updateDefaultConfiguration(i){this._defaultConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(i){this._localUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(i){this._remoteUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(i){this._workspaceConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(i,v){this._folderConfigurations.set(i,v),this._foldersConsolidatedConfigurations.delete(i)}deleteFolderConfiguration(i){this.folderConfigurations.delete(i),this._foldersConsolidatedConfigurations.delete(i)}compareAndUpdateDefaultConfiguration(i,v){const r=v.filter(s=>E.OVERRIDE_PROPERTY_PATTERN.test(s)).map(s=>{const l=(0,E.overrideIdentifierFromKey)(s),h=this._defaultConfiguration.getKeysForOverrideIdentifier(l),p=i.getKeysForOverrideIdentifier(l),k=[...p.filter(P=>h.indexOf(P)===-1),...h.filter(P=>p.indexOf(P)===-1),...h.filter(P=>!C.equals(this._defaultConfiguration.override(l).getValue(P),i.override(l).getValue(P)))];return[l,k]});return this.updateDefaultConfiguration(i),{keys:v,overrides:r}}compareAndUpdateLocalUserConfiguration(i){const{added:v,updated:r,removed:s,overrides:l}=(0,t.compare)(this.localUserConfiguration,i),h=[...v,...r,...s];return h.length&&this.updateLocalUserConfiguration(i),{keys:h,overrides:l}}compareAndUpdateRemoteUserConfiguration(i){const{added:v,updated:r,removed:s,overrides:l}=(0,t.compare)(this.remoteUserConfiguration,i);let h=[...v,...r,...s];return h.length&&this.updateRemoteUserConfiguration(i),{keys:h,overrides:l}}compareAndUpdateWorkspaceConfiguration(i){const{added:v,updated:r,removed:s,overrides:l}=(0,t.compare)(this.workspaceConfiguration,i);let h=[...v,...r,...s];return h.length&&this.updateWorkspaceConfiguration(i),{keys:h,overrides:l}}compareAndUpdateFolderConfiguration(i,v){const r=this.folderConfigurations.get(i),{added:s,updated:l,removed:h,overrides:p}=(0,t.compare)(r,v);let k=[...s,...l,...h];return(k.length||!r)&&this.updateFolderConfiguration(i,v),{keys:k,overrides:p}}compareAndDeleteFolderConfiguration(i){const v=this.folderConfigurations.get(i);if(!v)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:r,updated:s,removed:l,overrides:h}=(0,t.compare)(v,void 0);return{keys:[...r,...s,...l],overrides:h}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(i,v){let r=this.getConsolidatedConfigurationModelForResource(i,v);return i.overrideIdentifier?r.override(i.overrideIdentifier):r}getConsolidatedConfigurationModelForResource({resource:i},v){let r=this.getWorkspaceConsolidatedConfiguration();if(v&&i){const s=v.getFolder(i);s&&(r=this.getFolderConsolidatedConfiguration(s.uri)||r);const l=this._memoryConfigurationByResource.get(i);l&&(r=r.merge(l))}return r}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(i){let v=this._foldersConsolidatedConfigurations.get(i);if(!v){const r=this.getWorkspaceConsolidatedConfiguration(),s=this._folderConfigurations.get(i);s?(v=r.merge(s),this._freeze&&(v=v.freeze()),this._foldersConsolidatedConfigurations.set(i,v)):v=r}return v}getFolderConfigurationModelForResource(i,v){if(v&&i){const r=v.getFolder(i);if(r)return this._folderConfigurations.get(r.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((i,v)=>{const{contents:r,overrides:s,keys:l}=this._folderConfigurations.get(v);return i.push([v,{contents:r,overrides:s,keys:l}]),i},[])}}allKeys(){const i=new Set;return this._defaultConfiguration.freeze().keys.forEach(v=>i.add(v)),this.userConfiguration.freeze().keys.forEach(v=>i.add(v)),this._workspaceConfiguration.freeze().keys.forEach(v=>i.add(v)),this._folderConfigurations.forEach(v=>v.freeze().keys.forEach(r=>i.add(r))),[...i.values()]}getAllKeysForOverrideIdentifier(i){const v=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(i).forEach(r=>v.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(r=>v.add(r)),this._workspaceConfiguration.getKeysForOverrideIdentifier(i).forEach(r=>v.add(r)),this._folderConfigurations.forEach(r=>r.getKeysForOverrideIdentifier(i).forEach(s=>v.add(s))),[...v.values()]}static parse(i){const v=this.parseConfigurationModel(i.defaults),r=this.parseConfigurationModel(i.user),s=this.parseConfigurationModel(i.workspace),l=i.folders.reduce((h,p)=>(h.set(I.URI.revive(p[0]),this.parseConfigurationModel(p[1])),h),new F.ResourceMap);return new T(v,r,new c,s,l,new c,new F.ResourceMap,!1)}static parseConfigurationModel(i){return new c(i.contents,i.keys,i.overrides).freeze()}}e.Configuration=T;function S(...y){if(y.length===0)return{keys:[],overrides:[]};if(y.length===1)return y[0];const i=new Set,v=new Map;for(const s of y)s.keys.forEach(l=>i.add(l)),s.overrides.forEach(([l,h])=>{const p=(0,F.getOrSet)(v,l,new Set);h.forEach(k=>p.add(k))});const r=[];return v.forEach((s,l)=>r.push([l,[...s.values()]])),{keys:[...i.values()],overrides:r}}e.mergeChanges=S;class o{constructor(i,v,r,s){this.change=i,this.previous=v,this.currentConfiguraiton=r,this.currentWorkspace=s,this._previousConfiguration=void 0;const l=new Set;i.keys.forEach(p=>l.add(p)),i.overrides.forEach(([,p])=>p.forEach(k=>l.add(k))),this.affectedKeys=[...l.values()];const h=new c;this.affectedKeys.forEach(p=>h.setValue(p,{})),this.affectedKeysTree=h.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=T.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(i,v){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,i)){if(v){const r=this.previousConfiguration?this.previousConfiguration.getValue(i,v,this.previous?.workspace):void 0,s=this.currentConfiguraiton.getValue(i,v,this.currentWorkspace);return!C.equals(r,s)}return!0}return!1}doesAffectedKeysTreeContains(i,v){let r=(0,t.toValuesTree)({[v]:!0},()=>{}),s;for(;typeof r=="object"&&(s=Object.keys(r)[0]);){if(i=i[s],!i)return!1;r=r[s]}return!0}}e.ConfigurationChangeEvent=o;class f extends o{constructor(i,v,r,s){super({keys:i.allKeys(),overrides:[]},void 0,i,v);this.source=r,this.sourceConfig=s}}e.AllKeysConfigurationChangeEvent=f}),define(be[85],Ee([0,1,4]),function(re,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,d.createDecorator)("remoteAuthorityResolverService");var M;(function(R){R.Unknown="Unknown",R.NotAvailable="NotAvailable",R.TemporarilyNotAvailable="TemporarilyNotAvailable",R.NoResolverFound="NoResolverFound"})(M=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class b extends Error{constructor(F,C=M.Unknown,_){super(F);this._message=F,this._code=C,this._detail=_,this.isHandled=C===M.NotAvailable&&_===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,b.prototype)}static isTemporarilyNotAvailable(F){return F instanceof b&&F._code===M.TemporarilyNotAvailable}static isNoResolverFound(F){return F instanceof b&&F._code===M.NoResolverFound}static isHandled(F){return F instanceof b&&F.isHandled}}e.RemoteAuthorityResolverError=b}),define(be[86],Ee([0,1,11]),function(re,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function M(I){return I.scheme===d.Schemas.vscodeRemote?I.authority:void 0}e.getRemoteAuthority=M;function b(I){if(!I)return;const t=I.indexOf("+");return t<0?I:I.substr(0,t)}e.getRemoteName=b;function R(I){return I.scheme!==d.Schemas.file&&I.scheme!==d.Schemas.vscodeRemote}e.isVirtualResource=R;function F(I){if(I.folders.length)return I.folders.every(t=>R(t.uri))?I.folders[0].uri:void 0;if(I.configuration&&R(I.configuration))return I.configuration}e.getVirtualWorkspaceLocation=F;function C(I){return F(I)?.scheme}e.getVirtualWorkspaceScheme=C;function _(I){return F(I)!==void 0}e.isVirtualWorkspace=_}),define(be[149],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class d{constructor(b){this._callback=b,this._terminalBufferMap=new Map}dispose(){for(const b of this._terminalBufferMap.values())b.dispose()}startBuffering(b,R,F=5){let C;return C=R(_=>{const I=typeof _=="string"?_:_.data;let t=this._terminalBufferMap.get(b);if(t){t.data.push(I);return}const E=setTimeout(()=>this.flushBuffer(b),F);t={data:[I],timeoutId:E,dispose:()=>{clearTimeout(E),this.flushBuffer(b),C.dispose()}},this._terminalBufferMap.set(b,t)}),C}stopBuffering(b){const R=this._terminalBufferMap.get(b);R&&R.dispose()}flushBuffer(b){const R=this._terminalBufferMap.get(b);R&&(this._terminalBufferMap.delete(b),this._callback(b,R.data.join("")))}}e.TerminalDataBufferer=d}),define(be[150],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var d;(function(M){M.DARK="dark",M.LIGHT="light",M.HIGH_CONTRAST="hc"})(d=e.ColorScheme||(e.ColorScheme={}))}),define(be[46],Ee([0,1,34,3,6,4,28,150]),function(re,e,d,M,b,R,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,R.createDecorator)("themeService");var _;(function(w){function T(S){return S&&typeof S=="object"&&typeof S.id=="string"}w.isThemeColor=T})(_=e.ThemeColor||(e.ThemeColor={}));function I(w){return{id:w}}e.themeColorFromId=I;var t;(function(w){function T(v){return v&&typeof v=="object"&&typeof v.id=="string"&&(typeof v.color=="undefined"||_.isThemeColor(v.color))}w.isThemeIcon=T;const S=new RegExp(`^\\$\\((${d.CSSIcon.iconNameExpression}(?:${d.CSSIcon.iconModifierExpression})?)\\)$`);function o(v){const r=S.exec(v);if(!r)return;let[,s]=r;return{id:s}}w.fromString=o;function f(v,r){let s=v.id;const l=s.lastIndexOf("~");return l!==-1&&(s=s.substring(0,l)),r&&(s=`${s}~${r}`),{id:s}}w.modify=f;function y(v,r){return v.id===r.id&&v.color?.id===r.color?.id}w.isEqual=y;function i(v,r){return{id:v.id,color:r?I(r):void 0}}w.asThemeIcon=i,w.asClassNameArray=d.CSSIcon.asClassNameArray,w.asClassName=d.CSSIcon.asClassName,w.asCSSSelector=d.CSSIcon.asCSSSelector})(t=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=d.Codicon.file,e.FolderThemeIcon=d.Codicon.folder;function E(w){switch(w){case C.ColorScheme.DARK:return"vs-dark";case C.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=E,e.Extensions={ThemingContribution:"base.contributions.theming"};class n{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new M.Emitter}onColorThemeChange(T){return this.themingParticipants.push(T),this.onThemingParticipantAddedEmitter.fire(T),(0,b.toDisposable)(()=>{const S=this.themingParticipants.indexOf(T);this.themingParticipants.splice(S,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let c=new n;F.Registry.add(e.Extensions.ThemingContribution,c);function u(w){return c.onColorThemeChange(w)}e.registerThemingParticipant=u;class a extends b.Disposable{constructor(T){super();this.themeService=T,this.theme=T.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(S=>this.onThemeChange(S)))}onThemeChange(T){this.theme=T,this.updateStyles()}updateStyles(){}getColor(T,S){let o=this.theme.getColor(T);return o&&S&&(o=S(o,this.theme)),o?o.toString():null}}e.Themable=a}),define(be[151],Ee([0,1,14,34,3,123,83,28,46]),function(re,e,d,M,b,R,F,C,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};class I{constructor(){this._onDidChange=new b.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,R.localize)(0,null)},fontCharacter:{type:"string",description:(0,R.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${M.CSSIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(T,S,o,f){const y=this.iconsById[T];if(y){if(o&&!y.description){y.description=o,this.iconSchema.properties[T].markdownDescription=`${o} $(${T})`;const r=this.iconReferenceSchema.enum.indexOf(T);r!==-1&&(this.iconReferenceSchema.enumDescriptions[r]=o),this._onDidChange.fire()}return y}let i={id:T,description:o,defaults:S,deprecationMessage:f};this.iconsById[T]=i;let v={$ref:"#/definitions/icons"};return f&&(v.deprecationMessage=f),o&&(v.markdownDescription=`${o}: $(${T})`),this.iconSchema.properties[T]=v,this.iconReferenceSchema.enum.push(T),this.iconReferenceSchema.enumDescriptions.push(o||""),this._onDidChange.fire(),{id:T}}deregisterIcon(T){delete this.iconsById[T],delete this.iconSchema.properties[T];const S=this.iconReferenceSchema.enum.indexOf(T);S!==-1&&(this.iconReferenceSchema.enum.splice(S,1),this.iconReferenceSchema.enumDescriptions.splice(S,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(T=>this.iconsById[T])}getIcon(T){return this.iconsById[T]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(T,S){const o=this.iconFontsById[T];if(o)return o;let f={id:T,definition:S};return this.iconFontsById[T]=f,this._onDidChange.fire(),f}deregisterIconFont(T){delete this.iconFontsById[T]}getIconFonts(){return Object.keys(this.iconFontsById).map(T=>this.iconFontsById[T])}getIconFont(T){return this.iconFontsById[T]}toString(){const T=(y,i)=>y.id.localeCompare(i.id),S=y=>{for(;_.ThemeIcon.isThemeIcon(y.defaults);)y=this.iconsById[y.defaults.id];return`codicon codicon-${y?y.id:""}`};let o=[];o.push("| preview     | identifier                        | default codicon ID                | description"),o.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const f=Object.keys(this.iconsById).map(y=>this.iconsById[y]);for(const y of f.filter(i=>!!i.description).sort(T))o.push(`|<i class="${S(y)}"></i>|${y.id}|${_.ThemeIcon.isThemeIcon(y.defaults)?y.defaults.id:y.id}|${y.description||""}|`);o.push("| preview     | identifier                        "),o.push("| ----------- | --------------------------------- |");for(const y of f.filter(i=>!_.ThemeIcon.isThemeIcon(i.defaults)).sort(T))o.push(`|<i class="${S(y)}"></i>|${y.id}|`);return o.join(`
`)}}const t=new I;C.Registry.add(e.Extensions.IconContribution,t);function E(w,T,S,o){return t.registerIcon(w,T,S,o)}e.registerIcon=E;function n(){return t}e.getIconRegistry=n;function c(){for(const w of M.iconRegistry.all)t.registerIcon(w.id,w.definition,w.description);M.iconRegistry.onDidRegister(w=>t.registerIcon(w.id,w.definition,w.description))}c(),e.iconsSchemaId="vscode://schemas/icons";let u=C.Registry.as(F.Extensions.JSONContribution);u.registerSchema(e.iconsSchemaId,t.getIconSchema());const a=new d.RunOnceScheduler(()=>u.notifySchemaChanged(e.iconsSchemaId),200);t.onDidChange(()=>{a.isScheduled()||a.schedule()}),e.widgetClose=E("widget-close",M.Codicon.close,(0,R.localize)(2,null)),e.gotoPreviousLocation=E("goto-previous-location",M.Codicon.arrowUp,(0,R.localize)(3,null)),e.gotoNextLocation=E("goto-next-location",M.Codicon.arrowDown,(0,R.localize)(4,null)),e.syncing=_.ThemeIcon.modify(M.Codicon.sync,"spin")}),define(be[47],Ee([0,1,20,24,2,4]),function(re,e,d,M,b,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,R.createDecorator)("contextService");var F;(function(n){n[n.EMPTY=1]="EMPTY",n[n.FOLDER=2]="FOLDER",n[n.WORKSPACE=3]="WORKSPACE"})(F=e.WorkbenchState||(e.WorkbenchState={}));function C(n){const c=n;return!!(c&&typeof c=="object"&&typeof c.id=="string"&&Array.isArray(c.folders))}e.isWorkspace=C;function _(n){const c=n;return!!(c&&typeof c=="object"&&b.URI.isUri(c.uri)&&typeof c.name=="string"&&typeof c.toResource=="function")}e.isWorkspaceFolder=_;class I{constructor(c,u,a,w){this._id=c,this._configuration=a,this._ignorePathCasing=w,this._foldersMap=d.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=u}update(c){this._id=c.id,this._configuration=c.configuration,this._ignorePathCasing=c._ignorePathCasing,this.folders=c.folders}get folders(){return this._folders}set folders(c){this._folders=c,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(c){this._configuration=c}getFolder(c){return c&&this._foldersMap.findSubstr(c.with({scheme:c.scheme,authority:c.authority,path:c.path}))||null}updateFoldersMap(){this._foldersMap=d.TernarySearchTree.forUris(this._ignorePathCasing);for(const c of this.folders)this._foldersMap.set(c.uri,c)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=I;class t{constructor(c,u){this.raw=u,this.uri=c.uri,this.index=c.index,this.name=c.name}toResource(c){return(0,M.joinPath)(this.uri,c)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=t;function E(n){return new t({uri:n,index:0,name:(0,M.basenameOrAuthority)(n)},{uri:n.toString()})}e.toWorkspaceFolder=E}),define(be[63],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class d{constructor(b){this.id=b,this._data=new Map,this._idPool=1}add(b){const R=this._idPool++;return this._data.set(R,b),this.logDebugInfo(),R}get(b,R){return this._data.has(b)?this._data.get(b)[R]:void 0}delete(b){this._data.delete(b),this.logDebugInfo()}logDebugInfo(){!d.enableDebugLogging||console.log(`${this.id} cache size \u2014 ${this._data.size}`)}}e.Cache=d,d.enableDebugLogging=!1}),define(be[37],Ee([0,1,11,24,4]),function(re,e,d,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class R{constructor(){this._systemSchemes=new Set(Object.keys(d.Schemas)),this._providerInfo=new Map,this.extUri=new M.ExtUri(C=>{const _=this._providerInfo.get(C.scheme);return!(_===void 0||_&1024)})}$acceptProviderInfos(C,_){_===null?this._providerInfo.delete(C):this._providerInfo.set(C,_)}isFreeScheme(C){return!this._providerInfo.has(C)&&!this._systemSchemes.has(C)}getCapabilities(C){return this._providerInfo.get(C)}}e.ExtHostFileSystemInfo=R,e.IExtHostFileSystemInfo=(0,b.createDecorator)("IExtHostFileSystemInfo")}),define(be[29],Ee([0,1,4]),function(re,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,d.createDecorator)("IExtHostInitDataService")}),define(be[152],Ee([0,1,14]),function(re,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class M{constructor(F,C,_){this._deferredPromises=new Map,this._id=F,this._shared=C,this._storage=_,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(I=>(this._value=I,this)),this._storageListener=this._storage.onDidChangeStorage(I=>{I.shared===this._shared&&I.key===this._id&&(this._value=I.value)}),this._scheduler=new d.RunOnceScheduler(()=>{const I=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const t of I.values())t.complete()}catch(t){for(const E of I.values())E.error(t)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,F])=>F!==void 0).map(([F])=>F)}get whenReady(){return this._init}get(F,C){let _=this._value[F];return typeof _=="undefined"&&(_=C),_}update(F,C){this._value[F]=C;let _=this._deferredPromises.get(F);if(_!==void 0)return _.p;const I=new d.DeferredPromise;return this._deferredPromises.set(F,I),this._scheduler.isScheduled()||this._scheduler.schedule(),I.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=M;class b extends M{constructor(F,C){super(F.identifier.value,!0,C);this._extension=F}setKeysForSync(F){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},F)}}e.ExtensionGlobalMemento=b}),define(be[153],Ee([0,1,3,2,15]),function(re,e,d,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;let R=class{constructor(C,_){this._logService=C,this._notebooksAndEditors=_,this._onDidChangeNotebookDocumentMetadata=new d.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidSaveNotebookDocument=new d.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event}$acceptModelChanged(C,_,I){this._notebooksAndEditors.getNotebookDocument(M.URI.revive(C)).acceptModelChanged(_.value,I)}$acceptDirtyStateChanged(C,_){this._notebooksAndEditors.getNotebookDocument(M.URI.revive(C)).acceptDirty(_)}$acceptModelSaved(C){const _=this._notebooksAndEditors.getNotebookDocument(M.URI.revive(C));this._onDidSaveNotebookDocument.fire(_.apiNotebook)}$acceptDocumentPropertiesChanged(C,_){this._logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",C.path,_);const I=this._notebooksAndEditors.getNotebookDocument(M.URI.revive(C));I.acceptDocumentPropertiesChanged(_),_.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:I.apiNotebook})}};R=We([ze(0,b.ILogService)],R),e.ExtHostNotebookDocuments=R}),define(be[13],Ee([0,1,4]),function(re,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,d.createDecorator)("IExtHostRpcService");class M{constructor(R){this.getProxy=R.getProxy.bind(R),this.set=R.set.bind(R),this.assertRegistered=R.assertRegistered.bind(R),this.drain=R.drain.bind(R)}}e.ExtHostRpcService=M});var Ze=this&&this.__classPrivateFieldSet||function(re,e,d,M,b){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!b:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?b.call(re,d):b?b.value=d:e.set(re,d),d},Ae=this&&this.__classPrivateFieldGet||function(re,e,d,M){if(d==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?M:d==="a"?M.call(re):M?M.value:e.get(re)};define(be[154],Ee([0,1,25,3]),function(re,e,d,M){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class R{constructor(C,_){b.set(this,void 0),this._onDidChange=new M.Emitter,this.onDidChange=this._onDidChange.event,this._id=d.ExtensionIdentifier.toKey(C.identifier),Ze(this,b,_,"f"),Ae(this,b,"f").onDidChangePassword(I=>{I.extensionId===this._id&&this._onDidChange.fire({key:I.key})})}get(C){return Ae(this,b,"f").get(this._id,C)}store(C,_){return Ae(this,b,"f").store(this._id,C,_)}delete(C){return Ae(this,b,"f").delete(this._id,C)}}e.ExtensionSecrets=R,b=new WeakMap}),define(be[87],Ee([0,1,4,3]),function(re,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class b{constructor(){this._onDidChangeTelemetryEnabled=new M.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(F){this._enabled=F}$onDidChangeTelemetryEnabled(F){this._enabled=F,this._onDidChangeTelemetryEnabled.fire(F)}}e.ExtHostTelemetry=b,e.IExtHostTelemetry=(0,d.createDecorator)("IExtHostTelemetry")}),define(be[48],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestItemRootImpl=e.TestItemImpl=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.diffTestItems=e.getPrivateApiFor=e.createPrivateApiFor=e.ExtHostTestItemEventOp=void 0;var d;(function(S){S[S.Upsert=0]="Upsert",S[S.RemoveChild=1]="RemoveChild",S[S.Invalidated=2]="Invalidated",S[S.SetProp=3]="SetProp",S[S.Bulk=4]="Bulk"})(d=e.ExtHostTestItemEventOp||(e.ExtHostTestItemEventOp={}));const M=new WeakMap,b=(S,o)=>{const f={controllerId:o};return M.set(S,f),f};e.createPrivateApiFor=b;const R=S=>M.get(S);e.getPrivateApiFor=R;const F=(S,o,f,y)=>{let i=f;return{enumerable:!0,configurable:!1,get(){return i},set(v){if(!y(i,v)){const r=i;i=v,S.listener?.({op:3,key:o,value:v,previous:r})}}}},C=(S,o)=>S===o,_={range:(S,o)=>S===o?!0:!S||!o?!1:S.isEqual(o),label:C,description:C,busy:C,error:C,canResolveChildren:C,tags:(S,o)=>!(S.length!==o.length||S.some(f=>!o.find(y=>f.id===y.id)))},I=Object.keys(_),t=(S,o)=>({range:F(S,"range",void 0,_.range),label:F(S,"label",o,_.label),description:F(S,"description",void 0,_.description),canResolveChildren:F(S,"canResolveChildren",!1,_.canResolveChildren),busy:F(S,"busy",!1,_.busy),error:F(S,"error",void 0,_.error),tags:F(S,"tags",[],_.tags)}),E=(S,o)=>{const f=new Map;for(const y of I)_[y](S[y],o[y])||f.set(y,o[y]);return f};e.diffTestItems=E;class n extends Error{constructor(o){super(`Attempted to insert a duplicate test item ID ${o}`)}}e.DuplicateTestItemError=n;class c extends Error{constructor(o){super(`TestItem with ID "${o}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=c;class u extends Error{constructor(o,f,y){super(`TestItem with ID "${o}" is from controller "${f}" and cannot be added as a child of an item from controller "${y}".`)}}e.MixedTestItemController=u;const a=S=>{const o=(0,e.getPrivateApiFor)(S);let f=new Map;return{get size(){return f.size},forEach(y,i){for(const v of f.values())y.call(i,v,this)},replace(y){const i=new Map,v=new Set(f.keys()),r={op:4,ops:[]};for(const s of y){if(!(s instanceof w))throw new c(s.id);const l=(0,e.getPrivateApiFor)(s).controllerId;if(l!==o.controllerId)throw new u(s.id,l,o.controllerId);if(i.has(s.id))throw new n(s.id);i.set(s.id,s),v.delete(s.id),r.ops.push({op:0,item:s})}for(const s of v.keys())r.ops.push({op:1,id:s});o.listener?.(r),f=i},add(y){if(!(y instanceof w))throw new c(y.id);f.set(y.id,y),o.listener?.({op:0,item:y})},delete(y){f.delete(y)&&o.listener?.({op:1,id:y})},get(y){return f.get(y)},toJSON(){return Array.from(f.values())},[Symbol.iterator](){return f.values()}}};class w{constructor(o,f,y,i){if(f.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(f)} symbol`);const v=(0,e.createPrivateApiFor)(this,o);Object.defineProperties(this,{id:{value:f,enumerable:!0,writable:!1},uri:{value:i,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return v.parent instanceof T?void 0:v.parent}},children:{value:a(this),enumerable:!0,writable:!1},...t(v,y)})}invalidateResults(){(0,e.getPrivateApiFor)(this).listener?.({op:2})}}e.TestItemImpl=w;class T extends w{constructor(o,f){super(o,o,f,void 0)}}e.TestItemRootImpl=T}),define(be[64],Ee([0,1,4,3,13]),function(re,e,d,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var R;(function(C){function _(t){return{remoteAddress:t.remoteAddress,localAddress:t.localAddress,public:!!t.public,protocol:t.protocol}}C.fromApiTunnel=_;function I(t){return{remoteAddress:{host:t.tunnelRemoteHost,port:t.tunnelRemotePort},localAddress:t.localAddress,public:t.public,protocol:t.protocol}}C.fromServiceTunnel=I})(R=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,d.createDecorator)("IExtHostTunnelService");let F=class{constructor(_){this.onDidChangeTunnels=new M.Emitter().event}async $applyCandidateFilter(_){return _}async openTunnel(_,I){}async getTunnels(){return[]}async setTunnelExtensionFunctions(_){return{dispose:()=>{}}}registerPortsAttributesProvider(_,I){return{dispose:()=>{}}}async $providePortAttributes(_,I,t,E,n){return[]}async $forwardPort(_,I){}async $closeTunnel(_){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};F=We([ze(0,b.IExtHostRpcService)],F),e.ExtHostTunnelService=F});var Ze=this&&this.__classPrivateFieldSet||function(re,e,d,M,b){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!b:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?b.call(re,d):b?b.value=d:e.set(re,d),d},Ae=this&&this.__classPrivateFieldGet||function(re,e,d,M){if(d==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?M:d==="a"?M.call(re):M?M.value:e.get(re)};define(be[7],Ee([0,1,12,16,76,20,78,10,2,36,60,85]),function(re,e,d,M,b,R,F,C,_,I,t,E){"use strict";var n,c,u,a,w,T,S,o,f,y,i,v,r,s,l,h,p,k,P,g;Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function D(N){function O(){return Reflect.construct(N,arguments,this.constructor)}return Object.defineProperty(O,"name",Object.getOwnPropertyDescriptor(N,"name")),Object.setPrototypeOf(O,N),Object.setPrototypeOf(O.prototype,N.prototype),O}let m=w=class{constructor(O){n.set(this,void 0),Ze(this,n,O,"f")}static from(...O){let ie=O;return new w(function(){if(ie){for(const _e of ie)_e&&typeof _e.dispose=="function"&&_e.dispose();ie=void 0}})}dispose(){typeof Ae(this,n,"f")=="function"&&(Ae(this,n,"f").call(this),Ze(this,n,void 0,"f"))}};n=new WeakMap,m=w=We([D],m),e.Disposable=m;let A=T=class{constructor(O,ie){if(O<0)throw(0,M.illegalArgument)("line must be non-negative");if(ie<0)throw(0,M.illegalArgument)("character must be non-negative");this._line=O,this._character=ie}static Min(...O){if(O.length===0)throw new TypeError;let ie=O[0];for(let _e=1;_e<O.length;_e++){const Ge=O[_e];Ge.isBefore(ie)&&(ie=Ge)}return ie}static Max(...O){if(O.length===0)throw new TypeError;let ie=O[0];for(let _e=1;_e<O.length;_e++){const Ge=O[_e];Ge.isAfter(ie)&&(ie=Ge)}return ie}static isPosition(O){if(!O)return!1;if(O instanceof T)return!0;let{line:ie,character:_e}=O;return typeof ie=="number"&&typeof _e=="number"}get line(){return this._line}get character(){return this._character}isBefore(O){return this._line<O._line?!0:O._line<this._line?!1:this._character<O._character}isBeforeOrEqual(O){return this._line<O._line?!0:O._line<this._line?!1:this._character<=O._character}isAfter(O){return!this.isBeforeOrEqual(O)}isAfterOrEqual(O){return!this.isBefore(O)}isEqual(O){return this._line===O._line&&this._character===O._character}compareTo(O){return this._line<O._line?-1:this._line>O.line?1:this._character<O._character?-1:this._character>O._character?1:0}translate(O,ie=0){if(O===null||ie===null)throw(0,M.illegalArgument)();let _e;return typeof O=="undefined"?_e=0:typeof O=="number"?_e=O:(_e=typeof O.lineDelta=="number"?O.lineDelta:0,ie=typeof O.characterDelta=="number"?O.characterDelta:0),_e===0&&ie===0?this:new T(this.line+_e,this.character+ie)}with(O,ie=this.character){if(O===null||ie===null)throw(0,M.illegalArgument)();let _e;return typeof O=="undefined"?_e=this.line:typeof O=="number"?_e=O:(_e=typeof O.line=="number"?O.line:this.line,ie=typeof O.character=="number"?O.character:this.character),_e===this.line&&ie===this.character?this:new T(_e,ie)}toJSON(){return{line:this.line,character:this.character}}};A=T=We([D],A),e.Position=A;let L=S=class{constructor(O,ie,_e,Ge){let tt,ot;if(typeof O=="number"&&typeof ie=="number"&&typeof _e=="number"&&typeof Ge=="number"?(tt=new A(O,ie),ot=new A(_e,Ge)):O instanceof A&&ie instanceof A&&(tt=O,ot=ie),!tt||!ot)throw new Error("Invalid arguments");tt.isBefore(ot)?(this._start=tt,this._end=ot):(this._start=ot,this._end=tt)}static isRange(O){return O instanceof S?!0:O?A.isPosition(O.start)&&A.isPosition(O.end):!1}get start(){return this._start}get end(){return this._end}contains(O){return O instanceof S?this.contains(O._start)&&this.contains(O._end):O instanceof A?!(O.isBefore(this._start)||this._end.isBefore(O)):!1}isEqual(O){return this._start.isEqual(O._start)&&this._end.isEqual(O._end)}intersection(O){const ie=A.Max(O.start,this._start),_e=A.Min(O.end,this._end);if(!ie.isAfter(_e))return new S(ie,_e)}union(O){if(this.contains(O))return this;if(O.contains(this))return O;const ie=A.Min(O.start,this._start),_e=A.Max(O.end,this.end);return new S(ie,_e)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(O,ie=this.end){if(O===null||ie===null)throw(0,M.illegalArgument)();let _e;return O?A.isPosition(O)?_e=O:(_e=O.start||this.start,ie=O.end||this.end):_e=this.start,_e.isEqual(this._start)&&ie.isEqual(this.end)?this:new S(_e,ie)}toJSON(){return[this.start,this.end]}};L=S=We([D],L),e.Range=L;let V=o=class extends L{constructor(O,ie,_e,Ge){let tt,ot;if(typeof O=="number"&&typeof ie=="number"&&typeof _e=="number"&&typeof Ge=="number"?(tt=new A(O,ie),ot=new A(_e,Ge)):O instanceof A&&ie instanceof A&&(tt=O,ot=ie),!tt||!ot)throw new Error("Invalid arguments");super(tt,ot);this._anchor=tt,this._active=ot}static isSelection(O){return O instanceof o?!0:O?L.isRange(O)&&A.isPosition(O.anchor)&&A.isPosition(O.active)&&typeof O.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};V=o=We([D],V),e.Selection=V;class G{constructor(O,ie,_e){if(typeof O!="string"||O.length===0)throw(0,M.illegalArgument)("host");if(typeof ie!="number"||ie===0||Math.round(ie)!==ie)throw(0,M.illegalArgument)("port");if(typeof _e!="undefined"&&(typeof _e!="string"||_e.length===0||!/^[0-9A-Za-z\-]+$/.test(_e)))throw(0,M.illegalArgument)("connectionToken");this.host=O,this.port=Math.round(ie),this.connectionToken=_e}}e.ResolvedAuthority=G;class U extends Error{constructor(O,ie=E.RemoteAuthorityResolverErrorCode.Unknown,_e){super(O);this._message=O,this._code=ie,this._detail=_e,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,U.prototype)}static NotAvailable(O,ie){return new U(O,E.RemoteAuthorityResolverErrorCode.NotAvailable,ie)}static TemporarilyNotAvailable(O){return new U(O,E.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=U;var K;(function(N){N[N.LF=1]="LF",N[N.CRLF=2]="CRLF"})(K=e.EndOfLine||(e.EndOfLine={}));var $;(function(N){N[N.Replace=1]="Replace",N[N.Append=2]="Append",N[N.Prepend=3]="Prepend"})($=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let B=f=class{constructor(O,ie){this._range=O,this._newText=ie}static isTextEdit(O){return O instanceof f?!0:O?L.isRange(O)&&typeof O.newText=="string":!1}static replace(O,ie){return new f(O,ie)}static insert(O,ie){return f.replace(new L(O,O),ie)}static delete(O){return f.replace(O,"")}static setEndOfLine(O){const ie=new f(new L(new A(0,0),new A(0,0)),"");return ie.newEol=O,ie}get range(){return this._range}set range(O){if(O&&!L.isRange(O))throw(0,M.illegalArgument)("range");this._range=O}get newText(){return this._newText||""}set newText(O){if(O&&typeof O!="string")throw(0,M.illegalArgument)("newText");this._newText=O}get newEol(){return this._newEol}set newEol(O){if(O&&typeof O!="number")throw(0,M.illegalArgument)("newEol");this._newEol=O}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};B=f=We([D],B),e.TextEdit=B;var z;(function(N){N[N.File=1]="File",N[N.Text=2]="Text",N[N.Cell=3]="Cell",N[N.CellReplace=5]="CellReplace"})(z=e.FileEditType||(e.FileEditType={}));let Y=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(O,ie,_e,Ge){this._edits.push({_type:1,from:O,to:ie,options:_e,metadata:Ge})}createFile(O,ie,_e){this._edits.push({_type:1,from:void 0,to:O,options:ie,metadata:_e})}deleteFile(O,ie,_e){this._edits.push({_type:1,from:O,to:void 0,options:ie,metadata:_e})}replaceNotebookMetadata(O,ie,_e){this._edits.push({_type:3,metadata:_e,uri:O,edit:{editType:5,metadata:ie},notebookMetadata:ie})}replaceNotebookCells(O,ie,_e,Ge,tt){let ot,lt,Dt=[],At;if(Vt.isNotebookRange(ie)&&Mt.isNotebookCellDataArray(_e)&&!Mt.isNotebookCellDataArray(Ge)?(ot=ie.start,lt=ie.end,Dt=_e,At=Ge):typeof ie=="number"&&typeof _e=="number"&&Mt.isNotebookCellDataArray(Ge)&&(ot=ie,lt=_e,Dt=Ge,At=tt),ot===void 0||lt===void 0)throw new Error("Invalid arguments");(ot!==lt||Dt.length>0)&&this._edits.push({_type:5,uri:O,index:ot,count:lt-ot,cells:Dt,metadata:At})}replaceNotebookCellMetadata(O,ie,_e,Ge){this._edits.push({_type:3,metadata:Ge,uri:O,edit:{editType:8,index:ie,metadata:_e}})}replace(O,ie,_e,Ge){this._edits.push({_type:2,uri:O,edit:new B(ie,_e),metadata:Ge})}insert(O,ie,_e,Ge){this.replace(O,new L(ie,ie),_e,Ge)}delete(O,ie,_e){this.replace(O,ie,"",_e)}has(O){return this._edits.some(ie=>ie._type===2&&ie.uri.toString()===O.toString())}set(O,ie){if(ie)for(const _e of ie)_e&&this._edits.push({_type:2,uri:O,edit:_e});else{for(let _e=0;_e<this._edits.length;_e++){const Ge=this._edits[_e];Ge._type===2&&Ge.uri.toString()===O.toString()&&(this._edits[_e]=void 0)}(0,d.coalesceInPlace)(this._edits)}}get(O){const ie=[];for(let _e of this._edits)_e._type===2&&_e.uri.toString()===O.toString()&&ie.push(_e.edit);return ie}entries(){const O=new R.ResourceMap;for(let ie of this._edits)if(ie._type===2){let _e=O.get(ie.uri);_e||(_e=[ie.uri,[]],O.set(ie.uri,_e)),_e[1].push(ie.edit)}return[...O.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};Y=We([D],Y),e.WorkspaceEdit=Y;let ne=y=class{constructor(O){this._tabstop=1,this.value=O||""}static isSnippetString(O){return O instanceof y?!0:O?typeof O.value=="string":!1}static _escape(O){return O.replace(/\$|}|\\/g,"\\$&")}appendText(O){return this.value+=y._escape(O),this}appendTabstop(O=this._tabstop++){return this.value+="$",this.value+=O,this}appendPlaceholder(O,ie=this._tabstop++){if(typeof O=="function"){const _e=new y;_e._tabstop=this._tabstop,O(_e),this._tabstop=_e._tabstop,O=_e.value}else O=y._escape(O);return this.value+="${",this.value+=ie,this.value+=":",this.value+=O,this.value+="}",this}appendChoice(O,ie=this._tabstop++){const _e=O.map(Ge=>Ge.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ie,this.value+="|",this.value+=_e,this.value+="|}",this}appendVariable(O,ie){if(typeof ie=="function"){const _e=new y;_e._tabstop=this._tabstop,ie(_e),this._tabstop=_e._tabstop,ie=_e.value}else typeof ie=="string"&&(ie=ie.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=O,ie&&(this.value+=":",this.value+=ie),this.value+="}",this}};ne=y=We([D],ne),e.SnippetString=ne;var j;(function(N){N[N.Unnecessary=1]="Unnecessary",N[N.Deprecated=2]="Deprecated"})(j=e.DiagnosticTag||(e.DiagnosticTag={}));var le;(function(N){N[N.Hint=3]="Hint",N[N.Information=2]="Information",N[N.Warning=1]="Warning",N[N.Error=0]="Error"})(le=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let se=i=class{constructor(O,ie){if(this.uri=O,ie)if(ie instanceof L)this.range=ie;else if(ie instanceof A)this.range=new L(ie,ie);else throw new Error("Illegal argument")}static isLocation(O){return O instanceof i?!0:O?L.isRange(O.range)&&_.URI.isUri(O.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};se=i=We([D],se),e.Location=se;let ve=class{constructor(O,ie){this.location=O,this.message=ie}static is(O){return O?typeof O.message=="string"&&O.location&&L.isRange(O.location.range)&&_.URI.isUri(O.location.uri):!1}static isEqual(O,ie){return O===ie?!0:!O||!ie?!1:O.message===ie.message&&O.location.range.isEqual(ie.location.range)&&O.location.uri.toString()===ie.location.uri.toString()}};ve=We([D],ve),e.DiagnosticRelatedInformation=ve;let Fe=class{constructor(O,ie,_e=le.Error){if(!L.isRange(O))throw new TypeError("range must be set");if(!ie)throw new TypeError("message must be set");this.range=O,this.message=ie,this.severity=_e}toJSON(){return{severity:le[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(O,ie){return O===ie?!0:!O||!ie?!1:O.message===ie.message&&O.severity===ie.severity&&O.code===ie.code&&O.severity===ie.severity&&O.source===ie.source&&O.range.isEqual(ie.range)&&(0,d.equals)(O.tags,ie.tags)&&(0,d.equals)(O.relatedInformation,ie.relatedInformation,ve.isEqual)}};Fe=We([D],Fe),e.Diagnostic=Fe;let Me=class{constructor(O,ie){if(!O)throw new Error("Illegal argument, contents must be defined");Array.isArray(O)?this.contents=O:this.contents=[O],this.range=ie}};Me=We([D],Me),e.Hover=Me;var Ne;(function(N){N[N.Text=0]="Text",N[N.Read=1]="Read",N[N.Write=2]="Write"})(Ne=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let Ye=class{constructor(O,ie=Ne.Text){this.range=O,this.kind=ie}toJSON(){return{range:this.range,kind:Ne[this.kind]}}};Ye=We([D],Ye),e.DocumentHighlight=Ye;var Ve;(function(N){N[N.File=0]="File",N[N.Module=1]="Module",N[N.Namespace=2]="Namespace",N[N.Package=3]="Package",N[N.Class=4]="Class",N[N.Method=5]="Method",N[N.Property=6]="Property",N[N.Field=7]="Field",N[N.Constructor=8]="Constructor",N[N.Enum=9]="Enum",N[N.Interface=10]="Interface",N[N.Function=11]="Function",N[N.Variable=12]="Variable",N[N.Constant=13]="Constant",N[N.String=14]="String",N[N.Number=15]="Number",N[N.Boolean=16]="Boolean",N[N.Array=17]="Array",N[N.Object=18]="Object",N[N.Key=19]="Key",N[N.Null=20]="Null",N[N.EnumMember=21]="EnumMember",N[N.Struct=22]="Struct",N[N.Event=23]="Event",N[N.Operator=24]="Operator",N[N.TypeParameter=25]="TypeParameter"})(Ve=e.SymbolKind||(e.SymbolKind={}));var qe;(function(N){N[N.Deprecated=1]="Deprecated"})(qe=e.SymbolTag||(e.SymbolTag={}));let x=v=class{constructor(O,ie,_e,Ge,tt){this.name=O,this.kind=ie,this.containerName=tt,typeof _e=="string"&&(this.containerName=_e),Ge instanceof se?this.location=Ge:_e instanceof L&&(this.location=new se(Ge,_e)),v.validate(this)}static validate(O){if(!O.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:Ve[this.kind],location:this.location,containerName:this.containerName}}};x=v=We([D],x),e.SymbolInformation=x;let Q=r=class{constructor(O,ie,_e,Ge,tt){this.name=O,this.detail=ie,this.kind=_e,this.range=Ge,this.selectionRange=tt,this.children=[],r.validate(this)}static validate(O){if(!O.name)throw new Error("name must not be falsy");if(!O.range.contains(O.selectionRange))throw new Error("selectionRange must be contained in fullRange");O.children&&O.children.forEach(r.validate)}};Q=r=We([D],Q),e.DocumentSymbol=Q;var te;(function(N){N[N.Invoke=1]="Invoke",N[N.Automatic=2]="Automatic"})(te=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let ae=class{constructor(O,ie){this.title=O,this.kind=ie}};ae=We([D],ae),e.CodeAction=ae;let q=s=class{constructor(O){this.value=O}append(O){return new s(this.value?this.value+s.sep+O:O)}intersects(O){return this.contains(O)||O.contains(this)}contains(O){return this.value===O.value||O.value.startsWith(this.value+s.sep)}};q.sep=".",q=s=We([D],q),e.CodeActionKind=q,q.Empty=new q(""),q.QuickFix=q.Empty.append("quickfix"),q.Refactor=q.Empty.append("refactor"),q.RefactorExtract=q.Refactor.append("extract"),q.RefactorInline=q.Refactor.append("inline"),q.RefactorRewrite=q.Refactor.append("rewrite"),q.Source=q.Empty.append("source"),q.SourceOrganizeImports=q.Source.append("organizeImports"),q.SourceFixAll=q.Source.append("fixAll");let oe=class{constructor(O,ie){if(this.range=O,this.parent=ie,ie&&!ie.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};oe=We([D],oe),e.SelectionRange=oe;class he{constructor(O,ie,_e,Ge,tt,ot){this.kind=O,this.name=ie,this.detail=_e,this.uri=Ge,this.range=tt,this.selectionRange=ot}}e.CallHierarchyItem=he;class Te{constructor(O,ie){this.fromRanges=ie,this.from=O}}e.CallHierarchyIncomingCall=Te;class Ue{constructor(O,ie){this.fromRanges=ie,this.to=O}}e.CallHierarchyOutgoingCall=Ue;var He;(function(N){N[N.Information=0]="Information",N[N.Warning=1]="Warning",N[N.Error=2]="Error"})(He=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let Ke=class{constructor(O,ie){this.range=O,this.command=ie}get isResolved(){return!!this.command}};Ke=We([D],Ke),e.CodeLens=Ke;let ye=l=class{constructor(O,ie=!1){c.set(this,void 0),Ze(this,c,new b.MarkdownString(O,{supportThemeIcons:ie}),"f")}static isMarkdownString(O){return O instanceof l?!0:O&&O.appendCodeblock&&O.appendMarkdown&&O.appendText&&O.value!==void 0}get value(){return Ae(this,c,"f").value}set value(O){Ae(this,c,"f").value=O}get isTrusted(){return Ae(this,c,"f").isTrusted}set isTrusted(O){Ae(this,c,"f").isTrusted=O}get supportThemeIcons(){return Ae(this,c,"f").supportThemeIcons}set supportThemeIcons(O){Ae(this,c,"f").supportThemeIcons=O}get supportHtml(){return Ae(this,c,"f").supportHtml}set supportHtml(O){Ae(this,c,"f").supportHtml=O}appendText(O){return Ae(this,c,"f").appendText(O),this}appendMarkdown(O){return Ae(this,c,"f").appendMarkdown(O),this}appendCodeblock(O,ie){return Ae(this,c,"f").appendCodeblock(ie??"",O),this}};c=new WeakMap,ye=l=We([D],ye),e.MarkdownString=ye;let nt=class{constructor(O,ie){this.label=O,this.documentation=ie}};nt=We([D],nt),e.ParameterInformation=nt;let H=class{constructor(O,ie){this.label=O,this.documentation=ie,this.parameters=[]}};H=We([D],H),e.SignatureInformation=H;let X=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};X=We([D],X),e.SignatureHelp=X;var fe;(function(N){N[N.Invoke=1]="Invoke",N[N.TriggerCharacter=2]="TriggerCharacter",N[N.ContentChange=3]="ContentChange"})(fe=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var xe;(function(N){N[N.Other=0]="Other",N[N.Type=1]="Type",N[N.Parameter=2]="Parameter"})(xe=e.InlayHintKind||(e.InlayHintKind={}));let Qe=class{constructor(O,ie,_e){this.text=O,this.position=ie,this.kind=_e}};Qe=We([D],Qe),e.InlayHint=Qe;var rt;(function(N){N[N.Invoke=0]="Invoke",N[N.TriggerCharacter=1]="TriggerCharacter",N[N.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(rt=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var ct;(function(N){N[N.Text=0]="Text",N[N.Method=1]="Method",N[N.Function=2]="Function",N[N.Constructor=3]="Constructor",N[N.Field=4]="Field",N[N.Variable=5]="Variable",N[N.Class=6]="Class",N[N.Interface=7]="Interface",N[N.Module=8]="Module",N[N.Property=9]="Property",N[N.Unit=10]="Unit",N[N.Value=11]="Value",N[N.Enum=12]="Enum",N[N.Keyword=13]="Keyword",N[N.Snippet=14]="Snippet",N[N.Color=15]="Color",N[N.File=16]="File",N[N.Reference=17]="Reference",N[N.Folder=18]="Folder",N[N.EnumMember=19]="EnumMember",N[N.Constant=20]="Constant",N[N.Struct=21]="Struct",N[N.Event=22]="Event",N[N.Operator=23]="Operator",N[N.TypeParameter=24]="TypeParameter",N[N.User=25]="User",N[N.Issue=26]="Issue"})(ct=e.CompletionItemKind||(e.CompletionItemKind={}));var ft;(function(N){N[N.Deprecated=1]="Deprecated"})(ft=e.CompletionItemTag||(e.CompletionItemTag={}));let Pt=class{constructor(O,ie){this.label=O,this.kind=ie}toJSON(){return{label:this.label,kind:this.kind&&ct[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Pt=We([D],Pt),e.CompletionItem=Pt;let mt=class{constructor(O=[],ie=!1){this.items=O,this.isIncomplete=ie}};mt=We([D],mt),e.CompletionList=mt;let St=class{constructor(O,ie,_e){this.text=O,this.range=ie,this.command=_e}};St=We([D],St),e.InlineSuggestion=St;let Ct=class{constructor(O){this.items=O}};Ct=We([D],Ct),e.InlineSuggestions=Ct;var pt;(function(N){N[N.Active=-1]="Active",N[N.Beside=-2]="Beside",N[N.One=1]="One",N[N.Two=2]="Two",N[N.Three=3]="Three",N[N.Four=4]="Four",N[N.Five=5]="Five",N[N.Six=6]="Six",N[N.Seven=7]="Seven",N[N.Eight=8]="Eight",N[N.Nine=9]="Nine"})(pt=e.ViewColumn||(e.ViewColumn={}));var Xe;(function(N){N[N.Left=1]="Left",N[N.Right=2]="Right"})(Xe=e.StatusBarAlignment||(e.StatusBarAlignment={}));var _t;(function(N){N[N.Off=0]="Off",N[N.On=1]="On",N[N.Relative=2]="Relative"})(_t=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Pe;(function(N){N[N.Manual=1]="Manual",N[N.AfterDelay=2]="AfterDelay",N[N.FocusOut=3]="FocusOut"})(Pe=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Se;(function(N){N[N.Default=0]="Default",N[N.InCenter=1]="InCenter",N[N.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",N[N.AtTop=3]="AtTop"})(Se=e.TextEditorRevealType||(e.TextEditorRevealType={}));var De;(function(N){N[N.Keyboard=1]="Keyboard",N[N.Mouse=2]="Mouse",N[N.Command=3]="Command"})(De=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var ee;(function(N){N[N.Undo=1]="Undo",N[N.Redo=2]="Redo"})(ee=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var ue;(function(N){N[N.OpenOpen=0]="OpenOpen",N[N.ClosedClosed=1]="ClosedClosed",N[N.OpenClosed=2]="OpenClosed",N[N.ClosedOpen=3]="ClosedOpen"})(ue=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(N){function O(ie){switch(ie){case"keyboard":return N.Keyboard;case"mouse":return N.Mouse;case"api":return N.Command}}N.fromValue=O}(De=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let pe=class{constructor(O,ie){if(ie&&!_.URI.isUri(ie))throw(0,M.illegalArgument)("target");if(!L.isRange(O)||O.isEmpty)throw(0,M.illegalArgument)("range");this.range=O,this.target=ie}};pe=We([D],pe),e.DocumentLink=pe;let me=class{constructor(O,ie,_e,Ge){this.red=O,this.green=ie,this.blue=_e,this.alpha=Ge}};me=We([D],me),e.Color=me;let Ie=class{constructor(O,ie){if(ie&&!(ie instanceof me))throw(0,M.illegalArgument)("color");if(!L.isRange(O)||O.isEmpty)throw(0,M.illegalArgument)("range");this.range=O,this.color=ie}};Ie=We([D],Ie),e.ColorInformation=Ie;let Be=class{constructor(O){if(!O||typeof O!="string")throw(0,M.illegalArgument)("label");this.label=O}};Be=We([D],Be),e.ColorPresentation=Be;var Oe;(function(N){N[N.RGB=0]="RGB",N[N.HEX=1]="HEX",N[N.HSL=2]="HSL"})(Oe=e.ColorFormat||(e.ColorFormat={}));var je;(function(N){N[N.Error=0]="Error",N[N.Warning=1]="Warning",N[N.Information=2]="Information"})(je=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class et{constructor(O,ie,_e){if(this.startIndex=O,this.length=ie,this.tooltip=_e,typeof O!="number"||O<0)throw(0,M.illegalArgument)("startIndex");if(typeof ie!="number"||ie<1)throw(0,M.illegalArgument)("length");if(_e!==void 0&&typeof _e!="string")throw(0,M.illegalArgument)("tooltip")}}e.TerminalLink=et;var Le;(function(N){N[N.Panel=1]="Panel",N[N.Editor=2]="Editor"})(Le=e.TerminalLocation||(e.TerminalLocation={}));class de{constructor(O){this.options=O,typeof O!="object"&&(0,M.illegalArgument)("options")}}e.TerminalProfile=de;var ge;(function(N){N[N.Always=1]="Always",N[N.Silent=2]="Silent",N[N.Never=3]="Never"})(ge=e.TaskRevealKind||(e.TaskRevealKind={}));var J;(function(N){N[N.Shared=1]="Shared",N[N.Dedicated=2]="Dedicated",N[N.New=3]="New"})(J=e.TaskPanelKind||(e.TaskPanelKind={}));let W=h=class{constructor(O,ie){if(this.label=ie,typeof O!="string"||typeof ie!="string")throw(0,M.illegalArgument)("name");this._id=O}static from(O){switch(O){case"clean":return h.Clean;case"build":return h.Build;case"rebuild":return h.Rebuild;case"test":return h.Test;default:return}}get id(){return this._id}};W.Clean=new h("clean","Clean"),W.Build=new h("build","Build"),W.Rebuild=new h("rebuild","Rebuild"),W.Test=new h("test","Test"),W=h=We([D],W),e.TaskGroup=W;function we(N){let O="";for(let ie=0;ie<N.length;ie++)O+=N[ie].replace(/,/g,",,")+",";return O}let ke=class{constructor(O,ie,_e){if(typeof O!="string")throw(0,M.illegalArgument)("process");this._args=[],this._process=O,ie!==void 0&&(Array.isArray(ie)?(this._args=ie,this._options=_e):this._options=ie)}get process(){return this._process}set process(O){if(typeof O!="string")throw(0,M.illegalArgument)("process");this._process=O}get args(){return this._args}set args(O){Array.isArray(O)||(O=[]),this._args=O}get options(){return this._options}set options(O){this._options=O}computeId(){const O=[];if(O.push("process"),this._process!==void 0&&O.push(this._process),this._args&&this._args.length>0)for(let ie of this._args)O.push(ie);return we(O)}};ke=We([D],ke),e.ProcessExecution=ke;let Je=class{constructor(O,ie,_e){if(this._args=[],Array.isArray(ie)){if(!O)throw(0,M.illegalArgument)("command can't be undefined or null");if(typeof O!="string"&&typeof O.value!="string")throw(0,M.illegalArgument)("command");this._command=O,this._args=ie,this._options=_e}else{if(typeof O!="string")throw(0,M.illegalArgument)("commandLine");this._commandLine=O,this._options=ie}}get commandLine(){return this._commandLine}set commandLine(O){if(typeof O!="string")throw(0,M.illegalArgument)("commandLine");this._commandLine=O}get command(){return this._command?this._command:""}set command(O){if(typeof O!="string"&&typeof O.value!="string")throw(0,M.illegalArgument)("command");this._command=O}get args(){return this._args}set args(O){this._args=O||[]}get options(){return this._options}set options(O){this._options=O}computeId(){const O=[];if(O.push("shell"),this._commandLine!==void 0&&O.push(this._commandLine),this._command!==void 0&&O.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let ie of this._args)O.push(typeof ie=="string"?ie:ie.value);return we(O)}};Je=We([D],Je),e.ShellExecution=Je;var $e;(function(N){N[N.Escape=1]="Escape",N[N.Strong=2]="Strong",N[N.Weak=3]="Weak"})($e=e.ShellQuoting||(e.ShellQuoting={}));var ut;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace"})(ut=e.TaskScope||(e.TaskScope={}));class gt{constructor(O){this._callback=O}computeId(){return"customExecution"+(0,I.generateUuid)()}set callback(O){this._callback=O}get callback(){return this._callback}}e.CustomExecution=gt;let at=p=class{constructor(O,ie,_e,Ge,tt,ot){this.__deprecated=!1,this._definition=this.definition=O;let lt;typeof ie=="string"?(this._name=this.name=ie,this._source=this.source=_e,this.execution=Ge,lt=tt,this.__deprecated=!0):ie===ut.Global||ie===ut.Workspace?(this.target=ie,this._name=this.name=_e,this._source=this.source=Ge,this.execution=tt,lt=ot):(this.target=ie,this._name=this.name=_e,this._source=this.source=Ge,this.execution=tt,lt=ot),typeof lt=="string"?(this._problemMatchers=[lt],this._hasDefinedMatchers=!0):Array.isArray(lt)?(this._problemMatchers=lt,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(O){this.__id=O}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof ke?this._definition={type:p.ProcessType,id:this._execution.computeId()}:this._execution instanceof Je?this._definition={type:p.ShellType,id:this._execution.computeId()}:this._execution instanceof gt?this._definition={type:p.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:p.EmptyType,id:(0,I.generateUuid)()}}get definition(){return this._definition}set definition(O){if(O==null)throw(0,M.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=O}get scope(){return this._scope}set target(O){this.clear(),this._scope=O}get name(){return this._name}set name(O){if(typeof O!="string")throw(0,M.illegalArgument)("name");this.clear(),this._name=O}get execution(){return this._execution}set execution(O){O===null&&(O=void 0),this.clear(),this._execution=O;const ie=this._definition.type;(p.EmptyType===ie||p.ProcessType===ie||p.ShellType===ie||p.ExtensionCallbackType===ie)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(O){if(Array.isArray(O))this.clear(),this._problemMatchers=O,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(O){O!==!0&&O!==!1&&(O=!1),this.clear(),this._isBackground=O}get source(){return this._source}set source(O){if(typeof O!="string"||O.length===0)throw(0,M.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=O}get group(){return this._group}set group(O){O===null&&(O=void 0),this.clear(),this._group=O}get detail(){return this._detail}set detail(O){O===null&&(O=void 0),this._detail=O}get presentationOptions(){return this._presentationOptions}set presentationOptions(O){O==null&&(O=Object.create(null)),this.clear(),this._presentationOptions=O}get runOptions(){return this._runOptions}set runOptions(O){O==null&&(O=Object.create(null)),this.clear(),this._runOptions=O}};at.ExtensionCallbackType="customExecution",at.ProcessType="process",at.ShellType="shell",at.EmptyType="$empty",at=p=We([D],at),e.Task=at;var dt;(function(N){N[N.SourceControl=1]="SourceControl",N[N.Window=10]="Window",N[N.Notification=15]="Notification"})(dt=e.ProgressLocation||(e.ProgressLocation={}));let st=class{constructor(O,ie=Et.None){this.collapsibleState=ie,_.URI.isUri(O)?this.resourceUri=O:this.label=O}};st=We([D],st),e.TreeItem=st;var Et;(function(N){N[N.None=0]="None",N[N.Collapsed=1]="Collapsed",N[N.Expanded=2]="Expanded"})(Et=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let yt=class{constructor(O,ie){this.id=O,this.color=ie}};yt=We([D],yt),e.ThemeIcon=yt,yt.File=new yt("file"),yt.Folder=new yt("folder");let Ut=class{constructor(O){this.id=O}};Ut=We([D],Ut),e.ThemeColor=Ut;var $t;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace",N[N.WorkspaceFolder=3]="WorkspaceFolder"})($t=e.ConfigurationTarget||(e.ConfigurationTarget={}));let It=class{constructor(O,ie){if(typeof O!="string"&&(!O||!_.URI.isUri(O)&&!_.URI.isUri(O.uri)))throw(0,M.illegalArgument)("base");if(typeof ie!="string")throw(0,M.illegalArgument)("pattern");typeof O=="string"?(this.baseFolder=_.URI.file(O),this.base=O):_.URI.isUri(O)?(this.baseFolder=O,this.base=O.fsPath):(this.baseFolder=O.uri,this.base=O.uri.fsPath),this.pattern=ie}};It=We([D],It),e.RelativePattern=It;let Wt=class{constructor(O,ie,_e,Ge){this.enabled=typeof O=="boolean"?O:!0,typeof ie=="string"&&(this.condition=ie),typeof _e=="string"&&(this.hitCondition=_e),typeof Ge=="string"&&(this.logMessage=Ge)}get id(){return this._id||(this._id=(0,I.generateUuid)()),this._id}};Wt=We([D],Wt),e.Breakpoint=Wt;let ei=class extends Wt{constructor(O,ie,_e,Ge,tt){super(ie,_e,Ge,tt);if(O===null)throw(0,M.illegalArgument)("location");this.location=O}};ei=We([D],ei),e.SourceBreakpoint=ei;let vt=class extends Wt{constructor(O,ie,_e,Ge,tt){super(ie,_e,Ge,tt);this.functionName=O}};vt=We([D],vt),e.FunctionBreakpoint=vt;let Qt=class extends Wt{constructor(O,ie,_e,Ge,tt,ot,lt){super(Ge,tt,ot,lt);if(!ie)throw(0,M.illegalArgument)("dataId");this.label=O,this.dataId=ie,this.canPersist=_e}};Qt=We([D],Qt),e.DataBreakpoint=Qt;let jt=class{constructor(O,ie,_e){this.command=O,this.args=ie||[],this.options=_e}};jt=We([D],jt),e.DebugAdapterExecutable=jt;let ti=class{constructor(O,ie){this.port=O,this.host=ie}};ti=We([D],ti),e.DebugAdapterServer=ti;let ii=class{constructor(O){this.path=O}};ii=We([D],ii),e.DebugAdapterNamedPipeServer=ii;let Tt=class{constructor(O){this.implementation=O}};Tt=We([D],Tt),e.DebugAdapterInlineImplementation=Tt;let Yt=class{constructor(O,ie){this.range=O,this.expression=ie}};Yt=We([D],Yt),e.EvaluatableExpression=Yt;var wi;(function(N){N[N.Automatic=0]="Automatic",N[N.Explicit=1]="Explicit"})(wi=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let Ht=class{constructor(O,ie){this.range=O,this.text=ie}};Ht=We([D],Ht),e.InlineValueText=Ht;let zt=class{constructor(O,ie,_e=!0){this.range=O,this.variableName=ie,this.caseSensitiveLookup=_e}};zt=We([D],zt),e.InlineValueVariableLookup=zt;let ht=class{constructor(O,ie){this.range=O,this.expression=ie}};ht=We([D],ht),e.InlineValueEvaluatableExpression=ht;let ni=class{constructor(O,ie){this.frameId=O,this.stoppedLocation=ie}};ni=We([D],ni),e.InlineValueContext=ni;var Ot;(function(N){N[N.Changed=1]="Changed",N[N.Created=2]="Created",N[N.Deleted=3]="Deleted"})(Ot=e.FileChangeType||(e.FileChangeType={}));let Nt=k=class extends Error{constructor(O,ie=t.FileSystemProviderErrorCode.Unknown,_e){super(_.URI.isUri(O)?O.toString(!0):O);this.code=_e?.name??"Unknown",(0,t.markAsFileSystemProviderError)(this,ie),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,k.prototype),typeof Error.captureStackTrace=="function"&&typeof _e=="function"&&Error.captureStackTrace(this,_e)}static FileExists(O){return new k(O,t.FileSystemProviderErrorCode.FileExists,k.FileExists)}static FileNotFound(O){return new k(O,t.FileSystemProviderErrorCode.FileNotFound,k.FileNotFound)}static FileNotADirectory(O){return new k(O,t.FileSystemProviderErrorCode.FileNotADirectory,k.FileNotADirectory)}static FileIsADirectory(O){return new k(O,t.FileSystemProviderErrorCode.FileIsADirectory,k.FileIsADirectory)}static NoPermissions(O){return new k(O,t.FileSystemProviderErrorCode.NoPermissions,k.NoPermissions)}static Unavailable(O){return new k(O,t.FileSystemProviderErrorCode.Unavailable,k.Unavailable)}};Nt=k=We([D],Nt),e.FileSystemError=Nt;let Jt=class{constructor(O,ie,_e){this.start=O,this.end=ie,this.kind=_e}};Jt=We([D],Jt),e.FoldingRange=Jt;var bi;(function(N){N[N.Comment=1]="Comment",N[N.Imports=2]="Imports",N[N.Region=3]="Region"})(bi=e.FoldingRangeKind||(e.FoldingRangeKind={}));var hi;(function(N){N[N.Collapsed=0]="Collapsed",N[N.Expanded=1]="Expanded"})(hi=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var Ei;(function(N){N[N.Editing=0]="Editing",N[N.Preview=1]="Preview"})(Ei=e.CommentMode||(e.CommentMode={}));class fi{constructor(O,ie=[]){this.tokenTypes=O,this.tokenModifiers=ie}}e.SemanticTokensLegend=fi;function ri(N){return typeof N=="undefined"||(0,C.isStringArray)(N)}class si{constructor(O){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,O){this._hasLegend=!0;for(let ie=0,_e=O.tokenTypes.length;ie<_e;ie++)this._tokenTypeStrToInt.set(O.tokenTypes[ie],ie);for(let ie=0,_e=O.tokenModifiers.length;ie<_e;ie++)this._tokenModifierStrToInt.set(O.tokenModifiers[ie],ie)}}push(O,ie,_e,Ge,tt){if(typeof O=="number"&&typeof ie=="number"&&typeof _e=="number"&&typeof Ge=="number"&&(typeof tt=="number"||typeof tt=="undefined"))return typeof tt=="undefined"&&(tt=0),this._pushEncoded(O,ie,_e,Ge,tt);if(L.isRange(O)&&typeof ie=="string"&&ri(_e))return this._push(O,ie,_e);throw(0,M.illegalArgument)()}_push(O,ie,_e){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(O.start.line!==O.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(ie))throw new Error("`tokenType` is not in the provided legend");const Ge=O.start.line,tt=O.start.character,ot=O.end.character-O.start.character,lt=this._tokenTypeStrToInt.get(ie);let Dt=0;if(_e)for(const At of _e){if(!this._tokenModifierStrToInt.has(At))throw new Error("`tokenModifier` is not in the provided legend");const Ft=this._tokenModifierStrToInt.get(At);Dt|=1<<Ft>>>0}this._pushEncoded(Ge,tt,ot,lt,Dt)}_pushEncoded(O,ie,_e,Ge,tt){if(this._dataIsSortedAndDeltaEncoded&&(O<this._prevLine||O===this._prevLine&&ie<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const Dt=this._data.length/5|0;let At=0,Ft=0;for(let Lt=0;Lt<Dt;Lt++){let xt=this._data[5*Lt],ci=this._data[5*Lt+1];xt===0?(xt=At,ci+=Ft):xt+=At,this._data[5*Lt]=xt,this._data[5*Lt+1]=ci,At=xt,Ft=ci}}let ot=O,lt=ie;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(ot-=this._prevLine,ot===0&&(lt-=this._prevChar)),this._data[this._dataLen++]=ot,this._data[this._dataLen++]=lt,this._data[this._dataLen++]=_e,this._data[this._dataLen++]=Ge,this._data[this._dataLen++]=tt,this._prevLine=O,this._prevChar=ie}static _sortAndDeltaEncode(O){let ie=[];const _e=O.length/5|0;for(let lt=0;lt<_e;lt++)ie[lt]=lt;ie.sort((lt,Dt)=>{const At=O[5*lt],Ft=O[5*Dt];if(At===Ft){const Lt=O[5*lt+1],xt=O[5*Dt+1];return Lt-xt}return At-Ft});const Ge=new Uint32Array(O.length);let tt=0,ot=0;for(let lt=0;lt<_e;lt++){const Dt=5*ie[lt],At=O[Dt+0],Ft=O[Dt+1],Lt=O[Dt+2],xt=O[Dt+3],ci=O[Dt+4],xi=At-tt,qi=xi===0?Ft-ot:Ft,di=5*lt;Ge[di+0]=xi,Ge[di+1]=qi,Ge[di+2]=Lt,Ge[di+3]=xt,Ge[di+4]=ci,tt=At,ot=Ft}return Ge}build(O){return this._dataIsSortedAndDeltaEncoded?new qt(new Uint32Array(this._data),O):new qt(si._sortAndDeltaEncode(this._data),O)}}e.SemanticTokensBuilder=si;class qt{constructor(O,ie){this.resultId=ie,this.data=O}}e.SemanticTokens=qt;class oi{constructor(O,ie,_e){this.start=O,this.deleteCount=ie,this.data=_e}}e.SemanticTokensEdit=oi;class _i{constructor(O,ie){this.resultId=ie,this.edits=O}}e.SemanticTokensEdits=_i;var yi;(function(N){N[N.Separate=0]="Separate",N[N.MergeWithParent=1]="MergeWithParent"})(yi=e.DebugConsoleMode||(e.DebugConsoleMode={}));var Gt;(function(N){N[N.Initial=1]="Initial",N[N.Dynamic=2]="Dynamic"})(Gt=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let Xt=class{constructor(){}};Xt.Back={iconPath:new yt("arrow-left")},Xt=We([D],Xt),e.QuickInputButtons=Xt;var Si;(function(N){N[N.UI=1]="UI",N[N.Workspace=2]="Workspace"})(Si=e.ExtensionKind||(e.ExtensionKind={}));class Di{constructor(O,ie,_e){this.badge=O,this.tooltip=ie,this.color=_e}static validate(O){if(O.badge&&O.badge.length!==1&&O.badge.length!==2)throw new Error("The 'badge'-property must be undefined or a short character");if(!O.color&&!O.badge&&!O.tooltip)throw new Error("The decoration is empty")}}e.FileDecoration=Di;let ai=class{constructor(O){this.kind=O}};ai=We([D],ai),e.ColorTheme=ai;var li;(function(N){N[N.Light=1]="Light",N[N.Dark=2]="Dark",N[N.HighContrast=3]="HighContrast"})(li=e.ColorThemeKind||(e.ColorThemeKind={}));class Vt{constructor(O,ie){if(O<0)throw(0,M.illegalArgument)("start must be positive");if(ie<0)throw(0,M.illegalArgument)("end must be positive");O<=ie?(this._start=O,this._end=ie):(this._start=ie,this._end=O)}static isNotebookRange(O){return O instanceof Vt?!0:O?typeof O.start=="number"&&typeof O.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(O){let ie=this._start,_e=this._end;return O.start!==void 0&&(ie=O.start),O.end!==void 0&&(_e=O.end),ie===this._start&&_e===this._end?this:new Vt(ie,_e)}}e.NotebookRange=Vt;class Mt{constructor(O,ie,_e,Ge,tt,ot,lt){this.kind=O,this.value=ie,this.languageId=_e,this.mime=Ge,this.outputs=tt??[],this.metadata=ot,this.executionSummary=lt,Mt.validate(this)}static validate(O){if(typeof O.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof O.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof O.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(O){return Array.isArray(O)&&O.every(ie=>Mt.isNotebookCellData(ie))}static isNotebookCellData(O){return!0}}e.NotebookCellData=Mt;class Re{constructor(O){this.cells=O}}e.NotebookData=Re;class Rt{constructor(O,ie){this.data=O,this.mime=ie;const _e=(0,F.normalizeMimeType)(ie,!0);if(!_e)throw new Error(`INVALID mime type: ${ie}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=_e}static isNotebookCellOutputItem(O){return O instanceof Rt?!0:O?typeof O.mime=="string"&&O.data instanceof Uint8Array:!1}static error(O){const ie={name:O.name,message:O.message,stack:O.stack};return Rt.json(ie,"application/vnd.code.notebook.error")}static stdout(O){return Rt.text(O,"application/vnd.code.notebook.stdout")}static stderr(O){return Rt.text(O,"application/vnd.code.notebook.stderr")}static bytes(O,ie="application/octet-stream"){return new Rt(O,ie)}static text(O,ie=F.Mimes.text){const _e=Ae(Rt,u,"f",a).encode(String(O));return new Rt(_e,ie)}static json(O,ie="application/json"){const _e=JSON.stringify(O,void 0,"	");return Rt.text(_e,ie)}}e.NotebookCellOutputItem=Rt,u=Rt,a={value:new TextEncoder};class Kt{constructor(O,ie,_e){this.items=Kt.ensureUniqueMimeTypes(O,!0),typeof ie=="string"?(this.id=ie,this.metadata=_e):(this.id=(0,I.generateUuid)(),this.metadata=ie??_e)}static isNotebookCellOutput(O){return O instanceof Kt?!0:!O||typeof O!="object"?!1:typeof O.id=="string"&&(0,C.isArray)(O.items)}static ensureUniqueMimeTypes(O,ie=!1){const _e=new Set,Ge=new Set;for(let tt=0;tt<O.length;tt++){const ot=O[tt],lt=(0,F.normalizeMimeType)(ot.mime);if(!_e.has(lt)){_e.add(lt);continue}Ge.add(tt),ie&&console.warn(`DUPLICATED mime type '${ot.mime}' will be dropped`)}return Ge.size===0?O:O.filter((tt,ot)=>!Ge.has(ot))}}e.NotebookCellOutput=Kt;var wt;(function(N){N[N.Markup=1]="Markup",N[N.Code=2]="Code"})(wt=e.NotebookCellKind||(e.NotebookCellKind={}));var Ci;(function(N){N[N.Idle=1]="Idle",N[N.Pending=2]="Pending",N[N.Executing=3]="Executing"})(Ci=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var ki;(function(N){N[N.Left=1]="Left",N[N.Right=2]="Right"})(ki=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var mi;(function(N){N[N.Default=0]="Default",N[N.InCenter=1]="InCenter",N[N.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",N[N.AtTop=3]="AtTop"})(mi=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class gi{constructor(O,ie){this.text=O,this.alignment=ie}}e.NotebookCellStatusBarItem=gi;var Ii;(function(N){N[N.Default=1]="Default",N[N.Preferred=2]="Preferred"})(Ii=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class Pi{constructor(O,ie=[]){this.uri=O,this.provides=(0,d.asArray)(ie)}}e.NotebookRendererScript=Pi;let ui=class{constructor(O,ie){this.label=O,this.timestamp=ie}};ui=We([D],ui),e.TimelineItem=ui;var Ti;(function(N){N[N.Production=1]="Production",N[N.Development=2]="Development",N[N.Test=3]="Test"})(Ti=e.ExtensionMode||(e.ExtensionMode={}));var pi;(function(N){N[N.Node=1]="Node",N[N.Webworker=2]="Webworker"})(pi=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Ai;(function(N){N[N.Other=0]="Other",N[N.Comment=1]="Comment",N[N.String=2]="String",N[N.RegEx=4]="RegEx"})(Ai=e.StandardTokenType||(e.StandardTokenType={}));class Ri{constructor(O,ie){this.ranges=O,this.wordPattern=ie}}e.LinkedEditingRanges=Ri;class Fi{constructor(O,ie){this._port=O,this._autoForwardAction=ie}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Fi;var Mi;(function(N){N[N.Queued=1]="Queued",N[N.Running=2]="Running",N[N.Passed=3]="Passed",N[N.Failed=4]="Failed",N[N.Skipped=5]="Skipped",N[N.Errored=6]="Errored"})(Mi=e.TestResultState||(e.TestResultState={}));var Li;(function(N){N[N.Run=1]="Run",N[N.Debug=2]="Debug",N[N.Coverage=3]="Coverage"})(Li=e.TestRunProfileKind||(e.TestRunProfileKind={}));let Z=class{constructor(O,ie,_e){this.include=O,this.exclude=ie,this.profile=_e}};Z=We([D],Z),e.TestRunRequest=Z;let ce=P=class{constructor(O){this.message=O}static diff(O,ie,_e){const Ge=new P(O);return Ge.expectedOutput=ie,Ge.actualOutput=_e,Ge}};ce=P=We([D],ce),e.TestMessage=ce;let Ce=class{constructor(O){this.id=O}};Ce=We([D],Ce),e.TestTag=Ce;let it=class{constructor(O,ie){this.covered=O,this.total=ie}};it=We([D],it),e.CoveredCount=it;let bt=g=class{constructor(O,ie,_e,Ge){this.uri=O,this.statementCoverage=ie,this.branchCoverage=_e,this.functionCoverage=Ge}static fromDetails(O,ie){const _e=new it(0,0),Ge=new it(0,0),tt=new it(0,0);for(const lt of ie)if("branches"in lt){_e.total+=1,_e.covered+=lt.executionCount>0?1:0;for(const Dt of lt.branches)Ge.total+=1,Ge.covered+=Dt.executionCount>0?1:0}else tt.total+=1,tt.covered+=lt.executionCount>0?1:0;const ot=new g(O,_e,Ge.total>0?Ge:void 0,tt.total>0?tt:void 0);return ot.detailedCoverage=ie,ot}};bt=g=We([D],bt),e.FileCoverage=bt;let kt=class{constructor(O,ie,_e=[]){this.executionCount=O,this.location=ie,this.branches=_e}};kt=We([D],kt),e.StatementCoverage=kt;let Oi=class{constructor(O,ie){this.executionCount=O,this.location=ie}};Oi=We([D],Oi),e.BranchCoverage=Oi;let Ni=class{constructor(O,ie){this.executionCount=O,this.location=ie}};Ni=We([D],Ni),e.FunctionCoverage=Ni;var Hi;(function(N){N[N.None=0]="None",N[N.Option=1]="Option",N[N.Default=2]="Default",N[N.Preferred=3]="Preferred"})(Hi=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var zi;(function(N){N[N.Untrusted=0]="Untrusted",N[N.Trusted=1]="Trusted",N[N.Unspecified=2]="Unspecified"})(zi=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var Vi;(function(N){N[N.Notify=1]="Notify",N[N.OpenBrowser=2]="OpenBrowser",N[N.OpenPreview=3]="OpenPreview",N[N.Silent=4]="Silent",N[N.Ignore=5]="Ignore",N[N.OpenBrowserOnce=6]="OpenBrowserOnce"})(Vi=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class ji{constructor(O,ie,_e,Ge,tt,ot){this.kind=O,this.name=ie,this.detail=_e,this.uri=Ge,this.range=tt,this.selectionRange=ot}}e.TypeHierarchyItem=ji}),define(be[88],Ee([0,1,42,11,9,227,118,7,12]),function(re,e,d,M,b,R,F,C,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const I=new Map;function t(u,a){a?I.set(u,a):I.delete(u)}e.setWordDefinitionFor=t;function E(u){return I.get(u)}e.getWordDefinitionFor=E;class n extends R.MirrorTextModel{constructor(a,w,T,S,o,f,y,i){super(w,T,S,o);this._proxy=a,this._languageId=f,this._isDirty=y,this._notebook=i,this._isDisposed=!1}dispose(){(0,d.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(a){return(0,_.equals)(this._lines,a)}get document(){if(!this._document){const a=this;this._document={get uri(){return a._uri},get fileName(){return a._uri.fsPath},get isUntitled(){return a._uri.scheme===M.Schemas.untitled},get languageId(){return a._languageId},get version(){return a._versionId},get isClosed(){return a._isDisposed},get isDirty(){return a._isDirty},get notebook(){return a._notebook},save(){return a._save()},getText(w){return w?a._getTextInRange(w):a.getText()},get eol(){return a._eol===`
`?C.EndOfLine.LF:C.EndOfLine.CRLF},get lineCount(){return a._lines.length},lineAt(w){return a._lineAt(w)},offsetAt(w){return a._offsetAt(w)},positionAt(w){return a._positionAt(w)},validateRange(w){return a._validateRange(w)},validatePosition(w){return a._validatePosition(w)},getWordRangeAtPosition(w,T){return a._getWordRangeAtPosition(w,T)}}}return Object.freeze(this._document)}_acceptLanguageId(a){(0,d.ok)(!this._isDisposed),this._languageId=a}_acceptIsDirty(a){(0,d.ok)(!this._isDisposed),this._isDirty=a}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(a){const w=this._validateRange(a);if(w.isEmpty)return"";if(w.isSingleLine)return this._lines[w.start.line].substring(w.start.character,w.end.character);const T=this._eol,S=w.start.line,o=w.end.line,f=[];f.push(this._lines[S].substring(w.start.character));for(let y=S+1;y<o;y++)f.push(this._lines[y]);return f.push(this._lines[o].substring(0,w.end.character)),f.join(T)}_lineAt(a){let w;if(a instanceof C.Position?w=a.line:typeof a=="number"&&(w=a),typeof w!="number"||w<0||w>=this._lines.length||Math.floor(w)!==w)throw new Error("Illegal value for `line`");return new c(w,this._lines[w],w===this._lines.length-1)}_offsetAt(a){return a=this._validatePosition(a),this._ensureLineStarts(),this._lineStarts.getPrefixSum(a.line-1)+a.character}_positionAt(a){a=Math.floor(a),a=Math.max(0,a),this._ensureLineStarts();const w=this._lineStarts.getIndexOf(a),T=this._lines[w.index].length;return new C.Position(w.index,Math.min(w.remainder,T))}_validateRange(a){if(!(a instanceof C.Range))throw new Error("Invalid argument");const w=this._validatePosition(a.start),T=this._validatePosition(a.end);return w===a.start&&T===a.end?a:new C.Range(w.line,w.character,T.line,T.character)}_validatePosition(a){if(!(a instanceof C.Position))throw new Error("Invalid argument");if(this._lines.length===0)return a.with(0,0);let{line:w,character:T}=a,S=!1;if(w<0)w=0,T=0,S=!0;else if(w>=this._lines.length)w=this._lines.length-1,T=this._lines[w].length,S=!0;else{const o=this._lines[w].length;T<0?(T=0,S=!0):T>o&&(T=o,S=!0)}return S?new C.Position(w,T):a}_getWordRangeAtPosition(a,w){const T=this._validatePosition(a);if(!w)w=E(this._languageId);else if((0,b.regExpLeadsToEndlessLoop)(w))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${w.source}' because it matches the empty string.`);const S=(0,F.getWordAtText)(T.character+1,(0,F.ensureValidWordDefinition)(w),this._lines[T.line],0);if(S)return new C.Range(T.line,S.startColumn-1,T.line,S.endColumn-1)}}e.ExtHostDocumentData=n;class c{constructor(a,w,T){this._line=a,this._text=w,this._isLastLine=T}get lineNumber(){return this._line}get text(){return this._text}get range(){return new C.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new C.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=c}),define(be[155],Ee([0,1,7,3,228,6,55,20,2,36]),function(re,e,d,M,b,R,F,C,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class t{constructor(n,c,u,a){this._notebook=u,this._selector=a,this._disposables=new R.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new M.Emitter,this.onDidChange=this._onDidChange.event,this.uri=_.URI.from({scheme:"vscode-concat-doc",path:(0,I.generateUuid)()}),this._init(),this._disposables.add(c.onDidChangeDocument(T=>{const S=this._cellUris.get(T.document.uri);S!==void 0&&(this._cellLengths.changeValue(S,this._cells[S].document.getText().length+1),this._cellLines.changeValue(S,this._cells[S].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const w=T=>{T===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(n.onDidChangeNotebookCells(T=>w(T.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new C.ResourceMap;const n=[],c=[];for(const u of this._notebook.getCells())u.kind===d.NotebookCellKind.Code&&(!this._selector||(0,F.score)(this._selector,u.document.uri,u.document.languageId,!0))&&(this._cellUris.set(u.document.uri,this._cells.length),this._cells.push(u),n.push(u.document.getText().length+1),c.push(u.document.lineCount));this._cellLengths=new b.PrefixSumComputer(new Uint32Array(n)),this._cellLines=new b.PrefixSumComputer(new Uint32Array(c))}get version(){return this._versionId}getText(n){if(!n){let S="";for(const o of this._cells)S+=o.document.getText()+`
`;return S=S.slice(0,-1),S}if(n.isEmpty)return"";const c=this.locationAt(n.start),u=this.locationAt(n.end),a=this._cellUris.get(c.uri),w=this._cellUris.get(u.uri);if(a===void 0||w===void 0)return"";if(a===w)return this._cells[a].document.getText(new d.Range(c.range.start,u.range.end));const T=[this._cells[a].document.getText(new d.Range(c.range.start,new d.Position(this._cells[a].document.lineCount,0)))];for(let S=a+1;S<w;S++)T.push(this._cells[S].document.getText());return T.push(this._cells[w].document.getText(new d.Range(new d.Position(0,0),u.range.end))),T.join(`
`)}offsetAt(n){const c=this._cellLines.getIndexOf(n.line),u=this._cellLengths.getPrefixSum(c.index-1),a=this._cells[c.index].document.offsetAt(n.with(c.remainder));return u+a}positionAt(n){if(typeof n=="number"){const u=this._cellLengths.getIndexOf(n),a=this._cellLines.getPrefixSum(u.index-1);return this._cells[u.index].document.positionAt(u.remainder).translate(a)}const c=this._cellUris.get(n.uri);if(c!==void 0){const u=this._cellLines.getPrefixSum(c-1);return new d.Position(u+n.range.start.line,n.range.start.character)}return new d.Position(0,0)}locationAt(n){d.Range.isRange(n)||(n=new d.Range(n,n));const c=this._cellLines.getIndexOf(n.start.line);let u=c;n.isEmpty||(u=this._cellLines.getIndexOf(n.end.line));const a=new d.Position(c.remainder,n.start.character),w=new d.Position(u.remainder,n.end.character),T=new d.Range(a,w),S=this._cells[c.index];return new d.Location(S.document.uri,S.document.validateRange(T))}contains(n){return this._cellUris.has(n)}validateRange(n){const c=this.validatePosition(n.start),u=this.validatePosition(n.end);return n.with(c,u)}validatePosition(n){const c=this._cellLines.getIndexOf(n.line),u=new d.Position(c.remainder,n.character),a=this._cells[c.index].document.validatePosition(u),w=this._cellLines.getPrefixSum(c.index-1);return new d.Position(w+a.line,a.character)}}e.ExtHostNotebookConcatDocument=t}),define(be[156],Ee([0,1,7,13,3]),function(re,e,d,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let R=class{constructor(C){this._actual=new d.ColorTheme(d.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new b.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(C){let _=C==="light"?d.ColorThemeKind.Light:C==="dark"?d.ColorThemeKind.Dark:d.ColorThemeKind.HighContrast;this._actual=new d.ColorTheme(_),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};R=We([ze(0,M.IExtHostRpcService)],R),e.ExtHostTheming=R}),define(be[65],Ee([0,1,4]),function(re,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,d.createDecorator)("IURITransformerService");class M{constructor(R){R?(this.transformIncoming=R.transformIncoming.bind(R),this.transformOutgoing=R.transformOutgoing.bind(R),this.transformOutgoingURI=R.transformOutgoingURI.bind(R),this.transformOutgoingScheme=R.transformOutgoingScheme.bind(R)):(this.transformIncoming=F=>F,this.transformOutgoing=F=>F,this.transformOutgoingURI=F=>F,this.transformOutgoingScheme=F=>F)}}e.URITransformerService=M}),define(be[157],Ee([0,1,22]),function(re,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class M{constructor(){this.buffers=[]}add(_){let I=this.buffers.indexOf(_);return I<0&&(I=this.buffers.length,this.buffers.push(_)),I}}function b(C,_){if(_.serializeBuffersForPostMessage){const I=new M,t=(c,u)=>{if(u instanceof ArrayBuffer){const a=I.add(u);return{$$vscode_array_buffer_reference$$:!0,index:a}}else if(ArrayBuffer.isView(u)){const a=R(u);if(a){const w=I.add(u.buffer);return{$$vscode_array_buffer_reference$$:!0,index:w,view:{type:a,byteLength:u.byteLength,byteOffset:u.byteOffset}}}}return u},E=JSON.stringify(C,t),n=I.buffers.map(c=>{const u=new Uint8Array(c);return d.VSBuffer.wrap(u)});return{message:E,buffers:n}}else return{message:JSON.stringify(C),buffers:[]}}e.serializeWebviewMessage=b;function R(C){switch(C.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function F(C,_){const I=_.map(n=>{const c=new ArrayBuffer(n.byteLength);return new Uint8Array(c).set(n.buffer),c}),t=_.length?(n,c)=>{if(typeof c=="object"&&c.$$vscode_array_buffer_reference$$){const u=c,{index:a}=u,w=I[a];if(u.view)switch(u.view.type){case 1:return new Int8Array(w,u.view.byteOffset,u.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(w,u.view.byteOffset,u.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(w,u.view.byteOffset,u.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(w,u.view.byteOffset,u.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(w,u.view.byteOffset,u.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(w,u.view.byteOffset,u.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(w,u.view.byteOffset,u.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(w,u.view.byteOffset,u.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(w,u.view.byteOffset,u.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(w,u.view.byteOffset,u.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(w,u.view.byteOffset,u.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return w}return c}:void 0;return{message:JSON.parse(C,t),arrayBuffers:I}}e.deserializeWebviewMessage=F}),define(be[158],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeDataTransferConverter=void 0;var d;(function(M){function b(F){const C={items:new Map};return F.types.forEach((_,I)=>{C.items.set(_,{asString:async()=>F.items[I].asString})}),C}M.toITreeDataTransfer=b;async function R(F){const C={types:[],items:[]},_=Array.from(F.items.entries());for(const I of _)C.types.push(I[0]),C.items.push({asString:await I[1].asString()});return C}M.toTreeDataTransferDTO=R})(d=e.TreeDataTransferConverter||(e.TreeDataTransferConverter={}))}),define(be[66],Ee([0,1,11,2]),function(re,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function b(C,_){return C.scheme===d.Schemas.http||C.scheme===d.Schemas.https?C:(_&&_.authority&&_.isRemote&&C.scheme===d.Schemas.file&&(C=M.URI.from({scheme:d.Schemas.vscodeRemote,authority:_.authority,path:C.path})),M.URI.from({scheme:d.Schemas.https,authority:`${C.scheme}+${R(C.authority)}.${e.webviewRootResourceAuthority}`,path:C.path,fragment:C.fragment,query:C.query}))}e.asWebviewUri=b;function R(C){return C.replace(/./g,_=>{const I=_.charCodeAt(0);return I>=97&&I<=122||I>=65&&I<=90||I>=48&&I<=57?_:"-"+I.toString(16).padStart(4,"0")})}function F(C){return C.replace(/-([0-9a-f]{4})/g,(_,I)=>String.fromCharCode(parseInt(I,16)))}e.decodeAuthority=F}),define(be[159],Ee([0,1,3,6,66]),function(re,e,d,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class R{constructor(C,_,I){this._proxy=C,this._editors=_,this._initData=I,this._handlePool=0,this._disposables=new M.DisposableStore,this._insets=new Map,this._disposables.add(_.onDidChangeVisibleTextEditors(()=>{const t=_.getVisibleTextEditors();for(const E of this._insets.values())t.indexOf(E.editor)<0&&E.inset.dispose()}))}dispose(){this._insets.forEach(C=>C.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(C,_,I,t,E){let n;for(const o of this._editors.getVisibleTextEditors(!0))if(o.value===C){n=o;break}if(!n)throw new Error("not a visible editor");const c=this,u=this._handlePool++,a=new d.Emitter,w=new d.Emitter,T=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(o){return(0,b.asWebviewUri)(o,c._initData.remote)}get cspSource(){return b.webviewGenericCspSource}set options(o){this._options=o,c._proxy.$setOptions(u,o)}get options(){return this._options}set html(o){this._html=o,c._proxy.$setHtml(u,o)}get html(){return this._html}get onDidReceiveMessage(){return a.event}postMessage(o){return c._proxy.$postMessage(u,o)}},S=new class{constructor(){this.editor=C,this.line=_,this.height=I,this.webview=T,this.onDidDispose=w.event}dispose(){c._insets.has(u)&&(c._insets.delete(u),c._proxy.$disposeEditorInset(u),w.fire(),w.dispose(),a.dispose())}};return this._proxy.$createEditorInset(u,n.id,n.value.document.uri,_+1,I,t||{},E.identifier,E.extensionLocation),this._insets.set(u,{editor:C,inset:S,onDidReceiveMessage:a}),S}$onDidDispose(C){const _=this._insets.get(C);_&&_.inset.dispose()}$onDidReceiveMessage(C,_){const I=this._insets.get(C);I&&I.onDidReceiveMessage.fire(_)}}e.ExtHostEditorInsets=R}),define(be[160],Ee([0,1,131,10,2,6,4,45,28,12,11]),function(re,e,d,M,b,R,F,C,_,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.EditorAreaVisibleContext=e.SplitEditorsVertically=e.IsCenteredLayoutContext=e.InEditorZenModeContext=e.EditorsVisibleContext=e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext=e.ActiveEditorGroupLockedContext=e.ActiveEditorGroupLastContext=e.ActiveEditorGroupIndexContext=e.ActiveEditorGroupEmptyContext=e.EditorGroupEditorsCountContext=e.SideBySideEditorActiveContext=e.TextCompareEditorActiveContext=e.TextCompareEditorVisibleContext=e.ActiveEditorAvailableEditorIdsContext=e.ActiveEditorContext=e.ActiveEditorCanSplitInGroupContext=e.ActiveEditorCanRevertContext=e.ActiveEditorReadonlyContext=e.ActiveEditorStickyContext=e.ActiveEditorPinnedContext=e.ActiveEditorDirtyContext=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,d.localize)(0,null),providerDisplayName:(0,d.localize)(1,null)},e.ActiveEditorDirtyContext=new C.RawContextKey("activeEditorIsDirty",!1,(0,d.localize)(2,null)),e.ActiveEditorPinnedContext=new C.RawContextKey("activeEditorIsNotPreview",!1,(0,d.localize)(3,null)),e.ActiveEditorStickyContext=new C.RawContextKey("activeEditorIsPinned",!1,(0,d.localize)(4,null)),e.ActiveEditorReadonlyContext=new C.RawContextKey("activeEditorIsReadonly",!1,(0,d.localize)(5,null)),e.ActiveEditorCanRevertContext=new C.RawContextKey("activeEditorCanRevert",!1,(0,d.localize)(6,null)),e.ActiveEditorCanSplitInGroupContext=new C.RawContextKey("activeEditorCanSplitInGroup",!0),e.ActiveEditorContext=new C.RawContextKey("activeEditor",null,{type:"string",description:(0,d.localize)(7,null)}),e.ActiveEditorAvailableEditorIdsContext=new C.RawContextKey("activeEditorAvailableEditorIds","",(0,d.localize)(8,null)),e.TextCompareEditorVisibleContext=new C.RawContextKey("textCompareEditorVisible",!1,(0,d.localize)(9,null)),e.TextCompareEditorActiveContext=new C.RawContextKey("textCompareEditorActive",!1,(0,d.localize)(10,null)),e.SideBySideEditorActiveContext=new C.RawContextKey("sideBySideEditorActive",!1,(0,d.localize)(11,null)),e.EditorGroupEditorsCountContext=new C.RawContextKey("groupEditorsCount",0,(0,d.localize)(12,null)),e.ActiveEditorGroupEmptyContext=new C.RawContextKey("activeEditorGroupEmpty",!1,(0,d.localize)(13,null)),e.ActiveEditorGroupIndexContext=new C.RawContextKey("activeEditorGroupIndex",0,(0,d.localize)(14,null)),e.ActiveEditorGroupLastContext=new C.RawContextKey("activeEditorGroupLast",!1,(0,d.localize)(15,null)),e.ActiveEditorGroupLockedContext=new C.RawContextKey("activeEditorGroupLocked",!1,(0,d.localize)(16,null)),e.MultipleEditorGroupsContext=new C.RawContextKey("multipleEditorGroups",!1,(0,d.localize)(17,null)),e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext.toNegated(),e.EditorsVisibleContext=new C.RawContextKey("editorIsOpen",!1,(0,d.localize)(18,null)),e.InEditorZenModeContext=new C.RawContextKey("inZenMode",!1,(0,d.localize)(19,null)),e.IsCenteredLayoutContext=new C.RawContextKey("isCenteredLayout",!1,(0,d.localize)(20,null)),e.SplitEditorsVertically=new C.RawContextKey("splitEditorsVertically",!1,(0,d.localize)(21,null)),e.EditorAreaVisibleContext=new C.RawContextKey("editorAreaVisible",!0,(0,d.localize)(22,null)),e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";function E(A,L,V){for(const G of V.visibleEditorPanes)if(G.group.id===L&&A.matches(G.input))return G.getViewState()}e.findViewStateForEditor=E;function n(A){if(f(A))return!1;const L=A;return b.URI.isUri(L?.resource)}e.isResourceEditorInput=n;function c(A){if(f(A))return!1;const L=A;return L?.original!==void 0&&L.modified!==void 0}e.isResourceDiffEditorInput=c;function u(A){if(f(A)||c(A))return!1;const L=A;return L?.primary!==void 0&&L.secondary!==void 0}e.isResourceSideBySideEditorInput=u;function a(A){if(f(A))return!1;const L=A;return L?L.resource===void 0||L.resource.scheme===t.Schemas.untitled||L.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=a;var w;(function(A){A[A.SHORT=0]="SHORT",A[A.MEDIUM=1]="MEDIUM",A[A.LONG=2]="LONG"})(w=e.Verbosity||(e.Verbosity={}));var T;(function(A){A[A.EXPLICIT=1]="EXPLICIT",A[A.AUTO=2]="AUTO",A[A.FOCUS_CHANGE=3]="FOCUS_CHANGE",A[A.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(T=e.SaveReason||(e.SaveReason={}));var S;(function(A){A[A.None=0]="None",A[A.Readonly=2]="Readonly",A[A.Untitled=4]="Untitled",A[A.Singleton=8]="Singleton",A[A.RequiresTrust=16]="RequiresTrust",A[A.CanSplitInGroup=32]="CanSplitInGroup"})(S=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class o extends R.Disposable{}e.AbstractEditorInput=o;function f(A){return A instanceof o}e.isEditorInput=f;function y(A){const L=A;return b.URI.isUri(L?.preferredResource)}function i(A){const L=A;return f(L?.primary)&&f(L?.secondary)}e.isSideBySideEditorInput=i;function v(A){const L=A;return f(L?.modified)&&f(L?.original)}e.isDiffEditorInput=v;function r(A){return f(A?.editor)}e.isEditorInputWithOptions=r;function s(A){const L=A;return r(A)&&L?.group!==void 0}e.isEditorInputWithOptionsAndGroup=s;function l(A){const L=A;return typeof L?.groupId=="number"&&f(L.editor)}e.isEditorIdentifier=l;var h;(function(A){A[A.UNKNOWN=0]="UNKNOWN",A[A.REPLACE=1]="REPLACE",A[A.MOVE=2]="MOVE",A[A.UNPIN=3]="UNPIN"})(h=e.EditorCloseContext||(e.EditorCloseContext={}));var p;(function(A){A[A.PRIMARY=1]="PRIMARY",A[A.SECONDARY=2]="SECONDARY",A[A.BOTH=3]="BOTH",A[A.ANY=4]="ANY"})(p=e.SideBySideEditor||(e.SideBySideEditor={}));class k{getOriginalUri(L,V){if(!L)return;if(V?.supportSideBySide){const{primary:U,secondary:K}=this.getSideEditors(L);if(U&&K){if(V?.supportSideBySide===p.BOTH)return{primary:this.getOriginalUri(U,{filterByScheme:V.filterByScheme}),secondary:this.getOriginalUri(K,{filterByScheme:V.filterByScheme})};if(V?.supportSideBySide===p.ANY)return this.getOriginalUri(U,{filterByScheme:V.filterByScheme})??this.getOriginalUri(K,{filterByScheme:V.filterByScheme});L=V.supportSideBySide===p.PRIMARY?U:K}}if(c(L)||u(L))return;const G=y(L)?L.preferredResource:L.resource;return!G||!V||!V.filterByScheme?G:this.filterUri(G,V.filterByScheme)}getSideEditors(L){return i(L)||u(L)?{primary:L.primary,secondary:L.secondary}:v(L)||c(L)?{primary:L.modified,secondary:L.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(L,V){if(!L)return;if(V?.supportSideBySide){const{primary:U,secondary:K}=this.getSideEditors(L);if(U&&K){if(V?.supportSideBySide===p.BOTH)return{primary:this.getCanonicalUri(U,{filterByScheme:V.filterByScheme}),secondary:this.getCanonicalUri(K,{filterByScheme:V.filterByScheme})};if(V?.supportSideBySide===p.ANY)return this.getCanonicalUri(U,{filterByScheme:V.filterByScheme})??this.getCanonicalUri(K,{filterByScheme:V.filterByScheme});L=V.supportSideBySide===p.PRIMARY?U:K}}if(c(L)||u(L))return;const G=L.resource;return!G||!V||!V.filterByScheme?G:this.filterUri(G,V.filterByScheme)}filterUri(L,V){if(Array.isArray(V)){if(V.some(G=>L.scheme===G))return L}else if(V===L.scheme)return L}}e.EditorResourceAccessor=new k;var P;(function(A){A[A.LEFT=0]="LEFT",A[A.RIGHT=1]="RIGHT"})(P=e.CloseDirection||(e.CloseDirection={}));class g{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(L){const V=this.instantiationService=L.get(F.IInstantiationService);for(const[G,U]of this.editorSerializerConstructors)this.createEditorSerializer(G,U,V);this.editorSerializerConstructors.clear()}createEditorSerializer(L,V,G){const U=G.createInstance(V);this.editorSerializerInstances.set(L,U)}registerFileEditorFactory(L){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=L}getFileEditorFactory(){return(0,M.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(L,V){if(this.editorSerializerConstructors.has(L)||this.editorSerializerInstances.has(L))throw new Error(`A editor serializer with type ID '${L}' was already registered.`);return this.instantiationService?this.createEditorSerializer(L,V,this.instantiationService):this.editorSerializerConstructors.set(L,V),(0,R.toDisposable)(()=>{this.editorSerializerConstructors.delete(L),this.editorSerializerInstances.delete(L)})}getEditorSerializer(L){return this.editorSerializerInstances.get(typeof L=="string"?L:L.typeId)}}_.Registry.add(e.EditorExtensions.EditorFactory,new g);async function D(A,L){if(!A||!A.length)return[];const V=await Promise.all(A.map(async G=>{const U=b.URI.revive(G.fileUri);if(!U||(await L.activateProvider(U.scheme),!L.canHandleResource(U)))return;const K=typeof G.exists=="boolean"?G.exists:await L.exists(U);if(!K&&G.openOnlyIfExists)return;const $={selection:K?G.selection:void 0,pinned:!0,override:G.editorOverrideId};let B;return K?B={resource:U,options:$}:B={resource:U,options:$,forceUntitled:!0},B}));return(0,I.coalesce)(V)}e.pathsToEditors=D;var m;(function(A){A[A.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",A[A.SEQUENTIAL=1]="SEQUENTIAL"})(m=e.EditorsOrder||(e.EditorsOrder={}))}),define(be[161],Ee([0,1,3,45,132,4,6,20,28,12,51,23,34,151]),function(re,e,d,M,b,R,F,C,_,I,t,E,n,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TREE_ITEM_DATA_TRANSFER_TYPE=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.getVisbileViewContextKey=e.FocusedViewContext=e.IViewsService=e.ViewContentGroups=e.getEnabledViewContainerContextKey=e.ViewContainerLocationToString=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,c.registerIcon)("default-view-icon",n.Codicon.window,(0,b.localize)(0,null));var u;(function(l){l.ViewContainersRegistry="workbench.registry.view.containers",l.ViewsRegistry="workbench.registry.view"})(u=e.Extensions||(e.Extensions={}));var a;(function(l){l[l.Sidebar=0]="Sidebar",l[l.Panel=1]="Panel"})(a=e.ViewContainerLocation||(e.ViewContainerLocation={}));function w(l){switch(l){case 0:return"sidebar";case 1:return"panel"}}e.ViewContainerLocationToString=w;function T(l){return`viewContainer.${l}.enabled`}e.getEnabledViewContainerContextKey=T;class S extends F.Disposable{constructor(){super(...arguments);this._onDidRegister=this._register(new d.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new d.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,I.flatten)([...this.viewContainers.values()])}registerViewContainer(h,p,k){const P=this.get(h.id);if(P)return P;const g=h;return g.openCommandActionDescriptor=k?.donotRegisterOpenCommand?void 0:g.openCommandActionDescriptor??{id:g.id},(0,C.getOrSet)(this.viewContainers,p,[]).push(g),k?.isDefault&&this.defaultViewContainers.push(g),this._onDidRegister.fire({viewContainer:g,viewContainerLocation:p}),g}deregisterViewContainer(h){for(const p of this.viewContainers.keys()){const k=this.viewContainers.get(p),P=k?.indexOf(h);if(P!==-1){k?.splice(P,1),k.length===0&&this.viewContainers.delete(p),this._onDidDeregister.fire({viewContainer:h,viewContainerLocation:p});return}}}get(h){return this.all.filter(p=>p.id===h)[0]}getViewContainers(h){return[...this.viewContainers.get(h)||[]]}getViewContainerLocation(h){return[...this.viewContainers.keys()].filter(p=>this.getViewContainers(p).filter(k=>k?.id===h.id).length>0)[0]}getDefaultViewContainer(h){return this.defaultViewContainers.find(p=>this.getViewContainerLocation(p)===h)}}_.Registry.add(u.ViewContainersRegistry,new S);var o;(function(l){l.Open="2_open",l.Debug="4_debug",l.SCM="5_scm",l.More="9_more"})(o=e.ViewContentGroups||(e.ViewContentGroups={}));function f(l,h){const p=l.group??o.More,k=h.group??o.More;return p!==k?p.localeCompare(k):(l.order??5)-(h.order??5)}class y extends F.Disposable{constructor(){super(...arguments);this._onViewsRegistered=this._register(new d.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new d.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new d.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new d.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new t.SetMap}registerViews(h,p){this.registerViews2([{views:h,viewContainer:p}])}registerViews2(h){h.forEach(({views:p,viewContainer:k})=>this.addViews(p,k)),this._onViewsRegistered.fire(h)}deregisterViews(h,p){const k=this.removeViews(h,p);k.length&&this._onViewsDeregistered.fire({views:k,viewContainer:p})}moveViews(h,p){for(const k of this._views.keys())if(k!==p){const P=this.removeViews(h,k);P.length&&(this.addViews(P,p),this._onDidChangeContainer.fire({views:P,from:k,to:p}))}}getViews(h){return this._views.get(h)||[]}getView(h){for(const p of this._viewContainers){const k=(this._views.get(p)||[]).filter(P=>P.id===h)[0];if(k)return k}return null}getViewContainer(h){for(const p of this._viewContainers)if((this._views.get(p)||[]).filter(P=>P.id===h)[0])return p;return null}registerViewWelcomeContent(h,p){return this._viewWelcomeContents.add(h,p),this._onDidChangeViewWelcomeContent.fire(h),(0,F.toDisposable)(()=>{this._viewWelcomeContents.delete(h,p),this._onDidChangeViewWelcomeContent.fire(h)})}registerViewWelcomeContent2(h,p){const k=new Map;for(const[P,g]of p)this._viewWelcomeContents.add(h,g),k.set(P,(0,F.toDisposable)(()=>{this._viewWelcomeContents.delete(h,g),this._onDidChangeViewWelcomeContent.fire(h)}));return this._onDidChangeViewWelcomeContent.fire(h),k}getViewWelcomeContent(h){const p=[];return this._viewWelcomeContents.forEach(h,k=>p.push(k)),p.sort(f)}addViews(h,p){let k=this._views.get(p);k||(k=[],this._views.set(p,k),this._viewContainers.push(p));for(const P of h){if(this.getView(P.id)!==null)throw new Error((0,b.localize)(1,null,P.id));k.push(P)}}removeViews(h,p){const k=this._views.get(p);if(!k)return[];const P=[],g=[];for(const D of k)h.includes(D)?P.push(D):g.push(D);return P.length&&(g.length?this._views.set(p,g):(this._views.delete(p),this._viewContainers.splice(this._viewContainers.indexOf(p),1))),P}}_.Registry.add(u.ViewsRegistry,new y),e.IViewsService=(0,R.createDecorator)("viewsService"),e.FocusedViewContext=new M.RawContextKey("focusedView","",(0,b.localize)(2,null));function i(l){return`view.${l}.visible`}e.getVisbileViewContextKey=i,e.IViewDescriptorService=(0,R.createDecorator)("viewDescriptorService");var v;(function(l){l[l.Default=0]="Default",l[l.Expand=1]="Expand"})(v=e.ViewVisibilityState||(e.ViewVisibilityState={}));var r;(function(l){l[l.None=0]="None",l[l.Collapsed=1]="Collapsed",l[l.Expanded=2]="Expanded"})(r=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class s{constructor(h,p){this.resolved=!1,this._hasResolve=!1,(0,E.mixin)(this,h),this._hasResolve=!!p,this.resolve=async k=>{if(p&&!this.resolved){const P=await p(k);P&&(this.tooltip=this.tooltip??P.tooltip,this.command=this.command??P.command)}k.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=s,e.TREE_ITEM_DATA_TRANSFER_TYPE="text/treeitems"}),define(be[162],Ee([0,1,3,14,133]),function(re,e,d,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class R{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new d.Emitter,this._onExit=new d.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(C){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=C}onEvent(C){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=C}onRequest(C){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=C}sendResponse(C){C.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${C.command}`)):this.internalSend("response",C)}sendRequest(C,_,I,t){const E={command:C};if(_&&Object.keys(_).length>0&&(E.arguments=_),this.internalSend("request",E),typeof t=="number"){const n=setTimeout(()=>{clearTimeout(n);const c=this.pendingRequests.get(E.seq);if(c){this.pendingRequests.delete(E.seq);const u={type:"response",seq:0,request_seq:E.seq,success:!1,command:C,message:(0,b.localize)(0,null,t,C)};c(u)}},t)}return I&&this.pendingRequests.set(E.seq,I),E.seq}acceptMessage(C){this.messageCallback?this.messageCallback(C):(this.queue.push(C),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(C,_){return C.type!=="event"||_.type!=="event"}async processQueue(){let C;for(;this.queue.length;){if((!C||this.needsTaskBoundaryBetween(this.queue[0],C))&&await(0,M.timeout)(0),C=this.queue.shift(),!C)return;switch(C.type){case"event":this.eventCallback&&this.eventCallback(C);break;case"request":this.requestCallback&&this.requestCallback(C);break;case"response":const _=C,I=this.pendingRequests.get(_.request_seq);I&&(this.pendingRequests.delete(_.request_seq),I(_));break}}}internalSend(C,_){_.type=C,_.seq=this.sequence++,this.sendMessage(_)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const C=new Map;this.pendingRequests.forEach((_,I)=>C.set(I,_)),await(0,M.timeout)(500),C.forEach((_,I)=>{_({type:"response",seq:0,request_seq:I,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(I)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=R}),define(be[163],Ee([0,1,9,2,17,23,11]),function(re,e,d,M,b,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const C=/{([^}]+)}/g;function _(r,s,l){return r.replace(C,function(h,p){return s&&p.length>0&&p[0]!=="_"?h:l&&l.hasOwnProperty(p)?l[p]:h})}e.formatPII=_;function I(r){const s={};for(const l of Object.keys(r))l.startsWith("!")||(s[l]=r[l]);return s}e.filterExceptionsFromTelemetry=I;function t(r){return r.configuration.request==="attach"&&!E(r)&&(!r.parentSession||t(r.parentSession))}e.isSessionAttach=t;function E(r){let s=r.configuration.type;if(!!s)return s==="vslsShare"&&(s=r.configuration.adapterProxy.configuration.type),(0,d.equalsIgnoreCase)(s,"extensionhost")||(0,d.equalsIgnoreCase)(s,"pwa-extensionhost")?r:r.parentSession?E(r.parentSession):void 0}e.getExtensionHostDebugSession=E;function n(r){return r.type&&(r.label||r.program||r.runtime)}e.isDebuggerMainContribution=n;function c(r,s,l){let h,p=0,k=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,P=null;for(;P=k.exec(r);){let g=P.index+1,D=g+P[0].length;if(g<=s&&D>=l){h=P[0],p=g;break}}if(h){let g=/\w+/g,D=null;for(;(D=g.exec(h))&&!(D.index+1+p+D[0].length>=l););D&&(h=h.substring(0,g.lastIndex))}return h?{start:p,end:p+h.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=c;const u=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function a(r){return!!(r&&r.match(u))}e.isUri=a;function w(r){if(typeof r.path=="string"&&!(typeof r.sourceReference=="number"&&r.sourceReference>0)){if(a(r.path))return M.URI.parse(r.path);if((0,b.isAbsolute)(r.path))return M.URI.file(r.path)}return r.path}function T(r){if(typeof r.path=="object"){const s=M.URI.revive(r.path);if(s)return s.scheme===F.Schemas.file?s.fsPath:s.toString()}return r.path}function S(r,s){const l=s?w:T,h=(0,R.deepClone)(r);return f(h,(p,k)=>{p&&k&&(k.path=l(k))}),h}e.convertToDAPaths=S;function o(r,s){const l=s?w:T,h=(0,R.deepClone)(r);return f(h,(p,k)=>{!p&&k&&(k.path=l(k))}),h}e.convertToVSCPaths=o;function f(r,s){switch(r.type){case"event":const l=r;switch(l.event){case"output":s(!1,l.body.source);break;case"loadedSource":s(!1,l.body.source);break;case"breakpoint":s(!1,l.body.breakpoint.source);break;default:break}break;case"request":const h=r;switch(h.command){case"setBreakpoints":s(!0,h.arguments.source);break;case"breakpointLocations":s(!0,h.arguments.source);break;case"source":s(!0,h.arguments.source);break;case"gotoTargets":s(!0,h.arguments.source);break;case"launchVSCode":h.arguments.args.forEach(k=>s(!1,k));break;default:break}break;case"response":const p=r;if(p.success&&p.body)switch(p.command){case"stackTrace":p.body.stackFrames.forEach(k=>s(!1,k.source));break;case"loadedSources":p.body.sources.forEach(k=>s(!1,k));break;case"scopes":p.body.scopes.forEach(k=>s(!1,k.source));break;case"setFunctionBreakpoints":p.body.breakpoints.forEach(k=>s(!1,k.source));break;case"setBreakpoints":p.body.breakpoints.forEach(k=>s(!1,k.source));break;default:break}break}}function y(r){return r.filter(s=>!s.presentation?.hidden).sort((s,l)=>s.presentation?l.presentation?s.presentation.group?l.presentation.group?s.presentation.group!==l.presentation.group?s.presentation.group.localeCompare(l.presentation.group):i(s.presentation.order,l.presentation.order):-1:l.presentation.group?1:i(s.presentation.order,l.presentation.order):-1:l.presentation?1:0)}e.getVisibleAndSorted=y;function i(r,s){return typeof r!="number"?typeof s!="number"?0:1:typeof s!="number"?-1:r-s}async function v(r,s){const l=r.getValue("debug.saveBeforeStart",{overrideIdentifier:s.activeTextEditorMode});if(l!=="none"&&(await s.saveAll(),l==="allEditorsInActiveGroup")){const h=s.activeEditorPane;h&&await s.save({editor:h.input,groupId:h.group.id})}await r.reloadConfiguration()}e.saveAllBeforeDebugStart=v}),define(be[89],Ee([0,1,27,78,11,17,26,45]),function(re,e,d,M,b,R,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.GlobalToolbarShowLabel=e.TextOutputLineLimit=e.OpenGettingStarted=e.ConsolidatedRunButton=e.NotebookCellEditorOptionsCustomizations=e.DragAndDropEnabled=e.ShowFoldingControls=e.ConsolidatedOutputButton=e.UndoRedoPerCell=e.GlobalToolbar=e.InsertToolbarLocation=e.FocusIndicator=e.CompactView=e.ExperimentalInsertToolbarAlignment=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBar=e.CellToolbarVisibility=e.CellToolbarLocation=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.sortMimeTypes=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var _;(function(g){g[g.Markup=1]="Markup",g[g.Code=2]="Code"})(_=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",M.Mimes.markdown,"image/png","image/jpeg",M.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[M.Mimes.markdown,"application/json",M.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var I;(function(g){g[g.Running=1]="Running",g[g.Idle=2]="Idle"})(I=e.NotebookRunState||(e.NotebookRunState={}));var t;(function(g){g[g.Pending=2]="Pending",g[g.Executing=3]="Executing"})(t=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var E;(function(g){g[g.WithHardKernelDependency=0]="WithHardKernelDependency",g[g.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",g[g.Pure=2]="Pure",g[g.Never=3]="Never"})(E=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var n;(function(g){g.Always="always",g.Never="never",g.Optional="optional"})(n=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var c;(function(g){g[g.ModelChange=1]="ModelChange",g[g.Move=2]="Move",g[g.ChangeLanguage=5]="ChangeLanguage",g[g.Initialize=6]="Initialize",g[g.ChangeCellMetadata=7]="ChangeCellMetadata",g[g.Output=8]="Output",g[g.OutputItem=9]="OutputItem",g[g.ChangeCellContent=10]="ChangeCellContent",g[g.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",g[g.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",g[g.ChangeCellMime=13]="ChangeCellMime",g[g.Unknown=100]="Unknown"})(c=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var u;(function(g){g[g.Handle=0]="Handle",g[g.Index=1]="Index"})(u=e.SelectionStateType||(e.SelectionStateType={}));var a;(function(g){g[g.Replace=1]="Replace",g[g.Output=2]="Output",g[g.Metadata=3]="Metadata",g[g.CellLanguage=4]="CellLanguage",g[g.DocumentMetadata=5]="DocumentMetadata",g[g.Move=6]="Move",g[g.OutputItems=7]="OutputItems",g[g.PartialMetadata=8]="PartialMetadata",g[g.PartialInternalMetadata=9]="PartialInternalMetadata"})(a=e.CellEditType||(e.CellEditType={}));var w;(function(g){g.scheme=b.Schemas.vscodeNotebookCell;const D=/^ch(\d{7,})/;function m(U,K){return U.with({scheme:g.scheme,fragment:`ch${K.toString().padStart(7,"0")}${U.scheme!==b.Schemas.file?U.scheme:""}`})}g.generate=m;function A(U){if(U.scheme!==g.scheme)return;const K=D.exec(U.fragment);return K?{handle:Number(K[1]),notebook:U.with({scheme:U.fragment.substr(K[0].length)||b.Schemas.file,fragment:null})}:void 0}g.parse=A;function L(U){if(U.scheme!==b.Schemas.vscodeNotebookCellMetadata)return;const K=D.exec(U.fragment);return K?{handle:Number(K[1]),notebook:U.with({scheme:U.fragment.substr(K[0].length)||b.Schemas.file,fragment:null})}:void 0}g.parseCellMetadataUri=L;function V(U,K,$){return U.with({scheme:$,fragment:`ch${K.toString().padStart(7,"0")}${U.scheme!==b.Schemas.file?U.scheme:""}`})}g.generateCellUri=V;function G(U,K){if(U.scheme!==K)return;const $=D.exec(U.fragment);return $?{handle:Number($[1]),notebook:U.with({scheme:U.fragment.substr($[0].length)||b.Schemas.file,fragment:null})}:void 0}g.parseCellUri=G})(w=e.CellUri||(e.CellUri={}));const T=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],[M.Mimes.markdown,{alwaysSecure:!0,supportedByCore:!0}],[M.Mimes.text,{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function S(g){return T.get(g)?.alwaysSecure??!1}e.mimeTypeIsAlwaysSecure=S;function o(g){return T.get(g)?.supportedByCore??!1}e.mimeTypeSupportedByCore=o;function f(g){return T.get(g)?.mergeable??!1}e.mimeTypeIsMergeable=f;function y(g,D){return F.isWindows&&(g=g.replace(/\//g,"\\"),D=D.replace(/\//g,"\\")),d.match(g,D)}function i(g,D,m){let A=0;for(let L=0;L<D.length;L++){if(y(D[L],g))return A;A++}for(let L=0;L<m.length;L++){if(y(m[L],g))return A;A++}return A}function v(g,D,m){return g.sort((A,L)=>i(A,D,m)-i(L,D,m))}e.sortMimeTypes=v;function r(g,D,m,A=(L,V)=>L===V){const L=[];function V(K,$,B){if($===0&&B.length===0)return;const z=L[L.length-1];z&&z.start+z.deleteCount===K?(z.deleteCount+=$,z.toInsert.push(...B)):L.push({start:K,deleteCount:$,toInsert:B})}let G=0,U=0;for(;;){if(G===g.length){V(G,0,D.slice(U));break}if(U===D.length){V(G,g.length-G,[]);break}const K=g[G],$=D[U];if(A(K,$)){G+=1,U+=1;continue}m($)?(V(G,1,[]),G+=1):(V(G,0,[$]),U+=1)}return L}e.diff=r,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new C.RawContextKey("notebookEditorCursorAtBoundary","none");var s;(function(g){g.default="default",g.option="option"})(s=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function l(g){const D=g;return!!((typeof D.include=="string"||d.isRelativePattern(D.include))&&(typeof D.exclude=="string"||d.isRelativePattern(D.exclude)))}e.isDocumentExcludePattern=l;function h(g,D,m){if(Array.isArray(g.viewType)&&g.viewType.indexOf(D)>=0||g.viewType===D)return!0;if(g.filenamePattern){let A=l(g.filenamePattern)?g.filenamePattern.include:g.filenamePattern,L=l(g.filenamePattern)?g.filenamePattern.exclude:void 0;if(d.match(A,(0,R.basename)(m.fsPath).toLowerCase()))return!(L&&d.match(L,(0,R.basename)(m.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=h;class p{constructor(D){this.textModel=D}getElements(){const D=new Int32Array(this.textModel.cells.length);for(let m=0;m<this.textModel.cells.length;m++)D[m]=this.textModel.cells[m].getHashValue();return D}}e.CellSequence=p,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocation="notebook.cellToolbarLocation",e.CellToolbarVisibility="notebook.cellToolbarVisibility",e.ShowCellStatusBar="notebook.showCellStatusBar",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview",e.ExperimentalInsertToolbarAlignment="notebook.experimental.insertToolbarAlignment",e.CompactView="notebook.compactView",e.FocusIndicator="notebook.cellFocusIndicator",e.InsertToolbarLocation="notebook.insertToolbarLocation",e.GlobalToolbar="notebook.globalToolbar",e.UndoRedoPerCell="notebook.undoRedoPerCell",e.ConsolidatedOutputButton="notebook.consolidatedOutputButton",e.ShowFoldingControls="notebook.showFoldingControls",e.DragAndDropEnabled="notebook.dragAndDropEnabled",e.NotebookCellEditorOptionsCustomizations="notebook.editorOptionsCustomizations",e.ConsolidatedRunButton="notebook.consolidatedRunButton",e.OpenGettingStarted="notebook.experimental.openGettingStarted",e.TextOutputLineLimit="notebook.output.textLineLimit",e.GlobalToolbarShowLabel="notebook.globalToolbarShowLabel";var k;(function(g){g[g.Left=1]="Left",g[g.Right=2]="Right"})(k=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class P{static create(D){return`${P._prefix}${D}`}static parse(D){if(D.startsWith(P._prefix))return D.substr(P._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=P,P._prefix="notebook/"}),define(be[164],Ee([0,1,4]),function(re,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var M;(function(b){b[b.Output=1]="Output",b[b.OutputItems=2]="OutputItems",b[b.ExecutionState=3]="ExecutionState",b[b.Complete=4]="Complete"})(M=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,d.createDecorator)("INotebookExecutionService")}),define(be[165],Ee([0,1,135,4,45]),function(re,e,d,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new b.RawContextKey("customExecutionSupported",!0,d.localize(0,null)),e.ShellExecutionSupportedContext=new b.RawContextKey("shellExecutionSupported",!1,d.localize(1,null)),e.ProcessExecutionSupportedContext=new b.RawContextKey("processExecutionSupported",!1,d.localize(2,null)),e.ITaskService=(0,M.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(be[166],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function d(b){return[...b.entries()]}e.serializeEnvironmentVariableCollection=d;function M(b){return new Map(b)}e.deserializeEnvironmentVariableCollection=M}),define(be[90],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestDiffOpType=e.DetailType=e.applyTestItemUpdate=e.TestItemExpandState=e.TestMessageType=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var d;(function(E){E[E.Unset=0]="Unset",E[E.Queued=1]="Queued",E[E.Running=2]="Running",E[E.Passed=3]="Passed",E[E.Failed=4]="Failed",E[E.Skipped=5]="Skipped",E[E.Errored=6]="Errored"})(d=e.TestResultState||(e.TestResultState={}));var M;(function(E){E[E.Run=2]="Run",E[E.Debug=4]="Debug",E[E.Coverage=8]="Coverage",E[E.HasNonDefaultProfile=16]="HasNonDefaultProfile",E[E.HasConfigurable=32]="HasConfigurable"})(M=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var b;(function(E){E[E.Error=0]="Error",E[E.Info=1]="Info"})(b=e.TestMessageType||(e.TestMessageType={}));var R;(function(E){E[E.NotExpandable=0]="NotExpandable",E[E.Expandable=1]="Expandable",E[E.BusyExpanding=2]="BusyExpanding",E[E.Expanded=3]="Expanded"})(R=e.TestItemExpandState||(e.TestItemExpandState={}));const F=(E,n)=>{n.expand!==void 0&&(E.expand=n.expand),n.item!==void 0&&(E.item=E.item?Object.assign(E.item,n.item):n.item)};e.applyTestItemUpdate=F;var C;(function(E){E[E.Function=0]="Function",E[E.Statement=1]="Statement"})(C=e.DetailType||(e.DetailType={}));var _;(function(E){E[E.Add=0]="Add",E[E.Update=1]="Update",E[E.Remove=2]="Remove",E[E.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",E[E.Retire=4]="Retire",E[E.AddTag=5]="AddTag",E[E.RemoveTag=6]="RemoveTag"})(_=e.TestDiffOpType||(e.TestDiffOpType={}));class I{add(n){}update(n){}remove(n,c){}complete(){}}e.IncrementalChangeCollector=I;class t{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(n){const c=this.createChangeCollector();for(const u of n)switch(u[0]){case 0:{const a=u[1];if(a.parent){if(this.items.has(a.parent)){const w=this.items.get(a.parent);w.children.add(a.item.extId);const T=this.createItem(a,w);this.items.set(a.item.extId,T),c.add(T)}}else{const w=this.createItem(a);this.roots.add(w),this.items.set(a.item.extId,w),c.add(w)}a.expand===2&&this.busyControllerCount++;break}case 1:{const a=u[1],w=this.items.get(a.extId);if(!w)break;a.expand!==void 0&&(w.expand===2&&this.busyControllerCount--,a.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(w,a),c.update(w);break}case 2:{const a=this.items.get(u[1]);if(!a)break;a.parent?this.items.get(a.parent).children.delete(a.item.extId):this.roots.delete(a);const w=[[u[1]]];for(;w.length;)for(const T of w.pop()){const S=this.items.get(T);S&&(w.push(S.children),this.items.delete(T),c.remove(S,S!==a),S.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(u[1]);break;case 3:this.updatePendingRoots(u[1]);break;case 5:this._tags.set(u[1].id,u[1]);break;case 6:this._tags.delete(u[1]);break}c.complete()}retireTest(n){}updatePendingRoots(n){this.pendingRootCount+=n}createChangeCollector(){return new I}}e.AbstractIncrementalTestCollection=t}),define(be[67],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var d;(function(R){R.Delimiter="\0"})(d=e.TestIdPathParts||(e.TestIdPathParts={}));var M;(function(R){R[R.IsSame=0]="IsSame",R[R.Disconnected=1]="Disconnected",R[R.IsChild=2]="IsChild",R[R.IsParent=3]="IsParent"})(M=e.TestPosition||(e.TestPosition={}));class b{constructor(F,C=F.length){if(this.path=F,this.viewEnd=C,F.length===0||C<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(F,C,_=F.parent){if(F.id===C)return new b([C]);let I=[F.id];for(let t=_;t&&t.id!==C;t=t.parent)I.push(t.id);return I.push(C),new b(I.reverse())}static isRoot(F){return!F.includes("\0")}static fromString(F){return new b(F.split("\0"))}static join(F,C){return new b([...F.path,C])}static joinToString(F,C){return F.toString()+"\0"+C}static compare(F,C){return F===C?0:C.startsWith(F+"\0")?2:F.startsWith(C+"\0")?3:1}get parentId(){return this.viewEnd>1?new b(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let F=1;F<=this.viewEnd;F++)yield new b(this.path,F)}compare(F){if(typeof F=="string")return b.compare(this.toString(),F);for(let C=0;C<F.viewEnd&&C<this.viewEnd;C++)if(F.path[C]!==this.path[C])return 1;return F.viewEnd>this.viewEnd?2:F.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let F=1;F<this.viewEnd;F++)this.stringifed+="\0",this.stringifed+=this.path[F]}return this.stringifed}}e.TestId=b}),define(be[167],Ee([0,1,17,91,10,23,26,77,136]),function(re,e,d,M,b,R,F,C,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class I{constructor(E,n,c){this._contributedVariables=new Map,this._context=E,this._labelService=n,c&&(this._envVariablesPromise=c.then(u=>this.prepareEnv(u)))}prepareEnv(E){if(F.isWindows){const n=Object.create(null);return Object.keys(E).forEach(c=>{n[c.toLowerCase()]=E[c]}),n}return E}resolveWithEnvironment(E,n,c){return this.recursiveResolve(this.prepareEnv(E),n?n.uri:void 0,c)}async resolveAsync(E,n){return this.recursiveResolve(await this._envVariablesPromise,E?E.uri:void 0,n)}async resolveAnyBase(E,n,c,u){const a=R.deepClone(n);return F.isWindows&&a.windows?Object.keys(a.windows).forEach(w=>a[w]=a.windows[w]):F.isMacintosh&&a.osx?Object.keys(a.osx).forEach(w=>a[w]=a.osx[w]):F.isLinux&&a.linux&&Object.keys(a.linux).forEach(w=>a[w]=a.linux[w]),delete a.windows,delete a.osx,delete a.linux,this.recursiveResolve(await this._envVariablesPromise,E?E.uri:void 0,a,c,u)}async resolveAnyAsync(E,n,c){return this.resolveAnyBase(E,n,c)}async resolveAnyMap(E,n,c){const u=new Map;return{newConfig:await this.resolveAnyBase(E,n,c,u),resolvedVariables:u}}resolveWithInteractionReplace(E,n,c,u){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(E,n,c,u){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(E,n){if(this._contributedVariables.has(E))throw new Error("Variable "+E+" is contributed twice.");this._contributedVariables.set(E,n)}recursiveResolve(E,n,c,u,a){if(b.isString(c))return this.resolveString(E,n,c,u,a);if(b.isArray(c))return c.map(w=>this.recursiveResolve(E,n,w,u,a));if(b.isObject(c)){let w=Object.create(null);return Object.keys(c).forEach(T=>{const S=this.resolveString(E,n,T,u,a);w[S]=this.recursiveResolve(E,n,c[T],u,a)}),w}return c}resolveString(E,n,c,u,a){return c.replace(I.VARIABLE_REGEXP,(T,S)=>{if(S.includes(I.VARIABLE_LHS))return T;let o=this.evaluateSingleVariable(E,T,S,n,u);return a&&a.set(S,o),o!==T&&b.isString(o)&&o.match(I.VARIABLE_REGEXP)&&(o=this.resolveString(E,n,o,u,a)),o})}fsPath(E){return this._labelService?this._labelService.getUriLabel(E,{noPrefix:!0}):E.fsPath}evaluateSingleVariable(E,n,c,u,a){let w;const T=c.split(":");T.length>1&&(c=T[0],w=T[1]);const S=()=>{const y=this._context.getFilePath();if(y)return y;throw new Error((0,_.localize)(0,null,n))},o=()=>{const y=S();if(this._context.getWorkspaceFolderPathForFile){const i=this._context.getWorkspaceFolderPathForFile();if(i)return i}throw new Error((0,_.localize)(1,null,n,d.basename(y)))},f=()=>{if(w){const y=this._context.getFolderUri(w);if(y)return y;throw new Error((0,_.localize)(2,null,n,w))}if(u)return u;throw this._context.getWorkspaceFolderCount()>1?new Error((0,_.localize)(3,null,n)):new Error((0,_.localize)(4,null,n))};switch(c){case"env":if(w){if(E){const y=E[F.isWindows?w.toLowerCase():w];if(b.isString(y))return y}return""}throw new Error((0,_.localize)(5,null,n));case"config":if(w){const y=this._context.getConfigurationValue(u,w);if(b.isUndefinedOrNull(y))throw new Error((0,_.localize)(6,null,n,w));if(b.isObject(y))throw new Error((0,_.localize)(7,null,n,w));return y}throw new Error((0,_.localize)(8,null,n));case"command":return this.resolveFromMap(n,w,a,"command");case"input":return this.resolveFromMap(n,w,a,"input");default:switch(c){case"workspaceRoot":case"workspaceFolder":return(0,C.normalizeDriveLetter)(this.fsPath(f()));case"cwd":return u||w?(0,C.normalizeDriveLetter)(this.fsPath(f())):M.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return d.basename(this.fsPath(f()));case"lineNumber":const y=this._context.getLineNumber();if(y)return y;throw new Error((0,_.localize)(9,null,n));case"selectedText":const i=this._context.getSelectedText();if(i)return i;throw new Error((0,_.localize)(10,null,n));case"file":return S();case"fileWorkspaceFolder":return o();case"relativeFile":return u||w?d.relative(this.fsPath(f()),S()):S();case"relativeFileDirname":const v=d.dirname(S());if(u||w){const h=d.relative(this.fsPath(f()),v);return h.length===0?".":h}return v;case"fileDirname":return d.dirname(S());case"fileExtname":return d.extname(S());case"fileBasename":return d.basename(S());case"fileBasenameNoExtension":const r=d.basename(S());return r.slice(0,r.length-d.extname(r).length);case"fileDirnameBasename":return d.basename(d.dirname(S()));case"execPath":const s=this._context.getExecPath();return s||n;case"execInstallFolder":const l=this._context.getAppRoot();return l||n;case"pathSeparator":return d.sep;default:try{const h=w?`${c}:${w}`:c;return this.resolveFromMap(n,h,a,void 0)}catch(h){return n}}}}resolveFromMap(E,n,c,u){if(n&&c){const a=u===void 0?c[n]:c[u+":"+n];if(typeof a=="string")return a;throw new Error((0,_.localize)(11,null,E))}return E}}e.AbstractVariableResolverService=I,I.VARIABLE_LHS="${",I.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(be[92],Ee([0,1,4,160]),function(re,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,d.createDecorator)("editorGroupsService");var b;(function(a){a[a.UP=0]="UP",a[a.DOWN=1]="DOWN",a[a.LEFT=2]="LEFT",a[a.RIGHT=3]="RIGHT"})(b=e.GroupDirection||(e.GroupDirection={}));var R;(function(a){a[a.HORIZONTAL=0]="HORIZONTAL",a[a.VERTICAL=1]="VERTICAL"})(R=e.GroupOrientation||(e.GroupOrientation={}));var F;(function(a){a[a.FIRST=0]="FIRST",a[a.LAST=1]="LAST",a[a.NEXT=2]="NEXT",a[a.PREVIOUS=3]="PREVIOUS"})(F=e.GroupLocation||(e.GroupLocation={}));var C;(function(a){a[a.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",a[a.EVEN=1]="EVEN",a[a.TOGGLE=2]="TOGGLE"})(C=e.GroupsArrangement||(e.GroupsArrangement={}));var _;(function(a){a[a.COPY_EDITORS=0]="COPY_EDITORS",a[a.MOVE_EDITORS=1]="MOVE_EDITORS"})(_=e.MergeGroupMode||(e.MergeGroupMode={}));function I(a){const w=a;return(0,M.isEditorInput)(w?.editor)&&(0,M.isEditorInput)(w?.replacement)}e.isEditorReplacement=I;var t;(function(a){a[a.CREATION_TIME=0]="CREATION_TIME",a[a.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",a[a.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(t=e.GroupsOrder||(e.GroupsOrder={}));var E;(function(a){a[a.GROUP_ACTIVE=0]="GROUP_ACTIVE",a[a.GROUP_INDEX=1]="GROUP_INDEX",a[a.GROUP_LOCKED=2]="GROUP_LOCKED",a[a.EDITOR_OPEN=3]="EDITOR_OPEN",a[a.EDITOR_CLOSE=4]="EDITOR_CLOSE",a[a.EDITOR_MOVE=5]="EDITOR_MOVE",a[a.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",a[a.EDITOR_LABEL=7]="EDITOR_LABEL",a[a.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",a[a.EDITOR_PIN=9]="EDITOR_PIN",a[a.EDITOR_STICKY=10]="EDITOR_STICKY",a[a.EDITOR_DIRTY=11]="EDITOR_DIRTY"})(E=e.GroupChangeKind||(e.GroupChangeKind={}));var n;(function(a){a[a.NEW_EDITOR=1]="NEW_EDITOR",a[a.MOVE_EDITOR=2]="MOVE_EDITOR",a[a.COPY_EDITOR=3]="COPY_EDITOR"})(n=e.OpenEditorContext||(e.OpenEditorContext={}));function c(a){const w=a;return!!w&&typeof w.id=="number"&&Array.isArray(w.editors)}e.isEditorGroup=c;function u(a){return a.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=u}),define(be[168],Ee([0,1,4,92]),function(re,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,d.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function b(R){const F=R;return typeof R=="number"||(0,M.isEditorGroup)(F)}e.isPreferredGroup=b}),define(be[8],Ee([0,1,12,22,76,229,54,23,10,2,44,59,137,82,48,89,67,168,7]),function(re,e,d,M,b,R,F,C,_,I,t,E,n,c,u,a,w,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var o;(function(de){function ge(W){const{selectionStartLineNumber:we,selectionStartColumn:ke,positionLineNumber:Je,positionColumn:$e}=W,ut=new S.Position(we-1,ke-1),gt=new S.Position(Je-1,$e-1);return new S.Selection(ut,gt)}de.to=ge;function J(W){const{anchor:we,active:ke}=W;return{selectionStartLineNumber:we.line+1,selectionStartColumn:we.character+1,positionLineNumber:ke.line+1,positionColumn:ke.character+1}}de.from=J})(o=e.Selection||(e.Selection={}));var f;(function(de){function ge(W){if(!W)return;const{start:we,end:ke}=W;return{startLineNumber:we.line+1,startColumn:we.character+1,endLineNumber:ke.line+1,endColumn:ke.character+1}}de.from=ge;function J(W){if(!W)return;const{startLineNumber:we,startColumn:ke,endLineNumber:Je,endColumn:$e}=W;return new S.Range(we-1,ke-1,Je-1,$e-1)}de.to=J})(f=e.Range||(e.Range={}));var y;(function(de){function ge(J){switch(J){case 1:return S.StandardTokenType.Comment;case 0:return S.StandardTokenType.Other;case 4:return S.StandardTokenType.RegEx;case 2:return S.StandardTokenType.String}}de.to=ge})(y=e.TokenType||(e.TokenType={}));var i;(function(de){function ge(W){return new S.Position(W.lineNumber-1,W.column-1)}de.to=ge;function J(W){return{lineNumber:W.line+1,column:W.character+1}}de.from=J})(i=e.Position||(e.Position={}));var v;(function(de){function ge(we,ke){return(0,d.coalesce)((0,d.asArray)(we).map(Je=>J(Je,ke)))}de.from=ge;function J(we,ke){if(typeof we=="string")return{$serialized:!0,language:we};if(we)return{$serialized:!0,language:we.language,scheme:W(we.scheme,ke),pattern:typeof we.pattern=="undefined"?void 0:ft.from(we.pattern),exclusive:we.exclusive}}function W(we,ke){return ke&&typeof we=="string"?ke.transformOutgoingScheme(we):we}})(v=e.DocumentSelector||(e.DocumentSelector={}));var r;(function(de){function ge(W){switch(W){case S.DiagnosticTag.Unnecessary:return 1;case S.DiagnosticTag.Deprecated:return 2}}de.from=ge;function J(W){switch(W){case 1:return S.DiagnosticTag.Unnecessary;case 2:return S.DiagnosticTag.Deprecated;default:return}}de.to=J})(r=e.DiagnosticTag||(e.DiagnosticTag={}));var s;(function(de){function ge(W){let we;return W.code&&((0,_.isString)(W.code)||(0,_.isNumber)(W.code)?we=String(W.code):we={value:String(W.code.value),target:W.code.target}),{...f.from(W.range),message:W.message,source:W.source,code:we,severity:h.from(W.severity),relatedInformation:W.relatedInformation&&W.relatedInformation.map(l.from),tags:Array.isArray(W.tags)?(0,d.coalesce)(W.tags.map(r.from)):void 0}}de.from=ge;function J(W){const we=new S.Diagnostic(f.to(W),W.message,h.to(W.severity));return we.source=W.source,we.code=(0,_.isString)(W.code)?W.code:W.code?.value,we.relatedInformation=W.relatedInformation&&W.relatedInformation.map(l.to),we.tags=W.tags&&(0,d.coalesce)(W.tags.map(r.to)),we}de.to=J})(s=e.Diagnostic||(e.Diagnostic={}));var l;(function(de){function ge(W){return{...f.from(W.location.range),message:W.message,resource:W.location.uri}}de.from=ge;function J(W){return new S.DiagnosticRelatedInformation(new S.Location(W.resource,f.to(W)),W.message)}de.to=J})(l=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var h;(function(de){function ge(W){switch(W){case S.DiagnosticSeverity.Error:return c.MarkerSeverity.Error;case S.DiagnosticSeverity.Warning:return c.MarkerSeverity.Warning;case S.DiagnosticSeverity.Information:return c.MarkerSeverity.Info;case S.DiagnosticSeverity.Hint:return c.MarkerSeverity.Hint}return c.MarkerSeverity.Error}de.from=ge;function J(W){switch(W){case c.MarkerSeverity.Info:return S.DiagnosticSeverity.Information;case c.MarkerSeverity.Warning:return S.DiagnosticSeverity.Warning;case c.MarkerSeverity.Error:return S.DiagnosticSeverity.Error;case c.MarkerSeverity.Hint:return S.DiagnosticSeverity.Hint;default:return S.DiagnosticSeverity.Error}}de.to=J})(h=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var p;(function(de){function ge(W){return typeof W=="number"&&W>=S.ViewColumn.One?W-1:W===S.ViewColumn.Beside?T.SIDE_GROUP:T.ACTIVE_GROUP}de.from=ge;function J(W){if(typeof W=="number"&&W>=0)return W+1;throw new Error("invalid 'EditorGroupColumn'")}de.to=J})(p=e.ViewColumn||(e.ViewColumn={}));function k(de){return typeof de.range!="undefined"}function P(de){return de.length===0?!0:!!k(de[0])}e.isDecorationOptionsArr=P;var g;(function(de){function ge($e){return $e.map(de.from)}de.fromMany=ge;function J($e){return $e&&typeof $e=="object"&&typeof $e.language=="string"&&typeof $e.value=="string"}function W($e){let ut;if(J($e)){const{language:st,value:Et}=$e;ut={value:"```"+st+`
`+Et+"\n```\n"}}else S.MarkdownString.isMarkdownString($e)?ut={value:$e.value,isTrusted:$e.isTrusted,supportThemeIcons:$e.supportThemeIcons,supportHtml:$e.supportHtml}:typeof $e=="string"?ut={value:$e}:ut={value:""};const gt=Object.create(null);ut.uris=gt;const at=st=>{try{let Et=I.URI.parse(st,!0);Et=Et.with({query:we(Et.query,gt)}),gt[st]=Et}catch(Et){}return""},dt=new R.Renderer;return dt.link=at,dt.image=st=>at(b.parseHrefAndDimensions(st).href),R(ut.value,{renderer:dt}),ut}de.from=W;function we($e,ut){if(!$e)return $e;let gt;try{gt=(0,F.parse)($e)}catch(dt){}if(!gt)return $e;let at=!1;return gt=(0,C.cloneAndChange)(gt,dt=>{if(I.URI.isUri(dt)){const st=`__uri_${Math.random().toString(16).slice(2,8)}`;return ut[st]=dt,at=!0,st}else return}),at?JSON.stringify(gt):$e}function ke($e){const ut=new S.MarkdownString($e.value,$e.supportThemeIcons);return ut.isTrusted=$e.isTrusted,ut.supportHtml=$e.supportHtml,ut}de.to=ke;function Je($e){if(!!$e)return typeof $e=="string"?$e:de.from($e)}de.fromStrict=Je})(g=e.MarkdownString||(e.MarkdownString={}));function D(de){return P(de)?de.map(ge=>({range:f.from(ge.range),hoverMessage:Array.isArray(ge.hoverMessage)?g.fromMany(ge.hoverMessage):ge.hoverMessage?g.from(ge.hoverMessage):void 0,renderOptions:ge.renderOptions})):de.map(ge=>({range:f.from(ge)}))}e.fromRangeOrRangeWithMessage=D;function m(de){return typeof de=="undefined"?de:typeof de=="string"?I.URI.file(de):de}e.pathOrURIToURI=m;var A;(function(de){function ge(J){return typeof J=="undefined"?J:{contentText:J.contentText,contentIconPath:J.contentIconPath?m(J.contentIconPath):void 0,border:J.border,borderColor:J.borderColor,fontStyle:J.fontStyle,fontWeight:J.fontWeight,textDecoration:J.textDecoration,color:J.color,backgroundColor:J.backgroundColor,margin:J.margin,width:J.width,height:J.height}}de.from=ge})(A=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var L;(function(de){function ge(J){return typeof J=="undefined"?J:{backgroundColor:J.backgroundColor,outline:J.outline,outlineColor:J.outlineColor,outlineStyle:J.outlineStyle,outlineWidth:J.outlineWidth,border:J.border,borderColor:J.borderColor,borderRadius:J.borderRadius,borderSpacing:J.borderSpacing,borderStyle:J.borderStyle,borderWidth:J.borderWidth,fontStyle:J.fontStyle,fontWeight:J.fontWeight,textDecoration:J.textDecoration,cursor:J.cursor,color:J.color,opacity:J.opacity,letterSpacing:J.letterSpacing,gutterIconPath:J.gutterIconPath?m(J.gutterIconPath):void 0,gutterIconSize:J.gutterIconSize,overviewRulerColor:J.overviewRulerColor,before:J.before?A.from(J.before):void 0,after:J.after?A.from(J.after):void 0}}de.from=ge})(L=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var V;(function(de){function ge(J){if(typeof J=="undefined")return J;switch(J){case S.DecorationRangeBehavior.OpenOpen:return 0;case S.DecorationRangeBehavior.ClosedClosed:return 1;case S.DecorationRangeBehavior.OpenClosed:return 2;case S.DecorationRangeBehavior.ClosedOpen:return 3}}de.from=ge})(V=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var G;(function(de){function ge(J){return{isWholeLine:J.isWholeLine,rangeBehavior:J.rangeBehavior?V.from(J.rangeBehavior):void 0,overviewRulerLane:J.overviewRulerLane,light:J.light?L.from(J.light):void 0,dark:J.dark?L.from(J.dark):void 0,backgroundColor:J.backgroundColor,outline:J.outline,outlineColor:J.outlineColor,outlineStyle:J.outlineStyle,outlineWidth:J.outlineWidth,border:J.border,borderColor:J.borderColor,borderRadius:J.borderRadius,borderSpacing:J.borderSpacing,borderStyle:J.borderStyle,borderWidth:J.borderWidth,fontStyle:J.fontStyle,fontWeight:J.fontWeight,textDecoration:J.textDecoration,cursor:J.cursor,color:J.color,opacity:J.opacity,letterSpacing:J.letterSpacing,gutterIconPath:J.gutterIconPath?m(J.gutterIconPath):void 0,gutterIconSize:J.gutterIconSize,overviewRulerColor:J.overviewRulerColor,before:J.before?A.from(J.before):void 0,after:J.after?A.from(J.after):void 0}}de.from=ge})(G=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var U;(function(de){function ge(W){return{text:W.newText,eol:W.newEol&&fe.from(W.newEol),range:f.from(W.range)}}de.from=ge;function J(W){const we=new S.TextEdit(f.to(W.range),W.text);return we.newEol=typeof W.eol=="undefined"?void 0:fe.to(W.eol),we}de.to=J})(U=e.TextEdit||(e.TextEdit={}));var K;(function(de){function ge(W,we,ke){const Je={edits:[]};if(W instanceof S.WorkspaceEdit)for(let $e of W._allEntries())if($e._type===1)Je.edits.push({_type:1,oldUri:$e.from,newUri:$e.to,options:$e.options,metadata:$e.metadata});else if($e._type===2){const ut=we?.getDocument($e.uri);Je.edits.push({_type:2,resource:$e.uri,edit:U.from($e.edit),modelVersionId:ut?.version,metadata:$e.metadata})}else $e._type===3?Je.edits.push({_type:3,metadata:$e.metadata,resource:$e.uri,edit:$e.edit,notebookMetadata:$e.notebookMetadata,notebookVersionId:ke?.getNotebookDocument($e.uri,!0)?.apiNotebook.version}):$e._type===5&&Je.edits.push({_type:3,metadata:$e.metadata,resource:$e.uri,notebookVersionId:ke?.getNotebookDocument($e.uri,!0)?.apiNotebook.version,edit:{editType:1,index:$e.index,count:$e.count,cells:$e.cells.map(Xe.from)}});return Je}de.from=ge;function J(W){const we=new S.WorkspaceEdit;for(const ke of W.edits)ke.edit?we.replace(I.URI.revive(ke.resource),f.to(ke.edit.range),ke.edit.text):we.renameFile(I.URI.revive(ke.oldUri),I.URI.revive(ke.newUri),ke.options);return we}de.to=J})(K=e.WorkspaceEdit||(e.WorkspaceEdit={}));var $;(function(de){const ge=Object.create(null);ge[S.SymbolKind.File]=0,ge[S.SymbolKind.Module]=1,ge[S.SymbolKind.Namespace]=2,ge[S.SymbolKind.Package]=3,ge[S.SymbolKind.Class]=4,ge[S.SymbolKind.Method]=5,ge[S.SymbolKind.Property]=6,ge[S.SymbolKind.Field]=7,ge[S.SymbolKind.Constructor]=8,ge[S.SymbolKind.Enum]=9,ge[S.SymbolKind.Interface]=10,ge[S.SymbolKind.Function]=11,ge[S.SymbolKind.Variable]=12,ge[S.SymbolKind.Constant]=13,ge[S.SymbolKind.String]=14,ge[S.SymbolKind.Number]=15,ge[S.SymbolKind.Boolean]=16,ge[S.SymbolKind.Array]=17,ge[S.SymbolKind.Object]=18,ge[S.SymbolKind.Key]=19,ge[S.SymbolKind.Null]=20,ge[S.SymbolKind.EnumMember]=21,ge[S.SymbolKind.Struct]=22,ge[S.SymbolKind.Event]=23,ge[S.SymbolKind.Operator]=24,ge[S.SymbolKind.TypeParameter]=25;function J(we){return typeof ge[we]=="number"?ge[we]:6}de.from=J;function W(we){for(const ke in ge)if(ge[ke]===we)return Number(ke);return S.SymbolKind.Property}de.to=W})($=e.SymbolKind||(e.SymbolKind={}));var B;(function(de){function ge(W){switch(W){case S.SymbolTag.Deprecated:return 1}}de.from=ge;function J(W){switch(W){case 1:return S.SymbolTag.Deprecated}}de.to=J})(B=e.SymbolTag||(e.SymbolTag={}));var z;(function(de){function ge(W){return{name:W.name,kind:$.from(W.kind),tags:W.tags&&W.tags.map(B.from),containerName:W.containerName,location:se.from(W.location)}}de.from=ge;function J(W){const we=new S.SymbolInformation(W.name,$.to(W.kind),W.containerName,se.to(W.location));return we.tags=W.tags&&W.tags.map(B.to),we}de.to=J})(z=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var Y;(function(de){function ge(W){const we={name:W.name||"!!MISSING: name!!",detail:W.detail,range:f.from(W.range),selectionRange:f.from(W.selectionRange),kind:$.from(W.kind),tags:W.tags?.map(B.from)??[]};return W.children&&(we.children=W.children.map(ge)),we}de.from=ge;function J(W){const we=new S.DocumentSymbol(W.name,W.detail,$.to(W.kind),f.to(W.range),f.to(W.selectionRange));return(0,d.isNonEmptyArray)(W.tags)&&(we.tags=W.tags.map(B.to)),W.children&&(we.children=W.children.map(J)),we}de.to=J})(Y=e.DocumentSymbol||(e.DocumentSymbol={}));var ne;(function(de){function ge(W){const we=new S.CallHierarchyItem($.to(W.kind),W.name,W.detail||"",I.URI.revive(W.uri),f.to(W.range),f.to(W.selectionRange));return we._sessionId=W._sessionId,we._itemId=W._itemId,we}de.to=ge;function J(W,we,ke){if(we=we??W._sessionId,ke=ke??W._itemId,we===void 0||ke===void 0)throw new Error("invalid item");return{_sessionId:we,_itemId:ke,name:W.name,detail:W.detail,kind:$.from(W.kind),uri:W.uri,range:f.from(W.range),selectionRange:f.from(W.selectionRange),tags:W.tags?.map(B.from)}}de.from=J})(ne=e.CallHierarchyItem||(e.CallHierarchyItem={}));var j;(function(de){function ge(J){return new S.CallHierarchyIncomingCall(ne.to(J.from),J.fromRanges.map(W=>f.to(W)))}de.to=ge})(j=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var le;(function(de){function ge(J){return new S.CallHierarchyOutgoingCall(ne.to(J.to),J.fromRanges.map(W=>f.to(W)))}de.to=ge})(le=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var se;(function(de){function ge(W){return{range:W.range&&f.from(W.range),uri:W.uri}}de.from=ge;function J(W){return new S.Location(I.URI.revive(W.uri),f.to(W.range))}de.to=J})(se=e.location||(e.location={}));var ve;(function(de){function ge(W){const we=W,ke=W;return{originSelectionRange:we.originSelectionRange?f.from(we.originSelectionRange):void 0,uri:we.targetUri?we.targetUri:ke.uri,range:f.from(we.targetRange?we.targetRange:ke.range),targetSelectionRange:we.targetSelectionRange?f.from(we.targetSelectionRange):void 0}}de.from=ge;function J(W){return{targetUri:I.URI.revive(W.uri),targetRange:f.to(W.range),targetSelectionRange:W.targetSelectionRange?f.to(W.targetSelectionRange):void 0,originSelectionRange:W.originSelectionRange?f.to(W.originSelectionRange):void 0}}de.to=J})(ve=e.DefinitionLink||(e.DefinitionLink={}));var Fe;(function(de){function ge(W){return{range:f.from(W.range),contents:g.fromMany(W.contents)}}de.from=ge;function J(W){return new S.Hover(W.contents.map(g.to),f.to(W.range))}de.to=J})(Fe=e.Hover||(e.Hover={}));var Me;(function(de){function ge(W){return{range:f.from(W.range),expression:W.expression}}de.from=ge;function J(W){return new S.EvaluatableExpression(f.to(W.range),W.expression)}de.to=J})(Me=e.EvaluatableExpression||(e.EvaluatableExpression={}));var Ne;(function(de){function ge(W){if(W instanceof S.InlineValueText)return{type:"text",range:f.from(W.range),text:W.text};if(W instanceof S.InlineValueVariableLookup)return{type:"variable",range:f.from(W.range),variableName:W.variableName,caseSensitiveLookup:W.caseSensitiveLookup};if(W instanceof S.InlineValueEvaluatableExpression)return{type:"expression",range:f.from(W.range),expression:W.expression};throw new Error("Unknown 'InlineValue' type")}de.from=ge;function J(W){switch(W.type){case"text":return{range:f.to(W.range),text:W.text};case"variable":return{range:f.to(W.range),variableName:W.variableName,caseSensitiveLookup:W.caseSensitiveLookup};case"expression":return{range:f.to(W.range),expression:W.expression}}}de.to=J})(Ne=e.InlineValue||(e.InlineValue={}));var Ye;(function(de){function ge(W){return{frameId:W.frameId,stoppedLocation:f.from(W.stoppedLocation)}}de.from=ge;function J(W){return new S.InlineValueContext(W.frameId,f.to(W.stoppedLocation))}de.to=J})(Ye=e.InlineValueContext||(e.InlineValueContext={}));var Ve;(function(de){function ge(W){return{range:f.from(W.range),kind:W.kind}}de.from=ge;function J(W){return new S.DocumentHighlight(f.to(W.range),W.kind)}de.to=J})(Ve=e.DocumentHighlight||(e.DocumentHighlight={}));var qe;(function(de){function ge(J){switch(J){case 1:return S.CompletionTriggerKind.TriggerCharacter;case 2:return S.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return S.CompletionTriggerKind.Invoke}}de.to=ge})(qe=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var x;(function(de){function ge(J){return{triggerKind:qe.to(J.triggerKind),triggerCharacter:J.triggerCharacter}}de.to=ge})(x=e.CompletionContext||(e.CompletionContext={}));var Q;(function(de){function ge(W){switch(W){case S.CompletionItemTag.Deprecated:return 1}}de.from=ge;function J(W){switch(W){case 1:return S.CompletionItemTag.Deprecated}}de.to=J})(Q=e.CompletionItemTag||(e.CompletionItemTag={}));var te;(function(de){const ge=new Map([[S.CompletionItemKind.Method,0],[S.CompletionItemKind.Function,1],[S.CompletionItemKind.Constructor,2],[S.CompletionItemKind.Field,3],[S.CompletionItemKind.Variable,4],[S.CompletionItemKind.Class,5],[S.CompletionItemKind.Interface,7],[S.CompletionItemKind.Struct,6],[S.CompletionItemKind.Module,8],[S.CompletionItemKind.Property,9],[S.CompletionItemKind.Unit,12],[S.CompletionItemKind.Value,13],[S.CompletionItemKind.Constant,14],[S.CompletionItemKind.Enum,15],[S.CompletionItemKind.EnumMember,16],[S.CompletionItemKind.Keyword,17],[S.CompletionItemKind.Snippet,27],[S.CompletionItemKind.Text,18],[S.CompletionItemKind.Color,19],[S.CompletionItemKind.File,20],[S.CompletionItemKind.Reference,21],[S.CompletionItemKind.Folder,23],[S.CompletionItemKind.Event,10],[S.CompletionItemKind.Operator,11],[S.CompletionItemKind.TypeParameter,24],[S.CompletionItemKind.Issue,26],[S.CompletionItemKind.User,25]]);function J(ke){return ge.get(ke)??9}de.from=J;const W=new Map([[0,S.CompletionItemKind.Method],[1,S.CompletionItemKind.Function],[2,S.CompletionItemKind.Constructor],[3,S.CompletionItemKind.Field],[4,S.CompletionItemKind.Variable],[5,S.CompletionItemKind.Class],[7,S.CompletionItemKind.Interface],[6,S.CompletionItemKind.Struct],[8,S.CompletionItemKind.Module],[9,S.CompletionItemKind.Property],[12,S.CompletionItemKind.Unit],[13,S.CompletionItemKind.Value],[14,S.CompletionItemKind.Constant],[15,S.CompletionItemKind.Enum],[16,S.CompletionItemKind.EnumMember],[17,S.CompletionItemKind.Keyword],[27,S.CompletionItemKind.Snippet],[18,S.CompletionItemKind.Text],[19,S.CompletionItemKind.Color],[20,S.CompletionItemKind.File],[21,S.CompletionItemKind.Reference],[23,S.CompletionItemKind.Folder],[10,S.CompletionItemKind.Event],[11,S.CompletionItemKind.Operator],[24,S.CompletionItemKind.TypeParameter],[25,S.CompletionItemKind.User],[26,S.CompletionItemKind.Issue]]);function we(ke){return W.get(ke)??S.CompletionItemKind.Property}de.to=we})(te=e.CompletionItemKind||(e.CompletionItemKind={}));var ae;(function(de){function ge(J,W){const we=new S.CompletionItem(J.label);return we.insertText=J.insertText,we.kind=te.to(J.kind),we.tags=J.tags?.map(Q.to),we.detail=J.detail,we.documentation=b.isMarkdownString(J.documentation)?g.to(J.documentation):J.documentation,we.sortText=J.sortText,we.filterText=J.filterText,we.preselect=J.preselect,we.commitCharacters=J.commitCharacters,t.Range.isIRange(J.range)?we.range=f.to(J.range):typeof J.range=="object"&&(we.range={inserting:f.to(J.range.insert),replacing:f.to(J.range.replace)}),we.keepWhitespace=typeof J.insertTextRules=="undefined"?!1:Boolean(J.insertTextRules&1),typeof J.insertTextRules!="undefined"&&J.insertTextRules&4?we.insertText=new S.SnippetString(J.insertText):(we.insertText=J.insertText,we.textEdit=we.range instanceof S.Range?new S.TextEdit(we.range,we.insertText):void 0),J.additionalTextEdits&&J.additionalTextEdits.length>0&&(we.additionalTextEdits=J.additionalTextEdits.map(ke=>U.to(ke))),we.command=W&&J.command?W.fromInternal(J.command):void 0,we}de.to=ge})(ae=e.CompletionItem||(e.CompletionItem={}));var q;(function(de){function ge(W){return{label:W.label,documentation:W.documentation?g.fromStrict(W.documentation):void 0}}de.from=ge;function J(W){return{label:W.label,documentation:b.isMarkdownString(W.documentation)?g.to(W.documentation):W.documentation}}de.to=J})(q=e.ParameterInformation||(e.ParameterInformation={}));var oe;(function(de){function ge(W){return{label:W.label,documentation:W.documentation?g.fromStrict(W.documentation):void 0,parameters:Array.isArray(W.parameters)?W.parameters.map(q.from):[],activeParameter:W.activeParameter}}de.from=ge;function J(W){return{label:W.label,documentation:b.isMarkdownString(W.documentation)?g.to(W.documentation):W.documentation,parameters:Array.isArray(W.parameters)?W.parameters.map(q.to):[],activeParameter:W.activeParameter}}de.to=J})(oe=e.SignatureInformation||(e.SignatureInformation={}));var he;(function(de){function ge(W){return{activeSignature:W.activeSignature,activeParameter:W.activeParameter,signatures:Array.isArray(W.signatures)?W.signatures.map(oe.from):[]}}de.from=ge;function J(W){return{activeSignature:W.activeSignature,activeParameter:W.activeParameter,signatures:Array.isArray(W.signatures)?W.signatures.map(oe.to):[]}}de.to=J})(he=e.SignatureHelp||(e.SignatureHelp={}));var Te;(function(de){function ge(W){return{text:W.text,position:i.from(W.position),kind:Ue.from(W.kind??S.InlayHintKind.Other),whitespaceBefore:W.whitespaceBefore,whitespaceAfter:W.whitespaceAfter}}de.from=ge;function J(W){const we=new S.InlayHint(W.text,i.to(W.position),Ue.to(W.kind));return we.whitespaceAfter=W.whitespaceAfter,we.whitespaceBefore=W.whitespaceBefore,we}de.to=J})(Te=e.InlayHint||(e.InlayHint={}));var Ue;(function(de){function ge(W){return W}de.from=ge;function J(W){return W}de.to=J})(Ue=e.InlayHintKind||(e.InlayHintKind={}));var He;(function(de){function ge(W){return{range:f.from(W.range),url:W.target,tooltip:W.tooltip}}de.from=ge;function J(W){let we;if(W.url)try{we=typeof W.url=="string"?I.URI.parse(W.url,!0):I.URI.revive(W.url)}catch(ke){}return new S.DocumentLink(f.to(W.range),we)}de.to=J})(He=e.DocumentLink||(e.DocumentLink={}));var Ke;(function(de){function ge(W){const we=new S.ColorPresentation(W.label);return W.textEdit&&(we.textEdit=U.to(W.textEdit)),W.additionalTextEdits&&(we.additionalTextEdits=W.additionalTextEdits.map(ke=>U.to(ke))),we}de.to=ge;function J(W){return{label:W.label,textEdit:W.textEdit?U.from(W.textEdit):void 0,additionalTextEdits:W.additionalTextEdits?W.additionalTextEdits.map(we=>U.from(we)):void 0}}de.from=J})(Ke=e.ColorPresentation||(e.ColorPresentation={}));var ye;(function(de){function ge(W){return new S.Color(W[0],W[1],W[2],W[3])}de.to=ge;function J(W){return[W.red,W.green,W.blue,W.alpha]}de.from=J})(ye=e.Color||(e.Color={}));var nt;(function(de){function ge(W){return{range:f.from(W.range)}}de.from=ge;function J(W){return new S.SelectionRange(f.to(W.range))}de.to=J})(nt=e.SelectionRange||(e.SelectionRange={}));var H;(function(de){function ge(J){switch(J){case 2:return S.TextDocumentSaveReason.AfterDelay;case 1:return S.TextDocumentSaveReason.Manual;case 3:case 4:return S.TextDocumentSaveReason.FocusOut}}de.to=ge})(H=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var X;(function(de){function ge(W){switch(W){case S.TextEditorLineNumbersStyle.Off:return 0;case S.TextEditorLineNumbersStyle.Relative:return 2;case S.TextEditorLineNumbersStyle.On:default:return 1}}de.from=ge;function J(W){switch(W){case 0:return S.TextEditorLineNumbersStyle.Off;case 2:return S.TextEditorLineNumbersStyle.Relative;case 1:default:return S.TextEditorLineNumbersStyle.On}}de.to=J})(X=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var fe;(function(de){function ge(W){if(W===S.EndOfLine.CRLF)return 1;if(W===S.EndOfLine.LF)return 0}de.from=ge;function J(W){if(W===1)return S.EndOfLine.CRLF;if(W===0)return S.EndOfLine.LF}de.to=J})(fe=e.EndOfLine||(e.EndOfLine={}));var xe;(function(de){function ge(J){if(typeof J=="object")return J.viewId;switch(J){case S.ProgressLocation.SourceControl:return 3;case S.ProgressLocation.Window:return 10;case S.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}de.from=ge})(xe=e.ProgressLocation||(e.ProgressLocation={}));var Qe;(function(de){function ge(J){const W={start:J.start+1,end:J.end+1};return J.kind&&(W.kind=rt.from(J.kind)),W}de.from=ge})(Qe=e.FoldingRange||(e.FoldingRange={}));var rt;(function(de){function ge(J){if(J)switch(J){case S.FoldingRangeKind.Comment:return E.FoldingRangeKind.Comment;case S.FoldingRangeKind.Imports:return E.FoldingRangeKind.Imports;case S.FoldingRangeKind.Region:return E.FoldingRangeKind.Region}}de.from=ge})(rt=e.FoldingRangeKind||(e.FoldingRangeKind={}));var ct;(function(de){function ge(J){if(J)return{pinned:typeof J.preview=="boolean"?!J.preview:void 0,inactive:J.background,preserveFocus:J.preserveFocus,selection:typeof J.selection=="object"?f.from(J.selection):void 0,override:typeof J.override=="boolean"?n.EditorResolution.DISABLED:void 0}}de.from=ge})(ct=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var ft;(function(de){function ge(W){return W instanceof S.RelativePattern||typeof W=="string"?W:J(W)?new S.RelativePattern(W.base,W.pattern):W}de.from=ge;function J(W){const we=W;return we&&typeof we.base=="string"&&typeof we.pattern=="string"}})(ft=e.GlobPattern||(e.GlobPattern={}));var Pt;(function(de){function ge(J){if(J){if(Array.isArray(J))return J.map(ge);if(typeof J=="string")return J;{const W=J;return{language:W.language,scheme:W.scheme,pattern:typeof W.pattern=="undefined"?void 0:ft.from(W.pattern),exclusive:W.exclusive}}}else return}de.from=ge})(Pt=e.LanguageSelector||(e.LanguageSelector={}));var mt;(function(de){function ge(W){return{start:W.start,end:W.end}}de.from=ge;function J(W){return new S.NotebookRange(W.start,W.end)}de.to=J})(mt=e.NotebookRange||(e.NotebookRange={}));var St;(function(de){function ge(W){return{timing:typeof W.runStartTime=="number"&&typeof W.runEndTime=="number"?{startTime:W.runStartTime,endTime:W.runEndTime}:void 0,executionOrder:W.executionOrder,success:W.lastRunSuccess}}de.to=ge;function J(W){return{lastRunSuccess:W.success,runStartTime:W.timing?.startTime,runEndTime:W.timing?.endTime,executionOrder:W.executionOrder}}de.from=J})(St=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var Ct;(function(de){function ge(W){switch(W){case S.NotebookCellKind.Markup:return a.CellKind.Markup;case S.NotebookCellKind.Code:default:return a.CellKind.Code}}de.from=ge;function J(W){switch(W){case a.CellKind.Markup:return S.NotebookCellKind.Markup;case a.CellKind.Code:default:return S.NotebookCellKind.Code}}de.to=J})(Ct=e.NotebookCellKind||(e.NotebookCellKind={}));var pt;(function(de){function ge(W){const we={metadata:W.metadata??Object.create(null),cells:[]};for(let ke of W.cells)S.NotebookCellData.validate(ke),we.cells.push(Xe.from(ke));return we}de.from=ge;function J(W){const we=new S.NotebookData(W.cells.map(Xe.to));return(0,_.isEmptyObject)(W.metadata)||(we.metadata=W.metadata),we}de.to=J})(pt=e.NotebookData||(e.NotebookData={}));var Xe;(function(de){function ge(W){return{cellKind:Ct.from(W.kind),language:W.languageId,mime:W.mime,source:W.value,metadata:W.metadata,internalMetadata:St.from(W.executionSummary??{}),outputs:W.outputs?W.outputs.map(Pe.from):[]}}de.from=ge;function J(W){return new S.NotebookCellData(Ct.to(W.cellKind),W.source,W.language,W.mime,W.outputs?W.outputs.map(Pe.to):void 0,W.metadata,W.internalMetadata?St.to(W.internalMetadata):void 0)}de.to=J})(Xe=e.NotebookCellData||(e.NotebookCellData={}));var _t;(function(de){function ge(W){return{mime:W.mime,valueBytes:M.VSBuffer.wrap(W.data)}}de.from=ge;function J(W){return new S.NotebookCellOutputItem(W.valueBytes.buffer,W.mime)}de.to=J})(_t=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var Pe;(function(de){function ge(W){return{outputId:W.id,items:W.items.map(_t.from),metadata:W.metadata}}de.from=ge;function J(W){const we=W.items.map(_t.to);return new S.NotebookCellOutput(we,W.outputId,W.metadata)}de.to=J})(Pe=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Se;(function(de){function ge(ke){if(ke!=null){if(ke instanceof S.RelativePattern||typeof ke=="string")return ke;if(we(ke))return new S.RelativePattern(ke.base,ke.pattern);if(W(ke))return{include:ft.from(ke.include)||void 0,exclude:ft.from(ke.exclude)||void 0}}}de.from=ge;function J(ke){return typeof ke=="string"?ke:we(ke)?{base:ke.base,pattern:ke.pattern}:{include:ke.include,exclude:ke.exclude}}de.to=J;function W(ke){const Je=ke,$e=ft.from(Je.include);if(!($e&&$e instanceof S.RelativePattern||typeof $e=="string"))return!1;const ut=ft.from(Je.exclude);return!!(ut&&ut instanceof S.RelativePattern||typeof ut=="string")}function we(ke){const Je=ke;return Je&&typeof Je.base=="string"&&typeof Je.pattern=="string"}})(Se=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var De;(function(de){function ge(J){return{backgroundColor:J.backgroundColor,borderColor:J.borderColor,top:J.top?A.from(J.top):void 0}}de.from=ge})(De=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var ee;(function(de){function ge(J,W,we){const ke=typeof J.command=="string"?{title:"",command:J.command}:J.command;return{alignment:J.alignment===S.NotebookCellStatusBarAlignment.Left?1:2,command:W.toInternal(ke,we),text:J.text,tooltip:J.tooltip,accessibilityInformation:J.accessibilityInformation,priority:J.priority}}de.from=ge})(ee=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var ue;(function(de){function ge(J){return{transientOutputs:J?.transientOutputs??!1,transientCellMetadata:J?.transientCellMetadata??{},transientDocumentMetadata:J?.transientDocumentMetadata??{}}}de.from=ge})(ue=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var pe;(function(de){function ge(W){return{uri:W.uri,provides:W.provides}}de.from=ge;function J(W){return new S.NotebookRendererScript(I.URI.revive(W.uri),W.provides)}de.to=J})(pe=e.NotebookRendererScript||(e.NotebookRendererScript={}));var me;(function(de){function ge(W){return{message:g.fromStrict(W.message)||"",type:0,expected:W.expectedOutput,actual:W.actualOutput,location:W.location?se.from(W.location):void 0}}de.from=ge;function J(W){const we=new S.TestMessage(typeof W.message=="string"?W.message:g.to(W.message));return we.actualOutput=W.actual,we.expectedOutput=W.expected,we.location=W.location?se.to(W.location):void 0,we}de.to=J})(me=e.TestMessage||(e.TestMessage={}));var Ie;(function(de){let ge;(function(J){J.Delimiter="\0"})(ge||(ge={})),de.namespace=(J,W)=>J+"\0"+W,de.denamespace=J=>{const W=J.indexOf("\0");return{ctrlId:J.slice(0,W),tagId:J.slice(W+1)}}})(Ie=e.TestTag||(e.TestTag={}));var Be;(function(de){function ge(ke){const Je=(0,u.getPrivateApiFor)(ke).controllerId;return{extId:w.TestId.fromExtHostTestItem(ke,Je).toString(),label:ke.label,uri:ke.uri,tags:ke.tags.map($e=>Ie.namespace(Je,$e.id)),range:f.from(ke.range)||null,description:ke.description||null,error:ke.error&&g.fromStrict(ke.error)||null}}de.from=ge;function J(ke){return{id:w.TestId.fromString(ke.extId).localId,label:ke.label,uri:I.URI.revive(ke.uri),tags:(ke.tags||[]).map(Je=>{const{tagId:$e}=Ie.denamespace(Je);return new S.TestTag($e)}),range:f.to(ke.range||void 0),invalidateResults:()=>{},canResolveChildren:!1,busy:!1,description:ke.description||void 0}}de.toPlain=J;function W(ke){const Je=w.TestId.fromString(ke.extId),$e=new u.TestItemImpl(Je.controllerId,Je.localId,ke.label,I.URI.revive(ke.uri));return $e.range=f.to(ke.range||void 0),$e.description=ke.description||void 0,$e}function we(ke){let Je;for(const $e of ke.tests){const ut=W($e.item);(0,u.getPrivateApiFor)(ut).parent=Je,Je=ut}return Je}de.toItemFromContext=we})(Be=e.TestItem||(e.TestItem={})),function(de){function ge(W){return{id:W.id}}de.from=ge;function J(W){return new S.TestTag(W.id)}de.to=J}(Ie=e.TestTag||(e.TestTag={}));var Oe;(function(de){const ge=(W,we)=>{const ke={...Be.toPlain(W.item),parent:void 0,taskStates:W.tasks.map(Je=>({state:Je.state,duration:Je.duration,messages:Je.messages.filter($e=>$e.type===0).map(me.to)})),children:W.children.map(Je=>we.get(Je)).filter(_.isDefined).map(Je=>ge(Je,we))};for(const Je of ke.children)Je.parent=ke;return ke};function J(W){const we=[],ke=new Map;for(const Je of W.items)ke.set(Je.item.extId,Je),W.request.targets.some($e=>$e.controllerId===Je.controllerId&&$e.testIds.includes(Je.item.extId))&&we.push(Je);return{completedAt:W.completedAt,results:we.map(Je=>ge(Je,ke))}}de.to=J})(Oe=e.TestResults||(e.TestResults={}));var je;(function(de){function ge(ke){return{covered:ke.covered,total:ke.covered}}function J(ke){return"line"in ke?i.from(ke):f.from(ke)}function W(ke){return"branches"in ke?{count:ke.executionCount,location:J(ke.location),type:1,branches:ke.branches.length?ke.branches.map(Je=>({count:Je.executionCount,location:Je.location&&J(Je.location)})):void 0}:{type:0,count:ke.executionCount,location:J(ke.location)}}de.fromDetailed=W;function we(ke){return{uri:ke.uri,statement:ge(ke.statementCoverage),branch:ke.branchCoverage&&ge(ke.branchCoverage),function:ke.functionCoverage&&ge(ke.functionCoverage),details:ke.detailedCoverage?.map(W)}}de.fromFile=we})(je=e.TestCoverage||(e.TestCoverage={}));var et;(function(de){function ge(J){switch(J){case 1:return S.CodeActionTriggerKind.Invoke;case 2:return S.CodeActionTriggerKind.Automatic}}de.to=ge})(et=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Le;(function(de){function ge(W){const we=new S.TypeHierarchyItem($.to(W.kind),W.name,W.detail||"",I.URI.revive(W.uri),f.to(W.range),f.to(W.selectionRange));return we._sessionId=W._sessionId,we._itemId=W._itemId,we}de.to=ge;function J(W,we,ke){if(we=we??W._sessionId,ke=ke??W._itemId,we===void 0||ke===void 0)throw new Error("invalid item");return{_sessionId:we,_itemId:ke,kind:$.from(W.kind),name:W.name,detail:W.detail??"",uri:W.uri,range:f.from(W.range),selectionRange:f.from(W.selectionRange),tags:W.tags?.map(B.from)}}de.from=J})(Le=e.TypeHierarchyItem||(e.TypeHierarchyItem={}))}),define(be[169],Ee([0,1,2,16,7,8,230]),function(re,e,d,M,b,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class C{constructor(I,t,E,n={timeout:1500,errors:3}){this._logService=I,this._documents=t,this._mainThreadBulkEdits=E,this._thresholds=n,this._callbacks=new F.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(I){return(t,E,n)=>{const u={dispose:this._callbacks.push([t,E,I])};return Array.isArray(n)&&n.push(u),u}}async $participateInSave(I,t){const E=d.URI.revive(I);let n=!1;const c=setTimeout(()=>n=!0,this._thresholds.timeout),u=[];try{for(let a of[...this._callbacks]){if(n)break;const w=this._documents.getDocument(E),T=await this._deliverEventAsyncAndBlameBadListeners(a,{document:w,reason:R.TextDocumentSaveReason.to(t)});u.push(T)}}finally{clearTimeout(c)}return u}_deliverEventAsyncAndBlameBadListeners([I,t,E],n){const c=this._badListeners.get(I);return typeof c=="number"&&c>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(E,I,t,n).then(()=>!0,u=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${E.identifier.value}' threw ERROR`),this._logService.error(u),!(u instanceof Error)||u.message!=="concurrent_edits"){const a=this._badListeners.get(I);this._badListeners.set(I,a?a+1:1),typeof a=="number"&&a>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${E.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(I,t,E,n){const c=[],u=Date.now(),{document:a,reason:w}=n,{version:T}=a,S=Object.freeze({document:a,reason:w,waitUntil(o){if(Object.isFrozen(c))throw(0,M.illegalState)("waitUntil can not be called async");c.push(Promise.resolve(o))}});try{t.apply(E,[S])}catch(o){return Promise.reject(o)}return Object.freeze(c),new Promise((o,f)=>{const y=setTimeout(()=>f(new Error("timeout")),this._thresholds.timeout);return Promise.all(c).then(i=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' finished after ${Date.now()-u}ms`),clearTimeout(y),o(i)}).catch(i=>{clearTimeout(y),f(i)})}).then(o=>{const f={edits:[]};for(const y of o)if(Array.isArray(y)&&y.every(i=>i instanceof b.TextEdit))for(const{newText:i,newEol:v,range:r}of y)f.edits.push({_type:2,resource:a.uri,edit:{range:r&&R.Range.from(r),text:i,eol:v&&R.EndOfLine.from(v)}});if(f.edits.length!==0)return T===a.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(f):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=C}),define(be[68],Ee([0,1,8,2,3,4]),function(re,e,d,M,b,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,R.createDecorator)("IExtHostEditorTabs");class F{constructor(){this._onDidChangeTabs=new b.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._onDidChangeActiveTab=new b.Emitter,this.onDidChangeActiveTab=this._onDidChangeActiveTab.event,this._tabs=[]}get tabs(){return this._tabs}get activeTab(){return this._activeTab}$acceptEditorTabs(_){let I=-1;this._tabs=_.map((E,n)=>(E.isActive&&(I=n),Object.freeze({label:E.label,viewColumn:d.ViewColumn.to(E.viewColumn),resource:M.URI.revive(E.resource),viewId:E.editorId,isActive:E.isActive})));const t=this._activeTab;this._activeTab=I===-1?void 0:this._tabs[I],this._activeTab!==t&&this._onDidChangeActiveTab.fire(this._activeTab),this._onDidChangeTabs.fire(this._tabs)}}e.ExtHostEditorTabs=F}),define(be[170],Ee([0,1,3,27,2,8,7]),function(re,e,d,M,b,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class C{constructor(t,E,n,c,u){this._onDidCreate=new d.Emitter,this._onDidChange=new d.Emitter,this._onDidDelete=new d.Emitter,this._config=0,n&&(this._config+=1),c&&(this._config+=2),u&&(this._config+=4);const a=(0,M.parse)(E),w=t(T=>{if(!n)for(let S of T.created){const o=b.URI.revive(S);a(o.fsPath)&&this._onDidCreate.fire(o)}if(!c)for(let S of T.changed){const o=b.URI.revive(S);a(o.fsPath)&&this._onDidChange.fire(o)}if(!u)for(let S of T.deleted){const o=b.URI.revive(S);a(o.fsPath)&&this._onDidDelete.fire(o)}});this._disposable=F.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,w)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class _{constructor(t,E,n){this._logService=E,this._extHostDocumentsAndEditors=n,this._onFileSystemEvent=new d.Emitter,this._onDidRenameFile=new d.Emitter,this._onDidCreateFile=new d.Emitter,this._onDidDeleteFile=new d.Emitter,this._onWillRenameFile=new d.AsyncEmitter,this._onWillCreateFile=new d.AsyncEmitter,this._onWillDeleteFile=new d.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(t,E,n,c){return new C(this._onFileSystemEvent.event,t,E,n,c)}$onFileEvent(t){this._onFileSystemEvent.fire(t)}$onDidRunFileOperation(t,E){switch(t){case 2:this._onDidRenameFile.fire(Object.freeze({files:E.map(n=>({oldUri:b.URI.revive(n.source),newUri:b.URI.revive(n.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:E.map(n=>b.URI.revive(n.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:E.map(n=>b.URI.revive(n.target))}));break;default:}}getOnWillRenameFileEvent(t){return this._createWillExecuteEvent(t,this._onWillRenameFile)}getOnWillCreateFileEvent(t){return this._createWillExecuteEvent(t,this._onWillCreateFile)}getOnWillDeleteFileEvent(t){return this._createWillExecuteEvent(t,this._onWillDeleteFile)}_createWillExecuteEvent(t,E){return(n,c,u)=>{const a=function(T){n.call(c,T)};return a.extension=t,E.event(a,void 0,u)}}async $onWillRunFileOperation(t,E,n,c){switch(t){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:E.map(u=>({oldUri:b.URI.revive(u.source),newUri:b.URI.revive(u.target)}))},n,c);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:E.map(u=>b.URI.revive(u.target))},n,c);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:E.map(u=>b.URI.revive(u.target))},n,c)}}async _fireWillEvent(t,E,n,c){const u=new Set,a=[];if(await t.fireAsync(E,c,async(T,S)=>{const o=Date.now(),f=await Promise.resolve(T);f instanceof F.WorkspaceEdit&&(a.push(f),u.add(S.extension.displayName??S.extension.identifier.value)),Date.now()-o>n&&this._logService.warn("SLOW file-participant",S.extension.identifier)}),c.isCancellationRequested||a.length===0)return;const w={edits:[]};for(let T of a){let{edits:S}=R.WorkspaceEdit.from(T,this._extHostDocumentsAndEditors);w.edits=w.edits.concat(S)}return{edit:w,extensionNames:Array.from(u)}}}e.ExtHostFileSystemEventService=_}),define(be[171],Ee([0,1,11,23,2,8,7,89]),function(re,e,d,M,b,R,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class _{constructor(n,c,u,a){this.start=n,this.deletedCount=c,this.deletedItems=u,this.items=a}static asApiEvents(n){return n.map(c=>({start:c.start,deletedCount:c.deletedCount,deletedItems:c.deletedItems,items:c.items.map(u=>u.apiCell)}))}}class I{constructor(n,c,u){this.notebook=n,this._extHostDocument=c,this._cellData=u,this.handle=u.handle,this.uri=b.URI.revive(u.uri),this.cellKind=u.cellKind,this._outputs=u.outputs.map(R.NotebookCellOutput.to),this._internalMetadata=u.internalMetadata??{},this._metadata=Object.freeze(u.metadata??{}),this._previousResult=Object.freeze(R.NotebookCellExecutionSummary.to(u.internalMetadata??{}))}static asModelAddData(n,c){return{EOL:c.eol,lines:c.source,modeId:c.language,uri:c.uri,isDirty:!1,versionId:1,notebook:n}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const n=this,c=this._extHostDocument.getDocument(this.uri);if(!c)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return n.notebook.getCellIndex(n)},notebook:n.notebook.apiNotebook,kind:R.NotebookCellKind.to(this._cellData.cellKind),document:c.document,get mime(){return n._mime},set mime(u){n._mime=u},get outputs(){return n._outputs.slice(0)},get metadata(){return n._metadata},get executionSummary(){return n._previousResult}})}return this._apiCell}setOutputs(n){this._outputs=n.map(R.NotebookCellOutput.to)}setOutputItems(n,c,u){const a=u.map(R.NotebookCellOutputItem.to),w=this._outputs.find(T=>T.id===n);w&&(c||(w.items.length=0),w.items.push(...a))}setMetadata(n){this._metadata=Object.freeze(n)}setInternalMetadata(n){this._internalMetadata=n,this._previousResult=Object.freeze(R.NotebookCellExecutionSummary.to(n))}setMime(n){}}e.ExtHostCell=I;class t{constructor(n,c,u,a,w,T){this._proxy=n,this._textDocumentsAndEditors=c,this._textDocuments=u,this._emitter=a,this.uri=w,this.handle=t._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=T.viewType,this._metadata=Object.freeze(T.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,T.cells]],!0),this._versionId=T.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const n=this;this._notebook={get uri(){return n.uri},get version(){return n._versionId},get notebookType(){return n._notebookType},get isDirty(){return n._isDirty},get isUntitled(){return n.uri.scheme===d.Schemas.untitled},get isClosed(){return n._disposed},get metadata(){return n._metadata},get cellCount(){return n._cells.length},cellAt(c){return c=n._validateIndex(c),n._cells[c].apiCell},getCells(c){return(c?n._getCells(c):n._cells).map(a=>a.apiCell)},save(){return n._save()}}}return this._notebook}updateBackup(n){this._backup?.delete(),this._backup=n}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(n){n.metadata&&(this._metadata=Object.freeze({...this._metadata,...n.metadata}))}acceptDirty(n){this._isDirty=n}acceptModelChanged(n,c){this._versionId=n.versionId,this._isDirty=c;for(const u of n.rawEvents)u.kind===C.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(u.changes,!1):u.kind===C.NotebookCellsChangeType.Move?this._moveCell(u.index,u.newIdx):u.kind===C.NotebookCellsChangeType.Output?this._setCellOutputs(u.index,u.outputs):u.kind===C.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(u.index,u.outputId,u.append,u.outputItems):u.kind===C.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(u.index,u.language):u.kind===C.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(u.index,u.mime):u.kind===C.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(u.index,u.metadata):u.kind===C.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(u.index,u.internalMetadata)}_validateIndex(n){return n=n|0,n<0?0:n>=this._cells.length?this._cells.length-1:n}_validateRange(n){let c=n.start|0,u=n.end|0;return c<0&&(c=0),u>this._cells.length&&(u=this._cells.length),n.with({start:c,end:u})}_getCells(n){n=this._validateRange(n);const c=[];for(let u=n.start;u<n.end;u++)c.push(this._cells[u]);return c}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(n,c){if(this._disposed)return;const u=[],a=[],w=[];n.reverse().forEach(T=>{const o=T[2].map(i=>{const v=new I(this,this._textDocumentsAndEditors,i);return c||a.push(I.asModelAddData(this.apiNotebook,i)),v}),f=new _(T[0],T[1],[],o),y=this._cells.splice(T[0],T[1],...o);for(const i of y)w.push(i.uri),f.deletedItems.push(i.apiCell);u.push(f)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:a,removedDocuments:w}),c||this._emitter.emitModelChange((0,M.deepFreeze)({document:this.apiNotebook,changes:_.asApiEvents(u)}))}_moveCell(n,c){const u=this._cells.splice(n,1);this._cells.splice(c,0,...u);const a=[new _(n,1,u.map(w=>w.apiCell),[]),new _(c,0,[],u)];this._emitter.emitModelChange((0,M.deepFreeze)({document:this.apiNotebook,changes:_.asApiEvents(a)}))}_setCellOutputs(n,c){const u=this._cells[n];u.setOutputs(c),this._emitter.emitCellOutputsChange((0,M.deepFreeze)({document:this.apiNotebook,cells:[u.apiCell]}))}_setCellOutputItems(n,c,u,a){const w=this._cells[n];w.setOutputItems(c,u,a),this._emitter.emitCellOutputsChange((0,M.deepFreeze)({document:this.apiNotebook,cells:[w.apiCell]}))}_changeCellLanguage(n,c){const u=this._cells[n];u.apiCell.document.languageId!==c&&this._textDocuments.$acceptModelModeChanged(u.uri,c)}_changeCellMime(n,c){const u=this._cells[n];u.apiCell.mime=c}_changeCellMetadata(n,c){const u=this._cells[n],a=u.apiCell.metadata;u.setMetadata(c);const w=u.apiCell.metadata;(0,M.equals)(a,w)||this._emitter.emitCellMetadataChange((0,M.deepFreeze)({document:this.apiNotebook,cell:u.apiCell}))}_changeCellInternalMetadata(n,c){const u=this._cells[n],a=u.internalMetadata;if(u.setInternalMetadata(c),a.runState!==c.runState){const w=c.runState??F.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange((0,M.deepFreeze)({document:this.apiNotebook,cell:u.apiCell,state:w}))}}getCellFromApiCell(n){return this._cells.find(c=>c.apiCell===n)}getCellFromIndex(n){return this._cells[n]}getCell(n){return this._cells.find(c=>c.handle===n)}getCellIndex(n){return this._cells.indexOf(n)}}e.ExtHostNotebookDocument=t,t._handlePool=0}),define(be[93],Ee([0,1,7,8,16]),function(re,e,d,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class R{constructor(_){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=_}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(_){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:_})}replaceCellMetadata(_,I){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:_,metadata:I})}replaceCells(_,I,t){this._throwIfFinalized(),!(_===I&&t.length===0)&&this._collectedEdits.push({editType:1,index:_,count:I-_,cells:t.map(M.NotebookCellData.from)})}}class F{constructor(_,I,t,E,n,c){this.id=_,this._proxy=I,this.notebookData=t,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=n,this._visibleRanges=E,this._viewColumn=c}get apiEditor(){if(!this._editor){const _=this;this._editor={get document(){return _.notebookData.apiNotebook},get selections(){return _._selections},set selections(I){if(!Array.isArray(I)||!I.every(d.NotebookRange.isNotebookRange))throw(0,b.illegalArgument)("selections");_._selections=I,_._trySetSelections(I)},get visibleRanges(){return _._visibleRanges},revealRange(I,t){_._proxy.$tryRevealRange(_.id,M.NotebookRange.from(I),t??d.NotebookEditorRevealType.Default)},get viewColumn(){return _._viewColumn},edit(I){const t=new R(this.document.version);return I(t),_._applyEdit(t.finalize())},setDecorations(I,t){return _.setDecorations(I,t)}},F.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(_){this._visible=_}_acceptVisibleRanges(_){this._visibleRanges=_}_acceptSelections(_){this._selections=_}_trySetSelections(_){this._proxy.$trySetSelections(this.id,_.map(M.NotebookRange.from))}_acceptViewColumn(_){this._viewColumn=_}_applyEdit(_){if(_.cellEdits.length===0)return Promise.resolve(!0);const I=[];let t=-1;for(let E=0;E<_.cellEdits.length;E++){if(t<0){I.push(_.cellEdits[E]),t++;continue}const c=I[t],u=_.cellEdits[E];if(c.editType===1&&u.editType===1&&c.index===u.index){c.cells.push(..._.cellEdits[E].cells),c.count+=_.cellEdits[E].count;continue}I.push(_.cellEdits[E]),t++}return this._proxy.$tryApplyEdits(this.id,_.documentVersionId,I)}setDecorations(_,I){if(!(I.isEmpty&&!this._hasDecorationsForKey.has(_.key)))return I.isEmpty?this._hasDecorationsForKey.delete(_.key):this._hasDecorationsForKey.add(_.key),this._proxy.$trySetDecorations(this.id,M.NotebookRange.from(I),_.key)}}e.ExtHostNotebookEditor=F,F.apiEditorsToExtHost=new WeakMap}),define(be[172],Ee([0,1,8,147,126,21,52]),function(re,e,d,M,b,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class C{constructor(E){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=E}withProgress(E,n,c){const u=this._handles++,{title:a,location:w,cancellable:T}=n,S={label:(0,b.localize)(0,null,E.displayName||E.name),id:E.identifier.value};return this._proxy.$startProgress(u,{location:d.ProgressLocation.from(w),title:a,source:S,cancellable:T},E),this._withProgress(u,c,!!T)}_withProgress(E,n,c){let u;c&&(u=new R.CancellationTokenSource,this._mapHandleToCancellationSource.set(E,u));const a=T=>{this._proxy.$progressEnd(T),this._mapHandleToCancellationSource.delete(T),u&&u.dispose()};let w;try{w=n(new I(this._proxy,E),c&&u?u.token:R.CancellationToken.None)}catch(T){throw a(E),T}return w.then(T=>a(E),T=>a(E)),w}$acceptProgressCanceled(E){const n=this._mapHandleToCancellationSource.get(E);n&&(n.cancel(),this._mapHandleToCancellationSource.delete(E))}}e.ExtHostProgress=C;function _(t,E){return t.message=E.message,typeof E.increment=="number"&&(typeof t.increment=="number"?t.increment+=E.increment:t.increment=E.increment),t}class I extends M.Progress{constructor(E,n){super(c=>this.throttledReport(c));this._proxy=E,this._handle=n}throttledReport(E){this._proxy.$progressReport(this._handle,E)}}We([(0,F.throttle)(100,(t,E)=>_(t,E),()=>Object.create(null))],I.prototype,"throttledReport",null)}),define(be[94],Ee([0,1,42,16,53,8,7]),function(re,e,d,M,b,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class C{constructor(n,c,u){const a=C._Keys.nextId();n.$registerTextEditorDecorationType(c.identifier,a,R.DecorationRenderOptions.from(u)),this.value=Object.freeze({key:a,dispose(){n.$removeTextEditorDecorationType(a)}})}}e.TextEditorDecorationType=C,C._Keys=new b.IdGenerator("TextEditorDecorationType");class _{constructor(n,c){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=n,this._documentVersionId=n.version,this._undoStopBefore=c.undoStopBefore,this._undoStopAfter=c.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(n,c){this._throwIfFinalized();let u=null;if(n instanceof F.Position)u=new F.Range(n,n);else if(n instanceof F.Range)u=n;else throw new Error("Unrecognized location");this._pushEdit(u,c,!1)}insert(n,c){this._throwIfFinalized(),this._pushEdit(new F.Range(n,n),c,!0)}delete(n){this._throwIfFinalized();let c=null;if(n instanceof F.Range)c=n;else throw new Error("Unrecognized location");this._pushEdit(c,null,!0)}_pushEdit(n,c,u){const a=this._document.validateRange(n);this._collectedEdits.push({range:a,text:c,forceMoveMarkers:u})}setEndOfLine(n){if(this._throwIfFinalized(),n!==F.EndOfLine.LF&&n!==F.EndOfLine.CRLF)throw(0,M.illegalArgument)("endOfLine");this._setEndOfLine=n}}e.TextEditorEdit=_;class I{constructor(n,c,u,a){this._proxy=n,this._id=c,this._accept(u),this._logService=a;const w=this;this.value={get tabSize(){return w._tabSize},set tabSize(T){w._setTabSize(T)},get insertSpaces(){return w._insertSpaces},set insertSpaces(T){w._setInsertSpaces(T)},get cursorStyle(){return w._cursorStyle},set cursorStyle(T){w._setCursorStyle(T)},get lineNumbers(){return w._lineNumbers},set lineNumbers(T){w._setLineNumbers(T)}}}_accept(n){this._tabSize=n.tabSize,this._insertSpaces=n.insertSpaces,this._cursorStyle=n.cursorStyle,this._lineNumbers=R.TextEditorLineNumbersStyle.to(n.lineNumbers)}_validateTabSize(n){if(n==="auto")return"auto";if(typeof n=="number"){const c=Math.floor(n);return c>0?c:null}if(typeof n=="string"){const c=parseInt(n,10);return isNaN(c)?null:c>0?c:null}return null}_setTabSize(n){const c=this._validateTabSize(n);if(c!==null){if(typeof c=="number"){if(this._tabSize===c)return;this._tabSize=c}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:c}))}}_validateInsertSpaces(n){return n==="auto"?"auto":n==="false"?!1:Boolean(n)}_setInsertSpaces(n){const c=this._validateInsertSpaces(n);if(typeof c=="boolean"){if(this._insertSpaces===c)return;this._insertSpaces=c}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:c}))}_setCursorStyle(n){this._cursorStyle!==n&&(this._cursorStyle=n,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:n})))}_setLineNumbers(n){this._lineNumbers!==n&&(this._lineNumbers=n,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:R.TextEditorLineNumbersStyle.from(n)})))}assign(n){const c={};let u=!1;if(typeof n.tabSize!="undefined"){const a=this._validateTabSize(n.tabSize);a==="auto"?(u=!0,c.tabSize=a):typeof a=="number"&&this._tabSize!==a&&(this._tabSize=a,u=!0,c.tabSize=a)}if(typeof n.insertSpaces!="undefined"){const a=this._validateInsertSpaces(n.insertSpaces);a==="auto"?(u=!0,c.insertSpaces=a):this._insertSpaces!==a&&(this._insertSpaces=a,u=!0,c.insertSpaces=a)}typeof n.cursorStyle!="undefined"&&this._cursorStyle!==n.cursorStyle&&(this._cursorStyle=n.cursorStyle,u=!0,c.cursorStyle=n.cursorStyle),typeof n.lineNumbers!="undefined"&&this._lineNumbers!==n.lineNumbers&&(this._lineNumbers=n.lineNumbers,u=!0,c.lineNumbers=R.TextEditorLineNumbersStyle.from(n.lineNumbers)),u&&this._warnOnError(this._proxy.$trySetOptions(this._id,c))}_warnOnError(n){n.catch(c=>this._logService.warn(c))}}e.ExtHostTextEditorOptions=I;class t{constructor(n,c,u,a,w,T,S,o){this.id=n,this._proxy=c,this._logService=u,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=w,this._options=new I(this._proxy,this.id,T,u),this._visibleRanges=S,this._viewColumn=o;const f=this;this.value=Object.freeze({get document(){return a.getValue()},set document(y){throw(0,M.readonly)("document")},get selection(){return f._selections&&f._selections[0]},set selection(y){if(!(y instanceof F.Selection))throw(0,M.illegalArgument)("selection");f._selections=[y],f._trySetSelection()},get selections(){return f._selections},set selections(y){if(!Array.isArray(y)||y.some(i=>!(i instanceof F.Selection)))throw(0,M.illegalArgument)("selections");f._selections=y,f._trySetSelection()},get visibleRanges(){return f._visibleRanges},set visibleRanges(y){throw(0,M.readonly)("visibleRanges")},get options(){return f._options.value},set options(y){f._disposed||f._options.assign(y)},get viewColumn(){return f._viewColumn},set viewColumn(y){throw(0,M.readonly)("viewColumn")},edit(y,i={undoStopBefore:!0,undoStopAfter:!0}){if(f._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const v=new _(a.getValue(),i);return y(v),f._applyEdit(v)},insertSnippet(y,i,v={undoStopBefore:!0,undoStopAfter:!0}){if(f._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let r;if(!i||Array.isArray(i)&&i.length===0)r=f._selections.map(s=>R.Range.from(s));else if(i instanceof F.Position){const{lineNumber:s,column:l}=R.Position.from(i);r=[{startLineNumber:s,startColumn:l,endLineNumber:s,endColumn:l}]}else if(i instanceof F.Range)r=[R.Range.from(i)];else{r=[];for(const s of i)if(s instanceof F.Range)r.push(R.Range.from(s));else{const{lineNumber:l,column:h}=R.Position.from(s);r.push({startLineNumber:l,startColumn:h,endLineNumber:l,endColumn:h})}}return c.$tryInsertSnippet(n,y.value,r,v)},setDecorations(y,i){const v=i.length===0;v&&!f._hasDecorationsForKey.has(y.key)||(v?f._hasDecorationsForKey.delete(y.key):f._hasDecorationsForKey.add(y.key),f._runOnProxy(()=>{if(R.isDecorationOptionsArr(i))return c.$trySetDecorations(n,y.key,R.fromRangeOrRangeWithMessage(i));{const r=new Array(4*i.length);for(let s=0,l=i.length;s<l;s++){const h=i[s];r[4*s]=h.start.line+1,r[4*s+1]=h.start.character+1,r[4*s+2]=h.end.line+1,r[4*s+3]=h.end.character+1}return c.$trySetDecorationsFast(n,y.key,r)}}))},revealRange(y,i){f._runOnProxy(()=>c.$tryRevealRange(n,R.Range.from(y),i||F.TextEditorRevealType.Default))},show(y){c.$tryShowEditor(n,R.ViewColumn.from(y))},hide(){c.$tryHideEditor(n)}})}dispose(){(0,d.ok)(!this._disposed),this._disposed=!0}_acceptOptions(n){(0,d.ok)(!this._disposed),this._options._accept(n)}_acceptVisibleRanges(n){(0,d.ok)(!this._disposed),this._visibleRanges=n}_acceptViewColumn(n){(0,d.ok)(!this._disposed),this._viewColumn=n}_acceptSelections(n){(0,d.ok)(!this._disposed),this._selections=n}async _trySetSelection(){const n=this._selections.map(R.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,n)),this.value}_applyEdit(n){const c=n.finalize();if(c.edits.length===0&&!c.setEndOfLine)return Promise.resolve(!0);const u=c.edits.map(w=>w.range);u.sort((w,T)=>w.end.line===T.end.line?w.end.character===T.end.character?w.start.line===T.start.line?w.start.character-T.start.character:w.start.line-T.start.line:w.end.character-T.end.character:w.end.line-T.end.line);for(let w=0,T=u.length-1;w<T;w++){const S=u[w].end;if(u[w+1].start.isBefore(S))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const a=c.edits.map(w=>({range:R.Range.from(w.range),text:w.text,forceMoveMarkers:w.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,c.documentVersionId,a,{setEndOfLine:typeof c.setEndOfLine=="number"?R.EndOfLine.from(c.setEndOfLine):void 0,undoStopBefore:c.undoStopBefore,undoStopAfter:c.undoStopAfter})}_runOnProxy(n){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):n().then(()=>this,c=>(c instanceof Error&&c.name==="DISPOSED"||this._logService.warn(c),null))}}e.ExtHostTextEditor=t}),define(be[173],Ee([0,1,129,24,2,3,6,161,14,7,10,12,8,21,158]),function(re,e,d,M,b,R,F,C,_,I,t,E,n,c,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function a(S,o){if((0,t.isString)(S))return{label:S};if(S&&typeof S=="object"&&typeof S.label=="string"){let f;return Array.isArray(S.highlights)&&(f=S.highlights.filter(y=>y.length===2&&typeof y[0]=="number"&&typeof y[1]=="number"),f=f.length?f:void 0),{label:S.label,highlights:f}}}class w{constructor(o,f,y){this._proxy=o,this.commands=f,this.logService=y,this.treeViews=new Map;function i(v){return v&&v.$treeViewId&&v.$treeItemHandle}f.registerArgumentProcessor({processArgument:v=>i(v)?this.convertArgument(v):Array.isArray(v)&&v.length>0?v.map(r=>i(r)?this.convertArgument(r):r):v})}registerTreeDataProvider(o,f,y){const i=this.createTreeView(o,{treeDataProvider:f},y);return{dispose:()=>i.dispose()}}createTreeView(o,f,y){if(!f||!f.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const i=f.dragAndDropController!==void 0,v=this._proxy.$registerTreeViewDataProvider(o,{showCollapseAll:!!f.showCollapseAll,canSelectMany:!!f.canSelectMany,canDragAndDrop:i}),r=this.createExtHostTreeView(o,f,y);return{get onDidCollapseElement(){return r.onDidCollapseElement},get onDidExpandElement(){return r.onDidExpandElement},get selection(){return r.selectedElements},get onDidChangeSelection(){return r.onDidChangeSelection},get visible(){return r.visible},get onDidChangeVisibility(){return r.onDidChangeVisibility},get message(){return r.message},set message(s){r.message=s},get title(){return r.title},set title(s){r.title=s},get description(){return r.description},set description(s){r.description=s},reveal:(s,l)=>r.reveal(s,l),dispose:async()=>{await v,this.treeViews.delete(o),r.dispose()}}}$getChildren(o,f){const y=this.treeViews.get(o);return y?y.getChildren(f):Promise.reject(new Error((0,d.localize)(0,null,o)))}async $onDrop(o,f,y){const i=this.treeViews.get(o);if(!i)return Promise.reject(new Error((0,d.localize)(1,null,o)));const v=u.TreeDataTransferConverter.toITreeDataTransfer(f);if(v.items.has(C.TREE_ITEM_DATA_TRANSFER_TYPE)){const s=JSON.parse(await v.items.get(C.TREE_ITEM_DATA_TRANSFER_TYPE).asString()).map(l=>i.getExtensionElement(l)).filter(l=>!!l);s.length>0?v.items.set(C.TREE_ITEM_DATA_TRANSFER_TYPE,{asString:async()=>JSON.stringify(s)}):v.items.delete(C.TREE_ITEM_DATA_TRANSFER_TYPE)}return i.onDrop(v,y)}async $hasResolve(o){const f=this.treeViews.get(o);if(!f)throw new Error((0,d.localize)(2,null,o));return f.hasResolve}$resolve(o,f,y){const i=this.treeViews.get(o);if(!i)throw new Error((0,d.localize)(3,null,o));return i.resolveTreeItem(f,y)}$setExpanded(o,f,y){const i=this.treeViews.get(o);if(!i)throw new Error((0,d.localize)(4,null,o));i.setExpanded(f,y)}$setSelection(o,f){const y=this.treeViews.get(o);if(!y)throw new Error((0,d.localize)(5,null,o));y.setSelection(f)}$setVisible(o,f){const y=this.treeViews.get(o);if(!y)throw new Error((0,d.localize)(6,null,o));y.setVisible(f)}createExtHostTreeView(o,f,y){const i=new T(o,f,this._proxy,this.commands.converter,this.logService,y);return this.treeViews.set(o,i),i}convertArgument(o){const f=this.treeViews.get(o.$treeViewId);return f?f.getExtensionElement(o.$treeItemHandle):null}}e.ExtHostTreeViews=w;class T extends F.Disposable{constructor(o,f,y,i,v,r){super();if(this.viewId=o,this.proxy=y,this.commands=i,this.logService=v,this.extension=r,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new R.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new R.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new R.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new R.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new R.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new c.CancellationTokenSource,r.contributes&&r.contributes.views)for(const h in r.contributes.views)for(const p of r.contributes.views[h])p.id===o&&(this._title=p.name);this.dataProvider=f.treeDataProvider,this.dndController=f.dragAndDropController,this.dataProvider.onDidChangeTreeData2?this._register(this.dataProvider.onDidChangeTreeData2(h=>this._onDidChangeData.fire({message:!1,element:h}))):this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(h=>this._onDidChangeData.fire({message:!1,element:h})));let s,l;this._register(R.Event.debounce(this._onDidChangeData.event,(h,p)=>(h||(h={message:!1,elements:[]}),p.element!==!1&&(s||(s=new Promise(k=>l=k),this.refreshPromise=this.refreshPromise.then(()=>s)),Array.isArray(p.element)?h.elements.push(...p.element):h.elements.push(p.element)),p.message&&(h.message=!0),h),200,!0)(({message:h,elements:p})=>{p.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const k=l;return s=null,this.refresh(p).then(()=>k())})),h&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(o=>this.getExtensionElement(o)).filter(o=>!(0,t.isUndefinedOrNull)(o))}async getChildren(o){const f=o?this.getExtensionElement(o):void 0;if(o&&!f)return this.logService.error(`No tree item with id '${o}' found.`),Promise.resolve([]);let y=this.getChildrenNodes(o);return y||(y=await this.fetchChildrenNodes(f)),y?y.map(i=>i.item):void 0}getExtensionElement(o){return this.elements.get(o)}reveal(o,f){f=f||{select:!0,focus:!1};const y=(0,t.isUndefinedOrNull)(f.select)?!0:f.select,i=(0,t.isUndefinedOrNull)(f.focus)?!1:f.focus,v=(0,t.isUndefinedOrNull)(f.expand)?!1:f.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):o?this.refreshPromise.then(()=>this.resolveUnknownParentChain(o)).then(r=>this.resolveTreeNode(o,r[r.length-1]).then(s=>this.proxy.$reveal(this.viewId,{item:s.item,parentChain:r.map(l=>l.item)},{select:y,focus:i,expand:v})),r=>this.logService.error(r)):this.proxy.$reveal(this.viewId,void 0,{select:y,focus:i,expand:v})}get message(){return this._message}set message(o){this._message=o,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(o){this._title=o,this.proxy.$setTitle(this.viewId,o,this._description)}get description(){return this._description}set description(o){this._description=o,this.proxy.$setTitle(this.viewId,this._title,o)}setExpanded(o,f){const y=this.getExtensionElement(o);y&&(f?this._onDidExpandElement.fire(Object.freeze({element:y})):this._onDidCollapseElement.fire(Object.freeze({element:y})))}setSelection(o){(0,E.equals)(this._selectedHandles,o)||(this._selectedHandles=o,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(o){o!==this._visible&&(this._visible=o,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async onDrop(o,f){const y=this.getExtensionElement(f);if(!!y)return(0,_.asPromise)(()=>this.dndController?.onDrop(o,y))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(o,f){if(!this.dataProvider.resolveTreeItem)return;const y=this.elements.get(o);if(y){const i=this.nodes.get(y);if(i){const v=await this.dataProvider.resolveTreeItem(i.extensionItem,y,f)??i.extensionItem;return i.item.tooltip=this.getTooltip(v.tooltip),i.item.command=this.getCommand(i.disposableStore,v.command),i.item}}}resolveUnknownParentChain(o){return this.resolveParent(o).then(f=>f?this.resolveUnknownParentChain(f).then(y=>this.resolveTreeNode(f,y[y.length-1]).then(i=>(y.push(i),y))):Promise.resolve([]))}resolveParent(o){const f=this.nodes.get(o);return f?Promise.resolve(f.parent?this.elements.get(f.parent.item.handle):void 0):(0,_.asPromise)(()=>this.dataProvider.getParent(o))}resolveTreeNode(o,f){const y=this.nodes.get(o);return y?Promise.resolve(y):(0,_.asPromise)(()=>this.dataProvider.getTreeItem(o)).then(i=>this.createHandle(o,i,f,!0)).then(i=>this.getChildren(f?f.item.handle:void 0).then(()=>{const v=this.getExtensionElement(i);if(v){const r=this.nodes.get(v);if(r)return Promise.resolve(r)}throw new Error(`Cannot resolve tree item for element ${i}`)}))}getChildrenNodes(o){if(o){let f;if(typeof o=="string"){const y=this.getExtensionElement(o);f=y?this.nodes.get(y):void 0}else f=o;return f&&f.children||void 0}return this.roots}async fetchChildrenNodes(o){this.clearChildren(o);const f=new c.CancellationTokenSource(this._refreshCancellationSource.token);try{const y=o?this.nodes.get(o):void 0,i=await this.dataProvider.getChildren(o);if(f.token.isCancellationRequested)return;const v=await Promise.all((0,E.coalesce)(i||[]).map(async r=>{const s=await this.dataProvider.getTreeItem(r);return s&&!f.token.isCancellationRequested?this.createAndRegisterTreeNode(r,s,y):null}));return f.token.isCancellationRequested?void 0:(0,E.coalesce)(v)}finally{f.dispose()}}refresh(o){if(o.some(y=>!y))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new c.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const y=this.getHandlesToRefresh(o);if(y.length)return this.refreshHandles(y)}return Promise.resolve(void 0)}getHandlesToRefresh(o){const f=new Set,y=o.map(v=>this.nodes.get(v));for(const v of y)if(v&&!f.has(v.item.handle)){let r=v;for(;r&&r.parent&&y.findIndex(s=>r&&r.parent&&s&&s.item.handle===r.parent.item.handle)===-1;){const s=this.elements.get(r.parent.item.handle);r=s?this.nodes.get(s):void 0}r&&!r.parent&&f.add(v.item.handle)}const i=[];return f.forEach(v=>{const r=this.elements.get(v);if(r){const s=this.nodes.get(r);s&&(!s.parent||!f.has(s.parent.item.handle))&&i.push(v)}}),i}refreshHandles(o){const f={};return Promise.all(o.map(y=>this.refreshNode(y).then(i=>{i&&(f[y]=i.item)}))).then(()=>Object.keys(f).length?this.proxy.$refresh(this.viewId,f):void 0)}refreshNode(o){const f=this.getExtensionElement(o);if(f){const y=this.nodes.get(f);if(y)return this.clearChildren(f),(0,_.asPromise)(()=>this.dataProvider.getTreeItem(f)).then(i=>{if(i){const v=this.createTreeNode(f,i,y.parent);return this.updateNodeCache(f,v,y,y.parent),y.dispose(),v}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(o,f,y){const i=this.createTreeNode(o,f,y);if(f.id&&this.elements.has(i.item.handle))throw new Error((0,d.localize)(7,null,f.id));return this.addNodeToCache(o,i),this.addNodeToParentCache(i,y),i}getTooltip(o){return I.MarkdownString.isMarkdownString(o)?n.MarkdownString.from(o):o}getCommand(o,f){return f?this.commands.toInternal(f,o):void 0}createTreeNode(o,f,y){const i=new F.DisposableStore,v=this.createHandle(o,f,y),r=this.getLightIconPath(f);return{item:{handle:v,parentHandle:y?y.item.handle:void 0,label:a(f.label,this.extension),description:f.description,resourceUri:f.resourceUri,tooltip:this.getTooltip(f.tooltip),command:this.getCommand(i,f.command),contextValue:f.contextValue,icon:r,iconDark:this.getDarkIconPath(f)||r,themeIcon:this.getThemeIcon(f),collapsibleState:(0,t.isUndefinedOrNull)(f.collapsibleState)?I.TreeItemCollapsibleState.None:f.collapsibleState,accessibilityInformation:f.accessibilityInformation},extensionItem:f,parent:y,children:void 0,disposableStore:i,dispose(){i.dispose()}}}getThemeIcon(o){return o.iconPath instanceof I.ThemeIcon?o.iconPath:void 0}createHandle(o,{id:f,label:y,resourceUri:i},v,r){if(f)return`${T.ID_HANDLE_PREFIX}/${f}`;const s=a(y,this.extension),l=v?v.item.handle:T.LABEL_HANDLE_PREFIX;let h=s?s.label:i?(0,M.basename)(i):"";h=h.indexOf("/")!==-1?h.replace("/","//"):h;const p=this.nodes.has(o)?this.nodes.get(o).item.handle:void 0,k=this.getChildrenNodes(v)||[];let P,g=0;do{if(P=`${l}/${g}:${h}`,r||!this.elements.has(P)||p===P)break;g++}while(g<=k.length);return P}getLightIconPath(o){if(o.iconPath&&!(o.iconPath instanceof I.ThemeIcon))return typeof o.iconPath=="string"||b.URI.isUri(o.iconPath)?this.getIconPath(o.iconPath):this.getIconPath(o.iconPath.light)}getDarkIconPath(o){if(o.iconPath&&!(o.iconPath instanceof I.ThemeIcon)&&o.iconPath.dark)return this.getIconPath(o.iconPath.dark)}getIconPath(o){return b.URI.isUri(o)?o:b.URI.file(o)}addNodeToCache(o,f){this.elements.set(f.item.handle,o),this.nodes.set(o,f)}updateNodeCache(o,f,y,i){this.elements.delete(f.item.handle),this.nodes.delete(o),f.item.handle!==y.item.handle&&this.elements.delete(y.item.handle),this.addNodeToCache(o,f);const v=this.getChildrenNodes(i)||[],r=v.filter(s=>s.item.handle===y.item.handle)[0];r&&v.splice(v.indexOf(r),1,f)}addNodeToParentCache(o,f){f?(f.children||(f.children=[]),f.children.push(o)):(this.roots||(this.roots=[]),this.roots.push(o))}clearChildren(o){if(o){const f=this.nodes.get(o);if(f){if(f.children)for(const y of f.children){const i=this.elements.get(y.item.handle);i&&this.clear(i)}f.children=void 0}}else this.clearAll()}clear(o){const f=this.nodes.get(o);if(f){if(f.children)for(const y of f.children){const i=this.elements.get(y.item.handle);i&&this.clear(i)}this.nodes.delete(o),this.elements.delete(f.item.handle),f.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(o=>o.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}T.LABEL_HANDLE_PREFIX="0",T.ID_HANDLE_PREFIX="1"}),define(be[174],Ee([0,1,14,3,6,10,48,8,90,67]),function(re,e,d,M,b,R,F,C,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=void 0;class t extends b.Disposable{constructor(n){super();this.controllerId=n,this.debounceSendDiff=this._register(new d.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new M.Emitter),this.root=new F.TestItemRootImpl(this.controllerId,this.controllerId),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(n){this._resolveHandler=n;for(const c of this.tree.values())this.updateExpandability(c)}collectDiff(){const n=this.diff;return this.diff=[],n}pushDiff(n){const c=this.diff[this.diff.length-1];if(c&&n[0]===1){if(c[0]===1&&c[1].extId===n[1].extId){(0,_.applyTestItemUpdate)(c[1],n[1]);return}if(c[0]===0&&c[1].item.extId===n[1].extId){(0,_.applyTestItemUpdate)(c[1],n[1]);return}}this.diff.push(n),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(n,c){const u=this.tree.get(n);if(!!u){if((u.expandLevels===void 0||c>u.expandLevels)&&(u.expandLevels=c),u.expand===1){const a=this.resolveChildren(u);return a.isOpen()?this.expandChildren(u,c-1):a.wait().then(()=>this.expandChildren(u,c-1))}else if(u.expand===3)return u.resolveBarrier?.isOpen()===!1?u.resolveBarrier.wait().then(()=>this.expandChildren(u,c-1)):this.expandChildren(u,c-1)}}dispose(){for(const n of this.tree.values())(0,F.getPrivateApiFor)(n.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(n,c){switch(c.op){case 2:this.pushDiff([4,n.fullId.toString()]);break;case 1:this.removeItem(I.TestId.joinToString(n.fullId,c.id));break;case 0:this.upsertItem(c.item,n);break;case 4:for(const S of c.ops)this.onTestItemEvent(n,S);break;case 3:const{key:u,value:a,previous:w}=c,T=n.fullId.toString();switch(u){case"canResolveChildren":this.updateExpandability(n);break;case"tags":this.diffTagRefs(a,w,T);break;case"range":this.pushDiff([1,{extId:T,item:{range:C.Range.from(a)}}]);break;case"error":this.pushDiff([1,{extId:T,item:{error:C.MarkdownString.fromStrict(a)||null}}]);break;default:this.pushDiff([1,{extId:T,item:{[u]:a??null}}]);break}break;default:(0,R.assertNever)(c)}}upsertItem(n,c){if(!(n instanceof F.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${n.id} did not`);const u=I.TestId.fromExtHostTestItem(n,this.root.id,c?.actual),a=(0,F.getPrivateApiFor)(n);a.parent&&a.parent!==c?.actual&&a.parent.children.delete(n.id);let w=this.tree.get(u.toString());if(!w){w={fullId:u,actual:n,parent:c?u.parentId:null,expandLevels:c?.expandLevels?c.expandLevels-1:void 0,expand:0},n.tags.forEach(this.incrementTagRefs,this),this.tree.set(w.fullId.toString(),w),this.setItemParent(n,c),this.pushDiff([0,{parent:w.parent&&w.parent.toString(),controllerId:this.controllerId,expand:w.expand,item:C.TestItem.from(n)}]),this.connectItemAndChildren(n,w,c);return}if(w.actual===n){this.connectItem(n,w,c);return}const T=w.actual.children,S=w.actual,o=(0,F.diffTestItems)(S,n);(0,F.getPrivateApiFor)(S).listener=void 0,w.actual=n,w.expand=0;for(const[f,y]of o)this.onTestItemEvent(w,{op:3,key:f,value:y,previous:S[f]});this.connectItemAndChildren(n,w,c);for(const f of T)n.children.get(f.id)||this.removeItem(I.TestId.joinToString(u,f.id))}diffTagRefs(n,c,u){const a=new Set(c.map(w=>w.id));for(const w of n)a.delete(w.id)||this.incrementTagRefs(w);this.pushDiff([1,{extId:u,item:{tags:n.map(w=>C.TestTag.namespace(this.controllerId,w.id))}}]),a.forEach(this.decrementTagRefs,this)}incrementTagRefs(n){const c=this.tags.get(n.id);c?c.refCount++:(this.tags.set(n.id,{refCount:1}),this.pushDiff([5,{id:C.TestTag.namespace(this.controllerId,n.id),ctrlLabel:this.root.label}]))}decrementTagRefs(n){const c=this.tags.get(n);c&&!--c.refCount&&(this.tags.delete(n),this.pushDiff([6,C.TestTag.namespace(this.controllerId,n)]))}setItemParent(n,c){(0,F.getPrivateApiFor)(n).parent=c&&c.actual!==this.root?c.actual:void 0}connectItem(n,c,u){this.setItemParent(n,u);const a=(0,F.getPrivateApiFor)(n);a.parent=u?.actual,a.listener=w=>this.onTestItemEvent(c,w),this.updateExpandability(c)}connectItemAndChildren(n,c,u){this.connectItem(n,c,u);for(const a of n.children)this.upsertItem(a,c)}updateExpandability(n){let c;this._resolveHandler?n.resolveBarrier?c=n.resolveBarrier.isOpen()?3:2:c=n.actual.canResolveChildren?1:0:c=0,c!==n.expand&&(n.expand=c,this.pushDiff([1,{extId:n.fullId.toString(),expand:c}]),c===1&&n.expandLevels!==void 0&&this.resolveChildren(n))}expandChildren(n,c){if(c<0)return;const u=[];for(const a of n.actual.children){const w=this.expand(I.TestId.joinToString(n.fullId,a.id),c);(0,d.isThenable)(w)&&u.push(w)}if(u.length)return Promise.all(u).then(()=>{})}resolveChildren(n){if(n.resolveBarrier)return n.resolveBarrier;if(!this._resolveHandler){const w=new d.Barrier;return w.open(),w}n.expand=2,this.pushExpandStateUpdate(n);const c=n.resolveBarrier=new d.Barrier,u=w=>{console.error(`Unhandled error in resolveHandler of test controller "${this.controllerId}"`),n.actual!==this.root&&(n.actual.error=w.stack||w.message||String(w))};let a;try{a=this._resolveHandler(n.actual===this.root?void 0:n.actual)}catch(w){u(w)}return(0,d.isThenable)(a)?a.catch(u).then(()=>{c.open(),this.updateExpandability(n)}):(c.open(),this.updateExpandability(n)),n.resolveBarrier}pushExpandStateUpdate(n){this.pushDiff([1,{extId:n.fullId.toString(),expand:n.expand}])}removeItem(n){const c=this.tree.get(n);if(!c)throw new Error("attempting to remove non-existent child");this.pushDiff([2,n]);const u=[c];for(;u.length;){const a=u.pop();if(!!a){(0,F.getPrivateApiFor)(a.actual).listener=void 0;for(const w of a.actual.tags)this.decrementTagRefs(w.id);this.tree.delete(a.fullId.toString());for(const w of a.actual.children)u.push(this.tree.get(I.TestId.joinToString(a.fullId,w.id)))}}}flushDiff(){const n=this.collectDiff();n.length&&this.diffOpEmitter.fire(n)}}e.SingleUseTestCollection=t}),define(be[175],Ee([0,1,4,142]),function(re,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,d.refineServiceDecorator)(M.IEnvironmentService)}),define(be[176],Ee([0,1,25,3,17]),function(re,e,d,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class R{constructor(t){this.removedDueToLooping=t}}e.DeltaExtensionsResult=R;class F{constructor(t){this._onDidChange=new M.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=t,this._initialize()}_initialize(){this._extensionDescriptions.sort(_),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const t of this._extensionDescriptions){if(this._extensionsMap.has(d.ExtensionIdentifier.toKey(t.identifier))){console.error("Extension `"+t.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(d.ExtensionIdentifier.toKey(t.identifier),t),this._extensionsArr.push(t),Array.isArray(t.activationEvents))for(let E of t.activationEvents)E==="onUri"&&(E=`onUri:${d.ExtensionIdentifier.toKey(t.identifier)}`),this._activationMap.has(E)||this._activationMap.set(E,[]),this._activationMap.get(E).push(t)}}keepOnly(t){const E=new Set;t.forEach(n=>E.add(d.ExtensionIdentifier.toKey(n))),this._extensionDescriptions=this._extensionDescriptions.filter(n=>E.has(d.ExtensionIdentifier.toKey(n.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(t,E){t.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(t));const n=F._findLoopingExtensions(this._extensionDescriptions);if(E=E.concat(n.map(c=>c.identifier)),E.length>0){const c=new Set;E.forEach(u=>c.add(d.ExtensionIdentifier.toKey(u))),this._extensionDescriptions=this._extensionDescriptions.filter(u=>!c.has(d.ExtensionIdentifier.toKey(u.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new R(n)}static _findLoopingExtensions(t){const E=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(w){this._nodesSet.has(w)||(this._nodesSet.add(w),this._nodesArr.push(w))}addArc(w,T){this.addNode(w),this.addNode(T),this._arcs.has(w)?this._arcs.get(w).push(T):this._arcs.set(w,[T])}getArcs(w){return this._arcs.has(w)?this._arcs.get(w):[]}hasOnlyGoodArcs(w,T){const S=E.getArcs(w);for(let o=0;o<S.length;o++)if(!T.has(S[o]))return!1;return!0}getNodes(){return this._nodesArr}};let n=new Map;for(let w of t){const T=d.ExtensionIdentifier.toKey(w.identifier);if(n.set(T,w),w.extensionDependencies)for(let S of w.extensionDependencies){const o=d.ExtensionIdentifier.toKey(S);E.addArc(T,o)}}let c=new Set;E.getNodes().filter(w=>E.getArcs(w).length===0).forEach(w=>c.add(w));let u=E.getNodes().filter(w=>!c.has(w)),a;do{a=!1;for(let w=0;w<u.length;w++){const T=u[w];E.hasOnlyGoodArcs(T,c)&&(u.splice(w,1),w--,c.add(T),a=!0)}}while(a);return u.map(w=>n.get(w))}containsActivationEvent(t){return this._activationMap.has(t)}containsExtension(t){return this._extensionsMap.has(d.ExtensionIdentifier.toKey(t))}getExtensionDescriptionsForActivationEvent(t){const E=this._activationMap.get(t);return E?E.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(t){const E=this._extensionsMap.get(d.ExtensionIdentifier.toKey(t));return E||void 0}}e.ExtensionDescriptionRegistry=F;var C;(function(I){I[I.Builtin=0]="Builtin",I[I.User=1]="User",I[I.Dev=2]="Dev"})(C||(C={}));function _(I,t){const E=I.isBuiltin?0:I.isUnderDevelopment?2:1,n=t.isBuiltin?0:t.isUnderDevelopment?2:1;if(E!==n)return E-n;const c=b.posix.basename(I.extensionLocation.path),u=b.posix.basename(t.extensionLocation.path);return c<u?-1:c>u?1:0}}),define(be[177],Ee([0,1,22]),function(re,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var M;(function(C){C[C.VersionMismatch=55]="VersionMismatch",C[C.UnexpectedError=81]="UnexpectedError"})(M=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var b;(function(C){C[C.Initialized=0]="Initialized",C[C.Ready=1]="Ready",C[C.Terminate=2]="Terminate"})(b=e.MessageType||(e.MessageType={}));function R(C){const _=d.VSBuffer.alloc(1);switch(C){case 0:_.writeUInt8(1,0);break;case 1:_.writeUInt8(2,0);break;case 2:_.writeUInt8(3,0);break}return _}e.createMessageOfType=R;function F(C,_){if(C.byteLength!==1)return!1;switch(C.readUInt8(0)){case 1:return _===0;case 2:return _===1;case 3:return _===2;default:return!1}}e.isMessageOfType=F}),define(be[30],Ee([0,1,3,2,4,25,143]),function(re,e,d,M,b,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.throwProposedApiError=e.checkProposedApiEnabled=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.ExtensionRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new R.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:M.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,b.createDecorator)("extensionService");var C;(function(o){o[o.None=0]="None",o[o.LocalProcess=1]="LocalProcess",o[o.LocalWebWorker=2]="LocalWebWorker",o[o.Remote=3]="Remote"})(C=e.ExtensionRunningLocation||(e.ExtensionRunningLocation={}));class _{constructor(f){this.dependency=f}}e.MissingExtensionDependency=_;var I;(function(o){o[o.LocalProcess=0]="LocalProcess",o[o.LocalWebWorker=1]="LocalWebWorker",o[o.Remote=2]="Remote"})(I=e.ExtensionHostKind||(e.ExtensionHostKind={}));function t(o){switch(o){case 0:return"LocalProcess";case 1:return"LocalWebWorker";case 2:return"Remote"}}e.extensionHostKindToString=t;class E{constructor(f,y,i,v){this.codeLoadingTime=f,this.activateCallTime=y,this.activateResolvedTime=i,this.activationReason=v}}e.ActivationTimes=E;class n{constructor(f,y){this.description=f,this.value=y}}e.ExtensionPointContribution=n,e.ExtensionHostLogFileName="exthost";var c;(function(o){o[o.Normal=0]="Normal",o[o.Immediate=1]="Immediate"})(c=e.ActivationKind||(e.ActivationKind={}));function u(o){o.enableProposedApi||a(o)}e.checkProposedApiEnabled=u;function a(o){throw new Error(`[${o.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${o.identifier.value}`)}e.throwProposedApiError=a;function w(o){return{type:o.isBuiltin?0:1,isBuiltin:o.isBuiltin||o.isUserBuiltin,identifier:{id:(0,F.getGalleryExtensionId)(o.publisher,o.name),uuid:o.uuid},manifest:o,location:o.extensionLocation}}e.toExtension=w;function T(o,f){return{identifier:new R.ExtensionIdentifier(o.identifier.id),isBuiltin:o.type===0,isUserBuiltin:o.type===1&&o.isBuiltin,isUnderDevelopment:!!f,extensionLocation:o.location,...o.manifest,uuid:o.identifier.uuid}}e.toExtensionDescription=T;class S{constructor(){this.onDidRegisterExtensions=d.Event.None,this.onDidChangeExtensionsStatus=d.Event.None,this.onDidChangeExtensions=d.Event.None,this.onWillActivateByEvent=d.Event.None,this.onDidChangeResponsiveChange=d.Event.None}activateByEvent(f){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(f){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(f){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(f){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(f,y){return Promise.resolve()}_onWillActivateExtension(f){}_onDidActivateExtension(f,y,i,v,r){}_onDidActivateExtensionError(f,y){}_onExtensionRuntimeError(f,y){}_onExtensionHostExit(f){}}e.NullExtensionService=S}),define(be[178],Ee([0,1,25,30,15]),function(re,e,d,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const R=Promise.resolve(void 0);class F{constructor(u,a,w,T){this.startup=u,this.codeLoadingTime=a,this.activateCallTime=w,this.activateResolvedTime=T}}e.ExtensionActivationTimes=F,F.NONE=new F(!1,-1,-1,-1);class C{constructor(u){this._startup=u,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(u,a){return u===-1||a===-1?-1:a-u}build(){return new F(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=C;class _{constructor(u,a,w,T,S,o){this.activationFailed=u,this.activationFailedError=a,this.activationTimes=w,this.module=T,this.exports=S,this.subscriptions=o}}e.ActivatedExtension=_;class I extends _{constructor(u){super(!1,null,u,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=I;class t extends _{constructor(){super(!1,null,F.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=t;class E extends _{constructor(u){super(!0,u,F.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=E;let n=class{constructor(u,a,w,T,S){this._logService=S,this._registry=u,this._resolvedExtensionsSet=new Set,a.forEach(o=>this._resolvedExtensionsSet.add(d.ExtensionIdentifier.toKey(o))),this._hostExtensionsMap=new Map,w.forEach(o=>this._hostExtensionsMap.set(d.ExtensionIdentifier.toKey(o),o)),this._host=T,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(u){const a=d.ExtensionIdentifier.toKey(u);return this._activatedExtensions.has(a)}getActivatedExtension(u){const a=d.ExtensionIdentifier.toKey(u),w=this._activatedExtensions.get(a);if(!w)throw new Error("Extension `"+u.value+"` is not known or not activated");return w}activateByEvent(u,a){if(this._alreadyActivatedEvents[u])return R;const w=this._registry.getExtensionDescriptionsForActivationEvent(u);return this._activateExtensions(w.map(T=>({id:T.identifier,reason:{startup:a,extensionId:T.identifier,activationEvent:u}}))).then(()=>{this._alreadyActivatedEvents[u]=!0})}activateById(u,a){const w=this._registry.getExtensionDescription(u);if(!w)throw new Error("Extension `"+u+"` is not known");return this._activateExtensions([{id:w.identifier,reason:a}])}_handleActivateRequest(u,a,w){if(this._hostExtensionsMap.has(d.ExtensionIdentifier.toKey(u.id))){a[d.ExtensionIdentifier.toKey(u.id)]=u;return}const T=this._registry.getExtensionDescription(u.id);if(!T){const f=new Error(`Cannot activate unknown extension '${u.id.value}'`);this._host.onExtensionActivationError(u.id,f,new M.MissingExtensionDependency(u.id.value)),this._activatedExtensions.set(d.ExtensionIdentifier.toKey(u.id),new E(f));return}const S=typeof T.extensionDependencies=="undefined"?[]:T.extensionDependencies;let o=!0;for(let f=0,y=S.length;f<y;f++){const i=S[f];if(this._resolvedExtensionsSet.has(d.ExtensionIdentifier.toKey(i)))continue;const v=this._activatedExtensions.get(d.ExtensionIdentifier.toKey(i));if(v&&!v.activationFailed)continue;if(v&&v.activationFailed){const h=T.displayName||T.identifier.value,p=this._registry.getExtensionDescription(i),k=p&&p.displayName||i,P=new Error(`Cannot activate the '${h}' extension because its dependency '${k}' failed to activate`);P.detail=v.activationFailedError,this._host.onExtensionActivationError(T.identifier,P,null),this._activatedExtensions.set(d.ExtensionIdentifier.toKey(T.identifier),new E(P));return}if(this._hostExtensionsMap.has(d.ExtensionIdentifier.toKey(i))){o=!1,a[d.ExtensionIdentifier.toKey(i)]={id:this._hostExtensionsMap.get(d.ExtensionIdentifier.toKey(i)),reason:u.reason};continue}const r=this._registry.getExtensionDescription(i);if(r){o=!1,a[d.ExtensionIdentifier.toKey(i)]={id:r.identifier,reason:u.reason};continue}const s=T.displayName||T.identifier.value,l=new Error(`Cannot activate the '${s}' extension because it depends on unknown extension '${i}'`);this._host.onExtensionActivationError(T.identifier,l,new M.MissingExtensionDependency(i)),this._activatedExtensions.set(d.ExtensionIdentifier.toKey(T.identifier),new E(l));return}o?a[d.ExtensionIdentifier.toKey(T.identifier)]=u:w.push(u)}_activateExtensions(u){if(u.length===0||(u=u.filter(S=>!this._activatedExtensions.has(d.ExtensionIdentifier.toKey(S.id))),u.length===0))return Promise.resolve(void 0);const a=Object.create(null),w=[];for(let S=0,o=u.length;S<o;S++)this._handleActivateRequest(u[S],a,w);for(let S=0,o=w.length;S<o;S++){const f=d.ExtensionIdentifier.toKey(w[S].id);a[f]&&delete a[f]}const T=Object.keys(a).map(S=>a[S]);return w.length===0?Promise.all(T.map(S=>this._activateExtension(S.id,S.reason))).then(S=>{}):this._activateExtensions(T).then(S=>this._activateExtensions(w))}_activateExtension(u,a){const w=d.ExtensionIdentifier.toKey(u);if(this._activatedExtensions.has(w))return Promise.resolve(void 0);const T=this._activatingExtensions.get(w);if(T)return T;const S=this._host.actualActivateExtension(u,a).then(void 0,o=>{const f=new Error;return o&&o.name&&(f.name=o.name),o&&o.message?f.message=`Activating extension '${u.value}' failed: ${o.message}.`:f.message=`Activating extension '${u.value}' failed: ${o}.`,o&&o.stack&&(f.stack=o.stack),this._host.onExtensionActivationError(u,f,null),this._logService.error(`Activating extension ${u.value} failed due to an error:`),this._logService.error(o),new E(o)}).then(o=>{this._activatedExtensions.set(w,o),this._activatingExtensions.delete(w)});return this._activatingExtensions.set(w,S),S}};n=We([ze(4,b.ILogService)],n),e.ExtensionsActivator=n}),define(be[179],Ee([0,1,16]),function(re,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class M{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((R,F)=>{this._actualOk=R,this._actualErr=F,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(R){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=R,this._actual&&this._actualOk(R))}resolveErr(R){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=R,this._actual?this._actualErr(R):(0,d.onUnexpectedError)(R))}then(R,F){return this._ensureActual().then(R,F)}catch(R){return this._ensureActual().then(void 0,R)}finally(R){return this._ensureActual().finally(R)}}e.LazyPromise=M}),define(be[38],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class d{constructor(I,t){this._proxyIdentifierBrand=void 0,this.isMain=I,this.sid=t,this.nid=++d.count}}e.ProxyIdentifier=d,d.count=0;const M=[];function b(_){const I=new d(!0,_);return M[I.nid]=I,I}e.createMainContextProxyIdentifier=b;function R(_){const I=new d(!1,_);return M[I.nid]=I,I}e.createExtHostContextProxyIdentifier=R;function F(_){return M[_].sid}e.getStringIdentifierForProxy=F;class C{constructor(I){this.value=I}}e.SerializableObjectWithBuffers=C}),define(be[5],Ee([0,1,54,2,38]),function(re,e,d,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var R;(function(o){o[o.Desktop=1]="Desktop",o[o.Web=2]="Web"})(R=e.UIKind||(e.UIKind={}));var F;(function(o){o[o.Default=0]="Default",o[o.InCenter=1]="InCenter",o[o.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",o[o.AtTop=3]="AtTop"})(F=e.TextEditorRevealType||(e.TextEditorRevealType={}));var C;(function(o){o[o.Editable=0]="Editable",o[o.SupportsHotExit=1]="SupportsHotExit"})(C=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var _;(function(o){o[o.Int8Array=1]="Int8Array",o[o.Uint8Array=2]="Uint8Array",o[o.Uint8ClampedArray=3]="Uint8ClampedArray",o[o.Int16Array=4]="Int16Array",o[o.Uint16Array=5]="Uint16Array",o[o.Int32Array=6]="Int32Array",o[o.Uint32Array=7]="Uint32Array",o[o.Float32Array=8]="Float32Array",o[o.Float64Array=9]="Float64Array",o[o.BigInt64Array=10]="BigInt64Array",o[o.BigUint64Array=11]="BigUint64Array"})(_=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var I;(function(o){o[o.Text=1]="Text",o[o.Error=2]="Error",o[o.Rich=3]="Rich"})(I=e.CellOutputKind||(e.CellOutputKind={}));var t;(function(o){o[o.Default=0]="Default",o[o.InCenter=1]="InCenter",o[o.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",o[o.AtTop=3]="AtTop"})(t=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var E;(function(o){o[o.None=0]="None",o[o.Process=1]="Process",o[o.Output=2]="Output"})(E=e.CandidatePortSource||(e.CandidatePortSource={}));var n;(function(o){o.name="$ident";function f(i,v){return Object.defineProperty(i,o.name,{value:v,enumerable:!0}),i}o.mixin=f;function y(i){return i[o.name]}o.of=y})(n=e.ObjectIdentifier||(e.ObjectIdentifier={}));class c{static mixin(f){return f._id=c._n++,f}}e.IdObject=c,c._n=0;var u;(function(o){o.label="a",o.kind="b",o.detail="c",o.documentation="d",o.sortText="e",o.filterText="f",o.preselect="g",o.insertText="h",o.insertTextRules="i",o.range="j",o.commitCharacters="k",o.additionalTextEdits="l",o.command="m",o.kindModifier="n"})(u=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var a;(function(o){o.defaultRanges="a",o.completions="b",o.isIncomplete="c",o.duration="d"})(a=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var w;(function(o){o[o.File=1]="File",o[o.Text=2]="Text",o[o.Cell=3]="Cell"})(w=e.WorkspaceEditType||(e.WorkspaceEditType={}));function T(o){if(o&&o.edits)for(const f of o.edits)typeof f.resource=="object"?f.resource=M.URI.revive(f.resource):(f.newUri=M.URI.revive(f.newUri),f.oldUri=M.URI.revive(f.oldUri)),f.metadata&&f.metadata.iconPath&&(f.metadata=(0,d.revive)(f.metadata));return o}e.reviveWorkspaceEditDto=T;var S;(function(o){o[o.Workspace=0]="Workspace",o[o.TextDocument=1]="TextDocument"})(S=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,b.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,b.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,b.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,b.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,b.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,b.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,b.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,b.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,b.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,b.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,b.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,b.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,b.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,b.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,b.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,b.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,b.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,b.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,b.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,b.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,b.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,b.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLog:(0,b.createMainContextProxyIdentifier)("MainThread"),MainThreadMessageService:(0,b.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,b.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,b.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,b.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,b.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,b.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,b.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,b.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,b.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,b.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,b.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,b.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,b.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,b.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,b.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,b.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,b.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,b.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,b.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,b.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,b.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,b.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,b.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,b.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,b.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,b.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,b.createMainContextProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,b.createMainContextProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,b.createMainContextProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,b.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,b.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,b.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,b.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,b.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,b.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,b.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,b.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,b.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,b.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,b.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,b.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,b.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,b.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,b.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,b.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,b.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,b.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,b.createExtHostContextProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,b.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,b.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,b.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogService:(0,b.createExtHostContextProxyIdentifier)("ExtHostLogService"),ExtHostTerminalService:(0,b.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,b.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,b.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,b.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,b.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,b.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,b.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,b.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,b.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,b.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,b.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,b.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,b.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,b.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,b.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,b.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,b.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,b.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,b.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,b.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,b.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,b.createMainContextProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,b.createMainContextProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,b.createMainContextProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,b.createMainContextProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,b.createMainContextProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,b.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,b.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,b.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,b.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,b.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,b.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(be[69],Ee([0,1,5,3,4]),function(re,e,d,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class R{constructor(C){this._onDidChangePassword=new M.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=C.getProxy(d.MainContext.MainThreadSecretState)}async $onDidChangePassword(C){this._onDidChangePassword.fire(C)}get(C,_){return this._proxy.$getPassword(C,_)}store(C,_,I){return this._proxy.$setPassword(C,_,I)}delete(C,_){return this._proxy.$deletePassword(C,_)}}e.ExtHostSecretState=R,e.IExtHostSecretState=(0,b.createDecorator)("IExtHostSecretState")}),define(be[70],Ee([0,1,4,15,5,13]),function(re,e,d,M,b,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,d.createDecorator)("IExtHostApiDeprecationService");let F=class{constructor(_,I){this._extHostLogService=I,this._reportedUsages=new Set,this._telemetryShape=_.getProxy(b.MainContext.MainThreadTelemetry)}report(_,I,t){const E=this.getUsageKey(_,I);this._reportedUsages.has(E)||(this._reportedUsages.add(E),I.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${_}' is deprecated. ${t}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:I.identifier.value,apiId:_}))}getUsageKey(_,I){return`${_}-${I.identifier.value}`}};F=We([ze(0,R.IExtHostRpcService),ze(1,M.ILogService)],F),e.ExtHostApiDeprecationService=F,e.NullApiDeprecationService=Object.freeze(new class{report(C,_,I){}})}),define(be[180],Ee([0,1,3,5,7,25]),function(re,e,d,M,b,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class F{constructor(_){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new d.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=_.getProxy(M.MainContext.MainThreadAuthentication)}$setProviders(_){return this._providers=_,Promise.resolve()}async getSession(_,I,t,E={}){const n=R.ExtensionIdentifier.toKey(_.identifier),c=this._inFlightRequests.get(n)||[],u=[...t].sort().join(" ");let a=c.find(w=>w.scopes===u);if(a)return a.result;{const w=this._getSession(_,n,I,t,E);a={scopes:u,result:w},c.push(a),this._inFlightRequests.set(n,c);try{await w}finally{const T=c.findIndex(S=>S.scopes===u);T>-1&&(c.splice(T),this._inFlightRequests.set(n,c))}return w}}async _getSession(_,I,t,E,n={}){await this._proxy.$ensureProvider(t);const c=_.displayName||_.name;return this._proxy.$getSession(t,E,I,c,n)}async removeSession(_,I){const t=this._authenticationProviders.get(_);return t?t.provider.removeSession(I):this._proxy.$removeSession(_,I)}registerAuthenticationProvider(_,I,t,E){if(this._authenticationProviders.get(_))throw new Error(`An authentication provider with id '${_}' is already registered.`);this._authenticationProviders.set(_,{label:I,provider:t,options:E??{supportsMultipleAccounts:!1}}),this._providers.find(c=>c.id===_)||this._providers.push({id:_,label:I});const n=t.onDidChangeSessions(c=>{this._proxy.$sendDidChangeSessions(_,{added:c.added??[],changed:c.changed??[],removed:c.removed??[]})});return this._proxy.$registerAuthenticationProvider(_,I,E?.supportsMultipleAccounts??!1),new b.Disposable(()=>{n.dispose(),this._authenticationProviders.delete(_);const c=this._providers.findIndex(u=>u.id===_);c>-1&&this._providers.splice(c),this._proxy.$unregisterAuthenticationProvider(_)})}$createSession(_,I){const t=this._authenticationProviders.get(_);if(t)return Promise.resolve(t.provider.createSession(I));throw new Error(`Unable to find authentication provider with handle: ${_}`)}$removeSession(_,I){const t=this._authenticationProviders.get(_);if(t)return Promise.resolve(t.provider.removeSession(I));throw new Error(`Unable to find authentication provider with handle: ${_}`)}$getSessions(_,I){const t=this._authenticationProviders.get(_);if(t)return Promise.resolve(t.provider.getSessions(I));throw new Error(`Unable to find authentication provider with handle: ${_}`)}$onDidChangeAuthenticationSessions(_,I){return this._onDidChangeSessions.fire({provider:{id:_,label:I}}),Promise.resolve()}}e.ExtHostAuthentication=F}),define(be[181],Ee([0,1,5,13,8]),function(re,e,d,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let R=class{constructor(C,_){this._extHostDocumentsAndEditors=_,this._proxy=C.getProxy(d.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(C){const _=b.WorkspaceEdit.from(C,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(_)}};R=We([ze(0,M.IExtHostRpcService)],R),e.ExtHostBulkEdits=R}),define(be[182],Ee([0,1,5]),function(re,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class M{constructor(R){const F=R.getProxy(d.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return F.$readText()},writeText(C){return F.$writeText(C)}})}}e.ExtHostClipboard=M}),define(be[39],Ee([0,1,10,7,8,23,5,12,15,54,44,112,2,6,4,13,48,22,38]),function(re,e,d,M,b,R,F,C,_,I,t,E,n,c,u,a,w,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let o=class{constructor(s,l){this._commands=new Map,this._apiCommands=new Map,this._proxy=s.getProxy(F.MainContext.MainThreadCommands),this._logService=l,this.converter=new f(this,h=>{const p=this._apiCommands.get(h);return p?.result===i.Void?p:void 0},l),this._argumentProcessors=[{processArgument(h){return(0,I.revive)(h)}},{processArgument(h){return(0,R.cloneAndChange)(h,function(p){if(t.Range.isIRange(p))return b.Range.to(p);if(E.Position.isIPosition(p))return b.Position.to(p);if(t.Range.isIRange(p.range)&&n.URI.isUri(p.uri))return b.location.to(p);if(p instanceof T.VSBuffer)return p.buffer.buffer;if(!Array.isArray(p))return p})}}]}registerArgumentProcessor(s){this._argumentProcessors.push(s)}registerApiCommand(s){const l=this.registerCommand(!1,s.id,async(...h)=>{const p=s.args.map((P,g)=>{if(!P.validate(h[g]))throw new Error(`Invalid argument '${P.name}' when running '${s.id}', received: ${h[g]}`);return P.convert(h[g])}),k=await this.executeCommand(s.internalId,...p);return s.result.convert(k,h,this.converter)},void 0,{description:s.description,args:s.args,returns:s.result.description});return this._apiCommands.set(s.id,s),new M.Disposable(()=>{l.dispose(),this._apiCommands.delete(s.id)})}registerCommand(s,l,h,p,k){if(this._logService.trace("ExtHostCommands#registerCommand",l),!l.trim().length)throw new Error("invalid id");if(this._commands.has(l))throw new Error(`command '${l}' already exists`);return this._commands.set(l,{callback:h,thisArg:p,description:k}),s&&this._proxy.$registerCommand(l),new M.Disposable(()=>{this._commands.delete(l)&&s&&this._proxy.$unregisterCommand(l)})}executeCommand(s,...l){return this._logService.trace("ExtHostCommands#executeCommand",s),this._doExecuteCommand(s,l,!0)}async _doExecuteCommand(s,l,h){if(this._commands.has(s))return this._executeContributedCommand(s,l);{let p=!1;const k=(0,R.cloneAndChange)(l,function(P){if(P instanceof M.Position)return b.Position.from(P);if(P instanceof M.Range)return b.Range.from(P);if(P instanceof M.Location)return b.location.from(P);if(M.NotebookRange.isNotebookRange(P))return b.NotebookRange.from(P);if(P instanceof ArrayBuffer)return p=!0,T.VSBuffer.wrap(new Uint8Array(P));if(P instanceof Uint8Array)return p=!0,T.VSBuffer.wrap(P);if(!Array.isArray(P))return P});try{const P=await this._proxy.$executeCommand(s,p?new S.SerializableObjectWithBuffers(k):k,h);return(0,I.revive)(P)}catch(P){if(P instanceof Error&&P.message==="$executeCommand:retry")return this._doExecuteCommand(s,l,!1);throw P}}}async _executeContributedCommand(s,l){const h=this._commands.get(s);if(!h)throw new Error("Unknown command");let{callback:p,thisArg:k,description:P}=h;if(P)for(let g=0;g<P.args.length;g++)try{(0,d.validateConstraint)(l[g],P.args[g].constraint)}catch(D){throw new Error(`Running the contributed command: '${s}' failed. Illegal argument '${P.args[g].name}' - ${P.args[g].description}`)}try{return await p.apply(k,l)}catch(g){if(s===this.converter.delegatingCommandId){const D=this.converter.getActualCommand(...l);D&&(s=D.command)}throw this._logService.error(g,s),new Error(`Running the contributed command: '${s}' failed.`)}}$executeContributedCommand(s,...l){return this._logService.trace("ExtHostCommands#$executeContributedCommand",s),this._commands.has(s)?(l=l.map(h=>this._argumentProcessors.reduce((p,k)=>k.processArgument(p),h)),this._executeContributedCommand(s,l)):Promise.reject(new Error(`Contributed command '${s}' does not exist.`))}getCommands(s=!1){return this._logService.trace("ExtHostCommands#getCommands",s),this._proxy.$getCommands().then(l=>(s&&(l=l.filter(h=>h[0]!=="_")),l))}$getContributedCommandHandlerDescriptions(){const s=Object.create(null);for(let[l,h]of this._commands){let{description:p}=h;p&&(s[l]=p)}return Promise.resolve(s)}};o=We([ze(0,a.IExtHostRpcService),ze(1,_.ILogService)],o),e.ExtHostCommands=o,e.IExtHostCommands=(0,u.createDecorator)("IExtHostCommands");class f{constructor(s,l,h){this._commands=s,this._lookupApiCommand=l,this._logService=h,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(s,l){if(!s)return;const h={$ident:void 0,id:s.command,title:s.title,tooltip:s.tooltip};if(!s.command)return h;const p=this._lookupApiCommand(s.command);if(p)h.id=p.internalId,h.arguments=p.args.map((k,P)=>k.convert(s.arguments&&s.arguments[P]));else if((0,C.isNonEmptyArray)(s.arguments)){const k=++this._cachIdPool;this._cache.set(k,s),l.add((0,c.toDisposable)(()=>{this._cache.delete(k),this._logService.trace("CommandsConverter#DISPOSE",k)})),h.$ident=k,h.id=this.delegatingCommandId,h.arguments=[k],this._logService.trace("CommandsConverter#CREATE",s.command,k)}return h}fromInternal(s){const l=F.ObjectIdentifier.of(s);return typeof l=="number"?this._cache.get(l):{command:s.id,title:s.title,arguments:s.arguments}}getActualCommand(...s){return this._cache.get(s[0])}_executeConvertedCommand(...s){const l=this.getActualCommand(...s);return this._logService.trace("CommandsConverter#EXECUTE",s[0],l?l.command:"MISSING"),l?this._commands.executeCommand(l.command,...l.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=f;class y{constructor(s,l,h,p){this.name=s,this.description=l,this.validate=h,this.convert=p}optional(){return new y(this.name,`(optional) ${this.description}`,s=>s==null||this.validate(s),s=>s===void 0?void 0:s===null?null:this.convert(s))}with(s,l){return new y(s??this.name,l??this.description,this.validate,this.convert)}}e.ApiCommandArgument=y,y.Uri=new y("uri","Uri of a text document",r=>n.URI.isUri(r),r=>r),y.Position=new y("position","A position in a text document",r=>M.Position.isPosition(r),b.Position.from),y.Range=new y("range","A range in a text document",r=>M.Range.isRange(r),b.Range.from),y.Selection=new y("selection","A selection in a text document",r=>M.Selection.isSelection(r),b.Selection.from),y.Number=new y("number","",r=>typeof r=="number",r=>r),y.String=new y("string","",r=>typeof r=="string",r=>r),y.CallHierarchyItem=new y("item","A call hierarchy item",r=>r instanceof M.CallHierarchyItem,b.CallHierarchyItem.from),y.TypeHierarchyItem=new y("item","A type hierarchy item",r=>r instanceof M.TypeHierarchyItem,b.TypeHierarchyItem.from),y.TestItem=new y("testItem","A VS Code TestItem",r=>r instanceof w.TestItemImpl,b.TestItem.from);class i{constructor(s,l){this.description=s,this.convert=l}}e.ApiCommandResult=i,i.Void=new i("no result",r=>r);class v{constructor(s,l,h,p,k){this.id=s,this.internalId=l,this.description=h,this.args=p,this.result=k}}e.ApiCommand=v}),define(be[183],Ee([0,1,8,7,59,39,12,80]),function(re,e,d,M,b,R,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const _=[new R.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[R.ApiCommandArgument.Uri,R.ApiCommandArgument.Position],new R.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",t(d.DocumentHighlight.to))),new R.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[R.ApiCommandArgument.Uri],new R.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(n,c)=>{if((0,F.isFalsyOrEmpty)(n))return;class u extends M.SymbolInformation{static to(w){const T=new u(w.name,d.SymbolKind.to(w.kind),w.containerName||"",new M.Location(c[0],d.Range.to(w.range)));return T.detail=w.detail,T.range=T.location.range,T.selectionRange=d.Range.to(w.selectionRange),T.children=w.children?w.children.map(u.to):[],T}}return n.map(u.to)})),new R.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[R.ApiCommandArgument.Uri,new R.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new R.ApiCommandResult("A promise that resolves to an array of TextEdits.",t(d.TextEdit.to))),new R.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[R.ApiCommandArgument.Uri,R.ApiCommandArgument.Range,new R.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new R.ApiCommandResult("A promise that resolves to an array of TextEdits.",t(d.TextEdit.to))),new R.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[R.ApiCommandArgument.Uri,R.ApiCommandArgument.Position,new R.ApiCommandArgument("ch","Trigger character",n=>typeof n=="string",n=>n),new R.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new R.ApiCommandResult("A promise that resolves to an array of TextEdits.",t(d.TextEdit.to))),new R.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[R.ApiCommandArgument.Uri,R.ApiCommandArgument.Position],new R.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",E)),new R.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[R.ApiCommandArgument.Uri,R.ApiCommandArgument.Position],new R.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",E)),new R.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[R.ApiCommandArgument.Uri,R.ApiCommandArgument.Position],new R.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",E)),new R.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[R.ApiCommandArgument.Uri,R.ApiCommandArgument.Position],new R.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",E)),new R.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[R.ApiCommandArgument.Uri,R.ApiCommandArgument.Position],new R.ApiCommandResult("A promise that resolves to an array of Location-instances.",t(d.location.to))),new R.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[R.ApiCommandArgument.Uri,R.ApiCommandArgument.Position],new R.ApiCommandResult("A promise that resolves to an array of Hover-instances.",t(d.Hover.to))),new R.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[R.ApiCommandArgument.Uri,new R.ApiCommandArgument("position","A position in a text document",n=>Array.isArray(n)&&n.every(c=>M.Position.isPosition(c)),n=>n.map(d.Position.from))],new R.ApiCommandResult("A promise that resolves to an array of ranges.",n=>n.map(c=>{let u;for(const a of c.reverse())u=new M.SelectionRange(d.Range.to(a),u);return u}))),new R.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[R.ApiCommandArgument.String.with("query","Search string")],new R.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",n=>{const c=[];if(Array.isArray(n))for(let u of n)c.push(...u[1].map(d.WorkspaceSymbol.to));return c})),new R.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[R.ApiCommandArgument.Uri,R.ApiCommandArgument.Position],new R.ApiCommandResult("A CallHierarchyItem or undefined",n=>n.map(d.CallHierarchyItem.to))),new R.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[R.ApiCommandArgument.CallHierarchyItem],new R.ApiCommandResult("A CallHierarchyItem or undefined",n=>n.map(d.CallHierarchyIncomingCall.to))),new R.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[R.ApiCommandArgument.CallHierarchyItem],new R.ApiCommandResult("A CallHierarchyItem or undefined",n=>n.map(d.CallHierarchyOutgoingCall.to))),new R.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[R.ApiCommandArgument.Uri,R.ApiCommandArgument.Position,R.ApiCommandArgument.String.with("newName","The new symbol name")],new R.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",n=>{if(!!n){if(n.rejectReason)throw new Error(n.rejectReason);return d.WorkspaceEdit.to(n)}})),new R.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[R.ApiCommandArgument.Uri,R.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new R.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",n=>n.map(d.DocumentLink.to))),new R.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[R.ApiCommandArgument.Uri],new R.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",n=>{if(!!n)return new M.SemanticTokensLegend(n.tokenTypes,n.tokenModifiers)})),new R.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[R.ApiCommandArgument.Uri],new R.ApiCommandResult("A promise that resolves to SemanticTokens.",n=>{if(!n)return;const c=(0,C.decodeSemanticTokensDto)(n);if(c.type==="full")return new M.SemanticTokens(c.data,void 0)})),new R.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[R.ApiCommandArgument.Uri],new R.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",n=>{if(!!n)return new M.SemanticTokensLegend(n.tokenTypes,n.tokenModifiers)})),new R.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[R.ApiCommandArgument.Uri,R.ApiCommandArgument.Range],new R.ApiCommandResult("A promise that resolves to SemanticTokens.",n=>{if(!n)return;const c=(0,C.decodeSemanticTokensDto)(n);if(c.type==="full")return new M.SemanticTokens(c.data,void 0)})),new R.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[R.ApiCommandArgument.Uri,R.ApiCommandArgument.Position,R.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),R.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new R.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(n,c,u)=>{if(!n)return new M.CompletionList([]);const a=n.suggestions.map(w=>d.CompletionItem.to(w,u));return new M.CompletionList(a,n.incomplete)})),new R.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[R.ApiCommandArgument.Uri,R.ApiCommandArgument.Position,R.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new R.ApiCommandResult("A promise that resolves to SignatureHelp.",n=>{if(n)return d.SignatureHelp.to(n)})),new R.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[R.ApiCommandArgument.Uri,R.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new R.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(n,c,u)=>t(a=>new M.CodeLens(d.Range.to(a.range),a.command&&u.fromInternal(a.command)))(n))),new R.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[R.ApiCommandArgument.Uri,new R.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",n=>M.Range.isRange(n),n=>M.Selection.isSelection(n)?d.Selection.from(n):d.Range.from(n)),R.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),R.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new R.ApiCommandResult("A promise that resolves to an array of Command-instances.",(n,c,u)=>t(a=>{if(a._isSynthetic){if(!a.command)throw new Error("Synthetic code actions must have a command");return u.fromInternal(a.command)}else{const w=new M.CodeAction(a.title,a.kind?new M.CodeActionKind(a.kind):void 0);return a.edit&&(w.edit=d.WorkspaceEdit.to(a.edit)),a.command&&(w.command=u.fromInternal(a.command)),w.isPreferred=a.isPreferred,w}})(n))),new R.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[R.ApiCommandArgument.Uri],new R.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",n=>n?n.map(c=>new M.ColorInformation(d.Range.to(c.range),d.Color.to(c.color))):[])),new R.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new R.ApiCommandArgument("color","The color to show and insert",n=>n instanceof M.Color,d.Color.from),new R.ApiCommandArgument("context","Context object with uri and range",n=>!0,n=>({uri:n.uri,range:d.Range.from(n.range)}))],new R.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",n=>n?n.map(d.ColorPresentation.to):[])),new R.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[R.ApiCommandArgument.Uri,R.ApiCommandArgument.Range],new R.ApiCommandResult("A promise that resolves to an array of Inlay objects",n=>n.map(d.InlayHint.to))),new R.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new R.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",t(n=>({viewType:n.viewType,displayName:n.displayName,options:{transientOutputs:n.options.transientOutputs,transientCellMetadata:n.options.transientCellMetadata,transientDocumentMetadata:n.options.transientDocumentMetadata},filenamePattern:n.filenamePattern.map(c=>d.NotebookExclusiveDocumentPattern.to(c))})))),new R.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[R.ApiCommandArgument.Uri,R.ApiCommandArgument.Range],new R.ApiCommandResult("A promise that resolves to an array of InlineValue objects",n=>n.map(d.InlineValue.to))),new R.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[R.ApiCommandArgument.Uri,new R.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="number"||typeof n=="object",n=>n&&(typeof n=="number"?[n,void 0]:[d.ViewColumn.from(n.viewColumn),d.TextEditorOpenOptions.from(n)])).optional(),R.ApiCommandArgument.String.with("label","").optional()],R.ApiCommandResult.Void),new R.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[R.ApiCommandArgument.Uri.with("resource","Resource to open"),R.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new R.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="number"||typeof n=="object",n=>n&&(typeof n=="number"?[n,void 0]:[d.ViewColumn.from(n.viewColumn),d.TextEditorOpenOptions.from(n)])).optional()],R.ApiCommandResult.Void),new R.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[R.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),R.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),R.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new R.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="object",n=>n&&[d.ViewColumn.from(n.viewColumn),d.TextEditorOpenOptions.from(n)]).optional()],R.ApiCommandResult.Void),new R.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[R.ApiCommandArgument.Uri,R.ApiCommandArgument.Position],new R.ApiCommandResult("A TypeHierarchyItem or undefined",n=>n.map(d.TypeHierarchyItem.to))),new R.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[R.ApiCommandArgument.TypeHierarchyItem],new R.ApiCommandResult("A TypeHierarchyItem or undefined",n=>n.map(d.TypeHierarchyItem.to))),new R.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[R.ApiCommandArgument.TypeHierarchyItem],new R.ApiCommandResult("A TypeHierarchyItem or undefined",n=>n.map(d.TypeHierarchyItem.to))),new R.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[R.ApiCommandArgument.TestItem],R.ApiCommandResult.Void)];class I{static register(c){_.forEach(c.registerApiCommand,c)}}e.ExtHostApiCommands=I;function t(n){return c=>{if(Array.isArray(c))return c.map(n)}}function E(n){if(!Array.isArray(n))return;const c=[];for(const u of n)b.isLocationLink(u)?c.push(d.DefinitionLink.to(u)):c.push(d.location.to(u));return c}}),define(be[184],Ee([0,1,14,52,3,6,2,59,25,8,7,5]),function(re,e,d,M,b,R,F,C,_,I,t,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function n(c,u,a){const w=c.getProxy(E.MainContext.MainThreadComments);class T{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,u.registerArgumentProcessor({processArgument:s=>{if(s&&s.$mid===6){const l=this._commentControllers.get(s.handle);return l||s}else if(s&&s.$mid===7){const l=this._commentControllers.get(s.commentControlHandle);if(!l)return s;const h=l.getCommentThread(s.commentThreadHandle);return h||s}else if(s&&s.$mid===8){const l=this._commentControllers.get(s.thread.commentControlHandle);if(!l)return s;const h=l.getCommentThread(s.thread.commentThreadHandle);return h?{thread:h,text:s.text}:s}else if(s&&s.$mid===9){const l=this._commentControllers.get(s.thread.commentControlHandle);if(!l)return s;const h=l.getCommentThread(s.thread.commentThreadHandle);if(!h)return s;let p=s.commentUniqueId,k=h.getCommentByUniqueId(p);return k||s}else if(s&&s.$mid===10){const l=this._commentControllers.get(s.thread.commentControlHandle);if(!l)return s;const h=l.getCommentThread(s.thread.commentThreadHandle);if(!h)return s;let p=s.text,k=s.commentUniqueId,P=h.getCommentByUniqueId(k);return P?(P.body=p,P):s}return s}})}createCommentController(s,l,h){const p=T.handlePool++,k=new o(s,p,l,h);this._commentControllers.set(k.handle,k);const P=this._commentControllersByExtension.get(_.ExtensionIdentifier.toKey(s.identifier))||[];return P.push(k),this._commentControllersByExtension.set(_.ExtensionIdentifier.toKey(s.identifier),P),k.value}$createCommentThreadTemplate(s,l,h){const p=this._commentControllers.get(s);!p||p.$createCommentThreadTemplate(l,h)}async $updateCommentThreadTemplate(s,l,h){const p=this._commentControllers.get(s);!p||p.$updateCommentThreadTemplate(l,h)}$deleteCommentThread(s,l){const h=this._commentControllers.get(s);h&&h.$deleteCommentThread(l)}$provideCommentingRanges(s,l,h){const p=this._commentControllers.get(s);if(!p||!p.commentingRangeProvider)return Promise.resolve(void 0);const k=a.getDocument(F.URI.revive(l));return(0,d.asPromise)(()=>p.commentingRangeProvider.provideCommentingRanges(k,h)).then(P=>P?P.map(g=>I.Range.from(g)):void 0)}$toggleReaction(s,l,h,p,k){const P=this._commentControllers.get(s);return!P||!P.reactionHandler?Promise.resolve(void 0):(0,d.asPromise)(()=>{const g=P.getCommentThread(l);if(g){const D=g.getCommentByUniqueId(p.uniqueIdInThread);if(P!==void 0&&D&&P.reactionHandler)return P.reactionHandler(D,i(k))}return Promise.resolve(void 0)})}dispose(){}}T.handlePool=0;class S{constructor(s,l,h,p,k,P,g){this._commentControllerHandle=l,this._id=h,this._uri=p,this._range=k,this._comments=P,this.handle=S._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new b.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new R.MutableDisposable,this._acceptInputDisposables.value=new R.DisposableStore,this._id===void 0&&(this._id=`${s}.${this.handle}`),w.$createCommentThread(l,this.handle,this._id,this._uri,I.Range.from(this._range),g),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=P,this._localDisposables.push({dispose:()=>{w.$deleteCommentThread(l,this.handle)}});const D=this;this.value={get uri(){return D.uri},get range(){return D.range},set range(m){D.range=m},get comments(){return D.comments},set comments(m){D.comments=m},get collapsibleState(){return D.collapsibleState},set collapsibleState(m){D.collapsibleState=m},get canReply(){return D.canReply},set canReply(m){D.canReply=m},get contextValue(){return D.contextValue},set contextValue(m){D.contextValue=m},get label(){return D.label},set label(m){D.label=m},dispose:()=>{D.dispose()}}}set threadId(s){this._id=s}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(s){s.isEqual(this._range)||(this._range=s,this.modifications.range=s,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(s){this._canReply!==s&&(this._canReply=s,this.modifications.canReply=s,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(s){this._label=s,this.modifications.label=s,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(s){this._contextValue=s,this.modifications.contextValue=s,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(s){this._comments=s,this.modifications.comments=s,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(s){this._collapseState=s,this.modifications.collapsibleState=s,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new R.DisposableStore);const s=h=>Object.prototype.hasOwnProperty.call(this.modifications,h),l={};s("range")&&(l.range=I.Range.from(this._range)),s("label")&&(l.label=this.label),s("contextValue")&&(l.contextValue=this.contextValue),s("comments")&&(l.comments=this._comments.map(h=>f(this,h,this._commentsMap))),s("collapsibleState")&&(l.collapseState=v(this._collapseState)),s("canReply")&&(l.canReply=this.canReply),this.modifications={},w.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,l)}getCommentByUniqueId(s){for(let l of this._commentsMap){let h=l[0],p=l[1];if(s===p)return h}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(s=>s.dispose())}}S._handlePool=0,We([(0,M.debounce)(100)],S.prototype,"eventuallyUpdateCommentThread",null);class o{constructor(s,l,h,p){this._extension=s,this._handle=l,this._id=h,this._label=p,this._threads=new Map,w.$registerCommentController(this.handle,h,p);const k=this;this.value=Object.freeze({id:k.id,label:k.label,get options(){return k.options},set options(P){k.options=P},get commentingRangeProvider(){return k.commentingRangeProvider},set commentingRangeProvider(P){k.commentingRangeProvider=P},get reactionHandler(){return k.reactionHandler},set reactionHandler(P){k.reactionHandler=P},createCommentThread(P,g,D){return k.createCommentThread(P,g,D).value},dispose:()=>{k.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{w.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get reactionHandler(){return this._reactionHandler}set reactionHandler(s){this._reactionHandler=s,w.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!s})}get options(){return this._options}set options(s){this._options=s,w.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(s,l,h,p){if(typeof s=="string"){const k=new S(this.id,this.handle,s,l,h,p,this._extension.identifier);return this._threads.set(k.handle,k),k}else{const k=new S(this.id,this.handle,void 0,s,l,h,this._extension.identifier);return this._threads.set(k.handle,k),k}}$createCommentThreadTemplate(s,l){const h=new S(this.id,this.handle,void 0,F.URI.revive(s),I.Range.to(l),[],this._extension.identifier);return h.collapsibleState=C.CommentThreadCollapsibleState.Expanded,this._threads.set(h.handle,h),h}$updateCommentThreadTemplate(s,l){let h=this._threads.get(s);h&&(h.range=I.Range.to(l))}$deleteCommentThread(s){let l=this._threads.get(s);l&&l.dispose(),this._threads.delete(s)}getCommentThread(s){return this._threads.get(s)}dispose(){this._threads.forEach(s=>{s.dispose()}),this._localDisposables.forEach(s=>s.dispose())}}function f(r,s,l){let h=l.get(s);h||(h=++r.commentHandle,l.set(s,h));const p=s.author&&s.author.iconPath?s.author.iconPath.toString():void 0;return{mode:s.mode,contextValue:s.contextValue,uniqueIdInThread:h,body:I.MarkdownString.from(s.body),userName:s.author.name,userIconPath:p,label:s.label,commentReactions:s.reactions?s.reactions.map(k=>y(k)):void 0}}function y(r){return{label:r.label,iconPath:r.iconPath?I.pathOrURIToURI(r.iconPath):void 0,count:r.count,hasReacted:r.authorHasReacted}}function i(r){return{label:r.label||"",count:r.count||0,iconPath:r.iconPath?F.URI.revive(r.iconPath):"",authorHasReacted:r.hasReacted||!1}}function v(r){if(r!==void 0)switch(r){case t.CommentThreadCollapsibleState.Expanded:return C.CommentThreadCollapsibleState.Expanded;case t.CommentThreadCollapsibleState.Collapsed:return C.CommentThreadCollapsibleState.Collapsed}return C.CommentThreadCollapsibleState.Collapsed}return new T}e.createExtHostComments=n}),define(be[95],Ee([0,1,2,5,7,4,13,15,12,9,17]),function(re,e,d,M,b,R,F,C,_,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let E=class vi{constructor(c,u){this._logService=u,this._provider=new Map,this._proxy=c.getProxy(M.MainContext.MainThreadDecorations)}registerFileDecorationProvider(c,u){const a=vi._handlePool++;this._provider.set(a,{provider:c,extensionId:u}),this._proxy.$registerDecorationProvider(a,u.value);const w=c.onDidChangeFileDecorations&&c.onDidChangeFileDecorations(T=>{if(!T){this._proxy.$onDidChange(a,null);return}let S=(0,_.asArray)(T);if(S.length<=vi._maxEventSize){this._proxy.$onDidChange(a,S);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",u.value,S.length);const o=S.map(i=>({uri:i,rank:(0,I.count)(i.path,"/")})),f=(0,_.groupBy)(o,(i,v)=>i.rank-v.rank||(0,I.compare)(i.uri.path,v.uri.path));let y=[];e:for(let i of f){let v;for(let r of i){let s=(0,t.dirname)(r.uri.path);if(v!==s&&(v=s,y.push(r.uri)>=vi._maxEventSize))break e}}this._proxy.$onDidChange(a,y)});return new b.Disposable(()=>{w?.dispose(),this._proxy.$unregisterDecorationProvider(a),this._provider.delete(a)})}async $provideDecorations(c,u,a){if(!this._provider.has(c))return Object.create(null);const w=Object.create(null),{provider:T,extensionId:S}=this._provider.get(c);return await Promise.all(u.map(async o=>{try{const{uri:f,id:y}=o,i=await Promise.resolve(T.provideFileDecoration(d.URI.revive(f),a));if(!i)return;try{b.FileDecoration.validate(i),w[y]=[i.propagate,i.tooltip,i.badge,i.color]}catch(v){this._logService.warn(`INVALID decoration from extension '${S.value}': ${v}`)}}catch(f){this._logService.error(f)}})),w}};E._handlePool=0,E._maxEventSize=250,E=We([ze(0,F.IExtHostRpcService),ze(1,C.ILogService)],E),e.ExtHostDecorations=E,e.IExtHostDecorations=(0,R.createDecorator)("IExtHostDecorations")});var Ze=this&&this.__classPrivateFieldSet||function(re,e,d,M,b){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!b:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?b.call(re,d):b?b.value=d:e.set(re,d),d},Ae=this&&this.__classPrivateFieldGet||function(re,e,d,M){if(d==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?M:d==="a"?M.call(re):M?M.value:e.get(re)};define(be[185],Ee([0,1,124,82,2,5,7,8,3,15,20,37,104]),function(re,e,d,M,b,R,F,C,_,I,t,E,n){"use strict";var c,u,a;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class w{constructor(o,f,y,i,v,r){this._name=o,this._owner=f,this._maxDiagnosticsPerFile=y,c.set(this,void 0),u.set(this,void 0),a.set(this,void 0),this._isDisposed=!1,Ze(this,a,new n.SkipList((s,l)=>i.compare(s,l)),"f"),Ze(this,c,v,"f"),Ze(this,u,r,"f")}dispose(){this._isDisposed||(Ae(this,u,"f").fire([...Ae(this,a,"f").keys()]),Ae(this,c,"f")&&Ae(this,c,"f").$clear(this._owner),Ae(this,a,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(o,f){if(!o){this.clear();return}this._checkDisposed();let y=[];if(b.URI.isUri(o)){if(!f){this.delete(o);return}Ae(this,a,"f").set(o,f.slice()),y=[o]}else if(Array.isArray(o)){y=[];let v;o=[...o].sort(w._compareIndexedTuplesByUri);for(const r of o){const[s,l]=r;if((!v||s.toString()!==v.toString())&&(v&&Ae(this,a,"f").get(v).length===0&&Ae(this,a,"f").delete(v),v=s,y.push(s),Ae(this,a,"f").set(s,[])),l){const h=Ae(this,a,"f").get(s);h&&h.push(...l)}else{const h=Ae(this,a,"f").get(s);h&&(h.length=0)}}}if(Ae(this,u,"f").fire(y),!Ae(this,c,"f"))return;const i=[];for(let v of y){let r=[];const s=Ae(this,a,"f").get(v);if(s)if(s.length>this._maxDiagnosticsPerFile){r=[];const l=[F.DiagnosticSeverity.Error,F.DiagnosticSeverity.Warning,F.DiagnosticSeverity.Information,F.DiagnosticSeverity.Hint];e:for(let h=0;h<4;h++)for(let p of s)if(p.severity===l[h]&&r.push(C.Diagnostic.from(p))===this._maxDiagnosticsPerFile)break e;r.push({severity:M.MarkerSeverity.Info,message:(0,d.localize)(0,null,s.length-this._maxDiagnosticsPerFile),startLineNumber:r[r.length-1].startLineNumber,startColumn:r[r.length-1].startColumn,endLineNumber:r[r.length-1].endLineNumber,endColumn:r[r.length-1].endColumn})}else r=s.map(l=>C.Diagnostic.from(l));i.push([v,r])}Ae(this,c,"f").$changeMany(this._owner,i)}delete(o){this._checkDisposed(),Ae(this,u,"f").fire([o]),Ae(this,a,"f").delete(o),Ae(this,c,"f")&&Ae(this,c,"f").$changeMany(this._owner,[[o,void 0]])}clear(){this._checkDisposed(),Ae(this,u,"f").fire([...Ae(this,a,"f").keys()]),Ae(this,a,"f").clear(),Ae(this,c,"f")&&Ae(this,c,"f").$clear(this._owner)}forEach(o,f){this._checkDisposed();for(let y of Ae(this,a,"f").keys())o.apply(f,[y,this.get(y),this])}get(o){this._checkDisposed();const f=Ae(this,a,"f").get(o);return Array.isArray(f)?Object.freeze(f.slice(0)):[]}has(o){return this._checkDisposed(),Array.isArray(Ae(this,a,"f").get(o))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(o,f){return o[0].toString()<f[0].toString()?-1:o[0].toString()>f[0].toString()?1:0}}e.DiagnosticCollection=w,c=new WeakMap,u=new WeakMap,a=new WeakMap;let T=class Zt{constructor(o,f,y){this._logService=f,this._fileSystemInfoService=y,this._collections=new Map,this._onDidChangeDiagnostics=new _.DebounceEmitter({merge:i=>i.flat(),delay:50}),this.onDidChangeDiagnostics=_.Event.map(this._onDidChangeDiagnostics.event,Zt._mapper),this._proxy=o.getProxy(R.MainContext.MainThreadDiagnostics)}static _mapper(o){const f=new t.ResourceMap;for(const y of o)f.set(y,y);return{uris:Object.freeze(Array.from(f.values()))}}createDiagnosticCollection(o,f){const{_collections:y,_proxy:i,_onDidChangeDiagnostics:v,_logService:r,_fileSystemInfoService:s}=this,l=new class{$changeMany(k,P){i.$changeMany(k,P),r.trace("[DiagnosticCollection] change many (extension, owner, uris)",o.value,k,P.length===0?"CLEARING":P)}$clear(k){i.$clear(k),r.trace("[DiagnosticCollection] remove all (extension, owner)",o.value,k)}dispose(){i.dispose()}};let h;if(!f)f="_generated_diagnostic_collection_name_#"+Zt._idPool++,h=f;else if(!y.has(f))h=f;else{this._logService.warn(`DiagnosticCollection with name '${f}' does already exist.`);do h=f+Zt._idPool++;while(y.has(h))}return new class extends w{constructor(){super(f,h,Zt._maxDiagnosticsPerFile,s.extUri,l,v);y.set(h,this)}dispose(){super.dispose(),y.delete(h)}}}getDiagnostics(o){if(o)return this._getDiagnostics(o);{const f=new Map,y=[];for(const i of this._collections.values())i.forEach((v,r)=>{let s=f.get(v.toString());typeof s=="undefined"&&(s=y.length,f.set(v.toString(),s),y.push([v,[]])),y[s][1]=y[s][1].concat(...r)});return y}}_getDiagnostics(o){let f=[];for(let y of this._collections.values())y.has(o)&&(f=f.concat(y.get(o)));return f}$acceptMarkersChange(o){if(!this._mirrorCollection){const f="_generated_mirror",y=new w(f,f,Zt._maxDiagnosticsPerFile,this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(f,y),this._mirrorCollection=y}for(const[f,y]of o)this._mirrorCollection.set(b.URI.revive(f),y.map(C.Diagnostic.to))}};T._idPool=0,T._maxDiagnosticsPerFile=1e3,T=We([ze(1,I.ILogService),ze(2,E.IExtHostFileSystemInfo)],T),e.ExtHostDiagnostics=T}),define(be[186],Ee([0,1,2,5]),function(re,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class b{constructor(F){this._proxy=F.getProxy(M.MainContext.MainThreadDialogs)}showOpenDialog(F){return this._proxy.$showOpenDialog(F).then(C=>C?C.map(_=>d.URI.revive(_)):void 0)}showSaveDialog(F){return this._proxy.$showSaveDialog(F).then(C=>C?d.URI.revive(C):void 0)}}e.ExtHostDialogs=b}),define(be[187],Ee([0,1,16,2,7,5,11,21,9]),function(re,e,d,M,b,R,F,C,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class I{constructor(E,n,c){this._documentsAndEditors=n,this._logService=c,this._documentContentProviders=new Map,this._proxy=E.getProxy(R.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(E,n){if(Object.keys(F.Schemas).indexOf(E)>=0)throw new Error(`scheme '${E}' already registered`);const c=I._handlePool++;this._documentContentProviders.set(c,n),this._proxy.$registerTextContentProvider(c,E);let u;return typeof n.onDidChange=="function"&&(u=n.onDidChange(a=>{if(a.scheme!==E){this._logService.warn(`Provider for scheme '${E}' is firing event for schema '${a.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(a)&&this.$provideTextDocumentContent(c,a).then(w=>{if(!w&&typeof w!="string")return;const T=this._documentsAndEditors.getDocument(a);if(!T)return;const S=(0,_.splitLines)(w);if(!T.equalLines(S))return this._proxy.$onVirtualDocumentChange(a,w)},d.onUnexpectedError)})),new b.Disposable(()=>{this._documentContentProviders.delete(c)&&this._proxy.$unregisterTextContentProvider(c),u&&(u.dispose(),u=void 0)})}$provideTextDocumentContent(E,n){const c=this._documentContentProviders.get(E);return c?Promise.resolve(c.provideTextDocumentContent(M.URI.revive(n),C.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${n.scheme}`))}}e.ExtHostDocumentContentProvider=I,I._handlePool=0}),define(be[188],Ee([0,1,3,6,2,5,88,8,10,23,7]),function(re,e,d,M,b,R,F,C,_,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class E{constructor(c,u){this._onDidAddDocument=new d.Emitter,this._onDidRemoveDocument=new d.Emitter,this._onDidChangeDocument=new d.Emitter,this._onDidSaveDocument=new d.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new M.DisposableStore,this._documentLoader=new Map,this._proxy=c.getProxy(R.MainContext.MainThreadDocuments),this._documentsAndEditors=u,this._documentsAndEditors.onDidRemoveDocuments(a=>{for(const w of a)this._onDidRemoveDocument.fire(w.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(a=>{for(const w of a)this._onDidAddDocument.fire(w.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(c){if(!c)return;const u=this._documentsAndEditors.getDocument(c);if(u)return u}getDocument(c){const u=this.getDocumentData(c);if(!u?.document)throw new Error(`Unable to retrieve document from URI '${c}'`);return u.document}ensureDocumentData(c){const u=this._documentsAndEditors.getDocument(c);if(u)return Promise.resolve(u);let a=this._documentLoader.get(c.toString());return a||(a=this._proxy.$tryOpenDocument(c).then(w=>{this._documentLoader.delete(c.toString());const T=b.URI.revive(w);return(0,_.assertIsDefined)(this._documentsAndEditors.getDocument(T))},w=>(this._documentLoader.delete(c.toString()),Promise.reject(w))),this._documentLoader.set(c.toString(),a)),a}createDocumentData(c){return this._proxy.$tryCreateDocument(c).then(u=>b.URI.revive(u))}$acceptModelModeChanged(c,u){const a=b.URI.revive(c),w=this._documentsAndEditors.getDocument(a);if(!w)throw new Error("unknown document");this._onDidRemoveDocument.fire(w.document),w._acceptLanguageId(u),this._onDidAddDocument.fire(w.document)}$acceptModelSaved(c){const u=b.URI.revive(c),a=this._documentsAndEditors.getDocument(u);if(!a)throw new Error("unknown document");this.$acceptDirtyStateChanged(c,!1),this._onDidSaveDocument.fire(a.document)}$acceptDirtyStateChanged(c,u){const a=b.URI.revive(c),w=this._documentsAndEditors.getDocument(a);if(!w)throw new Error("unknown document");w._acceptIsDirty(u),this._onDidChangeDocument.fire({document:w.document,contentChanges:[],reason:void 0})}$acceptModelChanged(c,u,a){const w=b.URI.revive(c),T=this._documentsAndEditors.getDocument(w);if(!T)throw new Error("unknown document");T._acceptIsDirty(a),T.onEvents(u);let S;u.isUndoing?S=t.TextDocumentChangeReason.Undo:u.isRedoing&&(S=t.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,I.deepFreeze)({document:T.document,contentChanges:u.changes.map(o=>({range:C.Range.to(o.range),rangeOffset:o.rangeOffset,rangeLength:o.rangeLength,text:o.text})),reason:S}))}setWordDefinitionFor(c,u){(0,F.setWordDefinitionFor)(c,u)}}e.ExtHostDocuments=E}),define(be[49],Ee([0,1,42,3,6,2,4,5,88,13,94,8,15,20,11,231,103]),function(re,e,d,M,b,R,F,C,_,I,t,E,n,c,u,a,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class T{constructor(f){this.value=f,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let S=class{constructor(f,y){this._extHostRpc=f,this._logService=y,this._activeEditorId=null,this._editors=new Map,this._documents=new c.ResourceMap,this._onDidAddDocuments=new M.Emitter,this._onDidRemoveDocuments=new M.Emitter,this._onDidChangeVisibleTextEditors=new M.Emitter,this._onDidChangeActiveTextEditor=new M.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(f){this.acceptDocumentsAndEditorsDelta(f)}acceptDocumentsAndEditorsDelta(f){const y=[],i=[],v=[];if(f.removedDocuments)for(const r of f.removedDocuments){const s=R.URI.revive(r),l=this._documents.get(s);l?.unref()&&(this._documents.delete(s),y.push(l.value))}if(f.addedDocuments)for(const r of f.addedDocuments){const s=R.URI.revive(r.uri);let l=this._documents.get(s);if(l&&s.scheme!==u.Schemas.vscodeNotebookCell&&s.scheme!==u.Schemas.vscodeInteractiveInput)throw new Error(`document '${s} already exists!'`);l||(l=new T(new _.ExtHostDocumentData(this._extHostRpc.getProxy(C.MainContext.MainThreadDocuments),s,r.lines,r.EOL,r.versionId,r.modeId,r.isDirty,r.notebook)),this._documents.set(s,l),i.push(l.value)),l.ref()}if(f.removedEditors)for(const r of f.removedEditors){const s=this._editors.get(r);this._editors.delete(r),s&&v.push(s)}if(f.addedEditors)for(const r of f.addedEditors){const s=R.URI.revive(r.documentUri);d.ok(this._documents.has(s),`document '${s}' does not exist`),d.ok(!this._editors.has(r.id),`editor '${r.id}' already exists!`);const l=this._documents.get(s).value,h=new t.ExtHostTextEditor(r.id,this._extHostRpc.getProxy(C.MainContext.MainThreadTextEditors),this._logService,new w.Lazy(()=>l.document),r.selections.map(E.Selection.to),r.options,r.visibleRanges.map(p=>E.Range.to(p)),typeof r.editorPosition=="number"?E.ViewColumn.to(r.editorPosition):void 0);this._editors.set(r.id,h)}f.newActiveEditor!==void 0&&(d.ok(f.newActiveEditor===null||this._editors.has(f.newActiveEditor),`active editor '${f.newActiveEditor}' does not exist`),this._activeEditorId=f.newActiveEditor),(0,b.dispose)(y),(0,b.dispose)(v),f.removedDocuments&&this._onDidRemoveDocuments.fire(y),f.addedDocuments&&this._onDidAddDocuments.fire(i),(f.removedEditors||f.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(r=>r.value)),f.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(f){return this._documents.get(f)?.value}allDocuments(){return a.Iterable.map(this._documents.values(),f=>f.value)}getEditor(f){return this._editors.get(f)}activeEditor(f){if(!this._activeEditorId)return;const y=this._editors.get(this._activeEditorId);return f?y:y?.value}allEditors(){return[...this._editors.values()]}};S=We([ze(0,I.IExtHostRpcService),ze(1,n.ILogService)],S),e.ExtHostDocumentsAndEditors=S,e.IExtHostDocumentsAndEditors=(0,F.createDecorator)("IExtHostDocumentsAndEditors")}),define(be[189],Ee([0,1,2,5,6,7,8,232,9,22]),function(re,e,d,M,b,R,F,C,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class t{constructor(){this._schemes=[]}add(c){this._stateMachine=void 0,this._schemes.push(c)}delete(c){const u=this._schemes.indexOf(c);u>=0&&(this._schemes.splice(u,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const c=this._schemes.sort(),u=[];let a,w,T=14,S=14;for(const o of c){let f=a?(0,_.commonPrefixLength)(a,o):0;for(f===0?w=1:w=S;f<o.length;f++)f+1===o.length?(T=S,S=9):S+=1,u.push([w,o.toUpperCase().charCodeAt(f),S]),u.push([w,o.toLowerCase().charCodeAt(f),S]),w=S;a=o,S=T}u.push([9,58,10]),u.push([10,47,12]),this._stateMachine=new C.StateMachine(u)}}provideDocumentLinks(c){this._initStateMachine();const u=[],a=C.LinkComputer.computeLinks({getLineContent(w){return c.lineAt(w-1).text},getLineCount(){return c.lineCount}},this._stateMachine);for(const w of a){const T=F.DocumentLink.to(w);T.target&&u.push(T)}return u}}class E{constructor(c,u){this._extHostLanguageFeatures=u,this._linkProvider=new t,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=c.getProxy(M.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(c,u,a,w={}){if(this._registeredSchemes.has(u))throw new Error(`a provider for the scheme '${u}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const T=this._handlePool++;this._linkProvider.add(u),this._registeredSchemes.add(u),this._fsProvider.set(T,a);let S=2;w.isCaseSensitive&&(S+=1024),w.isReadonly&&(S+=2048),typeof a.copy=="function"&&(S+=8),typeof a.open=="function"&&typeof a.close=="function"&&typeof a.read=="function"&&typeof a.write=="function"&&(S+=4),this._proxy.$registerFileSystemProvider(T,u,S).catch(f=>{console.error(`FAILED to register filesystem provider of ${c.value}-extension for the scheme ${u}`),console.error(f)});const o=a.onDidChangeFile(f=>{const y=[];for(const i of f){let{uri:v,type:r}=i;if(v.scheme!==u)continue;let s;switch(r){case R.FileChangeType.Changed:s=0;break;case R.FileChangeType.Created:s=1;break;case R.FileChangeType.Deleted:s=2;break;default:throw new Error("Unknown FileChangeType")}y.push({resource:v,type:s})}this._proxy.$onFileSystemChange(T,y)});return(0,b.toDisposable)(()=>{o.dispose(),this._linkProvider.delete(u),this._registeredSchemes.delete(u),this._fsProvider.delete(T),this._proxy.$unregisterProvider(T)})}static _asIStat(c){const{type:u,ctime:a,mtime:w,size:T,permissions:S}=c;return{type:u,ctime:a,mtime:w,size:T,permissions:S}}$stat(c,u){return Promise.resolve(this._getFsProvider(c).stat(d.URI.revive(u))).then(a=>E._asIStat(a))}$readdir(c,u){return Promise.resolve(this._getFsProvider(c).readDirectory(d.URI.revive(u)))}$readFile(c,u){return Promise.resolve(this._getFsProvider(c).readFile(d.URI.revive(u))).then(a=>I.VSBuffer.wrap(a))}$writeFile(c,u,a,w){return Promise.resolve(this._getFsProvider(c).writeFile(d.URI.revive(u),a.buffer,w))}$delete(c,u,a){return Promise.resolve(this._getFsProvider(c).delete(d.URI.revive(u),a))}$rename(c,u,a,w){return Promise.resolve(this._getFsProvider(c).rename(d.URI.revive(u),d.URI.revive(a),w))}$copy(c,u,a,w){const T=this._getFsProvider(c);if(!T.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(T.copy(d.URI.revive(u),d.URI.revive(a),w))}$mkdir(c,u){return Promise.resolve(this._getFsProvider(c).createDirectory(d.URI.revive(u)))}$watch(c,u,a,w){const T=this._getFsProvider(c).watch(d.URI.revive(a),w);this._watches.set(u,T)}$unwatch(c,u){const a=this._watches.get(u);a&&(a.dispose(),this._watches.delete(u))}$open(c,u,a){const w=this._getFsProvider(c);if(!w.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(w.open(d.URI.revive(u),a))}$close(c,u){const a=this._getFsProvider(c);if(!a.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(a.close(u))}$read(c,u,a,w){const T=this._getFsProvider(c);if(!T.read)throw new Error('FileSystemProvider does not implement "read"');const S=I.VSBuffer.alloc(w);return Promise.resolve(T.read(u,a,S.buffer,0,w)).then(o=>S.slice(0,o))}$write(c,u,a,w){const T=this._getFsProvider(c);if(!T.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(T.write(u,a,w.buffer,0,w.byteLength))}_getFsProvider(c){const u=this._fsProvider.get(c);if(!u){const a=new Error;throw a.name="ENOPRO",a.message="no provider",a}return u}}e.ExtHostFileSystem=E}),define(be[71],Ee([0,1,5,60,7,22,4,13,37]),function(re,e,d,M,b,R,F,C,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let I=class Bt{constructor(E,n){const c=E.getProxy(d.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(u){return c.$stat(u).catch(Bt._handleError)},readDirectory(u){return c.$readdir(u).catch(Bt._handleError)},createDirectory(u){return c.$mkdir(u).catch(Bt._handleError)},async readFile(u){return c.$readFile(u).then(a=>a.buffer).catch(Bt._handleError)},writeFile(u,a){return c.$writeFile(u,R.VSBuffer.wrap(a)).catch(Bt._handleError)},delete(u,a){return c.$delete(u,{recursive:!1,useTrash:!1,...a}).catch(Bt._handleError)},rename(u,a,w){return c.$rename(u,a,{overwrite:!1,...w}).catch(Bt._handleError)},copy(u,a,w){return c.$copy(u,a,{overwrite:!1,...w}).catch(Bt._handleError)},isWritableFileSystem(u){const a=n.getCapabilities(u);if(typeof a=="number")return!(a&2048)}})}static _handleError(E){if(!(E instanceof Error))throw new b.FileSystemError(String(E));if(E.name==="ENOPRO")throw b.FileSystemError.Unavailable(E.message);switch(E.name){case M.FileSystemProviderErrorCode.FileExists:throw b.FileSystemError.FileExists(E.message);case M.FileSystemProviderErrorCode.FileNotFound:throw b.FileSystemError.FileNotFound(E.message);case M.FileSystemProviderErrorCode.FileNotADirectory:throw b.FileSystemError.FileNotADirectory(E.message);case M.FileSystemProviderErrorCode.FileIsADirectory:throw b.FileSystemError.FileIsADirectory(E.message);case M.FileSystemProviderErrorCode.NoPermissions:throw b.FileSystemError.NoPermissions(E.message);case M.FileSystemProviderErrorCode.Unavailable:throw b.FileSystemError.Unavailable(E.message);default:throw new b.FileSystemError(E.message,E.name)}}};I=We([ze(0,C.IExtHostRpcService),ze(1,_.IExtHostFileSystemInfo)],I),e.ExtHostConsumerFileSystem=I,e.IExtHostConsumerFileSystem=(0,F.createDecorator)("IExtHostConsumerFileSystem")}),define(be[190],Ee([0,1,2,39]),function(re,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class b{constructor(F,C,_,I){this._extHostNotebooks=C,this._textDocumentsAndEditors=_,this._commands=I;const t=new M.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new M.ApiCommandArgument("showOptions","Show Options",E=>!0,E=>E),new M.ApiCommandArgument("resource","Interactive resource Uri",E=>!0,E=>E),new M.ApiCommandArgument("controllerId","Notebook controller Id",E=>!0,E=>E),new M.ApiCommandArgument("title","Interactive editor title",E=>!0,E=>E)],new M.ApiCommandResult("Notebook and input URI",E=>{if(E.notebookEditorId!==void 0){const n=this._extHostNotebooks.getEditorById(E.notebookEditorId);return{notebookUri:d.URI.revive(E.notebookUri),inputUri:d.URI.revive(E.inputUri),notebookEditor:n.apiEditor}}return{notebookUri:d.URI.revive(E.notebookUri),inputUri:d.URI.revive(E.inputUri)}}));this._commands.registerApiCommand(t)}$willAddInteractiveDocument(F,C,_,I){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:C,lines:[""],modeId:_,uri:F,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(d.URI.revive(I))?.apiNotebook}]})}$willRemoveInteractiveDocument(F,C){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[F]})}}e.ExtHostInteractive=b}),define(be[191],Ee([0,1,6,5]),function(re,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class b{constructor(F){this._handlePool=0,this._proxy=F.getProxy(M.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(F){const C=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(C,F),(0,d.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(C)})}}e.ExtHostLabelService=b}),define(be[192],Ee([0,1,2,23,8,7,5,9,44,12,10,233,6,80,53,63,193,16,3]),function(re,e,d,M,b,R,F,C,_,I,t,E,n,c,u,a,w,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class o{constructor(x,Q){this._documents=x,this._provider=Q}async provideDocumentSymbols(x,Q){const te=this._documents.getDocument(x),ae=await this._provider.provideDocumentSymbols(te,Q);if(!(0,I.isFalsyOrEmpty)(ae))return ae[0]instanceof R.DocumentSymbol?ae.map(b.DocumentSymbol.from):o._asDocumentSymbolTree(ae)}static _asDocumentSymbolTree(x){x=x.slice(0).sort((ae,q)=>{let oe=ae.location.range.start.compareTo(q.location.range.start);return oe===0&&(oe=q.location.range.end.compareTo(ae.location.range.end)),oe});const Q=[],te=[];for(const ae of x){const q={name:ae.name||"!!MISSING: name!!",kind:b.SymbolKind.from(ae.kind),tags:ae.tags?.map(b.SymbolTag.from)||[],detail:"",containerName:ae.containerName,range:b.Range.from(ae.location.range),selectionRange:b.Range.from(ae.location.range),children:[]};for(;;){if(te.length===0){te.push(q),Q.push(q);break}const oe=te[te.length-1];if(_.Range.containsRange(oe.range,q.range)&&!_.Range.equalsRange(oe.range,q.range)){oe.children&&oe.children.push(q),te.push(q);break}te.pop()}}return Q}}class f{constructor(x,Q,te){this._documents=x,this._commands=Q,this._provider=te,this._cache=new a.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(x,Q){const te=this._documents.getDocument(x),ae=await this._provider.provideCodeLenses(te,Q);if(!ae||Q.isCancellationRequested)return;const q=this._cache.add(ae),oe=new n.DisposableStore;this._disposables.set(q,oe);const he={cacheId:q,lenses:[]};for(let Te=0;Te<ae.length;Te++)he.lenses.push({cacheId:[q,Te],range:b.Range.from(ae[Te].range),command:this._commands.toInternal(ae[Te].command,oe)});return he}async resolveCodeLens(x,Q){const te=x.cacheId&&this._cache.get(...x.cacheId);if(!te)return;let ae;if(typeof this._provider.resolveCodeLens!="function"||te.isResolved?ae=te:ae=await this._provider.resolveCodeLens(te,Q),ae||(ae=te),Q.isCancellationRequested)return;const q=x.cacheId&&this._disposables.get(x.cacheId[0]);if(!!q)return x.command=this._commands.toInternal(ae.command??f._badCmd,q),x}releaseCodeLenses(x){this._disposables.get(x)?.dispose(),this._disposables.delete(x),this._cache.delete(x)}}f._badCmd={command:"missing",title:"!!MISSING: command!!"};function y(qe){return Array.isArray(qe)?qe.map(b.DefinitionLink.from):qe?[b.DefinitionLink.from(qe)]:[]}class i{constructor(x,Q){this._documents=x,this._provider=Q}async provideDefinition(x,Q,te){const ae=this._documents.getDocument(x),q=b.Position.to(Q),oe=await this._provider.provideDefinition(ae,q,te);return y(oe)}}class v{constructor(x,Q){this._documents=x,this._provider=Q}async provideDeclaration(x,Q,te){const ae=this._documents.getDocument(x),q=b.Position.to(Q),oe=await this._provider.provideDeclaration(ae,q,te);return y(oe)}}class r{constructor(x,Q){this._documents=x,this._provider=Q}async provideImplementation(x,Q,te){const ae=this._documents.getDocument(x),q=b.Position.to(Q),oe=await this._provider.provideImplementation(ae,q,te);return y(oe)}}class s{constructor(x,Q){this._documents=x,this._provider=Q}async provideTypeDefinition(x,Q,te){const ae=this._documents.getDocument(x),q=b.Position.to(Q),oe=await this._provider.provideTypeDefinition(ae,q,te);return y(oe)}}class l{constructor(x,Q){this._documents=x,this._provider=Q}async provideHover(x,Q,te){const ae=this._documents.getDocument(x),q=b.Position.to(Q),oe=await this._provider.provideHover(ae,q,te);if(!(!oe||(0,I.isFalsyOrEmpty)(oe.contents)))return oe.range||(oe.range=ae.getWordRangeAtPosition(q)),oe.range||(oe.range=new R.Range(q,q)),b.Hover.from(oe)}}class h{constructor(x,Q){this._documents=x,this._provider=Q}async provideEvaluatableExpression(x,Q,te){const ae=this._documents.getDocument(x),q=b.Position.to(Q),oe=await this._provider.provideEvaluatableExpression(ae,q,te);if(oe)return b.EvaluatableExpression.from(oe)}}class p{constructor(x,Q){this._documents=x,this._provider=Q}async provideInlineValues(x,Q,te,ae){const q=this._documents.getDocument(x),oe=await this._provider.provideInlineValues(q,b.Range.to(Q),b.InlineValueContext.to(te),ae);if(Array.isArray(oe))return oe.map(he=>b.InlineValue.from(he))}}class k{constructor(x,Q){this._documents=x,this._provider=Q}async provideDocumentHighlights(x,Q,te){const ae=this._documents.getDocument(x),q=b.Position.to(Q),oe=await this._provider.provideDocumentHighlights(ae,q,te);if(Array.isArray(oe))return oe.map(b.DocumentHighlight.from)}}class P{constructor(x,Q){this._documents=x,this._provider=Q}async provideLinkedEditingRanges(x,Q,te){const ae=this._documents.getDocument(x),q=b.Position.to(Q),oe=await this._provider.provideLinkedEditingRanges(ae,q,te);if(oe&&Array.isArray(oe.ranges))return{ranges:(0,I.coalesce)(oe.ranges.map(b.Range.from)),wordPattern:oe.wordPattern}}}class g{constructor(x,Q){this._documents=x,this._provider=Q}async provideReferences(x,Q,te,ae){const q=this._documents.getDocument(x),oe=b.Position.to(Q),he=await this._provider.provideReferences(q,oe,te,ae);if(Array.isArray(he))return he.map(b.location.from)}}class D{constructor(x,Q,te,ae,q,oe,he){this._documents=x,this._commands=Q,this._diagnostics=te,this._provider=ae,this._logService=q,this._extension=oe,this._apiDeprecation=he,this._cache=new a.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(x,Q,te,ae){const q=this._documents.getDocument(x),oe=E.Selection.isISelection(Q)?b.Selection.to(Q):b.Range.to(Q),he=[];for(const nt of this._diagnostics.getDiagnostics(x))if(oe.intersection(nt.range)&&he.push(nt)>D._maxCodeActionsPerFile)break;const Te={diagnostics:he,only:te.only?new R.CodeActionKind(te.only):void 0,triggerKind:b.CodeActionTriggerKind.to(te.trigger)},Ue=await this._provider.provideCodeActions(q,oe,Te,ae);if(!(0,I.isNonEmptyArray)(Ue)||ae.isCancellationRequested)return;const He=this._cache.add(Ue),Ke=new n.DisposableStore;this._disposables.set(He,Ke);const ye=[];for(let nt=0;nt<Ue.length;nt++){const H=Ue[nt];!H||(D._isCommand(H)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),ye.push({_isSynthetic:!0,title:H.title,command:this._commands.toInternal(H,Ke)})):(Te.only&&(H.kind?Te.only.contains(H.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Te.only.value} 'requested but returned code action is of kind '${H.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Te.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),ye.push({cacheId:[He,nt],title:H.title,command:H.command&&this._commands.toInternal(H.command,Ke),diagnostics:H.diagnostics&&H.diagnostics.map(b.Diagnostic.from),edit:H.edit&&b.WorkspaceEdit.from(H.edit),kind:H.kind&&H.kind.value,isPreferred:H.isPreferred,disabled:H.disabled?.reason})))}return{cacheId:He,actions:ye}}async resolveCodeAction(x,Q){const[te,ae]=x,q=this._cache.get(te,ae);if(!q||D._isCommand(q)||!this._provider.resolveCodeAction)return;const oe=await this._provider.resolveCodeAction(q,Q)??q;return oe?.edit?b.WorkspaceEdit.from(oe.edit):void 0}releaseCodeActions(x){this._disposables.get(x)?.dispose(),this._disposables.delete(x),this._cache.delete(x)}static _isCommand(x){return typeof x.command=="string"&&typeof x.title=="string"}}D._maxCodeActionsPerFile=1e3;class m{constructor(x,Q){this._documents=x,this._provider=Q}async provideDocumentFormattingEdits(x,Q,te){const ae=this._documents.getDocument(x),q=await this._provider.provideDocumentFormattingEdits(ae,Q,te);if(Array.isArray(q))return q.map(b.TextEdit.from)}}class A{constructor(x,Q){this._documents=x,this._provider=Q}async provideDocumentRangeFormattingEdits(x,Q,te,ae){const q=this._documents.getDocument(x),oe=b.Range.to(Q),he=await this._provider.provideDocumentRangeFormattingEdits(q,oe,te,ae);if(Array.isArray(he))return he.map(b.TextEdit.from)}}class L{constructor(x,Q){this._documents=x,this._provider=Q,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(x,Q,te,ae,q){const oe=this._documents.getDocument(x),he=b.Position.to(Q),Te=await this._provider.provideOnTypeFormattingEdits(oe,he,te,ae,q);if(Array.isArray(Te))return Te.map(b.TextEdit.from)}}class V{constructor(x,Q){this._provider=x,this._logService=Q,this._symbolCache=new Map,this._resultCache=new Map}async provideWorkspaceSymbols(x,Q){const te=F.IdObject.mixin({symbols:[]}),ae=await this._provider.provideWorkspaceSymbols(x,Q);if((0,I.isNonEmptyArray)(ae))for(const q of ae){if(!q)continue;if(!q.name){this._logService.warn("INVALID SymbolInformation, lacks name",q);continue}const oe=F.IdObject.mixin(b.WorkspaceSymbol.from(q));this._symbolCache.set(oe._id,q),te.symbols.push(oe)}return te.symbols.length>0&&this._resultCache.set(te._id,[te.symbols[0]._id,te.symbols[te.symbols.length-1]._id]),te}async resolveWorkspaceSymbol(x,Q){if(typeof this._provider.resolveWorkspaceSymbol!="function")return x;const te=this._symbolCache.get(x._id);if(te){const ae=await this._provider.resolveWorkspaceSymbol(te,Q);return ae&&(0,M.mixin)(x,b.WorkspaceSymbol.from(ae),!0)}}releaseWorkspaceSymbols(x){const Q=this._resultCache.get(x);if(Q){for(let[te,ae]=Q;te<=ae;te++)this._symbolCache.delete(te);this._resultCache.delete(x)}}}class G{constructor(x,Q,te){this._documents=x,this._provider=Q,this._logService=te}static supportsResolving(x){return typeof x.prepareRename=="function"}async provideRenameEdits(x,Q,te,ae){const q=this._documents.getDocument(x),oe=b.Position.to(Q);try{const he=await this._provider.provideRenameEdits(q,oe,te,ae);return he?b.WorkspaceEdit.from(he):void 0}catch(he){const Te=G._asMessage(he);return Te?{rejectReason:Te,edits:void 0}:Promise.reject(he)}}async resolveRenameLocation(x,Q,te){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const ae=this._documents.getDocument(x),q=b.Position.to(Q);try{const oe=await this._provider.prepareRename(ae,q,te);let he,Te;if(R.Range.isRange(oe)?(he=oe,Te=ae.getText(oe)):(0,t.isObject)(oe)&&(he=oe.range,Te=oe.placeholder),!he||!Te)return;if(he.start.line>q.line||he.end.line<q.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:b.Range.from(he),text:Te}}catch(oe){const he=G._asMessage(oe);return he?{rejectReason:he,range:void 0,text:void 0}:Promise.reject(oe)}}static _asMessage(x){return typeof x=="string"?x:x instanceof Error&&typeof x.message=="string"?x.message:void 0}}class U{constructor(x,Q){this.resultId=x,this.tokens=Q}}class K{constructor(x,Q){this._documents=x,this._provider=Q,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(x,Q,te){const ae=this._documents.getDocument(x),q=Q!==0?this._previousResults.get(Q):null;let oe=typeof q?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(ae,q.resultId,te):await this._provider.provideDocumentSemanticTokens(ae,te);return q&&this._previousResults.delete(Q),oe?(oe=K._fixProvidedSemanticTokens(oe),this._send(K._convertToEdits(q,oe),oe)):null}async releaseDocumentSemanticColoring(x){this._previousResults.delete(x)}static _fixProvidedSemanticTokens(x){return K._isSemanticTokens(x)?K._isCorrectSemanticTokens(x)?x:new R.SemanticTokens(new Uint32Array(x.data),x.resultId):K._isSemanticTokensEdits(x)?K._isCorrectSemanticTokensEdits(x)?x:new R.SemanticTokensEdits(x.edits.map(Q=>new R.SemanticTokensEdit(Q.start,Q.deleteCount,Q.data?new Uint32Array(Q.data):Q.data)),x.resultId):x}static _isSemanticTokens(x){return x&&!!x.data}static _isCorrectSemanticTokens(x){return x.data instanceof Uint32Array}static _isSemanticTokensEdits(x){return x&&Array.isArray(x.edits)}static _isCorrectSemanticTokensEdits(x){for(const Q of x.edits)if(!(Q.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(x,Q){if(!K._isSemanticTokens(Q)||!x||!x.tokens)return Q;const te=x.tokens,ae=te.length,q=Q.data,oe=q.length;let he=0;const Te=Math.min(ae,oe);for(;he<Te&&te[he]===q[he];)he++;if(he===ae&&he===oe)return new R.SemanticTokensEdits([],Q.resultId);let Ue=0;const He=Te-he;for(;Ue<He&&te[ae-Ue-1]===q[oe-Ue-1];)Ue++;return new R.SemanticTokensEdits([{start:he,deleteCount:ae-he-Ue,data:q.subarray(he,oe-Ue)}],Q.resultId)}_send(x,Q){if(K._isSemanticTokens(x)){const te=this._nextResultId++;return this._previousResults.set(te,new U(x.resultId,x.data)),(0,c.encodeSemanticTokensDto)({id:te,type:"full",data:x.data})}if(K._isSemanticTokensEdits(x)){const te=this._nextResultId++;return K._isSemanticTokens(Q)?this._previousResults.set(te,new U(Q.resultId,Q.data)):this._previousResults.set(te,new U(x.resultId)),(0,c.encodeSemanticTokensDto)({id:te,type:"delta",deltas:(x.edits||[]).map(ae=>({start:ae.start,deleteCount:ae.deleteCount,data:ae.data}))})}return null}}e.DocumentSemanticTokensAdapter=K;class ${constructor(x,Q){this._documents=x,this._provider=Q}async provideDocumentRangeSemanticTokens(x,Q,te){const ae=this._documents.getDocument(x),q=await this._provider.provideDocumentRangeSemanticTokens(ae,b.Range.to(Q),te);return q?this._send(q):null}_send(x){return(0,c.encodeSemanticTokensDto)({id:0,type:"full",data:x.data})}}e.DocumentRangeSemanticTokensAdapter=$;class B{constructor(x,Q,te,ae,q){this._documents=x,this._commands=Q,this._provider=te,this._apiDeprecation=ae,this._extension=q,this._cache=new a.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(x){return typeof x.resolveCompletionItem=="function"}async provideCompletionItems(x,Q,te,ae){const q=this._documents.getDocument(x),oe=b.Position.to(Q),he=q.getWordRangeAtPosition(oe)||new R.Range(oe,oe),Te=he.with({end:oe}),Ue=new w.StopWatch(!0),He=await this._provider.provideCompletionItems(q,oe,ae,b.CompletionContext.to(te));if(!He||ae.isCancellationRequested)return;const Ke=Array.isArray(He)?new R.CompletionList(He):He,ye=B.supportsResolving(this._provider)?this._cache.add(Ke.items):this._cache.add([]),nt=new n.DisposableStore;this._disposables.set(ye,nt);const H=[],X={x:ye,b:H,a:{replace:b.Range.from(he),insert:b.Range.from(Te)},c:Ke.isIncomplete||void 0,d:Ue.elapsed()};for(let fe=0;fe<Ke.items.length;fe++){const xe=Ke.items[fe],Qe=this._convertCompletionItem(xe,[ye,fe],Te,he);H.push(Qe)}return X}async resolveCompletionItem(x,Q){if(typeof this._provider.resolveCompletionItem!="function")return;const te=this._cache.get(...x);if(!te)return;const ae=await this._provider.resolveCompletionItem(te,Q);if(!!ae)return this._convertCompletionItem(ae,x)}releaseCompletionItems(x){this._disposables.get(x)?.dispose(),this._disposables.delete(x),this._cache.delete(x)}_convertCompletionItem(x,Q,te,ae){const q=this._disposables.get(Q[0]);if(!q)throw Error("DisposableStore is missing...");const oe={x:Q,a:x.label,b:x.kind!==void 0?b.CompletionItemKind.from(x.kind):void 0,n:x.tags&&x.tags.map(b.CompletionItemTag.from),c:x.detail,d:typeof x.documentation=="undefined"?void 0:b.MarkdownString.fromStrict(x.documentation),e:x.sortText!==x.label?x.sortText:void 0,f:x.filterText!==x.label?x.filterText:void 0,g:x.preselect||void 0,i:x.keepWhitespace?1:0,k:x.commitCharacters,l:x.additionalTextEdits&&x.additionalTextEdits.map(b.TextEdit.from),m:this._commands.toInternal(x.command,q)};x.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),oe.h=x.textEdit.newText):typeof x.insertText=="string"?oe.h=x.insertText:x.insertText instanceof R.SnippetString&&(oe.h=x.insertText.value,oe.i|=4);let he;return x.textEdit?he=x.textEdit.range:x.range&&(he=x.range),R.Range.isRange(he)?oe.j=b.Range.from(he):he&&(!te?.isEqual(he.inserting)||!ae?.isEqual(he.replacing))&&(oe.j={insert:b.Range.from(he.inserting),replace:b.Range.from(he.replacing)}),oe}}class z{constructor(x,Q,te){this._documents=x,this._provider=Q,this._commands=te,this._cache=new a.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions(x,Q,te,ae){const q=this._documents.getDocument(x),oe=b.Position.to(Q),he=await this._provider.provideInlineCompletionItems(q,oe,{selectedCompletionInfo:te.selectedSuggestionInfo?{range:b.Range.to(te.selectedSuggestionInfo.range),text:te.selectedSuggestionInfo.text}:void 0,triggerKind:te.triggerKind},ae);if(!he||ae.isCancellationRequested)return;const Te=(0,t.isArray)(he)?{items:he}:he,Ue=this._cache.add(Te.items);let He;return{pid:Ue,items:Te.items.map((Ke,ye)=>{let nt;return Ke.command&&(He||(He=new n.DisposableStore,this._disposables.set(Ue,He)),nt=this._commands.toInternal(Ke.command,He)),{text:Ke.text,range:Ke.range?b.Range.from(Ke.range):void 0,command:nt,idx:ye}})}}disposeCompletions(x){this._cache.delete(x);const Q=this._disposables.get(x);Q&&Q.clear(),this._disposables.delete(x)}handleDidShowCompletionItem(x,Q){const te=this._cache.get(x,Q);te&&Y.get(this._provider).fireOnDidShowCompletionItem({completionItem:te})}}class Y{constructor(){this._onDidShowCompletionItemEmitter=new S.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get(x){let Q=Y.map.get(x);return Q||(Q=new Y,Y.map.set(x,Q)),Q}fireOnDidShowCompletionItem(x){this._onDidShowCompletionItemEmitter.fire(x)}}e.InlineCompletionController=Y,Y.map=new WeakMap;class ne{constructor(x,Q){this._documents=x,this._provider=Q,this._cache=new a.Cache("SignatureHelp")}async provideSignatureHelp(x,Q,te,ae){const q=this._documents.getDocument(x),oe=b.Position.to(Q),he=this.reviveContext(te),Te=await this._provider.provideSignatureHelp(q,oe,ae,he);if(Te){const Ue=this._cache.add([Te]);return{...b.SignatureHelp.from(Te),id:Ue}}}reviveContext(x){let Q;if(x.activeSignatureHelp){const te=b.SignatureHelp.to(x.activeSignatureHelp),ae=this._cache.get(x.activeSignatureHelp.id,0);ae?(Q=ae,Q.activeSignature=te.activeSignature,Q.activeParameter=te.activeParameter):Q=te}return{...x,activeSignatureHelp:Q}}releaseSignatureHelp(x){this._cache.delete(x)}}class j{constructor(x,Q){this._documents=x,this._provider=Q}async provideInlayHints(x,Q,te){const ae=this._documents.getDocument(x),q=await this._provider.provideInlayHints(ae,b.Range.to(Q),te);return q?{hints:q.map(b.InlayHint.from)}:void 0}}class le{constructor(x,Q){this._documents=x,this._provider=Q,this._cache=new a.Cache("DocumentLink")}async provideLinks(x,Q){const te=this._documents.getDocument(x),ae=await this._provider.provideDocumentLinks(te,Q);if(!(!Array.isArray(ae)||ae.length===0)&&!Q.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:ae.filter(le._validateLink).map(b.DocumentLink.from)};{const q=this._cache.add(ae),oe={links:[],id:q};for(let he=0;he<ae.length;he++){if(!le._validateLink(ae[he]))continue;const Te=b.DocumentLink.from(ae[he]);Te.cacheId=[q,he],oe.links.push(Te)}return oe}}}static _validateLink(x){return x.target&&x.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(x,Q){if(typeof this._provider.resolveDocumentLink!="function")return;const te=this._cache.get(...x);if(!te)return;const ae=await this._provider.resolveDocumentLink(te,Q);if(!(!ae||!le._validateLink(ae)))return b.DocumentLink.from(ae)}releaseLinks(x){this._cache.delete(x)}}class se{constructor(x,Q){this._documents=x,this._provider=Q}async provideColors(x,Q){const te=this._documents.getDocument(x),ae=await this._provider.provideDocumentColors(te,Q);return Array.isArray(ae)?ae.map(oe=>({color:b.Color.from(oe.color),range:b.Range.from(oe.range)})):[]}async provideColorPresentations(x,Q,te){const ae=this._documents.getDocument(x),q=b.Range.to(Q.range),oe=b.Color.to(Q.color),he=await this._provider.provideColorPresentations(oe,{document:ae,range:q},te);if(!!Array.isArray(he))return he.map(b.ColorPresentation.from)}}class ve{constructor(x,Q){this._documents=x,this._provider=Q}async provideFoldingRanges(x,Q,te){const ae=this._documents.getDocument(x),q=await this._provider.provideFoldingRanges(ae,Q,te);if(!!Array.isArray(q))return q.map(b.FoldingRange.from)}}class Fe{constructor(x,Q,te){this._documents=x,this._provider=Q,this._logService=te}async provideSelectionRanges(x,Q,te){const ae=this._documents.getDocument(x),q=Q.map(b.Position.to),oe=await this._provider.provideSelectionRanges(ae,q,te);if(!(0,I.isNonEmptyArray)(oe))return[];if(oe.length!==q.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const he=[];for(let Te=0;Te<q.length;Te++){const Ue=[];he.push(Ue);let He=q[Te],Ke=oe[Te];for(;;){if(!Ke.range.contains(He))throw new Error("INVALID selection range, must contain the previous range");if(Ue.push(b.SelectionRange.from(Ke)),!Ke.parent)break;He=Ke.range,Ke=Ke.parent}}return he}}class Me{constructor(x,Q){this._documents=x,this._provider=Q,this._idPool=new u.IdGenerator(""),this._cache=new Map}async prepareSession(x,Q,te){const ae=this._documents.getDocument(x),q=b.Position.to(Q),oe=await this._provider.prepareCallHierarchy(ae,q,te);if(!oe)return;const he=this._idPool.nextId();return this._cache.set(he,new Map),Array.isArray(oe)?oe.map(Te=>this._cacheAndConvertItem(he,Te)):[this._cacheAndConvertItem(he,oe)]}async provideCallsTo(x,Q,te){const ae=this._itemFromCache(x,Q);if(!ae)throw new Error("missing call hierarchy item");const q=await this._provider.provideCallHierarchyIncomingCalls(ae,te);if(!!q)return q.map(oe=>({from:this._cacheAndConvertItem(x,oe.from),fromRanges:oe.fromRanges.map(he=>b.Range.from(he))}))}async provideCallsFrom(x,Q,te){const ae=this._itemFromCache(x,Q);if(!ae)throw new Error("missing call hierarchy item");const q=await this._provider.provideCallHierarchyOutgoingCalls(ae,te);if(!!q)return q.map(oe=>({to:this._cacheAndConvertItem(x,oe.to),fromRanges:oe.fromRanges.map(he=>b.Range.from(he))}))}releaseSession(x){this._cache.delete(x)}_cacheAndConvertItem(x,Q){const te=this._cache.get(x),ae=b.CallHierarchyItem.from(Q,x,te.size.toString(36));return te.set(ae._itemId,Q),ae}_itemFromCache(x,Q){return this._cache.get(x)?.get(Q)}}class Ne{constructor(x,Q){this._documents=x,this._provider=Q,this._idPool=new u.IdGenerator(""),this._cache=new Map}async prepareSession(x,Q,te){const ae=this._documents.getDocument(x),q=b.Position.to(Q),oe=await this._provider.prepareTypeHierarchy(ae,q,te);if(!oe)return;const he=this._idPool.nextId();return this._cache.set(he,new Map),Array.isArray(oe)?oe.map(Te=>this._cacheAndConvertItem(he,Te)):[this._cacheAndConvertItem(he,oe)]}async provideSupertypes(x,Q,te){const ae=this._itemFromCache(x,Q);if(!ae)throw new Error("missing type hierarchy item");const q=await this._provider.provideTypeHierarchySupertypes(ae,te);if(!!q)return q.map(oe=>this._cacheAndConvertItem(x,oe))}async provideSubtypes(x,Q,te){const ae=this._itemFromCache(x,Q);if(!ae)throw new Error("missing type hierarchy item");const q=await this._provider.provideTypeHierarchySubtypes(ae,te);if(!!q)return q.map(oe=>this._cacheAndConvertItem(x,oe))}releaseSession(x){this._cache.delete(x)}_cacheAndConvertItem(x,Q){const te=this._cache.get(x),ae=b.TypeHierarchyItem.from(Q,x,te.size.toString(36));return te.set(ae._itemId,Q),ae}_itemFromCache(x,Q){return this._cache.get(x)?.get(Q)}}class Ye{constructor(x,Q){this.adapter=x,this.extension=Q}}class Ve{constructor(x,Q,te,ae,q,oe,he){this._adapter=new Map,this._uriTransformer=Q,this._proxy=x.getProxy(F.MainContext.MainThreadLanguageFeatures),this._documents=te,this._commands=ae,this._diagnostics=q,this._logService=oe,this._apiDeprecation=he}_transformDocumentSelector(x){return b.DocumentSelector.from(x,this._uriTransformer)}_createDisposable(x){return new R.Disposable(()=>{this._adapter.delete(x),this._proxy.$unregister(x)})}_nextHandle(){return Ve._handlePool++}_withAdapter(x,Q,te,ae,q=!1){const oe=this._adapter.get(x);if(!oe)return Promise.resolve(ae);if(oe.adapter instanceof Q){let he;oe.extension&&(he=Date.now(),this._logService.trace(`[${oe.extension.identifier.value}] INVOKE provider '${Q.name}'`));const Te=te(oe.adapter,oe.extension),Ue=oe.extension;return Ue&&Promise.resolve(Te).then(()=>this._logService.trace(`[${Ue.identifier.value}] provider DONE after ${Date.now()-he}ms`),He=>{q&&He instanceof T.CancellationError||(this._logService.error(`[${Ue.identifier.value}] provider FAILED`),this._logService.error(He))}),Te}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(x,Q){const te=this._nextHandle();return this._adapter.set(te,new Ye(x,Q)),te}static _extLabel(x){return x.displayName||x.name}registerDocumentSymbolProvider(x,Q,te,ae){const q=this._addNewAdapter(new o(this._documents,te),x),oe=ae&&ae.label||Ve._extLabel(x);return this._proxy.$registerDocumentSymbolProvider(q,this._transformDocumentSelector(Q),oe),this._createDisposable(q)}$provideDocumentSymbols(x,Q,te){return this._withAdapter(x,o,ae=>ae.provideDocumentSymbols(d.URI.revive(Q),te),void 0)}registerCodeLensProvider(x,Q,te){const ae=this._nextHandle(),q=typeof te.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(ae,new Ye(new f(this._documents,this._commands.converter,te),x)),this._proxy.$registerCodeLensSupport(ae,this._transformDocumentSelector(Q),q);let oe=this._createDisposable(ae);if(q!==void 0){const he=te.onDidChangeCodeLenses(Te=>this._proxy.$emitCodeLensEvent(q));oe=R.Disposable.from(oe,he)}return oe}$provideCodeLenses(x,Q,te){return this._withAdapter(x,f,ae=>ae.provideCodeLenses(d.URI.revive(Q),te),void 0)}$resolveCodeLens(x,Q,te){return this._withAdapter(x,f,ae=>ae.resolveCodeLens(Q,te),void 0)}$releaseCodeLenses(x,Q){this._withAdapter(x,f,te=>Promise.resolve(te.releaseCodeLenses(Q)),void 0)}registerDefinitionProvider(x,Q,te){const ae=this._addNewAdapter(new i(this._documents,te),x);return this._proxy.$registerDefinitionSupport(ae,this._transformDocumentSelector(Q)),this._createDisposable(ae)}$provideDefinition(x,Q,te,ae){return this._withAdapter(x,i,q=>q.provideDefinition(d.URI.revive(Q),te,ae),[])}registerDeclarationProvider(x,Q,te){const ae=this._addNewAdapter(new v(this._documents,te),x);return this._proxy.$registerDeclarationSupport(ae,this._transformDocumentSelector(Q)),this._createDisposable(ae)}$provideDeclaration(x,Q,te,ae){return this._withAdapter(x,v,q=>q.provideDeclaration(d.URI.revive(Q),te,ae),[])}registerImplementationProvider(x,Q,te){const ae=this._addNewAdapter(new r(this._documents,te),x);return this._proxy.$registerImplementationSupport(ae,this._transformDocumentSelector(Q)),this._createDisposable(ae)}$provideImplementation(x,Q,te,ae){return this._withAdapter(x,r,q=>q.provideImplementation(d.URI.revive(Q),te,ae),[])}registerTypeDefinitionProvider(x,Q,te){const ae=this._addNewAdapter(new s(this._documents,te),x);return this._proxy.$registerTypeDefinitionSupport(ae,this._transformDocumentSelector(Q)),this._createDisposable(ae)}$provideTypeDefinition(x,Q,te,ae){return this._withAdapter(x,s,q=>q.provideTypeDefinition(d.URI.revive(Q),te,ae),[])}registerHoverProvider(x,Q,te,ae){const q=this._addNewAdapter(new l(this._documents,te),x);return this._proxy.$registerHoverProvider(q,this._transformDocumentSelector(Q)),this._createDisposable(q)}$provideHover(x,Q,te,ae){return this._withAdapter(x,l,q=>q.provideHover(d.URI.revive(Q),te,ae),void 0)}registerEvaluatableExpressionProvider(x,Q,te,ae){const q=this._addNewAdapter(new h(this._documents,te),x);return this._proxy.$registerEvaluatableExpressionProvider(q,this._transformDocumentSelector(Q)),this._createDisposable(q)}$provideEvaluatableExpression(x,Q,te,ae){return this._withAdapter(x,h,q=>q.provideEvaluatableExpression(d.URI.revive(Q),te,ae),void 0)}registerInlineValuesProvider(x,Q,te,ae){const q=typeof te.onDidChangeInlineValues=="function"?this._nextHandle():void 0,oe=this._addNewAdapter(new p(this._documents,te),x);this._proxy.$registerInlineValuesProvider(oe,this._transformDocumentSelector(Q),q);let he=this._createDisposable(oe);if(q!==void 0){const Te=te.onDidChangeInlineValues(Ue=>this._proxy.$emitInlineValuesEvent(q));he=R.Disposable.from(he,Te)}return he}$provideInlineValues(x,Q,te,ae,q){return this._withAdapter(x,p,oe=>oe.provideInlineValues(d.URI.revive(Q),te,ae,q),void 0)}registerDocumentHighlightProvider(x,Q,te){const ae=this._addNewAdapter(new k(this._documents,te),x);return this._proxy.$registerDocumentHighlightProvider(ae,this._transformDocumentSelector(Q)),this._createDisposable(ae)}$provideDocumentHighlights(x,Q,te,ae){return this._withAdapter(x,k,q=>q.provideDocumentHighlights(d.URI.revive(Q),te,ae),void 0)}registerLinkedEditingRangeProvider(x,Q,te){const ae=this._addNewAdapter(new P(this._documents,te),x);return this._proxy.$registerLinkedEditingRangeProvider(ae,this._transformDocumentSelector(Q)),this._createDisposable(ae)}$provideLinkedEditingRanges(x,Q,te,ae){return this._withAdapter(x,P,async q=>{const oe=await q.provideLinkedEditingRanges(d.URI.revive(Q),te,ae);if(oe)return{ranges:oe.ranges,wordPattern:oe.wordPattern?Ve._serializeRegExp(oe.wordPattern):void 0}},void 0)}registerReferenceProvider(x,Q,te){const ae=this._addNewAdapter(new g(this._documents,te),x);return this._proxy.$registerReferenceSupport(ae,this._transformDocumentSelector(Q)),this._createDisposable(ae)}$provideReferences(x,Q,te,ae,q){return this._withAdapter(x,g,oe=>oe.provideReferences(d.URI.revive(Q),te,ae,q),void 0)}registerCodeActionProvider(x,Q,te,ae){const q=new n.DisposableStore,oe=this._addNewAdapter(new D(this._documents,this._commands.converter,this._diagnostics,te,this._logService,x,this._apiDeprecation),x);return this._proxy.$registerQuickFixSupport(oe,this._transformDocumentSelector(Q),{providedKinds:ae?.providedCodeActionKinds?.map(he=>he.value),documentation:ae?.documentation?.map(he=>({kind:he.kind.value,command:this._commands.converter.toInternal(he.command,q)}))},Ve._extLabel(x),Boolean(te.resolveCodeAction)),q.add(this._createDisposable(oe)),q}$provideCodeActions(x,Q,te,ae,q){return this._withAdapter(x,D,oe=>oe.provideCodeActions(d.URI.revive(Q),te,ae,q),void 0)}$resolveCodeAction(x,Q,te){return this._withAdapter(x,D,ae=>ae.resolveCodeAction(Q,te),void 0)}$releaseCodeActions(x,Q){this._withAdapter(x,D,te=>Promise.resolve(te.releaseCodeActions(Q)),void 0)}registerDocumentFormattingEditProvider(x,Q,te){const ae=this._addNewAdapter(new m(this._documents,te),x);return this._proxy.$registerDocumentFormattingSupport(ae,this._transformDocumentSelector(Q),x.identifier,x.displayName||x.name),this._createDisposable(ae)}$provideDocumentFormattingEdits(x,Q,te,ae){return this._withAdapter(x,m,q=>q.provideDocumentFormattingEdits(d.URI.revive(Q),te,ae),void 0)}registerDocumentRangeFormattingEditProvider(x,Q,te){const ae=this._addNewAdapter(new A(this._documents,te),x);return this._proxy.$registerRangeFormattingSupport(ae,this._transformDocumentSelector(Q),x.identifier,x.displayName||x.name),this._createDisposable(ae)}$provideDocumentRangeFormattingEdits(x,Q,te,ae,q){return this._withAdapter(x,A,oe=>oe.provideDocumentRangeFormattingEdits(d.URI.revive(Q),te,ae,q),void 0)}registerOnTypeFormattingEditProvider(x,Q,te,ae){const q=this._addNewAdapter(new L(this._documents,te),x);return this._proxy.$registerOnTypeFormattingSupport(q,this._transformDocumentSelector(Q),ae,x.identifier),this._createDisposable(q)}$provideOnTypeFormattingEdits(x,Q,te,ae,q,oe){return this._withAdapter(x,L,he=>he.provideOnTypeFormattingEdits(d.URI.revive(Q),te,ae,q,oe),void 0)}registerWorkspaceSymbolProvider(x,Q){const te=this._addNewAdapter(new V(Q,this._logService),x);return this._proxy.$registerNavigateTypeSupport(te),this._createDisposable(te)}$provideWorkspaceSymbols(x,Q,te){return this._withAdapter(x,V,ae=>ae.provideWorkspaceSymbols(Q,te),{symbols:[]})}$resolveWorkspaceSymbol(x,Q,te){return this._withAdapter(x,V,ae=>ae.resolveWorkspaceSymbol(Q,te),void 0)}$releaseWorkspaceSymbols(x,Q){this._withAdapter(x,V,te=>te.releaseWorkspaceSymbols(Q),void 0)}registerRenameProvider(x,Q,te){const ae=this._addNewAdapter(new G(this._documents,te,this._logService),x);return this._proxy.$registerRenameSupport(ae,this._transformDocumentSelector(Q),G.supportsResolving(te)),this._createDisposable(ae)}$provideRenameEdits(x,Q,te,ae,q){return this._withAdapter(x,G,oe=>oe.provideRenameEdits(d.URI.revive(Q),te,ae,q),void 0)}$resolveRenameLocation(x,Q,te,ae){return this._withAdapter(x,G,q=>q.resolveRenameLocation(d.URI.revive(Q),te,ae),void 0)}registerDocumentSemanticTokensProvider(x,Q,te,ae){const q=this._nextHandle(),oe=typeof te.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(q,new Ye(new K(this._documents,te),x)),this._proxy.$registerDocumentSemanticTokensProvider(q,this._transformDocumentSelector(Q),ae,oe);let he=this._createDisposable(q);if(oe){const Te=te.onDidChangeSemanticTokens(Ue=>this._proxy.$emitDocumentSemanticTokensEvent(oe));he=R.Disposable.from(he,Te)}return he}$provideDocumentSemanticTokens(x,Q,te,ae){return this._withAdapter(x,K,q=>q.provideDocumentSemanticTokens(d.URI.revive(Q),te,ae),null,!0)}$releaseDocumentSemanticTokens(x,Q){this._withAdapter(x,K,te=>te.releaseDocumentSemanticColoring(Q),void 0)}registerDocumentRangeSemanticTokensProvider(x,Q,te,ae){const q=this._addNewAdapter(new $(this._documents,te),x);return this._proxy.$registerDocumentRangeSemanticTokensProvider(q,this._transformDocumentSelector(Q),ae),this._createDisposable(q)}$provideDocumentRangeSemanticTokens(x,Q,te,ae){return this._withAdapter(x,$,q=>q.provideDocumentRangeSemanticTokens(d.URI.revive(Q),te,ae),null,!0)}registerCompletionItemProvider(x,Q,te,ae){const q=this._addNewAdapter(new B(this._documents,this._commands.converter,te,this._apiDeprecation,x),x);return this._proxy.$registerSuggestSupport(q,this._transformDocumentSelector(Q),ae,B.supportsResolving(te),`${x.identifier.value}(${ae.join("")})`),this._createDisposable(q)}$provideCompletionItems(x,Q,te,ae,q){return this._withAdapter(x,B,oe=>oe.provideCompletionItems(d.URI.revive(Q),te,ae,q),void 0)}$resolveCompletionItem(x,Q,te){return this._withAdapter(x,B,ae=>ae.resolveCompletionItem(Q,te),void 0)}$releaseCompletionItems(x,Q){this._withAdapter(x,B,te=>te.releaseCompletionItems(Q),void 0)}registerInlineCompletionsProvider(x,Q,te){const ae=this._addNewAdapter(new z(this._documents,te,this._commands.converter),x);return this._proxy.$registerInlineCompletionsSupport(ae,this._transformDocumentSelector(Q)),this._createDisposable(ae)}$provideInlineCompletions(x,Q,te,ae,q){return this._withAdapter(x,z,oe=>oe.provideInlineCompletions(d.URI.revive(Q),te,ae,q),void 0)}$handleInlineCompletionDidShow(x,Q,te){this._withAdapter(x,z,async ae=>{ae.handleDidShowCompletionItem(Q,te)},void 0)}$freeInlineCompletionsList(x,Q){this._withAdapter(x,z,async te=>{te.disposeCompletions(Q)},void 0)}registerSignatureHelpProvider(x,Q,te,ae){const q=Array.isArray(ae)?{triggerCharacters:ae,retriggerCharacters:[]}:ae,oe=this._addNewAdapter(new ne(this._documents,te),x);return this._proxy.$registerSignatureHelpProvider(oe,this._transformDocumentSelector(Q),q),this._createDisposable(oe)}$provideSignatureHelp(x,Q,te,ae,q){return this._withAdapter(x,ne,oe=>oe.provideSignatureHelp(d.URI.revive(Q),te,ae,q),void 0)}$releaseSignatureHelp(x,Q){this._withAdapter(x,ne,te=>te.releaseSignatureHelp(Q),void 0)}registerInlayHintsProvider(x,Q,te){const ae=typeof te.onDidChangeInlayHints=="function"?this._nextHandle():void 0,q=this._addNewAdapter(new j(this._documents,te),x);this._proxy.$registerInlayHintsProvider(q,this._transformDocumentSelector(Q),ae);let oe=this._createDisposable(q);if(ae!==void 0){const he=te.onDidChangeInlayHints(Te=>this._proxy.$emitInlayHintsEvent(ae));oe=R.Disposable.from(oe,he)}return oe}$provideInlayHints(x,Q,te,ae){return this._withAdapter(x,j,q=>q.provideInlayHints(d.URI.revive(Q),te,ae),void 0)}registerDocumentLinkProvider(x,Q,te){const ae=this._addNewAdapter(new le(this._documents,te),x);return this._proxy.$registerDocumentLinkProvider(ae,this._transformDocumentSelector(Q),typeof te.resolveDocumentLink=="function"),this._createDisposable(ae)}$provideDocumentLinks(x,Q,te){return this._withAdapter(x,le,ae=>ae.provideLinks(d.URI.revive(Q),te),void 0)}$resolveDocumentLink(x,Q,te){return this._withAdapter(x,le,ae=>ae.resolveLink(Q,te),void 0)}$releaseDocumentLinks(x,Q){this._withAdapter(x,le,te=>te.releaseLinks(Q),void 0)}registerColorProvider(x,Q,te){const ae=this._addNewAdapter(new se(this._documents,te),x);return this._proxy.$registerDocumentColorProvider(ae,this._transformDocumentSelector(Q)),this._createDisposable(ae)}$provideDocumentColors(x,Q,te){return this._withAdapter(x,se,ae=>ae.provideColors(d.URI.revive(Q),te),[])}$provideColorPresentations(x,Q,te,ae){return this._withAdapter(x,se,q=>q.provideColorPresentations(d.URI.revive(Q),te,ae),void 0)}registerFoldingRangeProvider(x,Q,te){const ae=this._nextHandle(),q=typeof te.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(ae,new Ye(new ve(this._documents,te),x)),this._proxy.$registerFoldingRangeProvider(ae,this._transformDocumentSelector(Q),q);let oe=this._createDisposable(ae);if(q!==void 0){const he=te.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(q));oe=R.Disposable.from(oe,he)}return oe}$provideFoldingRanges(x,Q,te,ae){return this._withAdapter(x,ve,q=>q.provideFoldingRanges(d.URI.revive(Q),te,ae),void 0)}registerSelectionRangeProvider(x,Q,te){const ae=this._addNewAdapter(new Fe(this._documents,te,this._logService),x);return this._proxy.$registerSelectionRangeProvider(ae,this._transformDocumentSelector(Q)),this._createDisposable(ae)}$provideSelectionRanges(x,Q,te,ae){return this._withAdapter(x,Fe,q=>q.provideSelectionRanges(d.URI.revive(Q),te,ae),[])}registerCallHierarchyProvider(x,Q,te){const ae=this._addNewAdapter(new Me(this._documents,te),x);return this._proxy.$registerCallHierarchyProvider(ae,this._transformDocumentSelector(Q)),this._createDisposable(ae)}$prepareCallHierarchy(x,Q,te,ae){return this._withAdapter(x,Me,q=>Promise.resolve(q.prepareSession(d.URI.revive(Q),te,ae)),void 0)}$provideCallHierarchyIncomingCalls(x,Q,te,ae){return this._withAdapter(x,Me,q=>q.provideCallsTo(Q,te,ae),void 0)}$provideCallHierarchyOutgoingCalls(x,Q,te,ae){return this._withAdapter(x,Me,q=>q.provideCallsFrom(Q,te,ae),void 0)}$releaseCallHierarchy(x,Q){this._withAdapter(x,Me,te=>Promise.resolve(te.releaseSession(Q)),void 0)}registerTypeHierarchyProvider(x,Q,te){const ae=this._addNewAdapter(new Ne(this._documents,te),x);return this._proxy.$registerTypeHierarchyProvider(ae,this._transformDocumentSelector(Q)),this._createDisposable(ae)}$prepareTypeHierarchy(x,Q,te,ae){return this._withAdapter(x,Ne,q=>Promise.resolve(q.prepareSession(d.URI.revive(Q),te,ae)),void 0)}$provideTypeHierarchySupertypes(x,Q,te,ae){return this._withAdapter(x,Ne,q=>q.provideSupertypes(Q,te,ae),void 0)}$provideTypeHierarchySubtypes(x,Q,te,ae){return this._withAdapter(x,Ne,q=>q.provideSubtypes(Q,te,ae),void 0)}$releaseTypeHierarchy(x,Q){this._withAdapter(x,Ne,te=>Promise.resolve(te.releaseSession(Q)),void 0)}static _serializeRegExp(x){return{pattern:x.source,flags:(0,C.regExpFlags)(x)}}static _serializeIndentationRule(x){return{decreaseIndentPattern:Ve._serializeRegExp(x.decreaseIndentPattern),increaseIndentPattern:Ve._serializeRegExp(x.increaseIndentPattern),indentNextLinePattern:x.indentNextLinePattern?Ve._serializeRegExp(x.indentNextLinePattern):void 0,unIndentedLinePattern:x.unIndentedLinePattern?Ve._serializeRegExp(x.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(x){return{beforeText:Ve._serializeRegExp(x.beforeText),afterText:x.afterText?Ve._serializeRegExp(x.afterText):void 0,previousLineText:x.previousLineText?Ve._serializeRegExp(x.previousLineText):void 0,action:x.action}}static _serializeOnEnterRules(x){return x.map(Ve._serializeOnEnterRule)}setLanguageConfiguration(x,Q,te){let{wordPattern:ae}=te;if(ae&&(0,C.regExpLeadsToEndlessLoop)(ae))throw new Error(`Invalid language configuration: wordPattern '${ae}' is not allowed to match the empty string.`);ae?this._documents.setWordDefinitionFor(Q,ae):this._documents.setWordDefinitionFor(Q,void 0),te.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",x,"Do not use."),te.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",x,"Do not use.");const q=this._nextHandle(),oe={comments:te.comments,brackets:te.brackets,wordPattern:te.wordPattern?Ve._serializeRegExp(te.wordPattern):void 0,indentationRules:te.indentationRules?Ve._serializeIndentationRule(te.indentationRules):void 0,onEnterRules:te.onEnterRules?Ve._serializeOnEnterRules(te.onEnterRules):void 0,__electricCharacterSupport:te.__electricCharacterSupport,__characterPairSupport:te.__characterPairSupport};return this._proxy.$setLanguageConfiguration(q,Q,oe),this._createDisposable(q)}$setWordDefinitions(x){for(const Q of x)this._documents.setWordDefinitionFor(Q.languageId,new RegExp(Q.regexSource,Q.regexFlags))}}e.ExtHostLanguageFeatures=Ve,Ve._handlePool=0}),define(be[194],Ee([0,1,5,8,7,35,14,6]),function(re,e,d,M,b,R,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class _{constructor(t,E,n,c){this._documents=E,this._commands=n,this._uriTransformer=c,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=t.getProxy(d.MainContext.MainThreadLanguages)}$acceptLanguageIds(t){this._languageIds=t}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(t,E){await this._proxy.$changeLanguage(t,E);const n=this._documents.getDocumentData(t);if(!n)throw new Error(`document '${t.toString}' NOT found`);return n.document}async tokenAtPosition(t,E){const n=t.version,c=M.Position.from(E),u=await this._proxy.$tokensAtPosition(t.uri,c),a={type:b.StandardTokenType.Other,range:t.getWordRangeAtPosition(E)??new b.Range(E.line,E.character,E.line,E.character)};if(!u)return a;const w={range:M.Range.to(u.range),type:M.TokenType.to(u.type)};return!w.range.contains(E)||n!==t.version?a:w}createLanguageStatusItem(t,E,n){const c=this._handlePool++,u=this._proxy,a=this._ids,w=`${t.identifier.value}/${E}`;if(a.has(w))throw new Error(`LanguageStatusItem with id '${E}' ALREADY exists`);a.add(w);const T={selector:n,id:E,name:t.displayName??t.name,severity:b.LanguageStatusSeverity.Information,command:void 0,text:"",detail:""};let S,o=new C.DisposableStore;const f=()=>{S?.dispose(),S=(0,F.disposableTimeout)(()=>{o.clear(),this._proxy.$setLanguageStatus(c,{id:w,name:T.name??t.displayName??t.name,source:t.displayName??t.name,selector:M.DocumentSelector.from(T.selector,this._uriTransformer),label:T.text,detail:T.detail??"",severity:T.severity===b.LanguageStatusSeverity.Error?R.default.Error:T.severity===b.LanguageStatusSeverity.Warning?R.default.Warning:R.default.Info,command:T.command&&this._commands.toInternal(T.command,o),accessibilityInfo:T.accessibilityInformation})},0)},y={dispose(){o.dispose(),S?.dispose(),u.$removeLanguageStatus(c),a.delete(w)},get id(){return T.id},get name(){return T.name},set name(i){T.name=i,f()},get selector(){return T.selector},set selector(i){T.selector=i,f()},get text(){return T.text},set text(i){T.text=i,f()},get detail(){return T.detail},set detail(i){T.detail=i,f()},get severity(){return T.severity},set severity(i){T.severity=i,f()},get accessibilityInformation(){return T.accessibilityInformation},set accessibilityInformation(i){T.accessibilityInformation=i,f()},get command(){return T.command},set command(i){T.command=i,f()}};return f(),y}}e.ExtHostLanguages=_}),define(be[195],Ee([0,1,5,15,30]),function(re,e,d,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function R(C){return C&&C.title}let F=class{constructor(_,I){this._logService=I,this._proxy=_.getProxy(d.MainContext.MainThreadMessageService)}showMessage(_,I,t,E,n){const c={extension:_};let u;typeof E=="string"||R(E)?u=[E,...n]:(c.modal=E?.modal,c.useCustom=E?.useCustom,c.detail=E?.detail,u=n),c.useCustom&&(0,b.checkProposedApiEnabled)(_);const a=[];for(let w=0;w<u.length;w++){const T=u[w];if(typeof T=="string")a.push({title:T,handle:w,isCloseAffordance:!1});else if(typeof T=="object"){let{title:S,isCloseAffordance:o}=T;a.push({title:S,isCloseAffordance:!!o,handle:w})}else this._logService.warn("Invalid message item:",T)}return this._proxy.$showMessage(I,t,c,a).then(w=>{if(typeof w=="number")return u[w]})}};F=We([ze(1,M.ILogService)],F),e.ExtHostMessageService=F}),define(be[196],Ee([0,1,22,3,58,6,20,9,10,2,63,5,8,7,38,171,93]),function(re,e,d,M,b,R,F,C,_,I,t,E,n,c,u,a,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class T{constructor(o,f,y,i,v){this._textDocumentsAndEditors=y,this._textDocuments=i,this._extensionStoragePaths=v,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new F.ResourceMap,this._editors=new Map,this._onDidChangeNotebookCells=new M.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new M.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new M.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new M.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new M.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new M.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new M.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new M.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new t.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=o.getProxy(E.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=o.getProxy(E.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=o.getProxy(E.MainContext.MainThreadNotebookEditors),this._commandsConverter=f.converter,f.registerArgumentProcessor({processArgument:r=>{if(r&&r.$mid===12){const s=r.notebookEditor?.notebookUri,l=r.cell.handle,p=this._documents.get(s)?.getCell(l);if(p)return p.apiCell}return r}})}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(o=>o.apiEditor)}getEditorById(o){const f=this._editors.get(o);if(!f)throw new Error(`unknown text editor: ${o}. known editors: ${[...this._editors.keys()]} `);return f}getIdByEditor(o){for(const[f,y]of this._editors)if(y.apiEditor===o)return f}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(o,f){const y=this._documents.get(o);if(!y&&!f)throw new Error(`NO notebook document for '${o}'`);return y}_getProviderData(o){const f=this._notebookContentProviders.get(o);if(!f)throw new Error(`NO provider for '${o}'`);return f}registerNotebookContentProvider(o,f,y,i,v){if((0,C.isFalsyOrWhitespace)(f))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(f))throw new Error(`Notebook provider for '${f}' already registered`);this._notebookContentProviders.set(f,{extension:o,provider:y});let r;return y.onDidChangeNotebookContentOptions&&(r=y.onDidChangeNotebookContentOptions(()=>{const s=n.NotebookDocumentContentOptions.from(y.options);this._notebookProxy.$updateNotebookProviderOptions(f,s)})),this._notebookProxy.$registerNotebookProvider({id:o.identifier,location:o.extensionLocation},f,n.NotebookDocumentContentOptions.from(i),T._convertNotebookRegistrationData(o,v)),new c.Disposable(()=>{r?.dispose(),this._notebookContentProviders.delete(f),this._notebookProxy.$unregisterNotebookProvider(f)})}static _convertNotebookRegistrationData(o,f){if(!f)return;const y=f.filenamePattern.map(i=>n.NotebookExclusiveDocumentPattern.from(i)).filter(i=>i!==void 0);if(f.filenamePattern&&!y){console.warn(`Notebook content provider view options file name pattern is invalid ${f.filenamePattern}`);return}return{extension:o.identifier,providerDisplayName:o.displayName||o.name,displayName:f.displayName,filenamePattern:y,exclusive:f.exclusive||!1}}registerNotebookCellStatusBarItemProvider(o,f,y){const i=T._notebookStatusBarItemProviderHandlePool++,v=typeof y.onDidChangeCellStatusBarItems=="function"?T._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(i,y),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(i,v,f);let r;return v!==void 0&&(r=y.onDidChangeCellStatusBarItems(s=>this._notebookProxy.$emitCellStatusBarEvent(v))),new c.Disposable(()=>{this._notebookStatusBarItemProviders.delete(i),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(i,v),r&&r.dispose()})}async createNotebookDocument(o){const f=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:o.viewType,content:o.content&&n.NotebookData.from(o.content)});return I.URI.revive(f)}async openNotebookDocument(o){const f=this._documents.get(o);if(f)return f.apiNotebook;const y=await this._notebookDocumentsProxy.$tryOpenNotebook(o),i=this._documents.get(I.URI.revive(y));return(0,_.assertIsDefined)(i?.apiNotebook)}async showNotebookDocument(o,f){I.URI.isUri(o)&&(o=await this.openNotebookDocument(o));let y;typeof f=="object"?y={position:n.ViewColumn.from(f.viewColumn),preserveFocus:f.preserveFocus,selections:f.selections&&f.selections.map(n.NotebookRange.from),pinned:typeof f.preview=="boolean"?!f.preview:void 0}:y={preserveFocus:!1};const i=await this._notebookEditorsProxy.$tryShowNotebookDocument(o.uri,o.notebookType,y),v=i&&this._editors.get(i)?.apiEditor;if(v)return v;throw i?new Error(`Could NOT open editor for "${o.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${o.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(o,f,y,i){const v=this._notebookStatusBarItemProviders.get(o),r=I.URI.revive(f),s=this._documents.get(r);if(!s||!v)return;const l=s.getCellFromIndex(y);if(!l)return;const h=await v.provideCellStatusBarItems(l.apiCell,i);if(!h)return;const p=new R.DisposableStore,k=this._statusBarCache.add([p]),g=(Array.isArray(h)?h:[h]).map(D=>n.NotebookStatusBarItem.from(D,this._commandsConverter,p));return{cacheId:k,items:g}}$releaseNotebookCellStatusBarItems(o){this._statusBarCache.delete(o)}registerNotebookSerializer(o,f,y,i,v){if((0,C.isFalsyOrWhitespace)(f))throw new Error("viewType cannot be empty or just whitespace");const r=this._handlePool++;return this._notebookSerializer.set(r,y),this._notebookProxy.$registerNotebookSerializer(r,{id:o.identifier,location:o.extensionLocation},f,n.NotebookDocumentContentOptions.from(i),T._convertNotebookRegistrationData(o,v)),(0,R.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(r)})}async $dataToNotebook(o,f,y){const i=this._notebookSerializer.get(o);if(!i)throw new Error("NO serializer found");const v=await i.deserializeNotebook(f.buffer,y);return new u.SerializableObjectWithBuffers(n.NotebookData.from(v))}async $notebookToData(o,f,y){const i=this._notebookSerializer.get(o);if(!i)throw new Error("NO serializer found");const v=await i.serializeNotebook(n.NotebookData.to(f.value),y);return d.VSBuffer.wrap(v)}async $openNotebook(o,f,y,i,v){const{provider:r}=this._getProviderData(o),s=await r.openNotebook(I.URI.revive(f),{backupId:y,untitledDocumentData:i?.buffer},v);return new u.SerializableObjectWithBuffers({metadata:s.metadata??Object.create(null),cells:s.cells.map(n.NotebookCellData.from)})}async $saveNotebook(o,f,y){const i=this.getNotebookDocument(I.URI.revive(f)),{provider:v}=this._getProviderData(o);return await v.saveNotebook(i.apiNotebook,y),!0}async $saveNotebookAs(o,f,y,i){const v=this.getNotebookDocument(I.URI.revive(f)),{provider:r}=this._getProviderData(o);return await r.saveNotebookAs(I.URI.revive(y),v.apiNotebook,i),!0}async $backupNotebook(o,f,y){const i=this.getNotebookDocument(I.URI.revive(f)),v=this._getProviderData(o),r=this._extensionStoragePaths.workspaceValue(v.extension)??this._extensionStoragePaths.globalValue(v.extension),s=String((0,b.hash)([i.uri.toString(),this._backupIdPool++])),l=I.URI.joinPath(r,s),h=await v.provider.backupNotebook(i.apiNotebook,{destination:l},y);return i.updateBackup(h),h.id}_createExtHostEditor(o,f,y){if(this._editors.has(f))throw new Error(`editor with id ALREADY EXSIST: ${f}`);const i=new w.ExtHostNotebookEditor(f,this._notebookEditorsProxy,o,y.visibleRanges.map(n.NotebookRange.to),y.selections.map(n.NotebookRange.to),typeof y.viewColumn=="number"?n.ViewColumn.to(y.viewColumn):void 0);this._editors.set(f,i)}$acceptDocumentAndEditorsDelta(o){if(o.value.removedDocuments)for(const y of o.value.removedDocuments){const i=I.URI.revive(y),v=this._documents.get(i);v&&(v.dispose(),this._documents.delete(i),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:v.apiNotebook.getCells().map(r=>r.document.uri)}),this._onDidCloseNotebookDocument.fire(v.apiNotebook));for(const r of this._editors.values())r.notebookData.uri.toString()===i.toString()&&this._editors.delete(r.id)}if(o.value.addedDocuments){const y=[];for(const i of o.value.addedDocuments){const v=I.URI.revive(i.uri);if(this._documents.has(v))throw new Error(`adding EXISTING notebook ${v} `);const r=this,s=new a.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(l){r._onDidChangeNotebookCells.fire(l)},emitCellOutputsChange(l){r._onDidChangeCellOutputs.fire(l)},emitCellMetadataChange(l){r._onDidChangeCellMetadata.fire(l)},emitCellExecutionStateChange(l){r._onDidChangeCellExecutionState.fire(l)}},v,i);y.push(...i.cells.map(l=>a.ExtHostCell.asModelAddData(s.apiNotebook,l))),this._documents.get(v)?.dispose(),this._documents.set(v,s),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:y}),this._onDidOpenNotebookDocument.fire(s.apiNotebook)}}if(o.value.addedEditors)for(const y of o.value.addedEditors){if(this._editors.has(y.id))return;const i=I.URI.revive(y.documentUri),v=this._documents.get(i);v&&this._createExtHostEditor(v,y.id,y)}const f=[];if(o.value.removedEditors)for(const y of o.value.removedEditors){const i=this._editors.get(y);i&&(this._editors.delete(y),this._activeNotebookEditor?.id===i.id&&(this._activeNotebookEditor=void 0),f.push(i))}if(o.value.visibleEditors){this._visibleNotebookEditors=o.value.visibleEditors.map(i=>this._editors.get(i)).filter(i=>!!i);const y=new Set;this._visibleNotebookEditors.forEach(i=>y.add(i.id));for(const i of this._editors.values()){const v=y.has(i.id);i._acceptVisibility(v)}this._visibleNotebookEditors=[...this._editors.values()].map(i=>i).filter(i=>i.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}o.value.newActiveEditor===null?this._activeNotebookEditor=void 0:o.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(o.value.newActiveEditor)),o.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}}e.ExtHostNotebookController=T,T._notebookStatusBarItemProviderHandlePool=0}),define(be[197],Ee([0,1,3,53,15,5,13,8]),function(re,e,d,M,b,R,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class _{constructor(E,n){const c=_._Keys.nextId();E.$registerNotebookEditorDecorationType(c,C.NotebookDecorationRenderOptions.from(n)),this.value={key:c,dispose(){E.$removeNotebookEditorDecorationType(c)}}}}_._Keys=new M.IdGenerator("NotebookEditorDecorationType");let I=class{constructor(E,n,c){this._logService=E,this._extHostRpc=n,this._notebooksAndEditors=c,this._onDidChangeNotebookEditorSelection=new d.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new d.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(E){return new _(this._extHostRpc.getProxy(R.MainContext.MainThreadNotebookEditors),E).value}$acceptEditorPropertiesChanged(E,n){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",E,n);const c=this._notebooksAndEditors.getEditorById(E);n.visibleRanges&&c._acceptVisibleRanges(n.visibleRanges.ranges.map(C.NotebookRange.to)),n.selections&&c._acceptSelections(n.selections.selections.map(C.NotebookRange.to)),n.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:c.apiEditor,visibleRanges:c.apiEditor.visibleRanges}),n.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:c.apiEditor,selections:c.apiEditor.selections}))}$acceptEditorViewColumns(E){for(const n in E)this._notebooksAndEditors.getEditorById(n)._acceptViewColumn(C.ViewColumn.to(E[n]))}};I=We([ze(0,b.ILogService),ze(1,F.IExtHostRpcService)],I),e.ExtHostNotebookEditors=I}),define(be[198],Ee([0,1,12,14,21,3,6,20,2,25,15,5,39,8,7,66,164,30,38]),function(re,e,d,M,b,R,F,C,_,I,t,E,n,c,u,a,w,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let o=class{constructor(r,s,l,h,p){this._initData=s,this._extHostNotebook=l,this._commands=h,this._logService=p,this._activeExecutions=new C.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._proxy=r.getProxy(E.MainContext.MainThreadNotebookKernels);const k=new n.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new n.ApiCommandArgument("options","Select kernel options",P=>!0,P=>{if(P&&"notebookEditor"in P&&"id"in P){const g=this._extHostNotebook.getIdByEditor(P.notebookEditor);return{id:P.id,extension:P.extension,notebookEditorId:g}}else if(P&&"notebookEditor"in P){const g=this._extHostNotebook.getIdByEditor(P.notebookEditor);if(g===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${P.notebookEditor.document.uri.toString()}`);return{notebookEditorId:g}}return P})],n.ApiCommandResult.Void);this._commands.registerApiCommand(k)}createNotebookController(r,s,l,h,p,k){for(let ne of this._kernelData.values())if(ne.controller.id===s&&I.ExtensionIdentifier.equals(r.identifier,ne.extensionId))throw new Error(`notebook controller with id '${s}' ALREADY exist`);const P=this._handlePool++,g=this;this._logService.trace(`NotebookController[${P}], CREATED by ${r.identifier.value}, ${s}`);const D=()=>console.warn(`NO execute handler from notebook controller '${G.id}' of extension: '${r.identifier}'`);let m=!1;const A=new F.DisposableStore,L=new R.Emitter,V=new R.Emitter,G={id:`${r.identifier.value}/${s}`,notebookType:l,extensionId:r.identifier,extensionLocation:r.extensionLocation,label:h||r.identifier.value,preloads:k?k.map(c.NotebookRendererScript.from):[]};let U=p??D,K;this._proxy.$addKernel(P,G).catch(ne=>{console.log(ne),m=!0});let $=0;const B=()=>{if(m)return;const ne=++$;Promise.resolve().then(()=>{ne===$&&this._proxy.$updateKernel(P,G)})},z=new C.ResourceMap,Y={get id(){return s},get notebookType(){return G.notebookType},onDidChangeSelectedNotebooks:L.event,get label(){return G.label},set label(ne){G.label=ne??r.displayName??r.name,B()},get detail(){return G.detail??""},set detail(ne){G.detail=ne,B()},get description(){return G.description??""},set description(ne){G.description=ne,B()},get supportedLanguages(){return G.supportedLanguages},set supportedLanguages(ne){G.supportedLanguages=ne,B()},get supportsExecutionOrder(){return G.supportsExecutionOrder??!1},set supportsExecutionOrder(ne){G.supportsExecutionOrder=ne,B()},get rendererScripts(){return G.preloads?G.preloads.map(c.NotebookRendererScript.to):[]},get executeHandler(){return U},set executeHandler(ne){U=ne??D},get interruptHandler(){return K},set interruptHandler(ne){K=ne,G.supportsInterrupt=Boolean(ne),B()},createNotebookCellExecution(ne){if(m)throw new Error("notebook controller is DISPOSED");if(!z.has(ne.notebook.uri))throw g._logService.trace(`NotebookController[${P}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(z.keys()).map(j=>j.toString())),new Error(`notebook controller is NOT associated to notebook: ${ne.notebook.uri.toString()}`);return g._createNotebookCellExecution(ne)},dispose:()=>{m||(this._logService.trace(`NotebookController[${P}], DISPOSED`),m=!0,this._kernelData.delete(P),A.dispose(),L.dispose(),V.dispose(),this._proxy.$removeKernel(P))},updateNotebookAffinity(ne,j){g._proxy.$updateNotebookPriority(P,ne.uri,j)},onDidReceiveMessage:V.event,postMessage(ne,j){return(0,T.checkProposedApiEnabled)(r),g._proxy.$postMessage(P,j&&g._extHostNotebook.getIdByEditor(j),ne)},asWebviewUri(ne){return(0,T.checkProposedApiEnabled)(r),(0,a.asWebviewUri)(ne,g._initData.remote)}};return this._kernelData.set(P,{extensionId:r.identifier,controller:Y,onDidReceiveMessage:V,onDidChangeSelection:L,associatedNotebooks:z}),Y}$acceptNotebookAssociation(r,s,l){const h=this._kernelData.get(r);if(h){const p=this._extHostNotebook.getNotebookDocument(_.URI.revive(s));l?h.associatedNotebooks.set(p.uri,!0):h.associatedNotebooks.delete(p.uri),this._logService.trace(`NotebookController[${r}] ASSOCIATE notebook`,p.uri.toString(),l),h.onDidChangeSelection.fire({selected:l,notebook:p.apiNotebook})}}async $executeCells(r,s,l){const h=this._kernelData.get(r);if(!h)return;const p=this._extHostNotebook.getNotebookDocument(_.URI.revive(s)),k=[];for(let P of l){const g=p.getCell(P);g&&k.push(g.apiCell)}try{this._logService.trace(`NotebookController[${r}] EXECUTE cells`,p.uri.toString(),k.length),await h.controller.executeHandler.call(h.controller,k,p.apiNotebook,h.controller)}catch(P){this._logService.error(`NotebookController[${r}] execute cells FAILED`,P),console.error(P)}}async $cancelCells(r,s,l){const h=this._kernelData.get(r);if(!h)return;const p=this._extHostNotebook.getNotebookDocument(_.URI.revive(s));if(h.controller.interruptHandler)await h.controller.interruptHandler.call(h.controller,p.apiNotebook);else for(let k of l){const P=p.getCell(k);P&&this._activeExecutions.get(P.uri)?.cancel()}}$acceptKernelMessageFromRenderer(r,s,l){const h=this._kernelData.get(r);if(!h)return;const p=this._extHostNotebook.getEditorById(s);h.onDidReceiveMessage.fire(Object.freeze({editor:p.apiEditor,message:l}))}_createNotebookCellExecution(r){if(r.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const l=this._extHostNotebook.getNotebookDocument(r.notebook.uri).getCellFromApiCell(r);if(!l)throw new Error("invalid cell");if(this._activeExecutions.has(l.uri))throw new Error(`duplicate execution for ${l.uri}`);const h=new y(l.notebook,l,this._proxy);this._activeExecutions.set(l.uri,h);const p=h.onDidChangeState(()=>{h.state===f.Resolved&&(h.dispose(),p.dispose(),this._activeExecutions.delete(l.uri))});return h.asApiObject()}};o=We([ze(4,t.ILogService)],o),e.ExtHostNotebookKernels=o;var f;(function(v){v[v.Init=0]="Init",v[v.Started=1]="Started",v[v.Resolved=2]="Resolved"})(f||(f={}));class y extends F.Disposable{constructor(r,s,l){super();this._document=r,this._cell=s,this._proxy=l,this._handle=y.HANDLE++,this._onDidChangeState=new R.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=f.Init,this._tokenSource=this._register(new b.CancellationTokenSource),this._collector=new i(10,h=>this.update(h)),this._executionOrder=s.internalMetadata.executionOrder,this._proxy.$addExecution(this._handle,this._cell.notebook.uri,this._cell.handle)}get state(){return this._state}cancel(){this._tokenSource.cancel()}async updateSoon(r){await this._collector.addItem(r)}async update(r){const s=Array.isArray(r)?r:[r];return this._proxy.$updateExecutions(new S.SerializableObjectWithBuffers(s))}verifyStateForOutput(){if(this._state===f.Init)throw new Error("Must call start before modifying cell output");if(this._state===f.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(r){let s=this._cell;if(r&&(s=this._document.getCellFromApiCell(r)),!s)throw new Error("INVALID cell");return s.handle}validateAndConvertOutputs(r){return r.map(s=>{const l=u.NotebookCellOutput.ensureUniqueMimeTypes(s.items,!0);return l===s.items?c.NotebookCellOutput.from(s):c.NotebookCellOutput.from({items:l,id:s.id,metadata:s.metadata})})}async updateOutputs(r,s,l){const h=this.cellIndexToHandle(s),p=this.validateAndConvertOutputs((0,d.asArray)(r));return this.updateSoon({editType:w.CellExecutionUpdateType.Output,executionHandle:this._handle,cellHandle:h,append:l,outputs:p})}async updateOutputItems(r,s,l){return r=u.NotebookCellOutput.ensureUniqueMimeTypes((0,d.asArray)(r),!0),this.updateSoon({editType:w.CellExecutionUpdateType.OutputItems,executionHandle:this._handle,items:r.map(c.NotebookCellOutputItem.from),outputId:s.id,append:l})}asApiObject(){const r=this;return Object.freeze({get token(){return r._tokenSource.token},get cell(){return r._cell.apiCell},get executionOrder(){return r._executionOrder},set executionOrder(l){r._executionOrder=l,r.update([{editType:w.CellExecutionUpdateType.ExecutionState,executionHandle:r._handle,executionOrder:r._executionOrder}])},start(l){if(r._state===f.Resolved||r._state===f.Started)throw new Error("Cannot call start again");r._state=f.Started,r._onDidChangeState.fire(),r.update({editType:w.CellExecutionUpdateType.ExecutionState,executionHandle:r._handle,runStartTime:l})},end(l,h){if(r._state===f.Resolved)throw new Error("Cannot call resolve twice");r._state=f.Resolved,r._onDidChangeState.fire(),r.updateSoon({editType:w.CellExecutionUpdateType.Complete,executionHandle:r._handle,runEndTime:h,lastRunSuccess:l}),r._collector.flush(),r._proxy.$removeExecution(r._handle)},clearOutput(l){return r.verifyStateForOutput(),r.updateOutputs([],l,!1)},appendOutput(l,h){return r.verifyStateForOutput(),r.updateOutputs(l,h,!0)},replaceOutput(l,h){return r.verifyStateForOutput(),r.updateOutputs(l,h,!1)},appendOutputItems(l,h){return r.verifyStateForOutput(),r.updateOutputItems(l,h,!0)},replaceOutputItems(l,h){return r.verifyStateForOutput(),r.updateOutputItems(l,h,!1)}})}}y.HANDLE=0;class i{constructor(r,s){this.delay=r,this.callback=s,this.batch=[],this.startedTimer=Date.now()}addItem(r){return this.batch.push(r),this.currentDeferred||(this.currentDeferred=new M.DeferredPromise,this.startedTimer=Date.now(),(0,M.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const r=this.currentDeferred;this.currentDeferred=void 0;const s=this.batch;return this.batch=[],this.callback(s).finally(()=>r.complete())}}}),define(be[199],Ee([0,1,3,5,93]),function(re,e,d,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class R{constructor(C,_){this._extHostNotebook=_,this._rendererMessageEmitters=new Map,this.proxy=C.getProxy(M.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(C,_,I){const t=this._extHostNotebook.getEditorById(C);this._rendererMessageEmitters.get(_)?.fire({editor:t.apiEditor,message:I})}createRendererMessaging(C,_){if(!C.contributes?.notebookRenderer?.some(n=>n.id===_))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${_})`);const I=!!C.enableProposedApi,t=new WeakMap;return{onDidReceiveMessage:(n,c,u)=>{const a=I?n:w=>{const T={};t.set(T,w.editor),n({editor:T,message:w.message})};return this.getOrCreateEmitterFor(_).event(a,c,u)},postMessage:(n,c)=>{b.ExtHostNotebookEditor.apiEditorsToExtHost.has(n)&&([n,c]=[c,n]);const u=I?c:t.get(c),a=u&&b.ExtHostNotebookEditor.apiEditorsToExtHost.get(u);return this.proxy.$postMessage(a?.id,_,n)}}}getOrCreateEmitterFor(C){let _=this._rendererMessageEmitters.get(C);return _||(_=new d.Emitter({onLastListenerRemove:()=>{_?.dispose(),this._rendererMessageEmitters.delete(C)}}),this._rendererMessageEmitters.set(C,_),_)}}e.ExtHostNotebookRenderers=R}),define(be[96],Ee([0,1,5,3,6,22,4,13]),function(re,e,d,M,b,R,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.LazyOutputChannel=e.ExtHostPushOutputChannel=e.AbstractExtHostOutputChannel=void 0;class _ extends b.Disposable{constructor(u,a,w,T,S){super();this._onDidAppend=this._register(new M.Emitter),this.onDidAppend=this._onDidAppend.event,this._name=u,this._proxy=S,this._id=S.$register(this.name,a,w,T),this._disposed=!1,this._offset=0}get name(){return this._name}append(u){this.validate(),this._offset+=u?R.VSBuffer.fromString(u).byteLength:0}update(){this._id.then(u=>this._proxy.$update(u))}appendLine(u){this.validate(),this.append(u+`
`)}clear(){this.validate();const u=this._offset;this._id.then(a=>this._proxy.$clear(a,u))}show(u,a){this.validate(),this._id.then(w=>this._proxy.$reveal(w,!!(typeof u=="boolean"?u:a)))}hide(){this.validate(),this._id.then(u=>this._proxy.$close(u))}validate(){if(this._disposed)throw new Error("Channel has been closed")}dispose(){super.dispose(),this._disposed||this._id.then(u=>this._proxy.$dispose(u)).then(()=>this._disposed=!0)}}e.AbstractExtHostOutputChannel=_;class I extends _{constructor(u,a,w){super(u,!1,void 0,a,w)}append(u){super.append(u),this._id.then(a=>this._proxy.$append(a,u)),this._onDidAppend.fire()}}e.ExtHostPushOutputChannel=I;class t extends _{constructor(u,a,w){super(u,!0,a,void 0,w)}append(u){throw new Error("Not supported")}}class E{constructor(u,a){this.name=u,this._channel=a}append(u){this._channel.then(a=>a.append(u))}appendLine(u){this._channel.then(a=>a.appendLine(u))}clear(){this._channel.then(u=>u.clear())}show(u,a){this._channel.then(w=>w.show(u,a))}hide(){this._channel.then(u=>u.hide())}dispose(){this._channel.then(u=>u.dispose())}}e.LazyOutputChannel=E;let n=class{constructor(u){this._proxy=u.getProxy(d.MainContext.MainThreadOutputService)}$setVisibleChannel(u){}createOutputChannel(u,a){if(u=u.trim(),!u)throw new Error("illegal argument `name`. must not be falsy");return new I(u,a.identifier.value,this._proxy)}createOutputChannelFromLogFile(u,a){if(u=u.trim(),!u)throw new Error("illegal argument `name`. must not be falsy");if(!a)throw new Error("illegal argument `file`. must not be falsy");return new t(u,a,this._proxy)}};n=We([ze(0,C.IExtHostRpcService)],n),e.ExtHostOutputService=n,e.IExtHostOutputService=(0,F.createDecorator)("IExtHostOutputService")}),define(be[200],Ee([0,1,14,21,3,6,5,2,7,16,12,35,46]),function(re,e,d,M,b,R,F,C,_,I,t,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function c(u,a,w){const T=u.getProxy(F.MainContext.MainThreadQuickOpen);class S{constructor(h,p){this._sessions=new Map,this._instances=0,this._workspace=h,this._commands=p}showQuickPick(h,p,k,P=M.CancellationToken.None){this._onDidSelectItem=void 0;const g=Promise.resolve(h),D=++this._instances,m=T.$show(D,{title:k?.title,placeHolder:k?.placeHolder,matchOnDescription:k?.matchOnDescription,matchOnDetail:k?.matchOnDetail,ignoreFocusLost:k?.ignoreFocusOut,canPickMany:k?.canPickMany},P),A={},L=m.then(()=>A);return Promise.race([L,g]).then(V=>{if(V!==A)return g.then(G=>{const U=[];for(let K=0;K<G.length;K++){const $=G[K];let B,z,Y,ne,j;typeof $=="string"?B=$:(B=$.label,z=$.description,Y=$.detail,ne=$.picked,j=$.alwaysShow),U.push({label:B,description:z,handle:K,detail:Y,picked:ne,alwaysShow:j})}return k&&typeof k.onDidSelectItem=="function"&&(this._onDidSelectItem=K=>{k.onDidSelectItem(G[K])}),T.$setItems(D,U),m.then(K=>{if(typeof K=="number")return G[K];if(Array.isArray(K))return K.map($=>G[$])})})}).then(void 0,V=>{if(!(0,I.isPromiseCanceledError)(V))return T.$setError(D,V),Promise.reject(V)})}$onItemSelected(h){this._onDidSelectItem&&this._onDidSelectItem(h)}showInput(h,p=M.CancellationToken.None){return this._validateInput=h?h.validateInput:void 0,T.$input(h,typeof this._validateInput=="function",p).then(void 0,k=>{if(!(0,I.isPromiseCanceledError)(k))return Promise.reject(k)})}$validateInput(h){return this._validateInput?(0,d.asPromise)(()=>this._validateInput(h)):Promise.resolve(void 0)}async showWorkspaceFolderPick(h,p=M.CancellationToken.None){const k=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[h]);if(!k)return;const P=await this._workspace.getWorkspaceFolders2();if(!!P)return P.find(g=>g.uri.toString()===k.uri.toString())}createQuickPick(h,p){const k=new r(h,p,()=>this._sessions.delete(k._id));return this._sessions.set(k._id,k),k}createInputBox(h){const p=new s(h,()=>this._sessions.delete(p._id));return this._sessions.set(p._id,p),p}$onDidChangeValue(h,p){const k=this._sessions.get(h);k&&k._fireDidChangeValue(p)}$onDidAccept(h){const p=this._sessions.get(h);p&&p._fireDidAccept()}$onDidChangeActive(h,p){const k=this._sessions.get(h);k instanceof r&&k._fireDidChangeActive(p)}$onDidChangeSelection(h,p){const k=this._sessions.get(h);k instanceof r&&k._fireDidChangeSelection(p)}$onDidTriggerButton(h,p){const k=this._sessions.get(h);k&&k._fireDidTriggerButton(p)}$onDidTriggerItemButton(h,p,k){const P=this._sessions.get(h);P instanceof r&&P._fireDidTriggerItemButton(p,k)}$onDidHide(h){const p=this._sessions.get(h);p&&p._fireDidHide()}}class o{constructor(h,p){this._extensionId=h,this._onDidDispose=p,this._id=r._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new b.Emitter,this._onDidChangeValueEmitter=new b.Emitter,this._onDidTriggerButtonEmitter=new b.Emitter,this._onDidHideEmitter=new b.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(h){this._title=h,this.update({title:h})}get step(){return this._steps}set step(h){this._steps=h,this.update({step:h})}get totalSteps(){return this._totalSteps}set totalSteps(h){this._totalSteps=h,this.update({totalSteps:h})}get enabled(){return this._enabled}set enabled(h){this._enabled=h,this.update({enabled:h})}get busy(){return this._busy}set busy(h){this._busy=h,this.update({busy:h})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(h){this._ignoreFocusOut=h,this.update({ignoreFocusOut:h})}get value(){return this._value}set value(h){this._value=h,this.update({value:h})}get placeholder(){return this._placeholder}set placeholder(h){this._placeholder=h,this.update({placeholder:h})}get buttons(){return this._buttons}set buttons(h){this._buttons=h.slice(),this._handlesToButtons.clear(),h.forEach((p,k)=>{const P=p===_.QuickInputButtons.Back?-1:k;this._handlesToButtons.set(P,p)}),this.update({buttons:h.map((p,k)=>({...v(p),tooltip:p.tooltip,handle:p===_.QuickInputButtons.Back?-1:k}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(h){this._value=h,this._onDidChangeValueEmitter.fire(h)}_fireDidTriggerButton(h){const p=this._handlesToButtons.get(h);p&&this._onDidTriggerButtonEmitter.fire(p)}_fireDidHide(){this._expectingHide&&(this._expectingHide=!1,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,R.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),T.$dispose(this._id))}update(h){if(!this._disposed){for(const p of Object.keys(h)){const k=h[p];this._pendingUpdate[p]=k===void 0?null:k}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){T.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}o._nextId=1;function f(l){if(l instanceof _.ThemeIcon)return{id:l.id};const h=i(l),p=y(l);return{dark:typeof h=="string"?C.URI.file(h):h,light:typeof p=="string"?C.URI.file(p):p}}function y(l){return typeof l=="object"&&"light"in l?l.light:l}function i(l){return typeof l=="object"&&"dark"in l?l.dark:l}function v(l){const h=f(l.iconPath);let p,k;return"id"in h?k=n.ThemeIcon.asClassName(h):p=h,{iconPath:p,iconClass:k}}class r extends o{constructor(h,p,k){super(h,k);this.enableProposedApi=p,this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new b.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new b.Emitter,this._onDidTriggerItemButtonEmitter=new b.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(h){this._items=h.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),h.forEach((p,k)=>{this._handlesToItems.set(k,p),this._itemsToHandles.set(p,k)}),this.update({items:h.map((p,k)=>({label:p.label,description:p.description,handle:k,detail:p.detail,picked:p.picked,alwaysShow:p.alwaysShow,buttons:p.buttons&&this.enableProposedApi?p.buttons.map((P,g)=>({...v(P),tooltip:P.tooltip,handle:g})):void 0}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(h){this._canSelectMany=h,this.update({canSelectMany:h})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(h){this._matchOnDescription=h,this.update({matchOnDescription:h})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(h){this._matchOnDetail=h,this.update({matchOnDetail:h})}get sortByLabel(){return this._sortByLabel}set sortByLabel(h){this._sortByLabel=h,this.update({sortByLabel:h})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(h){this._keepScrollPosition=h,this.update({keepScrollPosition:h})}get activeItems(){return this._activeItems}set activeItems(h){this._activeItems=h.filter(p=>this._itemsToHandles.has(p)),this.update({activeItems:this._activeItems.map(p=>this._itemsToHandles.get(p))})}get selectedItems(){return this._selectedItems}set selectedItems(h){this._selectedItems=h.filter(p=>this._itemsToHandles.has(p)),this.update({selectedItems:this._selectedItems.map(p=>this._itemsToHandles.get(p))})}_fireDidChangeActive(h){const p=(0,t.coalesce)(h.map(k=>this._handlesToItems.get(k)));this._activeItems=p,this._onDidChangeActiveEmitter.fire(p)}_fireDidChangeSelection(h){const p=(0,t.coalesce)(h.map(k=>this._handlesToItems.get(k)));this._selectedItems=p,this._onDidChangeSelectionEmitter.fire(p)}_fireDidTriggerItemButton(h,p){const k=this._handlesToItems.get(h);if(!k||!k.buttons||!k.buttons.length)return;const P=k.buttons[p];P&&this._onDidTriggerItemButtonEmitter.fire({button:P,item:k})}}class s extends o{constructor(h,p){super(h,p);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(h){this._password=h,this.update({password:h})}get prompt(){return this._prompt}set prompt(h){this._prompt=h,this.update({prompt:h})}get validationMessage(){return this._validationMessage}set validationMessage(h){this._validationMessage=h,this.update({validationMessage:h,severity:h?E.default.Error:E.default.Ignore})}}return new S(a,w)}e.createExtHostQuickOpen=c}),define(be[201],Ee([0,1,2,3,52,6,14,5,12,108,15,25,30,46,8]),function(re,e,d,M,b,R,F,C,_,I,t,E,n,c,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function a(h){if(h)return typeof h.iconPath=="string"?d.URI.file(h.iconPath):d.URI.isUri(h.iconPath)||c.ThemeIcon.isThemeIcon(h.iconPath)?h.iconPath:void 0}function w(h,p){if(!h.iconPath&&!p.iconPath)return 0;if(h.iconPath){if(!p.iconPath)return 1}else return-1;const k=typeof h.iconPath=="string"?h.iconPath:d.URI.isUri(h.iconPath)?h.iconPath.fsPath:h.iconPath.id,P=typeof p.iconPath=="string"?p.iconPath:d.URI.isUri(p.iconPath)?p.iconPath.fsPath:p.iconPath.id;return(0,I.comparePaths)(k,P)}function T(h,p){let k=0;if(h.strikeThrough!==p.strikeThrough)return h.strikeThrough?1:-1;if(h.faded!==p.faded)return h.faded?1:-1;if(h.tooltip!==p.tooltip)return(h.tooltip||"").localeCompare(p.tooltip||"");if(k=w(h,p),k!==0)return k;if(h.light&&p.light)k=w(h.light,p.light);else{if(h.light)return 1;if(p.light)return-1}if(k!==0)return k;if(h.dark&&p.dark)k=w(h.dark,p.dark);else{if(h.dark)return 1;if(p.dark)return-1}return k}function S(h,p){if(h.command!==p.command)return h.command<p.command?-1:1;if(h.title!==p.title)return h.title<p.title?-1:1;if(h.tooltip!==p.tooltip){if(h.tooltip!==void 0&&p.tooltip!==void 0)return h.tooltip<p.tooltip?-1:1;if(h.tooltip!==void 0)return 1;if(p.tooltip!==void 0)return-1}if(h.arguments===p.arguments)return 0;if(h.arguments)if(p.arguments){if(h.arguments.length!==p.arguments.length)return h.arguments.length-p.arguments.length}else return 1;else return-1;for(let k=0;k<h.arguments.length;k++){const P=h.arguments[k],g=p.arguments[k];if(P!==g)return P<g?-1:1}return 0}function o(h,p){let k=(0,I.comparePaths)(h.resourceUri.fsPath,p.resourceUri.fsPath,!0);if(k!==0)return k;if(h.command&&p.command)k=S(h.command,p.command);else{if(h.command)return 1;if(p.command)return-1}if(k!==0)return k;if(h.decorations&&p.decorations)k=T(h.decorations,p.decorations);else{if(h.decorations)return 1;if(p.decorations)return-1}return k}function f(h,p){for(let k=0;k<h.length;k++)if(h[k]!==p[k])return!1;return!0}function y(h,p){return h.command===p.command&&h.title===p.title&&h.tooltip===p.tooltip&&(h.arguments&&p.arguments?f(h.arguments,p.arguments):h.arguments===p.arguments)}function i(h,p){return(0,_.equals)(h,p,y)}class v{constructor(p,k,P){this._extension=p,this._proxy=k,this._sourceControlHandle=P,this._value="",this._onDidChange=new M.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(p){this._proxy.$setInputBoxValue(this._sourceControlHandle,p),this.updateValue(p)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(p){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,p),this._placeholder=p}get validateInput(){return(0,n.checkProposedApiEnabled)(this._extension),this._validateInput}set validateInput(p){if((0,n.checkProposedApiEnabled)(this._extension),p&&typeof p!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=p,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!p)}get visible(){return this._visible}set visible(p){p=!!p,this._visible!==p&&(this._visible=p,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,p))}focus(){(0,n.checkProposedApiEnabled)(this._extension),this._visible||(this.visible=!0),this._proxy.$setInputBoxFocus(this._sourceControlHandle)}showValidationMessage(p,k){(0,n.checkProposedApiEnabled)(this._extension),this._proxy.$showValidationMessage(this._sourceControlHandle,p,k)}$onInputBoxValueChange(p){this.updateValue(p)}updateValue(p){this._value=p,this._onDidChange.fire(p)}}e.ExtHostSCMInputBox=v;class r{constructor(p,k,P,g,D){this._proxy=p,this._commands=k,this._sourceControlHandle=P,this._id=g,this._label=D,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new M.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new M.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=r._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(p){this._label=p,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,p)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(p){this._hideWhenEmpty=p,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(p){this._resourceStates=[...p],this._onDidUpdateResourceStates.fire()}getResourceState(p){return this._resourceStatesMap.get(p)}$executeResourceCommand(p,k){const P=this._resourceStatesCommandsMap.get(p);return P?(0,F.asPromise)(()=>this._commands.executeCommand(P.command,...P.arguments||[],k)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const p=[...this._resourceStates].sort(o),P=(0,_.sortedDiff)(this._resourceSnapshot,p,o).map(m=>{const A=m.toInsert.map(L=>{const V=this._resourceHandlePool++;this._resourceStatesMap.set(V,L);const G=L.resourceUri;let U;if(L.command)if(L.command.command==="vscode.open"||L.command.command==="vscode.diff"){const ve=new R.DisposableStore;U=this._commands.converter.toInternal(L.command,ve),this._resourceStatesDisposablesMap.set(V,ve)}else this._resourceStatesCommandsMap.set(V,L.command);const K=a(L.decorations),$=L.decorations&&a(L.decorations.light)||K,B=L.decorations&&a(L.decorations.dark)||K,z=[$,B],Y=L.decorations&&L.decorations.tooltip||"",ne=L.decorations&&!!L.decorations.strikeThrough,j=L.decorations&&!!L.decorations.faded,le=L.contextValue||"";return{rawResource:[V,G,z,Y,ne,j,le,U],handle:V}});return{start:m.start,deleteCount:m.deleteCount,toInsert:A}}),g=P.map(({start:m,deleteCount:A,toInsert:L})=>[m,A,L.map(V=>V.rawResource)]),D=P.reverse();for(const{start:m,deleteCount:A,toInsert:L}of D){const V=L.map(U=>U.handle),G=this._handlesSnapshot.splice(m,A,...V);for(const U of G)this._resourceStatesMap.delete(U),this._resourceStatesCommandsMap.delete(U),this._resourceStatesDisposablesMap.get(U)?.dispose(),this._resourceStatesDisposablesMap.delete(U)}return this._resourceSnapshot=p,g}dispose(){this._disposed=!0,this._onDidDispose.fire()}}r._handlePool=0;class s{constructor(p,k,P,g,D,m){this._proxy=k,this._commands=P,this._id=g,this._label=D,this._rootUri=m,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new R.MutableDisposable,this._acceptInputCommand=void 0,this._statusBarDisposables=new R.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new M.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=s._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new v(p,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,g,D,m)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(p){this._count!==p&&(this._count=p,this._proxy.$updateSourceControl(this.handle,{count:p}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(p){this._quickDiffProvider=p,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!p})}get commitTemplate(){return this._commitTemplate}set commitTemplate(p){p!==this._commitTemplate&&(this._commitTemplate=p,this._proxy.$updateSourceControl(this.handle,{commitTemplate:p}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(p){this._acceptInputDisposables.value=new R.DisposableStore,this._acceptInputCommand=p;const k=this._commands.converter.toInternal(p,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:k})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(p){if(this._statusBarCommands&&p&&i(this._statusBarCommands,p))return;this._statusBarDisposables.value=new R.DisposableStore,this._statusBarCommands=p;const k=(p||[]).map(P=>this._commands.converter.toInternal(P,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:k})}get selected(){return this._selected}createResourceGroup(p,k){const P=new r(this._proxy,this._commands,this.handle,p,k),g=M.Event.once(P.onDidDispose)(()=>this.createdResourceGroups.delete(P));return this.createdResourceGroups.set(P,g),this.eventuallyAddResourceGroups(),P}eventuallyAddResourceGroups(){const p=[],k=[];for(const[P,g]of this.createdResourceGroups){g.dispose();const D=P.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(P),this.eventuallyUpdateResourceStates()});M.Event.once(P.onDidDispose)(()=>{this.updatedResourceGroups.delete(P),D.dispose(),this._groups.delete(P.handle),this._proxy.$unregisterGroup(this.handle,P.handle)}),p.push([P.handle,P.id,P.label,P.features]);const m=P._takeResourceStateSnapshot();m.length>0&&k.push([P.handle,m]),this._groups.set(P.handle,P)}this._proxy.$registerGroups(this.handle,p,k),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const p=[];this.updatedResourceGroups.forEach(k=>{const P=k._takeResourceStateSnapshot();P.length!==0&&p.push([k.handle,P])}),p.length>0&&this._proxy.$spliceResourceStates(this.handle,p),this.updatedResourceGroups.clear()}getResourceGroup(p){return this._groups.get(p)}setSelectionState(p){this._selected=p,this._onDidChangeSelection.fire(p)}dispose(){this._acceptInputDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(p=>p.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}s._handlePool=0,We([(0,b.debounce)(100)],s.prototype,"eventuallyAddResourceGroups",null),We([(0,b.debounce)(100)],s.prototype,"eventuallyUpdateResourceStates",null);let l=class Bi{constructor(p,k,P){this._commands=k,this.logService=P,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new M.Emitter,this._proxy=p.getProxy(C.MainContext.MainThreadSCM),this._telemetry=p.getProxy(C.MainContext.MainThreadTelemetry),k.registerArgumentProcessor({processArgument:g=>{if(g&&g.$mid===3){const D=this._sourceControls.get(g.sourceControlHandle);if(!D)return g;const m=D.getResourceGroup(g.groupHandle);return m?m.getResourceState(g.handle):g}else if(g&&g.$mid===4){const D=this._sourceControls.get(g.sourceControlHandle);return D?D.getResourceGroup(g.groupHandle):g}else if(g&&g.$mid===5){const D=this._sourceControls.get(g.handle);return D||g}return g}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(p,k,P,g){this.logService.trace("ExtHostSCM#createSourceControl",p.identifier.value,k,P,g),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:p.identifier.value});const D=Bi._handlePool++,m=new s(p,this._proxy,this._commands,k,P,g);this._sourceControls.set(D,m);const A=this._sourceControlsByExtension.get(E.ExtensionIdentifier.toKey(p.identifier))||[];return A.push(m),this._sourceControlsByExtension.set(E.ExtensionIdentifier.toKey(p.identifier),A),m}getLastInputBox(p){this.logService.trace("ExtHostSCM#getLastInputBox",p.identifier.value);const k=this._sourceControlsByExtension.get(E.ExtensionIdentifier.toKey(p.identifier)),P=k&&k[k.length-1];return P&&P.inputBox}$provideOriginalResource(p,k,P){const g=d.URI.revive(k);this.logService.trace("ExtHostSCM#$provideOriginalResource",p,g.toString());const D=this._sourceControls.get(p);return!D||!D.quickDiffProvider||!D.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,F.asPromise)(()=>D.quickDiffProvider.provideOriginalResource(g,P)).then(m=>m||null)}$onInputBoxValueChange(p,k){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",p);const P=this._sourceControls.get(p);return P&&P.inputBox.$onInputBoxValueChange(k),Promise.resolve(void 0)}$executeResourceCommand(p,k,P,g){this.logService.trace("ExtHostSCM#$executeResourceCommand",p,k,P);const D=this._sourceControls.get(p);if(!D)return Promise.resolve(void 0);const m=D.getResourceGroup(k);return m?m.$executeResourceCommand(P,g):Promise.resolve(void 0)}$validateInput(p,k,P){this.logService.trace("ExtHostSCM#$validateInput",p);const g=this._sourceControls.get(p);return!g||!g.inputBox.validateInput?Promise.resolve(void 0):(0,F.asPromise)(()=>g.inputBox.validateInput(k,P)).then(D=>{if(!D)return Promise.resolve(void 0);const m=u.MarkdownString.fromStrict(D.message);return m?Promise.resolve([m,D.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(p){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",p),p!==void 0&&this._sourceControls.get(p)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=p,Promise.resolve(void 0)}};l._handlePool=0,l=We([ze(2,t.ILogService)],l),e.ExtHostSCM=l});var Ze=this&&this.__classPrivateFieldSet||function(re,e,d,M,b){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!b:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?b.call(re,d):b?b.value=d:e.set(re,d),d},Ae=this&&this.__classPrivateFieldGet||function(re,e,d,M){if(d==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?M:d==="a"?M.call(re):M?M.value:e.get(re)};define(be[202],Ee([0,1,7,5,127,6,8]),function(re,e,d,M,b,R,F){"use strict";var C,_;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class I{constructor(c,u,a,w,T=d.StatusBarAlignment.Left,S){C.set(this,void 0),_.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new R.DisposableStore,Ze(this,C,c,"f"),Ze(this,_,u,"f"),this._entryId=I.ID_GEN++,this._extension=a,this._id=w,this._alignment=T,this._priority=S}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(c){this._text=c,this.update()}set name(c){this._name=c,this.update()}set tooltip(c){this._tooltip=c,this.update()}set color(c){this._color=c,this.update()}set backgroundColor(c){c&&!I.ALLOWED_BACKGROUND_COLORS.has(c.id)&&(c=void 0),this._backgroundColor=c,this.update()}set command(c){this._command?.fromApi!==c&&(this._internalCommandRegistration.clear(),typeof c=="string"?this._command={fromApi:c,internal:Ae(this,_,"f").toInternal({title:"",command:c},this._internalCommandRegistration)}:c?this._command={fromApi:c,internal:Ae(this,_,"f").toInternal(c,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(c){this._accessibilityInformation=c,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Ae(this,C,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let c;this._extension?this._id?c=`${this._extension.identifier.value}.${this._id}`:c=this._extension.identifier.value:c=this._id;let u;this._name?u=this._name:u=(0,b.localize)(0,null,this._extension.displayName||this._extension.name);let a=this._color;this._backgroundColor&&(a=I.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const w=this._tooltip?F.MarkdownString.fromStrict(this._tooltip):void 0;Ae(this,C,"f").$setEntry(this._entryId,c,u,this._text,w,this._command?.internal,a,this._backgroundColor,this._alignment===d.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=I,C=new WeakMap,_=new WeakMap,I.ID_GEN=0,I.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new d.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new d.ThemeColor("statusBarItem.warningForeground")]]);class t{constructor(c){this._messages=[],this._item=c.createStatusBarEntry(void 0,"status.extensionMessage",d.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,b.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(c){const u={message:c};return this._messages.unshift(u),this._update(),new d.Disposable(()=>{const a=this._messages.indexOf(u);a>=0&&(this._messages.splice(a,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class E{constructor(c,u){this._proxy=c.getProxy(M.MainContext.MainThreadStatusBar),this._commands=u,this._statusMessage=new t(this)}createStatusBarEntry(c,u,a,w){return new I(this._proxy,this._commands,c,u,a,w)}setStatusBarMessage(c,u){const a=this._statusMessage.setMessage(c);let w;return typeof u=="number"?w=setTimeout(()=>a.dispose(),u):typeof u!="undefined"&&u.then(()=>a.dispose(),()=>a.dispose()),new d.Disposable(()=>{a.dispose(),clearTimeout(w)})}}e.ExtHostStatusBar=E}),define(be[72],Ee([0,1,5,3,4]),function(re,e,d,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class R{constructor(C){this._onDidChangeStorage=new M.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=C.getProxy(d.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(C,_){this._proxy.$registerExtensionStorageKeysToSync(C,_)}getValue(C,_,I){return this._proxy.$getValue(C,_).then(t=>t||I)}setValue(C,_,I){return this._proxy.$setValue(C,_,I)}$acceptValue(C,_,I){this._onDidChangeStorage.fire({shared:C,key:_,value:I})}}e.ExtHostStorage=R,e.IExtHostStorage=(0,b.createDecorator)("IExtHostStorage")}),define(be[73],Ee([0,1,4,29,15,71,2]),function(re,e,d,M,b,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,d.createDecorator)("IExtensionStoragePaths");let C=class{constructor(I,t,E){this._logService=t,this._extHostFileSystem=E,this._workspace=I.workspace??void 0,this._environment=I.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(n=>this._value=n)}async _getWorkspaceStorageURI(I){return F.URI.joinPath(this._environment.workspaceStorageHome,I)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const I=this._workspace.id,t=await this._getWorkspaceStorageURI(I);try{return await this._extHostFileSystem.value.stat(t),this._logService.trace("[ExtHostStorage] storage dir already exists",t),t}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",t),await this._extHostFileSystem.value.createDirectory(t),await this._extHostFileSystem.value.writeFile(F.URI.joinPath(t,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:F.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),t}catch(E){this._logService.error("[ExtHostStorage]",E);return}}workspaceValue(I){if(this._value)return F.URI.joinPath(this._value,I.identifier.value)}globalValue(I){return F.URI.joinPath(this._environment.globalStorageHome,I.identifier.value.toLowerCase())}onWillDeactivateAll(){}};C=We([ze(0,M.IExtHostInitDataService),ze(1,b.ILogService),ze(2,R.IExtHostConsumerFileSystem)],C),e.ExtensionStoragePaths=C}),define(be[40],Ee([0,1,3,5,4,2,13,6,7,128,16,166,21,36,149,46,10]),function(re,e,d,M,b,R,F,C,_,I,t,E,n,c,u,a,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,b.createDecorator)("IExtHostTerminalService");class T{constructor(l,h,p,k){this._proxy=l,this._id=h,this._creationOptions=p,this._name=k,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(g=>this._pidPromiseComplete=g);const P=this;this.value={get name(){return P._name||""},get processId(){return P._pidPromise},get creationOptions(){return P._creationOptions},get exitStatus(){return P._exitStatus},get state(){return P._state},sendText(g,D=!0){P._checkDisposed(),P._proxy.$sendText(P._id,g,D)},show(g){P._checkDisposed(),P._proxy.$show(P._id,g)},hide(){P._checkDisposed(),P._proxy.$hide(P._id)},dispose(){P._disposed||(P._disposed=!0,P._proxy.$dispose(P._id))},get dimensions(){if(!(P._cols===void 0||P._rows===void 0))return{columns:P._cols,rows:P._rows}}}}async create(l,h){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:l.name,shellPath:(0,w.withNullAsUndefined)(l.shellPath),shellArgs:(0,w.withNullAsUndefined)(l.shellArgs),cwd:(0,w.withNullAsUndefined)(l.cwd),env:(0,w.withNullAsUndefined)(l.env),icon:(0,w.withNullAsUndefined)(v(l.iconPath)),color:a.ThemeColor.isThemeColor(l.color)?l.color.id:void 0,initialText:(0,w.withNullAsUndefined)(l.message),strictEnv:(0,w.withNullAsUndefined)(l.strictEnv),hideFromUser:(0,w.withNullAsUndefined)(l.hideFromUser),isFeatureTerminal:(0,w.withNullAsUndefined)(h?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,w.withNullAsUndefined)(h?.useShellEnvironment),location:h?.location||this._serializeParentTerminal(l.location,h?.resolvedExtHostIdentifier)})}async createExtensionTerminal(l,h,p,k){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:p,color:a.ThemeColor.isThemeColor(k)?k.id:void 0,location:this._serializeParentTerminal(l,h)}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(l,h){return typeof l=="object"?"parentTerminal"in l&&l.parentTerminal&&h?{parentTerminal:h}:"viewColumn"in l?{viewColumn:l.viewColumn,preserveFocus:l.preserveFocus}:void 0:l}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(l){this._name=l}setExitCode(l){this._exitStatus=Object.freeze({code:l})}setDimensions(l,h){return l===this._cols&&h===this._rows||l===0||h===0?!1:(this._cols=l,this._rows=h,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(l){this._pidPromiseComplete?(this._pidPromiseComplete(l),this._pidPromiseComplete=void 0):this._pidPromise.then(h=>{h!==l&&(this._pidPromise=Promise.resolve(l))})}}e.ExtHostTerminal=T;class S{constructor(l){this._pty=l,this.id=0,this.shouldPersist=!1,this._capabilities=[],this._onProcessData=new d.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessExit=new d.Emitter,this.onProcessExit=this._onProcessExit.event,this._onProcessReady=new d.Emitter,this._onProcessTitleChanged=new d.Emitter,this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessOverrideDimensions=new d.Emitter,this._onProcessShellTypeChanged=new d.Emitter,this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event,this._onDidChangeProperty=new d.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event}get capabilities(){return this._capabilities}get onProcessReady(){return this._onProcessReady.event}get onProcessOverrideDimensions(){return this._onProcessOverrideDimensions.event}refreshProperty(l){return Promise.resolve("")}async start(){}shutdown(){this._pty.close()}input(l){this._pty.handleInput&&this._pty.handleInput(l)}resize(l,h){this._pty.setDimensions&&this._pty.setDimensions({columns:l,rows:h})}async processBinary(l){}acknowledgeDataEvent(l){}async setUnicodeVersion(l){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(l){this._pty.onDidWrite(h=>this._onProcessData.fire(h)),this._pty.onDidClose&&this._pty.onDidClose((h=void 0)=>{this._onProcessExit.fire(h===void 0?void 0:h)}),this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(h=>this._onProcessOverrideDimensions.fire(h&&{cols:h.columns,rows:h.rows})),this._pty.onDidChangeName&&this._pty.onDidChangeName(h=>this._onProcessTitleChanged.fire(h)),this._pty.open(l||void 0),this._pty.setDimensions&&l&&this._pty.setDimensions(l),this._onProcessReady.fire({pid:-1,cwd:"",capabilities:this._capabilities})}}e.ExtHostPseudoterminal=S;let o=1,f=class extends C.Disposable{constructor(l,h){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new d.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new d.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new d.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new d.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new d.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._proxy=h.getProxy(M.MainContext.MainThreadTerminalService),this._bufferer=new u.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new d.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(l),this._register({dispose:()=>{for(const[p,k]of this._terminalProcesses)k.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(l=>l.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}getDefaultShell(l){return(l?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(l){return(l?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(l,h){const p=new T(this._proxy,(0,c.generateUuid)(),l,l.name),k=new S(l.pty);return p.createExtensionTerminal(l.location,this._serializeParentTerminal(l,h).resolvedExtHostIdentifier,v(l.iconPath),r(l.color)).then(P=>{const g=this._setupExtHostProcessListeners(P,k);this._terminalProcessDisposables[P]=g}),this._terminals.push(p),p.value}_serializeParentTerminal(l,h){if(h=h||{},l.location&&typeof l.location=="object"&&"parentTerminal"in l.location){const p=l.location.parentTerminal;if(p){const k=this._terminals.find(P=>P.value===p);k&&(h.resolvedExtHostIdentifier=k._id)}}else l.location&&typeof l.location!="object"?h.location=l.location:h.location&&typeof h.location=="object"&&"splitActiveTerminal"in h.location&&(h.location={splitActiveTerminal:!0});return h}attachPtyToTerminal(l,h){if(!this._getTerminalById(l))throw new Error(`Cannot resolve terminal with id ${l} for virtual process`);const k=new S(h),P=this._setupExtHostProcessListeners(l,k);this._terminalProcessDisposables[l]=P}async $acceptActiveTerminalChanged(l){const h=this._activeTerminal;if(l===null){this._activeTerminal=void 0,h!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const p=this._getTerminalById(l);p&&(this._activeTerminal=p,h!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(l,h){const p=this._getTerminalById(l);p&&this._onDidWriteTerminalData.fire({terminal:p.value,data:h})}async $acceptTerminalDimensions(l,h,p){const k=this._getTerminalById(l);k&&k.setDimensions(h,p)&&this._onDidChangeTerminalDimensions.fire({terminal:k.value,dimensions:k.value.dimensions})}async $acceptTerminalMaximumDimensions(l,h,p){this._terminalProcesses.get(l)?.resize(h,p)}async $acceptTerminalTitleChange(l,h){const p=this._getTerminalById(l);p&&(p.name=h)}async $acceptTerminalClosed(l,h){const p=this._getTerminalObjectIndexById(this._terminals,l);if(p!==null){const k=this._terminals.splice(p,1)[0];k.setExitCode(h),this._onDidCloseTerminal.fire(k.value)}}$acceptTerminalOpened(l,h,p,k){if(h){const D=this._getTerminalObjectIndexById(this._terminals,h);if(D!==null){this._terminals[D]._id=l,this._onDidOpenTerminal.fire(this.terminals[D]),this._terminals[D].isOpen=!0;return}}const P={name:k.name,shellPath:k.executable,shellArgs:k.args,cwd:typeof k.cwd=="string"?k.cwd:R.URI.revive(k.cwd),env:k.env,hideFromUser:k.hideFromUser},g=new T(this._proxy,l,P,p);this._terminals.push(g),this._onDidOpenTerminal.fire(g.value),g.isOpen=!0}async $acceptTerminalProcessId(l,h){const p=this._getTerminalById(l);p&&p._setProcessId(h)}async $startExtensionTerminal(l,h){const p=this._getTerminalById(l);if(!p)return{message:(0,I.localize)(0,null,l)};p.isOpen||await new Promise(P=>{const g=this.onDidOpenTerminal(async D=>{D===p.value&&(g.dispose(),P())})});const k=this._terminalProcesses.get(l);k?k.startSendingEvents(h):this._extensionTerminalAwaitingStart[l]={initialDimensions:h}}_setupExtHostProcessListeners(l,h){const p=new C.DisposableStore;p.add(h.onProcessReady(P=>this._proxy.$sendProcessReady(l,P.pid,P.cwd))),p.add(h.onProcessTitleChanged(P=>this._proxy.$sendProcessTitle(l,P))),this._bufferer.startBuffering(l,h.onProcessData),p.add(h.onProcessExit(P=>this._onProcessExit(l,P))),h.onProcessOverrideDimensions&&p.add(h.onProcessOverrideDimensions(P=>this._proxy.$sendOverrideDimensions(l,P))),this._terminalProcesses.set(l,h);const k=this._extensionTerminalAwaitingStart[l];return k&&h instanceof S&&(h.startSendingEvents(k.initialDimensions),delete this._extensionTerminalAwaitingStart[l]),p}$acceptProcessAckDataEvent(l,h){this._terminalProcesses.get(l)?.acknowledgeDataEvent(h)}$acceptProcessInput(l,h){this._terminalProcesses.get(l)?.input(h)}$acceptTerminalInteraction(l){const h=this._getTerminalById(l);h?.setInteractedWith()&&this._onDidChangeTerminalState.fire(h.value)}$acceptProcessResize(l,h,p){try{this._terminalProcesses.get(l)?.resize(h,p)}catch(k){if(k.code!=="EPIPE"&&k.code!=="ERR_IPC_CHANNEL_CLOSED")throw k}}$acceptProcessShutdown(l,h){this._terminalProcesses.get(l)?.shutdown(h)}$acceptProcessRequestInitialCwd(l){this._terminalProcesses.get(l)?.getInitialCwd().then(h=>this._proxy.$sendProcessInitialCwd(l,h))}$acceptProcessRequestCwd(l){this._terminalProcesses.get(l)?.getCwd().then(h=>this._proxy.$sendProcessCwd(l,h))}$acceptProcessRequestLatency(l){return l}registerLinkProvider(l){return this._linkProviders.add(l),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new _.Disposable(()=>{this._linkProviders.delete(l),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(l,h,p){if(this._profileProviders.has(h))throw new Error(`Terminal profile provider "${h}" already registered`);return this._profileProviders.set(h,p),this._proxy.$registerProfileProvider(h,l.identifier.value),new _.Disposable(()=>{this._profileProviders.delete(h),this._proxy.$unregisterProfileProvider(h)})}async $createContributedProfileTerminal(l,h){const p=new n.CancellationTokenSource().token,k=await this._profileProviders.get(l)?.provideTerminalProfile(p);if(!p.isCancellationRequested){if(!k||!("options"in k))throw new Error(`No terminal profile options provided for id "${l}"`);if("pty"in k.options){this.createExtensionTerminal(k.options,h);return}this.createTerminalFromOptions(k.options,h)}}async $provideLinks(l,h){const p=this._getTerminalById(l);if(!p)return[];this._terminalLinkCache.delete(l);const k=this._terminalLinkCancellationSource.get(l);k&&k.dispose(!0);const P=new n.CancellationTokenSource;this._terminalLinkCancellationSource.set(l,P);const g=[],D={terminal:p.value,line:h},m=[];for(const V of this._linkProviders)m.push(new Promise(async G=>{P.token.onCancellationRequested(()=>G({provider:V,links:[]}));const U=await V.provideTerminalLinks(D,P.token)||[];P.token.isCancellationRequested||G({provider:V,links:U})}));const A=await Promise.all(m);if(P.token.isCancellationRequested)return[];const L=new Map;for(const V of A)V&&V.links.length>0&&g.push(...V.links.map(G=>{const U={id:o++,startIndex:G.startIndex,length:G.length,label:G.tooltip};return L.set(U.id,{provider:V.provider,link:G}),U}));return this._terminalLinkCache.set(l,L),g}$activateLink(l,h){const p=this._terminalLinkCache.get(l)?.get(h);!p||p.provider.handleTerminalLink(p.link)}_onProcessExit(l,h){this._bufferer.stopBuffering(l),this._terminalProcesses.delete(l),delete this._extensionTerminalAwaitingStart[l];const p=this._terminalProcessDisposables[l];p&&(p.dispose(),delete this._terminalProcessDisposables[l]),this._proxy.$sendProcessExit(l,h)}_getTerminalById(l){return this._getTerminalObjectById(this._terminals,l)}_getTerminalObjectById(l,h){const p=this._getTerminalObjectIndexById(l,h);return p!==null?l[p]:null}_getTerminalObjectIndexById(l,h){let p=null;return l.some((k,P)=>k._id===h?(p=P,!0):!1),p}getEnvironmentVariableCollection(l){let h=this._environmentVariableCollections.get(l.identifier.value);return h||(h=new y,this._setEnvironmentVariableCollection(l.identifier.value,h)),h}_syncEnvironmentVariableCollection(l,h){const p=(0,E.serializeEnvironmentVariableCollection)(h.map);this._proxy.$setEnvironmentVariableCollection(l,h.persistent,p.length===0?void 0:p)}$initEnvironmentVariableCollections(l){l.forEach(h=>{const p=h[0],k=new y(h[1]);this._setEnvironmentVariableCollection(p,k)})}$acceptDefaultProfile(l,h){this._defaultProfile=l,this._defaultAutomationProfile=h}_setEnvironmentVariableCollection(l,h){this._environmentVariableCollections.set(l,h),h.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(l,h)})}};f=We([ze(1,F.IExtHostRpcService)],f),e.BaseExtHostTerminalService=f;class y{constructor(l){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new d.Emitter,this.map=new Map(l)}get persistent(){return this._persistent}set persistent(l){this._persistent=l,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(l,h){this._setIfDiffers(l,{value:h,type:_.EnvironmentVariableMutatorType.Replace})}append(l,h){this._setIfDiffers(l,{value:h,type:_.EnvironmentVariableMutatorType.Append})}prepend(l,h){this._setIfDiffers(l,{value:h,type:_.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(l,h){const p=this.map.get(l);(!p||p.value!==h.value||p.type!==h.type)&&(this.map.set(l,h),this._onDidChangeCollection.fire())}get(l){return this.map.get(l)}forEach(l,h){this.map.forEach((p,k)=>l.call(h,k,p,this))}delete(l){this.map.delete(l),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=y;let i=class extends f{constructor(l){super(!1,l)}createTerminal(l,h,p){throw new t.NotSupportedError}createTerminalFromOptions(l,h){throw new t.NotSupportedError}};i=We([ze(0,F.IExtHostRpcService)],i),e.WorkerExtHostTerminalService=i;function v(s){if(!(!s||typeof s=="string"))return"id"in s?{id:s.id,color:s.color}:s}function r(s){return a.ThemeColor.isThemeColor(s)?s:void 0}});var Ze=this&&this.__classPrivateFieldSet||function(re,e,d,M,b){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!b:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?b.call(re,d):b?b.value=d:e.set(re,d),d},Ae=this&&this.__classPrivateFieldGet||function(re,e,d,M){if(d==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?M:d==="a"?M.call(re):M?M.value:e.get(re)};define(be[203],Ee([0,1,12,22,21,3,234,58,6,23,10,36,5,13,48,8,7,174,90,67]),function(re,e,d,M,b,R,F,C,_,I,t,E,n,c,u,a,w,T,S,o){"use strict";var f;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let y=class{constructor(m,A){this.resultsChangedEmitter=new R.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=m.getProxy(n.MainContext.MainThreadTesting),this.observer=new k(this.proxy),this.runTracker=new v(this.proxy),A.registerArgumentProcessor({processArgument:L=>L?.$mid===13?a.TestItem.toItemFromContext(L):L})}createTestController(m,A){if(this.controllers.has(m))throw new Error(`Attempt to insert a duplicate controller with ID "${m}"`);const L=new _.DisposableStore,V=L.add(new T.SingleUseTestCollection(m));V.root.label=A;const G=new Map,U=this.proxy,K={items:V.root.children,get label(){return A},set label(B){A=B,V.root.label=B,U.$updateControllerLabel(m,A)},get id(){return m},createRunProfile:(B,z,Y,ne,j)=>{let le=(0,C.hash)(B);for(;G.has(le);)le++;const se=new P(this.proxy,m,le,B,z,Y,ne,j);return G.set(le,se),se},createTestItem(B,z,Y){return new u.TestItemImpl(m,B,z,Y)},createTestRun:(B,z,Y=!0)=>this.runTracker.createTestRun(m,V,B,z,Y),set resolveHandler(B){V.resolveHandler=B},get resolveHandler(){return V.resolveHandler},dispose:()=>{L.dispose()}};K.createRunConfiguration=K.createRunProfile,U.$registerTestController(m,A),L.add((0,_.toDisposable)(()=>U.$unregisterTestController(m)));const $={controller:K,collection:V,profiles:G};return this.controllers.set(m,$),L.add((0,_.toDisposable)(()=>this.controllers.delete(m))),L.add(V.onDidGenerateDiff(B=>U.$publishDiff(m,B))),K}createTestObserver(){return this.observer.checkout()}async runTests(m,A=b.CancellationToken.None){const L=r(m);if(!L)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const V=this.controllers.get(L.controllerId);if(!V)throw new Error("Controller not found");await this.proxy.$runTests({targets:[{testIds:m.include?.map(G=>G.id)??[V.collection.root.id],profileGroup:g[L.kind],profileId:L.profileId,controllerId:L.controllerId}],exclude:m.exclude?.map(G=>G.id)},A)}$provideFileCoverage(m,A,L){return(0,d.mapFind)(this.runTracker.trackers,G=>G.id===m?G.getCoverage(A):void 0)?.provideFileCoverage(L)??Promise.resolve([])}$resolveFileCoverage(m,A,L,V){return(0,d.mapFind)(this.runTracker.trackers,U=>U.id===m?U.getCoverage(A):void 0)?.resolveFileCoverage(L,V)??Promise.resolve([])}$configureRunProfile(m,A){this.controllers.get(m)?.profiles.get(A)?.configureHandler?.()}$publishTestResults(m){this.results=Object.freeze(m.map(A=>(0,I.deepFreeze)(a.TestResults.to(A))).concat(this.results).sort((A,L)=>L.completedAt-A.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(m,A){const L=this.controllers.get(o.TestId.fromString(m).controllerId)?.collection;L&&(await L.expand(m,A<0?Infinity:A),L.flushDiff())}$acceptDiff(m){this.observer.applyDiff(m)}async $runControllerTests(m,A){const L=this.controllers.get(m.controllerId);if(!L)return;const{collection:V,profiles:G}=L,U=G.get(m.profileId);if(!U)return;const K=m.testIds.map(Y=>V.tree.get(Y)).filter(t.isDefined),$=m.excludeExtIds.map(Y=>L.collection.tree.get(Y)).filter(t.isDefined).filter(Y=>K.some(ne=>ne.fullId.compare(Y.fullId)===2));if(!K.length)return;const B=new w.TestRunRequest(K.some(Y=>Y.actual instanceof u.TestItemRootImpl)?void 0:K.map(Y=>Y.actual),$.map(Y=>Y.actual),U),z=this.runTracker.prepareForMainThreadTestRun(B,s.fromInternal(m,L.collection),A);try{await U.runHandler(B,A)}finally{z.isRunning&&!A.isCancellationRequested&&await R.Event.toPromise(z.onEnd),z.dispose()}}$cancelExtensionTestRun(m){m===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(m)}};y=We([ze(0,c.IExtHostRpcService)],y),e.ExtHostTesting=y;class i extends _.Disposable{constructor(m,A,L){super();this.dto=m,this.proxy=A,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new R.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new b.CancellationTokenSource(L)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:V}of this.tasks.values())V.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(m){return this.tasks.get(m)?.coverage}createRun(m){const A=this.dto.id,L=this.dto.controllerId,V=(0,E.generateUuid)(),G=new l(this.proxy,A,V),U=z=>(Y,...ne)=>{if($){console.warn(`Setting the state of test "${Y.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(Y)||(this.ensureTestIsKnown(Y),z(Y,...ne))},K=(z,Y)=>{const ne=Y instanceof Array?Y.map(a.TestMessage.from):[a.TestMessage.from(Y)];if(z.uri&&z.range){const j={range:a.Range.from(z.range),uri:z.uri};for(const le of ne)le.location=le.location||j}this.proxy.$appendTestMessagesInRun(A,V,o.TestId.fromExtHostTestItem(z,L).toString(),ne)};let $=!1;const B={isPersisted:this.dto.isPersisted,token:this.cts.token,name:m,get coverageProvider(){return G.coverageProvider},set coverageProvider(z){G.coverageProvider=z},enqueued:U(z=>{this.proxy.$updateTestStateInRun(A,V,o.TestId.fromExtHostTestItem(z,L).toString(),1)}),skipped:U(z=>{this.proxy.$updateTestStateInRun(A,V,o.TestId.fromExtHostTestItem(z,L).toString(),5)}),started:U(z=>{this.proxy.$updateTestStateInRun(A,V,o.TestId.fromExtHostTestItem(z,L).toString(),2)}),errored:U((z,Y,ne)=>{K(z,Y),this.proxy.$updateTestStateInRun(A,V,o.TestId.fromExtHostTestItem(z,L).toString(),6,ne)}),failed:U((z,Y,ne)=>{K(z,Y),this.proxy.$updateTestStateInRun(A,V,o.TestId.fromExtHostTestItem(z,L).toString(),4,ne)}),passed:U((z,Y)=>{this.proxy.$updateTestStateInRun(A,V,o.TestId.fromExtHostTestItem(z,this.dto.controllerId).toString(),3,Y)}),appendOutput:(z,Y,ne)=>{$||(ne&&(this.dto.isIncluded(ne)?this.ensureTestIsKnown(ne):ne=void 0),this.proxy.$appendOutputToRun(A,V,M.VSBuffer.fromString(z),Y&&a.location.from(Y),ne&&o.TestId.fromExtHostTestItem(ne,L).toString()))},end:()=>{$||($=!0,this.proxy.$finishedTestRunTask(A,V),this.tasks.delete(V),this.isRunning||this.dispose())}};return this.tasks.set(V,{run:B,coverage:G}),this.proxy.$startedTestRunTask(A,{id:V,name:m,running:!0}),B}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(m){if(!(m instanceof u.TestItemImpl))throw new u.InvalidTestItemError(m.id);if(this.sharedTestIds.has(o.TestId.fromExtHostTestItem(m,this.dto.controllerId).toString()))return;const A=[],L=this.dto.colllection.root;for(;;){const V=a.TestItem.from(m);if(A.unshift(V),this.sharedTestIds.has(V.extId)||(this.sharedTestIds.add(V.extId),m===L))break;m=m.parent||L}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,A)}}class v{constructor(m){this.proxy=m,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(m,A,L){return this.getTracker(m,A,L)}cancelRunById(m){for(const A of this.tracked.values())if(A.id===m){A.dispose();return}}cancelAllRuns(){for(const m of this.tracked.values())m.dispose()}createTestRun(m,A,L,V,G){const U=this.tracked.get(L);if(U)return U.createRun(V);const K=s.fromPublic(m,A,L,G),$=r(L);this.proxy.$startedExtensionTestRun({controllerId:m,profile:$&&{group:g[$.kind],id:$.profileId},exclude:L.exclude?.map(z=>z.id)??[],id:K.id,include:L.include?.map(z=>z.id)??[A.root.id],persist:G});const B=this.getTracker(L,K);return B.onEnd(()=>this.proxy.$finishedExtensionTestRun(K.id)),B.createRun(V)}getTracker(m,A,L){const V=new i(A,this.proxy,L);return this.tracked.set(m,V),V.onEnd(()=>this.tracked.delete(m)),V}}e.TestRunCoordinator=v;const r=D=>{if(!!D.profile){if(!(D.profile instanceof P))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return D.profile}};class s{constructor(m,A,L,V,G,U){this.controllerId=m,this.id=A,this.isPersisted=G,this.colllection=U,this.includePrefix=L.map(K=>K+"\0"),this.excludePrefix=V.map(K=>K+"\0")}static fromPublic(m,A,L,V){return new s(m,(0,E.generateUuid)(),L.include?.map(G=>o.TestId.fromExtHostTestItem(G,m).toString())??[m],L.exclude?.map(G=>o.TestId.fromExtHostTestItem(G,m).toString())??[],V,A)}static fromInternal(m,A){return new s(m.controllerId,m.runId,m.testIds,m.excludeExtIds,!0,A)}isIncluded(m){const A=o.TestId.fromExtHostTestItem(m,this.controllerId).toString()+"\0";for(const L of this.excludePrefix)if(A===L||A.startsWith(L))return!1;for(const L of this.includePrefix)if(A===L||A.startsWith(L))return!0;return!1}}e.TestRunDto=s;class l{constructor(m,A,L){this.proxy=m,this.runId=A,this.taskId=L}set coverageProvider(m){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!m||(this._coverageProvider=m,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(m){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(m))());try{return(await this.fileCoverage)?.map(a.TestCoverage.fromFile)??[]}catch(A){throw this.fileCoverage=void 0,A}}async resolveFileCoverage(m,A){const L=await this.fileCoverage;let V=L?.[m];return!this._coverageProvider||!L||!V?[]:(V.detailedCoverage||(V=L[m]=await this._coverageProvider.resolveFileCoverage?.(V,A)??V),V.detailedCoverage?.map(a.TestCoverage.fromDetailed)??[])}}class h extends S.IncrementalChangeCollector{constructor(m){super();this.emitter=m,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(m){this.added.add(m)}update(m){Object.assign(m.revived,a.TestItem.toPlain(m.item)),this.added.has(m)||this.updated.add(m)}remove(m){if(this.added.has(m)){this.added.delete(m);return}if(this.updated.delete(m),m.parent&&this.alreadyRemoved.has(m.parent)){this.alreadyRemoved.add(m.item.extId);return}this.removed.add(m)}getChangeEvent(){const{added:m,updated:A,removed:L}=this;return{get added(){return[...m].map(V=>V.revived)},get updated(){return[...A].map(V=>V.revived)},get removed(){return[...L].map(V=>V.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class p extends S.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new R.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(m){return this.items.get(m)}getMirroredTestDataByReference(m){return this.items.get(m.id)}createItem(m,A){return{...m,revived:a.TestItem.toPlain(m.item),depth:A?A.depth+1:0,children:new Set}}createChangeCollector(){return new h(this.changeEmitter)}}e.MirroredTestCollection=p;class k{constructor(m){this.proxy=m}checkout(){this.current||(this.current=this.createObserverData());const m=this.current;return m.observers++,{onDidChangeTest:m.tests.onDidChangeTests,get tests(){return[...m.tests.rootTests].map(A=>A.revived)},dispose:(0,F.once)(()=>{--m.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(m){return this.current?.tests.getMirroredTestDataByReference(m)}applyDiff(m){this.current?.tests.apply(m)}createObserverData(){const m=new p;return this.proxy.$subscribeToDiffs(),{observers:0,tests:m}}}class P{constructor(m,A,L,V,G,U,K=!1,$=void 0){this.controllerId=A,this.profileId=L,this._label=V,this.kind=G,this.runHandler=U,this._isDefault=K,this._tag=$,f.set(this,void 0),Ze(this,f,m,"f");const B=g[G];if(typeof B!="number")throw new Error(`Unknown TestRunProfile.group ${G}`);Ae(this,f,"f").$publishTestRunProfile({profileId:L,controllerId:A,tag:$?a.TestTag.namespace(this.controllerId,$.id):null,label:V,group:B,isDefault:K,hasConfigurationHandler:!1})}get label(){return this._label}set label(m){m!==this._label&&(this._label=m,Ae(this,f,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:m}))}get isDefault(){return this._isDefault}set isDefault(m){m!==this._isDefault&&(this._isDefault=m,Ae(this,f,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:m}))}get tag(){return this._tag}set tag(m){m?.id!==this._tag?.id&&(this._tag=m,Ae(this,f,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:m?a.TestTag.namespace(this.controllerId,m.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(m){m!==this._configureHandler&&(this._configureHandler=m,Ae(this,f,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!m}))}dispose(){Ae(this,f,"f").$removeTestProfile(this.controllerId,this.profileId)}}e.TestRunProfileImpl=P,f=new WeakMap;const g={[w.TestRunProfileKind.Coverage]:8,[w.TestRunProfileKind.Debug]:4,[w.TestRunProfileKind.Run]:2}}),define(be[204],Ee([0,1,3,12,5,94,8,7]),function(re,e,d,M,b,R,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class _{constructor(t,E){this._extHostDocumentsAndEditors=E,this._onDidChangeTextEditorSelection=new d.Emitter,this._onDidChangeTextEditorOptions=new d.Emitter,this._onDidChangeTextEditorVisibleRanges=new d.Emitter,this._onDidChangeTextEditorViewColumn=new d.Emitter,this._onDidChangeActiveTextEditor=new d.Emitter,this._onDidChangeVisibleTextEditors=new d.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=t.getProxy(b.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(n=>this._onDidChangeVisibleTextEditors.fire(n)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(n=>this._onDidChangeActiveTextEditor.fire(n))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(t){const E=this._extHostDocumentsAndEditors.allEditors();return t?E:E.map(n=>n.value)}async showTextDocument(t,E,n){let c;typeof E=="number"?c={position:F.ViewColumn.from(E),preserveFocus:n}:typeof E=="object"?c={position:F.ViewColumn.from(E.viewColumn),preserveFocus:E.preserveFocus,selection:typeof E.selection=="object"?F.Range.from(E.selection):void 0,pinned:typeof E.preview=="boolean"?!E.preview:void 0}:c={preserveFocus:!1};const u=await this._proxy.$tryShowTextDocument(t.uri,c),a=u&&this._extHostDocumentsAndEditors.getEditor(u);if(a)return a.value;throw u?new Error(`Could NOT open editor for "${t.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${t.uri.toString()}".`)}createTextEditorDecorationType(t,E){return new R.TextEditorDecorationType(this._proxy,t,E).value}$acceptEditorPropertiesChanged(t,E){const n=this._extHostDocumentsAndEditors.getEditor(t);if(!n)throw new Error("unknown text editor");if(E.options&&n._acceptOptions(E.options),E.selections){const c=E.selections.selections.map(F.Selection.to);n._acceptSelections(c)}if(E.visibleRanges){const c=M.coalesce(E.visibleRanges.map(F.Range.to));n._acceptVisibleRanges(c)}if(E.options&&this._onDidChangeTextEditorOptions.fire({textEditor:n.value,options:{...E.options,lineNumbers:F.TextEditorLineNumbersStyle.to(E.options.lineNumbers)}}),E.selections){const c=C.TextEditorSelectionChangeKind.fromValue(E.selections.source),u=E.selections.selections.map(F.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:n.value,selections:u,kind:c})}if(E.visibleRanges){const c=M.coalesce(E.visibleRanges.map(F.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:n.value,visibleRanges:c})}}$acceptEditorPositionData(t){for(const E in t){const n=this._extHostDocumentsAndEditors.getEditor(E);if(!n)throw new Error("Unknown text editor");const c=F.ViewColumn.to(t[E]);n.value.viewColumn!==c&&(n._acceptViewColumn(c),this._onDidChangeTextEditorViewColumn.fire({textEditor:n.value,viewColumn:c}))}}getDiffInformation(t){return Promise.resolve(this._proxy.$getDiffInformation(t))}}e.ExtHostEditors=_}),define(be[205],Ee([0,1,2,4,5,6,7]),function(re,e,d,M,b,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,M.createDecorator)("IExtHostTimeline");class C{constructor(t,E){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=t.getProxy(b.MainContext.MainThreadTimeline),E.registerArgumentProcessor({processArgument:n=>{if(n&&n.$mid===11){const c=n.uri===void 0?void 0:d.URI.revive(n.uri);return this._itemsBySourceAndUriMap.get(n.source)?.get(_(c))?.get(n.handle)}return n}})}async $getTimeline(t,E,n,c,u){return this._providers.get(t)?.provideTimeline(d.URI.revive(E),n,c,u)}registerTimelineProvider(t,E,n,c){const u=new R.DisposableStore,a=this.convertTimelineItem(E.id,c,u).bind(this);let w;E.onDidChange&&(w=E.onDidChange(S=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...S,id:E.id}),this));const T=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...E,scheme:t,onDidChange:void 0,async provideTimeline(S,o,f,y){y?.resetCache&&(u.clear(),T.get(E.id)?.clear());const i=await E.provideTimeline(S,o,f);if(i==null)return;const v=a(S,y);return{...i,source:E.id,items:i.items.map(v)}},dispose(){for(const S of T.values())S.get(E.id)?.clear();w?.dispose(),u.dispose()}})}convertTimelineItem(t,E,n){return(c,u)=>{let a;if(u?.cacheResults){let w=this._itemsBySourceAndUriMap.get(t);w===void 0&&(w=new Map,this._itemsBySourceAndUriMap.set(t,w));const T=_(c);a=w.get(T),a===void 0&&(a=new Map,w.set(T,a))}return w=>{const{iconPath:T,...S}=w,o=`${t}|${w.id??w.timestamp}`;a?.set(o,w);let f,y,i;return w.iconPath&&(T instanceof F.ThemeIcon?i={id:T.id,color:T.color}:d.URI.isUri(T)?(f=T,y=T):{light:f,dark:y}=T),{...S,id:S.id??void 0,handle:o,source:t,command:w.command?E.toInternal(w.command,n):void 0,icon:f,iconDark:y,themeIcon:i,accessibilityInformation:w.accessibilityInformation}}}}registerTimelineProviderCore(t){if(this._providers.get(t.id))throw new Error(`Timeline Provider ${t.id} already exists.`);return this._proxy.$registerTimelineProvider({id:t.id,label:t.label,scheme:t.scheme}),this._providers.set(t.id,t),(0,R.toDisposable)(()=>{for(const n of this._itemsBySourceAndUriMap.values())n.get(t.id)?.clear();this._providers.delete(t.id),this._proxy.$unregisterTimelineProvider(t.id),t.dispose()})}}e.ExtHostTimeline=C;function _(I){return I?.toString()}}),define(be[206],Ee([0,1,6,11,2,5]),function(re,e,d,M,b,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class F{constructor(_){this._openers=new Map,this._proxy=_.getProxy(R.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(_,I,t,E){if(this._openers.has(I))throw new Error(`Opener with id '${I}' already registered`);const n=E.schemes.find(c=>!F.supportedSchemes.has(c));if(n)throw new Error(`Scheme '${n}' is not supported. Only http and https are currently supported.`);return this._openers.set(I,t),this._proxy.$registerUriOpener(I,E.schemes,_,E.label),(0,d.toDisposable)(()=>{this._openers.delete(I),this._proxy.$unregisterUriOpener(I)})}async $canOpenUri(_,I,t){const E=this._openers.get(_);if(!E)throw new Error(`Unknown opener with id: ${_}`);const n=b.URI.revive(I);return E.canOpenExternalUri(n,t)}async $openUri(_,I,t){const E=this._openers.get(_);if(!E)throw new Error(`Unknown opener id: '${_}'`);return E.openExternalUri(b.URI.revive(I.resolvedUri),{sourceUri:b.URI.revive(I.sourceUri)},t)}}e.ExtHostUriOpeners=F,F.supportedSchemes=new Set([M.Schemas.http,M.Schemas.https])}),define(be[207],Ee([0,1,5,2,6,16,25]),function(re,e,d,M,b,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class C{constructor(I){this.handles=new Set,this.handlers=new Map,this._proxy=I.getProxy(d.MainContext.MainThreadUrls)}registerUriHandler(I,t){if(this.handles.has(F.ExtensionIdentifier.toKey(I)))throw new Error(`Protocol handler already registered for extension ${I}`);const E=C.HandlePool++;return this.handles.add(F.ExtensionIdentifier.toKey(I)),this.handlers.set(E,t),this._proxy.$registerUriHandler(E,I),(0,b.toDisposable)(()=>{this.handles.delete(F.ExtensionIdentifier.toKey(I)),this.handlers.delete(E),this._proxy.$unregisterUriHandler(E)})}$handleExternalUri(I,t){const E=this.handlers.get(I);if(!E)return Promise.resolve(void 0);try{E.handleUri(M.URI.revive(t))}catch(n){(0,R.onUnexpectedError)(n)}return Promise.resolve(void 0)}async createAppUri(I){return M.URI.revive(await this._proxy.$createAppUri(I))}}e.ExtHostUrls=C,C.HandlePool=0});var Ze=this&&this.__classPrivateFieldSet||function(re,e,d,M,b){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!b:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?b.call(re,d):b?b.value=d:e.set(re,d),d},Ae=this&&this.__classPrivateFieldGet||function(re,e,d,M){if(d==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?M:d==="a"?M.call(re):M?M.value:e.get(re)};define(be[50],Ee([0,1,3,2,138,157,66,5]),function(re,e,d,M,b,R,F,C){"use strict";var _,I,t,E,n,c,u,a,w,T,S,o;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class f{constructor(p,k,P,g,D,m,A){_.set(this,void 0),I.set(this,void 0),t.set(this,void 0),E.set(this,void 0),n.set(this,void 0),c.set(this,void 0),u.set(this,""),a.set(this,void 0),w.set(this,!1),T.set(this,!1),S.set(this,!1),this._onMessageEmitter=new d.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,o.set(this,new d.Emitter),this._onDidDispose=Ae(this,o,"f").event,Ze(this,_,p,"f"),Ze(this,I,k,"f"),Ze(this,a,P,"f"),Ze(this,E,g,"f"),Ze(this,n,D,"f"),Ze(this,c,m,"f"),Ze(this,S,y(m),"f"),Ze(this,t,A,"f")}dispose(){Ze(this,w,!0,"f"),Ae(this,o,"f").fire(),Ae(this,o,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(p){return Ze(this,T,!0,"f"),(0,F.asWebviewUri)(p,Ae(this,E,"f").remote)}get cspSource(){return F.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Ae(this,u,"f")}set html(p){this.assertNotDisposed(),Ae(this,u,"f")!==p&&(Ze(this,u,p,"f"),!Ae(this,T,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(p)&&(Ze(this,T,!0,"f"),Ae(this,t,"f").report("Webview vscode-resource: uris",Ae(this,c,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Ae(this,I,"f").$setHtml(Ae(this,_,"f"),p))}get options(){return this.assertNotDisposed(),Ae(this,a,"f")}set options(p){this.assertNotDisposed(),Ae(this,I,"f").$setOptions(Ae(this,_,"f"),r(Ae(this,c,"f"),Ae(this,n,"f"),p)),Ze(this,a,p,"f")}async postMessage(p){if(Ae(this,w,"f"))return!1;const k=(0,R.serializeWebviewMessage)(p,{serializeBuffersForPostMessage:Ae(this,S,"f")});return Ae(this,I,"f").$postMessage(Ae(this,_,"f"),k.message,...k.buffers)}assertNotDisposed(){if(Ae(this,w,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=f,_=new WeakMap,I=new WeakMap,t=new WeakMap,E=new WeakMap,n=new WeakMap,c=new WeakMap,u=new WeakMap,a=new WeakMap,w=new WeakMap,T=new WeakMap,S=new WeakMap,o=new WeakMap;function y(h){try{const p=(0,b.normalizeVersion)((0,b.parseVersion)(h.engines.vscode));return!!p&&p.majorBase>=1&&p.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=y;class i{constructor(p,k,P,g,D){this.initData=k,this.workspace=P,this._logService=g,this._deprecationService=D,this._webviews=new Map,this._webviewProxy=p.getProxy(C.MainContext.MainThreadWebviews)}$onMessage(p,k,...P){const g=this.getWebview(p);if(g){const{message:D}=(0,R.deserializeWebviewMessage)(k,P);g._onMessageEmitter.fire(D)}}$onMissingCsp(p,k){this._logService.warn(`${k} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(p,k,P){const g=new f(p,this._webviewProxy,s(k),this.initData,this.workspace,P,this._deprecationService);return this._webviews.set(p,g),g._onDidDispose(()=>{this._webviews.delete(p)}),g}deleteWebview(p){this._webviews.delete(p)}getWebview(p){return this._webviews.get(p)}}e.ExtHostWebviews=i;function v(h){return{id:h.identifier,location:h.extensionLocation}}e.toExtensionData=v;function r(h,p,k){return{enableCommandUris:k.enableCommandUris,enableScripts:k.enableScripts,enableForms:k.enableForms,portMapping:k.portMapping,localResourceRoots:k.localResourceRoots||l(h,p)}}e.serializeWebviewOptions=r;function s(h){return{enableCommandUris:h.enableCommandUris,enableScripts:h.enableScripts,enableForms:h.enableForms,portMapping:h.portMapping,localResourceRoots:h.localResourceRoots?.map(p=>M.URI.from(p))}}e.reviveOptions=s;function l(h,p){return[...(p?.getWorkspaceFolders()||[]).map(k=>k.uri),h.extensionLocation]}}),define(be[208],Ee([0,1,21,58,6,11,24,2,8,50,63,5,7]),function(re,e,d,M,b,R,F,C,_,I,t,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class c{constructor(i,v){this.document=i,this._storagePath=v,this._backupCounter=1,this._edits=new t.Cache("custom documents")}addEdit(i){return this._edits.add([i])}async undo(i,v){await this.getEdit(i).undo(),v||this.disposeBackup()}async redo(i,v){await this.getEdit(i).redo(),v||this.disposeBackup()}disposeEdits(i){for(const v of i)this._edits.delete(v)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const i=f(this.document.uri)+this._backupCounter++;return(0,F.joinPath)(this._storagePath,i)}updateBackup(i){this._backup?.delete(),this._backup=i}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(i){const v=this._edits.get(i,0);if(!v)throw new Error("No edit found");return v}}class u{constructor(){this._documents=new Map}get(i,v){return this._documents.get(this.key(i,v))}add(i,v,r){const s=this.key(i,v.uri);if(this._documents.has(s))throw new Error(`Document already exists for viewType:${i} resource:${v.uri}`);const l=new c(v,r);return this._documents.set(s,l),l}delete(i,v){const r=this.key(i,v.uri);this._documents.delete(r)}key(i,v){return`${i}@@@${v}`}}var a;(function(y){y[y.Text=0]="Text",y[y.Custom=1]="Custom"})(a||(a={}));class w{constructor(){this._providers=new Map}addTextProvider(i,v,r){return this.add(0,i,v,r)}addCustomProvider(i,v,r){return this.add(1,i,v,r)}get(i){return this._providers.get(i)}add(i,v,r,s){if(this._providers.has(v))throw new Error(`Provider for viewType:${v} already registered`);return this._providers.set(v,{type:i,extension:r,provider:s}),new n.Disposable(()=>this._providers.delete(v))}}class T{constructor(i,v,r,s,l){this._extHostDocuments=v,this._extensionStoragePaths=r,this._extHostWebview=s,this._extHostWebviewPanels=l,this._editorProviders=new w,this._documents=new u,this._proxy=i.getProxy(E.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(i,v,r,s){const l=new b.DisposableStore;return S(r)?(l.add(this._editorProviders.addTextProvider(v,i,r)),this._proxy.$registerTextEditorProvider((0,I.toExtensionData)(i),v,s.webviewOptions||{},{supportsMove:!!r.moveCustomTextEditor},(0,I.shouldSerializeBuffersForPostMessage)(i))):(l.add(this._editorProviders.addCustomProvider(v,i,r)),this.supportEditing(r)&&l.add(r.onDidChangeCustomDocument(h=>{const p=this.getCustomDocumentEntry(v,h.document.uri);if(o(h)){const k=p.addEdit(h);this._proxy.$onDidEdit(h.document.uri,v,k,h.label)}else this._proxy.$onContentChange(h.document.uri,v)})),this._proxy.$registerCustomEditorProvider((0,I.toExtensionData)(i),v,s.webviewOptions||{},!!s.supportsMultipleEditorsPerDocument,(0,I.shouldSerializeBuffersForPostMessage)(i))),n.Disposable.from(l,new n.Disposable(()=>{this._proxy.$unregisterEditorProvider(v)}))}async $createCustomDocument(i,v,r,s,l){const h=this._editorProviders.get(v);if(!h)throw new Error(`No provider found for '${v}'`);if(h.type!==1)throw new Error(`Invalid provide type for '${v}'`);const p=C.URI.revive(i),k=await h.provider.openCustomDocument(p,{backupId:r,untitledDocumentData:s?.buffer},l);let P;return this.supportEditing(h.provider)&&this._extensionStoragePaths&&(P=this._extensionStoragePaths.workspaceValue(h.extension)??this._extensionStoragePaths.globalValue(h.extension)),this._documents.add(v,k,P),{editable:this.supportEditing(h.provider)}}async $disposeCustomDocument(i,v){const r=this._editorProviders.get(v);if(!r)throw new Error(`No provider found for '${v}'`);if(r.type!==1)throw new Error(`Invalid provider type for '${v}'`);const s=C.URI.revive(i),{document:l}=this.getCustomDocumentEntry(v,s);this._documents.delete(v,l),l.dispose()}async $resolveWebviewEditor(i,v,r,s,l,h){const p=this._editorProviders.get(r);if(!p)throw new Error(`No provider found for '${r}'`);const k=_.ViewColumn.to(l),P=this._extHostWebview.createNewWebview(v,s.webviewOptions,p.extension),g=this._extHostWebviewPanels.createNewWebviewPanel(v,r,s.title,k,s.panelOptions,P),D=C.URI.revive(i);switch(p.type){case 1:{const{document:m}=this.getCustomDocumentEntry(r,D);return p.provider.resolveCustomEditor(m,g,h)}case 0:{const m=this._extHostDocuments.getDocument(D);return p.provider.resolveCustomTextEditor(m,g,h)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(i,v,r){this.getCustomDocumentEntry(v,i).disposeEdits(r)}async $onMoveCustomEditor(i,v,r){const s=this._editorProviders.get(r);if(!s)throw new Error(`No provider found for '${r}'`);if(!s.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${r}'`);const l=this._extHostWebviewPanels.getWebviewPanel(i);if(!l)throw new Error("No webview found");const h=C.URI.revive(v),p=this._extHostDocuments.getDocument(h);await s.provider.moveCustomTextEditor(p,l,d.CancellationToken.None)}async $undo(i,v,r,s){return this.getCustomDocumentEntry(v,i).undo(r,s)}async $redo(i,v,r,s){return this.getCustomDocumentEntry(v,i).redo(r,s)}async $revert(i,v,r){const s=this.getCustomDocumentEntry(v,i);await this.getCustomEditorProvider(v).revertCustomDocument(s.document,r),s.disposeBackup()}async $onSave(i,v,r){const s=this.getCustomDocumentEntry(v,i);await this.getCustomEditorProvider(v).saveCustomDocument(s.document,r),s.disposeBackup()}async $onSaveAs(i,v,r,s){const l=this.getCustomDocumentEntry(v,i);return this.getCustomEditorProvider(v).saveCustomDocumentAs(l.document,C.URI.revive(r),s)}async $backup(i,v,r){const s=this.getCustomDocumentEntry(v,i),h=await this.getCustomEditorProvider(v).backupCustomDocument(s.document,{destination:s.getNewBackupUri()},r);return s.updateBackup(h),h.id}getCustomDocumentEntry(i,v){const r=this._documents.get(i,C.URI.revive(v));if(!r)throw new Error("No custom document found");return r}getCustomEditorProvider(i){const r=this._editorProviders.get(i)?.provider;if(!r||!this.supportEditing(r))throw new Error("Custom document is not editable");return r}supportEditing(i){return!!i.onDidChangeCustomDocument}}e.ExtHostCustomEditors=T;function S(y){return typeof y.resolveCustomTextEditor=="function"}function o(y){return typeof y.undo=="function"&&typeof y.redo=="function"}function f(y){const i=y.scheme===R.Schemas.file||y.scheme===R.Schemas.untitled?y.fsPath:y.toString();return(0,M.hash)(i)+""}});var Ze=this&&this.__classPrivateFieldSet||function(re,e,d,M,b){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!b:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?b.call(re,d):b?b.value=d:e.set(re,d),d},Ae=this&&this.__classPrivateFieldGet||function(re,e,d,M){if(d==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?M:d==="a"?M.call(re):M?M.value:e.get(re)};define(be[209],Ee([0,1,3,6,2,36,8,50,5,7]),function(re,e,d,M,b,R,F,C,_,I){"use strict";var t,E,n,c,u,a,w,T,S,o,f,y,i;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class v extends M.Disposable{constructor(h,p,k,P,g,D,m){super();t.set(this,void 0),E.set(this,void 0),n.set(this,void 0),c.set(this,void 0),u.set(this,void 0),a.set(this,void 0),w.set(this,void 0),T.set(this,void 0),S.set(this,!0),o.set(this,!0),f.set(this,!1),y.set(this,this._register(new d.Emitter)),this.onDidDispose=Ae(this,y,"f").event,i.set(this,this._register(new d.Emitter)),this.onDidChangeViewState=Ae(this,i,"f").event,Ze(this,t,h,"f"),Ze(this,E,p,"f"),Ze(this,n,k,"f"),Ze(this,u,D,"f"),Ze(this,T,g,"f"),Ze(this,a,P,"f"),Ze(this,c,m,"f")}dispose(){Ae(this,f,"f")||(Ze(this,f,!0,"f"),Ae(this,y,"f").fire(),Ae(this,E,"f").$disposeWebview(Ae(this,t,"f")),Ae(this,c,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Ae(this,c,"f")}get viewType(){return this.assertNotDisposed(),Ae(this,n,"f")}get title(){return this.assertNotDisposed(),Ae(this,a,"f")}set title(h){this.assertNotDisposed(),Ae(this,a,"f")!==h&&(Ze(this,a,h,"f"),Ae(this,E,"f").$setTitle(Ae(this,t,"f"),h))}get iconPath(){return this.assertNotDisposed(),Ae(this,w,"f")}set iconPath(h){this.assertNotDisposed(),Ae(this,w,"f")!==h&&(Ze(this,w,h,"f"),Ae(this,E,"f").$setIconPath(Ae(this,t,"f"),b.URI.isUri(h)?{light:h,dark:h}:h))}get options(){return Ae(this,u,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Ae(this,T,"f")=="number"&&Ae(this,T,"f")<0))return Ae(this,T,"f")}get active(){return this.assertNotDisposed(),Ae(this,o,"f")}get visible(){return this.assertNotDisposed(),Ae(this,S,"f")}_updateViewState(h){Ae(this,f,"f")||(this.active!==h.active||this.visible!==h.visible||this.viewColumn!==h.viewColumn)&&(Ze(this,o,h.active,"f"),Ze(this,S,h.visible,"f"),Ze(this,T,h.viewColumn,"f"),Ae(this,i,"f").fire({webviewPanel:this}))}reveal(h,p){this.assertNotDisposed(),Ae(this,E,"f").$reveal(Ae(this,t,"f"),{viewColumn:h?F.ViewColumn.from(h):void 0,preserveFocus:!!p})}assertNotDisposed(){if(Ae(this,f,"f"))throw new Error("Webview is disposed")}}t=new WeakMap,E=new WeakMap,n=new WeakMap,c=new WeakMap,u=new WeakMap,a=new WeakMap,w=new WeakMap,T=new WeakMap,S=new WeakMap,o=new WeakMap,f=new WeakMap,y=new WeakMap,i=new WeakMap;class r{constructor(h,p,k){this.webviews=p,this.workspace=k,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=h.getProxy(_.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,R.generateUuid)()}createWebviewPanel(h,p,k,P,g={}){const D=typeof P=="object"?P.viewColumn:P,m={viewColumn:F.ViewColumn.from(D),preserveFocus:typeof P=="object"&&!!P.preserveFocus},A=(0,C.shouldSerializeBuffersForPostMessage)(h),L=r.newHandle();this._proxy.$createWebviewPanel((0,C.toExtensionData)(h),L,p,{title:k,panelOptions:s(g),webviewOptions:(0,C.serializeWebviewOptions)(h,this.workspace,g),serializeBuffersForPostMessage:A},m);const V=this.webviews.createNewWebview(L,g,h);return this.createNewWebviewPanel(L,p,k,D,g,V)}$onDidChangeWebviewPanelViewStates(h){const p=Object.keys(h);p.sort((k,P)=>{const g=h[k],D=h[P];return g.active?1:D.active?-1:+g.visible-+D.visible});for(const k of p){const P=this.getWebviewPanel(k);if(!P)continue;const g=h[k];P._updateViewState({active:g.active,visible:g.visible,viewColumn:F.ViewColumn.to(g.position)})}}async $onDidDisposeWebviewPanel(h){this.getWebviewPanel(h)?.dispose(),this._webviewPanels.delete(h),this.webviews.deleteWebview(h)}registerWebviewPanelSerializer(h,p,k){if(this._serializers.has(p))throw new Error(`Serializer for '${p}' already registered`);return this._serializers.set(p,{serializer:k,extension:h}),this._proxy.$registerSerializer(p,{serializeBuffersForPostMessage:(0,C.shouldSerializeBuffersForPostMessage)(h)}),new I.Disposable(()=>{this._serializers.delete(p),this._proxy.$unregisterSerializer(p)})}async $deserializeWebviewPanel(h,p,k,P){const g=this._serializers.get(p);if(!g)throw new Error(`No serializer found for '${p}'`);const{serializer:D,extension:m}=g,A=this.webviews.createNewWebview(h,k.webviewOptions,m),L=this.createNewWebviewPanel(h,p,k.title,P,k.panelOptions,A);await D.deserializeWebviewPanel(L,k.state)}createNewWebviewPanel(h,p,k,P,g,D){const m=new v(h,this._proxy,p,k,P,g,D);return this._webviewPanels.set(h,m),m}getWebviewPanel(h){return this._webviewPanels.get(h)}}e.ExtHostWebviewPanels=r;function s(l){return{enableFindWidget:l.enableFindWidget,retainContextWhenHidden:l.retainContextWhenHidden}}});var Ze=this&&this.__classPrivateFieldSet||function(re,e,d,M,b){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!b:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?b.call(re,d):b?b.value=d:e.set(re,d),d},Ae=this&&this.__classPrivateFieldGet||function(re,e,d,M){if(d==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?M:d==="a"?M.call(re):M?M.value:e.get(re)};define(be[210],Ee([0,1,3,6,50,5,7]),function(re,e,d,M,b,R,F){"use strict";var C,_,I,t,E,n,c,u,a,w;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class T extends M.Disposable{constructor(f,y,i,v,r,s){super();C.set(this,void 0),_.set(this,void 0),I.set(this,void 0),t.set(this,void 0),E.set(this,!1),n.set(this,void 0),c.set(this,void 0),u.set(this,void 0),a.set(this,this._register(new d.Emitter)),this.onDidChangeVisibility=Ae(this,a,"f").event,w.set(this,this._register(new d.Emitter)),this.onDidDispose=Ae(this,w,"f").event,Ze(this,I,i,"f"),Ze(this,c,v,"f"),Ze(this,C,f,"f"),Ze(this,_,y,"f"),Ze(this,t,r,"f"),Ze(this,n,s,"f")}dispose(){Ae(this,E,"f")||(Ze(this,E,!0,"f"),Ae(this,w,"f").fire(),Ae(this,t,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Ae(this,c,"f")}set title(f){this.assertNotDisposed(),Ae(this,c,"f")!==f&&(Ze(this,c,f,"f"),Ae(this,_,"f").$setWebviewViewTitle(Ae(this,C,"f"),f))}get description(){return this.assertNotDisposed(),Ae(this,u,"f")}set description(f){this.assertNotDisposed(),Ae(this,u,"f")!==f&&(Ze(this,u,f,"f"),Ae(this,_,"f").$setWebviewViewDescription(Ae(this,C,"f"),f))}get visible(){return Ae(this,n,"f")}get webview(){return Ae(this,t,"f")}get viewType(){return Ae(this,I,"f")}_setVisible(f){f===Ae(this,n,"f")||Ae(this,E,"f")||(Ze(this,n,f,"f"),Ae(this,a,"f").fire())}show(f){this.assertNotDisposed(),Ae(this,_,"f").$show(Ae(this,C,"f"),!!f)}assertNotDisposed(){if(Ae(this,E,"f"))throw new Error("Webview is disposed")}}C=new WeakMap,_=new WeakMap,I=new WeakMap,t=new WeakMap,E=new WeakMap,n=new WeakMap,c=new WeakMap,u=new WeakMap,a=new WeakMap,w=new WeakMap;class S{constructor(f,y){this._extHostWebview=y,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=f.getProxy(R.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(f,y,i,v){if(this._viewProviders.has(y))throw new Error(`View provider for '${y}' already registered`);return this._viewProviders.set(y,{provider:i,extension:f}),this._proxy.$registerWebviewViewProvider((0,b.toExtensionData)(f),y,{retainContextWhenHidden:v?.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new F.Disposable(()=>{this._viewProviders.delete(y),this._proxy.$unregisterWebviewViewProvider(y)})}async $resolveWebviewView(f,y,i,v,r){const s=this._viewProviders.get(y);if(!s)throw new Error(`No view provider found for '${y}'`);const{provider:l,extension:h}=s,p=this._extHostWebview.createNewWebview(f,{},h),k=new T(f,this._proxy,y,i,p,!0);this._webviewViews.set(f,k),await l.resolveWebviewView(k,{state:v},r)}async $onDidChangeWebviewViewVisibility(f,y){this.getWebviewView(f)._setVisible(y)}async $disposeWebviewView(f){const y=this.getWebviewView(f);this._webviewViews.delete(f),y.dispose(),this._extHostWebview.deleteWebview(f)}getWebviewView(f){const y=this._webviewViews.get(f);if(!y)throw new Error("No webview found");return y}}e.ExtHostWebviewViews=S}),define(be[97],Ee([0,1,3,5,2,11,9,4,13]),function(re,e,d,M,b,R,F,C,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let I=class Ui{constructor(E){this._onDidChangeWindowState=new d.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Ui.InitialState,this._proxy=E.getProxy(M.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(n=>this.$onDidChangeWindowFocus(n))}get state(){return this._state}$onDidChangeWindowFocus(E){E!==this._state.focused&&(this._state={...this._state,focused:E},this._onDidChangeWindowState.fire(this._state))}openUri(E,n){let c;if(typeof E=="string"){c=E;try{E=b.URI.parse(E)}catch(u){return Promise.reject(`Invalid uri - '${E}'`)}}return(0,F.isFalsyOrWhitespace)(E.scheme)?Promise.reject("Invalid scheme - cannot be empty"):E.scheme===R.Schemas.command?Promise.reject(`Invalid scheme '${E.scheme}'`):this._proxy.$openUri(E,c,n)}async asExternalUri(E,n){if((0,F.isFalsyOrWhitespace)(E.scheme))return Promise.reject("Invalid scheme - cannot be empty");const c=await this._proxy.$asExternalUri(E,n);return b.URI.from(c)}};I.InitialState={focused:!0},I=We([ze(0,_.IExtHostRpcService)],I),e.ExtHostWindow=I,e.IExtHostWindow=(0,C.createDecorator)("IExtHostWindow")}),define(be[211],Ee([0,1,15,5,29,13]),function(re,e,d,M,b,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let F=class extends d.AbstractLogger{constructor(_,I){super();this._proxy=_.getProxy(M.MainContext.MainThreadLog),this._logFile=I.logFile.toJSON(),this.setLevel(I.logLevel)}$setLevel(_){this.setLevel(_)}trace(_,...I){this.getLevel()<=d.LogLevel.Trace&&this._proxy.$log(this._logFile,d.LogLevel.Trace,Array.from(arguments))}debug(_,...I){this.getLevel()<=d.LogLevel.Debug&&this._proxy.$log(this._logFile,d.LogLevel.Debug,Array.from(arguments))}info(_,...I){this.getLevel()<=d.LogLevel.Info&&this._proxy.$log(this._logFile,d.LogLevel.Info,Array.from(arguments))}warn(_,...I){this.getLevel()<=d.LogLevel.Warning&&this._proxy.$log(this._logFile,d.LogLevel.Warning,Array.from(arguments))}error(_,...I){this.getLevel()<=d.LogLevel.Error&&this._proxy.$log(this._logFile,d.LogLevel.Error,Array.from(arguments))}critical(_,...I){this.getLevel()<=d.LogLevel.Critical&&this._proxy.$log(this._logFile,d.LogLevel.Critical,Array.from(arguments))}flush(){}};F=We([ze(0,R.IExtHostRpcService),ze(1,b.IExtHostInitDataService)],F),e.ExtHostLogService=F}),define(be[212],Ee([0,1,14,22,21,16,3,6,109,179,38]),function(re,e,d,M,b,R,F,C,_,I,t){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function n(g,D){try{return JSON.stringify(g,D)}catch(m){return"null"}}const c="$$ref$$",u={[c]:-1};class a{constructor(D,m){this.jsonString=D,this.referencedBuffers=m}}function w(g,D=null,m=!1){const A=[];return{jsonString:(m?n:JSON.stringify)(g,(V,G)=>{if(typeof G=="undefined")return u;if(typeof G=="object"){if(G instanceof M.VSBuffer){const U=A.push(G)-1;return{[c]:U}}if(D)return D(V,G)}return G}),referencedBuffers:A}}e.stringifyJsonWithBufferRefs=w;function T(g,D,m){return JSON.parse(g,(A,L)=>{if(L){const V=L[c];if(typeof V=="number")return D[V];if(m&&L.$mid===1)return m.transformIncoming(L)}return L})}e.parseJsonAndRestoreBufferRefs=T;function S(g,D){return JSON.stringify(g,D)}function o(g){return g?(D,m)=>m&&m.$mid===1?g.transformOutgoing(m):m:null}var f;(function(g){g[g.LocalSide=0]="LocalSide",g[g.OtherSide=1]="OtherSide"})(f=e.RequestInitiator||(e.RequestInitiator={}));var y;(function(g){g[g.Responsive=0]="Responsive",g[g.Unresponsive=1]="Unresponsive"})(y=e.ResponsiveState||(e.ResponsiveState={}));const i=()=>{},v=Symbol.for("rpcProtocol"),r=Symbol.for("rpcProxy");class s extends C.Disposable{constructor(D,m=null,A=null){super();this[E]=!0,this._onDidChangeResponsiveState=this._register(new F.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=D,this._logger=m,this._uriTransformer=A,this._uriReplacer=o(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let L=0,V=t.ProxyIdentifier.count;L<V;L++)this._locals[L]=null,this._proxies[L]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new d.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(L=>this._receiveOneMessage(L))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(D=>{this._pendingRPCReplies[D].resolveErr(R.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(D){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+s.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(D){this._unresponsiveTime=Date.now()+s.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(D){this._responsiveState!==D&&(this._responsiveState=D,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(D){return this._uriTransformer?(0,_.transformIncomingURIs)(D,this._uriTransformer):D}getProxy(D){const{nid:m,sid:A}=D;return this._proxies[m]||(this._proxies[m]=this._createProxy(m,A)),this._proxies[m]}_createProxy(D,m){let A={get:(L,V)=>(typeof V=="string"&&!L[V]&&V.charCodeAt(0)===36&&(L[V]=(...G)=>this._remoteCall(D,V,G)),V===r?m:L[V])};return new Proxy(Object.create(null),A)}set(D,m){return this._locals[D.nid]=m,m}assertRegistered(D){for(let m=0,A=D.length;m<A;m++){const L=D[m];if(!this._locals[L.nid])throw new Error(`Missing actor ${L.sid} (isMain: ${L.isMain})`)}}_receiveOneMessage(D){if(this._isDisposed)return;const m=D.byteLength,A=l.read(D,0),L=A.readUInt8(),V=A.readUInt32();switch(L){case 1:case 2:{let{rpcId:G,method:U,args:K}=p.deserializeRequestJSONArgs(A);this._uriTransformer&&(K=(0,_.transformIncomingURIs)(K,this._uriTransformer)),this._receiveRequest(m,V,G,U,K,L===2);break}case 3:case 4:{let{rpcId:G,method:U,args:K}=p.deserializeRequestMixedArgs(A);this._uriTransformer&&(K=(0,_.transformIncomingURIs)(K,this._uriTransformer)),this._receiveRequest(m,V,G,U,K,L===4);break}case 5:{this._logger&&this._logger.logIncoming(m,V,0,"ack"),this._onDidReceiveAcknowledge(V);break}case 6:{this._receiveCancel(m,V);break}case 7:{this._receiveReply(m,V,void 0);break}case 9:{let G=p.deserializeReplyOKJSON(A);this._uriTransformer&&(G=(0,_.transformIncomingURIs)(G,this._uriTransformer)),this._receiveReply(m,V,G);break}case 10:{const G=p.deserializeReplyOKJSONWithBuffers(A,this._uriTransformer);this._receiveReply(m,V,G);break}case 8:{let G=p.deserializeReplyOKVSBuffer(A);this._receiveReply(m,V,G);break}case 11:{let G=p.deserializeReplyErrError(A);this._uriTransformer&&(G=(0,_.transformIncomingURIs)(G,this._uriTransformer)),this._receiveReplyErr(m,V,G);break}case 12:{this._receiveReplyErr(m,V,void 0);break}default:console.error("received unexpected message"),console.error(D)}}_receiveRequest(D,m,A,L,V,G){this._logger&&this._logger.logIncoming(D,m,1,`receiveRequest ${(0,t.getStringIdentifierForProxy)(A)}.${L}(`,V);const U=String(m);let K,$;if(G){const z=new b.CancellationTokenSource;V.push(z.token),K=this._invokeHandler(A,L,V),$=()=>z.cancel()}else K=this._invokeHandler(A,L,V),$=i;this._cancelInvokedHandlers[U]=$;const B=p.serializeAcknowledged(m);this._logger&&this._logger.logOutgoing(B.byteLength,m,1,"ack"),this._protocol.send(B),K.then(z=>{delete this._cancelInvokedHandlers[U];const Y=p.serializeReplyOK(m,z,this._uriReplacer);this._logger&&this._logger.logOutgoing(Y.byteLength,m,1,"reply:",z),this._protocol.send(Y)},z=>{delete this._cancelInvokedHandlers[U];const Y=p.serializeReplyErr(m,z);this._logger&&this._logger.logOutgoing(Y.byteLength,m,1,"replyErr:",z),this._protocol.send(Y)})}_receiveCancel(D,m){this._logger&&this._logger.logIncoming(D,m,1,"receiveCancel");const A=String(m);this._cancelInvokedHandlers[A]&&this._cancelInvokedHandlers[A]()}_receiveReply(D,m,A){this._logger&&this._logger.logIncoming(D,m,0,"receiveReply:",A);const L=String(m);if(!this._pendingRPCReplies.hasOwnProperty(L))return;const V=this._pendingRPCReplies[L];delete this._pendingRPCReplies[L],V.resolveOk(A)}_receiveReplyErr(D,m,A){this._logger&&this._logger.logIncoming(D,m,0,"receiveReplyErr:",A);const L=String(m);if(!this._pendingRPCReplies.hasOwnProperty(L))return;const V=this._pendingRPCReplies[L];delete this._pendingRPCReplies[L];let G;A&&(A.$isError?(G=new Error,G.name=A.name,G.message=A.message,G.stack=A.stack):G=A),V.resolveErr(G)}_invokeHandler(D,m,A){try{return Promise.resolve(this._doInvokeHandler(D,m,A))}catch(L){return Promise.reject(L)}}_doInvokeHandler(D,m,A){const L=this._locals[D];if(!L)throw new Error("Unknown actor "+(0,t.getStringIdentifierForProxy)(D));let V=L[m];if(typeof V!="function")throw new Error("Unknown method "+m+" on actor "+(0,t.getStringIdentifierForProxy)(D));return V.apply(L,A)}_remoteCall(D,m,A){if(this._isDisposed)return Promise.reject(R.canceled());let L=null;if(A.length>0&&b.CancellationToken.isCancellationToken(A[A.length-1])&&(L=A.pop()),L&&L.isCancellationRequested)return Promise.reject(R.canceled());const V=p.serializeRequestArguments(A,this._uriReplacer),G=++this._lastMessageId,U=String(G),K=new I.LazyPromise;L&&L.onCancellationRequested(()=>{const B=p.serializeCancel(G);this._logger&&this._logger.logOutgoing(B.byteLength,G,0,"cancel"),this._protocol.send(p.serializeCancel(G))}),this._pendingRPCReplies[U]=K,this._onWillSendRequest(G);const $=p.serializeRequest(G,D,m,V,!!L);return this._logger&&this._logger.logOutgoing($.byteLength,G,0,`request: ${(0,t.getStringIdentifierForProxy)(D)}.${m}(`,A),this._protocol.send($),K}}e.RPCProtocol=s,E=v,s.UNRESPONSIVE_TIME=3*1e3;class l{constructor(D,m){this._buff=D,this._offset=m}static alloc(D,m,A){let L=new l(M.VSBuffer.alloc(A+1+4),0);return L.writeUInt8(D),L.writeUInt32(m),L}static read(D,m){return new l(D,m)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(D){this._buff.writeUInt8(D,this._offset),this._offset+=1}readUInt8(){const D=this._buff.readUInt8(this._offset);return this._offset+=1,D}writeUInt32(D){this._buff.writeUInt32BE(D,this._offset),this._offset+=4}readUInt32(){const D=this._buff.readUInt32BE(this._offset);return this._offset+=4,D}static sizeShortString(D){return 1+D.byteLength}writeShortString(D){this._buff.writeUInt8(D.byteLength,this._offset),this._offset+=1,this._buff.set(D,this._offset),this._offset+=D.byteLength}readShortString(){const D=this._buff.readUInt8(this._offset);this._offset+=1;const A=this._buff.slice(this._offset,this._offset+D).toString();return this._offset+=D,A}static sizeLongString(D){return 4+D.byteLength}writeLongString(D){this._buff.writeUInt32BE(D.byteLength,this._offset),this._offset+=4,this._buff.set(D,this._offset),this._offset+=D.byteLength}readLongString(){const D=this._buff.readUInt32BE(this._offset);this._offset+=4;const A=this._buff.slice(this._offset,this._offset+D).toString();return this._offset+=D,A}writeBuffer(D){this._buff.writeUInt32BE(D.byteLength,this._offset),this._offset+=4,this._buff.set(D,this._offset),this._offset+=D.byteLength}static sizeVSBuffer(D){return 4+D.byteLength}writeVSBuffer(D){this._buff.writeUInt32BE(D.byteLength,this._offset),this._offset+=4,this._buff.set(D,this._offset),this._offset+=D.byteLength}readVSBuffer(){const D=this._buff.readUInt32BE(this._offset);this._offset+=4;const m=this._buff.slice(this._offset,this._offset+D);return this._offset+=D,m}static sizeMixedArray(D){let m=0;m+=1;for(let A=0,L=D.length;A<L;A++){const V=D[A];switch(m+=1,V.type){case 1:m+=this.sizeLongString(V.value);break;case 2:m+=this.sizeVSBuffer(V.value);break;case 3:m+=this.sizeUInt32,m+=this.sizeLongString(V.value);for(let G=0;G<V.buffers.length;++G)m+=this.sizeVSBuffer(V.buffers[G]);break;case 4:break}}return m}writeMixedArray(D){this._buff.writeUInt8(D.length,this._offset),this._offset+=1;for(let m=0,A=D.length;m<A;m++){const L=D[m];switch(L.type){case 1:this.writeUInt8(1),this.writeLongString(L.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(L.value);break;case 3:this.writeUInt8(3),this.writeUInt32(L.buffers.length),this.writeLongString(L.value);for(let V=0;V<L.buffers.length;++V)this.writeBuffer(L.buffers[V]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const D=this._buff.readUInt8(this._offset);this._offset+=1;let m=new Array(D);for(let A=0;A<D;A++)switch(this.readUInt8()){case 1:m[A]=this.readLongString();break;case 2:m[A]=this.readVSBuffer();break;case 3:const V=this.readUInt32(),G=this.readLongString(),U=[];for(let K=0;K<V;++K)U.push(this.readVSBuffer());m[A]=new t.SerializableObjectWithBuffers(T(G,U,null));break;case 4:m[A]=void 0;break}return m}}l.sizeUInt32=4;var h;(function(g){g[g.Simple=0]="Simple",g[g.Mixed=1]="Mixed"})(h||(h={}));class p{static _useMixedArgSerialization(D){for(let m=0,A=D.length;m<A;m++)if(D[m]instanceof M.VSBuffer||D[m]instanceof t.SerializableObjectWithBuffers||typeof D[m]=="undefined")return!0;return!1}static serializeRequestArguments(D,m){if(this._useMixedArgSerialization(D)){const A=[];for(let L=0,V=D.length;L<V;L++){const G=D[L];if(G instanceof M.VSBuffer)A[L]={type:2,value:G};else if(typeof G=="undefined")A[L]={type:4};else if(G instanceof t.SerializableObjectWithBuffers){const{jsonString:U,referencedBuffers:K}=w(G.value,m);A[L]={type:3,value:M.VSBuffer.fromString(U),buffers:K}}else A[L]={type:1,value:M.VSBuffer.fromString(S(G,m))}}return{type:1,args:A}}return{type:0,args:S(D,m)}}static serializeRequest(D,m,A,L,V){switch(L.type){case 0:return this._requestJSONArgs(D,m,A,L.args,V);case 1:return this._requestMixedArgs(D,m,A,L.args,V)}}static _requestJSONArgs(D,m,A,L,V){const G=M.VSBuffer.fromString(A),U=M.VSBuffer.fromString(L);let K=0;K+=l.sizeUInt8(),K+=l.sizeShortString(G),K+=l.sizeLongString(U);let $=l.alloc(V?2:1,D,K);return $.writeUInt8(m),$.writeShortString(G),$.writeLongString(U),$.buffer}static deserializeRequestJSONArgs(D){const m=D.readUInt8(),A=D.readShortString(),L=D.readLongString();return{rpcId:m,method:A,args:JSON.parse(L)}}static _requestMixedArgs(D,m,A,L,V){const G=M.VSBuffer.fromString(A);let U=0;U+=l.sizeUInt8(),U+=l.sizeShortString(G),U+=l.sizeMixedArray(L);let K=l.alloc(V?4:3,D,U);return K.writeUInt8(m),K.writeShortString(G),K.writeMixedArray(L),K.buffer}static deserializeRequestMixedArgs(D){const m=D.readUInt8(),A=D.readShortString(),L=D.readMixedArray(),V=new Array(L.length);for(let G=0,U=L.length;G<U;G++){const K=L[G];typeof K=="string"?V[G]=JSON.parse(K):V[G]=K}return{rpcId:m,method:A,args:V}}static serializeAcknowledged(D){return l.alloc(5,D,0).buffer}static serializeCancel(D){return l.alloc(6,D,0).buffer}static serializeReplyOK(D,m,A){if(typeof m=="undefined")return this._serializeReplyOKEmpty(D);if(m instanceof M.VSBuffer)return this._serializeReplyOKVSBuffer(D,m);if(m instanceof t.SerializableObjectWithBuffers){const{jsonString:L,referencedBuffers:V}=w(m.value,A,!0);return this._serializeReplyOKJSONWithBuffers(D,L,V)}else return this._serializeReplyOKJSON(D,n(m,A))}static _serializeReplyOKEmpty(D){return l.alloc(7,D,0).buffer}static _serializeReplyOKVSBuffer(D,m){let A=0;A+=l.sizeVSBuffer(m);let L=l.alloc(8,D,A);return L.writeVSBuffer(m),L.buffer}static deserializeReplyOKVSBuffer(D){return D.readVSBuffer()}static _serializeReplyOKJSON(D,m){const A=M.VSBuffer.fromString(m);let L=0;L+=l.sizeLongString(A);let V=l.alloc(9,D,L);return V.writeLongString(A),V.buffer}static _serializeReplyOKJSONWithBuffers(D,m,A){const L=M.VSBuffer.fromString(m);let V=0;V+=l.sizeUInt32,V+=l.sizeLongString(L);for(const U of A)V+=l.sizeVSBuffer(U);let G=l.alloc(10,D,V);G.writeUInt32(A.length),G.writeLongString(L);for(const U of A)G.writeBuffer(U);return G.buffer}static deserializeReplyOKJSON(D){const m=D.readLongString();return JSON.parse(m)}static deserializeReplyOKJSONWithBuffers(D,m){const A=D.readUInt32(),L=D.readLongString(),V=[];for(let G=0;G<A;++G)V.push(D.readVSBuffer());return new t.SerializableObjectWithBuffers(T(L,V,m))}static serializeReplyErr(D,m){return m?this._serializeReplyErrEror(D,m):this._serializeReplyErrEmpty(D)}static _serializeReplyErrEror(D,m){const A=M.VSBuffer.fromString(n(R.transformErrorForSerialization(m),null));let L=0;L+=l.sizeLongString(A);let V=l.alloc(11,D,L);return V.writeLongString(A),V.buffer}static deserializeReplyErrError(D){const m=D.readLongString();return JSON.parse(m)}static _serializeReplyErrEmpty(D){return l.alloc(12,D,0).buffer}}var k;(function(g){g[g.RequestJSONArgs=1]="RequestJSONArgs",g[g.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",g[g.RequestMixedArgs=3]="RequestMixedArgs",g[g.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",g[g.Acknowledged=5]="Acknowledged",g[g.Cancel=6]="Cancel",g[g.ReplyOKEmpty=7]="ReplyOKEmpty",g[g.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",g[g.ReplyOKJSON=9]="ReplyOKJSON",g[g.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",g[g.ReplyErrError=11]="ReplyErrError",g[g.ReplyErrEmpty=12]="ReplyErrEmpty"})(k||(k={}));var P;(function(g){g[g.String=1]="String",g[g.VSBuffer=2]="VSBuffer",g[g.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",g[g.Undefined=4]="Undefined"})(P||(P={}))}),define(be[213],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const d=function(R){const F=C=>{self.removeEventListener("message",F);const _=C.data;Object.defineProperties(self,{postMessage:{value(I,t){_.postMessage(I,t)}},onmessage:{get(){return _.onmessage},set(I){_.onmessage=I}}}),_.addEventListener("message",I=>{self.dispatchEvent(new MessageEvent("message",{data:I.data}))}),_.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(R)};self.addEventListener("message",F)}.toString();class M extends EventTarget{constructor(R,F,C){super();this.onmessage=null,this.onmessageerror=null,this.onerror=null;const _=`((${d})('${F}'))`,I=new Blob([_],{type:"application/javascript"}),t=URL.createObjectURL(I),E=new MessageChannel,n=t,c={type:"_newWorker",id:n,port:E.port2,url:t,options:C};R(c,[E.port2]),this.postMessage=E.port1.postMessage.bind(E.port1),this.terminate=()=>{const u={type:"_terminateWorker",id:n};E.port1.postMessage(u),URL.revokeObjectURL(t),E.port1.close(),E.port2.close()},Object.defineProperties(this,{onmessage:{get(){return E.port1.onmessage},set(u){E.port1.onmessage=u}},onmessageerror:{get(){return E.port1.onmessageerror},set(u){E.port1.onmessageerror=u}}}),E.port1.addEventListener("messageerror",u=>{const a=new MessageEvent("messageerror",{data:u.data});this.dispatchEvent(a)}),E.port1.addEventListener("message",u=>{const a=new MessageEvent("message",{data:u.data});this.dispatchEvent(a)}),E.port1.start()}}e.NestedWorker=M}),define(be[214],Ee([0,1,4]),function(re,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,d.createDecorator)("remoteAgentService")}),define(be[215],Ee([0,1,11,17,26,2,4,86,47,175,214]),function(re,e,d,M,b,R,F,C,_,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,F.createDecorator)("pathService");let E=class $i{constructor(c,u,a,w){this.localUserHome=c,this.remoteAgentService=u,this.environmentService=a,this.contextService=w,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||b.OS)(),this.resolveUserHome=(async()=>{const T=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=T?.userHome||c})()}get defaultUriScheme(){return $i.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(c,u){if(c.remoteAuthority)return d.Schemas.vscodeRemote;const a=(0,C.getVirtualWorkspaceScheme)(u.getWorkspace());if(a)return a;const w=u.getWorkspace().folders[0];if(w)return w.uri.scheme;const T=u.getWorkspace().configuration;return T?T.scheme:d.Schemas.file}async userHome(c){return c?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(c=>c===1?M.win32:M.posix)}async fileURI(c){let u="";if(await this.resolveOS===1&&(c=c.replace(/\\/g,"/")),c[0]==="/"&&c[1]==="/"){const w=c.indexOf("/",2);w===-1?(u=c.substring(2),c="/"):(u=c.substring(2,w),c=c.substring(w)||"/")}return R.URI.from({scheme:d.Schemas.file,authority:u,path:c,query:"",fragment:""})}};E=We([ze(1,t.IRemoteAgentService),ze(2,I.IWorkbenchEnvironmentService),ze(3,_.IWorkspaceContextService)],E),e.AbstractPathService=E}),define(be[98],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class d{constructor(F,C){this.line=F,this.character=C}isBefore(F){return!1}isBeforeOrEqual(F){return!1}isAfter(F){return!1}isAfterOrEqual(F){return!1}isEqual(F){return!1}compareTo(F){return 0}translate(F,C){return new d(0,0)}with(F){return new d(0,0)}}e.Position=d;class M{constructor(F,C,_,I){this.isEmpty=!1,this.isSingleLine=!1,this.start=new d(F,C),this.end=new d(_,I)}contains(F){return!1}isEqual(F){return!1}intersection(F){}union(F){return new M(0,0,0,0)}with(F){return new M(0,0,0,0)}}e.Range=M;var b;(function(R){R[R.Information=1]="Information",R[R.Warning=2]="Warning"})(b=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(be[41],Ee([0,1,12,27,23,43,9,4,17,16,98,10]),function(re,e,d,M,b,R,F,C,_,I,t,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return t.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const n="\u27EA ",c=" characters skipped \u27EB",u=(n.length+c.length+5)*2;e.ISearchService=(0,C.createDecorator)("searchService");var a;(function(B){B[B.file=0]="file",B[B.text=1]="text"})(a=e.SearchProviderType||(e.SearchProviderType={}));var w;(function(B){B[B.File=1]="File",B[B.Text=2]="Text"})(w=e.QueryType||(e.QueryType={}));function T(B){return!!B.preview}e.resultIsMatch=T;function S(B){return!!B.resource}e.isFileMatch=S;function o(B){return!!B.message}e.isProgressMessage=o;var f;(function(B){B[B.Normal=0]="Normal",B[B.NewSearchStarted=1]="NewSearchStarted"})(f=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class y{constructor(z){this.resource=z,this.results=[]}}e.FileMatch=y;class i{constructor(z,Y,ne){this.ranges=Y;const j=Array.isArray(Y)?Y:[Y];if(ne&&ne.matchLines===1&&v(j)){z=(0,F.getNLines)(z,ne.matchLines);let le="",se=0,ve=0;const Fe=Math.floor(ne.charsPerLine/5),Me=[];for(const Ne of j){const Ye=Math.max(Ne.startColumn-Fe,0),Ve=Ne.startColumn+ne.charsPerLine;if(Ye>ve+Fe+u){const qe=n+(Ye-ve)+c;le+=qe+z.slice(Ye,Ve),se+=Ye-(ve+qe.length)}else le+=z.slice(ve,Ve);Me.push(new s(0,Ne.startColumn-se,Ne.endColumn-se)),ve=Ve}this.preview={text:le,matches:Array.isArray(this.ranges)?Me:Me[0]}}else{const le=Array.isArray(Y)?Y[0].startLineNumber:Y.startLineNumber;this.preview={text:z,matches:(0,d.mapArrayOrNot)(Y,se=>new r(se.startLineNumber-le,se.startColumn,se.endLineNumber-le,se.endColumn))}}}}e.TextSearchMatch=i;function v(B){const z=B[0].startLineNumber;for(const Y of B)if(Y.startLineNumber!==z||Y.endLineNumber!==z)return!1;return!0}class r{constructor(z,Y,ne,j){this.startLineNumber=z,this.startColumn=Y,this.endLineNumber=ne,this.endColumn=j}}e.SearchRange=r;class s extends r{constructor(z,Y,ne){super(z,Y,z,ne)}}e.OneLineRange=s;var l;(function(B){B.Default="default",B.FileNames="fileNames",B.Type="type",B.Modified="modified",B.CountDescending="countDescending",B.CountAscending="countAscending"})(l=e.SearchSortOrder||(e.SearchSortOrder={}));function h(B,z=!0){const Y=B&&B.files&&B.files.exclude,ne=z&&B&&B.search&&B.search.exclude;if(!Y&&!ne)return;if(!Y||!ne)return Y||ne;let j=Object.create(null);return j=b.mixin(j,b.deepClone(Y)),j=b.mixin(j,b.deepClone(ne),!0),j}e.getExcludes=h;function p(B,z){return B.excludePattern&&M.match(B.excludePattern,z)?!1:B.includePattern||B.usingSearchPaths?B.includePattern&&M.match(B.includePattern,z)?!0:B.usingSearchPaths?!!B.folderQueries&&B.folderQueries.some(Y=>{const ne=Y.folder.fsPath;if(R.isEqualOrParent(z,ne)){const j=_.relative(ne,z);return!Y.includePattern||!!M.match(Y.includePattern,j)}else return!1}):!1:!0}e.pathIncludedInQuery=p;var k;(function(B){B[B.unknownEncoding=1]="unknownEncoding",B[B.regexParseError=2]="regexParseError",B[B.globParseError=3]="globParseError",B[B.invalidLiteral=4]="invalidLiteral",B[B.rgProcessError=5]="rgProcessError",B[B.other=6]="other",B[B.canceled=7]="canceled"})(k=e.SearchErrorCode||(e.SearchErrorCode={}));class P extends Error{constructor(z,Y){super(z);this.code=Y}}e.SearchError=P;function g(B){const z=B.message;if((0,I.isPromiseCanceledError)(B))return new P(z,k.canceled);try{const Y=JSON.parse(z);return new P(Y.message,Y.code)}catch(Y){return new P(z,k.other)}}e.deserializeSearchError=g;function D(B){const z={message:B.message,code:B.code};return new Error(JSON.stringify(z))}e.serializeSearchError=D;function m(B){return B.type==="error"?!0:B.type==="success"}e.isSerializedSearchComplete=m;function A(B){return B.type==="success"}e.isSerializedSearchSuccess=A;function L(B){return!!B.path}e.isSerializedFileMatch=L;function V(B,z){const Y=B.searchPath?B.searchPath:B.relativePath;return(0,F.fuzzyContains)(Y,z)}e.isFilePatternMatch=V;class G{constructor(z){this.path=z,this.results=[]}addMatch(z){this.results.push(z)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=G;function U(B,z){const Y={...B||{},...z||{}};return Object.keys(Y).filter(ne=>{const j=Y[ne];return typeof j=="boolean"&&j})}e.resolvePatternsForProvider=U;class K{constructor(z,Y){this._parsedIncludeExpression=null,this._excludeExpression={...z.excludePattern||{},...Y.excludePattern||{}},this._parsedExcludeExpression=M.parse(this._excludeExpression);let ne=z.includePattern;Y.includePattern&&(ne?ne={...ne,...Y.includePattern}:ne=Y.includePattern),ne&&(this._parsedIncludeExpression=M.parse(ne))}includedInQuerySync(z,Y,ne){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(z,Y,ne)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(z,Y,ne))}includedInQuery(z,Y,ne){const j=this._parsedExcludeExpression(z,Y,ne),le=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(z,Y,ne):!0;return(0,E.isPromise)(j)?j.then(se=>se?!1:le()):le()}hasSiblingExcludeClauses(){return $(this._excludeExpression)}}e.QueryGlobTester=K;function $(B){for(const z in B)if(typeof B[z]!="boolean")return!0;return!1}}),define(be[31],Ee([0,1,12,14,21,3,20,11,75,24,9,10,2,130,4,15,145,47,37,29,13,7,41,5]),function(re,e,d,M,b,R,F,C,_,I,t,E,n,c,u,a,w,T,S,o,f,y,i,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function r(D,m,A){return new I.ExtUri(L=>p(L,A)).isEqual(D,m)}function s(D,m,A){return r(D.uri,m.uri,A)?0:(0,t.compare)(D.uri.toString(),m.uri.toString())}function l(D,m,A){return D.index!==m.index?D.index<m.index?-1:1:r(D.uri,m.uri,A)?(0,t.compare)(D.name,m.name):(0,t.compare)(D.uri.toString(),m.uri.toString())}function h(D,m,A,L){const V=D.slice(0).sort((U,K)=>A(U,K,L)),G=m.slice(0).sort((U,K)=>A(U,K,L));return(0,d.delta)(V,G,(U,K)=>A(U,K,L))}function p(D,m){const A=m.getCapabilities(D.scheme);return!(A&&A&1024)}class k extends T.Workspace{constructor(m,A,L,V,G,U){super(m,L.map(K=>new T.WorkspaceFolder(K)),V,U);this._name=A,this._isUntitled=G,this._workspaceFolders=[],this._structure=F.TernarySearchTree.forUris(U),L.forEach(K=>{this._workspaceFolders.push(K),this._structure.set(K.uri,K)})}static toExtHostWorkspace(m,A,L,V){if(!m)return{workspace:null,added:[],removed:[]};const{id:G,name:U,folders:K,configuration:$,isUntitled:B}=m,z=[],Y=A;A?K.forEach((se,ve)=>{const Fe=n.URI.revive(se.uri),Me=k._findFolder(L||A,Fe,V);Me?(Me.name=se.name,Me.index=se.index,z.push(Me)):z.push({uri:Fe,name:se.name,index:ve})}):z.push(...K.map(({uri:se,name:ve,index:Fe})=>({uri:n.URI.revive(se),name:ve,index:Fe}))),z.sort((se,ve)=>se.index<ve.index?-1:1);const ne=new k(G,U,z,$?n.URI.revive($):null,!!B,se=>p(se,V)),{added:j,removed:le}=h(Y?Y.workspaceFolders:[],ne.workspaceFolders,s,V);return{workspace:ne,added:j,removed:le}}static _findFolder(m,A,L){for(let V=0;V<m.folders.length;V++){const G=m.workspaceFolders[V];if(r(G.uri,A,L))return G}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(m,A){return A&&this._structure.get(m)&&(m=(0,I.dirname)(m)),this._structure.findSubstr(m)}resolveWorkspaceFolder(m){return this._structure.get(m)}}let P=class{constructor(m,A,L,V){this._onDidChangeWorkspace=new R.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new R.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=V,this._extHostFileSystemInfo=L,this._requestIdProvider=new _.Counter,this._barrier=new M.Barrier,this._proxy=m.getProxy(v.MainContext.MainThreadWorkspace),this._messageService=m.getProxy(v.MainContext.MainThreadMessageService);const G=A.workspace;this._confirmedWorkspace=G?new k(G.id,G.name,[],G.configuration?n.URI.revive(G.configuration):null,!!G.isUntitled,U=>p(U,L)):void 0}$initializeWorkspace(m,A){this._trusted=A,this.$acceptWorkspaceData(m),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?n.URI.from({scheme:C.Schemas.untitled,path:(0,I.basename)((0,I.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(m,A,L,...V){const G=[];if(Array.isArray(V)&&V.forEach(z=>{n.URI.isUri(z.uri)&&!G.some(Y=>r(Y.uri,z.uri,this._extHostFileSystemInfo))&&G.push({uri:z.uri,name:z.name||(0,I.basenameOrAuthority)(z.uri)})}),this._unconfirmedWorkspace||[A,L].some(z=>typeof z!="number"||z<0)||L===0&&G.length===0)return!1;const U=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(A+L>U.length)return!1;const K=U.slice(0);K.splice(A,L,...G.map(z=>({uri:z.uri,name:z.name||(0,I.basenameOrAuthority)(z.uri),index:void 0})));for(let z=0;z<K.length;z++){const Y=K[z];if(K.some((ne,j)=>j!==z&&r(Y.uri,ne.uri,this._extHostFileSystemInfo)))return!1}K.forEach((z,Y)=>z.index=Y);const{added:$,removed:B}=h(U,K,l,this._extHostFileSystemInfo);if($.length===0&&B.length===0)return!1;if(this._proxy){const z=m.displayName||m.name;this._proxy.$updateWorkspaceFolders(z,A,L,G).then(void 0,Y=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(w.Severity.Error,(0,c.localize)(0,null,z,Y.toString()),{extension:m},[])})}return this.trySetWorkspaceFolders(K),!0}getWorkspaceFolder(m,A){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(m,A)}async getWorkspaceFolder2(m,A){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(m,A)}async resolveWorkspaceFolder(m){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(m)}getPath(){if(!this._actualWorkspace)return;const{folders:m}=this._actualWorkspace;if(m.length!==0)return m[0].uri.fsPath}getRelativePath(m,A){let L,V="";if(typeof m=="string"?(L=n.URI.file(m),V=m):typeof m!="undefined"&&(L=m,V=m.fsPath),!L)return V;const G=this.getWorkspaceFolder(L,!0);if(!G)return V;typeof A=="undefined"&&this._actualWorkspace&&(A=this._actualWorkspace.folders.length>1);let U=(0,I.relativePath)(G.uri,L);return A&&G.name&&(U=`${G.name}/${U}`),U}trySetWorkspaceFolders(m){this._actualWorkspace&&(this._unconfirmedWorkspace=k.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:m,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(m){const{workspace:A,added:L,removed:V}=k.toExtHostWorkspace(m,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=A||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:L,removed:V}))}findFiles(m,A,L,V,G=b.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${V.value}, entryPoint: findFiles`);let U;if(A===null?U=!1:A&&(typeof A=="string"?U=A:U=A.pattern),G&&G.isCancellationRequested)return Promise.resolve([]);const{includePattern:K,folder:$}=g(m);return this._proxy.$startFileSearch((0,E.withUndefinedAsNull)(K),(0,E.withUndefinedAsNull)($),(0,E.withUndefinedAsNull)(U),(0,E.withUndefinedAsNull)(L),G).then(B=>Array.isArray(B)?B.map(z=>n.URI.revive(z)):[])}async findTextInFiles(m,A,L,V,G=b.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${V.value}, entryPoint: findTextInFiles`);const U=this._requestIdProvider.getNext(),K=typeof A.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:A.previewOptions,{includePattern:$,folder:B}=g(A.include),z=typeof A.exclude=="string"?A.exclude:A.exclude?A.exclude.pattern:void 0,Y={ignoreSymlinks:typeof A.followSymlinks=="boolean"?!A.followSymlinks:void 0,disregardIgnoreFiles:typeof A.useIgnoreFiles=="boolean"?!A.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof A.useGlobalIgnoreFiles=="boolean"?!A.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof A.useDefaultExcludes=="boolean"?!A.useDefaultExcludes:!0,fileEncoding:A.encoding,maxResults:A.maxResults,previewOptions:K,afterContext:A.afterContext,beforeContext:A.beforeContext,includePattern:$,excludePattern:z},ne=!1;if(this._activeSearchCallbacks[U]=j=>{if(ne)return;const le=n.URI.revive(j.resource);j.results.forEach(se=>{(0,i.resultIsMatch)(se)?L({uri:le,preview:{text:se.preview.text,matches:(0,d.mapArrayOrNot)(se.preview.matches,ve=>new y.Range(ve.startLineNumber,ve.startColumn,ve.endLineNumber,ve.endColumn))},ranges:(0,d.mapArrayOrNot)(se.ranges,ve=>new y.Range(ve.startLineNumber,ve.startColumn,ve.endLineNumber,ve.endColumn))}):L({uri:le,text:se.text,lineNumber:se.lineNumber})})},G.isCancellationRequested)return{};try{const j=await this._proxy.$startTextSearch(m,(0,E.withUndefinedAsNull)(B),Y,U,G);return delete this._activeSearchCallbacks[U],j||{}}catch(j){throw delete this._activeSearchCallbacks[U],j}}$handleTextSearchResult(m,A){this._activeSearchCallbacks[A]&&this._activeSearchCallbacks[A](m)}saveAll(m){return this._proxy.$saveAll(m)}resolveProxy(m){return this._proxy.$resolveProxy(m)}get trusted(){return this._trusted}requestWorkspaceTrust(m){return this._proxy.$requestWorkspaceTrust(m)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};P=We([ze(0,f.IExtHostRpcService),ze(1,o.IExtHostInitDataService),ze(2,S.IExtHostFileSystemInfo),ze(3,a.ILogService)],P),e.ExtHostWorkspace=P,e.IExtHostWorkspace=(0,u.createDecorator)("IExtHostWorkspace");function g(D){let m,A;return D&&(typeof D=="string"?m=D:(m=D.pattern,A=D.baseFolder||n.URI.file(D.base))),{includePattern:m,folder:A}}}),define(be[32],Ee([0,1,23,3,31,5,7,148,62,10,14,4,13,15,2]),function(re,e,d,M,b,R,F,C,_,I,t,E,n,c,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function a(v,r){if(r){const s=r.split(".");let l=v;for(let h=0;l&&h<s.length;h++)l=l[s[h]];return l}}function w(v){return v instanceof u.URI}function T(v){return v&&v.uri instanceof u.URI&&v.languageId&&typeof v.languageId=="string"}function S(v){return v&&!v.uri&&v.languageId&&typeof v.languageId=="string"}function o(v){return v&&v.uri instanceof u.URI&&(!v.name||typeof v.name=="string")&&(!v.index||typeof v.index=="number")}function f(v){if(w(v))return{resource:v};if(T(v))return{resource:v.uri,overrideIdentifier:v.languageId};if(S(v))return{overrideIdentifier:v.languageId};if(o(v))return{resource:v.uri};if(v===null)return{resource:null}}let y=class{constructor(r,s,l){this._proxy=r.getProxy(R.MainContext.MainThreadConfiguration),this._extHostWorkspace=s,this._logService=l,this._barrier=new t.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(r=>this._actual)}$initializeConfiguration(r){this._actual=new i(this._proxy,this._extHostWorkspace,r,this._logService),this._barrier.open()}$acceptConfigurationChanged(r,s){this.getConfigProvider().then(l=>l.$acceptConfigurationChanged(r,s))}};y=We([ze(0,n.IExtHostRpcService),ze(1,b.IExtHostWorkspace),ze(2,c.ILogService)],y),e.ExtHostConfiguration=y;class i{constructor(r,s,l,h){this._onDidChangeConfiguration=new M.Emitter,this._proxy=r,this._logService=h,this._extHostWorkspace=s,this._configuration=C.Configuration.parse(l),this._configurationScopes=this._toMap(l.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(r,s){const l={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=C.Configuration.parse(r),this._configurationScopes=this._toMap(r.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(s,l))}getConfiguration(r,s,l){const h=f(s)||{},p=this._toReadonlyValue(r?a(this._configuration.getValue(void 0,h,this._extHostWorkspace.workspace),r):this._configuration.getValue(void 0,h,this._extHostWorkspace.workspace));r&&this._validateConfigurationAccess(r,h,l?.identifier);function k(g){if(g==null)return null;if(typeof g=="boolean")return g?1:4;switch(g){case F.ConfigurationTarget.Global:return 1;case F.ConfigurationTarget.Workspace:return 4;case F.ConfigurationTarget.WorkspaceFolder:return 5}}const P={has(g){return typeof a(p,g)!="undefined"},get:(g,D)=>{this._validateConfigurationAccess(r?`${r}.${g}`:g,h,l?.identifier);let m=a(p,g);if(typeof m=="undefined")m=D;else{let A;const L=(V,G)=>{let U;const K=()=>{A=A||(0,d.deepClone)(p),U=U||a(A,G)};return(0,I.isObject)(V)?new Proxy(V,{get:($,B)=>{if(typeof B=="string"&&B.toLowerCase()==="tojson")return K(),()=>U;if(A)return U=U||a(A,G),U[B];const z=$[B];return typeof B=="string"?L(z,`${G}.${B}`):z},set:($,B,z)=>(K(),U&&(U[B]=z),!0),deleteProperty:($,B)=>(K(),U&&delete U[B],!0),defineProperty:($,B,z)=>(K(),U&&Object.defineProperty(U,B,z),!0)}):V};m=L(m,g)}return m},update:(g,D,m,A)=>{g=r?`${r}.${g}`:g;const L=k(m);return D!==void 0?this._proxy.$updateConfigurationOption(L,g,D,h,A):this._proxy.$removeConfigurationOption(L,g,h,A)},inspect:g=>{g=r?`${r}.${g}`:g;const D=(0,d.deepClone)(this._configuration.inspect(g,h,this._extHostWorkspace.workspace));if(D)return{key:g,defaultValue:D.default?.value,globalValue:D.user?.value,workspaceValue:D.workspace?.value,workspaceFolderValue:D.workspaceFolder?.value,defaultLanguageValue:D.default?.override,globalLanguageValue:D.user?.override,workspaceLanguageValue:D.workspace?.override,workspaceFolderLanguageValue:D.workspaceFolder?.override,languageIds:D.overrideIdentifiers}}};return typeof p=="object"&&(0,d.mixin)(P,p,!1),Object.freeze(P)}_toReadonlyValue(r){const s=l=>(0,I.isObject)(l)?new Proxy(l,{get:(h,p)=>s(h[p]),set:(h,p,k)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(p)}' of object`)},deleteProperty:(h,p)=>{throw new Error(`TypeError: Cannot delete read only property '${String(p)}' of object`)},defineProperty:(h,p)=>{throw new Error(`TypeError: Cannot define property '${String(p)}' for a readonly object`)},setPrototypeOf:h=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):l;return s(r)}_validateConfigurationAccess(r,s,l){const h=_.OVERRIDE_PROPERTY_PATTERN.test(r)?4:this._configurationScopes.get(r),p=l?`[${l.value}] `:"";if(h===4){typeof s?.resource=="undefined"&&this._logService.warn(`${p}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${r}', provide the URI of a resource or 'null' for any resource.`);return}if(h===3){s?.resource&&this._logService.warn(`${p}Accessing a window scoped configuration for a resource is not expected. To associate '${r}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(r,s){const l=new C.ConfigurationChangeEvent(r,s,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(h,p)=>l.affectsConfiguration(h,f(p))})}_toMap(r){return r.reduce((s,l)=>(s.set(l[0],l[1]),s),new Map)}}e.ExtHostConfigProvider=i,e.IExtHostConfiguration=(0,E.createDecorator)("IExtHostConfiguration")});var Ze=this&&this.__classPrivateFieldSet||function(re,e,d,M,b){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!b:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?b.call(re,d):b?b.value=d:e.set(re,d),d},Ae=this&&this.__classPrivateFieldGet||function(re,e,d,M){if(d==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?M:d==="a"?M.call(re):M?M.value:e.get(re)};define(be[99],Ee([0,1,2,14,3,5,7,31,49,32,21,40,13,29,4,11,26,15,70,165,16]),function(re,e,d,M,b,R,F,C,_,I,t,E,n,c,u,a,w,T,S,o,f){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var i;(function(G){function U($){if($!=null)return $}G.from=U;function K($){if($!=null)return $}G.to=K})(i=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var v;(function(G){function U($){if($!=null)return $}G.from=U;function K($){if($!=null)return $}G.to=K})(v=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var r;(function(G){function U($){if($!=null)return $}G.from=U;function K($){if($!=null)return $}G.to=K})(r=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var s;(function(G){function U(B){if(B){const z=B;return z&&!!z.process}else return!1}G.is=U;function K(B){if(B==null)return;const z={process:B.process,args:B.args};return B.options&&(z.options=r.from(B.options)),z}G.from=K;function $(B){if(B!=null)return new F.ProcessExecution(B.process,B.args,B.options)}G.to=$})(s=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var l;(function(G){function U($){if($!=null)return $}G.from=U;function K($){if($!=null)return $}G.to=K})(l=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var h;(function(G){function U(B){if(B){const z=B;return z&&(!!z.commandLine||!!z.command)}else return!1}G.is=U;function K(B){if(B==null)return;const z={};return B.commandLine!==void 0?z.commandLine=B.commandLine:(z.command=B.command,z.args=B.args),B.options&&(z.options=l.from(B.options)),z}G.from=K;function $(B){if(!(B==null||B.command===void 0&&B.commandLine===void 0))return B.commandLine?new F.ShellExecution(B.commandLine,B.options):new F.ShellExecution(B.command,B.args?B.args:[],B.options)}G.to=$})(h=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var p;(function(G){function U(B){if(B){let z=B;return z&&z.customExecution==="customExecution"}else return!1}G.is=U;function K(B){return{customExecution:"customExecution"}}G.from=K;function $(B,z){return z.get(B)}G.to=$})(p=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var k;(function(G){function U(K,$){let B;return K.scope!==void 0&&typeof K.scope!="number"?B=K.scope.uri:K.scope!==void 0&&typeof K.scope=="number"&&(K.scope===F.TaskScope.Workspace&&$&&$.workspaceFile?B=$.workspaceFile:B=o.USER_TASKS_GROUP_KEY),{id:K._id,workspaceFolder:B}}G.from=U})(k=e.TaskHandleDTO||(e.TaskHandleDTO={}));var P;(function(G){function U(K){if(K!=null)return{_id:K.id,isDefault:K.isDefault}}G.from=U})(P=e.TaskGroupDTO||(e.TaskGroupDTO={}));var g;(function(G){function U(B,z){if(B==null)return[];const Y=[];for(let ne of B){const j=K(ne,z);j&&Y.push(j)}return Y}G.fromMany=U;function K(B,z){if(B==null)return;let Y;B.execution instanceof F.ProcessExecution?Y=s.from(B.execution):B.execution instanceof F.ShellExecution?Y=h.from(B.execution):B.execution&&B.execution instanceof F.CustomExecution&&(Y=p.from(B.execution));const ne=i.from(B.definition);let j;return B.scope?typeof B.scope=="number"?j=B.scope:j=B.scope.uri:j=F.TaskScope.Workspace,!ne||!j?void 0:{_id:B._id,definition:ne,name:B.name,source:{extensionId:z.identifier.value,label:B.source,scope:j},execution:Y,isBackground:B.isBackground,group:P.from(B.group),presentationOptions:v.from(B.presentationOptions),problemMatchers:B.problemMatchers,hasDefinedMatchers:B.hasDefinedMatchers,runOptions:B.runOptions?B.runOptions:{reevaluateOnRerun:!0},detail:B.detail}}G.from=K;async function $(B,z,Y){if(B==null)return;let ne;s.is(B.execution)?ne=s.to(B.execution):h.is(B.execution)?ne=h.to(B.execution):p.is(B.execution)&&(ne=p.to(B._id,Y));const j=i.to(B.definition);let le;if(B.source&&(B.source.scope!==void 0?typeof B.source.scope=="number"?le=B.source.scope:le=await z.resolveWorkspaceFolder(d.URI.revive(B.source.scope)):le=F.TaskScope.Workspace),!j||!le)return;const se=new F.Task(j,le,B.name,B.source.label,ne,B.problemMatchers);return B.isBackground!==void 0&&(se.isBackground=B.isBackground),B.group!==void 0&&(se.group=F.TaskGroup.from(B.group._id),se.group&&(se.group=new F.TaskGroup(se.group.id,se.group.label),B.group.isDefault&&(se.group.isDefault=B.group.isDefault))),B.presentationOptions&&(se.presentationOptions=v.to(B.presentationOptions)),B._id&&(se._id=B._id),B.detail&&(se.detail=B.detail),se}G.to=$})(g=e.TaskDTO||(e.TaskDTO={}));var D;(function(G){function U($){return $}G.from=U;function K($){if(!!$)return Object.assign(Object.create(null),$)}G.to=K})(D=e.TaskFilterDTO||(e.TaskFilterDTO={}));class m{constructor(U,K,$){this._id=K,this._task=$,y.set(this,void 0),Ze(this,y,U,"f")}get task(){return this._task}terminate(){Ae(this,y,"f").terminateTask(this)}fireDidStartProcess(U){}fireDidEndProcess(U){}}y=new WeakMap;var A;(function(G){function U(K){return{id:K._id,task:void 0}}G.from=U})(A=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let L=class{constructor(U,K,$,B,z,Y,ne,j){this._onDidExecuteTask=new b.Emitter,this._onDidTerminateTask=new b.Emitter,this._onDidTaskProcessStarted=new b.Emitter,this._onDidTaskProcessEnded=new b.Emitter,this._proxy=U.getProxy(R.MainContext.MainThreadTask),this._workspaceProvider=$,this._editorService=B,this._configurationService=z,this._terminalService=Y,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=ne,this._deprecationService=j,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(U,K,$){if(!$)return new F.Disposable(()=>{});const B=this.nextHandle();return this._handlers.set(B,{type:K,provider:$,extension:U}),this._proxy.$registerTaskProvider(B,K),new F.Disposable(()=>{this._handlers.delete(B),this._proxy.$unregisterTaskProvider(B)})}registerTaskSystem(U,K){this._proxy.$registerTaskSystem(U,K)}fetchTasks(U){return this._proxy.$fetchTasks(D.from(U)).then(async K=>{const $=[];for(let B of K){const z=await g.to(B,this._workspaceProvider,this._providedCustomExecutions2);z&&$.push(z)}return $})}get taskExecutions(){const U=[];return this._taskExecutions.forEach(K=>U.push(K)),U}terminateTask(U){if(!(U instanceof m))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(U._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(U,K,$){const B=this._providedCustomExecutions2.get(U.id);if(B){if(this._activeCustomExecutions2.get(U.id)!==void 0)throw new Error("We should not be trying to start the same custom task executions twice.");this._activeCustomExecutions2.set(U.id,B),this._terminalService.attachPtyToTerminal(K,await B.callback($))}this._lastStartedTask=U.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(U)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(U){const K=await this.getTaskExecution(U);this._taskExecutionPromises.delete(U.id),this._taskExecutions.delete(U.id),this.customExecutionComplete(U),this._onDidTerminateTask.fire({execution:K})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(U){const K=await this.getTaskExecution(U.id);this._onDidTaskProcessStarted.fire({execution:K,processId:U.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(U){const K=await this.getTaskExecution(U.id);this._onDidTaskProcessEnded.fire({execution:K,exitCode:U.exitCode})}$provideTasks(U,K){const $=this._handlers.get(U);if(!$)return Promise.reject(new Error("no handler found"));const B=[],z=(0,M.asPromise)(()=>$.provider.provideTasks(t.CancellationToken.None)).then(Y=>this.provideTasksInternal(K,B,$,Y));return new Promise(Y=>{z.then(ne=>{Promise.all(B).then(()=>{Y(ne)})})})}async $resolveTask(U,K){const $=this._handlers.get(U);if(!$)return Promise.reject(new Error("no handler found"));if(K.definition.type!==$.type)throw new Error(`Unexpected: Task of type [${K.definition.type}] cannot be resolved by provider of type [${$.type}].`);const B=await g.to(K,this._workspaceProvider,this._providedCustomExecutions2);if(!B)throw new Error("Unexpected: Task cannot be resolved.");const z=await $.provider.resolveTask(B,t.CancellationToken.None);if(!z)return;this.checkDeprecation(z,$);const Y=g.from(z,$.extension);if(!Y)throw new Error("Unexpected: Task cannot be resolved.");if(z.definition!==B.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return p.is(Y.execution)&&await this.addCustomExecution(Y,z,!0),await this.resolveTaskInternal(Y)}nextHandle(){return this._handleCounter++}async addCustomExecution(U,K,$){const B=await this._proxy.$createTaskId(U);!$&&!this._providedCustomExecutions2.has(B)&&this._notProvidedCustomExecutions.add(B),this._providedCustomExecutions2.set(B,K.execution)}async getTaskExecution(U,K){if(typeof U=="string"){const z=this._taskExecutionPromises.get(U);if(!z)throw new Error("Unexpected: The specified task is missing an execution");return z}let $=this._taskExecutionPromises.get(U.id);if($)return $;const B=new Promise(async(z,Y)=>{const ne=K||await g.to(U.task,this._workspaceProvider,this._providedCustomExecutions2);ne?z(new m(this,U.id,ne)):Y("Unexpected: Task does not exist.")});return this._taskExecutionPromises.set(U.id,B),B.then(z=>(this._taskExecutions.set(U.id,z),z),z=>Promise.reject(z))}checkDeprecation(U,K){U._deprecated&&this._deprecationService.report("Task.constructor",K.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(U){this._activeCustomExecutions2.get(U.id)&&this._activeCustomExecutions2.delete(U.id),this._notProvidedCustomExecutions.has(U.id)&&this._lastStartedTask!==U.id&&(this._providedCustomExecutions2.delete(U.id),this._notProvidedCustomExecutions.delete(U.id));let $=this._notProvidedCustomExecutions.values(),B=$.next();for(;!B.done;)!this._activeCustomExecutions2.has(B.value)&&this._lastStartedTask!==B.value&&(this._providedCustomExecutions2.delete(B.value),this._notProvidedCustomExecutions.delete(B.value)),B=$.next()}};L=We([ze(0,n.IExtHostRpcService),ze(1,c.IExtHostInitDataService),ze(2,C.IExtHostWorkspace),ze(3,_.IExtHostDocumentsAndEditors),ze(4,I.IExtHostConfiguration),ze(5,E.IExtHostTerminalService),ze(6,T.ILogService),ze(7,S.IExtHostApiDeprecationService)],L),e.ExtHostTaskBase=L;let V=class extends L{constructor(U,K,$,B,z,Y,ne,j){super(U,K,$,B,z,Y,ne,j);this.registerTaskSystem(a.Schemas.vscodeRemote,{scheme:a.Schemas.vscodeRemote,authority:"",platform:w.PlatformToString(0)})}async executeTask(U,K){if(!K.execution)throw new Error("Tasks to execute must include an execution");const $=g.from(K,U);if($===void 0)throw new Error("Task is not valid");if(p.is($.execution))await this.addCustomExecution($,K,!1);else throw new f.NotSupportedError;const B=await this.getTaskExecution(await this._proxy.$getTaskExecution($),K);return this._proxy.$executeTask($).catch(z=>{throw new Error(z)}),B}provideTasksInternal(U,K,$,B){const z=[];if(B)for(let Y of B){this.checkDeprecation(Y,$),(!Y.definition||!U[Y.definition.type])&&this._logService.warn(`The task [${Y.source}, ${Y.name}] uses an undefined task type. The task will be ignored in the future.`);const ne=g.from(Y,$.extension);ne&&p.is(ne.execution)?(z.push(ne),K.push(this.addCustomExecution(ne,Y,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:z,extension:$.extension}}async resolveTaskInternal(U){if(p.is(U.execution))return U;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(U,K){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(U,K,$){}};V=We([ze(0,n.IExtHostRpcService),ze(1,c.IExtHostInitDataService),ze(2,C.IExtHostWorkspace),ze(3,_.IExtHostDocumentsAndEditors),ze(4,I.IExtHostConfiguration),ze(5,E.IExtHostTerminalService),ze(6,T.ILogService),ze(7,S.IExtHostApiDeprecationService)],V),e.WorkerExtHostTask=V,e.IExtHostTask=(0,u.createDecorator)("IExtHostTask")}),define(be[216],Ee([0,1,12,51,27,77,20,11,17,24,9,10,2,111,134,84,47,92,215,41]),function(re,e,d,M,b,R,F,C,_,I,t,E,n,c,u,a,w,T,S,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let f=class{constructor(k,P,g,D){this.configurationService=k,this.workspaceContextService=P,this.editorGroupsService=g,this.pathService=D}text(k,P,g={}){k=this.getContentPattern(k,g);const D=this.configurationService.getValue(),m=P&&P.some(L=>!this.configurationService.getValue({resource:L}).search.useRipgrep);return{...this.commonQuery(P?.map(w.toWorkspaceFolder),g),type:2,contentPattern:k,previewOptions:g.previewOptions,maxFileSize:g.maxFileSize,usePCRE2:D.search.usePCRE2||m||!1,beforeContext:g.beforeContext,afterContext:g.afterContext,userDisabledExcludesAndIgnoreFiles:g.disregardExcludeSettings&&g.disregardIgnoreFiles}}getContentPattern(k,P){const g=this.configurationService.getValue();k.isRegExp&&(k.pattern=k.pattern.replace(/\r?\n/g,"\\n"));const D={...k,wordSeparators:g.editor.wordSeparators};return this.isCaseSensitive(k,P)&&(D.isCaseSensitive=!0),this.isMultiline(k)&&(D.isMultiline=!0),D}file(k,P={}){return{...this.commonQuery(k,P),type:1,filePattern:P.filePattern?P.filePattern.trim():P.filePattern,exists:P.exists,sortByScore:P.sortByScore,cacheKey:P.cacheKey}}handleIncludeExclude(k,P){return k?(k=Array.isArray(k)?k.map(s):s(k),P?this.parseSearchPaths(k):{pattern:i(...Array.isArray(k)?k:[k])}):{}}commonQuery(k=[],P={}){const g=this.handleIncludeExclude(P.includePattern,P.expandPatterns),D=this.handleIncludeExclude(P.excludePattern,P.expandPatterns),m=k.length>1,A=(g.searchPaths&&g.searchPaths.length?g.searchPaths.map(G=>this.getFolderQueryForSearchPath(G,P,D)):k.map(G=>this.getFolderQueryForRoot(G,P,D,m))).filter(G=>!!G),L={_reason:P._reason,folderQueries:A,usingSearchPaths:!!(g.searchPaths&&g.searchPaths.length),extraFileResources:P.extraFileResources,excludePattern:D.pattern,includePattern:g.pattern,onlyOpenEditors:P.onlyOpenEditors,maxResults:P.maxResults};if(P.onlyOpenEditors){const U=d.coalesce(d.flatten(this.editorGroupsService.groups.map($=>$.editors.map(B=>B.resource)))).filter($=>(0,o.pathIncludedInQuery)(L,$.fsPath)),K=this.commonQueryFromFileList(U);return{...L,...K}}const V=P.extraFileResources&&P.extraFileResources.filter(G=>(0,o.pathIncludedInQuery)(L,G.fsPath));return L.extraFileResources=V&&V.length?V:void 0,L}commonQueryFromFileList(k){const P=[],g=new F.ResourceMap,D={};let m=!1;return k.forEach(A=>{if(A.scheme===C.Schemas.walkThrough)return;if((0,I.isAbsolutePath)(A)){const V=this.workspaceContextService.getWorkspaceFolder(A)?.uri??A.with({path:_.dirname(A.fsPath)});let G=g.get(V);G||(m=!0,G={folder:V,includePattern:{}},P.push(G),g.set(V,G));const U=_.relative(V.fsPath,A.fsPath);(0,E.assertIsDefined)(G.includePattern)[U.replace(/\\/g,"/")]=!0}else A.fsPath&&(m=!0,D[A.fsPath]=!0)}),{folderQueries:P,includePattern:D,usingSearchPaths:!0,excludePattern:m?void 0:{"**/*":!0}}}isCaseSensitive(k,P){if(P.isSmartCase){if(k.isRegExp){if(t.containsUppercaseCharacter(k.pattern,!0))return!0}else if(t.containsUppercaseCharacter(k.pattern))return!0}return!!k.isCaseSensitive}isMultiline(k){return k.isMultiline||k.isRegExp&&(0,c.isMultilineRegexSource)(k.pattern)||k.pattern.indexOf(`
`)>=0?!0:!!k.isMultiline}parseSearchPaths(k){const P=K=>_.isAbsolute(K)||/^\.\.?([\/\\]|$)/.test(K),D=(Array.isArray(k)?k:v(k)).map(K=>{const $=this.pathService.resolvedUserHome;return $?(0,R.untildify)(K,$.scheme===C.Schemas.file?$.fsPath:$.path):K}),m=M.groupBy(D,K=>P(K)?"searchPaths":"exprSegments"),A=(m.exprSegments||[]).map(K=>t.rtrim(K,"/")).map(K=>t.rtrim(K,"\\")).map(K=>(K[0]==="."&&(K="*"+K),r(K))),L={},V=this.expandSearchPathPatterns(m.searchPaths||[]);V&&V.length&&(L.searchPaths=V);const G=d.flatten(A),U=i(...G);return U&&(L.pattern=U),L}getExcludesForFolder(k,P){return P.disregardExcludeSettings?void 0:(0,o.getExcludes)(k,!P.disregardSearchExcludeSettings)}expandSearchPathPatterns(k){if(!k||!k.length)return[];const P=d.flatten(k.map(D=>{let{pathPortion:m,globPortion:A}=y(D);A&&(A=l(A));const L=this.expandOneSearchPath(m);return d.flatten(L.map(V=>this.resolveOneSearchPathPattern(V,A)))})),g=new Map;return P.forEach(D=>{const m=D.searchPath.toString(),A=g.get(m);A?D.pattern&&(A.pattern=A.pattern||{},A.pattern[D.pattern]=!0):g.set(m,{searchPath:D.searchPath,pattern:D.pattern?i(D.pattern):void 0})}),Array.from(g.values())}expandOneSearchPath(k){if(_.isAbsolute(k)){const P=this.workspaceContextService.getWorkspace().folders;return P[0]&&P[0].uri.scheme!==C.Schemas.file?[{searchPath:P[0].uri.with({path:k})}]:[{searchPath:n.URI.file(_.normalize(k))}]}if(this.workspaceContextService.getWorkbenchState()===2){const P=this.workspaceContextService.getWorkspace().folders[0].uri;if(k=s(k),k.startsWith("../")||k===".."){const D=_.posix.resolve(P.path,k);return[{searchPath:P.with({path:D})}]}const g=l(k);return[{searchPath:P,pattern:g}]}else{if(k==="./"||k===".\\")return[];{const P=k.replace(/^\.[\/\\]/,""),D=this.workspaceContextService.getWorkspace().folders.map(m=>{const A=P.match(new RegExp(`^${t.escapeRegExpCharacters(m.name)}(?:/(.*)|$)`));return A?{match:A,folder:m}:null}).filter(E.isDefined);if(D.length)return D.map(m=>{const A=m.match[1];return{searchPath:m.folder.uri,pattern:A&&l(A)}});{const m=k.match(/\.[\/\\](.+)[\/\\]?/),A=m?m[1]:k,L=u.localize(0,null,A);throw new Error(L)}}}}resolveOneSearchPathPattern(k,P){const g=k.pattern&&P?`${k.pattern}/${P}`:k.pattern||P,D=[{searchPath:k.searchPath,pattern:g}];return g&&!g.endsWith("**")&&D.push({searchPath:k.searchPath,pattern:g+"/**"}),D}getFolderQueryForSearchPath(k,P,g){const D=this.getFolderQueryForRoot((0,w.toWorkspaceFolder)(k.searchPath),P,g,!1);return D?{...D,includePattern:k.pattern}:null}getFolderQueryForRoot(k,P,g,D){let m;const A=n.URI.isUri(k)?k:k.uri;if(g.searchPaths){const K=g.searchPaths.filter($=>(0,I.isEqual)($.searchPath,A))[0];if(K&&!K.pattern)return null;K&&(m=K.pattern)}const L=this.configurationService.getValue({resource:A}),G={...this.getExcludesForFolder(L,P)||{},...m||{}},U=n.URI.isUri(k)?(0,I.basename)(k):k.name;return{folder:A,folderName:D?U:void 0,excludePattern:Object.keys(G).length>0?G:void 0,fileEncoding:L.files&&L.files.encoding,disregardIgnoreFiles:typeof P.disregardIgnoreFiles=="boolean"?P.disregardIgnoreFiles:!L.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof P.disregardGlobalIgnoreFiles=="boolean"?P.disregardGlobalIgnoreFiles:!L.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof P.ignoreSymlinks=="boolean"?P.ignoreSymlinks:!L.search.followSymlinks}}};f=We([ze(0,a.IConfigurationService),ze(1,w.IWorkspaceContextService),ze(2,T.IEditorGroupsService),ze(3,S.IPathService)],f),e.QueryBuilder=f;function y(p){const k=p.match(/[\*\{\}\(\)\[\]\?]/);if(k){const P=k.index,g=p.substr(0,P).match(/[/|\\][^/\\]*$/);if(g){let D=p.substr(0,g.index);return D.match(/[/\\]/)||(D+="/"),{pathPortion:D,globPortion:p.substr((g.index||0)+1)}}}return{pathPortion:p}}function i(...p){return p.length?p.reduce((k,P)=>(k[P]=!0,k),Object.create(null)):void 0}function v(p){return b.splitGlobAware(p,",").map(k=>k.trim()).filter(k=>!!k.length)}function r(p){return[`**/${p}/**`,`**/${p}`].map(P=>P.replace(/\*\*\/\*\*/g,"**"))}function s(p){return p.replace(/\\/g,"/")}function l(p){return s(p).replace(/^\.\//,"").replace(/\/+$/g,"")}function h(p,k){p=d.distinct(p,D=>D.toString());const P=[],g=k.getWorkspace();return p&&p.forEach(D=>{let m;if(k.getWorkbenchState()===2)m=(0,I.relativePath)(g.folders[0].uri,D),m&&m!=="."&&(m="./"+m);else{const A=k.getWorkspaceFolder(D);if(A){const L=A.name;if(g.folders.filter(G=>G.name===L).length===1){const G=(0,I.relativePath)(A.uri,D);G===""?m=`./${A.name}`:m=`./${A.name}/${G}`}else m=D.fsPath}}m&&P.push(m)}),P}e.resolveResourcesForSearchIncludes=h}),define(be[217],Ee([0,1,24,2,21,16,4,216,41,47]),function(re,e,d,M,b,R,F,C,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const t=7e3;function E(a,w){const T=w.activationEvents;if(!T)return Promise.resolve(void 0);const S=[],o=[];for(const s of T)if(/^workspaceContains:/.test(s)){const l=s.substr("workspaceContains:".length);l.indexOf("*")>=0||l.indexOf("?")>=0||a.forceUsingSearch?o.push(l):S.push(l)}if(S.length===0&&o.length===0)return Promise.resolve(void 0);let f;const y=new Promise((s,l)=>{f=s}),i=s=>f({activationEvent:s}),v=Promise.all(S.map(s=>n(a,s,i))).then(()=>{}),r=c(a,w.identifier,o,i);return Promise.all([v,r]).then(()=>{f(void 0)}),y}e.checkActivateWorkspaceContainsExtension=E;async function n(a,w,T){for(const S of a.folders)if(await a.exists(d.joinPath(M.URI.revive(S),w))){T(`workspaceContains:${w}`);return}}async function c(a,w,T,S){if(T.length===0)return Promise.resolve(void 0);const o=new b.CancellationTokenSource,f=a.checkExists(a.folders,T,o.token),y=setTimeout(async()=>{o.cancel(),S(`workspaceContainsTimeout:${T.join(",")}`)},t);let i=!1;try{i=await f}catch(v){R.isPromiseCanceledError(v)||R.onUnexpectedError(v)}o.dispose(),clearTimeout(y),i&&S(`workspaceContains:${T.join(",")}`)}function u(a,w,T,S){const o=a.get(F.IInstantiationService),f=a.get(_.ISearchService),i=o.createInstance(C.QueryBuilder).file(w.map(v=>(0,I.toWorkspaceFolder)(M.URI.revive(v))),{_reason:"checkExists",includePattern:T,exists:!0});return f.fileSearch(i,S).then(v=>!!v.limitHit,v=>R.isPromiseCanceledError(v)?!1:Promise.reject(v))}e.checkGlobFileExists=u});var Ze=this&&this.__classPrivateFieldSet||function(re,e,d,M,b){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!b:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?b.call(re,d):b?b.value=d:e.set(re,d),d},Ae=this&&this.__classPrivateFieldGet||function(re,e,d,M){if(d==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?M:d==="a"?M.call(re):M?M.value:e.get(re)};define(be[33],Ee([0,1,125,17,74,24,14,6,20,2,15,5,32,178,72,31,30,176,16,25,22,152,7,85,4,29,73,13,61,64,40,3,217,69,154]),function(re,e,d,M,b,R,F,C,_,I,t,E,n,c,u,a,w,T,S,o,f,y,i,v,r,s,l,h,p,k,P,g,D,m,A){"use strict";var L,V,G;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,r.createDecorator)("IHostUtils");let U=class Wi extends C.Disposable{constructor(z,Y,ne,j,le,se,ve,Fe,Me,Ne){super();this._onDidChangeRemoteConnectionData=this._register(new g.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=Y,this._extHostContext=ne,this._initData=ve,this._extHostWorkspace=j,this._extHostConfiguration=le,this._logService=se,this._extHostTunnelService=Me,this._extHostTerminalService=Ne,this._disposables=new C.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(E.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(E.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(E.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new F.Barrier,this._readyToStartExtensionHost=new F.Barrier,this._readyToRunExtensions=new F.Barrier,this._eagerExtensionsActivated=new F.Barrier,this._registry=new T.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new u.ExtHostStorage(this._extHostContext),this._secretState=new m.ExtHostSecretState(this._extHostContext),this._storagePath=Fe,this._instaService=z.createChild(new p.ServiceCollection([u.IExtHostStorage,this._storage],[m.IExtHostSecretState,this._secretState]));const Ye=new Set;this._initData.hostExtensions.forEach(Ve=>Ye.add(o.ExtensionIdentifier.toKey(Ve))),this._activator=new c.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(Ve,qe,x)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(Ve,S.transformErrorForSerialization(qe),x)},actualActivateExtension:async(Ve,qe)=>{if(Ye.has(o.ExtensionIdentifier.toKey(Ve)))return await this._mainThreadExtensionsProxy.$activateExtension(Ve,qe),new c.HostExtension;const x=this._registry.getExtensionDescription(Ve);return this._activateExtension(x,qe)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),b.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(z){S.onUnexpectedError(z)}}async deactivateAll(){this._storagePath.onWillDeactivateAll();let z=[];try{z=this._registry.getAllExtensionDescriptions().map(le=>le.identifier).filter(le=>this.isActivated(le)).map(le=>this._deactivate(le))}catch(Y){}await Promise.all(z)}isActivated(z){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(z):!1}_activateByEvent(z,Y){return this._activator.activateByEvent(z,Y)}_activateById(z,Y){return this._activator.activateById(z,Y)}activateByIdWithErrors(z,Y){return this._activateById(z,Y).then(()=>{const ne=this._activator.getActivatedExtension(z);if(ne.activationFailed)return Promise.reject(ne.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(z=>this._registry)}getExtensionExports(z){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(z).exports:null}getExtensionPathIndex(){if(!this._extensionPathIndex){const z=_.TernarySearchTree.forPaths(),Y=this._registry.getAllExtensionDescriptions().map(ne=>{if(!!this._getEntryPoint(ne))return this._hostUtils.realpath(ne.extensionLocation.fsPath).then(j=>z.set(I.URI.file(j).fsPath,ne))});this._extensionPathIndex=Promise.all(Y).then(()=>z)}return this._extensionPathIndex}_deactivate(z){let Y=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(z))return Y;const ne=this._activator.getActivatedExtension(z);if(!ne)return Y;try{typeof ne.module.deactivate=="function"&&(Y=Promise.resolve(ne.module.deactivate()).then(void 0,j=>(this._logService.error(j),Promise.resolve(void 0))))}catch(j){this._logService.error(j)}try{(0,C.dispose)(ne.subscriptions)}catch(j){this._logService.error(j)}return Y}async _activateExtension(z,Y){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(z.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(z.identifier),this._doActivateExtension(z,Y).then(ne=>{const j=ne.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(z.identifier,j.codeLoadingTime,j.activateCallTime,j.activateResolvedTime,Y),this._logExtensionActivationTimes(z,Y,"success",j),ne},ne=>{throw this._logExtensionActivationTimes(z,Y,"failure"),ne})}_logExtensionActivationTimes(z,Y,ne,j){const le=K(z,Y);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...le,...j||{},outcome:ne})}_doActivateExtension(z,Y){const ne=K(z,Y);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",ne);const j=this._getEntryPoint(z);if(!j)return Promise.resolve(new c.EmptyExtension(c.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${z.identifier.value} ${JSON.stringify(Y)}`),this._logService.flush();const le=new c.ExtensionActivationTimesBuilder(Y.startup);return Promise.all([this._loadCommonJSModule(z.identifier,(0,R.joinPath)(z.extensionLocation,j),le),this._loadExtensionContext(z)]).then(se=>(b.mark(`code/extHost/willActivateExtension/${z.identifier.value}`),Wi._callActivate(this._logService,z.identifier,se[0],se[1],le))).then(se=>(b.mark(`code/extHost/didActivateExtension/${z.identifier.value}`),se))}_loadExtensionContext(z){const Y=new y.ExtensionGlobalMemento(z,this._storage),ne=new y.ExtensionMemento(z.identifier.value,!1,this._storage),j=new A.ExtensionSecrets(z,this._secretState),le=z.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?i.ExtensionMode.Test:i.ExtensionMode.Development:i.ExtensionMode.Production,se=this._initData.remote.isRemote?i.ExtensionKind.Workspace:i.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${z.identifier.value}`),Promise.all([Y.whenReady,ne.whenReady,this._storagePath.whenReady]).then(()=>{const ve=this;let Fe;return Object.freeze({globalState:Y,workspaceState:ne,secrets:j,subscriptions:[],get extensionUri(){return z.extensionLocation},get extensionPath(){return z.extensionLocation.fsPath},asAbsolutePath(Me){return M.join(z.extensionLocation.fsPath,Me)},get storagePath(){return ve._storagePath.workspaceValue(z)?.fsPath},get globalStoragePath(){return ve._storagePath.globalValue(z).fsPath},get logPath(){return M.join(ve._initData.logsLocation.fsPath,z.identifier.value)},get logUri(){return I.URI.joinPath(ve._initData.logsLocation,z.identifier.value)},get storageUri(){return ve._storagePath.workspaceValue(z)},get globalStorageUri(){return ve._storagePath.globalValue(z)},get extensionMode(){return le},get extension(){return Fe===void 0&&(Fe=new $(ve,z.identifier,z,se)),Fe},get extensionRuntime(){return(0,w.checkProposedApiEnabled)(z),ve.extensionRuntime},get environmentVariableCollection(){return ve._extHostTerminalService.getEnvironmentVariableCollection(z)}})})}static _callActivate(z,Y,ne,j,le){return ne=ne||{activate:void 0,deactivate:void 0},this._callActivateOptional(z,Y,ne,j,le).then(se=>new c.ActivatedExtension(!1,null,le.build(),ne,se,j.subscriptions))}static _callActivateOptional(z,Y,ne,j,le){if(typeof ne.activate=="function")try{le.activateCallStart(),z.trace(`ExtensionService#_callActivateOptional ${Y.value}`);const se=typeof global=="object"?global:self,ve=ne.activate.apply(se,[j]);return le.activateCallStop(),le.activateResolveStart(),Promise.resolve(ve).then(Fe=>(le.activateResolveStop(),Fe))}catch(se){return Promise.reject(se)}else return Promise.resolve(ne)}_activateOneStartupFinished(z,Y){this._activateById(z.identifier,{startup:!1,extensionId:z.identifier,activationEvent:Y}).then(void 0,ne=>{this._logService.error(ne)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(b.getMarks());for(const z of this._registry.getAllExtensionDescriptions())if(z.activationEvents)for(const Y of z.activationEvents)Y==="onStartupFinished"&&this._activateOneStartupFinished(z,Y)}_handleEagerExtensions(){const z=this._activateByEvent("*",!0).then(void 0,le=>{this._logService.error(le)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(le=>this._handleWorkspaceContainsEagerExtensions(le.added)));const Y=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],ne=this._handleWorkspaceContainsEagerExtensions(Y),j=Promise.all([z,ne]).then(()=>{});return Promise.race([j,(0,F.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),j}_handleWorkspaceContainsEagerExtensions(z){return z.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(Y=>this._handleWorkspaceContainsEagerExtension(z,Y))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(z,Y){if(this.isActivated(Y.identifier))return;const ne=!this._initData.remote.isRemote&&!!this._initData.remote.authority,j={folders:z.map(se=>se.uri),forceUsingSearch:ne,exists:se=>this._hostUtils.exists(se.fsPath),checkExists:(se,ve,Fe)=>this._mainThreadWorkspaceProxy.$checkExists(se,ve,Fe)},le=await(0,D.checkActivateWorkspaceContainsExtension)(j,Y);if(!!le)return this._activateById(Y.identifier,{startup:!0,extensionId:Y.identifier,activationEvent:le.activationEvent}).then(void 0,se=>this._logService.error(se))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(z){throw console.error(z),z}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:z,extensionTestsLocationURI:Y}=this._initData.environment;if(!z||!Y)throw new Error(d.localize(0,null));const ne=await this._loadCommonJSModule(null,Y,new c.ExtensionActivationTimesBuilder(!1));if(!ne||typeof ne.run!="function")throw new Error(d.localize(1,null,Y.toString()));return new Promise((j,le)=>{const se=(Me,Ne)=>{Me?le(Me):j(typeof Ne=="number"&&Ne>0?1:0)},ve=(0,R.originalFSPath)(Y),Fe=ne.run(ve,se);Fe&&Fe.then&&Fe.then(()=>{j(0)}).catch(Me=>{le(Me.toString())})})}async $extensionTestsExit(z){this._logService.info(`extension host terminating: test runner requested exit with code ${z}`),this._logService.info(`exiting with code ${z}`),this._logService.flush(),this._hostUtils.exit(z)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("eager extensions activated")})}registerRemoteAuthorityResolver(z,Y){return this._resolvers[z]=Y,(0,C.toDisposable)(()=>{delete this._resolvers[z]})}async _activateAndGetResolver(z){const Y=z.indexOf("+");if(Y===-1)throw new Error("Not an authority that can be resolved!");const ne=z.substr(0,Y);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${ne}`,!1),{authorityPrefix:ne,resolver:this._resolvers[ne]}}async $resolveAuthority(z,Y){const{authorityPrefix:ne,resolver:j}=await this._activateAndGetResolver(z);if(!j)return{type:"error",error:{code:v.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${ne}.`,detail:void 0}};try{this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions(j)),b.mark(`code/extHost/willResolveAuthority/${ne}`);const le=await j.resolve(z,{resolveAttempt:Y});b.mark(`code/extHost/didResolveAuthorityOK/${ne}`);const se={authority:z,host:le.host,port:le.port,connectionToken:le.connectionToken},ve={extensionHostEnv:le.extensionHostEnv,isTrusted:le.isTrusted};return{type:"ok",value:{authority:se,options:ve,tunnelInformation:{environmentTunnels:le.environmentTunnels}}}}catch(le){if(b.mark(`code/extHost/didResolveAuthorityError/${ne}`),le instanceof i.RemoteAuthorityResolverError)return{type:"error",error:{code:le._code,message:le._message,detail:le._detail}};throw le}}async $getCanonicalURI(z,Y){const{authorityPrefix:ne,resolver:j}=await this._activateAndGetResolver(z);if(!j)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${ne}`);const le=I.URI.revive(Y);if(typeof j.getCanonicalURI=="undefined")return le;const se=await(0,F.asPromise)(()=>j.getCanonicalURI(le));return se||le}$startExtensionHost(z){return this._registry.keepOnly(z),this._startExtensionHost()}$activateByEvent(z,Y){return Y===1?this._activateByEvent(z,!1):this._readyToRunExtensions.wait().then(ne=>this._activateByEvent(z,!1))}async $activate(z,Y){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(z)?(await this._activateById(z,Y),!0):!1}async $deltaExtensions(z,Y){z.forEach(j=>j.extensionLocation=I.URI.revive(j.extensionLocation));const ne=await this.getExtensionPathIndex();return await Promise.all(Y.map(async j=>{const le=this._registry.getExtensionDescription(j);if(!le)return;const se=await this._hostUtils.realpath(le.extensionLocation.fsPath);ne.delete(I.URI.file(se).fsPath)})),await Promise.all(z.map(async j=>{const le=await this._hostUtils.realpath(j.extensionLocation.fsPath);ne.set(I.URI.file(le).fsPath,j)})),this._registry.deltaExtensions(z,Y),Promise.resolve(void 0)}async $test_latency(z){return z}async $test_up(z){return z.byteLength}async $test_down(z){let Y=f.VSBuffer.alloc(z),ne=Math.random()%256;for(let j=0;j<z;j++)Y.writeUInt8(ne,j);return Y}async $updateRemoteConnectionData(z){this._remoteConnectionData=z,this._onDidChangeRemoteConnectionData.fire()}};U=We([ze(0,r.IInstantiationService),ze(1,e.IHostUtils),ze(2,h.IExtHostRpcService),ze(3,a.IExtHostWorkspace),ze(4,n.IExtHostConfiguration),ze(5,t.ILogService),ze(6,s.IExtHostInitDataService),ze(7,l.IExtensionStoragePaths),ze(8,k.IExtHostTunnelService),ze(9,P.IExtHostTerminalService)],U),e.AbstractExtHostExtensionService=U;function K(B,z){return{id:B.identifier.value,name:B.name,extensionVersion:B.version,publisherDisplayName:B.publisher,activationEvents:B.activationEvents?B.activationEvents.join(","):null,isBuiltin:B.isBuiltin,reason:z.activationEvent,reasonId:z.extensionId.value}}e.IExtHostExtensionService=(0,r.createDecorator)("IExtHostExtensionService");class ${constructor(z,Y,ne,j){L.set(this,void 0),V.set(this,void 0),G.set(this,void 0),Ze(this,L,z,"f"),Ze(this,V,Y,"f"),Ze(this,G,ne.identifier,"f"),this.id=ne.identifier.value,this.extensionUri=ne.extensionLocation,this.extensionPath=M.normalize((0,R.originalFSPath)(ne.extensionLocation)),this.packageJSON=ne,this.extensionKind=j}get isActive(){return Ae(this,L,"f").isActivated(Ae(this,G,"f"))}get exports(){if(this.packageJSON.api!=="none")return Ae(this,L,"f").getExtensionExports(Ae(this,G,"f"))}activate(){return Ae(this,L,"f").activateByIdWithErrors(Ae(this,G,"f"),{startup:!1,extensionId:Ae(this,V,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=$,L=new WeakMap,V=new WeakMap,G=new WeakMap}),define(be[100],Ee([0,1,17,2,3,14,5,7,162,31,33,49,167,32,163,13,4,10,91,68]),function(re,e,d,M,b,R,F,C,_,I,t,E,n,c,u,a,w,T,S,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,w.createDecorator)("IExtHostDebugService");let f=class{constructor(p,k,P,g,D,m){this._workspaceService=k,this._extensionService=P,this._editorsService=g,this._configurationService=D,this._editorTabs=m,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new b.Emitter,this._onDidTerminateDebugSession=new b.Emitter,this._onDidChangeActiveDebugSession=new b.Emitter,this._onDidReceiveDebugSessionCustomEvent=new b.Emitter,this._debugServiceProxy=p.getProxy(F.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new b.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new i(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(A=>{A.onDidChange(L=>{this.registerAllDebugTypes(A)}),this.registerAllDebugTypes(A)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(p,k){const P=p;if(typeof P.sourceReference=="number"&&P.sourceReference>0){let g=`debug:${encodeURIComponent(P.path||"")}`,D="?";return k&&(g+=`${D}session=${encodeURIComponent(k.id)}`,D="&"),g+=`${D}ref=${P.sourceReference}`,M.URI.parse(g)}else{if(P.path)return M.URI.file(P.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(p){const k=[];for(const P of p.getAllExtensionDescriptions())if(P.contributes){const g=P.contributes.debuggers;if(g&&g.length>0)for(const D of g)(0,u.isDebuggerMainContribution)(D)&&k.push(D.type)}this._debugServiceProxy.$registerDebugTypes(k)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const p=[];return this._breakpoints.forEach(k=>p.push(k)),p}addBreakpoints(p){this.startBreakpoints();const k=p.filter(D=>{const m=D.id;return this._breakpoints.has(m)?!1:(this._breakpoints.set(m,D),!0)});this.fireBreakpointChanges(k,[],[]);const P=[],g=new Map;for(const D of k)if(D instanceof C.SourceBreakpoint){let m=g.get(D.location.uri.toString());m||(m={type:"sourceMulti",uri:D.location.uri,lines:[]},g.set(D.location.uri.toString(),m),P.push(m)),m.lines.push({id:D.id,enabled:D.enabled,condition:D.condition,hitCondition:D.hitCondition,logMessage:D.logMessage,line:D.location.range.start.line,character:D.location.range.start.character})}else D instanceof C.FunctionBreakpoint&&P.push({type:"function",id:D.id,enabled:D.enabled,hitCondition:D.hitCondition,logMessage:D.logMessage,condition:D.condition,functionName:D.functionName});return this._debugServiceProxy.$registerBreakpoints(P)}removeBreakpoints(p){this.startBreakpoints();const k=p.filter(m=>this._breakpoints.delete(m.id));this.fireBreakpointChanges([],k,[]);const P=k.filter(m=>m instanceof C.SourceBreakpoint).map(m=>m.id),g=k.filter(m=>m instanceof C.FunctionBreakpoint).map(m=>m.id),D=k.filter(m=>m instanceof C.DataBreakpoint).map(m=>m.id);return this._debugServiceProxy.$unregisterBreakpoints(P,g,D)}startDebugging(p,k,P){return this._debugServiceProxy.$startDebugging(p?p.uri:void 0,k,{parentSessionID:P.parentSession?P.parentSession.id:void 0,lifecycleManagedByParent:P.lifecycleManagedByParent,repl:P.consoleMode===C.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:P.noDebug,compact:P.compact,debugUI:P.debugUI,suppressSaveBeforeStart:P.suppressSaveBeforeStart})}stopDebugging(p){return this._debugServiceProxy.$stopDebugging(p?p.id:void 0)}registerDebugConfigurationProvider(p,k,P){if(!k)return new C.Disposable(()=>{});const g=this._configProviderHandleCounter++;return this._configProviders.push({type:p,handle:g,provider:k}),this._debugServiceProxy.$registerDebugConfigurationProvider(p,P,!!k.provideDebugConfigurations,!!k.resolveDebugConfiguration,!!k.resolveDebugConfigurationWithSubstitutedVariables,g),new C.Disposable(()=>{this._configProviders=this._configProviders.filter(D=>D.provider!==k),this._debugServiceProxy.$unregisterDebugConfigurationProvider(g)})}registerDebugAdapterDescriptorFactory(p,k,P){if(!P)return new C.Disposable(()=>{});if(!this.definesDebugType(p,k))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${k}' debugger.`);if(this.getAdapterDescriptorFactoryByType(k))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const g=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:k,handle:g,factory:P}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(k,g),new C.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(D=>D.factory!==P),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(g)})}registerDebugAdapterTrackerFactory(p,k){if(!k)return new C.Disposable(()=>{});const P=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:p,handle:P,factory:k}),new C.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(g=>g.factory!==k)})}async $runInTerminal(p,k){return Promise.resolve(void 0)}async $substituteVariables(p,k){if(!this._variableResolver){const[D,m]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(D||[],this._editorsService,m)}let P;const g=await this.getFolder(p);return g&&(P={uri:g.uri,name:g.name,index:g.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(P,k)}createDebugAdapter(p,k){if(p.type==="implementation")return new s(p.implementation)}createSignService(){}async $startDASession(p,k){const P=this,g=await this.getSession(k);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(g.type),g).then(D=>{if(!D)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${g.type}' (extension might have failed to activate)`);const m=this.convertToDto(D),A=this.createDebugAdapter(m,g);if(!A)throw new Error(`Couldn't create a debug adapter for type '${g.type}'.`);const L=A;return this._debugAdapters.set(p,L),this.getDebugAdapterTrackers(g).then(V=>(V&&this._debugAdaptersTrackers.set(p,V),L.onMessage(async G=>{if(G.type==="request"&&G.command==="handshake"){const U=G,K={type:"response",seq:0,command:U.command,request_seq:U.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const $=await this._signService.sign(U.arguments.value);K.body={signature:$},L.sendResponse(K)}else throw new Error("no signer")}catch($){K.success=!1,K.message=$.message,L.sendResponse(K)}}else V&&V.onDidSendMessage&&V.onDidSendMessage(G),G=(0,u.convertToVSCPaths)(G,!0),P._debugServiceProxy.$acceptDAMessage(p,G)}),L.onError(G=>{V&&V.onError&&V.onError(G),this._debugServiceProxy.$acceptDAError(p,G.name,G.message,G.stack)}),L.onExit(G=>{V&&V.onExit&&V.onExit((0,T.withNullAsUndefined)(G),void 0),this._debugServiceProxy.$acceptDAExit(p,(0,T.withNullAsUndefined)(G),void 0)}),V&&V.onWillStartSession&&V.onWillStartSession(),L.startSession()))})}$sendDAMessage(p,k){k=(0,u.convertToDAPaths)(k,!1);const P=this._debugAdaptersTrackers.get(p);P&&P.onWillReceiveMessage&&P.onWillReceiveMessage(k);const g=this._debugAdapters.get(p);g&&g.sendMessage(k)}$stopDASession(p){const k=this._debugAdaptersTrackers.get(p);this._debugAdaptersTrackers.delete(p),k&&k.onWillStopSession&&k.onWillStopSession();const P=this._debugAdapters.get(p);return this._debugAdapters.delete(p),P?P.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(p){const k=[],P=[],g=[];if(p.added)for(const D of p.added){const m=D.id;if(m&&!this._breakpoints.has(m)){let A;if(D.type==="function")A=new C.FunctionBreakpoint(D.functionName,D.enabled,D.condition,D.hitCondition,D.logMessage);else if(D.type==="data")A=new C.DataBreakpoint(D.label,D.dataId,D.canPersist,D.enabled,D.hitCondition,D.condition,D.logMessage);else{const L=M.URI.revive(D.uri);A=new C.SourceBreakpoint(new C.Location(L,new C.Position(D.line,D.character)),D.enabled,D.condition,D.hitCondition,D.logMessage)}A._id=m,this._breakpoints.set(m,A),k.push(A)}}if(p.removed)for(const D of p.removed){const m=this._breakpoints.get(D);m&&(this._breakpoints.delete(D),P.push(m))}if(p.changed){for(const D of p.changed)if(D.id){const m=this._breakpoints.get(D.id);if(m){if(m instanceof C.FunctionBreakpoint&&D.type==="function"){const A=m;A.enabled=D.enabled,A.condition=D.condition,A.hitCondition=D.hitCondition,A.logMessage=D.logMessage,A.functionName=D.functionName}else if(m instanceof C.SourceBreakpoint&&D.type==="source"){const A=m;A.enabled=D.enabled,A.condition=D.condition,A.hitCondition=D.hitCondition,A.logMessage=D.logMessage,A.location=new C.Location(M.URI.revive(D.uri),new C.Position(D.line,D.character))}g.push(m)}}}this.fireBreakpointChanges(k,P,g)}$provideDebugConfigurations(p,k,P){return(0,R.asPromise)(async()=>{const g=this.getConfigProviderByHandle(p);if(!g)throw new Error("no DebugConfigurationProvider found");if(!g.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const D=await this.getFolder(k);return g.provideDebugConfigurations(D,P)}).then(g=>{if(!g)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return g})}$resolveDebugConfiguration(p,k,P,g){return(0,R.asPromise)(async()=>{const D=this.getConfigProviderByHandle(p);if(!D)throw new Error("no DebugConfigurationProvider found");if(!D.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const m=await this.getFolder(k);return D.resolveDebugConfiguration(m,P,g)})}$resolveDebugConfigurationWithSubstitutedVariables(p,k,P,g){return(0,R.asPromise)(async()=>{const D=this.getConfigProviderByHandle(p);if(!D)throw new Error("no DebugConfigurationProvider found");if(!D.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const m=await this.getFolder(k);return D.resolveDebugConfigurationWithSubstitutedVariables(m,P,g)})}async $provideDebugAdapter(p,k){const P=this.getAdapterDescriptorFactoryByHandle(p);if(!P)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const g=await this.getSession(k);return this.getAdapterDescriptor(P,g).then(D=>{if(!D)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${g.type}'`);return this.convertToDto(D)})}async $acceptDebugSessionStarted(p){const k=await this.getSession(p);this._onDidStartDebugSession.fire(k)}async $acceptDebugSessionTerminated(p){const k=await this.getSession(p);k&&(this._onDidTerminateDebugSession.fire(k),this._debugSessions.delete(k.id))}async $acceptDebugSessionActiveChanged(p){this._activeDebugSession=p?await this.getSession(p):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(p,k){const P=await this.getSession(p);P&&P._acceptNameChanged(k)}async $acceptDebugSessionCustomEvent(p,k){const g={session:await this.getSession(p),event:k.event,body:k.body};this._onDidReceiveDebugSessionCustomEvent.fire(g)}convertToDto(p){if(p instanceof C.DebugAdapterExecutable)return{type:"executable",command:p.command,args:p.args,options:p.options};if(p instanceof C.DebugAdapterServer)return{type:"server",port:p.port,host:p.host};if(p instanceof C.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:p.path};if(p instanceof C.DebugAdapterInlineImplementation)return{type:"implementation",implementation:p.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(p){const k=this._adapterFactories.filter(P=>P.type===p);if(k.length>0)return k[0].factory}getAdapterDescriptorFactoryByHandle(p){const k=this._adapterFactories.filter(P=>P.handle===p);if(k.length>0)return k[0].factory}getConfigProviderByHandle(p){const k=this._configProviders.filter(P=>P.handle===p);if(k.length>0)return k[0].provider}definesDebugType(p,k){if(p.contributes){const P=p.contributes.debuggers;if(P&&P.length>0){for(const g of P)if(g.label&&g.type&&g.type===k)return!0}}return!1}getDebugAdapterTrackers(p){const P=p.configuration.type,g=this._trackerFactories.filter(D=>D.type===P||D.type==="*").map(D=>(0,R.asPromise)(()=>D.factory.createDebugAdapterTracker(p)).then(m=>m,m=>null));return Promise.race([Promise.all(g).then(D=>{const m=D.filter(A=>!!A);if(m.length>0)return new r(m)}),new Promise((D,m)=>{const A=setTimeout(()=>{clearTimeout(A),m(new Error("timeout"))},1e3)})]).catch(D=>{})}async getAdapterDescriptor(p,k){const P=k.configuration.debugServer;if(typeof P=="number")return Promise.resolve(new C.DebugAdapterServer(P));if(p){const D=await this._extensionService.getExtensionRegistry();return(0,R.asPromise)(()=>p.createDebugAdapterDescriptor(k,this.daExecutableFromPackage(k,D))).then(m=>{if(m)return m})}const g=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(k,g))}daExecutableFromPackage(p,k){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(p,k,P){(p.length>0||k.length>0||P.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:p,removed:k,changed:P}))}async getSession(p){if(p)if(typeof p=="string"){const k=this._debugSessions.get(p);if(k)return k}else{let k=this._debugSessions.get(p.id);if(!k){const P=await this.getFolder(p.folderUri),g=p.parent?this._debugSessions.get(p.parent):void 0;k=new y(this._debugServiceProxy,p.id,p.type,p.name,P,p.configuration,g),this._debugSessions.set(k.id,k),this._debugServiceProxy.$sessionCached(k.id)}return k}throw new Error("cannot find session")}getFolder(p){if(p){const k=M.URI.revive(p);return this._workspaceService.resolveWorkspaceFolder(k)}return Promise.resolve(void 0)}};f=We([ze(0,a.IExtHostRpcService),ze(1,I.IExtHostWorkspace),ze(2,t.IExtHostExtensionService),ze(3,E.IExtHostDocumentsAndEditors),ze(4,c.IExtHostConfiguration),ze(5,o.IExtHostEditorTabs)],f),e.ExtHostDebugServiceBase=f;class y{constructor(p,k,P,g,D,m,A){this._debugServiceProxy=p,this._id=k,this._type=P,this._name=g,this._workspaceFolder=D,this._configuration=m,this._parentSession=A}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(p){this._name=p,this._debugServiceProxy.$setDebugSessionName(this._id,p)}get parentSession(){return this._parentSession}_acceptNameChanged(p){this._name=p}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(p,k){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,p,k)}getDebugProtocolBreakpoint(p){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,p.id)}}e.ExtHostDebugSession=y;class i{constructor(p){this.value=Object.freeze({append(k){p.$appendDebugConsole(k)},appendLine(k){this.append(k+`
`)}})}}e.ExtHostDebugConsole=i;class v extends n.AbstractVariableResolverService{constructor(p,k,P,g,D){function m(){if(k){const A=k.activeEditor();if(A)return A.document.uri;const L=g.tabs.filter(V=>V.isActive);if(L.length>0){const V=L[0].resource;return V&&(V.primary||V.secondary)?V.primary??V.secondary:L[0].resource}}}super({getFolderUri:A=>{const L=p.filter(V=>V.name===A);if(L&&L.length>0)return L[0].uri},getWorkspaceFolderCount:()=>p.length,getConfigurationValue:(A,L)=>P.getConfiguration(void 0,A).get(L),getAppRoot:()=>S.cwd(),getExecPath:()=>S.env.VSCODE_EXEC_PATH,getFilePath:()=>{const A=m();if(A)return d.normalize(A.fsPath)},getWorkspaceFolderPathForFile:()=>{if(D){const A=m();if(A){const L=D.getWorkspaceFolder(A);if(L)return d.normalize(L.uri.fsPath)}}},getSelectedText:()=>{if(k){const A=k.activeEditor();if(A&&!A.selection.isEmpty)return A.document.getText(A.selection)}},getLineNumber:()=>{if(k){const A=k.activeEditor();if(A)return String(A.selection.end.line+1)}}},void 0,Promise.resolve(S.env))}}e.ExtHostVariableResolverService=v;class r{constructor(p){this.trackers=p}onWillStartSession(){this.trackers.forEach(p=>p.onWillStartSession?p.onWillStartSession():void 0)}onWillReceiveMessage(p){this.trackers.forEach(k=>k.onWillReceiveMessage?k.onWillReceiveMessage(p):void 0)}onDidSendMessage(p){this.trackers.forEach(k=>k.onDidSendMessage?k.onDidSendMessage(p):void 0)}onWillStopSession(){this.trackers.forEach(p=>p.onWillStopSession?p.onWillStopSession():void 0)}onError(p){this.trackers.forEach(k=>k.onError?k.onError(p):void 0)}onExit(p,k){this.trackers.forEach(P=>P.onExit?P.onExit(p,k):void 0)}}class s extends _.AbstractDebugAdapter{constructor(p){super();this.implementation=p,p.onDidSendMessage(k=>{this.acceptMessage(k)})}startSession(){return Promise.resolve(void 0)}sendMessage(p){this.implementation.handleMessage(p)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let l=class extends f{constructor(p,k,P,g,D,m){super(p,k,P,g,D,m)}createVariableResolver(p,k,P){return new v(p,k,P,this._editorTabs)}};l=We([ze(0,a.IExtHostRpcService),ze(1,I.IExtHostWorkspace),ze(2,t.IExtHostExtensionService),ze(3,E.IExtHostDocumentsAndEditors),ze(4,c.IExtHostConfiguration),ze(5,o.IExtHostEditorTabs)],l),e.WorkerExtHostDebugService=l}),define(be[218],Ee([0,1,74,2,5,32,30,25,13,29,4,33,91,15]),function(re,e,d,M,b,R,F,C,_,I,t,E,n,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let u=class{constructor(o,f,y,i,v,r,s){this._apiFactory=o,this._extensionRegistry=f,this._instaService=y,this._extHostConfiguration=i,this._extHostExtensionService=v,this._initData=r,this._logService=s,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),d.mark("code/extHost/willWaitForConfig");const o=await this._extHostConfiguration.getConfigProvider();d.mark("code/extHost/didWaitForConfig");const f=await this._extHostExtensionService.getExtensionPathIndex();this.register(new a(this._apiFactory,f,this._extensionRegistry,o,this._logService)),this.register(this._instaService.createInstance(w)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(T,f,this._initData.environment.appUriScheme))}register(o){if(Array.isArray(o.nodeModuleName))for(let f of o.nodeModuleName)this._factories.set(f,o);else this._factories.set(o.nodeModuleName,o);typeof o.alternativeModuleName=="function"&&this._alternatives.push(f=>o.alternativeModuleName(f))}};u=We([ze(2,t.IInstantiationService),ze(3,R.IExtHostConfiguration),ze(4,E.IExtHostExtensionService),ze(5,I.IExtHostInitDataService),ze(6,c.ILogService)],u),e.RequireInterceptor=u;class a{constructor(o,f,y,i,v){this._apiFactory=o,this._extensionPaths=f,this._extensionRegistry=y,this._configProvider=i,this._logService=v,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(o,f){const y=this._extensionPaths.findSubstr(f.fsPath);if(y){let i=this._extApiImpl.get(C.ExtensionIdentifier.toKey(y.identifier));return i||(i=this._apiFactory(y,this._extensionRegistry,this._configProvider),this._extApiImpl.set(C.ExtensionIdentifier.toKey(y.identifier),i)),i}if(!this._defaultApiImpl){let i="";this._extensionPaths.forEach((v,r)=>i+=`	${r} -> ${v.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${f.fsPath}. These are the extension path mappings: 
${i}`),this._defaultApiImpl=this._apiFactory(F.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let w=class{constructor(o,f){this.nodeModuleName="keytar";const{environment:y}=f,i=o.getProxy(b.MainContext.MainThreadKeytar);if(y.appRoot){let v=y.appRoot.fsPath;n.platform==="win32"&&(v=v.replace(/\\/g,"/")),v[v.length-1]==="/"&&(v=v.substr(0,v.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${v}/node_modules.asar/keytar`),this.alternativeNames.add(`${v}/node_modules/keytar`)}this._impl={getPassword:(v,r)=>i.$getPassword(v,r),setPassword:(v,r,s)=>i.$setPassword(v,r,s),deletePassword:(v,r)=>i.$deletePassword(v,r),findPassword:v=>i.$findPassword(v),findCredentials(v){return i.$findCredentials(v)}}}load(o,f){return this._impl}alternativeModuleName(o){const f=o.length;if(f<=7||!this.alternativeNames)return;const y=f-7;if((o.charAt(y)==="/"||o.charAt(y)==="\\")&&o.endsWith("keytar")&&(o=o.replace(/\\/g,"/"),this.alternativeNames.has(o)))return"keytar"}};w=We([ze(0,_.IExtHostRpcService),ze(1,I.IExtHostInitDataService)],w);let T=class{constructor(o,f,y){this._extensionPaths=o,this._appUriScheme=f,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=y.getProxy(b.MainContext.MainThreadTelemetry);const i=y.getProxy(b.MainContext.MainThreadWindow);this._impl=(v,r)=>{const s=M.URI.parse(v);return r?this.callOriginal(v,r):s.scheme==="http"||s.scheme==="https"?i.$openUri(s,v,{allowTunneling:!0}):s.scheme==="mailto"||s.scheme===this._appUriScheme?i.$openUri(s,v,{}):this.callOriginal(v,r)}}load(o,f,y){const i=this._extensionPaths.findSubstr(f.fsPath);return i&&(this._extensionId=i.identifier.value,this.sendShimmingTelemetry()),this._original=y(o),this._impl}callOriginal(o,f){return this.sendNoForwardTelemetry(),this._original(o,f)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};T=We([ze(2,_.IExtHostRpcService)],T)}),define(be[219],Ee([0,1,14,16,74,6,2,5,212,15,57,61,29,144,13,65,33,40]),function(re,e,d,M,b,R,F,C,_,I,t,E,n,c,u,a,w,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class S{constructor(f,y,i,v){this._disposables=new R.DisposableStore,this._isTerminating=!1,this._hostUtils=i,this._rpcProtocol=new _.RPCProtocol(f,null,v),y=S._transform(y,this._rpcProtocol);const r=new E.ServiceCollection(...(0,t.getSingletonServiceDescriptors)());r.set(n.IExtHostInitDataService,{_serviceBrand:void 0,...y}),r.set(u.IExtHostRpcService,new u.ExtHostRpcService(this._rpcProtocol)),r.set(a.IURITransformerService,new a.URITransformerService(v)),r.set(w.IHostUtils,i);const s=new c.InstantiationService(r,!0),l=s.invokeFunction(P=>P.get(T.IExtHostTerminalService));this._disposables.add(l),this._logService=s.invokeFunction(P=>P.get(I.ILogService)),b.mark("code/extHost/didCreateServices"),this._logService.info("extension host started"),this._logService.trace("initData",y),this._extensionService=s.invokeFunction(P=>P.get(w.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const h=new WeakMap;this._extensionService.getExtensionPathIndex().then(P=>{Error.prepareStackTrace=(g,D)=>{let m="",A,L;for(const V of D)m+=`
	at ${V.toString()}`,L=V.getFileName(),!A&&L&&(A=P.findSubstr(L));return h.set(g,A),`${g.name||"Error"}: ${g.message||""}${m}`}});const p=this._rpcProtocol.getProxy(C.MainContext.MainThreadExtensionService),k=this._rpcProtocol.getProxy(C.MainContext.MainThreadErrors);M.setUnexpectedErrorHandler(P=>{const g=M.transformErrorForSerialization(P),D=h.get(P);D?p.$onExtensionRuntimeError(D.identifier,g):k.$onUnexpectedError(g)})}terminate(f){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${f}`),this._logService.flush(),this._disposables.dispose(),M.setUnexpectedErrorHandler(i=>{this._logService.error(i)}),this._rpcProtocol.dispose();const y=this._extensionService.deactivateAll();setTimeout(()=>{Promise.race([(0,d.timeout)(4e3),y]).finally(()=>{this._logService.info("exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})},1e3)}static _transform(f,y){f.extensions.forEach(v=>v.extensionLocation=F.URI.revive(y.transformIncomingURIs(v.extensionLocation))),f.environment.appRoot=F.URI.revive(y.transformIncomingURIs(f.environment.appRoot));const i=f.environment.extensionDevelopmentLocationURI;return i&&(f.environment.extensionDevelopmentLocationURI=i.map(v=>F.URI.revive(y.transformIncomingURIs(v)))),f.environment.extensionTestsLocationURI=F.URI.revive(y.transformIncomingURIs(f.environment.extensionTestsLocationURI)),f.environment.globalStorageHome=F.URI.revive(y.transformIncomingURIs(f.environment.globalStorageHome)),f.environment.workspaceStorageHome=F.URI.revive(y.transformIncomingURIs(f.environment.workspaceStorageHome)),f.logsLocation=F.URI.revive(y.transformIncomingURIs(f.logsLocation)),f.logFile=F.URI.revive(y.transformIncomingURIs(f.logFile)),f.workspace=y.transformIncomingURIs(f.workspace),f}}e.ExtensionHostMain=S}),define(be[220],Ee([0,1,17,21,56,27,24,193,41]),function(re,e,d,M,b,R,F,C,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class I{constructor(n,c,u){this.config=n,this.provider=c,this.sessionToken=u,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=n.filePattern,this.includePattern=n.includePattern&&R.parse(n.includePattern),this.maxResults=n.maxResults||void 0,this.exists=n.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=n.excludePattern&&R.parse(n.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(n=>n.cancel()),this.activeCancellationTokens=new Set}search(n){const c=this.config.folderQueries||[];return new Promise((u,a)=>{const w=T=>{this.resultCount++,n(T)};if(this.isCanceled)return u({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(T=>{const S=T.toString(),o=d.basename(S);this.globalExcludePattern&&this.globalExcludePattern(S,o)||this.matchFile(w,{base:T,basename:o})}),Promise.all(c.map(T=>this.searchInFolder(T,w))).then(T=>{u({limitHit:this.isLimitHit,stats:T[0]||void 0})},T=>{a(new Error((0,b.toErrorMessage)(T)))})})}async searchInFolder(n,c){const u=new M.CancellationTokenSource,a=this.getSearchOptionsForFolder(n),w=this.initDirectoryTree(),T=new _.QueryGlobTester(this.config,n),S=!T.hasSiblingExcludeClauses();let o;try{this.activeCancellationTokens.add(u),o=C.StopWatch.create();const f=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},a,u.token),y=o.elapsed(),i=C.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(f&&f.forEach(v=>{const r=d.posix.relative(n.folder.path,v.path);if(S){const s=d.basename(v.path);this.matchFile(c,{base:n.folder,relativePath:r,basename:s});return}this.addDirectoryEntries(w,n.folder,r,c)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(w,T,c),{providerTime:y,postProcessTime:i.elapsed()})}finally{u.dispose(),this.activeCancellationTokens.delete(u)}}getSearchOptionsForFolder(n){const c=(0,_.resolvePatternsForProvider)(this.config.includePattern,n.includePattern),u=(0,_.resolvePatternsForProvider)(this.config.excludePattern,n.excludePattern);return{folder:n.folder,excludes:u,includes:c,useIgnoreFiles:!n.disregardIgnoreFiles,useGlobalIgnoreFiles:!n.disregardGlobalIgnoreFiles,followSymlinks:!n.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const n={rootEntries:[],pathToEntries:Object.create(null)};return n.pathToEntries["."]=n.rootEntries,n}addDirectoryEntries({pathToEntries:n},c,u,a){if(u===this.filePattern){const T=d.basename(this.filePattern);this.matchFile(a,{base:c,relativePath:this.filePattern,basename:T})}function w(T){const S=d.basename(T),o=d.dirname(T);let f=n[o];f||(f=n[o]=[],w(o)),f.push({base:c,relativePath:T,basename:S})}w(u)}matchDirectoryTree({rootEntries:n,pathToEntries:c},u,a){const w=this,T=this.filePattern;function S(o){const f=R.hasSiblingFn(()=>o.map(y=>y.basename));for(let y=0,i=o.length;y<i;y++){const v=o[y],{relativePath:r,basename:s}=v;if(!u.includedInQuerySync(r,s,T!==s?f:void 0))continue;const l=c[r];if(l)S(l);else{if(r===T)continue;w.matchFile(a,v)}if(w.isLimitHit)break}}S(n)}matchFile(n,c){(!this.includePattern||c.relativePath&&this.includePattern(c.relativePath,c.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||n(c))}}class t{constructor(){this.sessions=new Map}fileSearch(n,c,u,a){const w=this.getSessionTokenSource(n.cacheKey),T=new I(n,c,w&&w.token);let S=0;const o=f=>{S+=f.length,u(f.map(y=>this.rawMatchToSearchItem(y)))};return this.doSearch(T,t.BATCH_SIZE,o,a).then(f=>({limitHit:f.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:S,detailStats:f.stats}}))}clearCache(n){const c=this.getSessionTokenSource(n);c&&c.cancel()}getSessionTokenSource(n){if(!!n)return this.sessions.has(n)||this.sessions.set(n,new M.CancellationTokenSource),this.sessions.get(n)}rawMatchToSearchItem(n){return n.relativePath?{resource:F.joinPath(n.base,n.relativePath)}:{resource:n.base}}doSearch(n,c,u,a){a.onCancellationRequested(()=>{n.cancel()});const w=S=>{S&&(T.push(S),c>0&&T.length>=c&&(u(T),T=[]))};let T=[];return n.search(w).then(S=>(T.length&&u(T),S),S=>(T.length&&u(T),Promise.reject(S)))}}e.FileSearchManager=t,t.BATCH_SIZE=512}),define(be[221],Ee([0,1,12,21,56,27,11,17,24,10,2,41]),function(re,e,d,M,b,R,F,C,_,I,t,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class n{constructor(o,f,y,i){this.query=o,this.provider=f,this.fileUtils=y,this.processType=i,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(o,f){const y=this.query.folderQueries||[],i=new M.CancellationTokenSource;return f.onCancellationRequested(()=>i.cancel()),new Promise((v,r)=>{this.collector=new u(o);let s=!1;const l=(h,p)=>{if(!s&&!this.isLimitHit){const k=this.resultSize(h);w(h)&&typeof this.query.maxResults=="number"&&this.resultCount+k>this.query.maxResults&&(this.isLimitHit=!0,s=!0,i.cancel(),h=this.trimResultToSize(h,this.query.maxResults-this.resultCount));const P=this.resultSize(h);this.resultCount+=P,(P>0||!w(h))&&this.collector.add(h,p)}};Promise.all(y.map((h,p)=>this.searchInFolder(h,k=>l(k,p),i.token))).then(h=>{i.dispose(),this.collector.flush();const p=h.some(k=>!!k&&!!k.limitHit);v({limitHit:this.isLimitHit||p,messages:(0,d.flatten)(h.map(k=>k?.message?(0,I.isArray)(k.message)?k.message:[k.message]:[])),stats:{type:this.processType}})},h=>{i.dispose();const p=(0,b.toErrorMessage)(h);r(new Error(p))})})}resultSize(o){return w(o)?Array.isArray(o.ranges)?o.ranges.length:1:0}trimResultToSize(o,f){const y=Array.isArray(o.ranges)?o.ranges:[o.ranges],i=Array.isArray(o.preview.matches)?o.preview.matches:[o.preview.matches];return{ranges:y.slice(0,f),preview:{matches:i.slice(0,f),text:o.preview.text},uri:o.uri}}async searchInFolder(o,f,y){const i=new E.QueryGlobTester(this.query,o),v=[],r={report:h=>{if(!this.validateProviderResult(h))return;const p=o.folder.scheme===F.Schemas.file?R.hasSiblingPromiseFn(()=>this.fileUtils.readdir(_.dirname(h.uri))):void 0,k=_.relativePath(o.folder,h.uri);if(k){const P=i.includedInQuery(k,C.basename(k),p);(0,I.isPromise)(P)?v.push(P.then(g=>{g&&f(h)})):P&&f(h)}}},s=this.getSearchOptionsForFolder(o),l=await this.provider.provideTextSearchResults(c(this.query.contentPattern),s,r,y);return v.length&&await Promise.all(v),l}validateProviderResult(o){if(w(o)){if(Array.isArray(o.ranges)){if(!Array.isArray(o.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(o.preview.matches.length!==o.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(o.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(o){const f=(0,E.resolvePatternsForProvider)(this.query.includePattern,o.includePattern),y=(0,E.resolvePatternsForProvider)(this.query.excludePattern,o.excludePattern),i={folder:t.URI.from(o.folder),excludes:y,includes:f,useIgnoreFiles:!o.disregardIgnoreFiles,useGlobalIgnoreFiles:!o.disregardGlobalIgnoreFiles,followSymlinks:!o.ignoreSymlinks,encoding:o.fileEncoding&&this.fileUtils.toCanonicalName(o.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return i.usePCRE2=this.query.usePCRE2,i}}e.TextSearchManager=n;function c(S){return{isCaseSensitive:S.isCaseSensitive||!1,isRegExp:S.isRegExp||!1,isWordMatch:S.isWordMatch||!1,isMultiline:S.isMultiline||!1,pattern:S.pattern}}class u{constructor(o){this._onResult=o,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new T(512,f=>this.sendItems(f))}add(o,f){this._currentFileMatch&&(this._currentFolderIdx!==f||!_.isEqual(this._currentUri,o.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=f,this._currentFileMatch={resource:o.uri,results:[]}),this._currentFileMatch.results.push(a(o))}pushToCollector(){const o=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,o)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(o){this._onResult(o)}}e.TextSearchResultsCollector=u;function a(S){return w(S)?{preview:{matches:(0,d.mapArrayOrNot)(S.preview.matches,o=>({startLineNumber:o.start.line,startColumn:o.start.character,endLineNumber:o.end.line,endColumn:o.end.character})),text:S.preview.text},ranges:(0,d.mapArrayOrNot)(S.ranges,o=>({startLineNumber:o.start.line,startColumn:o.start.character,endLineNumber:o.end.line,endColumn:o.end.character}))}:{text:S.text,lineNumber:S.lineNumber}}function w(S){return!!S.preview}e.extensionResultIsMatch=w;class T{constructor(o,f){this.maxBatchSize=o,this.cb=f,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(o,f){!o||this.addItemToBatch(o,f)}addItems(o,f){!o||this.addItemsToBatch(o,f)}addItemToBatch(o,f){this.batch.push(o),this.batchSize+=f,this.onUpdate()}addItemsToBatch(o,f){this.batch=this.batch.concat(o),this.batchSize+=f,this.onUpdate()}onUpdate(){this.totalNumberCompleted<T.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},T.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=T,T.TIMEOUT=4e3,T.START_BATCH_AFTER_COUNT=50}),define(be[101],Ee([0,1,6,5,4,220,13,65,15,2,221]),function(re,e,d,M,b,R,F,C,_,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,b.createDecorator)("IExtHostSearch");let E=class{constructor(a,w,T){this.extHostRpc=a,this._uriTransformer=w,this._logService=T,this._proxy=this.extHostRpc.getProxy(M.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new R.FileSearchManager}_transformScheme(a){return this._uriTransformer.transformOutgoingScheme(a)}registerTextSearchProvider(a,w){if(this._textSearchUsedSchemes.has(a))throw new Error(`a text search provider for the scheme '${a}' is already registered`);this._textSearchUsedSchemes.add(a);const T=this._handlePool++;return this._textSearchProvider.set(T,w),this._proxy.$registerTextSearchProvider(T,this._transformScheme(a)),(0,d.toDisposable)(()=>{this._textSearchUsedSchemes.delete(a),this._textSearchProvider.delete(T),this._proxy.$unregisterProvider(T)})}registerFileSearchProvider(a,w){if(this._fileSearchUsedSchemes.has(a))throw new Error(`a file search provider for the scheme '${a}' is already registered`);this._fileSearchUsedSchemes.add(a);const T=this._handlePool++;return this._fileSearchProvider.set(T,w),this._proxy.$registerFileSearchProvider(T,this._transformScheme(a)),(0,d.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(a),this._fileSearchProvider.delete(T),this._proxy.$unregisterProvider(T)})}$provideFileSearchResults(a,w,T,S){const o=n(T),f=this._fileSearchProvider.get(a);if(f)return this._fileSearchManager.fileSearch(o,f,y=>{this._proxy.$handleFileMatch(a,w,y.map(i=>i.resource))},S);throw new Error("unknown provider: "+a)}$clearCache(a){return this._fileSearchManager.clearCache(a),Promise.resolve(void 0)}$provideTextSearchResults(a,w,T,S){const o=this._textSearchProvider.get(a);if(!o||!o.provideTextSearchResults)throw new Error(`Unknown provider ${a}`);const f=n(T);return this.createTextSearchManager(f,o).search(i=>this._proxy.$handleTextMatch(a,w,i),S)}$enableExtensionHostSearch(){}createTextSearchManager(a,w){return new t.TextSearchManager(a,w,{readdir:T=>Promise.resolve([]),toCanonicalName:T=>T},"textSearchProvider")}};E=We([ze(0,F.IExtHostRpcService),ze(1,C.IURITransformerService),ze(2,_.ILogService)],E),e.ExtHostSearch=E;function n(u){return{...u,folderQueries:u.folderQueries&&u.folderQueries.map(c),extraFileResources:u.extraFileResources&&u.extraFileResources.map(a=>I.URI.revive(a))}}e.reviveQuery=n;function c(u){return{...u,folder:I.URI.revive(u.folder)}}}),define(be[222],Ee([0,1,21,16,3,35,2,117,79,113,55,60,5,183,182,39,184,32,185,186,187,169,188,49,33,189,170,192,194,195,96,172,200,201,202,72,40,204,173,8,7,207,50,97,31,30,51,159,191,86,95,99,100,101,15,65,13,29,196,156,64,70,180,205,155,73,71,210,208,209,181,37,203,206,69,68,87,198,98,199,11,146,197,153,190]),function(re,e,d,M,b,R,F,C,_,I,t,E,n,c,u,a,w,T,S,o,f,y,i,v,r,s,l,h,p,k,P,g,D,m,A,L,V,G,U,K,$,B,z,Y,ne,j,le,se,ve,Fe,Me,Ne,Ye,Ve,qe,x,Q,te,ae,q,oe,he,Te,Ue,He,Ke,ye,nt,H,X,fe,xe,Qe,rt,ct,ft,Pt,mt,St,Ct,pt,Xe,_t,Pe,Se){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function De(ee){const ue=ee.get(te.IExtHostInitDataService),pe=ee.get(xe.IExtHostFileSystemInfo),me=ee.get(ye.IExtHostConsumerFileSystem),Ie=ee.get(r.IExtHostExtensionService),Be=ee.get(ne.IExtHostWorkspace),Oe=ee.get(Pt.IExtHostTelemetry),je=ee.get(T.IExtHostConfiguration),et=ee.get(x.IURITransformerService),Le=ee.get(Q.IExtHostRpcService),de=ee.get(L.IExtHostStorage),ge=ee.get(Ke.IExtensionStoragePaths),J=ee.get(qe.ILogService),W=ee.get(oe.IExtHostTunnelService),we=ee.get(he.IExtHostApiDeprecationService),ke=ee.get(Y.IExtHostWindow),Je=ee.get(ct.IExtHostSecretState),$e=ee.get(ft.IExtHostEditorTabs);Le.set(n.ExtHostContext.ExtHostFileSystemInfo,pe),Le.set(n.ExtHostContext.ExtHostLogService,J),Le.set(n.ExtHostContext.ExtHostWorkspace,Be),Le.set(n.ExtHostContext.ExtHostConfiguration,je),Le.set(n.ExtHostContext.ExtHostExtensionService,Ie),Le.set(n.ExtHostContext.ExtHostStorage,de),Le.set(n.ExtHostContext.ExtHostTunnelService,W),Le.set(n.ExtHostContext.ExtHostWindow,ke),Le.set(n.ExtHostContext.ExtHostSecretState,Je),Le.set(n.ExtHostContext.ExtHostTelemetry,Oe),Le.set(n.ExtHostContext.ExtHostEditorTabs,$e);const ut=Le.set(n.ExtHostContext.ExtHostDecorations,ee.get(Me.IExtHostDecorations)),gt=Le.set(n.ExtHostContext.ExtHostDocumentsAndEditors,ee.get(v.IExtHostDocumentsAndEditors)),at=Le.set(n.ExtHostContext.ExtHostCommands,ee.get(a.IExtHostCommands)),dt=Le.set(n.ExtHostContext.ExtHostTerminalService,ee.get(V.IExtHostTerminalService)),st=Le.set(n.ExtHostContext.ExtHostDebugService,ee.get(Ye.IExtHostDebugService)),Et=Le.set(n.ExtHostContext.ExtHostSearch,ee.get(Ve.IExtHostSearch)),yt=Le.set(n.ExtHostContext.ExtHostTask,ee.get(Ne.IExtHostTask)),Ut=Le.set(n.ExtHostContext.ExtHostOutputService,ee.get(P.IExtHostOutputService)),$t=Le.set(n.ExtHostContext.ExtHostUrls,new B.ExtHostUrls(Le)),It=Le.set(n.ExtHostContext.ExtHostDocuments,new i.ExtHostDocuments(Le,gt)),Wt=Le.set(n.ExtHostContext.ExtHostDocumentContentProviders,new f.ExtHostDocumentContentProvider(Le,gt,J)),ei=Le.set(n.ExtHostContext.ExtHostDocumentSaveParticipant,new y.ExtHostDocumentSaveParticipant(J,It,Le.getProxy(n.MainContext.MainThreadBulkEdits))),vt=Le.set(n.ExtHostContext.ExtHostNotebook,new ae.ExtHostNotebookController(Le,at,gt,It,ge)),Qt=Le.set(n.ExtHostContext.ExtHostNotebookDocuments,new Pe.ExtHostNotebookDocuments(J,vt)),jt=Le.set(n.ExtHostContext.ExtHostNotebookEditors,new _t.ExtHostNotebookEditors(J,Le,vt)),ti=Le.set(n.ExtHostContext.ExtHostNotebookKernels,new mt.ExtHostNotebookKernels(Le,ue,vt,at,J)),ii=Le.set(n.ExtHostContext.ExtHostNotebookRenderers,new Ct.ExtHostNotebookRenderers(Le,vt)),Tt=Le.set(n.ExtHostContext.ExtHostEditors,new G.ExtHostEditors(Le,gt)),Yt=Le.set(n.ExtHostContext.ExtHostTreeViews,new U.ExtHostTreeViews(Le.getProxy(n.MainContext.MainThreadTreeViews),at,J)),wi=Le.set(n.ExtHostContext.ExtHostEditorInsets,new se.ExtHostEditorInsets(Le.getProxy(n.MainContext.MainThreadEditorInsets),Tt,ue)),Ht=Le.set(n.ExtHostContext.ExtHostDiagnostics,new S.ExtHostDiagnostics(Le,J,pe)),zt=Le.set(n.ExtHostContext.ExtHostLanguages,new p.ExtHostLanguages(Le,It,at.converter,et)),ht=Le.set(n.ExtHostContext.ExtHostLanguageFeatures,new h.ExtHostLanguageFeatures(Le,et,It,at,Ht,J,we)),ni=Le.set(n.ExtHostContext.ExtHostFileSystem,new s.ExtHostFileSystem(Le,ht)),Ot=Le.set(n.ExtHostContext.ExtHostFileSystemEventService,new l.ExtHostFileSystemEventService(Le,J,gt)),Nt=Le.set(n.ExtHostContext.ExtHostQuickOpen,(0,D.createExtHostQuickOpen)(Le,Be,at)),Jt=Le.set(n.ExtHostContext.ExtHostSCM,new m.ExtHostSCM(Le,at,J)),bi=Le.set(n.ExtHostContext.ExtHostComments,(0,w.createExtHostComments)(Le,at,It)),hi=Le.set(n.ExtHostContext.ExtHostProgress,new g.ExtHostProgress(Le.getProxy(n.MainContext.MainThreadProgress))),Ei=Le.set(n.ExtHostContext.ExtHosLabelService,new ve.ExtHostLabelService(Le)),fi=Le.set(n.ExtHostContext.ExtHostTheming,new q.ExtHostTheming(Le)),ri=Le.set(n.ExtHostContext.ExtHostAuthentication,new Te.ExtHostAuthentication(Le)),si=Le.set(n.ExtHostContext.ExtHostTimeline,new Ue.ExtHostTimeline(Le,at)),qt=Le.set(n.ExtHostContext.ExtHostWebviews,new z.ExtHostWebviews(Le,{remote:ue.remote},Be,J,we)),oi=Le.set(n.ExtHostContext.ExtHostWebviewPanels,new X.ExtHostWebviewPanels(Le,qt,Be)),_i=Le.set(n.ExtHostContext.ExtHostCustomEditors,new H.ExtHostCustomEditors(Le,It,ge,qt,oi)),yi=Le.set(n.ExtHostContext.ExtHostWebviewViews,new nt.ExtHostWebviewViews(Le,qt)),Gt=Le.set(n.ExtHostContext.ExtHostTesting,new Qe.ExtHostTesting(Le,at)),Xt=Le.set(n.ExtHostContext.ExtHostUriOpeners,new rt.ExtHostUriOpeners(Le));Le.set(n.ExtHostContext.ExtHostInteractive,new Se.ExtHostInteractive(Le,vt,gt,at));const Si=(0,le.values)(n.ExtHostContext);Le.assertRegistered(Si);const Di=new fe.ExtHostBulkEdits(Le,gt),ai=new u.ExtHostClipboard(Le),li=new k.ExtHostMessageService(Le,J),Vt=new o.ExtHostDialogs(Le),Mt=new A.ExtHostStatusBar(Le,at.converter);return c.ExtHostApiCommands.register(at),function(Re,Rt,Kt){const wt=function(){let Z=!Re.isUnderDevelopment;function ce(Ce){Z||(J.info(`Extension '${Re.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),Z=!0)}return function Ce(it){if(Array.isArray(it))it.forEach(Ce);else if(typeof it=="string")ce(it);else{const bt=it;typeof bt.scheme=="undefined"&&ce(it),!Re.enableProposedApi&&typeof bt.exclusive=="boolean"&&(0,j.throwProposedApiError)(Re)}return it}}(),Ci={getSession(Z,ce,Ce){return Ce?.forceNewSession&&(0,j.checkProposedApiEnabled)(Re),ri.getSession(Re,Z,ce,Ce)},get onDidChangeSessions(){return ri.onDidChangeSessions},registerAuthenticationProvider(Z,ce,Ce,it){return ri.registerAuthenticationProvider(Z,ce,Ce,it)}},ki={registerCommand(Z,ce,Ce){return at.registerCommand(!0,Z,ce,Ce)},registerTextEditorCommand(Z,ce,Ce){return at.registerCommand(!0,Z,(...it)=>{const bt=Tt.getActiveTextEditor();if(!bt){J.warn("Cannot execute "+Z+" because there is no active text editor.");return}return bt.edit(kt=>{ce.apply(Ce,[bt,kt,...it])}).then(kt=>{kt||J.warn("Edits from command "+Z+" were not applied.")},kt=>{J.warn("An error occurred while running command "+Z,kt)})})},registerDiffInformationCommand:(Z,ce,Ce)=>((0,j.checkProposedApiEnabled)(Re),at.registerCommand(!0,Z,async(...it)=>{const bt=gt.activeEditor(!0);if(!bt){J.warn("Cannot execute "+Z+" because there is no active text editor.");return}const kt=await Tt.getDiffInformation(bt.id);ce.apply(Ce,[kt,...it])})),executeCommand(Z,...ce){return at.executeCommand(Z,...ce)},getCommands(Z=!1){return at.getCommands(Z)}},mi={get machineId(){return ue.telemetryInfo.machineId},get sessionId(){return ue.telemetryInfo.sessionId},get language(){return ue.environment.appLanguage},get appName(){return ue.environment.appName},get appRoot(){return ue.environment.appRoot?.fsPath??""},get appHost(){return ue.environment.appHost},get uriScheme(){return ue.environment.appUriScheme},get clipboard(){return ai.value},get shell(){return dt.getDefaultShell(!1)},get isTelemetryEnabled(){return Oe.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return Oe.onDidChangeTelemetryEnabled},get isNewAppInstall(){const Z=Date.now()-new Date(ue.telemetryInfo.firstSessionDate).getTime();return isNaN(Z)?!1:Z<1e3*60*60*24},openExternal(Z,ce){return ke.openUri(Z,{allowTunneling:!!ue.remote.authority,allowContributedOpeners:ce?.allowContributedOpeners})},async asExternalUri(Z){if(Z.scheme===ue.environment.appUriScheme)return $t.createAppUri(Z);try{return await ke.asExternalUri(Z,{allowTunneling:!!ue.remote.authority})}catch(ce){if((0,Xe.matchesScheme)(Z,pt.Schemas.http)||(0,Xe.matchesScheme)(Z,pt.Schemas.https))return Z;throw ce}},get remoteName(){return(0,Fe.getRemoteName)(ue.remote.authority)},get remoteAuthority(){return(0,j.checkProposedApiEnabled)(Re),ue.remote.authority},get uiKind(){return ue.uiKind}};ue.environment.extensionTestsLocationURI||Object.freeze(mi);const gi=ue.remote.isRemote?$.ExtensionKind.Workspace:$.ExtensionKind.UI,Ii={createTestController(Z,ce){return Gt.createTestController(Z,ce)},createTestObserver(){return(0,j.checkProposedApiEnabled)(Re),Gt.createTestObserver()},runTests(Z){return(0,j.checkProposedApiEnabled)(Re),Gt.runTests(Z)},get onDidChangeTestResults(){return(0,j.checkProposedApiEnabled)(Re),Gt.onResultsChanged},get testResults(){return(0,j.checkProposedApiEnabled)(Re),Gt.results}},Pi={getExtension(Z){const ce=Rt.getExtensionDescription(Z);if(ce)return new r.Extension(Ie,Re.identifier,ce,gi)},get all(){return Rt.getAllExtensionDescriptions().map(Z=>new r.Extension(Ie,Re.identifier,Z,gi))},get onDidChange(){return Rt.onDidChange}},ui={createDiagnosticCollection(Z){return Ht.createDiagnosticCollection(Re.identifier,Z)},get onDidChangeDiagnostics(){return Ht.onDidChangeDiagnostics},getDiagnostics:Z=>Ht.getDiagnostics(Z),getLanguages(){return zt.getLanguages()},setTextDocumentLanguage(Z,ce){return zt.changeLanguage(Z.uri,ce)},match(Z,ce){return(0,t.score)(K.LanguageSelector.from(Z),ce.uri,ce.languageId,!0)},registerCodeActionsProvider(Z,ce,Ce){return ht.registerCodeActionProvider(Re,wt(Z),ce,Ce)},registerCodeLensProvider(Z,ce){return ht.registerCodeLensProvider(Re,wt(Z),ce)},registerDefinitionProvider(Z,ce){return ht.registerDefinitionProvider(Re,wt(Z),ce)},registerDeclarationProvider(Z,ce){return ht.registerDeclarationProvider(Re,wt(Z),ce)},registerImplementationProvider(Z,ce){return ht.registerImplementationProvider(Re,wt(Z),ce)},registerTypeDefinitionProvider(Z,ce){return ht.registerTypeDefinitionProvider(Re,wt(Z),ce)},registerHoverProvider(Z,ce){return ht.registerHoverProvider(Re,wt(Z),ce,Re.identifier)},registerEvaluatableExpressionProvider(Z,ce){return ht.registerEvaluatableExpressionProvider(Re,wt(Z),ce,Re.identifier)},registerInlineValuesProvider(Z,ce){return ht.registerInlineValuesProvider(Re,wt(Z),ce,Re.identifier)},registerDocumentHighlightProvider(Z,ce){return ht.registerDocumentHighlightProvider(Re,wt(Z),ce)},registerLinkedEditingRangeProvider(Z,ce){return ht.registerLinkedEditingRangeProvider(Re,wt(Z),ce)},registerReferenceProvider(Z,ce){return ht.registerReferenceProvider(Re,wt(Z),ce)},registerRenameProvider(Z,ce){return ht.registerRenameProvider(Re,wt(Z),ce)},registerDocumentSymbolProvider(Z,ce,Ce){return ht.registerDocumentSymbolProvider(Re,wt(Z),ce,Ce)},registerWorkspaceSymbolProvider(Z){return ht.registerWorkspaceSymbolProvider(Re,Z)},registerDocumentFormattingEditProvider(Z,ce){return ht.registerDocumentFormattingEditProvider(Re,wt(Z),ce)},registerDocumentRangeFormattingEditProvider(Z,ce){return ht.registerDocumentRangeFormattingEditProvider(Re,wt(Z),ce)},registerOnTypeFormattingEditProvider(Z,ce,Ce,...it){return ht.registerOnTypeFormattingEditProvider(Re,wt(Z),ce,[Ce].concat(it))},registerDocumentSemanticTokensProvider(Z,ce,Ce){return ht.registerDocumentSemanticTokensProvider(Re,wt(Z),ce,Ce)},registerDocumentRangeSemanticTokensProvider(Z,ce,Ce){return ht.registerDocumentRangeSemanticTokensProvider(Re,wt(Z),ce,Ce)},registerSignatureHelpProvider(Z,ce,Ce,...it){return typeof Ce=="object"?ht.registerSignatureHelpProvider(Re,wt(Z),ce,Ce):ht.registerSignatureHelpProvider(Re,wt(Z),ce,typeof Ce=="undefined"?[]:[Ce,...it])},registerCompletionItemProvider(Z,ce,...Ce){return ht.registerCompletionItemProvider(Re,wt(Z),ce,Ce)},registerInlineCompletionItemProvider(Z,ce){return(0,j.checkProposedApiEnabled)(Re),ht.registerInlineCompletionsProvider(Re,wt(Z),ce)},registerDocumentLinkProvider(Z,ce){return ht.registerDocumentLinkProvider(Re,wt(Z),ce)},registerColorProvider(Z,ce){return ht.registerColorProvider(Re,wt(Z),ce)},registerFoldingRangeProvider(Z,ce){return ht.registerFoldingRangeProvider(Re,wt(Z),ce)},registerSelectionRangeProvider(Z,ce){return ht.registerSelectionRangeProvider(Re,Z,ce)},registerCallHierarchyProvider(Z,ce){return ht.registerCallHierarchyProvider(Re,Z,ce)},registerTypeHierarchyProvider(Z,ce){return ht.registerTypeHierarchyProvider(Re,Z,ce)},setLanguageConfiguration:(Z,ce)=>ht.setLanguageConfiguration(Re,Z,ce),getTokenInformationAtPosition(Z,ce){return(0,j.checkProposedApiEnabled)(Re),zt.tokenAtPosition(Z,ce)},registerInlayHintsProvider(Z,ce){return(0,j.checkProposedApiEnabled)(Re),ht.registerInlayHintsProvider(Re,Z,ce)},createLanguageStatusItem(Z,ce){return(0,j.checkProposedApiEnabled)(Re),zt.createLanguageStatusItem(Re,Z,ce)}},Ti={get activeTextEditor(){return Tt.getActiveTextEditor()},get visibleTextEditors(){return Tt.getVisibleTextEditors()},get activeTerminal(){return dt.activeTerminal},get terminals(){return dt.terminals},async showTextDocument(Z,ce,Ce){const it=await(F.URI.isUri(Z)?Promise.resolve(pi.openTextDocument(Z)):Promise.resolve(Z));return Tt.showTextDocument(it,ce,Ce)},createTextEditorDecorationType(Z){return Tt.createTextEditorDecorationType(Re,Z)},onDidChangeActiveTextEditor(Z,ce,Ce){return Tt.onDidChangeActiveTextEditor(Z,ce,Ce)},onDidChangeVisibleTextEditors(Z,ce,Ce){return Tt.onDidChangeVisibleTextEditors(Z,ce,Ce)},onDidChangeTextEditorSelection(Z,ce,Ce){return Tt.onDidChangeTextEditorSelection(Z,ce,Ce)},onDidChangeTextEditorOptions(Z,ce,Ce){return Tt.onDidChangeTextEditorOptions(Z,ce,Ce)},onDidChangeTextEditorVisibleRanges(Z,ce,Ce){return Tt.onDidChangeTextEditorVisibleRanges(Z,ce,Ce)},onDidChangeTextEditorViewColumn(Z,ce,Ce){return Tt.onDidChangeTextEditorViewColumn(Z,ce,Ce)},onDidCloseTerminal(Z,ce,Ce){return dt.onDidCloseTerminal(Z,ce,Ce)},onDidOpenTerminal(Z,ce,Ce){return dt.onDidOpenTerminal(Z,ce,Ce)},onDidChangeActiveTerminal(Z,ce,Ce){return dt.onDidChangeActiveTerminal(Z,ce,Ce)},onDidChangeTerminalDimensions(Z,ce,Ce){return(0,j.checkProposedApiEnabled)(Re),dt.onDidChangeTerminalDimensions(Z,ce,Ce)},onDidChangeTerminalState(Z,ce,Ce){return(0,j.checkProposedApiEnabled)(Re),dt.onDidChangeTerminalState(Z,ce,Ce)},onDidWriteTerminalData(Z,ce,Ce){return(0,j.checkProposedApiEnabled)(Re),dt.onDidWriteTerminalData(Z,ce,Ce)},get state(){return ke.state},onDidChangeWindowState(Z,ce,Ce){return ke.onDidChangeWindowState(Z,ce,Ce)},showInformationMessage(Z,...ce){return li.showMessage(Re,R.default.Info,Z,ce[0],ce.slice(1))},showWarningMessage(Z,...ce){return li.showMessage(Re,R.default.Warning,Z,ce[0],ce.slice(1))},showErrorMessage(Z,...ce){return li.showMessage(Re,R.default.Error,Z,ce[0],ce.slice(1))},showQuickPick(Z,ce,Ce){return Nt.showQuickPick(Z,!!Re.enableProposedApi,ce,Ce)},showWorkspaceFolderPick(Z){return Nt.showWorkspaceFolderPick(Z)},showInputBox(Z,ce){return Nt.showInput(Z,ce)},showOpenDialog(Z){return Vt.showOpenDialog(Z)},showSaveDialog(Z){return Vt.showSaveDialog(Z)},createStatusBarItem(Z,ce,Ce){let it,bt,kt;return typeof Z=="string"?(it=Z,bt=ce,kt=Ce):(bt=Z,kt=ce),Mt.createStatusBarEntry(Re,it,bt,kt)},setStatusBarMessage(Z,ce){return Mt.setStatusBarMessage(Z,ce)},withScmProgress(Z){return we.report("window.withScmProgress",Re,"Use 'withProgress' instead."),hi.withProgress(Re,{location:$.ProgressLocation.SourceControl},(ce,Ce)=>Z({report(it){}}))},withProgress(Z,ce){return hi.withProgress(Re,Z,ce)},createOutputChannel(Z){return Ut.createOutputChannel(Z,Re)},createWebviewPanel(Z,ce,Ce,it){return oi.createWebviewPanel(Re,Z,ce,Ce,it)},createWebviewTextEditorInset(Z,ce,Ce,it){return(0,j.checkProposedApiEnabled)(Re),wi.createWebviewEditorInset(Z,ce,Ce,it,Re)},createTerminal(Z,ce,Ce){return typeof Z=="object"?("location"in Z&&(0,j.checkProposedApiEnabled)(Re),"pty"in Z?dt.createExtensionTerminal(Z):dt.createTerminalFromOptions(Z)):dt.createTerminal(Z,ce,Ce)},registerTerminalLinkProvider(Z){return dt.registerLinkProvider(Z)},registerTerminalProfileProvider(Z,ce){return dt.registerProfileProvider(Re,Z,ce)},registerTreeDataProvider(Z,ce){return Yt.registerTreeDataProvider(Z,ce,Re)},createTreeView(Z,ce){return Yt.createTreeView(Z,ce,Re)},registerWebviewPanelSerializer:(Z,ce)=>oi.registerWebviewPanelSerializer(Re,Z,ce),registerCustomEditorProvider:(Z,ce,Ce={})=>_i.registerCustomEditorProvider(Re,Z,ce,Ce),registerFileDecorationProvider(Z){return ut.registerFileDecorationProvider(Z,Re.identifier)},registerUriHandler(Z){return $t.registerUriHandler(Re.identifier,Z)},createQuickPick(){return Nt.createQuickPick(Re.identifier,!!Re.enableProposedApi)},createInputBox(){return Nt.createInputBox(Re.identifier)},get activeColorTheme(){return fi.activeColorTheme},onDidChangeActiveColorTheme(Z,ce,Ce){return fi.onDidChangeActiveColorTheme(Z,ce,Ce)},registerWebviewViewProvider(Z,ce,Ce){return yi.registerWebviewViewProvider(Re,Z,ce,Ce?.webviewOptions)},get activeNotebookEditor(){return(0,j.checkProposedApiEnabled)(Re),vt.activeNotebookEditor},onDidChangeActiveNotebookEditor(Z,ce,Ce){return(0,j.checkProposedApiEnabled)(Re),vt.onDidChangeActiveNotebookEditor(Z,ce,Ce)},get visibleNotebookEditors(){return(0,j.checkProposedApiEnabled)(Re),vt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,j.checkProposedApiEnabled)(Re),vt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(Z,ce,Ce){return(0,j.checkProposedApiEnabled)(Re),jt.onDidChangeNotebookEditorSelection(Z,ce,Ce)},onDidChangeNotebookEditorVisibleRanges(Z,ce,Ce){return(0,j.checkProposedApiEnabled)(Re),jt.onDidChangeNotebookEditorVisibleRanges(Z,ce,Ce)},showNotebookDocument(Z,ce){return(0,j.checkProposedApiEnabled)(Re),vt.showNotebookDocument(Z,ce)},registerExternalUriOpener(Z,ce,Ce){return(0,j.checkProposedApiEnabled)(Re),Xt.registerExternalUriOpener(Re.identifier,Z,ce,Ce)},get tabs(){return(0,j.checkProposedApiEnabled)(Re),$e.tabs},get activeTab(){return(0,j.checkProposedApiEnabled)(Re),$e.activeTab},get onDidChangeTabs(){return(0,j.checkProposedApiEnabled)(Re),$e.onDidChangeTabs},get onDidChangeActiveTab(){return(0,j.checkProposedApiEnabled)(Re),$e.onDidChangeActiveTab},getInlineCompletionItemController(Z){return(0,j.checkProposedApiEnabled)(Re),h.InlineCompletionController.get(Z)}},pi={get rootPath(){return we.report("workspace.rootPath",Re,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),Be.getPath()},set rootPath(Z){throw M.readonly()},getWorkspaceFolder(Z){return Be.getWorkspaceFolder(Z)},get workspaceFolders(){return Be.getWorkspaceFolders()},get name(){return Be.name},set name(Z){throw M.readonly()},get workspaceFile(){return Be.workspaceFile},set workspaceFile(Z){throw M.readonly()},updateWorkspaceFolders:(Z,ce,...Ce)=>Be.updateWorkspaceFolders(Re,Z,ce||0,...Ce),onDidChangeWorkspaceFolders:function(Z,ce,Ce){return Be.onDidChangeWorkspace(Z,ce,Ce)},asRelativePath:(Z,ce)=>Be.getRelativePath(Z,ce),findFiles:(Z,ce,Ce,it)=>Be.findFiles(K.GlobPattern.from(Z),K.GlobPattern.from(ce),Ce,Re.identifier,it),findTextInFiles:(Z,ce,Ce,it)=>{let bt,kt;return typeof ce=="object"?(bt=ce,kt=Ce):(bt={},kt=ce,it=Ce),Be.findTextInFiles(Z,bt||{},kt,Re.identifier,it)},saveAll:Z=>Be.saveAll(Z),applyEdit(Z){return Di.applyWorkspaceEdit(Z)},createFileSystemWatcher:(Z,ce,Ce,it)=>Ot.createFileSystemWatcher(K.GlobPattern.from(Z),ce,Ce,it),get textDocuments(){return It.getAllDocumentData().map(Z=>Z.document)},set textDocuments(Z){throw M.readonly()},openTextDocument(Z){let ce;const Ce=Z;if(typeof Z=="string")ce=Promise.resolve(F.URI.file(Z));else if(F.URI.isUri(Z))ce=Promise.resolve(Z);else if(!Ce||typeof Ce=="object")ce=It.createDocumentData(Ce);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ce.then(it=>It.ensureDocumentData(it).then(bt=>bt.document))},onDidOpenTextDocument:(Z,ce,Ce)=>It.onDidAddDocument(Z,ce,Ce),onDidCloseTextDocument:(Z,ce,Ce)=>It.onDidRemoveDocument(Z,ce,Ce),onDidChangeTextDocument:(Z,ce,Ce)=>It.onDidChangeDocument(Z,ce,Ce),onDidSaveTextDocument:(Z,ce,Ce)=>It.onDidSaveDocument(Z,ce,Ce),onWillSaveTextDocument:(Z,ce,Ce)=>ei.getOnWillSaveTextDocumentEvent(Re)(Z,ce,Ce),get notebookDocuments(){return vt.notebookDocuments.map(Z=>Z.apiNotebook)},async openNotebookDocument(Z,ce){let Ce;if(F.URI.isUri(Z))Ce=Z,await vt.openNotebookDocument(Z);else if(typeof Z=="string")Ce=F.URI.revive(await vt.createNotebookDocument({viewType:Z,content:ce}));else throw new Error("Invalid arguments");return vt.getNotebookDocument(Ce).apiNotebook},get onDidOpenNotebookDocument(){return vt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return vt.onDidCloseNotebookDocument},registerNotebookSerializer(Z,ce,Ce,it){return vt.registerNotebookSerializer(Re,Z,ce,Ce,Re.enableProposedApi?it:void 0)},registerNotebookContentProvider:(Z,ce,Ce,it)=>((0,j.checkProposedApiEnabled)(Re),vt.registerNotebookContentProvider(Re,Z,ce,Ce,Re.enableProposedApi?it:void 0)),onDidChangeConfiguration:(Z,ce,Ce)=>Kt.onDidChangeConfiguration(Z,ce,Ce),getConfiguration(Z,ce){return ce=arguments.length===1?void 0:ce,Kt.getConfiguration(Z,ce,Re)},registerTextDocumentContentProvider(Z,ce){return Wt.registerTextDocumentContentProvider(Z,ce)},registerTaskProvider:(Z,ce)=>(we.report("window.registerTaskProvider",Re,"Use the corresponding function on the 'tasks' namespace instead"),yt.registerTaskProvider(Re,Z,ce)),registerFileSystemProvider(Z,ce,Ce){return ni.registerFileSystemProvider(Re.identifier,Z,ce,Ce)},get fs(){return me.value},registerFileSearchProvider:(Z,ce)=>((0,j.checkProposedApiEnabled)(Re),Et.registerFileSearchProvider(Z,ce)),registerTextSearchProvider:(Z,ce)=>((0,j.checkProposedApiEnabled)(Re),Et.registerTextSearchProvider(Z,ce)),registerRemoteAuthorityResolver:(Z,ce)=>((0,j.checkProposedApiEnabled)(Re),Ie.registerRemoteAuthorityResolver(Z,ce)),registerResourceLabelFormatter:Z=>((0,j.checkProposedApiEnabled)(Re),Ei.$registerResourceLabelFormatter(Z)),onDidCreateFiles:(Z,ce,Ce)=>Ot.onDidCreateFile(Z,ce,Ce),onDidDeleteFiles:(Z,ce,Ce)=>Ot.onDidDeleteFile(Z,ce,Ce),onDidRenameFiles:(Z,ce,Ce)=>Ot.onDidRenameFile(Z,ce,Ce),onWillCreateFiles:(Z,ce,Ce)=>Ot.getOnWillCreateFileEvent(Re)(Z,ce,Ce),onWillDeleteFiles:(Z,ce,Ce)=>Ot.getOnWillDeleteFileEvent(Re)(Z,ce,Ce),onWillRenameFiles:(Z,ce,Ce)=>Ot.getOnWillRenameFileEvent(Re)(Z,ce,Ce),openTunnel:Z=>((0,j.checkProposedApiEnabled)(Re),W.openTunnel(Re,Z).then(ce=>{if(!ce)throw new Error("cannot open tunnel");return ce})),get tunnels(){return(0,j.checkProposedApiEnabled)(Re),W.getTunnels()},onDidChangeTunnels:(Z,ce,Ce)=>((0,j.checkProposedApiEnabled)(Re),W.onDidChangeTunnels(Z,ce,Ce)),registerPortAttributesProvider:(Z,ce)=>((0,j.checkProposedApiEnabled)(Re),W.registerPortsAttributesProvider(Z,ce)),registerTimelineProvider:(Z,ce)=>((0,j.checkProposedApiEnabled)(Re),si.registerTimelineProvider(Z,ce,Re.identifier,at.converter)),get isTrusted(){return Be.trusted},requestWorkspaceTrust:Z=>((0,j.checkProposedApiEnabled)(Re),Be.requestWorkspaceTrust(Z)),onDidGrantWorkspaceTrust:(Z,ce,Ce)=>Be.onDidGrantWorkspaceTrust(Z,ce,Ce)},Ai={get inputBox(){return we.report("scm.inputBox",Re,"Use 'SourceControl.inputBox' instead"),Jt.getLastInputBox(Re)},createSourceControl(Z,ce,Ce){return Jt.createSourceControl(Re,Z,ce,Ce)}},Ri={createCommentController(Z,ce){return bi.createCommentController(Re,Z,ce)}},Fi={get activeDebugSession(){return st.activeDebugSession},get activeDebugConsole(){return st.activeDebugConsole},get breakpoints(){return st.breakpoints},onDidStartDebugSession(Z,ce,Ce){return st.onDidStartDebugSession(Z,ce,Ce)},onDidTerminateDebugSession(Z,ce,Ce){return st.onDidTerminateDebugSession(Z,ce,Ce)},onDidChangeActiveDebugSession(Z,ce,Ce){return st.onDidChangeActiveDebugSession(Z,ce,Ce)},onDidReceiveDebugSessionCustomEvent(Z,ce,Ce){return st.onDidReceiveDebugSessionCustomEvent(Z,ce,Ce)},onDidChangeBreakpoints(Z,ce,Ce){return st.onDidChangeBreakpoints(Z,ce,Ce)},registerDebugConfigurationProvider(Z,ce,Ce){return st.registerDebugConfigurationProvider(Z,ce,Ce||$.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(Z,ce){return st.registerDebugAdapterDescriptorFactory(Re,Z,ce)},registerDebugAdapterTrackerFactory(Z,ce){return st.registerDebugAdapterTrackerFactory(Z,ce)},startDebugging(Z,ce,Ce){return!Ce||typeof Ce=="object"&&"configuration"in Ce?st.startDebugging(Z,ce,{parentSession:Ce}):st.startDebugging(Z,ce,Ce||{})},stopDebugging(Z){return st.stopDebugging(Z)},addBreakpoints(Z){return st.addBreakpoints(Z)},removeBreakpoints(Z){return st.removeBreakpoints(Z)},asDebugSourceUri(Z,ce){return st.asDebugSourceUri(Z,ce)}},Mi={registerTaskProvider:(Z,ce)=>yt.registerTaskProvider(Re,Z,ce),fetchTasks:Z=>yt.fetchTasks(Z),executeTask:Z=>yt.executeTask(Re,Z),get taskExecutions(){return yt.taskExecutions},onDidStartTask:(Z,ce,Ce)=>yt.onDidStartTask(Z,ce,Ce),onDidEndTask:(Z,ce,Ce)=>yt.onDidEndTask(Z,ce,Ce),onDidStartTaskProcess:(Z,ce,Ce)=>yt.onDidStartTaskProcess(Z,ce,Ce),onDidEndTaskProcess:(Z,ce,Ce)=>yt.onDidEndTaskProcess(Z,ce,Ce)},Li={createNotebookController(Z,ce,Ce,it,bt){return ti.createNotebookController(Re,Z,ce,Ce,it,Re.enableProposedApi?bt:void 0)},registerNotebookCellStatusBarItemProvider:(Z,ce)=>vt.registerNotebookCellStatusBarItemProvider(Re,Z,ce),get onDidSaveNotebookDocument(){return(0,j.checkProposedApiEnabled)(Re),Qt.onDidSaveNotebookDocument},createNotebookEditorDecorationType(Z){return(0,j.checkProposedApiEnabled)(Re),jt.createNotebookEditorDecorationType(Z)},createRendererMessaging(Z){return ii.createRendererMessaging(Re,Z)},onDidChangeNotebookDocumentMetadata(Z,ce,Ce){return(0,j.checkProposedApiEnabled)(Re),Qt.onDidChangeNotebookDocumentMetadata(Z,ce,Ce)},onDidChangeNotebookCells(Z,ce,Ce){return(0,j.checkProposedApiEnabled)(Re),vt.onDidChangeNotebookCells(Z,ce,Ce)},onDidChangeNotebookCellExecutionState(Z,ce,Ce){return(0,j.checkProposedApiEnabled)(Re),vt.onDidChangeNotebookCellExecutionState(Z,ce,Ce)},onDidChangeCellOutputs(Z,ce,Ce){return(0,j.checkProposedApiEnabled)(Re),vt.onDidChangeCellOutputs(Z,ce,Ce)},onDidChangeCellMetadata(Z,ce,Ce){return(0,j.checkProposedApiEnabled)(Re),vt.onDidChangeCellMetadata(Z,ce,Ce)},createConcatTextDocument(Z,ce){return(0,j.checkProposedApiEnabled)(Re),new He.ExtHostNotebookConcatDocument(vt,It,Z,ce)}};return{version:ue.version,authentication:Ci,commands:ki,comments:Ri,debug:Fi,env:mi,extensions:Pi,languages:ui,notebooks:Li,scm:Ai,tasks:Mi,tests:Ii,window:Ti,workspace:pi,Breakpoint:$.Breakpoint,CallHierarchyIncomingCall:$.CallHierarchyIncomingCall,CallHierarchyItem:$.CallHierarchyItem,CallHierarchyOutgoingCall:$.CallHierarchyOutgoingCall,CancellationError:M.CancellationError,CancellationTokenSource:d.CancellationTokenSource,CandidatePortSource:n.CandidatePortSource,CodeAction:$.CodeAction,CodeActionKind:$.CodeActionKind,CodeActionTriggerKind:$.CodeActionTriggerKind,CodeLens:$.CodeLens,Color:$.Color,ColorInformation:$.ColorInformation,ColorPresentation:$.ColorPresentation,ColorThemeKind:$.ColorThemeKind,CommentMode:$.CommentMode,CommentThreadCollapsibleState:$.CommentThreadCollapsibleState,CompletionItem:$.CompletionItem,CompletionItemKind:$.CompletionItemKind,CompletionItemTag:$.CompletionItemTag,CompletionList:$.CompletionList,CompletionTriggerKind:$.CompletionTriggerKind,ConfigurationTarget:$.ConfigurationTarget,CustomExecution:$.CustomExecution,DebugAdapterExecutable:$.DebugAdapterExecutable,DebugAdapterInlineImplementation:$.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:$.DebugAdapterNamedPipeServer,DebugAdapterServer:$.DebugAdapterServer,DebugConfigurationProviderTriggerKind:$.DebugConfigurationProviderTriggerKind,DebugConsoleMode:$.DebugConsoleMode,DecorationRangeBehavior:$.DecorationRangeBehavior,Diagnostic:$.Diagnostic,DiagnosticRelatedInformation:$.DiagnosticRelatedInformation,DiagnosticSeverity:$.DiagnosticSeverity,DiagnosticTag:$.DiagnosticTag,Disposable:$.Disposable,DocumentHighlight:$.DocumentHighlight,DocumentHighlightKind:$.DocumentHighlightKind,DocumentLink:$.DocumentLink,DocumentSymbol:$.DocumentSymbol,EndOfLine:$.EndOfLine,EnvironmentVariableMutatorType:$.EnvironmentVariableMutatorType,EvaluatableExpression:$.EvaluatableExpression,InlineValueText:$.InlineValueText,InlineValueVariableLookup:$.InlineValueVariableLookup,InlineValueEvaluatableExpression:$.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:$.InlineCompletionTriggerKind,EventEmitter:b.Emitter,ExtensionKind:$.ExtensionKind,ExtensionMode:$.ExtensionMode,ExternalUriOpenerPriority:$.ExternalUriOpenerPriority,FileChangeType:$.FileChangeType,FileDecoration:$.FileDecoration,FileSystemError:$.FileSystemError,FileType:E.FileType,FilePermission:E.FilePermission,FoldingRange:$.FoldingRange,FoldingRangeKind:$.FoldingRangeKind,FunctionBreakpoint:$.FunctionBreakpoint,InlineCompletionItem:$.InlineSuggestion,InlineCompletionList:$.InlineSuggestions,Hover:$.Hover,IndentAction:I.IndentAction,Location:$.Location,MarkdownString:$.MarkdownString,OverviewRulerLane:_.OverviewRulerLane,ParameterInformation:$.ParameterInformation,PortAutoForwardAction:$.PortAutoForwardAction,Position:$.Position,ProcessExecution:$.ProcessExecution,ProgressLocation:$.ProgressLocation,QuickInputButtons:$.QuickInputButtons,Range:$.Range,RelativePattern:$.RelativePattern,Selection:$.Selection,SelectionRange:$.SelectionRange,SemanticTokens:$.SemanticTokens,SemanticTokensBuilder:$.SemanticTokensBuilder,SemanticTokensEdit:$.SemanticTokensEdit,SemanticTokensEdits:$.SemanticTokensEdits,SemanticTokensLegend:$.SemanticTokensLegend,ShellExecution:$.ShellExecution,ShellQuoting:$.ShellQuoting,SignatureHelp:$.SignatureHelp,SignatureHelpTriggerKind:$.SignatureHelpTriggerKind,SignatureInformation:$.SignatureInformation,SnippetString:$.SnippetString,SourceBreakpoint:$.SourceBreakpoint,StandardTokenType:$.StandardTokenType,StatusBarAlignment:$.StatusBarAlignment,SymbolInformation:$.SymbolInformation,SymbolKind:$.SymbolKind,SymbolTag:$.SymbolTag,Task:$.Task,TaskGroup:$.TaskGroup,TaskPanelKind:$.TaskPanelKind,TaskRevealKind:$.TaskRevealKind,TaskScope:$.TaskScope,TerminalLink:$.TerminalLink,TerminalLocation:$.TerminalLocation,TerminalProfile:$.TerminalProfile,TextDocumentSaveReason:$.TextDocumentSaveReason,TextEdit:$.TextEdit,TextEditorCursorStyle:C.TextEditorCursorStyle,TextEditorLineNumbersStyle:$.TextEditorLineNumbersStyle,TextEditorRevealType:$.TextEditorRevealType,TextEditorSelectionChangeKind:$.TextEditorSelectionChangeKind,TextDocumentChangeReason:$.TextDocumentChangeReason,ThemeColor:$.ThemeColor,ThemeIcon:$.ThemeIcon,TreeItem:$.TreeItem,TreeItemCollapsibleState:$.TreeItemCollapsibleState,TypeHierarchyItem:$.TypeHierarchyItem,UIKind:n.UIKind,Uri:F.URI,ViewColumn:$.ViewColumn,WorkspaceEdit:$.WorkspaceEdit,InlayHint:$.InlayHint,InlayHintKind:$.InlayHintKind,RemoteAuthorityResolverError:$.RemoteAuthorityResolverError,ResolvedAuthority:$.ResolvedAuthority,SourceControlInputBoxValidationType:$.SourceControlInputBoxValidationType,ExtensionRuntime:$.ExtensionRuntime,TimelineItem:$.TimelineItem,NotebookRange:$.NotebookRange,NotebookCellKind:$.NotebookCellKind,NotebookCellExecutionState:$.NotebookCellExecutionState,NotebookCellData:$.NotebookCellData,NotebookData:$.NotebookData,NotebookRendererScript:$.NotebookRendererScript,NotebookCellStatusBarAlignment:$.NotebookCellStatusBarAlignment,NotebookEditorRevealType:$.NotebookEditorRevealType,NotebookCellOutput:$.NotebookCellOutput,NotebookCellOutputItem:$.NotebookCellOutputItem,NotebookCellStatusBarItem:$.NotebookCellStatusBarItem,NotebookControllerAffinity:$.NotebookControllerAffinity,PortAttributes:$.PortAttributes,LinkedEditingRanges:$.LinkedEditingRanges,TestResultState:$.TestResultState,TestRunRequest:$.TestRunRequest,TestMessage:$.TestMessage,TestTag:$.TestTag,TestRunProfileKind:$.TestRunProfileKind,TextSearchCompleteMessageType:St.TextSearchCompleteMessageType,CoveredCount:$.CoveredCount,FileCoverage:$.FileCoverage,StatementCoverage:$.StatementCoverage,BranchCoverage:$.BranchCoverage,FunctionCoverage:$.FunctionCoverage,WorkspaceTrustState:$.WorkspaceTrustState,LanguageStatusSeverity:$.LanguageStatusSeverity}}}e.createApiFactoryAndRegisterActors=De}),define(be[223],Ee([0,1,57,96,31,95,32,39,49,40,99,100,101,72,64,70,97,71,37,69,87,68]),function(re,e,d,M,b,R,F,C,_,I,t,E,n,c,u,a,w,T,S,o,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,d.registerSingleton)(a.IExtHostApiDeprecationService,a.ExtHostApiDeprecationService),(0,d.registerSingleton)(C.IExtHostCommands,C.ExtHostCommands),(0,d.registerSingleton)(F.IExtHostConfiguration,F.ExtHostConfiguration),(0,d.registerSingleton)(T.IExtHostConsumerFileSystem,T.ExtHostConsumerFileSystem),(0,d.registerSingleton)(E.IExtHostDebugService,E.WorkerExtHostDebugService),(0,d.registerSingleton)(R.IExtHostDecorations,R.ExtHostDecorations),(0,d.registerSingleton)(_.IExtHostDocumentsAndEditors,_.ExtHostDocumentsAndEditors),(0,d.registerSingleton)(S.IExtHostFileSystemInfo,S.ExtHostFileSystemInfo),(0,d.registerSingleton)(M.IExtHostOutputService,M.ExtHostOutputService),(0,d.registerSingleton)(n.IExtHostSearch,n.ExtHostSearch),(0,d.registerSingleton)(c.IExtHostStorage,c.ExtHostStorage),(0,d.registerSingleton)(t.IExtHostTask,t.WorkerExtHostTask),(0,d.registerSingleton)(I.IExtHostTerminalService,I.WorkerExtHostTerminalService),(0,d.registerSingleton)(u.IExtHostTunnelService,u.ExtHostTunnelService),(0,d.registerSingleton)(w.IExtHostWindow,w.ExtHostWindow),(0,d.registerSingleton)(b.IExtHostWorkspace,b.ExtHostWorkspace),(0,d.registerSingleton)(o.IExtHostSecretState,o.ExtHostSecretState),(0,d.registerSingleton)(f.IExtHostTelemetry,f.ExtHostTelemetry),(0,d.registerSingleton)(y.IExtHostEditorTabs,y.ExtHostEditorTabs)}),define(be[224],Ee([0,1,222,33,218,7,14,5,11]),function(re,e,d,M,b,R,F,C,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;var I;(function(u){const a=self.trustedTypes?.createPolicy("TrustedFunctionWorkaround",{createScript:(T,...S)=>{S.forEach(i=>{if(!self.trustedTypes?.isScript(i))throw new Error("TrustedScripts only, please")});const o=S.slice(0,-1).join(","),f=S.pop().toString();return`(function anonymous(${o}) {
${f}
})`}});function w(...T){return a?self.eval(a.createScript("",...T)):new Function(...T)}u.create=w})(I||(I={}));class t extends b.RequireInterceptor{_installInterceptor(){}getModule(a,w){for(let T of this._alternatives){let S=T(a);if(S){a=S;break}}if(this._factories.has(a))return this._factories.get(a).load(a,w,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class E extends M.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=R.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){const a=this._extHostContext.getProxy(C.MainContext.MainThreadConsole);c(a,this._initData.environment.isExtensionDevelopmentDebug);const w=this._instaService.invokeFunction(d.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(t,w,this._registry),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(a){return a.browser}async _loadCommonJSModule(a,w,T){w=w.with({path:n(w.path,".js")}),a&&performance.mark(`code/extHost/willFetchExtensionCode/${a.value}`);const S=await fetch(_.FileAccess.asBrowserUri(w).toString(!0));if(a&&performance.mark(`code/extHost/didFetchExtensionCode/${a.value}`),S.status!==200)throw new Error(S.statusText);const o=await S.text(),f=`${w.toString(!0)}#vscode-extension`,y=`${o}
//# sourceURL=${f}`;let i;try{i=I.create(E._ttpExtensionScripts?.createScript("module")??"module",E._ttpExtensionScripts?.createScript("exports")??"exports",E._ttpExtensionScripts?.createScript("require")??"require",E._ttpExtensionScripts?.createScript(y)??y)}catch(l){throw console.error(a?`Loading code for extension ${a.value} failed: ${l.message}`:`Loading code failed: ${l.message}`),console.error(`${w.toString(!0)}${typeof l.line=="number"?` line ${l.line}`:""}${typeof l.column=="number"?` column ${l.column}`:""}`),console.error(l),l}const v={},r={exports:v},s=l=>{const h=this._fakeModules.getModule(l,w);if(h===void 0)throw new Error(`Cannot load module '${l}'`);return h};try{return T.codeLoadingStart(),a&&performance.mark(`code/extHost/willLoadExtensionCode/${a.value}`),i(r,v,s),r.exports!==v?r.exports:v}finally{a&&performance.mark(`code/extHost/didLoadExtensionCode/${a.value}`),T.codeLoadingStop()}}async $setRemoteEnvironment(a){}async _waitForDebuggerAttachment(a=5e3){if(!this._initData.environment.isExtensionDevelopmentDebug)return;const w=Date.now()+a;for(;Date.now()<w&&!("__jsDebugIsReady"in globalThis);)await(0,F.timeout)(10)}}e.ExtHostExtensionService=E,E._ttpExtensionScripts=self.trustedTypes?.createPolicy("ExtensionScripts",{createScript:u=>u});function n(u,a){return u.endsWith(a)?u:u+a}function c(u,a){w("info","log"),w("log","log"),w("warn","warn"),w("error","error");function w(o,f){const y=console[o];console[o]=function(){u.$logExtensionHostMessage({type:"__$console",severity:f,arguments:S(arguments)}),a&&y.apply(console,arguments)}}const T=1e5;function S(o){const f=[],y=[];if(o.length)for(let i=0;i<o.length;i++){if(typeof o[i]=="undefined")o[i]="undefined";else if(o[i]instanceof Error){const v=o[i];v.stack?o[i]=v.stack:o[i]=v.toString()}y.push(o[i])}try{const i=JSON.stringify(y,function(v,r){if(r&&typeof r=="object"){if(f.indexOf(r)!==-1)return"[Circular]";f.push(r)}return r});return i.length>T?"Output omitted for a large object that exceeds the limits":i}catch(i){return`Output omitted for an object that cannot be inspected ('${i.toString()}')`}}}}),define(be[225],Ee([0,1,57,15,33,73,224,211]),function(re,e,d,M,b,R,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,d.registerSingleton)(b.IExtHostExtensionService,F.ExtHostExtensionService),(0,d.registerSingleton)(M.ILogService,C.ExtHostLogService),(0,d.registerSingleton)(R.IExtensionStoragePaths,R.ExtensionStoragePaths)}),define(be[235],Ee([0,1,22,3,177,219,213,17,74,11,2,223,225]),function(re,e,d,M,b,R,F,C,_,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const E=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const n=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");const c=fetch.bind(self);if(self.fetch=function(o,f){return o instanceof Request||/^file:/i.test(String(o))&&(o=I.FileAccess.asBrowserUri(t.URI.parse(String(o))).toString(!0)),c(o,f)},self.XMLHttpRequest=class extends XMLHttpRequest{open(o,f,y,i,v){return/^file:/i.test(f.toString())&&(f=I.FileAccess.asBrowserUri(t.URI.parse(f.toString())).toString(!0)),super.open(o,f,y??!0,i,v)}},self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const o=self.trustedTypes?.createPolicy("extensionHostWorker",{createScriptURL:y=>y}),f=self.Worker;Worker=function(y,i){/^file:/i.test(y.toString())&&(y=I.FileAccess.asBrowserUri(t.URI.parse(y.toString())).toString(!0));const r=`(${function(p){function k(m){return typeof m=="string"||m instanceof URL?String(m).replace(/^file:\/\//i,"vscode-file://vscode-app"):m}const P=fetch.bind(self);self.fetch=function(m,A){return m instanceof Request?P(m,A):P(k(m),A)},self.XMLHttpRequest=class extends XMLHttpRequest{open(m,A,L,V,G){return super.open(m,k(A),L??!0,V,G)}};const g=importScripts.bind(self);self.importScripts=(...m)=>{g(...m.map(k))};const D=self.trustedTypes?self.trustedTypes.createPolicy("extensionHostWorker",{createScriptURL:m=>m}):void 0;g(D?D.createScriptURL(p):p)}.toString()}('${y}'))`;i=i||{},i.name=i.name||C.basename(y.toString());const s=new Blob([r],{type:"application/javascript"}),l=URL.createObjectURL(s);return new f(o?o.createScriptURL(l):l,i)}}else self.Worker=class extends F.NestedWorker{constructor(o,f){super(n,o,{name:C.basename(o.toString()),...f})}};const u=new class{exit(o){E()}async exists(o){return!0}async realpath(o){return o}};class a{constructor(){const f=new MessageChannel,y=new M.Emitter;let i=!1;n(f.port2,[f.port2]),f.port1.onmessage=v=>{const{data:r}=v;if(!(r instanceof ArrayBuffer)){console.warn("UNKNOWN data received",r);return}const s=d.VSBuffer.wrap(new Uint8Array(r,0,r.byteLength));if((0,b.isMessageOfType)(s,2)){i=!0,T("received terminate message from renderer");return}y.fire(s)},this.protocol={onMessage:y.event,send:v=>{if(!i){const r=v.buffer.buffer.slice(v.buffer.byteOffset,v.buffer.byteOffset+v.buffer.byteLength);f.port1.postMessage(r,[r])}}}}}function w(o){return new Promise(f=>{const y=o.onMessage(i=>{y.dispose();const v=JSON.parse(i.toString());o.send((0,b.createMessageOfType)(0)),f({protocol:o,initData:v})});o.send((0,b.createMessageOfType)(1))})}let T=o=>E();function S(){const o=new a;_.mark("code/extHost/willConnectToRenderer"),w(o.protocol).then(f=>{_.mark("code/extHost/didWaitForInitData");const y=new R.ExtensionHostMain(f.protocol,f.initData,u,null);T=i=>y.terminate(i)})}e.create=S})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/54cdd9c58b8cc77f6f9983125ddfacf15d6c82a6/core/vs/workbench/services/extensions/worker/extensionHostWorker.js.map
